-- 社团劳务
-- zmh
CREATE TABLE `player_guild_labor` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `tid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '任务内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`rid`,`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团劳务数据';

-- 社团
-- zmh
CREATE TABLE `guild` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '社团名字',
  `announce` varchar(500) NOT NULL DEFAULT '' COMMENT '社团公告',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '团长',
  `chief_name` varchar(50) NOT NULL DEFAULT '' COMMENT '社团名字',
  `lv` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `division` int(11) NOT NULL DEFAULT '0' COMMENT '评级',
  `funds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团资金',
  `style` int(11) NOT NULL DEFAULT '0' COMMENT '旗帜样式',
  `color` int(11) NOT NULL DEFAULT '0' COMMENT '旗帜颜色',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modify_times` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '社团修改次数',
  `approve_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '申请类型',
  `auto_approve_lv` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '自动加入的等级',
  `auto_approve_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '自动加入的战力',
  `disband_warnning_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解散警告开始时间',
  `week_labor` int(11) NOT NULL DEFAULT '0' COMMENT '周活跃',
  `week_labor_refresh` int(11) NOT NULL DEFAULT '0' COMMENT '上次刷新时间',
  `week_labor_last` int(11) NOT NULL DEFAULT '0' COMMENT '上周活跃',
  `c_rename` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以免费改名',
  `c_rename_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '改名时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团';

-- 社团申请
-- zmh
CREATE TABLE `guild_apply` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `position` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '申请职位(默认申请加入:0)',
  PRIMARY KEY (`role_id`,`guild_id`),
  KEY `guild_id` (`guild_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团申请';

-- 社团成员
-- zmh
CREATE TABLE `guild_member` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `position` tinyint(2) unsigned NOT NULL DEFAULT '2' COMMENT '职位',
  `week_labor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周活跃',
  `week_labor_refresh` int(11) NOT NULL DEFAULT '0' COMMENT '上次刷新时间',
  `labors` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本社历史活跃',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团成员';
