-- tyl 宠物支援

CREATE TABLE IF NOT EXISTS `pet_support_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `slot_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '槽位Id',
  `support_type` tinyint(2) unsigned NOT NULL COMMENT '支援类型 1,普通支援 2,全服支援',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`role_id`,`slot_id`,`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物支援槽位表';

CREATE TABLE IF NOT EXISTS `pet_support_rank` (
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `rank` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `role_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色战力',
  `support_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '支援数',
  `yesterday_support_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物昨天的支援人数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物全服支援排行榜数据表';

CREATE TABLE IF NOT EXISTS `pet_support_statistics` (
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `refresh_times` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '刷新次数',
  `yesterday_online_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物支援昨天登录的人数',
  `today_online_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物支援今天的登录人数',
  `today_support_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当天支援人次',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`server_id`,`refresh_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物全服支援统计数据表';
