-- tyl 孩子相关日志
CREATE TABLE IF NOT EXISTS `log_child_grow_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `child_year` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '孩子年龄-年',
  `child_month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '孩子年龄-月',
  `child_age_exp` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '孩子成长经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='孩子成长日志';

CREATE TABLE IF NOT EXISTS `log_child_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `heart_link_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '同心等级',
  `heart_link_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '同心经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=DYNAMIC COMMENT='孩子培养日志表';

CREATE TABLE IF NOT EXISTS `log_child_skill` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能Id',
  `skill_lv` mediumint(6) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='孩子技能日志表';

CREATE TABLE IF NOT EXISTS `log_child_toy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `toy_type_id` int(11) unsigned NOT NULL COMMENT '玩具类型Id',
  `toy_id` bigint(20) unsigned NOT NULL COMMENT '玩具Id',
  `toy_lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩具强化等级',
  `state` tinyint(1) unsigned NOT NULL COMMENT '槽位状态 0-不在槽位 1-在槽位上',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='孩子玩具强化日志表';

CREATE TABLE IF NOT EXISTS `log_child_fashion` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `fashion_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时装Id',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '时装等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='孩子时装强化日志';

-- 社团协助日志
CREATE TABLE IF NOT EXISTS `log_ask_guild_support` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '请求者Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `support_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助单Id',
  `content` varchar(255) NOT NULL DEFAULT '[]' COMMENT '协助具体内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '协助单创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='社团协助日志表';

CREATE TABLE IF NOT EXISTS `log_guild_support_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `supporter` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助者Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `support_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助单Id',
  `cfg_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '协助配置Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='协助单结算日志表';

