-- tyl 孩子添加玩具相关
CREATE TABLE IF NOT EXISTS `child_toy` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '套装类型',
  `toy_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具Id',
  `toy_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具等级',
  PRIMARY KEY (`role_id`,`suit_type`,`toy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子玩具数据表';

CREATE TABLE IF NOT EXISTS `child_toy_suit` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具套装类型',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  `collect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '集齐时间',
  PRIMARY KEY (`role_id`,`suit_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子玩具套装数据表';

CREATE TABLE IF NOT EXISTS `log_child_toy_suit` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具套装类型',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '收集进度状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='孩子玩具套装日志表';
