-- hh
-- 走格子
CREATE TABLE `role_lattice`(
    `role_id` bigint(20) UNSIGNED NOT NULL COMMENT '人物id',
    `pos` tinyint(6) UNSIGNED NOT NULL DEFAULT 0 COMMENT '位置',
    `circle` tinyint(6) UNSIGNED NOT NULL DEFAULT 0 COMMENT '轮次',
    `update_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '更新时间',
    `circle_reward` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '轮次奖励',
    PRIMARY KEY(`role_id`)
) ENGINE=InnoDB CHARSET=utf8 COMMENT="器灵寻宝-玩家走格子数据";

CREATE TABLE `role_lattice_shop`(
    `role_id` bigint(20) UNSIGNED NOT NULL COMMENT '人物id',
    `shop_count` tinyint(6) UNSIGNED NOT NULL DEFAULT 0 COMMENT '手动刷新次数',
    `shop_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '最近操作时间',
    `shop_info` varchar(255) NOT NULL DEFAULT '[]' COMMENT '商店信息',
    PRIMARY KEY(`role_id`)
) ENGINE=InnoDB CHARSET=utf8 COMMENT="器灵寻宝-玩家格子商店数据";

CREATE TABLE `log_lattice`(
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) UNSIGNED NOT NULL DEFAULT 0 COMMENT '玩家id',
  `circle` tinyint(5) UNSIGNED NOT NULL DEFAULT 0 COMMENT '轮次',
  `pre_step` tinyint(5) UNSIGNED NOT NULL DEFAULT 0 COMMENT '旧步数',
  `pass_step` tinyint(5) UNSIGNED NOT NULL DEFAULT 0 COMMENT '本次行步',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '时间',
  PRIMARY KEY(`id`)
) ENGINE=InnoDB CHARSET=utf8 COMMENT="器灵寻宝-走格子日志";


-- 龙神扭蛋 tyl

CREATE TABLE IF NOT EXISTS `capsule_egg_data` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pool_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖池类型',
  `next_free_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下次免费时间',
  `draw_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖次数',
  PRIMARY KEY (`role_id`,`pool_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-玩家抽奖数据表';

CREATE TABLE IF NOT EXISTS `capsule_egg_draw_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖池类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `reward_cfg_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '奖励配置Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-抽奖记录';

CREATE TABLE IF NOT EXISTS `capsule_egg_person_score` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖总积分',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-个人抽奖积分';

CREATE TABLE IF NOT EXISTS `capsule_egg_server_score` (
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖池类型',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖幸运值(全服积分)',
  PRIMARY KEY (`pool_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-全服幸运值';
