DROP TABLE `race_act_role`;
DROP TABLE `race_act_rank`;
DROP TABLE `race_act`;


CREATE TABLE `race_rank_zone` (
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `platform` varchar(100) NOT NULL DEFAULT '' COMMENT '平台名',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加入分区时间戳',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-分区信息(在跨服中使用-合跨服合并保留)';

CREATE TABLE `race_rank_opening_act` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `status` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已结算奖励:结算时的时间戳;还没结算奖励:0',
  PRIMARY KEY (`act_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-开启中的活动数据(在跨服中使用-合跨服保留主服数据)';


CREATE TABLE `race_rank` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `rname` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`act_id`,`zone_id`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-排行榜数据(在跨服中使用-合跨服合并保留)';

CREATE TABLE `role_race_rank` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计次数',
  `buy_ten_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽十次的累计次数',
  `buy_ten_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次抽十次的时间戳',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `use_free_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已使用免费次数',
  `free_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次使用免费次数的时间戳',
  `award_log` varchar(300) NOT NULL DEFAULT '[]' COMMENT '累计次数奖励领取记录[AwardId]',
  `valid_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据有效截止时间戳',
  `coin` int(11) NOT NULL DEFAULT '0' COMMENT '金币',
  `stage` int(11) NOT NULL DEFAULT '0' COMMENT '充值阶段',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '充值时间',
  `coin_draw` int(11) NOT NULL DEFAULT '0' COMMENT '金币次数',
  `coin_time` int(11) NOT NULL DEFAULT '0' COMMENT '金币时间',
  `rune_draw` int(11) NOT NULL DEFAULT '0' COMMENT '符文次数',
  `rune_time` int(11) NOT NULL DEFAULT '0' COMMENT '符文时间',
  PRIMARY KEY (`rid`,`act_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色竞榜活动数据(在游戏服中使用-合服合并保留)';


CREATE TABLE `log_race_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `rname` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-排行榜日志(在跨服中使用)';


CREATE TABLE `race_rank_server_score` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`act_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服积分-合跨服合并保留)';


CREATE TABLE `log_race_rank_draw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖后积分',
  `award` varchar(800) NOT NULL DEFAULT '[]' COMMENT '奖励:[{奖励类型,物品类型Id,数量}]',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗:[{奖励类型,物品类型Id,数量}]',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1019 DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-玩家抽奖记录(在游戏服中使用)';

