-- hh 唤神副本相关

CREATE TABLE `role_god_dun`(
    `role_id` bigint(20) UNSIGNED NOT NULL COMMENT '人物id',
    `day_shop_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '日常商品列表',
    `day_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '日常商品更新时间',
    `week_shop_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '周常商品列表',
    `week_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '周常商品更新时间',
    `role_attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '人物部分基础属性汇总',
    PRIMARY KEY(`role_id`)
) ENGINE = InnoDB CHARSET=utf8 COMMENT="人物唤神副本信息";

CREATE TABLE `god_dun_wave_score`(
    `dun_id` int(11) UNSIGNED NOT NULL COMMENT '副本id',
    `wave` int(11) UNSIGNED NOT NULL COMMENT '波数',
    `role_id` bigint(20) UNSIGNED NOT NULL COMMENT '人物id',
    `server_id` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '游戏服id',
    `server_num` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '游戏服编号',
    `score` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '波数积分',
    `role_show` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '人物外观',
    PRIMARY KEY(`dun_id`, `wave`, `role_id`)
)ENGINE = InnoDB CHARSET=utf8 COMMENT="唤神副本波数积分信息(跨服使用)-合跨服保留";

CREATE TABLE `god_dun_score`(
    `role_id` int(11) UNSIGNED NOT NULL COMMENT '副本id',
    `server_id` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '游戏服id',
    `server_num` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '游戏服编号',
    `score` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '总积分',
    `role_show` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '人物外观',
    PRIMARY KEY(`role_id`)
)ENGINE = InnoDB CHARSET=utf8 COMMENT="唤神副本总积分信息(跨服使用)-合跨服保留";

CREATE TABLE `role_god_dun_live`(
    `role_id` bigint(20) UNSIGNED NOT NULL COMMENT '玩家id',
    `server_id` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '游戏服id',
    `time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '时间',
    PRIMARY KEY(`role_id`)
)ENGINE = InnoDB CHARSET=utf8 COMMENT="唤神副本活跃数据(跨服使用)-合跨服保留";

-- huangyongxing
-- 团购活动
CREATE TABLE `group_buy_data` (
  `subtype` smallint(5) NOT NULL DEFAULT '1' COMMENT '活动子类型id',
  `grade` tinyint(3) NOT NULL DEFAULT '0' COMMENT '活动档次id',
  `real_buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '真实购买人数',
  `fix_buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '修正的购买人数',
  `gold_type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '货币类型',
  `original_price` smallint(5) NOT NULL DEFAULT '0' COMMENT '原始价格',
  `stime` int(11) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `etime` int(11) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `buyers` varchar(20000) NOT NULL COMMENT '购买者角色id列表',
  PRIMARY KEY (`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='团购活动数据';

