-- zmh
-- 进阶系统升级
CREATE TABLE `log_foster_upgrade` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶位',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `exp`  int(11) unsigned NOT NULL DEFAULT '0' COMMENT '祝福值',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效期',
  `autobuy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否自动购买',
  `costs` varchar(500)  NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统升级日志';


-- zmh
-- 进阶系统核心
CREATE TABLE `log_foster_core_upgrade` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `core` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '核心类型',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前值',
  `costs` varchar(500)  NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统核心日志';


-- zmh
-- 进阶系统技能
CREATE TABLE `log_foster_skill_upgrade` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `costs` varchar(500)  NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统技能日志';


-- zmh
-- 进阶系统装备
CREATE TABLE `log_foster_equip` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `bitem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前道具',
  `aitem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统技能日志';


-- zmh
-- 进阶系统装备升级
CREATE TABLE `log_foster_equip_lv` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶位',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具',
  `before_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前等级',
  `before_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前经验',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后等级',
  `after_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后经验',
  `costs` varchar(500)  NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统装备升级日志';

-- tyl
-- 快速充值日志
CREATE TABLE `log_quickcharge` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品Id',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币数',
  `money_gap` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值前金币差额',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值时间',
  PRIMARY KEY (`role_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='快速充值日志';
