-- liushl
CREATE TABLE `log_mate_rela` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方角色ID',
  `other_rname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型##（1.建立羁绊，2强制解除，3协议解除）',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY other_rid(`other_rid`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-关系';

CREATE TABLE `log_mate_anniversary` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方角色ID',
  `other_rname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '获取的奖励',
  `need_day` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '需求天数',
  `own_day` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '羁绊建立天数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY other_rid(`other_rid`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-纪念日奖励';

CREATE TABLE `log_mate_boat` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `grade` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '阶位',
  `star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成长值',
  `costs` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-小船升级';

CREATE TABLE `log_compose_evolution` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `role_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `classify_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成分类',
  `subclass` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成子类',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成物品',
  `cost_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `auto_buy` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否自动购买##（1是；2否）',
  `result` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结果##（1成功；2失败）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成日志';

CREATE TABLE `log_sign_in` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `role_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `round` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '周期',
  `day` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '第几天',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `vip_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级要求',
  `role_vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '角色VIP等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='签到奖励日志';

CREATE TABLE `log_level_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `role_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `role_career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '角色职业',
  `gift_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `lv_need` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级要求',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `limit_award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '额外奖励获取',
  `limit_remain` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '额外奖励剩余',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲级礼包日志';

CREATE TABLE `log_war_soul_equip` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '上阵位置',
  `soul_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上阵前战魂（没有则为0）',
  `soul_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上阵后战魂',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-上阵日志';

CREATE TABLE `log_war_soul_strength` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '被强化的战魂ID',
  `cost_exp` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗的战魂经验值',
  `exp_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗前的战魂经验值',
  `exp_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗后的战魂经验值',
  `lv_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化后的战魂等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-强化日志';

CREATE TABLE `log_war_soul_del` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `soul_id` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '被分解的战魂ID（列表）',
  `gain_exp` varchar(50) NOT NULL DEFAULT '[]' COMMENT '获得的战魂经验值',
  `exp_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分解后的战魂经验值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-分解日志';

CREATE TABLE `log_war_soul_evolution` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `soul_id` int(11) NOT NULL DEFAULT '0' COMMENT '进化前的战魂id',
  `soul_id_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进化后的战魂id',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `gain_exp` varchar(50) NOT NULL DEFAULT '[]' COMMENT '获得的战魂经验值##（如果消耗了已升级战魂的返还。没有则记为0）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-进化日志';

CREATE TABLE `log_war_soul_handbook` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `soul_unlock_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁战魂ID',
  `soul_unlock_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁战魂数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-图鉴日志';

-- 竞技场
DROP TABLE IF EXISTS log_arena_inspire;
DROP TABLE IF EXISTS log_arena_break_rank;
DROP TABLE IF EXISTS log_arena_season_rank;
DROP TABLE IF EXISTS log_arena_clear;
ALTER TABLE log_arena ADD COLUMN `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称' AFTER role_id;
ALTER TABLE log_arena ADD COLUMN `rival_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称' AFTER rival_id;
CREATE TABLE `log_arena_daily_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型##（0-每日奖励；1-每日首胜；2-每日五战）',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日奖励名次',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技联赛每日奖励';

CREATE TABLE `log_madness_land_role_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `role_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人排名',
  `guild_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '隶属社团id',
  `guild_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '社团名称',
  `guild_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-排名奖励（本服）';

CREATE TABLE `log_madness_land_role_reward_kf` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本服排名',
  `guild_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '隶属社团id',
  `guild_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '公会名',
  `guild_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY zone_id(`zone_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-排名奖励（跨服）';

CREATE TABLE `log_beauty_contest_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `fashion_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-主动报名日志';

CREATE TABLE `log_beauty_contest_vote` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `round` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `vote_info` varchar(50) NOT NULL DEFAULT '[]' COMMENT '选手信息##（格式为：[选手1昵称 - 选手2昵称，(票数高者ID)]）',
  `support_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对方ID （所支持选手ID）',
  `support_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '对方名称',
  `support_votes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对方当前票数',
  `rest_times` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '投票剩余次数',
  `is_extra` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否投票给高票数者',
  `award_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY zone_id(`zone_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-投票日志';

CREATE TABLE `log_beauty_contest_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `phase` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '期数',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '止步轮次',
  `rank` varchar(50) NOT NULL DEFAULT '[]' COMMENT '排名',
  `votes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结算票数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-排名日志';

CREATE TABLE `log_convoy_result` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '运送对象',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结束时的阶段##（1-第一阶段；2-第二阶段）',
  `end_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结算类型',
  `if_double` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否双倍（1-否；2-是）',
  `goods_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送结果';

CREATE TABLE `log_convoy_refresh` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `old_object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧运送对象',
  `new_object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新运送对象',
  `cost_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `vip_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '玩家VIP等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送刷新表';

CREATE TABLE `log_convoy_take` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型(1打劫|2被劫)',
  `object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '运送对象',
  `taken_server` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对方服务器',
  `taken_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方id',
  `taken_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '对方名称',
  `award` varchar(50) NOT NULL DEFAULT '[]' COMMENT '打劫奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY taken_id(`taken_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送拦截';

CREATE TABLE `log_offline_hosting_change` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `ai_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前托管值',
  `ai_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后托管值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='托管值结算日志';

-- 修改百团大战个人日志
ALTER TABLE log_guild_war_role_rank ADD COLUMN `kill_rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '击杀排名' AFTER score;
ALTER TABLE log_guild_war_role_rank ADD COLUMN `max_kill` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '击杀数' AFTER kill_rank;

CREATE TABLE `log_player_attr` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `hightest_combat_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '最高战力',
  `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `activity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存彩钻',
  `bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存红钻',
  `trade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存交易券',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存名望券',
  `total_money` decimal(12,2) DEFAULT '0.00' COMMENT '总充值金额',
  `total_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总充值元宝',
  `recency` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最近充值指标',
  `frequency` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '充值频率指标',
  `monetary` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '总充值指标',
  `top` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最高充值指标',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家每日属性记录';

-- 首充
ALTER TABLE log_recharge_first ADD COLUMN `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级' AFTER last_behavior;
ALTER TABLE log_recharge_first ADD COLUMN `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计在线时长' AFTER level;

CREATE TABLE `log_investment` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '投资类型',
  `grade` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '投资档次',
  `award_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `award_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `award_condition` varchar(50) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY time(`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投资领奖日志';

ALTER TABLE log_custom_act_reward ADD COLUMN `vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP' AFTER extra;
ALTER TABLE log_custom_act_reward ADD COLUMN `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级' AFTER vip;
ALTER TABLE log_custom_act_reward ADD COLUMN `gold_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖前彩钻' AFTER lv;
ALTER TABLE log_custom_act_reward ADD COLUMN `gold_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖后彩钻' AFTER gold_before;

-- 无尽领域日志
DROP TABLE IF EXISTS log_void_fam;
CREATE TABLE `log_void_fam` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 进入/退出',
  `floor` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '进入层数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进入积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽领域日志';


CREATE TABLE `log_void_fam_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `ser_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 进入/退出',
  `floor` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '进入层数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽排名日志';

CREATE TABLE `log_void_fam_rank_kf` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `ser_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 进入/退出',
  `floor` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '进入层数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽跨服排名日志';