-- 跨服国战参与日志
CREATE TABLE `log_cross_guild_war` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `guild` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `room` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `filed` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '城区',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY guild(`guild`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战参与日志';

-- 跨服国战占领日志
CREATE TABLE `log_cross_guild_war_conquer` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `room` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `guild` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团',
  `is_lord` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否团长',
  `city` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '城区',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY zone(`zone`),
  KEY guild(`guild`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战占领日志';


-- 跨服国战应援日志
CREATE TABLE `log_cross_guild_war_support` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `guild` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
  `cost` varchar(255) NOT NULL DEFAULT '' COMMENT '花费',
  `retimes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY role_id(`role_id`),
  KEY zone(`zone`),
  KEY guild(`guild`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战应援日志';