-- liushl
DROP TABLE IF EXISTS hi_points_act;
DROP TABLE IF EXISTS hi_points_extra;
DROP TABLE IF EXISTS hi_points_reward;
CREATE TABLE `player_hi_point` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '嗨点值',
  `extra_points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额外嗨点值',
  `task_info` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '任务情况',
  `reward_info` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '奖励情况',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`, `type`, `sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='玩家嗨点数据';

-- tyl 重新设置宝宝载具(因修改字段长度)
alter table role_child modify column show_vehicle int(11) UNSIGNED NOT NULL DEFAULT '0' COMMENT '跟随载具 0-不跟随 其他-具体载具Id';
alter table child_vehicle modify column vehicle_id int(11) UNSIGNED NOT NULL DEFAULT '0' COMMENT '载具Id';

-- huangyongxing
-- 明日之礼相关日志
-- 2020-12-22

-- 明日之礼购买日志
CREATE TABLE `log_hope_gift_buy` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `gold_cost` int(11) NOT NULL DEFAULT '0' COMMENT '消耗彩钻',
  `gold_before` int(11) NOT NULL DEFAULT '0' COMMENT '购买前彩钻',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `level` smallint(5) NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='明日之礼购买日志';

-- 明日之礼返还日志
CREATE TABLE `log_hope_gift_return` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `return_amount` int(11) NOT NULL DEFAULT '0' COMMENT '已返还数量',
  `return_left` int(11) NOT NULL DEFAULT '0' COMMENT '待返还数量',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='明日之礼返还日志';

-- 明日之礼抽奖日志
CREATE TABLE `log_hope_gift_draw` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `round` smallint(5) NOT NULL DEFAULT '0' COMMENT '当前轮次',
  `cost` smallint(5) NOT NULL DEFAULT '0' COMMENT '消耗抽奖道具数量',
  `item_before` int(11) NOT NULL DEFAULT '0' COMMENT '抽奖前抽奖道具数量',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='明日之礼抽奖日志';

-- 团购相关日志

-- 团购购买日志
CREATE TABLE `log_group_buy` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `gold_type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '货币类型',
  `gold_cost` int(11) NOT NULL DEFAULT '0' COMMENT '消耗货币数量',
  `gold_bef` int(11) NOT NULL DEFAULT '0' COMMENT '购买前彩钻',
  `bgold_bef` int(11) NOT NULL DEFAULT '0' COMMENT '购买前红钻',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `discount` tinyint(5) NOT NULL DEFAULT '10' COMMENT '购买时折扣',
  `buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '真实购买人数',
  `fix_buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '虚拟购买人数',
  `stage` tinyint(5) NOT NULL DEFAULT '0' COMMENT '购买时进度阶段',
  `stage_no_fix` tinyint(5) NOT NULL DEFAULT '0' COMMENT '购买时如果按真实人数计算的阶段',
  `stage_total` tinyint(5) NOT NULL DEFAULT '0' COMMENT '总进度阶段数',
  `vip` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='团购购买日志';

-- 团购返还日志
CREATE TABLE `log_group_buy_return` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `gold_type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '货币类型',
  `gold_num` int(11) NOT NULL DEFAULT '0' COMMENT '领取货币数量',
  `discount` tinyint(5) NOT NULL DEFAULT '10' COMMENT '返还时折扣',
  `is_mail` tinyint(3) NOT NULL DEFAULT '0' COMMENT '是否通过邮件补发(0手动 1活动结束邮件发放)',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='团购返还日志';

-- 补充日志表时间索引
ALTER TABLE log_hope_gift_buy ADD KEY `time` (`time`) USING BTREE;
ALTER TABLE log_hope_gift_draw ADD KEY `time` (`time`) USING BTREE;
ALTER TABLE log_hope_gift_return ADD KEY `time` (`time`) USING BTREE;
ALTER TABLE log_group_buy ADD KEY `time` (`time`) USING BTREE;
ALTER TABLE log_group_buy_return ADD KEY `time` (`time`) USING BTREE;

