-- 跨服沙盘
-- liushl
CREATE TABLE `cross_point_fight_zone`(
    `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
    `season_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季##不做功能使用',
    `season_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季开始时间',
    `point_mass` varchar(255) NOT NULL DEFAULT '[]' COMMENT '据点集结信息',
    `point_buff` varchar(255) NOT NULL DEFAULT '[]' COMMENT '据点BUFF信息',
    `buff_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BUFF结束时间',
    PRIMARY KEY(`zone_id`)
)ENGINE=InnoDB CHARSET=utf8 COMMENT="沙盘争夺战-分区信息(合服保留)";

CREATE TABLE `cross_point_fight_point`(
    `zone_id` INT(11) UNSIGNED NOT NULL DEFAULT '0' COMMENT '分区id',
    `point_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
    `faction` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '攻占国家id',
    `seize_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻占时间',
    `seize_info` varchar(255) NOT NULL DEFAULT '[]' COMMENT '据点攻占统计##[{faction,score}]',
    PRIMARY KEY(`zone_id`, `point_id`)
)ENGINE=InnoDB CHARSET=utf8 COMMENT="沙盘争夺战-城市信息(合服保留)";

CREATE TABLE `cross_point_fight_log`(
    `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
    `point_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
    `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
    `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
    PRIMARY KEY(`zone_id`, `point_id`, `role_id`)
)ENGINE=InnoDB CHARSET=utf8 COMMENT="沙盘争夺战-据点攻打记录(合服保留)";

CREATE TABLE `role_cross_point_score`(
    `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
    `point_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
    `single_max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次最大积分',
    `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总积分',
    `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点参数##对于安全据点：为输出比例/对于抢占据点，为副本波数',
    `award_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖次数',
    PRIMARY KEY(`role_id`, `point_id`)
)ENGINE=InnoDB CHARSET=utf8 COMMENT="沙盘争夺战-玩家在各个据点的总积分(合服保留)";

-- 社团BOSS公会排名日志
CREATE TABLE `log_guild_boss_guild`  (
    `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
    `guild_id` bigint(20) NOT NULL COMMENT '社团id',
    `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
    `rank` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '排名',
    `awards` varchar(600) NOT NULL DEFAULT '' COMMENT '奖励',
    `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8  COMMENT = '社团BOSS社团排名日志';

-- 社团BOSS个人排名日志
CREATE TABLE `log_guild_boss_role`  (
    `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
    `role_id` bigint(20) NOT NULL COMMENT '玩家id',
    `name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名称',
    `guild_id` bigint(20) NOT NULL COMMENT '社团id',
    `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
    `act_time` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '活动时间',
    `rank` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '排名',
    `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8  COMMENT = '社团BOSS个人排名日志';


-- 霸主特权
-- ljy
CREATE TABLE `overlord_info`  (
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `times` tinyint(2) NOT NULL DEFAULT 0 COMMENT '禁言次数',
  `pro_time` int(11) NOT NULL DEFAULT 0 COMMENT '上次使用禁言特权时间',
  `rename_time` int(11) NOT NULL DEFAULT 0 COMMENT '上次改名时间',
  PRIMARY KEY (`role_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '霸主特权信息' ROW_FORMAT = Dynamic;

-- 社团BOSS分红日志
CREATE TABLE `log_guild_boss_share`  (
    `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
    `guild_id` bigint(20) NOT NULL COMMENT '社团id',
    `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
    `num` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '参与人数',
    `rate` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '税率',
    `cash` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '总计获得',
    `money` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '人均获得',
    `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8  COMMENT = '社团BOSS分红日志';