-- tyl
-- 孩子奖励表
CREATE TABLE `child_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `share_reward` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '分享奖励领取状态 0-未领取 1-已领取',
  `yest_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨日榜排名',
  `yest_reward` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '昨日榜奖励领取状态 0-未领取 1-已领取',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-每日分享和昨日榜奖励表';

-- 活动预约
-- hh
CREATE TABLE `role_act_reserve`(
    `role_id` bigint(20) UNSIGNED NOT NULL COMMENT '玩家id',
    `module` int(11) UNSIGNED NOT NULL COMMENT '功能id', 
    `module_sub` int(11) UNSIGNED NOT NULL COMMENT '功能子id',
    `ac_sub` int(11) UNSIGNED NOT NULL COMMENT '子类id',
    `reserve` int(11) UNSIGNED NOT NULL DEFAULT 0 COMMENT '预约与否',
    `join_act` tinyint(2) UNSIGNED NOT NULL DEFAULT 0 COMMENT '是否参与',
    `rewards` tinyint(2) UNSIGNED NOT NULL DEFAULT 0 COMMENT '是否已领奖励',
    PRIMARY KEY(`role_id`, `module`, `module_sub`, `ac_sub`)
)ENGINE=InnoDB CHARSET=utf8 COMMENT="活动预约";

-- tyl
-- 宠物副本 关卡最大积分表
CREATE TABLE `role_dun_pet_max_score` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本Id',
  `max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史最大分数',
  PRIMARY KEY (`role_id`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-副本历史最大分数';