%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc
%%% 战斗对象挑选处理
%%% 主要包括技能BUFF作用对象、一些AI对象选择等等
%%% @end
%%% -------------------------------------------------------
-ifndef(BATTLE_OBJ_SELECT_HRL).
-define(BATTLE_OBJ_SELECT_HRL, ok).

%% 输入参数
-record(args_get_affects, {
        affect                  % 影响方参数（SKILL_AFFECT_MYSELF,...）
        ,aer                    % 攻击方
        ,der                    % 防守方
        ,aer_init               % 攻击方初始数据
        ,der_init               % 防守方初始数据
        ,aer_buff               % 攻击方缓存的BUFF数据
        ,der_buff               % 防守方缓存的BUFF数据
    }).
%% 返回结果数据
-record(ret_get_affects, {
        user                    % 将受到影响的战斗方数据
        ,user_buff              % 将受到影响的战斗方缓存BUFF数据
        ,user_init              % 将受到影响的战斗方初始数据
        ,oppo_user              % 另一方数据
        ,oppo_user_buff         % 另一方缓存BUFF数据
        ,oppo_user_init         % 另一方原始数据
    }).
%% 输入参数
-record(args_set_affects, {
        affect                  % 影响方参数
        ,aer                    % 攻方数据
        ,der                    % 守方数据
        ,aer_buff               % 攻方BUFF数据
        ,der_buff               % 守方BUFF数据
        ,affect_user            % 受技能影响后的参战者数据
        ,affect_user_buff       % 受技能影响后的参数者BUFF数据
        ,oppo_user = undefined  % 技能另一方参战者数据
        ,oppo_user_buff         % 技能另一方BUFF数据
    }).
%% 返回攻守双方数据
-record(ret_set_affects, {
        aer                     % 攻方数据
        ,aer_buff               % 攻方BUFF数据
        ,der                    % 守方数据
        ,der_buff               % 守方BUFF数据
    }).

-endif.
