%% %% ----------------------------------------------------
%% %% @author
%% %% @doc
%% %% 删档充值玩家回归奖励
%% %% created
%% %% @end
%% %% ----------------------------------------------------


%% 测试服测试时的数据，用特定接口导出后，导入到正式服库表使用
%% 使用时，根据测试数据生成 #comeback_history{}
-record(comeback_history, {
        role_level = 0                          % 账号角色最高等级
        ,charge_gold = 0                        % 充值元宝数
        ,login_days = 0                         % 累登天数
    }).

%% 缓存的账户数据
-record(comeback_cache, {
        account = <<>>,                         % 小写的账户名
        list = []                               % [#comeback_data{}]
    }).

-record(comeback_data, {
        data_id = 0                             % 数据库表id
        ,state = 0                              % 数据状态
        ,source = <<>>                          % 渠道
        ,data = []                              % 封测数据信息(二进制数据，使用时再转换)
        ,now_role_id = 0                        % 当前角色id
    }).

%% 是否处理过回归数据的状态
-define(COMEBACK_STATE_UNDO, 0).                % 未处理过
-define(COMEBACK_STATE_GOT, 1).                 % 本角色已经取得
-define(COMEBACK_STATE_OTHER_GOT, 2).           % 其他角色取得
-define(COMEBACK_STATE_NOT_BACK, 3).            % 非回归角色
-define(COMEBACK_STATE_NOTIFIED, 4).            % 已通知玩家封测信息，但尚未取得奖励

%% 数据是否已使用过
-define(DATA_STATE_UNUSE, 0).                   % 数据未使用
-define(DATA_STATE_USED,  1).                   % 数据已使用

%% 提示信息时的等级（应小于返利等级）
-define(NOTICE_LEVEL, 10).
%% 返利时的等级
-define(RETURN_LEVEL, 80).

%% 封测回归账户数据ETS表名
-define(COMEBACK_TAB, comeback).