-define(SQL_DRUMRANK_GET, <<"SELECT `drumid`,`zone`,`rid`,`name`,`gname`,`server_id`,`platform`,`server_num`,`rank`,`vip`,`power`,`career` FROM `drumwar_rank`">>).
-define(SQL_DRUMRANK_DEL,  <<"DELETE FROM drumwar_rank where `drumid`=~p">>).
-define(SQL_DRUMWAR_RANK_BATCH, <<"REPLACE INTO drumwar_rank (drumid,zone,rid,name,gname,server_id,platform,server_num,rank,vip,power,career) VALUES ~ts">>).

-define(SQL_DRUMWAR_SIGN_BATCH, <<"REPLACE INTO drumwar_sign (rid,server_id,platform,server_num,drumid,name,picturev,turn,lv,career,power) VALUES (~p,~p,'~ts',~p,~p,'~ts',~p,~p,~p,~p,~p)">>).
-define(SQL_DRUMSIGN_GET,  <<"SELECT `rid`,`server_id`,`platform`,`server_num`,`drumid`,`name`,`picturev`,`turn`,`lv`,`career`,`power` FROM `drumwar_sign`">>).

-define(SQL_DRUM_GET, <<"SELECT `drumid`,`one`,`zone`,`action`,`deal`,`choice`,`pay_time` FROM `role_drum` where rid=~p">>).
-define(SQL_DRUM_INSERT,<<"REPLACE INTO role_drum (`rid`,`drumid`,`one`,`zone`,`action`,`deal`,`choice`,`pay_time`) VALUES (~p,~p,~p,~p,~p,~p,'~ts',~p)">>).
-define(SQL_DRUM_UPDATE, <<"UPDATE role_drum SET one=~p,action=13 where rid=~p">>).


-define(SQL_DRUMRANK_RESULT_GET, <<"SELECT `zone`,`act`,`group`,`server_id`,`platform`,`server_num`,`rid`,`name`,`picturev`,`lv`,`career`,`pow` FROM `drumwar_result`">>).
-define(SQL_DRUMWAR_RESULT_INTERT, <<"INSERT INTO `drumwar_result` (`zone`,`act`,`group`,`server_id`,`platform`,`server_num`,`rid`,`name`,`picturev`,`lv`,`career`,`pow`) VALUES (~p,~p,~p,~p,'~ts',~p,~p,'~ts',~p,~p,~p,~p)">>).

-define(DRUMLV,           1). %%比赛等级
-define(CHOOSELV, 		  2). %%竞猜等级
-define(DRUMITEM,         3). %%门票id
-define(READY_SCENE,	  4).
-define(WAR_SCENE,		  5).
-define(READY_LOCATION,	  6).
-define(REVIVE_LOCATION,  7).
-define(DRUM_SKILLS,      8).
-define(LUCKY_NUM,        9). %%每个战区幸运奖
-define(LEFT_POS,         10).
-define(RIGHT_POS,        11).
-define(SKILL_COST,       12).
-define(SKILL_CD,         13).
-define(LIVE_BUY_COST,    15).
-define(OPEN_DAY,         16).
-define(LIMIT_NUM,        19).%%所需最低人数

-define(WAR_MAX,2048). %%核准参与人数
-define(WAR_LIMIT,64). %%最少参加人数

-define(LEGEND_TYPE,      1). %%传奇等级
-define(NOT_LEGEND_TYPE,  0). %%不是传奇等级

-define(IDLE, 0).
-define(SIGN, 1).
-define(READY, 2).
-define(SEAWAR, 3).
-define(RANKWAR, 4).
-define(CLOSE, 5).

-define(BUYMAX,3). %%购买上限
-define(BUYPRICE,20). %%购买单价

-define(TYPE_SEA_START,	  	1). %%海选赛开始倒计时
-define(TYPE_FIGHT_START,	2). %%战场开始倒计时
-define(TYPE_FIGHT_ENTER,	3). %%进入战场倒计时
-define(TYPE_FIGHT,		    4). %%打斗开始倒计时
-define(TYPE_SUCCESS,		5). %%成功晋级倒计时
-define(TYPE_RANK_START,	6). %%排位赛开始倒计时
-define(TYPE_FIGHT_END,		7). %%打斗结束倒计时

% -define(SKILL_CD,  20).

%%日志类型
-define(LOG_WIN,   	  1).   %% 胜利
-define(LOG_LOSE,     2).	%% 负
-define(LOG_EMPTY,    3). 	%% 轮空
-define(LOG_TIMEOUT,  4).	%% 超时
-define(LOG_LOGOUT,   5).	%% 离线

%%擂台赛管理进程
-record(drumwar_mgr,{
	state  = 0,   	%%当前状态
	action = 0,   	%%当前场次
    ref    = 0,   	%%当前状态定时器
    signs  = [],  	%%所有报名玩家
    zones  = [],  	%%战区划分
    mons   = [],  	%%假人Ai集合
    history= [],  	%%战报集合 十期
    etime  = 0,   	%%截止时间
    sub_time  = 0,  %%阶段结束时间
    sub_state = 0,  %%阶段类型：1海选开始倒计时;2入战斗场倒计时;3打斗开始倒计时;4成功晋级倒计时;5争霸战开始倒计时;
    ctime  = 0,   	%%竞猜截止时间
    cstate = 0,   	%%是否竞猜时段0否1是
    choose = [],  	%%竞猜数据[{战区,[{场次,[UidA,UidB]}]}]
    choice = [],  	%%竞猜结果数据
    ready_out = [],	%%战力退出2048后，[玩家id]，（做提示用）
    tip_info = {0, 0} %%场次更新信息 {更新状态(1:场次倒计时;2:海选转场16强), 结束时间戳}
}).


%%战区信息
-record(zone_base, {
	id = 0,      %%战区号
	seeds = [],  %%该区种子选手
	wins = []    %%胜场玩家
}).

%%擂台玩家
-record(drum_role, {
	rid = 0             %%玩家ID
	,sid = 0            %%Sid 发消息用
	,zid = 0            %%所在战区
	,group = 0          %%所在分组  就是房间号
	,action = 1         %%当前场次
	,server_id = 0
	,platform = []      %%平台
	,server_num = 0     %%
	,node = none        %%所在节点
	,figure = undefined
	,live = 1           %%命数 默认1
	,online = 0         %%1表示在线 在准备区
	,power = 0          %%战力
	,win = 0            %%胜场
	,lose = 0           %%负场
	,rank = 0           %%排位赛排次
	,pos = 0            %%标识站位 0左1右
	,ai = 0             %%标识对手是否机器人0不是1是(在排位赛表示轮空)
	,ruid = 0           %%对手Uid
	,one = 0            %%1标识该区No.1
	,scene = 0 			%%进入活动的场景id
	,calc_type = 0      %%当轮是否结算
}).

-record(rank_role,{
    drum = 0,
    zone = 0,
    rid  = 0,
    name = "",
    gname = "",
    server_id       = 0,      %%
    platform = "",
    servernum = 0,
    rank = 0,
    vip  = 0,
    career = 0,
    power= 0
}).

%%进活动前信息
-record(out, {
	scene = 0,
	pool_id = 0,
	copy_id = 0,
	x = 0,
	y = 0
	}).

-record(role_drum, {
	drumid = 0,
	one  = 0,
	zone = 0,
	action = 0,
	deal   = 0, %%有效截止时间 逾期清除
	choice = [], %%竞猜列表
	time = 0,
	out = #out{}
}).

%%假人记录
-record(base_mon,{
	id = 0,
	zone = 0,
	act = 0,
	min_lv = 0,
	max_lv = 0,
	mon_lv = 0,		% 假人等级
	ratio = 0,
	power = []
	}).
