%%%-------------------------------------------------------------------
%%% @doc     宝宝副本-头文件
%%% Module  : dungeon_child.hrl
%%% Created : 2020-08-25
%%% @Author : tyl
%%%-------------------------------------------------------------------

%% 宝宝副本场景
-define(DUN_CHILD_SCENE, 2300).
%% 宝宝副本Id
-define(DUN_CHILD_ID,   14001).

%% 每一波默认怪物数
-define(DEFAULT_DUN_CHILD_MON, 5).

%% 塔防怪检测周围游走怪时间间隔
-define(CHECK_ACT_SKILL_TIME, 1).

%% 副本波数
-define(DUN_CHILD_WAVE(DunId), lists:max(data_dungeon_wave:get_dun_waves(DunId))).    %% 宠物副本波数

%% 放置塔cd
-define(PUT_TOWER_CD, data_dungeon_child:get_dun_child_kv_cfg(tower_cd)).
-define(TOWER_CD_KEY(MonId), {dun_child_tower_cd, MonId}).

%% 结算界面推送key定义
-define(DUN_RESULT_DUN_CHILD_WAVE,         1).   %% 宝宝副本-通关到的波数

%% 玩家进程宝宝副本数据
-record(role_dun_child, {
	energy_pot  = 0     %% 能量点数
	,wave       = 0     %% 当前通关波数
}).

%% ==================================== 后台配置 ===========================
%% 常量配置表
-record(dun_child_kv_cfg, {
	id            = 0       %% Id
	,key          = ""      %% 键
	,value        = ""      %% 值
	,remark       = ""      %% 描述
}).

-record(dun_child_sweep_cfg, {
	id            = 0       %% Id
	,wave         = 0       %% 扫荡副本波数
	,mon_reward   = []      %% 对应波数宝箱怪掉落奖励
	,remark       = ""      %% 波数描述描述
}).
