%%-----------------------------------------------------------------------------
%% @Module  :       equip_devour.hrl
%% @Author  :       WJQ
%% @Created :       2018-11-26
%% @Description:    装备吞噬头文件
%%-----------------------------------------------------------------------------

-define(DEVOUR_MAX, 		100).			%% 单次装备吞噬最大数量

%% ============================ 后台配置定义 ===================================
%% ----------------------------------------------------------------------------
%% 吞噬等级配置
-record(equip_devour_lv_con, {
	lv = 0,								%% 萌羊等级
	exp = 0,							%% 升到下一级所需经验
	attr = [],							%% 当前等级属性
	notice = 0							%% 是否需要发送传闻	(1:需要 0:不需要)
}).

%% 吞噬经验配置
-record(equip_devour_exp_con, {
	stage = 0,							%% 道具阶数
	quality = 0,						%% 道具品质
	star = 0,							%% 道具星数
	goods_id = 0,						%% 物品ID	(为0时根据前三个条件筛选)
	exp = 0								%% 吞噬增加经验值
}).
%% -----------------------------------------------------------------------------

%% ============================== 邮件&传闻定义 ===================================
%% ----------------------------------------------------------------------------
%%
%% ----------------------------------------------------------------------------

%% ============================== 常量宏定义 ===================================
%% ----------------------------------------------------------------------------
%% 功能开放等级
-define(DEVOUR_OPEN_LV, 95).
%% ----------------------------------------------------------------------------

%% ============================ 数据保存定义 ===================================
%% ----------------------------------------------------------------------------
%% PS保存记录
-record(equip_devour_status, {
	role_id = 0,						%% 角色ID
	lv = 0,								%% 吃货羊当前等级
	exp = 0,							%% 吃货羊当前经验
	attr = []							%% 吃货羊当前属性
}).
%% ----------------------------------------------------------------------------

%% =============================== SQL 查询 ===================================
%% ----------------------------------------------------------------------------
%% Tab: [equip_devour]
-define(SQL_SELECT_STATUS, <<"SELECT `role_id`, `lv`, `exp` FROM `equip_devour` WHERE `role_id` = ~p">>).
-define(SQL_REPLACE_STATUS, <<"REPLACE INTO `equip_devour` (`role_id`, `lv`, `exp`) VALUES (~p, ~p, ~p)">>).
%% ----------------------------------------------------------------------------
