%%%--------------------------------------
%%% @Module  : login_reward.hrl
%%% @Author  : hyh
%%% @Created : 2018.01.12
%%% @Description:  七天登录
%%%--------------------------------------

% -define(LOGIN_REWARD_CFG_LV, 74).

%% 额外奖励格式类型
-define(REWARD_TYPE_LV,     1).     %% 指定玩家等级
-define(REWARD_TYPE_COMBAT, 2).     %% 指定玩家战力
-define(REWARD_TYPE_WLV,    3).     %% 指定玩家落后世界等级

% 指定玩家等级和职业 [{[玩家等级下限, 玩家等级上限], [{玩家职业, [{类型, 道具ID, 数量},...]},...]},...]
% 指定玩家战力和职业 [{[玩家战力下限, 玩家战力上限], [{玩家职业, [{类型, 道具ID, 数量},...]},...]},...]
% 指定玩家落后世界等级和职业 {落后世界等级下限, [{玩家职业, [{类型, 道具ID, 数量},...]},...]} （大于或等于关系）

-define(LOGIN_REWARD_CANNOT, 0).
-define(LOGIN_REWARD_UNGET, 1).
-define(LOGIN_REWARD_GETED, 2).

-define(LOGIN_REWARD_SHOW,  7).

-record(login_reward, {
    role_id = 0,           %% 角色id
    % day_id = 0,            %% 当前可领取阶段天数id
    day_states = [],       %% 已领取天数
    get_date = 0,          %% 领取时间
    refresh_days_time = 0, %% 上一次统计登录时间
    login_days = 0         %% 累计登录天数
}).

-record(login_reward_day_con, {
    day_id = 0,
    name = "",
    reward_list = [],
    extra_reward_type = 0,      %% 奖励类型 1指定等级段 2指定战力 3落后世界等级
    extra_reward = [],
    resource_id = [],
    show_type = 0
}).

-define(SQL_SELECT_LOGIN_REWARD,
    <<"SELECT `role_id`, `get_date`, `refresh_days_time`, `login_days`, `day_states` FROM `login_reward_player` WHERE `role_id` = ~p">>).

-define(SQL_REPLACE_LOGIN_REWARD,
    <<"REPLACE INTO `login_reward_player` (`role_id`, `get_date`, `refresh_days_time`, `login_days`, `day_states`) VALUES (~p, ~p, ~p, ~p, ~ts)">>).

-define(SQL_REPLACE_LOGIN_REWARD_WITH_QUOTA,
    <<"REPLACE INTO `login_reward_player` (`role_id`, `get_date`, `refresh_days_time`, `login_days`, `day_states`) VALUES (~p, ~p, ~p, ~p, '~ts')">>).
