%% desc     : 超级富豪头文件
%% author   : hh
%% time     : 20/08/25

%% 玩家超级富豪数据 存储于custom_act_data.act_data
-record(role_mono_poly, {
    total_gold = 0,         %% 今日已累充
    normal_get = 0,         %% 今日已获得普通骰子次数
    gold_get = 0,           %% 今日已获得金骰子次数
    dice_count = 0,         %% 今日已投掷普通次数
    gold_dice_count = 0,    %% 今日已投掷金骰子次数
    time = 0,               %% 操作最后时间
    normal_count = 0,       %% 已获普通次数
    normal_use = 0,         %% 已使用普通次数
    gold_count = 0,         %% 已获高级次数
    gold_use = 0,           %% 已使用高级次数
    round = 0,              %% 当前圈数
    dice_index = 0,         %% 当前停留格子编号
    lucky_pool = [],        %% 幸运奖池 [{奖励index, status}]
    reissue_count = 0,      %% 当前可补签次数
    reissue_use = 0,        %% 当前已补签次数
    circle_dice_list = [],  %% 当前圈数状态 [{格子index, 奖励列表, 幸运池索引}]
    round_rewards = []      %% [{圈数,奖励领取状态}]   
    }).

-define(NORMAL_DICE, 1).
-define(GOLD_DICE,   2).

-define(NORMAL_BOX,     1). %% 普通宝箱     
-define(LUCKY_BOX,      2). %% 幸运卡     
-define(ANOTHER_CHANCE, 3). %% 再投一次    
-define(BACKWARD_3,     4). %% 倒退3格    
-define(BACKWARD_1,     5). %% 倒退1格    
-define(DIRECT_END,     6). %% 直达终点

-define(LUCK_ACCESS,     0).
-define(LUCK_NOT_ACCESS, 1).

-define(TREASURE_LUCK,    1).
-define(NORMAL_LUCK,      2).

-define(ROUND_REWARDS_0, 0).    %% 不可领取
-define(ROUND_REWARDS_1, 1).    %% 可领取
-define(ROUND_REWARDS_2, 2).    %% 已领取

% 小宝箱奖励
-record(base_mono_smallbox, {
    index = 0,
    weight = 0,
    rewards = []
    }).

% 幸运卡奖励
-record(base_mono_luckycard, {
    index = 0,
    type = 0,       %% 1珍稀|2普通
    weight = 0,
    rewards = []
    }).

% 圈数奖励
-record(base_mono_round_rewards, {
    act_type = 0,
    sub_type = 0,
    round = 0,
    rewards = [],
    show = []
    }).

% 补签消耗
-record(base_mono_price, {
    count = 0,          %% 补签次数
    pirce = 0           %% 价格
    }).

%% 骰子格子类型
-record(base_mono_lattice, {
    round = 0,          %% 圈数
    lattice_index = 0,  %% 格子编号
    type = 0            %% 格子类型 1普通宝箱|2幸运卡|3再投一次|4倒退3格|5倒退1格|6直达终点
    }).

% 骰子点数权重
-record(base_mono_dice, {
    type = 0,           %% 0普通|1金骰子
    dice_count = 0,     %% 今日第几次投掷
    weight = []         %% 权重
    }).