%%%-------------------------------------------------------------------
%%% @doc     拼图头文件
%%% Module  : puzzle.hrl
%%% Created : 2020-12-07
%%% @author :tyl
%%% @end
%%%-------------------------------------------------------------------
%% 拼图阶数
-define(PUZZLE_2, 2).
-define(PUZZLE_3, 3).
-define(PUZZLE_4, 4).
-define(PUZZLE_5, 5).

%% 默认阶数
-define(PUZZLE_DEFAULT_ORDER, 2).

%% 拼图固定时间
-define(PUZZLE_2_TIME, 30).     %% 2阶
-define(PUZZLE_3_TIME, 60).     %% 3阶
-define(PUZZLE_4_TIME, 120).    %% 4阶
-define(PUZZLE_5_TIME, 180).    %% 5阶

-record(puzzle_data, {
	card_list   = []         %% 当前卡片位置[{{x,y},Num}...]
	,stage_list = []         %% 已完成阶段[stage...]
	,continue   = 0          %% 连续通关次数
	,picture    = 0          %% 当前图片Id
	,pic_list   = []         %% 抽取过的图片列表
	,start_time = 0          %% 开始时间
	,end_time   = 0          %% 结束时间
	,ref        = []         %% 结束定时器
}).