%%%---------------------------------------------------------------------
%%% 充值相关record定义
%%%---------------------------------------------------------------------
%% 充值数据
-record (recharge_status, {
           return_data     = #{},             %% 充值返利#{{product_id, return_type} => time}
           first_data      = []        %% 首充奖励数据 [#first_recharge{}]
    }).

%% 首充数据
-record(first_recharge, {
    product_id      = 0,         %% 产品id
    recharge        = 0,
    trigger_time    = 0,
    award_list      = []         %% 已领奖励列表[序号(第几天)...]
}).

%% 每日充值细则
-record(daily_recharge, {
    zero_time,                        %% 0点时间戳
    total_gold,                       %% 这一天的总元宝
    total_rmb,                        %% 这一天的总金额
    detail = []                       %% 详细 [[时间戳, 元宝, 金额]]
}).

%% 充值统计
-record(role_recharge_statistic, {
    last_pay_time = 0       %% 充值时间
    , total_money = 0       %% 总充值钱：实数
    , total_gold = 0        %% 总充值元宝
    %% 根据上面参数计算的评级
    , recency = 0       %% 评级：充值间隔   last_pay_time与登录时间戳相差的天数区间
    , frequency = 0     %% 评级：充值频率   最近30天内的充值次数
    , monetary = 0      %% 评级：历史总充值
    , top = 0           %% 评级：最高额充值
}).
%%%------------------------------配置相关------------------------------
%% 充值配置
-record(base_recharge_product, {
           product_id       = 0,              %% 商品id(0:特殊商品id：0任意充值的的额度)
           product_name     = "",             %% 商品名称
           product_type     = 0,              %% 商品大类:1常规充值 2福利卡 3每日礼包 4首冲礼包 99审核专用
           product_subtype  = 0,              %% 商品子类
           money            = 0,              %% 商品价格
           game_currency    = 0,              %% 充值游戏币: 只有增加元宝时使用的参数
           act_value        = 0,              %% 累充额度(触发其他系统)
           associate_list   = [],             %% 关联商品 [{商品大类,商品子类}]
           is_auth_show     = 0,              %% 审核服是否可见
           about            = ""              %% 描述
}).

%% 充值返利配置
-record(base_recharge_return, {
           product_id       = 0,              %% 商品id
           return_type      = 0,              %% 返利类型 0:无返利、1:终生首次、2:活动时间返利
           gold             = 0,              %% 基础钻石
           return_gold      = 0               %% 返利钻石
}).

%% 商品配置
-record(base_recharge_goods, {
    id              = 0,    %% 商品id
    type            = 0,    %% 商品类型
    sub_type        = 0,    %% 商品子类
    name            = "",   %% 商品名称
    limit           = [],   %% 限购类型##[限购类型，限购数量]
    start_time      = 0,    %% 开始时间
    end_time        = 0,    %% 结束时间
    open_day        = [],   %% 开服天数##[开始,结束]
    merge_day       = [],   %% 合服天数##[开始,结束]
    condition       = [],   %% 上架条件
    award           = []    %% 商品内容
}).