%% ---------------------------------------------------------------------------
%% @doc role.hrl

%% @author hjh
%% @since  2016-12-06
%% @deprecated 角色信息
%% ---------------------------------------------------------------------------

%% -define(ETS_ROLE_MAJOR, ets_role_major).
-define(ETS_ROLE_SHOW, ets_role_show).

%% 角色信息(操作只能在进程,数据重要,保证唯一性)
%% -record(ets_role_major, {id}).

%% 角色信息展示(数据不重要,不能过于频繁)
-record(ets_role_show, {
        id = 0
        , accid = 0
        , accname = <<>>
        , figure = undefined            %%
        , online_flag = 0               %% 在线标识
        , last_login_time = 0           %% 上次登陆时间
        , last_logout_time = 0          %% 上次登出时间
        , combat_power = 0              %% 玩家当前战力
        , h_combat_power = 0            %% 玩家历史最高战力
        , left_activity_num_list = []   %% 剩余活动次数列表 [{{Module, SubModule, Type}, Count} |...]
                                        %% 本字段登录时才初始化加载，离线的玩家不加载
        , mate_title = []               %% 羁绊称号
        , offline_hosting = 0           %% 是否设置了离线托管
    }).

%% 获取玩家展示的信息
-define(sql_role_show_other_info, <<"
    select
        pl.accid, pl.accname, pl.online_flag, pl.last_login_time, pl.last_logout_time, ps.last_combat_power, ph.hightest_combat_power
    from player_login as pl left join player_high as ph on pl.id = ph.id left join player_state as ps on pl.id = ps.id WHERE pl.id = ~p">>).

%% 获取最后退出游戏时候玩家战力
-define(sql_role_last_logout_power, <<"select last_combat_power from player_state where id = ~p">>).

%% ------------------------------------------------
%% @doc 查看角色信息
%% ------------------------------------------------
