%%% @author root <root@localhost.localdomain>
%%% @copyright (C) 2017, root
%%% @doc
%%% 商城
%%% @end
%%% Created :  3 Nov 2017 by root <root@localhost.localdomain>

%% 1-交易商城|2-羁绊商城|3-彩钻商城|4-名望商城|5-红钻商城
-define(SHOP_COIN,    1).        %% 交易商城
-define(SHOP_HONOUR,  2).        %% 名望商城
-define(SHOP_BGOLD,   3).        %% 红钻商城
-define(SHOP_MATE,    4).        %% 羁绊商城
-define(SHOP_GOLD,    5).        %% 彩钻商城

-define(SHOP_DIAMOND_VIP,  100). %% 至尊vip商城
-define(SHOP_KF_TOWN_WAR,  101). %% 跨服城战商城
-define(SHOP_1VN,          102). %% 1VN挑战者商城
-define(SHOP_1VN_DEF,      103). %% 1VN擂主商城

-define(QUOTA_NOTLIMIT, 0).      %% 不限购
-define(QUOTA_WEEK,     1).      %% 每周限购
-define(QUOTA_DAILY,    2).      %% 每日限购
-define(QUOTA_LIFE,     3).      %% 终生限购

%% 折扣基数
-define(BASE_DISCOUNT, 100).

%%商店表
-record(shop, {
          key_id,                %% 自增ID 唯一ID
          shop_type=0,           %% 商店类型， 1-每周限购，2-常用道具，3-绑定元宝，4-时装外形，5-终生商城
          sub_type=0,            %% 商店子类型， 1-每周限购，2-常用道具，3-绑定元宝，4-时装外形，5-终生商城
          rank=0,                %% 排序ID 道具显示在商城界面的顺序，由小到大显示，可重复
          goods_id=0,            %% 物品类型ID
          num = 0,               %% 单次出售个数 默认1
          ctype = 0,             %% 价格类型：1-钻石，2-绑定钻石，其他待定
          price=0,               %% 出售价格
          discount=0,            %% 折扣：默认100
          quota_type = 0,        %% 限购类型，0-不限购，1-每周限购，2-每日限购
          quota_num = 0,         %% 限购数量
          on_sale = 0,           %% 该道具在商城出售的开始出售的开服天数
          halt_sale = 0,         %% 该道具在商城出售的结束出售的开服天数
          wlv_sale = 0,          %% 默认是0,0为不限制，若有则为到该等级开始出售
          wlv_unsale = 0,        %% 默认是0,0为不限制，若有则为到该等级停止出售
          condition = [],        %% 否买条件：不限时默认[]，根据需求填条件[{lv,122,123},{vip,3}],可同时填多个
          bind = 0,              %% 是否绑定：默认是0,0为不绑定，1为绑定
          counter_module = 0,    %% 模块id
          counter_id = 0,        %% 次数id(由商店类型+模块id=确定)(根据配置这个在哪里计数器类型来重置)
          preview = 0            %% 是否可预览：默认为0，0为不可试穿，1为可试穿
          ,hot = 0               %% 热门推荐（0表示不进入热门推荐，大于0则是在热门推荐中的顺序） 
          ,on_lev = 0            %% 上架等级-等级条件未达到商品不上架，不显示在商城中
          ,down_lev = 0          %% 下架等级-等级条件超过后商品下架，不显示在商城中
          ,tips = 2              %% 标签 - 1.热卖2.新品3.独占4.必买
          ,career = 0            %% 1,2,3,4表示4个职业，0表示全职业。不是本职业的商品看不到
         }).
