%%%---------------------------------------
%%% module      : data_act_boss
%%% description : 活动BOSS配置
%%%
%%%---------------------------------------
-module(data_act_boss).
-compile(export_all).



%%BOSS存在秒数
get_act_boss_kv(boss_exist) ->
    5400;

%%BOSS刷新时间节点
get_act_boss_kv(boss_time) ->
    [{11,30},{19,00}];

%%稀有掉落奖励展示（活动界面）
get_act_boss_kv(drop_reward) ->
    [{100,330903,1},{100,250102,1},{100,109035,1},{100,450024,1},{100,102305,1},{100,450019,1},{100,450040,1}];

%%第一击奖励
get_act_boss_kv(first_hurt) ->
    [{100,450023,1},{100,450026,1}];

%%参与击杀奖励
get_act_boss_kv(kill_reward) ->
    [{100,109031,2},{100,102009,1}];

%%最后一击奖励
get_act_boss_kv(last_hurt) ->
    [{100,109032,1},{100,450025,1}];

%%单个BOSS分享奖励人数上限
get_act_boss_kv(share_max) ->
    5;

%%坐标分享奖励
get_act_boss_kv(share_reward) ->
    [{100,102403,1},{100,102000,1}];

%%组队击杀奖励
get_act_boss_kv(team_reward) ->
    [{100,102402,2},{100,102004,1}];

get_act_boss_kv(_Keycontent) ->
    [].

get_all_scene() ->
    [1002,1004,1005,1007,1008].


get_scene_position(1002) ->
    [{20487,4410},{26088,13304}];


get_scene_position(1004) ->
    [{5881,9670},{2369,7033}];


get_scene_position(1005) ->
    [{12180,11043},{1869,6701}];


get_scene_position(1007) ->
    [{10831,12954},{8671,15909}];


get_scene_position(1008) ->
    [{10626,6626},{8964,8611}];

get_scene_position(_Scene) ->
    [].


get_scene_boss(1002) ->
    [85000001];


get_scene_boss(1004) ->
    [85000001,85000003];


get_scene_boss(1005) ->
    [85000002];


get_scene_boss(1007) ->
    [85000002];


get_scene_boss(1008) ->
    [85000003];

get_scene_boss(_Scene) ->
    [].

get_act_boss_rank_reward(Rank) when Rank >= 1  andalso  Rank =< 1 ->
		[{100,102404,2},{100,450023,3},{100,109032,1}];
get_act_boss_rank_reward(Rank) when Rank >= 2  andalso  Rank =< 2 ->
		[{100,102404,1},{100,450023,2}];
get_act_boss_rank_reward(Rank) when Rank >= 3  andalso  Rank =< 3 ->
		[{100,102402,3},{100,450023,1}];
get_act_boss_rank_reward(Rank) when Rank >= 4  andalso  Rank =< 4 ->
		[{100,102402,2},{100,450023,1}];
get_act_boss_rank_reward(Rank) when Rank >= 5  andalso  Rank =< 5 ->
		[{100,102402,1},{100,109031,2}];
get_act_boss_rank_reward(_Rank) ->
    [].

