%%%---------------------------------------
%%% module      : data_activitycalen
%%% description : 活动日历配置
%%%
%%%---------------------------------------
-module(data_activitycalen).
-compile(export_all).
-include("activitycalen.hrl").



get_push_config(155,0) ->
    #ac_push{module = 155,module_sub = 0,push = 0,push_msg = "夺旗战场还有5分钟开始"};

get_push_config(646,0) ->
    #ac_push{module = 646,module_sub = 0,push = 0,push_msg = "野外领主还有5分钟开始"};

get_push_config(_Module,_Modulesub) ->
    #ac_push{}.

get_reward_id() ->
    [1,2,3,4,5].

get_reward_config(1,_RoleLv) when _RoleLv >= 1, _RoleLv =< 1000 ->
	#ac_reward{sort=1,id=1,min_lv=1,max_lv=1000,live=30,reward=[{0,102120,2}]};
get_reward_config(2,_RoleLv) when _RoleLv >= 1, _RoleLv =< 1000 ->
	#ac_reward{sort=2,id=2,min_lv=1,max_lv=1000,live=60,reward=[{0,109002,1}]};
get_reward_config(3,_RoleLv) when _RoleLv >= 1, _RoleLv =< 1000 ->
	#ac_reward{sort=3,id=3,min_lv=1,max_lv=1000,live=90,reward=[{0,102120,3}]};
get_reward_config(4,_RoleLv) when _RoleLv >= 1, _RoleLv =< 1000 ->
	#ac_reward{sort=4,id=4,min_lv=1,max_lv=1000,live=120,reward=[{0,102305,1}]};
get_reward_config(5,_RoleLv) when _RoleLv >= 1, _RoleLv =< 1000 ->
	#ac_reward{sort=5,id=5,min_lv=1,max_lv=1000,live=150,reward=[{0,102305,1}]};
get_reward_config(_Id,_RoleLv) ->
    [].

get_live_config(130,5) ->
    #ac_liveness{module = 130,module_sub = 5,act_type = 1,name = "交易券收集",start_lv = 9999,end_lv = 9999,max = 3500,res_max = 1,live = 0};

get_live_config(130,6) ->
    #ac_liveness{module = 130,module_sub = 6,act_type = 1,name = "名望券收集",start_lv = 96,end_lv = 9999,max = 1500,res_max = 1,live = 5};

get_live_config(142,0) ->
    #ac_liveness{module = 142,module_sub = 0,act_type = 2,name = "社团竞速",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 0};

get_live_config(152,0) ->
    #ac_liveness{module = 152,module_sub = 0,act_type = 1,name = "装备升星",start_lv = 100,end_lv = 9999,max = 1,res_max = 0,live = 10};

get_live_config(215,1) ->
    #ac_liveness{module = 215,module_sub = 1,act_type = 1,name = "装备副本",start_lv = 100,end_lv = 9999,max = 2,res_max = 2,live = 15};

get_live_config(215,2) ->
    #ac_liveness{module = 215,module_sub = 2,act_type = 1,name = "守卫信标",start_lv = 250,end_lv = 9999,max = 2,res_max = 2,live = 0};

get_live_config(223,0) ->
    #ac_liveness{module = 223,module_sub = 0,act_type = 1,name = "好友送礼",start_lv = 96,end_lv = 9999,max = 5,res_max = 1,live = 5};

get_live_config(280,0) ->
    #ac_liveness{module = 280,module_sub = 0,act_type = 1,name = "竞技场",start_lv = 92,end_lv = 9999,max = 10,res_max = 10,live = 1};

get_live_config(300,1) ->
    #ac_liveness{module = 300,module_sub = 1,act_type = 1,name = "经验跑环",start_lv = 96,end_lv = 9999,max = 10,res_max = 10,live = 2};

get_live_config(300,2) ->
    #ac_liveness{module = 300,module_sub = 2,act_type = 1,name = "社团跑环",start_lv = 100,end_lv = 9999,max = 10,res_max = 10,live = 1};

get_live_config(400,3) ->
    #ac_liveness{module = 400,module_sub = 3,act_type = 1,name = "社团拼单",start_lv = 100,end_lv = 9999,max = 5,res_max = 5,live = 2};

get_live_config(400,7) ->
    #ac_liveness{module = 400,module_sub = 7,act_type = 2,name = "社团晚宴",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(406,1) ->
    #ac_liveness{module = 406,module_sub = 1,act_type = 2,name = "社团幻魔",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(406,2) ->
    #ac_liveness{module = 406,module_sub = 2,act_type = 2,name = "社团幻魔",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(408,0) ->
    #ac_liveness{module = 408,module_sub = 0,act_type = 2,name = "封印裂隙",start_lv = 9999,end_lv = 9999,max = 10,res_max = 10,live = 0};

get_live_config(415,0) ->
    #ac_liveness{module = 415,module_sub = 0,act_type = 2,name = "狂战领域",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 0};

get_live_config(418,0) ->
    #ac_liveness{module = 418,module_sub = 0,act_type = 2,name = "舞池派对",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(460,1) ->
    #ac_liveness{module = 460,module_sub = 1,act_type = 1,name = "个人幻魔",start_lv = 90,end_lv = 9999,max = 2,res_max = 2,live = 10};

get_live_config(460,3) ->
    #ac_liveness{module = 460,module_sub = 3,act_type = 1,name = "赏金幻魔",start_lv = 100,end_lv = 9999,max = 5,res_max = 5,live = 10};

get_live_config(461,1) ->
    #ac_liveness{module = 461,module_sub = 1,act_type = 1,name = "星域幻魔",start_lv = 180,end_lv = 9999,max = 3,res_max = 3,live = 10};

get_live_config(461,2) ->
    #ac_liveness{module = 461,module_sub = 2,act_type = 1,name = "星域精英怪",start_lv = 180,end_lv = 9999,max = 6,res_max = 6,live = 1};

get_live_config(463,0) ->
    #ac_liveness{module = 463,module_sub = 0,act_type = 1,name = "沧海拾宝",start_lv = 120,end_lv = 9999,max = 1,res_max = 0,live = 5};

get_live_config(500,0) ->
    #ac_liveness{module = 500,module_sub = 0,act_type = 1,name = "水晶护送",start_lv = 100,end_lv = 9999,max = 3,res_max = 3,live = 5};

get_live_config(600,0) ->
    #ac_liveness{module = 600,module_sub = 0,act_type = 2,name = "无尽领域",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 0};

get_live_config(610,4) ->
    #ac_liveness{module = 610,module_sub = 4,act_type = 1,name = "无尽回廊",start_lv = 105,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(610,7) ->
    #ac_liveness{module = 610,module_sub = 7,act_type = 1,name = "幻光副本",start_lv = 125,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(610,8) ->
    #ac_liveness{module = 610,module_sub = 8,act_type = 1,name = "宠物副本",start_lv = 145,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(610,10) ->
    #ac_liveness{module = 610,module_sub = 10,act_type = 1,name = "未来神域",start_lv = 280,end_lv = 9999,max = 1,res_max = 2,live = 0};

get_live_config(610,15) ->
    #ac_liveness{module = 610,module_sub = 15,act_type = 1,name = "快速挂机",start_lv = 100,end_lv = 9999,max = 6,res_max = 6,live = 4};

get_live_config(610,20) ->
    #ac_liveness{module = 610,module_sub = 20,act_type = 1,name = "主线副本",start_lv = 86,end_lv = 9999,max = 1,res_max = 1,live = 0};

get_live_config(610,1001) ->
    #ac_liveness{module = 610,module_sub = 1001,act_type = 1,name = "座驾副本",start_lv = 42,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,1002) ->
    #ac_liveness{module = 610,module_sub = 1002,act_type = 1,name = "宝具副本",start_lv = 150,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,1003) ->
    #ac_liveness{module = 610,module_sub = 1003,act_type = 1,name = "AI娘副本",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,1004) ->
    #ac_liveness{module = 610,module_sub = 1004,act_type = 1,name = "神翼副本",start_lv = 110,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,1005) ->
    #ac_liveness{module = 610,module_sub = 1005,act_type = 1,name = "武器副本",start_lv = 130,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,1006) ->
    #ac_liveness{module = 610,module_sub = 1006,act_type = 1,name = "磁炮副本",start_lv = 150,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,1007) ->
    #ac_liveness{module = 610,module_sub = 1007,act_type = 1,name = "幻甲副本",start_lv = 180,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,1008) ->
    #ac_liveness{module = 610,module_sub = 1008,act_type = 1,name = "星翼副本",start_lv = 220,end_lv = 9999,max = 1,res_max = 1,live = 2};

get_live_config(610,5001) ->
    #ac_liveness{module = 610,module_sub = 5001,act_type = 1,name = "经验副本",start_lv = 100,end_lv = 9999,max = 1,res_max = 1,live = 5};

get_live_config(_Module,_Modulesub) ->
    #ac_liveness{}.

get_live_key() ->
    [{130,5},{130,6},{142,0},{152,0},{215,1},{215,2},{223,0},{280,0},{300,1},{300,2},{400,3},{400,7},{406,1},{406,2},{408,0},{415,0},{418,0},{460,1},{460,3},{461,1},{461,2},{463,0},{500,0},{600,0},{610,4},{610,7},{610,8},{610,10},{610,15},{610,20},{610,1001},{610,1002},{610,1003},{610,1004},{610,1005},{610,1006},{610,1007},{610,1008},{610,5001}].

get_ac(130,5,1) ->
    #base_ac{module = 130,module_sub = 5,ac_sub = 1,ac_name = "交易券收集",ac_icon = "130005",num = 1,start_lv = 9999,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "获得3500交易券，每天都有小钱花",reward = [{1,[{5,100007,1}]},{999,[{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(130,6,1) ->
    #base_ac{module = 130,module_sub = 6,ac_sub = 1,ac_name = "名望券收集",ac_icon = "130006",num = 1,start_lv = 96,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "获得1500名望券，常协助有好人缘",reward = [{1,[{5,100007,1}]},{999,[{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(142,0,1) ->
    #base_ac{module = 142,module_sub = 0,ac_sub = 1,ac_name = "赛马竞猜",ac_icon = "142001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{20,02},{20,14}}],open_day = [],merge_day = [],about = "社团晚宴中的赛马活动，获得积分越高奖励越多喔！",reward = [{1,[{8,100004,1}]},{999,[{8,100004,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(152,0,1) ->
    #base_ac{module = 152,module_sub = 0,ac_sub = 1,ac_name = "装备升星",ac_icon = "130005",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "高效提升战力的途径",reward = [{1,[{5,100007,1}]},{999,[{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(215,1,1) ->
    #base_ac{module = 215,module_sub = 1,ac_sub = 1,ac_name = "装备副本",ac_icon = "215001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "组队挑战，更快通关",reward = [{1,[{4,100003,1},{5,100007,1},{0,24101013,1}]},{999,[{4,100003,1},{5,100007,1},{0,24101013,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(215,2,1) ->
    #base_ac{module = 215,module_sub = 2,ac_sub = 1,ac_name = "守卫信标",ac_icon = "215002",num = 1,start_lv = 250,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "多人挑战，与其他玩家组队保护信标，坚持得越久奖励越多喔！",reward = [{1,[{100,280101,1},{100,109031,1},{2,100001,1}]},{999,[{100,280101,1},{100,109031,1},{2,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(223,0,1) ->
    #base_ac{module = 223,module_sub = 0,ac_sub = 1,ac_name = "好友送礼",ac_icon = "223000",num = 1,start_lv = 96,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "好关系要常常维护哦",reward = [{1,[{5,100007,1}]},{999,[{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(280,0,1) ->
    #base_ac{module = 280,module_sub = 0,ac_sub = 1,ac_name = "竞技场",ac_icon = "280000",num = 1,start_lv = 92,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚喔！",reward = [{1,[{4,100003,1},{5,100007,1},{1,100001,1}]},{999,[{4,100003,1},{5,100007,1},{1,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(300,1,1) ->
    #base_ac{module = 300,module_sub = 1,ac_sub = 1,ac_name = "经验跑环",ac_icon = "300001",num = 1,start_lv = 96,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "每天10环，等级提升不用愁！",reward = [{1,[{5,100007,1},{0,102004,1},{0,450026,1}]},{999,[{5,100007,1},{0,102004,3},{0,450026,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(300,2,1) ->
    #base_ac{module = 300,module_sub = 2,ac_sub = 1,ac_name = "社团跑环",ac_icon = "300002",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "每天10环，等级提升不用愁！",reward = [{1,[{5,100007,1},{0,109032,1},{0,450026,1}]},{999,[{5,100007,1},{0,109032,3},{0,450026,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(400,3,1) ->
    #base_ac{module = 400,module_sub = 3,ac_sub = 1,ac_name = "社团拼单",ac_icon = "300002",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "欢乐拼单，互帮互助",reward = [{1,[{5,100007,1}]},{999,[{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(400,7,1) ->
    #base_ac{module = 400,module_sub = 7,ac_sub = 1,ac_name = "社团晚宴",ac_icon = "400007",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{20,00},{20,15}}],open_day = [],merge_day = [],about = "社团参与人数越多，经验获取越多！",reward = [{1,[{5,100007,1},{8,100004,1}]},{999,[{5,100007,1},{8,100004,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 600};

get_ac(405,1,1) ->
    #base_ac{module = 405,module_sub = 1,ac_sub = 1,ac_name = "本服团战",ac_icon = "405001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{20,30},{20,50}}],open_day = [{2,2}],merge_day = [],about = "击败结晶守卫，运送高级结晶！",reward = [{1,[{17,432001,1},{17,432002,1},{17,432008,1},{100,102603,10}]},{999,[{17,432001,1},{17,432002,1},{17,432008,1},{100,102603,10}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 600};

get_ac(405,1,2) ->
    #base_ac{module = 405,module_sub = 1,ac_sub = 2,ac_name = "本服团战",ac_icon = "405001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [2],month = [],time = [],time_region = [{{20,30},{20,50}}],open_day = [{5,9999}],merge_day = [],about = "击败结晶守卫，运送高级结晶！",reward = [{1,[{17,432001,1},{17,432002,1},{17,432008,1},{100,102603,10}]},{999,[{17,432001,1},{17,432002,1},{17,432008,1},{100,102603,10}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 600};

get_ac(405,1,3) ->
    #base_ac{module = 405,module_sub = 1,ac_sub = 3,ac_name = "本服团战",ac_icon = "405001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [2],month = [],time = [],time_region = [{{20,30},{20,50}}],open_day = [],merge_day = [{1,9999}],about = "击败结晶守卫，运送高级结晶！",reward = [{1,[{17,432001,1},{17,432002,1},{17,432008,1},{100,102603,10}]},{999,[{17,432001,1},{17,432002,1},{17,432008,1},{100,102603,10}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 600};

get_ac(406,1,1) ->
    #base_ac{module = 406,module_sub = 1,ac_sub = 1,ac_name = "社团幻魔",ac_icon = "406001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{12,20},{12,30}}],open_day = [],merge_day = [],about = "不可托管，社团参与人数越多，橙装掉落越多！",reward = [{1,[{0,402000,1},{0,402001,1}]},{999,[{0,402000,1},{0,402001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 1200};

get_ac(406,1,2) ->
    #base_ac{module = 406,module_sub = 1,ac_sub = 2,ac_name = "社团幻魔",ac_icon = "406001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{20,15},{20,25}}],open_day = [],merge_day = [],about = "不可托管，社团参与人数越多，橙装掉落越多！",reward = [{1,[{0,402000,1},{0,402001,1}]},{999,[{0,402000,1},{0,402001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 1200};

get_ac(408,0,1) ->
    #base_ac{module = 408,module_sub = 0,ac_sub = 1,ac_name = "封印裂隙",ac_icon = "408000",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{14,00},{14,20}},{{15,00},{15,20}},{{16,00},{16,20}}],open_day = [],merge_day = [],about = "采集时空裂隙，召唤时空宝箱！",reward = [{1,[{0,450034,1},{4,100003,1}]},{999,[{0,450034,1},{4,100003,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 1800};

get_ac(410,1,2) ->
    #base_ac{module = 410,module_sub = 1,ac_sub = 2,ac_name = "本国团战",ac_icon = "410001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [4],month = [],time = [],time_region = [{{20,30},{20,45}}],open_day = [{5,9999}],merge_day = [],about = "采集增益效果，暴打荣耀图腾！",reward = [{1,[{17,432004,1},{17,432005,1},{17,432006,1},{100,101008,1}]},{999,[{17,432004,1},{17,432005,1},{17,432006,1},{100,101008,1}]}],ask = 0,look = 0,other = [],node_type = 1,pre_notice = 600};

get_ac(410,1,3) ->
    #base_ac{module = 410,module_sub = 1,ac_sub = 3,ac_name = "本国团战",ac_icon = "410001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [4],month = [],time = [],time_region = [{{20,30},{20,45}}],open_day = [],merge_day = [{1,9999}],about = "采集增益效果，暴打荣耀图腾！",reward = [{1,[{17,432004,1},{17,432005,1},{17,432006,1},{100,101008,1}]},{999,[{17,432004,1},{17,432005,1},{17,432006,1},{100,101008,1}]}],ask = 0,look = 0,other = [],node_type = 1,pre_notice = 600};

get_ac(410,2,1) ->
    #base_ac{module = 410,module_sub = 2,ac_sub = 1,ac_name = "本国团战",ac_icon = "410001",num = 3,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{20,30},{20,45}}],open_day = [{4,4}],merge_day = [],about = "采集增益效果，暴打荣耀图腾！",reward = [{1,[{17,432004,1},{17,432005,1},{17,432006,1},{100,101008,1}]},{999,[{17,432004,1},{17,432005,1},{17,432006,1},{100,101008,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 600};

get_ac(415,0,1) ->
    #base_ac{module = 415,module_sub = 0,ac_sub = 1,ac_name = "狂战领域",ac_icon = "415001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{19,30},{19,50}}],open_day = [{1,1}],merge_day = [],about = "热血激战，击败时空领主！",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 1800};

get_ac(415,0,2) ->
    #base_ac{module = 415,module_sub = 0,ac_sub = 2,ac_name = "狂战领域",ac_icon = "415001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [2,4,6],month = [],time = [],time_region = [{{19,30},{19,50}}],open_day = [{3,9999}],merge_day = [],about = "热血激战，击败时空领主！",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 1800};

get_ac(415,0,3) ->
    #base_ac{module = 415,module_sub = 0,ac_sub = 3,ac_name = "狂战领域",ac_icon = "415001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [2,4,6],month = [],time = [],time_region = [{{19,30},{19,50}}],open_day = [],merge_day = [{1,9999}],about = "热血激战，击败时空领主！",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 1800};

get_ac(418,0,1) ->
    #base_ac{module = 418,module_sub = 0,ac_sub = 1,ac_name = "舞池派对",ac_icon = "418000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{12,00},{12,15}}],open_day = [{2,2}],merge_day = [],about = "舞池派对活动，活动内可持续获得大量经验！",reward = [{1,[{0,432003,1},{2,100001,30},{5,100007,1}]},{999,[{0,432003,1},{2,100001,30},{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 1800};

get_ac(418,0,2) ->
    #base_ac{module = 418,module_sub = 0,ac_sub = 2,ac_name = "舞池派对",ac_icon = "418000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{12,00},{12,15}}],open_day = [{3,9999}],merge_day = [],about = "跨服舞池派对活动，活动内可持续获得大量经验！",reward = [{1,[{0,432003,1},{2,100001,30},{5,100007,1}]},{999,[{0,432003,1},{2,100001,30},{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 1800};

get_ac(418,0,3) ->
    #base_ac{module = 418,module_sub = 0,ac_sub = 3,ac_name = "舞池派对",ac_icon = "418000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{12,00},{12,15}}],open_day = [],merge_day = [{1,9999}],about = "跨服舞池派对活动，活动内可持续获得大量经验！",reward = [{1,[{0,432003,1},{2,100001,30},{5,100007,1}]},{999,[{0,432003,1},{2,100001,30},{5,100007,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 1800};

get_ac(460,1,1) ->
    #base_ac{module = 460,module_sub = 1,ac_sub = 1,ac_name = "专属幻魔",ac_icon = "460001",num = 1,start_lv = 90,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "专属幻魔，产出大量装备，概率获得稀有道具",reward = [{1,[{0,102611,1},{0,102613,1},{2,100002,1}]},{999,[{0,102611,1},{0,102613,1},{2,100002,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(460,2,1) ->
    #base_ac{module = 460,module_sub = 2,ac_sub = 1,ac_name = "世界幻魔",ac_icon = "460002",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "世界幻魔，产出大量装备，概率获得稀有道具",reward = [{1,[{0,102611,1},{0,102613,1},{2,100002,1}]},{999,[{0,102611,1},{0,102613,1},{2,100002,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(460,3,1) ->
    #base_ac{module = 460,module_sub = 3,ac_sub = 1,ac_name = "赏金幻魔",ac_icon = "460003",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "赏金幻魔，产出大量装备，概率获得稀有道具",reward = [{1,[{0,102611,1},{0,102613,1},{2,100002,1}]},{999,[{0,102611,1},{0,102613,1},{2,100002,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(461,1,1) ->
    #base_ac{module = 461,module_sub = 1,ac_sub = 1,ac_name = "幻魔星域",ac_icon = "461001",num = 1,start_lv = 180,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [{5,9999}],merge_day = [],about = "探索陨落星域，获得珍稀道具",reward = [{1,[{0,102611,1},{0,102613,1},{2,100002,1}]},{999,[{0,102611,1},{0,102613,1},{2,100002,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(461,2,1) ->
    #base_ac{module = 461,module_sub = 2,ac_sub = 1,ac_name = "星域精英",ac_icon = "461002",num = 1,start_lv = 180,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [{5,9999}],merge_day = [],about = "探索陨落星域，获得珍稀道具",reward = [{1,[{0,102611,1},{0,102613,1},{2,100002,1}]},{999,[{0,102611,1},{0,102613,1},{2,100002,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(463,0,1) ->
    #base_ac{module = 463,module_sub = 0,ac_sub = 1,ac_name = "沧海拾宝",ac_icon = "610000",num = 1,start_lv = 120,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [{2,9999}],merge_day = [],about = "轻松挂机，经验材料轻松拿",reward = [{1,[{5,100007,1},{3,100002,1},{2,100001,1}]},{999,[{5,100007,1},{3,100002,1},{2,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(500,0,1) ->
    #base_ac{module = 500,module_sub = 0,ac_sub = 1,ac_name = "双倍护送",ac_icon = "500000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "双倍护送，经验多多",reward = [{1,[{5,100007,1},{2,100001,1}]},{999,[{5,100007,1},{2,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(500,1,2) ->
    #base_ac{module = 500,module_sub = 1,ac_sub = 2,ac_name = "双倍护送",ac_icon = "500001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{17,0},{17,30}},{{21,30},{22,0}}],open_day = [{1,9999}],merge_day = [{0,9999}],about = "双倍护送，双倍奖励。",reward = [{1,[{5,100007,1},{2,100001,1}]},{999,[{5,100007,1},{2,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 1800};

get_ac(600,0,1) ->
    #base_ac{module = 600,module_sub = 0,ac_sub = 1,ac_name = "无尽领域",ac_icon = "600000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{19,30},{19,50}}],open_day = [{2,2}],merge_day = [],about = "激情混战，胜者为王",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 1800};

get_ac(600,0,2) ->
    #base_ac{module = 600,module_sub = 0,ac_sub = 2,ac_name = "无尽领域",ac_icon = "600000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [1,3,5,7],month = [],time = [],time_region = [{{19,30},{19,50}}],open_day = [{3,9999}],merge_day = [],about = "激情混战，胜者为王",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 1800};

get_ac(600,0,3) ->
    #base_ac{module = 600,module_sub = 0,ac_sub = 3,ac_name = "无尽领域",ac_icon = "600000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [1,3,5,7],month = [],time = [],time_region = [{{19,30},{19,50}}],open_day = [],merge_day = [{1,9999}],about = "激情混战，胜者为王",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 1800};

get_ac(601,0,1) ->
    #base_ac{module = 601,module_sub = 0,ac_sub = 1,ac_name = "跨服国战",ac_icon = "601000",num = 1,start_lv = 140,end_lv = 9999,ac_type = 2,week = [6],month = [],time = [],time_region = [{{20,30},{21,00}}],open_day = [{5,9999}],merge_day = [],about = "四国至高火拼，巅峰跨服对决！",reward = [{1,[{0,260004,2},{0,260002,5},{0,450020,2},{0,450019,6}]},{999,[{0,260004,2},{0,260002,5},{0,450020,2},{0,450019,6}]}],ask = 0,look = 0,other = [],node_type = 1,pre_notice = 3600};

get_ac(601,0,2) ->
    #base_ac{module = 601,module_sub = 0,ac_sub = 2,ac_name = "跨服国战",ac_icon = "601000",num = 1,start_lv = 140,end_lv = 9999,ac_type = 2,week = [6],month = [],time = [],time_region = [{{20,30},{21,00}}],open_day = [],merge_day = [{1,9999}],about = "四国至高火拼，巅峰跨服对决！",reward = [{1,[{0,260004,2},{0,260002,5},{0,450020,2},{0,450019,6}]},{999,[{0,260004,2},{0,260002,5},{0,450020,2},{0,450019,6}]}],ask = 0,look = 0,other = [],node_type = 1,pre_notice = 3600};

get_ac(602,0,1) ->
    #base_ac{module = 602,module_sub = 0,ac_sub = 1,ac_name = "饥饿游戏",ac_icon = "602001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{20,30},{20,50}}],open_day = [{1,1}],merge_day = [],about = "废土大逃杀，谁能站到最后！",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 600};

get_ac(602,0,2) ->
    #base_ac{module = 602,module_sub = 0,ac_sub = 2,ac_name = "饥饿游戏",ac_icon = "602001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [],month = [],time = [],time_region = [{{20,30},{20,50}}],open_day = [{3,3}],merge_day = [],about = "废土大逃杀，谁能站到最后！",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 600};

get_ac(602,0,3) ->
    #base_ac{module = 602,module_sub = 0,ac_sub = 3,ac_name = "饥饿游戏",ac_icon = "602001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [1,3,5,7],month = [],time = [],time_region = [{{20,30},{20,50}}],open_day = [{5,9999}],merge_day = [],about = "废土大逃杀，谁能站到最后！",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 600};

get_ac(602,0,4) ->
    #base_ac{module = 602,module_sub = 0,ac_sub = 4,ac_name = "饥饿游戏",ac_icon = "602001",num = 1,start_lv = 100,end_lv = 9999,ac_type = 2,week = [1,3,5,7],month = [],time = [],time_region = [{{20,30},{20,50}}],open_day = [],merge_day = [{1,9999}],about = "废土大逃杀，谁能站到最后！",reward = [{1,[{100,102000,1},{100,450023,1},{100,109033,1}]},{999,[{100,102000,1},{100,450023,1},{100,109033,1}]}],ask = 0,look = 0,other = [],node_type = 2,pre_notice = 600};

get_ac(610,4,1) ->
    #base_ac{module = 610,module_sub = 4,ac_sub = 1,ac_name = "无尽回廊",ac_icon = "610004",num = 1,start_lv = 105,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "探索回廊获得称号，每日还能领取进度奖励！",reward = [{1,[{0,102603,1},{2,100001,1},{0,430012,1}]},{999,[{0,102603,1},{2,100001,1},{0,430012,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 300};

get_ac(610,7,1) ->
    #base_ac{module = 610,module_sub = 7,ac_sub = 1,ac_name = "幻光副本",ac_icon = "610007",num = 1,start_lv = 125,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [{2,9999}],merge_day = [],about = "单人挑战，完成即可扫荡，获取大量幻光材料！",reward = [{1,[{0,101015,1},{0,102119,1}]},{999,[{0,101015,1},{0,102119,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,8,1) ->
    #base_ac{module = 610,module_sub = 8,ac_sub = 1,ac_name = "宠物副本",ac_icon = "610008",num = 1,start_lv = 145,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [{4,9999}],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,251007,1}]},{999,[{100,251007,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,10,1) ->
    #base_ac{module = 610,module_sub = 10,ac_sub = 1,ac_name = "未来神域",ac_icon = "610010",num = 1,start_lv = 280,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "打败被邪神附身的强者，获得式神碎片",reward = [{1,[{0,290001,1},{0,290002,1},{255,100013,1}]},{999,[{0,290001,1},{0,290002,1},{255,100013,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,15,1) ->
    #base_ac{module = 610,module_sub = 15,ac_sub = 1,ac_name = "快速挂机",ac_icon = "610000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "轻松领取巨量经验值，2倍领取升级更快",reward = [{1,[{5,100007,1},{3,100002,1},{2,100001,1}]},{999,[{5,100007,1},{3,100002,1},{2,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,20,1) ->
    #base_ac{module = 610,module_sub = 20,ac_sub = 1,ac_name = "主线副本",ac_icon = "610000",num = 1,start_lv = 86,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "每日必做，各种材料轻松补给",reward = [{1,[{5,100007,1},{3,100002,1},{2,100001,1}]},{999,[{5,100007,1},{3,100002,1},{2,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1001,1) ->
    #base_ac{module = 610,module_sub = 1001,ac_sub = 1,ac_name = "座驾副本",ac_icon = "610000",num = 1,start_lv = 42,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230001,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1002,1) ->
    #base_ac{module = 610,module_sub = 1002,ac_sub = 1,ac_name = "宝具副本",ac_icon = "610000",num = 1,start_lv = 150,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [{4,9999}],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230003,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1003,1) ->
    #base_ac{module = 610,module_sub = 1003,ac_sub = 1,ac_name = "AI娘副本",ac_icon = "610000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230005,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1004,1) ->
    #base_ac{module = 610,module_sub = 1004,ac_sub = 1,ac_name = "神翼副本",ac_icon = "610000",num = 1,start_lv = 110,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230002,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1005,1) ->
    #base_ac{module = 610,module_sub = 1005,ac_sub = 1,ac_name = "武器副本",ac_icon = "610000",num = 1,start_lv = 130,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [{3,9999}],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230004,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1006,1) ->
    #base_ac{module = 610,module_sub = 1006,ac_sub = 1,ac_name = "磁炮副本",ac_icon = "610000",num = 1,start_lv = 150,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230006,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1007,1) ->
    #base_ac{module = 610,module_sub = 1007,ac_sub = 1,ac_name = "幻甲副本",ac_icon = "610000",num = 1,start_lv = 180,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230008,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,1008,1) ->
    #base_ac{module = 610,module_sub = 1008,ac_sub = 1,ac_name = "星翼副本",ac_icon = "610000",num = 1,start_lv = 220,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦",reward = [{1,[{100,230007,1},{5,100007,60000}]},{999,[{100,230001,1},{5,100007,60000}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(610,5001,1) ->
    #base_ac{module = 610,module_sub = 5001,ac_sub = 1,ac_name = "经验闯关",ac_icon = "610000",num = 1,start_lv = 100,end_lv = 9999,ac_type = 1,week = [],month = [],time = [],time_region = [],open_day = [],merge_day = [],about = "挑战放置冒险，可获取巨量经验，还能提升经验收益喔！",reward = [{1,[{5,100007,1},{3,100002,1},{2,100001,1}]},{999,[{5,100007,1},{3,100002,1},{2,100001,1}]}],ask = 0,look = 0,other = [],node_type = 0,pre_notice = 0};

get_ac(_Module,_Modulesub,_Acsub) ->
    #base_ac{}.

get_ac_list() ->
    [{130,5,1,0},{130,6,1,0},{142,0,1,0},{152,0,1,0},{215,1,1,0},{215,2,1,0},{223,0,1,0},{280,0,1,0},{300,1,1,0},{300,2,1,0},{400,3,1,0},{400,7,1,0},{405,1,1,0},{405,1,2,0},{405,1,3,0},{406,1,1,0},{406,1,2,0},{408,0,1,0},{410,1,2,1},{410,1,3,1},{410,2,1,0},{415,0,1,0},{415,0,2,2},{415,0,3,2},{418,0,1,0},{418,0,2,2},{418,0,3,2},{460,1,1,0},{460,2,1,0},{460,3,1,0},{461,1,1,0},{461,2,1,0},{463,0,1,0},{500,0,1,0},{500,1,2,0},{600,0,1,0},{600,0,2,2},{600,0,3,2},{601,0,1,1},{601,0,2,1},{602,0,1,0},{602,0,2,0},{602,0,3,2},{602,0,4,2},{610,4,1,0},{610,7,1,0},{610,8,1,0},{610,10,1,0},{610,15,1,0},{610,20,1,0},{610,1001,1,0},{610,1002,1,0},{610,1003,1,0},{610,1004,1,0},{610,1005,1,0},{610,1006,1,0},{610,1007,1,0},{610,1008,1,0},{610,5001,1,0}].

get_ac_sub(130,5) ->
    [1];

get_ac_sub(130,6) ->
    [1];

get_ac_sub(142,0) ->
    [1];

get_ac_sub(152,0) ->
    [1];

get_ac_sub(215,1) ->
    [1];

get_ac_sub(215,2) ->
    [1];

get_ac_sub(223,0) ->
    [1];

get_ac_sub(280,0) ->
    [1];

get_ac_sub(300,1) ->
    [1];

get_ac_sub(300,2) ->
    [1];

get_ac_sub(400,3) ->
    [1];

get_ac_sub(400,7) ->
    [1];

get_ac_sub(405,1) ->
    [1,2,3];

get_ac_sub(406,1) ->
    [1,2];

get_ac_sub(408,0) ->
    [1];

get_ac_sub(410,1) ->
    [2,3];

get_ac_sub(410,2) ->
    [1];

get_ac_sub(415,0) ->
    [1,2,3];

get_ac_sub(418,0) ->
    [1,2,3];

get_ac_sub(460,1) ->
    [1];

get_ac_sub(460,2) ->
    [1];

get_ac_sub(460,3) ->
    [1];

get_ac_sub(461,1) ->
    [1];

get_ac_sub(461,2) ->
    [1];

get_ac_sub(463,0) ->
    [1];

get_ac_sub(500,0) ->
    [1];

get_ac_sub(500,1) ->
    [2];

get_ac_sub(600,0) ->
    [1,2,3];

get_ac_sub(601,0) ->
    [1,2];

get_ac_sub(602,0) ->
    [1,2,3,4];

get_ac_sub(610,4) ->
    [1];

get_ac_sub(610,7) ->
    [1];

get_ac_sub(610,8) ->
    [1];

get_ac_sub(610,10) ->
    [1];

get_ac_sub(610,15) ->
    [1];

get_ac_sub(610,20) ->
    [1];

get_ac_sub(610,1001) ->
    [1];

get_ac_sub(610,1002) ->
    [1];

get_ac_sub(610,1003) ->
    [1];

get_ac_sub(610,1004) ->
    [1];

get_ac_sub(610,1005) ->
    [1];

get_ac_sub(610,1006) ->
    [1];

get_ac_sub(610,1007) ->
    [1];

get_ac_sub(610,1008) ->
    [1];

get_ac_sub(610,5001) ->
    [1];

get_ac_sub(_Module,_Modulesub) ->
    [].

get_ac_by_lv(9999,1) ->
    [{130,5,1}];

get_ac_by_lv(96,1) ->
    [{130,6,1},{223,0,1},{300,1,1}];

get_ac_by_lv(100,2) ->
    [{142,0,1},{400,7,1},{405,1,1},{405,1,2},{405,1,3},{406,1,1},{406,1,2},{408,0,1},{410,1,2},{410,1,3},{410,2,1},{415,0,1},{415,0,2},{415,0,3},{418,0,1},{418,0,2},{418,0,3},{500,1,2},{600,0,1},{600,0,2},{600,0,3},{602,0,1},{602,0,2},{602,0,3},{602,0,4}];

get_ac_by_lv(100,1) ->
    [{152,0,1},{215,1,1},{300,2,1},{400,3,1},{460,2,1},{460,3,1},{500,0,1},{610,15,1},{610,1003,1},{610,5001,1}];

get_ac_by_lv(250,1) ->
    [{215,2,1}];

get_ac_by_lv(92,1) ->
    [{280,0,1}];

get_ac_by_lv(90,1) ->
    [{460,1,1}];

get_ac_by_lv(180,1) ->
    [{461,1,1},{461,2,1},{610,1007,1}];

get_ac_by_lv(120,1) ->
    [{463,0,1}];

get_ac_by_lv(140,2) ->
    [{601,0,1},{601,0,2}];

get_ac_by_lv(105,1) ->
    [{610,4,1}];

get_ac_by_lv(125,1) ->
    [{610,7,1}];

get_ac_by_lv(145,1) ->
    [{610,8,1}];

get_ac_by_lv(280,1) ->
    [{610,10,1}];

get_ac_by_lv(86,1) ->
    [{610,20,1}];

get_ac_by_lv(42,1) ->
    [{610,1001,1}];

get_ac_by_lv(150,1) ->
    [{610,1002,1},{610,1006,1}];

get_ac_by_lv(110,1) ->
    [{610,1004,1}];

get_ac_by_lv(130,1) ->
    [{610,1005,1}];

get_ac_by_lv(220,1) ->
    [{610,1008,1}];

get_ac_by_lv(_Startlv,_Actype) ->
    [].


get_start_lv_list(1) ->
    [9999,96,100,250,92,90,180,120,105,125,145,280,86,42,150,110,130,220];


get_start_lv_list(2) ->
    [100,140];

get_start_lv_list(_Actype) ->
    [].


get_ac_list_by_module(130) ->
    [{5,1},{6,1}];


get_ac_list_by_module(142) ->
    [{0,1}];


get_ac_list_by_module(152) ->
    [{0,1}];


get_ac_list_by_module(215) ->
    [{1,1},{2,1}];


get_ac_list_by_module(223) ->
    [{0,1}];


get_ac_list_by_module(280) ->
    [{0,1}];


get_ac_list_by_module(300) ->
    [{1,1},{2,1}];


get_ac_list_by_module(400) ->
    [{3,1},{7,1}];


get_ac_list_by_module(405) ->
    [{1,1},{1,2},{1,3}];


get_ac_list_by_module(406) ->
    [{1,1},{1,2}];


get_ac_list_by_module(408) ->
    [{0,1}];


get_ac_list_by_module(410) ->
    [{1,2},{1,3},{2,1}];


get_ac_list_by_module(415) ->
    [{0,1},{0,2},{0,3}];


get_ac_list_by_module(418) ->
    [{0,1},{0,2},{0,3}];


get_ac_list_by_module(460) ->
    [{1,1},{2,1},{3,1}];


get_ac_list_by_module(461) ->
    [{1,1},{2,1}];


get_ac_list_by_module(463) ->
    [{0,1}];


get_ac_list_by_module(500) ->
    [{0,1},{1,2}];


get_ac_list_by_module(600) ->
    [{0,1},{0,2},{0,3}];


get_ac_list_by_module(601) ->
    [{0,1},{0,2}];


get_ac_list_by_module(602) ->
    [{0,1},{0,2},{0,3},{0,4}];


get_ac_list_by_module(610) ->
    [{4,1},{7,1},{8,1},{10,1},{15,1},{20,1},{1001,1},{1002,1},{1003,1},{1004,1},{1005,1},{1006,1},{1007,1},{1008,1},{5001,1}];

get_ac_list_by_module(_Module) ->
    [].


get_value(1) ->
    [{241301,1}];

get_value(_Key) ->
    0.

get_liveness(0) ->
    #base_liveness_lv{lv = 0,exp = 5,attr = [{1,0},{2,0}],awards = []};

get_liveness(1) ->
    #base_liveness_lv{lv = 1,exp = 25,attr = [{1,50},{2,500}],awards = [{100,101014,5},{100,101010,1}]};

get_liveness(2) ->
    #base_liveness_lv{lv = 2,exp = 25,attr = [{1,55},{2,550}],awards = [{100,109031,1},{100,101010,1}]};

get_liveness(3) ->
    #base_liveness_lv{lv = 3,exp = 25,attr = [{1,60},{2,600}],awards = [{100,102009,1},{100,101010,1}]};

get_liveness(4) ->
    #base_liveness_lv{lv = 4,exp = 25,attr = [{1,65},{2,650}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(5) ->
    #base_liveness_lv{lv = 5,exp = 25,attr = [{1,70},{2,700}],awards = [{100,450026,1},{100,101010,1}]};

get_liveness(6) ->
    #base_liveness_lv{lv = 6,exp = 25,attr = [{1,75},{2,750}],awards = [{100,230301,1},{100,101010,1}]};

get_liveness(7) ->
    #base_liveness_lv{lv = 7,exp = 30,attr = [{1,80},{2,800}],awards = [{100,101014,5},{100,101010,1}]};

get_liveness(8) ->
    #base_liveness_lv{lv = 8,exp = 30,attr = [{1,85},{2,850}],awards = [{100,109031,1},{100,101010,1}]};

get_liveness(9) ->
    #base_liveness_lv{lv = 9,exp = 30,attr = [{1,90},{2,900}],awards = [{100,102009,1},{100,101010,1}]};

get_liveness(10) ->
    #base_liveness_lv{lv = 10,exp = 30,attr = [{1,95},{2,950}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(11) ->
    #base_liveness_lv{lv = 11,exp = 30,attr = [{1,100},{2,1000}],awards = [{100,450026,1},{100,101010,1}]};

get_liveness(12) ->
    #base_liveness_lv{lv = 12,exp = 30,attr = [{1,105},{2,1050}],awards = [{100,230302,1},{100,101010,1}]};

get_liveness(13) ->
    #base_liveness_lv{lv = 13,exp = 30,attr = [{1,110},{2,1100}],awards = [{100,102009,1},{100,101010,1}]};

get_liveness(14) ->
    #base_liveness_lv{lv = 14,exp = 30,attr = [{1,115},{2,1150}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(15) ->
    #base_liveness_lv{lv = 15,exp = 30,attr = [{1,120},{2,1200}],awards = [{100,450026,1},{100,101010,1}]};

get_liveness(16) ->
    #base_liveness_lv{lv = 16,exp = 30,attr = [{1,125},{2,1250}],awards = [{100,230303,1},{100,101010,1}]};

get_liveness(17) ->
    #base_liveness_lv{lv = 17,exp = 40,attr = [{1,130},{2,1300}],awards = [{100,102009,1},{100,101010,1}]};

get_liveness(18) ->
    #base_liveness_lv{lv = 18,exp = 40,attr = [{1,135},{2,1350}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(19) ->
    #base_liveness_lv{lv = 19,exp = 40,attr = [{1,140},{2,1400}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(20) ->
    #base_liveness_lv{lv = 20,exp = 40,attr = [{1,145},{2,1450}],awards = [{100,230304,1},{100,101010,1}]};

get_liveness(21) ->
    #base_liveness_lv{lv = 21,exp = 40,attr = [{1,150},{2,1500}],awards = [{100,102009,1},{100,101010,1}]};

get_liveness(22) ->
    #base_liveness_lv{lv = 22,exp = 40,attr = [{1,155},{2,1550}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(23) ->
    #base_liveness_lv{lv = 23,exp = 40,attr = [{1,160},{2,1600}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(24) ->
    #base_liveness_lv{lv = 24,exp = 40,attr = [{1,165},{2,1650}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(25) ->
    #base_liveness_lv{lv = 25,exp = 40,attr = [{1,170},{2,1700}],awards = [{100,102009,1},{100,101010,1}]};

get_liveness(26) ->
    #base_liveness_lv{lv = 26,exp = 40,attr = [{1,175},{2,1750}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(27) ->
    #base_liveness_lv{lv = 27,exp = 40,attr = [{1,180},{2,1800}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(28) ->
    #base_liveness_lv{lv = 28,exp = 40,attr = [{1,185},{2,1850}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(29) ->
    #base_liveness_lv{lv = 29,exp = 40,attr = [{1,190},{2,1900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(30) ->
    #base_liveness_lv{lv = 30,exp = 40,attr = [{1,195},{2,1950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(31) ->
    #base_liveness_lv{lv = 31,exp = 40,attr = [{1,200},{2,2000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(32) ->
    #base_liveness_lv{lv = 32,exp = 40,attr = [{1,205},{2,2050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(33) ->
    #base_liveness_lv{lv = 33,exp = 40,attr = [{1,210},{2,2100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(34) ->
    #base_liveness_lv{lv = 34,exp = 40,attr = [{1,215},{2,2150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(35) ->
    #base_liveness_lv{lv = 35,exp = 40,attr = [{1,220},{2,2200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(36) ->
    #base_liveness_lv{lv = 36,exp = 40,attr = [{1,225},{2,2250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(37) ->
    #base_liveness_lv{lv = 37,exp = 40,attr = [{1,230},{2,2300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(38) ->
    #base_liveness_lv{lv = 38,exp = 40,attr = [{1,235},{2,2350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(39) ->
    #base_liveness_lv{lv = 39,exp = 40,attr = [{1,240},{2,2400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(40) ->
    #base_liveness_lv{lv = 40,exp = 40,attr = [{1,245},{2,2450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(41) ->
    #base_liveness_lv{lv = 41,exp = 40,attr = [{1,250},{2,2500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(42) ->
    #base_liveness_lv{lv = 42,exp = 40,attr = [{1,255},{2,2550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(43) ->
    #base_liveness_lv{lv = 43,exp = 40,attr = [{1,260},{2,2600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(44) ->
    #base_liveness_lv{lv = 44,exp = 40,attr = [{1,265},{2,2650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(45) ->
    #base_liveness_lv{lv = 45,exp = 40,attr = [{1,270},{2,2700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(46) ->
    #base_liveness_lv{lv = 46,exp = 40,attr = [{1,275},{2,2750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(47) ->
    #base_liveness_lv{lv = 47,exp = 60,attr = [{1,280},{2,2800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(48) ->
    #base_liveness_lv{lv = 48,exp = 60,attr = [{1,285},{2,2850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(49) ->
    #base_liveness_lv{lv = 49,exp = 60,attr = [{1,290},{2,2900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(50) ->
    #base_liveness_lv{lv = 50,exp = 60,attr = [{1,295},{2,2950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(51) ->
    #base_liveness_lv{lv = 51,exp = 60,attr = [{1,300},{2,3000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(52) ->
    #base_liveness_lv{lv = 52,exp = 60,attr = [{1,305},{2,3050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(53) ->
    #base_liveness_lv{lv = 53,exp = 60,attr = [{1,310},{2,3100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(54) ->
    #base_liveness_lv{lv = 54,exp = 60,attr = [{1,315},{2,3150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(55) ->
    #base_liveness_lv{lv = 55,exp = 60,attr = [{1,320},{2,3200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(56) ->
    #base_liveness_lv{lv = 56,exp = 60,attr = [{1,325},{2,3250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(57) ->
    #base_liveness_lv{lv = 57,exp = 60,attr = [{1,330},{2,3300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(58) ->
    #base_liveness_lv{lv = 58,exp = 60,attr = [{1,335},{2,3350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(59) ->
    #base_liveness_lv{lv = 59,exp = 60,attr = [{1,340},{2,3400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(60) ->
    #base_liveness_lv{lv = 60,exp = 60,attr = [{1,345},{2,3450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(61) ->
    #base_liveness_lv{lv = 61,exp = 60,attr = [{1,350},{2,3500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(62) ->
    #base_liveness_lv{lv = 62,exp = 60,attr = [{1,355},{2,3550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(63) ->
    #base_liveness_lv{lv = 63,exp = 60,attr = [{1,360},{2,3600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(64) ->
    #base_liveness_lv{lv = 64,exp = 60,attr = [{1,365},{2,3650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(65) ->
    #base_liveness_lv{lv = 65,exp = 60,attr = [{1,370},{2,3700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(66) ->
    #base_liveness_lv{lv = 66,exp = 60,attr = [{1,375},{2,3750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(67) ->
    #base_liveness_lv{lv = 67,exp = 60,attr = [{1,380},{2,3800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(68) ->
    #base_liveness_lv{lv = 68,exp = 90,attr = [{1,385},{2,3850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(69) ->
    #base_liveness_lv{lv = 69,exp = 90,attr = [{1,390},{2,3900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(70) ->
    #base_liveness_lv{lv = 70,exp = 90,attr = [{1,395},{2,3950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(71) ->
    #base_liveness_lv{lv = 71,exp = 90,attr = [{1,400},{2,4000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(72) ->
    #base_liveness_lv{lv = 72,exp = 90,attr = [{1,405},{2,4050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(73) ->
    #base_liveness_lv{lv = 73,exp = 90,attr = [{1,410},{2,4100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(74) ->
    #base_liveness_lv{lv = 74,exp = 90,attr = [{1,415},{2,4150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(75) ->
    #base_liveness_lv{lv = 75,exp = 90,attr = [{1,420},{2,4200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(76) ->
    #base_liveness_lv{lv = 76,exp = 90,attr = [{1,425},{2,4250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(77) ->
    #base_liveness_lv{lv = 77,exp = 90,attr = [{1,430},{2,4300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(78) ->
    #base_liveness_lv{lv = 78,exp = 90,attr = [{1,435},{2,4350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(79) ->
    #base_liveness_lv{lv = 79,exp = 90,attr = [{1,440},{2,4400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(80) ->
    #base_liveness_lv{lv = 80,exp = 90,attr = [{1,445},{2,4450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(81) ->
    #base_liveness_lv{lv = 81,exp = 90,attr = [{1,450},{2,4500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(82) ->
    #base_liveness_lv{lv = 82,exp = 90,attr = [{1,455},{2,4550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(83) ->
    #base_liveness_lv{lv = 83,exp = 90,attr = [{1,460},{2,4600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(84) ->
    #base_liveness_lv{lv = 84,exp = 90,attr = [{1,465},{2,4650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(85) ->
    #base_liveness_lv{lv = 85,exp = 90,attr = [{1,470},{2,4700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(86) ->
    #base_liveness_lv{lv = 86,exp = 130,attr = [{1,475},{2,4750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(87) ->
    #base_liveness_lv{lv = 87,exp = 130,attr = [{1,480},{2,4800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(88) ->
    #base_liveness_lv{lv = 88,exp = 130,attr = [{1,485},{2,4850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(89) ->
    #base_liveness_lv{lv = 89,exp = 130,attr = [{1,490},{2,4900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(90) ->
    #base_liveness_lv{lv = 90,exp = 130,attr = [{1,495},{2,4950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(91) ->
    #base_liveness_lv{lv = 91,exp = 130,attr = [{1,500},{2,5000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(92) ->
    #base_liveness_lv{lv = 92,exp = 130,attr = [{1,505},{2,5050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(93) ->
    #base_liveness_lv{lv = 93,exp = 130,attr = [{1,510},{2,5100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(94) ->
    #base_liveness_lv{lv = 94,exp = 130,attr = [{1,515},{2,5150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(95) ->
    #base_liveness_lv{lv = 95,exp = 130,attr = [{1,520},{2,5200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(96) ->
    #base_liveness_lv{lv = 96,exp = 130,attr = [{1,525},{2,5250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(97) ->
    #base_liveness_lv{lv = 97,exp = 130,attr = [{1,530},{2,5300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(98) ->
    #base_liveness_lv{lv = 98,exp = 130,attr = [{1,535},{2,5350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(99) ->
    #base_liveness_lv{lv = 99,exp = 130,attr = [{1,540},{2,5400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(100) ->
    #base_liveness_lv{lv = 100,exp = 130,attr = [{1,545},{2,5450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(101) ->
    #base_liveness_lv{lv = 101,exp = 130,attr = [{1,550},{2,5500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(102) ->
    #base_liveness_lv{lv = 102,exp = 130,attr = [{1,555},{2,5550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(103) ->
    #base_liveness_lv{lv = 103,exp = 130,attr = [{1,560},{2,5600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(104) ->
    #base_liveness_lv{lv = 104,exp = 130,attr = [{1,565},{2,5650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(105) ->
    #base_liveness_lv{lv = 105,exp = 130,attr = [{1,570},{2,5700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(106) ->
    #base_liveness_lv{lv = 106,exp = 130,attr = [{1,575},{2,5750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(107) ->
    #base_liveness_lv{lv = 107,exp = 130,attr = [{1,580},{2,5800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(108) ->
    #base_liveness_lv{lv = 108,exp = 130,attr = [{1,585},{2,5850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(109) ->
    #base_liveness_lv{lv = 109,exp = 130,attr = [{1,590},{2,5900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(110) ->
    #base_liveness_lv{lv = 110,exp = 130,attr = [{1,595},{2,5950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(111) ->
    #base_liveness_lv{lv = 111,exp = 130,attr = [{1,600},{2,6000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(112) ->
    #base_liveness_lv{lv = 112,exp = 130,attr = [{1,605},{2,6050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(113) ->
    #base_liveness_lv{lv = 113,exp = 130,attr = [{1,610},{2,6100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(114) ->
    #base_liveness_lv{lv = 114,exp = 130,attr = [{1,615},{2,6150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(115) ->
    #base_liveness_lv{lv = 115,exp = 130,attr = [{1,620},{2,6200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(116) ->
    #base_liveness_lv{lv = 116,exp = 130,attr = [{1,625},{2,6250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(117) ->
    #base_liveness_lv{lv = 117,exp = 130,attr = [{1,630},{2,6300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(118) ->
    #base_liveness_lv{lv = 118,exp = 130,attr = [{1,635},{2,6350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(119) ->
    #base_liveness_lv{lv = 119,exp = 130,attr = [{1,640},{2,6400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(120) ->
    #base_liveness_lv{lv = 120,exp = 130,attr = [{1,645},{2,6450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(121) ->
    #base_liveness_lv{lv = 121,exp = 130,attr = [{1,650},{2,6500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(122) ->
    #base_liveness_lv{lv = 122,exp = 130,attr = [{1,655},{2,6550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(123) ->
    #base_liveness_lv{lv = 123,exp = 130,attr = [{1,660},{2,6600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(124) ->
    #base_liveness_lv{lv = 124,exp = 130,attr = [{1,665},{2,6650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(125) ->
    #base_liveness_lv{lv = 125,exp = 130,attr = [{1,670},{2,6700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(126) ->
    #base_liveness_lv{lv = 126,exp = 130,attr = [{1,675},{2,6750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(127) ->
    #base_liveness_lv{lv = 127,exp = 130,attr = [{1,680},{2,6800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(128) ->
    #base_liveness_lv{lv = 128,exp = 130,attr = [{1,685},{2,6850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(129) ->
    #base_liveness_lv{lv = 129,exp = 130,attr = [{1,690},{2,6900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(130) ->
    #base_liveness_lv{lv = 130,exp = 130,attr = [{1,695},{2,6950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(131) ->
    #base_liveness_lv{lv = 131,exp = 130,attr = [{1,700},{2,7000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(132) ->
    #base_liveness_lv{lv = 132,exp = 130,attr = [{1,705},{2,7050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(133) ->
    #base_liveness_lv{lv = 133,exp = 130,attr = [{1,710},{2,7100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(134) ->
    #base_liveness_lv{lv = 134,exp = 130,attr = [{1,715},{2,7150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(135) ->
    #base_liveness_lv{lv = 135,exp = 130,attr = [{1,720},{2,7200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(136) ->
    #base_liveness_lv{lv = 136,exp = 130,attr = [{1,725},{2,7250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(137) ->
    #base_liveness_lv{lv = 137,exp = 130,attr = [{1,730},{2,7300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(138) ->
    #base_liveness_lv{lv = 138,exp = 130,attr = [{1,735},{2,7350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(139) ->
    #base_liveness_lv{lv = 139,exp = 130,attr = [{1,740},{2,7400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(140) ->
    #base_liveness_lv{lv = 140,exp = 130,attr = [{1,745},{2,7450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(141) ->
    #base_liveness_lv{lv = 141,exp = 130,attr = [{1,750},{2,7500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(142) ->
    #base_liveness_lv{lv = 142,exp = 130,attr = [{1,755},{2,7550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(143) ->
    #base_liveness_lv{lv = 143,exp = 150,attr = [{1,760},{2,7600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(144) ->
    #base_liveness_lv{lv = 144,exp = 150,attr = [{1,765},{2,7650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(145) ->
    #base_liveness_lv{lv = 145,exp = 150,attr = [{1,770},{2,7700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(146) ->
    #base_liveness_lv{lv = 146,exp = 150,attr = [{1,775},{2,7750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(147) ->
    #base_liveness_lv{lv = 147,exp = 150,attr = [{1,780},{2,7800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(148) ->
    #base_liveness_lv{lv = 148,exp = 150,attr = [{1,785},{2,7850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(149) ->
    #base_liveness_lv{lv = 149,exp = 150,attr = [{1,790},{2,7900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(150) ->
    #base_liveness_lv{lv = 150,exp = 150,attr = [{1,795},{2,7950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(151) ->
    #base_liveness_lv{lv = 151,exp = 150,attr = [{1,800},{2,8000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(152) ->
    #base_liveness_lv{lv = 152,exp = 150,attr = [{1,805},{2,8050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(153) ->
    #base_liveness_lv{lv = 153,exp = 150,attr = [{1,810},{2,8100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(154) ->
    #base_liveness_lv{lv = 154,exp = 150,attr = [{1,815},{2,8150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(155) ->
    #base_liveness_lv{lv = 155,exp = 150,attr = [{1,820},{2,8200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(156) ->
    #base_liveness_lv{lv = 156,exp = 150,attr = [{1,825},{2,8250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(157) ->
    #base_liveness_lv{lv = 157,exp = 150,attr = [{1,830},{2,8300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(158) ->
    #base_liveness_lv{lv = 158,exp = 150,attr = [{1,835},{2,8350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(159) ->
    #base_liveness_lv{lv = 159,exp = 180,attr = [{1,840},{2,8400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(160) ->
    #base_liveness_lv{lv = 160,exp = 180,attr = [{1,845},{2,8450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(161) ->
    #base_liveness_lv{lv = 161,exp = 180,attr = [{1,850},{2,8500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(162) ->
    #base_liveness_lv{lv = 162,exp = 180,attr = [{1,855},{2,8550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(163) ->
    #base_liveness_lv{lv = 163,exp = 180,attr = [{1,860},{2,8600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(164) ->
    #base_liveness_lv{lv = 164,exp = 180,attr = [{1,865},{2,8650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(165) ->
    #base_liveness_lv{lv = 165,exp = 180,attr = [{1,870},{2,8700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(166) ->
    #base_liveness_lv{lv = 166,exp = 180,attr = [{1,875},{2,8750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(167) ->
    #base_liveness_lv{lv = 167,exp = 180,attr = [{1,880},{2,8800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(168) ->
    #base_liveness_lv{lv = 168,exp = 180,attr = [{1,885},{2,8850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(169) ->
    #base_liveness_lv{lv = 169,exp = 180,attr = [{1,890},{2,8900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(170) ->
    #base_liveness_lv{lv = 170,exp = 180,attr = [{1,895},{2,8950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(171) ->
    #base_liveness_lv{lv = 171,exp = 180,attr = [{1,900},{2,9000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(172) ->
    #base_liveness_lv{lv = 172,exp = 180,attr = [{1,905},{2,9050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(173) ->
    #base_liveness_lv{lv = 173,exp = 180,attr = [{1,910},{2,9100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(174) ->
    #base_liveness_lv{lv = 174,exp = 180,attr = [{1,915},{2,9150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(175) ->
    #base_liveness_lv{lv = 175,exp = 180,attr = [{1,920},{2,9200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(176) ->
    #base_liveness_lv{lv = 176,exp = 180,attr = [{1,925},{2,9250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(177) ->
    #base_liveness_lv{lv = 177,exp = 180,attr = [{1,930},{2,9300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(178) ->
    #base_liveness_lv{lv = 178,exp = 180,attr = [{1,935},{2,9350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(179) ->
    #base_liveness_lv{lv = 179,exp = 180,attr = [{1,940},{2,9400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(180) ->
    #base_liveness_lv{lv = 180,exp = 180,attr = [{1,945},{2,9450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(181) ->
    #base_liveness_lv{lv = 181,exp = 180,attr = [{1,950},{2,9500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(182) ->
    #base_liveness_lv{lv = 182,exp = 180,attr = [{1,955},{2,9550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(183) ->
    #base_liveness_lv{lv = 183,exp = 180,attr = [{1,960},{2,9600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(184) ->
    #base_liveness_lv{lv = 184,exp = 180,attr = [{1,965},{2,9650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(185) ->
    #base_liveness_lv{lv = 185,exp = 180,attr = [{1,970},{2,9700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(186) ->
    #base_liveness_lv{lv = 186,exp = 180,attr = [{1,975},{2,9750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(187) ->
    #base_liveness_lv{lv = 187,exp = 180,attr = [{1,980},{2,9800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(188) ->
    #base_liveness_lv{lv = 188,exp = 180,attr = [{1,985},{2,9850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(189) ->
    #base_liveness_lv{lv = 189,exp = 220,attr = [{1,990},{2,9900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(190) ->
    #base_liveness_lv{lv = 190,exp = 220,attr = [{1,995},{2,9950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(191) ->
    #base_liveness_lv{lv = 191,exp = 220,attr = [{1,1000},{2,10000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(192) ->
    #base_liveness_lv{lv = 192,exp = 220,attr = [{1,1005},{2,10050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(193) ->
    #base_liveness_lv{lv = 193,exp = 220,attr = [{1,1010},{2,10100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(194) ->
    #base_liveness_lv{lv = 194,exp = 220,attr = [{1,1015},{2,10150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(195) ->
    #base_liveness_lv{lv = 195,exp = 220,attr = [{1,1020},{2,10200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(196) ->
    #base_liveness_lv{lv = 196,exp = 220,attr = [{1,1025},{2,10250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(197) ->
    #base_liveness_lv{lv = 197,exp = 220,attr = [{1,1030},{2,10300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(198) ->
    #base_liveness_lv{lv = 198,exp = 220,attr = [{1,1035},{2,10350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(199) ->
    #base_liveness_lv{lv = 199,exp = 220,attr = [{1,1040},{2,10400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(200) ->
    #base_liveness_lv{lv = 200,exp = 220,attr = [{1,1045},{2,10450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(201) ->
    #base_liveness_lv{lv = 201,exp = 220,attr = [{1,1050},{2,10500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(202) ->
    #base_liveness_lv{lv = 202,exp = 220,attr = [{1,1055},{2,10550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(203) ->
    #base_liveness_lv{lv = 203,exp = 220,attr = [{1,1060},{2,10600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(204) ->
    #base_liveness_lv{lv = 204,exp = 220,attr = [{1,1065},{2,10650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(205) ->
    #base_liveness_lv{lv = 205,exp = 220,attr = [{1,1070},{2,10700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(206) ->
    #base_liveness_lv{lv = 206,exp = 220,attr = [{1,1075},{2,10750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(207) ->
    #base_liveness_lv{lv = 207,exp = 220,attr = [{1,1080},{2,10800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(208) ->
    #base_liveness_lv{lv = 208,exp = 220,attr = [{1,1085},{2,10850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(209) ->
    #base_liveness_lv{lv = 209,exp = 220,attr = [{1,1090},{2,10900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(210) ->
    #base_liveness_lv{lv = 210,exp = 220,attr = [{1,1095},{2,10950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(211) ->
    #base_liveness_lv{lv = 211,exp = 220,attr = [{1,1100},{2,11000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(212) ->
    #base_liveness_lv{lv = 212,exp = 220,attr = [{1,1105},{2,11050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(213) ->
    #base_liveness_lv{lv = 213,exp = 220,attr = [{1,1110},{2,11100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(214) ->
    #base_liveness_lv{lv = 214,exp = 220,attr = [{1,1115},{2,11150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(215) ->
    #base_liveness_lv{lv = 215,exp = 220,attr = [{1,1120},{2,11200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(216) ->
    #base_liveness_lv{lv = 216,exp = 220,attr = [{1,1125},{2,11250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(217) ->
    #base_liveness_lv{lv = 217,exp = 220,attr = [{1,1130},{2,11300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(218) ->
    #base_liveness_lv{lv = 218,exp = 220,attr = [{1,1135},{2,11350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(219) ->
    #base_liveness_lv{lv = 219,exp = 220,attr = [{1,1140},{2,11400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(220) ->
    #base_liveness_lv{lv = 220,exp = 220,attr = [{1,1145},{2,11450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(221) ->
    #base_liveness_lv{lv = 221,exp = 220,attr = [{1,1150},{2,11500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(222) ->
    #base_liveness_lv{lv = 222,exp = 220,attr = [{1,1155},{2,11550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(223) ->
    #base_liveness_lv{lv = 223,exp = 220,attr = [{1,1160},{2,11600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(224) ->
    #base_liveness_lv{lv = 224,exp = 220,attr = [{1,1165},{2,11650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(225) ->
    #base_liveness_lv{lv = 225,exp = 220,attr = [{1,1170},{2,11700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(226) ->
    #base_liveness_lv{lv = 226,exp = 220,attr = [{1,1175},{2,11750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(227) ->
    #base_liveness_lv{lv = 227,exp = 220,attr = [{1,1180},{2,11800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(228) ->
    #base_liveness_lv{lv = 228,exp = 220,attr = [{1,1185},{2,11850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(229) ->
    #base_liveness_lv{lv = 229,exp = 220,attr = [{1,1190},{2,11900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(230) ->
    #base_liveness_lv{lv = 230,exp = 220,attr = [{1,1195},{2,11950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(231) ->
    #base_liveness_lv{lv = 231,exp = 220,attr = [{1,1200},{2,12000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(232) ->
    #base_liveness_lv{lv = 232,exp = 220,attr = [{1,1205},{2,12050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(233) ->
    #base_liveness_lv{lv = 233,exp = 220,attr = [{1,1210},{2,12100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(234) ->
    #base_liveness_lv{lv = 234,exp = 220,attr = [{1,1215},{2,12150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(235) ->
    #base_liveness_lv{lv = 235,exp = 220,attr = [{1,1220},{2,12200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(236) ->
    #base_liveness_lv{lv = 236,exp = 220,attr = [{1,1225},{2,12250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(237) ->
    #base_liveness_lv{lv = 237,exp = 220,attr = [{1,1230},{2,12300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(238) ->
    #base_liveness_lv{lv = 238,exp = 220,attr = [{1,1235},{2,12350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(239) ->
    #base_liveness_lv{lv = 239,exp = 220,attr = [{1,1240},{2,12400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(240) ->
    #base_liveness_lv{lv = 240,exp = 220,attr = [{1,1245},{2,12450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(241) ->
    #base_liveness_lv{lv = 241,exp = 220,attr = [{1,1250},{2,12500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(242) ->
    #base_liveness_lv{lv = 242,exp = 220,attr = [{1,1255},{2,12550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(243) ->
    #base_liveness_lv{lv = 243,exp = 220,attr = [{1,1260},{2,12600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(244) ->
    #base_liveness_lv{lv = 244,exp = 220,attr = [{1,1265},{2,12650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(245) ->
    #base_liveness_lv{lv = 245,exp = 220,attr = [{1,1270},{2,12700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(246) ->
    #base_liveness_lv{lv = 246,exp = 220,attr = [{1,1275},{2,12750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(247) ->
    #base_liveness_lv{lv = 247,exp = 220,attr = [{1,1280},{2,12800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(248) ->
    #base_liveness_lv{lv = 248,exp = 220,attr = [{1,1285},{2,12850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(249) ->
    #base_liveness_lv{lv = 249,exp = 220,attr = [{1,1290},{2,12900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(250) ->
    #base_liveness_lv{lv = 250,exp = 220,attr = [{1,1295},{2,12950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(251) ->
    #base_liveness_lv{lv = 251,exp = 220,attr = [{1,1300},{2,13000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(252) ->
    #base_liveness_lv{lv = 252,exp = 220,attr = [{1,1305},{2,13050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(253) ->
    #base_liveness_lv{lv = 253,exp = 220,attr = [{1,1310},{2,13100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(254) ->
    #base_liveness_lv{lv = 254,exp = 260,attr = [{1,1315},{2,13150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(255) ->
    #base_liveness_lv{lv = 255,exp = 260,attr = [{1,1320},{2,13200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(256) ->
    #base_liveness_lv{lv = 256,exp = 260,attr = [{1,1325},{2,13250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(257) ->
    #base_liveness_lv{lv = 257,exp = 260,attr = [{1,1330},{2,13300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(258) ->
    #base_liveness_lv{lv = 258,exp = 260,attr = [{1,1335},{2,13350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(259) ->
    #base_liveness_lv{lv = 259,exp = 260,attr = [{1,1340},{2,13400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(260) ->
    #base_liveness_lv{lv = 260,exp = 260,attr = [{1,1345},{2,13450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(261) ->
    #base_liveness_lv{lv = 261,exp = 260,attr = [{1,1350},{2,13500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(262) ->
    #base_liveness_lv{lv = 262,exp = 260,attr = [{1,1355},{2,13550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(263) ->
    #base_liveness_lv{lv = 263,exp = 260,attr = [{1,1360},{2,13600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(264) ->
    #base_liveness_lv{lv = 264,exp = 260,attr = [{1,1365},{2,13650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(265) ->
    #base_liveness_lv{lv = 265,exp = 260,attr = [{1,1370},{2,13700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(266) ->
    #base_liveness_lv{lv = 266,exp = 260,attr = [{1,1375},{2,13750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(267) ->
    #base_liveness_lv{lv = 267,exp = 260,attr = [{1,1380},{2,13800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(268) ->
    #base_liveness_lv{lv = 268,exp = 260,attr = [{1,1385},{2,13850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(269) ->
    #base_liveness_lv{lv = 269,exp = 260,attr = [{1,1390},{2,13900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(270) ->
    #base_liveness_lv{lv = 270,exp = 260,attr = [{1,1395},{2,13950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(271) ->
    #base_liveness_lv{lv = 271,exp = 260,attr = [{1,1400},{2,14000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(272) ->
    #base_liveness_lv{lv = 272,exp = 260,attr = [{1,1405},{2,14050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(273) ->
    #base_liveness_lv{lv = 273,exp = 260,attr = [{1,1410},{2,14100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(274) ->
    #base_liveness_lv{lv = 274,exp = 260,attr = [{1,1415},{2,14150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(275) ->
    #base_liveness_lv{lv = 275,exp = 260,attr = [{1,1420},{2,14200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(276) ->
    #base_liveness_lv{lv = 276,exp = 260,attr = [{1,1425},{2,14250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(277) ->
    #base_liveness_lv{lv = 277,exp = 260,attr = [{1,1430},{2,14300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(278) ->
    #base_liveness_lv{lv = 278,exp = 260,attr = [{1,1435},{2,14350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(279) ->
    #base_liveness_lv{lv = 279,exp = 260,attr = [{1,1440},{2,14400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(280) ->
    #base_liveness_lv{lv = 280,exp = 260,attr = [{1,1445},{2,14450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(281) ->
    #base_liveness_lv{lv = 281,exp = 260,attr = [{1,1450},{2,14500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(282) ->
    #base_liveness_lv{lv = 282,exp = 260,attr = [{1,1455},{2,14550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(283) ->
    #base_liveness_lv{lv = 283,exp = 260,attr = [{1,1460},{2,14600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(284) ->
    #base_liveness_lv{lv = 284,exp = 260,attr = [{1,1465},{2,14650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(285) ->
    #base_liveness_lv{lv = 285,exp = 260,attr = [{1,1470},{2,14700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(286) ->
    #base_liveness_lv{lv = 286,exp = 260,attr = [{1,1475},{2,14750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(287) ->
    #base_liveness_lv{lv = 287,exp = 260,attr = [{1,1480},{2,14800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(288) ->
    #base_liveness_lv{lv = 288,exp = 260,attr = [{1,1485},{2,14850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(289) ->
    #base_liveness_lv{lv = 289,exp = 260,attr = [{1,1490},{2,14900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(290) ->
    #base_liveness_lv{lv = 290,exp = 260,attr = [{1,1495},{2,14950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(291) ->
    #base_liveness_lv{lv = 291,exp = 260,attr = [{1,1500},{2,15000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(292) ->
    #base_liveness_lv{lv = 292,exp = 260,attr = [{1,1505},{2,15050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(293) ->
    #base_liveness_lv{lv = 293,exp = 260,attr = [{1,1510},{2,15100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(294) ->
    #base_liveness_lv{lv = 294,exp = 260,attr = [{1,1515},{2,15150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(295) ->
    #base_liveness_lv{lv = 295,exp = 260,attr = [{1,1520},{2,15200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(296) ->
    #base_liveness_lv{lv = 296,exp = 260,attr = [{1,1525},{2,15250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(297) ->
    #base_liveness_lv{lv = 297,exp = 260,attr = [{1,1530},{2,15300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(298) ->
    #base_liveness_lv{lv = 298,exp = 260,attr = [{1,1535},{2,15350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(299) ->
    #base_liveness_lv{lv = 299,exp = 260,attr = [{1,1540},{2,15400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(300) ->
    #base_liveness_lv{lv = 300,exp = 260,attr = [{1,1545},{2,15450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(301) ->
    #base_liveness_lv{lv = 301,exp = 260,attr = [{1,1550},{2,15500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(302) ->
    #base_liveness_lv{lv = 302,exp = 260,attr = [{1,1555},{2,15550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(303) ->
    #base_liveness_lv{lv = 303,exp = 260,attr = [{1,1560},{2,15600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(304) ->
    #base_liveness_lv{lv = 304,exp = 260,attr = [{1,1565},{2,15650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(305) ->
    #base_liveness_lv{lv = 305,exp = 260,attr = [{1,1570},{2,15700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(306) ->
    #base_liveness_lv{lv = 306,exp = 260,attr = [{1,1575},{2,15750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(307) ->
    #base_liveness_lv{lv = 307,exp = 260,attr = [{1,1580},{2,15800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(308) ->
    #base_liveness_lv{lv = 308,exp = 260,attr = [{1,1585},{2,15850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(309) ->
    #base_liveness_lv{lv = 309,exp = 260,attr = [{1,1590},{2,15900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(310) ->
    #base_liveness_lv{lv = 310,exp = 260,attr = [{1,1595},{2,15950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(311) ->
    #base_liveness_lv{lv = 311,exp = 260,attr = [{1,1600},{2,16000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(312) ->
    #base_liveness_lv{lv = 312,exp = 300,attr = [{1,1605},{2,16050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(313) ->
    #base_liveness_lv{lv = 313,exp = 300,attr = [{1,1610},{2,16100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(314) ->
    #base_liveness_lv{lv = 314,exp = 300,attr = [{1,1615},{2,16150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(315) ->
    #base_liveness_lv{lv = 315,exp = 300,attr = [{1,1620},{2,16200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(316) ->
    #base_liveness_lv{lv = 316,exp = 300,attr = [{1,1625},{2,16250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(317) ->
    #base_liveness_lv{lv = 317,exp = 300,attr = [{1,1630},{2,16300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(318) ->
    #base_liveness_lv{lv = 318,exp = 300,attr = [{1,1635},{2,16350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(319) ->
    #base_liveness_lv{lv = 319,exp = 300,attr = [{1,1640},{2,16400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(320) ->
    #base_liveness_lv{lv = 320,exp = 300,attr = [{1,1645},{2,16450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(321) ->
    #base_liveness_lv{lv = 321,exp = 300,attr = [{1,1650},{2,16500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(322) ->
    #base_liveness_lv{lv = 322,exp = 300,attr = [{1,1655},{2,16550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(323) ->
    #base_liveness_lv{lv = 323,exp = 300,attr = [{1,1660},{2,16600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(324) ->
    #base_liveness_lv{lv = 324,exp = 300,attr = [{1,1665},{2,16650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(325) ->
    #base_liveness_lv{lv = 325,exp = 300,attr = [{1,1670},{2,16700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(326) ->
    #base_liveness_lv{lv = 326,exp = 300,attr = [{1,1675},{2,16750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(327) ->
    #base_liveness_lv{lv = 327,exp = 300,attr = [{1,1680},{2,16800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(328) ->
    #base_liveness_lv{lv = 328,exp = 300,attr = [{1,1685},{2,16850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(329) ->
    #base_liveness_lv{lv = 329,exp = 300,attr = [{1,1690},{2,16900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(330) ->
    #base_liveness_lv{lv = 330,exp = 300,attr = [{1,1695},{2,16950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(331) ->
    #base_liveness_lv{lv = 331,exp = 300,attr = [{1,1700},{2,17000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(332) ->
    #base_liveness_lv{lv = 332,exp = 300,attr = [{1,1705},{2,17050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(333) ->
    #base_liveness_lv{lv = 333,exp = 300,attr = [{1,1710},{2,17100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(334) ->
    #base_liveness_lv{lv = 334,exp = 300,attr = [{1,1715},{2,17150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(335) ->
    #base_liveness_lv{lv = 335,exp = 300,attr = [{1,1720},{2,17200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(336) ->
    #base_liveness_lv{lv = 336,exp = 300,attr = [{1,1725},{2,17250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(337) ->
    #base_liveness_lv{lv = 337,exp = 300,attr = [{1,1730},{2,17300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(338) ->
    #base_liveness_lv{lv = 338,exp = 300,attr = [{1,1735},{2,17350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(339) ->
    #base_liveness_lv{lv = 339,exp = 300,attr = [{1,1740},{2,17400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(340) ->
    #base_liveness_lv{lv = 340,exp = 300,attr = [{1,1745},{2,17450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(341) ->
    #base_liveness_lv{lv = 341,exp = 300,attr = [{1,1750},{2,17500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(342) ->
    #base_liveness_lv{lv = 342,exp = 300,attr = [{1,1755},{2,17550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(343) ->
    #base_liveness_lv{lv = 343,exp = 300,attr = [{1,1760},{2,17600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(344) ->
    #base_liveness_lv{lv = 344,exp = 300,attr = [{1,1765},{2,17650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(345) ->
    #base_liveness_lv{lv = 345,exp = 300,attr = [{1,1770},{2,17700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(346) ->
    #base_liveness_lv{lv = 346,exp = 300,attr = [{1,1775},{2,17750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(347) ->
    #base_liveness_lv{lv = 347,exp = 300,attr = [{1,1780},{2,17800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(348) ->
    #base_liveness_lv{lv = 348,exp = 300,attr = [{1,1785},{2,17850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(349) ->
    #base_liveness_lv{lv = 349,exp = 300,attr = [{1,1790},{2,17900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(350) ->
    #base_liveness_lv{lv = 350,exp = 300,attr = [{1,1795},{2,17950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(351) ->
    #base_liveness_lv{lv = 351,exp = 300,attr = [{1,1800},{2,18000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(352) ->
    #base_liveness_lv{lv = 352,exp = 300,attr = [{1,1805},{2,18050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(353) ->
    #base_liveness_lv{lv = 353,exp = 300,attr = [{1,1810},{2,18100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(354) ->
    #base_liveness_lv{lv = 354,exp = 300,attr = [{1,1815},{2,18150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(355) ->
    #base_liveness_lv{lv = 355,exp = 300,attr = [{1,1820},{2,18200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(356) ->
    #base_liveness_lv{lv = 356,exp = 300,attr = [{1,1825},{2,18250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(357) ->
    #base_liveness_lv{lv = 357,exp = 300,attr = [{1,1830},{2,18300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(358) ->
    #base_liveness_lv{lv = 358,exp = 300,attr = [{1,1835},{2,18350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(359) ->
    #base_liveness_lv{lv = 359,exp = 300,attr = [{1,1840},{2,18400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(360) ->
    #base_liveness_lv{lv = 360,exp = 300,attr = [{1,1845},{2,18450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(361) ->
    #base_liveness_lv{lv = 361,exp = 300,attr = [{1,1850},{2,18500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(362) ->
    #base_liveness_lv{lv = 362,exp = 300,attr = [{1,1855},{2,18550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(363) ->
    #base_liveness_lv{lv = 363,exp = 300,attr = [{1,1860},{2,18600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(364) ->
    #base_liveness_lv{lv = 364,exp = 300,attr = [{1,1865},{2,18650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(365) ->
    #base_liveness_lv{lv = 365,exp = 300,attr = [{1,1870},{2,18700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(366) ->
    #base_liveness_lv{lv = 366,exp = 300,attr = [{1,1875},{2,18750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(367) ->
    #base_liveness_lv{lv = 367,exp = 300,attr = [{1,1880},{2,18800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(368) ->
    #base_liveness_lv{lv = 368,exp = 300,attr = [{1,1885},{2,18850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(369) ->
    #base_liveness_lv{lv = 369,exp = 300,attr = [{1,1890},{2,18900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(370) ->
    #base_liveness_lv{lv = 370,exp = 300,attr = [{1,1895},{2,18950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(371) ->
    #base_liveness_lv{lv = 371,exp = 300,attr = [{1,1900},{2,19000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(372) ->
    #base_liveness_lv{lv = 372,exp = 300,attr = [{1,1905},{2,19050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(373) ->
    #base_liveness_lv{lv = 373,exp = 300,attr = [{1,1910},{2,19100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(374) ->
    #base_liveness_lv{lv = 374,exp = 300,attr = [{1,1915},{2,19150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(375) ->
    #base_liveness_lv{lv = 375,exp = 300,attr = [{1,1920},{2,19200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(376) ->
    #base_liveness_lv{lv = 376,exp = 300,attr = [{1,1925},{2,19250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(377) ->
    #base_liveness_lv{lv = 377,exp = 300,attr = [{1,1930},{2,19300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(378) ->
    #base_liveness_lv{lv = 378,exp = 300,attr = [{1,1935},{2,19350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(379) ->
    #base_liveness_lv{lv = 379,exp = 300,attr = [{1,1940},{2,19400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(380) ->
    #base_liveness_lv{lv = 380,exp = 300,attr = [{1,1945},{2,19450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(381) ->
    #base_liveness_lv{lv = 381,exp = 300,attr = [{1,1950},{2,19500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(382) ->
    #base_liveness_lv{lv = 382,exp = 300,attr = [{1,1955},{2,19550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(383) ->
    #base_liveness_lv{lv = 383,exp = 300,attr = [{1,1960},{2,19600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(384) ->
    #base_liveness_lv{lv = 384,exp = 300,attr = [{1,1965},{2,19650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(385) ->
    #base_liveness_lv{lv = 385,exp = 300,attr = [{1,1970},{2,19700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(386) ->
    #base_liveness_lv{lv = 386,exp = 300,attr = [{1,1975},{2,19750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(387) ->
    #base_liveness_lv{lv = 387,exp = 300,attr = [{1,1980},{2,19800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(388) ->
    #base_liveness_lv{lv = 388,exp = 300,attr = [{1,1985},{2,19850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(389) ->
    #base_liveness_lv{lv = 389,exp = 300,attr = [{1,1990},{2,19900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(390) ->
    #base_liveness_lv{lv = 390,exp = 300,attr = [{1,1995},{2,19950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(391) ->
    #base_liveness_lv{lv = 391,exp = 300,attr = [{1,2000},{2,20000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(392) ->
    #base_liveness_lv{lv = 392,exp = 300,attr = [{1,2005},{2,20050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(393) ->
    #base_liveness_lv{lv = 393,exp = 300,attr = [{1,2010},{2,20100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(394) ->
    #base_liveness_lv{lv = 394,exp = 300,attr = [{1,2015},{2,20150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(395) ->
    #base_liveness_lv{lv = 395,exp = 300,attr = [{1,2020},{2,20200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(396) ->
    #base_liveness_lv{lv = 396,exp = 300,attr = [{1,2025},{2,20250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(397) ->
    #base_liveness_lv{lv = 397,exp = 300,attr = [{1,2030},{2,20300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(398) ->
    #base_liveness_lv{lv = 398,exp = 300,attr = [{1,2035},{2,20350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(399) ->
    #base_liveness_lv{lv = 399,exp = 300,attr = [{1,2040},{2,20400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(400) ->
    #base_liveness_lv{lv = 400,exp = 300,attr = [{1,2045},{2,20450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(401) ->
    #base_liveness_lv{lv = 401,exp = 300,attr = [{1,2050},{2,20500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(402) ->
    #base_liveness_lv{lv = 402,exp = 300,attr = [{1,2055},{2,20550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(403) ->
    #base_liveness_lv{lv = 403,exp = 300,attr = [{1,2060},{2,20600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(404) ->
    #base_liveness_lv{lv = 404,exp = 300,attr = [{1,2065},{2,20650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(405) ->
    #base_liveness_lv{lv = 405,exp = 300,attr = [{1,2070},{2,20700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(406) ->
    #base_liveness_lv{lv = 406,exp = 300,attr = [{1,2075},{2,20750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(407) ->
    #base_liveness_lv{lv = 407,exp = 300,attr = [{1,2080},{2,20800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(408) ->
    #base_liveness_lv{lv = 408,exp = 300,attr = [{1,2085},{2,20850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(409) ->
    #base_liveness_lv{lv = 409,exp = 300,attr = [{1,2090},{2,20900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(410) ->
    #base_liveness_lv{lv = 410,exp = 300,attr = [{1,2095},{2,20950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(411) ->
    #base_liveness_lv{lv = 411,exp = 300,attr = [{1,2100},{2,21000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(412) ->
    #base_liveness_lv{lv = 412,exp = 300,attr = [{1,2105},{2,21050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(413) ->
    #base_liveness_lv{lv = 413,exp = 300,attr = [{1,2110},{2,21100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(414) ->
    #base_liveness_lv{lv = 414,exp = 300,attr = [{1,2115},{2,21150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(415) ->
    #base_liveness_lv{lv = 415,exp = 300,attr = [{1,2120},{2,21200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(416) ->
    #base_liveness_lv{lv = 416,exp = 300,attr = [{1,2125},{2,21250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(417) ->
    #base_liveness_lv{lv = 417,exp = 300,attr = [{1,2130},{2,21300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(418) ->
    #base_liveness_lv{lv = 418,exp = 300,attr = [{1,2135},{2,21350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(419) ->
    #base_liveness_lv{lv = 419,exp = 300,attr = [{1,2140},{2,21400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(420) ->
    #base_liveness_lv{lv = 420,exp = 300,attr = [{1,2145},{2,21450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(421) ->
    #base_liveness_lv{lv = 421,exp = 300,attr = [{1,2150},{2,21500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(422) ->
    #base_liveness_lv{lv = 422,exp = 300,attr = [{1,2155},{2,21550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(423) ->
    #base_liveness_lv{lv = 423,exp = 300,attr = [{1,2160},{2,21600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(424) ->
    #base_liveness_lv{lv = 424,exp = 300,attr = [{1,2165},{2,21650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(425) ->
    #base_liveness_lv{lv = 425,exp = 300,attr = [{1,2170},{2,21700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(426) ->
    #base_liveness_lv{lv = 426,exp = 300,attr = [{1,2175},{2,21750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(427) ->
    #base_liveness_lv{lv = 427,exp = 300,attr = [{1,2180},{2,21800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(428) ->
    #base_liveness_lv{lv = 428,exp = 300,attr = [{1,2185},{2,21850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(429) ->
    #base_liveness_lv{lv = 429,exp = 300,attr = [{1,2190},{2,21900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(430) ->
    #base_liveness_lv{lv = 430,exp = 300,attr = [{1,2195},{2,21950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(431) ->
    #base_liveness_lv{lv = 431,exp = 300,attr = [{1,2200},{2,22000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(432) ->
    #base_liveness_lv{lv = 432,exp = 300,attr = [{1,2205},{2,22050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(433) ->
    #base_liveness_lv{lv = 433,exp = 300,attr = [{1,2210},{2,22100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(434) ->
    #base_liveness_lv{lv = 434,exp = 300,attr = [{1,2215},{2,22150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(435) ->
    #base_liveness_lv{lv = 435,exp = 300,attr = [{1,2220},{2,22200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(436) ->
    #base_liveness_lv{lv = 436,exp = 300,attr = [{1,2225},{2,22250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(437) ->
    #base_liveness_lv{lv = 437,exp = 300,attr = [{1,2230},{2,22300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(438) ->
    #base_liveness_lv{lv = 438,exp = 300,attr = [{1,2235},{2,22350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(439) ->
    #base_liveness_lv{lv = 439,exp = 300,attr = [{1,2240},{2,22400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(440) ->
    #base_liveness_lv{lv = 440,exp = 300,attr = [{1,2245},{2,22450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(441) ->
    #base_liveness_lv{lv = 441,exp = 300,attr = [{1,2250},{2,22500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(442) ->
    #base_liveness_lv{lv = 442,exp = 300,attr = [{1,2255},{2,22550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(443) ->
    #base_liveness_lv{lv = 443,exp = 300,attr = [{1,2260},{2,22600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(444) ->
    #base_liveness_lv{lv = 444,exp = 300,attr = [{1,2265},{2,22650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(445) ->
    #base_liveness_lv{lv = 445,exp = 300,attr = [{1,2270},{2,22700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(446) ->
    #base_liveness_lv{lv = 446,exp = 300,attr = [{1,2275},{2,22750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(447) ->
    #base_liveness_lv{lv = 447,exp = 300,attr = [{1,2280},{2,22800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(448) ->
    #base_liveness_lv{lv = 448,exp = 300,attr = [{1,2285},{2,22850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(449) ->
    #base_liveness_lv{lv = 449,exp = 300,attr = [{1,2290},{2,22900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(450) ->
    #base_liveness_lv{lv = 450,exp = 300,attr = [{1,2295},{2,22950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(451) ->
    #base_liveness_lv{lv = 451,exp = 300,attr = [{1,2300},{2,23000}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(452) ->
    #base_liveness_lv{lv = 452,exp = 300,attr = [{1,2305},{2,23050}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(453) ->
    #base_liveness_lv{lv = 453,exp = 300,attr = [{1,2310},{2,23100}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(454) ->
    #base_liveness_lv{lv = 454,exp = 300,attr = [{1,2315},{2,23150}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(455) ->
    #base_liveness_lv{lv = 455,exp = 300,attr = [{1,2320},{2,23200}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(456) ->
    #base_liveness_lv{lv = 456,exp = 300,attr = [{1,2325},{2,23250}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(457) ->
    #base_liveness_lv{lv = 457,exp = 300,attr = [{1,2330},{2,23300}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(458) ->
    #base_liveness_lv{lv = 458,exp = 300,attr = [{1,2335},{2,23350}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(459) ->
    #base_liveness_lv{lv = 459,exp = 300,attr = [{1,2340},{2,23400}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(460) ->
    #base_liveness_lv{lv = 460,exp = 300,attr = [{1,2345},{2,23450}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(461) ->
    #base_liveness_lv{lv = 461,exp = 300,attr = [{1,2350},{2,23500}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(462) ->
    #base_liveness_lv{lv = 462,exp = 300,attr = [{1,2355},{2,23550}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(463) ->
    #base_liveness_lv{lv = 463,exp = 300,attr = [{1,2360},{2,23600}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(464) ->
    #base_liveness_lv{lv = 464,exp = 300,attr = [{1,2365},{2,23650}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(465) ->
    #base_liveness_lv{lv = 465,exp = 300,attr = [{1,2370},{2,23700}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(466) ->
    #base_liveness_lv{lv = 466,exp = 300,attr = [{1,2375},{2,23750}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(467) ->
    #base_liveness_lv{lv = 467,exp = 300,attr = [{1,2380},{2,23800}],awards = [{100,230014,1},{100,101010,1}]};

get_liveness(468) ->
    #base_liveness_lv{lv = 468,exp = 300,attr = [{1,2385},{2,23850}],awards = [{100,230016,1},{100,101010,1}]};

get_liveness(469) ->
    #base_liveness_lv{lv = 469,exp = 300,attr = [{1,2390},{2,23900}],awards = [{100,230010,1},{100,101010,1}]};

get_liveness(470) ->
    #base_liveness_lv{lv = 470,exp = 300,attr = [{1,2395},{2,23950}],awards = [{100,230012,1},{100,101010,1}]};

get_liveness(_Lv) ->
    [].

get_lv_max() -> 470.

get_all_reserve_module() ->
    [{400,7,1},{405,1,1},{405,1,2},{405,1,3},{406,1,1},{406,1,2},{410,1,2},{410,1,3},{410,2,1},{415,0,1},{415,0,2},{415,0,3},{418,0,1},{418,0,2},{418,0,3},{427,1,1},{600,0,1},{600,0,2},{600,0,3},{601,0,1},{601,0,2},{602,0,1},{602,0,2},{602,0,3},{602,0,4}].

get_reserve_rewards(400,7,1) ->
    [{4,100003,20}];

get_reserve_rewards(405,1,1) ->
    [{4,100003,20}];

get_reserve_rewards(405,1,2) ->
    [{4,100003,20}];

get_reserve_rewards(405,1,3) ->
    [{4,100003,20}];

get_reserve_rewards(406,1,1) ->
    [{4,100003,20}];

get_reserve_rewards(406,1,2) ->
    [{4,100003,20}];

get_reserve_rewards(410,1,2) ->
    [{4,100003,20}];

get_reserve_rewards(410,1,3) ->
    [{4,100003,20}];

get_reserve_rewards(410,2,1) ->
    [{4,100003,20}];

get_reserve_rewards(415,0,1) ->
    [{4,100003,20}];

get_reserve_rewards(415,0,2) ->
    [{4,100003,20}];

get_reserve_rewards(415,0,3) ->
    [{4,100003,20}];

get_reserve_rewards(418,0,1) ->
    [{4,100003,20}];

get_reserve_rewards(418,0,2) ->
    [{4,100003,20}];

get_reserve_rewards(418,0,3) ->
    [{4,100003,20}];

get_reserve_rewards(427,1,1) ->
    [{4,100003,20}];

get_reserve_rewards(600,0,1) ->
    [{4,100003,20}];

get_reserve_rewards(600,0,2) ->
    [{4,100003,20}];

get_reserve_rewards(600,0,3) ->
    [{4,100003,20}];

get_reserve_rewards(601,0,1) ->
    [{4,100003,20}];

get_reserve_rewards(601,0,2) ->
    [{4,100003,20}];

get_reserve_rewards(602,0,1) ->
    [{4,100003,20}];

get_reserve_rewards(602,0,2) ->
    [{4,100003,20}];

get_reserve_rewards(602,0,3) ->
    [{4,100003,20}];

get_reserve_rewards(602,0,4) ->
    [{4,100003,20}];

get_reserve_rewards(_Moduleid,_Modulesub,_Acsub) ->
    [].

