%%%---------------------------------------
%%% module      : data_charm_beach
%%% description : 魅力海滩配置
%%%
%%%---------------------------------------
-module(data_charm_beach).
-compile(export_all).
-include("charm_beach.hrl").



get_max_rank() ->
    [40,20,10,5,4,3,2,1].

get_reward_cfg(_Rank) when _Rank >= 1, _Rank =< 1 ->
		[{17,432003,1},{2,100001,30}];
get_reward_cfg(_Rank) when _Rank >= 2, _Rank =< 2 ->
		[{2,100001,25}];
get_reward_cfg(_Rank) when _Rank >= 3, _Rank =< 3 ->
		[{2,100001,20}];
get_reward_cfg(_Rank) when _Rank >= 4, _Rank =< 4 ->
		[{2,100001,15}];
get_reward_cfg(_Rank) when _Rank >= 5, _Rank =< 5 ->
		[{2,100001,10}];
get_reward_cfg(_Rank) when _Rank >= 6, _Rank =< 10 ->
		[{2,100001,9}];
get_reward_cfg(_Rank) when _Rank >= 11, _Rank =< 20 ->
		[{2,100001,8}];
get_reward_cfg(_Rank) when _Rank >= 21, _Rank =< 40 ->
		[{2,100001,5}];
get_reward_cfg(_Rank) ->
    [].


get_cfg(open_day_to_kf) ->
    3;


get_cfg(buy_times_money) ->
    [{1,10}];


get_cfg(send_exp_time) ->
    5;


get_cfg(reward_to_over_time) ->
    10;


get_cfg(free_vote_times) ->
    5;


get_cfg(solo_interval) ->
    10;


get_cfg(max_exp_reward) ->
    890;


get_cfg(kf_scene) ->
    6110;


get_cfg(bf_scene) ->
    6100;


get_cfg(max_people) ->
    50;


get_cfg(born_loc) ->
    [{1208,2280,300},{899,1797,500},{1003,1014,500},{1782,710,500},{1606,805,500},{2352,1026,300}];


get_cfg(servers_each_room) ->
    2;


get_cfg(buy_vote_times) ->
    10;


get_cfg(vote_exp_ratio) ->
    1000;


get_cfg(solo_dance_point) ->
    [1848,1706];


get_cfg(list_max) ->
    100;


get_cfg(vip_add) ->
    20;


get_cfg(first_reward) ->
    432003;


get_cfg(dancer_name) ->
    "舞王";


get_cfg(dummy_num) ->
    6;

get_cfg(_Key) ->
    [].

get_exp_cfg(40) ->
    #base_beach_exp{level = 40,timer_add_exp = 436,vote_add_exp = 2616};

get_exp_cfg(41) ->
    #base_beach_exp{level = 41,timer_add_exp = 447,vote_add_exp = 2683};

get_exp_cfg(42) ->
    #base_beach_exp{level = 42,timer_add_exp = 458,vote_add_exp = 2750};

get_exp_cfg(43) ->
    #base_beach_exp{level = 43,timer_add_exp = 470,vote_add_exp = 2818};

get_exp_cfg(44) ->
    #base_beach_exp{level = 44,timer_add_exp = 480,vote_add_exp = 2880};

get_exp_cfg(45) ->
    #base_beach_exp{level = 45,timer_add_exp = 491,vote_add_exp = 2947};

get_exp_cfg(46) ->
    #base_beach_exp{level = 46,timer_add_exp = 502,vote_add_exp = 3014};

get_exp_cfg(47) ->
    #base_beach_exp{level = 47,timer_add_exp = 514,vote_add_exp = 3082};

get_exp_cfg(48) ->
    #base_beach_exp{level = 48,timer_add_exp = 525,vote_add_exp = 3149};

get_exp_cfg(49) ->
    #base_beach_exp{level = 49,timer_add_exp = 536,vote_add_exp = 3216};

get_exp_cfg(50) ->
    #base_beach_exp{level = 50,timer_add_exp = 547,vote_add_exp = 3283};

get_exp_cfg(51) ->
    #base_beach_exp{level = 51,timer_add_exp = 558,vote_add_exp = 3350};

get_exp_cfg(52) ->
    #base_beach_exp{level = 52,timer_add_exp = 570,vote_add_exp = 3418};

get_exp_cfg(53) ->
    #base_beach_exp{level = 53,timer_add_exp = 580,vote_add_exp = 3480};

get_exp_cfg(54) ->
    #base_beach_exp{level = 54,timer_add_exp = 591,vote_add_exp = 3547};

get_exp_cfg(55) ->
    #base_beach_exp{level = 55,timer_add_exp = 602,vote_add_exp = 3614};

get_exp_cfg(56) ->
    #base_beach_exp{level = 56,timer_add_exp = 614,vote_add_exp = 3682};

get_exp_cfg(57) ->
    #base_beach_exp{level = 57,timer_add_exp = 625,vote_add_exp = 3749};

get_exp_cfg(58) ->
    #base_beach_exp{level = 58,timer_add_exp = 636,vote_add_exp = 3816};

get_exp_cfg(59) ->
    #base_beach_exp{level = 59,timer_add_exp = 647,vote_add_exp = 3883};

get_exp_cfg(60) ->
    #base_beach_exp{level = 60,timer_add_exp = 658,vote_add_exp = 3950};

get_exp_cfg(61) ->
    #base_beach_exp{level = 61,timer_add_exp = 669,vote_add_exp = 4013};

get_exp_cfg(62) ->
    #base_beach_exp{level = 62,timer_add_exp = 680,vote_add_exp = 4080};

get_exp_cfg(63) ->
    #base_beach_exp{level = 63,timer_add_exp = 691,vote_add_exp = 4147};

get_exp_cfg(64) ->
    #base_beach_exp{level = 64,timer_add_exp = 702,vote_add_exp = 4214};

get_exp_cfg(65) ->
    #base_beach_exp{level = 65,timer_add_exp = 714,vote_add_exp = 4282};

get_exp_cfg(66) ->
    #base_beach_exp{level = 66,timer_add_exp = 725,vote_add_exp = 4349};

get_exp_cfg(67) ->
    #base_beach_exp{level = 67,timer_add_exp = 736,vote_add_exp = 4416};

get_exp_cfg(68) ->
    #base_beach_exp{level = 68,timer_add_exp = 747,vote_add_exp = 4483};

get_exp_cfg(69) ->
    #base_beach_exp{level = 69,timer_add_exp = 758,vote_add_exp = 4550};

get_exp_cfg(70) ->
    #base_beach_exp{level = 70,timer_add_exp = 769,vote_add_exp = 4613};

get_exp_cfg(71) ->
    #base_beach_exp{level = 71,timer_add_exp = 780,vote_add_exp = 4680};

get_exp_cfg(72) ->
    #base_beach_exp{level = 72,timer_add_exp = 791,vote_add_exp = 4747};

get_exp_cfg(73) ->
    #base_beach_exp{level = 73,timer_add_exp = 802,vote_add_exp = 4814};

get_exp_cfg(74) ->
    #base_beach_exp{level = 74,timer_add_exp = 814,vote_add_exp = 4882};

get_exp_cfg(75) ->
    #base_beach_exp{level = 75,timer_add_exp = 825,vote_add_exp = 4949};

get_exp_cfg(76) ->
    #base_beach_exp{level = 76,timer_add_exp = 836,vote_add_exp = 5016};

get_exp_cfg(77) ->
    #base_beach_exp{level = 77,timer_add_exp = 847,vote_add_exp = 5083};

get_exp_cfg(78) ->
    #base_beach_exp{level = 78,timer_add_exp = 858,vote_add_exp = 5146};

get_exp_cfg(79) ->
    #base_beach_exp{level = 79,timer_add_exp = 2013,vote_add_exp = 10065};

get_exp_cfg(80) ->
    #base_beach_exp{level = 80,timer_add_exp = 2013,vote_add_exp = 10065};

get_exp_cfg(81) ->
    #base_beach_exp{level = 81,timer_add_exp = 2082,vote_add_exp = 10410};

get_exp_cfg(82) ->
    #base_beach_exp{level = 82,timer_add_exp = 2082,vote_add_exp = 10410};

get_exp_cfg(83) ->
    #base_beach_exp{level = 83,timer_add_exp = 2186,vote_add_exp = 10930};

get_exp_cfg(84) ->
    #base_beach_exp{level = 84,timer_add_exp = 2186,vote_add_exp = 10930};

get_exp_cfg(85) ->
    #base_beach_exp{level = 85,timer_add_exp = 2290,vote_add_exp = 11450};

get_exp_cfg(86) ->
    #base_beach_exp{level = 86,timer_add_exp = 2290,vote_add_exp = 11450};

get_exp_cfg(87) ->
    #base_beach_exp{level = 87,timer_add_exp = 2360,vote_add_exp = 11800};

get_exp_cfg(88) ->
    #base_beach_exp{level = 88,timer_add_exp = 2360,vote_add_exp = 11800};

get_exp_cfg(89) ->
    #base_beach_exp{level = 89,timer_add_exp = 2430,vote_add_exp = 12150};

get_exp_cfg(90) ->
    #base_beach_exp{level = 90,timer_add_exp = 2430,vote_add_exp = 12150};

get_exp_cfg(91) ->
    #base_beach_exp{level = 91,timer_add_exp = 2534,vote_add_exp = 12670};

get_exp_cfg(92) ->
    #base_beach_exp{level = 92,timer_add_exp = 2534,vote_add_exp = 12670};

get_exp_cfg(93) ->
    #base_beach_exp{level = 93,timer_add_exp = 2603,vote_add_exp = 13015};

get_exp_cfg(94) ->
    #base_beach_exp{level = 94,timer_add_exp = 2603,vote_add_exp = 13015};

get_exp_cfg(95) ->
    #base_beach_exp{level = 95,timer_add_exp = 3575,vote_add_exp = 17875};

get_exp_cfg(96) ->
    #base_beach_exp{level = 96,timer_add_exp = 3575,vote_add_exp = 17875};

get_exp_cfg(97) ->
    #base_beach_exp{level = 97,timer_add_exp = 3575,vote_add_exp = 17875};

get_exp_cfg(98) ->
    #base_beach_exp{level = 98,timer_add_exp = 6370,vote_add_exp = 31850};

get_exp_cfg(99) ->
    #base_beach_exp{level = 99,timer_add_exp = 6414,vote_add_exp = 32070};

get_exp_cfg(100) ->
    #base_beach_exp{level = 100,timer_add_exp = 6458,vote_add_exp = 32290};

get_exp_cfg(101) ->
    #base_beach_exp{level = 101,timer_add_exp = 6502,vote_add_exp = 32510};

get_exp_cfg(102) ->
    #base_beach_exp{level = 102,timer_add_exp = 2610,vote_add_exp = 13050};

get_exp_cfg(103) ->
    #base_beach_exp{level = 103,timer_add_exp = 2613,vote_add_exp = 13065};

get_exp_cfg(104) ->
    #base_beach_exp{level = 104,timer_add_exp = 2616,vote_add_exp = 13080};

get_exp_cfg(105) ->
    #base_beach_exp{level = 105,timer_add_exp = 2618,vote_add_exp = 13090};

get_exp_cfg(106) ->
    #base_beach_exp{level = 106,timer_add_exp = 2621,vote_add_exp = 13105};

get_exp_cfg(107) ->
    #base_beach_exp{level = 107,timer_add_exp = 2624,vote_add_exp = 13120};

get_exp_cfg(108) ->
    #base_beach_exp{level = 108,timer_add_exp = 2626,vote_add_exp = 13130};

get_exp_cfg(109) ->
    #base_beach_exp{level = 109,timer_add_exp = 2629,vote_add_exp = 13145};

get_exp_cfg(110) ->
    #base_beach_exp{level = 110,timer_add_exp = 2632,vote_add_exp = 13160};

get_exp_cfg(111) ->
    #base_beach_exp{level = 111,timer_add_exp = 2634,vote_add_exp = 13170};

get_exp_cfg(112) ->
    #base_beach_exp{level = 112,timer_add_exp = 2637,vote_add_exp = 13185};

get_exp_cfg(113) ->
    #base_beach_exp{level = 113,timer_add_exp = 2639,vote_add_exp = 13195};

get_exp_cfg(114) ->
    #base_beach_exp{level = 114,timer_add_exp = 2642,vote_add_exp = 13210};

get_exp_cfg(115) ->
    #base_beach_exp{level = 115,timer_add_exp = 2645,vote_add_exp = 13225};

get_exp_cfg(116) ->
    #base_beach_exp{level = 116,timer_add_exp = 2647,vote_add_exp = 13235};

get_exp_cfg(117) ->
    #base_beach_exp{level = 117,timer_add_exp = 2650,vote_add_exp = 13250};

get_exp_cfg(118) ->
    #base_beach_exp{level = 118,timer_add_exp = 2653,vote_add_exp = 13265};

get_exp_cfg(119) ->
    #base_beach_exp{level = 119,timer_add_exp = 2655,vote_add_exp = 13275};

get_exp_cfg(120) ->
    #base_beach_exp{level = 120,timer_add_exp = 2658,vote_add_exp = 13290};

get_exp_cfg(121) ->
    #base_beach_exp{level = 121,timer_add_exp = 2661,vote_add_exp = 13305};

get_exp_cfg(122) ->
    #base_beach_exp{level = 122,timer_add_exp = 2663,vote_add_exp = 13315};

get_exp_cfg(123) ->
    #base_beach_exp{level = 123,timer_add_exp = 1935,vote_add_exp = 9675};

get_exp_cfg(124) ->
    #base_beach_exp{level = 124,timer_add_exp = 1937,vote_add_exp = 9685};

get_exp_cfg(125) ->
    #base_beach_exp{level = 125,timer_add_exp = 1939,vote_add_exp = 9695};

get_exp_cfg(126) ->
    #base_beach_exp{level = 126,timer_add_exp = 1941,vote_add_exp = 9705};

get_exp_cfg(127) ->
    #base_beach_exp{level = 127,timer_add_exp = 1942,vote_add_exp = 9710};

get_exp_cfg(128) ->
    #base_beach_exp{level = 128,timer_add_exp = 1944,vote_add_exp = 9720};

get_exp_cfg(129) ->
    #base_beach_exp{level = 129,timer_add_exp = 1946,vote_add_exp = 9730};

get_exp_cfg(130) ->
    #base_beach_exp{level = 130,timer_add_exp = 1962,vote_add_exp = 9810};

get_exp_cfg(131) ->
    #base_beach_exp{level = 131,timer_add_exp = 1950,vote_add_exp = 9750};

get_exp_cfg(132) ->
    #base_beach_exp{level = 132,timer_add_exp = 1952,vote_add_exp = 9760};

get_exp_cfg(133) ->
    #base_beach_exp{level = 133,timer_add_exp = 1954,vote_add_exp = 9770};

get_exp_cfg(134) ->
    #base_beach_exp{level = 134,timer_add_exp = 1956,vote_add_exp = 9780};

get_exp_cfg(135) ->
    #base_beach_exp{level = 135,timer_add_exp = 1958,vote_add_exp = 9790};

get_exp_cfg(136) ->
    #base_beach_exp{level = 136,timer_add_exp = 1960,vote_add_exp = 9800};

get_exp_cfg(137) ->
    #base_beach_exp{level = 137,timer_add_exp = 2019,vote_add_exp = 10095};

get_exp_cfg(138) ->
    #base_beach_exp{level = 138,timer_add_exp = 2021,vote_add_exp = 10105};

get_exp_cfg(139) ->
    #base_beach_exp{level = 139,timer_add_exp = 2023,vote_add_exp = 10115};

get_exp_cfg(140) ->
    #base_beach_exp{level = 140,timer_add_exp = 2025,vote_add_exp = 10125};

get_exp_cfg(141) ->
    #base_beach_exp{level = 141,timer_add_exp = 2027,vote_add_exp = 10135};

get_exp_cfg(142) ->
    #base_beach_exp{level = 142,timer_add_exp = 2029,vote_add_exp = 10145};

get_exp_cfg(143) ->
    #base_beach_exp{level = 143,timer_add_exp = 2031,vote_add_exp = 10155};

get_exp_cfg(144) ->
    #base_beach_exp{level = 144,timer_add_exp = 2033,vote_add_exp = 10165};

get_exp_cfg(145) ->
    #base_beach_exp{level = 145,timer_add_exp = 2035,vote_add_exp = 10175};

get_exp_cfg(146) ->
    #base_beach_exp{level = 146,timer_add_exp = 2039,vote_add_exp = 10195};

get_exp_cfg(147) ->
    #base_beach_exp{level = 147,timer_add_exp = 2039,vote_add_exp = 10195};

get_exp_cfg(148) ->
    #base_beach_exp{level = 148,timer_add_exp = 2041,vote_add_exp = 10205};

get_exp_cfg(149) ->
    #base_beach_exp{level = 149,timer_add_exp = 2044,vote_add_exp = 10220};

get_exp_cfg(150) ->
    #base_beach_exp{level = 150,timer_add_exp = 2046,vote_add_exp = 10230};

get_exp_cfg(151) ->
    #base_beach_exp{level = 151,timer_add_exp = 2048,vote_add_exp = 10240};

get_exp_cfg(152) ->
    #base_beach_exp{level = 152,timer_add_exp = 2050,vote_add_exp = 10250};

get_exp_cfg(153) ->
    #base_beach_exp{level = 153,timer_add_exp = 2052,vote_add_exp = 10260};

get_exp_cfg(154) ->
    #base_beach_exp{level = 154,timer_add_exp = 2054,vote_add_exp = 10270};

get_exp_cfg(155) ->
    #base_beach_exp{level = 155,timer_add_exp = 2056,vote_add_exp = 10280};

get_exp_cfg(156) ->
    #base_beach_exp{level = 156,timer_add_exp = 2220,vote_add_exp = 11100};

get_exp_cfg(157) ->
    #base_beach_exp{level = 157,timer_add_exp = 2222,vote_add_exp = 11110};

get_exp_cfg(158) ->
    #base_beach_exp{level = 158,timer_add_exp = 2224,vote_add_exp = 11120};

get_exp_cfg(159) ->
    #base_beach_exp{level = 159,timer_add_exp = 2227,vote_add_exp = 11135};

get_exp_cfg(160) ->
    #base_beach_exp{level = 160,timer_add_exp = 2229,vote_add_exp = 11145};

get_exp_cfg(161) ->
    #base_beach_exp{level = 161,timer_add_exp = 2231,vote_add_exp = 11155};

get_exp_cfg(162) ->
    #base_beach_exp{level = 162,timer_add_exp = 2233,vote_add_exp = 11165};

get_exp_cfg(163) ->
    #base_beach_exp{level = 163,timer_add_exp = 2236,vote_add_exp = 11180};

get_exp_cfg(164) ->
    #base_beach_exp{level = 164,timer_add_exp = 2238,vote_add_exp = 11190};

get_exp_cfg(165) ->
    #base_beach_exp{level = 165,timer_add_exp = 2240,vote_add_exp = 11200};

get_exp_cfg(166) ->
    #base_beach_exp{level = 166,timer_add_exp = 2242,vote_add_exp = 11210};

get_exp_cfg(167) ->
    #base_beach_exp{level = 167,timer_add_exp = 2245,vote_add_exp = 11225};

get_exp_cfg(168) ->
    #base_beach_exp{level = 168,timer_add_exp = 2247,vote_add_exp = 11235};

get_exp_cfg(169) ->
    #base_beach_exp{level = 169,timer_add_exp = 2249,vote_add_exp = 11245};

get_exp_cfg(170) ->
    #base_beach_exp{level = 170,timer_add_exp = 2251,vote_add_exp = 11255};

get_exp_cfg(171) ->
    #base_beach_exp{level = 171,timer_add_exp = 2253,vote_add_exp = 11265};

get_exp_cfg(172) ->
    #base_beach_exp{level = 172,timer_add_exp = 2256,vote_add_exp = 11280};

get_exp_cfg(173) ->
    #base_beach_exp{level = 173,timer_add_exp = 2316,vote_add_exp = 11580};

get_exp_cfg(174) ->
    #base_beach_exp{level = 174,timer_add_exp = 2318,vote_add_exp = 11590};

get_exp_cfg(175) ->
    #base_beach_exp{level = 175,timer_add_exp = 2321,vote_add_exp = 11605};

get_exp_cfg(176) ->
    #base_beach_exp{level = 176,timer_add_exp = 2323,vote_add_exp = 11615};

get_exp_cfg(177) ->
    #base_beach_exp{level = 177,timer_add_exp = 2325,vote_add_exp = 11625};

get_exp_cfg(178) ->
    #base_beach_exp{level = 178,timer_add_exp = 2328,vote_add_exp = 11640};

get_exp_cfg(179) ->
    #base_beach_exp{level = 179,timer_add_exp = 2330,vote_add_exp = 11650};

get_exp_cfg(180) ->
    #base_beach_exp{level = 180,timer_add_exp = 2332,vote_add_exp = 11660};

get_exp_cfg(181) ->
    #base_beach_exp{level = 181,timer_add_exp = 2335,vote_add_exp = 11675};

get_exp_cfg(182) ->
    #base_beach_exp{level = 182,timer_add_exp = 2337,vote_add_exp = 11685};

get_exp_cfg(183) ->
    #base_beach_exp{level = 183,timer_add_exp = 2339,vote_add_exp = 11695};

get_exp_cfg(184) ->
    #base_beach_exp{level = 184,timer_add_exp = 2342,vote_add_exp = 11710};

get_exp_cfg(185) ->
    #base_beach_exp{level = 185,timer_add_exp = 2344,vote_add_exp = 11720};

get_exp_cfg(186) ->
    #base_beach_exp{level = 186,timer_add_exp = 2346,vote_add_exp = 11730};

get_exp_cfg(187) ->
    #base_beach_exp{level = 187,timer_add_exp = 2349,vote_add_exp = 11745};

get_exp_cfg(188) ->
    #base_beach_exp{level = 188,timer_add_exp = 2523,vote_add_exp = 12615};

get_exp_cfg(189) ->
    #base_beach_exp{level = 189,timer_add_exp = 2526,vote_add_exp = 12630};

get_exp_cfg(190) ->
    #base_beach_exp{level = 190,timer_add_exp = 2528,vote_add_exp = 12640};

get_exp_cfg(191) ->
    #base_beach_exp{level = 191,timer_add_exp = 2531,vote_add_exp = 12655};

get_exp_cfg(192) ->
    #base_beach_exp{level = 192,timer_add_exp = 2533,vote_add_exp = 12665};

get_exp_cfg(193) ->
    #base_beach_exp{level = 193,timer_add_exp = 2536,vote_add_exp = 12680};

get_exp_cfg(194) ->
    #base_beach_exp{level = 194,timer_add_exp = 2538,vote_add_exp = 12690};

get_exp_cfg(195) ->
    #base_beach_exp{level = 195,timer_add_exp = 2541,vote_add_exp = 12705};

get_exp_cfg(196) ->
    #base_beach_exp{level = 196,timer_add_exp = 2543,vote_add_exp = 12715};

get_exp_cfg(197) ->
    #base_beach_exp{level = 197,timer_add_exp = 2546,vote_add_exp = 12730};

get_exp_cfg(198) ->
    #base_beach_exp{level = 198,timer_add_exp = 2549,vote_add_exp = 12745};

get_exp_cfg(199) ->
    #base_beach_exp{level = 199,timer_add_exp = 2551,vote_add_exp = 12755};

get_exp_cfg(200) ->
    #base_beach_exp{level = 200,timer_add_exp = 2554,vote_add_exp = 12770};

get_exp_cfg(201) ->
    #base_beach_exp{level = 201,timer_add_exp = 2623,vote_add_exp = 13115};

get_exp_cfg(202) ->
    #base_beach_exp{level = 202,timer_add_exp = 2625,vote_add_exp = 13125};

get_exp_cfg(203) ->
    #base_beach_exp{level = 203,timer_add_exp = 2628,vote_add_exp = 13140};

get_exp_cfg(204) ->
    #base_beach_exp{level = 204,timer_add_exp = 2631,vote_add_exp = 13155};

get_exp_cfg(205) ->
    #base_beach_exp{level = 205,timer_add_exp = 2633,vote_add_exp = 13165};

get_exp_cfg(206) ->
    #base_beach_exp{level = 206,timer_add_exp = 2636,vote_add_exp = 13180};

get_exp_cfg(207) ->
    #base_beach_exp{level = 207,timer_add_exp = 2654,vote_add_exp = 13270};

get_exp_cfg(208) ->
    #base_beach_exp{level = 208,timer_add_exp = 2641,vote_add_exp = 13205};

get_exp_cfg(209) ->
    #base_beach_exp{level = 209,timer_add_exp = 2644,vote_add_exp = 13220};

get_exp_cfg(210) ->
    #base_beach_exp{level = 210,timer_add_exp = 2647,vote_add_exp = 13235};

get_exp_cfg(211) ->
    #base_beach_exp{level = 211,timer_add_exp = 2649,vote_add_exp = 13245};

get_exp_cfg(212) ->
    #base_beach_exp{level = 212,timer_add_exp = 2652,vote_add_exp = 13260};

get_exp_cfg(213) ->
    #base_beach_exp{level = 213,timer_add_exp = 2839,vote_add_exp = 14195};

get_exp_cfg(214) ->
    #base_beach_exp{level = 214,timer_add_exp = 2842,vote_add_exp = 14210};

get_exp_cfg(215) ->
    #base_beach_exp{level = 215,timer_add_exp = 2844,vote_add_exp = 14220};

get_exp_cfg(216) ->
    #base_beach_exp{level = 216,timer_add_exp = 2847,vote_add_exp = 14235};

get_exp_cfg(217) ->
    #base_beach_exp{level = 217,timer_add_exp = 2850,vote_add_exp = 14250};

get_exp_cfg(218) ->
    #base_beach_exp{level = 218,timer_add_exp = 2853,vote_add_exp = 14265};

get_exp_cfg(219) ->
    #base_beach_exp{level = 219,timer_add_exp = 2856,vote_add_exp = 14280};

get_exp_cfg(220) ->
    #base_beach_exp{level = 220,timer_add_exp = 2859,vote_add_exp = 14295};

get_exp_cfg(221) ->
    #base_beach_exp{level = 221,timer_add_exp = 2862,vote_add_exp = 14310};

get_exp_cfg(222) ->
    #base_beach_exp{level = 222,timer_add_exp = 2944,vote_add_exp = 14720};

get_exp_cfg(223) ->
    #base_beach_exp{level = 223,timer_add_exp = 2947,vote_add_exp = 14735};

get_exp_cfg(224) ->
    #base_beach_exp{level = 224,timer_add_exp = 2950,vote_add_exp = 14750};

get_exp_cfg(225) ->
    #base_beach_exp{level = 225,timer_add_exp = 2953,vote_add_exp = 14765};

get_exp_cfg(226) ->
    #base_beach_exp{level = 226,timer_add_exp = 2959,vote_add_exp = 14795};

get_exp_cfg(227) ->
    #base_beach_exp{level = 227,timer_add_exp = 2962,vote_add_exp = 14810};

get_exp_cfg(228) ->
    #base_beach_exp{level = 228,timer_add_exp = 2965,vote_add_exp = 14825};

get_exp_cfg(229) ->
    #base_beach_exp{level = 229,timer_add_exp = 2968,vote_add_exp = 14840};

get_exp_cfg(230) ->
    #base_beach_exp{level = 230,timer_add_exp = 3160,vote_add_exp = 15800};

get_exp_cfg(231) ->
    #base_beach_exp{level = 231,timer_add_exp = 3163,vote_add_exp = 15815};

get_exp_cfg(232) ->
    #base_beach_exp{level = 232,timer_add_exp = 3167,vote_add_exp = 15835};

get_exp_cfg(233) ->
    #base_beach_exp{level = 233,timer_add_exp = 3170,vote_add_exp = 15850};

get_exp_cfg(234) ->
    #base_beach_exp{level = 234,timer_add_exp = 3176,vote_add_exp = 15880};

get_exp_cfg(235) ->
    #base_beach_exp{level = 235,timer_add_exp = 3179,vote_add_exp = 15895};

get_exp_cfg(236) ->
    #base_beach_exp{level = 236,timer_add_exp = 3183,vote_add_exp = 15915};

get_exp_cfg(237) ->
    #base_beach_exp{level = 237,timer_add_exp = 3186,vote_add_exp = 15930};

get_exp_cfg(238) ->
    #base_beach_exp{level = 238,timer_add_exp = 3274,vote_add_exp = 16370};

get_exp_cfg(239) ->
    #base_beach_exp{level = 239,timer_add_exp = 3278,vote_add_exp = 16390};

get_exp_cfg(240) ->
    #base_beach_exp{level = 240,timer_add_exp = 3281,vote_add_exp = 16405};

get_exp_cfg(241) ->
    #base_beach_exp{level = 241,timer_add_exp = 3284,vote_add_exp = 16420};

get_exp_cfg(242) ->
    #base_beach_exp{level = 242,timer_add_exp = 3288,vote_add_exp = 16440};

get_exp_cfg(243) ->
    #base_beach_exp{level = 243,timer_add_exp = 3291,vote_add_exp = 16455};

get_exp_cfg(244) ->
    #base_beach_exp{level = 244,timer_add_exp = 3294,vote_add_exp = 16470};

get_exp_cfg(245) ->
    #base_beach_exp{level = 245,timer_add_exp = 3496,vote_add_exp = 17480};

get_exp_cfg(246) ->
    #base_beach_exp{level = 246,timer_add_exp = 3500,vote_add_exp = 17500};

get_exp_cfg(247) ->
    #base_beach_exp{level = 247,timer_add_exp = 3503,vote_add_exp = 17515};

get_exp_cfg(248) ->
    #base_beach_exp{level = 248,timer_add_exp = 3507,vote_add_exp = 17535};

get_exp_cfg(249) ->
    #base_beach_exp{level = 249,timer_add_exp = 3511,vote_add_exp = 17555};

get_exp_cfg(250) ->
    #base_beach_exp{level = 250,timer_add_exp = 3514,vote_add_exp = 17570};

get_exp_cfg(251) ->
    #base_beach_exp{level = 251,timer_add_exp = 3518,vote_add_exp = 17590};

get_exp_cfg(252) ->
    #base_beach_exp{level = 252,timer_add_exp = 3613,vote_add_exp = 18065};

get_exp_cfg(253) ->
    #base_beach_exp{level = 253,timer_add_exp = 3617,vote_add_exp = 18085};

get_exp_cfg(254) ->
    #base_beach_exp{level = 254,timer_add_exp = 3620,vote_add_exp = 18100};

get_exp_cfg(255) ->
    #base_beach_exp{level = 255,timer_add_exp = 3628,vote_add_exp = 18140};

get_exp_cfg(256) ->
    #base_beach_exp{level = 256,timer_add_exp = 3631,vote_add_exp = 18155};

get_exp_cfg(257) ->
    #base_beach_exp{level = 257,timer_add_exp = 3635,vote_add_exp = 18175};

get_exp_cfg(258) ->
    #base_beach_exp{level = 258,timer_add_exp = 3841,vote_add_exp = 19205};

get_exp_cfg(259) ->
    #base_beach_exp{level = 259,timer_add_exp = 3844,vote_add_exp = 19220};

get_exp_cfg(260) ->
    #base_beach_exp{level = 260,timer_add_exp = 3848,vote_add_exp = 19240};

get_exp_cfg(261) ->
    #base_beach_exp{level = 261,timer_add_exp = 3856,vote_add_exp = 19280};

get_exp_cfg(262) ->
    #base_beach_exp{level = 262,timer_add_exp = 3860,vote_add_exp = 19300};

get_exp_cfg(263) ->
    #base_beach_exp{level = 263,timer_add_exp = 3864,vote_add_exp = 19320};

get_exp_cfg(264) ->
    #base_beach_exp{level = 264,timer_add_exp = 3963,vote_add_exp = 19815};

get_exp_cfg(265) ->
    #base_beach_exp{level = 265,timer_add_exp = 3967,vote_add_exp = 19835};

get_exp_cfg(266) ->
    #base_beach_exp{level = 266,timer_add_exp = 3971,vote_add_exp = 19855};

get_exp_cfg(267) ->
    #base_beach_exp{level = 267,timer_add_exp = 3975,vote_add_exp = 19875};

get_exp_cfg(268) ->
    #base_beach_exp{level = 268,timer_add_exp = 3979,vote_add_exp = 19895};

get_exp_cfg(269) ->
    #base_beach_exp{level = 269,timer_add_exp = 3983,vote_add_exp = 19915};

get_exp_cfg(270) ->
    #base_beach_exp{level = 270,timer_add_exp = 3987,vote_add_exp = 19935};

get_exp_cfg(271) ->
    #base_beach_exp{level = 271,timer_add_exp = 4196,vote_add_exp = 20980};

get_exp_cfg(272) ->
    #base_beach_exp{level = 272,timer_add_exp = 4200,vote_add_exp = 21000};

get_exp_cfg(273) ->
    #base_beach_exp{level = 273,timer_add_exp = 4204,vote_add_exp = 21020};

get_exp_cfg(274) ->
    #base_beach_exp{level = 274,timer_add_exp = 4213,vote_add_exp = 21065};

get_exp_cfg(275) ->
    #base_beach_exp{level = 275,timer_add_exp = 4217,vote_add_exp = 21085};

get_exp_cfg(276) ->
    #base_beach_exp{level = 276,timer_add_exp = 4221,vote_add_exp = 21105};

get_exp_cfg(277) ->
    #base_beach_exp{level = 277,timer_add_exp = 4323,vote_add_exp = 21615};

get_exp_cfg(278) ->
    #base_beach_exp{level = 278,timer_add_exp = 4328,vote_add_exp = 21640};

get_exp_cfg(279) ->
    #base_beach_exp{level = 279,timer_add_exp = 4332,vote_add_exp = 21660};

get_exp_cfg(280) ->
    #base_beach_exp{level = 280,timer_add_exp = 4341,vote_add_exp = 21705};

get_exp_cfg(281) ->
    #base_beach_exp{level = 281,timer_add_exp = 4345,vote_add_exp = 21725};

get_exp_cfg(282) ->
    #base_beach_exp{level = 282,timer_add_exp = 4349,vote_add_exp = 21745};

get_exp_cfg(283) ->
    #base_beach_exp{level = 283,timer_add_exp = 4562,vote_add_exp = 22810};

get_exp_cfg(284) ->
    #base_beach_exp{level = 284,timer_add_exp = 4567,vote_add_exp = 22835};

get_exp_cfg(285) ->
    #base_beach_exp{level = 285,timer_add_exp = 4571,vote_add_exp = 22855};

get_exp_cfg(286) ->
    #base_beach_exp{level = 286,timer_add_exp = 4576,vote_add_exp = 22880};

get_exp_cfg(287) ->
    #base_beach_exp{level = 287,timer_add_exp = 4580,vote_add_exp = 22900};

get_exp_cfg(288) ->
    #base_beach_exp{level = 288,timer_add_exp = 4585,vote_add_exp = 22925};

get_exp_cfg(289) ->
    #base_beach_exp{level = 289,timer_add_exp = 4590,vote_add_exp = 22950};

get_exp_cfg(290) ->
    #base_beach_exp{level = 290,timer_add_exp = 4695,vote_add_exp = 23475};

get_exp_cfg(291) ->
    #base_beach_exp{level = 291,timer_add_exp = 4700,vote_add_exp = 23500};

get_exp_cfg(292) ->
    #base_beach_exp{level = 292,timer_add_exp = 4705,vote_add_exp = 23525};

get_exp_cfg(293) ->
    #base_beach_exp{level = 293,timer_add_exp = 4714,vote_add_exp = 23570};

get_exp_cfg(294) ->
    #base_beach_exp{level = 294,timer_add_exp = 4719,vote_add_exp = 23595};

get_exp_cfg(295) ->
    #base_beach_exp{level = 295,timer_add_exp = 4724,vote_add_exp = 23620};

get_exp_cfg(296) ->
    #base_beach_exp{level = 296,timer_add_exp = 4944,vote_add_exp = 24720};

get_exp_cfg(297) ->
    #base_beach_exp{level = 297,timer_add_exp = 4949,vote_add_exp = 24745};

get_exp_cfg(298) ->
    #base_beach_exp{level = 298,timer_add_exp = 4954,vote_add_exp = 24770};

get_exp_cfg(299) ->
    #base_beach_exp{level = 299,timer_add_exp = 4959,vote_add_exp = 24795};

get_exp_cfg(300) ->
    #base_beach_exp{level = 300,timer_add_exp = 4964,vote_add_exp = 24820};

get_exp_cfg(301) ->
    #base_beach_exp{level = 301,timer_add_exp = 5078,vote_add_exp = 25390};

get_exp_cfg(302) ->
    #base_beach_exp{level = 302,timer_add_exp = 5714,vote_add_exp = 28570};

get_exp_cfg(303) ->
    #base_beach_exp{level = 303,timer_add_exp = 5720,vote_add_exp = 28600};

get_exp_cfg(304) ->
    #base_beach_exp{level = 304,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(305) ->
    #base_beach_exp{level = 305,timer_add_exp = 5732,vote_add_exp = 28660};

get_exp_cfg(306) ->
    #base_beach_exp{level = 306,timer_add_exp = 5737,vote_add_exp = 28685};

get_exp_cfg(307) ->
    #base_beach_exp{level = 307,timer_add_exp = 5743,vote_add_exp = 28715};

get_exp_cfg(308) ->
    #base_beach_exp{level = 308,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(309) ->
    #base_beach_exp{level = 309,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(310) ->
    #base_beach_exp{level = 310,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(311) ->
    #base_beach_exp{level = 311,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(312) ->
    #base_beach_exp{level = 312,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(313) ->
    #base_beach_exp{level = 313,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(314) ->
    #base_beach_exp{level = 314,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(315) ->
    #base_beach_exp{level = 315,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(316) ->
    #base_beach_exp{level = 316,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(317) ->
    #base_beach_exp{level = 317,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(318) ->
    #base_beach_exp{level = 318,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(319) ->
    #base_beach_exp{level = 319,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(320) ->
    #base_beach_exp{level = 320,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(321) ->
    #base_beach_exp{level = 321,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(322) ->
    #base_beach_exp{level = 322,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(323) ->
    #base_beach_exp{level = 323,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(324) ->
    #base_beach_exp{level = 324,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(325) ->
    #base_beach_exp{level = 325,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(326) ->
    #base_beach_exp{level = 326,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(327) ->
    #base_beach_exp{level = 327,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(328) ->
    #base_beach_exp{level = 328,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(329) ->
    #base_beach_exp{level = 329,timer_add_exp = 5726,vote_add_exp = 28630};

get_exp_cfg(330) ->
    #base_beach_exp{level = 330,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(331) ->
    #base_beach_exp{level = 331,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(332) ->
    #base_beach_exp{level = 332,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(333) ->
    #base_beach_exp{level = 333,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(334) ->
    #base_beach_exp{level = 334,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(335) ->
    #base_beach_exp{level = 335,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(336) ->
    #base_beach_exp{level = 336,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(337) ->
    #base_beach_exp{level = 337,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(338) ->
    #base_beach_exp{level = 338,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(339) ->
    #base_beach_exp{level = 339,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(340) ->
    #base_beach_exp{level = 340,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(341) ->
    #base_beach_exp{level = 341,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(342) ->
    #base_beach_exp{level = 342,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(343) ->
    #base_beach_exp{level = 343,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(344) ->
    #base_beach_exp{level = 344,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(345) ->
    #base_beach_exp{level = 345,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(346) ->
    #base_beach_exp{level = 346,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(347) ->
    #base_beach_exp{level = 347,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(348) ->
    #base_beach_exp{level = 348,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(349) ->
    #base_beach_exp{level = 349,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(350) ->
    #base_beach_exp{level = 350,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(351) ->
    #base_beach_exp{level = 351,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(352) ->
    #base_beach_exp{level = 352,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(353) ->
    #base_beach_exp{level = 353,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(354) ->
    #base_beach_exp{level = 354,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(355) ->
    #base_beach_exp{level = 355,timer_add_exp = 6766,vote_add_exp = 33830};

get_exp_cfg(356) ->
    #base_beach_exp{level = 356,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(357) ->
    #base_beach_exp{level = 357,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(358) ->
    #base_beach_exp{level = 358,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(359) ->
    #base_beach_exp{level = 359,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(360) ->
    #base_beach_exp{level = 360,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(361) ->
    #base_beach_exp{level = 361,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(362) ->
    #base_beach_exp{level = 362,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(363) ->
    #base_beach_exp{level = 363,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(364) ->
    #base_beach_exp{level = 364,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(365) ->
    #base_beach_exp{level = 365,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(366) ->
    #base_beach_exp{level = 366,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(367) ->
    #base_beach_exp{level = 367,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(368) ->
    #base_beach_exp{level = 368,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(369) ->
    #base_beach_exp{level = 369,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(370) ->
    #base_beach_exp{level = 370,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(371) ->
    #base_beach_exp{level = 371,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(372) ->
    #base_beach_exp{level = 372,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(373) ->
    #base_beach_exp{level = 373,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(374) ->
    #base_beach_exp{level = 374,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(375) ->
    #base_beach_exp{level = 375,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(376) ->
    #base_beach_exp{level = 376,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(377) ->
    #base_beach_exp{level = 377,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(378) ->
    #base_beach_exp{level = 378,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(379) ->
    #base_beach_exp{level = 379,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(380) ->
    #base_beach_exp{level = 380,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(381) ->
    #base_beach_exp{level = 381,timer_add_exp = 7897,vote_add_exp = 39485};

get_exp_cfg(382) ->
    #base_beach_exp{level = 382,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(383) ->
    #base_beach_exp{level = 383,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(384) ->
    #base_beach_exp{level = 384,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(385) ->
    #base_beach_exp{level = 385,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(386) ->
    #base_beach_exp{level = 386,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(387) ->
    #base_beach_exp{level = 387,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(388) ->
    #base_beach_exp{level = 388,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(389) ->
    #base_beach_exp{level = 389,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(390) ->
    #base_beach_exp{level = 390,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(391) ->
    #base_beach_exp{level = 391,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(392) ->
    #base_beach_exp{level = 392,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(393) ->
    #base_beach_exp{level = 393,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(394) ->
    #base_beach_exp{level = 394,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(395) ->
    #base_beach_exp{level = 395,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(396) ->
    #base_beach_exp{level = 396,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(397) ->
    #base_beach_exp{level = 397,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(398) ->
    #base_beach_exp{level = 398,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(399) ->
    #base_beach_exp{level = 399,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(400) ->
    #base_beach_exp{level = 400,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(401) ->
    #base_beach_exp{level = 401,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(402) ->
    #base_beach_exp{level = 402,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(403) ->
    #base_beach_exp{level = 403,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(404) ->
    #base_beach_exp{level = 404,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(405) ->
    #base_beach_exp{level = 405,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(406) ->
    #base_beach_exp{level = 406,timer_add_exp = 9076,vote_add_exp = 45380};

get_exp_cfg(407) ->
    #base_beach_exp{level = 407,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(408) ->
    #base_beach_exp{level = 408,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(409) ->
    #base_beach_exp{level = 409,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(410) ->
    #base_beach_exp{level = 410,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(411) ->
    #base_beach_exp{level = 411,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(412) ->
    #base_beach_exp{level = 412,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(413) ->
    #base_beach_exp{level = 413,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(414) ->
    #base_beach_exp{level = 414,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(415) ->
    #base_beach_exp{level = 415,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(416) ->
    #base_beach_exp{level = 416,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(417) ->
    #base_beach_exp{level = 417,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(418) ->
    #base_beach_exp{level = 418,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(419) ->
    #base_beach_exp{level = 419,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(420) ->
    #base_beach_exp{level = 420,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(421) ->
    #base_beach_exp{level = 421,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(422) ->
    #base_beach_exp{level = 422,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(423) ->
    #base_beach_exp{level = 423,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(424) ->
    #base_beach_exp{level = 424,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(425) ->
    #base_beach_exp{level = 425,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(426) ->
    #base_beach_exp{level = 426,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(427) ->
    #base_beach_exp{level = 427,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(428) ->
    #base_beach_exp{level = 428,timer_add_exp = 10346,vote_add_exp = 51730};

get_exp_cfg(429) ->
    #base_beach_exp{level = 429,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(430) ->
    #base_beach_exp{level = 430,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(431) ->
    #base_beach_exp{level = 431,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(432) ->
    #base_beach_exp{level = 432,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(433) ->
    #base_beach_exp{level = 433,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(434) ->
    #base_beach_exp{level = 434,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(435) ->
    #base_beach_exp{level = 435,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(436) ->
    #base_beach_exp{level = 436,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(437) ->
    #base_beach_exp{level = 437,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(438) ->
    #base_beach_exp{level = 438,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(439) ->
    #base_beach_exp{level = 439,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(440) ->
    #base_beach_exp{level = 440,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(441) ->
    #base_beach_exp{level = 441,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(442) ->
    #base_beach_exp{level = 442,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(443) ->
    #base_beach_exp{level = 443,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(444) ->
    #base_beach_exp{level = 444,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(445) ->
    #base_beach_exp{level = 445,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(446) ->
    #base_beach_exp{level = 446,timer_add_exp = 11664,vote_add_exp = 58320};

get_exp_cfg(447) ->
    #base_beach_exp{level = 447,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(448) ->
    #base_beach_exp{level = 448,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(449) ->
    #base_beach_exp{level = 449,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(450) ->
    #base_beach_exp{level = 450,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(451) ->
    #base_beach_exp{level = 451,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(452) ->
    #base_beach_exp{level = 452,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(453) ->
    #base_beach_exp{level = 453,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(454) ->
    #base_beach_exp{level = 454,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(455) ->
    #base_beach_exp{level = 455,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(456) ->
    #base_beach_exp{level = 456,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(457) ->
    #base_beach_exp{level = 457,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(458) ->
    #base_beach_exp{level = 458,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(459) ->
    #base_beach_exp{level = 459,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(460) ->
    #base_beach_exp{level = 460,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(461) ->
    #base_beach_exp{level = 461,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(462) ->
    #base_beach_exp{level = 462,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(463) ->
    #base_beach_exp{level = 463,timer_add_exp = 13074,vote_add_exp = 65370};

get_exp_cfg(464) ->
    #base_beach_exp{level = 464,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(465) ->
    #base_beach_exp{level = 465,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(466) ->
    #base_beach_exp{level = 466,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(467) ->
    #base_beach_exp{level = 467,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(468) ->
    #base_beach_exp{level = 468,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(469) ->
    #base_beach_exp{level = 469,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(470) ->
    #base_beach_exp{level = 470,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(471) ->
    #base_beach_exp{level = 471,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(472) ->
    #base_beach_exp{level = 472,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(473) ->
    #base_beach_exp{level = 473,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(474) ->
    #base_beach_exp{level = 474,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(475) ->
    #base_beach_exp{level = 475,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(476) ->
    #base_beach_exp{level = 476,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(477) ->
    #base_beach_exp{level = 477,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(478) ->
    #base_beach_exp{level = 478,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(479) ->
    #base_beach_exp{level = 479,timer_add_exp = 11399,vote_add_exp = 56995};

get_exp_cfg(480) ->
    #base_beach_exp{level = 480,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(481) ->
    #base_beach_exp{level = 481,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(482) ->
    #base_beach_exp{level = 482,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(483) ->
    #base_beach_exp{level = 483,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(484) ->
    #base_beach_exp{level = 484,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(485) ->
    #base_beach_exp{level = 485,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(486) ->
    #base_beach_exp{level = 486,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(487) ->
    #base_beach_exp{level = 487,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(488) ->
    #base_beach_exp{level = 488,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(489) ->
    #base_beach_exp{level = 489,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(490) ->
    #base_beach_exp{level = 490,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(491) ->
    #base_beach_exp{level = 491,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(492) ->
    #base_beach_exp{level = 492,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(493) ->
    #base_beach_exp{level = 493,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(494) ->
    #base_beach_exp{level = 494,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(495) ->
    #base_beach_exp{level = 495,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(496) ->
    #base_beach_exp{level = 496,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(497) ->
    #base_beach_exp{level = 497,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(498) ->
    #base_beach_exp{level = 498,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(499) ->
    #base_beach_exp{level = 499,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(500) ->
    #base_beach_exp{level = 500,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(501) ->
    #base_beach_exp{level = 501,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(502) ->
    #base_beach_exp{level = 502,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(503) ->
    #base_beach_exp{level = 503,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(504) ->
    #base_beach_exp{level = 504,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(505) ->
    #base_beach_exp{level = 505,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(506) ->
    #base_beach_exp{level = 506,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(507) ->
    #base_beach_exp{level = 507,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(508) ->
    #base_beach_exp{level = 508,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(509) ->
    #base_beach_exp{level = 509,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(510) ->
    #base_beach_exp{level = 510,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(511) ->
    #base_beach_exp{level = 511,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(512) ->
    #base_beach_exp{level = 512,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(513) ->
    #base_beach_exp{level = 513,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(514) ->
    #base_beach_exp{level = 514,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(515) ->
    #base_beach_exp{level = 515,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(516) ->
    #base_beach_exp{level = 516,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(517) ->
    #base_beach_exp{level = 517,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(518) ->
    #base_beach_exp{level = 518,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(519) ->
    #base_beach_exp{level = 519,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(520) ->
    #base_beach_exp{level = 520,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(521) ->
    #base_beach_exp{level = 521,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(522) ->
    #base_beach_exp{level = 522,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(523) ->
    #base_beach_exp{level = 523,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(524) ->
    #base_beach_exp{level = 524,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(525) ->
    #base_beach_exp{level = 525,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(526) ->
    #base_beach_exp{level = 526,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(527) ->
    #base_beach_exp{level = 527,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(528) ->
    #base_beach_exp{level = 528,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(529) ->
    #base_beach_exp{level = 529,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(530) ->
    #base_beach_exp{level = 530,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(531) ->
    #base_beach_exp{level = 531,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(532) ->
    #base_beach_exp{level = 532,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(533) ->
    #base_beach_exp{level = 533,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(534) ->
    #base_beach_exp{level = 534,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(535) ->
    #base_beach_exp{level = 535,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(536) ->
    #base_beach_exp{level = 536,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(537) ->
    #base_beach_exp{level = 537,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(538) ->
    #base_beach_exp{level = 538,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(539) ->
    #base_beach_exp{level = 539,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(540) ->
    #base_beach_exp{level = 540,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(541) ->
    #base_beach_exp{level = 541,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(542) ->
    #base_beach_exp{level = 542,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(543) ->
    #base_beach_exp{level = 543,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(544) ->
    #base_beach_exp{level = 544,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(545) ->
    #base_beach_exp{level = 545,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(546) ->
    #base_beach_exp{level = 546,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(547) ->
    #base_beach_exp{level = 547,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(548) ->
    #base_beach_exp{level = 548,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(549) ->
    #base_beach_exp{level = 549,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(550) ->
    #base_beach_exp{level = 550,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(551) ->
    #base_beach_exp{level = 551,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(552) ->
    #base_beach_exp{level = 552,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(553) ->
    #base_beach_exp{level = 553,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(554) ->
    #base_beach_exp{level = 554,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(555) ->
    #base_beach_exp{level = 555,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(556) ->
    #base_beach_exp{level = 556,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(557) ->
    #base_beach_exp{level = 557,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(558) ->
    #base_beach_exp{level = 558,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(559) ->
    #base_beach_exp{level = 559,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(560) ->
    #base_beach_exp{level = 560,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(561) ->
    #base_beach_exp{level = 561,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(562) ->
    #base_beach_exp{level = 562,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(563) ->
    #base_beach_exp{level = 563,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(564) ->
    #base_beach_exp{level = 564,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(565) ->
    #base_beach_exp{level = 565,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(566) ->
    #base_beach_exp{level = 566,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(567) ->
    #base_beach_exp{level = 567,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(568) ->
    #base_beach_exp{level = 568,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(569) ->
    #base_beach_exp{level = 569,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(570) ->
    #base_beach_exp{level = 570,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(571) ->
    #base_beach_exp{level = 571,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(572) ->
    #base_beach_exp{level = 572,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(573) ->
    #base_beach_exp{level = 573,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(574) ->
    #base_beach_exp{level = 574,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(575) ->
    #base_beach_exp{level = 575,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(576) ->
    #base_beach_exp{level = 576,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(577) ->
    #base_beach_exp{level = 577,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(578) ->
    #base_beach_exp{level = 578,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(579) ->
    #base_beach_exp{level = 579,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(580) ->
    #base_beach_exp{level = 580,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(581) ->
    #base_beach_exp{level = 581,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(582) ->
    #base_beach_exp{level = 582,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(583) ->
    #base_beach_exp{level = 583,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(584) ->
    #base_beach_exp{level = 584,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(585) ->
    #base_beach_exp{level = 585,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(586) ->
    #base_beach_exp{level = 586,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(587) ->
    #base_beach_exp{level = 587,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(588) ->
    #base_beach_exp{level = 588,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(589) ->
    #base_beach_exp{level = 589,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(590) ->
    #base_beach_exp{level = 590,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(591) ->
    #base_beach_exp{level = 591,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(592) ->
    #base_beach_exp{level = 592,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(593) ->
    #base_beach_exp{level = 593,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(594) ->
    #base_beach_exp{level = 594,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(595) ->
    #base_beach_exp{level = 595,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(596) ->
    #base_beach_exp{level = 596,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(597) ->
    #base_beach_exp{level = 597,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(598) ->
    #base_beach_exp{level = 598,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(599) ->
    #base_beach_exp{level = 599,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(600) ->
    #base_beach_exp{level = 600,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(601) ->
    #base_beach_exp{level = 601,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(602) ->
    #base_beach_exp{level = 602,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(603) ->
    #base_beach_exp{level = 603,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(604) ->
    #base_beach_exp{level = 604,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(605) ->
    #base_beach_exp{level = 605,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(606) ->
    #base_beach_exp{level = 606,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(607) ->
    #base_beach_exp{level = 607,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(608) ->
    #base_beach_exp{level = 608,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(609) ->
    #base_beach_exp{level = 609,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(610) ->
    #base_beach_exp{level = 610,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(611) ->
    #base_beach_exp{level = 611,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(612) ->
    #base_beach_exp{level = 612,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(613) ->
    #base_beach_exp{level = 613,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(614) ->
    #base_beach_exp{level = 614,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(615) ->
    #base_beach_exp{level = 615,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(616) ->
    #base_beach_exp{level = 616,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(617) ->
    #base_beach_exp{level = 617,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(618) ->
    #base_beach_exp{level = 618,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(619) ->
    #base_beach_exp{level = 619,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(620) ->
    #base_beach_exp{level = 620,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(621) ->
    #base_beach_exp{level = 621,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(622) ->
    #base_beach_exp{level = 622,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(623) ->
    #base_beach_exp{level = 623,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(624) ->
    #base_beach_exp{level = 624,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(625) ->
    #base_beach_exp{level = 625,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(626) ->
    #base_beach_exp{level = 626,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(627) ->
    #base_beach_exp{level = 627,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(628) ->
    #base_beach_exp{level = 628,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(629) ->
    #base_beach_exp{level = 629,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(630) ->
    #base_beach_exp{level = 630,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(631) ->
    #base_beach_exp{level = 631,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(632) ->
    #base_beach_exp{level = 632,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(633) ->
    #base_beach_exp{level = 633,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(634) ->
    #base_beach_exp{level = 634,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(635) ->
    #base_beach_exp{level = 635,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(636) ->
    #base_beach_exp{level = 636,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(637) ->
    #base_beach_exp{level = 637,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(638) ->
    #base_beach_exp{level = 638,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(639) ->
    #base_beach_exp{level = 639,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(640) ->
    #base_beach_exp{level = 640,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(641) ->
    #base_beach_exp{level = 641,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(642) ->
    #base_beach_exp{level = 642,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(643) ->
    #base_beach_exp{level = 643,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(644) ->
    #base_beach_exp{level = 644,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(645) ->
    #base_beach_exp{level = 645,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(646) ->
    #base_beach_exp{level = 646,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(647) ->
    #base_beach_exp{level = 647,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(648) ->
    #base_beach_exp{level = 648,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(649) ->
    #base_beach_exp{level = 649,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(650) ->
    #base_beach_exp{level = 650,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(651) ->
    #base_beach_exp{level = 651,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(652) ->
    #base_beach_exp{level = 652,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(653) ->
    #base_beach_exp{level = 653,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(654) ->
    #base_beach_exp{level = 654,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(655) ->
    #base_beach_exp{level = 655,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(656) ->
    #base_beach_exp{level = 656,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(657) ->
    #base_beach_exp{level = 657,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(658) ->
    #base_beach_exp{level = 658,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(659) ->
    #base_beach_exp{level = 659,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(660) ->
    #base_beach_exp{level = 660,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(661) ->
    #base_beach_exp{level = 661,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(662) ->
    #base_beach_exp{level = 662,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(663) ->
    #base_beach_exp{level = 663,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(664) ->
    #base_beach_exp{level = 664,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(665) ->
    #base_beach_exp{level = 665,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(666) ->
    #base_beach_exp{level = 666,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(667) ->
    #base_beach_exp{level = 667,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(668) ->
    #base_beach_exp{level = 668,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(669) ->
    #base_beach_exp{level = 669,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(670) ->
    #base_beach_exp{level = 670,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(671) ->
    #base_beach_exp{level = 671,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(672) ->
    #base_beach_exp{level = 672,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(673) ->
    #base_beach_exp{level = 673,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(674) ->
    #base_beach_exp{level = 674,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(675) ->
    #base_beach_exp{level = 675,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(676) ->
    #base_beach_exp{level = 676,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(677) ->
    #base_beach_exp{level = 677,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(678) ->
    #base_beach_exp{level = 678,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(679) ->
    #base_beach_exp{level = 679,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(680) ->
    #base_beach_exp{level = 680,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(681) ->
    #base_beach_exp{level = 681,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(682) ->
    #base_beach_exp{level = 682,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(683) ->
    #base_beach_exp{level = 683,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(684) ->
    #base_beach_exp{level = 684,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(685) ->
    #base_beach_exp{level = 685,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(686) ->
    #base_beach_exp{level = 686,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(687) ->
    #base_beach_exp{level = 687,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(688) ->
    #base_beach_exp{level = 688,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(689) ->
    #base_beach_exp{level = 689,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(690) ->
    #base_beach_exp{level = 690,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(691) ->
    #base_beach_exp{level = 691,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(692) ->
    #base_beach_exp{level = 692,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(693) ->
    #base_beach_exp{level = 693,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(694) ->
    #base_beach_exp{level = 694,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(695) ->
    #base_beach_exp{level = 695,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(696) ->
    #base_beach_exp{level = 696,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(697) ->
    #base_beach_exp{level = 697,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(698) ->
    #base_beach_exp{level = 698,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(699) ->
    #base_beach_exp{level = 699,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(700) ->
    #base_beach_exp{level = 700,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(701) ->
    #base_beach_exp{level = 701,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(702) ->
    #base_beach_exp{level = 702,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(703) ->
    #base_beach_exp{level = 703,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(704) ->
    #base_beach_exp{level = 704,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(705) ->
    #base_beach_exp{level = 705,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(706) ->
    #base_beach_exp{level = 706,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(707) ->
    #base_beach_exp{level = 707,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(708) ->
    #base_beach_exp{level = 708,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(709) ->
    #base_beach_exp{level = 709,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(710) ->
    #base_beach_exp{level = 710,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(711) ->
    #base_beach_exp{level = 711,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(712) ->
    #base_beach_exp{level = 712,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(713) ->
    #base_beach_exp{level = 713,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(714) ->
    #base_beach_exp{level = 714,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(715) ->
    #base_beach_exp{level = 715,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(716) ->
    #base_beach_exp{level = 716,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(717) ->
    #base_beach_exp{level = 717,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(718) ->
    #base_beach_exp{level = 718,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(719) ->
    #base_beach_exp{level = 719,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(720) ->
    #base_beach_exp{level = 720,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(721) ->
    #base_beach_exp{level = 721,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(722) ->
    #base_beach_exp{level = 722,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(723) ->
    #base_beach_exp{level = 723,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(724) ->
    #base_beach_exp{level = 724,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(725) ->
    #base_beach_exp{level = 725,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(726) ->
    #base_beach_exp{level = 726,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(727) ->
    #base_beach_exp{level = 727,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(728) ->
    #base_beach_exp{level = 728,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(729) ->
    #base_beach_exp{level = 729,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(730) ->
    #base_beach_exp{level = 730,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(731) ->
    #base_beach_exp{level = 731,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(732) ->
    #base_beach_exp{level = 732,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(733) ->
    #base_beach_exp{level = 733,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(734) ->
    #base_beach_exp{level = 734,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(735) ->
    #base_beach_exp{level = 735,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(736) ->
    #base_beach_exp{level = 736,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(737) ->
    #base_beach_exp{level = 737,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(738) ->
    #base_beach_exp{level = 738,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(739) ->
    #base_beach_exp{level = 739,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(740) ->
    #base_beach_exp{level = 740,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(741) ->
    #base_beach_exp{level = 741,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(742) ->
    #base_beach_exp{level = 742,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(743) ->
    #base_beach_exp{level = 743,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(744) ->
    #base_beach_exp{level = 744,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(745) ->
    #base_beach_exp{level = 745,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(746) ->
    #base_beach_exp{level = 746,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(747) ->
    #base_beach_exp{level = 747,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(748) ->
    #base_beach_exp{level = 748,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(749) ->
    #base_beach_exp{level = 749,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(750) ->
    #base_beach_exp{level = 750,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(751) ->
    #base_beach_exp{level = 751,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(752) ->
    #base_beach_exp{level = 752,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(753) ->
    #base_beach_exp{level = 753,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(754) ->
    #base_beach_exp{level = 754,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(755) ->
    #base_beach_exp{level = 755,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(756) ->
    #base_beach_exp{level = 756,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(757) ->
    #base_beach_exp{level = 757,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(758) ->
    #base_beach_exp{level = 758,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(759) ->
    #base_beach_exp{level = 759,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(760) ->
    #base_beach_exp{level = 760,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(761) ->
    #base_beach_exp{level = 761,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(762) ->
    #base_beach_exp{level = 762,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(763) ->
    #base_beach_exp{level = 763,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(764) ->
    #base_beach_exp{level = 764,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(765) ->
    #base_beach_exp{level = 765,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(766) ->
    #base_beach_exp{level = 766,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(767) ->
    #base_beach_exp{level = 767,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(768) ->
    #base_beach_exp{level = 768,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(769) ->
    #base_beach_exp{level = 769,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(770) ->
    #base_beach_exp{level = 770,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(771) ->
    #base_beach_exp{level = 771,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(772) ->
    #base_beach_exp{level = 772,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(773) ->
    #base_beach_exp{level = 773,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(774) ->
    #base_beach_exp{level = 774,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(775) ->
    #base_beach_exp{level = 775,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(776) ->
    #base_beach_exp{level = 776,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(777) ->
    #base_beach_exp{level = 777,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(778) ->
    #base_beach_exp{level = 778,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(779) ->
    #base_beach_exp{level = 779,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(780) ->
    #base_beach_exp{level = 780,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(781) ->
    #base_beach_exp{level = 781,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(782) ->
    #base_beach_exp{level = 782,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(783) ->
    #base_beach_exp{level = 783,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(784) ->
    #base_beach_exp{level = 784,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(785) ->
    #base_beach_exp{level = 785,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(786) ->
    #base_beach_exp{level = 786,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(787) ->
    #base_beach_exp{level = 787,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(788) ->
    #base_beach_exp{level = 788,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(789) ->
    #base_beach_exp{level = 789,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(790) ->
    #base_beach_exp{level = 790,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(791) ->
    #base_beach_exp{level = 791,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(792) ->
    #base_beach_exp{level = 792,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(793) ->
    #base_beach_exp{level = 793,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(794) ->
    #base_beach_exp{level = 794,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(795) ->
    #base_beach_exp{level = 795,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(796) ->
    #base_beach_exp{level = 796,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(797) ->
    #base_beach_exp{level = 797,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(798) ->
    #base_beach_exp{level = 798,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(799) ->
    #base_beach_exp{level = 799,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(800) ->
    #base_beach_exp{level = 800,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(801) ->
    #base_beach_exp{level = 801,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(802) ->
    #base_beach_exp{level = 802,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(803) ->
    #base_beach_exp{level = 803,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(804) ->
    #base_beach_exp{level = 804,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(805) ->
    #base_beach_exp{level = 805,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(806) ->
    #base_beach_exp{level = 806,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(807) ->
    #base_beach_exp{level = 807,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(808) ->
    #base_beach_exp{level = 808,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(809) ->
    #base_beach_exp{level = 809,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(810) ->
    #base_beach_exp{level = 810,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(811) ->
    #base_beach_exp{level = 811,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(812) ->
    #base_beach_exp{level = 812,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(813) ->
    #base_beach_exp{level = 813,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(814) ->
    #base_beach_exp{level = 814,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(815) ->
    #base_beach_exp{level = 815,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(816) ->
    #base_beach_exp{level = 816,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(817) ->
    #base_beach_exp{level = 817,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(818) ->
    #base_beach_exp{level = 818,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(819) ->
    #base_beach_exp{level = 819,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(820) ->
    #base_beach_exp{level = 820,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(821) ->
    #base_beach_exp{level = 821,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(822) ->
    #base_beach_exp{level = 822,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(823) ->
    #base_beach_exp{level = 823,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(824) ->
    #base_beach_exp{level = 824,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(825) ->
    #base_beach_exp{level = 825,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(826) ->
    #base_beach_exp{level = 826,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(827) ->
    #base_beach_exp{level = 827,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(828) ->
    #base_beach_exp{level = 828,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(829) ->
    #base_beach_exp{level = 829,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(830) ->
    #base_beach_exp{level = 830,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(831) ->
    #base_beach_exp{level = 831,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(832) ->
    #base_beach_exp{level = 832,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(833) ->
    #base_beach_exp{level = 833,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(834) ->
    #base_beach_exp{level = 834,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(835) ->
    #base_beach_exp{level = 835,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(836) ->
    #base_beach_exp{level = 836,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(837) ->
    #base_beach_exp{level = 837,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(838) ->
    #base_beach_exp{level = 838,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(839) ->
    #base_beach_exp{level = 839,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(840) ->
    #base_beach_exp{level = 840,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(841) ->
    #base_beach_exp{level = 841,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(842) ->
    #base_beach_exp{level = 842,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(843) ->
    #base_beach_exp{level = 843,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(844) ->
    #base_beach_exp{level = 844,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(845) ->
    #base_beach_exp{level = 845,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(846) ->
    #base_beach_exp{level = 846,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(847) ->
    #base_beach_exp{level = 847,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(848) ->
    #base_beach_exp{level = 848,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(849) ->
    #base_beach_exp{level = 849,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(850) ->
    #base_beach_exp{level = 850,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(851) ->
    #base_beach_exp{level = 851,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(852) ->
    #base_beach_exp{level = 852,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(853) ->
    #base_beach_exp{level = 853,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(854) ->
    #base_beach_exp{level = 854,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(855) ->
    #base_beach_exp{level = 855,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(856) ->
    #base_beach_exp{level = 856,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(857) ->
    #base_beach_exp{level = 857,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(858) ->
    #base_beach_exp{level = 858,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(859) ->
    #base_beach_exp{level = 859,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(860) ->
    #base_beach_exp{level = 860,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(861) ->
    #base_beach_exp{level = 861,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(862) ->
    #base_beach_exp{level = 862,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(863) ->
    #base_beach_exp{level = 863,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(864) ->
    #base_beach_exp{level = 864,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(865) ->
    #base_beach_exp{level = 865,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(866) ->
    #base_beach_exp{level = 866,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(867) ->
    #base_beach_exp{level = 867,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(868) ->
    #base_beach_exp{level = 868,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(869) ->
    #base_beach_exp{level = 869,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(870) ->
    #base_beach_exp{level = 870,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(871) ->
    #base_beach_exp{level = 871,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(872) ->
    #base_beach_exp{level = 872,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(873) ->
    #base_beach_exp{level = 873,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(874) ->
    #base_beach_exp{level = 874,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(875) ->
    #base_beach_exp{level = 875,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(876) ->
    #base_beach_exp{level = 876,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(877) ->
    #base_beach_exp{level = 877,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(878) ->
    #base_beach_exp{level = 878,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(879) ->
    #base_beach_exp{level = 879,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(880) ->
    #base_beach_exp{level = 880,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(881) ->
    #base_beach_exp{level = 881,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(882) ->
    #base_beach_exp{level = 882,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(883) ->
    #base_beach_exp{level = 883,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(884) ->
    #base_beach_exp{level = 884,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(885) ->
    #base_beach_exp{level = 885,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(886) ->
    #base_beach_exp{level = 886,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(887) ->
    #base_beach_exp{level = 887,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(888) ->
    #base_beach_exp{level = 888,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(889) ->
    #base_beach_exp{level = 889,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(890) ->
    #base_beach_exp{level = 890,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(891) ->
    #base_beach_exp{level = 891,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(892) ->
    #base_beach_exp{level = 892,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(893) ->
    #base_beach_exp{level = 893,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(894) ->
    #base_beach_exp{level = 894,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(895) ->
    #base_beach_exp{level = 895,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(896) ->
    #base_beach_exp{level = 896,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(897) ->
    #base_beach_exp{level = 897,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(898) ->
    #base_beach_exp{level = 898,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(899) ->
    #base_beach_exp{level = 899,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(900) ->
    #base_beach_exp{level = 900,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(901) ->
    #base_beach_exp{level = 901,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(902) ->
    #base_beach_exp{level = 902,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(903) ->
    #base_beach_exp{level = 903,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(904) ->
    #base_beach_exp{level = 904,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(905) ->
    #base_beach_exp{level = 905,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(906) ->
    #base_beach_exp{level = 906,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(907) ->
    #base_beach_exp{level = 907,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(908) ->
    #base_beach_exp{level = 908,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(909) ->
    #base_beach_exp{level = 909,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(910) ->
    #base_beach_exp{level = 910,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(911) ->
    #base_beach_exp{level = 911,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(912) ->
    #base_beach_exp{level = 912,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(913) ->
    #base_beach_exp{level = 913,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(914) ->
    #base_beach_exp{level = 914,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(915) ->
    #base_beach_exp{level = 915,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(916) ->
    #base_beach_exp{level = 916,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(917) ->
    #base_beach_exp{level = 917,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(918) ->
    #base_beach_exp{level = 918,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(919) ->
    #base_beach_exp{level = 919,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(920) ->
    #base_beach_exp{level = 920,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(921) ->
    #base_beach_exp{level = 921,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(922) ->
    #base_beach_exp{level = 922,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(923) ->
    #base_beach_exp{level = 923,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(924) ->
    #base_beach_exp{level = 924,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(925) ->
    #base_beach_exp{level = 925,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(926) ->
    #base_beach_exp{level = 926,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(927) ->
    #base_beach_exp{level = 927,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(928) ->
    #base_beach_exp{level = 928,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(929) ->
    #base_beach_exp{level = 929,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(930) ->
    #base_beach_exp{level = 930,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(931) ->
    #base_beach_exp{level = 931,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(932) ->
    #base_beach_exp{level = 932,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(933) ->
    #base_beach_exp{level = 933,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(934) ->
    #base_beach_exp{level = 934,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(935) ->
    #base_beach_exp{level = 935,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(936) ->
    #base_beach_exp{level = 936,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(937) ->
    #base_beach_exp{level = 937,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(938) ->
    #base_beach_exp{level = 938,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(939) ->
    #base_beach_exp{level = 939,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(940) ->
    #base_beach_exp{level = 940,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(941) ->
    #base_beach_exp{level = 941,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(942) ->
    #base_beach_exp{level = 942,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(943) ->
    #base_beach_exp{level = 943,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(944) ->
    #base_beach_exp{level = 944,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(945) ->
    #base_beach_exp{level = 945,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(946) ->
    #base_beach_exp{level = 946,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(947) ->
    #base_beach_exp{level = 947,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(948) ->
    #base_beach_exp{level = 948,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(949) ->
    #base_beach_exp{level = 949,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(950) ->
    #base_beach_exp{level = 950,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(951) ->
    #base_beach_exp{level = 951,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(952) ->
    #base_beach_exp{level = 952,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(953) ->
    #base_beach_exp{level = 953,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(954) ->
    #base_beach_exp{level = 954,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(955) ->
    #base_beach_exp{level = 955,timer_add_exp = 9608,vote_add_exp = 48040};

get_exp_cfg(_Level) ->
    [].

get_dummy_cfg(1) ->
    #base_beach_dummy{id = 1,sex = 2,location = {1995,2479},model = [{1,2000},{3,2000}],fashion_model = [{1,14,1},{2,2015,1},{3,1017,1},{5,14,1}],name = "魅力舞者"};

get_dummy_cfg(2) ->
    #base_beach_dummy{id = 2,sex = 1,location = {2210,2269},model = [{1,2000},{3,1000}],fashion_model = [{1,14,1},{2,2015,1},{3,1017,1},{5,14,1}],name = "魅力舞者"};

get_dummy_cfg(3) ->
    #base_beach_dummy{id = 3,sex = 3,location = {2414,2062},model = [{1,2000},{3,1000}],fashion_model = [{1,14,1},{2,2015,1},{3,1017,1},{5,14,1}],name = "魅力舞者"};

get_dummy_cfg(4) ->
    #base_beach_dummy{id = 4,sex = 4,location = {2615,1865},model = [{1,2000},{3,2000}],fashion_model = [{1,14,1},{2,2015,1},{3,1017,1},{5,14,1}],name = "魅力舞者"};

get_dummy_cfg(_Id) ->
    [].

get_all_dummy() ->
    [1,2,3,4].

get_beach_voice(1) ->
    #base_beach_voice{type = 1,cd = 0,base_id = 1};

get_beach_voice(2) ->
    #base_beach_voice{type = 2,cd = 300,base_id = 2};

get_beach_voice(_Type) ->
    [].

get_beach_voice_content(1,101) ->
    #base_beach_voice_content{base_id = 1,content_id = 101,content = <<"嘿嘿，我就是这个舞池的KING!"/utf8>>};

get_beach_voice_content(1,102) ->
    #base_beach_voice_content{base_id = 1,content_id = 102,content = <<"哈哈，榜一是我的啦！"/utf8>>};

get_beach_voice_content(1,103) ->
    #base_beach_voice_content{base_id = 1,content_id = 103,content = <<"感谢大家的投票！"/utf8>>};

get_beach_voice_content(2,201) ->
    #base_beach_voice_content{base_id = 2,content_id = 201,content = <<"<color@2><@player></color>giegie,我给你投票，你女朋友不会骂我吧？"/utf8>>};

get_beach_voice_content(2,202) ->
    #base_beach_voice_content{base_id = 2,content_id = 202,content = <<"<color@2><@player></color>铁汁，给你投票了，记得回票哦！"/utf8>>};

get_beach_voice_content(2,203) ->
    #base_beach_voice_content{base_id = 2,content_id = 203,content = <<"快跟我一起为<color@2><@player></color>打CALL!"/utf8>>};

get_beach_voice_content(_Baseid,_Contentid) ->
    [].

