%%%---------------------------------------
%%% module      : data_convoy
%%% description : 护送配置
%%%
%%%---------------------------------------
-module(data_convoy).
-compile(export_all).
-include("convoy.hrl").



%%非双倍时间双倍完成消耗
get_convoy_kv(convoy_double_cost) ->
    [{2,100001,20}];

%%[本服]护送终点
get_convoy_kv(convoy_end) ->
    [{1006,7281,5025}];

%%[跨服]护送终点
get_convoy_kv(convoy_end_kf) ->
    [{1017,7281,5025}];

%%[本服]护送传送门到下一场景
get_convoy_kv(convoy_fly) ->
    [{1003,18356,10294}];

%%[跨服]护送传送门到下一场景
get_convoy_kv(convoy_fly_kf) ->
    [{1016,18356,10294}];

%%护送对象随机权重
get_convoy_kv(convoy_object_weight) ->
    [{4500,1001},{4500,1002},{500,1003}];

%%护送时间限制（秒）
get_convoy_kv(convoy_overtime) ->
    300;

%%第二段pk护送场景ID
get_convoy_kv(convoy_pk_scene) ->
    [1006, 1017];

%%第一段主城护送场景ID
get_convoy_kv(convoy_safe_scene) ->
    [1003, 1016];

%%[本服]护送起始点（NPC接取任务）
get_convoy_kv(convoy_start) ->
    [{1003,10589,7833}];

%%[跨服]护送起始点（NPC接取任务）
get_convoy_kv(convoy_start_kf) ->
    [{1016,10589,7833}];

%%提升品质失败随机获得祝福值
get_convoy_kv(convoy_up_num) ->
    [5,5];

%%每日护送次数
get_convoy_kv(daily_convy_times) ->
    3;

get_convoy_kv(_Keycontent) ->
    [].

get_convoy_object(1001) ->
    #base_convoy_object{id = 1001,name = <<"普通外送"/utf8>>,upgrade_cost = [{0,102009,1}],next_id = 1002,award = [],stage_one_ratio = 70,overdue_ratio = 60,up_next_val = 10,up_next_weight = 8000};

get_convoy_object(1002) ->
    #base_convoy_object{id = 1002,name = <<"精致外送"/utf8>>,upgrade_cost = [{0,102009,2}],next_id = 1003,award = [],stage_one_ratio = 76,overdue_ratio = 60,up_next_val = 10,up_next_weight = 7000};

get_convoy_object(1003) ->
    #base_convoy_object{id = 1003,name = <<"稀有外送"/utf8>>,upgrade_cost = [{0,102009,3}],next_id = 1004,award = [],stage_one_ratio = 100,overdue_ratio = 60,up_next_val = 10,up_next_weight = 6500};

get_convoy_object(1004) ->
    #base_convoy_object{id = 1004,name = <<"豪华外送"/utf8>>,upgrade_cost = [],next_id = 0,award = [{2,100001,60}],stage_one_ratio = 120,overdue_ratio = 60,up_next_val = 0,up_next_weight = 0};

get_convoy_object(_Id) ->
    [].

get_top_convoy() -> 1004.

get_convoy_exp(Lv) when Lv >= 1  andalso  Lv =< 80 ->
		[120833,24167];
get_convoy_exp(Lv) when Lv >= 81  andalso  Lv =< 81 ->
		[125000,25000];
get_convoy_exp(Lv) when Lv >= 82  andalso  Lv =< 82 ->
		[125000,25000];
get_convoy_exp(Lv) when Lv >= 83  andalso  Lv =< 83 ->
		[131250,26250];
get_convoy_exp(Lv) when Lv >= 84  andalso  Lv =< 84 ->
		[131250,26250];
get_convoy_exp(Lv) when Lv >= 85  andalso  Lv =< 85 ->
		[137500,27500];
get_convoy_exp(Lv) when Lv >= 86  andalso  Lv =< 86 ->
		[137500,27500];
get_convoy_exp(Lv) when Lv >= 87  andalso  Lv =< 87 ->
		[141667,28333];
get_convoy_exp(Lv) when Lv >= 88  andalso  Lv =< 88 ->
		[141667,28333];
get_convoy_exp(Lv) when Lv >= 89  andalso  Lv =< 89 ->
		[145833,29167];
get_convoy_exp(Lv) when Lv >= 90  andalso  Lv =< 90 ->
		[145833,29167];
get_convoy_exp(Lv) when Lv >= 91  andalso  Lv =< 91 ->
		[152083,30417];
get_convoy_exp(Lv) when Lv >= 92  andalso  Lv =< 92 ->
		[152083,30417];
get_convoy_exp(Lv) when Lv >= 93  andalso  Lv =< 93 ->
		[156250,31250];
get_convoy_exp(Lv) when Lv >= 94  andalso  Lv =< 94 ->
		[156250,31250];
get_convoy_exp(Lv) when Lv >= 95  andalso  Lv =< 95 ->
		[214583,42917];
get_convoy_exp(Lv) when Lv >= 96  andalso  Lv =< 96 ->
		[214583,42917];
get_convoy_exp(Lv) when Lv >= 97  andalso  Lv =< 97 ->
		[214583,42917];
get_convoy_exp(Lv) when Lv >= 98  andalso  Lv =< 98 ->
		[382340,76468];
get_convoy_exp(Lv) when Lv >= 99  andalso  Lv =< 99 ->
		[384995,76999];
get_convoy_exp(Lv) when Lv >= 100  andalso  Lv =< 100 ->
		[328017,77530];
get_convoy_exp(Lv) when Lv >= 101  andalso  Lv =< 101 ->
		[328100,78061];
get_convoy_exp(Lv) when Lv >= 102  andalso  Lv =< 102 ->
		[328263,78592];
get_convoy_exp(Lv) when Lv >= 103  andalso  Lv =< 103 ->
		[328595,79123];
get_convoy_exp(Lv) when Lv >= 104  andalso  Lv =< 104 ->
		[328927,79654];
get_convoy_exp(Lv) when Lv >= 105  andalso  Lv =< 105 ->
		[329258,80185];
get_convoy_exp(Lv) when Lv >= 106  andalso  Lv =< 106 ->
		[329589,80716];
get_convoy_exp(Lv) when Lv >= 107  andalso  Lv =< 107 ->
		[329921,81247];
get_convoy_exp(Lv) when Lv >= 108  andalso  Lv =< 108 ->
		[330252,81778];
get_convoy_exp(Lv) when Lv >= 109  andalso  Lv =< 109 ->
		[330584,82309];
get_convoy_exp(Lv) when Lv >= 110  andalso  Lv =< 110 ->
		[330916,82841];
get_convoy_exp(Lv) when Lv >= 111  andalso  Lv =< 111 ->
		[331247,83372];
get_convoy_exp(Lv) when Lv >= 112  andalso  Lv =< 112 ->
		[331579,83903];
get_convoy_exp(Lv) when Lv >= 113  andalso  Lv =< 113 ->
		[331911,84434];
get_convoy_exp(Lv) when Lv >= 114  andalso  Lv =< 114 ->
		[332242,84965];
get_convoy_exp(Lv) when Lv >= 115  andalso  Lv =< 115 ->
		[332574,85496];
get_convoy_exp(Lv) when Lv >= 116  andalso  Lv =< 116 ->
		[332905,86027];
get_convoy_exp(Lv) when Lv >= 117  andalso  Lv =< 117 ->
		[333236,86558];
get_convoy_exp(Lv) when Lv >= 118  andalso  Lv =< 118 ->
		[333568,87089];
get_convoy_exp(Lv) when Lv >= 119  andalso  Lv =< 119 ->
		[333900,87620];
get_convoy_exp(Lv) when Lv >= 120  andalso  Lv =< 120 ->
		[334231,88151];
get_convoy_exp(Lv) when Lv >= 121  andalso  Lv =< 121 ->
		[334563,88682];
get_convoy_exp(Lv) when Lv >= 122  andalso  Lv =< 122 ->
		[334895,89213];
get_convoy_exp(Lv) when Lv >= 123  andalso  Lv =< 123 ->
		[243285,89744];
get_convoy_exp(Lv) when Lv >= 124  andalso  Lv =< 124 ->
		[243530,90275];
get_convoy_exp(Lv) when Lv >= 125  andalso  Lv =< 125 ->
		[243775,90806];
get_convoy_exp(Lv) when Lv >= 126  andalso  Lv =< 126 ->
		[244020,91337];
get_convoy_exp(Lv) when Lv >= 127  andalso  Lv =< 127 ->
		[244265,91868];
get_convoy_exp(Lv) when Lv >= 128  andalso  Lv =< 128 ->
		[244510,92399];
get_convoy_exp(Lv) when Lv >= 129  andalso  Lv =< 129 ->
		[244755,92930];
get_convoy_exp(Lv) when Lv >= 130  andalso  Lv =< 130 ->
		[246715,99022];
get_convoy_exp(Lv) when Lv >= 131  andalso  Lv =< 131 ->
		[245245,100686];
get_convoy_exp(Lv) when Lv >= 132  andalso  Lv =< 132 ->
		[245490,103348];
get_convoy_exp(Lv) when Lv >= 133  andalso  Lv =< 133 ->
		[245735,104013];
get_convoy_exp(Lv) when Lv >= 134  andalso  Lv =< 134 ->
		[245980,105344];
get_convoy_exp(Lv) when Lv >= 135  andalso  Lv =< 135 ->
		[246225,105677];
get_convoy_exp(Lv) when Lv >= 136  andalso  Lv =< 136 ->
		[246470,106010];
get_convoy_exp(Lv) when Lv >= 137  andalso  Lv =< 137 ->
		[253894,106343];
get_convoy_exp(Lv) when Lv >= 138  andalso  Lv =< 138 ->
		[254150,106343];
get_convoy_exp(Lv) when Lv >= 139  andalso  Lv =< 139 ->
		[254407,106343];
get_convoy_exp(Lv) when Lv >= 140  andalso  Lv =< 140 ->
		[254663,106343];
get_convoy_exp(Lv) when Lv >= 141  andalso  Lv =< 141 ->
		[254919,106343];
get_convoy_exp(Lv) when Lv >= 142  andalso  Lv =< 142 ->
		[255175,106675];
get_convoy_exp(Lv) when Lv >= 143  andalso  Lv =< 143 ->
		[255431,106675];
get_convoy_exp(Lv) when Lv >= 144  andalso  Lv =< 144 ->
		[255688,106675];
get_convoy_exp(Lv) when Lv >= 145  andalso  Lv =< 145 ->
		[255944,106675];
get_convoy_exp(Lv) when Lv >= 146  andalso  Lv =< 146 ->
		[256456,106675];
get_convoy_exp(Lv) when Lv >= 147  andalso  Lv =< 147 ->
		[256456,106675];
get_convoy_exp(Lv) when Lv >= 148  andalso  Lv =< 148 ->
		[256712,107008];
get_convoy_exp(Lv) when Lv >= 149  andalso  Lv =< 149 ->
		[256969,107008];
get_convoy_exp(Lv) when Lv >= 150  andalso  Lv =< 150 ->
		[257225,107008];
get_convoy_exp(Lv) when Lv >= 151  andalso  Lv =< 151 ->
		[257481,107008];
get_convoy_exp(Lv) when Lv >= 152  andalso  Lv =< 152 ->
		[257737,107008];
get_convoy_exp(Lv) when Lv >= 153  andalso  Lv =< 153 ->
		[257993,107008];
get_convoy_exp(Lv) when Lv >= 154  andalso  Lv =< 154 ->
		[258250,107008];
get_convoy_exp(Lv) when Lv >= 155  andalso  Lv =< 155 ->
		[258506,107008];
get_convoy_exp(Lv) when Lv >= 156  andalso  Lv =< 156 ->
		[279149,107008];
get_convoy_exp(Lv) when Lv >= 157  andalso  Lv =< 157 ->
		[279430,107008];
get_convoy_exp(Lv) when Lv >= 158  andalso  Lv =< 158 ->
		[279712,104906];
get_convoy_exp(Lv) when Lv >= 159  andalso  Lv =< 159 ->
		[279993,105502];
get_convoy_exp(Lv) when Lv >= 160  andalso  Lv =< 160 ->
		[280274,106098];
get_convoy_exp(Lv) when Lv >= 161  andalso  Lv =< 161 ->
		[280556,106695];
get_convoy_exp(Lv) when Lv >= 162  andalso  Lv =< 162 ->
		[280837,107291];
get_convoy_exp(Lv) when Lv >= 163  andalso  Lv =< 163 ->
		[281119,107887];
get_convoy_exp(Lv) when Lv >= 164  andalso  Lv =< 164 ->
		[281400,108597];
get_convoy_exp(Lv) when Lv >= 165  andalso  Lv =< 165 ->
		[281681,109307];
get_convoy_exp(Lv) when Lv >= 166  andalso  Lv =< 166 ->
		[281963,110016];
get_convoy_exp(Lv) when Lv >= 167  andalso  Lv =< 167 ->
		[282244,110726];
get_convoy_exp(Lv) when Lv >= 168  andalso  Lv =< 168 ->
		[282526,111436];
get_convoy_exp(Lv) when Lv >= 169  andalso  Lv =< 169 ->
		[282807,112146];
get_convoy_exp(Lv) when Lv >= 170  andalso  Lv =< 170 ->
		[283088,112856];
get_convoy_exp(Lv) when Lv >= 171  andalso  Lv =< 171 ->
		[283370,113565];
get_convoy_exp(Lv) when Lv >= 172  andalso  Lv =< 172 ->
		[283651,114275];
get_convoy_exp(Lv) when Lv >= 173  andalso  Lv =< 173 ->
		[291247,114985];
get_convoy_exp(Lv) when Lv >= 174  andalso  Lv =< 174 ->
		[291540,115695];
get_convoy_exp(Lv) when Lv >= 175  andalso  Lv =< 175 ->
		[291834,116405];
get_convoy_exp(Lv) when Lv >= 176  andalso  Lv =< 176 ->
		[292127,117114];
get_convoy_exp(Lv) when Lv >= 177  andalso  Lv =< 177 ->
		[292420,117824];
get_convoy_exp(Lv) when Lv >= 178  andalso  Lv =< 178 ->
		[292713,118534];
get_convoy_exp(Lv) when Lv >= 179  andalso  Lv =< 179 ->
		[293007,119244];
get_convoy_exp(Lv) when Lv >= 180  andalso  Lv =< 180 ->
		[293300,119953];
get_convoy_exp(Lv) when Lv >= 181  andalso  Lv =< 181 ->
		[293593,120663];
get_convoy_exp(Lv) when Lv >= 182  andalso  Lv =< 182 ->
		[293887,121373];
get_convoy_exp(Lv) when Lv >= 183  andalso  Lv =< 183 ->
		[294180,122083];
get_convoy_exp(Lv) when Lv >= 184  andalso  Lv =< 184 ->
		[294473,112948];
get_convoy_exp(Lv) when Lv >= 185  andalso  Lv =< 185 ->
		[294767,113576];
get_convoy_exp(Lv) when Lv >= 186  andalso  Lv =< 186 ->
		[295060,114323];
get_convoy_exp(Lv) when Lv >= 187  andalso  Lv =< 187 ->
		[295353,115070];
get_convoy_exp(Lv) when Lv >= 188  andalso  Lv =< 188 ->
		[317285,115818];
get_convoy_exp(Lv) when Lv >= 189  andalso  Lv =< 189 ->
		[317604,116565];
get_convoy_exp(Lv) when Lv >= 190  andalso  Lv =< 190 ->
		[317923,117312];
get_convoy_exp(Lv) when Lv >= 191  andalso  Lv =< 191 ->
		[318242,118059];
get_convoy_exp(Lv) when Lv >= 192  andalso  Lv =< 192 ->
		[318562,118806];
get_convoy_exp(Lv) when Lv >= 193  andalso  Lv =< 193 ->
		[318881,119554];
get_convoy_exp(Lv) when Lv >= 194  andalso  Lv =< 194 ->
		[319200,120301];
get_convoy_exp(Lv) when Lv >= 195  andalso  Lv =< 195 ->
		[319519,121048];
get_convoy_exp(Lv) when Lv >= 196  andalso  Lv =< 196 ->
		[319838,121795];
get_convoy_exp(Lv) when Lv >= 197  andalso  Lv =< 197 ->
		[320158,122543];
get_convoy_exp(Lv) when Lv >= 198  andalso  Lv =< 198 ->
		[320477,123290];
get_convoy_exp(Lv) when Lv >= 199  andalso  Lv =< 199 ->
		[320796,124037];
get_convoy_exp(Lv) when Lv >= 200  andalso  Lv =< 200 ->
		[321115,124784];
get_convoy_exp(Lv) when Lv >= 201  andalso  Lv =< 201 ->
		[329809,125531];
get_convoy_exp(Lv) when Lv >= 202  andalso  Lv =< 202 ->
		[330141,120192];
get_convoy_exp(Lv) when Lv >= 203  andalso  Lv =< 203 ->
		[330473,121741];
get_convoy_exp(Lv) when Lv >= 204  andalso  Lv =< 204 ->
		[330805,122532];
get_convoy_exp(Lv) when Lv >= 205  andalso  Lv =< 205 ->
		[331136,123322];
get_convoy_exp(Lv) when Lv >= 206  andalso  Lv =< 206 ->
		[331468,124113];
get_convoy_exp(Lv) when Lv >= 207  andalso  Lv =< 207 ->
		[333791,124903];
get_convoy_exp(Lv) when Lv >= 208  andalso  Lv =< 208 ->
		[332132,125694];
get_convoy_exp(Lv) when Lv >= 209  andalso  Lv =< 209 ->
		[332464,126484];
get_convoy_exp(Lv) when Lv >= 210  andalso  Lv =< 210 ->
		[332795,127275];
get_convoy_exp(Lv) when Lv >= 211  andalso  Lv =< 211 ->
		[333127,128065];
get_convoy_exp(Lv) when Lv >= 212  andalso  Lv =< 212 ->
		[333459,128856];
get_convoy_exp(Lv) when Lv >= 213  andalso  Lv =< 213 ->
		[356966,129646];
get_convoy_exp(Lv) when Lv >= 214  andalso  Lv =< 214 ->
		[357325,130437];
get_convoy_exp(Lv) when Lv >= 215  andalso  Lv =< 215 ->
		[357683,131228];
get_convoy_exp(Lv) when Lv >= 216  andalso  Lv =< 216 ->
		[358042,132018];
get_convoy_exp(Lv) when Lv >= 217  andalso  Lv =< 217 ->
		[358400,132809];
get_convoy_exp(Lv) when Lv >= 218  andalso  Lv =< 218 ->
		[358758,133886];
get_convoy_exp(Lv) when Lv >= 219  andalso  Lv =< 219 ->
		[359117,134750];
get_convoy_exp(Lv) when Lv >= 220  andalso  Lv =< 220 ->
		[359475,135614];
get_convoy_exp(Lv) when Lv >= 221  andalso  Lv =< 221 ->
		[359834,136478];
get_convoy_exp(Lv) when Lv >= 222  andalso  Lv =< 222 ->
		[370213,137342];
get_convoy_exp(Lv) when Lv >= 223  andalso  Lv =< 223 ->
		[370585,138205];
get_convoy_exp(Lv) when Lv >= 224  andalso  Lv =< 224 ->
		[370957,139069];
get_convoy_exp(Lv) when Lv >= 225  andalso  Lv =< 225 ->
		[371328,139933];
get_convoy_exp(Lv) when Lv >= 226  andalso  Lv =< 226 ->
		[372072,140797];
get_convoy_exp(Lv) when Lv >= 227  andalso  Lv =< 227 ->
		[372443,141661];
get_convoy_exp(Lv) when Lv >= 228  andalso  Lv =< 228 ->
		[372815,142524];
get_convoy_exp(Lv) when Lv >= 229  andalso  Lv =< 229 ->
		[373187,143388];
get_convoy_exp(Lv) when Lv >= 230  andalso  Lv =< 230 ->
		[397404,140257];
get_convoy_exp(Lv) when Lv >= 231  andalso  Lv =< 231 ->
		[397803,141162];
get_convoy_exp(Lv) when Lv >= 232  andalso  Lv =< 232 ->
		[398202,142067];
get_convoy_exp(Lv) when Lv >= 233  andalso  Lv =< 233 ->
		[398601,142972];
get_convoy_exp(Lv) when Lv >= 234  andalso  Lv =< 234 ->
		[399399,143877];
get_convoy_exp(Lv) when Lv >= 235  andalso  Lv =< 235 ->
		[399798,144782];
get_convoy_exp(Lv) when Lv >= 236  andalso  Lv =< 236 ->
		[400197,145687];
get_convoy_exp(Lv) when Lv >= 237  andalso  Lv =< 237 ->
		[400596,146591];
get_convoy_exp(Lv) when Lv >= 238  andalso  Lv =< 238 ->
		[411761,147496];
get_convoy_exp(Lv) when Lv >= 239  andalso  Lv =< 239 ->
		[412174,148401];
get_convoy_exp(Lv) when Lv >= 240  andalso  Lv =< 240 ->
		[412587,149306];
get_convoy_exp(Lv) when Lv >= 241  andalso  Lv =< 241 ->
		[413000,147893];
get_convoy_exp(Lv) when Lv >= 242  andalso  Lv =< 242 ->
		[413413,148847];
get_convoy_exp(Lv) when Lv >= 243  andalso  Lv =< 243 ->
		[413826,149802];
get_convoy_exp(Lv) when Lv >= 244  andalso  Lv =< 244 ->
		[414239,150756];
get_convoy_exp(Lv) when Lv >= 245  andalso  Lv =< 245 ->
		[439677,151710];
get_convoy_exp(Lv) when Lv >= 246  andalso  Lv =< 246 ->
		[440118,152664];
get_convoy_exp(Lv) when Lv >= 247  andalso  Lv =< 247 ->
		[440559,153618];
get_convoy_exp(Lv) when Lv >= 248  andalso  Lv =< 248 ->
		[441000,154572];
get_convoy_exp(Lv) when Lv >= 249  andalso  Lv =< 249 ->
		[441441,155526];
get_convoy_exp(Lv) when Lv >= 250  andalso  Lv =< 250 ->
		[441882,156481];
get_convoy_exp(Lv) when Lv >= 251  andalso  Lv =< 251 ->
		[442323,152757];
get_convoy_exp(Lv) when Lv >= 252  andalso  Lv =< 252 ->
		[454333,153737];
get_convoy_exp(Lv) when Lv >= 253  andalso  Lv =< 253 ->
		[454789,154716];
get_convoy_exp(Lv) when Lv >= 254  andalso  Lv =< 254 ->
		[455244,155695];
get_convoy_exp(Lv) when Lv >= 255  andalso  Lv =< 255 ->
		[456156,156674];
get_convoy_exp(Lv) when Lv >= 256  andalso  Lv =< 256 ->
		[456611,157654];
get_convoy_exp(Lv) when Lv >= 257  andalso  Lv =< 257 ->
		[457067,158633];
get_convoy_exp(Lv) when Lv >= 258  andalso  Lv =< 258 ->
		[482947,159612];
get_convoy_exp(Lv) when Lv >= 259  andalso  Lv =< 259 ->
		[483431,160591];
get_convoy_exp(Lv) when Lv >= 260  andalso  Lv =< 260 ->
		[483916,157153];
get_convoy_exp(Lv) when Lv >= 261  andalso  Lv =< 261 ->
		[484884,158160];
get_convoy_exp(Lv) when Lv >= 262  andalso  Lv =< 262 ->
		[485369,159168];
get_convoy_exp(Lv) when Lv >= 263  andalso  Lv =< 263 ->
		[485853,160175];
get_convoy_exp(Lv) when Lv >= 264  andalso  Lv =< 264 ->
		[498301,161183];
get_convoy_exp(Lv) when Lv >= 265  andalso  Lv =< 265 ->
		[498800,162190];
get_convoy_exp(Lv) when Lv >= 266  andalso  Lv =< 266 ->
		[499300,163197];
get_convoy_exp(Lv) when Lv >= 267  andalso  Lv =< 267 ->
		[499800,164205];
get_convoy_exp(Lv) when Lv >= 268  andalso  Lv =< 268 ->
		[500300,165212];
get_convoy_exp(Lv) when Lv >= 269  andalso  Lv =< 269 ->
		[500800,161298];
get_convoy_exp(Lv) when Lv >= 270  andalso  Lv =< 270 ->
		[501299,162332];
get_convoy_exp(Lv) when Lv >= 271  andalso  Lv =< 271 ->
		[527612,163366];
get_convoy_exp(Lv) when Lv >= 272  andalso  Lv =< 272 ->
		[528142,164400];
get_convoy_exp(Lv) when Lv >= 273  andalso  Lv =< 273 ->
		[528671,165434];
get_convoy_exp(Lv) when Lv >= 274  andalso  Lv =< 274 ->
		[529729,166468];
get_convoy_exp(Lv) when Lv >= 275  andalso  Lv =< 275 ->
		[530258,167502];
get_convoy_exp(Lv) when Lv >= 276  andalso  Lv =< 276 ->
		[530788,168536];
get_convoy_exp(Lv) when Lv >= 277  andalso  Lv =< 277 ->
		[543664,169570];
get_convoy_exp(Lv) when Lv >= 278  andalso  Lv =< 278 ->
		[544209,174745];
get_convoy_exp(Lv) when Lv >= 279  andalso  Lv =< 279 ->
		[544755,175865];
get_convoy_exp(Lv) when Lv >= 280  andalso  Lv =< 280 ->
		[545845,176985];
get_convoy_exp(Lv) when Lv >= 281  andalso  Lv =< 281 ->
		[546391,178105];
get_convoy_exp(Lv) when Lv >= 282  andalso  Lv =< 282 ->
		[546936,179226];
get_convoy_exp(Lv) when Lv >= 283  andalso  Lv =< 283 ->
		[573674,180346];
get_convoy_exp(Lv) when Lv >= 284  andalso  Lv =< 284 ->
		[574249,181466];
get_convoy_exp(Lv) when Lv >= 285  andalso  Lv =< 285 ->
		[574825,182586];
get_convoy_exp(Lv) when Lv >= 286  andalso  Lv =< 286 ->
		[575400,183706];
get_convoy_exp(Lv) when Lv >= 287  andalso  Lv =< 287 ->
		[575975,177532];
get_convoy_exp(Lv) when Lv >= 288  andalso  Lv =< 288 ->
		[576551,178670];
get_convoy_exp(Lv) when Lv >= 289  andalso  Lv =< 289 ->
		[577126,179808];
get_convoy_exp(Lv) when Lv >= 290  andalso  Lv =< 290 ->
		[590423,180946];
get_convoy_exp(Lv) when Lv >= 291  andalso  Lv =< 291 ->
		[591016,182084];
get_convoy_exp(Lv) when Lv >= 292  andalso  Lv =< 292 ->
		[591608,183222];
get_convoy_exp(Lv) when Lv >= 293  andalso  Lv =< 293 ->
		[592792,184360];
get_convoy_exp(Lv) when Lv >= 294  andalso  Lv =< 294 ->
		[593384,185498];
get_convoy_exp(Lv) when Lv >= 295  andalso  Lv =< 295 ->
		[593977,186636];
get_convoy_exp(Lv) when Lv >= 296  andalso  Lv =< 296 ->
		[621754,186939];
get_convoy_exp(Lv) when Lv >= 297  andalso  Lv =< 297 ->
		[622377,188137];
get_convoy_exp(Lv) when Lv >= 298  andalso  Lv =< 298 ->
		[623000,189335];
get_convoy_exp(Lv) when Lv >= 299  andalso  Lv =< 299 ->
		[623623,190534];
get_convoy_exp(Lv) when Lv >= 300  andalso  Lv =< 300 ->
		[624246,191732];
get_convoy_exp(Lv) when Lv >= 301  andalso  Lv =< 301 ->
		[638579,192930];
get_convoy_exp(Lv) when Lv >= 302  andalso  Lv =< 302 ->
		[718580,194129];
get_convoy_exp(Lv) when Lv >= 303  andalso  Lv =< 303 ->
		[719300,195327];
get_convoy_exp(Lv) when Lv >= 304  andalso  Lv =< 304 ->
		[720020,196241];
get_convoy_exp(Lv) when Lv >= 305  andalso  Lv =< 305 ->
		[720740,196291];
get_convoy_exp(Lv) when Lv >= 306  andalso  Lv =< 306 ->
		[721460,197542];
get_convoy_exp(Lv) when Lv >= 307  andalso  Lv =< 307 ->
		[722180,198792];
get_convoy_exp(Lv) when Lv >= 308  andalso  Lv =< 308 ->
		[720020,200042];
get_convoy_exp(Lv) when Lv >= 309  andalso  Lv =< 309 ->
		[720020,201293];
get_convoy_exp(Lv) when Lv >= 310  andalso  Lv =< 310 ->
		[720020,202543];
get_convoy_exp(Lv) when Lv >= 311  andalso  Lv =< 311 ->
		[720020,203793];
get_convoy_exp(Lv) when Lv >= 312  andalso  Lv =< 312 ->
		[720020,195462];
get_convoy_exp(Lv) when Lv >= 313  andalso  Lv =< 313 ->
		[720020,195512];
get_convoy_exp(Lv) when Lv >= 314  andalso  Lv =< 314 ->
		[720020,196757];
get_convoy_exp(Lv) when Lv >= 315  andalso  Lv =< 315 ->
		[720020,198002];
get_convoy_exp(Lv) when Lv >= 316  andalso  Lv =< 316 ->
		[720020,199248];
get_convoy_exp(Lv) when Lv >= 317  andalso  Lv =< 317 ->
		[720020,200493];
get_convoy_exp(Lv) when Lv >= 318  andalso  Lv =< 318 ->
		[720020,201738];
get_convoy_exp(Lv) when Lv >= 319  andalso  Lv =< 319 ->
		[720020,202984];
get_convoy_exp(Lv) when Lv >= 320  andalso  Lv =< 320 ->
		[720020,203566];
get_convoy_exp(Lv) when Lv >= 321  andalso  Lv =< 321 ->
		[720020,203618];
get_convoy_exp(Lv) when Lv >= 322  andalso  Lv =< 322 ->
		[720020,204914];
get_convoy_exp(Lv) when Lv >= 323  andalso  Lv =< 323 ->
		[720020,206211];
get_convoy_exp(Lv) when Lv >= 324  andalso  Lv =< 324 ->
		[720020,207508];
get_convoy_exp(Lv) when Lv >= 325  andalso  Lv =< 325 ->
		[720020,208805];
get_convoy_exp(Lv) when Lv >= 326  andalso  Lv =< 326 ->
		[720020,210102];
get_convoy_exp(Lv) when Lv >= 327  andalso  Lv =< 327 ->
		[720020,211399];
get_convoy_exp(Lv) when Lv >= 328  andalso  Lv =< 328 ->
		[720020,212391];
get_convoy_exp(Lv) when Lv >= 329  andalso  Lv =< 329 ->
		[720020,212445];
get_convoy_exp(Lv) when Lv >= 330  andalso  Lv =< 330 ->
		[850780,213798];
get_convoy_exp(Lv) when Lv >= 331  andalso  Lv =< 331 ->
		[850780,215151];
get_convoy_exp(Lv) when Lv >= 332  andalso  Lv =< 332 ->
		[850780,216505];
get_convoy_exp(Lv) when Lv >= 333  andalso  Lv =< 333 ->
		[850780,217858];
get_convoy_exp(Lv) when Lv >= 334  andalso  Lv =< 334 ->
		[850780,219211];
get_convoy_exp(Lv) when Lv >= 335  andalso  Lv =< 335 ->
		[850780,220564];
get_convoy_exp(Lv) when Lv >= 336  andalso  Lv =< 336 ->
		[850780,220970];
get_convoy_exp(Lv) when Lv >= 337  andalso  Lv =< 337 ->
		[850780,221026];
get_convoy_exp(Lv) when Lv >= 338  andalso  Lv =< 338 ->
		[850780,222434];
get_convoy_exp(Lv) when Lv >= 339  andalso  Lv =< 339 ->
		[850780,223842];
get_convoy_exp(Lv) when Lv >= 340  andalso  Lv =< 340 ->
		[850780,225250];
get_convoy_exp(Lv) when Lv >= 341  andalso  Lv =< 341 ->
		[850780,226657];
get_convoy_exp(Lv) when Lv >= 342  andalso  Lv =< 342 ->
		[850780,228065];
get_convoy_exp(Lv) when Lv >= 343  andalso  Lv =< 343 ->
		[850780,229473];
get_convoy_exp(Lv) when Lv >= 344  andalso  Lv =< 344 ->
		[850780,229618];
get_convoy_exp(Lv) when Lv >= 345  andalso  Lv =< 345 ->
		[850780,231081];
get_convoy_exp(Lv) when Lv >= 346  andalso  Lv =< 346 ->
		[850780,232543];
get_convoy_exp(Lv) when Lv >= 347  andalso  Lv =< 347 ->
		[850780,234006];
get_convoy_exp(Lv) when Lv >= 348  andalso  Lv =< 348 ->
		[850780,235469];
get_convoy_exp(Lv) when Lv >= 349  andalso  Lv =< 349 ->
		[850780,236931];
get_convoy_exp(Lv) when Lv >= 350  andalso  Lv =< 350 ->
		[850780,238394];
get_convoy_exp(Lv) when Lv >= 351  andalso  Lv =< 351 ->
		[850780,238154];
get_convoy_exp(Lv) when Lv >= 352  andalso  Lv =< 352 ->
		[850780,239671];
get_convoy_exp(Lv) when Lv >= 353  andalso  Lv =< 353 ->
		[850780,241188];
get_convoy_exp(Lv) when Lv >= 354  andalso  Lv =< 354 ->
		[850780,242705];
get_convoy_exp(Lv) when Lv >= 355  andalso  Lv =< 355 ->
		[850780,244222];
get_convoy_exp(Lv) when Lv >= 356  andalso  Lv =< 356 ->
		[993020,245739];
get_convoy_exp(Lv) when Lv >= 357  andalso  Lv =< 357 ->
		[993020,247256];
get_convoy_exp(Lv) when Lv >= 358  andalso  Lv =< 358 ->
		[993020,250974];
get_convoy_exp(Lv) when Lv >= 359  andalso  Lv =< 359 ->
		[993020,252573];
get_convoy_exp(Lv) when Lv >= 360  andalso  Lv =< 360 ->
		[993020,254171];
get_convoy_exp(Lv) when Lv >= 361  andalso  Lv =< 361 ->
		[993020,255770];
get_convoy_exp(Lv) when Lv >= 362  andalso  Lv =< 362 ->
		[993020,257369];
get_convoy_exp(Lv) when Lv >= 363  andalso  Lv =< 363 ->
		[993020,258967];
get_convoy_exp(Lv) when Lv >= 364  andalso  Lv =< 364 ->
		[993020,260566];
get_convoy_exp(Lv) when Lv >= 365  andalso  Lv =< 365 ->
		[993020,253970];
get_convoy_exp(Lv) when Lv >= 366  andalso  Lv =< 366 ->
		[993020,255587];
get_convoy_exp(Lv) when Lv >= 367  andalso  Lv =< 367 ->
		[993020,257205];
get_convoy_exp(Lv) when Lv >= 368  andalso  Lv =< 368 ->
		[993020,258823];
get_convoy_exp(Lv) when Lv >= 369  andalso  Lv =< 369 ->
		[993020,260440];
get_convoy_exp(Lv) when Lv >= 370  andalso  Lv =< 370 ->
		[993020,262058];
get_convoy_exp(Lv) when Lv >= 371  andalso  Lv =< 371 ->
		[993020,263676];
get_convoy_exp(Lv) when Lv >= 372  andalso  Lv =< 372 ->
		[993020,259666];
get_convoy_exp(Lv) when Lv >= 373  andalso  Lv =< 373 ->
		[993020,261320];
get_convoy_exp(Lv) when Lv >= 374  andalso  Lv =< 374 ->
		[993020,262974];
get_convoy_exp(Lv) when Lv >= 375  andalso  Lv =< 375 ->
		[993020,264628];
get_convoy_exp(Lv) when Lv >= 376  andalso  Lv =< 376 ->
		[993020,266282];
get_convoy_exp(Lv) when Lv >= 377  andalso  Lv =< 377 ->
		[993020,267936];
get_convoy_exp(Lv) when Lv >= 378  andalso  Lv =< 378 ->
		[993020,269589];
get_convoy_exp(Lv) when Lv >= 379  andalso  Lv =< 379 ->
		[993020,251802];
get_convoy_exp(Lv) when Lv >= 380  andalso  Lv =< 380 ->
		[993020,253406];
get_convoy_exp(Lv) when Lv >= 381  andalso  Lv =< 381 ->
		[993020,255009];
get_convoy_exp(Lv) when Lv >= 382  andalso  Lv =< 382 ->
		[1141280,256613];
get_convoy_exp(Lv) when Lv >= 383  andalso  Lv =< 383 ->
		[1141280,258217];
get_convoy_exp(Lv) when Lv >= 384  andalso  Lv =< 384 ->
		[1141280,259821];
get_convoy_exp(Lv) when Lv >= 385  andalso  Lv =< 385 ->
		[1141280,261425];
get_convoy_exp(Lv) when Lv >= 386  andalso  Lv =< 386 ->
		[1141280,260387];
get_convoy_exp(Lv) when Lv >= 387  andalso  Lv =< 387 ->
		[1141280,262046];
get_convoy_exp(Lv) when Lv >= 388  andalso  Lv =< 388 ->
		[1141280,263704];
get_convoy_exp(Lv) when Lv >= 389  andalso  Lv =< 389 ->
		[1141280,265363];
get_convoy_exp(Lv) when Lv >= 390  andalso  Lv =< 390 ->
		[1141280,267022];
get_convoy_exp(Lv) when Lv >= 391  andalso  Lv =< 391 ->
		[1141280,268680];
get_convoy_exp(Lv) when Lv >= 392  andalso  Lv =< 392 ->
		[1141280,270339];
get_convoy_exp(Lv) when Lv >= 393  andalso  Lv =< 393 ->
		[1141280,273187];
get_convoy_exp(Lv) when Lv >= 394  andalso  Lv =< 394 ->
		[1141280,274927];
get_convoy_exp(Lv) when Lv >= 395  andalso  Lv =< 395 ->
		[1141280,276667];
get_convoy_exp(Lv) when Lv >= 396  andalso  Lv =< 396 ->
		[1141280,278407];
get_convoy_exp(Lv) when Lv >= 397  andalso  Lv =< 397 ->
		[1141280,280147];
get_convoy_exp(Lv) when Lv >= 398  andalso  Lv =< 398 ->
		[1141280,281887];
get_convoy_exp(Lv) when Lv >= 399  andalso  Lv =< 399 ->
		[1141280,283627];
get_convoy_exp(Lv) when Lv >= 400  andalso  Lv =< 400 ->
		[1141280,280401];
get_convoy_exp(Lv) when Lv >= 401  andalso  Lv =< 401 ->
		[1141280,282187];
get_convoy_exp(Lv) when Lv >= 402  andalso  Lv =< 402 ->
		[1141280,283973];
get_convoy_exp(Lv) when Lv >= 403  andalso  Lv =< 403 ->
		[1141280,285759];
get_convoy_exp(Lv) when Lv >= 404  andalso  Lv =< 404 ->
		[1141280,287545];
get_convoy_exp(Lv) when Lv >= 405  andalso  Lv =< 405 ->
		[1141280,289331];
get_convoy_exp(Lv) when Lv >= 406  andalso  Lv =< 406 ->
		[1141280,291117];
get_convoy_exp(Lv) when Lv >= 407  andalso  Lv =< 407 ->
		[1301020,288933];
get_convoy_exp(Lv) when Lv >= 408  andalso  Lv =< 408 ->
		[1301020,290773];
get_convoy_exp(Lv) when Lv >= 409  andalso  Lv =< 409 ->
		[1301020,292613];
get_convoy_exp(Lv) when Lv >= 410  andalso  Lv =< 410 ->
		[1301020,294454];
get_convoy_exp(Lv) when Lv >= 411  andalso  Lv =< 411 ->
		[1301020,296294];
get_convoy_exp(Lv) when Lv >= 412  andalso  Lv =< 412 ->
		[1301020,298134];
get_convoy_exp(Lv) when Lv >= 413  andalso  Lv =< 413 ->
		[1301020,299975];
get_convoy_exp(Lv) when Lv >= 414  andalso  Lv =< 414 ->
		[1301020,297536];
get_convoy_exp(Lv) when Lv >= 415  andalso  Lv =< 415 ->
		[1301020,299431];
get_convoy_exp(Lv) when Lv >= 416  andalso  Lv =< 416 ->
		[1301020,301327];
get_convoy_exp(Lv) when Lv >= 417  andalso  Lv =< 417 ->
		[1301020,303222];
get_convoy_exp(Lv) when Lv >= 418  andalso  Lv =< 418 ->
		[1301020,305117];
get_convoy_exp(Lv) when Lv >= 419  andalso  Lv =< 419 ->
		[1301020,307012];
get_convoy_exp(Lv) when Lv >= 420  andalso  Lv =< 420 ->
		[1301020,308907];
get_convoy_exp(Lv) when Lv >= 421  andalso  Lv =< 421 ->
		[1301020,343451];
get_convoy_exp(Lv) when Lv >= 422  andalso  Lv =< 422 ->
		[1301020,345639];
get_convoy_exp(Lv) when Lv >= 423  andalso  Lv =< 423 ->
		[1301020,347826];
get_convoy_exp(Lv) when Lv >= 424  andalso  Lv =< 424 ->
		[1301020,350014];
get_convoy_exp(Lv) when Lv >= 425  andalso  Lv =< 425 ->
		[1301020,352202];
get_convoy_exp(Lv) when Lv >= 426  andalso  Lv =< 426 ->
		[1301020,354389];
get_convoy_exp(Lv) when Lv >= 427  andalso  Lv =< 427 ->
		[1301020,356577];
get_convoy_exp(Lv) when Lv >= 428  andalso  Lv =< 428 ->
		[1301020,350594];
get_convoy_exp(Lv) when Lv >= 429  andalso  Lv =< 429 ->
		[1466780,352813];
get_convoy_exp(Lv) when Lv >= 430  andalso  Lv =< 430 ->
		[1466780,355032];
get_convoy_exp(Lv) when Lv >= 431  andalso  Lv =< 431 ->
		[1466780,357251];
get_convoy_exp(Lv) when Lv >= 432  andalso  Lv =< 432 ->
		[1466780,359470];
get_convoy_exp(Lv) when Lv >= 433  andalso  Lv =< 433 ->
		[1466780,360623];
get_convoy_exp(Lv) when Lv >= 434  andalso  Lv =< 434 ->
		[1466780,361553];
get_convoy_exp(Lv) when Lv >= 435  andalso  Lv =< 435 ->
		[1466780,363842];
get_convoy_exp(Lv) when Lv >= 436  andalso  Lv =< 436 ->
		[1466780,366130];
get_convoy_exp(Lv) when Lv >= 437  andalso  Lv =< 437 ->
		[1466780,368418];
get_convoy_exp(Lv) when Lv >= 438  andalso  Lv =< 438 ->
		[1466780,370707];
get_convoy_exp(Lv) when Lv >= 439  andalso  Lv =< 439 ->
		[1466780,371897];
get_convoy_exp(Lv) when Lv >= 440  andalso  Lv =< 440 ->
		[1466780,366554];
get_convoy_exp(Lv) when Lv >= 441  andalso  Lv =< 441 ->
		[1466780,368874];
get_convoy_exp(Lv) when Lv >= 442  andalso  Lv =< 442 ->
		[1466780,371194];
get_convoy_exp(Lv) when Lv >= 443  andalso  Lv =< 443 ->
		[1466780,373514];
get_convoy_exp(Lv) when Lv >= 444  andalso  Lv =< 444 ->
		[1466780,375834];
get_convoy_exp(Lv) when Lv >= 445  andalso  Lv =< 445 ->
		[1466780,377040];
get_convoy_exp(Lv) when Lv >= 446  andalso  Lv =< 446 ->
		[1466780,377454];
get_convoy_exp(Lv) when Lv >= 447  andalso  Lv =< 447 ->
		[1644020,379843];
get_convoy_exp(Lv) when Lv >= 448  andalso  Lv =< 448 ->
		[1644020,382232];
get_convoy_exp(Lv) when Lv >= 449  andalso  Lv =< 449 ->
		[1644020,384621];
get_convoy_exp(Lv) when Lv >= 450  andalso  Lv =< 450 ->
		[1644020,387010];
get_convoy_exp(Lv) when Lv >= 451  andalso  Lv =< 451 ->
		[1644020,388252];
get_convoy_exp(Lv) when Lv >= 452  andalso  Lv =< 452 ->
		[1644020,382470];
get_convoy_exp(Lv) when Lv >= 453  andalso  Lv =< 453 ->
		[1644020,384891];
get_convoy_exp(Lv) when Lv >= 454  andalso  Lv =< 454 ->
		[1644020,387312];
get_convoy_exp(Lv) when Lv >= 455  andalso  Lv =< 455 ->
		[1644020,389732];
get_convoy_exp(Lv) when Lv >= 456  andalso  Lv =< 456 ->
		[1644020,392153];
get_convoy_exp(Lv) when Lv >= 457  andalso  Lv =< 457 ->
		[1644020,393412];
get_convoy_exp(Lv) when Lv >= 458  andalso  Lv =< 458 ->
		[1644020,393416];
get_convoy_exp(Lv) when Lv >= 459  andalso  Lv =< 459 ->
		[1644020,395906];
get_convoy_exp(Lv) when Lv >= 460  andalso  Lv =< 460 ->
		[1644020,398396];
get_convoy_exp(Lv) when Lv >= 461  andalso  Lv =< 461 ->
		[1644020,400886];
get_convoy_exp(Lv) when Lv >= 462  andalso  Lv =< 462 ->
		[1644020,403376];
get_convoy_exp(Lv) when Lv >= 463  andalso  Lv =< 463 ->
		[1644020,404671];
get_convoy_exp(Lv) when Lv >= 464  andalso  Lv =< 464 ->
		[1433460,398387];
get_convoy_exp(Lv) when Lv >= 465  andalso  Lv =< 465 ->
		[1433460,400909];
get_convoy_exp(Lv) when Lv >= 466  andalso  Lv =< 466 ->
		[1433460,403430];
get_convoy_exp(Lv) when Lv >= 467  andalso  Lv =< 467 ->
		[1433460,405952];
get_convoy_exp(Lv) when Lv >= 468  andalso  Lv =< 468 ->
		[1433460,408473];
get_convoy_exp(Lv) when Lv >= 469  andalso  Lv =< 469 ->
		[1433460,409784];
get_convoy_exp(Lv) when Lv >= 470  andalso  Lv =< 470 ->
		[1433460,409334];
get_convoy_exp(Lv) when Lv >= 471  andalso  Lv =< 471 ->
		[1433460,411925];
get_convoy_exp(Lv) when Lv >= 472  andalso  Lv =< 472 ->
		[1433460,414515];
get_convoy_exp(Lv) when Lv >= 473  andalso  Lv =< 473 ->
		[1433460,417106];
get_convoy_exp(Lv) when Lv >= 474  andalso  Lv =< 474 ->
		[1433460,419697];
get_convoy_exp(Lv) when Lv >= 475  andalso  Lv =< 475 ->
		[1433460,421044];
get_convoy_exp(Lv) when Lv >= 476  andalso  Lv =< 476 ->
		[1433460,414290];
get_convoy_exp(Lv) when Lv >= 477  andalso  Lv =< 477 ->
		[1433460,416913];
get_convoy_exp(Lv) when Lv >= 478  andalso  Lv =< 478 ->
		[1433460,419535];
get_convoy_exp(Lv) when Lv >= 479  andalso  Lv =< 479 ->
		[1433460,422157];
get_convoy_exp(Lv) when Lv >= 480  andalso  Lv =< 480 ->
		[1208200,424779];
get_convoy_exp(Lv) when Lv >= 481  andalso  Lv =< 481 ->
		[1208200,426142];
get_convoy_exp(Lv) when Lv >= 482  andalso  Lv =< 482 ->
		[1208200,425252];
get_convoy_exp(Lv) when Lv >= 483  andalso  Lv =< 483 ->
		[1208200,427944];
get_convoy_exp(Lv) when Lv >= 484  andalso  Lv =< 484 ->
		[1208200,430635];
get_convoy_exp(Lv) when Lv >= 485  andalso  Lv =< 485 ->
		[1208200,433327];
get_convoy_exp(Lv) when Lv >= 486  andalso  Lv =< 486 ->
		[1208200,436018];
get_convoy_exp(Lv) when Lv >= 487  andalso  Lv =< 487 ->
		[1208200,437418];
get_convoy_exp(Lv) when Lv >= 488  andalso  Lv =< 488 ->
		[1208200,430255];
get_convoy_exp(Lv) when Lv >= 489  andalso  Lv =< 489 ->
		[1208200,432978];
get_convoy_exp(Lv) when Lv >= 490  andalso  Lv =< 490 ->
		[1208200,435701];
get_convoy_exp(Lv) when Lv >= 491  andalso  Lv =< 491 ->
		[1208200,438424];
get_convoy_exp(Lv) when Lv >= 492  andalso  Lv =< 492 ->
		[1208200,441147];
get_convoy_exp(Lv) when Lv >= 493  andalso  Lv =< 493 ->
		[1208200,442563];
get_convoy_exp(Lv) when Lv >= 494  andalso  Lv =< 494 ->
		[1208200,441157];
get_convoy_exp(Lv) when Lv >= 495  andalso  Lv =< 495 ->
		[1208200,443949];
get_convoy_exp(Lv) when Lv >= 496  andalso  Lv =< 496 ->
		[1208200,446741];
get_convoy_exp(Lv) when Lv >= 497  andalso  Lv =< 497 ->
		[1208200,449533];
get_convoy_exp(Lv) when Lv >= 498  andalso  Lv =< 498 ->
		[1208200,452325];
get_convoy_exp(Lv) when Lv >= 499  andalso  Lv =< 499 ->
		[1208200,446174];
get_convoy_exp(Lv) when Lv >= 500  andalso  Lv =< 500 ->
		[1208200,448998];
get_convoy_exp(Lv) when Lv >= 501  andalso  Lv =< 501 ->
		[1208200,451822];
get_convoy_exp(Lv) when Lv >= 502  andalso  Lv =< 502 ->
		[1208200,454646];
get_convoy_exp(Lv) when Lv >= 503  andalso  Lv =< 503 ->
		[1208200,457470];
get_convoy_exp(Lv) when Lv >= 504  andalso  Lv =< 504 ->
		[1208200,452515];
get_convoy_exp(Lv) when Lv >= 505  andalso  Lv =< 505 ->
		[1208200,455379];
get_convoy_exp(Lv) when Lv >= 506  andalso  Lv =< 506 ->
		[1208200,458243];
get_convoy_exp(Lv) when Lv >= 507  andalso  Lv =< 507 ->
		[1208200,461107];
get_convoy_exp(Lv) when Lv >= 508  andalso  Lv =< 508 ->
		[1208200,463971];
get_convoy_exp(Lv) when Lv >= 509  andalso  Lv =< 509 ->
		[1208200,830805];
get_convoy_exp(Lv) when Lv >= 510  andalso  Lv =< 510 ->
		[1208200,836064];
get_convoy_exp(Lv) when Lv >= 511  andalso  Lv =< 511 ->
		[1208200,841322];
get_convoy_exp(Lv) when Lv >= 512  andalso  Lv =< 512 ->
		[1208200,846580];
get_convoy_exp(Lv) when Lv >= 513  andalso  Lv =< 513 ->
		[1208200,851839];
get_convoy_exp(Lv) when Lv >= 514  andalso  Lv =< 514 ->
		[1208200,839325];
get_convoy_exp(Lv) when Lv >= 515  andalso  Lv =< 515 ->
		[1208200,844638];
get_convoy_exp(Lv) when Lv >= 516  andalso  Lv =< 516 ->
		[1208200,849950];
get_convoy_exp(Lv) when Lv >= 517  andalso  Lv =< 517 ->
		[1208200,855262];
get_convoy_exp(Lv) when Lv >= 518  andalso  Lv =< 518 ->
		[1208200,860575];
get_convoy_exp(Lv) when Lv >= 519  andalso  Lv =< 519 ->
		[1208200,850286];
get_convoy_exp(Lv) when Lv >= 520  andalso  Lv =< 520 ->
		[1208200,855667];
get_convoy_exp(Lv) when Lv >= 521  andalso  Lv =< 521 ->
		[1208200,861049];
get_convoy_exp(Lv) when Lv >= 522  andalso  Lv =< 522 ->
		[1208200,866431];
get_convoy_exp(Lv) when Lv >= 523  andalso  Lv =< 523 ->
		[1208200,883083];
get_convoy_exp(Lv) when Lv >= 524  andalso  Lv =< 524 ->
		[1208200,784961];
get_convoy_exp(Lv) when Lv >= 525  andalso  Lv =< 525 ->
		[1208200,790412];
get_convoy_exp(Lv) when Lv >= 526  andalso  Lv =< 526 ->
		[1208200,795864];
get_convoy_exp(Lv) when Lv >= 527  andalso  Lv =< 527 ->
		[1208200,796715];
get_convoy_exp(Lv) when Lv >= 528  andalso  Lv =< 528 ->
		[1208200,802135];
get_convoy_exp(Lv) when Lv >= 529  andalso  Lv =< 529 ->
		[1208200,807555];
get_convoy_exp(Lv) when Lv >= 530  andalso  Lv =< 530 ->
		[1208200,812975];
get_convoy_exp(Lv) when Lv >= 531  andalso  Lv =< 531 ->
		[1208200,818395];
get_convoy_exp(Lv) when Lv >= 532  andalso  Lv =< 532 ->
		[1208200,823814];
get_convoy_exp(Lv) when Lv >= 533  andalso  Lv =< 533 ->
		[1208200,829234];
get_convoy_exp(Lv) when Lv >= 534  andalso  Lv =< 534 ->
		[1208200,834654];
get_convoy_exp(Lv) when Lv >= 535  andalso  Lv =< 535 ->
		[1208200,840074];
get_convoy_exp(Lv) when Lv >= 536  andalso  Lv =< 536 ->
		[1208200,845494];
get_convoy_exp(Lv) when Lv >= 537  andalso  Lv =< 537 ->
		[1208200,850914];
get_convoy_exp(Lv) when Lv >= 538  andalso  Lv =< 538 ->
		[1208200,856334];
get_convoy_exp(Lv) when Lv >= 539  andalso  Lv =< 539 ->
		[1208200,861754];
get_convoy_exp(Lv) when Lv >= 540  andalso  Lv =< 540 ->
		[1208200,867174];
get_convoy_exp(Lv) when Lv >= 541  andalso  Lv =< 541 ->
		[1208200,872594];
get_convoy_exp(Lv) when Lv >= 542  andalso  Lv =< 542 ->
		[1208200,878013];
get_convoy_exp(Lv) when Lv >= 543  andalso  Lv =< 543 ->
		[1208200,883433];
get_convoy_exp(Lv) when Lv >= 544  andalso  Lv =< 544 ->
		[1208200,888853];
get_convoy_exp(Lv) when Lv >= 545  andalso  Lv =< 545 ->
		[1208200,894273];
get_convoy_exp(Lv) when Lv >= 546  andalso  Lv =< 546 ->
		[1208200,899693];
get_convoy_exp(Lv) when Lv >= 547  andalso  Lv =< 547 ->
		[1208200,905113];
get_convoy_exp(Lv) when Lv >= 548  andalso  Lv =< 548 ->
		[1208200,910533];
get_convoy_exp(Lv) when Lv >= 549  andalso  Lv =< 549 ->
		[1208200,915953];
get_convoy_exp(Lv) when Lv >= 550  andalso  Lv =< 550 ->
		[1208200,921373];
get_convoy_exp(Lv) when Lv >= 551  andalso  Lv =< 551 ->
		[1208200,926793];
get_convoy_exp(Lv) when Lv >= 552  andalso  Lv =< 552 ->
		[1208200,932212];
get_convoy_exp(Lv) when Lv >= 553  andalso  Lv =< 553 ->
		[1208200,937632];
get_convoy_exp(Lv) when Lv >= 554  andalso  Lv =< 554 ->
		[1208200,943052];
get_convoy_exp(Lv) when Lv >= 555  andalso  Lv =< 555 ->
		[1208200,948472];
get_convoy_exp(Lv) when Lv >= 556  andalso  Lv =< 556 ->
		[1208200,953892];
get_convoy_exp(Lv) when Lv >= 557  andalso  Lv =< 557 ->
		[1208200,959312];
get_convoy_exp(Lv) when Lv >= 558  andalso  Lv =< 558 ->
		[1208200,964732];
get_convoy_exp(Lv) when Lv >= 559  andalso  Lv =< 559 ->
		[1208200,970152];
get_convoy_exp(Lv) when Lv >= 560  andalso  Lv =< 560 ->
		[1208200,758775];
get_convoy_exp(Lv) when Lv >= 561  andalso  Lv =< 561 ->
		[1208200,760943];
get_convoy_exp(Lv) when Lv >= 562  andalso  Lv =< 562 ->
		[1208200,763111];
get_convoy_exp(Lv) when Lv >= 563  andalso  Lv =< 563 ->
		[1208200,765279];
get_convoy_exp(Lv) when Lv >= 564  andalso  Lv =< 564 ->
		[1208200,767447];
get_convoy_exp(Lv) when Lv >= 565  andalso  Lv =< 565 ->
		[1208200,769615];
get_convoy_exp(Lv) when Lv >= 566  andalso  Lv =< 566 ->
		[1208200,771783];
get_convoy_exp(Lv) when Lv >= 567  andalso  Lv =< 567 ->
		[1208200,773951];
get_convoy_exp(Lv) when Lv >= 568  andalso  Lv =< 568 ->
		[1208200,776119];
get_convoy_exp(Lv) when Lv >= 569  andalso  Lv =< 569 ->
		[1208200,778287];
get_convoy_exp(Lv) when Lv >= 570  andalso  Lv =< 570 ->
		[1208200,780455];
get_convoy_exp(Lv) when Lv >= 571  andalso  Lv =< 571 ->
		[1208200,782623];
get_convoy_exp(Lv) when Lv >= 572  andalso  Lv =< 572 ->
		[1208200,791295];
get_convoy_exp(Lv) when Lv >= 573  andalso  Lv =< 573 ->
		[1208200,796715];
get_convoy_exp(Lv) when Lv >= 574  andalso  Lv =< 574 ->
		[1208200,799425];
get_convoy_exp(Lv) when Lv >= 575  andalso  Lv =< 575 ->
		[1208200,802135];
get_convoy_exp(Lv) when Lv >= 576  andalso  Lv =< 576 ->
		[1208200,804845];
get_convoy_exp(Lv) when Lv >= 577  andalso  Lv =< 577 ->
		[1208200,807555];
get_convoy_exp(Lv) when Lv >= 578  andalso  Lv =< 578 ->
		[1208200,810265];
get_convoy_exp(Lv) when Lv >= 579  andalso  Lv =< 579 ->
		[1208200,812975];
get_convoy_exp(Lv) when Lv >= 580  andalso  Lv =< 580 ->
		[1208200,815685];
get_convoy_exp(Lv) when Lv >= 581  andalso  Lv =< 581 ->
		[1208200,818395];
get_convoy_exp(Lv) when Lv >= 582  andalso  Lv =< 582 ->
		[1208200,821104];
get_convoy_exp(Lv) when Lv >= 583  andalso  Lv =< 583 ->
		[1208200,823814];
get_convoy_exp(Lv) when Lv >= 584  andalso  Lv =< 584 ->
		[1208200,826524];
get_convoy_exp(Lv) when Lv >= 585  andalso  Lv =< 585 ->
		[1208200,829234];
get_convoy_exp(Lv) when Lv >= 586  andalso  Lv =< 586 ->
		[1208200,831944];
get_convoy_exp(Lv) when Lv >= 587  andalso  Lv =< 587 ->
		[1208200,834654];
get_convoy_exp(Lv) when Lv >= 588  andalso  Lv =< 588 ->
		[1208200,837364];
get_convoy_exp(Lv) when Lv >= 589  andalso  Lv =< 589 ->
		[1208200,840074];
get_convoy_exp(Lv) when Lv >= 590  andalso  Lv =< 590 ->
		[1208200,842784];
get_convoy_exp(Lv) when Lv >= 591  andalso  Lv =< 591 ->
		[1208200,845494];
get_convoy_exp(Lv) when Lv >= 592  andalso  Lv =< 592 ->
		[1208200,848204];
get_convoy_exp(Lv) when Lv >= 593  andalso  Lv =< 593 ->
		[1208200,850914];
get_convoy_exp(Lv) when Lv >= 594  andalso  Lv =< 594 ->
		[1208200,853624];
get_convoy_exp(Lv) when Lv >= 595  andalso  Lv =< 595 ->
		[1208200,856334];
get_convoy_exp(Lv) when Lv >= 596  andalso  Lv =< 596 ->
		[1208200,859044];
get_convoy_exp(Lv) when Lv >= 597  andalso  Lv =< 597 ->
		[1208200,861754];
get_convoy_exp(Lv) when Lv >= 598  andalso  Lv =< 598 ->
		[1208200,864464];
get_convoy_exp(Lv) when Lv >= 599  andalso  Lv =< 599 ->
		[1208200,867174];
get_convoy_exp(Lv) when Lv >= 600  andalso  Lv =< 600 ->
		[1208200,869884];
get_convoy_exp(Lv) when Lv >= 601  andalso  Lv =< 601 ->
		[1208200,872594];
get_convoy_exp(Lv) when Lv >= 602  andalso  Lv =< 602 ->
		[1208200,875304];
get_convoy_exp(Lv) when Lv >= 603  andalso  Lv =< 603 ->
		[1208200,878013];
get_convoy_exp(Lv) when Lv >= 604  andalso  Lv =< 604 ->
		[1208200,880723];
get_convoy_exp(Lv) when Lv >= 605  andalso  Lv =< 605 ->
		[1208200,883433];
get_convoy_exp(Lv) when Lv >= 606  andalso  Lv =< 606 ->
		[1208200,886143];
get_convoy_exp(Lv) when Lv >= 607  andalso  Lv =< 607 ->
		[1208200,888853];
get_convoy_exp(Lv) when Lv >= 608  andalso  Lv =< 608 ->
		[1208200,891563];
get_convoy_exp(Lv) when Lv >= 609  andalso  Lv =< 609 ->
		[1208200,894273];
get_convoy_exp(Lv) when Lv >= 610  andalso  Lv =< 610 ->
		[1208200,896983];
get_convoy_exp(Lv) when Lv >= 611  andalso  Lv =< 611 ->
		[1208200,899693];
get_convoy_exp(Lv) when Lv >= 612  andalso  Lv =< 612 ->
		[1208200,902403];
get_convoy_exp(Lv) when Lv >= 613  andalso  Lv =< 613 ->
		[1208200,905113];
get_convoy_exp(Lv) when Lv >= 614  andalso  Lv =< 614 ->
		[1208200,907823];
get_convoy_exp(Lv) when Lv >= 615  andalso  Lv =< 615 ->
		[1208200,910533];
get_convoy_exp(Lv) when Lv >= 616  andalso  Lv =< 616 ->
		[1208200,913243];
get_convoy_exp(Lv) when Lv >= 617  andalso  Lv =< 617 ->
		[1208200,915953];
get_convoy_exp(Lv) when Lv >= 618  andalso  Lv =< 618 ->
		[1208200,918663];
get_convoy_exp(Lv) when Lv >= 619  andalso  Lv =< 619 ->
		[1208200,921373];
get_convoy_exp(Lv) when Lv >= 620  andalso  Lv =< 620 ->
		[1208200,924083];
get_convoy_exp(Lv) when Lv >= 621  andalso  Lv =< 621 ->
		[1208200,926793];
get_convoy_exp(Lv) when Lv >= 622  andalso  Lv =< 622 ->
		[1208200,929503];
get_convoy_exp(Lv) when Lv >= 623  andalso  Lv =< 623 ->
		[1208200,932212];
get_convoy_exp(Lv) when Lv >= 624  andalso  Lv =< 624 ->
		[1208200,934922];
get_convoy_exp(Lv) when Lv >= 625  andalso  Lv =< 625 ->
		[1208200,937632];
get_convoy_exp(Lv) when Lv >= 626  andalso  Lv =< 626 ->
		[1208200,940342];
get_convoy_exp(Lv) when Lv >= 627  andalso  Lv =< 627 ->
		[1208200,943052];
get_convoy_exp(Lv) when Lv >= 628  andalso  Lv =< 628 ->
		[1208200,945762];
get_convoy_exp(Lv) when Lv >= 629  andalso  Lv =< 629 ->
		[1208200,948472];
get_convoy_exp(Lv) when Lv >= 630  andalso  Lv =< 630 ->
		[1208200,951182];
get_convoy_exp(Lv) when Lv >= 631  andalso  Lv =< 631 ->
		[1208200,953892];
get_convoy_exp(Lv) when Lv >= 632  andalso  Lv =< 632 ->
		[1208200,955735];
get_convoy_exp(Lv) when Lv >= 633  andalso  Lv =< 633 ->
		[1208200,957578];
get_convoy_exp(Lv) when Lv >= 634  andalso  Lv =< 634 ->
		[1208200,959420];
get_convoy_exp(Lv) when Lv >= 635  andalso  Lv =< 635 ->
		[1208200,961263];
get_convoy_exp(Lv) when Lv >= 636  andalso  Lv =< 636 ->
		[1208200,963106];
get_convoy_exp(Lv) when Lv >= 637  andalso  Lv =< 637 ->
		[1208200,964949];
get_convoy_exp(Lv) when Lv >= 638  andalso  Lv =< 638 ->
		[1208200,966792];
get_convoy_exp(Lv) when Lv >= 639  andalso  Lv =< 639 ->
		[1208200,968634];
get_convoy_exp(Lv) when Lv >= 640  andalso  Lv =< 640 ->
		[1208200,970477];
get_convoy_exp(Lv) when Lv >= 641  andalso  Lv =< 641 ->
		[1208200,972320];
get_convoy_exp(Lv) when Lv >= 642  andalso  Lv =< 642 ->
		[1208200,974163];
get_convoy_exp(Lv) when Lv >= 643  andalso  Lv =< 643 ->
		[1208200,976005];
get_convoy_exp(Lv) when Lv >= 644  andalso  Lv =< 644 ->
		[1208200,977848];
get_convoy_exp(Lv) when Lv >= 645  andalso  Lv =< 645 ->
		[1208200,979691];
get_convoy_exp(Lv) when Lv >= 646  andalso  Lv =< 646 ->
		[1208200,981534];
get_convoy_exp(Lv) when Lv >= 647  andalso  Lv =< 647 ->
		[1208200,983377];
get_convoy_exp(Lv) when Lv >= 648  andalso  Lv =< 648 ->
		[1208200,985219];
get_convoy_exp(Lv) when Lv >= 649  andalso  Lv =< 649 ->
		[1208200,987062];
get_convoy_exp(Lv) when Lv >= 650  andalso  Lv =< 650 ->
		[1208200,859044];
get_convoy_exp(Lv) when Lv >= 651  andalso  Lv =< 651 ->
		[1208200,861754];
get_convoy_exp(Lv) when Lv >= 652  andalso  Lv =< 652 ->
		[1208200,864464];
get_convoy_exp(Lv) when Lv >= 653  andalso  Lv =< 653 ->
		[1208200,867174];
get_convoy_exp(Lv) when Lv >= 654  andalso  Lv =< 654 ->
		[1208200,869884];
get_convoy_exp(Lv) when Lv >= 655  andalso  Lv =< 655 ->
		[1208200,872594];
get_convoy_exp(Lv) when Lv >= 656  andalso  Lv =< 656 ->
		[1208200,875304];
get_convoy_exp(Lv) when Lv >= 657  andalso  Lv =< 999 ->
		[1208200,878013];
get_convoy_exp(_Lv) ->
    [].

%%主城出发至PVE点
get_path_by_id(1) ->
    [{13844,10092},{15443,10143}];

%%PVE到第一段结算点
get_path_by_id(2) ->
    [{15443,10143},{17658,10291}];

%%第一段结束寻路到PK场景
get_path_by_id(3) ->
    [{17658,10291},{18356,10294}];

%%第二段pk路线1
get_path_by_id(4) ->
    [{13490,1775},{13010,2061},{10275,3529},{9141,4169},{7094,5107}];

%%第二段pk路线2
get_path_by_id(5) ->
    [{13027,8620},{12540,8319},{10204,6841},{9171,6293},{7092,4922}];

%%第二段普通路线
get_path_by_id(6) ->
    [{936,1090},{1202,1271},{4391,3254},{5468,3946},{7405,5118}];

get_path_by_id(_Id) ->
    [].

%%主城出发至PVE点
get_path_id_by_type(1) ->
    [1];

%%PVE到第一段结算点
get_path_id_by_type(2) ->
    [2];

%%第一段结束寻路到PK场景
get_path_id_by_type(3) ->
    [3];

%%第二段pk路线2
get_path_id_by_type(4) ->
    [4,5];

%%第二段普通路线
get_path_id_by_type(5) ->
    [6];

get_path_id_by_type(_Type) ->
    [].

%%主城出发至PVE点
get_center_path_by_id(1) ->
    [{13844,10092},{15443,10143}];

%%PVE到第一段结算点
get_center_path_by_id(2) ->
    [{15443,10143},{17658,10291}];

%%第一段结束寻路到PK场景
get_center_path_by_id(3) ->
    [{17658,10291},{18356,10294}];

%%第二段pk路线1
get_center_path_by_id(4) ->
    [{13490,1775},{13010,2061},{10275,3529},{9141,4169},{7094,5107}];

%%第二段pk路线2
get_center_path_by_id(5) ->
    [{13027,8620},{12540,8319},{10204,6841},{9171,6293},{7092,4922}];

%%第二段普通路线
get_center_path_by_id(6) ->
    [{936,1090},{1202,1271},{4391,3254},{5468,3946},{7405,5118}];

get_center_path_by_id(_Id) ->
    [].

