%%%---------------------------------------
%%% module      : data_cross_guild_war
%%% description : 跨服国战配置
%%%
%%%---------------------------------------
-module(data_cross_guild_war).
-compile(export_all).
-include("cross_guild_war.hrl").



get_cross_guild_war_config() ->
    #cross_guild_war_config{week_list=[6],sign_up_period={{00,00,05},{20,00,00}},support_period={{00,00,05},{20,30,00}},battle_period={{20,30,00},{21,00,00}}}.

%%核心区团长占领奖励
get_config(mteam_centerfield_lord_rewards) ->
    [{17,432015,1},{0,260004,5},{0,260002,20},{0,450020,5},{0,450019,10}];

%%核心区团员占领奖励
get_config(mteam_centerfield_member_rewards) ->
    [{17,432017,1},{0,260004,3},{0,260002,10},{0,450020,3},{0,450019,6}];

%%其他区团长占领奖励
get_config(mteam_surroundfield_lord_rewards) ->
    [{17,432016,1},{0,260004,3},{0,260002,15},{0,450020,4},{0,450019,8}];

%%其他区团员占领奖励
get_config(mteam_surroundfield_member_rewards) ->
    [{0,260004,2},{0,260002,5},{0,450020,2},{0,450019,6}];

%%核心区应援单份奖励
get_config(centerfield_encourage_rewards) ->
    [{0,260002,1}];

%%副城应援单份奖励
get_config(surroundfield_encourage_rewards) ->
    [{0,102501,1}];

%%战场场景id
get_config(scene_id) ->
    4300;

%%核心区城池Id
get_config(main_city) ->
    1;

%%免费应援次数
get_config(support_free) ->
    1;

%%跨服团战第一社团准入人数
get_config(sign_up_max) ->
    15;

%%应援消耗
get_config(support_cost) ->
    [{2, 0,10}];

%%应援次数上限
get_config(support_max) ->
    10;

%%占领核心区每日奖励
get_config(centerfield_daily_award) ->
    [{0,260002,1},{0,102607,1}];

%%占领非核心区每日奖励
get_config(surroundfield_daily_award) ->
    [{0,450023,1},{0,102604,1}];

%%开启等级
get_config(open_lv) ->
    180;

%%跨服国战接入跨服开服天数限制
get_config(need_open_days) ->
    5;

%%外援报名人数
get_config(sign_up_help_max) ->
    15;

%%第一期活动开启时间
get_config(open_time) ->
    1612540800;

%%活动结束后，战况公示时间(天)
get_config(public_time) ->
    3;

%%再次报名CD
get_config(resign_time) ->
    1800;

get_config(_Key) ->
    [].

get_city_config(1) ->
    #cross_guild_war_city{id = 1,name = <<"核心主城"/utf8>>,type_id = 1,born_point = {},revive_point = {},flag = {43001001,8437,8375},mon_list = [{43001101,8172,8707},{43001101,8794,8763},{43001101,8790,8145},{43001101,8136,8153}]};

get_city_config(2) ->
    #cross_guild_war_city{id = 2,name = <<"西城据点"/utf8>>,type_id = 2,born_point = {4019,13625},revive_point = {5252,12227},flag = {43001002,5937,11357},mon_list = [{43001102,6315,11684},{43001102,6267,10990},{43001102,5553,11022},{43001102,5613,11720}]};

get_city_config(3) ->
    #cross_guild_war_city{id = 3,name = <<"南城据点"/utf8>>,type_id = 2,born_point = {3626,4214},revive_point = {4977,5400},flag = {43001003,5880,6120},mon_list = [{43001103,6258,6447},{43001103,6210,5753},{43001103,5496,5785},{43001103,5556,6483}]};

get_city_config(4) ->
    #cross_guild_war_city{id = 4,name = <<"东城据点"/utf8>>,type_id = 2,born_point = {12944,3245},revive_point = {11581,4655},flag = {43001004,11019,5490},mon_list = [{43001104,11397,5817},{43001104,11349,5123},{43001104,10635,5155},{43001104,10695,5853}]};

get_city_config(5) ->
    #cross_guild_war_city{id = 5,name = <<"北城据点"/utf8>>,type_id = 2,born_point = {13491,12767},revive_point = {11988,11439},flag = {43001005,11266,10808},mon_list = [{43001105,11644,11135},{43001105,11596,10441},{43001105,10882,10473},{43001105,10942,11171}]};

get_city_config(_Id) ->
    [].

city_ids() ->
    [1,2,3,4,5].


get_mon_city(43001001) ->
    1;


get_mon_city(43001002) ->
    2;


get_mon_city(43001003) ->
    3;


get_mon_city(43001004) ->
    4;


get_mon_city(43001005) ->
    5;


get_mon_city(43001101) ->
    1;


get_mon_city(43001102) ->
    2;


get_mon_city(43001103) ->
    3;


get_mon_city(43001104) ->
    4;


get_mon_city(43001105) ->
    5;

get_mon_city(_Id) ->
    0.


get_mon_type(43001001) ->
    1;


get_mon_type(43001002) ->
    1;


get_mon_type(43001003) ->
    1;


get_mon_type(43001004) ->
    1;


get_mon_type(43001005) ->
    1;


get_mon_type(43001101) ->
    2;


get_mon_type(43001102) ->
    2;


get_mon_type(43001103) ->
    2;


get_mon_type(43001104) ->
    2;


get_mon_type(43001105) ->
    2;

get_mon_type(_Id) ->
    0.


get_mon_config(43001001) ->
    {1,1};


get_mon_config(43001002) ->
    {2,1};


get_mon_config(43001003) ->
    {3,1};


get_mon_config(43001004) ->
    {4,1};


get_mon_config(43001005) ->
    {5,1};


get_mon_config(43001101) ->
    {1,2};


get_mon_config(43001102) ->
    {2,2};


get_mon_config(43001103) ->
    {3,2};


get_mon_config(43001104) ->
    {4,2};


get_mon_config(43001105) ->
    {5,2};

get_mon_config(_Id) ->
    [].

get_rooms() ->
    [1].


get_room_name(1) ->
    "主战区";

get_room_name(_Id) ->
    "".

get_overlord_buy_cfg(1) ->
    #overlord_buy_cfg{phase = 1,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(2) ->
    #overlord_buy_cfg{phase = 2,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(3) ->
    #overlord_buy_cfg{phase = 3,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(4) ->
    #overlord_buy_cfg{phase = 4,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(5) ->
    #overlord_buy_cfg{phase = 5,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(6) ->
    #overlord_buy_cfg{phase = 6,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(7) ->
    #overlord_buy_cfg{phase = 7,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(8) ->
    #overlord_buy_cfg{phase = 8,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(9) ->
    #overlord_buy_cfg{phase = 9,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(10) ->
    #overlord_buy_cfg{phase = 10,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(11) ->
    #overlord_buy_cfg{phase = 11,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(12) ->
    #overlord_buy_cfg{phase = 12,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(13) ->
    #overlord_buy_cfg{phase = 13,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(14) ->
    #overlord_buy_cfg{phase = 14,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(15) ->
    #overlord_buy_cfg{phase = 15,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(16) ->
    #overlord_buy_cfg{phase = 16,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(17) ->
    #overlord_buy_cfg{phase = 17,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(18) ->
    #overlord_buy_cfg{phase = 18,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(19) ->
    #overlord_buy_cfg{phase = 19,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(20) ->
    #overlord_buy_cfg{phase = 20,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(21) ->
    #overlord_buy_cfg{phase = 21,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(22) ->
    #overlord_buy_cfg{phase = 22,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(23) ->
    #overlord_buy_cfg{phase = 23,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(24) ->
    #overlord_buy_cfg{phase = 24,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(25) ->
    #overlord_buy_cfg{phase = 25,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(26) ->
    #overlord_buy_cfg{phase = 26,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(27) ->
    #overlord_buy_cfg{phase = 27,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(28) ->
    #overlord_buy_cfg{phase = 28,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(29) ->
    #overlord_buy_cfg{phase = 29,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(30) ->
    #overlord_buy_cfg{phase = 30,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(31) ->
    #overlord_buy_cfg{phase = 31,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(32) ->
    #overlord_buy_cfg{phase = 32,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(33) ->
    #overlord_buy_cfg{phase = 33,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(34) ->
    #overlord_buy_cfg{phase = 34,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(35) ->
    #overlord_buy_cfg{phase = 35,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(36) ->
    #overlord_buy_cfg{phase = 36,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(37) ->
    #overlord_buy_cfg{phase = 37,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(38) ->
    #overlord_buy_cfg{phase = 38,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(39) ->
    #overlord_buy_cfg{phase = 39,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(40) ->
    #overlord_buy_cfg{phase = 40,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(41) ->
    #overlord_buy_cfg{phase = 41,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(42) ->
    #overlord_buy_cfg{phase = 42,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(43) ->
    #overlord_buy_cfg{phase = 43,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(44) ->
    #overlord_buy_cfg{phase = 44,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(45) ->
    #overlord_buy_cfg{phase = 45,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(46) ->
    #overlord_buy_cfg{phase = 46,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(47) ->
    #overlord_buy_cfg{phase = 47,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(48) ->
    #overlord_buy_cfg{phase = 48,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(49) ->
    #overlord_buy_cfg{phase = 49,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(50) ->
    #overlord_buy_cfg{phase = 50,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(51) ->
    #overlord_buy_cfg{phase = 51,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(52) ->
    #overlord_buy_cfg{phase = 52,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(53) ->
    #overlord_buy_cfg{phase = 53,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(54) ->
    #overlord_buy_cfg{phase = 54,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(55) ->
    #overlord_buy_cfg{phase = 55,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(56) ->
    #overlord_buy_cfg{phase = 56,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(57) ->
    #overlord_buy_cfg{phase = 57,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(58) ->
    #overlord_buy_cfg{phase = 58,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(59) ->
    #overlord_buy_cfg{phase = 59,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(60) ->
    #overlord_buy_cfg{phase = 60,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(61) ->
    #overlord_buy_cfg{phase = 61,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(62) ->
    #overlord_buy_cfg{phase = 62,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(63) ->
    #overlord_buy_cfg{phase = 63,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(64) ->
    #overlord_buy_cfg{phase = 64,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(65) ->
    #overlord_buy_cfg{phase = 65,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(66) ->
    #overlord_buy_cfg{phase = 66,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(67) ->
    #overlord_buy_cfg{phase = 67,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(68) ->
    #overlord_buy_cfg{phase = 68,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(69) ->
    #overlord_buy_cfg{phase = 69,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(70) ->
    #overlord_buy_cfg{phase = 70,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(71) ->
    #overlord_buy_cfg{phase = 71,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(72) ->
    #overlord_buy_cfg{phase = 72,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(73) ->
    #overlord_buy_cfg{phase = 73,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(74) ->
    #overlord_buy_cfg{phase = 74,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(75) ->
    #overlord_buy_cfg{phase = 75,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(76) ->
    #overlord_buy_cfg{phase = 76,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(77) ->
    #overlord_buy_cfg{phase = 77,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(78) ->
    #overlord_buy_cfg{phase = 78,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(79) ->
    #overlord_buy_cfg{phase = 79,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(80) ->
    #overlord_buy_cfg{phase = 80,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(81) ->
    #overlord_buy_cfg{phase = 81,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(82) ->
    #overlord_buy_cfg{phase = 82,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(83) ->
    #overlord_buy_cfg{phase = 83,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(84) ->
    #overlord_buy_cfg{phase = 84,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(85) ->
    #overlord_buy_cfg{phase = 85,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(86) ->
    #overlord_buy_cfg{phase = 86,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(87) ->
    #overlord_buy_cfg{phase = 87,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(88) ->
    #overlord_buy_cfg{phase = 88,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(89) ->
    #overlord_buy_cfg{phase = 89,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(90) ->
    #overlord_buy_cfg{phase = 90,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(91) ->
    #overlord_buy_cfg{phase = 91,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(92) ->
    #overlord_buy_cfg{phase = 92,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(93) ->
    #overlord_buy_cfg{phase = 93,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(94) ->
    #overlord_buy_cfg{phase = 94,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(95) ->
    #overlord_buy_cfg{phase = 95,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(96) ->
    #overlord_buy_cfg{phase = 96,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(97) ->
    #overlord_buy_cfg{phase = 97,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(98) ->
    #overlord_buy_cfg{phase = 98,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(99) ->
    #overlord_buy_cfg{phase = 99,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(100) ->
    #overlord_buy_cfg{phase = 100,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(101) ->
    #overlord_buy_cfg{phase = 101,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(102) ->
    #overlord_buy_cfg{phase = 102,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(103) ->
    #overlord_buy_cfg{phase = 103,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(104) ->
    #overlord_buy_cfg{phase = 104,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(105) ->
    #overlord_buy_cfg{phase = 105,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(106) ->
    #overlord_buy_cfg{phase = 106,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(107) ->
    #overlord_buy_cfg{phase = 107,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(108) ->
    #overlord_buy_cfg{phase = 108,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(109) ->
    #overlord_buy_cfg{phase = 109,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(110) ->
    #overlord_buy_cfg{phase = 110,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(111) ->
    #overlord_buy_cfg{phase = 111,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(112) ->
    #overlord_buy_cfg{phase = 112,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(113) ->
    #overlord_buy_cfg{phase = 113,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(114) ->
    #overlord_buy_cfg{phase = 114,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(115) ->
    #overlord_buy_cfg{phase = 115,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(116) ->
    #overlord_buy_cfg{phase = 116,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(117) ->
    #overlord_buy_cfg{phase = 117,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(118) ->
    #overlord_buy_cfg{phase = 118,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(119) ->
    #overlord_buy_cfg{phase = 119,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(120) ->
    #overlord_buy_cfg{phase = 120,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(121) ->
    #overlord_buy_cfg{phase = 121,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(122) ->
    #overlord_buy_cfg{phase = 122,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(123) ->
    #overlord_buy_cfg{phase = 123,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(124) ->
    #overlord_buy_cfg{phase = 124,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(125) ->
    #overlord_buy_cfg{phase = 125,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(126) ->
    #overlord_buy_cfg{phase = 126,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(127) ->
    #overlord_buy_cfg{phase = 127,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(128) ->
    #overlord_buy_cfg{phase = 128,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(129) ->
    #overlord_buy_cfg{phase = 129,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(130) ->
    #overlord_buy_cfg{phase = 130,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(131) ->
    #overlord_buy_cfg{phase = 131,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(132) ->
    #overlord_buy_cfg{phase = 132,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(133) ->
    #overlord_buy_cfg{phase = 133,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(134) ->
    #overlord_buy_cfg{phase = 134,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(135) ->
    #overlord_buy_cfg{phase = 135,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(136) ->
    #overlord_buy_cfg{phase = 136,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(137) ->
    #overlord_buy_cfg{phase = 137,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(138) ->
    #overlord_buy_cfg{phase = 138,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(139) ->
    #overlord_buy_cfg{phase = 139,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(140) ->
    #overlord_buy_cfg{phase = 140,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(141) ->
    #overlord_buy_cfg{phase = 141,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(142) ->
    #overlord_buy_cfg{phase = 142,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(143) ->
    #overlord_buy_cfg{phase = 143,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(144) ->
    #overlord_buy_cfg{phase = 144,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(145) ->
    #overlord_buy_cfg{phase = 145,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(146) ->
    #overlord_buy_cfg{phase = 146,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(147) ->
    #overlord_buy_cfg{phase = 147,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(148) ->
    #overlord_buy_cfg{phase = 148,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(149) ->
    #overlord_buy_cfg{phase = 149,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(150) ->
    #overlord_buy_cfg{phase = 150,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(151) ->
    #overlord_buy_cfg{phase = 151,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(152) ->
    #overlord_buy_cfg{phase = 152,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(153) ->
    #overlord_buy_cfg{phase = 153,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(154) ->
    #overlord_buy_cfg{phase = 154,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(155) ->
    #overlord_buy_cfg{phase = 155,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(156) ->
    #overlord_buy_cfg{phase = 156,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(157) ->
    #overlord_buy_cfg{phase = 157,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(158) ->
    #overlord_buy_cfg{phase = 158,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(159) ->
    #overlord_buy_cfg{phase = 159,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(160) ->
    #overlord_buy_cfg{phase = 160,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(161) ->
    #overlord_buy_cfg{phase = 161,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(162) ->
    #overlord_buy_cfg{phase = 162,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(163) ->
    #overlord_buy_cfg{phase = 163,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(164) ->
    #overlord_buy_cfg{phase = 164,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(165) ->
    #overlord_buy_cfg{phase = 165,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(166) ->
    #overlord_buy_cfg{phase = 166,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(167) ->
    #overlord_buy_cfg{phase = 167,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(168) ->
    #overlord_buy_cfg{phase = 168,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(169) ->
    #overlord_buy_cfg{phase = 169,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(170) ->
    #overlord_buy_cfg{phase = 170,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(171) ->
    #overlord_buy_cfg{phase = 171,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(172) ->
    #overlord_buy_cfg{phase = 172,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(173) ->
    #overlord_buy_cfg{phase = 173,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(174) ->
    #overlord_buy_cfg{phase = 174,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(175) ->
    #overlord_buy_cfg{phase = 175,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(176) ->
    #overlord_buy_cfg{phase = 176,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(177) ->
    #overlord_buy_cfg{phase = 177,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(178) ->
    #overlord_buy_cfg{phase = 178,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(179) ->
    #overlord_buy_cfg{phase = 179,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(180) ->
    #overlord_buy_cfg{phase = 180,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(181) ->
    #overlord_buy_cfg{phase = 181,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(182) ->
    #overlord_buy_cfg{phase = 182,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(183) ->
    #overlord_buy_cfg{phase = 183,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(184) ->
    #overlord_buy_cfg{phase = 184,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(185) ->
    #overlord_buy_cfg{phase = 185,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(186) ->
    #overlord_buy_cfg{phase = 186,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(187) ->
    #overlord_buy_cfg{phase = 187,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(188) ->
    #overlord_buy_cfg{phase = 188,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(189) ->
    #overlord_buy_cfg{phase = 189,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(190) ->
    #overlord_buy_cfg{phase = 190,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(191) ->
    #overlord_buy_cfg{phase = 191,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(192) ->
    #overlord_buy_cfg{phase = 192,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(193) ->
    #overlord_buy_cfg{phase = 193,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(194) ->
    #overlord_buy_cfg{phase = 194,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(195) ->
    #overlord_buy_cfg{phase = 195,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(196) ->
    #overlord_buy_cfg{phase = 196,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(197) ->
    #overlord_buy_cfg{phase = 197,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(198) ->
    #overlord_buy_cfg{phase = 198,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(199) ->
    #overlord_buy_cfg{phase = 199,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(200) ->
    #overlord_buy_cfg{phase = 200,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(201) ->
    #overlord_buy_cfg{phase = 201,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(202) ->
    #overlord_buy_cfg{phase = 202,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(203) ->
    #overlord_buy_cfg{phase = 203,reward = [{0,404003,30},{0,401012,30},{0,402005,30}],cost = [{1,0,25199}],display = 1};

get_overlord_buy_cfg(_Phase) ->
    [].

