%%%---------------------------------------
%%% module      : data_custom_journey
%%% description : 征途活动配置
%%%
%%%---------------------------------------
-module(data_custom_journey).
-compile(export_all).
-include("custom_journey.hrl").



%%彩钻购买
get(goldbuy) ->
    1;

%%红钻购买
get(bgoldbug) ->
    2;

%%交易券购买
get(coinbuy) ->
    3;

%%名望券购买
get(famebuy) ->
    4;

%%次元、星域幻魔击杀
get(boss) ->
    5;

%%好友送礼
get(gift) ->
    6;

%%竞技联赛
get(arena) ->
    7;

get(_Key) ->
    [].

get_map(1) ->
    #base_journey_map{map = 1,name = <<"蛇骨之国"/utf8>>,grade = 2,totem = 1,unlock_map = 0,unlock_tasks = 0};

get_map(2) ->
    #base_journey_map{map = 2,name = <<"废弃海港"/utf8>>,grade = 1,totem = 0,unlock_map = 1,unlock_tasks = 7};

get_map(3) ->
    #base_journey_map{map = 3,name = <<"琼鲸之国"/utf8>>,grade = 2,totem = 2,unlock_map = 2,unlock_tasks = 7};

get_map(4) ->
    #base_journey_map{map = 4,name = <<"失落遗国"/utf8>>,grade = 1,totem = 0,unlock_map = 3,unlock_tasks = 7};

get_map(5) ->
    #base_journey_map{map = 5,name = <<"羽鹰之国"/utf8>>,grade = 2,totem = 3,unlock_map = 4,unlock_tasks = 8};

get_map(6) ->
    #base_journey_map{map = 6,name = <<"飞船商队"/utf8>>,grade = 1,totem = 0,unlock_map = 5,unlock_tasks = 7};

get_map(7) ->
    #base_journey_map{map = 7,name = <<"雄狮之国"/utf8>>,grade = 2,totem = 4,unlock_map = 6,unlock_tasks = 8};

get_map(8) ->
    #base_journey_map{map = 8,name = <<"水晶矿坑"/utf8>>,grade = 1,totem = 0,unlock_map = 7,unlock_tasks = 7};

get_map(9) ->
    #base_journey_map{map = 9,name = <<"雀灵之国"/utf8>>,grade = 2,totem = 5,unlock_map = 8,unlock_tasks = 8};

get_map(_Map) ->
    [].

get_task(1,1,1) ->
    #base_journey_task{suit = 1,map = 1,task = 1,task_type = 6,cons = 1,unlock = 0,desc = <<"节日欢庆之际，给你的好友也送上一份礼物吧~"/utf8>>};

get_task(1,1,2) ->
    #base_journey_task{suit = 1,map = 1,task = 2,task_type = 6,cons = 2,unlock = 0,desc = <<"这是从雀灵之国进口的礼品，要给你的好友送点吗"/utf8>>};

get_task(1,1,3) ->
    #base_journey_task{suit = 1,map = 1,task = 3,task_type = 7,cons = 1,unlock = 0,desc = <<"在竞技联赛中胜利才是真正的勇士，不去试试吗"/utf8>>};

get_task(1,1,4) ->
    #base_journey_task{suit = 1,map = 1,task = 4,task_type = 3,cons = 300,unlock = 0,desc = <<"我需要买一个珍品，可以借我点交易券吗，事后不会亏待你的"/utf8>>};

get_task(1,1,5) ->
    #base_journey_task{suit = 1,map = 1,task = 5,task_type = 4,cons = 200,unlock = 0,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,1,6) ->
    #base_journey_task{suit = 1,map = 1,task = 6,task_type = 2,cons = 38,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,1,7) ->
    #base_journey_task{suit = 1,map = 1,task = 7,task_type = 2,cons = 68,unlock = 0,desc = <<"佣兵团需要补充点人员，可以给点雇佣费用吗"/utf8>>};

get_task(1,1,8) ->
    #base_journey_task{suit = 1,map = 1,task = 8,task_type = 1,cons = 28,unlock = 6,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,1,9) ->
    #base_journey_task{suit = 1,map = 1,task = 9,task_type = 1,cons = 88,unlock = 6,desc = <<"预付旅馆费用的话，我可以送你一份小礼物哦"/utf8>>};

get_task(1,1,10) ->
    #base_journey_task{suit = 1,map = 1,task = 10,task_type = 1,cons = 128,unlock = 6,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,2,1) ->
    #base_journey_task{suit = 1,map = 2,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体化身的幻魔又在到处破坏了，请帮忙击杀%s个幻魔。(赏金幻魔、星域幻魔)"/utf8>>};

get_task(1,2,2) ->
    #base_journey_task{suit = 1,map = 2,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"星域空间混乱，请帮忙击杀%s个幻魔，维护世界和平。(赏金幻魔、星域幻魔)"/utf8>>};

get_task(1,2,3) ->
    #base_journey_task{suit = 1,map = 2,task = 3,task_type = 3,cons = 500,unlock = 0,desc = <<"我需要买一个珍品，可以借我点交易券吗，事后不会亏待你的"/utf8>>};

get_task(1,2,4) ->
    #base_journey_task{suit = 1,map = 2,task = 4,task_type = 3,cons = 600,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,2,5) ->
    #base_journey_task{suit = 1,map = 2,task = 5,task_type = 2,cons = 88,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,2,6) ->
    #base_journey_task{suit = 1,map = 2,task = 6,task_type = 2,cons = 128,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,2,7) ->
    #base_journey_task{suit = 1,map = 2,task = 7,task_type = 1,cons = 38,unlock = 0,desc = <<"预付旅馆费用的话，我可以送你一份小礼物哦"/utf8>>};

get_task(1,2,8) ->
    #base_journey_task{suit = 1,map = 2,task = 8,task_type = 1,cons = 68,unlock = 7,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,2,9) ->
    #base_journey_task{suit = 1,map = 2,task = 9,task_type = 1,cons = 168,unlock = 7,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,2,10) ->
    #base_journey_task{suit = 1,map = 2,task = 10,task_type = 1,cons = 288,unlock = 7,desc = <<"佣兵团需要补充点人员，可以给点雇佣费用吗"/utf8>>};

get_task(1,3,1) ->
    #base_journey_task{suit = 1,map = 3,task = 1,task_type = 7,cons = 1,unlock = 0,desc = <<"在竞技联赛中胜利才是真正的勇士，不去试试吗"/utf8>>};

get_task(1,3,2) ->
    #base_journey_task{suit = 1,map = 3,task = 2,task_type = 7,cons = 3,unlock = 0,desc = <<"在竞技联赛中胜利才是真正的勇士，不去试试吗"/utf8>>};

get_task(1,3,3) ->
    #base_journey_task{suit = 1,map = 3,task = 3,task_type = 3,cons = 600,unlock = 0,desc = <<"我需要买一个珍品，可以借我点交易券吗，事后不会亏待你的"/utf8>>};

get_task(1,3,4) ->
    #base_journey_task{suit = 1,map = 3,task = 4,task_type = 3,cons = 800,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,3,5) ->
    #base_journey_task{suit = 1,map = 3,task = 5,task_type = 2,cons = 88,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,3,6) ->
    #base_journey_task{suit = 1,map = 3,task = 6,task_type = 2,cons = 168,unlock = 0,desc = <<"预付旅馆费用的话，我可以送你一份小礼物哦"/utf8>>};

get_task(1,3,7) ->
    #base_journey_task{suit = 1,map = 3,task = 7,task_type = 1,cons = 68,unlock = 0,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,3,8) ->
    #base_journey_task{suit = 1,map = 3,task = 8,task_type = 1,cons = 128,unlock = 6,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,3,9) ->
    #base_journey_task{suit = 1,map = 3,task = 9,task_type = 1,cons = 198,unlock = 6,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,3,10) ->
    #base_journey_task{suit = 1,map = 3,task = 10,task_type = 1,cons = 388,unlock = 6,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,4,1) ->
    #base_journey_task{suit = 1,map = 4,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体化身的幻魔又在到处破坏了，请帮忙击杀%s个幻魔。(赏金幻魔、星域幻魔)"/utf8>>};

get_task(1,4,2) ->
    #base_journey_task{suit = 1,map = 4,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"星域空间混乱，请帮忙击杀%s个幻魔，维护世界和平。(赏金幻魔、星域幻魔)"/utf8>>};

get_task(1,4,3) ->
    #base_journey_task{suit = 1,map = 4,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体化身的幻魔又在到处破坏了，请帮忙击杀%s个幻魔。(赏金幻魔、星域幻魔)"/utf8>>};

get_task(1,4,4) ->
    #base_journey_task{suit = 1,map = 4,task = 4,task_type = 2,cons = 38,unlock = 0,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,4,5) ->
    #base_journey_task{suit = 1,map = 4,task = 5,task_type = 2,cons = 68,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,4,6) ->
    #base_journey_task{suit = 1,map = 4,task = 6,task_type = 2,cons = 98,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,4,7) ->
    #base_journey_task{suit = 1,map = 4,task = 7,task_type = 1,cons = 88,unlock = 0,desc = <<"佣兵团需要补充点人员，可以给点雇佣费用吗"/utf8>>};

get_task(1,4,8) ->
    #base_journey_task{suit = 1,map = 4,task = 8,task_type = 1,cons = 158,unlock = 7,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,4,9) ->
    #base_journey_task{suit = 1,map = 4,task = 9,task_type = 1,cons = 288,unlock = 7,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,4,10) ->
    #base_journey_task{suit = 1,map = 4,task = 10,task_type = 1,cons = 488,unlock = 7,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,5,1) ->
    #base_journey_task{suit = 1,map = 5,task = 1,task_type = 6,cons = 1,unlock = 0,desc = <<"这是从雀灵之国进口的礼品，要给你的好友送点吗"/utf8>>};

get_task(1,5,2) ->
    #base_journey_task{suit = 1,map = 5,task = 2,task_type = 6,cons = 2,unlock = 0,desc = <<"节日欢庆之际，给你的好友也送上一份礼物吧~"/utf8>>};

get_task(1,5,3) ->
    #base_journey_task{suit = 1,map = 5,task = 3,task_type = 3,cons = 500,unlock = 0,desc = <<"我需要买一个珍品，可以借我点交易券吗，事后不会亏待你的"/utf8>>};

get_task(1,5,4) ->
    #base_journey_task{suit = 1,map = 5,task = 4,task_type = 2,cons = 58,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,5,5) ->
    #base_journey_task{suit = 1,map = 5,task = 5,task_type = 2,cons = 88,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,5,6) ->
    #base_journey_task{suit = 1,map = 5,task = 6,task_type = 2,cons = 168,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,5,7) ->
    #base_journey_task{suit = 1,map = 5,task = 7,task_type = 1,cons = 78,unlock = 0,desc = <<"佣兵团需要补充点人员，可以给点雇佣费用吗"/utf8>>};

get_task(1,5,8) ->
    #base_journey_task{suit = 1,map = 5,task = 8,task_type = 1,cons = 168,unlock = 7,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,5,9) ->
    #base_journey_task{suit = 1,map = 5,task = 9,task_type = 1,cons = 298,unlock = 7,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,5,10) ->
    #base_journey_task{suit = 1,map = 5,task = 10,task_type = 1,cons = 488,unlock = 7,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,6,1) ->
    #base_journey_task{suit = 1,map = 6,task = 1,task_type = 7,cons = 1,unlock = 0,desc = <<"在竞技联赛中胜利才是真正的勇士，不去试试吗"/utf8>>};

get_task(1,6,2) ->
    #base_journey_task{suit = 1,map = 6,task = 2,task_type = 7,cons = 2,unlock = 0,desc = <<"在竞技联赛中胜利才是真正的勇士，不去试试吗"/utf8>>};

get_task(1,6,3) ->
    #base_journey_task{suit = 1,map = 6,task = 3,task_type = 6,cons = 1,unlock = 0,desc = <<"这是从雀灵之国进口的礼品，要给你的好友送点吗"/utf8>>};

get_task(1,6,4) ->
    #base_journey_task{suit = 1,map = 6,task = 4,task_type = 2,cons = 38,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,6,5) ->
    #base_journey_task{suit = 1,map = 6,task = 5,task_type = 2,cons = 98,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,6,6) ->
    #base_journey_task{suit = 1,map = 6,task = 6,task_type = 2,cons = 158,unlock = 0,desc = <<"佣兵团需要补充点人员，可以给点雇佣费用吗"/utf8>>};

get_task(1,6,7) ->
    #base_journey_task{suit = 1,map = 6,task = 7,task_type = 1,cons = 88,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,6,8) ->
    #base_journey_task{suit = 1,map = 6,task = 8,task_type = 1,cons = 168,unlock = 6,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,6,9) ->
    #base_journey_task{suit = 1,map = 6,task = 9,task_type = 1,cons = 328,unlock = 6,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,6,10) ->
    #base_journey_task{suit = 1,map = 6,task = 10,task_type = 1,cons = 488,unlock = 6,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,7,1) ->
    #base_journey_task{suit = 1,map = 7,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体化身的幻魔又在到处破坏了，请帮忙击杀%s个幻魔。(赏金幻魔、星域幻魔)"/utf8>>};

get_task(1,7,2) ->
    #base_journey_task{suit = 1,map = 7,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"星域空间混乱，请帮忙击杀%s个幻魔，维护世界和平。(赏金幻魔、星域幻魔)"/utf8>>};

get_task(1,7,3) ->
    #base_journey_task{suit = 1,map = 7,task = 3,task_type = 4,cons = 300,unlock = 0,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,7,4) ->
    #base_journey_task{suit = 1,map = 7,task = 4,task_type = 2,cons = 68,unlock = 0,desc = <<"预付旅馆费用的话，我可以送你一份小礼物哦"/utf8>>};

get_task(1,7,5) ->
    #base_journey_task{suit = 1,map = 7,task = 5,task_type = 2,cons = 88,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,7,6) ->
    #base_journey_task{suit = 1,map = 7,task = 6,task_type = 2,cons = 108,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,7,7) ->
    #base_journey_task{suit = 1,map = 7,task = 7,task_type = 1,cons = 98,unlock = 0,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,7,8) ->
    #base_journey_task{suit = 1,map = 7,task = 8,task_type = 1,cons = 188,unlock = 7,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,7,9) ->
    #base_journey_task{suit = 1,map = 7,task = 9,task_type = 1,cons = 388,unlock = 7,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,7,10) ->
    #base_journey_task{suit = 1,map = 7,task = 10,task_type = 1,cons = 488,unlock = 7,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,8,1) ->
    #base_journey_task{suit = 1,map = 8,task = 1,task_type = 7,cons = 1,unlock = 0,desc = <<"在竞技联赛中胜利才是真正的勇士，不去试试吗"/utf8>>};

get_task(1,8,2) ->
    #base_journey_task{suit = 1,map = 8,task = 2,task_type = 7,cons = 2,unlock = 0,desc = <<"在竞技联赛中胜利才是真正的勇士，不去试试吗"/utf8>>};

get_task(1,8,3) ->
    #base_journey_task{suit = 1,map = 8,task = 3,task_type = 3,cons = 600,unlock = 0,desc = <<"我需要买一个珍品，可以借我点交易券吗，事后不会亏待你的"/utf8>>};

get_task(1,8,4) ->
    #base_journey_task{suit = 1,map = 8,task = 4,task_type = 2,cons = 58,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,8,5) ->
    #base_journey_task{suit = 1,map = 8,task = 5,task_type = 2,cons = 98,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,8,6) ->
    #base_journey_task{suit = 1,map = 8,task = 6,task_type = 2,cons = 128,unlock = 0,desc = <<"预付旅馆费用的话，我可以送你一份小礼物哦"/utf8>>};

get_task(1,8,7) ->
    #base_journey_task{suit = 1,map = 8,task = 7,task_type = 1,cons = 158,unlock = 0,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,8,8) ->
    #base_journey_task{suit = 1,map = 8,task = 8,task_type = 1,cons = 198,unlock = 6,desc = <<"这是雀灵之国新发现的秘宝，特价销售仅此一次哦"/utf8>>};

get_task(1,8,9) ->
    #base_journey_task{suit = 1,map = 8,task = 9,task_type = 1,cons = 328,unlock = 6,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,8,10) ->
    #base_journey_task{suit = 1,map = 8,task = 10,task_type = 1,cons = 488,unlock = 6,desc = <<"这是琼鲸之国新发现的珍稀秘宝，特价销售仅此一次"/utf8>>};

get_task(1,9,1) ->
    #base_journey_task{suit = 1,map = 9,task = 1,task_type = 6,cons = 1,unlock = 0,desc = <<"节日欢庆之际，给你的好友也送上一份礼物吧~"/utf8>>};

get_task(1,9,2) ->
    #base_journey_task{suit = 1,map = 9,task = 2,task_type = 6,cons = 3,unlock = 0,desc = <<"这是从雀灵之国进口的礼品，要给你的好友送点吗"/utf8>>};

get_task(1,9,3) ->
    #base_journey_task{suit = 1,map = 9,task = 3,task_type = 2,cons = 68,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(1,9,4) ->
    #base_journey_task{suit = 1,map = 9,task = 4,task_type = 2,cons = 188,unlock = 0,desc = <<"佣兵团需要补充点人员，可以给点雇佣费用吗"/utf8>>};

get_task(1,9,5) ->
    #base_journey_task{suit = 1,map = 9,task = 5,task_type = 1,cons = 168,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,9,6) ->
    #base_journey_task{suit = 1,map = 9,task = 6,task_type = 1,cons = 328,unlock = 5,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,9,7) ->
    #base_journey_task{suit = 1,map = 9,task = 7,task_type = 1,cons = 588,unlock = 6,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(1,9,8) ->
    #base_journey_task{suit = 1,map = 9,task = 8,task_type = 1,cons = 888,unlock = 7,desc = <<"幻魔又在蠢蠢欲动了，帮忙多雇佣一些佣兵维护浮空岛安全"/utf8>>};

get_task(1,9,9) ->
    #base_journey_task{suit = 1,map = 9,task = 9,task_type = 1,cons = 1288,unlock = 8,desc = <<"我这里有个好东西，你要不要了解下"/utf8>>};

get_task(1,9,10) ->
    #base_journey_task{suit = 1,map = 9,task = 10,task_type = 1,cons = 1988,unlock = 9,desc = <<"这是雀灵之国新发现的珍稀秘宝，特价销售仅此一次哦"/utf8>>};

get_task(2,1,1) ->
    #base_journey_task{suit = 2,map = 1,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,1,2) ->
    #base_journey_task{suit = 2,map = 1,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,1,3) ->
    #base_journey_task{suit = 2,map = 1,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,1,4) ->
    #base_journey_task{suit = 2,map = 1,task = 4,task_type = 3,cons = 2000,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,1,5) ->
    #base_journey_task{suit = 2,map = 1,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,1,6) ->
    #base_journey_task{suit = 2,map = 1,task = 6,task_type = 2,cons = 55,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,1,7) ->
    #base_journey_task{suit = 2,map = 1,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,1,8) ->
    #base_journey_task{suit = 2,map = 1,task = 8,task_type = 1,cons = 38,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,1,9) ->
    #base_journey_task{suit = 2,map = 1,task = 9,task_type = 1,cons = 58,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,1,10) ->
    #base_journey_task{suit = 2,map = 1,task = 10,task_type = 1,cons = 128,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,2,1) ->
    #base_journey_task{suit = 2,map = 2,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,2,2) ->
    #base_journey_task{suit = 2,map = 2,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,2,3) ->
    #base_journey_task{suit = 2,map = 2,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,2,4) ->
    #base_journey_task{suit = 2,map = 2,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,2,5) ->
    #base_journey_task{suit = 2,map = 2,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,2,6) ->
    #base_journey_task{suit = 2,map = 2,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,2,7) ->
    #base_journey_task{suit = 2,map = 2,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,2,8) ->
    #base_journey_task{suit = 2,map = 2,task = 8,task_type = 4,cons = 1000,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,2,9) ->
    #base_journey_task{suit = 2,map = 2,task = 9,task_type = 1,cons = 58,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,2,10) ->
    #base_journey_task{suit = 2,map = 2,task = 10,task_type = 1,cons = 138,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,3,1) ->
    #base_journey_task{suit = 2,map = 3,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,3,2) ->
    #base_journey_task{suit = 2,map = 3,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,3,3) ->
    #base_journey_task{suit = 2,map = 3,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,3,4) ->
    #base_journey_task{suit = 2,map = 3,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,3,5) ->
    #base_journey_task{suit = 2,map = 3,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,3,6) ->
    #base_journey_task{suit = 2,map = 3,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,3,7) ->
    #base_journey_task{suit = 2,map = 3,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,3,8) ->
    #base_journey_task{suit = 2,map = 3,task = 8,task_type = 1,cons = 38,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,3,9) ->
    #base_journey_task{suit = 2,map = 3,task = 9,task_type = 1,cons = 58,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,3,10) ->
    #base_journey_task{suit = 2,map = 3,task = 10,task_type = 1,cons = 148,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,4,1) ->
    #base_journey_task{suit = 2,map = 4,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,4,2) ->
    #base_journey_task{suit = 2,map = 4,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,4,3) ->
    #base_journey_task{suit = 2,map = 4,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,4,4) ->
    #base_journey_task{suit = 2,map = 4,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,4,5) ->
    #base_journey_task{suit = 2,map = 4,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,4,6) ->
    #base_journey_task{suit = 2,map = 4,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,4,7) ->
    #base_journey_task{suit = 2,map = 4,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,4,8) ->
    #base_journey_task{suit = 2,map = 4,task = 8,task_type = 1,cons = 38,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,4,9) ->
    #base_journey_task{suit = 2,map = 4,task = 9,task_type = 1,cons = 58,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,4,10) ->
    #base_journey_task{suit = 2,map = 4,task = 10,task_type = 1,cons = 158,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,5,1) ->
    #base_journey_task{suit = 2,map = 5,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,5,2) ->
    #base_journey_task{suit = 2,map = 5,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔，维护世界和平。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,5,3) ->
    #base_journey_task{suit = 2,map = 5,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,5,4) ->
    #base_journey_task{suit = 2,map = 5,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,5,5) ->
    #base_journey_task{suit = 2,map = 5,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,5,6) ->
    #base_journey_task{suit = 2,map = 5,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,5,7) ->
    #base_journey_task{suit = 2,map = 5,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,5,8) ->
    #base_journey_task{suit = 2,map = 5,task = 8,task_type = 1,cons = 38,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,5,9) ->
    #base_journey_task{suit = 2,map = 5,task = 9,task_type = 1,cons = 58,unlock = 8,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,5,10) ->
    #base_journey_task{suit = 2,map = 5,task = 10,task_type = 1,cons = 88,unlock = 8,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,6,1) ->
    #base_journey_task{suit = 2,map = 6,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,6,2) ->
    #base_journey_task{suit = 2,map = 6,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,6,3) ->
    #base_journey_task{suit = 2,map = 6,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,6,4) ->
    #base_journey_task{suit = 2,map = 6,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,6,5) ->
    #base_journey_task{suit = 2,map = 6,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,6,6) ->
    #base_journey_task{suit = 2,map = 6,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,6,7) ->
    #base_journey_task{suit = 2,map = 6,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,6,8) ->
    #base_journey_task{suit = 2,map = 6,task = 8,task_type = 1,cons = 38,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,6,9) ->
    #base_journey_task{suit = 2,map = 6,task = 9,task_type = 1,cons = 58,unlock = 8,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,6,10) ->
    #base_journey_task{suit = 2,map = 6,task = 10,task_type = 1,cons = 98,unlock = 8,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,7,1) ->
    #base_journey_task{suit = 2,map = 7,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,7,2) ->
    #base_journey_task{suit = 2,map = 7,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,7,3) ->
    #base_journey_task{suit = 2,map = 7,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,7,4) ->
    #base_journey_task{suit = 2,map = 7,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,7,5) ->
    #base_journey_task{suit = 2,map = 7,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,7,6) ->
    #base_journey_task{suit = 2,map = 7,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,7,7) ->
    #base_journey_task{suit = 2,map = 7,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,7,8) ->
    #base_journey_task{suit = 2,map = 7,task = 8,task_type = 1,cons = 38,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,7,9) ->
    #base_journey_task{suit = 2,map = 7,task = 9,task_type = 1,cons = 58,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,7,10) ->
    #base_journey_task{suit = 2,map = 7,task = 10,task_type = 1,cons = 108,unlock = 9,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,8,1) ->
    #base_journey_task{suit = 2,map = 8,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,8,2) ->
    #base_journey_task{suit = 2,map = 8,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,8,3) ->
    #base_journey_task{suit = 2,map = 8,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,8,4) ->
    #base_journey_task{suit = 2,map = 8,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,8,5) ->
    #base_journey_task{suit = 2,map = 8,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,8,6) ->
    #base_journey_task{suit = 2,map = 8,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,8,7) ->
    #base_journey_task{suit = 2,map = 8,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,8,8) ->
    #base_journey_task{suit = 2,map = 8,task = 8,task_type = 1,cons = 38,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,8,9) ->
    #base_journey_task{suit = 2,map = 8,task = 9,task_type = 1,cons = 58,unlock = 8,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,8,10) ->
    #base_journey_task{suit = 2,map = 8,task = 10,task_type = 1,cons = 118,unlock = 8,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,9,1) ->
    #base_journey_task{suit = 2,map = 9,task = 1,task_type = 5,cons = 1,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,9,2) ->
    #base_journey_task{suit = 2,map = 9,task = 2,task_type = 5,cons = 2,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,9,3) ->
    #base_journey_task{suit = 2,map = 9,task = 3,task_type = 5,cons = 3,unlock = 0,desc = <<"变异机体又变为幻魔到处破坏了，请帮忙击杀%s个幻魔。(次元幻魔、星域幻魔)"/utf8>>};

get_task(2,9,4) ->
    #base_journey_task{suit = 2,map = 9,task = 4,task_type = 3,cons = 2500,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,9,5) ->
    #base_journey_task{suit = 2,map = 9,task = 5,task_type = 2,cons = 18,unlock = 0,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,9,6) ->
    #base_journey_task{suit = 2,map = 9,task = 6,task_type = 2,cons = 50,unlock = 0,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,9,7) ->
    #base_journey_task{suit = 2,map = 9,task = 7,task_type = 1,cons = 18,unlock = 0,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(2,9,8) ->
    #base_journey_task{suit = 2,map = 9,task = 8,task_type = 1,cons = 38,unlock = 7,desc = <<"我需要在黑市上买点特殊材料，你可以帮我吗"/utf8>>};

get_task(2,9,9) ->
    #base_journey_task{suit = 2,map = 9,task = 9,task_type = 1,cons = 58,unlock = 7,desc = <<"麻烦派遣一些雇佣兵维护浮空岛安全"/utf8>>};

get_task(2,9,10) ->
    #base_journey_task{suit = 2,map = 9,task = 10,task_type = 1,cons = 128,unlock = 7,desc = <<"研究经费用完了，需要补充一些经费"/utf8>>};

get_task(_Suit,_Map,_Task) ->
    [].

%%这是雀灵之国新发现的珍稀秘宝，特价销售仅此一次哦
get_suit_task(1) ->
    [{1,1},{1,2},{1,3},{1,4},{1,5},{1,6},{1,7},{1,8},{1,9},{1,10},{2,1},{2,2},{2,3},{2,4},{2,5},{2,6},{2,7},{2,8},{2,9},{2,10},{3,1},{3,2},{3,3},{3,4},{3,5},{3,6},{3,7},{3,8},{3,9},{3,10},{4,1},{4,2},{4,3},{4,4},{4,5},{4,6},{4,7},{4,8},{4,9},{4,10},{5,1},{5,2},{5,3},{5,4},{5,5},{5,6},{5,7},{5,8},{5,9},{5,10},{6,1},{6,2},{6,3},{6,4},{6,5},{6,6},{6,7},{6,8},{6,9},{6,10},{7,1},{7,2},{7,3},{7,4},{7,5},{7,6},{7,7},{7,8},{7,9},{7,10},{8,1},{8,2},{8,3},{8,4},{8,5},{8,6},{8,7},{8,8},{8,9},{8,10},{9,1},{9,2},{9,3},{9,4},{9,5},{9,6},{9,7},{9,8},{9,9},{9,10}];

%%研究经费用完了，需要补充一些经费
get_suit_task(2) ->
    [{1,1},{1,2},{1,3},{1,4},{1,5},{1,6},{1,7},{1,8},{1,9},{1,10},{2,1},{2,2},{2,3},{2,4},{2,5},{2,6},{2,7},{2,8},{2,9},{2,10},{3,1},{3,2},{3,3},{3,4},{3,5},{3,6},{3,7},{3,8},{3,9},{3,10},{4,1},{4,2},{4,3},{4,4},{4,5},{4,6},{4,7},{4,8},{4,9},{4,10},{5,1},{5,2},{5,3},{5,4},{5,5},{5,6},{5,7},{5,8},{5,9},{5,10},{6,1},{6,2},{6,3},{6,4},{6,5},{6,6},{6,7},{6,8},{6,9},{6,10},{7,1},{7,2},{7,3},{7,4},{7,5},{7,6},{7,7},{7,8},{7,9},{7,10},{8,1},{8,2},{8,3},{8,4},{8,5},{8,6},{8,7},{8,8},{8,9},{8,10},{9,1},{9,2},{9,3},{9,4},{9,5},{9,6},{9,7},{9,8},{9,9},{9,10}];

get_suit_task(_Suit) ->
    [].

get_suit_map_task(1,1) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,2) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,3) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,4) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,5) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,6) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,7) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,8) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(1,9) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,1) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,2) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,3) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,4) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,5) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,6) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,7) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,8) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(2,9) ->
    [1,2,3,4,5,6,7,8,9,10];

get_suit_map_task(_Suit,_Map) ->
    [].

%%这是雀灵之国新发现的珍稀秘宝，特价销售仅此一次哦
get_suit_map(1) ->
    [1,2,3,4,5,6,7,8,9];

%%研究经费用完了，需要补充一些经费
get_suit_map(2) ->
    [1,2,3,4,5,6,7,8,9];

get_suit_map(_Suit) ->
    [].

get_award(1,0,1) ->
    #base_journey_award{act = 1,map = 0,grade = 1,desc = <<"主界面大奖展示"/utf8>>,award = [{100,401003,30}],weight = 0,days = [1,999]};

get_award(1,0,2) ->
    #base_journey_award{act = 1,map = 0,grade = 2,desc = <<"主界面大奖展示"/utf8>>,award = [{100,250102,30}],weight = 0,days = [1,999]};

get_award(1,0,3) ->
    #base_journey_award{act = 1,map = 0,grade = 3,desc = <<"主界面大奖展示"/utf8>>,award = [{100,109035,1}],weight = 0,days = [1,999]};

get_award(1,0,4) ->
    #base_journey_award{act = 1,map = 0,grade = 4,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102408,1}],weight = 0,days = [1,999]};

get_award(1,0,5) ->
    #base_journey_award{act = 1,map = 0,grade = 5,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102407,1}],weight = 0,days = [1,999]};

get_award(1,0,6) ->
    #base_journey_award{act = 1,map = 0,grade = 6,desc = <<"主界面大奖展示"/utf8>>,award = [{100,252241,1}],weight = 0,days = [1,999]};

get_award(1,0,7) ->
    #base_journey_award{act = 1,map = 0,grade = 7,desc = <<"主界面大奖展示"/utf8>>,award = [{100,252242,1}],weight = 0,days = [1,999]};

get_award(1,0,8) ->
    #base_journey_award{act = 1,map = 0,grade = 8,desc = <<"主界面大奖展示"/utf8>>,award = [{100,450020,1}],weight = 0,days = [1,999]};

get_award(1,0,9) ->
    #base_journey_award{act = 1,map = 0,grade = 9,desc = <<"主界面大奖展示"/utf8>>,award = [{100,450022,1}],weight = 0,days = [1,999]};

get_award(1,1,1) ->
    #base_journey_award{act = 1,map = 1,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102305,3}],weight = 20,days = [1,999]};

get_award(1,1,2) ->
    #base_journey_award{act = 1,map = 1,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450024,2}],weight = 100,days = [1,999]};

get_award(1,1,3) ->
    #base_journey_award{act = 1,map = 1,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450023,3}],weight = 200,days = [1,999]};

get_award(1,1,4) ->
    #base_journey_award{act = 1,map = 1,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330902,1}],weight = 500,days = [1,999]};

get_award(1,1,5) ->
    #base_journey_award{act = 1,map = 1,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109032,2}],weight = 1000,days = [1,999]};

get_award(1,1,6) ->
    #base_journey_award{act = 1,map = 1,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330901,3}],weight = 1000,days = [1,999]};

get_award(1,1,7) ->
    #base_journey_award{act = 1,map = 1,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 3000,days = [1,999]};

get_award(1,1,8) ->
    #base_journey_award{act = 1,map = 1,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450025,2}],weight = 3000,days = [1,999]};

get_award(1,1,9) ->
    #base_journey_award{act = 1,map = 1,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109031,2}],weight = 500000,days = [1,999]};

get_award(1,1,10) ->
    #base_journey_award{act = 1,map = 1,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102402,5}],weight = 5000000,days = [1,999]};

get_award(1,2,1) ->
    #base_journey_award{act = 1,map = 2,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,250102,5}],weight = 20,days = [1,999]};

get_award(1,2,2) ->
    #base_journey_award{act = 1,map = 2,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,2}],weight = 100,days = [1,999]};

get_award(1,2,3) ->
    #base_journey_award{act = 1,map = 2,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102305,1}],weight = 200,days = [1,999]};

get_award(1,2,4) ->
    #base_journey_award{act = 1,map = 2,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,251005,3}],weight = 500,days = [1,999]};

get_award(1,2,5) ->
    #base_journey_award{act = 1,map = 2,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450023,10}],weight = 1000,days = [1,999]};

get_award(1,2,6) ->
    #base_journey_award{act = 1,map = 2,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450024,2}],weight = 1000,days = [1,999]};

get_award(1,2,7) ->
    #base_journey_award{act = 1,map = 2,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450026,3}],weight = 30000,days = [1,999]};

get_award(1,2,8) ->
    #base_journey_award{act = 1,map = 2,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450025,4}],weight = 30000,days = [1,999]};

get_award(1,2,9) ->
    #base_journey_award{act = 1,map = 2,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500000,days = [1,999]};

get_award(1,2,10) ->
    #base_journey_award{act = 1,map = 2,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109032,1}],weight = 5000000,days = [1,999]};

get_award(1,3,1) ->
    #base_journey_award{act = 1,map = 3,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,3}],weight = 20,days = [1,999]};

get_award(1,3,2) ->
    #base_journey_award{act = 1,map = 3,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450021,1}],weight = 100,days = [1,999]};

get_award(1,3,3) ->
    #base_journey_award{act = 1,map = 3,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,252012,1}],weight = 200,days = [1,999]};

get_award(1,3,4) ->
    #base_journey_award{act = 1,map = 3,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102305,1}],weight = 500,days = [1,999]};

get_award(1,3,5) ->
    #base_journey_award{act = 1,map = 3,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450024,2}],weight = 1000,days = [1,999]};

get_award(1,3,6) ->
    #base_journey_award{act = 1,map = 3,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450023,6}],weight = 1000,days = [1,999]};

get_award(1,3,7) ->
    #base_journey_award{act = 1,map = 3,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109033,1}],weight = 3000,days = [1,999]};

get_award(1,3,8) ->
    #base_journey_award{act = 1,map = 3,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 3000,days = [1,999]};

get_award(1,3,9) ->
    #base_journey_award{act = 1,map = 3,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,251005,1}],weight = 500000,days = [1,999]};

get_award(1,3,10) ->
    #base_journey_award{act = 1,map = 3,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330901,3}],weight = 5000000,days = [1,999]};

get_award(1,4,1) ->
    #base_journey_award{act = 1,map = 4,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,5}],weight = 20,days = [1,999]};

get_award(1,4,2) ->
    #base_journey_award{act = 1,map = 4,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450019,1}],weight = 100,days = [1,999]};

get_award(1,4,3) ->
    #base_journey_award{act = 1,map = 4,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,270013,6}],weight = 200,days = [1,999]};

get_award(1,4,4) ->
    #base_journey_award{act = 1,map = 4,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450024,3}],weight = 500,days = [1,999]};

get_award(1,4,5) ->
    #base_journey_award{act = 1,map = 4,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450023,7}],weight = 1000,days = [1,999]};

get_award(1,4,6) ->
    #base_journey_award{act = 1,map = 4,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,2}],weight = 1000,days = [1,999]};

get_award(1,4,7) ->
    #base_journey_award{act = 1,map = 4,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109032,2}],weight = 3000,days = [1,999]};

get_award(1,4,8) ->
    #base_journey_award{act = 1,map = 4,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330902,1}],weight = 500000,days = [1,999]};

get_award(1,4,9) ->
    #base_journey_award{act = 1,map = 4,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,251002,1}],weight = 500000,days = [1,999]};

get_award(1,4,10) ->
    #base_journey_award{act = 1,map = 4,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,101014,20}],weight = 5000000,days = [1,999]};

get_award(1,5,1) ->
    #base_journey_award{act = 1,map = 5,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,5}],weight = 20,days = [1,999]};

get_award(1,5,2) ->
    #base_journey_award{act = 1,map = 5,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,250102,5}],weight = 100,days = [1,999]};

get_award(1,5,3) ->
    #base_journey_award{act = 1,map = 5,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102305,2}],weight = 200,days = [1,999]};

get_award(1,5,4) ->
    #base_journey_award{act = 1,map = 5,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450026,6}],weight = 500,days = [1,999]};

get_award(1,5,5) ->
    #base_journey_award{act = 1,map = 5,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102305,1}],weight = 1000,days = [1,999]};

get_award(1,5,6) ->
    #base_journey_award{act = 1,map = 5,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450024,2}],weight = 1000,days = [1,999]};

get_award(1,5,7) ->
    #base_journey_award{act = 1,map = 5,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450023,3}],weight = 3000,days = [1,999]};

get_award(1,5,8) ->
    #base_journey_award{act = 1,map = 5,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109033,1}],weight = 3000,days = [1,999]};

get_award(1,5,9) ->
    #base_journey_award{act = 1,map = 5,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500000,days = [1,999]};

get_award(1,5,10) ->
    #base_journey_award{act = 1,map = 5,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450025,1}],weight = 5000000,days = [1,999]};

get_award(1,6,1) ->
    #base_journey_award{act = 1,map = 6,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,5}],weight = 20,days = [1,999]};

get_award(1,6,2) ->
    #base_journey_award{act = 1,map = 6,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450015,1}],weight = 100,days = [1,999]};

get_award(1,6,3) ->
    #base_journey_award{act = 1,map = 6,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,250102,3}],weight = 200,days = [1,999]};

get_award(1,6,4) ->
    #base_journey_award{act = 1,map = 6,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450024,3}],weight = 500,days = [1,999]};

get_award(1,6,5) ->
    #base_journey_award{act = 1,map = 6,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109034,1}],weight = 1000,days = [1,999]};

get_award(1,6,6) ->
    #base_journey_award{act = 1,map = 6,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 1000,days = [1,999]};

get_award(1,6,7) ->
    #base_journey_award{act = 1,map = 6,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330902,2}],weight = 3000,days = [1,999]};

get_award(1,6,8) ->
    #base_journey_award{act = 1,map = 6,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450026,2}],weight = 3000,days = [1,999]};

get_award(1,6,9) ->
    #base_journey_award{act = 1,map = 6,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,101014,30}],weight = 500000,days = [1,999]};

get_award(1,6,10) ->
    #base_journey_award{act = 1,map = 6,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109031,2}],weight = 5000000,days = [1,999]};

get_award(1,7,1) ->
    #base_journey_award{act = 1,map = 7,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,5}],weight = 20,days = [1,999]};

get_award(1,7,2) ->
    #base_journey_award{act = 1,map = 7,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450020,1}],weight = 100,days = [1,999]};

get_award(1,7,3) ->
    #base_journey_award{act = 1,map = 7,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102305,2}],weight = 200,days = [1,999]};

get_award(1,7,4) ->
    #base_journey_award{act = 1,map = 7,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450023,10}],weight = 500,days = [1,999]};

get_award(1,7,5) ->
    #base_journey_award{act = 1,map = 7,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330902,3}],weight = 1000,days = [1,999]};

get_award(1,7,6) ->
    #base_journey_award{act = 1,map = 7,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450025,5}],weight = 1000,days = [1,999]};

get_award(1,7,7) ->
    #base_journey_award{act = 1,map = 7,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109032,3}],weight = 3000,days = [1,999]};

get_award(1,7,8) ->
    #base_journey_award{act = 1,map = 7,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330901,5}],weight = 3000,days = [1,999]};

get_award(1,7,9) ->
    #base_journey_award{act = 1,map = 7,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,251008,1}],weight = 500000,days = [1,999]};

get_award(1,7,10) ->
    #base_journey_award{act = 1,map = 7,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102009,2}],weight = 5000000,days = [1,999]};

get_award(1,8,1) ->
    #base_journey_award{act = 1,map = 8,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,5}],weight = 20,days = [1,999]};

get_award(1,8,2) ->
    #base_journey_award{act = 1,map = 8,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450022,1}],weight = 100,days = [1,999]};

get_award(1,8,3) ->
    #base_journey_award{act = 1,map = 8,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,250102,4}],weight = 200,days = [1,999]};

get_award(1,8,4) ->
    #base_journey_award{act = 1,map = 8,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450008,1}],weight = 500,days = [1,999]};

get_award(1,8,5) ->
    #base_journey_award{act = 1,map = 8,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109033,2}],weight = 1000,days = [1,999]};

get_award(1,8,6) ->
    #base_journey_award{act = 1,map = 8,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450023,5}],weight = 1000,days = [1,999]};

get_award(1,8,7) ->
    #base_journey_award{act = 1,map = 8,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,450024,1}],weight = 3000,days = [1,999]};

get_award(1,8,8) ->
    #base_journey_award{act = 1,map = 8,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,2}],weight = 3000,days = [1,999]};

get_award(1,8,9) ->
    #base_journey_award{act = 1,map = 8,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109032,3}],weight = 500000,days = [1,999]};

get_award(1,8,10) ->
    #base_journey_award{act = 1,map = 8,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330902,1}],weight = 5000000,days = [1,999]};

get_award(1,9,1) ->
    #base_journey_award{act = 1,map = 9,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,401003,30}],weight = 20,days = [1,999]};

get_award(1,9,2) ->
    #base_journey_award{act = 1,map = 9,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 100,days = [1,999]};

get_award(1,9,3) ->
    #base_journey_award{act = 1,map = 9,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,252241,1}],weight = 200,days = [1,999]};

get_award(1,9,4) ->
    #base_journey_award{act = 1,map = 9,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,252242,1}],weight = 500,days = [1,999]};

get_award(1,9,5) ->
    #base_journey_award{act = 1,map = 9,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109035,1}],weight = 1000,days = [1,999]};

get_award(1,9,6) ->
    #base_journey_award{act = 1,map = 9,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 1000,days = [1,999]};

get_award(1,9,7) ->
    #base_journey_award{act = 1,map = 9,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,270013,3}],weight = 3000,days = [1,999]};

get_award(1,9,8) ->
    #base_journey_award{act = 1,map = 9,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102305,1}],weight = 3000,days = [1,999]};

get_award(1,9,9) ->
    #base_journey_award{act = 1,map = 9,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109033,2}],weight = 500000,days = [1,999]};

get_award(1,9,10) ->
    #base_journey_award{act = 1,map = 9,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,330902,2}],weight = 5000000,days = [1,999]};

get_award(2,0,1) ->
    #base_journey_award{act = 2,map = 0,grade = 1,desc = <<"主界面大奖展示"/utf8>>,award = [{100,402001,1}],weight = 0,days = [1,999]};

get_award(2,0,2) ->
    #base_journey_award{act = 2,map = 0,grade = 2,desc = <<"主界面大奖展示"/utf8>>,award = [{100,403006,1}],weight = 0,days = [1,999]};

get_award(2,0,3) ->
    #base_journey_award{act = 2,map = 0,grade = 3,desc = <<"主界面大奖展示"/utf8>>,award = [{100,109012,1}],weight = 0,days = [1,999]};

get_award(2,0,4) ->
    #base_journey_award{act = 2,map = 0,grade = 4,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102408,1}],weight = 0,days = [1,999]};

get_award(2,0,5) ->
    #base_journey_award{act = 2,map = 0,grade = 5,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102407,1}],weight = 0,days = [1,999]};

get_award(2,0,6) ->
    #base_journey_award{act = 2,map = 0,grade = 6,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102406,1}],weight = 0,days = [1,999]};

get_award(2,0,7) ->
    #base_journey_award{act = 2,map = 0,grade = 7,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102405,1}],weight = 0,days = [1,999]};

get_award(2,0,8) ->
    #base_journey_award{act = 2,map = 0,grade = 8,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102404,1}],weight = 0,days = [1,999]};

get_award(2,0,9) ->
    #base_journey_award{act = 2,map = 0,grade = 9,desc = <<"主界面大奖展示"/utf8>>,award = [{100,102403,1}],weight = 0,days = [1,999]};

get_award(2,1,1) ->
    #base_journey_award{act = 2,map = 1,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109019,10}],weight = 20,days = [1,999]};

get_award(2,1,2) ->
    #base_journey_award{act = 2,map = 1,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109018,1}],weight = 100,days = [1,999]};

get_award(2,1,3) ->
    #base_journey_award{act = 2,map = 1,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,1,4) ->
    #base_journey_award{act = 2,map = 1,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,1,5) ->
    #base_journey_award{act = 2,map = 1,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,1,6) ->
    #base_journey_award{act = 2,map = 1,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,1,7) ->
    #base_journey_award{act = 2,map = 1,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,1,8) ->
    #base_journey_award{act = 2,map = 1,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,1,9) ->
    #base_journey_award{act = 2,map = 1,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109017,1}],weight = 3000,days = [1,999]};

get_award(2,1,10) ->
    #base_journey_award{act = 2,map = 1,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109016,1}],weight = 3000,days = [1,999]};

get_award(2,2,1) ->
    #base_journey_award{act = 2,map = 2,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109029,1}],weight = 20,days = [1,999]};

get_award(2,2,2) ->
    #base_journey_award{act = 2,map = 2,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109028,1}],weight = 100,days = [1,999]};

get_award(2,2,3) ->
    #base_journey_award{act = 2,map = 2,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,2,4) ->
    #base_journey_award{act = 2,map = 2,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,2,5) ->
    #base_journey_award{act = 2,map = 2,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,2,6) ->
    #base_journey_award{act = 2,map = 2,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,2,7) ->
    #base_journey_award{act = 2,map = 2,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,2,8) ->
    #base_journey_award{act = 2,map = 2,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,2,9) ->
    #base_journey_award{act = 2,map = 2,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109027,1}],weight = 3000,days = [1,999]};

get_award(2,2,10) ->
    #base_journey_award{act = 2,map = 2,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109026,1}],weight = 3000,days = [1,999]};

get_award(2,3,1) ->
    #base_journey_award{act = 2,map = 3,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109009,1}],weight = 20,days = [1,999]};

get_award(2,3,2) ->
    #base_journey_award{act = 2,map = 3,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109008,1}],weight = 100,days = [1,999]};

get_award(2,3,3) ->
    #base_journey_award{act = 2,map = 3,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,3,4) ->
    #base_journey_award{act = 2,map = 3,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,3,5) ->
    #base_journey_award{act = 2,map = 3,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,3,6) ->
    #base_journey_award{act = 2,map = 3,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,3,7) ->
    #base_journey_award{act = 2,map = 3,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,3,8) ->
    #base_journey_award{act = 2,map = 3,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,3,9) ->
    #base_journey_award{act = 2,map = 3,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109007,1}],weight = 3000,days = [1,999]};

get_award(2,3,10) ->
    #base_journey_award{act = 2,map = 3,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109006,1}],weight = 3000,days = [1,999]};

get_award(2,4,1) ->
    #base_journey_award{act = 2,map = 4,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,403005,1}],weight = 20,days = [1,999]};

get_award(2,4,2) ->
    #base_journey_award{act = 2,map = 4,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109012,1}],weight = 100,days = [1,999]};

get_award(2,4,3) ->
    #base_journey_award{act = 2,map = 4,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,4,4) ->
    #base_journey_award{act = 2,map = 4,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,4,5) ->
    #base_journey_award{act = 2,map = 4,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,4,6) ->
    #base_journey_award{act = 2,map = 4,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,4,7) ->
    #base_journey_award{act = 2,map = 4,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,4,8) ->
    #base_journey_award{act = 2,map = 4,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,4,9) ->
    #base_journey_award{act = 2,map = 4,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109017,1}],weight = 3000,days = [1,999]};

get_award(2,4,10) ->
    #base_journey_award{act = 2,map = 4,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109016,1}],weight = 3000,days = [1,999]};

get_award(2,5,1) ->
    #base_journey_award{act = 2,map = 5,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,402000,1}],weight = 20,days = [1,999]};

get_award(2,5,2) ->
    #base_journey_award{act = 2,map = 5,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109028,1}],weight = 100,days = [1,999]};

get_award(2,5,3) ->
    #base_journey_award{act = 2,map = 5,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,5,4) ->
    #base_journey_award{act = 2,map = 5,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,5,5) ->
    #base_journey_award{act = 2,map = 5,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,5,6) ->
    #base_journey_award{act = 2,map = 5,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,5,7) ->
    #base_journey_award{act = 2,map = 5,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,5,8) ->
    #base_journey_award{act = 2,map = 5,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,5,9) ->
    #base_journey_award{act = 2,map = 5,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109027,1}],weight = 3000,days = [1,999]};

get_award(2,5,10) ->
    #base_journey_award{act = 2,map = 5,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109026,1}],weight = 3000,days = [1,999]};

get_award(2,6,1) ->
    #base_journey_award{act = 2,map = 6,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109009,1}],weight = 20,days = [1,999]};

get_award(2,6,2) ->
    #base_journey_award{act = 2,map = 6,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109008,1}],weight = 100,days = [1,999]};

get_award(2,6,3) ->
    #base_journey_award{act = 2,map = 6,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,6,4) ->
    #base_journey_award{act = 2,map = 6,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 5000000,days = [1,999]};

get_award(2,6,5) ->
    #base_journey_award{act = 2,map = 6,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500000,days = [1,999]};

get_award(2,6,6) ->
    #base_journey_award{act = 2,map = 6,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,6,7) ->
    #base_journey_award{act = 2,map = 6,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,6,8) ->
    #base_journey_award{act = 2,map = 6,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,6,9) ->
    #base_journey_award{act = 2,map = 6,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109007,1}],weight = 3000,days = [1,999]};

get_award(2,6,10) ->
    #base_journey_award{act = 2,map = 6,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109006,1}],weight = 3000,days = [1,999]};

get_award(2,7,1) ->
    #base_journey_award{act = 2,map = 7,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109019,3}],weight = 20,days = [1,999]};

get_award(2,7,2) ->
    #base_journey_award{act = 2,map = 7,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109018,3}],weight = 10000000,days = [1,999]};

get_award(2,7,3) ->
    #base_journey_award{act = 2,map = 7,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,3}],weight = 200,days = [1,999]};

get_award(2,7,4) ->
    #base_journey_award{act = 2,map = 7,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,7,5) ->
    #base_journey_award{act = 2,map = 7,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,7,6) ->
    #base_journey_award{act = 2,map = 7,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,7,7) ->
    #base_journey_award{act = 2,map = 7,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,7,8) ->
    #base_journey_award{act = 2,map = 7,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,7,9) ->
    #base_journey_award{act = 2,map = 7,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109017,1}],weight = 3000,days = [1,999]};

get_award(2,7,10) ->
    #base_journey_award{act = 2,map = 7,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109016,1}],weight = 3000,days = [1,999]};

get_award(2,8,1) ->
    #base_journey_award{act = 2,map = 8,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109029,1}],weight = 20,days = [1,999]};

get_award(2,8,2) ->
    #base_journey_award{act = 2,map = 8,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109028,1}],weight = 100,days = [1,999]};

get_award(2,8,3) ->
    #base_journey_award{act = 2,map = 8,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,8,4) ->
    #base_journey_award{act = 2,map = 8,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,8,5) ->
    #base_journey_award{act = 2,map = 8,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,8,6) ->
    #base_journey_award{act = 2,map = 8,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,8,7) ->
    #base_journey_award{act = 2,map = 8,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,8,8) ->
    #base_journey_award{act = 2,map = 8,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,8,9) ->
    #base_journey_award{act = 2,map = 8,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109027,1}],weight = 3000,days = [1,999]};

get_award(2,8,10) ->
    #base_journey_award{act = 2,map = 8,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109026,1}],weight = 3000,days = [1,999]};

get_award(2,9,1) ->
    #base_journey_award{act = 2,map = 9,grade = 1,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109009,1}],weight = 20,days = [1,999]};

get_award(2,9,2) ->
    #base_journey_award{act = 2,map = 9,grade = 2,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109008,1}],weight = 100,days = [1,999]};

get_award(2,9,3) ->
    #base_journey_award{act = 2,map = 9,grade = 3,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102408,1}],weight = 200,days = [1,999]};

get_award(2,9,4) ->
    #base_journey_award{act = 2,map = 9,grade = 4,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102407,1}],weight = 500,days = [1,999]};

get_award(2,9,5) ->
    #base_journey_award{act = 2,map = 9,grade = 5,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102406,1}],weight = 500,days = [1,999]};

get_award(2,9,6) ->
    #base_journey_award{act = 2,map = 9,grade = 6,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102405,1}],weight = 500,days = [1,999]};

get_award(2,9,7) ->
    #base_journey_award{act = 2,map = 9,grade = 7,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102404,1}],weight = 500,days = [1,999]};

get_award(2,9,8) ->
    #base_journey_award{act = 2,map = 9,grade = 8,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,102403,1}],weight = 500,days = [1,999]};

get_award(2,9,9) ->
    #base_journey_award{act = 2,map = 9,grade = 9,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109007,1}],weight = 3000,days = [1,999]};

get_award(2,9,10) ->
    #base_journey_award{act = 2,map = 9,grade = 10,desc = <<"第一天数阶段，day_min为1"/utf8>>,award = [{100,109006,1}],weight = 3000,days = [1,999]};

get_award(_Act,_Map,_Grade) ->
    [].

get_map_award(1,0) ->
    [1,2,3,4,5,6,7,8,9];

get_map_award(1,1) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,2) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,3) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,4) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,5) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,6) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,7) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,8) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(1,9) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,0) ->
    [1,2,3,4,5,6,7,8,9];

get_map_award(2,1) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,2) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,3) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,4) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,5) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,6) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,7) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,8) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(2,9) ->
    [1,2,3,4,5,6,7,8,9,10];

get_map_award(_Act,_Map) ->
    [].

