%%%---------------------------------------
%%% module      : data_dungeon_child
%%% description : 宝宝副本配置
%%%
%%%---------------------------------------
-module(data_dungeon_child).
-compile(export_all).
-include("dungeon_child.hrl").




get_dun_child_kv_cfg(tower_cd) ->
    10;


get_dun_child_kv_cfg(ice_tower_id) ->
    2300501;


get_dun_child_kv_cfg(run_away_num) ->
    5;


get_dun_child_kv_cfg(clean_cd_cost) ->
    10;


get_dun_child_kv_cfg(fire_tower_id) ->
    2300502;


get_dun_child_kv_cfg(time_light_color) ->
    15;


get_dun_child_kv_cfg(mon_born) ->
    [{1,1,[3024,4246]},{2,1,[3137,4145]},{3,2,[3224,4047]},{4,3,[3326,3954]},{5,3,[3422,3861]}];


get_dun_child_kv_cfg(mon_death) ->
    [{1,[1066,2102]},{2,[1168,2005]},{3,[1272,1907]}];


get_dun_child_kv_cfg(skill_open) ->
    [{1,502002,0},{2,502003,0},{3,502004,5},{4,502005,10}];


get_dun_child_kv_cfg(energy_max) ->
    150;


get_dun_child_kv_cfg(skill_expends) ->
    [{502002,0},{502003,20},{502004,50},{502005,100}];


get_dun_child_kv_cfg(fall_energy) ->
    [1,2];


get_dun_child_kv_cfg(baby_refresh) ->
    {2113,2926};


get_dun_child_kv_cfg(mon_born_effect) ->
    [{3231,4434},{3435,4250},{3634,4070}];


get_dun_child_kv_cfg(mon_death_effect) ->
    [{1168,2005}];

get_dun_child_kv_cfg(_Key) ->
    [].

get_dun_child_sweep_wave_reward(14001,4) ->
    #dun_child_sweep_cfg{id = 14001,wave = 4,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,8) ->
    #dun_child_sweep_cfg{id = 14001,wave = 8,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,12) ->
    #dun_child_sweep_cfg{id = 14001,wave = 12,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,16) ->
    #dun_child_sweep_cfg{id = 14001,wave = 16,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,20) ->
    #dun_child_sweep_cfg{id = 14001,wave = 20,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,24) ->
    #dun_child_sweep_cfg{id = 14001,wave = 24,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,28) ->
    #dun_child_sweep_cfg{id = 14001,wave = 28,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,32) ->
    #dun_child_sweep_cfg{id = 14001,wave = 32,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,36) ->
    #dun_child_sweep_cfg{id = 14001,wave = 36,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,40) ->
    #dun_child_sweep_cfg{id = 14001,wave = 40,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,44) ->
    #dun_child_sweep_cfg{id = 14001,wave = 44,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,48) ->
    #dun_child_sweep_cfg{id = 14001,wave = 48,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(14001,50) ->
    #dun_child_sweep_cfg{id = 14001,wave = 50,mon_reward = [{0,260004,1}],remark = "副本定义波数"};

get_dun_child_sweep_wave_reward(_Id,_Wave) ->
    [].

get_dun_child_sweep_wave(14001,Wave) when Wave >= 50 ->
		50;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 48 ->
		48;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 44 ->
		44;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 40 ->
		40;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 36 ->
		36;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 32 ->
		32;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 28 ->
		28;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 24 ->
		24;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 20 ->
		20;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 16 ->
		16;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 12 ->
		12;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 8 ->
		8;
get_dun_child_sweep_wave(14001,Wave) when Wave >= 4 ->
		4;
get_dun_child_sweep_wave(_Id,_Wave) ->
    [].


get_wave_mon_run_time(1) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17}];


get_wave_mon_run_time(2) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,22}];


get_wave_mon_run_time(3) ->
    [{1,29},{2,25},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,22}];


get_wave_mon_run_time(4) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,22}];


get_wave_mon_run_time(5) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,22},{10,42}];


get_wave_mon_run_time(6) ->
    [{1,29},{2,25},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,22},{10,42}];


get_wave_mon_run_time(7) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,22},{10,42}];


get_wave_mon_run_time(8) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,22},{10,42}];


get_wave_mon_run_time(9) ->
    [{1,29},{2,25},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,22},{10,42},{11,39}];


get_wave_mon_run_time(10) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,22},{10,42},{11,39}];


get_wave_mon_run_time(11) ->
    [{1,45},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,42},{11,39}];


get_wave_mon_run_time(12) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,42},{11,39}];


get_wave_mon_run_time(13) ->
    [{1,29},{2,25},{3,21},{4,33},{5,33},{6,50},{7,17},{8,37},{9,41},{10,42},{11,39}];


get_wave_mon_run_time(14) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,42},{11,39},{12,22}];


get_wave_mon_run_time(15) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,42},{11,39},{12,22}];


get_wave_mon_run_time(16) ->
    [{1,33},{2,25},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,29},{10,42},{11,39},{12,22}];


get_wave_mon_run_time(17) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,42},{11,39},{12,22}];


get_wave_mon_run_time(18) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,42},{11,39},{12,22}];


get_wave_mon_run_time(19) ->
    [{1,29},{2,33},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,25},{10,42},{11,39},{12,22}];


get_wave_mon_run_time(20) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,42},{11,39},{12,22}];


get_wave_mon_run_time(21) ->
    [{1,45},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(22) ->
    [{1,25},{2,41},{3,41},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,17},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(23) ->
    [{1,29},{2,25},{3,21},{4,33},{5,33},{6,50},{7,17},{8,37},{9,41},{10,41},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(24) ->
    [{1,45},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(25) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,41},{8,37},{9,33},{10,21},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(26) ->
    [{1,33},{2,25},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,29},{10,41},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(27) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(28) ->
    [{1,25},{2,41},{3,17},{4,33},{5,41},{6,50},{7,21},{8,37},{9,33},{10,29},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(29) ->
    [{1,29},{2,33},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,25},{10,41},{11,42},{12,39},{13,22}];


get_wave_mon_run_time(30) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,41},{11,42},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(31) ->
    [{1,45},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,37},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(32) ->
    [{1,25},{2,41},{3,41},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,17},{11,37},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(33) ->
    [{1,29},{2,25},{3,21},{4,37},{5,33},{6,50},{7,17},{8,37},{9,41},{10,41},{11,33},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(34) ->
    [{1,45},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,37},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(35) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,41},{8,37},{9,33},{10,21},{11,37},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(36) ->
    [{1,33},{2,25},{3,21},{4,33},{5,41},{6,37},{7,17},{8,37},{9,29},{10,41},{11,45},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(37) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,37},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(38) ->
    [{1,25},{2,41},{3,17},{4,33},{5,41},{6,50},{7,21},{8,37},{9,33},{10,29},{11,37},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(39) ->
    [{1,37},{2,33},{3,21},{4,33},{5,41},{6,50},{7,17},{8,37},{9,25},{10,41},{11,29},{12,39},{13,22},{14,35}];


get_wave_mon_run_time(40) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,41},{11,37},{12,39},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(41) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,37},{12,21},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(42) ->
    [{1,25},{2,41},{3,41},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,17},{11,37},{12,21},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(43) ->
    [{1,29},{2,25},{3,21},{4,37},{5,21},{6,50},{7,17},{8,37},{9,41},{10,41},{11,33},{12,33},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(44) ->
    [{1,45},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,37},{12,21},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(45) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,41},{8,37},{9,33},{10,21},{11,37},{12,21},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(46) ->
    [{1,33},{2,25},{3,21},{4,33},{5,41},{6,37},{7,21},{8,37},{9,29},{10,41},{11,50},{12,17},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(47) ->
    [{1,50},{2,41},{3,37},{4,33},{5,29},{6,25},{7,21},{8,17},{9,33},{10,41},{11,37},{12,21},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(48) ->
    [{1,25},{2,41},{3,17},{4,33},{5,41},{6,50},{7,21},{8,37},{9,33},{10,29},{11,37},{12,21},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(49) ->
    [{1,37},{2,33},{3,21},{4,33},{5,21},{6,50},{7,17},{8,37},{9,25},{10,41},{11,29},{12,41},{13,22},{14,35},{15,31}];


get_wave_mon_run_time(50) ->
    [{1,25},{2,41},{3,17},{4,33},{5,29},{6,50},{7,21},{8,37},{9,33},{10,41},{11,37},{12,21},{13,22},{14,35},{15,31}];

get_wave_mon_run_time(_Wave) ->
    [].

