%%%---------------------------------------
%%% module      : data_guild_boss
%%% description : 社团BOSS配置
%%%
%%%---------------------------------------
-module(data_guild_boss).
-compile(export_all).
-include("guild_tribe.hrl").
-include("drop.hrl").



%%有效参与时间
get(act_time) ->
    10;

%%每次鼓舞消耗的红钻数量，次数
get(bgold_encourage_cost) ->
    {20,3};

%%BOSS状态
get(boss_step) ->
    [{enter_box,60},{enter_box,60},{enter_box,60},{enter_box,60},{enter_box,60},{enter_box,60},{enter_box,60},{enter_box,60},{enter_box,60},{enter_finish,60}];

%%掉落物范围{x,y,半径}
get(box_pos) ->
    [{2500,2600,800}];

%%持续时间
get(continue_time) ->
    600;

%%掉落物存在时间
get(drop_alive) ->
    60;

%%掉落间距
get(drop_space) ->
    300;

%%鼓舞一次增加伤害万分比
get(encourage_hurt) ->
    500;

%%免费鼓舞次数
get(free_encourage) ->
    2;

%%掉落箱
get(guild_box) ->
    651105;

%%市场展示时间
get(maket_notice_time) ->
    1800;

%%最少分享人数
get(min_share) ->
    10;

%%BOSS坐标
get(mon_pos) ->
    {2500,2600};

%%前N个人数控制
get(mult_drop) ->
    2;

%%社团榜单上榜
get(rank_guild) ->
    10;

%%个人榜单上榜
get(rank_role) ->
    30;

%%实际血量
get(real_hp) ->
    1000000000000000;

%%roll点时间
get(roll_time) ->
    15;

%%BOSS展示奖励
get(show_boss_reward) ->
    [{100,24101014,1},{100,24201024,1},{100,24102034,1},{100,24202044,1},{100,24103054,1},{100,24203064,1},{100,24104074,1},{100,24204014,1},{100,24105024,1},{100,24105034,1},{100,24106044,1},{100,24206054,1}];

%%roll点展示奖励
get(show_roll_reward) ->
    [{100,102405,1},{100,102305,1},{100,101010,1},{100,101016,1},{100,230001,1},{100,230002,1},{100,230003,1},{100,230004,1},{100,230010,1}];

get(_Key) ->
    [].

get_all_boss() ->
    [651001].

get_boss(Lv) when 0 =< Lv, Lv =< 999 ->
		651001;
get_boss(_Lv) ->
    0.

get_awards(1,Rank,Lv,Day,Num) when 1=<Rank,Rank=<1,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{101016,1}],weight=10000}]},{1,[#drop{list=[{101014,10}],weight=10000}]}];
get_awards(1,Rank,Lv,Day,Num) when 2=<Rank,Rank=<3,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{101016,1}],weight=10000}]},{1,[#drop{list=[{101014,8}],weight=10000}]}];
get_awards(1,Rank,Lv,Day,Num) when 4=<Rank,Rank=<10,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{101016,1}],weight=10000}]},{1,[#drop{list=[{101014,6}],weight=10000}]}];
get_awards(1,Rank,Lv,Day,Num) when 11=<Rank,Rank=<20,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{101016,1}],weight=10000}]},{1,[#drop{list=[{101014,5}],weight=10000}]}];
get_awards(1,Rank,Lv,Day,Num) when 21=<Rank,Rank=<99,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{101016,1}],weight=10000}]},{1,[#drop{list=[{101014,4}],weight=10000}]}];
get_awards(2,Rank,Lv,Day,Num) when 1=<Rank,Rank=<3,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{450025,3}],weight=10000}]}];
get_awards(2,Rank,Lv,Day,Num) when 4=<Rank,Rank=<10,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{450025,2}],weight=10000}]}];
get_awards(2,Rank,Lv,Day,Num) when 11=<Rank,Rank=<99,1=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{450025,1}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,1=<Lv,Lv=<130,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24031,2}],weight=10000}]},{1,[#drop{list=[{24031,5}],weight=5000}]},{1,[#drop{list=[{24041,2}],weight=10000}]},{1,[#drop{list=[{24041,1}],weight=5000}]},{1,[#drop{list=[{402000,3}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,1=<Lv,Lv=<130,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24031,4}],weight=10000}]},{1,[#drop{list=[{24031,6}],weight=5000}]},{1,[#drop{list=[{24041,3}],weight=10000}]},{1,[#drop{list=[{24041,1}],weight=5000}]},{1,[#drop{list=[{402000,5}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,1=<Lv,Lv=<130,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24031,6}],weight=10000}]},{1,[#drop{list=[{24031,7}],weight=5000}]},{1,[#drop{list=[{24041,4}],weight=10000}]},{1,[#drop{list=[{24041,2}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,1=<Lv,Lv=<130,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24031,8}],weight=10000}]},{1,[#drop{list=[{24031,8}],weight=5000}]},{1,[#drop{list=[{24041,5}],weight=10000}]},{1,[#drop{list=[{24041,2}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,1=<Lv,Lv=<130,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24031,10}],weight=10000}]},{1,[#drop{list=[{24031,10}],weight=5000}]},{1,[#drop{list=[{24041,6}],weight=10000}]},{1,[#drop{list=[{24041,3}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,131=<Lv,Lv=<230,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24032,2}],weight=10000}]},{1,[#drop{list=[{24032,5}],weight=5000}]},{1,[#drop{list=[{24042,2}],weight=10000}]},{1,[#drop{list=[{24042,1}],weight=5000}]},{1,[#drop{list=[{402000,3}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,131=<Lv,Lv=<230,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24032,4}],weight=10000}]},{1,[#drop{list=[{24032,6}],weight=5000}]},{1,[#drop{list=[{24042,3}],weight=10000}]},{1,[#drop{list=[{24042,1}],weight=5000}]},{1,[#drop{list=[{402000,5}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,131=<Lv,Lv=<230,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24032,6}],weight=10000}]},{1,[#drop{list=[{24032,7}],weight=5000}]},{1,[#drop{list=[{24042,4}],weight=10000}]},{1,[#drop{list=[{24042,2}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,131=<Lv,Lv=<230,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24032,8}],weight=10000}]},{1,[#drop{list=[{24032,8}],weight=5000}]},{1,[#drop{list=[{24042,5}],weight=10000}]},{1,[#drop{list=[{24042,2}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,131=<Lv,Lv=<230,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24032,10}],weight=10000}]},{1,[#drop{list=[{24032,10}],weight=5000}]},{1,[#drop{list=[{24042,6}],weight=10000}]},{1,[#drop{list=[{24042,3}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,231=<Lv,Lv=<320,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24033,2}],weight=10000}]},{1,[#drop{list=[{24033,5}],weight=5000}]},{1,[#drop{list=[{24043,2}],weight=10000}]},{1,[#drop{list=[{24043,1}],weight=5000}]},{1,[#drop{list=[{4500220,2}],weight=6000}]},{1,[#drop{list=[{402000,3}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,231=<Lv,Lv=<320,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24033,4}],weight=10000}]},{1,[#drop{list=[{24033,6}],weight=5000}]},{1,[#drop{list=[{24043,3}],weight=10000}]},{1,[#drop{list=[{24043,1}],weight=5000}]},{1,[#drop{list=[{4500220,3}],weight=6000}]},{1,[#drop{list=[{402000,5}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,231=<Lv,Lv=<320,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24033,6}],weight=10000}]},{1,[#drop{list=[{24033,7}],weight=5000}]},{1,[#drop{list=[{24043,4}],weight=10000}]},{1,[#drop{list=[{24043,2}],weight=5000}]},{1,[#drop{list=[{4500220,4}],weight=6000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,231=<Lv,Lv=<320,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24033,8}],weight=10000}]},{1,[#drop{list=[{24033,8}],weight=5000}]},{1,[#drop{list=[{24043,5}],weight=10000}]},{1,[#drop{list=[{24043,2}],weight=5000}]},{1,[#drop{list=[{4500220,5}],weight=6000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,231=<Lv,Lv=<320,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24033,10}],weight=10000}]},{1,[#drop{list=[{24033,10}],weight=5000}]},{1,[#drop{list=[{24043,6}],weight=10000}]},{1,[#drop{list=[{24043,3}],weight=5000}]},{1,[#drop{list=[{4500220,6}],weight=6000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,321=<Lv,Lv=<420,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24034,2}],weight=10000}]},{1,[#drop{list=[{24034,5}],weight=5000}]},{1,[#drop{list=[{24044,2}],weight=10000}]},{1,[#drop{list=[{24044,1}],weight=5000}]},{1,[#drop{list=[{4500220,2}],weight=6000}]},{1,[#drop{list=[{4500370,2}],weight=5000}]},{1,[#drop{list=[{402000,3}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,321=<Lv,Lv=<420,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24034,4}],weight=10000}]},{1,[#drop{list=[{24034,6}],weight=5000}]},{1,[#drop{list=[{24044,3}],weight=10000}]},{1,[#drop{list=[{24044,1}],weight=5000}]},{1,[#drop{list=[{4500220,3}],weight=6000}]},{1,[#drop{list=[{4500370,3}],weight=5000}]},{1,[#drop{list=[{402000,5}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,321=<Lv,Lv=<420,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24034,6}],weight=10000}]},{1,[#drop{list=[{24034,7}],weight=5000}]},{1,[#drop{list=[{24044,4}],weight=10000}]},{1,[#drop{list=[{24044,2}],weight=5000}]},{1,[#drop{list=[{4500220,4}],weight=6000}]},{1,[#drop{list=[{4500370,4}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,321=<Lv,Lv=<420,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24034,8}],weight=10000}]},{1,[#drop{list=[{24034,8}],weight=5000}]},{1,[#drop{list=[{24044,5}],weight=10000}]},{1,[#drop{list=[{24044,2}],weight=5000}]},{1,[#drop{list=[{4500220,5}],weight=6000}]},{1,[#drop{list=[{4500370,5}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,321=<Lv,Lv=<420,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24034,10}],weight=10000}]},{1,[#drop{list=[{24034,10}],weight=5000}]},{1,[#drop{list=[{24044,6}],weight=10000}]},{1,[#drop{list=[{24044,3}],weight=5000}]},{1,[#drop{list=[{4500220,6}],weight=6000}]},{1,[#drop{list=[{4500370,6}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,521=<Lv,Lv=<620,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24035,2}],weight=10000}]},{1,[#drop{list=[{24035,5}],weight=5000}]},{1,[#drop{list=[{24045,2}],weight=10000}]},{1,[#drop{list=[{24045,1}],weight=5000}]},{1,[#drop{list=[{4500220,2}],weight=6000}]},{1,[#drop{list=[{4500370,2}],weight=5000}]},{1,[#drop{list=[{402000,3}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,521=<Lv,Lv=<620,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24035,4}],weight=10000}]},{1,[#drop{list=[{24035,6}],weight=5000}]},{1,[#drop{list=[{24045,3}],weight=10000}]},{1,[#drop{list=[{24045,1}],weight=5000}]},{1,[#drop{list=[{4500220,3}],weight=6000}]},{1,[#drop{list=[{4500370,3}],weight=5000}]},{1,[#drop{list=[{402000,5}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,521=<Lv,Lv=<620,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24035,6}],weight=10000}]},{1,[#drop{list=[{24035,7}],weight=5000}]},{1,[#drop{list=[{24045,4}],weight=10000}]},{1,[#drop{list=[{24045,2}],weight=5000}]},{1,[#drop{list=[{4500220,4}],weight=6000}]},{1,[#drop{list=[{4500370,4}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,521=<Lv,Lv=<620,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24035,8}],weight=10000}]},{1,[#drop{list=[{24035,8}],weight=5000}]},{1,[#drop{list=[{24045,5}],weight=10000}]},{1,[#drop{list=[{24045,2}],weight=5000}]},{1,[#drop{list=[{4500220,5}],weight=6000}]},{1,[#drop{list=[{4500370,5}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,521=<Lv,Lv=<620,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24035,10}],weight=10000}]},{1,[#drop{list=[{24035,10}],weight=5000}]},{1,[#drop{list=[{24045,6}],weight=10000}]},{1,[#drop{list=[{24045,3}],weight=5000}]},{1,[#drop{list=[{4500220,6}],weight=6000}]},{1,[#drop{list=[{4500370,6}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,621=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24036,2}],weight=10000}]},{1,[#drop{list=[{24036,5}],weight=5000}]},{1,[#drop{list=[{24046,2}],weight=10000}]},{1,[#drop{list=[{24046,1}],weight=5000}]},{1,[#drop{list=[{4500220,2}],weight=6000}]},{1,[#drop{list=[{4500370,2}],weight=5000}]},{1,[#drop{list=[{402000,3}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,621=<Lv,Lv=<999,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24036,4}],weight=10000}]},{1,[#drop{list=[{24036,6}],weight=5000}]},{1,[#drop{list=[{24046,3}],weight=10000}]},{1,[#drop{list=[{24046,1}],weight=5000}]},{1,[#drop{list=[{4500220,3}],weight=6000}]},{1,[#drop{list=[{4500370,3}],weight=5000}]},{1,[#drop{list=[{402000,5}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,621=<Lv,Lv=<999,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24036,6}],weight=10000}]},{1,[#drop{list=[{24036,7}],weight=5000}]},{1,[#drop{list=[{24046,4}],weight=10000}]},{1,[#drop{list=[{24046,2}],weight=5000}]},{1,[#drop{list=[{4500220,4}],weight=6000}]},{1,[#drop{list=[{4500370,4}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,621=<Lv,Lv=<999,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24036,8}],weight=10000}]},{1,[#drop{list=[{24036,8}],weight=5000}]},{1,[#drop{list=[{24046,5}],weight=10000}]},{1,[#drop{list=[{24046,2}],weight=5000}]},{1,[#drop{list=[{4500220,5}],weight=6000}]},{1,[#drop{list=[{4500370,5}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 1=<Rank,Rank=<2,621=<Lv,Lv=<999,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24036,10}],weight=10000}]},{1,[#drop{list=[{24036,10}],weight=5000}]},{1,[#drop{list=[{24046,6}],weight=10000}]},{1,[#drop{list=[{24046,3}],weight=5000}]},{1,[#drop{list=[{4500220,6}],weight=6000}]},{1,[#drop{list=[{4500370,6}],weight=5000}]},{1,[#drop{list=[{402000,10}],weight=10000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,1=<Lv,Lv=<130,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24031,2}],weight=10000}]},{1,[#drop{list=[{24031,3}],weight=4000}]},{1,[#drop{list=[{24041,1}],weight=10000}]},{1,[#drop{list=[{24041,1}],weight=3000}]},{1,[#drop{list=[{402000,3}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,1=<Lv,Lv=<130,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24031,3}],weight=10000}]},{1,[#drop{list=[{24031,4}],weight=4000}]},{1,[#drop{list=[{24041,2}],weight=10000}]},{1,[#drop{list=[{24041,1}],weight=3000}]},{1,[#drop{list=[{402000,5}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,1=<Lv,Lv=<130,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24031,4}],weight=10000}]},{1,[#drop{list=[{24031,5}],weight=4000}]},{1,[#drop{list=[{24041,3}],weight=10000}]},{1,[#drop{list=[{24041,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,1=<Lv,Lv=<130,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24031,5}],weight=10000}]},{1,[#drop{list=[{24031,6}],weight=4000}]},{1,[#drop{list=[{24041,4}],weight=10000}]},{1,[#drop{list=[{24041,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,1=<Lv,Lv=<130,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24031,6}],weight=10000}]},{1,[#drop{list=[{24031,8}],weight=4000}]},{1,[#drop{list=[{24041,5}],weight=10000}]},{1,[#drop{list=[{24041,3}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,131=<Lv,Lv=<230,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24032,2}],weight=10000}]},{1,[#drop{list=[{24032,3}],weight=4000}]},{1,[#drop{list=[{24042,1}],weight=10000}]},{1,[#drop{list=[{24042,1}],weight=3000}]},{1,[#drop{list=[{402000,3}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,131=<Lv,Lv=<230,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24032,3}],weight=10000}]},{1,[#drop{list=[{24032,4}],weight=4000}]},{1,[#drop{list=[{24042,2}],weight=10000}]},{1,[#drop{list=[{24042,1}],weight=3000}]},{1,[#drop{list=[{402000,5}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,131=<Lv,Lv=<230,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24032,4}],weight=10000}]},{1,[#drop{list=[{24032,5}],weight=4000}]},{1,[#drop{list=[{24042,3}],weight=10000}]},{1,[#drop{list=[{24042,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,131=<Lv,Lv=<230,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24032,5}],weight=10000}]},{1,[#drop{list=[{24032,6}],weight=4000}]},{1,[#drop{list=[{24042,4}],weight=10000}]},{1,[#drop{list=[{24042,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,131=<Lv,Lv=<230,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24032,6}],weight=10000}]},{1,[#drop{list=[{24032,8}],weight=4000}]},{1,[#drop{list=[{24042,5}],weight=10000}]},{1,[#drop{list=[{24042,3}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,231=<Lv,Lv=<320,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24033,2}],weight=10000}]},{1,[#drop{list=[{24033,3}],weight=4000}]},{1,[#drop{list=[{24043,1}],weight=10000}]},{1,[#drop{list=[{24043,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{402000,3}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,231=<Lv,Lv=<320,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24033,3}],weight=10000}]},{1,[#drop{list=[{24033,4}],weight=4000}]},{1,[#drop{list=[{24043,2}],weight=10000}]},{1,[#drop{list=[{24043,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{402000,5}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,231=<Lv,Lv=<320,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24033,4}],weight=10000}]},{1,[#drop{list=[{24033,5}],weight=4000}]},{1,[#drop{list=[{24043,3}],weight=10000}]},{1,[#drop{list=[{24043,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,231=<Lv,Lv=<320,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24033,5}],weight=10000}]},{1,[#drop{list=[{24033,6}],weight=4000}]},{1,[#drop{list=[{24043,4}],weight=10000}]},{1,[#drop{list=[{24043,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,231=<Lv,Lv=<320,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24033,6}],weight=10000}]},{1,[#drop{list=[{24033,8}],weight=4000}]},{1,[#drop{list=[{24043,5}],weight=10000}]},{1,[#drop{list=[{24043,3}],weight=3000}]},{1,[#drop{list=[{4500220,4}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,321=<Lv,Lv=<420,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24034,2}],weight=10000}]},{1,[#drop{list=[{24034,3}],weight=4000}]},{1,[#drop{list=[{24044,1}],weight=10000}]},{1,[#drop{list=[{24044,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,3}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,321=<Lv,Lv=<420,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24034,3}],weight=10000}]},{1,[#drop{list=[{24034,4}],weight=4000}]},{1,[#drop{list=[{24044,2}],weight=10000}]},{1,[#drop{list=[{24044,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,5}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,321=<Lv,Lv=<420,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24034,4}],weight=10000}]},{1,[#drop{list=[{24034,5}],weight=4000}]},{1,[#drop{list=[{24044,3}],weight=10000}]},{1,[#drop{list=[{24044,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,321=<Lv,Lv=<420,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24034,5}],weight=10000}]},{1,[#drop{list=[{24034,6}],weight=4000}]},{1,[#drop{list=[{24044,4}],weight=10000}]},{1,[#drop{list=[{24044,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,321=<Lv,Lv=<420,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24034,6}],weight=10000}]},{1,[#drop{list=[{24034,8}],weight=4000}]},{1,[#drop{list=[{24044,5}],weight=10000}]},{1,[#drop{list=[{24044,3}],weight=3000}]},{1,[#drop{list=[{4500220,4}],weight=3000}]},{1,[#drop{list=[{4500370,4}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,521=<Lv,Lv=<620,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24035,2}],weight=10000}]},{1,[#drop{list=[{24035,3}],weight=4000}]},{1,[#drop{list=[{24045,1}],weight=10000}]},{1,[#drop{list=[{24045,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,3}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,521=<Lv,Lv=<620,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24035,3}],weight=10000}]},{1,[#drop{list=[{24035,4}],weight=4000}]},{1,[#drop{list=[{24045,2}],weight=10000}]},{1,[#drop{list=[{24045,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,5}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,521=<Lv,Lv=<620,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24035,4}],weight=10000}]},{1,[#drop{list=[{24035,5}],weight=4000}]},{1,[#drop{list=[{24045,3}],weight=10000}]},{1,[#drop{list=[{24045,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,521=<Lv,Lv=<620,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24035,5}],weight=10000}]},{1,[#drop{list=[{24035,6}],weight=4000}]},{1,[#drop{list=[{24045,4}],weight=10000}]},{1,[#drop{list=[{24045,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,521=<Lv,Lv=<620,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24035,6}],weight=10000}]},{1,[#drop{list=[{24035,8}],weight=4000}]},{1,[#drop{list=[{24045,5}],weight=10000}]},{1,[#drop{list=[{24045,3}],weight=3000}]},{1,[#drop{list=[{4500220,4}],weight=3000}]},{1,[#drop{list=[{4500370,4}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,621=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24036,2}],weight=10000}]},{1,[#drop{list=[{24036,3}],weight=4000}]},{1,[#drop{list=[{24046,1}],weight=10000}]},{1,[#drop{list=[{24046,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,3}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,621=<Lv,Lv=<999,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24036,3}],weight=10000}]},{1,[#drop{list=[{24036,4}],weight=4000}]},{1,[#drop{list=[{24046,2}],weight=10000}]},{1,[#drop{list=[{24046,1}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,5}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,621=<Lv,Lv=<999,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24036,4}],weight=10000}]},{1,[#drop{list=[{24036,5}],weight=4000}]},{1,[#drop{list=[{24046,3}],weight=10000}]},{1,[#drop{list=[{24046,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,621=<Lv,Lv=<999,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24036,5}],weight=10000}]},{1,[#drop{list=[{24036,6}],weight=4000}]},{1,[#drop{list=[{24046,4}],weight=10000}]},{1,[#drop{list=[{24046,2}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 3=<Rank,Rank=<5,621=<Lv,Lv=<999,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24036,6}],weight=10000}]},{1,[#drop{list=[{24036,8}],weight=4000}]},{1,[#drop{list=[{24046,5}],weight=10000}]},{1,[#drop{list=[{24046,3}],weight=3000}]},{1,[#drop{list=[{4500220,4}],weight=3000}]},{1,[#drop{list=[{4500370,4}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=6000}]},{1,[#drop{list=[{402001,5}],weight=1000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,1=<Lv,Lv=<130,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24031,2}],weight=10000}]},{1,[#drop{list=[{24031,2}],weight=3000}]},{1,[#drop{list=[{24041,1}],weight=10000}]},{1,[#drop{list=[{24041,1}],weight=3000}]},{1,[#drop{list=[{402000,3}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,1=<Lv,Lv=<130,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24031,3}],weight=10000}]},{1,[#drop{list=[{24031,3}],weight=3000}]},{1,[#drop{list=[{24041,1}],weight=10000}]},{1,[#drop{list=[{24041,1}],weight=3000}]},{1,[#drop{list=[{402000,5}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,1=<Lv,Lv=<130,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24031,4}],weight=10000}]},{1,[#drop{list=[{24031,4}],weight=3000}]},{1,[#drop{list=[{24041,2}],weight=10000}]},{1,[#drop{list=[{24041,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,1=<Lv,Lv=<130,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24031,5}],weight=10000}]},{1,[#drop{list=[{24031,5}],weight=3000}]},{1,[#drop{list=[{24041,2}],weight=10000}]},{1,[#drop{list=[{24041,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,1=<Lv,Lv=<130,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24031,6}],weight=10000}]},{1,[#drop{list=[{24031,6}],weight=3000}]},{1,[#drop{list=[{24041,3}],weight=10000}]},{1,[#drop{list=[{24041,3}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,131=<Lv,Lv=<230,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24032,2}],weight=10000}]},{1,[#drop{list=[{24032,2}],weight=3000}]},{1,[#drop{list=[{24042,1}],weight=10000}]},{1,[#drop{list=[{24042,1}],weight=3000}]},{1,[#drop{list=[{402000,3}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,131=<Lv,Lv=<230,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24032,3}],weight=10000}]},{1,[#drop{list=[{24032,3}],weight=3000}]},{1,[#drop{list=[{24042,1}],weight=10000}]},{1,[#drop{list=[{24042,1}],weight=3000}]},{1,[#drop{list=[{402000,5}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,131=<Lv,Lv=<230,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24032,4}],weight=10000}]},{1,[#drop{list=[{24032,4}],weight=3000}]},{1,[#drop{list=[{24042,2}],weight=10000}]},{1,[#drop{list=[{24042,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,131=<Lv,Lv=<230,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24032,5}],weight=10000}]},{1,[#drop{list=[{24032,5}],weight=3000}]},{1,[#drop{list=[{24042,2}],weight=10000}]},{1,[#drop{list=[{24042,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,131=<Lv,Lv=<230,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24032,6}],weight=10000}]},{1,[#drop{list=[{24032,6}],weight=3000}]},{1,[#drop{list=[{24042,3}],weight=10000}]},{1,[#drop{list=[{24042,3}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,231=<Lv,Lv=<320,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24033,2}],weight=10000}]},{1,[#drop{list=[{24033,2}],weight=3000}]},{1,[#drop{list=[{24043,1}],weight=10000}]},{1,[#drop{list=[{24043,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{402000,3}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,231=<Lv,Lv=<320,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24033,3}],weight=10000}]},{1,[#drop{list=[{24033,3}],weight=3000}]},{1,[#drop{list=[{24043,1}],weight=10000}]},{1,[#drop{list=[{24043,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{402000,5}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,231=<Lv,Lv=<320,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24033,4}],weight=10000}]},{1,[#drop{list=[{24033,4}],weight=3000}]},{1,[#drop{list=[{24043,2}],weight=10000}]},{1,[#drop{list=[{24043,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,231=<Lv,Lv=<320,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24033,5}],weight=10000}]},{1,[#drop{list=[{24033,5}],weight=3000}]},{1,[#drop{list=[{24043,2}],weight=10000}]},{1,[#drop{list=[{24043,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,231=<Lv,Lv=<320,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24033,6}],weight=10000}]},{1,[#drop{list=[{24033,6}],weight=3000}]},{1,[#drop{list=[{24043,3}],weight=10000}]},{1,[#drop{list=[{24043,3}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,321=<Lv,Lv=<420,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24034,2}],weight=10000}]},{1,[#drop{list=[{24034,2}],weight=3000}]},{1,[#drop{list=[{24044,1}],weight=10000}]},{1,[#drop{list=[{24044,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{4500370,1}],weight=2000}]},{1,[#drop{list=[{402000,3}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,321=<Lv,Lv=<420,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24034,3}],weight=10000}]},{1,[#drop{list=[{24034,3}],weight=3000}]},{1,[#drop{list=[{24044,1}],weight=10000}]},{1,[#drop{list=[{24044,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,5}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,321=<Lv,Lv=<420,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24034,4}],weight=10000}]},{1,[#drop{list=[{24034,4}],weight=3000}]},{1,[#drop{list=[{24044,2}],weight=10000}]},{1,[#drop{list=[{24044,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,321=<Lv,Lv=<420,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24034,5}],weight=10000}]},{1,[#drop{list=[{24034,5}],weight=3000}]},{1,[#drop{list=[{24044,2}],weight=10000}]},{1,[#drop{list=[{24044,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,321=<Lv,Lv=<420,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24034,6}],weight=10000}]},{1,[#drop{list=[{24034,6}],weight=3000}]},{1,[#drop{list=[{24044,3}],weight=10000}]},{1,[#drop{list=[{24044,3}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,521=<Lv,Lv=<620,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24035,2}],weight=10000}]},{1,[#drop{list=[{24035,2}],weight=3000}]},{1,[#drop{list=[{24045,1}],weight=10000}]},{1,[#drop{list=[{24045,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{4500370,1}],weight=2000}]},{1,[#drop{list=[{402000,3}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,521=<Lv,Lv=<620,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24035,3}],weight=10000}]},{1,[#drop{list=[{24035,3}],weight=3000}]},{1,[#drop{list=[{24045,1}],weight=10000}]},{1,[#drop{list=[{24045,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,5}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,521=<Lv,Lv=<620,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24035,4}],weight=10000}]},{1,[#drop{list=[{24035,4}],weight=3000}]},{1,[#drop{list=[{24045,2}],weight=10000}]},{1,[#drop{list=[{24045,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,521=<Lv,Lv=<620,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24035,5}],weight=10000}]},{1,[#drop{list=[{24035,5}],weight=3000}]},{1,[#drop{list=[{24045,2}],weight=10000}]},{1,[#drop{list=[{24045,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,521=<Lv,Lv=<620,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24035,6}],weight=10000}]},{1,[#drop{list=[{24035,6}],weight=3000}]},{1,[#drop{list=[{24045,3}],weight=10000}]},{1,[#drop{list=[{24045,3}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,621=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<10 -> [{1,[#drop{list=[{24036,2}],weight=10000}]},{1,[#drop{list=[{24036,2}],weight=3000}]},{1,[#drop{list=[{24046,1}],weight=10000}]},{1,[#drop{list=[{24046,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{4500370,1}],weight=2000}]},{1,[#drop{list=[{402000,3}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,621=<Lv,Lv=<999,1=<Day,Day=<999,11=<Num,Num=<20 -> [{1,[#drop{list=[{24036,3}],weight=10000}]},{1,[#drop{list=[{24036,3}],weight=3000}]},{1,[#drop{list=[{24046,1}],weight=10000}]},{1,[#drop{list=[{24046,1}],weight=3000}]},{1,[#drop{list=[{4500220,1}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,5}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,621=<Lv,Lv=<999,1=<Day,Day=<999,21=<Num,Num=<30 -> [{1,[#drop{list=[{24036,4}],weight=10000}]},{1,[#drop{list=[{24036,4}],weight=3000}]},{1,[#drop{list=[{24046,2}],weight=10000}]},{1,[#drop{list=[{24046,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,2}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,621=<Lv,Lv=<999,1=<Day,Day=<999,31=<Num,Num=<40 -> [{1,[#drop{list=[{24036,5}],weight=10000}]},{1,[#drop{list=[{24036,5}],weight=3000}]},{1,[#drop{list=[{24046,2}],weight=10000}]},{1,[#drop{list=[{24046,2}],weight=3000}]},{1,[#drop{list=[{4500220,2}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 6=<Rank,Rank=<10,621=<Lv,Lv=<999,1=<Day,Day=<999,41=<Num,Num=<100 -> [{1,[#drop{list=[{24036,6}],weight=10000}]},{1,[#drop{list=[{24036,6}],weight=3000}]},{1,[#drop{list=[{24046,3}],weight=10000}]},{1,[#drop{list=[{24046,3}],weight=3000}]},{1,[#drop{list=[{4500220,3}],weight=3000}]},{1,[#drop{list=[{4500370,3}],weight=2000}]},{1,[#drop{list=[{402000,10}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 11=<Rank,Rank=<99,1=<Lv,Lv=<130,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{24031,1}],weight=10000}]},{1,[#drop{list=[{24031,3}],weight=6000}]},{1,[#drop{list=[{24041,1}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 11=<Rank,Rank=<99,131=<Lv,Lv=<230,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{24032,1}],weight=10000}]},{1,[#drop{list=[{24032,3}],weight=6000}]},{1,[#drop{list=[{24042,1}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 11=<Rank,Rank=<99,231=<Lv,Lv=<320,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{24033,1}],weight=10000}]},{1,[#drop{list=[{24033,3}],weight=6000}]},{1,[#drop{list=[{24043,1}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 11=<Rank,Rank=<99,321=<Lv,Lv=<420,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{24034,1}],weight=10000}]},{1,[#drop{list=[{24034,3}],weight=6000}]},{1,[#drop{list=[{24044,1}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 11=<Rank,Rank=<99,521=<Lv,Lv=<620,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{24035,1}],weight=10000}]},{1,[#drop{list=[{24035,3}],weight=6000}]},{1,[#drop{list=[{24045,1}],weight=3000}]}];
get_awards(3,Rank,Lv,Day,Num) when 11=<Rank,Rank=<99,621=<Lv,Lv=<999,1=<Day,Day=<999,1=<Num,Num=<100 -> [{1,[#drop{list=[{24036,1}],weight=10000}]},{1,[#drop{list=[{24036,3}],weight=6000}]},{1,[#drop{list=[{24046,1}],weight=3000}]}];
get_awards(_Type,_Rank,_Lv,_Day,_Num)->[].

get_cash_rate(Num) when 1 =< Num, Num =< 20 ->
		[600,20];
get_cash_rate(_Num) ->
    [0,0].

get_box_num(Join) when Join >= 12 ->
		4;
get_box_num(Join) when Join >= 9 ->
		3;
get_box_num(Join) when Join >= 6 ->
		2;
get_box_num(Join) when Join >= 3 ->
		1;
get_box_num(_Join) ->
    0.

