%%%---------------------------------------
%%% module      : data_guild_race_rank
%%% description : 社团竞速配置
%%%
%%%---------------------------------------
-module(data_guild_race_rank).
-compile(export_all).
-include("guild_race_rank.hrl").




get_guild_race_rank_kv_cfg(last_day) ->
    7;


get_guild_race_rank_kv_cfg(reward_time) ->
    {23,0};


get_guild_race_rank_kv_cfg(common_reward) ->
    [{0,262006,1}];


get_guild_race_rank_kv_cfg(refresh_interval) ->
    3600;


get_guild_race_rank_kv_cfg(active_common_reward) ->
    [{0,102401,1},{0,109033,1},{0,230001,5}];


get_guild_race_rank_kv_cfg(active_chairman_reward) ->
    [{0,102401,1},{0,109033,1},{0,230001,10}];


get_guild_race_rank_kv_cfg(power_chairman_reward) ->
    [{0,102401,1},{0,109033,1},{0,230002,10}];


get_guild_race_rank_kv_cfg(power_rank_top) ->
    3;


get_guild_race_rank_kv_cfg(active_rank_top) ->
    10;

get_guild_race_rank_kv_cfg(_Key) ->
    [].

get_guild_race_rank_reward_cfg(1,Rank) when Rank >= 1, Rank =< 1 ->
	#guild_race_rank_reward_cfg{id=1,rank_low=1,rank_high=1,reward=[{0,433017,1}],guild_rank=1};
get_guild_race_rank_reward_cfg(1,Rank) when Rank >= 2, Rank =< 4 ->
	#guild_race_rank_reward_cfg{id=2,rank_low=2,rank_high=4,reward=[{0,433018,1}],guild_rank=1};
get_guild_race_rank_reward_cfg(1,Rank) when Rank >= 5, Rank =< 10 ->
	#guild_race_rank_reward_cfg{id=3,rank_low=5,rank_high=10,reward=[{0,433019,1}],guild_rank=1};
get_guild_race_rank_reward_cfg(2,Rank) when Rank >= 1, Rank =< 1 ->
	#guild_race_rank_reward_cfg{id=4,rank_low=1,rank_high=1,reward=[{0,433017,1}],guild_rank=2};
get_guild_race_rank_reward_cfg(2,Rank) when Rank >= 2, Rank =< 4 ->
	#guild_race_rank_reward_cfg{id=5,rank_low=2,rank_high=4,reward=[{0,433018,1}],guild_rank=2};
get_guild_race_rank_reward_cfg(2,Rank) when Rank >= 5, Rank =< 10 ->
	#guild_race_rank_reward_cfg{id=6,rank_low=5,rank_high=10,reward=[{0,433019,1}],guild_rank=2};
get_guild_race_rank_reward_cfg(3,Rank) when Rank >= 1, Rank =< 1 ->
	#guild_race_rank_reward_cfg{id=7,rank_low=1,rank_high=1,reward=[{0,433017,1}],guild_rank=3};
get_guild_race_rank_reward_cfg(3,Rank) when Rank >= 2, Rank =< 4 ->
	#guild_race_rank_reward_cfg{id=8,rank_low=2,rank_high=4,reward=[{0,433018,1}],guild_rank=3};
get_guild_race_rank_reward_cfg(3,Rank) when Rank >= 5, Rank =< 10 ->
	#guild_race_rank_reward_cfg{id=9,rank_low=5,rank_high=10,reward=[{0,433019,1}],guild_rank=3};
get_guild_race_rank_reward_cfg(_Guild_rank,_Rank) ->
    [].


get_guild_race_rank_expand_cfg(1) ->
    5;


get_guild_race_rank_expand_cfg(2) ->
    10;


get_guild_race_rank_expand_cfg(3) ->
    15;


get_guild_race_rank_expand_cfg(4) ->
    20;


get_guild_race_rank_expand_cfg(5) ->
    20;


get_guild_race_rank_expand_cfg(6) ->
    20;


get_guild_race_rank_expand_cfg(7) ->
    20;

get_guild_race_rank_expand_cfg(_Day) ->
    [].

get_task(1) ->
    #base_guild_race_rank_task{id = 1,sequence = 1,task_name = "建立社团",task_desc = "创建一个社团",reward = [{0,101016,5}],condition = [{limit_times,1}],client_skip = [400,0]};

get_task(2) ->
    #base_guild_race_rank_task{id = 2,sequence = 2,task_name = "人才引进",task_desc = "社团总人数达到10人",reward = [{0,101016,3}],condition = [{limit_times,10}],client_skip = [400,88]};

get_task(3) ->
    #base_guild_race_rank_task{id = 3,sequence = 3,task_name = "战力提升",task_desc = "社团总战力达到100万",reward = [{0,101016,3}],condition = [{limit_times,1000000}],client_skip = [157,0]};

get_task(4) ->
    #base_guild_race_rank_task{id = 4,sequence = 4,task_name = "活跃提升",task_desc = "社团累计活跃达到500",reward = [{0,101016,3}],condition = [{limit_times,500}],client_skip = [400,2]};

get_task(5) ->
    #base_guild_race_rank_task{id = 5,sequence = 5,task_name = "社团幻魔",task_desc = "团长参与社团幻魔3次",reward = [{0,101016,3}],condition = [{limit_times,3}],client_skip = [406,1]};

get_task(_Id) ->
    [].

get_all_task() ->
    [1,2,3,4,5].

