%%%---------------------------------------
%%% module      : data_guild_war
%%% description : 百团大战配置
%%%
%%%---------------------------------------
-module(data_guild_war).
-compile(export_all).



%%押运官id
get_guild_war_kv(boss_id) ->
    653001;

%%押运官坐标
get_guild_war_kv(boss_position) ->
    {10674,11390};

%%每X次攻击押运官得Y积分
get_guild_war_kv(each_hit_score) ->
    {5,5};

%%首次攻击押运官的积分
get_guild_war_kv(first_hit_score) ->
    500;

%%循环每次发放10积分
get_guild_war_kv(heart_beat_score) ->
    5;

%%每10秒自动增加一次积分
get_guild_war_kv(heart_beat_time) ->
    10;

%%高品质物资id
get_guild_war_kv(high_quality_materials_id) ->
    653003;

%%击杀玩家的基础积分
get_guild_war_kv(kill_base_score) ->
    100;

%%最后攻击押运官的积分
get_guild_war_kv(last_hit_score) ->
    2000;

%%低品质物资id
get_guild_war_kv(low_quality_materials_id) ->
    653002;

%%中品质物资id
get_guild_war_kv(medium_quality_materials_id) ->
    653004;

%%刷新押运官时间间隔
get_guild_war_kv(refresh_boss) ->
    [60,240,300,300];

%%运送物资积分（低级结晶、高级结晶和中级结晶）
get_guild_war_kv(send_score) ->
    [{653002,50},{653003,500},{653004,150}];

%%技能CD
get_guild_war_kv(skill_cd) ->
    30;

%%明星社团团长奖励
get_guild_war_kv(star_org_award) ->
    [{17,432001,1}];

get_guild_war_kv(_Keycontent) ->
    [].

get_guild_war_role_reward(Rank) when Rank >= 1  andalso  Rank =< 1 ->
		[{100,102603,10},{100,109032,3}];
get_guild_war_role_reward(Rank) when Rank >= 2  andalso  Rank =< 2 ->
		[{100,102603,9},{100,109032,2}];
get_guild_war_role_reward(Rank) when Rank >= 3  andalso  Rank =< 3 ->
		[{100,102603,8},{100,109032,2}];
get_guild_war_role_reward(Rank) when Rank >= 4  andalso  Rank =< 4 ->
		[{100,102603,7},{100,109032,1}];
get_guild_war_role_reward(Rank) when Rank >= 5  andalso  Rank =< 5 ->
		[{100,102603,6},{100,109032,1}];
get_guild_war_role_reward(Rank) when Rank >= 6  andalso  Rank =< 6 ->
		[{100,102603,5},{100,109032,1}];
get_guild_war_role_reward(Rank) when Rank >= 7  andalso  Rank =< 7 ->
		[{100,102603,4},{100,109031,3}];
get_guild_war_role_reward(Rank) when Rank >= 8  andalso  Rank =< 8 ->
		[{100,102603,3},{100,109031,2}];
get_guild_war_role_reward(Rank) when Rank >= 9  andalso  Rank =< 9 ->
		[{100,102603,2},{100,109031,1}];
get_guild_war_role_reward(Rank) when Rank >= 10  andalso  Rank =< 10 ->
		[{100,102603,1},{100,109031,1}];
get_guild_war_role_reward(_Rank) ->
    [].

get_guild_war_guild_reward(Rank) when Rank >= 1  andalso  Rank =< 1 ->
		[{8,100004,1000},{17,432002,1}];
get_guild_war_guild_reward(Rank) when Rank >= 2  andalso  Rank =< 2 ->
		[{8,100004,800}];
get_guild_war_guild_reward(Rank) when Rank >= 3  andalso  Rank =< 3 ->
		[{8,100004,700}];
get_guild_war_guild_reward(Rank) when Rank >= 4  andalso  Rank =< 4 ->
		[{8,100004,650}];
get_guild_war_guild_reward(Rank) when Rank >= 5  andalso  Rank =< 5 ->
		[{8,100004,600}];
get_guild_war_guild_reward(Rank) when Rank >= 6  andalso  Rank =< 6 ->
		[{8,100004,550}];
get_guild_war_guild_reward(Rank) when Rank >= 7  andalso  Rank =< 7 ->
		[{8,100004,500}];
get_guild_war_guild_reward(Rank) when Rank >= 8  andalso  Rank =< 8 ->
		[{8,100004,450}];
get_guild_war_guild_reward(Rank) when Rank >= 9  andalso  Rank =< 9 ->
		[{8,100004,400}];
get_guild_war_guild_reward(Rank) when Rank >= 10  andalso  Rank =< 10 ->
		[{8,100004,350}];
get_guild_war_guild_reward(_Rank) ->
    [].

get_guild_war_continue_kill_ratio(Kill) when Kill >= 1  andalso  Kill =< 5 ->
		0.1;
get_guild_war_continue_kill_ratio(Kill) when Kill >= 6  andalso  Kill =< 10 ->
		0.3;
get_guild_war_continue_kill_ratio(Kill) when Kill >= 11  andalso  Kill =< 15 ->
		0.5;
get_guild_war_continue_kill_ratio(Kill) when Kill >= 16  andalso  Kill =< 30 ->
		0.8;
get_guild_war_continue_kill_ratio(Kill) when Kill >= 31  andalso  Kill =< 50 ->
		1;
get_guild_war_continue_kill_ratio(Kill) when Kill >= 51  andalso  Kill =< 9999 ->
		1.5;
get_guild_war_continue_kill_ratio(_Kill) ->
    0.

get_guild_war_extra_ratio(Kill) when Kill >= 1  andalso  Kill =< 5 ->
		0.1;
get_guild_war_extra_ratio(Kill) when Kill >= 6  andalso  Kill =< 10 ->
		0.2;
get_guild_war_extra_ratio(Kill) when Kill >= 11  andalso  Kill =< 15 ->
		0.4;
get_guild_war_extra_ratio(Kill) when Kill >= 16  andalso  Kill =< 30 ->
		0.5;
get_guild_war_extra_ratio(Kill) when Kill >= 31  andalso  Kill =< 50 ->
		0.8;
get_guild_war_extra_ratio(Kill) when Kill >= 51  andalso  Kill =< 9999 ->
		1;
get_guild_war_extra_ratio(_Kill) ->
    0.


get_score_level_reward(1) ->
    [{100,102603,1},{100,109021,1}];


get_score_level_reward(2) ->
    [{100,101016,1},{100,450023,1}];


get_score_level_reward(3) ->
    [{100,102603,1},{100,109011,1}];


get_score_level_reward(4) ->
    [{100,101016,2},{100,450023,1}];


get_score_level_reward(5) ->
    [{100,102603,2},{100,109001,1}];


get_score_level_reward(6) ->
    [{100,101016,3},{100,450023,1}];


get_score_level_reward(7) ->
    [{100,102603,3},{100,109032,1}];


get_score_level_reward(8) ->
    [{100,450024,1},{100,450023,2}];

get_score_level_reward(_Level) ->
    [].

get_score_reward_level(Score) when Score >= 4000 ->
		8;
get_score_reward_level(Score) when Score >= 3500 ->
		7;
get_score_reward_level(Score) when Score >= 3000 ->
		6;
get_score_reward_level(Score) when Score >= 2500 ->
		5;
get_score_reward_level(Score) when Score >= 2000 ->
		4;
get_score_reward_level(Score) when Score >= 1500 ->
		3;
get_score_reward_level(Score) when Score >= 1000 ->
		2;
get_score_reward_level(Score) when Score >= 500 ->
		1;
get_score_reward_level(_Score) ->
    0.


get_kill_rank_award(1) ->
    [{17,432008,1},{8,100004,200},{100,450023,3}];


get_kill_rank_award(2) ->
    [{17,432009,1},{8,100004,200},{100,450023,2}];


get_kill_rank_award(3) ->
    [{17,432010,1},{8,100004,200},{100,450023,1}];


get_kill_rank_award(4) ->
    [{17,432007,1},{8,100004,150},{100,102603,3}];


get_kill_rank_award(5) ->
    [{17,432007,1},{8,100004,150},{100,102603,2}];


get_kill_rank_award(6) ->
    [{17,432007,1},{8,100004,150},{100,102603,1}];


get_kill_rank_award(7) ->
    [{17,432007,1},{8,100004,150},{100,102603,1}];


get_kill_rank_award(8) ->
    [{17,432007,1},{8,100004,100}];


get_kill_rank_award(9) ->
    [{17,432007,1},{8,100004,100}];


get_kill_rank_award(10) ->
    [{17,432007,1},{8,100004,100}];

get_kill_rank_award(_Rank) ->
    [].

