%%%---------------------------------------
%%% module      : data_jump_act
%%% description : 跳一跳配置
%%%
%%%---------------------------------------
-module(data_jump_act).
-compile(export_all).



get_distance_by_round(Round) when Round >= 1  andalso  Round =< 5 ->
		[400, 700];
get_distance_by_round(Round) when Round >= 6  andalso  Round =< 10 ->
		[600, 900];
get_distance_by_round(Round) when Round >= 11  andalso  Round =< 15 ->
		[800, 1100];
get_distance_by_round(Round) when Round >= 16  andalso  Round =< 20 ->
		[1000, 1300];
get_distance_by_round(Round) when Round >= 21  andalso  Round =< 25 ->
		[1200, 1500];
get_distance_by_round(Round) when Round >= 26  andalso  Round =< 9999 ->
		[1400, 1700];
get_distance_by_round(_Round) ->
    [].

get_radius_by_round(Round) when Round >= 1  andalso  Round =< 5 ->
		[150, 190];
get_radius_by_round(Round) when Round >= 6  andalso  Round =< 10 ->
		[140, 180];
get_radius_by_round(Round) when Round >= 11  andalso  Round =< 15 ->
		[130, 170];
get_radius_by_round(Round) when Round >= 16  andalso  Round =< 20 ->
		[120, 160];
get_radius_by_round(Round) when Round >= 21  andalso  Round =< 25 ->
		[110, 150];
get_radius_by_round(Round) when Round >= 26  andalso  Round =< 9999 ->
		[100, 140];
get_radius_by_round(_Round) ->
    [].


get_map_born_xy(1) ->
    {9715,3326};


get_map_born_xy(2) ->
    {6187,6847};


get_map_born_xy(3) ->
    {13373,6933};


get_map_born_xy(4) ->
    {9816,10487};

get_map_born_xy(_Mapid) ->
    [].


get_map_border_xy(1) ->
    {9862,8633};


get_map_border_xy(2) ->
    {6187,12314};


get_map_border_xy(3) ->
    {13373,12234};


get_map_border_xy(4) ->
    {9649,15838};

get_map_border_xy(_Mapid) ->
    [].


get_next_map(1) ->
    2;


get_next_map(2) ->
    3;


get_next_map(3) ->
    4;


get_next_map(4) ->
    1;

get_next_map(_Mapid) ->
    [].

%%每天最多可参与游戏次数
get_jump_act_kv(jump_day_max) ->
    [20];

%%每天最多可获得奖励次数
get_jump_act_kv(jump_everyday_times) ->
    [5];

%%命数
get_jump_act_kv(jump_life) ->
    [3];

%%最大开始人数
get_jump_act_kv(jump_max_num) ->
    [4];

%%最大蓄力秒数
get_jump_act_kv(jump_max_second) ->
    [3];

%%最少开始人数
get_jump_act_kv(jump_min_num) ->
    [3];

%%单人模式单日最大次数
get_jump_act_kv(jump_single_everyday_times) ->
    [5];

%%单人模式单场命数
get_jump_act_kv(jump_single_life) ->
    [5];

%%台子模型
get_jump_act_kv(jump_step_model) ->
    [[1,2,3,4,5,6]];

%%跳跃超时
get_jump_act_kv(jump_time) ->
    [15];

%%达到最少人数后多久开始
get_jump_act_kv(jump_wait) ->
    [120];

get_jump_act_kv(_Keycontent) ->
    [].

