%%%---------------------------------------
%%% module      : data_madness_land
%%% description : 狂战领域配置
%%%
%%%---------------------------------------
-module(data_madness_land).
-compile(export_all).



%%循环积分时间间隔
get_madness_land_kv(cycle_time_interval) ->
    10;

%%循环积分
get_madness_land_kv(cycle_time_score) ->
    20;

%%本服BOSS首刀奖励
get_madness_land_kv(first_kill_one) ->
    [{100,450023,2},{100,109033,1}];

%%跨服BOSS首刀奖励
get_madness_land_kv(first_kill_two) ->
    [{100,450023,2},{100,109032,1}];

%%对BOSS造成伤害的积分数[{刀数，积分奖励数}]
get_madness_land_kv(hurt_integral) ->
    {10,15};

%%击杀1个玩家奖励积分数
get_madness_land_kv(kill_integral) ->
    30;

%%本服BOSS刷新坐标{x,y}
get_madness_land_kv(monster_1) ->
    {3792,3787};

%%跨服BOSS刷新坐标{x,y}
get_madness_land_kv(monster_2) ->
    {3782,3782};

%%本服BOSS分身坐标[{怪物id,x,y}]
get_madness_land_kv(monster_refresh_one) ->
    [{83000002,4868,3827},{83000002,3763,2676},{83000002,2786,3340},{83000002,3649,4873}];

%%跨服BOSS分身坐标[{怪物id,x,y}]
get_madness_land_kv(monster_refresh_two) ->
    [{83000004,4868,3827},{83000004,3763,2676},{83000004,2786,3340},{83000004,3649,4873}];

%%对BOSS分身造成伤害的积分数[{刀数，积分奖励数}]
get_madness_land_kv(refresh_hurt) ->
    {5,80};

%%第一轮结算推前时间
get_madness_land_kv(rest_time) ->
    15;

%%活动开始n秒后第一轮小怪出现时间
get_madness_land_kv(round_1_monster_time) ->
    300;

%%第一轮持续时间
get_madness_land_kv(round_1_time) ->
    600;

%%活动开始n秒后第二轮小怪出现时间
get_madness_land_kv(round_2_monster_time) ->
    300;

%%第二轮持续时间
get_madness_land_kv(round_2_time) ->
    600;

%%跨服积分第一社团--全服邮件
get_madness_land_kv(service_rewards) ->
    [{100,450023,1},{100,109032,1}];

%%主UI奖励展示
get_madness_land_kv(show_rewards) ->
    [[1,{100,450023,1}],[1,{100,109032,1}],[2,{2,100001,1}],[2,{100,109033,1}],[2,{100,109031,1}],[2,{100,109002,1}],[2,{100,102603,1}]];

get_madness_land_kv(_Keycontent) ->
    [].

get_madness_land_role_reward(Rank) when Rank >= 1  andalso  Rank =< 1 ->
		[{2,100001,20},{100,450023,2},{100,109022,1},{100,102603,2}];
get_madness_land_role_reward(Rank) when Rank >= 2  andalso  Rank =< 2 ->
		[{2,100001,15},{100,450023,1},{100,109002,1},{100,102603,2}];
get_madness_land_role_reward(Rank) when Rank >= 3  andalso  Rank =< 3 ->
		[{2,100001,10},{100,450023,1},{100,109002,1},{100,102603,2}];
get_madness_land_role_reward(Rank) when Rank >= 4  andalso  Rank =< 10 ->
		[{2,100001,10},{100,102603,2},{100,109002,1}];
get_madness_land_role_reward(Rank) when Rank >= 11  andalso  Rank =< 20 ->
		[{2,100001,8},{100,102603,2},{100,109002,1}];
get_madness_land_role_reward(Rank) when Rank >= 21  andalso  Rank =< 99 ->
		[{2,100001,6},{100,102603,1},{100,109002,1}];
get_madness_land_role_reward(_Rank) ->
    [].

get_madness_land_server_reward(Rank) when Rank >= 1  andalso  Rank =< 1 ->
		[{2,100001,5},{100,102603,2},{100,109001,1}];
get_madness_land_server_reward(Rank) when Rank >= 2  andalso  Rank =< 2 ->
		[{2,100001,5},{100,102000,3},{100,109021,1}];
get_madness_land_server_reward(Rank) when Rank >= 3  andalso  Rank =< 3 ->
		[{2,100001,3},{100,102603,2},{100,109011,1}];
get_madness_land_server_reward(Rank) when Rank >= 4  andalso  Rank =< 4 ->
		[{100,102603,1},{100,109011,1}];
get_madness_land_server_reward(Rank) when Rank >= 5  andalso  Rank =< 5 ->
		[{100,102603,1},{100,109011,1}];
get_madness_land_server_reward(Rank) when Rank >= 6  andalso  Rank =< 6 ->
		[{100,102603,1},{100,109011,1}];
get_madness_land_server_reward(Rank) when Rank >= 7  andalso  Rank =< 7 ->
		[{100,102603,1},{100,109011,1}];
get_madness_land_server_reward(Rank) when Rank >= 8  andalso  Rank =< 8 ->
		[{100,102603,1},{100,109011,1}];
get_madness_land_server_reward(Rank) when Rank >= 9  andalso  Rank =< 9 ->
		[{100,102603,1},{100,109011,1}];
get_madness_land_server_reward(Rank) when Rank >= 10  andalso  Rank =< 10 ->
		[{100,102603,1},{100,109011,1}];
get_madness_land_server_reward(_Rank) ->
    [].


get_madness_land_score_reward(1) ->
    [{100,102000,1},{100,102603,1},{100,109031,1}];


get_madness_land_score_reward(2) ->
    [{100,102000,1},{100,102603,2},{100,109031,1}];


get_madness_land_score_reward(3) ->
    [{100,102000,1},{100,102603,2},{100,109031,1}];


get_madness_land_score_reward(4) ->
    [{2,100001,15},{100,450023,2},{100,109031,1}];


get_madness_land_score_reward(5) ->
    [{100,102000,2},{100,102603,3},{100,109032,1}];


get_madness_land_score_reward(6) ->
    [{100,102000,2},{100,450023,1},{100,109032,1}];


get_madness_land_score_reward(7) ->
    [{2,100001,20},{100,102000,2},{100,109032,1}];


get_madness_land_score_reward(8) ->
    [{100,102000,3},{100,450023,2},{100,109033,1}];


get_madness_land_score_reward(9) ->
    [{100,102000,3},{100,450023,2},{100,109033,1}];

get_madness_land_score_reward(_Id) ->
    [].

get_madness_land_score_id(Score) when Score >= 5000 ->
		9;
get_madness_land_score_id(Score) when Score >= 3200 ->
		8;
get_madness_land_score_id(Score) when Score >= 1800 ->
		7;
get_madness_land_score_id(Score) when Score >= 1200 ->
		6;
get_madness_land_score_id(Score) when Score >= 800 ->
		5;
get_madness_land_score_id(Score) when Score >= 600 ->
		4;
get_madness_land_score_id(Score) when Score >= 300 ->
		3;
get_madness_land_score_id(Score) when Score >= 100 ->
		2;
get_madness_land_score_id(Score) when Score >= 30 ->
		1;
get_madness_land_score_id(_Score) ->
    0.

get_madness_land_continue_kill_score(Num) when Num >= 500 ->
		50;
get_madness_land_continue_kill_score(Num) when Num >= 200 ->
		30;
get_madness_land_continue_kill_score(Num) when Num >= 100 ->
		25;
get_madness_land_continue_kill_score(Num) when Num >= 50 ->
		20;
get_madness_land_continue_kill_score(Num) when Num >= 20 ->
		15;
get_madness_land_continue_kill_score(Num) when Num >= 10 ->
		10;
get_madness_land_continue_kill_score(Num) when Num >= 5 ->
		5;
get_madness_land_continue_kill_score(Num) when Num >= 2 ->
		1;
get_madness_land_continue_kill_score(_Num) ->
    0.

get_madness_land_end_score(Num) when Num >= 500 ->
		150;
get_madness_land_end_score(Num) when Num >= 200 ->
		120;
get_madness_land_end_score(Num) when Num >= 100 ->
		100;
get_madness_land_end_score(Num) when Num >= 50 ->
		80;
get_madness_land_end_score(Num) when Num >= 20 ->
		60;
get_madness_land_end_score(Num) when Num >= 10 ->
		50;
get_madness_land_end_score(Num) when Num >= 5 ->
		10;
get_madness_land_end_score(_Num) ->
    0.

