%%%---------------------------------------
%%% module      : data_mate
%%% description : 羁绊配置
%%%
%%%---------------------------------------
-module(data_mate).
-compile(export_all).
-include("mate.hrl").



%%羁绊预告奖励
get_mate_key(advance_rewards) ->
    [{0,102401,99}];

%%自动解除天数
get_mate_key(autobreak_day) ->
    3;

%%光环出现时间
get_mate_key(ball_click) ->
    1.5;

%%小球飞行时间
get_mate_key(ball_fly) ->
    3;

%%强制解除价格
get_mate_key(break_cost) ->
    [{1,0,88}];

%%解除亲密返还比例（万分比）
get_mate_key(break_return) ->
    9500;

%%连打部分总分
get_mate_key(combo_rate) ->
    5000;

%%单次每日赠送内容
get_mate_key(daily_sent) ->
    {255,100011,5};

%%默认羁绊称号（前接玩家名称）
get_mate_key(default_desg) ->
    "小宝贝";

%%默认备注套组（前端定id先）
get_mate_key(default_remark) ->
    1;

%%发布交友普通消费
get_mate_key(hall_release_normal_price) ->
    [];

%%发布交友置顶消费
get_mate_key(hall_release_sp_price) ->
    [{2,0,10}];

%%交友大厅发布时间(5分钟)
get_mate_key(hall_show_time) ->
    300;

%%羁绊价格
get_mate_key(mate_cost) ->
    [{2,0,100}];

%%羁绊所需最低亲密度
get_mate_key(mate_intimacy) ->
    520;

%%羁绊人数上限
get_mate_key(mate_max) ->
    4;

%%羁绊奖励
get_mate_key(mate_rewards) ->
    [{0,102403,5},{0,102004,10},{0,102000,10}];

%%A评级谱面分数
get_mate_key(music_Arank) ->
    {800001,900000};

%%B评级谱面分数
get_mate_key(music_Brank) ->
    {700001,800000};

%%C评级谱面分数
get_mate_key(music_Crank) ->
    {0,700000};

%%谱面总分
get_mate_key(music_score) ->
    95000;

%%S评级谱面分数
get_mate_key(music_Srank) ->
    {900001,950000};

%%SS评级谱面分数
get_mate_key(music_Ssrank) ->
    {950001,1000000};

%%拍点精确时间
get_mate_key(note_correct) ->
    600;

%%拍点Great范围
get_mate_key(note_great) ->
    200;

%%拍点总长
get_mate_key(note_last) ->
    850;

%%拍点圆收缩最大半径
get_mate_key(note_max_radius) ->
    400;

%%拍点圆半径
get_mate_key(note_radius) ->
    175;

%%拍点圆热区半径
get_mate_key(note_tap_radius) ->
    225;

%%小船成长道具
get_mate_key(ship_item) ->
    102501;

%%小船单个成长经验
get_mate_key(ship_item_exp) ->
    10;

get_mate_key(_Keycontent) ->
    error.


get_mate_lv_attr(1) ->
    [{1,20},{2,240},{26,300}];


get_mate_lv_attr(2) ->
    [{1,30},{2,360},{26,350}];


get_mate_lv_attr(3) ->
    [{1,40},{2,480},{26,400}];


get_mate_lv_attr(4) ->
    [{1,60},{2,720},{26,450}];


get_mate_lv_attr(5) ->
    [{1,90},{2,1080},{26,500}];


get_mate_lv_attr(6) ->
    [{1,110},{2,1320},{26,550}];


get_mate_lv_attr(7) ->
    [{1,150},{2,1800},{26,600}];


get_mate_lv_attr(8) ->
    [{1,170},{2,2040},{26,650}];


get_mate_lv_attr(9) ->
    [{1,230},{2,2760},{26,700}];


get_mate_lv_attr(10) ->
    [{1,250},{2,3000},{26,750}];


get_mate_lv_attr(11) ->
    [{1,300},{2,3600},{26,800}];


get_mate_lv_attr(12) ->
    [{1,330},{2,3960},{26,850}];


get_mate_lv_attr(13) ->
    [{1,380},{2,4560},{26,900}];


get_mate_lv_attr(14) ->
    [{1,430},{2,5160},{26,950}];


get_mate_lv_attr(15) ->
    [{1,470},{2,5640},{26,1000}];


get_mate_lv_attr(16) ->
    [{1,510},{2,6120},{26,1050}];


get_mate_lv_attr(17) ->
    [{1,540},{2,6480},{26,1100}];


get_mate_lv_attr(18) ->
    [{1,570},{2,6840},{26,1150}];


get_mate_lv_attr(19) ->
    [{1,600},{2,7200},{26,1200}];


get_mate_lv_attr(20) ->
    [{1,620},{2,7440},{26,1250}];


get_mate_lv_attr(21) ->
    [{1,640},{2,7680},{26,1300}];


get_mate_lv_attr(22) ->
    [{1,660},{2,7920},{26,1350}];


get_mate_lv_attr(23) ->
    [{1,680},{2,8160},{26,1400}];


get_mate_lv_attr(24) ->
    [{1,720},{2,8640},{26,1450}];


get_mate_lv_attr(25) ->
    [{1,760},{2,9120},{26,1500}];


get_mate_lv_attr(26) ->
    [{1,800},{2,9600},{26,1550}];


get_mate_lv_attr(27) ->
    [{1,830},{2,9960},{26,1600}];


get_mate_lv_attr(28) ->
    [{1,860},{2,10320},{26,1650}];


get_mate_lv_attr(29) ->
    [{1,930},{2,11160},{26,1700}];


get_mate_lv_attr(30) ->
    [{1,990},{2,11880},{26,1750}];


get_mate_lv_attr(31) ->
    [{1,1040},{2,12480},{26,1800}];


get_mate_lv_attr(32) ->
    [{1,1090},{2,13080},{26,1850}];


get_mate_lv_attr(33) ->
    [{1,1140},{2,13680},{26,1900}];

get_mate_lv_attr(_Lv) ->
    [].


get_mate_anniversary_day(1) ->
    [{0,102401,1}];


get_mate_anniversary_day(2) ->
    [{0,102402,1}];


get_mate_anniversary_day(3) ->
    [{0,102403,1}];


get_mate_anniversary_day(5) ->
    [{0,102403,2}];


get_mate_anniversary_day(8) ->
    [{0,102404,1}];


get_mate_anniversary_day(10) ->
    [{0,102404,2}];


get_mate_anniversary_day(15) ->
    [{0,102405,1}];


get_mate_anniversary_day(30) ->
    [{0,102405,2}];


get_mate_anniversary_day(90) ->
    [{0,102406,1}];


get_mate_anniversary_day(120) ->
    [{0,102406,2}];


get_mate_anniversary_day(180) ->
    [{0,102407,1}];


get_mate_anniversary_day(200) ->
    [{0,102407,2}];


get_mate_anniversary_day(365) ->
    [{0,102408,1}];

get_mate_anniversary_day(_Day) ->
    [].

get_mate_boat(1,1) ->
    #base_mate_boat{stage = 1,star = 1,name = <<"友谊的小纸船"/utf8>>,exp = 61,attr = [{1,184},{2,1840},{4,92}],picture = 1001,goods_id = 340001};

get_mate_boat(1,2) ->
    #base_mate_boat{stage = 1,star = 2,name = <<"友谊的小纸船"/utf8>>,exp = 72,attr = [{1,220},{2,2200},{4,110}],picture = 1001,goods_id = 340001};

get_mate_boat(1,3) ->
    #base_mate_boat{stage = 1,star = 3,name = <<"友谊的小纸船"/utf8>>,exp = 84,attr = [{1,258},{2,2580},{4,129}],picture = 1001,goods_id = 340001};

get_mate_boat(1,4) ->
    #base_mate_boat{stage = 1,star = 4,name = <<"友谊的小纸船"/utf8>>,exp = 96,attr = [{1,298},{2,2980},{4,149}],picture = 1001,goods_id = 340001};

get_mate_boat(1,5) ->
    #base_mate_boat{stage = 1,star = 5,name = <<"友谊的小纸船"/utf8>>,exp = 109,attr = [{1,340},{2,3400},{4,170}],picture = 1001,goods_id = 340001};

get_mate_boat(1,6) ->
    #base_mate_boat{stage = 1,star = 6,name = <<"友谊的小纸船"/utf8>>,exp = 122,attr = [{1,384},{2,3840},{4,192}],picture = 1001,goods_id = 340001};

get_mate_boat(1,7) ->
    #base_mate_boat{stage = 1,star = 7,name = <<"友谊的小纸船"/utf8>>,exp = 136,attr = [{1,430},{2,4300},{4,215}],picture = 1001,goods_id = 340001};

get_mate_boat(1,8) ->
    #base_mate_boat{stage = 1,star = 8,name = <<"友谊的小纸船"/utf8>>,exp = 151,attr = [{1,478},{2,4780},{4,239}],picture = 1001,goods_id = 340001};

get_mate_boat(1,9) ->
    #base_mate_boat{stage = 1,star = 9,name = <<"友谊的小纸船"/utf8>>,exp = 167,attr = [{1,529},{2,5290},{4,265}],picture = 1001,goods_id = 340001};

get_mate_boat(1,10) ->
    #base_mate_boat{stage = 1,star = 10,name = <<"友谊的小纸船"/utf8>>,exp = 183,attr = [{1,582},{2,5820},{4,291}],picture = 1001,goods_id = 340001};

get_mate_boat(2,1) ->
    #base_mate_boat{stage = 2,star = 1,name = <<"友谊的独木舟"/utf8>>,exp = 200,attr = [{1,638},{2,6380},{4,319}],picture = 1002,goods_id = 340002};

get_mate_boat(2,2) ->
    #base_mate_boat{stage = 2,star = 2,name = <<"友谊的独木舟"/utf8>>,exp = 218,attr = [{1,697},{2,6970},{4,349}],picture = 1002,goods_id = 340002};

get_mate_boat(2,3) ->
    #base_mate_boat{stage = 2,star = 3,name = <<"友谊的独木舟"/utf8>>,exp = 237,attr = [{1,759},{2,7590},{4,380}],picture = 1002,goods_id = 340002};

get_mate_boat(2,4) ->
    #base_mate_boat{stage = 2,star = 4,name = <<"友谊的独木舟"/utf8>>,exp = 257,attr = [{1,824},{2,8240},{4,412}],picture = 1002,goods_id = 340002};

get_mate_boat(2,5) ->
    #base_mate_boat{stage = 2,star = 5,name = <<"友谊的独木舟"/utf8>>,exp = 278,attr = [{1,892},{2,8920},{4,446}],picture = 1002,goods_id = 340002};

get_mate_boat(2,6) ->
    #base_mate_boat{stage = 2,star = 6,name = <<"友谊的独木舟"/utf8>>,exp = 300,attr = [{1,963},{2,9630},{4,482}],picture = 1002,goods_id = 340002};

get_mate_boat(2,7) ->
    #base_mate_boat{stage = 2,star = 7,name = <<"友谊的独木舟"/utf8>>,exp = 323,attr = [{1,1038},{2,10380},{4,519}],picture = 1002,goods_id = 340002};

get_mate_boat(2,8) ->
    #base_mate_boat{stage = 2,star = 8,name = <<"友谊的独木舟"/utf8>>,exp = 347,attr = [{1,1117},{2,11170},{4,559}],picture = 1002,goods_id = 340002};

get_mate_boat(2,9) ->
    #base_mate_boat{stage = 2,star = 9,name = <<"友谊的独木舟"/utf8>>,exp = 372,attr = [{1,1199},{2,11990},{4,600}],picture = 1002,goods_id = 340002};

get_mate_boat(2,10) ->
    #base_mate_boat{stage = 2,star = 10,name = <<"友谊的独木舟"/utf8>>,exp = 399,attr = [{1,1286},{2,12860},{4,643}],picture = 1002,goods_id = 340002};

get_mate_boat(3,1) ->
    #base_mate_boat{stage = 3,star = 1,name = <<"友谊的小竹筏"/utf8>>,exp = 427,attr = [{1,1377},{2,13770},{4,689}],picture = 1003,goods_id = 340003};

get_mate_boat(3,2) ->
    #base_mate_boat{stage = 3,star = 2,name = <<"友谊的小竹筏"/utf8>>,exp = 456,attr = [{1,1473},{2,14730},{4,737}],picture = 1003,goods_id = 340003};

get_mate_boat(3,3) ->
    #base_mate_boat{stage = 3,star = 3,name = <<"友谊的小竹筏"/utf8>>,exp = 487,attr = [{1,1573},{2,15730},{4,787}],picture = 1003,goods_id = 340003};

get_mate_boat(3,4) ->
    #base_mate_boat{stage = 3,star = 4,name = <<"友谊的小竹筏"/utf8>>,exp = 519,attr = [{1,1678},{2,16780},{4,839}],picture = 1003,goods_id = 340003};

get_mate_boat(3,5) ->
    #base_mate_boat{stage = 3,star = 5,name = <<"友谊的小竹筏"/utf8>>,exp = 553,attr = [{1,1789},{2,17890},{4,895}],picture = 1003,goods_id = 340003};

get_mate_boat(3,6) ->
    #base_mate_boat{stage = 3,star = 6,name = <<"友谊的小竹筏"/utf8>>,exp = 589,attr = [{1,1905},{2,19050},{4,953}],picture = 1003,goods_id = 340003};

get_mate_boat(3,7) ->
    #base_mate_boat{stage = 3,star = 7,name = <<"友谊的小竹筏"/utf8>>,exp = 626,attr = [{1,2027},{2,20270},{4,1014}],picture = 1003,goods_id = 340003};

get_mate_boat(3,8) ->
    #base_mate_boat{stage = 3,star = 8,name = <<"友谊的小竹筏"/utf8>>,exp = 665,attr = [{1,2155},{2,21550},{4,1078}],picture = 1003,goods_id = 340003};

get_mate_boat(3,9) ->
    #base_mate_boat{stage = 3,star = 9,name = <<"友谊的小竹筏"/utf8>>,exp = 706,attr = [{1,2289},{2,22890},{4,1145}],picture = 1003,goods_id = 340003};

get_mate_boat(3,10) ->
    #base_mate_boat{stage = 3,star = 10,name = <<"友谊的小竹筏"/utf8>>,exp = 749,attr = [{1,2430},{2,24300},{4,1215}],picture = 1003,goods_id = 340003};

get_mate_boat(4,1) ->
    #base_mate_boat{stage = 4,star = 1,name = <<"友谊的乌篷船"/utf8>>,exp = 794,attr = [{1,2578},{2,25780},{4,1289}],picture = 1004,goods_id = 340004};

get_mate_boat(4,2) ->
    #base_mate_boat{stage = 4,star = 2,name = <<"友谊的乌篷船"/utf8>>,exp = 842,attr = [{1,2734},{2,27340},{4,1367}],picture = 1004,goods_id = 340004};

get_mate_boat(4,3) ->
    #base_mate_boat{stage = 4,star = 3,name = <<"友谊的乌篷船"/utf8>>,exp = 892,attr = [{1,2897},{2,28970},{4,1449}],picture = 1004,goods_id = 340004};

get_mate_boat(4,4) ->
    #base_mate_boat{stage = 4,star = 4,name = <<"友谊的乌篷船"/utf8>>,exp = 945,attr = [{1,3069},{2,30690},{4,1535}],picture = 1004,goods_id = 340004};

get_mate_boat(4,5) ->
    #base_mate_boat{stage = 4,star = 5,name = <<"友谊的乌篷船"/utf8>>,exp = 1000,attr = [{1,3249},{2,32490},{4,1625}],picture = 1004,goods_id = 340004};

get_mate_boat(4,6) ->
    #base_mate_boat{stage = 4,star = 6,name = <<"友谊的乌篷船"/utf8>>,exp = 1058,attr = [{1,3438},{2,34380},{4,1719}],picture = 1004,goods_id = 340004};

get_mate_boat(4,7) ->
    #base_mate_boat{stage = 4,star = 7,name = <<"友谊的乌篷船"/utf8>>,exp = 1119,attr = [{1,3637},{2,36370},{4,1819}],picture = 1004,goods_id = 340004};

get_mate_boat(4,8) ->
    #base_mate_boat{stage = 4,star = 8,name = <<"友谊的乌篷船"/utf8>>,exp = 1183,attr = [{1,3846},{2,38460},{4,1923}],picture = 1004,goods_id = 340004};

get_mate_boat(4,9) ->
    #base_mate_boat{stage = 4,star = 9,name = <<"友谊的乌篷船"/utf8>>,exp = 1250,attr = [{1,4065},{2,40650},{4,2033}],picture = 1004,goods_id = 340004};

get_mate_boat(4,10) ->
    #base_mate_boat{stage = 4,star = 10,name = <<"友谊的乌篷船"/utf8>>,exp = 1320,attr = [{1,4295},{2,42950},{4,2148}],picture = 1004,goods_id = 340004};

get_mate_boat(5,1) ->
    #base_mate_boat{stage = 5,star = 1,name = <<"友谊的太阳帆"/utf8>>,exp = 1394,attr = [{1,4537},{2,45370},{4,2269}],picture = 1005,goods_id = 340004};

get_mate_boat(5,2) ->
    #base_mate_boat{stage = 5,star = 2,name = <<"友谊的太阳帆"/utf8>>,exp = 1472,attr = [{1,4791},{2,47910},{4,2396}],picture = 1005,goods_id = 340004};

get_mate_boat(5,3) ->
    #base_mate_boat{stage = 5,star = 3,name = <<"友谊的太阳帆"/utf8>>,exp = 1553,attr = [{1,5057},{2,50570},{4,2529}],picture = 1005,goods_id = 340004};

get_mate_boat(5,4) ->
    #base_mate_boat{stage = 5,star = 4,name = <<"友谊的太阳帆"/utf8>>,exp = 1639,attr = [{1,5337},{2,53370},{4,2669}],picture = 1005,goods_id = 340004};

get_mate_boat(5,5) ->
    #base_mate_boat{stage = 5,star = 5,name = <<"友谊的太阳帆"/utf8>>,exp = 1729,attr = [{1,5631},{2,56310},{4,2816}],picture = 1005,goods_id = 340004};

get_mate_boat(5,6) ->
    #base_mate_boat{stage = 5,star = 6,name = <<"友谊的太阳帆"/utf8>>,exp = 1823,attr = [{1,5940},{2,59400},{4,2970}],picture = 1005,goods_id = 340004};

get_mate_boat(5,7) ->
    #base_mate_boat{stage = 5,star = 7,name = <<"友谊的太阳帆"/utf8>>,exp = 1922,attr = [{1,6264},{2,62640},{4,3132}],picture = 1005,goods_id = 340004};

get_mate_boat(5,8) ->
    #base_mate_boat{stage = 5,star = 8,name = <<"友谊的太阳帆"/utf8>>,exp = 2026,attr = [{1,6604},{2,66040},{4,3302}],picture = 1005,goods_id = 340004};

get_mate_boat(5,9) ->
    #base_mate_boat{stage = 5,star = 9,name = <<"友谊的太阳帆"/utf8>>,exp = 2135,attr = [{1,6961},{2,69610},{4,3481}],picture = 1005,goods_id = 340004};

get_mate_boat(5,10) ->
    #base_mate_boat{stage = 5,star = 10,name = <<"友谊的太阳帆"/utf8>>,exp = 2250,attr = [{1,7336},{2,73360},{4,3668}],picture = 1005,goods_id = 340004};

get_mate_boat(6,1) ->
    #base_mate_boat{stage = 6,star = 1,name = <<"友谊的快艇"/utf8>>,exp = 2370,attr = [{1,7730},{2,77300},{4,3865}],picture = 1006,goods_id = 340005};

get_mate_boat(6,2) ->
    #base_mate_boat{stage = 6,star = 2,name = <<"友谊的快艇"/utf8>>,exp = 2496,attr = [{1,8144},{2,81440},{4,4072}],picture = 1006,goods_id = 340005};

get_mate_boat(6,3) ->
    #base_mate_boat{stage = 6,star = 3,name = <<"友谊的快艇"/utf8>>,exp = 2629,attr = [{1,8578},{2,85780},{4,4289}],picture = 1006,goods_id = 340005};

get_mate_boat(6,4) ->
    #base_mate_boat{stage = 6,star = 4,name = <<"友谊的快艇"/utf8>>,exp = 2768,attr = [{1,9034},{2,90340},{4,4517}],picture = 1006,goods_id = 340005};

get_mate_boat(6,5) ->
    #base_mate_boat{stage = 6,star = 5,name = <<"友谊的快艇"/utf8>>,exp = 2914,attr = [{1,9513},{2,95130},{4,4757}],picture = 1006,goods_id = 340005};

get_mate_boat(6,6) ->
    #base_mate_boat{stage = 6,star = 6,name = <<"友谊的快艇"/utf8>>,exp = 3068,attr = [{1,10016},{2,100160},{4,5008}],picture = 1006,goods_id = 340005};

get_mate_boat(6,7) ->
    #base_mate_boat{stage = 6,star = 7,name = <<"友谊的快艇"/utf8>>,exp = 3229,attr = [{1,10544},{2,105440},{4,5272}],picture = 1006,goods_id = 340005};

get_mate_boat(6,8) ->
    #base_mate_boat{stage = 6,star = 8,name = <<"友谊的快艇"/utf8>>,exp = 3398,attr = [{1,11099},{2,110990},{4,5550}],picture = 1006,goods_id = 340005};

get_mate_boat(6,9) ->
    #base_mate_boat{stage = 6,star = 9,name = <<"友谊的快艇"/utf8>>,exp = 3576,attr = [{1,11681},{2,116810},{4,5841}],picture = 1006,goods_id = 340005};

get_mate_boat(6,10) ->
    #base_mate_boat{stage = 6,star = 10,name = <<"友谊的快艇"/utf8>>,exp = 3763,attr = [{1,12292},{2,122920},{4,6146}],picture = 1006,goods_id = 340005};

get_mate_boat(7,1) ->
    #base_mate_boat{stage = 7,star = 1,name = <<"友谊的海盗船"/utf8>>,exp = 3959,attr = [{1,12934},{2,129340},{4,6467}],picture = 1007,goods_id = 340005};

get_mate_boat(7,2) ->
    #base_mate_boat{stage = 7,star = 2,name = <<"友谊的海盗船"/utf8>>,exp = 4165,attr = [{1,13608},{2,136080},{4,6804}],picture = 1007,goods_id = 340005};

get_mate_boat(7,3) ->
    #base_mate_boat{stage = 7,star = 3,name = <<"友谊的海盗船"/utf8>>,exp = 4381,attr = [{1,14316},{2,143160},{4,7158}],picture = 1007,goods_id = 340005};

get_mate_boat(7,4) ->
    #base_mate_boat{stage = 7,star = 4,name = <<"友谊的海盗船"/utf8>>,exp = 4608,attr = [{1,15059},{2,150590},{4,7530}],picture = 1007,goods_id = 340005};

get_mate_boat(7,5) ->
    #base_mate_boat{stage = 7,star = 5,name = <<"友谊的海盗船"/utf8>>,exp = 4846,attr = [{1,15840},{2,158400},{4,7920}],picture = 1007,goods_id = 340005};

get_mate_boat(7,6) ->
    #base_mate_boat{stage = 7,star = 6,name = <<"友谊的海盗船"/utf8>>,exp = 5096,attr = [{1,16660},{2,166600},{4,8330}],picture = 1007,goods_id = 340005};

get_mate_boat(7,7) ->
    #base_mate_boat{stage = 7,star = 7,name = <<"友谊的海盗船"/utf8>>,exp = 5359,attr = [{1,17521},{2,175210},{4,8761}],picture = 1007,goods_id = 340005};

get_mate_boat(7,8) ->
    #base_mate_boat{stage = 7,star = 8,name = <<"友谊的海盗船"/utf8>>,exp = 5635,attr = [{1,18425},{2,184250},{4,9213}],picture = 1007,goods_id = 340005};

get_mate_boat(7,9) ->
    #base_mate_boat{stage = 7,star = 9,name = <<"友谊的海盗船"/utf8>>,exp = 5925,attr = [{1,19374},{2,193740},{4,9687}],picture = 1007,goods_id = 340005};

get_mate_boat(7,10) ->
    #base_mate_boat{stage = 7,star = 10,name = <<"友谊的海盗船"/utf8>>,exp = 6229,attr = [{1,20371},{2,203710},{4,10186}],picture = 1007,goods_id = 340005};

get_mate_boat(8,1) ->
    #base_mate_boat{stage = 8,star = 1,name = <<"友谊的大游艇"/utf8>>,exp = 6548,attr = [{1,21418},{2,214180},{4,10709}],picture = 1008,goods_id = 340006};

get_mate_boat(8,2) ->
    #base_mate_boat{stage = 8,star = 2,name = <<"友谊的大游艇"/utf8>>,exp = 6883,attr = [{1,22517},{2,225170},{4,11259}],picture = 1008,goods_id = 340006};

get_mate_boat(8,3) ->
    #base_mate_boat{stage = 8,star = 3,name = <<"友谊的大游艇"/utf8>>,exp = 7235,attr = [{1,23671},{2,236710},{4,11836}],picture = 1008,goods_id = 340006};

get_mate_boat(8,4) ->
    #base_mate_boat{stage = 8,star = 4,name = <<"友谊的大游艇"/utf8>>,exp = 7605,attr = [{1,24883},{2,248830},{4,12442}],picture = 1008,goods_id = 340006};

get_mate_boat(8,5) ->
    #base_mate_boat{stage = 8,star = 5,name = <<"友谊的大游艇"/utf8>>,exp = 7993,attr = [{1,26155},{2,261550},{4,13078}],picture = 1008,goods_id = 340006};

get_mate_boat(8,6) ->
    #base_mate_boat{stage = 8,star = 6,name = <<"友谊的大游艇"/utf8>>,exp = 8401,attr = [{1,27491},{2,274910},{4,13746}],picture = 1008,goods_id = 340006};

get_mate_boat(8,7) ->
    #base_mate_boat{stage = 8,star = 7,name = <<"友谊的大游艇"/utf8>>,exp = 8829,attr = [{1,28894},{2,288940},{4,14447}],picture = 1008,goods_id = 340006};

get_mate_boat(8,8) ->
    #base_mate_boat{stage = 8,star = 8,name = <<"友谊的大游艇"/utf8>>,exp = 9279,attr = [{1,30367},{2,303670},{4,15184}],picture = 1008,goods_id = 340006};

get_mate_boat(8,9) ->
    #base_mate_boat{stage = 8,star = 9,name = <<"友谊的大游艇"/utf8>>,exp = 9751,attr = [{1,31914},{2,319140},{4,15957}],picture = 1008,goods_id = 340006};

get_mate_boat(8,10) ->
    #base_mate_boat{stage = 8,star = 10,name = <<"友谊的大游艇"/utf8>>,exp = 10247,attr = [{1,33538},{2,335380},{4,16769}],picture = 1008,goods_id = 340006};

get_mate_boat(9,1) ->
    #base_mate_boat{stage = 9,star = 1,name = <<"友谊的巨轮"/utf8>>,exp = 10767,attr = [{1,35244},{2,352440},{4,17622}],picture = 1009,goods_id = 340006};

get_mate_boat(9,2) ->
    #base_mate_boat{stage = 9,star = 2,name = <<"友谊的巨轮"/utf8>>,exp = 11313,attr = [{1,37035},{2,370350},{4,18518}],picture = 1009,goods_id = 340006};

get_mate_boat(9,3) ->
    #base_mate_boat{stage = 9,star = 3,name = <<"友谊的巨轮"/utf8>>,exp = 11887,attr = [{1,38916},{2,389160},{4,19458}],picture = 1009,goods_id = 340006};

get_mate_boat(9,4) ->
    #base_mate_boat{stage = 9,star = 4,name = <<"友谊的巨轮"/utf8>>,exp = 12489,attr = [{1,40891},{2,408910},{4,20446}],picture = 1009,goods_id = 340006};

get_mate_boat(9,5) ->
    #base_mate_boat{stage = 9,star = 5,name = <<"友谊的巨轮"/utf8>>,exp = 13122,attr = [{1,42965},{2,429650},{4,21483}],picture = 1009,goods_id = 340006};

get_mate_boat(9,6) ->
    #base_mate_boat{stage = 9,star = 6,name = <<"友谊的巨轮"/utf8>>,exp = 13786,attr = [{1,45143},{2,451430},{4,22572}],picture = 1009,goods_id = 340006};

get_mate_boat(9,7) ->
    #base_mate_boat{stage = 9,star = 7,name = <<"友谊的巨轮"/utf8>>,exp = 14483,attr = [{1,47430},{2,474300},{4,23715}],picture = 1009,goods_id = 340006};

get_mate_boat(9,8) ->
    #base_mate_boat{stage = 9,star = 8,name = <<"友谊的巨轮"/utf8>>,exp = 15215,attr = [{1,49831},{2,498310},{4,24916}],picture = 1009,goods_id = 340006};

get_mate_boat(9,9) ->
    #base_mate_boat{stage = 9,star = 9,name = <<"友谊的巨轮"/utf8>>,exp = 15984,attr = [{1,52353},{2,523530},{4,26177}],picture = 1009,goods_id = 340006};

get_mate_boat(9,10) ->
    #base_mate_boat{stage = 9,star = 10,name = <<"友谊的巨轮"/utf8>>,exp = 16791,attr = [{1,55001},{2,550010},{4,27501}],picture = 1009,goods_id = 340006};

get_mate_boat(10,1) ->
    #base_mate_boat{stage = 10,star = 1,name = <<"友谊的巡航舰"/utf8>>,exp = 17639,attr = [{1,57782},{2,577820},{4,28891}],picture = 1010,goods_id = 340007};

get_mate_boat(10,2) ->
    #base_mate_boat{stage = 10,star = 2,name = <<"友谊的巡航舰"/utf8>>,exp = 18529,attr = [{1,60702},{2,607020},{4,30351}],picture = 1010,goods_id = 340007};

get_mate_boat(10,3) ->
    #base_mate_boat{stage = 10,star = 3,name = <<"友谊的巡航舰"/utf8>>,exp = 19464,attr = [{1,63768},{2,637680},{4,31884}],picture = 1010,goods_id = 340007};

get_mate_boat(10,4) ->
    #base_mate_boat{stage = 10,star = 4,name = <<"友谊的巡航舰"/utf8>>,exp = 20445,attr = [{1,66987},{2,669870},{4,33494}],picture = 1010,goods_id = 340007};

get_mate_boat(10,5) ->
    #base_mate_boat{stage = 10,star = 5,name = <<"友谊的巡航舰"/utf8>>,exp = 21475,attr = [{1,70368},{2,703680},{4,35184}],picture = 1010,goods_id = 340007};

get_mate_boat(10,6) ->
    #base_mate_boat{stage = 10,star = 6,name = <<"友谊的巡航舰"/utf8>>,exp = 22557,attr = [{1,73918},{2,739180},{4,36959}],picture = 1010,goods_id = 340007};

get_mate_boat(10,7) ->
    #base_mate_boat{stage = 10,star = 7,name = <<"友谊的巡航舰"/utf8>>,exp = 23693,attr = [{1,77646},{2,776460},{4,38823}],picture = 1010,goods_id = 340007};

get_mate_boat(10,8) ->
    #base_mate_boat{stage = 10,star = 8,name = <<"友谊的巡航舰"/utf8>>,exp = 24886,attr = [{1,81560},{2,815600},{4,40780}],picture = 1010,goods_id = 340007};

get_mate_boat(10,9) ->
    #base_mate_boat{stage = 10,star = 9,name = <<"友谊的巡航舰"/utf8>>,exp = 26138,attr = [{1,85670},{2,856700},{4,42835}],picture = 1010,goods_id = 340007};

get_mate_boat(10,10) ->
    #base_mate_boat{stage = 10,star = 10,name = <<"友谊的巡航舰"/utf8>>,exp = 27453,attr = [{1,89986},{2,899860},{4,44993}],picture = 1010,goods_id = 340007};

get_mate_boat(_Stage,_Star) ->
    [].

get_mate_boat_all_skills() ->
    [{3,510001},{5,510002},{7,510003},{10,510004}].

get_mate_music(1) ->
    #base_mate_rhythm_master_music{music_id = 1,name = <<"漂流"/utf8>>,bgm = mate_game_1,move = wgc,bit_group = [1,2,3,4,5,6,7,8,9,10,11,12],time = 112000};

get_mate_music(_Musicid) ->
    [].

get_mate_all_music() ->
    [1].

get_mate_bit(1,1) ->
    #base_mate_rhythm_master_bit{bit_group = 1,bit_id = 1,bit_position = {30,75},pre_time = 7850};

get_mate_bit(1,2) ->
    #base_mate_rhythm_master_bit{bit_group = 1,bit_id = 2,bit_position = {50,60},pre_time = 1200};

get_mate_bit(1,3) ->
    #base_mate_rhythm_master_bit{bit_group = 1,bit_id = 3,bit_position = {70,40},pre_time = 1200};

get_mate_bit(1,4) ->
    #base_mate_rhythm_master_bit{bit_group = 1,bit_id = 4,bit_position = {30,40},pre_time = 1200};

get_mate_bit(1,5) ->
    #base_mate_rhythm_master_bit{bit_group = 1,bit_id = 5,bit_position = {50,25},pre_time = 1200};

get_mate_bit(2,6) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 6,bit_position = {20,85},pre_time = 3000};

get_mate_bit(2,7) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 7,bit_position = {30,85},pre_time = 1200};

get_mate_bit(2,8) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 8,bit_position = {50,85},pre_time = 1200};

get_mate_bit(2,9) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 9,bit_position = {70,85},pre_time = 1200};

get_mate_bit(2,10) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 10,bit_position = {70,50},pre_time = 1200};

get_mate_bit(2,11) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 11,bit_position = {50,50},pre_time = 1200};

get_mate_bit(2,12) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 12,bit_position = {20,50},pre_time = 1200};

get_mate_bit(2,13) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 13,bit_position = {20,15},pre_time = 1200};

get_mate_bit(2,14) ->
    #base_mate_rhythm_master_bit{bit_group = 2,bit_id = 14,bit_position = {50,15},pre_time = 1200};

get_mate_bit(3,15) ->
    #base_mate_rhythm_master_bit{bit_group = 3,bit_id = 15,bit_position = {18,18},pre_time = 3500};

get_mate_bit(3,16) ->
    #base_mate_rhythm_master_bit{bit_group = 3,bit_id = 16,bit_position = {34,34},pre_time = 1200};

get_mate_bit(3,17) ->
    #base_mate_rhythm_master_bit{bit_group = 3,bit_id = 17,bit_position = {50,50},pre_time = 1200};

get_mate_bit(3,18) ->
    #base_mate_rhythm_master_bit{bit_group = 3,bit_id = 18,bit_position = {66,66},pre_time = 1200};

get_mate_bit(3,19) ->
    #base_mate_rhythm_master_bit{bit_group = 3,bit_id = 19,bit_position = {82,82},pre_time = 1200};

get_mate_bit(3,20) ->
    #base_mate_rhythm_master_bit{bit_group = 3,bit_id = 20,bit_position = {82,66},pre_time = 1200};

get_mate_bit(3,21) ->
    #base_mate_rhythm_master_bit{bit_group = 3,bit_id = 21,bit_position = {82,50},pre_time = 1200};

get_mate_bit(4,22) ->
    #base_mate_rhythm_master_bit{bit_group = 4,bit_id = 22,bit_position = {20,50},pre_time = 2870};

get_mate_bit(4,23) ->
    #base_mate_rhythm_master_bit{bit_group = 4,bit_id = 23,bit_position = {40,70},pre_time = 1200};

get_mate_bit(4,24) ->
    #base_mate_rhythm_master_bit{bit_group = 4,bit_id = 24,bit_position = {60,70},pre_time = 1200};

get_mate_bit(4,25) ->
    #base_mate_rhythm_master_bit{bit_group = 4,bit_id = 25,bit_position = {80,50},pre_time = 1200};

get_mate_bit(5,26) ->
    #base_mate_rhythm_master_bit{bit_group = 5,bit_id = 26,bit_position = {18,82},pre_time = 1620};

get_mate_bit(5,27) ->
    #base_mate_rhythm_master_bit{bit_group = 5,bit_id = 27,bit_position = {34,66},pre_time = 1200};

get_mate_bit(5,28) ->
    #base_mate_rhythm_master_bit{bit_group = 5,bit_id = 28,bit_position = {50,50},pre_time = 1200};

get_mate_bit(5,29) ->
    #base_mate_rhythm_master_bit{bit_group = 5,bit_id = 29,bit_position = {66,34},pre_time = 1200};

get_mate_bit(5,30) ->
    #base_mate_rhythm_master_bit{bit_group = 5,bit_id = 30,bit_position = {82,18},pre_time = 1200};

get_mate_bit(5,31) ->
    #base_mate_rhythm_master_bit{bit_group = 5,bit_id = 31,bit_position = {82,34},pre_time = 1200};

get_mate_bit(6,32) ->
    #base_mate_rhythm_master_bit{bit_group = 6,bit_id = 32,bit_position = {40,50},pre_time = 1810};

get_mate_bit(6,33) ->
    #base_mate_rhythm_master_bit{bit_group = 6,bit_id = 33,bit_position = {60,50},pre_time = 1200};

get_mate_bit(7,34) ->
    #base_mate_rhythm_master_bit{bit_group = 7,bit_id = 34,bit_position = {18,82},pre_time = 1430};

get_mate_bit(7,35) ->
    #base_mate_rhythm_master_bit{bit_group = 7,bit_id = 35,bit_position = {34,66},pre_time = 1200};

get_mate_bit(7,36) ->
    #base_mate_rhythm_master_bit{bit_group = 7,bit_id = 36,bit_position = {50,50},pre_time = 1200};

get_mate_bit(7,37) ->
    #base_mate_rhythm_master_bit{bit_group = 7,bit_id = 37,bit_position = {66,34},pre_time = 1200};

get_mate_bit(7,38) ->
    #base_mate_rhythm_master_bit{bit_group = 7,bit_id = 38,bit_position = {82,18},pre_time = 1200};

get_mate_bit(7,39) ->
    #base_mate_rhythm_master_bit{bit_group = 7,bit_id = 39,bit_position = {82,34},pre_time = 1200};

get_mate_bit(8,40) ->
    #base_mate_rhythm_master_bit{bit_group = 8,bit_id = 40,bit_position = {20,85},pre_time = 2370};

get_mate_bit(8,41) ->
    #base_mate_rhythm_master_bit{bit_group = 8,bit_id = 41,bit_position = {30,85},pre_time = 1200};

get_mate_bit(8,42) ->
    #base_mate_rhythm_master_bit{bit_group = 8,bit_id = 42,bit_position = {50,85},pre_time = 1200};

get_mate_bit(8,43) ->
    #base_mate_rhythm_master_bit{bit_group = 8,bit_id = 43,bit_position = {70,85},pre_time = 1200};

get_mate_bit(9,44) ->
    #base_mate_rhythm_master_bit{bit_group = 9,bit_id = 44,bit_position = {20,35},pre_time = 1690};

get_mate_bit(9,45) ->
    #base_mate_rhythm_master_bit{bit_group = 9,bit_id = 45,bit_position = {30,35},pre_time = 1200};

get_mate_bit(9,46) ->
    #base_mate_rhythm_master_bit{bit_group = 9,bit_id = 46,bit_position = {50,35},pre_time = 1200};

get_mate_bit(9,47) ->
    #base_mate_rhythm_master_bit{bit_group = 9,bit_id = 47,bit_position = {70,35},pre_time = 1200};

get_mate_bit(10,48) ->
    #base_mate_rhythm_master_bit{bit_group = 10,bit_id = 48,bit_position = {18,82},pre_time = 1310};

get_mate_bit(10,49) ->
    #base_mate_rhythm_master_bit{bit_group = 10,bit_id = 49,bit_position = {34,66},pre_time = 1200};

get_mate_bit(10,50) ->
    #base_mate_rhythm_master_bit{bit_group = 10,bit_id = 50,bit_position = {50,50},pre_time = 1200};

get_mate_bit(10,51) ->
    #base_mate_rhythm_master_bit{bit_group = 10,bit_id = 51,bit_position = {66,34},pre_time = 1200};

get_mate_bit(10,52) ->
    #base_mate_rhythm_master_bit{bit_group = 10,bit_id = 52,bit_position = {82,18},pre_time = 1200};

get_mate_bit(11,53) ->
    #base_mate_rhythm_master_bit{bit_group = 11,bit_id = 53,bit_position = {20,85},pre_time = 1190};

get_mate_bit(11,54) ->
    #base_mate_rhythm_master_bit{bit_group = 11,bit_id = 54,bit_position = {30,85},pre_time = 1200};

get_mate_bit(11,55) ->
    #base_mate_rhythm_master_bit{bit_group = 11,bit_id = 55,bit_position = {50,85},pre_time = 1200};

get_mate_bit(11,56) ->
    #base_mate_rhythm_master_bit{bit_group = 11,bit_id = 56,bit_position = {70,85},pre_time = 1200};

get_mate_bit(11,57) ->
    #base_mate_rhythm_master_bit{bit_group = 11,bit_id = 57,bit_position = {70,50},pre_time = 1200};

get_mate_bit(11,58) ->
    #base_mate_rhythm_master_bit{bit_group = 11,bit_id = 58,bit_position = {50,50},pre_time = 1560};

get_mate_bit(12,59) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 59,bit_position = {20,20},pre_time = 1680};

get_mate_bit(12,60) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 60,bit_position = {20,80},pre_time = 1200};

get_mate_bit(12,61) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 61,bit_position = {40,20},pre_time = 1200};

get_mate_bit(12,62) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 62,bit_position = {40,80},pre_time = 1200};

get_mate_bit(12,63) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 63,bit_position = {60,20},pre_time = 1200};

get_mate_bit(12,64) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 64,bit_position = {60,80},pre_time = 1200};

get_mate_bit(12,65) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 65,bit_position = {80,20},pre_time = 1200};

get_mate_bit(12,66) ->
    #base_mate_rhythm_master_bit{bit_group = 12,bit_id = 66,bit_position = {80,80},pre_time = 1200};

get_mate_bit(13,67) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 67,bit_position = {80,20},pre_time = 2130};

get_mate_bit(13,68) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 68,bit_position = {80,80},pre_time = 1200};

get_mate_bit(13,69) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 69,bit_position = {60,20},pre_time = 1200};

get_mate_bit(13,70) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 70,bit_position = {60,80},pre_time = 1200};

get_mate_bit(13,71) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 71,bit_position = {40,20},pre_time = 1200};

get_mate_bit(13,72) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 72,bit_position = {40,80},pre_time = 1200};

get_mate_bit(13,73) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 73,bit_position = {20,20},pre_time = 1200};

get_mate_bit(13,74) ->
    #base_mate_rhythm_master_bit{bit_group = 13,bit_id = 74,bit_position = {20,80},pre_time = 1200};

get_mate_bit(14,75) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 75,bit_position = {20,80},pre_time = 2490};

get_mate_bit(14,76) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 76,bit_position = {30,60},pre_time = 1200};

get_mate_bit(14,77) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 77,bit_position = {40,40},pre_time = 1200};

get_mate_bit(14,78) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 78,bit_position = {50,20},pre_time = 1200};

get_mate_bit(14,79) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 79,bit_position = {50,80},pre_time = 1200};

get_mate_bit(14,80) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 80,bit_position = {60,60},pre_time = 1200};

get_mate_bit(14,81) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 81,bit_position = {70,40},pre_time = 1200};

get_mate_bit(14,82) ->
    #base_mate_rhythm_master_bit{bit_group = 14,bit_id = 82,bit_position = {80,20},pre_time = 1200};

get_mate_bit(15,83) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 83,bit_position = {20,20},pre_time = 2120};

get_mate_bit(15,84) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 84,bit_position = {30,40},pre_time = 1200};

get_mate_bit(15,85) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 85,bit_position = {40,60},pre_time = 1200};

get_mate_bit(15,86) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 86,bit_position = {50,80},pre_time = 1200};

get_mate_bit(15,87) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 87,bit_position = {50,20},pre_time = 1200};

get_mate_bit(15,88) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 88,bit_position = {60,40},pre_time = 1200};

get_mate_bit(15,89) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 89,bit_position = {70,60},pre_time = 1200};

get_mate_bit(15,90) ->
    #base_mate_rhythm_master_bit{bit_group = 15,bit_id = 90,bit_position = {80,80},pre_time = 1200};

get_mate_bit(16,91) ->
    #base_mate_rhythm_master_bit{bit_group = 16,bit_id = 91,bit_position = {30,75},pre_time = 2120};

get_mate_bit(16,92) ->
    #base_mate_rhythm_master_bit{bit_group = 16,bit_id = 92,bit_position = {50,60},pre_time = 1200};

get_mate_bit(16,93) ->
    #base_mate_rhythm_master_bit{bit_group = 16,bit_id = 93,bit_position = {70,40},pre_time = 1200};

get_mate_bit(16,94) ->
    #base_mate_rhythm_master_bit{bit_group = 16,bit_id = 94,bit_position = {30,40},pre_time = 1200};

get_mate_bit(16,95) ->
    #base_mate_rhythm_master_bit{bit_group = 16,bit_id = 95,bit_position = {50,25},pre_time = 1200};

get_mate_bit(17,96) ->
    #base_mate_rhythm_master_bit{bit_group = 17,bit_id = 96,bit_position = {18,82},pre_time = 1870};

get_mate_bit(17,97) ->
    #base_mate_rhythm_master_bit{bit_group = 17,bit_id = 97,bit_position = {34,66},pre_time = 1200};

get_mate_bit(17,98) ->
    #base_mate_rhythm_master_bit{bit_group = 17,bit_id = 98,bit_position = {50,50},pre_time = 1200};

get_mate_bit(17,99) ->
    #base_mate_rhythm_master_bit{bit_group = 17,bit_id = 99,bit_position = {66,34},pre_time = 1200};

get_mate_bit(17,100) ->
    #base_mate_rhythm_master_bit{bit_group = 17,bit_id = 100,bit_position = {82,18},pre_time = 1200};

get_mate_bit(17,101) ->
    #base_mate_rhythm_master_bit{bit_group = 17,bit_id = 101,bit_position = {82,34},pre_time = 1200};

get_mate_bit(18,102) ->
    #base_mate_rhythm_master_bit{bit_group = 18,bit_id = 102,bit_position = {50,80},pre_time = 1680};

get_mate_bit(18,103) ->
    #base_mate_rhythm_master_bit{bit_group = 18,bit_id = 103,bit_position = {60,60},pre_time = 1200};

get_mate_bit(18,104) ->
    #base_mate_rhythm_master_bit{bit_group = 18,bit_id = 104,bit_position = {70,40},pre_time = 1200};

get_mate_bit(18,105) ->
    #base_mate_rhythm_master_bit{bit_group = 18,bit_id = 105,bit_position = {80,20},pre_time = 1200};

get_mate_bit(19,106) ->
    #base_mate_rhythm_master_bit{bit_group = 19,bit_id = 106,bit_position = {50,20},pre_time = 2560};

get_mate_bit(19,107) ->
    #base_mate_rhythm_master_bit{bit_group = 19,bit_id = 107,bit_position = {60,40},pre_time = 1200};

get_mate_bit(19,108) ->
    #base_mate_rhythm_master_bit{bit_group = 19,bit_id = 108,bit_position = {70,60},pre_time = 1200};

get_mate_bit(19,109) ->
    #base_mate_rhythm_master_bit{bit_group = 19,bit_id = 109,bit_position = {80,80},pre_time = 1200};

get_mate_bit(20,110) ->
    #base_mate_rhythm_master_bit{bit_group = 20,bit_id = 110,bit_position = {25,25},pre_time = 2490};

get_mate_bit(20,111) ->
    #base_mate_rhythm_master_bit{bit_group = 20,bit_id = 111,bit_position = {50,50},pre_time = 1200};

get_mate_bit(20,112) ->
    #base_mate_rhythm_master_bit{bit_group = 20,bit_id = 112,bit_position = {75,75},pre_time = 1200};

get_mate_bit(21,113) ->
    #base_mate_rhythm_master_bit{bit_group = 21,bit_id = 113,bit_position = {25,75},pre_time = 1620};

get_mate_bit(21,114) ->
    #base_mate_rhythm_master_bit{bit_group = 21,bit_id = 114,bit_position = {50,50},pre_time = 1200};

get_mate_bit(21,115) ->
    #base_mate_rhythm_master_bit{bit_group = 21,bit_id = 115,bit_position = {75,25},pre_time = 1200};

get_mate_bit(22,116) ->
    #base_mate_rhythm_master_bit{bit_group = 22,bit_id = 116,bit_position = {50,50},pre_time = 1560};

get_mate_bit(22,117) ->
    #base_mate_rhythm_master_bit{bit_group = 22,bit_id = 117,bit_position = {50,50},pre_time = 1680};

get_mate_bit(_Bitgroup,_Bitid) ->
    [].


get_mate_bit_by_group(1) ->
    [1,2,3,4,5];


get_mate_bit_by_group(2) ->
    [6,7,8,9,10,11,12,13,14];


get_mate_bit_by_group(3) ->
    [15,16,17,18,19,20,21];


get_mate_bit_by_group(4) ->
    [22,23,24,25];


get_mate_bit_by_group(5) ->
    [26,27,28,29,30,31];


get_mate_bit_by_group(6) ->
    [32,33];


get_mate_bit_by_group(7) ->
    [34,35,36,37,38,39];


get_mate_bit_by_group(8) ->
    [40,41,42,43];


get_mate_bit_by_group(9) ->
    [44,45,46,47];


get_mate_bit_by_group(10) ->
    [48,49,50,51,52];


get_mate_bit_by_group(11) ->
    [53,54,55,56,57,58];


get_mate_bit_by_group(12) ->
    [59,60,61,62,63,64,65,66];


get_mate_bit_by_group(13) ->
    [67,68,69,70,71,72,73,74];


get_mate_bit_by_group(14) ->
    [75,76,77,78,79,80,81,82];


get_mate_bit_by_group(15) ->
    [83,84,85,86,87,88,89,90];


get_mate_bit_by_group(16) ->
    [91,92,93,94,95];


get_mate_bit_by_group(17) ->
    [96,97,98,99,100,101];


get_mate_bit_by_group(18) ->
    [102,103,104,105];


get_mate_bit_by_group(19) ->
    [106,107,108,109];


get_mate_bit_by_group(20) ->
    [110,111,112];


get_mate_bit_by_group(21) ->
    [113,114,115];


get_mate_bit_by_group(22) ->
    [116,117];

get_mate_bit_by_group(_Bitgroup) ->
    [].


get_mate_score_award(1) ->
    [{255,100011,10},{0,102401,1}];


get_mate_score_award(2) ->
    [{255,100011,20},{0,102401,1}];


get_mate_score_award(3) ->
    [{255,100011,30},{0,102401,1}];


get_mate_score_award(4) ->
    [{255,100011,40},{0,102401,1}];


get_mate_score_award(5) ->
    [{255,100011,50},{0,102401,1}];


get_mate_score_award(6) ->
    [{255,100011,60},{0,102401,1}];

get_mate_score_award(_Lv) ->
    [].

get_mate_score_lv(Score) when Score >= 1, Score =< 60000 ->
		1;
get_mate_score_lv(Score) when Score >= 60001, Score =< 80000 ->
		2;
get_mate_score_lv(Score) when Score >= 80001, Score =< 90000 ->
		3;
get_mate_score_lv(Score) when Score >= 90000, Score =< 95001 ->
		4;
get_mate_score_lv(Score) when Score >= 95000, Score =< 99999 ->
		5;
get_mate_score_lv(Score) when Score >= 100000, Score =< 999999 ->
		6;
get_mate_score_lv(_Score) ->
    0.


get_mate_catch_ball_award(1) ->
    [{255,100011,10},{0,102401,1}];


get_mate_catch_ball_award(2) ->
    [{255,100011,20},{0,102401,1}];


get_mate_catch_ball_award(3) ->
    [{255,100011,30},{0,102401,1}];


get_mate_catch_ball_award(4) ->
    [{255,100011,40},{0,102401,1}];


get_mate_catch_ball_award(5) ->
    [{255,100011,50},{0,102401,1}];


get_mate_catch_ball_award(6) ->
    [{255,100011,60},{0,102401,1}];

get_mate_catch_ball_award(_Lv) ->
    [].

get_mate_catch_ball_lv(Hits) when Hits >= 25 ->
		6;
get_mate_catch_ball_lv(Hits) when Hits >= 20 ->
		5;
get_mate_catch_ball_lv(Hits) when Hits >= 15 ->
		4;
get_mate_catch_ball_lv(Hits) when Hits >= 10 ->
		3;
get_mate_catch_ball_lv(Hits) when Hits >= 5 ->
		2;
get_mate_catch_ball_lv(Hits) when Hits >= 1 ->
		1;
get_mate_catch_ball_lv(_Hits) ->
    0.

get_xy_by_id(1) ->
    #base_mate_photo_pos{id = 1,scene_id = 1003,my_xy = {3302,5652},others_xy = [{1,{3173,5441}},{2,{3334,5433}},{3,{3081,5525}},{4,{3139,5307}}]};

get_xy_by_id(2) ->
    #base_mate_photo_pos{id = 2,scene_id = 1002,my_xy = {5793,11996},others_xy = [{1,{5885,12101}},{2,{5697,11912}},{3,{5793,11908}},{4,{5891,11996}}]};

get_xy_by_id(_Id) ->
    [].

get_all_pos_id() ->
    [1,2].


get_photo_award(1) ->
    {[{0,102501,10}],[{0,102501,1}]};


get_photo_award(2) ->
    {[],[{0,102501,1}]};


get_photo_award(3) ->
    {[],[{0,102501,1}]};


get_photo_award(4) ->
    {[],[{0,102501,1}]};

get_photo_award(_Times) ->
    [].

get_daily_task(1) ->
    #base_mate_daily_task{task_id = 1,type = 1,count = 1,object = [1,2,3],reward = [{0,102501,5},{19,100011,15}]};

get_daily_task(2) ->
    #base_mate_daily_task{task_id = 2,type = 2,count = 1,object = [1,2,3],reward = [{0,102501,5},{19,100011,15}]};

get_daily_task(3) ->
    #base_mate_daily_task{task_id = 3,type = 3,count = 1,object = [1],reward = [{0,102501,5},{19,100011,15}]};

get_daily_task(4) ->
    #base_mate_daily_task{task_id = 4,type = 4,count = 1,object = [1],reward = [{0,102501,5},{19,100011,15}]};

get_daily_task(5) ->
    #base_mate_daily_task{task_id = 5,type = 5,count = 1,object = [1,2],reward = [{0,102501,5},{19,100011,15}]};

get_daily_task(_Taskid) ->
    [].

get_all_task_id() ->
    [1,2,3,4,5].

