%%%---------------------------------------
%%% module      : data_printer_draw
%%% description : 合成机配置
%%%
%%%---------------------------------------
-module(data_printer_draw).
-compile(export_all).
-include("printer_draw.hrl").



get_common_goods() ->
    [{1,105501},{1,105502},{1,105503},{1,105504},{1,105505},{2,105506},{2,105507},{2,105508},{2,105509},{2,105510}].

get_printer_draw(1) ->
    #base_printer_draw_list{id = 1,exchange = [105501,105502,105504],item_suit = 1,pool = 1};

get_printer_draw(2) ->
    #base_printer_draw_list{id = 2,exchange = [105501,105502,105503],item_suit = 1,pool = 2};

get_printer_draw(3) ->
    #base_printer_draw_list{id = 3,exchange = [105501,105502,105505],item_suit = 1,pool = 3};

get_printer_draw(4) ->
    #base_printer_draw_list{id = 4,exchange = [105502,105503,105505],item_suit = 1,pool = 4};

get_printer_draw(5) ->
    #base_printer_draw_list{id = 5,exchange = [105502,105504,105505],item_suit = 1,pool = 5};

get_printer_draw(6) ->
    #base_printer_draw_list{id = 6,exchange = [105503,105503,105502],item_suit = 1,pool = 6};

get_printer_draw(7) ->
    #base_printer_draw_list{id = 7,exchange = [105503,105504,105505],item_suit = 1,pool = 7};

get_printer_draw(8) ->
    #base_printer_draw_list{id = 8,exchange = [105503,105505,105505],item_suit = 1,pool = 8};

get_printer_draw(_Id) ->
    [].

get_all_printers_1() ->
    [1,2,3,4,5,6,7,8].

get_all_printers_2() ->
    [{1,[105501,105502,105504],1},{2,[105501,105502,105503],2},{3,[105501,105502,105505],3},{4,[105502,105503,105505],4},{5,[105502,105504,105505],5},{6,[105503,105503,105502],6},{7,[105503,105504,105505],7},{8,[105503,105505,105505],8}].


get_printer_cost(1) ->
    [{[105501,105502,105504],1,1}];


get_printer_cost(2) ->
    [{[105501,105502,105503],1,2}];


get_printer_cost(3) ->
    [{[105501,105502,105505],1,3}];


get_printer_cost(4) ->
    [{[105502,105503,105505],1,4}];


get_printer_cost(5) ->
    [{[105502,105504,105505],1,5}];


get_printer_cost(6) ->
    [{[105503,105503,105502],1,6}];


get_printer_cost(7) ->
    [{[105503,105504,105505],1,7}];


get_printer_cost(8) ->
    [{[105503,105505,105505],1,8}];

get_printer_cost(_Id) ->
    [].

get_pool_cfg(1) ->
    #base_printer_draw_pool{id = 1,pool = 1,pool_type = 1,opday = 1,goods = [{100,401003,30}],weight = 100};

get_pool_cfg(2) ->
    #base_printer_draw_pool{id = 2,pool = 1,pool_type = 1,opday = 1,goods = [{100,440061,5}],weight = 1000};

get_pool_cfg(3) ->
    #base_printer_draw_pool{id = 3,pool = 1,pool_type = 1,opday = 1,goods = [{100,416141,1}],weight = 300};

get_pool_cfg(4) ->
    #base_printer_draw_pool{id = 4,pool = 1,pool_type = 1,opday = 1,goods = [{100,412061,1}],weight = 600};

get_pool_cfg(5) ->
    #base_printer_draw_pool{id = 5,pool = 1,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 2600};

get_pool_cfg(6) ->
    #base_printer_draw_pool{id = 6,pool = 1,pool_type = 1,opday = 1,goods = [{100,450051,5}],weight = 2000};

get_pool_cfg(7) ->
    #base_printer_draw_pool{id = 7,pool = 1,pool_type = 1,opday = 1,goods = [{100,450023,5}],weight = 3400};

get_pool_cfg(8) ->
    #base_printer_draw_pool{id = 8,pool = 2,pool_type = 1,opday = 1,goods = [{100,440061,5}],weight = 800};

get_pool_cfg(9) ->
    #base_printer_draw_pool{id = 9,pool = 2,pool_type = 1,opday = 1,goods = [{100,416141,1}],weight = 400};

get_pool_cfg(10) ->
    #base_printer_draw_pool{id = 10,pool = 2,pool_type = 1,opday = 1,goods = [{100,412061,1}],weight = 800};

get_pool_cfg(11) ->
    #base_printer_draw_pool{id = 11,pool = 2,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 1500};

get_pool_cfg(12) ->
    #base_printer_draw_pool{id = 12,pool = 2,pool_type = 1,opday = 1,goods = [{100,450051,5}],weight = 2000};

get_pool_cfg(13) ->
    #base_printer_draw_pool{id = 13,pool = 2,pool_type = 1,opday = 1,goods = [{100,450077,5}],weight = 3500};

get_pool_cfg(14) ->
    #base_printer_draw_pool{id = 14,pool = 2,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1000};

get_pool_cfg(15) ->
    #base_printer_draw_pool{id = 15,pool = 3,pool_type = 1,opday = 1,goods = [{100,416141,1}],weight = 400};

get_pool_cfg(16) ->
    #base_printer_draw_pool{id = 16,pool = 3,pool_type = 1,opday = 1,goods = [{100,412061,1}],weight = 600};

get_pool_cfg(17) ->
    #base_printer_draw_pool{id = 17,pool = 3,pool_type = 1,opday = 1,goods = [{100,450009,1}],weight = 800};

get_pool_cfg(18) ->
    #base_printer_draw_pool{id = 18,pool = 3,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 1500};

get_pool_cfg(19) ->
    #base_printer_draw_pool{id = 19,pool = 3,pool_type = 1,opday = 1,goods = [{100,450051,5}],weight = 2000};

get_pool_cfg(20) ->
    #base_printer_draw_pool{id = 20,pool = 3,pool_type = 1,opday = 1,goods = [{100,450077,5}],weight = 3500};

get_pool_cfg(21) ->
    #base_printer_draw_pool{id = 21,pool = 3,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1200};

get_pool_cfg(22) ->
    #base_printer_draw_pool{id = 22,pool = 4,pool_type = 1,opday = 1,goods = [{100,412061,1}],weight = 500};

get_pool_cfg(23) ->
    #base_printer_draw_pool{id = 23,pool = 4,pool_type = 1,opday = 1,goods = [{100,450009,1}],weight = 800};

get_pool_cfg(24) ->
    #base_printer_draw_pool{id = 24,pool = 4,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 1500};

get_pool_cfg(25) ->
    #base_printer_draw_pool{id = 25,pool = 4,pool_type = 1,opday = 1,goods = [{100,450051,5}],weight = 2000};

get_pool_cfg(26) ->
    #base_printer_draw_pool{id = 26,pool = 4,pool_type = 1,opday = 1,goods = [{100,450077,5}],weight = 3000};

get_pool_cfg(27) ->
    #base_printer_draw_pool{id = 27,pool = 4,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1200};

get_pool_cfg(28) ->
    #base_printer_draw_pool{id = 28,pool = 4,pool_type = 1,opday = 1,goods = [{100,102607,5}],weight = 1000};

get_pool_cfg(29) ->
    #base_printer_draw_pool{id = 29,pool = 5,pool_type = 1,opday = 1,goods = [{100,412061,1}],weight = 500};

get_pool_cfg(30) ->
    #base_printer_draw_pool{id = 30,pool = 5,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 1500};

get_pool_cfg(31) ->
    #base_printer_draw_pool{id = 31,pool = 5,pool_type = 1,opday = 1,goods = [{100,450051,5}],weight = 2500};

get_pool_cfg(32) ->
    #base_printer_draw_pool{id = 32,pool = 5,pool_type = 1,opday = 1,goods = [{100,450077,5}],weight = 2500};

get_pool_cfg(33) ->
    #base_printer_draw_pool{id = 33,pool = 5,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1000};

get_pool_cfg(34) ->
    #base_printer_draw_pool{id = 34,pool = 5,pool_type = 1,opday = 1,goods = [{100,102607,5}],weight = 1000};

get_pool_cfg(35) ->
    #base_printer_draw_pool{id = 35,pool = 5,pool_type = 1,opday = 1,goods = [{100,102603,10}],weight = 1000};

get_pool_cfg(36) ->
    #base_printer_draw_pool{id = 36,pool = 6,pool_type = 1,opday = 1,goods = [{100,102306,1}],weight = 500};

get_pool_cfg(37) ->
    #base_printer_draw_pool{id = 37,pool = 6,pool_type = 1,opday = 1,goods = [{100,450051,5}],weight = 1000};

get_pool_cfg(38) ->
    #base_printer_draw_pool{id = 38,pool = 6,pool_type = 1,opday = 1,goods = [{100,450077,10}],weight = 2500};

get_pool_cfg(39) ->
    #base_printer_draw_pool{id = 39,pool = 6,pool_type = 1,opday = 1,goods = [{100,450008,1}],weight = 1000};

get_pool_cfg(40) ->
    #base_printer_draw_pool{id = 40,pool = 6,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1000};

get_pool_cfg(41) ->
    #base_printer_draw_pool{id = 41,pool = 6,pool_type = 1,opday = 1,goods = [{100,102607,10}],weight = 1500};

get_pool_cfg(42) ->
    #base_printer_draw_pool{id = 42,pool = 6,pool_type = 1,opday = 1,goods = [{100,102603,10}],weight = 2500};

get_pool_cfg(43) ->
    #base_printer_draw_pool{id = 43,pool = 7,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 1000};

get_pool_cfg(44) ->
    #base_printer_draw_pool{id = 44,pool = 7,pool_type = 1,opday = 1,goods = [{100,450051,2}],weight = 1000};

get_pool_cfg(45) ->
    #base_printer_draw_pool{id = 45,pool = 7,pool_type = 1,opday = 1,goods = [{100,450077,5}],weight = 2000};

get_pool_cfg(46) ->
    #base_printer_draw_pool{id = 46,pool = 7,pool_type = 1,opday = 1,goods = [{100,450008,1}],weight = 1000};

get_pool_cfg(47) ->
    #base_printer_draw_pool{id = 47,pool = 7,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1000};

get_pool_cfg(48) ->
    #base_printer_draw_pool{id = 48,pool = 7,pool_type = 1,opday = 1,goods = [{100,102607,5}],weight = 1500};

get_pool_cfg(49) ->
    #base_printer_draw_pool{id = 49,pool = 7,pool_type = 1,opday = 1,goods = [{100,102603,5}],weight = 2500};

get_pool_cfg(50) ->
    #base_printer_draw_pool{id = 50,pool = 8,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 1000};

get_pool_cfg(51) ->
    #base_printer_draw_pool{id = 51,pool = 8,pool_type = 1,opday = 1,goods = [{100,450051,2}],weight = 1500};

get_pool_cfg(52) ->
    #base_printer_draw_pool{id = 52,pool = 8,pool_type = 1,opday = 1,goods = [{100,450077,3}],weight = 3000};

get_pool_cfg(53) ->
    #base_printer_draw_pool{id = 53,pool = 8,pool_type = 1,opday = 1,goods = [{100,450008,1}],weight = 1000};

get_pool_cfg(54) ->
    #base_printer_draw_pool{id = 54,pool = 8,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1000};

get_pool_cfg(55) ->
    #base_printer_draw_pool{id = 55,pool = 8,pool_type = 1,opday = 1,goods = [{100,102607,3}],weight = 1000};

get_pool_cfg(56) ->
    #base_printer_draw_pool{id = 56,pool = 8,pool_type = 1,opday = 1,goods = [{100,102603,3}],weight = 1500};

get_pool_cfg(57) ->
    #base_printer_draw_pool{id = 57,pool = 0,pool_type = 1,opday = 1,goods = [{100,102305,1}],weight = 1000};

get_pool_cfg(58) ->
    #base_printer_draw_pool{id = 58,pool = 0,pool_type = 1,opday = 1,goods = [{100,450051,1}],weight = 1000};

get_pool_cfg(59) ->
    #base_printer_draw_pool{id = 59,pool = 0,pool_type = 1,opday = 1,goods = [{100,450077,2}],weight = 2000};

get_pool_cfg(60) ->
    #base_printer_draw_pool{id = 60,pool = 0,pool_type = 1,opday = 1,goods = [{100,450008,1}],weight = 1000};

get_pool_cfg(61) ->
    #base_printer_draw_pool{id = 61,pool = 0,pool_type = 1,opday = 1,goods = [{100,450078,1}],weight = 1000};

get_pool_cfg(62) ->
    #base_printer_draw_pool{id = 62,pool = 0,pool_type = 1,opday = 1,goods = [{100,102607,2}],weight = 1500};

get_pool_cfg(63) ->
    #base_printer_draw_pool{id = 63,pool = 0,pool_type = 1,opday = 1,goods = [{100,102603,2}],weight = 2500};

get_pool_cfg(_Id) ->
    [].

get_all_pools() ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63].

