%%%---------------------------------------
%%% module      : data_rush_rank
%%% description : 开服冲榜配置
%%%
%%%---------------------------------------
-module(data_rush_rank).
-compile(export_all).
-include("rush_rank.hrl").



get_rush_rank_cfg(1) ->
    #base_rush_rank{id = 1,name = "座驾排行",start_day = 1,clear_day = 2,max_len = 30,limit = [],figure_id = [{show,3,1,433000}]};

get_rush_rank_cfg(2) ->
    #base_rush_rank{id = 2,name = "炫翼排行",start_day = 2,clear_day = 3,max_len = 30,limit = [],figure_id = [{show,3,1,433001}]};

get_rush_rank_cfg(3) ->
    #base_rush_rank{id = 3,name = "宝具排行",start_day = 4,clear_day = 5,max_len = 30,limit = [],figure_id = [{show,3,1,433003}]};

get_rush_rank_cfg(4) ->
    #base_rush_rank{id = 4,name = "武器排行",start_day = 3,clear_day = 4,max_len = 30,limit = [],figure_id = [{show,3,1,433002}]};

get_rush_rank_cfg(9) ->
    #base_rush_rank{id = 9,name = "战力排行",start_day = 7,clear_day = 9,max_len = 30,limit = [],figure_id = [{show,3,1,433030}]};

get_rush_rank_cfg(31) ->
    #base_rush_rank{id = 31,name = "战魂排行",start_day = 5,clear_day = 6,max_len = 30,limit = [],figure_id = [{show,3,1,433099}]};

get_rush_rank_cfg(32) ->
    #base_rush_rank{id = 32,name = "红装排行",start_day = 6,clear_day = 7,max_len = 30,limit = [],figure_id = [{show,3,1,433098}]};

get_rush_rank_cfg(_Id) ->
    [].

get_id_list() ->
    [1,2,3,4,9,31,32].

get_rank_reward_cfg(1,1) ->
    #base_rush_rank_reward{id = 1,reward_id = 1,rank_min = 1,rank_max = 1,rank_limit = [{combat,100000}],reward = [{100,433000,1},{100,231041,1},{100,230151,1},{100,230001,50},{100,101008,300}],about = "座驾排名第<color=#ffe486>1</color>名的玩家可领取@10万战力上榜（推荐 <color=#2cf86f>座驾6阶</color>）"};

get_rank_reward_cfg(1,2) ->
    #base_rush_rank_reward{id = 1,reward_id = 2,rank_min = 2,rank_max = 3,rank_limit = [{combat,80000}],reward = [{100,231041,1},{100,230101,2},{100,230001,45},{100,101008,300}],about = "座驾排名第<color=#ffe486>2-3</color>名的玩家可领取@8万战力上榜（推荐 <color=#2cf86f>座驾5阶</color>）"};

get_rank_reward_cfg(1,3) ->
    #base_rush_rank_reward{id = 1,reward_id = 3,rank_min = 4,rank_max = 10,rank_limit = [{combat,50000}],reward = [{100,231031,1},{100,230101,1},{100,230001,30},{100,101008,150}],about = "座驾排名第<color=#ffe486>4-10</color>名的玩家可领取@5万战力上榜（推荐 <color=#ffe486>座驾4阶</color>）"};

get_rank_reward_cfg(1,4) ->
    #base_rush_rank_reward{id = 1,reward_id = 4,rank_min = 11,rank_max = 30,rank_limit = [{combat,30000}],reward = [{100,231021,1},{100,230001,20},{100,101008,50}],about = "座驾排名第<color=#ffe486>11-30</color>名的玩家可领取@3万战力上榜（推荐 <color=#ffe486>座驾3阶</color>）"};

get_rank_reward_cfg(2,1) ->
    #base_rush_rank_reward{id = 2,reward_id = 1,rank_min = 1,rank_max = 1,rank_limit = [{combat,80000}],reward = [{100,433001,1},{100,231042,1},{100,230152,1},{100,230002,50},{100,101008,300}],about = "炫翼排名第<color=#ffe486>1</color>名的玩家可领取@8万战力上榜（推荐 <color=#2cf86f>炫翼6阶</color>）"};

get_rank_reward_cfg(2,2) ->
    #base_rush_rank_reward{id = 2,reward_id = 2,rank_min = 2,rank_max = 3,rank_limit = [{combat,60000}],reward = [{100,231042,1},{100,230102,2},{100,230002,45},{100,101008,300}],about = "炫翼排名第<color=#ffe486>2-3</color>名的玩家可领取@6万战力上榜（推荐 <color=#2cf86f>炫翼5阶</color>）"};

get_rank_reward_cfg(2,3) ->
    #base_rush_rank_reward{id = 2,reward_id = 3,rank_min = 4,rank_max = 10,rank_limit = [{combat,40000}],reward = [{100,231032,1},{100,230102,1},{100,230002,30},{100,101008,150}],about = "炫翼排名第<color=#ffe486>4-10</color>名的玩家可领取@4万战力上榜（推荐 <color=#ffe486>炫翼4阶</color>）"};

get_rank_reward_cfg(2,4) ->
    #base_rush_rank_reward{id = 2,reward_id = 4,rank_min = 11,rank_max = 30,rank_limit = [{combat,30000}],reward = [{100,231022,1},{100,230002,20},{100,101008,50}],about = "炫翼排名第<color=#ffe486>11-30</color>名的玩家可领取@3万战力上榜（推荐 <color=#ffe486>炫翼3阶</color>）"};

get_rank_reward_cfg(3,1) ->
    #base_rush_rank_reward{id = 3,reward_id = 1,rank_min = 1,rank_max = 1,rank_limit = [{combat,80000}],reward = [{100,433003,1},{100,231044,1},{100,230153,1},{100,230003,50},{100,101008,300}],about = "宝具排名第<color=#ffe486>1</color>名的玩家可领取@8万战力上榜（推荐 <color=#2cf86f>宝具6阶</color>）"};

get_rank_reward_cfg(3,2) ->
    #base_rush_rank_reward{id = 3,reward_id = 2,rank_min = 2,rank_max = 3,rank_limit = [{combat,60000}],reward = [{100,231044,1},{100,230103,2},{100,230003,45},{100,101008,300}],about = "宝具排名第<color=#ffe486>2-3</color>名的玩家可领取@6万战力上榜（推荐 <color=#2cf86f>宝具5阶</color>）"};

get_rank_reward_cfg(3,3) ->
    #base_rush_rank_reward{id = 3,reward_id = 3,rank_min = 4,rank_max = 10,rank_limit = [{combat,40000}],reward = [{100,231034,1},{100,230103,1},{100,230003,30},{100,101008,150}],about = "宝具排名第<color=#ffe486>4-10</color>名的玩家可领取@4万战力上榜（推荐 <color=#ffe486>宝具4阶</color>）"};

get_rank_reward_cfg(3,4) ->
    #base_rush_rank_reward{id = 3,reward_id = 4,rank_min = 11,rank_max = 30,rank_limit = [{combat,30000}],reward = [{100,231024,1},{100,230003,20},{100,101008,50}],about = "宝具排名第<color=#ffe486>11-30</color>名的玩家可领取@3万战力上榜（推荐 <color=#ffe486>宝具3阶</color>）"};

get_rank_reward_cfg(4,1) ->
    #base_rush_rank_reward{id = 4,reward_id = 1,rank_min = 1,rank_max = 1,rank_limit = [{combat,80000}],reward = [{100,433002,1},{100,231043,1},{100,230154,1},{100,230004,50},{100,101008,300}],about = "武器排名第<color=#ffe486>1</color>名的玩家可领取@8万战力上榜（推荐 <color=#2cf86f>武器6阶</color>）"};

get_rank_reward_cfg(4,2) ->
    #base_rush_rank_reward{id = 4,reward_id = 2,rank_min = 2,rank_max = 3,rank_limit = [{combat,60000}],reward = [{100,231043,1},{100,230104,2},{100,230004,45},{100,101008,300}],about = "武器排名第<color=#ffe486>2-3</color>名的玩家可领取@6万战力上榜（推荐 <color=#2cf86f>武器5阶</color>）"};

get_rank_reward_cfg(4,3) ->
    #base_rush_rank_reward{id = 4,reward_id = 3,rank_min = 4,rank_max = 10,rank_limit = [{combat,40000}],reward = [{100,231033,1},{100,230104,1},{100,230004,30},{100,101008,150}],about = "武器排名第<color=#ffe486>4-10</color>名的玩家可领取@4万战力上榜（推荐 <color=#ffe486>武器4阶</color>）"};

get_rank_reward_cfg(4,4) ->
    #base_rush_rank_reward{id = 4,reward_id = 4,rank_min = 11,rank_max = 30,rank_limit = [{combat,30000}],reward = [{100,231023,1},{100,230004,20},{100,101008,50}],about = "武器排名第<color=#ffe486>11-30</color>名的玩家可领取@3万战力上榜（推荐 <color=#ffe486>武器3阶</color>）"};

get_rank_reward_cfg(9,1) ->
    #base_rush_rank_reward{id = 9,reward_id = 1,rank_min = 1,rank_max = 1,rank_limit = [{combat,1}],reward = [{100,433030,1},{100,450062,1},{100,100021,200},{100,252051,1},{100,109035,1}],about = "战力排名第<color=#ffe486>1</color>名的玩家可领取@提升<color=#ffe486>总战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(9,2) ->
    #base_rush_rank_reward{id = 9,reward_id = 2,rank_min = 2,rank_max = 3,rank_limit = [{combat,1}],reward = [{100,450062,1},{100,100021,150},{100,252041,1},{100,109035,1}],about = "战力排名第<color=#ffe486>2-3</color>名的玩家可领取@提升<color=#ffe486>总战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(9,3) ->
    #base_rush_rank_reward{id = 9,reward_id = 3,rank_min = 4,rank_max = 10,rank_limit = [{combat,1}],reward = [{100,252041,1},{100,100021,100},{100,109034,1},{100,109034,1}],about = "战力排名第<color=#ffe486>4-10</color>名的玩家可领取@提升<color=#ffe486>总战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(9,4) ->
    #base_rush_rank_reward{id = 9,reward_id = 4,rank_min = 11,rank_max = 30,rank_limit = [{combat,1}],reward = [{100,252031,1},{100,100021,50},{100,109034,1}],about = "战力排名第<color=#ffe486>11-30</color>名的玩家可领取@提升<color=#ffe486>总战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(31,1) ->
    #base_rush_rank_reward{id = 31,reward_id = 1,rank_min = 1,rank_max = 1,rank_limit = [{combat,1}],reward = [{100,433099,1},{100,231045,1},{100,100021,200},{100,450061,3},{100,330903,1}],about = "战魂排名第<color=#ffe486>1</color>名的玩家可领取@提升<color=#ffe486>战魂战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(31,2) ->
    #base_rush_rank_reward{id = 31,reward_id = 2,rank_min = 2,rank_max = 3,rank_limit = [{combat,1}],reward = [{100,231045,1},{100,100021,150},{100,450061,2},{100,330902,3}],about = "战魂排名第<color=#ffe486>2-3</color>名的玩家可领取@提升<color=#ffe486>战魂战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(31,3) ->
    #base_rush_rank_reward{id = 31,reward_id = 3,rank_min = 4,rank_max = 10,rank_limit = [{combat,1}],reward = [{100,231035,1},{100,100021,100},{100,450061,1},{100,330902,2}],about = "战魂排名第<color=#ffe486>4-10</color>名的玩家可领取@提升<color=#ffe486>战魂战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(31,4) ->
    #base_rush_rank_reward{id = 31,reward_id = 4,rank_min = 11,rank_max = 30,rank_limit = [{combat,1}],reward = [{100,231025,1},{100,100021,50},{100,330902,1}],about = "战魂排名第<color=#ffe486>11-30</color>名的玩家可领取@提升<color=#ffe486>战魂战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(32,1) ->
    #base_rush_rank_reward{id = 32,reward_id = 1,rank_min = 1,rank_max = 1,rank_limit = [{combat,1}],reward = [{100,433098,1},{100,231046,1},{100,100021,200},{100,450052,1},{100,450051,15}],about = "红装排名第<color=#ffe486>1</color>名的玩家可领取@提升<color=#ffe486>红装战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(32,2) ->
    #base_rush_rank_reward{id = 32,reward_id = 2,rank_min = 2,rank_max = 3,rank_limit = [{combat,1}],reward = [{100,231046,1},{100,100021,150},{100,450050,10},{100,450051,10}],about = "红装排名第<color=#ffe486>2-3</color>名的玩家可领取@提升<color=#ffe486>红装战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(32,3) ->
    #base_rush_rank_reward{id = 32,reward_id = 3,rank_min = 4,rank_max = 10,rank_limit = [{combat,1}],reward = [{100,231036,1},{100,100021,100},{100,450050,5},{100,450051,5}],about = "红装排名第<color=#ffe486>4-10</color>名的玩家可领取@提升<color=#ffe486>红装战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(32,4) ->
    #base_rush_rank_reward{id = 32,reward_id = 4,rank_min = 11,rank_max = 30,rank_limit = [{combat,1}],reward = [{100,231026,1},{100,100021,50},{100,450050,5}],about = "红装排名第<color=#ffe486>11-30</color>名的玩家可领取@提升<color=#ffe486>红装战力</color> ，冲榜领豪礼"};

get_rank_reward_cfg(_Id,_Rewardid) ->
    [].


get_rank_reward_ids(1) ->
    [1,2,3,4];


get_rank_reward_ids(2) ->
    [1,2,3,4];


get_rank_reward_ids(3) ->
    [1,2,3,4];


get_rank_reward_ids(4) ->
    [1,2,3,4];


get_rank_reward_ids(9) ->
    [1,2,3,4];


get_rank_reward_ids(31) ->
    [1,2,3,4];


get_rank_reward_ids(32) ->
    [1,2,3,4];

get_rank_reward_ids(_Id) ->
    [].

get_reward_id_by_rank(1,_Rank) when _Rank >= 1, _Rank =< 1 ->
		1;
get_reward_id_by_rank(1,_Rank) when _Rank >= 2, _Rank =< 3 ->
		2;
get_reward_id_by_rank(1,_Rank) when _Rank >= 4, _Rank =< 10 ->
		3;
get_reward_id_by_rank(1,_Rank) when _Rank >= 11, _Rank =< 30 ->
		4;
get_reward_id_by_rank(2,_Rank) when _Rank >= 1, _Rank =< 1 ->
		1;
get_reward_id_by_rank(2,_Rank) when _Rank >= 2, _Rank =< 3 ->
		2;
get_reward_id_by_rank(2,_Rank) when _Rank >= 4, _Rank =< 10 ->
		3;
get_reward_id_by_rank(2,_Rank) when _Rank >= 11, _Rank =< 30 ->
		4;
get_reward_id_by_rank(3,_Rank) when _Rank >= 1, _Rank =< 1 ->
		1;
get_reward_id_by_rank(3,_Rank) when _Rank >= 2, _Rank =< 3 ->
		2;
get_reward_id_by_rank(3,_Rank) when _Rank >= 4, _Rank =< 10 ->
		3;
get_reward_id_by_rank(3,_Rank) when _Rank >= 11, _Rank =< 30 ->
		4;
get_reward_id_by_rank(4,_Rank) when _Rank >= 1, _Rank =< 1 ->
		1;
get_reward_id_by_rank(4,_Rank) when _Rank >= 2, _Rank =< 3 ->
		2;
get_reward_id_by_rank(4,_Rank) when _Rank >= 4, _Rank =< 10 ->
		3;
get_reward_id_by_rank(4,_Rank) when _Rank >= 11, _Rank =< 30 ->
		4;
get_reward_id_by_rank(9,_Rank) when _Rank >= 1, _Rank =< 1 ->
		1;
get_reward_id_by_rank(9,_Rank) when _Rank >= 2, _Rank =< 3 ->
		2;
get_reward_id_by_rank(9,_Rank) when _Rank >= 4, _Rank =< 10 ->
		3;
get_reward_id_by_rank(9,_Rank) when _Rank >= 11, _Rank =< 30 ->
		4;
get_reward_id_by_rank(31,_Rank) when _Rank >= 1, _Rank =< 1 ->
		1;
get_reward_id_by_rank(31,_Rank) when _Rank >= 2, _Rank =< 3 ->
		2;
get_reward_id_by_rank(31,_Rank) when _Rank >= 4, _Rank =< 10 ->
		3;
get_reward_id_by_rank(31,_Rank) when _Rank >= 11, _Rank =< 30 ->
		4;
get_reward_id_by_rank(32,_Rank) when _Rank >= 1, _Rank =< 1 ->
		1;
get_reward_id_by_rank(32,_Rank) when _Rank >= 2, _Rank =< 3 ->
		2;
get_reward_id_by_rank(32,_Rank) when _Rank >= 4, _Rank =< 10 ->
		3;
get_reward_id_by_rank(32,_Rank) when _Rank >= 11, _Rank =< 30 ->
		4;
get_reward_id_by_rank(_Id,_Rank) ->
    0.

get_goal_reward_cfg(1,1) ->
    #base_rush_goal_reward{id = 1,reward_id = 1,goal_value = [{combat,30000}],reward = [{100,230001,3},{100,230001,3},{100,230001,3}],about = "座驾战力达到<color=#ffe486>30000</color>可领取"};

get_goal_reward_cfg(1,2) ->
    #base_rush_goal_reward{id = 1,reward_id = 2,goal_value = [{combat,20000}],reward = [{100,230001,3},{100,230001,3}],about = "座驾战力达到<color=#ffe486>20000</color>可领取"};

get_goal_reward_cfg(1,3) ->
    #base_rush_goal_reward{id = 1,reward_id = 3,goal_value = [{combat,10000}],reward = [{100,230001,3}],about = "座驾战力达到<color=#ffe486>10000</color>可领取"};

get_goal_reward_cfg(2,1) ->
    #base_rush_goal_reward{id = 2,reward_id = 1,goal_value = [{combat,25000}],reward = [{100,230002,3},{100,230002,3},{100,230002,3}],about = "炫翼战力达到<color=#ffe486>25000</color>可领取"};

get_goal_reward_cfg(2,2) ->
    #base_rush_goal_reward{id = 2,reward_id = 2,goal_value = [{combat,15000}],reward = [{100,230002,3},{100,230002,3}],about = "炫翼战力达到<color=#ffe486>15000</color>可领取"};

get_goal_reward_cfg(2,3) ->
    #base_rush_goal_reward{id = 2,reward_id = 3,goal_value = [{combat,10000}],reward = [{100,230002,3}],about = "炫翼战力达到<color=#ffe486>10000</color>可领取"};

get_goal_reward_cfg(3,1) ->
    #base_rush_goal_reward{id = 3,reward_id = 1,goal_value = [{combat,25000}],reward = [{100,230003,3},{100,230003,3},{100,230003,3}],about = "宝具战力达到<color=#ffe486>25000</color>可领取"};

get_goal_reward_cfg(3,2) ->
    #base_rush_goal_reward{id = 3,reward_id = 2,goal_value = [{combat,15000}],reward = [{100,230003,3},{100,230003,3}],about = "宝具战力达到<color=#ffe486>15000</color>可领取"};

get_goal_reward_cfg(3,3) ->
    #base_rush_goal_reward{id = 3,reward_id = 3,goal_value = [{combat,10000}],reward = [{100,230003,3}],about = "宝具战力达到<color=#ffe486>10000</color>可领取"};

get_goal_reward_cfg(4,1) ->
    #base_rush_goal_reward{id = 4,reward_id = 1,goal_value = [{combat,25000}],reward = [{100,230004,3},{100,230004,3},{100,230004,3}],about = "武器战力达到<color=#ffe486>25000</color>可领取"};

get_goal_reward_cfg(4,2) ->
    #base_rush_goal_reward{id = 4,reward_id = 2,goal_value = [{combat,15000}],reward = [{100,230004,3},{100,230004,3}],about = "武器战力达到<color=#ffe486>15000</color>可领取"};

get_goal_reward_cfg(4,3) ->
    #base_rush_goal_reward{id = 4,reward_id = 3,goal_value = [{combat,10000}],reward = [{100,230004,3}],about = "武器战力达到<color=#ffe486>10000</color>可领取"};

get_goal_reward_cfg(9,1) ->
    #base_rush_goal_reward{id = 9,reward_id = 1,goal_value = [{combat,1000000}],reward = [{100,450023,3},{100,450023,3},{100,450023,3}],about = "战力达到<color=#ffe486>1000000</color>可领取"};

get_goal_reward_cfg(9,2) ->
    #base_rush_goal_reward{id = 9,reward_id = 2,goal_value = [{combat,600000}],reward = [{100,450023,3},{100,450023,3}],about = "战力达到<color=#ffe486>600000</color>可领取"};

get_goal_reward_cfg(9,3) ->
    #base_rush_goal_reward{id = 9,reward_id = 3,goal_value = [{combat,300000}],reward = [{100,450023,3}],about = "战力达到<color=#ffe486>300000</color>可领取"};

get_goal_reward_cfg(31,1) ->
    #base_rush_goal_reward{id = 31,reward_id = 1,goal_value = [{combat,80000}],reward = [{100,330902,3},{100,330902,3},{100,330902,3}],about = "战魂战力达到<color=#ffe486>80000</color>可领取"};

get_goal_reward_cfg(31,2) ->
    #base_rush_goal_reward{id = 31,reward_id = 2,goal_value = [{combat,50000}],reward = [{100,330902,3},{100,330902,3}],about = "战魂战力达到<color=#ffe486>50000</color>可领取"};

get_goal_reward_cfg(31,3) ->
    #base_rush_goal_reward{id = 31,reward_id = 3,goal_value = [{combat,20000}],reward = [{100,330902,3}],about = "战魂战力达到<color=#ffe486>20000</color>可领取"};

get_goal_reward_cfg(32,1) ->
    #base_rush_goal_reward{id = 32,reward_id = 1,goal_value = [{combat,50000}],reward = [{100,450051,2},{100,450051,1},{100,450051,1}],about = "红装战力达到<color=#ffe486>50000</color>可领取"};

get_goal_reward_cfg(32,2) ->
    #base_rush_goal_reward{id = 32,reward_id = 2,goal_value = [{combat,30000}],reward = [{100,450051,2},{100,450051,1}],about = "红装战力达到<color=#ffe486>30000</color>可领取"};

get_goal_reward_cfg(32,3) ->
    #base_rush_goal_reward{id = 32,reward_id = 3,goal_value = [{combat,20000}],reward = [{100,450051,1}],about = "红装战力达到<color=#ffe486>20000</color>可领取"};

get_goal_reward_cfg(_Id,_Rewardid) ->
    [].


get_goal_reward_ids(1) ->
    [1,2,3];


get_goal_reward_ids(2) ->
    [1,2,3];


get_goal_reward_ids(3) ->
    [1,2,3];


get_goal_reward_ids(4) ->
    [1,2,3];


get_goal_reward_ids(9) ->
    [1,2,3];


get_goal_reward_ids(31) ->
    [1,2,3];


get_goal_reward_ids(32) ->
    [1,2,3];

get_goal_reward_ids(_Id) ->
    [].

