%%%---------------------------------------
%%% module      : data_seven_goal
%%% description : 七日目标配置
%%%
%%%---------------------------------------
-module(data_seven_goal).
-compile(export_all).
-include("seven_day_goal.hrl").



get_task_cfg(1,110,4) ->
    #base_seven_goal_task{days = 1,mod_id = 110,sub_id = 4,order_id = 4,name = "",jump_id = {110,4},reward = [{100,230101,1}],desc = "社团发言1次",condition = [{limit_times,1}],task_tag = 2};

get_task_cfg(1,146,1) ->
    #base_seven_goal_task{days = 1,mod_id = 146,sub_id = 1,order_id = 1,name = "",jump_id = {146,1},reward = [{100,230101,1}],desc = "座驾进阶到3阶",condition = [{limit_times,3}],task_tag = 4};

get_task_cfg(1,152,2) ->
    #base_seven_goal_task{days = 1,mod_id = 152,sub_id = 2,order_id = 2,name = "",jump_id = {152,2},reward = [{100,230101,1}],desc = "装备升星5次",condition = [{limit_times,5}],task_tag = 1};

get_task_cfg(1,152,8) ->
    #base_seven_goal_task{days = 1,mod_id = 152,sub_id = 8,order_id = 3,name = "",jump_id = {152,8},reward = [{100,230101,1}],desc = "穿戴7件1代紫色以上装备\n",condition = [{limit_times,7}],task_tag = 1};

get_task_cfg(2,146,2) ->
    #base_seven_goal_task{days = 2,mod_id = 146,sub_id = 2,order_id = 1,name = "110级主线",jump_id = {146,2},reward = [{100,230102,1}],desc = "炫翼进阶到3阶",condition = [{limit_times,3}],task_tag = 4};

get_task_cfg(2,152,9) ->
    #base_seven_goal_task{days = 2,mod_id = 152,sub_id = 9,order_id = 3,name = "",jump_id = {152,2},reward = [{100,230102,1}],desc = "1代装备全升到2星",condition = [{limit_times,7}],task_tag = 1};

get_task_cfg(2,155,1) ->
    #base_seven_goal_task{days = 2,mod_id = 155,sub_id = 1,order_id = 2,name = "",jump_id = {155,1},reward = [{100,230102,1}],desc = "购买2件装备",condition = [{limit_times,2}],task_tag = 1};

get_task_cfg(2,164,1) ->
    #base_seven_goal_task{days = 2,mod_id = 164,sub_id = 1,order_id = 4,name = "",jump_id = {164,1},reward = [{100,230102,1}],desc = "完成1转转职",condition = [{limit_times,1}],task_tag = 4};

get_task_cfg(3,146,4) ->
    #base_seven_goal_task{days = 3,mod_id = 146,sub_id = 4,order_id = 1,name = "",jump_id = {146,4},reward = [{100,230104,1}],desc = "武器进阶到3阶",condition = [{limit_times,3}],task_tag = 4};

get_task_cfg(3,152,10) ->
    #base_seven_goal_task{days = 3,mod_id = 152,sub_id = 10,order_id = 2,name = "",jump_id = {152,2},reward = [{100,230104,1}],desc = "2代装备升星1次",condition = [{limit_times,1}],task_tag = 1};

get_task_cfg(3,155,4) ->
    #base_seven_goal_task{days = 3,mod_id = 155,sub_id = 4,order_id = 3,name = "",jump_id = {155,4},reward = [{100,230104,1}],desc = "装备上架3次",condition = [{limit_times,3}],task_tag = 1};

get_task_cfg(3,421,2) ->
    #base_seven_goal_task{days = 3,mod_id = 421,sub_id = 2,order_id = 4,name = "140级支线",jump_id = {421,2},reward = [{100,230104,1}],desc = "制衣商城购买2次",condition = [{limit_times,2}],task_tag = 5};

get_task_cfg(4,146,3) ->
    #base_seven_goal_task{days = 4,mod_id = 146,sub_id = 3,order_id = 1,name = "",jump_id = {146,3},reward = [{100,230103,1}],desc = "宝具进阶到3阶",condition = [{limit_times,3}],task_tag = 4};

get_task_cfg(4,152,9) ->
    #base_seven_goal_task{days = 4,mod_id = 152,sub_id = 9,order_id = 3,name = "",jump_id = {152,2},reward = [{100,230103,1}],desc = "3件2代装备升到2星",condition = [{limit_times,3}],task_tag = 1};

get_task_cfg(4,155,4) ->
    #base_seven_goal_task{days = 4,mod_id = 155,sub_id = 4,order_id = 2,name = "",jump_id = {155,4},reward = [{100,230103,1}],desc = "装备上架3次",condition = [{limit_times,3}],task_tag = 1};

get_task_cfg(4,163,0) ->
    #base_seven_goal_task{days = 4,mod_id = 163,sub_id = 0,order_id = 4,name = "145级支线",jump_id = {163,1},reward = [{100,230103,1}],desc = "宠物培养到3级",condition = [{limit_times,3}],task_tag = 6};

get_task_cfg(5,143,1) ->
    #base_seven_goal_task{days = 5,mod_id = 143,sub_id = 1,order_id = 3,name = "105级主线",jump_id = {143,1},reward = [{100,330901,1}],desc = "战魂达到40000战力\n",condition = [{limit_times,40000}],task_tag = 3};

get_task_cfg(5,146,5) ->
    #base_seven_goal_task{days = 5,mod_id = 146,sub_id = 5,order_id = 1,name = "",jump_id = {146,5},reward = [{100,330901,1}],desc = "AI娘提升到40级",condition = [{limit_times,40}],task_tag = 4};

get_task_cfg(5,152,0) ->
    #base_seven_goal_task{days = 5,mod_id = 152,sub_id = 0,order_id = 2,name = "",jump_id = {152,999},reward = [{100,330901,1}],desc = "装备星级达到40",condition = [{limit_times,40}],task_tag = 1};

get_task_cfg(5,210,1) ->
    #base_seven_goal_task{days = 5,mod_id = 210,sub_id = 1,order_id = 4,name = "",jump_id = {210,1},reward = [{100,330901,1}],desc = "升级1次职业技能",condition = [{limit_times,1}],task_tag = 4};

get_task_cfg(6,146,6) ->
    #base_seven_goal_task{days = 6,mod_id = 146,sub_id = 6,order_id = 1,name = "",jump_id = {146,6},reward = [{100,450051,1}],desc = "磁炮提升到30级",condition = [{limit_times,30}],task_tag = 4};

get_task_cfg(6,152,4) ->
    #base_seven_goal_task{days = 6,mod_id = 152,sub_id = 4,order_id = 2,name = "180级支线",jump_id = {152,5},reward = [{100,450051,1}],desc = "升品得到1件红装",condition = [{limit_times,1}],task_tag = 1};

get_task_cfg(6,165,0) ->
    #base_seven_goal_task{days = 6,mod_id = 165,sub_id = 0,order_id = 3,name = "160级支线",jump_id = {110,1},reward = [{100,450051,1}],desc = "点赞5次宝宝",condition = [{limit_times,5}],task_tag = 2};

get_task_cfg(6,165,1) ->
    #base_seven_goal_task{days = 6,mod_id = 165,sub_id = 1,order_id = 4,name = "160级支线",jump_id = {165,1},reward = [{100,450051,1}],desc = "成功孵化宝宝",condition = [{limit_times,1}],task_tag = 4};

get_task_cfg(7,146,8) ->
    #base_seven_goal_task{days = 7,mod_id = 146,sub_id = 8,order_id = 1,name = "",jump_id = {146,8},reward = [{100,102305,1}],desc = "幻甲提升到30级",condition = [{limit_times,30}],task_tag = 4};

get_task_cfg(7,149,1) ->
    #base_seven_goal_task{days = 7,mod_id = 149,sub_id = 1,order_id = 4,name = "",jump_id = {149,1},reward = [{100,102305,1}],desc = "结成1位羁绊",condition = [{limit_times,1}],task_tag = 2};

get_task_cfg(7,159,1) ->
    #base_seven_goal_task{days = 7,mod_id = 159,sub_id = 1,order_id = 3,name = "",jump_id = {159,1},reward = [{100,102305,1}],desc = "达成首充",condition = [{limit_times,1}],task_tag = 4};

get_task_cfg(7,170,1) ->
    #base_seven_goal_task{days = 7,mod_id = 170,sub_id = 1,order_id = 2,name = "105级主线",jump_id = {170,1},reward = [{100,102305,1}],desc = "战魂抽奖20次",condition = [{limit_times,20}],task_tag = 3};

get_task_cfg(_Days,_Modid,_Subid) ->
    [].

get_all_task_id() ->
    [{1,110,4},{1,146,1},{1,152,2},{1,152,8},{2,146,2},{2,152,9},{2,155,1},{2,164,1},{3,146,4},{3,152,10},{3,155,4},{3,421,2},{4,146,3},{4,152,9},{4,155,4},{4,163,0},{5,143,1},{5,146,5},{5,152,0},{5,210,1},{6,146,6},{6,152,4},{6,165,0},{6,165,1},{7,146,8},{7,149,1},{7,159,1},{7,170,1}].

get_all_days() ->
    [1,2,3,4,5,6,7].

get_task_days(110,4) ->
    [1];

get_task_days(146,1) ->
    [1];

get_task_days(146,2) ->
    [2];

get_task_days(146,4) ->
    [3];

get_task_days(146,3) ->
    [4];

get_task_days(146,5) ->
    [5];

get_task_days(146,6) ->
    [6];

get_task_days(146,8) ->
    [7];

get_task_days(152,2) ->
    [1];

get_task_days(152,8) ->
    [1];

get_task_days(152,9) ->
    [2,4];

get_task_days(152,10) ->
    [3];

get_task_days(152,0) ->
    [5];

get_task_days(152,4) ->
    [6];

get_task_days(155,1) ->
    [2];

get_task_days(155,4) ->
    [3,4];

get_task_days(164,1) ->
    [2];

get_task_days(421,2) ->
    [3];

get_task_days(163,0) ->
    [4];

get_task_days(143,1) ->
    [5];

get_task_days(210,1) ->
    [5];

get_task_days(165,0) ->
    [6];

get_task_days(165,1) ->
    [6];

get_task_days(149,1) ->
    [7];

get_task_days(159,1) ->
    [7];

get_task_days(170,1) ->
    [7];

get_task_days(_Modid,_Subid) ->
    [].

get_sub_ids(1,110) ->
    [4];

get_sub_ids(1,146) ->
    [1];

get_sub_ids(1,152) ->
    [2,8];

get_sub_ids(2,146) ->
    [2];

get_sub_ids(2,152) ->
    [9];

get_sub_ids(2,155) ->
    [1];

get_sub_ids(2,164) ->
    [1];

get_sub_ids(3,146) ->
    [4];

get_sub_ids(3,152) ->
    [10];

get_sub_ids(3,155) ->
    [4];

get_sub_ids(3,421) ->
    [2];

get_sub_ids(4,146) ->
    [3];

get_sub_ids(4,152) ->
    [9];

get_sub_ids(4,155) ->
    [4];

get_sub_ids(4,163) ->
    [0];

get_sub_ids(5,143) ->
    [1];

get_sub_ids(5,146) ->
    [5];

get_sub_ids(5,152) ->
    [0];

get_sub_ids(5,210) ->
    [1];

get_sub_ids(6,146) ->
    [6];

get_sub_ids(6,152) ->
    [4];

get_sub_ids(6,165) ->
    [0,1];

get_sub_ids(7,146) ->
    [8];

get_sub_ids(7,149) ->
    [1];

get_sub_ids(7,159) ->
    [1];

get_sub_ids(7,170) ->
    [1];

get_sub_ids(_Days,_Modid) ->
    [].


get_task_for_day(1) ->
    [{110,4},{146,1},{152,2},{152,8}];


get_task_for_day(2) ->
    [{146,2},{152,9},{155,1},{164,1}];


get_task_for_day(3) ->
    [{146,4},{152,10},{155,4},{421,2}];


get_task_for_day(4) ->
    [{146,3},{152,9},{155,4},{163,0}];


get_task_for_day(5) ->
    [{143,1},{146,5},{152,0},{210,1}];


get_task_for_day(6) ->
    [{146,6},{152,4},{165,0},{165,1}];


get_task_for_day(7) ->
    [{146,8},{149,1},{159,1},{170,1}];

get_task_for_day(_Days) ->
    [].

get_score_cfg(28) ->
    #base_seven_goal_score{score = 28,reward = [{100,250103,25}]};

get_score_cfg(_Score) ->
    [].

get_skill_reward_cfg(1) ->
    #base_seven_skill_reward{days = 1,skill_reward = 800001,name = "加强攻击",desc = "攻击神技"};

get_skill_reward_cfg(2) ->
    #base_seven_skill_reward{days = 2,skill_reward = 800002,name = "幻魔狩猎",desc = "幻魔增伤"};

get_skill_reward_cfg(3) ->
    #base_seven_skill_reward{days = 3,skill_reward = 800003,name = "三倍伤害",desc = "会心一击"};

get_skill_reward_cfg(4) ->
    #base_seven_skill_reward{days = 4,skill_reward = 800004,name = "精英狩猎",desc = "刷怪必备"};

get_skill_reward_cfg(5) ->
    #base_seven_skill_reward{days = 5,skill_reward = 800005,name = "伤害减半",desc = "无限格挡"};

get_skill_reward_cfg(6) ->
    #base_seven_skill_reward{days = 6,skill_reward = 800006,name = "坚守奋战",desc = "对敌必备"};

get_skill_reward_cfg(7) ->
    #base_seven_skill_reward{days = 7,skill_reward = 800007,name = "完美无伤",desc = "保命神技"};

get_skill_reward_cfg(_Days) ->
    [].

