%%%---------------------------------------
%%% module      : data_ta_properties
%%% description : TA系统事件属性配置
%%%
%%%---------------------------------------
-module(data_ta_properties).
-compile(export_all).



%%账号登录
event_keys(account_login) ->
    [login_ip,is_simulator];

%%账号注册
event_keys(account_register) ->
    [reg_ip,is_simulator];

%%舞池派对
event_keys(activity_beach) ->
    [is_offline_hosting,ai_cost,ai_left,use_time,is_count_down];

%%拍卖行
event_keys(auction_state) ->
    [auction_type,option_type,market_sell_type,market_sell_sub_type,goods_color,goods_id,goods_only_id,equip_series,equip_career,is_player,is_public,is_auction,bid_times,is_fixed_price,is_auto,origin_price,deal_price,shelves_time,public_time];

%%红钻消耗
event_keys(bgold_consume) ->
    [cost_amount,change_after,consume_type];

%%幻魔之家击杀归属
event_keys(boss_home_belong) ->
    [boss_id,boss_lv,boss_series,team_num,home_type,floor,revive_times,damage_percent,damage_rank,use_time];

%%宝宝时装
event_keys(child_fashion) ->
    [goods_id,new_level,cost_num];

%%宝宝同心值
event_keys(child_heart) ->
    [type,task_id,cost_bgold,get_heart,current_heart];

%%宝宝技能
event_keys(child_skill) ->
    [skill_id,new_level,cost_goods,cost_num];

%%宝宝载具
event_keys(child_vehicle) ->
    [goods_id,new_stage,cost_num];

%%护送
event_keys(convoy) ->
    [color_id,result_type,old_color,refresh_times,cost_card,cost_bgold,double_type];

%%创建角色
event_keys(create_role) ->
    [create_ip,name,is_simulator];

%%星域争霸挑战
event_keys(cross_point_fight) ->
    [dun_type,dun_name,guild_id,country_id,challenge_type,get_point,current_point,left_activity];

%%星域幻魔击杀归属
event_keys(deserted_boss_belong) ->
    [boss_type,boss_id,boss_lv,boss_series,is_first_kill,revive_times,team_num,assist_num,damage_percent,damage_rank,use_time];

%%装备红装
event_keys(equip_empower) ->
    [equip_series,equip_type,new_level,cost_goods,cost_num];

%%装备获取
event_keys(equip_get) ->
    [equip_series,equip_type,equip_career,get_type,goods_id,goods_color];

%%装备进化
event_keys(equip_great) ->
    [equip_series,equip_type,goods_id,goods_color,great_ratio,is_success,star_level,is_makeup,cost_list,cost_equip_num];

%%装备强化
event_keys(equip_strengthen) ->
    [equip_series,equip_type,goods_id,goods_color,strengthen_ratio,is_success,new_level];

%%装备继承
event_keys(equip_wear) ->
    [equip_series,equip_type,goods_id,old_goods_id,goods_color_old,goods_color_new,level,star];

%%经验副本
event_keys(exp_dungeon) ->
    [old_dun_wave,new_dun_wave,power_advice,result_type,result_subtype,use_time];

%%名望券消耗
event_keys(fame_consume) ->
    [cost_amount,change_after,consume_type];

%%名望券获取
event_keys(fame_get) ->
    [get_amount,change_after,get_type,assist_type];

%%时装激活升星
event_keys(fashion_up) ->
    [pos_id,fashion_id,color_id,option_type,cost_goods,cost_num,old_star,new_star];

%%材料副本
event_keys(foster_dungeon) ->
    [dun_type,is_sweep,result_type,dun_times];

%%进阶升级
event_keys(foster_up) ->
    [type,step_level,star_level,exp,exp_add,need_exp,end_time,is_auto,cost_goods,cost_num,cost_gold,cost_bgold,current_gold,current_bgold];

%%礼包卡日志
event_keys(gift_card) ->
    [card_no,card_type,gift_type,is_success,fail_type];

%%赏金幻魔击杀归属
event_keys(gold_boss_belong) ->
    [boss_id,boss_lv,boss_series,is_first_kill,inspire_ticket,inspire_bgold,inspire_gold,revive_times,team_num,assist_num,damage_percent,damage_rank,use_time];

%%彩钻消耗
event_keys(gold_consume) ->
    [cost_amount,change_after,consume_type];

%%彩钻获取
event_keys(gold_get) ->
    [get_amount,change_after,get_type];

%%守卫信标
event_keys(guard_dungeon) ->
    [dun_type,player_num,robot_num,is_captain,power_need,power_player2,power_player3,result_subtype,dun_wave_aft,hp_top,hp_mid,hp_bot,revive_times,use_time];

%%社团活跃
event_keys(guild_activity) ->
    [guild_id,guild_name,guild_level,guild_num,task_type,live,person_live,guild_live];

%%社团晚间活动
event_keys(guild_ballroom) ->
    [is_offline_hosting,ai_cost,ai_left,is_count_down,glamour_like_times,glamour_free_items,glamour_pay_items,use_time];

%%社团boss
event_keys(guild_boss) ->
    [is_offline_hosting,ai_cost,ai_left,is_count_down,encourage_times,revive_times,damage_percent];

%%社团封印
event_keys(guild_seal) ->
    [is_count_down,collet_times,assist_times,use_time];

%%社团状态变动
event_keys(guild_state) ->
    [event_type,guild_id,guild_name,guild_level,guild_num,guild_power,guild_rank,old_position,new_position];

%%等级排行
event_keys(level_rank) ->
    [rank_order,guild_id,guild_name,last_login];

%%幻光副本
event_keys(llusory_light) ->
    [dun_type,old_dun_wave,new_dun_wave,result_type,result_subtype,use_time];

%%狂战领域
event_keys(madness_land) ->
    [fam_stage,score,revive_times,use_time];

%%主线副本通关
event_keys(main_line_dungeon) ->
    [dun_type,dun_name,dun_level,result_subtype,dun_star,use_time];

%%羁绊关系
event_keys(mate_friend) ->
    [friend_id,type,intimacy];

%%小队讨伐
event_keys(multi_dungeon) ->
    [dun_type,is_single_mode,player_num,robot_num,assist_num,result_subtype,dun_star,use_time];

%%圣物抽奖
event_keys(nucleon_draw) ->
    [pool_type,type,color_orange1,color_orange2,section_piece,cost_goods,cost_gold,cost_bgold,current_gold,current_bgold];

%%圣物觉醒
event_keys(nucleon_section) ->
    [pos,level,cost_num];

%%圣物变化
event_keys(nucleon_state) ->
    [pos,level_pos,type,old_goods_id,goods_id,old_color,new_color,old_star,new_star,promote_power];

%%放置冒险一键加速
event_keys(onhook_fast) ->
    [type,supervip_state,level_up,cost_gold];

%%在线表
event_keys(online_count) ->
    [server_id,amount,hosting_amount];

%%橙装合成
event_keys(orange_compose) ->
    [equip_series,equip_typ,equip_career,cost_goods,cost_num,goods_id];

%%订单完成
event_keys(order_finish) ->
    [order_id,currency,pay_amount,act_value,pay_item_type,pay_sub_type,pay_item_id,pay_item,is_first_pay,pay_method];

%%发起订单
event_keys(order_init) ->
    [currency,pay_amount,pay_item_type,pay_sub_type,pay_item_id,pay_item,is_quick,is_first_pay];

%%宠物副本
event_keys(pet_dungeon) ->
    [dun_type,dun_wave,is_first,drop_select,result_type,result_subtype,dun_star,dun_score,pet_hp_left,use_time];

%%宠物激活升星
event_keys(pet_up) ->
    [pet_id,rare_degree,color_id,race_id,old_star,new_star,cost_goods,cost_num];

%%战力排行
event_keys(power_rank) ->
    [rank_order,guild_id,guild_name,last_login];

%%角色每日活跃
event_keys(role_daily_active) ->
    [active_degree,cross_activity,trade_actime,fame_actime,horse_actime,team_actime,gift_actime,arena_actime,daily_task_actime,guild_task_actime,dinner_actime,guild_boss_actime,collect_actime,dance_actime,person_boss,money_boss,deserted_boss,deserted_elite,escort_actime,light_actime,mount_actime,trump_actime,partner_actime,wing_actime,weapon_actime,magnet_actime,armor_actime,starwing_actime,exp_dun_actime,fame_get,current_hosting,today_hosting,person_boss_free,money_boss_free,cloister_actime_normal,cloister_actime_hard];

%%角色每日状态
event_keys(role_daily_attr) ->
    [total_online_time,current_gold,current_bgold,current_trade,current_fame,get_bgold,get_fame,consume_fame,consume_gold,consume_bgold,consume_trade,charge_rfmt];

%%角色登录
event_keys(role_login) ->
    [login_type,login_ip,network_type,channel,current_gold,current_bgold,current_trade,current_fame];

%%角色登出
event_keys(role_logout) ->
    [logout_type,online_time,current_gold,current_bgold,current_trade,current_fame];

%%七日目标任务
event_keys(seven_goal) ->
    [days,mod_id,sub_id,task_name,difficulty];

%%商城购买
event_keys(shop_buy) ->
    [shop_type,sub_type,goods_id,goods_num,cost_type,cost_num,currency_left,is_quick];

%%个人幻魔击杀归属
event_keys(single_boss_belong) ->
    [boss_id,boss_lv,boss_series,is_first_kill,kill_num,revive_times,use_time];

%%游戏登出
event_keys(ta_app_end) ->
    ['#duration',reg_ip];

%%无尽回廊
event_keys(tower_dungeon) ->
    [dun_type,dun_level,result_type,result_subtype,dun_star,power_advice,use_time];

%%交易券消耗
event_keys(trade_consume) ->
    [cost_amount,change_after,consume_type];

%%交易券获取
event_keys(trade_get) ->
    [get_amount,change_after,get_type];

%%珍宝升星
event_keys(treasure_up) ->
    [type,treasure_id,old_star,new_star,cost_goods,cost_num];

%%无尽领域
event_keys(void_fam) ->
    [max_floor,score,revive_times,use_time];

%%龙神宝库抽奖
event_keys(warsoul_draw) ->
    [type,award_list,purple_num,orange4_num,orange5_num,red_num,is_prize,is_absolute,total_times,cost_gold,cost_ticket,current_gold,current_ticket];

%%战魂变更
event_keys(warsoul_equip) ->
    [type,pos,old_goods_id,new_goods_id,goods_color,goods_star,group_type,promote_power];

%%饥饿游戏
event_keys(wasteland_war_kv) ->
    [war_round,result_type ,crystal_score,kill_score,rank_num,revive_times,use_time];

event_keys(_Eventname) ->
    [].

%%服务端事件公共属性列表，properties字段内层每条事件都上报的公共内容
get(common_properties) ->
    [accname,vip_level,role_level,current_power,total_pay_amount,open_day];

%%服务端用户属性列表，可使用user_set、user_setOnce等操作的属性
get(user_properties) ->
    [channel,register_time,accname,origin_server,server_open_time,is_roll,career,create_role_time,reg_ip,is_choose_career,is_change_name,server_id,latest_logout_time,total_pay_amount,charge_rfmt,vip_level,role_level,current_power];

get(_Key) ->
    [].
property_data_type('#duration') -> 2;
property_data_type('accname') -> 1;
property_data_type('active_degree') -> 2;
property_data_type('act_value') -> 2;
property_data_type('ai_cost') -> 2;
property_data_type('ai_left') -> 2;
property_data_type('amount') -> 2;
property_data_type('arena_actime') -> 2;
property_data_type('armor_actime') -> 2;
property_data_type('assist_num') -> 2;
property_data_type('assist_times') -> 2;
property_data_type('assist_type') -> 1;
property_data_type('auction_type') -> 2;
property_data_type('award_list') -> 5;
property_data_type('bid_times') -> 2;
property_data_type('boss_id') -> 1;
property_data_type('boss_lv') -> 2;
property_data_type('boss_series') -> 2;
property_data_type('boss_type') -> 2;
property_data_type('card_no') -> 1;
property_data_type('card_type') -> 1;
property_data_type('career') -> 1;
property_data_type('challenge_type') -> 2;
property_data_type('change_after') -> 2;
property_data_type('channel') -> 1;
property_data_type('charge_rfmt') -> 1;
property_data_type('cloister_actime_hard') -> 2;
property_data_type('cloister_actime_normal') -> 2;
property_data_type('collect_actime') -> 2;
property_data_type('collet_times') -> 2;
property_data_type('color_id') -> 2;
property_data_type('color_orange1') -> 2;
property_data_type('color_orange2') -> 2;
property_data_type('consume_bgold') -> 2;
property_data_type('consume_fame') -> 2;
property_data_type('consume_gold') -> 2;
property_data_type('consume_trade') -> 2;
property_data_type('consume_type') -> 2;
property_data_type('cost_amount') -> 2;
property_data_type('cost_bgold') -> 2;
property_data_type('cost_card') -> 2;
property_data_type('cost_equip_num') -> 2;
property_data_type('cost_gold') -> 2;
property_data_type('cost_goods') -> 2;
property_data_type('cost_list') -> 5;
property_data_type('cost_num') -> 2;
property_data_type('cost_ticket') -> 2;
property_data_type('cost_type') -> 1;
property_data_type('country_id') -> 2;
property_data_type('create_ip') -> 1;
property_data_type('create_role_time') -> 4;
property_data_type('cross_activity') -> 2;
property_data_type('crystal_score') -> 2;
property_data_type('currency') -> 1;
property_data_type('currency_left') -> 2;
property_data_type('current_bgold') -> 2;
property_data_type('current_channel') -> 1;
property_data_type('current_fame') -> 2;
property_data_type('current_gold') -> 2;
property_data_type('current_heart') -> 2;
property_data_type('current_hosting') -> 2;
property_data_type('current_point') -> 2;
property_data_type('current_power') -> 2;
property_data_type('current_ticket') -> 2;
property_data_type('current_trade') -> 2;
property_data_type('daily_task_actime') -> 2;
property_data_type('damage_percent') -> 2;
property_data_type('damage_rank') -> 2;
property_data_type('dance_actime') -> 2;
property_data_type('days') -> 2;
property_data_type('deal_price') -> 2;
property_data_type('deserted_boss') -> 2;
property_data_type('deserted_elite') -> 2;
property_data_type('difficulty') -> 2;
property_data_type('dinner_actime') -> 2;
property_data_type('double_type') -> 2;
property_data_type('drop_select') -> 2;
property_data_type('dun_level') -> 2;
property_data_type('dun_name') -> 1;
property_data_type('dun_score') -> 2;
property_data_type('dun_star') -> 2;
property_data_type('dun_times') -> 2;
property_data_type('dun_type') -> 2;
property_data_type('dun_wave') -> 2;
property_data_type('dun_wave_aft') -> 2;
property_data_type('duration') -> 2;
property_data_type('encourage_times') -> 2;
property_data_type('end_time') -> 4;
property_data_type('equip_career') -> 1;
property_data_type('equip_series') -> 2;
property_data_type('equip_type') -> 2;
property_data_type('escort_actime') -> 2;
property_data_type('event_type') -> 2;
property_data_type('exp') -> 2;
property_data_type('exp_add') -> 2;
property_data_type('exp_dun_actime') -> 2;
property_data_type('fail_type') -> 1;
property_data_type('fame_actime') -> 2;
property_data_type('fame_get') -> 2;
property_data_type('fam_stage') -> 2;
property_data_type('fashion_id') -> 2;
property_data_type('floor') -> 2;
property_data_type('friend_id') -> 1;
property_data_type('get_amount') -> 2;
property_data_type('get_bgold') -> 2;
property_data_type('get_fame') -> 2;
property_data_type('get_heart') -> 2;
property_data_type('get_point') -> 2;
property_data_type('get_type') -> 2;
property_data_type('gift_actime') -> 2;
property_data_type('gift_type') -> 1;
property_data_type('glamour_free_items') -> 2;
property_data_type('glamour_like_times') -> 2;
property_data_type('glamour_pay_items') -> 2;
property_data_type('goods_color') -> 2;
property_data_type('goods_color_new') -> 2;
property_data_type('goods_color_old') -> 2;
property_data_type('goods_id') -> 1;
property_data_type('goods_num') -> 2;
property_data_type('goods_only_id') -> 1;
property_data_type('goods_star') -> 1;
property_data_type('great_ratio') -> 2;
property_data_type('group_type') -> 2;
property_data_type('guild_boss_actime') -> 2;
property_data_type('guild_id') -> 1;
property_data_type('guild_level') -> 2;
property_data_type('guild_live') -> 2;
property_data_type('guild_name') -> 1;
property_data_type('guild_num') -> 2;
property_data_type('guild_power') -> 2;
property_data_type('guild_rank') -> 2;
property_data_type('guild_task_actime') -> 2;
property_data_type('home_type') -> 1;
property_data_type('horse_actime') -> 2;
property_data_type('hosting_amount') -> 2;
property_data_type('hp_bot') -> 2;
property_data_type('hp_mid') -> 2;
property_data_type('hp_top') -> 2;
property_data_type('inspire_bgold') -> 2;
property_data_type('inspire_gold') -> 2;
property_data_type('inspire_ticket') -> 2;
property_data_type('intimacy') -> 2;
property_data_type('is_absolute') -> 3;
property_data_type('is_auction') -> 3;
property_data_type('is_auto') -> 3;
property_data_type('is_captain') -> 3;
property_data_type('is_change_name') -> 3;
property_data_type('is_choose_career') -> 3;
property_data_type('is_count_down') -> 3;
property_data_type('is_double') -> 3;
property_data_type('is_first') -> 3;
property_data_type('is_first_kill') -> 3;
property_data_type('is_first_pay') -> 3;
property_data_type('is_fixed_price') -> 3;
property_data_type('is_makeup') -> 2;
property_data_type('is_offline_hosting') -> 3;
property_data_type('is_player') -> 3;
property_data_type('is_prize') -> 3;
property_data_type('is_public') -> 3;
property_data_type('is_quick') -> 3;
property_data_type('is_roll') -> 2;
property_data_type('is_simulator') -> 3;
property_data_type('is_single_mode') -> 3;
property_data_type('is_success') -> 3;
property_data_type('is_sweep') -> 3;
property_data_type('kill_num') -> 2;
property_data_type('kill_score') -> 2;
property_data_type('last_login') -> 2;
property_data_type('latest_logout_time') -> 4;
property_data_type('left_activity') -> 2;
property_data_type('level') -> 2;
property_data_type('level_pos') -> 2;
property_data_type('level_up') -> 2;
property_data_type('light_actime') -> 2;
property_data_type('live') -> 2;
property_data_type('login_ip') -> 1;
property_data_type('login_type') -> 1;
property_data_type('logout_type') -> 1;
property_data_type('magnet_actime') -> 2;
property_data_type('market_sell_sub_type') -> 2;
property_data_type('market_sell_type') -> 2;
property_data_type('max_floor') -> 2;
property_data_type('mod_id') -> 2;
property_data_type('money_boss') -> 2;
property_data_type('mount_actime') -> 2;
property_data_type('name') -> 1;
property_data_type('need_exp') -> 2;
property_data_type('network_type') -> 1;
property_data_type('new_color') -> 2;
property_data_type('new_dun_wave') -> 2;
property_data_type('new_goods_id') -> 1;
property_data_type('new_level') -> 2;
property_data_type('new_position') -> 2;
property_data_type('new_stage') -> 2;
property_data_type('new_star') -> 2;
property_data_type('old_color') -> 2;
property_data_type('old_dun_wave') -> 2;
property_data_type('old_goods_id') -> 1;
property_data_type('old_position') -> 2;
property_data_type('old_star') -> 2;
property_data_type('online_time') -> 2;
property_data_type('option_type') -> 2;
property_data_type('orange4_num') -> 2;
property_data_type('orange5_num') -> 2;
property_data_type('order_id') -> 1;
property_data_type('origin_price') -> 2;
property_data_type('origin_server') -> 1;
property_data_type('partner_actime') -> 2;
property_data_type('pay_amount') -> 2;
property_data_type('pay_item') -> 1;
property_data_type('pay_item_id') -> 1;
property_data_type('pay_item_type') -> 1;
property_data_type('pay_method') -> 1;
property_data_type('pay_sub_type') -> 1;
property_data_type('person_boss') -> 2;
property_data_type('person_live') -> 2;
property_data_type('pet_hp_left') -> 2;
property_data_type('pet_id') -> 1;
property_data_type('player_num') -> 2;
property_data_type('pool_type') -> 1;
property_data_type('pos') -> 2;
property_data_type('pos_id') -> 2;
property_data_type('power_advice') -> 2;
property_data_type('power_need') -> 2;
property_data_type('power_player2') -> 2;
property_data_type('power_player3') -> 2;
property_data_type('promote_power') -> 2;
property_data_type('public_time') -> 4;
property_data_type('purple_num') -> 2;
property_data_type('race_id') -> 2;
property_data_type('rank_num') -> 2;
property_data_type('rank_order') -> 2;
property_data_type('rare_degree') -> 2;
property_data_type('red_num') -> 2;
property_data_type('refresh_times') -> 2;
property_data_type('register_time') -> 4;
property_data_type('reg_ip') -> 1;
property_data_type('result_stage') -> 2;
property_data_type('result_subtype') -> 2;
property_data_type('result_type') -> 2;
property_data_type('revive_times') -> 2;
property_data_type('robot_num') -> 2;
property_data_type('role_level') -> 2;
property_data_type('score') -> 2;
property_data_type('section_piece') -> 2;
property_data_type('server_id') -> 1;
property_data_type('server_open_time') -> 4;
property_data_type('shelves_time') -> 4;
property_data_type('shop_type') -> 1;
property_data_type('skill_id') -> 1;
property_data_type('star') -> 2;
property_data_type('starwing_actime') -> 2;
property_data_type('star_level') -> 2;
property_data_type('step_level') -> 2;
property_data_type('strengthen_ratio') -> 2;
property_data_type('sub_id') -> 2;
property_data_type('sub_type') -> 1;
property_data_type('supervip_state') -> 2;
property_data_type('task_id') -> 1;
property_data_type('task_name') -> 1;
property_data_type('task_type') -> 1;
property_data_type('team_actime') -> 2;
property_data_type('team_num') -> 2;
property_data_type('today_hosting') -> 2;
property_data_type('total_online_time') -> 2;
property_data_type('total_pay_amount') -> 2;
property_data_type('total_times') -> 2;
property_data_type('trade_actime') -> 2;
property_data_type('treasure_id') -> 1;
property_data_type('trump_actime') -> 2;
property_data_type('type') -> 1;
property_data_type('use_time') -> 2;
property_data_type('vip_level') -> 2;
property_data_type('war_round') -> 2;
property_data_type('weapon_actime') -> 2;
property_data_type('wing_actime') -> 2;
%% error property
property_data_type(_) -> undefined.

