%%%---------------------------------------
%%% module      : data_top_pk
%%% description : 巅峰竞技配置
%%%
%%%---------------------------------------
-module(data_top_pk).
-compile(export_all).
-include("top_pk.hrl").



get_keyvalues(2) ->
    #base_top_pk_keyvalues{id = 2,value = 14,about = "赛季时长(天)"};

get_keyvalues(3) ->
    #base_top_pk_keyvalues{id = 3,value = 8,about = "开启跨服竞技需要的开服天数"};

get_keyvalues(4) ->
    #base_top_pk_keyvalues{id = 4,value = 310,about = "开启跨服竞技需要的世界等级"};

get_keyvalues(5) ->
    #base_top_pk_keyvalues{id = 5,value = 4053,about = "本服竞技场景id"};

get_keyvalues(6) ->
    #base_top_pk_keyvalues{id = 6,value = 4054,about = "跨服竞技场景id"};

get_keyvalues(7) ->
    #base_top_pk_keyvalues{id = 7,value = [{4098,4485},{5501,4505}],about = "本服战场出生点{X,Y}"};

get_keyvalues(8) ->
    #base_top_pk_keyvalues{id = 8,value = [{4098,4485},{5501,4505}],about = "跨服战场出生点{X,Y}"};

get_keyvalues(9) ->
    #base_top_pk_keyvalues{id = 9,value = 90,about = "每场竞技比赛时长(秒)"};

get_keyvalues(10) ->
    #base_top_pk_keyvalues{id = 10,value = 5,about = "每场竞技比赛准备时长(秒)"};

get_keyvalues(11) ->
    #base_top_pk_keyvalues{id = 11,value = 5,about = "开启竞技活动提前多久预告(分钟)"};

get_keyvalues(12) ->
    #base_top_pk_keyvalues{id = 12,value = 3,about = "玩家连续失败多少场匹配一次假人"};

get_keyvalues(13) ->
    #base_top_pk_keyvalues{id = 13,value = 5,about = "每轮匹配时长(s)"};

get_keyvalues(14) ->
    #base_top_pk_keyvalues{id = 14,value = 4,about = "最多匹配几轮，还匹配不到匹配假人"};

get_keyvalues(15) ->
    #base_top_pk_keyvalues{id = 15,value = 100,about = "排行榜最大长度"};

get_keyvalues(16) ->
    #base_top_pk_keyvalues{id = 16,value = 115,about = "功能开启等级"};

get_keyvalues(17) ->
    #base_top_pk_keyvalues{id = 17,value = 1000,about = "赛季玩家初始积分"};

get_keyvalues(18) ->
    #base_top_pk_keyvalues{id = 18,value = 10,about = "玩家每天可以参与匹配次数"};

get_keyvalues(19) ->
    #base_top_pk_keyvalues{id = 19,value = [{3,5},{7,6},{10,7}],about = "连胜传闻 格式：[{连胜次数,功能传闻id}]"};

get_keyvalues(20) ->
    #base_top_pk_keyvalues{id = 20,value = [{2,1,8},{3,1,9},{4,1,10},{5,1,11},{6,1,12}],about = "段位传闻 格式：[{段位,阶数,功能传闻id}]"};

get_keyvalues(21) ->
    #base_top_pk_keyvalues{id = 21,value = [{1,10},{2,25},{3,50},{4,100}],about = "匹配区间列表 格式：[{匹配次数，名次区间}]"};

get_keyvalues(22) ->
    #base_top_pk_keyvalues{id = 22,value = 32,about = "[弃用] ELO天梯算法K参数(通常为32)"};

get_keyvalues(23) ->
    #base_top_pk_keyvalues{id = 23,value = 1,about = "[弃用] ELO天梯算法S参数(通常为1)"};

get_keyvalues(24) ->
    #base_top_pk_keyvalues{id = 24,value = [{4279,4478},{3978,4640},{3962,4327}],about = "本服战场我方星灵出生点{X,Y}"};

get_keyvalues(25) ->
    #base_top_pk_keyvalues{id = 25,value = [{5308,4488},{5588,4643},{5560,4331}],about = "本服战场对方星灵出生点{X,Y}"};

get_keyvalues(26) ->
    #base_top_pk_keyvalues{id = 26,value = [{4279,4478},{3978,4640},{3962,4327}],about = "跨服战场我方星灵出生点{X,Y}"};

get_keyvalues(27) ->
    #base_top_pk_keyvalues{id = 27,value = [{5308,4488},{5588,4643},{5560,4331}],about = "跨服战场对方星灵出生点{X,Y}"};

get_keyvalues(28) ->
    #base_top_pk_keyvalues{id = 28,value = 10,about = "赛季排行奖励发放前几名"};

get_keyvalues(29) ->
    #base_top_pk_keyvalues{id = 29,value = 7,about = "发放赛季排行奖励需要的开服天数"};

get_keyvalues(_Id) ->
    [].

get_grade_list() ->
    [1,2,3,4,5,6].

get_grade_info(_Score) when _Score >= 1, _Score =< 1014 ->
	#base_top_pk_grade_info{grade_num=1,stage=1,name= "青铜1",min_score=1,max_score=1014,win_score=8,lose_score=4};
get_grade_info(_Score) when _Score >= 1015, _Score =< 1029 ->
	#base_top_pk_grade_info{grade_num=1,stage=2,name= "青铜2",min_score=1015,max_score=1029,win_score=8,lose_score=4};
get_grade_info(_Score) when _Score >= 1030, _Score =< 1044 ->
	#base_top_pk_grade_info{grade_num=1,stage=3,name= "青铜3",min_score=1030,max_score=1044,win_score=8,lose_score=4};
get_grade_info(_Score) when _Score >= 1045, _Score =< 1074 ->
	#base_top_pk_grade_info{grade_num=2,stage=1,name= "白银1",min_score=1045,max_score=1074,win_score=10,lose_score=4};
get_grade_info(_Score) when _Score >= 1075, _Score =< 1109 ->
	#base_top_pk_grade_info{grade_num=2,stage=2,name= "白银2",min_score=1075,max_score=1109,win_score=10,lose_score=4};
get_grade_info(_Score) when _Score >= 1110, _Score =< 1139 ->
	#base_top_pk_grade_info{grade_num=2,stage=3,name= "白银3",min_score=1110,max_score=1139,win_score=10,lose_score=4};
get_grade_info(_Score) when _Score >= 1140, _Score =< 1174 ->
	#base_top_pk_grade_info{grade_num=3,stage=1,name= "黄金1",min_score=1140,max_score=1174,win_score=12,lose_score=5};
get_grade_info(_Score) when _Score >= 1175, _Score =< 1209 ->
	#base_top_pk_grade_info{grade_num=3,stage=2,name= "黄金2",min_score=1175,max_score=1209,win_score=12,lose_score=5};
get_grade_info(_Score) when _Score >= 1210, _Score =< 1244 ->
	#base_top_pk_grade_info{grade_num=3,stage=3,name= "黄金3",min_score=1210,max_score=1244,win_score=12,lose_score=5};
get_grade_info(_Score) when _Score >= 1245, _Score =< 1289 ->
	#base_top_pk_grade_info{grade_num=4,stage=1,name= "铂金1",min_score=1245,max_score=1289,win_score=15,lose_score=6};
get_grade_info(_Score) when _Score >= 1290, _Score =< 1334 ->
	#base_top_pk_grade_info{grade_num=4,stage=2,name= "铂金2",min_score=1290,max_score=1334,win_score=15,lose_score=6};
get_grade_info(_Score) when _Score >= 1335, _Score =< 1379 ->
	#base_top_pk_grade_info{grade_num=4,stage=3,name= "铂金3",min_score=1335,max_score=1379,win_score=15,lose_score=6};
get_grade_info(_Score) when _Score >= 1380, _Score =< 1424 ->
	#base_top_pk_grade_info{grade_num=4,stage=4,name= "铂金4",min_score=1380,max_score=1424,win_score=15,lose_score=6};
get_grade_info(_Score) when _Score >= 1425, _Score =< 1499 ->
	#base_top_pk_grade_info{grade_num=5,stage=1,name= "钻石1",min_score=1425,max_score=1499,win_score=18,lose_score=7};
get_grade_info(_Score) when _Score >= 1500, _Score =< 1574 ->
	#base_top_pk_grade_info{grade_num=5,stage=2,name= "钻石2",min_score=1500,max_score=1574,win_score=18,lose_score=7};
get_grade_info(_Score) when _Score >= 1575, _Score =< 1639 ->
	#base_top_pk_grade_info{grade_num=5,stage=3,name= "钻石3",min_score=1575,max_score=1639,win_score=18,lose_score=7};
get_grade_info(_Score) when _Score >= 1640, _Score =< 1714 ->
	#base_top_pk_grade_info{grade_num=5,stage=4,name= "钻石4",min_score=1640,max_score=1714,win_score=18,lose_score=7};
get_grade_info(_Score) when _Score >= 1715, _Score =< 1799 ->
	#base_top_pk_grade_info{grade_num=6,stage=1,name= "王者1",min_score=1715,max_score=1799,win_score=20,lose_score=8};
get_grade_info(_Score) when _Score >= 1800, _Score =< 1874 ->
	#base_top_pk_grade_info{grade_num=6,stage=2,name= "王者2",min_score=1800,max_score=1874,win_score=20,lose_score=8};
get_grade_info(_Score) when _Score >= 1875, _Score =< 1954 ->
	#base_top_pk_grade_info{grade_num=6,stage=3,name= "王者3",min_score=1875,max_score=1954,win_score=20,lose_score=8};
get_grade_info(_Score) when _Score >= 1955, _Score =< 2034 ->
	#base_top_pk_grade_info{grade_num=6,stage=4,name= "王者4",min_score=1955,max_score=2034,win_score=20,lose_score=8};
get_grade_info(_Score) when _Score >= 2035, _Score =< 99999 ->
	#base_top_pk_grade_info{grade_num=6,stage=5,name= "王者5",min_score=2035,max_score=99999,win_score=25,lose_score=8};
get_grade_info(_Score) ->
    [].

get_match_num_list() ->
    [1,5,10].

get_match_reward(_WorldLv,1) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{0,24010001,4},{0,15020201,5},{0,18020001,5}];
get_match_reward(_WorldLv,5) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{0,24010001,4},{0,15020201,5},{0,18020001,5}];
get_match_reward(_WorldLv,10) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{0,24010001,4},{0,15020201,5},{0,18020001,5}];
get_match_reward(_WorldLv,1) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{0,24010001,4},{0,15020201,5},{0,18020001,5}];
get_match_reward(_WorldLv,5) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{0,24010001,4},{0,15020201,5},{0,18020001,5}];
get_match_reward(_WorldLv,10) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{0,24010001,4},{0,15020201,5},{0,18020001,5}];
get_match_reward(_WorldLv,1) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{0,24010001,6},{0,15020201,6},{0,18020001,6}];
get_match_reward(_WorldLv,5) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{0,24010001,6},{0,15020201,6},{0,18020001,6}];
get_match_reward(_WorldLv,10) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{0,24010001,6},{0,15020201,6},{0,18020001,6}];
get_match_reward(_WorldLv,1) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{0,24010001,6},{0,15020201,6},{0,18020001,6}];
get_match_reward(_WorldLv,5) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{0,24010001,6},{0,15020201,6},{0,18020001,6}];
get_match_reward(_WorldLv,10) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{0,24010001,6},{0,15020201,6},{0,18020001,6}];
get_match_reward(_WorldLv,1) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{0,24010001,8},{0,15020201,8},{0,18020001,8}];
get_match_reward(_WorldLv,5) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{0,24010001,8},{0,15020201,8},{0,18020001,8}];
get_match_reward(_WorldLv,10) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{0,24010001,8},{0,15020201,8},{0,18020001,8}];
get_match_reward(_WorldLv,1) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{0,24010001,8},{0,15020201,8},{0,18020001,10}];
get_match_reward(_WorldLv,5) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{0,24010001,8},{0,15020201,8},{0,18020001,10}];
get_match_reward(_WorldLv,10) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{0,24010001,8},{0,15020201,8},{0,18020001,10}];
get_match_reward(_WorldLv,1) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{0,24010001,10},{0,15020201,10},{0,18020001,12}];
get_match_reward(_WorldLv,5) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{0,24010001,10},{0,15020201,10},{0,18020001,12}];
get_match_reward(_WorldLv,10) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{0,24010001,10},{0,15020201,10},{0,18020001,12}];
get_match_reward(_WorldLv,1) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,5}];
get_match_reward(_WorldLv,5) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,5}];
get_match_reward(_WorldLv,10) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,5}];
get_match_reward(_WorldLv,1) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,6}];
get_match_reward(_WorldLv,5) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,6}];
get_match_reward(_WorldLv,10) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,6}];
get_match_reward(_WorldLv,1) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,6}];
get_match_reward(_WorldLv,5) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,6}];
get_match_reward(_WorldLv,10) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{0,24010002,5},{0,15020202,5},{0,18020002,6}];
get_match_reward(_WorldLv,1) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{0,24010002,6},{0,15020202,6},{0,18020002,8}];
get_match_reward(_WorldLv,5) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{0,24010002,6},{0,15020202,6},{0,18020002,8}];
get_match_reward(_WorldLv,10) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{0,24010002,6},{0,15020202,6},{0,18020002,8}];
get_match_reward(_WorldLv,1) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{0,24010002,6},{0,15020202,6},{0,18020002,8}];
get_match_reward(_WorldLv,5) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{0,24010002,6},{0,15020202,6},{0,18020002,8}];
get_match_reward(_WorldLv,10) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{0,24010002,6},{0,15020202,6},{0,18020002,8}];
get_match_reward(_WorldLv,1) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{0,24010002,8},{0,15020202,8},{0,18020002,10}];
get_match_reward(_WorldLv,5) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{0,24010002,8},{0,15020202,8},{0,18020002,10}];
get_match_reward(_WorldLv,10) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{0,24010002,8},{0,15020202,8},{0,18020002,10}];
get_match_reward(_WorldLv,_Match_num) ->
    [].

get_grade_reward_list() ->
    [1,2,3,4,5,6].

get_grade_reward(_WorldLv,1) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{2,36020001,20},{0,15020201,8},{3,36030001,100000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{2,36020001,40},{0,15020201,12},{3,36030001,150000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{2,36020001,80},{0,15020201,16},{3,36030001,200000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{2,36020001,120},{0,15020201,21},{3,36030001,250000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{2,36020001,150},{0,15020201,27},{3,36030001,300000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 1, _WorldLv =< 200 ->
		[{2,36020001,200},{0,15020201,35},{3,36030001,350000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{2,36020001,20},{0,15020201,8},{3,36030001,150000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{2,36020001,40},{0,15020201,12},{3,36030001,200000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{2,36020001,80},{0,15020201,16},{3,36030001,250000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{2,36020001,120},{0,15020201,21},{3,36030001,300000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{2,36020001,150},{0,15020201,27},{3,36030001,350000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 201, _WorldLv =< 260 ->
		[{2,36020001,200},{0,15020201,35},{3,36030001,400000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{2,36020001,20},{0,15020201,8},{3,36030001,200000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{2,36020001,40},{0,15020201,12},{3,36030001,250000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{2,36020001,80},{0,15020201,16},{3,36030001,300000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{2,36020001,120},{0,15020201,21},{3,36030001,350000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{2,36020001,150},{0,15020201,27},{3,36030001,400000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 261, _WorldLv =< 320 ->
		[{2,36020001,200},{0,15020201,35},{3,36030001,450000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{2,36020001,20},{0,15020202,4},{3,36030001,250000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{2,36020001,40},{0,15020202,6},{3,36030001,300000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{2,36020001,80},{0,15020202,9},{3,36030001,350000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{2,36020001,120},{0,15020202,12},{3,36030001,400000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{2,36020001,150},{0,15020202,14},{3,36030001,450000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 321, _WorldLv =< 350 ->
		[{2,36020001,200},{0,15020202,16},{3,36030001,500000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{2,36020001,20},{0,15020202,4},{3,36030001,300000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{2,36020001,40},{0,15020202,6},{3,36030001,350000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{2,36020001,80},{0,15020202,9},{3,36030001,400000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{2,36020001,120},{0,15020202,12},{3,36030001,450000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{2,36020001,150},{0,15020202,14},{3,36030001,500000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 351, _WorldLv =< 370 ->
		[{2,36020001,200},{0,15020202,16},{3,36030001,550000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{2,36020001,20},{0,15020202,4},{3,36030001,350000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{2,36020001,40},{0,15020202,6},{3,36030001,400000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{2,36020001,80},{0,15020202,9},{3,36030001,450000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{2,36020001,120},{0,15020202,12},{3,36030001,500000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{2,36020001,150},{0,15020202,14},{3,36030001,550000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 371, _WorldLv =< 390 ->
		[{2,36020001,200},{0,15020202,16},{3,36030001,600000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{2,36020001,20},{0,15020202,4},{3,36030001,400000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{2,36020001,40},{0,15020202,6},{3,36030001,450000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{2,36020001,80},{0,15020202,9},{3,36030001,500000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{2,36020001,120},{0,15020202,12},{3,36030001,550000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{2,36020001,150},{0,15020202,14},{3,36030001,600000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 391, _WorldLv =< 430 ->
		[{2,36020001,200},{0,15020202,16},{3,36030001,650000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{2,36020001,20},{0,15020202,4},{3,36030001,450000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{2,36020001,40},{0,15020202,6},{3,36030001,500000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{2,36020001,80},{0,15020202,9},{3,36030001,550000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{2,36020001,120},{0,15020202,12},{3,36030001,600000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{2,36020001,150},{0,15020202,14},{3,36030001,650000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 431, _WorldLv =< 500 ->
		[{2,36020001,200},{0,15020202,16},{3,36030001,700000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{2,36020001,20},{0,15020203,2},{3,36030001,500000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{2,36020001,40},{0,15020203,3},{3,36030001,550000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{2,36020001,80},{0,15020203,4},{3,36030001,600000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{2,36020001,120},{0,15020203,5},{3,36030001,650000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{2,36020001,150},{0,15020203,6},{3,36030001,700000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 501, _WorldLv =< 560 ->
		[{2,36020001,200},{0,15020203,7},{3,36030001,750000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{2,36020001,20},{0,15020203,2},{3,36030001,550000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{2,36020001,40},{0,15020203,3},{3,36030001,600000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{2,36020001,80},{0,15020203,4},{3,36030001,650000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{2,36020001,120},{0,15020203,5},{3,36030001,700000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{2,36020001,150},{0,15020203,6},{3,36030001,750000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 561, _WorldLv =< 610 ->
		[{2,36020001,200},{0,15020203,7},{3,36030001,800000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{2,36020001,20},{0,15020203,2},{3,36030001,600000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{2,36020001,40},{0,15020203,3},{3,36030001,650000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{2,36020001,80},{0,15020203,4},{3,36030001,700000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{2,36020001,120},{0,15020203,5},{3,36030001,750000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{2,36020001,150},{0,15020203,6},{3,36030001,800000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 611, _WorldLv =< 660 ->
		[{2,36020001,200},{0,15020203,7},{3,36030001,850000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{2,36020001,20},{0,15020203,2},{3,36030001,650000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{2,36020001,40},{0,15020203,3},{3,36030001,700000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{2,36020001,80},{0,15020203,4},{3,36030001,750000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{2,36020001,120},{0,15020203,5},{3,36030001,800000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{2,36020001,150},{0,15020203,6},{3,36030001,850000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 661, _WorldLv =< 750 ->
		[{2,36020001,200},{0,15020203,7},{3,36030001,900000}];
get_grade_reward(_WorldLv,1) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{2,36020001,20},{0,15020203,2},{3,36030001,700000}];
get_grade_reward(_WorldLv,2) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{2,36020001,40},{0,15020203,3},{3,36030001,750000}];
get_grade_reward(_WorldLv,3) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{2,36020001,80},{0,15020203,4},{3,36030001,800000}];
get_grade_reward(_WorldLv,4) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{2,36020001,120},{0,15020203,5},{3,36030001,850000}];
get_grade_reward(_WorldLv,5) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{2,36020001,150},{0,15020203,6},{3,36030001,900000}];
get_grade_reward(_WorldLv,6) when _WorldLv >= 751, _WorldLv =< 1000 ->
		[{2,36020001,200},{0,15020203,7},{3,36030001,950000}];
get_grade_reward(_WorldLv,_Grade_num) ->
    [].

get_rank_reward(_WorldLv,_Rank) when _WorldLv >= 0, _WorldLv =< 1000, _Rank >= 1, _Rank =< 1 ->
		[{0,4913003,1},{2,36020001,500},{0,17020003,3},{0,17020002,6},{0,17020001,10}];
get_rank_reward(_WorldLv,_Rank) when _WorldLv >= 0, _WorldLv =< 1000, _Rank >= 2, _Rank =< 3 ->
		[{0,4913002,1},{2,36020001,400},{0,17020003,3},{0,17020002,5},{0,17020001,9}];
get_rank_reward(_WorldLv,_Rank) when _WorldLv >= 0, _WorldLv =< 1000, _Rank >= 4, _Rank =< 10 ->
		[{0,4913001,1},{2,36020001,300},{0,17020003,2},{0,17020002,5},{0,17020001,8}];
get_rank_reward(_WorldLv,_Rank) when _WorldLv >= 0, _WorldLv =< 1000, _Rank >= 11, _Rank =< 20 ->
		[{2,36020001,225},{0,17020003,1},{0,17020002,4},{0,17020001,6}];
get_rank_reward(_WorldLv,_Rank) when _WorldLv >= 0, _WorldLv =< 1000, _Rank >= 21, _Rank =< 50 ->
		[{2,36020001,150},{0,17020003,1},{0,17020002,2},{0,17020001,4}];
get_rank_reward(_WorldLv,_Rank) ->
    [].

get_fake_man_cfg(_Lv) when _Lv >= 140, _Lv =< 160 ->
	#base_top_pk_fake_man{min_lv=140,max_lv=160,fake_man_id=2810001,power_range={1404052,1372704}};
get_fake_man_cfg(_Lv) when _Lv >= 161, _Lv =< 180 ->
	#base_top_pk_fake_man{min_lv=161,max_lv=180,fake_man_id=2810002,power_range={2731180,1404051}};
get_fake_man_cfg(_Lv) when _Lv >= 181, _Lv =< 200 ->
	#base_top_pk_fake_man{min_lv=181,max_lv=200,fake_man_id=2810003,power_range={4261694,2731179}};
get_fake_man_cfg(_Lv) when _Lv >= 201, _Lv =< 220 ->
	#base_top_pk_fake_man{min_lv=201,max_lv=220,fake_man_id=2810004,power_range={5601921,4261693}};
get_fake_man_cfg(_Lv) when _Lv >= 221, _Lv =< 240 ->
	#base_top_pk_fake_man{min_lv=221,max_lv=240,fake_man_id=2810005,power_range={8057207,5601920}};
get_fake_man_cfg(_Lv) when _Lv >= 241, _Lv =< 260 ->
	#base_top_pk_fake_man{min_lv=241,max_lv=260,fake_man_id=2810006,power_range={11355793,8057206}};
get_fake_man_cfg(_Lv) when _Lv >= 261, _Lv =< 280 ->
	#base_top_pk_fake_man{min_lv=261,max_lv=280,fake_man_id=2810007,power_range={14597605,11355792}};
get_fake_man_cfg(_Lv) when _Lv >= 281, _Lv =< 300 ->
	#base_top_pk_fake_man{min_lv=281,max_lv=300,fake_man_id=2810008,power_range={17865115,14597604}};
get_fake_man_cfg(_Lv) when _Lv >= 301, _Lv =< 310 ->
	#base_top_pk_fake_man{min_lv=301,max_lv=310,fake_man_id=2810009,power_range={19743261,17865114}};
get_fake_man_cfg(_Lv) when _Lv >= 311, _Lv =< 320 ->
	#base_top_pk_fake_man{min_lv=311,max_lv=320,fake_man_id=2810010,power_range={21621407,19743260}};
get_fake_man_cfg(_Lv) when _Lv >= 321, _Lv =< 330 ->
	#base_top_pk_fake_man{min_lv=321,max_lv=330,fake_man_id=2810011,power_range={23499629,21621406}};
get_fake_man_cfg(_Lv) when _Lv >= 331, _Lv =< 340 ->
	#base_top_pk_fake_man{min_lv=331,max_lv=340,fake_man_id=2810012,power_range={25377875,23499628}};
get_fake_man_cfg(_Lv) when _Lv >= 341, _Lv =< 350 ->
	#base_top_pk_fake_man{min_lv=341,max_lv=350,fake_man_id=2810013,power_range={27298553,25377874}};
get_fake_man_cfg(_Lv) when _Lv >= 351, _Lv =< 360 ->
	#base_top_pk_fake_man{min_lv=351,max_lv=360,fake_man_id=2810014,power_range={29601812,27298552}};
get_fake_man_cfg(_Lv) when _Lv >= 361, _Lv =< 370 ->
	#base_top_pk_fake_man{min_lv=361,max_lv=370,fake_man_id=2810015,power_range={31905096,29601811}};
get_fake_man_cfg(_Lv) when _Lv >= 371, _Lv =< 380 ->
	#base_top_pk_fake_man{min_lv=371,max_lv=380,fake_man_id=2810016,power_range={34208230,31905095}};
get_fake_man_cfg(_Lv) when _Lv >= 381, _Lv =< 390 ->
	#base_top_pk_fake_man{min_lv=381,max_lv=390,fake_man_id=2810017,power_range={36511464,34208229}};
get_fake_man_cfg(_Lv) when _Lv >= 391, _Lv =< 400 ->
	#base_top_pk_fake_man{min_lv=391,max_lv=400,fake_man_id=2810018,power_range={38807708,36511463}};
get_fake_man_cfg(_Lv) when _Lv >= 401, _Lv =< 410 ->
	#base_top_pk_fake_man{min_lv=401,max_lv=410,fake_man_id=2810019,power_range={41039739,38807707}};
get_fake_man_cfg(_Lv) when _Lv >= 411, _Lv =< 420 ->
	#base_top_pk_fake_man{min_lv=411,max_lv=420,fake_man_id=2810020,power_range={43271796,41039738}};
get_fake_man_cfg(_Lv) when _Lv >= 421, _Lv =< 430 ->
	#base_top_pk_fake_man{min_lv=421,max_lv=430,fake_man_id=2810021,power_range={45503928,43271795}};
get_fake_man_cfg(_Lv) when _Lv >= 431, _Lv =< 440 ->
	#base_top_pk_fake_man{min_lv=431,max_lv=440,fake_man_id=2810022,power_range={47736084,45503927}};
get_fake_man_cfg(_Lv) when _Lv >= 441, _Lv =< 450 ->
	#base_top_pk_fake_man{min_lv=441,max_lv=450,fake_man_id=2810023,power_range={50066664,47736083}};
get_fake_man_cfg(_Lv) when _Lv >= 451, _Lv =< 460 ->
	#base_top_pk_fake_man{min_lv=451,max_lv=460,fake_man_id=2810024,power_range={53284270,50066663}};
get_fake_man_cfg(_Lv) when _Lv >= 461, _Lv =< 470 ->
	#base_top_pk_fake_man{min_lv=461,max_lv=470,fake_man_id=2810025,power_range={56501902,53284269}};
get_fake_man_cfg(_Lv) when _Lv >= 471, _Lv =< 480 ->
	#base_top_pk_fake_man{min_lv=471,max_lv=480,fake_man_id=2810026,power_range={59719509,56501901}};
get_fake_man_cfg(_Lv) when _Lv >= 481, _Lv =< 490 ->
	#base_top_pk_fake_man{min_lv=481,max_lv=490,fake_man_id=2810027,power_range={62937040,59719508}};
get_fake_man_cfg(_Lv) when _Lv >= 491, _Lv =< 500 ->
	#base_top_pk_fake_man{min_lv=491,max_lv=500,fake_man_id=2810028,power_range={66210030,62937039}};
get_fake_man_cfg(_Lv) when _Lv >= 501, _Lv =< 510 ->
	#base_top_pk_fake_man{min_lv=501,max_lv=510,fake_man_id=2810029,power_range={69981338,66210029}};
get_fake_man_cfg(_Lv) when _Lv >= 511, _Lv =< 520 ->
	#base_top_pk_fake_man{min_lv=511,max_lv=520,fake_man_id=2810030,power_range={73752646,69981337}};
get_fake_man_cfg(_Lv) when _Lv >= 521, _Lv =< 530 ->
	#base_top_pk_fake_man{min_lv=521,max_lv=530,fake_man_id=2810031,power_range={77523979,73752645}};
get_fake_man_cfg(_Lv) when _Lv >= 531, _Lv =< 540 ->
	#base_top_pk_fake_man{min_lv=531,max_lv=540,fake_man_id=2810032,power_range={81295262,77523978}};
get_fake_man_cfg(_Lv) when _Lv >= 541, _Lv =< 550 ->
	#base_top_pk_fake_man{min_lv=541,max_lv=550,fake_man_id=2810033,power_range={85087885,81295261}};
get_fake_man_cfg(_Lv) when _Lv >= 551, _Lv =< 560 ->
	#base_top_pk_fake_man{min_lv=551,max_lv=560,fake_man_id=2810034,power_range={89071388,85087884}};
get_fake_man_cfg(_Lv) when _Lv >= 561, _Lv =< 570 ->
	#base_top_pk_fake_man{min_lv=561,max_lv=570,fake_man_id=2810035,power_range={93054891,89071387}};
get_fake_man_cfg(_Lv) when _Lv >= 571, _Lv =< 580 ->
	#base_top_pk_fake_man{min_lv=571,max_lv=580,fake_man_id=2810036,power_range={97038344,93054890}};
get_fake_man_cfg(_Lv) when _Lv >= 581, _Lv =< 590 ->
	#base_top_pk_fake_man{min_lv=581,max_lv=590,fake_man_id=2810037,power_range={101021822,97038343}};
get_fake_man_cfg(_Lv) when _Lv >= 591, _Lv =< 600 ->
	#base_top_pk_fake_man{min_lv=591,max_lv=600,fake_man_id=2810038,power_range={105046937,101021821}};
get_fake_man_cfg(_Lv) when _Lv >= 601, _Lv =< 610 ->
	#base_top_pk_fake_man{min_lv=601,max_lv=610,fake_man_id=2810039,power_range={109447132,105046936}};
get_fake_man_cfg(_Lv) when _Lv >= 611, _Lv =< 620 ->
	#base_top_pk_fake_man{min_lv=611,max_lv=620,fake_man_id=2810040,power_range={113847278,109447131}};
get_fake_man_cfg(_Lv) when _Lv >= 621, _Lv =< 630 ->
	#base_top_pk_fake_man{min_lv=621,max_lv=630,fake_man_id=2810041,power_range={118247448,113847277}};
get_fake_man_cfg(_Lv) when _Lv >= 631, _Lv =< 640 ->
	#base_top_pk_fake_man{min_lv=631,max_lv=640,fake_man_id=2810042,power_range={122647594,118247447}};
get_fake_man_cfg(_Lv) when _Lv >= 641, _Lv =< 650 ->
	#base_top_pk_fake_man{min_lv=641,max_lv=650,fake_man_id=2810043,power_range={127140568,122647593}};
get_fake_man_cfg(_Lv) when _Lv >= 651, _Lv =< 660 ->
	#base_top_pk_fake_man{min_lv=651,max_lv=660,fake_man_id=2810044,power_range={132468303,127140567}};
get_fake_man_cfg(_Lv) when _Lv >= 661, _Lv =< 670 ->
	#base_top_pk_fake_man{min_lv=661,max_lv=670,fake_man_id=2810045,power_range={137796137,132468302}};
get_fake_man_cfg(_Lv) when _Lv >= 671, _Lv =< 680 ->
	#base_top_pk_fake_man{min_lv=671,max_lv=680,fake_man_id=2810046,power_range={143123922,137796136}};
get_fake_man_cfg(_Lv) when _Lv >= 681, _Lv =< 690 ->
	#base_top_pk_fake_man{min_lv=681,max_lv=690,fake_man_id=2810047,power_range={148451657,143123921}};
get_fake_man_cfg(_Lv) when _Lv >= 691, _Lv =< 700 ->
	#base_top_pk_fake_man{min_lv=691,max_lv=700,fake_man_id=2810048,power_range={153732813,148451656}};
get_fake_man_cfg(_Lv) when _Lv >= 701, _Lv =< 710 ->
	#base_top_pk_fake_man{min_lv=701,max_lv=710,fake_man_id=2810049,power_range={158593783,153732812}};
get_fake_man_cfg(_Lv) when _Lv >= 711, _Lv =< 720 ->
	#base_top_pk_fake_man{min_lv=711,max_lv=720,fake_man_id=2810050,power_range={163454702,158593782}};
get_fake_man_cfg(_Lv) when _Lv >= 721, _Lv =< 730 ->
	#base_top_pk_fake_man{min_lv=721,max_lv=730,fake_man_id=2810051,power_range={168315622,163454701}};
get_fake_man_cfg(_Lv) when _Lv >= 731, _Lv =< 740 ->
	#base_top_pk_fake_man{min_lv=731,max_lv=740,fake_man_id=2810052,power_range={173176641,168315621}};
get_fake_man_cfg(_Lv) when _Lv >= 741, _Lv =< 750 ->
	#base_top_pk_fake_man{min_lv=741,max_lv=750,fake_man_id=2810053,power_range={178079899,173176640}};
get_fake_man_cfg(_Lv) when _Lv >= 751, _Lv =< 760 ->
	#base_top_pk_fake_man{min_lv=751,max_lv=760,fake_man_id=2810054,power_range={183365352,178079898}};
get_fake_man_cfg(_Lv) when _Lv >= 761, _Lv =< 770 ->
	#base_top_pk_fake_man{min_lv=761,max_lv=770,fake_man_id=2810055,power_range={188650830,183365351}};
get_fake_man_cfg(_Lv) when _Lv >= 771, _Lv =< 780 ->
	#base_top_pk_fake_man{min_lv=771,max_lv=780,fake_man_id=2810056,power_range={193936233,188650829}};
get_fake_man_cfg(_Lv) when _Lv >= 781, _Lv =< 790 ->
	#base_top_pk_fake_man{min_lv=781,max_lv=790,fake_man_id=2810057,power_range={199221685,193936232}};
get_fake_man_cfg(_Lv) when _Lv >= 791, _Lv =< 800 ->
	#base_top_pk_fake_man{min_lv=791,max_lv=800,fake_man_id=2810058,power_range={203978590,199221684}};
get_fake_man_cfg(_Lv) when _Lv >= 801, _Lv =< 810 ->
	#base_top_pk_fake_man{min_lv=801,max_lv=810,fake_man_id=2810059,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 811, _Lv =< 820 ->
	#base_top_pk_fake_man{min_lv=811,max_lv=820,fake_man_id=2810060,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 821, _Lv =< 830 ->
	#base_top_pk_fake_man{min_lv=821,max_lv=830,fake_man_id=2810061,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 831, _Lv =< 840 ->
	#base_top_pk_fake_man{min_lv=831,max_lv=840,fake_man_id=2810062,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 841, _Lv =< 850 ->
	#base_top_pk_fake_man{min_lv=841,max_lv=850,fake_man_id=2810063,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 851, _Lv =< 860 ->
	#base_top_pk_fake_man{min_lv=851,max_lv=860,fake_man_id=2810064,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 861, _Lv =< 870 ->
	#base_top_pk_fake_man{min_lv=861,max_lv=870,fake_man_id=2810065,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 871, _Lv =< 880 ->
	#base_top_pk_fake_man{min_lv=871,max_lv=880,fake_man_id=2810066,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 881, _Lv =< 890 ->
	#base_top_pk_fake_man{min_lv=881,max_lv=890,fake_man_id=2810067,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 891, _Lv =< 900 ->
	#base_top_pk_fake_man{min_lv=891,max_lv=900,fake_man_id=2810068,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 901, _Lv =< 910 ->
	#base_top_pk_fake_man{min_lv=901,max_lv=910,fake_man_id=2810069,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 911, _Lv =< 920 ->
	#base_top_pk_fake_man{min_lv=911,max_lv=920,fake_man_id=2810070,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 921, _Lv =< 930 ->
	#base_top_pk_fake_man{min_lv=921,max_lv=930,fake_man_id=2810071,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 931, _Lv =< 940 ->
	#base_top_pk_fake_man{min_lv=931,max_lv=940,fake_man_id=2810072,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 941, _Lv =< 950 ->
	#base_top_pk_fake_man{min_lv=941,max_lv=950,fake_man_id=2810073,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 951, _Lv =< 960 ->
	#base_top_pk_fake_man{min_lv=951,max_lv=960,fake_man_id=2810074,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 961, _Lv =< 970 ->
	#base_top_pk_fake_man{min_lv=961,max_lv=970,fake_man_id=2810075,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 971, _Lv =< 980 ->
	#base_top_pk_fake_man{min_lv=971,max_lv=980,fake_man_id=2810076,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 981, _Lv =< 990 ->
	#base_top_pk_fake_man{min_lv=981,max_lv=990,fake_man_id=2810077,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) when _Lv >= 991, _Lv =< 1000 ->
	#base_top_pk_fake_man{min_lv=991,max_lv=1000,fake_man_id=2810078,power_range={203978589,203978589}};
get_fake_man_cfg(_Lv) ->
    [].

