%%%---------------------------------------
%%% module      : data_treasure_map
%%% description : 藏宝图配置
%%%
%%%---------------------------------------
-module(data_treasure_map).
-compile(export_all).
-include("treasure_map.hrl").



%%普通藏宝图挖宝消耗道具
get_kv(cost_common_map) ->
    [{0,360001,1}];

%%高级藏宝图挖宝消耗道具
get_kv(cost_advanced_map) ->
    [{0,360002,1}];

%%藏宝秘闻触发概率，[{vip等级,概率(%)}]
get_kv(event_rate) ->
    [{0,50},{1,50},{2,50},{3,50},{4,50},{5,50},{6,50},{7,50},{8,50},{9,50},{10,50},{11,50},{12,50},{13,50},{14,50},{15,50}];

%%藏宝秘闻各事件权重，[{权重,事件}]，1-神秘大亨，2-珍宝之门，3-宝藏看守者
get_kv(event_type_rate) ->
    [{5000,1},{5000,2},{5000,3}];

%%藏宝秘闻单日触发次数上限
get_kv(event_max) ->
    50;

%%BOSS对应怪物ID
get_kv(mon_id) ->
    85000004;

%%BOSS存活秒数
get_kv(mon_alive) ->
    500;

%%普通藏宝图激活批量使用所需次数
get_kv(common_map_times) ->
    15;

%%高级藏宝图大奖概率提升所需轮数及概率，[{轮数,提升概率(%)}]
get_kv(advanced_map_times) ->
    [{1,5000},{5,5000},{10,5000},{15,5000},{20,5000},{50,50},{50,50}];

%%高级藏宝图每月使用次数奖励，[{次数，奖励ID，数量}]
get_kv(advanced_map_times_reward) ->
    [{10,360002,1},{50,360002,3},{60,360002,8},{100,360002,12},{150,360002,20}];

%%每种藏宝图单日最大使用上限
get_kv(map_times_max) ->
    50;

%%珍宝之门物品收纳秒数
get_kv(goods_time) ->
    500;

%%活动说明-普通图展板九宫格展示
get_kv(common_map_show) ->
     {102403,102351,102009,230001,231021,102009,102404,102351,102009};

%%活动说明-高级图展板九宫格展示
get_kv(advanced_map_show) ->
     {102403,102351,102009,230001,231021,102009,102404,102351,102009} ;

%%下一张藏宝图坐标在当前地图概率（%）
get_kv(map_scene_same) ->
    40;

%%高级藏宝图转盘工作秒数
get_kv(advanced_map_speed) ->
    9;

get_kv(_Key) ->
    [].

get_reward(1) ->
    #base_treasure_map_rewards{reward_id = 1,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 200,show_weight = 1000,notice = 0,rewards = [{100,230001,1}]};

get_reward(2) ->
    #base_treasure_map_rewards{reward_id = 2,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 100,show_weight = 1000,notice = 0,rewards = [{100,230001,1}]};

get_reward(3) ->
    #base_treasure_map_rewards{reward_id = 3,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 200,show_weight = 1000,notice = 1,rewards = [{100,230001,1}]};

get_reward(4) ->
    #base_treasure_map_rewards{reward_id = 4,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 300,show_weight = 1000,notice = 0,rewards = [{100,109031,2}]};

get_reward(5) ->
    #base_treasure_map_rewards{reward_id = 5,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 200,show_weight = 1000,notice = 0,rewards = [{100,109001,1}]};

get_reward(6) ->
    #base_treasure_map_rewards{reward_id = 6,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 200,show_weight = 1000,notice = 1,rewards = [{100,109001,2}]};

get_reward(7) ->
    #base_treasure_map_rewards{reward_id = 7,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 200,show_weight = 1000,notice = 1,rewards = [{100,109001,3}]};

get_reward(8) ->
    #base_treasure_map_rewards{reward_id = 8,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 300,show_weight = 1000,notice = 0,rewards = [{100,109011,1}]};

get_reward(9) ->
    #base_treasure_map_rewards{reward_id = 9,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 300,show_weight = 1000,notice = 0,rewards = [{100,109021,1}]};

get_reward(10) ->
    #base_treasure_map_rewards{reward_id = 10,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 500,show_weight = 1000,notice = 0,rewards = [{100,102603,1}]};

get_reward(11) ->
    #base_treasure_map_rewards{reward_id = 11,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 500,show_weight = 1000,notice = 0,rewards = [{100,102000,1}]};

get_reward(12) ->
    #base_treasure_map_rewards{reward_id = 12,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 200,show_weight = 1000,notice = 1,rewards = [{100,102004,1}]};

get_reward(20) ->
    #base_treasure_map_rewards{reward_id = 20,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 20,show_weight = 1000,notice = 2,rewards = [{100,230001,1}]};

get_reward(21) ->
    #base_treasure_map_rewards{reward_id = 21,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 250,show_weight = 1000,notice = 1,rewards = [{100,230001,1}]};

get_reward(22) ->
    #base_treasure_map_rewards{reward_id = 22,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,230001,1}]};

get_reward(23) ->
    #base_treasure_map_rewards{reward_id = 23,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,109031,2}]};

get_reward(24) ->
    #base_treasure_map_rewards{reward_id = 24,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,109001,1}]};

get_reward(25) ->
    #base_treasure_map_rewards{reward_id = 25,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,109001,2}]};

get_reward(26) ->
    #base_treasure_map_rewards{reward_id = 26,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,109001,3}]};

get_reward(27) ->
    #base_treasure_map_rewards{reward_id = 27,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,109011,1}]};

get_reward(28) ->
    #base_treasure_map_rewards{reward_id = 28,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,109021,1}]};

get_reward(29) ->
    #base_treasure_map_rewards{reward_id = 29,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,102603,1}]};

get_reward(30) ->
    #base_treasure_map_rewards{reward_id = 30,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,102000,1}]};

get_reward(31) ->
    #base_treasure_map_rewards{reward_id = 31,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,get_weight = 1000,show_weight = 1000,notice = 0,rewards = [{100,102000,1}]};

get_reward(_Rewardid) ->
    [].


get_reward_list_by_type(1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12];


get_reward_list_by_type(2) ->
    [20,21,22,23,24,25,26,27,28,29,30,31];

get_reward_list_by_type(_Type) ->
    [].

get_all_pos() ->
    [1,2,3,4,5,6,7,8,9,10,11,12].


get_pos(1) ->
    {1004,7791,9087};


get_pos(2) ->
    {1004,6087,8944};


get_pos(3) ->
    {1004,2776,12614};


get_pos(4) ->
    {1016,12198,5696};


get_pos(5) ->
    {1016,10121,8635};


get_pos(6) ->
    {1016,10121,8635};


get_pos(7) ->
    {1002,16374,344};


get_pos(8) ->
    {1002,20359,4313};


get_pos(9) ->
    {1005,2191,7116};


get_pos(10) ->
    {1005,3261,8146};


get_pos(11) ->
    {1008,7897,1906};


get_pos(12) ->
    {1008,7365,4996};

get_pos(_Posid) ->
    [].

get_event_rewards(1) ->
    #base_treasure_event_rewards{reward_id = 1,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,230001,1}]};

get_event_rewards(2) ->
    #base_treasure_event_rewards{reward_id = 2,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,230001,1}]};

get_event_rewards(3) ->
    #base_treasure_event_rewards{reward_id = 3,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,230001,1}]};

get_event_rewards(4) ->
    #base_treasure_event_rewards{reward_id = 4,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,109031,2}]};

get_event_rewards(5) ->
    #base_treasure_event_rewards{reward_id = 5,type = 1,min_lv = 1,max_lv = 999,min_vip = 5,weight = 100,rewards = [{100,109001,1}]};

get_event_rewards(6) ->
    #base_treasure_event_rewards{reward_id = 6,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,109001,2}]};

get_event_rewards(7) ->
    #base_treasure_event_rewards{reward_id = 7,type = 1,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,109001,3}]};

get_event_rewards(8) ->
    #base_treasure_event_rewards{reward_id = 8,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,109011,1}]};

get_event_rewards(9) ->
    #base_treasure_event_rewards{reward_id = 9,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,109021,1}]};

get_event_rewards(10) ->
    #base_treasure_event_rewards{reward_id = 10,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,102603,1}]};

get_event_rewards(11) ->
    #base_treasure_event_rewards{reward_id = 11,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,102000,1}]};

get_event_rewards(12) ->
    #base_treasure_event_rewards{reward_id = 12,type = 2,min_lv = 1,max_lv = 999,min_vip = 0,weight = 100,rewards = [{100,102004,1}]};

get_event_rewards(_Rewardid) ->
    [].

get_all_event_rewards() ->
    [1,2,3,4,5,6,7,8,9,10,11,12].

get_limit_shop_rewards(1) ->
    #base_treasure_map_door{reward_id = 1,min_lv = 1,max_lv = 999,weight = 100,rewards = [{1,{{100,109032,1},bgold,150,1}},{2,{{100,109032,1},gold,50,1}}]};

get_limit_shop_rewards(2) ->
    #base_treasure_map_door{reward_id = 2,min_lv = 500,max_lv = 999,weight = 300,rewards = [{1,{{100,109032,1},bgold,100,1}},{2,{{100,109001,1},gold,30,1}}]};

get_limit_shop_rewards(3) ->
    #base_treasure_map_door{reward_id = 3,min_lv = 500,max_lv = 999,weight = 300,rewards = [{1,{{100,109031,4},bgold,80,1}},{2,{{100,109031,1},gold,20,3}}]};

get_limit_shop_rewards(_Rewardid) ->
    [].

get_all_shop_rewards() ->
    [1,2,3].

get_quiz(1) ->
    #base_treasure_map_quiz{id = 1,question = <<"以下不属于高级藏宝图来源途径的是："/utf8>>,option = [{1,"碎片合成"},{2,"野外挂机"},{3,"商城购买"},{4,"运营活动"}],answer = 2};

get_quiz(2) ->
    #base_treasure_map_quiz{id = 2,question = <<"以下不属于游戏内种族的是："/utf8>>,option = [{1,"人类"},{2,"人造机械"},{3,"异兽"},{4,"神族"}],answer = 4};

get_quiz(3) ->
    #base_treasure_map_quiz{id = 3,question = <<"大灾厄后魔龙血液凝结成的结晶名为："/utf8>>,option = [{1,"白晶"},{2,"黑晶"},{3,"紫晶"},{4,"源晶"}],answer = 2};

get_quiz(4) ->
    #base_treasure_map_quiz{id = 4,question = <<"在西方神话中,丘比特常被称为："/utf8>>,option = [{1,"死神"},{2,"战神"},{3,"原神"},{4,"爱神"}],answer = 4};

get_quiz(5) ->
    #base_treasure_map_quiz{id = 5,question = <<"阿拉伯神灯的主人公是："/utf8>>,option = [{1,"阿拉甲"},{2,"阿拉乙"},{3,"阿拉丙"},{4,"阿拉丁"}],answer = 4};

get_quiz(6) ->
    #base_treasure_map_quiz{id = 6,question = <<"发现新大陆的是："/utf8>>,option = [{1,"哥伦布"},{2,"弟伦布"},{3,"姐伦布"},{4,"妹伦布"}],answer = 1};

get_quiz(7) ->
    #base_treasure_map_quiz{id = 7,question = <<"猩猩最讨厌什么线："/utf8>>,option = [{1,"平行线"},{2,"垂线"},{3,"斜线"},{4,"角平分线"}],answer = 1};

get_quiz(8) ->
    #base_treasure_map_quiz{id = 8,question = <<"以下哪一种动物属于鱼类："/utf8>>,option = [{1,"娃娃鱼"},{2,"海马"},{3,"鲸"},{4,"鳄鱼"}],answer = 2};

get_quiz(9) ->
    #base_treasure_map_quiz{id = 9,question = <<"以下哪一种花最无力："/utf8>>,option = [{1,"向日葵"},{2,"玫瑰"},{3,"茉莉花"},{4,"樱花"}],answer = 3};

get_quiz(10) ->
    #base_treasure_map_quiz{id = 10,question = <<"如果昨天是明天，今天就是周五了。请问今天是："/utf8>>,option = [{1,"周三"},{2,"周四"},{3,"周五"},{4,"周日"}],answer = 1};

get_quiz(_Id) ->
    [].

get_all_quiz() ->
    [1,2,3,4,5,6,7,8,9,10].

