%%%---------------------------------------
%%% module      : data_turntable
%%% description : 源能转盘配置
%%%
%%%---------------------------------------
-module(data_turntable).
-compile(export_all).
-include("turntable.hrl").




get_config(free_time) ->
    1;


get_config(luck_total) ->
    100;


get_config(one_time) ->
    8;


get_config(ten_time) ->
    25;


get_config(turn_cost_1) ->
    [{0,102352,1}];


get_config(turn_cost_10) ->
    [{0,102352,9}];


get_config(turn_luck) ->
    1;


get_config(turn_score) ->
    1;

get_config(_Key) ->
    [].

get_offset_reward(101,Point) when 1 =< Point, Point =< 10 ->
		[{100,109011,1}];
get_offset_reward(101,Point) when 11 =< Point, Point =< 20 ->
		[{100,109011,2}];
get_offset_reward(101,Point) when 21 =< Point, Point =< 30 ->
		[{100,109011,3}];
get_offset_reward(101,Point) when 31 =< Point, Point =< 40 ->
		[{100,109011,4}];
get_offset_reward(101,Point) when 41 =< Point, Point =< 50 ->
		[{100,109011,5}];
get_offset_reward(101,Point) when 51 =< Point, Point =< 60 ->
		[{100,109011,6}];
get_offset_reward(101,Point) when 61 =< Point, Point =< 70 ->
		[{100,109011,7}];
get_offset_reward(101,Point) when 71 =< Point, Point =< 80 ->
		[{100,109011,8}];
get_offset_reward(101,Point) when 81 =< Point, Point =< 90 ->
		[{100,109011,9}];
get_offset_reward(101,Point) when 91 =< Point, Point =< 9999 ->
		[{100,109011,10}];
get_offset_reward(102,Point) when 1 =< Point, Point =< 10 ->
		[{100,109011,11}];
get_offset_reward(102,Point) when 11 =< Point, Point =< 20 ->
		[{100,109011,12}];
get_offset_reward(102,Point) when 21 =< Point, Point =< 30 ->
		[{100,109011,13}];
get_offset_reward(102,Point) when 31 =< Point, Point =< 40 ->
		[{100,109011,14}];
get_offset_reward(102,Point) when 41 =< Point, Point =< 50 ->
		[{100,109011,15}];
get_offset_reward(102,Point) when 51 =< Point, Point =< 60 ->
		[{100,109011,16}];
get_offset_reward(102,Point) when 61 =< Point, Point =< 70 ->
		[{100,109011,17}];
get_offset_reward(102,Point) when 71 =< Point, Point =< 80 ->
		[{100,109011,18}];
get_offset_reward(102,Point) when 81 =< Point, Point =< 90 ->
		[{100,109011,19}];
get_offset_reward(102,Point) when 91 =< Point, Point =< 9999 ->
		[{100,109011,20}];
get_offset_reward(_Suit,_Point) ->
    [].

get_min_suit() -> 101.

turntable_point_reward(1,1) ->
    #base_turntable_point_reward{sub_id = 1,id = 1,reward = [{100,109031,1}],limit = 1,points = 1};

turntable_point_reward(1,2) ->
    #base_turntable_point_reward{sub_id = 1,id = 2,reward = [{100,109001,1}],limit = 1,points = 2};

turntable_point_reward(1,3) ->
    #base_turntable_point_reward{sub_id = 1,id = 3,reward = [{100,109011,1}],limit = 1,points = 3};

turntable_point_reward(1,4) ->
    #base_turntable_point_reward{sub_id = 1,id = 4,reward = [{100,102404,1}],limit = 2,points = 4};

turntable_point_reward(1,5) ->
    #base_turntable_point_reward{sub_id = 1,id = 5,reward = [{100,109021,1}],limit = 2,points = 5};

turntable_point_reward(1,6) ->
    #base_turntable_point_reward{sub_id = 1,id = 6,reward = [{100,102000,1}],limit = 5,points = 6};

turntable_point_reward(1,7) ->
    #base_turntable_point_reward{sub_id = 1,id = 7,reward = [{100,102603,1}],limit = 5,points = 7};

turntable_point_reward(2,1) ->
    #base_turntable_point_reward{sub_id = 2,id = 1,reward = [{100,109031,1}],limit = 1,points = 1};

turntable_point_reward(2,2) ->
    #base_turntable_point_reward{sub_id = 2,id = 2,reward = [{100,109001,1}],limit = 1,points = 2};

turntable_point_reward(2,3) ->
    #base_turntable_point_reward{sub_id = 2,id = 3,reward = [{100,109011,1}],limit = 1,points = 3};

turntable_point_reward(2,4) ->
    #base_turntable_point_reward{sub_id = 2,id = 4,reward = [{100,102404,1}],limit = 2,points = 4};

turntable_point_reward(2,5) ->
    #base_turntable_point_reward{sub_id = 2,id = 5,reward = [{100,109021,1}],limit = 2,points = 5};

turntable_point_reward(2,6) ->
    #base_turntable_point_reward{sub_id = 2,id = 6,reward = [{100,102000,1}],limit = 5,points = 6};

turntable_point_reward(2,7) ->
    #base_turntable_point_reward{sub_id = 2,id = 7,reward = [{100,102603,1}],limit = 5,points = 7};

turntable_point_reward(_Subid,_Id) ->
    [].


get_point_ids(1) ->
    [1,2,3,4,5,6,7];


get_point_ids(2) ->
    [1,2,3,4,5,6,7];

get_point_ids(_Subid) ->
    [].

turntable_reward_cfg(1,1) ->
    #base_turntable_reward{sub_id = 1,id = 1,reward = [{100,102408,1}],weights = 1,is_tv = 1,tag = 6};

turntable_reward_cfg(1,2) ->
    #base_turntable_reward{sub_id = 1,id = 2,reward = [{100,102407,1}],weights = 500,is_tv = 1,tag = 0};

turntable_reward_cfg(1,3) ->
    #base_turntable_reward{sub_id = 1,id = 3,reward = [{100,102306,1}],weights = 100,is_tv = 0,tag = 0};

turntable_reward_cfg(1,4) ->
    #base_turntable_reward{sub_id = 1,id = 4,reward = [{100,250106,3}],weights = 100,is_tv = 0,tag = 0};

turntable_reward_cfg(1,5) ->
    #base_turntable_reward{sub_id = 1,id = 5,reward = [{100,109003,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(1,6) ->
    #base_turntable_reward{sub_id = 1,id = 6,reward = [{100,109023,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(1,7) ->
    #base_turntable_reward{sub_id = 1,id = 7,reward = [{100,109013,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(1,8) ->
    #base_turntable_reward{sub_id = 1,id = 8,reward = [{100,109002,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(1,9) ->
    #base_turntable_reward{sub_id = 1,id = 9,reward = [{100,109022,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(1,10) ->
    #base_turntable_reward{sub_id = 1,id = 10,reward = [{100,109012,1}],weights = 100,is_tv = 0,tag = 0};

turntable_reward_cfg(2,1) ->
    #base_turntable_reward{sub_id = 2,id = 1,reward = [{100,102408,1}],weights = 50,is_tv = 1,tag = 6};

turntable_reward_cfg(2,2) ->
    #base_turntable_reward{sub_id = 2,id = 2,reward = [{100,102407,1}],weights = 100,is_tv = 1,tag = 1};

turntable_reward_cfg(2,3) ->
    #base_turntable_reward{sub_id = 2,id = 3,reward = [{100,102306,1}],weights = 100,is_tv = 1,tag = 2};

turntable_reward_cfg(2,4) ->
    #base_turntable_reward{sub_id = 2,id = 4,reward = [{100,250106,3}],weights = 100,is_tv = 1,tag = 3};

turntable_reward_cfg(2,5) ->
    #base_turntable_reward{sub_id = 2,id = 5,reward = [{100,109003,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(2,6) ->
    #base_turntable_reward{sub_id = 2,id = 6,reward = [{100,109023,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(2,7) ->
    #base_turntable_reward{sub_id = 2,id = 7,reward = [{100,109013,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(2,8) ->
    #base_turntable_reward{sub_id = 2,id = 8,reward = [{100,109002,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(2,9) ->
    #base_turntable_reward{sub_id = 2,id = 9,reward = [{100,109022,1}],weights = 200,is_tv = 0,tag = 0};

turntable_reward_cfg(2,10) ->
    #base_turntable_reward{sub_id = 2,id = 10,reward = [{100,109012,1}],weights = 500,is_tv = 0,tag = 0};

turntable_reward_cfg(_Subid,_Id) ->
    [].


get_pool_ids(1) ->
    [1,2,3,4,5,6,7,8,9,10];


get_pool_ids(2) ->
    [1,2,3,4,5,6,7,8,9,10];

get_pool_ids(_Subid) ->
    [].


get_pool_weight(1) ->
    [{1,1},{500,2},{100,3},{100,4},{200,5},{200,6},{200,7},{200,8},{200,9},{100,10}];


get_pool_weight(2) ->
    [{50,1},{100,2},{100,3},{100,4},{200,5},{200,6},{200,7},{200,8},{200,9},{500,10}];

get_pool_weight(_Subid) ->
    [].


get_pool_whit_tag(1) ->
    [{6,1,1},{0,500,2},{0,100,3},{0,100,4},{0,200,5},{0,200,6},{0,200,7},{0,200,8},{0,200,9},{0,100,10}];


get_pool_whit_tag(2) ->
    [{6,50,1},{1,100,2},{2,100,3},{3,100,4},{0,200,5},{0,200,6},{0,200,7},{0,200,8},{0,200,9},{0,500,10}];

get_pool_whit_tag(_Subid) ->
    [].

