%%%---------------------------------------
%%% module      : data_void_fam
%%% description : 无尽领域配置
%%%
%%%---------------------------------------
-module(data_void_fam).
-compile(export_all).
-include("void_fam.hrl").




get_cfg(need_role_lv) ->
    96;


get_cfg(kill_player_score) ->
    30;


get_cfg(kill_mon_score) ->
    15;


get_cfg(reward_preview) ->
    [{2,100001,1},{100,450023,1},{100,109022,1},{100,102603,1}];


get_cfg(pass_exit_count_down) ->
    10;


get_cfg(interval_add) ->
    10;


get_cfg(max_rank) ->
    99;


get_cfg(interval_score) ->
    [{1,5},{2,10},{3,12},{4,15},{5,18},{6,20},{7,24},{8,25},{9,30}];


get_cfg(interval_drop) ->
    [{1,180},{2,180},{3,180},{4,180},{5,180}];


get_cfg(low_drop) ->
    {15010001,4,[{9748,5939},{9469,6332},{9083,6049},{9357,5669}]};


get_cfg(normal_drop) ->
    {15010002,0,[{13900,8022}]};


get_cfg(high_drop) ->
    {15010003,1,[{9413,6004}]};


get_cfg(max_zone) ->
    2;


get_cfg(first_refresh_zone_time) ->
    60;


get_cfg(refresh_zone_time) ->
    3600;


get_cfg(delay_out) ->
    12;

get_cfg(_Key) ->
    [].

get_floor_cfg(1) ->
    #void_fam_floor_cfg{floor = 1,scene = 7100,kf_scene = 7110,nkill = 1,reward = [{100,102000,1},{100,102603,1},{100,109031,1}],drate = 0};

get_floor_cfg(2) ->
    #void_fam_floor_cfg{floor = 2,scene = 7101,kf_scene = 7111,nkill = 2,reward = [{100,102000,1},{100,102603,2},{100,109031,1}],drate = 100};

get_floor_cfg(3) ->
    #void_fam_floor_cfg{floor = 3,scene = 7102,kf_scene = 7112,nkill = 3,reward = [{100,102000,1},{100,102603,2},{100,109031,1}],drate = 100};

get_floor_cfg(4) ->
    #void_fam_floor_cfg{floor = 4,scene = 7103,kf_scene = 7113,nkill = 4,reward = [{2,100001,15},{100,450023,2},{100,109031,1}],drate = 0};

get_floor_cfg(5) ->
    #void_fam_floor_cfg{floor = 5,scene = 7104,kf_scene = 7114,nkill = 5,reward = [{100,102000,2},{100,102603,3},{100,109032,1}],drate = 120};

get_floor_cfg(6) ->
    #void_fam_floor_cfg{floor = 6,scene = 7105,kf_scene = 7115,nkill = 7,reward = [{100,102000,2},{100,450023,1},{100,109032,1}],drate = 120};

get_floor_cfg(7) ->
    #void_fam_floor_cfg{floor = 7,scene = 7106,kf_scene = 7116,nkill = 9,reward = [{100,102000,2},{100,450023,1},{100,109032,1}],drate = 120};

get_floor_cfg(8) ->
    #void_fam_floor_cfg{floor = 8,scene = 7107,kf_scene = 7117,nkill = 11,reward = [{100,102000,3},{100,450023,2},{100,109033,1}],drate = 0};

get_floor_cfg(9) ->
    #void_fam_floor_cfg{floor = 9,scene = 7108,kf_scene = 7118,nkill = 12,reward = [{100,102000,3},{100,450023,2},{100,109033,1}],drate = 150};

get_floor_cfg(_Floor) ->
    [].

get_all_floor() ->
    [9,8,7,6,5,4,3,2,1].

get_scene() ->
    [7100,7101,7102,7103,7104,7105,7106,7107,7108].

get_kf_scene() ->
    [7110,7111,7112,7113,7114,7115,7116,7117,7118].


get_floor(7100) ->
    1;


get_floor(7101) ->
    2;


get_floor(7102) ->
    3;


get_floor(7103) ->
    4;


get_floor(7104) ->
    5;


get_floor(7105) ->
    6;


get_floor(7106) ->
    7;


get_floor(7107) ->
    8;


get_floor(7108) ->
    9;

get_floor(_Scene) ->
    0.


get_kf_floor(7110) ->
    1;


get_kf_floor(7111) ->
    2;


get_kf_floor(7112) ->
    3;


get_kf_floor(7113) ->
    4;


get_kf_floor(7114) ->
    5;


get_kf_floor(7115) ->
    6;


get_kf_floor(7116) ->
    7;


get_kf_floor(7117) ->
    8;


get_kf_floor(7118) ->
    9;

get_kf_floor(_Kfscene) ->
    0.


get_pass_reward(1) ->
    [{100,450023,2},{100,109033,1}];


get_pass_reward(2) ->
    [{100,450023,2},{100,109032,1}];


get_pass_reward(3) ->
    [{100,450023,1},{100,109032,1}];

get_pass_reward(_Id) ->
    [].

get_pass_max() -> 3.

get_stage_award(Score) when Score =< 999, Score >= 300 ->
		[1,[{2,100001,2},{100,102000,2},{100,109001,1}]];
get_stage_award(Score) when Score =< 2499, Score >= 1000 ->
		[2,[{2,100001,3},{100,102603,2},{100,109011,1}]];
get_stage_award(Score) when Score =< 4999, Score >= 2500 ->
		[3,[{2,100001,5},{100,102000,3},{100,109021,1}]];
get_stage_award(Score) when Score =< 9999, Score >= 5000 ->
		[4,[{2,100001,5},{100,102603,2},{100,109001,1}]];
get_stage_award(_Score) ->
    [0,[]].

get_rank_award(Rank) when Rank =< 1, Rank >= 1 ->
		[{17,431005,1},{2,100001,20},{100,450023,2},{100,109022,1},{100,102603,2}];
get_rank_award(Rank) when Rank =< 2, Rank >= 2 ->
		[{2,100001,15},{100,450023,1},{100,109002,1},{100,102603,2}];
get_rank_award(Rank) when Rank =< 3, Rank >= 3 ->
		[{2,100001,10},{100,450023,1},{100,109002,1},{100,102603,2}];
get_rank_award(Rank) when Rank =< 10, Rank >= 4 ->
		[{2,100001,10},{100,102603,2},{100,109002,1}];
get_rank_award(Rank) when Rank =< 99, Rank >= 11 ->
		[{2,100001,10},{100,102603,1},{100,109002,1}];
get_rank_award(_Rank) ->
    [].

