%%%---------------------------------------
%%% module      : data_wasteland_war
%%% description : 废土战场配置
%%%
%%%---------------------------------------
-module(data_wasteland_war).
-compile(export_all).
-include("wasteland_war.hrl").




get_kv_cfg(crystal_update) ->
    60;


get_kv_cfg(crystal_num) ->
    3;


get_kv_cfg(crystal_id) ->
    11001;


get_kv_cfg(crystal_kill_grade) ->
    15;


get_kv_cfg(crystal_assist_grade) ->
    5;


get_kv_cfg(people_assist_grade) ->
    10;


get_kv_cfg(stage_time) ->
    [{1,300},{2,900}];


get_kv_cfg(rank_num) ->
    50;


get_kv_cfg(shutdown) ->
    3;


get_kv_cfg(people_kill_grade) ->
    30;

get_kv_cfg(_Key) ->
    [].

get_score_reward(Score) when Score >= 3200 ->
		[{100,102000,3},{100,450023,2},{100,109033,1}];
get_score_reward(Score) when Score >= 1900 ->
		[{100,102000,3},{100,450023,2},{100,109033,1}];
get_score_reward(Score) when Score >= 1300 ->
		[{2,100001,20},{100,102000,2},{100,109032,1}];
get_score_reward(Score) when Score >= 1000 ->
		[{100,102000,2},{100,450023,1},{100,109032,1}];
get_score_reward(Score) when Score >= 800 ->
		[{100,102000,2},{100,102603,3},{100,109032,1}];
get_score_reward(Score) when Score >= 500 ->
		[{2,100001,15},{100,450023,2},{100,109031,1}];
get_score_reward(Score) when Score >= 300 ->
		[{100,102000,1},{100,102603,2},{100,109031,1}];
get_score_reward(Score) when Score >= 100 ->
		[{100,102000,1},{100,102603,2},{100,109031,1}];
get_score_reward(Score) when Score >= 30 ->
		[{100,102000,1},{100,102603,1},{100,109031,1}];
get_score_reward(_Score) ->
    [].

get_score_reward_cfg(Score) when Score >= 3200 ->
	#wasteland_score_reward_cfg{need_score=3200,reward=[{100,102000,3},{100,450023,2},{100,109033,1}]};
get_score_reward_cfg(Score) when Score >= 1900 ->
	#wasteland_score_reward_cfg{need_score=1900,reward=[{100,102000,3},{100,450023,2},{100,109033,1}]};
get_score_reward_cfg(Score) when Score >= 1300 ->
	#wasteland_score_reward_cfg{need_score=1300,reward=[{2,100001,20},{100,102000,2},{100,109032,1}]};
get_score_reward_cfg(Score) when Score >= 1000 ->
	#wasteland_score_reward_cfg{need_score=1000,reward=[{100,102000,2},{100,450023,1},{100,109032,1}]};
get_score_reward_cfg(Score) when Score >= 800 ->
	#wasteland_score_reward_cfg{need_score=800,reward=[{100,102000,2},{100,102603,3},{100,109032,1}]};
get_score_reward_cfg(Score) when Score >= 500 ->
	#wasteland_score_reward_cfg{need_score=500,reward=[{2,100001,15},{100,450023,2},{100,109031,1}]};
get_score_reward_cfg(Score) when Score >= 300 ->
	#wasteland_score_reward_cfg{need_score=300,reward=[{100,102000,1},{100,102603,2},{100,109031,1}]};
get_score_reward_cfg(Score) when Score >= 100 ->
	#wasteland_score_reward_cfg{need_score=100,reward=[{100,102000,1},{100,102603,2},{100,109031,1}]};
get_score_reward_cfg(Score) when Score >= 30 ->
	#wasteland_score_reward_cfg{need_score=30,reward=[{100,102000,1},{100,102603,1},{100,109031,1}]};
get_score_reward_cfg(_Score) ->
    [].

get_round_cfg(1) ->
    #wasteland_round_reward_cfg{round = 1,scene = 7600,cls_scene = 7601,duration = 300,max_crystal = 5,max_role = 40,reward = [{2,100001,3},{100,102603,2},{100,109011,1}]};

get_round_cfg(2) ->
    #wasteland_round_reward_cfg{round = 2,scene = 7610,cls_scene = 7611,duration = 300,max_crystal = 5,max_role = 20,reward = [{2,100001,5},{100,102000,3},{100,109021,1}]};

get_round_cfg(3) ->
    #wasteland_round_reward_cfg{round = 3,scene = 7620,cls_scene = 7621,duration = 300,max_crystal = 2,max_role = 4,reward = [{2,100001,5},{100,102603,2},{100,109001,1}]};

get_round_cfg(_Round) ->
    [].

get_all_round() ->
    [1,2,3].

get_all_scene() ->
    [7600,7610,7620].

get_cls_all_scene() ->
    [7601,7611,7621].

get_rank_reward(Rank) when Rank >= 1, Rank =< 1 ->
		[{2,100001,20},{100,450023,2},{100,109022,1},{100,102603,2}];
get_rank_reward(Rank) when Rank >= 2, Rank =< 2 ->
		[{2,100001,15},{100,450023,1},{100,109002,1},{100,102603,2}];
get_rank_reward(Rank) when Rank >= 3, Rank =< 3 ->
		[{2,100001,12},{100,450023,1},{100,109002,1},{100,102603,2}];
get_rank_reward(Rank) when Rank >= 4, Rank =< 8 ->
		[{2,100001,12},{100,102603,2},{100,109002,1}];
get_rank_reward(Rank) when Rank >= 9, Rank =< 20 ->
		[{2,100001,10},{100,102603,2},{100,109002,1}];
get_rank_reward(Rank) when Rank >= 21, Rank =< 50 ->
		[{2,100001,8},{100,102603,1},{100,109002,1}];
get_rank_reward(_Rank) ->
    [].

get_bleed_score_cfg(KillNum) when KillNum >= 50 ->
	#wasteland_bleed_score_cfg{kill_count=50,kill_score=150,over_score=150};
get_bleed_score_cfg(KillNum) when KillNum >= 30 ->
	#wasteland_bleed_score_cfg{kill_count=30,kill_score=120,over_score=120};
get_bleed_score_cfg(KillNum) when KillNum >= 20 ->
	#wasteland_bleed_score_cfg{kill_count=20,kill_score=100,over_score=100};
get_bleed_score_cfg(KillNum) when KillNum >= 10 ->
	#wasteland_bleed_score_cfg{kill_count=10,kill_score=50,over_score=50};
get_bleed_score_cfg(KillNum) when KillNum >= 1 ->
	#wasteland_bleed_score_cfg{kill_count=1,kill_score=5,over_score=5};
get_bleed_score_cfg(_KillNum) ->
    [].

get_pos_list(7600) ->
    #wasteland_select_pos_cfg{scene = 7600,pos_list = [{2945,3559,10},{2965,2950,10},{3577,3548,10},{3601,2936,10},{3251,3252,10}],war_pos_list = [{2176,4630,10},{2462,4654,10},{2768,4651,10},{2900,4807,10},{3091,4950,10},{3421,4967,10},{3582,4818,10},{3810,4641,10},{4133,4627,10},{4432,4637,10},{1856,2304,10},{1850,2552,10},{1826,2780,10},{1680,2926,10},{1564,3086,10},{1531,3396,10},{1671,3570,10},{1823,3753,10},{1823,3964,10},{1830,4216,10},{2203,1788,10},{2461,1795,10},{2770,1809,10},{2964,1640,10},{3131,1515,10},{3423,1525,10},{3576,1664,10},{3739,1800,10},{4025,1824,10},{4338,1827,10},{4663,2443,10},{4666,2657,10},{4676,2858,10},{4839,2967,10},{4982,3103,10},{4982,3399,10},{4826,3579,10},{4683,3714,10},{4676,3949,10},{4666,4187,10}]};

get_pos_list(7601) ->
    #wasteland_select_pos_cfg{scene = 7601,pos_list = [{2945,3559,10},{2965,2950,10},{3577,3548,10},{3601,2936,10},{3251,3252,10}],war_pos_list = [{2176,4630,10},{2462,4654,10},{2768,4651,10},{2900,4807,10},{3091,4950,10},{3421,4967,10},{3582,4818,10},{3810,4641,10},{4133,4627,10},{4432,4637,10},{1856,2304,10},{1850,2552,10},{1826,2780,10},{1680,2926,10},{1564,3086,10},{1531,3396,10},{1671,3570,10},{1823,3753,10},{1823,3964,10},{1830,4216,10},{2203,1788,10},{2461,1795,10},{2770,1809,10},{2964,1640,10},{3131,1515,10},{3423,1525,10},{3576,1664,10},{3739,1800,10},{4025,1824,10},{4338,1827,10},{4663,2443,10},{4666,2657,10},{4676,2858,10},{4839,2967,10},{4982,3103,10},{4982,3399,10},{4826,3579,10},{4683,3714,10},{4676,3949,10},{4666,4187,10}]};

get_pos_list(7610) ->
    #wasteland_select_pos_cfg{scene = 7610,pos_list = [{3298,3570,10},{2982,3254,10},{3315,2916,10},{3605,3262,10},{3294,3267,10}],war_pos_list = [{2390,2752,10},{2233,3264,10},{2347,3769,10},{2823,4196,10},{3300,4324,10},{3826,4160,10},{4210,3733,10},{4338,3250,10},{4146,2695,10},{3790,2354,10},{3293,2212,10},{2795,2340,10},{2745,3037,10},{2738,3506,10},{3086,3797,10},{3577,3797,10},{3890,3506,10},{3876,3129,10},{3605,2774,10},{3072,2759,10}]};

get_pos_list(7611) ->
    #wasteland_select_pos_cfg{scene = 7611,pos_list = [{3298,3570,10},{2982,3254,10},{3315,2916,10},{3605,3262,10},{3294,3267,10}],war_pos_list = [{2390,2752,10},{2233,3264,10},{2347,3769,10},{2823,4196,10},{3300,4324,10},{3826,4160,10},{4210,3733,10},{4338,3250,10},{4146,2695,10},{3790,2354,10},{3293,2212,10},{2795,2340,10},{2745,3037,10},{2738,3506,10},{3086,3797,10},{3577,3797,10},{3890,3506,10},{3876,3129,10},{3605,2774,10},{3072,2759,10}]};

get_pos_list(7620) ->
    #wasteland_select_pos_cfg{scene = 7620,pos_list = [{3245,3501,10},{2996,3246,10},{3493,3243,10},{3255,3002,10}],war_pos_list = [{3250,3891,10},{2593,3303,10},{3271,2594,10},{3901,3282,10}]};

get_pos_list(7621) ->
    #wasteland_select_pos_cfg{scene = 7621,pos_list = [{3245,3501,10},{2996,3246,10},{3493,3243,10},{3255,3002,10}],war_pos_list = [{3250,3891,10},{2593,3303,10},{3271,2594,10},{3901,3282,10}]};

get_pos_list(7630) ->
    #wasteland_select_pos_cfg{scene = 7630,pos_list = [{3248,3067,800}],war_pos_list = []};

get_pos_list(7631) ->
    #wasteland_select_pos_cfg{scene = 7631,pos_list = [{3248,3067,800}],war_pos_list = []};

get_pos_list(_Scene) ->
    [].

