%% ---------------------------------------------------------------------------
%% @doc 服务器分区配置
%% @author hek
%% @since  2018-4-28
%% @deprecated 本模块用于配置服务器分区的一些常用数据
%% ---------------------------------------------------------------------------

-module(data_clusters_zone).
-include("common.hrl").
-include("clusters_zone.hrl").
-include("def_module.hrl").
-include("custom_act.hrl").
-export([
    get_zone_max_server_num/1,  %% 获取各分区类型对应的服务器数量
    get_zone_type/1,            %% 功能对应分区类型配置
    get_zone_type/2             %% 功能对应分区类型配置
]).

%% 获取各分区类型对应的服务器数量
get_zone_max_server_num(?SMALL_ZONE_TYPE) -> 5;     %% 小型分区
get_zone_max_server_num(?MEDIUM_ZONE_TYPE) -> 10;   %% 中型分区
get_zone_max_server_num(?LARGE_ZONE_TYPE) -> 20;    %% 大型分区
get_zone_max_server_num(ZoneType) ->                %% 容错
    ?ERR("unkown zone_type:~p~n", [ZoneType]),
    10.

%%% Usage:
%%% 新增功能分区类型步骤
%%% 1. get_zone_type/1中配置module_id对应的zone_type
%%% 3. 新增获取功能分区id的接口，如get_eudemons_zone/1
%%% End.
%% 功能对应分区类型配置
get_zone_type(ModuleId) ->
    get_zone_type(ModuleId, 0).

get_zone_type(?MOD_SCENE, ?MOD_SCENE_LINE) -> ?MEDIUM_ZONE_TYPE;
get_zone_type(ModuleId, SubModuleId) ->
    ?ERR("unkown module_id:~p,~p~n", [ModuleId,SubModuleId]),
    ?MEDIUM_ZONE_TYPE.


