%%-----------------------------------------------------------------------------
%% @Module  :       data_role_name.erl
%% @Author  :       J
%% @Email   :       j-som@foxmail.com
%% @Created :       2018-02-07
%% @Description:    名字库
%%-----------------------------------------------------------------------------
-module (data_role_name).
-export ([
    last_name_list/1,
    first_name_list/2,
    get_all_group/0,
    get_guild_helper_name/0
    ]).

%% 根据组别和性别获取姓
-spec last_name_list(Group) -> Ret when
    Group :: integer(),
    Ret   :: list().
last_name_list(1) ->
    [
    "安藤",
"安田",
"奥村",
"百里",
"坂本",
"包",
"北村",
"贝",
"本间",
"毕",
"滨田",
"蔡",
"曹",
"柴田",
"昌",
"常",
"陈",
"成",
"成田",
"川村",
"川岛",
"川口",
"川崎",
"川上",
"村上",
"村田",
"大岛",
"大谷",
"大桥",
"大森",
"大石",
"大西",
"大野",
"单",
"岛田",
"邓",
"狄",
"丁",
"东方",
"东郭",
"东门",
"董",
"杜",
"渡边",
"端木",
"樊",
"饭田",
"范",
"方",
"房",
"费",
"冯",
"凤",
"服部",
"福岛",
"福井",
"福田",
"傅",
"富田",
"干",
"冈本",
"冈崎",
"冈田",
"高木",
"高桥",
"高山",
"高田",
"高野",
"葛",
"工藤",
"公良",
"公孙",
"公西",
"公冶",
"宫本",
"宫崎",
"宫田",
"谷口",
"顾",
"管",
"广濑",
"归海",
"郭",
"韩",
"杭",
"何",
"和",
"和田",
"河野",
"贺",
"黑田",
"横山",
"横田",
"洪",
"后藤",
"呼延",
"胡",
"花",
"华",
"荒井",
"荒木",
"皇甫",
"黄",
"吉川",
"吉村",
"吉冈",
"吉田",
"纪",
"季",
"加藤",
"夹谷",
"贾",
"菅野",
"菅原",
"江",
"姜",
"解",
"今井",
"近藤",
"经",
"井上",
"久保",
"久保",
"酒井",
"菊池",
"康",
"柯",
"孔",
"蓝",
"郎",
"乐正",
"雷",
"李",
"栗原",
"梁",
"梁丘",
"林",
"林",
"铃木",
"凌",
"令狐",
"柳",
"娄",
"卢",
"鲁",
"罗",
"吕",
"麻",
"马",
"茅",
"梅",
"孟",
"米",
"苗",
"明",
"莫",
"木村",
"木下",
"慕容",
"穆",
"南门",
"内藤",
"内田",
"欧阳",
"潘",
"庞",
"彭",
"皮",
"片山",
"平",
"平井",
"平田",
"平野",
"齐",
"千叶",
"前田",
"钱",
"浅野",
"桥本",
"秦",
"青木",
"清水",
"邱",
"秋山",
"屈",
"任",
"阮",
"三浦",
"三宅",
"森",
"森本",
"森田",
"山本",
"山内",
"山崎",
"山田",
"山下",
"山中",
"杉山",
"上官",
"上田",
"上野",
"邵",
"沈",
"盛",
"施",
"石川",
"石井",
"石桥",
"石田",
"石原",
"时",
"史",
"舒",
"水",
"水野",
"司空",
"司徒",
"松本",
"松村",
"松冈",
"松井",
"松浦",
"松田",
"松尾",
"松下",
"松原",
"宋",
"苏",
"孙",
"太田",
"汤",
"唐",
"陶",
"藤本",
"藤峰",
"藤井",
"藤田",
"藤原",
"田",
"田边",
"田村",
"田口",
"童",
"土屋",
"丸山",
"万",
"汪",
"王",
"望月",
"微生",
"韦",
"尾崎",
"卫",
"尉迟",
"魏",
"吴",
"武田",
"西川",
"西村",
"西门",
"西山",
"西田",
"席",
"夏",
"夏侯",
"项",
"萧",
"小川",
"小岛",
"小林",
"小山",
"小松",
"小田",
"小西",
"小野",
"小泽",
"谢",
"新井",
"星野",
"熊",
"熊谷",
"徐",
"许",
"轩辕",
"宣",
"薛",
"严",
"岩本",
"岩崎",
"岩田",
"颜",
"姚",
"野村",
"野口",
"野田",
"伊东",
"伊藤",
"殷",
"尹",
"樱井",
"应",
"永井",
"永田",
"有琴",
"于",
"俞",
"宇文",
"喻",
"袁",
"原田",
"远藤",
"云",
"早川",
"泽田",
"增田",
"斋藤",
"张",
"章",
"长孙",
"赵",
"郑",
"支",
"中川",
"中村",
"中岛",
"中山",
"中田",
"中西",
"中野",
"钟",
"钟离",
"仲孙",
"周",
"诸葛",
"竹内",
"祝",
"宗",
"宗政",
"左",
"左丘",
"佐藤",
"佐野"
    ];
last_name_list(2) ->
    [
    ""
    ];
last_name_list(3) ->
    [
    "白衣",
"白衣",
"白衣、",
"白衣、",
"白衣＋",
"白衣＋",
"白衣↗",
"白衣↗",
"白衣★",
"白衣★",
"白衣de",
"白衣de",
"白衣о",
"白衣о",
"白衣の",
"白衣の",
"白衣ミ",
"白衣ミ",
"白衣メ",
"白衣メ",
"白衣メ",
"白衣メ",
"白衣的",
"白衣的",
"白衣的",
"白衣灬",
"白衣灬",
"半边",
"半边、",
"半边＋",
"半边★",
"半边de",
"半边о",
"半边の",
"半边ミ",
"半边メ",
"半边的",
"半边灬",
"半邊↗",
"半邊メ",
"薄暮",
"薄暮、",
"薄暮＋",
"薄暮↗",
"薄暮★",
"薄暮de",
"薄暮о",
"薄暮の",
"薄暮ミ",
"薄暮メ",
"薄暮メ",
"薄暮的",
"薄暮灬",
"本宫",
"本宫、",
"本宫＋",
"本宫★",
"本宫de",
"本宫о",
"本宫の",
"本宫ミ",
"本宫メ",
"本宫的",
"本宫灬",
"夲宫↗",
"夲宫メ",
"夲宫的",
"不笑猫",
"东京",
"东京、",
"东京＋",
"东京↗",
"东京★",
"东京de",
"东京о",
"东京の",
"东京ミ",
"东京メ",
"东京メ",
"东京的",
"东京的",
"东京灬",
"独尊",
"独尊、",
"独尊＋",
"独尊★",
"独尊de",
"独尊о",
"独尊の",
"独尊ミ",
"独尊メ",
"独尊的",
"独尊灬",
"獨尊↗",
"獨尊メ",
"獨尊的",
"芳华",
"芳华、",
"芳华＋",
"芳华↗",
"芳华★",
"芳华de",
"芳华о",
"芳华の",
"芳华ミ",
"芳华メ",
"芳华メ",
"芳华的",
"芳华的",
"芳华灬",
"纷舞",
"纷舞、",
"纷舞＋",
"纷舞↗",
"纷舞★",
"纷舞de",
"纷舞о",
"纷舞の",
"纷舞ミ",
"纷舞メ",
"纷舞メ",
"纷舞的",
"纷舞的",
"纷舞灬",
"怪味",
"怪味、",
"怪味＋",
"怪味↗",
"怪味★",
"怪味de",
"怪味о",
"怪味の",
"怪味ミ",
"怪味メ",
"怪味メ",
"怪味的",
"怪味灬",
"花、",
"花＋",
"花↗",
"花★",
"花de",
"花о",
"花の",
"花ミ",
"花メ",
"花メ",
"花灬",
"花谢",
"花谢、",
"花谢＋",
"花谢★",
"花谢de",
"花谢о",
"花谢の",
"花谢ミ",
"花谢メ",
"花谢的",
"花谢灬",
"花謝↗",
"花謝メ",
"娇软",
"娇软、",
"娇软＋",
"娇软↗",
"娇软★",
"娇软de",
"娇软о",
"娇软の",
"娇软ミ",
"娇软メ",
"娇软メ",
"娇软的",
"娇软灬",
"久往",
"久往、",
"久往＋",
"久往↗",
"久往★",
"久往de",
"久往о",
"久往の",
"久往ミ",
"久往メ",
"久往メ",
"久往的",
"久往灬",
"蓝莓",
"蓝莓、",
"蓝莓＋",
"蓝莓↗",
"蓝莓★",
"蓝莓de",
"蓝莓о",
"蓝莓の",
"蓝莓ミ",
"蓝莓メ",
"蓝莓メ",
"蓝莓的",
"蓝莓的",
"蓝莓灬",
"蓝天",
"蓝天、",
"蓝天＋",
"蓝天↗",
"蓝天★",
"蓝天de",
"蓝天о",
"蓝天の",
"蓝天ミ",
"蓝天メ",
"蓝天メ",
"蓝天的",
"蓝天的",
"蓝天灬",
"凉薄",
"凉薄、",
"凉薄＋",
"凉薄↗",
"凉薄★",
"凉薄de",
"凉薄о",
"凉薄の",
"凉薄ミ",
"凉薄メ",
"凉薄メ",
"凉薄的",
"凉薄灬",
"喵小呆",
"木有牙",
"南风",
"南风、",
"南风＋",
"南风↗",
"南风★",
"南风de",
"南风о",
"南风の",
"南风ミ",
"南风メ",
"南风メ",
"南风的",
"南风灬",
"南幕",
"南幕、",
"南幕＋",
"南幕↗",
"南幕★",
"南幕de",
"南幕о",
"南幕の",
"南幕ミ",
"南幕メ",
"南幕メ",
"南幕的",
"南幕灬",
"你、",
"你＋",
"你↗",
"你★",
"你de",
"你о",
"你の",
"你ミ",
"你メ",
"你メ",
"你灬",
"柠檬色",
"前、",
"前＋",
"前↗",
"前★",
"前de",
"前о",
"前の",
"前ミ",
"前メ",
"前メ",
"前灬",
"若雪",
"若雪、",
"若雪＋",
"若雪↗",
"若雪★",
"若雪de",
"若雪о",
"若雪の",
"若雪ミ",
"若雪メ",
"若雪メ",
"若雪的",
"若雪灬",
"撒娇",
"撒娇、",
"撒娇＋",
"撒娇↗",
"撒娇★",
"撒娇de",
"撒娇о",
"撒娇の",
"撒娇ミ",
"撒娇メ",
"撒娇メ",
"撒娇的",
"撒娇的",
"撒娇灬",
"傻呆呆",
"神圣",
"神圣、",
"神圣＋",
"神圣★",
"神圣de",
"神圣о",
"神圣の",
"神圣ミ",
"神圣メ",
"神圣的",
"神圣灬",
"鉮聖↗",
"鉮聖メ",
"鉮聖的",
"史迪仔",
"水、",
"水＋",
"水↗",
"水★",
"水de",
"水о",
"水の",
"水ミ",
"水メ",
"水メ",
"水灬",
"兎耳↗",
"兎耳メ",
"兔耳",
"兔耳、",
"兔耳＋",
"兔耳★",
"兔耳de",
"兔耳о",
"兔耳の",
"兔耳ミ",
"兔耳メ",
"兔耳的",
"兔耳灬",
"哇咔咔",
"玩网",
"玩网、",
"玩网＋",
"玩网↗",
"玩网★",
"玩网de",
"玩网о",
"玩网の",
"玩网ミ",
"玩网メ",
"玩网メ",
"玩网的",
"玩网的",
"玩网灬",
"王者",
"王者、",
"王者＋",
"王者↗",
"王者★",
"王者de",
"王者о",
"王者の",
"王者ミ",
"王者メ",
"王者メ",
"王者的",
"王者的",
"王者灬",
"夏末",
"夏末、",
"夏末＋",
"夏末↗",
"夏末★",
"夏末de",
"夏末о",
"夏末の",
"夏末ミ",
"夏末メ",
"夏末メ",
"夏末的",
"夏末灬",
"仙女味",
"潇洒",
"潇洒、",
"潇洒＋",
"潇洒↗",
"潇洒★",
"潇洒de",
"潇洒о",
"潇洒の",
"潇洒ミ",
"潇洒メ",
"潇洒メ",
"潇洒的",
"潇洒的",
"潇洒灬",
"小脾气",
"小七",
"小七、",
"小七＋",
"小七↗",
"小七★",
"小七de",
"小七о",
"小七の",
"小七ミ",
"小七メ",
"小七メ",
"小七的",
"小七灬",
"邂逅",
"邂逅、",
"邂逅＋",
"邂逅↗",
"邂逅★",
"邂逅de",
"邂逅о",
"邂逅の",
"邂逅ミ",
"邂逅メ",
"邂逅メ",
"邂逅的",
"邂逅灬",
"心机",
"心机、",
"心机＋",
"心机↗",
"心机★",
"心机de",
"心机о",
"心机の",
"心机ミ",
"心机メ",
"心机メ",
"心机的",
"心机灬",
"氧气",
"氧气、",
"氧气＋",
"氧气↗",
"氧气★",
"氧气de",
"氧气о",
"氧气の",
"氧气ミ",
"氧气メ",
"氧气メ",
"氧气的",
"氧气灬",
"依恋",
"依恋、",
"依恋＋",
"依恋↗",
"依恋★",
"依恋de",
"依恋о",
"依恋の",
"依恋ミ",
"依恋メ",
"依恋メ",
"依恋的",
"依恋的",
"依恋灬",
"中二",
"中二、",
"中二＋",
"中二↗",
"中二★",
"中二de",
"中二о",
"中二の",
"中二ミ",
"中二メ",
"中二メ",
"中二的",
"中二灬",
"种花",
"种花、",
"种花＋",
"种花↗",
"种花★",
"种花de",
"种花о",
"种花の",
"种花ミ",
"种花メ",
"种花メ",
"种花的",
"种花的",
"种花灬",
"紫樱",
"紫樱、",
"紫樱＋",
"紫樱↗",
"紫樱★",
"紫樱de",
"紫樱о",
"紫樱の",
"紫樱ミ",
"紫樱メ",
"紫樱メ",
"紫樱的",
"紫樱灬",
"最萌",
"最萌、",
"最萌＋",
"最萌↗",
"最萌★",
"最萌de",
"最萌о",
"最萌の",
"最萌ミ",
"最萌メ",
"最萌メ",
"最萌的",
"最萌灬"
    ].

%% 根据组别和性别获取名
-spec first_name_list(Group, Sex) -> Ret when
    Group :: integer(),     %% 组别
    Sex   :: integer(),     %% 性别
    Ret   :: list().        %% 名字库
first_name_list(1, 1) ->
    [
    "安国",
"安顺",
"宾白",
"宾实",
"彬彬",
"彬栋",
"彬幸",
"彬轩",
"冰铭",
"冰毅",
"冰悦",
"博厚",
"博文",
"博喜",
"博锌",
"博延",
"才良",
"才哲",
"曾琪",
"昌翰",
"昌茂",
"昌勇",
"昌宇",
"辰茹",
"辰阳",
"晨冰",
"晨博",
"晨成",
"晨毅",
"晨泽",
"成济",
"成天",
"诚明",
"承安",
"承基",
"承宣",
"承洋",
"承载",
"程磊",
"德冠",
"德欢",
"德辉",
"德馨",
"德尧",
"登颢",
"迪华",
"东冰",
"东杰",
"东斓",
"东沛",
"东世",
"东效",
"东瑜",
"东媛",
"范明",
"飞昂",
"飞沉",
"飞航",
"飞虎",
"飞鹏",
"飞翔",
"飞扬",
"飞英",
"飞舟",
"刚豪",
"高澹",
"高格",
"高翰",
"高丽",
"高兴",
"高轩",
"高懿",
"功彦",
"冠宇",
"光康",
"光亮",
"光誉",
"光远",
"贵依",
"海琦",
"涵畅",
"涵魁",
"寒韵",
"翰池",
"翰藻",
"瀚海",
"豪冰",
"豪初",
"豪杰",
"豪琳",
"豪平",
"豪天",
"豪祥",
"昊嘉",
"浩博",
"浩恩",
"浩歌",
"浩瀚",
"浩航",
"浩慨",
"浩澜",
"浩漫",
"浩淼",
"浩邈",
"浩鸣",
"浩润",
"浩霞",
"浩晔",
"皓枫",
"皓轩",
"灏宇",
"和风",
"和洽",
"和悌",
"和裕",
"和泽",
"和志",
"鹤怡",
"鹤毅",
"亨柠",
"弘博",
"弘诚",
"弘阔",
"弘庆",
"弘文",
"宏伯",
"宏籍",
"宏阔",
"宏邈",
"宏爽",
"宏硕",
"宏远",
"鸿风",
"鸿树",
"鸿羲",
"鸿毓",
"鸿运",
"鸿哲",
"鸿振",
"鸿志",
"鸿卓",
"华辉",
"华清",
"积远",
"吉星",
"嘉晨",
"嘉赐",
"嘉虹",
"嘉荣",
"嘉树",
"嘉澍",
"嘉祥",
"嘉勋",
"嘉誉",
"嘉志",
"嘉志",
"稼宜",
"骞信",
"骞泽",
"建德",
"建锋",
"建茗",
"建木",
"建轩",
"建义",
"建元",
"建中",
"健恒",
"鉴清",
"杰华",
"杰椒",
"堇宾",
"经亘",
"经略",
"经纬",
"经艺",
"景澄",
"景浩",
"景铄",
"景天",
"景同",
"景曜",
"景中",
"景子",
"军宸",
"君昊",
"君浩",
"君毅",
"君元",
"君知",
"钧翔",
"俊德",
"俊恩",
"俊晖",
"俊吉",
"俊健",
"俊杰",
"俊名",
"俊明",
"俊人",
"俊欣",
"俊誉",
"俊远",
"俊哲",
"骏奇",
"开济",
"开霁",
"凯复",
"凯乐",
"凯泽",
"康安",
"康适",
"康顺",
"昆鹏",
"昆琦",
"朗宸",
"乐成",
"乐池",
"乐人",
"乐山",
"乐学",
"乐咏",
"乐正",
"乐志",
"礼程",
"理群",
"力菡",
"力言",
"立坤",
"利综",
"良奥",
"良翰",
"良骏",
"凌安",
"令羽",
"令志",
"令梓",
"茂材",
"茂德",
"明诚",
"明达",
"明德",
"明俊",
"明亮",
"明寿",
"明宇",
"明志",
"明珠",
"铭桉",
"铭晨",
"铭海",
"铭帅",
"铭祥",
"铭校",
"铭心",
"铭泽",
"慕富",
"乃澳",
"宁含",
"彭湃",
"彭越",
"彭泽",
"鹏程",
"鹏池",
"鹏天",
"鹏煊",
"璞玉",
"濮铭",
"奇玮",
"奇希",
"棋羽",
"祺然",
"祺瑞",
"祺祥",
"秋昊",
"秋恒",
"仁道",
"茹铭",
"锐志",
"锐智",
"瑞亭",
"瑞迅",
"睿诚",
"睿好",
"睿昊",
"睿业",
"绍元",
"胜晨",
"胜卿",
"晟昊",
"晟睿",
"世阳",
"思博",
"思行",
"思润",
"思源",
"斯年",
"泰河",
"涛诚",
"天成",
"天翰",
"天豪",
"天骄",
"天晓",
"天逸",
"天宇",
"巍昂",
"为嘉",
"维铭",
"伟懋",
"伟祺",
"伟毅",
"玮琪",
"玮天",
"玮彤",
"玮宇",
"温纶",
"温瑜",
"文昂",
"文斌",
"文岛",
"文栋",
"文赋",
"文翰",
"文林",
"文泰",
"文轩",
"文曜",
"文元",
"武桓",
"希明",
"祥东",
"祥冬",
"祥海",
"祥晴",
"祥孝",
"向笛",
"晓博",
"晓睿",
"晓顼",
"昕仁",
"欣德",
"欣嘉",
"欣怿",
"新翰",
"鑫鹏",
"信鸿",
"信瑞",
"星驰",
"星华",
"星鹏",
"星睿",
"星腾",
"星雨",
"星渊",
"星洲",
"兴安",
"兴昌",
"兴平",
"兴腾",
"兴贤",
"兴学",
"修德",
"修竹",
"戌东",
"旭泰",
"旭扬",
"学林",
"雪宪",
"雅君",
"妍以",
"岩宇",
"颜音",
"阳波",
"阳棋",
"阳云",
"阳泽",
"曜瑞",
"烨铭",
"烨然",
"烨烁",
"烨煜",
"烨昀",
"一庆",
"依祥",
"宜然",
"忆旭",
"亦民",
"意智",
"熠彤",
"懿浩",
"胤骞",
"英豪",
"英杰",
"英锐",
"英睿",
"英武",
"英卓",
"颖山",
"影金",
"永春",
"永嘉",
"永康",
"永年",
"永寿",
"永思",
"永新",
"永怡",
"永长",
"永贞",
"永卓",
"宇寰",
"宇学",
"宇荫",
"雨广",
"雨华",
"雨松",
"雨星",
"雨星",
"玉宸",
"玉书",
"玉堂",
"玉泽",
"昱火",
"钰泽",
"元白",
"元德",
"元化",
"元嘉",
"元驹",
"元正",
"元洲",
"远年",
"苑柏",
"云孜",
"运诚",
"运杰",
"运莱",
"运鹏",
"泽嘉",
"泽祥",
"泽阳",
"泽语",
"展亦",
"章毓",
"长岳",
"哲昌",
"哲瀚",
"振华",
"振链",
"振平",
"震旭",
"正诚",
"正豪",
"正平",
"正文",
"正梧",
"正真",
"祉琛",
"志行",
"志展",
"志专",
"智晖",
"智敏",
"智明",
"忠豪",
"钟校",
"卓君",
"子凌",
"子民",
"子明",
"子墨",
"子南",
"子平",
"子实",
"子希",
"子真",
"梓东",
"梓舒",
"自明",
"自珍",
"棕皓"
     ];
first_name_list(1, 2) ->
    [
    "安海",
"安琳",
"安婷",
"安杏",
"碧蝶",
"彬菡",
"冰芙",
"冰蕊",
"博斐",
"彩玲",
"彩燕",
"姹文",
"琛子",
"辰悦",
"宸旭",
"晨锦",
"晨宜",
"程晨",
"聪羽",
"丛妍",
"翠幻",
"丹凡",
"丹婷",
"东忆",
"冬寄",
"尔彤",
"芳多",
"芳瑞",
"芳婷",
"芳伊",
"飞歆",
"霏晗",
"斐婷",
"风柳",
"枫玟",
"谷凡",
"海丹",
"含函",
"函艺",
"晗斓",
"晗璇",
"涵聪",
"涵骄",
"涵娜",
"涵诺",
"菡娣",
"菡晴",
"菡夏",
"泓月",
"华芬",
"幻莺",
"惠枫",
"惠涵",
"惠桃",
"吉杏",
"季伊",
"佳菲",
"佳妮",
"佳晴",
"佳珊",
"佳彤",
"家蓉",
"嘉菲",
"娇遥",
"姣晶",
"洁玲",
"婕文",
"锦怡",
"晶怡",
"景雯",
"景欣",
"景怡",
"镜媛",
"娟怀",
"君晓",
"珂谩",
"珂琼",
"柯燕",
"可惠",
"可娇",
"可娇",
"岢忆",
"岚潞",
"蓝然",
"澜歆",
"乐翊",
"梨访",
"立芝",
"丽晨",
"丽春",
"丽娇",
"丽悦",
"莉椒",
"莉冉",
"琳君",
"琳悦",
"苓芳",
"苓伊",
"玲雨",
"凌雯",
"璐程",
"璐芳",
"露娜",
"露伊",
"泺瑶",
"曼妮",
"曼思",
"曼芸",
"蔓岚",
"美凌",
"美凝",
"美亿",
"美云",
"萌雅",
"梦秋",
"梦文",
"梦妍",
"梦莹",
"梦韵",
"米思",
"淼玲",
"敏倩",
"敏馨",
"敏瑶",
"明玉",
"娜婉",
"娜羽",
"南嫣",
"倪冉",
"宁流",
"宁蓉",
"凝怡",
"诺绯",
"诺蓝",
"沛梦",
"佩宁",
"佩维",
"佩瑶",
"萍琳",
"棋嘉",
"祺煦",
"绮思",
"倩涵",
"倩雅",
"芹扬",
"芩熙",
"琴桐",
"清涵",
"清慕",
"清妍",
"晴钰",
"琼雯",
"琼云",
"秋莉",
"秋楠",
"冉毓",
"蓉宁",
"如涵",
"茹弈",
"茹奕",
"儒琴",
"蕊谷",
"蕊敏",
"蕊凝",
"蕊丝",
"蕊扬",
"蕊谊",
"睿桐",
"润月",
"若香",
"若雅",
"珊岚",
"诗蓓",
"诗婧",
"诗絮",
"世敏",
"抒慧",
"纾潇",
"姝芳",
"姝涵",
"姝皓",
"姝清",
"姝耘",
"淑迪",
"淑倩",
"淑妤",
"水芩",
"思锦",
"思娅",
"素萍",
"太翰",
"亭萱",
"亭瑛",
"婷君",
"婷琳",
"婷蓉",
"婷茹",
"彤茜",
"彤姗",
"婉梦",
"婉漾",
"婉颖",
"婉玉",
"琬茹",
"薇小",
"炜雪",
"文栎",
"文萍",
"文湘",
"文怡",
"文筝",
"雯冬",
"雯蕾",
"雯妮",
"雯珊",
"雯维",
"雯心",
"雯颖",
"紊娟",
"昔文",
"曦萍",
"夏谣",
"香淑",
"湘驰",
"萧妍",
"晓蓓",
"晓琴",
"晓清",
"晓欣",
"筱容",
"心月",
"芯凝",
"欣合",
"欣倩",
"欣媛",
"新柏",
"新慧",
"歆涵",
"歆沁",
"歆钰",
"馨姝",
"鑫蕾",
"秀琰",
"轩可",
"萱白",
"萱铃",
"璇静",
"璇蓝",
"雪鹭",
"雪如",
"雪霞",
"雪瑶",
"寻菡",
"寻琴",
"雅戈",
"雅虹",
"雅妮",
"雅宁",
"雅珊",
"雅欣",
"雅雪",
"雅晔",
"娅玲",
"娅彤",
"娅玉",
"言清",
"妍靖",
"妍丽",
"妍宁",
"妍熙",
"妍雅",
"妍雅",
"炎梦",
"颜晨",
"艳涵",
"艳珊",
"艳雅",
"雁莲",
"雁茜",
"雁蓉",
"雁芷",
"洋凡",
"瑶春",
"瑶可",
"瑶玲",
"瑶微",
"瑶萱",
"烨睿",
"依晗",
"依坤",
"仪旭",
"怡岚",
"怡敏",
"怡轩",
"宜姝",
"宜元",
"亿琳",
"义颖",
"艺华",
"艺晶",
"艺静",
"艺琦",
"忆宸",
"译岚",
"奕涵",
"奕雯",
"奕芯",
"奕懿",
"奕颖",
"羿斓",
"意娇",
"意逸",
"薏莉",
"臆湘",
"萤枫",
"萦宇",
"永君",
"瑜桂",
"瑜楦",
"瑜余",
"宇肜",
"羽静",
"羽儇",
"雨芬",
"雨茹",
"雨萱",
"雨雅",
"雨雁",
"禹昕",
"语蕊",
"语童",
"语欣",
"玉文",
"育遥",
"昱书",
"昱珍",
"毓洁",
"媛怡",
"远妤",
"悦永",
"云畅",
"云勤",
"芸慧",
"芸书",
"芸雅",
"芸懿",
"泽筠",
"之惠",
"芷柳",
"芷蕊",
"智柯",
"智茹",
"竹兰",
"姿雨",
"子菲",
"子琳",
"子曼",
"子鸣",
"子思",
"子昕",
"子优",
"梓蔓",
"紫婷"
    ];
first_name_list(2, 1) ->
    [
    "阿比达",
"阿比雅",
"阿代",
"阿德莱",
"阿德里尔",
"阿德利",
"阿德尼",
"阿迪巴",
"阿蒂",
"阿多奈",
"阿多尼斯",
"阿尔菲",
"阿尔及尔",
"阿尔斯顿",
"阿尔瓦",
"阿尔文",
"阿克塞尔",
"阿拉德",
"阿兰",
"阿里克",
"阿莲",
"阿隆佐",
"阿罗",
"阿马尔",
"阿蒙",
"阿米尔",
"阿摩司",
"阿舍尔",
"阿特金斯",
"阿特利",
"阿维夫",
"阿文",
"阿扎里亚",
"埃比尼泽",
"埃布纳",
"埃德",
"埃德加",
"埃德加德",
"埃德里克",
"埃德蒙",
"埃德温",
"埃迪",
"埃尔伯特",
"埃尔登",
"埃尔金",
"埃尔默",
"埃尔斯顿",
"埃尔文",
"埃夫拉特",
"埃夫伦",
"埃格伯特",
"埃里克",
"埃里克森",
"埃利哈",
"埃利索",
"埃利亚斯",
"埃利泽",
"埃洛伊",
"埃米利奥",
"埃齐奥",
"埃瓦尔德",
"埃文",
"埃泽奎尔",
"艾伯纳",
"艾丹",
"艾尔",
"艾尔默",
"艾尔温",
"艾夫斯",
"艾哈迈德",
"艾克",
"艾米克",
"艾西格",
"爱丹",
"爱德伯特",
"爱德华",
"爱丽舍",
"爱莲",
"安德鲁",
"安德斯",
"安迪",
"安蒂昂",
"安格斯",
"安杰洛",
"安生",
"奥巴底亚",
"奥顿",
"奥尔德温",
"奥尔登",
"奥尔森",
"奥格登",
"奥克利",
"奥克斯顿",
"奥克斯利",
"奥兰",
"奥里克",
"奥利",
"奥利佛",
"奥伦",
"奥马尔",
"奥蒙德",
"奥齐",
"奥斯丁",
"奥斯玛",
"奥斯蒙德",
"奥瓦尔",
"奥兹",
"巴德里克",
"巴登",
"巴恩斯",
"巴尔塔萨",
"巴克",
"巴克利",
"巴拉巴斯",
"巴拉克",
"巴伦",
"巴纳比",
"巴纳卜",
"巴塞洛缪",
"巴塞特",
"巴特",
"巴特莱特",
"巴特利",
"白兰度",
"百特",
"拜拉姆",
"拜兰",
"拜伦",
"保尔",
"保罗",
"鲍比",
"鲍勃",
"贝克",
"贝纳多",
"本恩",
"本杰门",
"本森",
"本特利",
"比尔",
"比默",
"比奇",
"比斯利",
"彼德森",
"宾基",
"波洛克",
"波斯顿",
"伯德",
"伯蒂",
"伯恩",
"伯吉斯",
"伯爵",
"伯里斯",
"伯内特",
"伯尼",
"伯特",
"博斯利",
"布福德",
"布拉德",
"布拉德利",
"布莱登",
"布莱克",
"布赖登",
"布赖顿",
"布兰",
"布兰丹",
"布兰登",
"布兰顿",
"布兰森",
"布朗森",
"布劳略",
"布雷登",
"布雷迪",
"布雷顿",
"布雷纳德",
"布里杰",
"布林利",
"布龙",
"布鲁克斯",
"布鲁诺",
"布伦登",
"布伦丁",
"布伦纳",
"布伦南",
"布伦宁",
"布伦农",
"布伦特利",
"布伦滕",
"布罗德",
"布罗克顿",
"采夫",
"参孙",
"策布",
"策克",
"查德里克",
"查尔顿",
"查尔斯",
"查尔斯顿",
"查理",
"查斯",
"柴卡",
"池井",
"创世记",
"刺穿",
"达德利",
"达尔顿",
"达格尔",
"达克斯",
"达里奥",
"达里尔",
"达里乌斯",
"达林",
"达龙",
"达伦",
"达蒙",
"达米安",
"达内尔",
"达森",
"达斯汀",
"达维德",
"达文",
"大林",
"大卫",
"戴尔",
"戴夫",
"戴伦",
"戴维斯",
"丹蒂",
"丹恩",
"丹利",
"丹麦文",
"丹尼尔",
"丹尼森",
"丹农",
"道顿",
"道森",
"德德里克",
"德尔顿",
"德尔文",
"德克斯特",
"德拉尼",
"德莱顿",
"德雷",
"德里克",
"德龙",
"德马科",
"德纳姆",
"德文",
"德沃恩",
"登顿",
"堤防",
"狄恩",
"狄克逊",
"迪伯恩",
"迪德里克",
"迪绍恩",
"迪生",
"弟弟",
"蒂莫西",
"蒂姆",
"杜尔",
"杜雷尔",
"杜文",
"多布",
"多恩",
"多伦",
"多米尼克",
"多诺万",
"厄兰",
"恩佐",
"法恩利",
"法尔",
"法利",
"法利托",
"法罗",
"法纳",
"菲德尔",
"菲尔",
"菲利普",
"菲洛梅娜",
"费尔顿",
"费利克斯",
"费利佩",
"费维尔",
"费兹",
"芬莱",
"丰富",
"佛朗哥",
"弗莱彻",
"弗莱明",
"弗兰基",
"弗朗西斯",
"弗雷",
"弗雷温",
"弗里多夫",
"弗里克",
"弗里曼",
"福尔摩斯",
"福勒",
"福雷斯特",
"高登",
"高迪",
"高尔顿",
"高梅",
"戈德温",
"格拉德温",
"格莱美",
"格兰特",
"格雷厄姆",
"格雷戈里",
"格雷森",
"格雷舍姆",
"格里",
"格里利",
"格里姆肖",
"格森",
"格舍姆",
"根特",
"公理",
"贡扎洛",
"古尔",
"哈德森",
"哈德温",
"哈丁",
"哈尔",
"哈尔伯特",
"哈尔福德",
"哈格利",
"哈勒姆",
"哈里",
"哈里尔",
"哈里森",
"哈立德",
"哈利德",
"哈罗德",
"哈洛",
"哈马里",
"哈蒙",
"哈米尔",
"哈米什",
"哈珀",
"哈特利",
"哈维尔",
"海德",
"海登",
"海狸",
"海曼",
"海耶斯",
"汉德尔",
"汉利",
"汉密尔顿",
"汉普顿",
"汉斯",
"何西阿",
"赫德利",
"赫顿",
"赫斯特",
"赫歇尔",
"黑尔",
"黑格",
"亨利",
"胡安",
"华登",
"怀特",
"惠特",
"霍布森",
"霍顿",
"霍尔顿",
"霍华德",
"霍利",
"霍奇森",
"机会",
"基安",
"基丁",
"基顿",
"基弗",
"基拉",
"基隆",
"基纳",
"基文",
"基延",
"吉安卡洛",
"吉布森",
"吉迪亚",
"吉尔",
"吉福德",
"吉格",
"吉隆",
"吉米",
"加拜",
"加布",
"加尔曼",
"加拉德",
"加勒斯",
"加里",
"加里昂",
"加里克",
"加林",
"加尼特",
"加森",
"加思",
"贾巴里",
"贾德",
"贾登",
"贾恩卡洛",
"贾戈",
"贾古尔",
"贾拉德",
"贾雷尔",
"贾雷特",
"贾里亚斯",
"贾伦",
"贾马里",
"贾梅尔",
"贾米森",
"贾斯",
"贾斯顿",
"贾旺",
"贾希姆",
"脚踏",
"杰德",
"杰登",
"杰斐逊",
"杰弗里",
"杰弗斯",
"杰克",
"杰克森",
"杰克斯",
"杰拉德",
"杰拉米",
"杰里米",
"杰列姆",
"杰琳",
"杰罗尔",
"杰罗米",
"杰曼",
"杰米",
"杰米森",
"杰姆斯",
"杰瑞",
"杰瑞德",
"杰瑞尔",
"杰森",
"杰维斯",
"杰文",
"杰西",
"解冻",
"金博尔",
"金斯利",
"卡登",
"卡尔",
"卡尔德",
"卡尔顿",
"卡尔森",
"卡尔坦",
"卡拉",
"卡莱尔",
"卡莱姆",
"卡乐",
"卡里布",
"卡列布",
"卡洛斯",
"卡梅隆",
"卡内尔",
"卡斯伯特",
"卡斯帕",
"卡特",
"卡维尔",
"开尔文",
"凯安",
"凯德里克",
"凯尔",
"凯尔顿",
"凯尔森",
"凯弗",
"凯拉尔",
"凯洛尔",
"凯南",
"凯文",
"坎姆龙",
"康拉德",
"康妮",
"考利",
"柯蒂",
"柯克利",
"柯克林",
"柯林",
"科迪",
"科丁",
"科尔",
"科尔比",
"科尔宾",
"科尔伯特",
"科尔达罗",
"科尔曼",
"科尔森",
"科尔滕",
"科尔汀",
"科雷",
"科利斯",
"科林",
"科特尔",
"科温",
"可尔丁",
"克莱",
"克莱顿",
"克莱默",
"克兰德尔",
"克兰斯顿",
"克雷格",
"克里斯特",
"克里斯托",
"克里文",
"克利夫",
"克利夫兰",
"克利福德",
"克温",
"肯代尔",
"肯德雷尔",
"肯德里克",
"肯恩",
"肯里克",
"肯普",
"肯瑞克",
"肯沃德",
"奎兰",
"昆腾",
"昆汀",
"拉德利",
"拉德诺",
"拉蒂默",
"拉尔菲",
"拉尔斯",
"拉尔斯顿",
"拉菲",
"拉斐尔",
"拉冯",
"拉马库斯",
"拉姆西",
"拉嫩",
"拉撒路",
"拉扎尔",
"拉扎罗",
"莱恩",
"莱尔",
"莱克斯",
"兰达",
"兰丹",
"兰德尔",
"兰登",
"兰迪",
"兰金",
"兰尼",
"兰斯顿",
"兰斯利",
"劳里",
"劳利",
"勒穆埃尔",
"雷德利",
"雷顿",
"雷吉",
"雷克斯",
"雷克斯顿",
"雷兰",
"雷蒙多",
"雷斯",
"雷扬",
"李维",
"里查德",
"里格",
"里格比",
"里基",
"里克",
"里奇",
"里奇利",
"里斯顿",
"里文",
"理查德",
"利奥",
"利奥波多",
"利桑德罗",
"利亚姆",
"良安",
"列维",
"林达尔",
"林德利",
"林登",
"林克",
"卢卡",
"卢卡斯",
"卢克斯",
"卢西亚诺",
"鲁本",
"鲁迪",
"鲁奇亚诺",
"陆克文",
"路加",
"路卡斯",
"罗比",
"罗宾逊",
"罗伯茨",
"罗伯逊",
"罗德里克",
"罗德尼",
"罗登",
"罗恩",
"罗汉",
"罗利",
"罗莉",
"罗洛",
"罗密欧",
"罗纳德",
"罗纳尔多",
"罗尼",
"罗森",
"罗斯",
"罗威尔",
"罗伊斯",
"洛根",
"洛克",
"洛伦佐",
"洛维尔",
"落在",
"马登",
"马蒂亚斯",
"马尔登",
"马尔科姆",
"马尔克",
"马克",
"马克西姆",
"马库斯",
"马里奥",
"马里克",
"马利",
"马洛",
"马洛尼",
"马纳夫",
"马切利诺",
"马塞利诺",
"马瑟",
"马斯登",
"马斯顿",
"马特尔",
"马文",
"马西",
"马西莫",
"玛拉基",
"玛拿西",
"迈尔",
"麦可",
"曼顿",
"曼宁",
"曼努埃尔",
"梅德里奇",
"梅尔登",
"梅尔文",
"梅林",
"梅诺",
"梅休",
"蒙特",
"蒙特尔",
"孟德尔",
"米德",
"米尔顿",
"米尔斯",
"米恰尔",
"米切尔",
"米特",
"莫顿",
"莫尔斯",
"莫利",
"纳达夫",
"纳尔逊",
"纳赫曼克",
"纳森",
"纳塔尼尔",
"纳特",
"纳西尔",
"奈兰德",
"内德",
"内特",
"内文",
"尼格尔",
"尼古拉",
"尼古拉斯",
"尼科尔斯",
"尼科拉斯",
"尼希米记",
"纽维尔",
"诺阿",
"诺阿迪亚",
"诺贝托",
"诺兰",
"诺姆",
"诺沃德",
"诺亚",
"欧内斯特",
"欧斯里克",
"欧文",
"帕尔蒂",
"帕金",
"帕维尔",
"派克",
"佩登",
"佩蒂",
"佩尔",
"佩尔顿",
"佩里",
"佩特罗斯",
"彭利",
"皮尔森",
"皮尔斯",
"皮特尼",
"皮乌斯",
"珀金",
"普雷斯顿",
"普伦蒂斯",
"齐夫",
"恰德里克",
"强纳丹",
"强尼",
"乔尔",
"乔利",
"乔纳森",
"乔纳坦",
"乔纳通",
"乔希",
"乔伊",
"切斯顿",
"切斯特",
"琼恩",
"丘吉尔",
"裘德",
"瑞安",
"瑞奇",
"撒比底亚",
"撒迦利亚",
"萨福德",
"萨吉夫",
"萨利姆",
"萨洛曼",
"萨缪尔",
"萨姆",
"萨穆埃尔",
"萨维奥",
"塞巴底亚",
"塞尔",
"塞尔比",
"塞尔万",
"塞隆",
"塞缪尔",
"塞文",
"赛勒斯",
"赛斯",
"桑德",
"桑尼",
"桑普森",
"瑟威尔",
"沙德",
"沙米尔",
"沙姆斯",
"圣蒂诺",
"史蒂芬",
"史蒂夫",
"史蒂文斯",
"史考特",
"史密斯",
"斯宾塞",
"斯蒂芬森",
"斯科蒂",
"斯莱德",
"斯梅德利",
"斯泰森",
"斯特恩",
"斯特凡诺",
"斯特林",
"斯通尼",
"斯图尔特",
"斯托",
"斯托克",
"斯旺妮",
"斯温德尔",
"斯温福德",
"苏厄德",
"苏格登",
"索恩",
"索尔顿",
"索耶",
"塔德利",
"塔顿",
"塔夫脱",
"塔弗",
"塔伦",
"塔纳尔",
"塔瓦里斯",
"塔旺",
"塔维安",
"泰拉尔",
"泰勒",
"泰隆",
"泰瑞尔",
"坦迪",
"坦南特",
"坦然地",
"汤姆",
"汤姆斯",
"汤尼",
"汤普森",
"唐诺万",
"特德",
"特尔莫",
"特拉维斯",
"特赖",
"特雷顿",
"特雷尔",
"特雷文",
"特里",
"特里普",
"提尔",
"托比",
"托比亚斯",
"托德",
"托里",
"托马斯",
"托尼",
"瓦伦丁",
"瓦舍尔",
"万斯",
"威伯特",
"威尔伯",
"威尔基",
"威尔金斯",
"威尔士",
"威尔士语",
"威克姆",
"威利",
"威斯顿",
"威斯汀",
"韦伯",
"韦伯利",
"韦德",
"韦尔",
"韦林",
"维克",
"维克多",
"维森特",
"维托",
"温德尔",
"温恩",
"温弗雷德",
"温尼",
"温切尔",
"温斯利",
"文森",
"文森特",
"文斯",
"翁贝托",
"沃德利",
"沃顿",
"沃尔顿",
"沃尔什",
"沃尔温",
"沃里克",
"沃利",
"沃特金斯",
"乌尔里希",
"乌里",
"乌里亚",
"乌兹",
"屋大维",
"西奥",
"西德尔",
"西拉斯",
"西蒙",
"西万",
"希洛",
"希普利",
"希思",
"夏洛克",
"肖恩",
"萧氏",
"谢菲尔德",
"谢里尔",
"休斯顿",
"宣威",
"迅速",
"押沙龙",
"雅比兹",
"雅各布",
"雅克兹",
"雅琳",
"雅马库斯",
"亚伯",
"亚伯拉罕",
"亚当",
"亚当姆",
"亚德利",
"亚东",
"亚基尔",
"亚吉尔",
"亚历克斯",
"亚历山达",
"亚龙",
"亚瑟",
"亚希雅",
"耶茨",
"耶胡达",
"耶拉尔德",
"耶拉米",
"耶勒特",
"耶雷米",
"耶里哥",
"耶罗德",
"伊安",
"伊恩",
"伊户",
"伊拉杰",
"伊利",
"伊利亚",
"伊利亚姆",
"伊曼纽尔",
"伊萨克",
"伊赛家",
"伊森",
"伊坦",
"伊特罗",
"伊西德罗",
"伊西多尔",
"伊扎克",
"伊兹",
"以弗仑",
"以利亚",
"以诺",
"以赛亚斯",
"以实玛利",
"以斯拉",
"英格拉姆",
"尤尔",
"尤里尔",
"尤瓦尔",
"约阿基姆",
"约尔",
"约根",
"约翰娜顿",
"约翰娜森",
"约翰逊",
"约克",
"约里克",
"约拿",
"约瑟姆",
"约书亚",
"约万",
"赞恩",
"泽布伦",
"泽维尔",
"扎查里亚",
"扎恩",
"扎哈里",
"扎卡里",
"扎凯",
"扎乔",
"扎瓦德",
"扎维尔",
"扎祖",
"斋顿",
"斋罗",
"詹姆森",
"詹姆士",
"朱利安",
"朱利叶斯",
"朱瓦安"
    ];
first_name_list(2, 2) ->
    [
    "阿贝拉",
"阿比",
"阿比盖尔",
"阿比加勒",
"阿达拉",
"阿达利娜",
"阿达利亚",
"阿达莉",
"阿达林",
"阿黛尔",
"阿黛拉",
"阿德莱德",
"阿德利",
"阿德林",
"阿德琳娜",
"阿迪蒂",
"阿迪林",
"阿迪娜",
"阿迪亚",
"阿尔玛",
"阿夫尼",
"阿加莎",
"阿莱格拉",
"阿莱特",
"阿莱西亚",
"阿兰察",
"阿兰萨",
"阿雷达",
"阿雷莉",
"阿雷娜",
"阿里安妮",
"阿里娜",
"阿里森",
"阿里维亚",
"阿里亚",
"阿里耶尔",
"阿丽安娜",
"阿丽娜",
"阿利亚",
"阿列拉",
"阿琳",
"阿琳娜",
"阿隆德拉",
"阿罗拉",
"阿马里斯",
"阿玛拉",
"阿玛尼",
"阿玛雅",
"阿曼达",
"阿弥亚",
"阿米",
"阿米拉",
"阿米莉亚",
"阿米雅",
"阿米亚",
"阿莫拉",
"阿那利亚",
"阿纳利",
"阿纳耶",
"阿奈斯",
"阿妮雅",
"阿妮亚",
"阿努什卡",
"阿瑞安娜",
"阿莎",
"阿什顿",
"阿什利",
"阿什琳",
"阿斯彭",
"阿瓦隆",
"阿瓦尼",
"阿维盖尔",
"阿维拉",
"阿维亚",
"阿文",
"阿泽尼斯",
"阿扎利亚",
"阿祖尔",
"阿祖纳",
"埃尔维拉",
"埃莱尼",
"埃勒",
"埃勒里",
"埃里森",
"埃里斯",
"埃利斯",
"埃利亚",
"埃莉诺拉",
"埃琳娜",
"埃洛拉",
"埃洛伊萨",
"埃梅琳",
"埃米尔",
"埃米利亚",
"埃默里",
"埃默森",
"埃姆",
"埃斯梅",
"埃斯特尔",
"埃维",
"艾安娜",
"艾比",
"艾迪",
"艾迪森",
"艾迪生",
"艾格尼丝",
"艾拉",
"艾拉尼",
"艾兰妮",
"艾里斯",
"艾丽莎",
"艾丽西亚",
"艾利",
"艾莉",
"艾莉莎",
"艾莉丝",
"艾琳娜",
"艾略特",
"艾玛",
"艾玛琳",
"艾玛琳娜",
"艾玛尼",
"艾美莉",
"艾美琳",
"艾米",
"艾米利亚",
"艾米莉",
"艾米亚",
"艾斯林",
"艾塔娜",
"艾娃",
"艾瓦",
"艾亚娜",
"艾耶那",
"爱尔兰",
"爱丽儿",
"爱丽莎",
"爱丽丝",
"爱莉安娜",
"爱伦",
"爱美",
"爱默生",
"爱那拉",
"爱田",
"爱西",
"安德里亚",
"安东尼娅",
"安吉",
"安吉利",
"安吉利卡",
"安吉莉",
"安贾利",
"安玛丽",
"安娜",
"安娜贝尔",
"安娜贝拉",
"安娜丽莎",
"安娜丽丝",
"安娜莉",
"安娜莉亚",
"安娜玛丽",
"安娜雅",
"安妮拉",
"安妮莎",
"安妮塔",
"安妮特",
"安琪莉",
"安琪莉可",
"安斯利",
"安维",
"奥布里埃",
"奥黛丽",
"奥黛特",
"奥德瑞",
"奥尔加",
"奥菲利亚",
"奥拉尼斯",
"奥里尔",
"奥里亚纳",
"奥利维亚",
"奥斯汀",
"宝拉",
"宝琳娜",
"保拉",
"保莱特",
"鲍伊",
"贝基",
"贝拉",
"贝林",
"贝伦",
"贝伦尼斯",
"贝纳黛特",
"本内特",
"本特利",
"比利",
"波蒂亚",
"伯大尼",
"伯特利",
"不列颠",
"布莱克",
"布莱克利",
"布莱里",
"布莱斯",
"布赖安娜",
"布兰卡",
"布雷安娜",
"布雷利",
"布雷林",
"布里埃尔",
"布里吉特",
"布里利",
"布里萨",
"布里坦尼",
"布里西达",
"布里扎",
"布列塔尼",
"布林",
"布林利",
"布鲁克",
"布鲁克林",
"布伦达",
"曾达亚",
"查里斯",
"达安娜",
"达芙妮",
"达拉斯",
"达雷萨",
"达利拉",
"达利萨",
"达莉亚",
"达林",
"达琳",
"达马里斯",
"达娜",
"达妮卡",
"达维纳",
"达西",
"戴西",
"黛安娜",
"黛博拉",
"黛拉",
"黛咪",
"丹妮",
"丹妮尔",
"丹妮卡",
"丹妮莉丝",
"丹妮丝",
"丹尼斯",
"丹雅",
"德博拉",
"德莱尼",
"德丽拉",
"德鲁",
"德文郡",
"迪克西",
"迪莉亚",
"迪伦",
"迪娜",
"迪亚",
"蒂芙尼",
"蒂娜",
"杜松",
"多拉",
"多丽丝",
"多萝西",
"多米尼克",
"恩雅",
"法比奥拉",
"法拉",
"凡妮莎",
"菲奥娜",
"菲斯",
"菲耶",
"费利西亚",
"芬利",
"佛罗伦斯",
"弗朗辛",
"弗雷雅",
"弗里达",
"弗洛尔",
"高迪",
"格拉迪斯",
"格拉塞林",
"格雷塔",
"格雷西亚",
"格蕾琴",
"格蕾丝琳",
"格蕾特",
"格温多琳",
"格温妮丝",
"古诺尔",
"哈德利",
"哈德森",
"哈里尼",
"哈里亚",
"哈莉",
"哈林",
"哈那",
"哈珀",
"哈特利",
"哈瓦那",
"海登",
"海迪",
"海利",
"海伦",
"海伦娜",
"赫敏",
"亨利",
"胡安妮塔",
"霍莉",
"基拉尼",
"基利",
"基亚拉",
"吉安娜",
"吉恩",
"吉莲",
"吉米娜",
"吉纳维芙",
"吉娜",
"吉赛尔",
"吉瑟尔",
"嘉莉",
"贾凡纳",
"贾拉尼",
"贾林",
"贾尼斯",
"贾斯林",
"贾亚",
"贾泽尔",
"贾兹林",
"贾兹敏",
"贾兹明",
"杰德",
"杰德琳",
"杰登",
"杰基",
"杰克林",
"杰奎林",
"杰奎琳",
"杰拉",
"杰拉尔丁",
"杰琳",
"杰伦",
"杰米",
"杰娜",
"杰斯琳",
"杰西",
"杰伊莉",
"金德尔",
"金利",
"金西",
"卡蒂亚",
"卡拉",
"卡莱亚",
"卡里利",
"卡里纳",
"卡里萨",
"卡里斯",
"卡里西",
"卡利",
"卡莉",
"卡莉莎",
"卡琳娜",
"卡罗琳",
"卡罗琳娜",
"卡梅尔",
"卡梅伦",
"卡门",
"卡米尔",
"卡米耶",
"卡姆丁",
"卡普里",
"卡奇",
"卡桑德拉",
"卡塔利亚",
"卡塔琳娜",
"卡特",
"卡特琳",
"卡特琳娜",
"卡西",
"卡西迪",
"凯登",
"凯登斯",
"凯蒂",
"凯拉",
"凯拉尼",
"凯兰妮",
"凯里",
"凯莉",
"凯林",
"凯伦",
"凯齐亚",
"凯茜",
"凯瑟琳",
"凯西",
"凯亚",
"坎布里亚",
"坎迪丝",
"坎迪斯",
"珂赛特",
"科迪利亚",
"科拉",
"科莱特",
"科洛",
"可拉",
"克尔斯滕",
"克拉拉",
"克莱奥",
"克莱门汀",
"克劳迪娅",
"克里沙",
"克里斯汀",
"克洛伊",
"肯德尔",
"肯德拉",
"肯利",
"肯纳",
"肯尼迪",
"肯尼亚",
"肯西",
"肯辛顿",
"库珀",
"昆西",
"拉斐拉",
"拉里萨",
"拉莫纳",
"拉尼亚",
"拉切尔",
"拉维尼亚",
"拉雅",
"莱尔",
"莱兰妮",
"莱斯利",
"莱西",
"赖利",
"劳林",
"劳伦",
"勒克斯",
"雷安娜",
"雷恩",
"雷兰",
"雷利",
"雷林",
"雷琳",
"雷姆",
"雷纳",
"雷纳塔",
"雷切尔",
"蕾拉",
"蕾娜",
"蕾丝",
"里贾纳",
"里拉",
"里普利",
"里斯",
"里雅",
"里泽斯",
"丽贝卡",
"丽芙",
"丽拉",
"丽莲",
"丽娜",
"丽赛特",
"丽塔",
"丽雅",
"丽泽特",
"丽兹",
"利安",
"利维亚",
"利亚",
"利兹贝斯",
"莉安娜",
"莉迪亚",
"莉拉",
"莉莉安",
"莉莉亚",
"莉莉亚娜",
"莉莲",
"莉娜",
"列克西",
"林赛",
"琳达",
"琳内特",
"隆丁",
"卢尔德",
"卢卡",
"卢塞罗",
"鲁维亚",
"鲁兹",
"路西尔",
"露丝",
"露西",
"露西亚",
"露西亚娜",
"露易丝",
"罗宾",
"罗克萨娜",
"罗克珊",
"罗克珊娜",
"罗米",
"罗米娜",
"罗密",
"罗莎莉",
"罗莎琳达",
"罗莎琳德",
"罗斯林",
"罗斯琳",
"罗文",
"罗西",
"萝拉",
"洛根",
"洛雷莱",
"洛雷塔",
"洛林",
"洛伦",
"马贝拉",
"马达林",
"马迪森",
"马蒂尔达",
"马戈特",
"马哥",
"马卡利亚",
"马克纳",
"马肯齐",
"马拉克",
"马来亚",
"马莱纳",
"马里埃拉",
"马里贝尔",
"马里察",
"马里恩",
"马里塞拉",
"马里索尔",
"马里亚纳",
"马利",
"马利亚",
"马林",
"马琳娜",
"马伦",
"马洛",
"马洛里",
"马乔里",
"马赛琳",
"马文",
"马西",
"马耶拉",
"玛达琳",
"玛歌",
"玛格丽",
"玛格丽塔",
"玛拉",
"玛丽安",
"玛丽安娜",
"玛丽琳",
"玛丽莎",
"玛丽亚妮",
"玛莉",
"玛琳",
"玛琳娜",
"玛雅",
"麦迪",
"麦迪琳",
"麦凯拉",
"麦肯纳",
"麦拉",
"麦特",
"麦西",
"曼纳特",
"梅达",
"梅根",
"梅拉尼",
"梅雷迪思",
"梅里达",
"梅丽娜",
"梅林",
"梅琳达",
"梅赛德斯",
"梅特",
"梅西",
"美佳",
"美利亚",
"蒙蒙",
"蒙塞拉特",
"弥亚",
"米阿贝拉",
"米迦勒",
"米凯拉",
"米拉",
"米拉尼亚",
"米莱娜",
"米兰达",
"米兰尼",
"米里亚姆",
"米娜",
"米切拉",
"米沙",
"米娅",
"蜜糖",
"明美",
"茉莉",
"莫琳",
"莫娜",
"莫妮卡",
"莫妮克",
"纳迪亚",
"纳丁",
"纳拉尼",
"纳里亚",
"纳塔利亚",
"纳塔利娅",
"纳威",
"纳雅",
"纳耶利",
"娜丽莉",
"娜莎莉",
"娜塔莉",
"奈拉",
"奈马",
"奈屋",
"奈亚",
"内莉",
"内斯米",
"内娃",
"妮拉",
"妮莉",
"妮雅",
"妮娅",
"尼基",
"尼卡",
"尼科莱特",
"尼拉",
"尼里亚",
"尼姆",
"尼亚",
"努尔",
"诺拉",
"诺拉尼",
"诺莉亚",
"诺美",
"诺木",
"帕洛玛",
"帕梅拉",
"帕特里夏",
"佩顿",
"佩拉",
"佩特拉",
"皮拉尔",
"普雷斯利",
"普里西拉",
"齐亚",
"奇安娜",
"乔安",
"乔安娜",
"乔勒",
"乔琳",
"乔塞林",
"乔塞琳",
"乔万娜",
"乔西",
"乔雅",
"乔伊斯",
"切尔西",
"裘德",
"瑞安",
"瑞娜",
"瑞秋",
"撒利亚",
"撒玛拉",
"萨宾",
"萨布丽娜",
"萨迪",
"萨凡纳",
"萨拉",
"萨里亚",
"萨伦",
"萨马拉",
"萨玛雅",
"萨米拉",
"萨那",
"萨尼亚",
"萨沙",
"塞多纳",
"塞拉特",
"塞莱斯特",
"塞勒姆",
"塞那",
"塞西莉亚",
"赛迪",
"赛拉",
"赛勒",
"赛琳娜",
"桑塔纳",
"瑟琳娜",
"沙伊拉",
"莎贝拉",
"莎拉",
"珊瑚",
"尚塔尔",
"舍拉",
"什里亚",
"史蒂芬妮",
"斯宾塞",
"斯蒂芬妮",
"斯蒂维",
"斯卡列特",
"斯凯",
"斯凯拉",
"斯凯勒",
"斯塔拉",
"斯泰西",
"斯特拉",
"斯瓦拉",
"苏哈尼",
"苏里",
"苏珊娜",
"苏西",
"索尔",
"索菲亚",
"索拉亚",
"索雷尔",
"索尼亚",
"索耶",
"塔比莎",
"塔蒂亚娜",
"塔拉",
"塔利亚",
"塔玛拉",
"塔米",
"塔米娅",
"塔图姆",
"泰勒",
"泰莎",
"坦维",
"唐娜",
"特蕾丝",
"特斯拉",
"滕利",
"廷利",
"托里",
"托尼",
"瓦莱里",
"瓦莱丽",
"瓦伦蒂娜",
"瓦内洛佩",
"瓦尼亚",
"万尼",
"威达",
"威尼斯",
"维安娜",
"维奥莱塔",
"维奥莱特",
"维达",
"维拉",
"维罗妮卡",
"维维安",
"维维亚纳",
"维也纳",
"温迪",
"温妮",
"乌玛",
"西埃洛",
"西奥多拉",
"西尔塞",
"西尔瓦娜",
"西尔维",
"西梅纳",
"西蒙娜",
"西姆兰",
"西奈",
"西瑞",
"西塔利",
"西特拉利",
"西娅",
"希尔达",
"希拉",
"希拉里",
"希瑟",
"希望",
"锡安",
"锡耶纳",
"席琳",
"夏安",
"夏琳",
"夏洛特",
"谢尔比",
"谢丽尔",
"辛迪",
"休玛拉",
"雪莉",
"雅顿",
"雅克林",
"亚迪拉",
"亚拉",
"亚雷齐",
"亚里安妮",
"亚里扎",
"亚历克斯",
"亚列尼",
"亚米特",
"亚娜",
"亚尼利",
"亚尼雅",
"亚斯曼",
"亚斯敏",
"亚洲",
"亚兹里",
"亚兹敏",
"耶尔",
"耶拉",
"耶纳维夫",
"耶尼西斯",
"耶塞尼亚",
"伊策尔",
"伊迪",
"伊尔塞",
"伊凡尼",
"伊冯娜",
"伊芙莉娜",
"伊芙琳",
"伊拉娜",
"伊莱恩",
"伊莱娜",
"伊丽莎",
"伊丽莎白",
"伊利安娜",
"伊莉",
"伊莉安娜",
"伊琳娜",
"伊莫根",
"伊内斯",
"伊涅兹",
"伊萨",
"伊萨玛",
"伊沙尼",
"伊莎多拉",
"伊娃",
"伊瓦林",
"伊万杰琳",
"伊万卡",
"伊万那",
"伊泽尔",
"伊扎贝尔",
"伊扎贝利",
"以利沙",
"以利亚娜",
"印度",
"樱桃",
"尤兰达",
"尤利亚娜",
"尤莉安娜",
"尤娜",
"尤妮丝",
"约丁",
"约翰娜",
"约瑟琳",
"扎哈拉",
"扎赫拉",
"扎里亚",
"扎尼耶",
"扎耶",
"扎伊拉",
"扎伊娜",
"詹娜",
"詹妮莎",
"侦察",
"珍贵",
"珍妮",
"珍妮尔",
"珍妮卡",
"珍妮莉",
"珍妮特",
"珍惜",
"证据",
"朱迪",
"朱迪思",
"朱尔斯",
"朱丽安娜",
"朱丽丝",
"朱利安娜",
"朱莉安娜",
"朱莉安妮",
"朱莉亚",
"紫色",
"祖雷卡",
"祖里",
"钻石",
"佐拉",
"佐亚"
    ];
first_name_list(3, 1) ->
    [
    "爱不灭",
"傲龙飞",
"傲藐者",
"傲世",
"傲世ζ",
"傲世ξ",
"傲世丶",
"傲视",
"傲视ζ",
"傲视ξ",
"傲视丶",
"比你帅",
"别碍我",
"不悔",
"不悔*",
"不悔ζ",
"不悔ξ",
"不悔丶",
"苍穹",
"苍穹*",
"苍穹ζ",
"苍穹ξ",
"苍穹丶",
"潮男",
"潮男ζ",
"潮男ξ",
"潮男丶",
"捣蛋",
"捣蛋ζ",
"捣蛋ξ",
"捣蛋丶",
"帝霸",
"帝霸ζ",
"帝霸ξ",
"帝霸丶",
"独步",
"独步ζ",
"独步ξ",
"独步丶",
"反差帅",
"范儿",
"范儿ζ",
"范儿ξ",
"范儿丶",
"富翁",
"富翁ζ",
"富翁ξ",
"富翁丶",
"公子",
"公子ζ",
"公子ξ",
"公子丶",
"归来",
"归来ζ",
"归来ξ",
"归来丶",
"贵族",
"贵族ζ",
"贵族ξ",
"贵族丶",
"狠拽",
"狠拽ζ",
"狠拽ξ",
"狠拽丶",
"假面",
"假面ζ",
"假面ξ",
"假面丶",
"剑啸",
"剑啸ζ",
"剑啸ξ",
"剑啸丶",
"经典",
"经典ζ",
"经典ξ",
"经典丶",
"精英",
"精英ζ",
"精英ξ",
"精英丶",
"君王",
"君王ζ",
"君王ξ",
"君王丶",
"俊颜",
"俊颜ζ",
"俊颜ξ",
"俊颜丶",
"狂灵",
"狂灵ζ",
"狂灵ξ",
"狂灵丶",
"狂神",
"狂神ζ",
"狂神ξ",
"狂神丶",
"狂妄",
"狂妄ζ",
"狂妄ξ",
"狂妄丶",
"狼",
"狼ζ",
"狼ξ",
"狼丶",
"浪帝",
"浪帝ζ",
"浪帝ξ",
"浪帝丶",
"莲华",
"莲华ζ",
"莲华ξ",
"莲华丶",
"炼狱",
"炼狱ζ",
"炼狱ξ",
"炼狱丶",
"龙霸天",
"戮灭",
"戮灭ζ",
"戮灭ξ",
"戮灭丶",
"眉目",
"眉目ζ",
"眉目ξ",
"眉目丶",
"美男兮",
"男神",
"男神ζ",
"男神ξ",
"男神丶",
"虐菜",
"虐菜ζ",
"虐菜ξ",
"虐菜丶",
"欧巴",
"欧巴ζ",
"欧巴ξ",
"欧巴丶",
"气质哥",
"琴狂",
"琴狂ζ",
"琴狂ξ",
"琴狂丶",
"清俊",
"清俊ζ",
"清俊ξ",
"清俊丶",
"清朗",
"清朗ζ",
"清朗ξ",
"清朗丶",
"权力",
"权力ζ",
"权力ξ",
"权力丶",
"绅士",
"绅士*",
"绅士ζ",
"绅士ξ",
"绅士丶",
"弑神",
"弑神ζ",
"弑神ξ",
"弑神丶",
"帅",
"帅ζ",
"帅ξ",
"帅八怪",
"帅比君",
"帅丶",
"帅帅哒",
"特工",
"特工ζ",
"特工ξ",
"特工丶",
"天帝",
"天帝ζ",
"天帝ξ",
"天帝丶",
"玩世",
"玩世ζ",
"玩世ξ",
"玩世丶",
"万人迷",
"王",
"王ζ",
"王ξ",
"王丶",
"无双",
"无双ζ",
"无双ξ",
"无双丶",
"嚣张",
"嚣张ζ",
"嚣张ξ",
"嚣张丶",
"小生",
"小生ζ",
"小生ξ",
"小生丶",
"啸月",
"啸月ζ",
"啸月ξ",
"啸月丶",
"因为帅",
"斩苍穹",
"掌门人",
"朕略帅",
"至尊",
"至尊ζ",
"至尊ξ",
"至尊丶",
"中意你",
"自傲",
"自傲ζ",
"自傲ξ",
"自傲丶",
"安国",
"安顺",
"宾白",
"宾实",
"彬彬",
"彬栋",
"彬幸",
"彬轩",
"冰铭",
"冰毅",
"冰悦",
"博厚",
"博文",
"博喜",
"博锌",
"博延",
"才良",
"才哲",
"曾琪",
"昌翰",
"昌茂",
"昌勇",
"昌宇",
"辰茹",
"辰阳",
"晨冰",
"晨博",
"晨成",
"晨毅",
"晨泽",
"成济",
"成天",
"诚明",
"承安",
"承基",
"承宣",
"承洋",
"承载",
"程磊",
"德冠",
"德欢",
"德辉",
"德馨",
"德尧",
"登颢",
"迪华",
"东冰",
"东杰",
"东斓",
"东沛",
"东世",
"东效",
"东瑜",
"东媛",
"范明",
"飞昂",
"飞沉",
"飞航",
"飞虎",
"飞鹏",
"飞翔",
"飞扬",
"飞英",
"飞舟",
"刚豪",
"高澹",
"高格",
"高翰",
"高丽",
"高兴",
"高轩",
"高懿",
"功彦",
"冠宇",
"光康",
"光亮",
"光誉",
"光远",
"贵依",
"海琦",
"涵畅",
"涵魁",
"寒韵",
"翰池",
"翰藻",
"瀚海",
"豪冰",
"豪初",
"豪杰",
"豪琳",
"豪平",
"豪天",
"豪祥",
"昊嘉",
"浩博",
"浩恩",
"浩歌",
"浩瀚",
"浩航",
"浩慨",
"浩澜",
"浩漫",
"浩淼",
"浩邈",
"浩鸣",
"浩润",
"浩霞",
"浩晔",
"皓枫",
"皓轩",
"灏宇",
"和风",
"和洽",
"和悌",
"和裕",
"和泽",
"和志",
"鹤怡",
"鹤毅",
"亨柠",
"弘博",
"弘诚",
"弘阔",
"弘庆",
"弘文",
"宏伯",
"宏籍",
"宏阔",
"宏邈",
"宏爽",
"宏硕",
"宏远",
"鸿风",
"鸿树",
"鸿羲",
"鸿毓",
"鸿运",
"鸿哲",
"鸿振",
"鸿志",
"鸿卓",
"华辉",
"华清",
"积远",
"吉星",
"嘉晨",
"嘉赐",
"嘉虹",
"嘉荣",
"嘉树",
"嘉澍",
"嘉祥",
"嘉勋",
"嘉誉",
"嘉志",
"嘉志",
"稼宜",
"骞信",
"骞泽",
"建德",
"建锋",
"建茗",
"建木",
"建轩",
"建义",
"建元",
"建中",
"健恒",
"鉴清",
"杰华",
"杰椒",
"堇宾",
"经亘",
"经略",
"经纬",
"经艺",
"景澄",
"景浩",
"景铄",
"景天",
"景同",
"景曜",
"景中",
"景子",
"军宸",
"君昊",
"君浩",
"君毅",
"君元",
"君知",
"钧翔",
"俊德",
"俊恩",
"俊晖",
"俊吉",
"俊健",
"俊杰",
"俊名",
"俊明",
"俊人",
"俊欣",
"俊誉",
"俊远",
"俊哲",
"骏奇",
"开济",
"开霁",
"凯复",
"凯乐",
"凯泽",
"康安",
"康适",
"康顺",
"昆鹏",
"昆琦",
"朗宸",
"乐成",
"乐池",
"乐人",
"乐山",
"乐学",
"乐咏",
"乐正",
"乐志",
"礼程",
"理群",
"力菡",
"力言",
"立坤",
"利综",
"良奥",
"良翰",
"良骏",
"凌安",
"令羽",
"令志",
"令梓",
"茂材",
"茂德",
"明诚",
"明达",
"明德",
"明俊",
"明亮",
"明寿",
"明宇",
"明志",
"明珠",
"铭桉",
"铭晨",
"铭海",
"铭帅",
"铭祥",
"铭校",
"铭心",
"铭泽",
"慕富",
"乃澳",
"宁含",
"彭湃",
"彭越",
"彭泽",
"鹏程",
"鹏池",
"鹏天",
"鹏煊",
"璞玉",
"濮铭",
"奇玮",
"奇希",
"棋羽",
"祺然",
"祺瑞",
"祺祥",
"秋昊",
"秋恒",
"仁道",
"茹铭",
"锐志",
"锐智",
"瑞亭",
"瑞迅",
"睿诚",
"睿好",
"睿昊",
"睿业",
"绍元",
"胜晨",
"胜卿",
"晟昊",
"晟睿",
"世阳",
"思博",
"思行",
"思润",
"思源",
"斯年",
"泰河",
"涛诚",
"天成",
"天翰",
"天豪",
"天骄",
"天晓",
"天逸",
"天宇",
"巍昂",
"为嘉",
"维铭",
"伟懋",
"伟祺",
"伟毅",
"玮琪",
"玮天",
"玮彤",
"玮宇",
"温纶",
"温瑜",
"文昂",
"文斌",
"文岛",
"文栋",
"文赋",
"文翰",
"文林",
"文泰",
"文轩",
"文曜",
"文元",
"武桓",
"希明",
"祥东",
"祥冬",
"祥海",
"祥晴",
"祥孝",
"向笛",
"晓博",
"晓睿",
"晓顼",
"昕仁",
"欣德",
"欣嘉",
"欣怿",
"新翰",
"鑫鹏",
"信鸿",
"信瑞",
"星驰",
"星华",
"星鹏",
"星睿",
"星腾",
"星雨",
"星渊",
"星洲",
"兴安",
"兴昌",
"兴平",
"兴腾",
"兴贤",
"兴学",
"修德",
"修竹",
"戌东",
"旭泰",
"旭扬",
"学林",
"雪宪",
"雅君",
"妍以",
"岩宇",
"颜音",
"阳波",
"阳棋",
"阳云",
"阳泽",
"曜瑞",
"烨铭",
"烨然",
"烨烁",
"烨煜",
"烨昀",
"一庆",
"依祥",
"宜然",
"忆旭",
"亦民",
"意智",
"熠彤",
"懿浩",
"胤骞",
"英豪",
"英杰",
"英锐",
"英睿",
"英武",
"英卓",
"颖山",
"影金",
"永春",
"永嘉",
"永康",
"永年",
"永寿",
"永思",
"永新",
"永怡",
"永长",
"永贞",
"永卓",
"宇寰",
"宇学",
"宇荫",
"雨广",
"雨华",
"雨松",
"雨星",
"雨星",
"玉宸",
"玉书",
"玉堂",
"玉泽",
"昱火",
"钰泽",
"元白",
"元德",
"元化",
"元嘉",
"元驹",
"元正",
"元洲",
"远年",
"苑柏",
"云孜",
"运诚",
"运杰",
"运莱",
"运鹏",
"泽嘉",
"泽祥",
"泽阳",
"泽语",
"展亦",
"章毓",
"长岳",
"哲昌",
"哲瀚",
"振华",
"振链",
"振平",
"震旭",
"正诚",
"正豪",
"正平",
"正文",
"正梧",
"正真",
"祉琛",
"志行",
"志展",
"志专",
"智晖",
"智敏",
"智明",
"忠豪",
"钟校",
"卓君",
"子凌",
"子民",
"子明",
"子墨",
"子南",
"子平",
"子实",
"子希",
"子真",
"梓东",
"梓舒",
"自明",
"自珍",
"棕皓"
    ];
first_name_list(3, 2) ->
    [
    "白薯",
"白薯◎",
"白薯ζ",
"白薯ξ",
"白薯丶",
"半夏",
"半夏◎",
"半夏ζ",
"半夏ξ",
"半夏丶",
"薄荷糖",
"本萝",
"本萝◎",
"本萝ζ",
"本萝ξ",
"本萝丶",
"晨曦",
"晨曦◎",
"晨曦ζ",
"晨曦ξ",
"晨曦丶",
"澄萌",
"澄萌◎",
"澄萌ζ",
"澄萌ξ",
"澄萌丶",
"持伞猫",
"初雪",
"初雪◎",
"初雪ζ",
"初雪ξ",
"初雪丶",
"大总攻",
"点点圈",
"蝶き梦",
"东南萌",
"嘟醉",
"嘟醉◎",
"嘟醉ζ",
"嘟醉ξ",
"嘟醉丶",
"风之乐",
"花开",
"花开◎",
"花开ζ",
"花开ξ",
"花开丶",
"花客",
"花客◎",
"花客ζ",
"花客ξ",
"花客丶",
"久夏青",
"卷耳",
"卷耳◎",
"卷耳ζ",
"卷耳ξ",
"卷耳丶",
"可爱鬼",
"梨涡酒",
"铃兰",
"铃兰◎",
"铃兰ζ",
"铃兰ξ",
"铃兰丶",
"留蓝",
"留蓝◎",
"留蓝ζ",
"留蓝ξ",
"留蓝丶",
"萝莉病",
"旅行箱",
"绿野",
"绿野◎",
"绿野ζ",
"绿野ξ",
"绿野丶",
"猫咚",
"猫咚◎",
"猫咚ζ",
"猫咚ξ",
"猫咚丶",
"猫耳酱",
"猫猫",
"猫猫◎",
"猫猫ζ",
"猫猫ξ",
"猫猫丶",
"萌比受",
"萌懂",
"萌懂◎",
"萌懂ζ",
"萌懂ξ",
"萌懂丶",
"萌美仁",
"萌眯",
"萌眯◎",
"萌眯ζ",
"萌眯ξ",
"萌眯丶",
"萌糯糯",
"萌趴趴",
"迷你仙",
"喵酱",
"喵酱◎",
"喵酱ζ",
"喵酱ξ",
"喵酱丶",
"喵咩咩",
"茉绿",
"茉绿◎",
"茉绿ζ",
"茉绿ξ",
"茉绿丶",
"木瑾",
"木瑾◎",
"木瑾ζ",
"木瑾ξ",
"木瑾丶",
"木槿花",
"挠心猫",
"闹不闹",
"柠檬ξ",
"青柠",
"青柠◎",
"青柠ζ",
"青柠ξ",
"青柠丶",
"软嘟嘟",
"软果儿",
"软三岁",
"软甜啾",
"森花",
"森花◎",
"森花ζ",
"森花ξ",
"森花丶",
"树上的",
"树瑶风",
"素素猫",
"甜野猫",
"童鞋",
"童鞋◎",
"童鞋ζ",
"童鞋ξ",
"童鞋丶",
"无痕",
"无痕◎",
"无痕ζ",
"无痕ξ",
"无痕丶",
"无眠兔",
"西瓜头",
"相依ζ",
"小公举",
"小鹿",
"小鹿◎",
"小鹿ζ",
"小鹿ξ",
"小鹿丶",
"小缌谂",
"小汤圆",
"小甜心",
"小心肝",
"颜控",
"颜控◎",
"颜控ζ",
"颜控ξ",
"颜控丶",
"樱桃红",
"樱桃子",
"晕菜菜",
"雲朵兒",
"长颈猫",
"猪小二",
"安海",
"安琳",
"安婷",
"安杏",
"碧蝶",
"彬菡",
"冰芙",
"冰蕊",
"博斐",
"彩玲",
"彩燕",
"姹文",
"琛子",
"辰悦",
"宸旭",
"晨锦",
"晨宜",
"程晨",
"聪羽",
"丛妍",
"翠幻",
"丹凡",
"丹婷",
"东忆",
"冬寄",
"尔彤",
"芳多",
"芳瑞",
"芳婷",
"芳伊",
"飞歆",
"霏晗",
"斐婷",
"风柳",
"枫玟",
"谷凡",
"海丹",
"含函",
"函艺",
"晗斓",
"晗璇",
"涵聪",
"涵骄",
"涵娜",
"涵诺",
"菡娣",
"菡晴",
"菡夏",
"泓月",
"华芬",
"幻莺",
"惠枫",
"惠涵",
"惠桃",
"吉杏",
"季伊",
"佳菲",
"佳妮",
"佳晴",
"佳珊",
"佳彤",
"家蓉",
"嘉菲",
"娇遥",
"姣晶",
"洁玲",
"婕文",
"锦怡",
"晶怡",
"景雯",
"景欣",
"景怡",
"镜媛",
"娟怀",
"君晓",
"珂谩",
"珂琼",
"柯燕",
"可惠",
"可娇",
"可娇",
"岢忆",
"岚潞",
"蓝然",
"澜歆",
"乐翊",
"梨访",
"立芝",
"丽晨",
"丽春",
"丽娇",
"丽悦",
"莉椒",
"莉冉",
"琳君",
"琳悦",
"苓芳",
"苓伊",
"玲雨",
"凌雯",
"璐程",
"璐芳",
"露娜",
"露伊",
"泺瑶",
"曼妮",
"曼思",
"曼芸",
"蔓岚",
"美凌",
"美凝",
"美亿",
"美云",
"萌雅",
"梦秋",
"梦文",
"梦妍",
"梦莹",
"梦韵",
"米思",
"淼玲",
"敏倩",
"敏馨",
"敏瑶",
"明玉",
"娜婉",
"娜羽",
"南嫣",
"倪冉",
"宁流",
"宁蓉",
"凝怡",
"诺绯",
"诺蓝",
"沛梦",
"佩宁",
"佩维",
"佩瑶",
"萍琳",
"棋嘉",
"祺煦",
"绮思",
"倩涵",
"倩雅",
"芹扬",
"芩熙",
"琴桐",
"清涵",
"清慕",
"清妍",
"晴钰",
"琼雯",
"琼云",
"秋莉",
"秋楠",
"冉毓",
"蓉宁",
"如涵",
"茹弈",
"茹奕",
"儒琴",
"蕊谷",
"蕊敏",
"蕊凝",
"蕊丝",
"蕊扬",
"蕊谊",
"睿桐",
"润月",
"若香",
"若雅",
"珊岚",
"诗蓓",
"诗婧",
"诗絮",
"世敏",
"抒慧",
"纾潇",
"姝芳",
"姝涵",
"姝皓",
"姝清",
"姝耘",
"淑迪",
"淑倩",
"淑妤",
"水芩",
"思锦",
"思娅",
"素萍",
"太翰",
"亭萱",
"亭瑛",
"婷君",
"婷琳",
"婷蓉",
"婷茹",
"彤茜",
"彤姗",
"婉梦",
"婉漾",
"婉颖",
"婉玉",
"琬茹",
"薇小",
"炜雪",
"文栎",
"文萍",
"文湘",
"文怡",
"文筝",
"雯冬",
"雯蕾",
"雯妮",
"雯珊",
"雯维",
"雯心",
"雯颖",
"紊娟",
"昔文",
"曦萍",
"夏谣",
"香淑",
"湘驰",
"萧妍",
"晓蓓",
"晓琴",
"晓清",
"晓欣",
"筱容",
"心月",
"芯凝",
"欣合",
"欣倩",
"欣媛",
"新柏",
"新慧",
"歆涵",
"歆沁",
"歆钰",
"馨姝",
"鑫蕾",
"秀琰",
"轩可",
"萱白",
"萱铃",
"璇静",
"璇蓝",
"雪鹭",
"雪如",
"雪霞",
"雪瑶",
"寻菡",
"寻琴",
"雅戈",
"雅虹",
"雅妮",
"雅宁",
"雅珊",
"雅欣",
"雅雪",
"雅晔",
"娅玲",
"娅彤",
"娅玉",
"言清",
"妍靖",
"妍丽",
"妍宁",
"妍熙",
"妍雅",
"妍雅",
"炎梦",
"颜晨",
"艳涵",
"艳珊",
"艳雅",
"雁莲",
"雁茜",
"雁蓉",
"雁芷",
"洋凡",
"瑶春",
"瑶可",
"瑶玲",
"瑶微",
"瑶萱",
"烨睿",
"依晗",
"依坤",
"仪旭",
"怡岚",
"怡敏",
"怡轩",
"宜姝",
"宜元",
"亿琳",
"义颖",
"艺华",
"艺晶",
"艺静",
"艺琦",
"忆宸",
"译岚",
"奕涵",
"奕雯",
"奕芯",
"奕懿",
"奕颖",
"羿斓",
"意娇",
"意逸",
"薏莉",
"臆湘",
"萤枫",
"萦宇",
"永君",
"瑜桂",
"瑜楦",
"瑜余",
"宇肜",
"羽静",
"羽儇",
"雨芬",
"雨茹",
"雨萱",
"雨雅",
"雨雁",
"禹昕",
"语蕊",
"语童",
"语欣",
"玉文",
"育遥",
"昱书",
"昱珍",
"毓洁",
"媛怡",
"远妤",
"悦永",
"云畅",
"云勤",
"芸慧",
"芸书",
"芸雅",
"芸懿",
"泽筠",
"之惠",
"芷柳",
"芷蕊",
"智柯",
"智茹",
"竹兰",
"姿雨",
"子菲",
"子琳",
"子曼",
"子鸣",
"子思",
"子昕",
"子优",
"梓蔓",
"紫婷"
    ].

%% 所有组别
get_all_group() ->
    [1, 2, 3].


get_guild_helper_name()->
    <<"小助手"/utf8>>.