-- --------------------------------------------------------
-- 主机:                           127.0.0.1
-- 服务器版本:                        5.5.53 - MySQL Community Server (GPL)
-- 服务器操作系统:                      Win32
-- HeidiSQL 版本:                  12.10.0.7000
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- 导出 yzygame 的数据库结构
DROP DATABASE IF EXISTS `mrzj`;
CREATE DATABASE IF NOT EXISTS `mrzj` /*!40100 DEFAULT CHARACTER SET utf8 */;
USE `mrzj`;

-- 导出  表 yzygame.acc_share_data 结构
DROP TABLE IF EXISTS `acc_share_data`;
CREATE TABLE IF NOT EXISTS `acc_share_data` (
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台账号id',
  `accname` varchar(50) NOT NULL DEFAULT '' COMMENT '平台账号',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '元宝',
  `total_charge` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帐号累计充值值(元宝)',
  `day_charge` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家历史单日最高充值元宝数',
  PRIMARY KEY (`accid`,`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='帐号共享数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.achievement 结构
DROP TABLE IF EXISTS `achievement`;
CREATE TABLE IF NOT EXISTS `achievement` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '成就大类',
  `sub_type` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '小类',
  `id` int(11) NOT NULL,
  `progress` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`type`,`sub_type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家成就数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.achievement_category_reward 结构
DROP TABLE IF EXISTS `achievement_category_reward`;
CREATE TABLE IF NOT EXISTS `achievement_category_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `category` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.achievement_logout 结构
DROP TABLE IF EXISTS `achievement_logout`;
CREATE TABLE IF NOT EXISTS `achievement_logout` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `event_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '事件ID',
  `update_list` varchar(1024) NOT NULL COMMENT '成就更新列表',
  PRIMARY KEY (`player_id`,`event_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就离线数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.achievement_lv 结构
DROP TABLE IF EXISTS `achievement_lv`;
CREATE TABLE IF NOT EXISTS `achievement_lv` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成就等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成就经验',
  `lv_reward_list` varchar(500) NOT NULL DEFAULT '[]' COMMENT '成就奖励领取状态[{lv, status}]',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='成就等级数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.advance_payment_account 结构
DROP TABLE IF EXISTS `advance_payment_account`;
CREATE TABLE IF NOT EXISTS `advance_payment_account` (
  `ref` varchar(63) NOT NULL COMMENT '唯一引用',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `cost_list` varchar(1000) NOT NULL COMMENT '消耗记录',
  `consume_id` int(10) unsigned NOT NULL COMMENT '消耗类型id',
  `about` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `other` varchar(255) NOT NULL DEFAULT '[]' COMMENT '其它数据',
  PRIMARY KEY (`ref`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='预付款记账表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.arena_challenge_cd 结构
DROP TABLE IF EXISTS `arena_challenge_cd`;
CREATE TABLE IF NOT EXISTS `arena_challenge_cd` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家角色id',
  `last_use` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次使用竞技场时间',
  `rest_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余冷却时间',
  `trigger1` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否触发竞技场使用限制',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场玩家挑战cd冷却相关参数表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.arena_real_role 结构
DROP TABLE IF EXISTS `arena_real_role`;
CREATE TABLE IF NOT EXISTS `arena_real_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家排名',
  `history_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史最高排名',
  `reward_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励根据的排名',
  `rank_time` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '排名变更时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场玩家排名';

-- 数据导出被取消选择。

-- 导出  表 yzygame.arena_record 结构
DROP TABLE IF EXISTS `arena_record`;
CREATE TABLE IF NOT EXISTS `arena_record` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  `rival_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '挑战玩家Id',
  `rival_name` varchar(100) NOT NULL DEFAULT '' COMMENT '挑战玩家名字',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '挑战结果',
  `rank_change` int(11) NOT NULL DEFAULT '0' COMMENT '排名变化',
  `code` tinyint(2) NOT NULL COMMENT '挑战方\\被挑战方',
  `role_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战力',
  `rival_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '挑战玩家战力',
  PRIMARY KEY (`role_id`,`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='被挑战记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.arena_season_info 结构
DROP TABLE IF EXISTS `arena_season_info`;
CREATE TABLE IF NOT EXISTS `arena_season_info` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季结算时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场赛季相关数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.auction 结构
DROP TABLE IF EXISTS `auction`;
CREATE TABLE IF NOT EXISTS `auction` (
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `cfg_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖会配置Id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `auction_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖时间',
  `last_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次更新时间',
  PRIMARY KEY (`auction_id`),
  KEY `time` (`time`),
  KEY `last_time` (`last_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖场次表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.auction_goods 结构
DROP TABLE IF EXISTS `auction_goods`;
CREATE TABLE IF NOT EXISTS `auction_goods` (
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物id',
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `goods_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品大类',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `cfg_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖会配置Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍物品拥有者id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `goods_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物状态',
  `bonus_tax_rate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分红税率',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始拍卖时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`goods_id`),
  KEY `auction_id` (`auction_id`),
  KEY `auction_type` (`auction_type`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖物品表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.auction_guild_award 结构
DROP TABLE IF EXISTS `auction_guild_award`;
CREATE TABLE IF NOT EXISTS `auction_guild_award` (
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `award_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`auction_id`,`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：公会奖励信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.auction_info 结构
DROP TABLE IF EXISTS `auction_info`;
CREATE TABLE IF NOT EXISTS `auction_info` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物id',
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍人id',
  `price_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞价',
  `price_list` varchar(256) NOT NULL DEFAULT '' COMMENT '竞价详细',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.auction_log 结构
DROP TABLE IF EXISTS `auction_log`;
CREATE TABLE IF NOT EXISTS `auction_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `goods_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `money_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '价格类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交价格',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `to_world` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否流拍至世界',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖成交记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.auto_id 结构
DROP TABLE IF EXISTS `auto_id`;
CREATE TABLE IF NOT EXISTS `auto_id` (
  `type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '类型 1角色 2物品 3帮派',
  `count` int(11) NOT NULL DEFAULT '0' COMMENT '计数',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='id计数表（合服保留主服数据）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.ban_info 结构
DROP TABLE IF EXISTS `ban_info`;
CREATE TABLE IF NOT EXISTS `ban_info` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '禁止序号',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '禁止类型(1:ip)',
  `value` varchar(20) NOT NULL COMMENT '禁止的值',
  PRIMARY KEY (`id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='禁止数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_ac 结构
DROP TABLE IF EXISTS `base_ac`;
CREATE TABLE IF NOT EXISTS `base_ac` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能ID',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `ac_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `ac_name` varchar(1024) NOT NULL COMMENT '活动名称@lang@',
  `ac_icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '活动图标',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数标记',
  `start_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开启等级',
  `end_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动消失等级',
  `ac_type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `week` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每日每周',
  `month` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每月第几天',
  `time` varchar(255) NOT NULL DEFAULT '[]' COMMENT '固定日期',
  `time_region` varchar(255) NOT NULL DEFAULT '[]' COMMENT '具体时间段',
  `open_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服第几天',
  `merge_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服第几天',
  `about` varchar(1024) NOT NULL COMMENT '活动描述@lang@',
  `reward` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '活动奖励显示',
  `ask` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '“问号”按钮',
  `look` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '“查看活动”按钮',
  `other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '其他条件',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序值',
  `jump_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '跳转id(客户端用)',
  `filter_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '筛选id',
  `node_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '生效节点',
  `pre_notice` int(11) NOT NULL COMMENT '提前预告显示',
  `sign` tinyint(1) NOT NULL DEFAULT '0' COMMENT '标签',
  PRIMARY KEY (`module`,`module_sub`,`ac_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动日历';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_achievement 结构
DROP TABLE IF EXISTS `base_achievement`;
CREATE TABLE IF NOT EXISTS `base_achievement` (
  `category` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成就章节',
  `sub_category` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排列顺序',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成就类别(前端展示)',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '成就名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '成就描述@lang@',
  `is_hide` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否是隐藏成就 0:不是 1:是',
  `is_inherit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否继承前一成就的进度 0:不继承 1:继承',
  `show_progress` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示成就进度 0:不显示 1:显示',
  `condition` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '达成条件',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成就经验',
  `client_skip` varchar(255) NOT NULL DEFAULT '[]' COMMENT '客户端跳转',
  PRIMARY KEY (`category`,`sub_category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_achievement_category_reward 结构
DROP TABLE IF EXISTS `base_achievement_category_reward`;
CREATE TABLE IF NOT EXISTS `base_achievement_category_reward` (
  `category` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `count` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '章节细节数',
  PRIMARY KEY (`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就星级奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_achievement_kv 结构
DROP TABLE IF EXISTS `base_achievement_kv`;
CREATE TABLE IF NOT EXISTS `base_achievement_kv` (
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_achievement_stage 结构
DROP TABLE IF EXISTS `base_achievement_stage`;
CREATE TABLE IF NOT EXISTS `base_achievement_stage` (
  `stage` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需求经验',
  `attr_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='成就-等级配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_achievement_stage_privilege 结构
DROP TABLE IF EXISTS `base_achievement_stage_privilege`;
CREATE TABLE IF NOT EXISTS `base_achievement_stage_privilege` (
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '等级名称',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  `content` varchar(500) NOT NULL DEFAULT '' COMMENT '特殊定制',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前端展示Icon',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='成就-成就等级特权配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_activity_liveness 结构
DROP TABLE IF EXISTS `base_activity_liveness`;
CREATE TABLE IF NOT EXISTS `base_activity_liveness` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `icon` varchar(500) NOT NULL DEFAULT '""' COMMENT '图标',
  `act_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型：1-非限时活动；2-限时活动',
  `name` varchar(1024) NOT NULL COMMENT '名称@lang@',
  `start_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开始等级',
  `end_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消失等级',
  `max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单项活动获得活跃度的总次数',
  `res_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可找回的次数上限',
  `live` int(11) NOT NULL DEFAULT '0' COMMENT '活跃度单次',
  `hidden` int(11) NOT NULL DEFAULT '0' COMMENT '是否隐藏1隐藏',
  PRIMARY KEY (`module`,`module_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_activity_push 结构
DROP TABLE IF EXISTS `base_activity_push`;
CREATE TABLE IF NOT EXISTS `base_activity_push` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能ID',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `push` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动推送',
  `push_msg` varchar(1024) NOT NULL COMMENT '推送消息@lang@',
  PRIMARY KEY (`module`,`module_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动推送配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_activity_reward 结构
DROP TABLE IF EXISTS `base_activity_reward`;
CREATE TABLE IF NOT EXISTS `base_activity_reward` (
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT '序号',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'ID',
  `min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级下限',
  `max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级上限',
  `live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`sort`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_act_boss_info 结构
DROP TABLE IF EXISTS `base_act_boss_info`;
CREATE TABLE IF NOT EXISTS `base_act_boss_info` (
  `scene` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '场景名字',
  `boss_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS怪物id',
  `position_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '随机坐标',
  PRIMARY KEY (`scene`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动BOSS-信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_act_boss_kv 结构
DROP TABLE IF EXISTS `base_act_boss_kv`;
CREATE TABLE IF NOT EXISTS `base_act_boss_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动BOSS-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_act_boss_rank 结构
DROP TABLE IF EXISTS `base_act_boss_rank`;
CREATE TABLE IF NOT EXISTS `base_act_boss_rank` (
  `rank_high` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '最高排名',
  `rank_low` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '最低排名',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动BOSS-击杀排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_act_slice_task 结构
DROP TABLE IF EXISTS `base_act_slice_task`;
CREATE TABLE IF NOT EXISTS `base_act_slice_task` (
  `suit` int(11) NOT NULL DEFAULT '0' COMMENT '套件id',
  `row` int(11) NOT NULL DEFAULT '0' COMMENT '行',
  `colu` int(11) NOT NULL DEFAULT '0' COMMENT '列',
  `mod` int(11) NOT NULL DEFAULT '0' COMMENT '模块',
  `sub` int(11) NOT NULL DEFAULT '0' COMMENT '子ID',
  `name` varchar(200) NOT NULL DEFAULT '[]' COMMENT '功能描述',
  `times` int(11) NOT NULL DEFAULT '0' COMMENT '次数要求',
  `jump` varchar(200) NOT NULL DEFAULT '[]' COMMENT '功能跳转',
  PRIMARY KEY (`suit`,`row`,`colu`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='拼图任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_ac_cuscom 结构
DROP TABLE IF EXISTS `base_ac_cuscom`;
CREATE TABLE IF NOT EXISTS `base_ac_cuscom` (
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `ac_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `ac_name` varchar(1024) NOT NULL COMMENT '活动名称@lang@',
  `week` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每日每周',
  `month` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每月第几天',
  `time` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '固定日期',
  `time_region` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '具体时间段',
  `start_timestamp` varchar(1024) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_timestamp` varchar(1024) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `open_day` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '开服第几天',
  `merge_day` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '合服第几天',
  `about` varchar(1024) NOT NULL COMMENT '活动描述@lang@',
  `other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '其他条件',
  PRIMARY KEY (`module_sub`,`ac_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动（官服）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_ac_kv 结构
DROP TABLE IF EXISTS `base_ac_kv`;
CREATE TABLE IF NOT EXISTS `base_ac_kv` (
  `key` int(11) NOT NULL DEFAULT '0' COMMENT 'key',
  `value` varchar(1024) NOT NULL DEFAULT '0' COMMENT 'value',
  `about` varchar(1024) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动日历KV';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_adventure_act_reward 结构
DROP TABLE IF EXISTS `base_adventure_act_reward`;
CREATE TABLE IF NOT EXISTS `base_adventure_act_reward` (
  `sub_id` smallint(5) NOT NULL DEFAULT '0' COMMENT '映射id',
  `grade_id` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励id',
  `reward_list` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `rate` smallint(5) DEFAULT '0' COMMENT '权重',
  PRIMARY KEY (`sub_id`,`grade_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='冒险征途-随机奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_adventure_act_task 结构
DROP TABLE IF EXISTS `base_adventure_act_task`;
CREATE TABLE IF NOT EXISTS `base_adventure_act_task` (
  `suit_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '套装Id',
  `mod_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块Id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '功能名称',
  `one_points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次可得狂欢值',
  `max_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '狂欢次数上限',
  `order_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序id',
  `jump_id` varchar(255) NOT NULL DEFAULT '' COMMENT '跳转id',
  `about` varchar(1024) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`suit_id`,`mod_id`,`sub_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='冒险征途活动配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_ai 结构
DROP TABLE IF EXISTS `base_ai`;
CREATE TABLE IF NOT EXISTS `base_ai` (
  `type` int(11) unsigned NOT NULL COMMENT '类型',
  `mon_id` int(10) unsigned NOT NULL COMMENT '怪物ID',
  `param` varchar(255) NOT NULL COMMENT '参数，多个需要分隔',
  `ai` text NOT NULL COMMENT '1.发送传闻 AI类型:cw 参数:  [传闻类型(1世界,2场景), <<"文字内容">>]  2.怪物说话 AI类型:msg 参数:  [怪物id, <<"文字内容">>]  3.创建怪物 AI类型 create_mon 参数:  [怪物id,最小x坐标,最大x坐标,最小y坐标,最大y坐标,是否主动,高阶参数]',
  `remark` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`mon_id`,`type`,`param`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='AI配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_ai_content 结构
DROP TABLE IF EXISTS `base_ai_content`;
CREATE TABLE IF NOT EXISTS `base_ai_content` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'AI库id',
  `content` text NOT NULL COMMENT '1.发送传闻 AI类型:cw 参数:  [传闻类型(1世界,2场景), <<"文字内容">>]  2.怪物说话 AI类型:msg 参数:  [怪物id, <<"文字内容">>]  3.创建怪物 AI类型 create_mon 参数:  [怪物id,最小x坐标,最大x坐标,最小y坐标,最大y坐标,是否主动,高阶参数]',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_ai_hp_mon 结构
DROP TABLE IF EXISTS `base_ai_hp_mon`;
CREATE TABLE IF NOT EXISTS `base_ai_hp_mon` (
  `mon_id` int(11) unsigned NOT NULL COMMENT '怪物Id',
  `is_one_off` int(11) unsigned NOT NULL COMMENT '血量ai是否只执行一次:1:是;0:否',
  PRIMARY KEY (`mon_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='血量AI只执行一次的怪';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_badge 结构
DROP TABLE IF EXISTS `base_arena_badge`;
CREATE TABLE IF NOT EXISTS `base_arena_badge` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `rank_min` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '最小名次',
  `rank_max` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '最大名次',
  `award` varchar(500) NOT NULL DEFAULT '[]' COMMENT '赛季奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场-徽章';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_battle_reward 结构
DROP TABLE IF EXISTS `base_arena_battle_reward`;
CREATE TABLE IF NOT EXISTS `base_arena_battle_reward` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `max_rank` smallint(5) unsigned NOT NULL COMMENT '被挑战者最高排名',
  `min_rank` smallint(5) unsigned NOT NULL COMMENT '被挑战者最低排名',
  `win_reward` varchar(255) NOT NULL COMMENT '获胜奖励',
  `lose_reward` varchar(255) NOT NULL COMMENT '失败奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场战斗奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_break_reward 结构
DROP TABLE IF EXISTS `base_arena_break_reward`;
CREATE TABLE IF NOT EXISTS `base_arena_break_reward` (
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) NOT NULL COMMENT '最大排名',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`min_rank`,`max_rank`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排名突破奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_buy_num 结构
DROP TABLE IF EXISTS `base_arena_buy_num`;
CREATE TABLE IF NOT EXISTS `base_arena_buy_num` (
  `num` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数',
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '货币类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '价格',
  `need_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需要vip等级',
  PRIMARY KEY (`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='购买次数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_config 结构
DROP TABLE IF EXISTS `base_arena_config`;
CREATE TABLE IF NOT EXISTS `base_arena_config` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'ID',
  `value` varchar(1024) NOT NULL DEFAULT '0' COMMENT '值',
  `about` varchar(1024) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_daily_reward 结构
DROP TABLE IF EXISTS `base_arena_daily_reward`;
CREATE TABLE IF NOT EXISTS `base_arena_daily_reward` (
  `lv_min` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最小等级',
  `lv_max` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最大等级',
  `award_first` varchar(500) NOT NULL DEFAULT '[]' COMMENT '首胜奖励',
  `award_num` varchar(500) NOT NULL DEFAULT '[]' COMMENT '5战奖励',
  PRIMARY KEY (`lv_min`,`lv_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场-每日战斗奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_exp_reward 结构
DROP TABLE IF EXISTS `base_arena_exp_reward`;
CREATE TABLE IF NOT EXISTS `base_arena_exp_reward` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '等级下限',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '等级上限',
  `win_exp` int(11) unsigned NOT NULL COMMENT '胜利经验',
  `lose_exp` int(11) unsigned NOT NULL COMMENT '失败经验',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场战斗经验奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_fake_attr 结构
DROP TABLE IF EXISTS `base_arena_fake_attr`;
CREATE TABLE IF NOT EXISTS `base_arena_fake_attr` (
  `id` smallint(5) unsigned NOT NULL COMMENT '区域排名id',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `fake_role_lv` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '假人等级',
  `fake_role_carrer` smallint(5) NOT NULL DEFAULT '3' COMMENT '职业',
  `combat` varchar(255) NOT NULL COMMENT '假人战力范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场假人配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_search 结构
DROP TABLE IF EXISTS `base_arena_search`;
CREATE TABLE IF NOT EXISTS `base_arena_search` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名区域',
  `min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `max_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大搜索范围',
  `min_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小搜索范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='对手搜索配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_arena_season_award 结构
DROP TABLE IF EXISTS `base_arena_season_award`;
CREATE TABLE IF NOT EXISTS `base_arena_season_award` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季Id',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小名次',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大名次',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `rare_award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '珍稀奖励',
  `daily_award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每日奖励',
  PRIMARY KEY (`id`,`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场-赛季奖励表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_act 结构
DROP TABLE IF EXISTS `base_auction_act`;
CREATE TABLE IF NOT EXISTS `base_auction_act` (
  `opday_slot` varchar(100) NOT NULL COMMENT '开服天数',
  `cfg_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '配置ID',
  `sys_goods` varchar(5120) NOT NULL COMMENT '系统物品',
  `start_time` varchar(256) NOT NULL COMMENT '开始时间',
  `end_time` varchar(256) NOT NULL COMMENT '结束时间',
  PRIMARY KEY (`opday_slot`,`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='系统拍卖活动';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_catalog 结构
DROP TABLE IF EXISTS `base_auction_catalog`;
CREATE TABLE IF NOT EXISTS `base_auction_catalog` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `name` varchar(255) NOT NULL COMMENT '类目名称@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖类目';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_common_args 结构
DROP TABLE IF EXISTS `base_auction_common_args`;
CREATE TABLE IF NOT EXISTS `base_auction_common_args` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `zone` int(11) NOT NULL DEFAULT '0' COMMENT '战区',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '参数设定',
  PRIMARY KEY (`module_id`,`zone`,`min_rank`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_common_liveness 结构
DROP TABLE IF EXISTS `base_auction_common_liveness`;
CREATE TABLE IF NOT EXISTS `base_auction_common_liveness` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级上限',
  `min_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度下限',
  `max_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度上限',
  `reward_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖池价值参数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_common_reward 结构
DROP TABLE IF EXISTS `base_auction_common_reward`;
CREATE TABLE IF NOT EXISTS `base_auction_common_reward` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `zone` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '战区',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖池',
  PRIMARY KEY (`module_id`,`zone`,`min_world_lv`,`min_rank`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_goods 结构
DROP TABLE IF EXISTS `base_auction_goods`;
CREATE TABLE IF NOT EXISTS `base_auction_goods` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `server_lv_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `server_lv_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类',
  `guild_price_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖价格类型',
  `guild_base_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖基础价',
  `guild_add_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖单次加价',
  `guild_one_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖一口价',
  `world_price_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖价格类型',
  `world_base_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖基础价',
  `world_add_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖单次加价',
  `world_one_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖一口价',
  `price_add_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍加价比例',
  `server_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器等级',
  `gold_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '消耗钻石类型',
  `price_types` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '世界价格类型',
  `world_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖价格',
  `personal_base_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人拍卖价格',
  `personal_one_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人拍卖一口价',
  PRIMARY KEY (`goods_id`,`server_lv_min`,`server_lv_max`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_keyvalues 结构
DROP TABLE IF EXISTS `base_auction_keyvalues`;
CREATE TABLE IF NOT EXISTS `base_auction_keyvalues` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '常量Id',
  `value` varchar(512) NOT NULL COMMENT '常量值',
  `about` varchar(512) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_liveness_tax 结构
DROP TABLE IF EXISTS `base_auction_liveness_tax`;
CREATE TABLE IF NOT EXISTS `base_auction_liveness_tax` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小公会活跃度',
  `max_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大公会活跃度',
  `tax_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '税率',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会拍卖活跃度税率配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_auction_mem_tax 结构
DROP TABLE IF EXISTS `base_auction_mem_tax`;
CREATE TABLE IF NOT EXISTS `base_auction_mem_tax` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_mem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小公会人数',
  `max_mem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大公会人数',
  `tax_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '税率',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会拍卖人数税率配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_award_exp 结构
DROP TABLE IF EXISTS `base_award_exp`;
CREATE TABLE IF NOT EXISTS `base_award_exp` (
  `mid` int(20) NOT NULL COMMENT '模块ID',
  `sid` int(20) NOT NULL COMMENT '功能ID',
  `lv_min` int(20) NOT NULL COMMENT '等级下限',
  `lv_max` int(20) NOT NULL COMMENT '等级上限',
  `extra` int(20) NOT NULL COMMENT '周期性经验加成系数（千分比）',
  PRIMARY KEY (`mid`,`sid`,`lv_min`,`lv_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能经验系数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_baby_building_show 结构
DROP TABLE IF EXISTS `base_baby_building_show`;
CREATE TABLE IF NOT EXISTS `base_baby_building_show` (
  `building_id` int(10) unsigned NOT NULL COMMENT '建筑类型',
  `pos` varchar(215) NOT NULL COMMENT '坐标',
  `remark` varchar(255) NOT NULL DEFAULT '[]' COMMENT '备注@lang@',
  PRIMARY KEY (`building_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝驻守显示表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_baby_cost 结构
DROP TABLE IF EXISTS `base_baby_cost`;
CREATE TABLE IF NOT EXISTS `base_baby_cost` (
  `id` bigint(10) unsigned NOT NULL COMMENT '物品ID',
  `goods_id` bigint(10) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `exp` int(10) unsigned NOT NULL COMMENT '增加经验值',
  `grade` varchar(255) NOT NULL COMMENT '适用宝宝品阶',
  PRIMARY KEY (`id`),
  UNIQUE KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-升级道具配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_baby_talent 结构
DROP TABLE IF EXISTS `base_baby_talent`;
CREATE TABLE IF NOT EXISTS `base_baby_talent` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `talent_type` int(10) unsigned NOT NULL COMMENT '天赋类型',
  `talent_name` varchar(215) NOT NULL COMMENT '天赋名称@lang@',
  `image_id` int(10) unsigned NOT NULL COMMENT '图标ID',
  `grade` int(10) unsigned NOT NULL COMMENT '天赋品质',
  `planet` int(10) unsigned NOT NULL COMMENT '归属星球',
  `planet_name` varchar(215) NOT NULL COMMENT '星球名字@lang@',
  `talent` varchar(512) NOT NULL COMMENT '天赋效果',
  `learn_time` int(10) unsigned NOT NULL COMMENT '学习耗时',
  `learn_cost` varchar(512) NOT NULL COMMENT '学习消耗',
  `reset_time` int(10) unsigned NOT NULL COMMENT '重置耗时',
  `reset_cost` varchar(512) NOT NULL COMMENT '重置消耗',
  `up_time` int(10) unsigned NOT NULL COMMENT '提升耗时',
  `up_cost` varchar(512) NOT NULL COMMENT '提升消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-天赋配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_baby_type 结构
DROP TABLE IF EXISTS `base_baby_type`;
CREATE TABLE IF NOT EXISTS `base_baby_type` (
  `id` int(10) unsigned NOT NULL COMMENT '宝宝ID',
  `grade` int(10) unsigned NOT NULL COMMENT '品阶',
  `name` varchar(215) NOT NULL COMMENT '名称@lang@',
  `resource_id` int(10) unsigned NOT NULL COMMENT '模型ID',
  `mid` bigint(10) unsigned NOT NULL COMMENT '宝宝怪物ID',
  `image_source` varchar(255) NOT NULL COMMENT '头像资源',
  `cost` varchar(512) NOT NULL COMMENT '激活消耗',
  `open_num` varchar(512) NOT NULL COMMENT '天赋格子开启',
  `open_grade` varchar(512) NOT NULL COMMENT '天赋品质开启',
  `learn_grade` varchar(255) NOT NULL COMMENT '学习品质开启',
  `skill` varchar(512) NOT NULL COMMENT '技能',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-种类配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_baby_uplv 结构
DROP TABLE IF EXISTS `base_baby_uplv`;
CREATE TABLE IF NOT EXISTS `base_baby_uplv` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `grade` int(10) unsigned NOT NULL COMMENT '品阶',
  `baby_id` int(10) unsigned NOT NULL COMMENT '宝宝ID',
  `name` varchar(215) NOT NULL COMMENT '名字@lang@',
  `lv` int(10) unsigned NOT NULL COMMENT '等级',
  `exp` int(10) unsigned NOT NULL COMMENT '升到下一级所需经验',
  `attr` varchar(512) NOT NULL COMMENT '属性加成',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-升级配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_beach_dummy 结构
DROP TABLE IF EXISTS `base_beach_dummy`;
CREATE TABLE IF NOT EXISTS `base_beach_dummy` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `location` varchar(255) NOT NULL DEFAULT '' COMMENT '坐标',
  `model` varchar(255) NOT NULL DEFAULT '0' COMMENT '普通模型',
  `fashion_model` varchar(255) NOT NULL DEFAULT '' COMMENT '时装模型',
  `name` varchar(255) NOT NULL DEFAULT '魅力舞者' COMMENT '名字',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='温泉-假人配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_beach_kv 结构
DROP TABLE IF EXISTS `base_beach_kv`;
CREATE TABLE IF NOT EXISTS `base_beach_kv` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `key` varchar(255) NOT NULL COMMENT '键',
  `value` varchar(255) NOT NULL COMMENT '值',
  `desc` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魅力海滩常量配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_beach_reward 结构
DROP TABLE IF EXISTS `base_beach_reward`;
CREATE TABLE IF NOT EXISTS `base_beach_reward` (
  `rank_ll` int(20) NOT NULL COMMENT '等级下限',
  `rank_ul` int(20) NOT NULL COMMENT '等级上限',
  `reward` varchar(1024) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`rank_ll`,`rank_ul`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魅力值排行榜奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_beauty_contest 结构
DROP TABLE IF EXISTS `base_beauty_contest`;
CREATE TABLE IF NOT EXISTS `base_beauty_contest` (
  `rank_high` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `rank_low` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_beauty_contest_kv 结构
DROP TABLE IF EXISTS `base_beauty_contest_kv`;
CREATE TABLE IF NOT EXISTS `base_beauty_contest_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(5000) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_boss_cfg 结构
DROP TABLE IF EXISTS `base_boss_cfg`;
CREATE TABLE IF NOT EXISTS `base_boss_cfg` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `type` tinyint(1) unsigned DEFAULT '0' COMMENT 'boss类型',
  `scene` int(11) unsigned DEFAULT '0' COMMENT 'boss出生场景id',
  `x` int(11) unsigned DEFAULT '0' COMMENT '出生x坐标',
  `y` int(11) unsigned DEFAULT '0' COMMENT '出生y坐标',
  `range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伤害计算范围',
  `rand_xy` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '随机坐标',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生成上限',
  `layers` smallint(5) unsigned DEFAULT '0' COMMENT 'boss层数',
  `drop_lv` int(11) unsigned DEFAULT '0' COMMENT '掉落等级差距',
  `reborn_time` varchar(1000) DEFAULT '[]' COMMENT '重生时间[{开服时间, 重生间隔}...]',
  `goods` varchar(1000) DEFAULT '[]' COMMENT '固定掉落',
  `ratio_goods` varchar(1000) DEFAULT '[]' COMMENT '随机掉落',
  `cost` varchar(1000) DEFAULT '[]' COMMENT '单个boss进入消耗',
  `condition` varchar(1000) DEFAULT '[]' COMMENT '进入条件',
  `stage` varchar(50) NOT NULL DEFAULT '[]' COMMENT '阶数',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人boss对应的副本id',
  `crush_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '碾压属性',
  `recommend_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '推荐属性',
  `recommend_lv` varchar(50) NOT NULL DEFAULT '[]' COMMENT '推荐等级',
  `recommend_power` int(11) NOT NULL DEFAULT '0' COMMENT '推荐战力',
  `image` varchar(255) NOT NULL DEFAULT '""' COMMENT 'boss半身像',
  `peace_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '和平状态',
  `drop_stage` tinyint(1) NOT NULL DEFAULT '0' COMMENT '掉率级别',
  PRIMARY KEY (`boss_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_boss_crush_r 结构
DROP TABLE IF EXISTS `base_boss_crush_r`;
CREATE TABLE IF NOT EXISTS `base_boss_crush_r` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性',
  `attr_r` double unsigned NOT NULL DEFAULT '0' COMMENT '属性比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`id`,`attr_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_boss_kv 结构
DROP TABLE IF EXISTS `base_boss_kv`;
CREATE TABLE IF NOT EXISTS `base_boss_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_boss_lv_crush_r 结构
DROP TABLE IF EXISTS `base_boss_lv_crush_r`;
CREATE TABLE IF NOT EXISTS `base_boss_lv_crush_r` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人物等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人物等级上限',
  `diff_min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物-人物等级下限',
  `diff_max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物-人物等级上限',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_boss_power_crush 结构
DROP TABLE IF EXISTS `base_boss_power_crush`;
CREATE TABLE IF NOT EXISTS `base_boss_power_crush` (
  `power_r` double NOT NULL DEFAULT '0' COMMENT '战力比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`power_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss战力碾压配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_boss_rank_reward 结构
DROP TABLE IF EXISTS `base_boss_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_boss_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss_id',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_boss_type 结构
DROP TABLE IF EXISTS `base_boss_type`;
CREATE TABLE IF NOT EXISTS `base_boss_type` (
  `boss_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'boss类型##1:世界Boss;2:个人Boss;3:Boss之家;4:蛮荒禁地',
  `count` int(11) unsigned DEFAULT '0' COMMENT '每天限制次数',
  `module` int(11) unsigned DEFAULT '0' COMMENT '模块id',
  `daily_id` smallint(5) unsigned DEFAULT '0' COMMENT '计数器id',
  `max_anger` int(11) unsigned DEFAULT '0' COMMENT '最大怒气值',
  `tired` int(11) unsigned DEFAULT '0' COMMENT '最大疲劳值',
  `cost` varchar(1000) DEFAULT '[]' COMMENT '该类型boss进入的消耗',
  `condition` varchar(1000) DEFAULT '[]' COMMENT '该类型boss进入的条件',
  `mon_ids` varchar(300) NOT NULL DEFAULT '[]' COMMENT '蛮荒禁地的小怪id',
  `refresh_time` varchar(255) NOT NULL DEFAULT '[]' COMMENT '定时刷新的时间点',
  `enter_reward_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参与奖次数',
  `revive_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '原地复活消耗',
  PRIMARY KEY (`boss_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_camp_war_kv 结构
DROP TABLE IF EXISTS `base_camp_war_kv`;
CREATE TABLE IF NOT EXISTS `base_camp_war_kv` (
  `key` varchar(255) NOT NULL COMMENT '主键',
  `val` varchar(255) NOT NULL COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服团战-常量配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_camp_war_mirror_rewards 结构
DROP TABLE IF EXISTS `base_camp_war_mirror_rewards`;
CREATE TABLE IF NOT EXISTS `base_camp_war_mirror_rewards` (
  `rank_min` int(11) NOT NULL COMMENT '排名上限',
  `rank_max` int(11) NOT NULL COMMENT '排名下限',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '排名奖励',
  PRIMARY KEY (`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人镜像排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_camp_war_rank_reward 结构
DROP TABLE IF EXISTS `base_camp_war_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_camp_war_rank_reward` (
  `rank_min` int(11) NOT NULL COMMENT '排名上限',
  `rank_max` int(11) NOT NULL COMMENT '排名下限',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服团战-社团排行奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_camp_war_role_rank_reward 结构
DROP TABLE IF EXISTS `base_camp_war_role_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_camp_war_role_rank_reward` (
  `rank_min` int(11) NOT NULL COMMENT '排名上限',
  `rank_max` int(11) NOT NULL DEFAULT '0' COMMENT '排名下限',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '排行奖励',
  PRIMARY KEY (`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服团战-个人排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_egg_exchange 结构
DROP TABLE IF EXISTS `base_capsule_egg_exchange`;
CREATE TABLE IF NOT EXISTS `base_capsule_egg_exchange` (
  `id` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '兑换物品',
  `cost_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗积分',
  `exchange_times` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '可兑换次数',
  `limit_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '限购类型',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='扭蛋-积分兑换配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_egg_kv 结构
DROP TABLE IF EXISTS `base_capsule_egg_kv`;
CREATE TABLE IF NOT EXISTS `base_capsule_egg_kv` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='扭蛋键值配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_egg_ratio 结构
DROP TABLE IF EXISTS `base_capsule_egg_ratio`;
CREATE TABLE IF NOT EXISTS `base_capsule_egg_ratio` (
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '档位',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '概率类型 1-个人 2-全服',
  `low` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下限',
  `high` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `add_weight` int(11) NOT NULL DEFAULT '0' COMMENT '权重加成',
  PRIMARY KEY (`pool_type`,`color`,`type`,`low`,`high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='扭蛋-动态概率配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_egg_reward 结构
DROP TABLE IF EXISTS `base_capsule_egg_reward`;
CREATE TABLE IF NOT EXISTS `base_capsule_egg_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '档位(品质)',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `client_pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '客户端展示位置',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='扭蛋-抽奖物品配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_egg_times 结构
DROP TABLE IF EXISTS `base_capsule_egg_times`;
CREATE TABLE IF NOT EXISTS `base_capsule_egg_times` (
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `draw_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖次数',
  `select_color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '必得物品档位',
  PRIMARY KEY (`pool_type`,`draw_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='扭蛋-次数必得配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_egg_times_reward 结构
DROP TABLE IF EXISTS `base_capsule_egg_times_reward`;
CREATE TABLE IF NOT EXISTS `base_capsule_egg_times_reward` (
  `pool_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `draw_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖次数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`pool_type`,`draw_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神宝库-次数奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_toys_constant 结构
DROP TABLE IF EXISTS `base_capsule_toys_constant`;
CREATE TABLE IF NOT EXISTS `base_capsule_toys_constant` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号ID',
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT '关键词',
  `value` varchar(128) NOT NULL DEFAULT '' COMMENT '值',
  `describe` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='扭蛋常量表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_capsule_toys_reward 结构
DROP TABLE IF EXISTS `base_capsule_toys_reward`;
CREATE TABLE IF NOT EXISTS `base_capsule_toys_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `lower_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限(包含）',
  `upper_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限(包含)',
  `reward_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '奖励格式',
  `rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `special_effects` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有特效',
  `broadcast` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `rare` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否珍藏',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='扭蛋奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_career 结构
DROP TABLE IF EXISTS `base_career`;
CREATE TABLE IF NOT EXISTS `base_career` (
  `career_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '职业编号',
  `career_name` varchar(255) NOT NULL COMMENT '职业名字',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  PRIMARY KEY (`career_id`,`sex`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='职业类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_center_zone 结构
DROP TABLE IF EXISTS `base_center_zone`;
CREATE TABLE IF NOT EXISTS `base_center_zone` (
  `stage` tinyint(3) unsigned NOT NULL COMMENT '分区阶段（从1开始，必须是连续的）',
  `open_days` smallint(5) unsigned NOT NULL DEFAULT '2' COMMENT '开服天数',
  `world_level` smallint(5) unsigned NOT NULL COMMENT '世界等级要求',
  `clique_cnt` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '阵营数量（策划用）',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服中心标准分区';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_change_name 结构
DROP TABLE IF EXISTS `base_change_name`;
CREATE TABLE IF NOT EXISTS `base_change_name` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '配置id',
  `value` varchar(255) NOT NULL COMMENT '值',
  `desc` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色改名';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_chapter 结构
DROP TABLE IF EXISTS `base_chapter`;
CREATE TABLE IF NOT EXISTS `base_chapter` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '任务ID',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '任务等级',
  `awards` text NOT NULL COMMENT '完成奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='章节配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_charm_week_reward 结构
DROP TABLE IF EXISTS `base_charm_week_reward`;
CREATE TABLE IF NOT EXISTS `base_charm_week_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次下限',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '名次奖励',
  `fame_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '额外奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魅力周榜奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_chat_simulation_content 结构
DROP TABLE IF EXISTS `base_chat_simulation_content`;
CREATE TABLE IF NOT EXISTS `base_chat_simulation_content` (
  `classify` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '分类',
  `order` int(10) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '机器人id',
  `content` varchar(5000) NOT NULL DEFAULT '<<>>' COMMENT '内容',
  `space_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '下一句时间间隔',
  `desc` varchar(5000) NOT NULL DEFAULT '<<>>' COMMENT '描述',
  `condition` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '触发条件',
  PRIMARY KEY (`classify`,`id`,`order`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='聊天机器人-聊天内容';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_chat_simulation_robot 结构
DROP TABLE IF EXISTS `base_chat_simulation_robot`;
CREATE TABLE IF NOT EXISTS `base_chat_simulation_robot` (
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '机器人id',
  `name` varchar(50) NOT NULL DEFAULT '<<>>' COMMENT '名字',
  `vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '性别',
  `picture` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头像',
  `lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='聊天机器人-机器人配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_chat_simulation_trigger 结构
DROP TABLE IF EXISTS `base_chat_simulation_trigger`;
CREATE TABLE IF NOT EXISTS `base_chat_simulation_trigger` (
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `lv_min` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '等级区间',
  `lv_max` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '等级区间',
  `content` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '触发内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='聊天机器人-聊天触发';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_daily_task 结构
DROP TABLE IF EXISTS `base_child_daily_task`;
CREATE TABLE IF NOT EXISTS `base_child_daily_task` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `open_level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '开启人物等级',
  `desc` varchar(500) NOT NULL DEFAULT '' COMMENT '任务描述',
  `task_content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '任务内容',
  `reward_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成奖励经验值',
  `client_skip` varchar(255) NOT NULL DEFAULT '' COMMENT '客户端跳转',
  PRIMARY KEY (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子每日任务配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_fashion 结构
DROP TABLE IF EXISTS `base_child_fashion`;
CREATE TABLE IF NOT EXISTS `base_child_fashion` (
  `fashion_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时装Id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `fashion_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '时装类型',
  `fashion_name` varchar(255) NOT NULL DEFAULT '' COMMENT '时装名称',
  `upgrade_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  `attr_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `model_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '模型id',
  `buy_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '购买类别',
  `buy_price` varchar(255) NOT NULL DEFAULT '{}' COMMENT '购买价格',
  `add_carry_weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可增加玩具负重',
  `client_skip` varchar(255) NOT NULL DEFAULT '{}' COMMENT '客户端跳转',
  `desc` varchar(500) NOT NULL DEFAULT '' COMMENT '获取说明',
  PRIMARY KEY (`fashion_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-时装配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_figure 结构
DROP TABLE IF EXISTS `base_child_figure`;
CREATE TABLE IF NOT EXISTS `base_child_figure` (
  `child_sex` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `grow_up_level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成长等级',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型Id',
  PRIMARY KEY (`child_sex`,`grow_up_level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子形象配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_grow_up 结构
DROP TABLE IF EXISTS `base_child_grow_up`;
CREATE TABLE IF NOT EXISTS `base_child_grow_up` (
  `year` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '年龄-年',
  `month` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '年龄-月',
  `next_year` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '下一年龄',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一月需求经验值',
  `attr_list` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `can_carry_weight` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '孩子负重',
  PRIMARY KEY (`year`,`month`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子成长配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_kv 结构
DROP TABLE IF EXISTS `base_child_kv`;
CREATE TABLE IF NOT EXISTS `base_child_kv` (
  `id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `constant` varchar(500) NOT NULL DEFAULT '' COMMENT '常量',
  `remark` varchar(500) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子常量配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_link_heart 结构
DROP TABLE IF EXISTS `base_child_link_heart`;
CREATE TABLE IF NOT EXISTS `base_child_link_heart` (
  `reward_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '奖励Id',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需求同心值',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子同心奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_skill 结构
DROP TABLE IF EXISTS `base_child_skill`;
CREATE TABLE IF NOT EXISTS `base_child_skill` (
  `sequence` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '技能激活顺次',
  `level` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `skill_name` varchar(255) NOT NULL DEFAULT '' COMMENT '技能名称',
  `skill_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '技能描述',
  `active_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活的技能',
  `add_attr_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  `active_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活消耗',
  `pre_sequence` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '前置顺次',
  `need_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需求角色战力',
  PRIMARY KEY (`sequence`,`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-孩子技能配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy 结构
DROP TABLE IF EXISTS `base_child_toy`;
CREATE TABLE IF NOT EXISTS `base_child_toy` (
  `toy_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具Id',
  `toy_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具类别',
  `toy_name` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '玩具名称',
  `toy_weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具重量',
  `toy_color` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具品质',
  `strength_high` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化上限',
  `attr_list` varchar(500) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '玩具属性',
  `target_toy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级目标玩具Id',
  PRIMARY KEY (`toy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=COMPACT COMMENT='孩子-玩具配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_box_upgrade 结构
DROP TABLE IF EXISTS `base_child_toy_box_upgrade`;
CREATE TABLE IF NOT EXISTS `base_child_toy_box_upgrade` (
  `toy_box_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具盒等级',
  `next_cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '下级消耗',
  `add_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  PRIMARY KEY (`toy_box_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子玩具等级配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_forge_content 结构
DROP TABLE IF EXISTS `base_child_toy_forge_content`;
CREATE TABLE IF NOT EXISTS `base_child_toy_forge_content` (
  `id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '库Id',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励Id',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `select_least` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最低出现次数',
  `reward_content` varchar(250) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`id`,`reward_id`,`select_least`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-玩具打造抽取库内容配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_forge_slot_open 结构
DROP TABLE IF EXISTS `base_child_toy_forge_slot_open`;
CREATE TABLE IF NOT EXISTS `base_child_toy_forge_slot_open` (
  `slot_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '玩具打造位Id',
  `condition` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '[]' COMMENT '解锁条件',
  PRIMARY KEY (`slot_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf32 ROW_FORMAT=COMPACT COMMENT='孩子-玩具打造位开启条件配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_forge_time 结构
DROP TABLE IF EXISTS `base_child_toy_forge_time`;
CREATE TABLE IF NOT EXISTS `base_child_toy_forge_time` (
  `id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '库Id',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `need_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需求时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-玩具打造时间抽取库配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_new 结构
DROP TABLE IF EXISTS `base_child_toy_new`;
CREATE TABLE IF NOT EXISTS `base_child_toy_new` (
  `toy_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具Id',
  `toy_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩具名称',
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '套装类别',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `attr_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `decompose_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '分解获得',
  PRIMARY KEY (`toy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子玩具配置表(新)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_slot_open 结构
DROP TABLE IF EXISTS `base_child_toy_slot_open`;
CREATE TABLE IF NOT EXISTS `base_child_toy_slot_open` (
  `slot_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具位',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '解锁条件',
  PRIMARY KEY (`slot_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-玩具位解锁配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_speed_up 结构
DROP TABLE IF EXISTS `base_child_toy_speed_up`;
CREATE TABLE IF NOT EXISTS `base_child_toy_speed_up` (
  `time_low` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间下限',
  `time_high` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间上限',
  `cost` varchar(250) NOT NULL DEFAULT '[]' COMMENT '消耗',
  PRIMARY KEY (`time_low`,`time_high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-玩具打造加速配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_stren 结构
DROP TABLE IF EXISTS `base_child_toy_stren`;
CREATE TABLE IF NOT EXISTS `base_child_toy_stren` (
  `toy_color` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具品质',
  `toy_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具类型',
  `stren_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '强化消耗',
  `add_attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  PRIMARY KEY (`toy_color`,`toy_type`,`stren_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-玩具强化配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_toy_suit 结构
DROP TABLE IF EXISTS `base_child_toy_suit`;
CREATE TABLE IF NOT EXISTS `base_child_toy_suit` (
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '套装类别',
  `suit_name` varchar(255) NOT NULL DEFAULT '' COMMENT '套装名称',
  `sequence` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '序列',
  `collect_reward` varchar(500) NOT NULL DEFAULT '' COMMENT '集满奖励',
  PRIMARY KEY (`suit_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子玩具套装配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_vehicle 结构
DROP TABLE IF EXISTS `base_child_vehicle`;
CREATE TABLE IF NOT EXISTS `base_child_vehicle` (
  `vehicle_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '载具Id',
  `stage` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `vehicle_name` varchar(255) NOT NULL DEFAULT '' COMMENT '载具名称',
  `upgrade_cost` varchar(250) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  `add_attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  `active_skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活技能',
  `add_carry_weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可增加玩具负重',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型Id',
  PRIMARY KEY (`vehicle_id`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-孩子载具配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_child_vote_reward 结构
DROP TABLE IF EXISTS `base_child_vote_reward`;
CREATE TABLE IF NOT EXISTS `base_child_vote_reward` (
  `rank_high` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `rank_low` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `reward_list` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子点赞奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_choose_talk 结构
DROP TABLE IF EXISTS `base_choose_talk`;
CREATE TABLE IF NOT EXISTS `base_choose_talk` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `intellect` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '理性对话',
  `nastic` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '感性对话',
  `indecision` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '优柔(中性)对话',
  `value` varchar(250) NOT NULL DEFAULT '[]' COMMENT '回答加点',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='选项对话配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_cloud_buy 结构
DROP TABLE IF EXISTS `base_cloud_buy`;
CREATE TABLE IF NOT EXISTS `base_cloud_buy` (
  `id` smallint(5) unsigned NOT NULL COMMENT '大奖id',
  `reward_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '奖励类型',
  `rewards` varchar(1000) NOT NULL COMMENT '奖励内容',
  `resouce_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '资源id',
  `resouce_size` int(10) NOT NULL COMMENT '大奖模型尺寸',
  `resouce_height` varchar(50) NOT NULL COMMENT '大奖模型坐标',
  `total_count` int(10) unsigned NOT NULL COMMENT '总份数',
  `cost` varchar(1000) NOT NULL COMMENT '购买消耗',
  `worth` varchar(255) NOT NULL COMMENT '价值',
  `award_count` smallint(5) unsigned NOT NULL COMMENT '开奖份数',
  `happy_awards` varchar(1000) NOT NULL COMMENT '保底奖励##[{权重, {goods,Id,Num}}]',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_cloud_buy_reward 结构
DROP TABLE IF EXISTS `base_cloud_buy_reward`;
CREATE TABLE IF NOT EXISTS `base_cloud_buy_reward` (
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `reward_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '奖励类型',
  `reward_list` varchar(500) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购普通奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_color_type 结构
DROP TABLE IF EXISTS `base_color_type`;
CREATE TABLE IF NOT EXISTS `base_color_type` (
  `color_id` int(11) NOT NULL COMMENT '颜色ID',
  `color_type` varchar(20) NOT NULL COMMENT '颜色RGB',
  `color_name` varchar(20) NOT NULL COMMENT '颜色名称@lang@',
  PRIMARY KEY (`color_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='颜色配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_common_rank_kv 结构
DROP TABLE IF EXISTS `base_common_rank_kv`;
CREATE TABLE IF NOT EXISTS `base_common_rank_kv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜键值表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_common_rank_target_reward 结构
DROP TABLE IF EXISTS `base_common_rank_target_reward`;
CREATE TABLE IF NOT EXISTS `base_common_rank_target_reward` (
  `type` int(11) NOT NULL COMMENT '类型',
  `target` int(11) NOT NULL DEFAULT '0' COMMENT '达成目标',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  PRIMARY KEY (`type`,`target`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜目标奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_compose_menu 结构
DROP TABLE IF EXISTS `base_compose_menu`;
CREATE TABLE IF NOT EXISTS `base_compose_menu` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '菜单id',
  `open_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  `is_bottom` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '有无子菜单 0:没有、1:有',
  `list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '子菜单id列表',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '150' COMMENT '功能id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成菜单';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_compose_menu_id 结构
DROP TABLE IF EXISTS `base_compose_menu_id`;
CREATE TABLE IF NOT EXISTS `base_compose_menu_id` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '菜单id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `open_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '备注@lang@',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '150' COMMENT '功能id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成菜单类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_consume_type 结构
DROP TABLE IF EXISTS `base_consume_type`;
CREATE TABLE IF NOT EXISTS `base_consume_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `for_act` smallint(2) NOT NULL DEFAULT '1' COMMENT '参与消费活动(默认参与)',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='消耗类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_contract_pass_buy 结构
DROP TABLE IF EXISTS `base_contract_pass_buy`;
CREATE TABLE IF NOT EXISTS `base_contract_pass_buy` (
  `sub_type` int(11) NOT NULL COMMENT '活动子类型',
  `normal_price` varchar(255) NOT NULL DEFAULT '[]' COMMENT '普通价格',
  `luxury_price` varchar(255) NOT NULL DEFAULT '[]' COMMENT '尊享价格',
  `luxury_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '尊享奖励',
  `rewards_val` int(11) NOT NULL DEFAULT '0' COMMENT '奖励总价值',
  `discount` varchar(255) NOT NULL DEFAULT '[]' COMMENT '折扣卡',
  PRIMARY KEY (`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通行证-购买配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_contract_pass_task 结构
DROP TABLE IF EXISTS `base_contract_pass_task`;
CREATE TABLE IF NOT EXISTS `base_contract_pass_task` (
  `type` int(11) NOT NULL COMMENT '类型',
  `day` int(11) NOT NULL DEFAULT '0' COMMENT '周几',
  `task_type_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务类型id',
  `cons` int(11) NOT NULL DEFAULT '0' COMMENT '条件',
  `point` int(11) NOT NULL DEFAULT '0' COMMENT '任务积分',
  PRIMARY KEY (`type`,`day`,`task_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通行证-任务配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_contract_rewards 结构
DROP TABLE IF EXISTS `base_contract_rewards`;
CREATE TABLE IF NOT EXISTS `base_contract_rewards` (
  `sub_type` int(11) NOT NULL COMMENT '活动子类型',
  `pass_lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `lv_exp` int(11) NOT NULL DEFAULT '0' COMMENT '等级经验',
  `normal_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '普通奖励',
  `luxury_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '尊享奖励',
  `node_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '节点奖励',
  PRIMARY KEY (`sub_type`,`pass_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通行证奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_contract_task_type 结构
DROP TABLE IF EXISTS `base_contract_task_type`;
CREATE TABLE IF NOT EXISTS `base_contract_task_type` (
  `task_type_id` int(11) NOT NULL COMMENT '任务类型id',
  `open_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开放等级',
  `open_day` int(11) NOT NULL DEFAULT '0' COMMENT '开放天数',
  `task_type` varchar(255) NOT NULL DEFAULT '' COMMENT '任务类型',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '任务描述',
  `link` varchar(255) NOT NULL DEFAULT '[]' COMMENT '跳转',
  `recom` int(11) NOT NULL DEFAULT '0' COMMENT '推荐度',
  PRIMARY KEY (`task_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通行证-任务类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_convoy_exp 结构
DROP TABLE IF EXISTS `base_convoy_exp`;
CREATE TABLE IF NOT EXISTS `base_convoy_exp` (
  `lv_low` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级区间',
  `lv_high` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级区间',
  `convoy_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '护送经验',
  `supporting_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助经验',
  PRIMARY KEY (`lv_low`,`lv_high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送-经验配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_convoy_kv 结构
DROP TABLE IF EXISTS `base_convoy_kv`;
CREATE TABLE IF NOT EXISTS `base_convoy_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(5000) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_convoy_object 结构
DROP TABLE IF EXISTS `base_convoy_object`;
CREATE TABLE IF NOT EXISTS `base_convoy_object` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对象id(怪物id)',
  `name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '名称',
  `upgrade_cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一级id',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '额外奖励',
  `stage_one_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段一经验比例(百分比)',
  `stage_two_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段二普通路线经验比列(百分比)',
  `stage_two_sp_ratio` int(11) NOT NULL DEFAULT '0' COMMENT '阶段二PK路线经验比例(比例)',
  `overdue_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '超时经验比例(百分比)',
  `damaged_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '破损经验比例(百分比)',
  `rob_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '打劫经验比例(百分比)',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送-护送对象';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_convoy_path 结构
DROP TABLE IF EXISTS `base_convoy_path`;
CREATE TABLE IF NOT EXISTS `base_convoy_path` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '路径序号',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '路径阶段',
  `path` varchar(255) NOT NULL DEFAULT '[]' COMMENT '路径',
  `desc` varchar(100) NOT NULL DEFAULT '[]' COMMENT '说明',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送-护送路径';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_con_map_func 结构
DROP TABLE IF EXISTS `base_con_map_func`;
CREATE TABLE IF NOT EXISTS `base_con_map_func` (
  `condition_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '条件Id',
  `func_id` varchar(255) NOT NULL DEFAULT '' COMMENT '功能对应Id',
  PRIMARY KEY (`condition_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='功能预告-功能映射Id配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_counter 结构
DROP TABLE IF EXISTS `base_counter`;
CREATE TABLE IF NOT EXISTS `base_counter` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='终生次数id配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_counter_daily 结构
DROP TABLE IF EXISTS `base_counter_daily`;
CREATE TABLE IF NOT EXISTS `base_counter_daily` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `clock` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理时间',
  `write_db` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否入库',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数id配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_counter_daily_extra 结构
DROP TABLE IF EXISTS `base_counter_daily_extra`;
CREATE TABLE IF NOT EXISTS `base_counter_daily_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `clock` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理时间',
  `write_db` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否入库',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`sub_module`),
  KEY `sub_module` (`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数id配置(额外版)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_counter_extra 结构
DROP TABLE IF EXISTS `base_counter_extra`;
CREATE TABLE IF NOT EXISTS `base_counter_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`sub_module`),
  KEY `sub_module` (`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='终生次数id配置(额外版)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_counter_week 结构
DROP TABLE IF EXISTS `base_counter_week`;
CREATE TABLE IF NOT EXISTS `base_counter_week` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '周定时器类型(0:0点，4:4点)',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每周次数id配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_counter_week_extra 结构
DROP TABLE IF EXISTS `base_counter_week_extra`;
CREATE TABLE IF NOT EXISTS `base_counter_week_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '周定时器类型(0:0点，4:4点)',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`sub_module`),
  KEY `sub_module` (`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每周次数id配置(额外版)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_cross_guild_war 结构
DROP TABLE IF EXISTS `base_cross_guild_war`;
CREATE TABLE IF NOT EXISTS `base_cross_guild_war` (
  `id` int(11) unsigned NOT NULL COMMENT 'Id',
  `week_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '表示周几开',
  `sign_up_period` varchar(255) NOT NULL COMMENT '报名时间段',
  `support_period` varchar(255) NOT NULL COMMENT '应援时间段',
  `battle_period` varchar(255) NOT NULL COMMENT '战场时间段',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战时间配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_cross_guild_war_config 结构
DROP TABLE IF EXISTS `base_cross_guild_war_config`;
CREATE TABLE IF NOT EXISTS `base_cross_guild_war_config` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `value` varchar(3000) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(1000) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_cross_guild_war_mon 结构
DROP TABLE IF EXISTS `base_cross_guild_war_mon`;
CREATE TABLE IF NOT EXISTS `base_cross_guild_war_mon` (
  `id` int(11) unsigned NOT NULL COMMENT '怪物Id',
  `city_id` int(11) NOT NULL COMMENT '城池Id',
  `type_id` int(11) unsigned NOT NULL COMMENT '怪物类型，1战旗，2守护兽',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战怪物城池对应关系配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_cross_guild_war_room 结构
DROP TABLE IF EXISTS `base_cross_guild_war_room`;
CREATE TABLE IF NOT EXISTS `base_cross_guild_war_room` (
  `id` int(11) unsigned NOT NULL COMMENT '房间Id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '房间名称',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战房间配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_cross_guild_war_scene 结构
DROP TABLE IF EXISTS `base_cross_guild_war_scene`;
CREATE TABLE IF NOT EXISTS `base_cross_guild_war_scene` (
  `id` int(11) unsigned NOT NULL COMMENT '城池id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '城池名称',
  `type_id` int(11) unsigned NOT NULL COMMENT '城池类型，1为主城，2为卫城',
  `born_point` varchar(255) NOT NULL COMMENT '出生点，距离此卫城最近的初始出生点，主城无此项；格式为{posX,posY}',
  `revive_point` varchar(255) NOT NULL COMMENT '复活点，占领此卫城后获得的新默认复活点，主城无此项；格式为{posX,posY}',
  `flag` varchar(255) NOT NULL COMMENT '战旗，城中战旗的配置；格式为{怪物id,posX,posY}',
  `mon_list` varchar(255) NOT NULL COMMENT '将军，战旗守护将军的配置；格式为[{怪物id,posX,posY},{},…]',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战场景配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_crusade_dun_count_reward 结构
DROP TABLE IF EXISTS `base_crusade_dun_count_reward`;
CREATE TABLE IF NOT EXISTS `base_crusade_dun_count_reward` (
  `id` int(11) NOT NULL COMMENT '活动id',
  `count` int(11) NOT NULL COMMENT '次数节点',
  `min_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小开服天数',
  `max_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大开服天数',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '次数奖励',
  PRIMARY KEY (`id`,`count`,`min_day`,`max_day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='讨伐副本-次数奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_crusade_subtype_resource 结构
DROP TABLE IF EXISTS `base_crusade_subtype_resource`;
CREATE TABLE IF NOT EXISTS `base_crusade_subtype_resource` (
  `type` int(11) NOT NULL COMMENT '大类类型',
  `sub_type` int(11) NOT NULL COMMENT '子类类型',
  `type_name` varchar(255) NOT NULL DEFAULT '' COMMENT '大类名称',
  `sub_type_name` varchar(255) NOT NULL DEFAULT '' COMMENT '子类名称',
  `scene_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '场景列表',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  `pass_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '通关奖励',
  `boss_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT 'boss奖励',
  `boss_id` int(11) NOT NULL DEFAULT '0' COMMENT 'boss模型id',
  `boss_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'boss名称',
  `icon` int(11) NOT NULL DEFAULT '0' COMMENT '图标id',
  `enter_dun` int(11) NOT NULL DEFAULT '0' COMMENT '默认副本',
  PRIMARY KEY (`type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='讨伐副本-子类资源表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_customer_service 结构
DROP TABLE IF EXISTS `base_customer_service`;
CREATE TABLE IF NOT EXISTS `base_customer_service` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:显示 0:隐藏',
  `display_code` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示二维码',
  `keyword` varchar(100) NOT NULL DEFAULT '' COMMENT '关键字',
  `medium` varchar(255) NOT NULL DEFAULT '' COMMENT '渠道',
  `link_info_1` varchar(1024) NOT NULL DEFAULT '' COMMENT '联系方式1',
  `link_info_2` varchar(1024) NOT NULL DEFAULT '' COMMENT '联系方式2',
  `work_time` varchar(255) NOT NULL DEFAULT '' COMMENT '工作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='客服信息配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_customer_service_vip 结构
DROP TABLE IF EXISTS `base_customer_service_vip`;
CREATE TABLE IF NOT EXISTS `base_customer_service_vip` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:显示 0:隐藏',
  `keyword` varchar(100) NOT NULL DEFAULT '' COMMENT '关键字',
  `medium` varchar(255) NOT NULL DEFAULT '' COMMENT '平台',
  `menu_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '界面显示金额',
  `qq_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'qq显示金额',
  `qq` varchar(255) NOT NULL DEFAULT '' COMMENT 'QQ',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级vip客服信息配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_custom_act 结构
DROP TABLE IF EXISTS `base_custom_act`;
CREATE TABLE IF NOT EXISTS `base_custom_act` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `act_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '活动描述@lang@',
  `opday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服天数限制',
  `merday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服天数限制',
  `optype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '开启类型',
  `opday` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `optime` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启时间段',
  `start_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `clear_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理类型',
  `condition` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '条件',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_custom_act_kv 结构
DROP TABLE IF EXISTS `base_custom_act_kv`;
CREATE TABLE IF NOT EXISTS `base_custom_act_kv` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `key_content` varchar(100) NOT NULL DEFAULT '[]' COMMENT '键',
  `value_content` varchar(100) NOT NULL DEFAULT '[]' COMMENT '值',
  `desc` varchar(100) NOT NULL DEFAULT '[]' COMMENT '描述',
  PRIMARY KEY (`type`,`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-通用配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_custom_act_reward 结构
DROP TABLE IF EXISTS `base_custom_act_reward`;
CREATE TABLE IF NOT EXISTS `base_custom_act_reward` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励名称@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励描述@lang@',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `format` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励格式类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`type`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_custom_act_type 结构
DROP TABLE IF EXISTS `base_custom_act_type`;
CREATE TABLE IF NOT EXISTS `base_custom_act_type` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_days_plan_task 结构
DROP TABLE IF EXISTS `base_days_plan_task`;
CREATE TABLE IF NOT EXISTS `base_days_plan_task` (
  `task_type` int(11) NOT NULL DEFAULT '0' COMMENT '任务类型',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务id',
  `open_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开启等级',
  `recommend` int(11) NOT NULL DEFAULT '0' COMMENT '推荐度',
  `content` int(11) NOT NULL DEFAULT '0' COMMENT '任务内容',
  `desc` varchar(50) NOT NULL DEFAULT '任务描述' COMMENT '任务描述',
  `reward` varchar(50) NOT NULL DEFAULT '[]' COMMENT '任务奖励',
  `link` varchar(50) NOT NULL DEFAULT '[]' COMMENT '任务跳转',
  PRIMARY KEY (`task_type`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='任务配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_days_plan_task_suit 结构
DROP TABLE IF EXISTS `base_days_plan_task_suit`;
CREATE TABLE IF NOT EXISTS `base_days_plan_task_suit` (
  `suit` int(11) NOT NULL DEFAULT '0' COMMENT '任务套件',
  `open_day` int(11) NOT NULL DEFAULT '0' COMMENT '开放天',
  `task_type` int(11) NOT NULL DEFAULT '0' COMMENT '任务类型',
  PRIMARY KEY (`suit`,`open_day`,`task_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='任务套件配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_days_plan_task_type 结构
DROP TABLE IF EXISTS `base_days_plan_task_type`;
CREATE TABLE IF NOT EXISTS `base_days_plan_task_type` (
  `task_type` int(11) NOT NULL COMMENT '任务类型',
  `task_desc` varchar(50) NOT NULL COMMENT '类型描述',
  PRIMARY KEY (`task_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='任务类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_degree 结构
DROP TABLE IF EXISTS `base_degree`;
CREATE TABLE IF NOT EXISTS `base_degree` (
  `degree_id` int(11) NOT NULL DEFAULT '0' COMMENT '学位Id',
  `degree_name` varchar(255) NOT NULL COMMENT '学位名称',
  `icon` int(11) NOT NULL COMMENT '图标Id',
  `attr_list` varchar(500) NOT NULL COMMENT '学位属性列表',
  `need_exp` int(11) NOT NULL DEFAULT '0' COMMENT '需求经验',
  `need_matrial` varchar(500) NOT NULL COMMENT '需求材料',
  `finish_dungeon` int(11) NOT NULL COMMENT '完成副本Id',
  `description` varchar(500) NOT NULL COMMENT '娱乐描述',
  `is_tv` tinyint(10) NOT NULL COMMENT '是否传闻',
  PRIMARY KEY (`degree_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='学位配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_degree_timetable 结构
DROP TABLE IF EXISTS `base_degree_timetable`;
CREATE TABLE IF NOT EXISTS `base_degree_timetable` (
  `class_id` int(11) NOT NULL COMMENT '功课Id',
  `class_name` varchar(255) NOT NULL COMMENT '功课名称',
  `class_desc` varchar(500) NOT NULL COMMENT '功课描述',
  `target` varchar(255) NOT NULL COMMENT '完成目标',
  `award_exp` int(11) NOT NULL COMMENT '经验奖励',
  `need_degree` int(11) NOT NULL COMMENT '学位等级限制',
  PRIMARY KEY (`class_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日常功课配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_deserted_boss_info 结构
DROP TABLE IF EXISTS `base_deserted_boss_info`;
CREATE TABLE IF NOT EXISTS `base_deserted_boss_info` (
  `boss_id` int(11) NOT NULL COMMENT 'bossid',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT 'boss代数',
  `boss_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'boss名字',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT 'boss层数',
  `born_pos` varchar(255) NOT NULL DEFAULT '[]' COMMENT '出生坐标',
  `reborn_time` varchar(500) NOT NULL DEFAULT '[]' COMMENT '重生时间',
  `base_reward` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '普通奖励展示',
  `extra_reward` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '珍稀奖励展示',
  `boss_pic` int(11) NOT NULL DEFAULT '0' COMMENT 'boss头像',
  `recommend_lv` varchar(255) NOT NULL DEFAULT '0' COMMENT '推荐等级',
  `recommend_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '推荐属性',
  `recommend_power` int(11) NOT NULL DEFAULT '0' COMMENT '推荐战力',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='废都boss信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_deserted_kv 结构
DROP TABLE IF EXISTS `base_deserted_kv`;
CREATE TABLE IF NOT EXISTS `base_deserted_kv` (
  `key` varchar(255) NOT NULL COMMENT '主键',
  `val` varchar(255) NOT NULL COMMENT '键值',
  `desc` varchar(255) NOT NULL COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='废都boss常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_deserted_level 结构
DROP TABLE IF EXISTS `base_deserted_level`;
CREATE TABLE IF NOT EXISTS `base_deserted_level` (
  `level` int(11) NOT NULL COMMENT 'boss层数',
  `scene` int(11) NOT NULL DEFAULT '0' COMMENT '场景',
  `open_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开启等级',
  PRIMARY KEY (`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='废都层数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_discount_mall_coupon 结构
DROP TABLE IF EXISTS `base_discount_mall_coupon`;
CREATE TABLE IF NOT EXISTS `base_discount_mall_coupon` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '优惠券id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型##1折扣/2满减',
  `condition` varchar(50) NOT NULL DEFAULT '[]' COMMENT '使用条件',
  `discount` varchar(50) NOT NULL DEFAULT '[]' COMMENT '折扣满减',
  `ab_discount` varchar(500) NOT NULL DEFAULT '[]' COMMENT '绝对满减',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='折扣满减-优惠券';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_discount_mall_coupon_rate 结构
DROP TABLE IF EXISTS `base_discount_mall_coupon_rate`;
CREATE TABLE IF NOT EXISTS `base_discount_mall_coupon_rate` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '优惠券id',
  `weight` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `min_count` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '入库次数下限',
  `max_count` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '入库次数上限',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='折扣满减-抽奖概率';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_distri_scene 结构
DROP TABLE IF EXISTS `base_distri_scene`;
CREATE TABLE IF NOT EXISTS `base_distri_scene` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `distri_scene_id` int(32) unsigned NOT NULL COMMENT '场景ID',
  `scene_name` varchar(128) DEFAULT '""' COMMENT '场景名称',
  `scene_type` int(3) unsigned NOT NULL DEFAULT '0' COMMENT '场景类型',
  `transfer_coordinate` varchar(512) NOT NULL DEFAULT '[]' COMMENT '传送坐标',
  `coordinate` varchar(128) NOT NULL DEFAULT '[]' COMMENT '钓鱼区范围',
  `near_water_area` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '近水域',
  `middle_water_area` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '中水域',
  `far_water_area` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '远水域',
  `open_role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开放等级',
  `open_mastery_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钓鱼等级',
  `home_fish_pond_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家园鱼塘等级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_draw_ratio_show 结构
DROP TABLE IF EXISTS `base_draw_ratio_show`;
CREATE TABLE IF NOT EXISTS `base_draw_ratio_show` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块Id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能Id',
  `sub_act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子Id',
  `award_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励编号',
  `name` varchar(100) NOT NULL COMMENT '活动名称',
  `goods_name` varchar(100) NOT NULL COMMENT '物品',
  `ratio` int(11) NOT NULL DEFAULT '0' COMMENT '概率（10000）',
  PRIMARY KEY (`module`,`sub_module`,`sub_act`,`award_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='抽奖概率展示配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dress_illustration 结构
DROP TABLE IF EXISTS `base_dress_illustration`;
CREATE TABLE IF NOT EXISTS `base_dress_illustration` (
  `illu_lv` int(10) NOT NULL COMMENT '图鉴等级',
  `illu_lvup_exp` int(20) NOT NULL DEFAULT '0' COMMENT '图鉴升级经验',
  `illu_lvup_sttr` varchar(1024) NOT NULL COMMENT '图鉴升级属性',
  PRIMARY KEY (`illu_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='图鉴升级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dress_illustration_mat 结构
DROP TABLE IF EXISTS `base_dress_illustration_mat`;
CREATE TABLE IF NOT EXISTS `base_dress_illustration_mat` (
  `illu_debris_id` int(10) NOT NULL COMMENT '物品id',
  `illu_exp` int(20) NOT NULL DEFAULT '0' COMMENT '图鉴经验',
  PRIMARY KEY (`illu_debris_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴(装扮)消耗材料';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dress_up 结构
DROP TABLE IF EXISTS `base_dress_up`;
CREATE TABLE IF NOT EXISTS `base_dress_up` (
  `dress_id` int(11) NOT NULL COMMENT '装扮id',
  `dress_type` smallint(2) NOT NULL COMMENT '装扮类型',
  `dress_name` varchar(255) NOT NULL COMMENT '装扮名称',
  `dress_desc` varchar(255) NOT NULL COMMENT '装扮描述',
  `dress_consume_id` int(10) NOT NULL DEFAULT '0' COMMENT '装扮消耗材料id',
  `dress_attr` varchar(1024) CHARACTER SET latin1 NOT NULL COMMENT '装扮升星属性',
  `is_default` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否默认装扮',
  `sequence` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '展示顺序',
  PRIMARY KEY (`dress_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装扮激活升星配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drop_dot_rule 结构
DROP TABLE IF EXISTS `base_drop_dot_rule`;
CREATE TABLE IF NOT EXISTS `base_drop_dot_rule` (
  `cid` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '圈id',
  `dot_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '掉落列表',
  PRIMARY KEY (`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='掉落坐标';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drop_goods 结构
DROP TABLE IF EXISTS `base_drop_goods`;
CREATE TABLE IF NOT EXISTS `base_drop_goods` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型，0 随机掉落物品，1 固定掉落物品，2 任务物品',
  `drop_thing_type` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '掉落物类型',
  `list_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '列表ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '机率',
  `career_ratio_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '职业机率列表',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大掉落数',
  `min_num` int(11) DEFAULT '0' COMMENT '最小掉落数',
  `cond_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '条件列表',
  `repeat` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '是否循环利用(放回随机)##1放回，0不放回，默认1',
  `get_way` tinyint(1) NOT NULL COMMENT '获得方式',
  `drop_icon` varchar(255) DEFAULT NULL COMMENT '掉落在地上显示的图标0：无图标；>0:掉落图标id',
  `drop_leff` varchar(255) DEFAULT NULL COMMENT '掉落在地上显示的光效：0：无光效；>0:光效id',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '绑定状态',
  `notice` varchar(255) NOT NULL COMMENT '传闻@lang@',
  `hour_start` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '时间段限制，0为无',
  `hour_end` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '时间段限制，0为无',
  `time_start` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日期限制，0为无',
  `time_end` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日期限制，0为无',
  `replace_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '职业替换列表',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `list_id` (`list_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='掉落物品表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drop_limit 结构
DROP TABLE IF EXISTS `base_drop_limit`;
CREATE TABLE IF NOT EXISTS `base_drop_limit` (
  `drop_thing_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '掉落类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '掉落物品id',
  `limit_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '限制类型',
  `limit_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制天数##0：玩家单个物品Id限制；1：全服单个物品Id限制',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制数量##（玩家单个物品限制只能填1和7）',
  PRIMARY KEY (`drop_thing_type`,`goods_id`,`limit_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='掉落上限配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drop_mon_list 结构
DROP TABLE IF EXISTS `base_drop_mon_list`;
CREATE TABLE IF NOT EXISTS `base_drop_mon_list` (
  `mon_id` int(11) NOT NULL COMMENT '怪物ID',
  `list_id` int(11) NOT NULL COMMENT '列表ID',
  UNIQUE KEY `mon_id` (`mon_id`,`list_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品掉落怪物相关列表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drop_rule 结构
DROP TABLE IF EXISTS `base_drop_rule`;
CREATE TABLE IF NOT EXISTS `base_drop_rule` (
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物ID',
  `alloc` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '分配方式：1个人独占，2随机分配，3均等分配，4先到先得',
  `min_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `bltype` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '归属类型：分配方式4：启作用 0：伤害最高获得 1：第一击获得 2：最后一击获得 3：无归属；配置“无归属”后所有玩家都可以拾取列表中的道具',
  `task` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有任务物品，1 有，0 无',
  `broad` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '广播场景，0不广播，1队伍广播，2场景广播',
  `drop_rule` varchar(2000) NOT NULL COMMENT '掉落规则，格式：包:掉落数+包:掉落数=机率, ...',
  `drop_range` varchar(256) NOT NULL COMMENT '掉落范围',
  PRIMARY KEY (`mon_id`,`alloc`,`min_lv`,`max_lv`),
  KEY `task` (`task`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品掉落规则表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drop_timelimit 结构
DROP TABLE IF EXISTS `base_drop_timelimit`;
CREATE TABLE IF NOT EXISTS `base_drop_timelimit` (
  `drop_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '掉落类型',
  `drop_way` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '掉落BOSS',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  `link` varchar(100) NOT NULL DEFAULT '[]' COMMENT '跳转',
  `award` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '掉落奖励',
  PRIMARY KEY (`drop_type`,`drop_way`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时掉落配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_cfg 结构
DROP TABLE IF EXISTS `base_drumwar_cfg`;
CREATE TABLE IF NOT EXISTS `base_drumwar_cfg` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `open_day` varchar(512) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `sign_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名持续时间',
  `sea_ready` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '准备期持续时间',
  `sea_prepare` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '海选赛准备时间',
  `sea_enter` int(11) NOT NULL DEFAULT '0' COMMENT '海选赛拉人进战场时间',
  `sea_war` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '海选赛每场战斗时间',
  `rank_ready` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '夺王赛备战时间(转场时间)',
  `rank_prepare` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '夺王赛准备时间',
  `rank_enter` int(11) NOT NULL DEFAULT '0' COMMENT '夺王赛拉人进场时间',
  `rank_war` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '夺王赛时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_choose 结构
DROP TABLE IF EXISTS `base_drumwar_choose`;
CREATE TABLE IF NOT EXISTS `base_drumwar_choose` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `input` varchar(512) NOT NULL DEFAULT '[]' COMMENT '投入金额',
  `output` varchar(512) NOT NULL DEFAULT '[]' COMMENT '成功奖励',
  PRIMARY KEY (`id`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_kv 结构
DROP TABLE IF EXISTS `base_drumwar_kv`;
CREATE TABLE IF NOT EXISTS `base_drumwar_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '[]' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_lv_to_zone 结构
DROP TABLE IF EXISTS `base_drumwar_lv_to_zone`;
CREATE TABLE IF NOT EXISTS `base_drumwar_lv_to_zone` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `turn` int(11) NOT NULL DEFAULT '0' COMMENT '传奇等级',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `lucky_reward` varchar(50) NOT NULL DEFAULT '[]' COMMENT '幸运奖',
  PRIMARY KEY (`zid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_mon 结构
DROP TABLE IF EXISTS `base_drumwar_mon`;
CREATE TABLE IF NOT EXISTS `base_drumwar_mon` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `mon_lv` int(11) NOT NULL DEFAULT '0' COMMENT '假人等级',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系数',
  `power` varchar(50) NOT NULL DEFAULT '[]' COMMENT '假人战力区间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_rank_reward 结构
DROP TABLE IF EXISTS `base_drumwar_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_drumwar_rank_reward` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`zid`,`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_robot 结构
DROP TABLE IF EXISTS `base_drumwar_robot`;
CREATE TABLE IF NOT EXISTS `base_drumwar_robot` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '机器人id',
  `name` varchar(100) NOT NULL COMMENT '机器人名字@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_drumwar_zone_reward 结构
DROP TABLE IF EXISTS `base_drumwar_zone_reward`;
CREATE TABLE IF NOT EXISTS `base_drumwar_zone_reward` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `win_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '胜奖励',
  `lose_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '败奖励',
  PRIMARY KEY (`zid`,`act`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dsgt 结构
DROP TABLE IF EXISTS `base_dsgt`;
CREATE TABLE IF NOT EXISTS `base_dsgt` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号id',
  `main_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号大类',
  `name` varchar(50) NOT NULL COMMENT '称号名称@lang@',
  `description` varchar(512) NOT NULL COMMENT '称号描述@lang@',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '称号类型',
  `is_trial` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否体验',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号对应的物品ID',
  `attr_list` varchar(1024) NOT NULL COMMENT '属性奖励',
  `resource_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源id',
  `is_global` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '全局称号数量',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '称号颜色',
  `power` int(11) NOT NULL DEFAULT '0' COMMENT '战力显示',
  `access_way` varchar(512) NOT NULL DEFAULT '[]' COMMENT '获取途径',
  `access_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获取途径id',
  `index` int(11) NOT NULL DEFAULT '0' COMMENT '排序id',
  `force_cancel` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以强制取消 1- 可以 0-不可以',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='称号配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dsgt_trial 结构
DROP TABLE IF EXISTS `base_dsgt_trial`;
CREATE TABLE IF NOT EXISTS `base_dsgt_trial` (
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '物品id',
  `dsgt_id` int(11) NOT NULL COMMENT '称号id',
  `trial_time` int(11) NOT NULL DEFAULT '0' COMMENT '体验时间',
  `is_overlay` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否可叠加',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时称号体验配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_attr_crush 结构
DROP TABLE IF EXISTS `base_dungeon_attr_crush`;
CREATE TABLE IF NOT EXISTS `base_dungeon_attr_crush` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性',
  `attr_r` double unsigned NOT NULL DEFAULT '0' COMMENT '属性比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`id`,`attr_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_cfg 结构
DROP TABLE IF EXISTS `base_dungeon_cfg`;
CREATE TABLE IF NOT EXISTS `base_dungeon_cfg` (
  `id` int(11) unsigned NOT NULL COMMENT '副本id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '副本名称',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '副本类型',
  `scene_id` int(11) NOT NULL DEFAULT '0' COMMENT '场景id',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '副本时间',
  `condition` varchar(511) NOT NULL DEFAULT '[]' COMMENT '进入条件',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '进入消耗',
  `count_cond` varchar(255) NOT NULL DEFAULT '[]' COMMENT '次数条件',
  `count_deduct` int(11) NOT NULL DEFAULT '1' COMMENT '次数扣除方式',
  `buy_count_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '次数购买消耗',
  `wave_num` int(11) NOT NULL DEFAULT '0' COMMENT '波数条件',
  `fail_event` varchar(255) NOT NULL DEFAULT '[]' COMMENT '失败条件',
  `is_use_power_crush` int(11) NOT NULL DEFAULT '0' COMMENT '是否使用战力碾压',
  `is_use_attr_crush` int(11) NOT NULL DEFAULT '0' COMMENT '是否使用属性碾压',
  `recommend_power` int(11) NOT NULL DEFAULT '0' COMMENT '推荐战力',
  `recommend_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '推荐属性',
  `revive_count` int(11) NOT NULL DEFAULT '0' COMMENT '复活次数',
  `revive_time` int(11) NOT NULL DEFAULT '0' COMMENT '复活时间',
  `reward_show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励展示',
  `rand_reward_show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机奖励展示',
  `flop_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '水晶消耗',
  `flop_pools` varchar(255) NOT NULL DEFAULT '[]' COMMENT '水晶奖池&权重',
  `flop_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '水晶奖励',
  `flop_times` varchar(255) NOT NULL DEFAULT '[]' COMMENT '水晶倍率',
  `base_reward` varchar(511) NOT NULL DEFAULT '[]' COMMENT '通关奖励',
  `first_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '首通奖励',
  `rand_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机奖励',
  `trigger` int(11) NOT NULL DEFAULT '0' COMMENT '任务触发类型',
  `quit_time` smallint(5) unsigned NOT NULL DEFAULT '30' COMMENT '副本退出时间',
  `born_type` smallint(5) NOT NULL DEFAULT '0' COMMENT '出生类型',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_grade 结构
DROP TABLE IF EXISTS `base_dungeon_grade`;
CREATE TABLE IF NOT EXISTS `base_dungeon_grade` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `grade_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `grade_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `condition` varchar(500) NOT NULL COMMENT '评分条件',
  `reward` varchar(500) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`dun_id`,`grade_min`,`grade_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本评分配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_grade_dynamic 结构
DROP TABLE IF EXISTS `base_dungeon_grade_dynamic`;
CREATE TABLE IF NOT EXISTS `base_dungeon_grade_dynamic` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评分等级',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` int(11) unsigned NOT NULL COMMENT '等级上限',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '静态奖励列表',
  `reward2` varchar(500) NOT NULL DEFAULT '[]' COMMENT '动态奖励(有参数参与计算)',
  PRIMARY KEY (`dun_id`,`grade`,`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本动态奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_level 结构
DROP TABLE IF EXISTS `base_dungeon_level`;
CREATE TABLE IF NOT EXISTS `base_dungeon_level` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本场景id',
  `serial_no` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号##顺序关卡需要使用的，顺序关卡副本不能有相同的serial_no',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `desc` varchar(1000) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `wave_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本波数',
  `mon_event` text NOT NULL COMMENT '刷怪事件##[ {事件编号ID1, 波数类型1, 参数列表, [{触发元素1},{触发元素2},...}]}, {事件编号ID2, 波数类型2, 参数列表, [{触发元素3},{触发元素4},...}]},...]',
  `story_event` text NOT NULL COMMENT '剧情事件##[ {事件编号ID1, [剧情配置ID1, 剧情子类型], [{触发元素1},{触发元素2},...}]}, {事件编号ID2, [剧情ID配置2, 剧情子类型], [{触发元素3},{触发元素4},...}]},...]',
  `zone_event` text NOT NULL COMMENT '区域事件##[ {事件编号ID1, 区域配置ID1, 切换状态, [{触发元素1},{触发元素2},...}]}, {事件编号ID2, 区域ID配置2, 切换状态, [{触发元素3},{触发元素4},...}]},...]',
  `scene_event` text NOT NULL COMMENT '场景事件##[ {事件编号ID1, 参数列表, [{触发元素1},{触发元素2},...}]}, {事件编号ID2, 场景id, 参数列表, [{触发元素3},{触发元素4},...}]} }] },...]',
  `success_event` text NOT NULL COMMENT '通关事件##[ {类型(0:直接结算,1:只推送结算信息), [{触发元素1},{触发元素2},...}]}, {类型, [{触发元素3},{触发元素4},...}]},...]',
  `fail_event` text NOT NULL COMMENT '失败事件##[ {类型(0:直接结算,1:只推送结算信息), [{触发元素1},{触发元素2},...}]}, {类型, [{触发元素3},{触发元素4},...}]},...]',
  PRIMARY KEY (`dun_id`,`scene_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_level_rewards 结构
DROP TABLE IF EXISTS `base_dungeon_level_rewards`;
CREATE TABLE IF NOT EXISTS `base_dungeon_level_rewards` (
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `level` smallint(5) unsigned NOT NULL COMMENT '关卡',
  `score_min` int(10) unsigned NOT NULL COMMENT '评分下限',
  `score_max` int(10) unsigned NOT NULL COMMENT '评分上限',
  `grade` smallint(5) unsigned NOT NULL COMMENT '评价等级',
  `rewards` varchar(1000) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`dun_id`,`level`,`score_min`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本关卡评分奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_mon_dynamic 结构
DROP TABLE IF EXISTS `base_dungeon_mon_dynamic`;
CREATE TABLE IF NOT EXISTS `base_dungeon_mon_dynamic` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '层数',
  `ratio` double unsigned NOT NULL DEFAULT '0' COMMENT '难度系数##小数',
  PRIMARY KEY (`id`,`dun_id`,`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本怪物动态属性配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_power_crush 结构
DROP TABLE IF EXISTS `base_dungeon_power_crush`;
CREATE TABLE IF NOT EXISTS `base_dungeon_power_crush` (
  `power_r` double NOT NULL DEFAULT '0' COMMENT '战力比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`power_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本战力碾压配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dungeon_special_cfg 结构
DROP TABLE IF EXISTS `base_dungeon_special_cfg`;
CREATE TABLE IF NOT EXISTS `base_dungeon_special_cfg` (
  `key` varchar(255) NOT NULL COMMENT '键',
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `value` text NOT NULL COMMENT '值',
  `desc` text NOT NULL COMMENT '说明',
  PRIMARY KEY (`dun_id`,`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本特殊配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_child_kv 结构
DROP TABLE IF EXISTS `base_dun_child_kv`;
CREATE TABLE IF NOT EXISTS `base_dun_child_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `key` varchar(255) NOT NULL COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_child_run_time 结构
DROP TABLE IF EXISTS `base_dun_child_run_time`;
CREATE TABLE IF NOT EXISTS `base_dun_child_run_time` (
  `wave` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数',
  `run_time` varchar(500) NOT NULL DEFAULT '[]' COMMENT '逃跑时间',
  PRIMARY KEY (`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宝宝副本-波数怪物逃跑时间';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_child_sweep_wave 结构
DROP TABLE IF EXISTS `base_dun_child_sweep_wave`;
CREATE TABLE IF NOT EXISTS `base_dun_child_sweep_wave` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `wave` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '波数',
  `mon_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '对应波数宝箱怪掉落奖励',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宝宝副本-扫荡波数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_galaxy_kv 结构
DROP TABLE IF EXISTS `base_dun_galaxy_kv`;
CREATE TABLE IF NOT EXISTS `base_dun_galaxy_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='星辰副本-常量配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_galaxy_next 结构
DROP TABLE IF EXISTS `base_dun_galaxy_next`;
CREATE TABLE IF NOT EXISTS `base_dun_galaxy_next` (
  `id` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本Id',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一副本Id',
  `stars_reward` varchar(511) NOT NULL DEFAULT '[]' COMMENT '首通星级奖励',
  `normal_reward` varchar(511) NOT NULL DEFAULT '[]' COMMENT '普通星级奖励',
  `plot` varchar(511) NOT NULL DEFAULT '' COMMENT '剧情内容',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='星辰副本-关卡下一副本配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_galaxy_reward 结构
DROP TABLE IF EXISTS `base_dun_galaxy_reward`;
CREATE TABLE IF NOT EXISTS `base_dun_galaxy_reward` (
  `id` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `chapter_id` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '章节Id',
  `dun_ids` varchar(255) NOT NULL DEFAULT '[]' COMMENT '章节所包含的副本',
  `final_dun_id` int(11) NOT NULL DEFAULT '0' COMMENT '章节最大副本id',
  `reward` varchar(511) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `next_id` smallint(6) NOT NULL DEFAULT '0' COMMENT '下一章节id',
  `show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '章节展示奖励',
  `puzzles_num` smallint(6) NOT NULL DEFAULT '0' COMMENT '拼图数量',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '章节名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='星辰副本-章节奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_grade_rating 结构
DROP TABLE IF EXISTS `base_dun_grade_rating`;
CREATE TABLE IF NOT EXISTS `base_dun_grade_rating` (
  `dun_id` int(11) NOT NULL COMMENT '副本id',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '评级',
  `last_time` int(11) NOT NULL DEFAULT '0' COMMENT '持续时间',
  `effiency` int(11) NOT NULL DEFAULT '0' COMMENT '奖励效率',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`dun_id`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本通用评级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_guard_achieve 结构
DROP TABLE IF EXISTS `base_dun_guard_achieve`;
CREATE TABLE IF NOT EXISTS `base_dun_guard_achieve` (
  `dun_id` int(11) NOT NULL COMMENT '副本id',
  `wave` int(11) NOT NULL COMMENT '波数',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '里程碑奖励',
  `breaking_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '全服首通奖励',
  PRIMARY KEY (`dun_id`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标-里程碑奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_guard_assist_reward 结构
DROP TABLE IF EXISTS `base_dun_guard_assist_reward`;
CREATE TABLE IF NOT EXISTS `base_dun_guard_assist_reward` (
  `rank_min` int(11) NOT NULL COMMENT '排名上限',
  `rank_max` int(11) NOT NULL COMMENT '排名下限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标-支援奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_guard_kv 结构
DROP TABLE IF EXISTS `base_dun_guard_kv`;
CREATE TABLE IF NOT EXISTS `base_dun_guard_kv` (
  `key` varchar(255) NOT NULL COMMENT '主键',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_guard_revive 结构
DROP TABLE IF EXISTS `base_dun_guard_revive`;
CREATE TABLE IF NOT EXISTS `base_dun_guard_revive` (
  `count` int(11) NOT NULL COMMENT '复活次数',
  `cd` int(11) NOT NULL DEFAULT '0' COMMENT '复活冷却',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '复活消耗',
  PRIMARY KEY (`count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标-复活配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_guard_tower_pos 结构
DROP TABLE IF EXISTS `base_dun_guard_tower_pos`;
CREATE TABLE IF NOT EXISTS `base_dun_guard_tower_pos` (
  `dun_id` int(11) NOT NULL COMMENT '副本id',
  `pos` varchar(512) NOT NULL DEFAULT '[]' COMMENT '塔坐标',
  PRIMARY KEY (`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标-塔坐标配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_guard_wave_assist 结构
DROP TABLE IF EXISTS `base_dun_guard_wave_assist`;
CREATE TABLE IF NOT EXISTS `base_dun_guard_wave_assist` (
  `dun_id` int(11) NOT NULL COMMENT '副本id',
  `wave_min` int(11) NOT NULL COMMENT '副本波数上限',
  `wave_max` int(11) NOT NULL COMMENT '副本波数下限',
  `val` int(11) NOT NULL DEFAULT '0' COMMENT '支援值',
  PRIMARY KEY (`dun_id`,`wave_min`,`wave_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标-波数支援值配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_multi_team_cfg 结构
DROP TABLE IF EXISTS `base_dun_multi_team_cfg`;
CREATE TABLE IF NOT EXISTS `base_dun_multi_team_cfg` (
  `type` int(11) NOT NULL COMMENT '活动大类',
  `sub_type` int(11) NOT NULL COMMENT '活动子类',
  `dun_id` int(11) NOT NULL COMMENT '副本id',
  `type_name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动大类名称',
  `sub_type_name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动子类名称',
  `scene` int(11) NOT NULL DEFAULT '0' COMMENT '场景id',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  PRIMARY KEY (`type`,`sub_type`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='多人副本组队活动配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_pet_buff 结构
DROP TABLE IF EXISTS `base_dun_pet_buff`;
CREATE TABLE IF NOT EXISTS `base_dun_pet_buff` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `effect` varchar(255) NOT NULL DEFAULT '[]' COMMENT '效果',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  `client_show` varchar(255) NOT NULL DEFAULT '' COMMENT '前端资源',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-buff球配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_pet_kv 结构
DROP TABLE IF EXISTS `base_dun_pet_kv`;
CREATE TABLE IF NOT EXISTS `base_dun_pet_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-常量配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_pet_next 结构
DROP TABLE IF EXISTS `base_dun_pet_next`;
CREATE TABLE IF NOT EXISTS `base_dun_pet_next` (
  `id` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '顺序',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本Id',
  `next_dun` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一副本Id',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `guard_mons` varchar(255) NOT NULL DEFAULT '[]' COMMENT '守卫怪物',
  `pet_mon` varchar(255) NOT NULL DEFAULT '[]' COMMENT '妖宠',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '里程碑奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-关卡下一副本配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_pet_rank_reward 结构
DROP TABLE IF EXISTS `base_dun_pet_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_dun_pet_rank_reward` (
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `rank_low` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `rank_height` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `need_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上榜需求',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-排名奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_pet_reward 结构
DROP TABLE IF EXISTS `base_dun_pet_reward`;
CREATE TABLE IF NOT EXISTS `base_dun_pet_reward` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本Id',
  `low` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分下限',
  `height` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`dun_id`,`low`,`height`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-结算奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_pet_score 结构
DROP TABLE IF EXISTS `base_dun_pet_score`;
CREATE TABLE IF NOT EXISTS `base_dun_pet_score` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本Id',
  `wave` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得积分',
  PRIMARY KEY (`dun_id`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-积分配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_talk_event 结构
DROP TABLE IF EXISTS `base_dun_talk_event`;
CREATE TABLE IF NOT EXISTS `base_dun_talk_event` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增',
  `dunid` int(11) NOT NULL DEFAULT '0' COMMENT '副本ID',
  `tritype` int(11) NOT NULL DEFAULT '0' COMMENT '触发类型1副本进入2波数',
  `wave` int(11) NOT NULL DEFAULT '0' COMMENT '事件波数',
  `delay` int(11) NOT NULL DEFAULT '0' COMMENT '怪物延迟',
  `show_time` int(11) NOT NULL DEFAULT '0' COMMENT '展示持续时间',
  `talker` varchar(100) NOT NULL DEFAULT '神秘' COMMENT '说话人',
  `content` text NOT NULL COMMENT '说话内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_dun_wave 结构
DROP TABLE IF EXISTS `base_dun_wave`;
CREATE TABLE IF NOT EXISTS `base_dun_wave` (
  `dun_id` int(11) NOT NULL COMMENT '副本id',
  `wave` int(11) NOT NULL COMMENT '副本波数',
  `scene` int(11) NOT NULL DEFAULT '0' COMMENT '场景id',
  `create_time` int(11) NOT NULL DEFAULT '0' COMMENT '波数创建时间（倒计时创怪）',
  `limit_time` int(11) NOT NULL DEFAULT '0' COMMENT '波数限制时间',
  `mon_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '波数怪物',
  `next_wave` int(11) NOT NULL DEFAULT '0' COMMENT '下一波数',
  `first_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '首通奖励',
  `normal_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '普通奖励',
  `recommend_power` int(11) NOT NULL DEFAULT '0' COMMENT '波数推荐战力',
  `recommend_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '波数推荐属性',
  `born_xy` varchar(255) NOT NULL DEFAULT '[]' COMMENT '初始出生坐标',
  PRIMARY KEY (`dun_id`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本波数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_elite_assess_reward 结构
DROP TABLE IF EXISTS `base_elite_assess_reward`;
CREATE TABLE IF NOT EXISTS `base_elite_assess_reward` (
  `category` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '章节奖励',
  `client_show` varchar(255) NOT NULL DEFAULT '' COMMENT '外观展示',
  `open_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开放等级',
  `category_name` varchar(255) NOT NULL DEFAULT '' COMMENT '章节名称',
  PRIMARY KEY (`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='精英考核-章节奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_elite_assess_task 结构
DROP TABLE IF EXISTS `base_elite_assess_task`;
CREATE TABLE IF NOT EXISTS `base_elite_assess_task` (
  `category` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `sub_category` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '子章节',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `content` varchar(255) NOT NULL DEFAULT '[]' COMMENT '任务内容',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `jump` varchar(255) NOT NULL DEFAULT '' COMMENT '客户端跳转',
  `task_name` varchar(500) NOT NULL DEFAULT '' COMMENT '任务名称',
  `task_desc` varchar(500) NOT NULL DEFAULT '' COMMENT '任务描述',
  PRIMARY KEY (`category`,`sub_category`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='精英考核-任务配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_elite_mon 结构
DROP TABLE IF EXISTS `base_elite_mon`;
CREATE TABLE IF NOT EXISTS `base_elite_mon` (
  `index` int(11) NOT NULL COMMENT '序号',
  `mon_id` int(11) NOT NULL DEFAULT '0' COMMENT '怪物id',
  `mon_name` varchar(255) NOT NULL DEFAULT '' COMMENT '怪物名字',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT '层数',
  `born_pos` varchar(255) NOT NULL DEFAULT '[]' COMMENT '出生坐标',
  `reborn_time` varchar(500) NOT NULL DEFAULT '[]' COMMENT '重生时间',
  PRIMARY KEY (`index`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='废都精英怪配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_encourage_attr 结构
DROP TABLE IF EXISTS `base_encourage_attr`;
CREATE TABLE IF NOT EXISTS `base_encourage_attr` (
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞类型##1彩钻鼓舞/2红钻鼓舞',
  `count` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞次数',
  `price` varchar(255) NOT NULL DEFAULT '' COMMENT '消耗',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '替代道具',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`type`,`count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战力鼓舞';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment 结构
DROP TABLE IF EXISTS `base_equipment`;
CREATE TABLE IF NOT EXISTS `base_equipment` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `name` varchar(500) NOT NULL DEFAULT '[]' COMMENT '名称名称',
  `series` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `color` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `career` varchar(500) NOT NULL DEFAULT '[]' COMMENT '职业##[职业]',
  `equip_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型',
  `lv` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '穿戴等级',
  `suit` varchar(500) NOT NULL DEFAULT '[]' COMMENT '套装类型##[套装id]',
  `base_attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '基础属性##[{key,value}]',
  `great_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '卓越属性条目上限',
  `great_attr_star` varchar(500) NOT NULL DEFAULT '[]' COMMENT '星级卓越属性列表##[{权重,入库次数,属性库id}]',
  `great_attr_normal` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '非星级卓越属性列表##[{权重,入库次数,属性库id}]',
  `devour_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬经验',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_collect_goods 结构
DROP TABLE IF EXISTS `base_equipment_collect_goods`;
CREATE TABLE IF NOT EXISTS `base_equipment_collect_goods` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '代数',
  `sub_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置(对于属性是装备数量)',
  `goods_id` varchar(200) NOT NULL DEFAULT '[]' COMMENT '装备id',
  `get_way` varchar(100) NOT NULL DEFAULT '[]' COMMENT '获取途径',
  `attr_node` varchar(100) NOT NULL DEFAULT '[]' COMMENT '套装节点属性',
  `attr_total` varchar(200) NOT NULL DEFAULT '[]' COMMENT '套装累计属性',
  `desc` varchar(200) NOT NULL DEFAULT '[]' COMMENT '获取途径描述',
  PRIMARY KEY (`id`,`sub_id`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备收集-装备目标';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_collect_subtype 结构
DROP TABLE IF EXISTS `base_equipment_collect_subtype`;
CREATE TABLE IF NOT EXISTS `base_equipment_collect_subtype` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '代数',
  `sub_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '名称',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励(称号)',
  PRIMARY KEY (`id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备收集-子页签';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_collect_type 结构
DROP TABLE IF EXISTS `base_equipment_collect_type`;
CREATE TABLE IF NOT EXISTS `base_equipment_collect_type` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '代数',
  `name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '名称',
  `open_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '开启等级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备收集-主页签';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_empower 结构
DROP TABLE IF EXISTS `base_equipment_empower`;
CREATE TABLE IF NOT EXISTS `base_equipment_empower` (
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '代数',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  `attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `condition` varchar(200) NOT NULL DEFAULT '[]' COMMENT '开放条件',
  PRIMARY KEY (`series`,`pos`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-器灵';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_empty 结构
DROP TABLE IF EXISTS `base_equipment_empty`;
CREATE TABLE IF NOT EXISTS `base_equipment_empty` (
  `id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '顺序id',
  `series` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '装备代数',
  `pos` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `get_way` varchar(100) NOT NULL DEFAULT '' COMMENT '获取途径',
  PRIMARY KEY (`id`,`series`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-装备栏tips';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_gems 结构
DROP TABLE IF EXISTS `base_equipment_gems`;
CREATE TABLE IF NOT EXISTS `base_equipment_gems` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类别##1攻击宝石、2防御宝石、3生命宝石',
  `lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '宝石等级',
  `attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性##[{key,value}]',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-宝石';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_gems_total 结构
DROP TABLE IF EXISTS `base_equipment_gems_total`;
CREATE TABLE IF NOT EXISTS `base_equipment_gems_total` (
  `series` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '全部宝石等级',
  `attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `total_attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '累计属性',
  PRIMARY KEY (`series`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-宝石套装';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_great 结构
DROP TABLE IF EXISTS `base_equipment_great`;
CREATE TABLE IF NOT EXISTS `base_equipment_great` (
  `series` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `equip_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型',
  `up_num` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `cost` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '单次消耗',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '属性',
  `ratio` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '基础成功率##万分比',
  PRIMARY KEY (`series`,`equip_type`,`up_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-升星';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_great_attr 结构
DROP TABLE IF EXISTS `base_equipment_great_attr`;
CREATE TABLE IF NOT EXISTS `base_equipment_great_attr` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主键id',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '类型##0普通|1星级',
  `attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-卓越属性库';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_great_ratio 结构
DROP TABLE IF EXISTS `base_equipment_great_ratio`;
CREATE TABLE IF NOT EXISTS `base_equipment_great_ratio` (
  `series` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `target_series` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标套数',
  `target_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标进化等级',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '提供概率',
  PRIMARY KEY (`series`,`color`,`target_series`,`target_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-进化概率';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_series_open 结构
DROP TABLE IF EXISTS `base_equipment_series_open`;
CREATE TABLE IF NOT EXISTS `base_equipment_series_open` (
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `visible_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可见等级',
  `open_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启等级',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁任务',
  PRIMARY KEY (`series`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-套数开启';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_star_total 结构
DROP TABLE IF EXISTS `base_equipment_star_total`;
CREATE TABLE IF NOT EXISTS `base_equipment_star_total` (
  `stars` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '星级数',
  `stage_attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '节点属性',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '总属性',
  PRIMARY KEY (`stars`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-星级总数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_strength 结构
DROP TABLE IF EXISTS `base_equipment_strength`;
CREATE TABLE IF NOT EXISTS `base_equipment_strength` (
  `series` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `equip_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型',
  `lv` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '强化等级',
  `cost` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '单次消耗',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '属性',
  `ratio` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '成功率##万分比',
  `fail_add_ratio` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '失败累加成功率##万分比',
  PRIMARY KEY (`series`,`equip_type`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-强化';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_strength_total 结构
DROP TABLE IF EXISTS `base_equipment_strength_total`;
CREATE TABLE IF NOT EXISTS `base_equipment_strength_total` (
  `series` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '全部强化等级',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '属性',
  `total_attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '累计属性',
  PRIMARY KEY (`series`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-强化套装';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equipment_suit 结构
DROP TABLE IF EXISTS `base_equipment_suit`;
CREATE TABLE IF NOT EXISTS `base_equipment_suit` (
  `suit_id` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套装id',
  `suit_num` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套装数量',
  `name` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '套装名称',
  `stage_attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '节点属性',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '总属性',
  `suit_equip` varchar(255) NOT NULL DEFAULT '[]' COMMENT '套装装备',
  PRIMARY KEY (`suit_id`,`suit_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-套装';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equip_attr_rating 结构
DROP TABLE IF EXISTS `base_equip_attr_rating`;
CREATE TABLE IF NOT EXISTS `base_equip_attr_rating` (
  `attr_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性类型',
  `power_section` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力区间',
  `min_power` bigint(5) unsigned NOT NULL DEFAULT '0' COMMENT '战力下限',
  `max_power` bigint(5) unsigned NOT NULL DEFAULT '0' COMMENT '战力上限',
  `rating` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评分',
  PRIMARY KEY (`attr_id`,`power_section`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备属性评分配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_equip_shop 结构
DROP TABLE IF EXISTS `base_equip_shop`;
CREATE TABLE IF NOT EXISTS `base_equip_shop` (
  `index` int(11) NOT NULL COMMENT '商品条目',
  `is_pay` tinyint(2) NOT NULL COMMENT '是否付费',
  `discount` int(11) NOT NULL COMMENT '折扣',
  `price` int(11) NOT NULL DEFAULT '0' COMMENT '价格',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '商品',
  `weight_val` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  PRIMARY KEY (`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备商店配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_error_code 结构
DROP TABLE IF EXISTS `base_error_code`;
CREATE TABLE IF NOT EXISTS `base_error_code` (
  `module` int(11) unsigned NOT NULL COMMENT '功能id',
  `type` varchar(100) NOT NULL COMMENT '错误类型',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '错误码id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='错误码配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp 结构
DROP TABLE IF EXISTS `base_exp`;
CREATE TABLE IF NOT EXISTS `base_exp` (
  `lv` int(11) NOT NULL COMMENT '等级',
  `exp` bigint(20) NOT NULL COMMENT '经验',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_expand_bag_costs 结构
DROP TABLE IF EXISTS `base_expand_bag_costs`;
CREATE TABLE IF NOT EXISTS `base_expand_bag_costs` (
  `bag_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '背包类型',
  `min_cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小开启格子数',
  `max_cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大开启格子数',
  `cost_goods_list` varchar(128) NOT NULL COMMENT '道具消耗列表',
  PRIMARY KEY (`bag_type`,`min_cell`,`max_cell`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='扩展背包空间消耗配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_add 结构
DROP TABLE IF EXISTS `base_exp_add`;
CREATE TABLE IF NOT EXISTS `base_exp_add` (
  `min_server_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_server_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小玩家等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大玩家等级',
  `exp_add` int(11) NOT NULL DEFAULT '0' COMMENT '经验加成百分比',
  UNIQUE KEY `min_gap` (`min_server_lv`,`max_server_lv`,`min_lv`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验加成配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_base 结构
DROP TABLE IF EXISTS `base_exp_base`;
CREATE TABLE IF NOT EXISTS `base_exp_base` (
  `level` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '等级',
  `exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '基础经验',
  PRIMARY KEY (`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='基准经验配置（用于其他功能读取基准数据）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_book 结构
DROP TABLE IF EXISTS `base_exp_book`;
CREATE TABLE IF NOT EXISTS `base_exp_book` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验书配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_chapter 结构
DROP TABLE IF EXISTS `base_exp_dun_chapter`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_chapter` (
  `chapter` int(11) NOT NULL COMMENT '章节',
  `chapter_name` varchar(255) NOT NULL DEFAULT '' COMMENT '章节名称',
  `res_id` int(11) NOT NULL DEFAULT '0' COMMENT '座驾资源id',
  `res_name` varchar(255) NOT NULL DEFAULT '' COMMENT '座驾名称',
  `effiency` int(11) NOT NULL DEFAULT '0' COMMENT '经验效率预览',
  PRIMARY KEY (`chapter`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_drop_goods 结构
DROP TABLE IF EXISTS `base_exp_dun_drop_goods`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_drop_goods` (
  `id` int(11) NOT NULL COMMENT '掉落id',
  `list_id` int(11) NOT NULL DEFAULT '0' COMMENT '列表id',
  `goods_type` int(11) NOT NULL DEFAULT '0' COMMENT '物品类型',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '物品id',
  `min` int(11) NOT NULL DEFAULT '0' COMMENT '数量下限',
  `max` int(11) NOT NULL DEFAULT '0' COMMENT '数量上限',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='放置经验-掉落物品配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_drop_kv 结构
DROP TABLE IF EXISTS `base_exp_dun_drop_kv`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_drop_kv` (
  `index` int(11) NOT NULL COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `value` varchar(511) NOT NULL DEFAULT '' COMMENT 'value',
  `desc` varchar(511) NOT NULL DEFAULT '' COMMENT '描述说明',
  PRIMARY KEY (`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='放置经验kv表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_drop_rule 结构
DROP TABLE IF EXISTS `base_exp_dun_drop_rule`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_drop_rule` (
  `min_lv` int(11) NOT NULL COMMENT '最小等级',
  `max_lv` int(11) NOT NULL COMMENT '最大等级',
  `wave` int(11) NOT NULL COMMENT '波数',
  `rule` varchar(1023) NOT NULL DEFAULT '[]' COMMENT '掉落规则',
  PRIMARY KEY (`min_lv`,`max_lv`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='放置经验-掉落规则配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_expect_drop 结构
DROP TABLE IF EXISTS `base_exp_dun_expect_drop`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_expect_drop` (
  `min_wave` int(11) NOT NULL COMMENT '最小波数',
  `max_wave` int(11) NOT NULL COMMENT '最大波数',
  `min_lv` int(11) NOT NULL COMMENT '最小等级',
  `max_lv` int(11) NOT NULL COMMENT '最大等级',
  `rewards` varchar(500) NOT NULL DEFAULT '[]' COMMENT '物品列表',
  PRIMARY KEY (`min_wave`,`max_wave`,`min_lv`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='预计掉落配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_level 结构
DROP TABLE IF EXISTS `base_exp_dun_level`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_level` (
  `level` int(11) NOT NULL COMMENT '线路',
  `min_wave` int(11) NOT NULL DEFAULT '0' COMMENT '波数下限',
  `max_wave` int(11) NOT NULL DEFAULT '0' COMMENT '波数上限',
  PRIMARY KEY (`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验副本线路配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_line 结构
DROP TABLE IF EXISTS `base_exp_dun_line`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_line` (
  `chapter` int(11) NOT NULL COMMENT '章节',
  `id` int(11) NOT NULL COMMENT '线路',
  `min_wave` int(11) NOT NULL DEFAULT '0' COMMENT '波数下限',
  `max_wave` int(11) NOT NULL DEFAULT '0' COMMENT '波数上限',
  PRIMARY KEY (`chapter`,`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验本线路配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_exp_dun_wave 结构
DROP TABLE IF EXISTS `base_exp_dun_wave`;
CREATE TABLE IF NOT EXISTS `base_exp_dun_wave` (
  `wave` int(11) NOT NULL COMMENT '波数',
  `type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '波数类型',
  `achieve_rewards` varchar(511) NOT NULL DEFAULT '[]' COMMENT '里程碑奖励',
  `mon_pic` int(11) NOT NULL DEFAULT '0' COMMENT '怪物头像',
  PRIMARY KEY (`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验本波数信息配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fake_role 结构
DROP TABLE IF EXISTS `base_fake_role`;
CREATE TABLE IF NOT EXISTS `base_fake_role` (
  `lv` smallint(5) unsigned NOT NULL COMMENT '假人等级',
  `attr_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='假人属性配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fake_role_attr_by_power 结构
DROP TABLE IF EXISTS `base_fake_role_attr_by_power`;
CREATE TABLE IF NOT EXISTS `base_fake_role_attr_by_power` (
  `attr_id` int(11) NOT NULL COMMENT '属性Id',
  `ratio` float NOT NULL DEFAULT '0' COMMENT '属性系数',
  PRIMARY KEY (`attr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='假人属性-战力计算方式';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fame_lv 结构
DROP TABLE IF EXISTS `base_fame_lv`;
CREATE TABLE IF NOT EXISTS `base_fame_lv` (
  `lv` int(11) unsigned NOT NULL COMMENT '名誉等级',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `name` varchar(255) NOT NULL COMMENT '名誉名字@lang@',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需名誉',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='名誉等级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fashion_color 结构
DROP TABLE IF EXISTS `base_fashion_color`;
CREATE TABLE IF NOT EXISTS `base_fashion_color` (
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `color_id` int(10) unsigned NOT NULL COMMENT '颜色id',
  `color_logo` int(10) unsigned NOT NULL COMMENT '资源id',
  `color_name` varchar(500) NOT NULL COMMENT '颜色名字@lang@',
  `icon_id` int(11) NOT NULL DEFAULT '0' COMMENT '图标ID',
  PRIMARY KEY (`fashion_id`,`color_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装颜色配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fashion_model 结构
DROP TABLE IF EXISTS `base_fashion_model`;
CREATE TABLE IF NOT EXISTS `base_fashion_model` (
  `pos_id` int(10) unsigned NOT NULL COMMENT '部位id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `fashion_name` varchar(255) NOT NULL DEFAULT ' ' COMMENT '时装名字',
  `model_id` int(10) unsigned NOT NULL COMMENT '展示图片',
  `index` int(11) NOT NULL DEFAULT '0' COMMENT '序号(排序)',
  PRIMARY KEY (`fashion_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装模型贴图配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fashion_star_up 结构
DROP TABLE IF EXISTS `base_fashion_star_up`;
CREATE TABLE IF NOT EXISTS `base_fashion_star_up` (
  `pos_id` int(11) NOT NULL COMMENT '部位',
  `fashion_id` int(11) NOT NULL COMMENT '时装ID',
  `color_id` int(11) NOT NULL COMMENT '颜色ID',
  `star_lv` int(11) NOT NULL DEFAULT '0' COMMENT '星级',
  `star_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升星消耗',
  `attr_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `power` int(11) NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`fashion_id`,`color_id`,`star_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装-颜色升星';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fashion_suit 结构
DROP TABLE IF EXISTS `base_fashion_suit`;
CREATE TABLE IF NOT EXISTS `base_fashion_suit` (
  `suit_id` int(11) NOT NULL COMMENT '套装id',
  `fashion_id` varchar(500) NOT NULL DEFAULT '[]' COMMENT '时装id',
  `attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `index` int(11) NOT NULL DEFAULT '0' COMMENT '序号',
  `res_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '资源id',
  `suit_name` varchar(255) NOT NULL DEFAULT '' COMMENT '套装名称',
  PRIMARY KEY (`suit_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装套装配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fashion_trial 结构
DROP TABLE IF EXISTS `base_fashion_trial`;
CREATE TABLE IF NOT EXISTS `base_fashion_trial` (
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '物品id',
  `fashion_id` int(11) NOT NULL COMMENT '时装id',
  `color_id` int(11) NOT NULL DEFAULT '0' COMMENT '颜色id',
  `expire_time` int(11) NOT NULL DEFAULT '0' COMMENT '体验时间',
  `is_overlay` int(11) NOT NULL DEFAULT '0' COMMENT '是否可叠加',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时时装体验配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fast_onhook_multi_reward_count 结构
DROP TABLE IF EXISTS `base_fast_onhook_multi_reward_count`;
CREATE TABLE IF NOT EXISTS `base_fast_onhook_multi_reward_count` (
  `vip` int(11) NOT NULL COMMENT 'vip等级',
  `count` int(11) NOT NULL DEFAULT '0' COMMENT '次数',
  PRIMARY KEY (`vip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='放置经验-快速挂机多倍领取次数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fast_onhook_reward 结构
DROP TABLE IF EXISTS `base_fast_onhook_reward`;
CREATE TABLE IF NOT EXISTS `base_fast_onhook_reward` (
  `lv` int(11) NOT NULL COMMENT '等级',
  `base_exp` int(11) NOT NULL COMMENT '基础经验',
  `time` int(11) NOT NULL COMMENT '持续时间',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='快速挂机基础经验配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fishing_gear_type 结构
DROP TABLE IF EXISTS `base_fishing_gear_type`;
CREATE TABLE IF NOT EXISTS `base_fishing_gear_type` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `fishing_gear_id` int(32) unsigned NOT NULL COMMENT '渔具ID',
  `fishing_gear_type` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '渔具类型',
  `quality_type` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '品质类型',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `price` varchar(500) NOT NULL DEFAULT '[]' COMMENT '价格',
  `usage_count` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '使用次数',
  `probability` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '概率加成',
  `incr_mastery` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '熟练度',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fishing_key_value 结构
DROP TABLE IF EXISTS `base_fishing_key_value`;
CREATE TABLE IF NOT EXISTS `base_fishing_key_value` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `key` varchar(500) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(1024) NOT NULL DEFAULT '' COMMENT '值',
  `describe` varchar(5000) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fishing_lv 结构
DROP TABLE IF EXISTS `base_fishing_lv`;
CREATE TABLE IF NOT EXISTS `base_fishing_lv` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `lv` int(32) unsigned NOT NULL COMMENT '钓鱼等级',
  `mastery` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '熟练度',
  `no_comsume_rod_pro` int(32) unsigned NOT NULL COMMENT '不消耗鱼竿次数的概率',
  `no_comsume_energy_pro` int(32) unsigned NOT NULL COMMENT '不消耗精力概率',
  `fish_quality_pro` varchar(128) NOT NULL DEFAULT '[]' COMMENT '鱼类品质加成',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fish_illustrated 结构
DROP TABLE IF EXISTS `base_fish_illustrated`;
CREATE TABLE IF NOT EXISTS `base_fish_illustrated` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '图鉴名称',
  `quality` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴品质',
  `active_condition` varchar(128) NOT NULL DEFAULT '[]' COMMENT '激活条件',
  `photo_id` varchar(50) NOT NULL DEFAULT '' COMMENT '图片资源id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴激活表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fish_illustrated_lv 结构
DROP TABLE IF EXISTS `base_fish_illustrated_lv`;
CREATE TABLE IF NOT EXISTS `base_fish_illustrated_lv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴等级',
  `attr` varchar(128) NOT NULL DEFAULT '[]' COMMENT '图鉴属性',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗道具',
  PRIMARY KEY (`id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴升级表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fish_illustrated_type 结构
DROP TABLE IF EXISTS `base_fish_illustrated_type`;
CREATE TABLE IF NOT EXISTS `base_fish_illustrated_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '类型名称',
  `comment` varchar(128) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_fish_type 结构
DROP TABLE IF EXISTS `base_fish_type`;
CREATE TABLE IF NOT EXISTS `base_fish_type` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `fish_id` int(32) unsigned NOT NULL COMMENT '物品ID',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `quality_type` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '品质类型',
  `hook_probability` int(32) unsigned NOT NULL COMMENT '上钩概率',
  `distri_water_area` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '分布水域',
  `range_of_balance` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '平衡范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_flower_egg 结构
DROP TABLE IF EXISTS `base_flower_egg`;
CREATE TABLE IF NOT EXISTS `base_flower_egg` (
  `egg_id` int(11) unsigned NOT NULL COMMENT '物品id',
  `egg_name` varchar(255) NOT NULL COMMENT '道具名称',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '等级下限',
  `vip_lv` tinyint(3) unsigned NOT NULL COMMENT '贵族等级限制',
  `limit_time` tinyint(3) unsigned NOT NULL COMMENT '限制次数',
  `cost` varchar(255) NOT NULL COMMENT '花费',
  `charm_value` int(11) NOT NULL DEFAULT '0' COMMENT '减少的魅力值',
  `effect` varchar(255) NOT NULL COMMENT '特效名',
  PRIMARY KEY (`egg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_flower_sp_gift 结构
DROP TABLE IF EXISTS `base_flower_sp_gift`;
CREATE TABLE IF NOT EXISTS `base_flower_sp_gift` (
  `goods_id` int(11) NOT NULL COMMENT '道具id',
  `my_back_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '我的所得',
  `my_day` int(11) NOT NULL DEFAULT '0' COMMENT '我的天数',
  `friend_back_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '对方的所得',
  `friend_day` int(11) NOT NULL DEFAULT '0' COMMENT '对方的天数',
  `limit_count` int(11) NOT NULL DEFAULT '0' COMMENT '每日限购次数',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鲜花特殊礼品配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_flower_tools 结构
DROP TABLE IF EXISTS `base_flower_tools`;
CREATE TABLE IF NOT EXISTS `base_flower_tools` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '鲜花道具类型id',
  `type` smallint(5) NOT NULL DEFAULT '0' COMMENT '礼品类型',
  `intimacy` int(11) unsigned NOT NULL COMMENT '增加亲密度',
  `charm` int(11) unsigned NOT NULL COMMENT '增加魅力(人气)值',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '慷慨值',
  `need_lv` smallint(6) unsigned NOT NULL COMMENT '需要等级',
  `need_vip` tinyint(4) unsigned NOT NULL COMMENT '需要VIP等级',
  `is_sell` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '是否可购买',
  `is_tv` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '传闻',
  `effect_type` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '特效类型',
  `effect` varchar(100) NOT NULL DEFAULT '' COMMENT '鲜花特效',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鲜花配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster 结构
DROP TABLE IF EXISTS `base_foster`;
CREATE TABLE IF NOT EXISTS `base_foster` (
  `type` int(11) NOT NULL COMMENT '系统类型',
  `grade` int(11) NOT NULL COMMENT '阶位',
  `star` int(11) NOT NULL COMMENT '星级',
  `name` varchar(200) NOT NULL DEFAULT '系统' COMMENT '名称',
  `next_grade` int(11) NOT NULL COMMENT '下一阶',
  `next_star` int(11) NOT NULL COMMENT '下一星级',
  `cost` varchar(1000) NOT NULL COMMENT '花销',
  `attrs` varchar(1000) NOT NULL COMMENT '属性',
  `tem_attrs` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '临时属性',
  `max` int(11) NOT NULL COMMENT '上限值',
  `min` int(11) NOT NULL COMMENT '保底值',
  `rate` int(5) NOT NULL COMMENT '暴击概率',
  `clear` int(11) NOT NULL COMMENT '是否清扫',
  `award` varchar(1000) NOT NULL COMMENT '阶位奖励',
  `resource` varchar(500) NOT NULL DEFAULT '0' COMMENT '外观资源',
  `is_tv` int(11) NOT NULL DEFAULT '0' COMMENT '是否传闻',
  PRIMARY KEY (`type`,`grade`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶基础表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_core 结构
DROP TABLE IF EXISTS `base_foster_core`;
CREATE TABLE IF NOT EXISTS `base_foster_core` (
  `type` int(11) NOT NULL COMMENT '系统类型',
  `kind` int(11) NOT NULL COMMENT '核心类',
  `cost` varchar(1000) NOT NULL COMMENT '开销',
  `ext` varchar(1000) NOT NULL COMMENT '附加属性',
  `max` varchar(1000) NOT NULL COMMENT '各阶次数上限',
  PRIMARY KEY (`type`,`kind`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='核心配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_equip 结构
DROP TABLE IF EXISTS `base_foster_equip`;
CREATE TABLE IF NOT EXISTS `base_foster_equip` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '适用系统',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '装备名字',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶装备配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_equip_lv 结构
DROP TABLE IF EXISTS `base_foster_equip_lv`;
CREATE TABLE IF NOT EXISTS `base_foster_equip_lv` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `next` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一级',
  `need` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '满级消耗',
  `attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '等级属性',
  `total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累积消耗',
  PRIMARY KEY (`type`,`color`,`pos`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备升级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_kv 结构
DROP TABLE IF EXISTS `base_foster_kv`;
CREATE TABLE IF NOT EXISTS `base_foster_kv` (
  `dkey` varchar(200) NOT NULL COMMENT '键',
  `dvalue` varchar(1000) NOT NULL COMMENT '值',
  `desc` varchar(1000) NOT NULL COMMENT '说明',
  PRIMARY KEY (`dkey`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_open 结构
DROP TABLE IF EXISTS `base_foster_open`;
CREATE TABLE IF NOT EXISTS `base_foster_open` (
  `lv` int(11) NOT NULL COMMENT '等级',
  `opens` varchar(1000) NOT NULL COMMENT '开放功能列表',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='系统开放';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_skill 结构
DROP TABLE IF EXISTS `base_foster_skill`;
CREATE TABLE IF NOT EXISTS `base_foster_skill` (
  `type` int(11) NOT NULL COMMENT '系统类型',
  `pos` int(11) NOT NULL COMMENT '孔位',
  `lv` int(11) NOT NULL COMMENT '等级',
  `next_lv` int(11) NOT NULL COMMENT '下一等级',
  `skillid` int(11) NOT NULL COMMENT '技能ID',
  `limit` int(11) NOT NULL COMMENT ' 阶位限制',
  `des` varchar(100) NOT NULL COMMENT '技能描述',
  `cost` varchar(1000) NOT NULL COMMENT '升级消耗',
  PRIMARY KEY (`type`,`pos`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_skill_open 结构
DROP TABLE IF EXISTS `base_foster_skill_open`;
CREATE TABLE IF NOT EXISTS `base_foster_skill_open` (
  `type` int(11) NOT NULL,
  `pos` int(11) NOT NULL,
  `grade` int(11) NOT NULL,
  PRIMARY KEY (`type`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='槽位控制';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_skin 结构
DROP TABLE IF EXISTS `base_foster_skin`;
CREATE TABLE IF NOT EXISTS `base_foster_skin` (
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '进阶系统',
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '外观ID',
  `star` int(11) NOT NULL DEFAULT '0' COMMENT '星级',
  `name` varchar(100) NOT NULL DEFAULT '飞毯' COMMENT '名字',
  `next_star` int(11) NOT NULL DEFAULT '0' COMMENT '下一星级',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `attrs` varchar(200) NOT NULL DEFAULT '[]' COMMENT '属性',
  `active` varchar(200) NOT NULL DEFAULT '[]' COMMENT '激活技能',
  `skills` varchar(500) NOT NULL DEFAULT '[]' COMMENT '所有技能',
  `model` int(11) NOT NULL DEFAULT '1001' COMMENT '模型',
  `resource` varchar(300) NOT NULL DEFAULT '0' COMMENT '资源',
  PRIMARY KEY (`type`,`id`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_foster_suit 结构
DROP TABLE IF EXISTS `base_foster_suit`;
CREATE TABLE IF NOT EXISTS `base_foster_suit` (
  `id` int(11) NOT NULL COMMENT '套装ID',
  `type` int(11) NOT NULL COMMENT '适用系统',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '阶位',
  `color` int(11) NOT NULL COMMENT '品质门槛',
  `attrs` varchar(500) NOT NULL COMMENT '属性',
  PRIMARY KEY (`id`,`type`,`grade`,`color`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='套装配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_collect 结构
DROP TABLE IF EXISTS `base_galaxy_collect`;
CREATE TABLE IF NOT EXISTS `base_galaxy_collect` (
  `type` int(10) unsigned NOT NULL COMMENT '星群',
  `tname` varchar(100) NOT NULL DEFAULT '[]' COMMENT '星群名',
  `subtype` int(10) unsigned NOT NULL COMMENT '星群',
  `sname` varchar(100) NOT NULL DEFAULT '[]' COMMENT '星团名',
  `items` varchar(500) NOT NULL DEFAULT '[]' COMMENT '收集',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰图鉴表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_goods 结构
DROP TABLE IF EXISTS `base_galaxy_goods`;
CREATE TABLE IF NOT EXISTS `base_galaxy_goods` (
  `id` int(10) unsigned NOT NULL COMMENT '道具ID',
  `type` int(10) NOT NULL DEFAULT '0' COMMENT '星群',
  `subtype` int(10) NOT NULL DEFAULT '0' COMMENT ' 星团',
  `color` int(10) unsigned NOT NULL COMMENT '品质',
  `attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `skill` int(10) unsigned NOT NULL COMMENT '默认技能',
  `skill_max` int(10) unsigned NOT NULL COMMENT '技能上限',
  `rand_skills` varchar(600) NOT NULL DEFAULT '[]' COMMENT '随机技能库',
  `resolve` varchar(600) NOT NULL DEFAULT '[]' COMMENT '分解获得',
  `model` int(10) unsigned NOT NULL COMMENT '模型id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰道具表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_kv 结构
DROP TABLE IF EXISTS `base_galaxy_kv`;
CREATE TABLE IF NOT EXISTS `base_galaxy_kv` (
  `dkey` varchar(200) NOT NULL COMMENT '键',
  `dvalue` varchar(1000) NOT NULL COMMENT '值',
  `desc` varchar(1000) NOT NULL COMMENT '说明',
  PRIMARY KEY (`dkey`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_lv 结构
DROP TABLE IF EXISTS `base_galaxy_lv`;
CREATE TABLE IF NOT EXISTS `base_galaxy_lv` (
  `color` int(10) unsigned NOT NULL COMMENT '品质',
  `lv` int(10) unsigned NOT NULL COMMENT '等级',
  `attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `cost` varchar(600) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `broken` int(10) unsigned NOT NULL COMMENT '是否突破',
  `next_lv` int(10) NOT NULL DEFAULT '0' COMMENT '下一级',
  PRIMARY KEY (`color`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰升级表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_pos 结构
DROP TABLE IF EXISTS `base_galaxy_pos`;
CREATE TABLE IF NOT EXISTS `base_galaxy_pos` (
  `id` int(10) unsigned NOT NULL COMMENT '位置',
  `type` int(10) unsigned NOT NULL COMMENT '类型0阵位1星位',
  `own` int(10) unsigned NOT NULL COMMENT '上级槽位',
  `cost` varchar(600) NOT NULL DEFAULT '[]' COMMENT '消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰槽位表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_shop_pool 结构
DROP TABLE IF EXISTS `base_galaxy_shop_pool`;
CREATE TABLE IF NOT EXISTS `base_galaxy_shop_pool` (
  `id` int(11) unsigned NOT NULL COMMENT '唯一Id',
  `pos` int(11) unsigned NOT NULL COMMENT '槽位Id',
  `award` varchar(150) NOT NULL DEFAULT '[]' COMMENT '物品',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '花费',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `times_weight` varchar(600) NOT NULL DEFAULT '[]' COMMENT '次数权重加成',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰商品配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_skill 结构
DROP TABLE IF EXISTS `base_galaxy_skill`;
CREATE TABLE IF NOT EXISTS `base_galaxy_skill` (
  `id` int(10) unsigned NOT NULL COMMENT '技能ID',
  `lv` int(10) unsigned NOT NULL COMMENT '技能等级',
  `color` int(10) unsigned NOT NULL COMMENT '品质',
  `item` int(10) NOT NULL DEFAULT '0' COMMENT '技能对应道具',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `is_repeate` int(11) NOT NULL DEFAULT '0' COMMENT '是否可重复',
  PRIMARY KEY (`id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰技能表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_galaxy_skin 结构
DROP TABLE IF EXISTS `base_galaxy_skin`;
CREATE TABLE IF NOT EXISTS `base_galaxy_skin` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '皮肤Id',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `next` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一星数',
  `skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活技能',
  `show` int(11) NOT NULL DEFAULT '0' COMMENT '展位展示',
  `resourse` int(11) NOT NULL DEFAULT '0' COMMENT '资源ID',
  `costs` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `attrs` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `model` int(11) NOT NULL DEFAULT '0' COMMENT '模型',
  `name` varchar(255) NOT NULL DEFAULT '皮肤' COMMENT '名字',
  PRIMARY KEY (`id`,`star`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='星辰皮肤配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_game 结构
DROP TABLE IF EXISTS `base_game`;
CREATE TABLE IF NOT EXISTS `base_game` (
  `cf_name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `cf_value` text NOT NULL COMMENT '值',
  PRIMARY KEY (`cf_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='游戏配置参数表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_act 结构
DROP TABLE IF EXISTS `base_gang_act`;
CREATE TABLE IF NOT EXISTS `base_gang_act` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `name` varchar(50) NOT NULL COMMENT '活动名称',
  `time_describe` varchar(255) NOT NULL DEFAULT '',
  `describe` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_building 结构
DROP TABLE IF EXISTS `base_gang_building`;
CREATE TABLE IF NOT EXISTS `base_gang_building` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗资金',
  `descriptoin` varchar(255) NOT NULL COMMENT '效果描述',
  PRIMARY KEY (`type`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_donate 结构
DROP TABLE IF EXISTS `base_gang_donate`;
CREATE TABLE IF NOT EXISTS `base_gang_donate` (
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_extra_live_reward 结构
DROP TABLE IF EXISTS `base_gang_extra_live_reward`;
CREATE TABLE IF NOT EXISTS `base_gang_extra_live_reward` (
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人累积活跃度',
  `extra_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额外增加公会活跃度',
  PRIMARY KEY (`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_king_building 结构
DROP TABLE IF EXISTS `base_gang_king_building`;
CREATE TABLE IF NOT EXISTS `base_gang_king_building` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金库等级',
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日上限',
  PRIMARY KEY (`lv`,`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_salary 结构
DROP TABLE IF EXISTS `base_gang_salary`;
CREATE TABLE IF NOT EXISTS `base_gang_salary` (
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `ac_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度最小值',
  `ac_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度最大值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`pos`,`ac_min`,`ac_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_shop 结构
DROP TABLE IF EXISTS `base_gang_shop`;
CREATE TABLE IF NOT EXISTS `base_gang_shop` (
  `auto_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品唯一id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗贡献',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买上限',
  `building_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店等级',
  PRIMARY KEY (`auto_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_skill 结构
DROP TABLE IF EXISTS `base_gang_skill`;
CREATE TABLE IF NOT EXISTS `base_gang_skill` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `skill_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `skill_name` varchar(50) NOT NULL DEFAULT '0' COMMENT '技能名字',
  `building_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑等级下限',
  `building_lv_max` int(11) NOT NULL DEFAULT '0' COMMENT '建筑等级上限',
  `guild_lv` int(11) NOT NULL DEFAULT '0' COMMENT '公会等级',
  `role_min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '人物等级下限',
  `role_max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '人物等级上限',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级消耗',
  `resource_id` int(11) NOT NULL DEFAULT '0' COMMENT '技能图标',
  `description` varchar(50) NOT NULL COMMENT '技能效果描述',
  PRIMARY KEY (`skill_id`,`skill_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_skill_building 结构
DROP TABLE IF EXISTS `base_gang_skill_building`;
CREATE TABLE IF NOT EXISTS `base_gang_skill_building` (
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能建筑等级',
  `attr_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性加成比例',
  PRIMARY KEY (`build_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_store 结构
DROP TABLE IF EXISTS `base_gang_store`;
CREATE TABLE IF NOT EXISTS `base_gang_store` (
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品阶',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`grade`,`star`,`color`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_store_building 结构
DROP TABLE IF EXISTS `base_gang_store_building`;
CREATE TABLE IF NOT EXISTS `base_gang_store_building` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '仓库等级',
  `cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '格子数',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gang_task_building 结构
DROP TABLE IF EXISTS `base_gang_task_building`;
CREATE TABLE IF NOT EXISTS `base_gang_task_building` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加成百分比',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gift_box 结构
DROP TABLE IF EXISTS `base_gift_box`;
CREATE TABLE IF NOT EXISTS `base_gift_box` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包物品ID',
  `get_way` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '领取方式，1礼包放在背包，2直接领取礼包内物品',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '绑定状态##0非绑定，1绑定',
  `condition` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '条件',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间，0为不限',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间，0为不限',
  `filter` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '筛选内容',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态，0为不生效，1为生效',
  `show` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示礼包领取界面',
  PRIMARY KEY (`goods_id`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包配置表(新)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gift_list 结构
DROP TABLE IF EXISTS `base_gift_list`;
CREATE TABLE IF NOT EXISTS `base_gift_list` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '序号',
  `gift_type` varchar(4) NOT NULL COMMENT '标识符，4位固定',
  `name` varchar(50) NOT NULL COMMENT '礼包名@lang@',
  `source` varchar(20) NOT NULL COMMENT '渠道',
  `list` varchar(1000) DEFAULT '[]' COMMENT '内容列表',
  `start_time` int(11) DEFAULT '0' COMMENT '有效开始，无0',
  `end_time` int(11) DEFAULT '0' COMMENT '有效结束，无0',
  `use_num` int(11) DEFAULT '1' COMMENT '同类型推广礼包最大叠加使用次数',
  PRIMARY KEY (`id`),
  UNIQUE KEY `type` (`gift_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼品卡列表配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_gift_reward 结构
DROP TABLE IF EXISTS `base_gift_reward`;
CREATE TABLE IF NOT EXISTS `base_gift_reward` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `slv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '开启等级',
  `elv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '结束等级',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '转生',
  `rand` int(11) unsigned DEFAULT '0' COMMENT '随机次数',
  `is_back` tinyint(1) unsigned DEFAULT '0' COMMENT '是否放回随机##0:否;1:是',
  `rand_gifts` varchar(5000) DEFAULT '[]' COMMENT '随机物品##[{{类型, 物品id, 数量}, R(权重)}]',
  `fixed_gifts` varchar(5000) DEFAULT '[]' COMMENT '固定物品##[{类型, 物品id, 数量}]',
  `drop_gifts` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '掉落物品##走掉落规则[{掉落列表id,数量}]',
  `tv_goods_id` varchar(1000) DEFAULT '[]' COMMENT '需要传闻的物品id##打开礼包时如果开到这些物品,会发传闻',
  PRIMARY KEY (`goods_id`,`slv`,`elv`,`sex`,`career`,`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_glamour_award 结构
DROP TABLE IF EXISTS `base_glamour_award`;
CREATE TABLE IF NOT EXISTS `base_glamour_award` (
  `min_money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资金下限',
  `max_money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资金上限',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`min_money`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_glamour_chat 结构
DROP TABLE IF EXISTS `base_glamour_chat`;
CREATE TABLE IF NOT EXISTS `base_glamour_chat` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `msg` varchar(2000) NOT NULL DEFAULT '' COMMENT '发言',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='随机发言';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_glamour_effect 结构
DROP TABLE IF EXISTS `base_glamour_effect`;
CREATE TABLE IF NOT EXISTS `base_glamour_effect` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数',
  `effect` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '效果',
  PRIMARY KEY (`type`,`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跑马道具效果';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_glamour_item 结构
DROP TABLE IF EXISTS `base_glamour_item`;
CREATE TABLE IF NOT EXISTS `base_glamour_item` (
  `item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `rate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '命中概率',
  `price` varchar(50) NOT NULL DEFAULT '[]' COMMENT '价格',
  PRIMARY KEY (`item`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='气氛道具';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_glamour_key_value 结构
DROP TABLE IF EXISTS `base_glamour_key_value`;
CREATE TABLE IF NOT EXISTS `base_glamour_key_value` (
  `key` varchar(50) NOT NULL DEFAULT '0' COMMENT '键',
  `value` varchar(500) NOT NULL COMMENT '数据',
  `desc` tinytext NOT NULL COMMENT '备注@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='杂项配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_glamour_speed 结构
DROP TABLE IF EXISTS `base_glamour_speed`;
CREATE TABLE IF NOT EXISTS `base_glamour_speed` (
  `type` int(11) unsigned NOT NULL COMMENT '类型',
  `seconds` int(11) unsigned NOT NULL COMMENT '秒',
  `extra` tinytext NOT NULL COMMENT '系数',
  PRIMARY KEY (`type`,`seconds`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时间因子表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_global_counter 结构
DROP TABLE IF EXISTS `base_global_counter`;
CREATE TABLE IF NOT EXISTS `base_global_counter` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '次数id',
  `limit` int(11) unsigned DEFAULT '1' COMMENT '上限',
  `about` varchar(1000) DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`module`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_global_counter_extra 结构
DROP TABLE IF EXISTS `base_global_counter_extra`;
CREATE TABLE IF NOT EXISTS `base_global_counter_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) NOT NULL DEFAULT '1' COMMENT '功能子id',
  `limit` int(11) unsigned DEFAULT '1' COMMENT '上限',
  `about` varchar(1000) DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`module`,`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god 结构
DROP TABLE IF EXISTS `base_god`;
CREATE TABLE IF NOT EXISTS `base_god` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '唤神id',
  `name` varchar(1000) NOT NULL DEFAULT '<<>>' COMMENT '唤神名称',
  `star` int(11) NOT NULL DEFAULT '0' COMMENT '星级',
  `cost` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '升星消耗',
  `need_lv` int(11) NOT NULL DEFAULT '0' COMMENT '升星等级限制',
  `attr` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '成长属性',
  `god_attr` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '唤神属性',
  `skills` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '初始技能列表##[{技能id，技能等级}]',
  `content` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '背景描述',
  `picture_id` int(11) NOT NULL DEFAULT '0' COMMENT '资源id',
  `order` int(11) NOT NULL DEFAULT '0' COMMENT '图鉴序号',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '激活卡id',
  `skill_max` int(11) NOT NULL DEFAULT '0' COMMENT '技能上限',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型ID',
  PRIMARY KEY (`id`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神-唤神图鉴';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_dun_kv 结构
DROP TABLE IF EXISTS `base_god_dun_kv`;
CREATE TABLE IF NOT EXISTS `base_god_dun_kv` (
  `key` varchar(255) NOT NULL COMMENT '主键',
  `val` varchar(255) NOT NULL DEFAULT '[]' COMMENT '值',
  `desc` varchar(255) DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_dun_mon_cfg 结构
DROP TABLE IF EXISTS `base_god_dun_mon_cfg`;
CREATE TABLE IF NOT EXISTS `base_god_dun_mon_cfg` (
  `mon_id` int(11) NOT NULL COMMENT '怪物ID',
  `type` int(11) NOT NULL DEFAULT '1' COMMENT '抽取类型',
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名值',
  `attrs` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性转换列表',
  `info_from_rank` int(11) NOT NULL DEFAULT '0' COMMENT '信息抽取排名',
  PRIMARY KEY (`mon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本-怪物信息配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_dun_rank_reward 结构
DROP TABLE IF EXISTS `base_god_dun_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_god_dun_rank_reward` (
  `rank_type` int(11) NOT NULL COMMENT '排名类型',
  `rank_min` int(11) NOT NULL COMMENT '排名上限',
  `rank_max` int(11) NOT NULL COMMENT '排名下限',
  `limit` int(11) NOT NULL DEFAULT '0' COMMENT '上榜限制',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_type`,`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本-排行奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_dun_shop_goods 结构
DROP TABLE IF EXISTS `base_god_dun_shop_goods`;
CREATE TABLE IF NOT EXISTS `base_god_dun_shop_goods` (
  `index` int(11) NOT NULL COMMENT '物品唯一序号',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '物品ID',
  `is_bind` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否绑定',
  `goods_num` int(11) NOT NULL DEFAULT '0' COMMENT '单次购买物品数量',
  `price` int(11) NOT NULL DEFAULT '0' COMMENT '价格',
  `rank_weight` int(11) NOT NULL DEFAULT '0' COMMENT '排序权重',
  PRIMARY KEY (`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本-商品项配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_dun_shop_rule 结构
DROP TABLE IF EXISTS `base_god_dun_shop_rule`;
CREATE TABLE IF NOT EXISTS `base_god_dun_shop_rule` (
  `lv_min` int(11) NOT NULL COMMENT '等级上限',
  `lv_max` int(11) NOT NULL COMMENT '等级下限',
  `fix_goods` varchar(1500) NOT NULL DEFAULT '[]' COMMENT '每日固定商品列表',
  `rand_goods` varchar(1500) NOT NULL DEFAULT '[]' COMMENT '每日随机商品列表',
  `rand_num` int(11) NOT NULL DEFAULT '0' COMMENT '每日随机商品数',
  `week_fix_goods` varchar(1500) NOT NULL DEFAULT '[]' COMMENT '每周固定商品列表',
  `week_rand_goods` varchar(1500) NOT NULL DEFAULT '[]' COMMENT '每周随机商品列表',
  `week_rand_num` int(11) NOT NULL DEFAULT '0' COMMENT '每周随机商品数',
  PRIMARY KEY (`lv_min`,`lv_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本-商店规则配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_dun_wave_reward 结构
DROP TABLE IF EXISTS `base_god_dun_wave_reward`;
CREATE TABLE IF NOT EXISTS `base_god_dun_wave_reward` (
  `wave` int(11) NOT NULL COMMENT '波数',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '兑换积分',
  `rank_score` int(11) NOT NULL DEFAULT '0' COMMENT '排行积分',
  PRIMARY KEY (`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本-波数奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_equip 结构
DROP TABLE IF EXISTS `base_god_equip`;
CREATE TABLE IF NOT EXISTS `base_god_equip` (
  `quality` int(11) NOT NULL DEFAULT '0' COMMENT '品质',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '升级经验',
  PRIMARY KEY (`quality`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神-装备升级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_equip_manual 结构
DROP TABLE IF EXISTS `base_god_equip_manual`;
CREATE TABLE IF NOT EXISTS `base_god_equip_manual` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '装备id',
  `name` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '装备名称',
  `attr` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '成长属性',
  `extra_attr` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '变异属性',
  `pos` int(11) NOT NULL DEFAULT '0' COMMENT '位置',
  `quality` int(11) NOT NULL DEFAULT '0' COMMENT '品质',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '吞噬经验',
  `suit_id` int(11) NOT NULL DEFAULT '0' COMMENT '套装类型',
  `picture_id` int(11) NOT NULL DEFAULT '0' COMMENT '资源id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神-装备图鉴';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_equip_suit 结构
DROP TABLE IF EXISTS `base_god_equip_suit`;
CREATE TABLE IF NOT EXISTS `base_god_equip_suit` (
  `suit_id` int(11) NOT NULL DEFAULT '0' COMMENT '套装id',
  `equip_num` tinyint(2) NOT NULL DEFAULT '0' COMMENT '装备数量',
  `name` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '套装名',
  `skill_id` int(11) NOT NULL DEFAULT '0' COMMENT '技能id',
  `effect` varchar(1000) NOT NULL DEFAULT '0' COMMENT '效果',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '效果类型##(1上阵唤神属性加成/2上阵玩家属性加成/3出战玩家属性加成/9特殊效果)',
  `desc` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '描述',
  `type_name` varchar(255) NOT NULL DEFAULT '' COMMENT '套装大类名字',
  PRIMARY KEY (`suit_id`,`equip_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神-装备套装效果';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_kv 结构
DROP TABLE IF EXISTS `base_god_kv`;
CREATE TABLE IF NOT EXISTS `base_god_kv` (
  `key_content` varchar(100) NOT NULL DEFAULT '[]' COMMENT 'KEY',
  `value_content` varchar(1000) NOT NULL DEFAULT '[]' COMMENT 'VALUE',
  `desc_content` varchar(1000) NOT NULL DEFAULT '""' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神-唤神键值配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_limit_pool 结构
DROP TABLE IF EXISTS `base_god_limit_pool`;
CREATE TABLE IF NOT EXISTS `base_god_limit_pool` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '序号',
  `awards` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `broadcast` int(11) NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '奖品权重',
  `need_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开放等级',
  `phase` smallint(5) NOT NULL DEFAULT '0' COMMENT '需要期数',
  `is_show` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否展示',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_lottery_phase 结构
DROP TABLE IF EXISTS `base_god_lottery_phase`;
CREATE TABLE IF NOT EXISTS `base_god_lottery_phase` (
  `phase` smallint(5) NOT NULL DEFAULT '0' COMMENT '期数',
  `god_id` int(11) NOT NULL DEFAULT '0' COMMENT '主题式神',
  `count_award` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '保底奖励',
  `blessing_award` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '累计奖励',
  `days` smallint(5) NOT NULL DEFAULT '0' COMMENT '持续天数',
  PRIMARY KEY (`phase`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_lv 结构
DROP TABLE IF EXISTS `base_god_lv`;
CREATE TABLE IF NOT EXISTS `base_god_lv` (
  `god_id` int(11) NOT NULL DEFAULT '0' COMMENT '唤神id',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '升级经验',
  PRIMARY KEY (`god_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神-唤神升级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_normal_phase 结构
DROP TABLE IF EXISTS `base_god_normal_phase`;
CREATE TABLE IF NOT EXISTS `base_god_normal_phase` (
  `phase` smallint(5) NOT NULL DEFAULT '0' COMMENT '期数',
  `awards` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '累计奖励',
  PRIMARY KEY (`phase`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_normal_pool 结构
DROP TABLE IF EXISTS `base_god_normal_pool`;
CREATE TABLE IF NOT EXISTS `base_god_normal_pool` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '序号',
  `awards` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `broadcast` int(11) NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '奖品权重',
  `need_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开放等级',
  `phase` smallint(5) NOT NULL DEFAULT '0' COMMENT '需要期数',
  `show` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否展示',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_god_percent_rank_cfg 结构
DROP TABLE IF EXISTS `base_god_percent_rank_cfg`;
CREATE TABLE IF NOT EXISTS `base_god_percent_rank_cfg` (
  `rank_min` int(11) NOT NULL COMMENT '排名上限',
  `rank_max` int(11) NOT NULL COMMENT '排名下限',
  `percent` int(11) NOT NULL DEFAULT '0' COMMENT '百分比',
  PRIMARY KEY (`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本-百分比排名配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods 结构
DROP TABLE IF EXISTS `base_goods`;
CREATE TABLE IF NOT EXISTS `base_goods` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品编号',
  `goods_name` varchar(50) NOT NULL COMMENT '物品名称@lang@',
  `intro` text NOT NULL COMMENT '基础信息@lang@',
  `attr_intor` varchar(1024) NOT NULL COMMENT '物品说明@lang@',
  `combat_intor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力描述',
  `getway` text NOT NULL COMMENT '使用说明@lang@',
  `getway_url` varchar(255) NOT NULL DEFAULT '' COMMENT '获取途径链接',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '绑定类型，0非绑可交易，1绑定不可交易 ',
  `sell` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否出售，0不可出售 ，1可出售',
  `drop` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否可丢弃:1可丢弃|0不可丢弃',
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品子类型ID',
  `goods_icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品图标',
  `career_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '职业限制，0为不限',
  `level` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '等级需求，0为不限',
  `max_overlap` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '可叠加数，0为不可叠加',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '物品颜色，0白，1绿，2蓝，3紫，4橙，5红，6金',
  `expire_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1有效时间(秒数)/2时间戳/3开服天数/4合服天数/5当天0点开始计算的有效时间(秒数)',
  `expire_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效期，0为不限，单位为秒',
  `use` int(11) unsigned NOT NULL COMMENT '是否可使用，(0：不可使用，1：可使用)',
  `sell_category` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '市场商品类型',
  `sell_subcategory` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '市场商品子类型',
  `trade_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易底价（为0时无底价）',
  `price_markup` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易每次加价价格',
  `buyout_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易一口价（为0时无一口价）',
  `market_show_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公示时间-上架多久后可交易（秒）',
  `selling_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上架时间-可交易多长时间（秒）',
  `is_to_market` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否会流入世界拍卖（当上架公会拍卖流拍时是否能流入世界拍卖，1是0否）',
  `market_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可上架区域，0表示社团和世界都可以上架，1表示只能上架世界，2表示只能上架社团',
  `compose` int(11) unsigned NOT NULL COMMENT '是否可合成，(0：不可合成，1：可合成)',
  `quick_use` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '获得立即使用',
  `base_attrlist` varchar(512) NOT NULL DEFAULT '[]' COMMENT ' [{属性类型,值}]',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型资源id',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别限制##0为不限，1男，2女',
  `jump` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以跳转:0否;1是，仅用于显示“跳转”按钮，和“使用”字段互斥，只能有一个填“1”',
  `use_way` varchar(250) NOT NULL DEFAULT '' COMMENT '使用途径',
  `notice_use` varchar(255) NOT NULL DEFAULT '' COMMENT '使用提醒##[1]=true：玩家上线时提示使用;[2]=true：获得该物品时，提示使用;[3]=true：点击使用后弹出二级弹窗，并且出现配置的说明文本',
  `batch_use` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '批量使用',
  `suggested_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参考价格',
  PRIMARY KEY (`goods_id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_attribute 结构
DROP TABLE IF EXISTS `base_goods_attribute`;
CREATE TABLE IF NOT EXISTS `base_goods_attribute` (
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '编号ID',
  `attribute_name` varchar(50) NOT NULL DEFAULT '' COMMENT '属性类型名称@lang@',
  `attribute_about` varchar(255) NOT NULL DEFAULT '' COMMENT '属性类型说明@lang@',
  PRIMARY KEY (`attribute_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品属性类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_compose_or_evolution_classify 结构
DROP TABLE IF EXISTS `base_goods_compose_or_evolution_classify`;
CREATE TABLE IF NOT EXISTS `base_goods_compose_or_evolution_classify` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分类id',
  `id_name` varchar(500) NOT NULL DEFAULT '[]' COMMENT '分类名称',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类id',
  `name` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '子类名称',
  `condition` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  PRIMARY KEY (`id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品-物品合成进化分类';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_compose_or_evolution_info 结构
DROP TABLE IF EXISTS `base_goods_compose_or_evolution_info`;
CREATE TABLE IF NOT EXISTS `base_goods_compose_or_evolution_info` (
  `rule_id` int(11) unsigned NOT NULL COMMENT '规则id',
  `classify_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分类',
  `subclass` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类',
  `target_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标物品',
  `condition` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  `main_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主消耗物品##将该物品进化为目标物品id，普通合成为0',
  `cost_goods` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '消耗物品',
  `cost_money` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '消耗货币',
  `base_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始成功率##万分比',
  `desc` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '描述',
  `hidden` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否隐藏',
  PRIMARY KEY (`rule_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品-物品合成进化规则';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_decompose 结构
DROP TABLE IF EXISTS `base_goods_decompose`;
CREATE TABLE IF NOT EXISTS `base_goods_decompose` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `module` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `irregular_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '随机材料种类',
  `irregular_mat` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机材料',
  `regular_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '固定材料种类',
  `regular_mat` varchar(255) NOT NULL DEFAULT '[]' COMMENT '固定材料[{goods,id,num}]',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品分解配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_devour 结构
DROP TABLE IF EXISTS `base_goods_devour`;
CREATE TABLE IF NOT EXISTS `base_goods_devour` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下级经验',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-吞噬等级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_devour_extra 结构
DROP TABLE IF EXISTS `base_goods_devour_extra`;
CREATE TABLE IF NOT EXISTS `base_goods_devour_extra` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `name` varchar(255) NOT NULL COMMENT '名称',
  `attr_point` varchar(255) NOT NULL DEFAULT '[]' COMMENT '节点属性',
  `attr_total` varchar(255) NOT NULL DEFAULT '[]' COMMENT '总属性',
  `picture` varchar(255) NOT NULL COMMENT '资源id',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='吞噬-吞噬额外属性';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_effect 结构
DROP TABLE IF EXISTS `base_goods_effect`;
CREATE TABLE IF NOT EXISTS `base_goods_effect` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '道具类型',
  `buff_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BUFF类型ID',
  `effect_list` varchar(1024) NOT NULL COMMENT '效果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续时长(秒)',
  `limit_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '限制类型',
  `counter_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数模块ID',
  `counter_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数ID',
  `limit_scene` varchar(255) NOT NULL COMMENT '生效的场景ID',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品效果配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_effect_type 结构
DROP TABLE IF EXISTS `base_goods_effect_type`;
CREATE TABLE IF NOT EXISTS `base_goods_effect_type` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品buff类型id';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_exchange 结构
DROP TABLE IF EXISTS `base_goods_exchange`;
CREATE TABLE IF NOT EXISTS `base_goods_exchange` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '标题@lang@',
  `npc` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'NPC编号',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型，0 物品兑换，1 竞技积分兑换',
  `method` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换方式，0为固定兑换，1为随机兑换',
  `raw_goods` text NOT NULL COMMENT '原物品列表',
  `dst_goods` text NOT NULL COMMENT '兑换物品列表',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换物品的绑定状态',
  `max_overlap` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '兑换物品的最大叠加数',
  `exchange_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型，0:单日物品兑换; 1:每周物品的兑换; 2:日和周都要计算的类型（暂时只做0的类型',
  `limit_week_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制兑换数的每次次数类型Id(物品兑换每周限制专用区间17001 - 18500)',
  `limit_week_num` int(11) NOT NULL COMMENT '每周兑换的次数',
  `limit_day_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制兑换数的日常次数类型Id(物品兑换每日限制专用区间18501 - 20000)',
  `limit_day_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每天能兑换的次数',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间，0为不限',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间，0为不限',
  `condition` varchar(1000) DEFAULT '[]' COMMENT '开启条件',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态，1为生效，0为不生效',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品兑换规则表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_exp 结构
DROP TABLE IF EXISTS `base_goods_exp`;
CREATE TABLE IF NOT EXISTS `base_goods_exp` (
  `goods_id` int(10) unsigned NOT NULL COMMENT '物品id',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '等级区间左',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '等级区间右',
  `exp` int(10) unsigned NOT NULL COMMENT '固定经验',
  `up_lv` int(11) NOT NULL DEFAULT '0' COMMENT '升级数',
  PRIMARY KEY (`goods_id`,`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验丹动态经验';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_label 结构
DROP TABLE IF EXISTS `base_goods_label`;
CREATE TABLE IF NOT EXISTS `base_goods_label` (
  `label_id` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '标签ID',
  `label_name` varchar(50) NOT NULL DEFAULT '' COMMENT '标签名称@lang@',
  PRIMARY KEY (`label_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品标签表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_location 结构
DROP TABLE IF EXISTS `base_goods_location`;
CREATE TABLE IF NOT EXISTS `base_goods_location` (
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '位置类型',
  `name` varchar(50) NOT NULL DEFAULT '<<>>' COMMENT '名称',
  `default_size` int(11) NOT NULL DEFAULT '0' COMMENT '初始格子数##为0表示不设大小,由服务器端控制',
  `max_size` int(11) NOT NULL DEFAULT '0' COMMENT '最大格子数##为0表示不设大小,由服务器端控制',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品位置类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_passoff_type 结构
DROP TABLE IF EXISTS `base_goods_passoff_type`;
CREATE TABLE IF NOT EXISTS `base_goods_passoff_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品消耗类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_price 结构
DROP TABLE IF EXISTS `base_goods_price`;
CREATE TABLE IF NOT EXISTS `base_goods_price` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `price_type` smallint(6) unsigned DEFAULT '1' COMMENT '价格类型',
  `price` int(11) unsigned DEFAULT '0' COMMENT '购买价格',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_produce_type 结构
DROP TABLE IF EXISTS `base_goods_produce_type`;
CREATE TABLE IF NOT EXISTS `base_goods_produce_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品产出类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_renew 结构
DROP TABLE IF EXISTS `base_goods_renew`;
CREATE TABLE IF NOT EXISTS `base_goods_renew` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '物品id',
  `price_type` tinyint(3) unsigned NOT NULL COMMENT '价格类型',
  `price` int(11) unsigned NOT NULL COMMENT '价格',
  `renew_time` int(11) unsigned NOT NULL COMMENT '续费时长',
  PRIMARY KEY (`goods_id`,`price_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品续费配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_sell 结构
DROP TABLE IF EXISTS `base_goods_sell`;
CREATE TABLE IF NOT EXISTS `base_goods_sell` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_sell_subtype 结构
DROP TABLE IF EXISTS `base_goods_sell_subtype`;
CREATE TABLE IF NOT EXISTS `base_goods_sell_subtype` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '子类型ID',
  `subtype_name` varchar(50) NOT NULL DEFAULT '' COMMENT '子类型名称@lang@',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT '商品分类图标',
  PRIMARY KEY (`type`,`subtype`),
  UNIQUE KEY `type_id` (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品出售子类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_sell_type 结构
DROP TABLE IF EXISTS `base_goods_sell_type`;
CREATE TABLE IF NOT EXISTS `base_goods_sell_type` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '类型名称@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品出售类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_subtype 结构
DROP TABLE IF EXISTS `base_goods_subtype`;
CREATE TABLE IF NOT EXISTS `base_goods_subtype` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '子类型ID',
  `subtype_name` varchar(50) NOT NULL DEFAULT '' COMMENT '子类型名称@lang@',
  `sublabel_id` int(11) NOT NULL COMMENT '标签ID',
  `sub_bag_location` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型背包位置',
  UNIQUE KEY `type_id` (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品子类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_goods_type 结构
DROP TABLE IF EXISTS `base_goods_type`;
CREATE TABLE IF NOT EXISTS `base_goods_type` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '类型名称@lang@',
  `label_id` int(11) NOT NULL COMMENT '标签ID',
  `bag_location` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '背包位置',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_badge 结构
DROP TABLE IF EXISTS `base_guild_badge`;
CREATE TABLE IF NOT EXISTS `base_guild_badge` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '徽章id',
  `name` varchar(200) NOT NULL DEFAULT '徽章' COMMENT '名字',
  `level` int(11) NOT NULL DEFAULT '1' COMMENT '等级',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cool` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  `condition` varchar(500) NOT NULL DEFAULT '[]' COMMENT '激活条件',
  `note` varchar(200) NOT NULL DEFAULT '条件描述' COMMENT '条件描述',
  `effect` varchar(500) NOT NULL DEFAULT '0' COMMENT '效果',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '效果描述',
  `shape` int(11) NOT NULL DEFAULT '0' COMMENT '外形',
  `next` int(11) NOT NULL DEFAULT '0' COMMENT '下一个ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团徽章配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_boss 结构
DROP TABLE IF EXISTS `base_guild_boss`;
CREATE TABLE IF NOT EXISTS `base_guild_boss` (
  `boss` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上',
  PRIMARY KEY (`boss`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团boss';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_boss_awards 结构
DROP TABLE IF EXISTS `base_guild_boss_awards`;
CREATE TABLE IF NOT EXISTS `base_guild_boss_awards` (
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '归属类型',
  `min_rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名上限',
  `min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `min_day` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数下限',
  `max_day` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数上限',
  `awards` varchar(2000) NOT NULL DEFAULT '' COMMENT '奖励规则',
  PRIMARY KEY (`type`,`min_rank`,`max_rank`,`min_lv`,`max_lv`,`min_day`,`max_day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_boss_box 结构
DROP TABLE IF EXISTS `base_guild_boss_box`;
CREATE TABLE IF NOT EXISTS `base_guild_boss_box` (
  `join` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参与人数(降序)',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生成数',
  PRIMARY KEY (`join`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团BOSS人数掉落';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_boss_cash 结构
DROP TABLE IF EXISTS `base_guild_boss_cash`;
CREATE TABLE IF NOT EXISTS `base_guild_boss_cash` (
  `nummin` int(11) NOT NULL DEFAULT '0' COMMENT '人数下',
  `nummax` int(11) NOT NULL DEFAULT '0' COMMENT '人数上',
  `limit` int(11) NOT NULL DEFAULT '0' COMMENT '上限',
  `rate` int(11) NOT NULL DEFAULT '0' COMMENT '税率',
  PRIMARY KEY (`nummin`,`nummax`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_boss_kv 结构
DROP TABLE IF EXISTS `base_guild_boss_kv`;
CREATE TABLE IF NOT EXISTS `base_guild_boss_kv` (
  `key` varchar(50) NOT NULL DEFAULT '0' COMMENT '键',
  `value` varchar(500) NOT NULL COMMENT '数据',
  `desc` tinytext NOT NULL COMMENT '备注@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='杂项配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_cargo 结构
DROP TABLE IF EXISTS `base_guild_cargo`;
CREATE TABLE IF NOT EXISTS `base_guild_cargo` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `lv_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级下',
  `lv_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级上',
  `guild_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团等级',
  `cargo` varchar(500) NOT NULL DEFAULT '[]' COMMENT '商品',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限购类型',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限购数量',
  `cost` varchar(500) NOT NULL DEFAULT '' COMMENT '消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团商品配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_collect_kv 结构
DROP TABLE IF EXISTS `base_guild_collect_kv`;
CREATE TABLE IF NOT EXISTS `base_guild_collect_kv` (
  `key` varchar(255) NOT NULL COMMENT '主键',
  `value` varchar(255) NOT NULL DEFAULT '[]' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团午间采集-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_collect_mon 结构
DROP TABLE IF EXISTS `base_guild_collect_mon`;
CREATE TABLE IF NOT EXISTS `base_guild_collect_mon` (
  `mon_id` int(11) NOT NULL COMMENT '怪物id',
  `min_world_lv` int(11) NOT NULL COMMENT '世界等级下限',
  `max_world_lv` int(11) NOT NULL COMMENT '世界等级上限',
  PRIMARY KEY (`mon_id`,`min_world_lv`,`max_world_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团午间采集-裂缝怪物配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_collect_mon_rewards 结构
DROP TABLE IF EXISTS `base_guild_collect_mon_rewards`;
CREATE TABLE IF NOT EXISTS `base_guild_collect_mon_rewards` (
  `lv_min` int(11) NOT NULL COMMENT '玩家等级下限',
  `lv_max` int(11) NOT NULL COMMENT '玩家等级上限',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '召唤奖励',
  `help_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '协助奖励',
  PRIMARY KEY (`lv_min`,`lv_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团午间采集-怪物协助奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_create 结构
DROP TABLE IF EXISTS `base_guild_create`;
CREATE TABLE IF NOT EXISTS `base_guild_create` (
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `guild_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始公会大厅等级',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '创建条件',
  PRIMARY KEY (`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_demon_awards 结构
DROP TABLE IF EXISTS `base_guild_demon_awards`;
CREATE TABLE IF NOT EXISTS `base_guild_demon_awards` (
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '归属类型',
  `min_rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名上限',
  `min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `min_day` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数下限',
  `max_day` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数上限',
  `awards` varchar(2000) NOT NULL DEFAULT '' COMMENT '奖励规则',
  PRIMARY KEY (`type`,`min_rank`,`max_rank`,`min_lv`,`max_lv`,`min_day`,`max_day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_kv 结构
DROP TABLE IF EXISTS `base_guild_kv`;
CREATE TABLE IF NOT EXISTS `base_guild_kv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `key` varchar(50) NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(256) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_lv 结构
DROP TABLE IF EXISTS `base_guild_lv`;
CREATE TABLE IF NOT EXISTS `base_guild_lv` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '需要的活跃值',
  `member_capacity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成员数量',
  `pos_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '职位数量',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_merge 结构
DROP TABLE IF EXISTS `base_guild_merge`;
CREATE TABLE IF NOT EXISTS `base_guild_merge` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `min_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天下',
  `max_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天上',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '免疫合并',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团合并条件';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_order 结构
DROP TABLE IF EXISTS `base_guild_order`;
CREATE TABLE IF NOT EXISTS `base_guild_order` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置ID',
  `name` varchar(200) NOT NULL DEFAULT '打豆豆' COMMENT '单名',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级下',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级上',
  `max_num` int(11) NOT NULL DEFAULT '0' COMMENT '拼单人数',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '订单内容',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `gain` varchar(500) NOT NULL DEFAULT '[]' COMMENT '派单奖励',
  `awards` varchar(500) NOT NULL DEFAULT '[]' COMMENT '完成奖励',
  `desc` varchar(500) NOT NULL DEFAULT '打豆豆' COMMENT '描述',
  `link` varchar(200) NOT NULL DEFAULT '0' COMMENT '跳转',
  `thank_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '感谢-协助者奖励',
  `order_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '感谢-任务主奖励',
  `weight` int(11) NOT NULL DEFAULT '1' COMMENT '权重',
  `show_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '感谢礼包展示',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团订单配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_pos 结构
DROP TABLE IF EXISTS `base_guild_pos`;
CREATE TABLE IF NOT EXISTS `base_guild_pos` (
  `position` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `name` varchar(50) NOT NULL DEFAULT '0' COMMENT '职位名称',
  `permission_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '权限列表',
  `reputation_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日声望加成',
  PRIMARY KEY (`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_race_rank_expand 结构
DROP TABLE IF EXISTS `base_guild_race_rank_expand`;
CREATE TABLE IF NOT EXISTS `base_guild_race_rank_expand` (
  `day` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '天数',
  `add_mem_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '增加成员数量',
  PRIMARY KEY (`day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团竞榜结算-社团扩张人数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_race_rank_kv 结构
DROP TABLE IF EXISTS `base_guild_race_rank_kv`;
CREATE TABLE IF NOT EXISTS `base_guild_race_rank_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团竞速-常量配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_race_rank_reward 结构
DROP TABLE IF EXISTS `base_guild_race_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_guild_race_rank_reward` (
  `id` int(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `rank_low` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `rank_high` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '个人奖励',
  `guild_rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '社团排名',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团竞榜结算-个人奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_skill 结构
DROP TABLE IF EXISTS `base_guild_skill`;
CREATE TABLE IF NOT EXISTS `base_guild_skill` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 1: 基础技能 2: 高级技能',
  `unlock_lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '解锁所需公会等级',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_skill_research 结构
DROP TABLE IF EXISTS `base_guild_skill_research`;
CREATE TABLE IF NOT EXISTS `base_guild_skill_research` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `research_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '研究消耗',
  `learn_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '学习消耗',
  PRIMARY KEY (`skill_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能研究';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_support 结构
DROP TABLE IF EXISTS `base_guild_support`;
CREATE TABLE IF NOT EXISTS `base_guild_support` (
  `support_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '协助Id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能Id',
  `sub_mod_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子Id',
  `mod_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩法名字',
  `support_limit` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '协助人数上限',
  `reward_reputation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '协助奖励声望',
  `thank_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '请求者奖励',
  `support_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '协助者奖励',
  PRIMARY KEY (`support_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团-社团协助配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_task 结构
DROP TABLE IF EXISTS `base_guild_task`;
CREATE TABLE IF NOT EXISTS `base_guild_task` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '任务名',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  `content` varchar(1024) NOT NULL DEFAULT '{}' COMMENT '任务内容',
  `add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成长值',
  `days` varchar(255) NOT NULL DEFAULT '[]' COMMENT '非展示天',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团劳务配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_task_guild_award 结构
DROP TABLE IF EXISTS `base_guild_task_guild_award`;
CREATE TABLE IF NOT EXISTS `base_guild_task_guild_award` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段id',
  `glv_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮派等级下',
  `glv_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮派等级上',
  `day_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服下',
  `day_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服上',
  `need` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '劳务值',
  `awards` varchar(500) NOT NULL DEFAULT '' COMMENT '奖励',
  PRIMARY KEY (`id`,`glv_min`,`glv_max`,`day_min`,`day_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团劳务集体奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_task_role_award 结构
DROP TABLE IF EXISTS `base_guild_task_role_award`;
CREATE TABLE IF NOT EXISTS `base_guild_task_role_award` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段id',
  `glv_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮派等级下',
  `glv_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮派等级上',
  `day_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服下',
  `day_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服上',
  `need` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '劳务值',
  `awards` varchar(500) NOT NULL DEFAULT '' COMMENT '奖励',
  PRIMARY KEY (`id`,`glv_min`,`glv_max`,`day_min`,`day_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团劳务个人奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_tribe_dot 结构
DROP TABLE IF EXISTS `base_guild_tribe_dot`;
CREATE TABLE IF NOT EXISTS `base_guild_tribe_dot` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '位置',
  `dotx` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '坐标X',
  `doty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '坐标Y',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_tribe_radio 结构
DROP TABLE IF EXISTS `base_guild_tribe_radio`;
CREATE TABLE IF NOT EXISTS `base_guild_tribe_radio` (
  `num_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数',
  `num_max` int(11) NOT NULL DEFAULT '0' COMMENT '人数上限',
  `radio` int(11) NOT NULL DEFAULT '0' COMMENT '效率',
  PRIMARY KEY (`num_min`,`num_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='晚宴人数经验加成';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_war_continue_kill_ratio 结构
DROP TABLE IF EXISTS `base_guild_war_continue_kill_ratio`;
CREATE TABLE IF NOT EXISTS `base_guild_war_continue_kill_ratio` (
  `count_low` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '连杀次数',
  `count_high` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '连杀次数',
  `ratio` varchar(10) NOT NULL DEFAULT '0' COMMENT '连杀系数',
  PRIMARY KEY (`count_low`,`count_high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='百团大战-连杀系数(自己当前连杀)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_war_extra_ratio 结构
DROP TABLE IF EXISTS `base_guild_war_extra_ratio`;
CREATE TABLE IF NOT EXISTS `base_guild_war_extra_ratio` (
  `count_low` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '连杀次数',
  `count_high` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '连杀次数',
  `ratio` varchar(10) NOT NULL DEFAULT '0' COMMENT '连杀系数',
  PRIMARY KEY (`count_low`,`count_high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='百团大战-额外系数(对方当前连杀)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_war_guild_reward 结构
DROP TABLE IF EXISTS `base_guild_war_guild_reward`;
CREATE TABLE IF NOT EXISTS `base_guild_war_guild_reward` (
  `rank_high` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `rank_low` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='百团大战-社团会排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_war_kill_rank 结构
DROP TABLE IF EXISTS `base_guild_war_kill_rank`;
CREATE TABLE IF NOT EXISTS `base_guild_war_kill_rank` (
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服社团战-杀人榜奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_war_kv 结构
DROP TABLE IF EXISTS `base_guild_war_kv`;
CREATE TABLE IF NOT EXISTS `base_guild_war_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(5000) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='百团大战-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_war_role_reward 结构
DROP TABLE IF EXISTS `base_guild_war_role_reward`;
CREATE TABLE IF NOT EXISTS `base_guild_war_role_reward` (
  `rank_high` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `rank_low` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='百团大战-个人排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_guild_war_score_reward 结构
DROP TABLE IF EXISTS `base_guild_war_score_reward`;
CREATE TABLE IF NOT EXISTS `base_guild_war_score_reward` (
  `level` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '级别',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`score`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='百团大战-积分奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_hi_point 结构
DROP TABLE IF EXISTS `base_hi_point`;
CREATE TABLE IF NOT EXISTS `base_hi_point` (
  `suit_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '套装Id',
  `mod_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块Id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '功能名称',
  `one_points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次可得狂欢值',
  `max_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '狂欢次数上限',
  `order_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序id',
  `jump_id` varchar(255) NOT NULL DEFAULT '' COMMENT '跳转id',
  `about` varchar(1024) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`suit_id`,`mod_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='嗨点活动配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_hope_gift 结构
DROP TABLE IF EXISTS `base_hope_gift`;
CREATE TABLE IF NOT EXISTS `base_hope_gift` (
  `sub_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '定制活动子ID',
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励轮次',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '名称',
  `weigh` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `resource` varchar(255) NOT NULL DEFAULT '' COMMENT '展示模型资源',
  `is_show` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否宝库展示',
  `is_TV` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='明日之礼';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_hp_resume 结构
DROP TABLE IF EXISTS `base_hp_resume`;
CREATE TABLE IF NOT EXISTS `base_hp_resume` (
  `role_level` smallint(5) NOT NULL COMMENT '角色等级需求',
  `skill_level` tinyint(3) NOT NULL COMMENT '技能等级需求',
  `hp_resume` int(11) NOT NULL COMMENT '回血量',
  PRIMARY KEY (`role_level`,`skill_level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能特殊BUFF产生的特殊回血效果配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_improve_activityhall 结构
DROP TABLE IF EXISTS `base_improve_activityhall`;
CREATE TABLE IF NOT EXISTS `base_improve_activityhall` (
  `adate` varchar(25) NOT NULL COMMENT '开放日期',
  `atime` varchar(25) NOT NULL COMMENT '开放时间',
  `asort` tinyint(3) unsigned NOT NULL COMMENT '排序值',
  `str_id` varchar(100) NOT NULL COMMENT '功能ID',
  PRIMARY KEY (`asort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强活动时间表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_improve_constant 结构
DROP TABLE IF EXISTS `base_improve_constant`;
CREATE TABLE IF NOT EXISTS `base_improve_constant` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `key` varchar(215) NOT NULL COMMENT '键',
  `value` varchar(512) NOT NULL COMMENT '值',
  `note` varchar(512) NOT NULL COMMENT '备注@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强-常量表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_improve_fight_condition 结构
DROP TABLE IF EXISTS `base_improve_fight_condition`;
CREATE TABLE IF NOT EXISTS `base_improve_fight_condition` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '评级ID',
  `condition` tinyint(3) unsigned NOT NULL COMMENT '评级标准',
  `icon` tinyint(3) unsigned NOT NULL COMMENT '评级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强评级表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_improve_fight_num 结构
DROP TABLE IF EXISTS `base_improve_fight_num`;
CREATE TABLE IF NOT EXISTS `base_improve_fight_num` (
  `lv_min` smallint(5) unsigned NOT NULL COMMENT '最低等级',
  `lv_max` smallint(5) unsigned NOT NULL COMMENT '最高等级',
  `fight_num` mediumint(8) unsigned NOT NULL COMMENT '推荐战斗力',
  PRIMARY KEY (`lv_min`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强推荐战斗力表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_improve_fight_task 结构
DROP TABLE IF EXISTS `base_improve_fight_task`;
CREATE TABLE IF NOT EXISTS `base_improve_fight_task` (
  `id` smallint(5) unsigned NOT NULL COMMENT 'ID',
  `page_id` smallint(5) unsigned NOT NULL COMMENT '页码ID',
  `sort_id` smallint(5) unsigned NOT NULL COMMENT '排序ID',
  `lv_min` smallint(5) unsigned NOT NULL COMMENT '最低等级',
  `lv_max` smallint(5) unsigned NOT NULL COMMENT '最高等级',
  `max_num` int(15) unsigned NOT NULL COMMENT '进度条最大值',
  `task_name` varchar(255) NOT NULL COMMENT '任务名称@lang@',
  `task_des` varchar(255) NOT NULL COMMENT '任务描述@lang@',
  `task_nonopen` varchar(255) NOT NULL COMMENT '任务未开启描述@lang@',
  `task_lv` smallint(5) unsigned NOT NULL COMMENT '任务等级',
  `tagplace` smallint(5) unsigned NOT NULL COMMENT '标签位置',
  `sub_tag` smallint(5) unsigned NOT NULL COMMENT '跳转标记',
  `icon` varchar(255) NOT NULL COMMENT '图标资源',
  `condition` varchar(255) NOT NULL COMMENT '触发条件',
  `process_des` varchar(1024) NOT NULL COMMENT '进度描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强标签表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_improve_suit 结构
DROP TABLE IF EXISTS `base_improve_suit`;
CREATE TABLE IF NOT EXISTS `base_improve_suit` (
  `suit_type` int(10) unsigned NOT NULL COMMENT '套装类型',
  `suit_lv` int(10) unsigned NOT NULL COMMENT '套装等级',
  `suit_stage` int(10) unsigned NOT NULL COMMENT '套装阶数',
  `point` int(10) unsigned NOT NULL COMMENT '积分转换',
  PRIMARY KEY (`suit_type`,`suit_lv`,`suit_stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强-套装积分转换表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_intimacy 结构
DROP TABLE IF EXISTS `base_intimacy`;
CREATE TABLE IF NOT EXISTS `base_intimacy` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `id` int(11) unsigned NOT NULL DEFAULT '0',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '亲密度',
  UNIQUE KEY `type` (`type`,`id`),
  KEY `intimacy` (`intimacy`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品亲密度';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_intimacy_lv 结构
DROP TABLE IF EXISTS `base_intimacy_lv`;
CREATE TABLE IF NOT EXISTS `base_intimacy_lv` (
  `lv` int(11) unsigned NOT NULL COMMENT '亲密度等级',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `name` varchar(255) NOT NULL COMMENT '亲密度名字',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需亲密度',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  PRIMARY KEY (`lv`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='亲密度等级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_intimacy_obtain 结构
DROP TABLE IF EXISTS `base_intimacy_obtain`;
CREATE TABLE IF NOT EXISTS `base_intimacy_obtain` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `trigger_obj` varchar(255) NOT NULL DEFAULT '0' COMMENT '触发对象',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '亲密度',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数上限',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='亲密度获取途径配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_investment_rewards 结构
DROP TABLE IF EXISTS `base_investment_rewards`;
CREATE TABLE IF NOT EXISTS `base_investment_rewards` (
  `type` int(10) unsigned NOT NULL COMMENT '投资类型',
  `level` smallint(5) unsigned NOT NULL COMMENT '档次',
  `id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `rewards` varchar(1000) NOT NULL COMMENT '奖励内容',
  `condition` varchar(1000) NOT NULL COMMENT '领取条件',
  `desc` varchar(1000) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`type`,`level`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投资回报配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_investment_types 结构
DROP TABLE IF EXISTS `base_investment_types`;
CREATE TABLE IF NOT EXISTS `base_investment_types` (
  `type` int(10) unsigned NOT NULL COMMENT '投资类型',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `level` smallint(5) unsigned NOT NULL COMMENT '档次',
  `price` int(11) unsigned NOT NULL COMMENT '价格',
  `return_money` varchar(50) NOT NULL DEFAULT '0' COMMENT '回报',
  `price_type` int(10) unsigned NOT NULL COMMENT '价格类型',
  `clear_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理类型##0为不重置，1为领完奖重置',
  `condition` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '条件（预留）',
  PRIMARY KEY (`type`,`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投资类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_journey_award 结构
DROP TABLE IF EXISTS `base_journey_award`;
CREATE TABLE IF NOT EXISTS `base_journey_award` (
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动',
  `map` int(11) NOT NULL DEFAULT '0' COMMENT '地图',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '档次',
  `desc` varchar(200) NOT NULL DEFAULT '描述' COMMENT '描述',
  `award` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  `days` varchar(100) NOT NULL DEFAULT '[0,0]' COMMENT '天数限定',
  PRIMARY KEY (`act`,`map`,`grade`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='征途奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_journey_map 结构
DROP TABLE IF EXISTS `base_journey_map`;
CREATE TABLE IF NOT EXISTS `base_journey_map` (
  `map` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '地图',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '名字',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '级别',
  `totem` int(11) NOT NULL DEFAULT '0' COMMENT '图腾',
  `unlock_map` int(11) NOT NULL DEFAULT '0' COMMENT '解锁对应地图',
  `unlock_tasks` int(11) NOT NULL DEFAULT '0' COMMENT '解锁所需任务数',
  PRIMARY KEY (`map`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='远征地图';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_journey_task 结构
DROP TABLE IF EXISTS `base_journey_task`;
CREATE TABLE IF NOT EXISTS `base_journey_task` (
  `suit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '套件',
  `map` int(11) NOT NULL DEFAULT '0' COMMENT '地图',
  `task` int(11) NOT NULL DEFAULT '0' COMMENT '任务',
  `task_type` int(11) NOT NULL DEFAULT '0' COMMENT '任务类',
  `cons` int(11) NOT NULL DEFAULT '0' COMMENT '任务值',
  `unlock` int(11) NOT NULL DEFAULT '0' COMMENT '解锁条件',
  `link` varchar(50) NOT NULL DEFAULT '[]' COMMENT '跳转',
  `picture` varchar(50) NOT NULL DEFAULT '0' COMMENT '头像',
  `desc` varchar(100) NOT NULL DEFAULT '阿达' COMMENT '描述',
  PRIMARY KEY (`suit`,`map`,`task`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='远征任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_journey_task_type 结构
DROP TABLE IF EXISTS `base_journey_task_type`;
CREATE TABLE IF NOT EXISTS `base_journey_task_type` (
  `task_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务类',
  `key` varchar(50) NOT NULL DEFAULT 'key' COMMENT '名字',
  `desc` varchar(100) NOT NULL DEFAULT '描述' COMMENT '描述',
  PRIMARY KEY (`task_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='任务类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_jump_act_kv 结构
DROP TABLE IF EXISTS `base_jump_act_kv`;
CREATE TABLE IF NOT EXISTS `base_jump_act_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跳一跳-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_jump_act_scene 结构
DROP TABLE IF EXISTS `base_jump_act_scene`;
CREATE TABLE IF NOT EXISTS `base_jump_act_scene` (
  `map_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '地图编号',
  `born_xy` varchar(100) NOT NULL DEFAULT '[]' COMMENT '出生坐标',
  `border_xy` varchar(100) NOT NULL DEFAULT '[]' COMMENT '终点坐标',
  `next_map` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一个地图',
  PRIMARY KEY (`map_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跳一跳-场景配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_jump_act_step 结构
DROP TABLE IF EXISTS `base_jump_act_step`;
CREATE TABLE IF NOT EXISTS `base_jump_act_step` (
  `round_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次区间',
  `round_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次区间',
  `distance` varchar(100) NOT NULL DEFAULT '[]' COMMENT '距离区间',
  `radius` varchar(100) NOT NULL DEFAULT '[]' COMMENT '半径区间',
  PRIMARY KEY (`round_min`,`round_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跳一跳-台子配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_key_value 结构
DROP TABLE IF EXISTS `base_key_value`;
CREATE TABLE IF NOT EXISTS `base_key_value` (
  `key` varchar(100) NOT NULL COMMENT '字符键',
  `name` varchar(50) NOT NULL COMMENT '名称',
  `value` varchar(1000) NOT NULL COMMENT '数据',
  `desc` tinytext NOT NULL COMMENT '备注@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='杂项配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_key_value_config 结构
DROP TABLE IF EXISTS `base_key_value_config`;
CREATE TABLE IF NOT EXISTS `base_key_value_config` (
  `type` varchar(25) NOT NULL,
  `key` int(11) NOT NULL,
  `value` varchar(50) NOT NULL,
  `ext` text NOT NULL,
  `desc` varchar(50) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`type`,`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf3v3_act_list 结构
DROP TABLE IF EXISTS `base_kf3v3_act_list`;
CREATE TABLE IF NOT EXISTS `base_kf3v3_act_list` (
  `id` int(11) NOT NULL COMMENT '活动ID',
  `week` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '开启日期',
  `time` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '开启时间',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf3v3_act_rewards 结构
DROP TABLE IF EXISTS `base_kf3v3_act_rewards`;
CREATE TABLE IF NOT EXISTS `base_kf3v3_act_rewards` (
  `win_num` int(11) NOT NULL COMMENT '胜利场次',
  `rewards` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '奖励',
  PRIMARY KEY (`win_num`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf3v3_inherit_tier 结构
DROP TABLE IF EXISTS `base_kf3v3_inherit_tier`;
CREATE TABLE IF NOT EXISTS `base_kf3v3_inherit_tier` (
  `old_tier` int(11) NOT NULL COMMENT '原段位',
  `new_tier` int(11) NOT NULL COMMENT '继承段位',
  PRIMARY KEY (`old_tier`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf3v3_rank_rewards 结构
DROP TABLE IF EXISTS `base_kf3v3_rank_rewards`;
CREATE TABLE IF NOT EXISTS `base_kf3v3_rank_rewards` (
  `rank_max` int(11) NOT NULL COMMENT '排名上限',
  `rank_min` int(11) NOT NULL COMMENT '排名下限',
  `rewards` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '奖励',
  PRIMARY KEY (`rank_max`,`rank_min`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf3v3_tier_info 结构
DROP TABLE IF EXISTS `base_kf3v3_tier_info`;
CREATE TABLE IF NOT EXISTS `base_kf3v3_tier_info` (
  `tier` int(11) NOT NULL COMMENT '段位等级',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` int(11) NOT NULL COMMENT '升级星数',
  `daily_reward` int(11) NOT NULL COMMENT '每日段位奖励',
  `win_star` int(11) NOT NULL COMMENT '单场胜利星数',
  `lose_star` int(11) NOT NULL COMMENT '单场失败星数',
  `win_reward` int(11) NOT NULL COMMENT '单场胜利荣耀',
  `lose_reward` int(11) NOT NULL COMMENT '单场失败荣耀',
  `tier_name` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '段位名称',
  `big_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '大段位',
  PRIMARY KEY (`tier`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf3v3_win_row 结构
DROP TABLE IF EXISTS `base_kf3v3_win_row`;
CREATE TABLE IF NOT EXISTS `base_kf3v3_win_row` (
  `win_row` int(11) NOT NULL COMMENT '连胜次数',
  `extra_star` int(11) NOT NULL COMMENT '额外星数奖励',
  PRIMARY KEY (`win_row`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_area 结构
DROP TABLE IF EXISTS `base_kf_1vn_area`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_area` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区id',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最低等级（包含）',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高等级（包含）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='区域配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_auction 结构
DROP TABLE IF EXISTS `base_kf_1vn_auction`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_auction` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `area` tinyint(3) unsigned NOT NULL COMMENT '赛区',
  `goods` varchar(500) NOT NULL DEFAULT '[]' COMMENT '道具列表',
  `goods_model` text COMMENT '道具资源id列表',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `ser_award` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '全服奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn拍卖';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_bet 结构
DROP TABLE IF EXISTS `base_kf_1vn_bet`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_bet` (
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `ratio` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '赔率',
  PRIMARY KEY (`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂台赔率配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_def 结构
DROP TABLE IF EXISTS `base_kf_1vn_def`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_def` (
  `sign_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名人数下限（包含）',
  `sign_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名人数上限（包含）',
  `def_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '擂主数量',
  `seed_num` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '种子选手数量',
  PRIMARY KEY (`sign_min`,`sign_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂主数量';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_exp 结构
DROP TABLE IF EXISTS `base_kf_1vn_exp`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_exp` (
  `min_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础经验',
  PRIMARY KEY (`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn经验配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_extra_score 结构
DROP TABLE IF EXISTS `base_kf_1vn_extra_score`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_extra_score` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '自增id',
  `min_combat` int(11) unsigned NOT NULL COMMENT '最低战力',
  `max_combat` int(11) unsigned NOT NULL COMMENT '最高战力',
  `extra_score` smallint(5) unsigned NOT NULL COMMENT '额外积分',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn额外积分配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_fake_role 结构
DROP TABLE IF EXISTS `base_kf_1vn_fake_role`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_fake_role` (
  `id` smallint(5) unsigned NOT NULL COMMENT '自增id',
  `type` tinyint(2) unsigned NOT NULL COMMENT '比赛阶段1资格赛2挑战赛',
  `area` tinyint(2) unsigned NOT NULL COMMENT '战区',
  `hard` smallint(5) unsigned NOT NULL COMMENT '难度评级',
  `fake_role_lv` smallint(5) unsigned NOT NULL COMMENT '假人等级',
  `fake_role_combat` varchar(255) NOT NULL COMMENT '假人战力',
  `ratio` tinyint(3) unsigned NOT NULL COMMENT '假人悉数（百分比）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn假人配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_group 结构
DROP TABLE IF EXISTS `base_kf_1vn_group`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_group` (
  `hard` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '难度系数',
  `robot_args` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '机器人系数(百分比)',
  `height` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数权重',
  PRIMARY KEY (`hard`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分组配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_hard 结构
DROP TABLE IF EXISTS `base_kf_1vn_hard`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_hard` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '自增id',
  `min_combat` int(11) unsigned NOT NULL COMMENT '战力下限',
  `max_combat` int(11) unsigned NOT NULL COMMENT '战力上限',
  `hard` tinyint(3) unsigned NOT NULL COMMENT '难度评级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn难度评级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_kv 结构
DROP TABLE IF EXISTS `base_kf_1vn_kv`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_kv` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `value` text NOT NULL COMMENT '值',
  `desc` varchar(200) NOT NULL DEFAULT '[]' COMMENT '备注',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn键值配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_match 结构
DROP TABLE IF EXISTS `base_kf_1vn_match`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_match` (
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `area` tinyint(3) unsigned NOT NULL COMMENT '战区',
  `hard_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '难度评分列表',
  `c_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战者人数',
  `all_hard` varchar(255) NOT NULL DEFAULT '[]' COMMENT '难度上下限',
  PRIMARY KEY (`stage`,`area`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛匹配规则';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_race_2_award 结构
DROP TABLE IF EXISTS `base_kf_1vn_race_2_award`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_race_2_award` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型(1擂主|2挑战者)',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `win_award` varchar(500) NOT NULL DEFAULT '[]' COMMENT '胜利奖励',
  `lose_award` varchar(500) NOT NULL DEFAULT '[]' COMMENT '失败奖励',
  PRIMARY KEY (`type`,`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂台奖励表）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_score_reward 结构
DROP TABLE IF EXISTS `base_kf_1vn_score_reward`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_score_reward` (
  `race_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '排名类型',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限（包含）',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限（包含）',
  `rewards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`race_type`,`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_1vn_time 结构
DROP TABLE IF EXISTS `base_kf_1vn_time`;
CREATE TABLE IF NOT EXISTS `base_kf_1vn_time` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `open_week` varchar(50) NOT NULL DEFAULT '[]' COMMENT '星期几开启[1,2...7]',
  `signtime` varchar(50) NOT NULL DEFAULT '[]' COMMENT '报名开启{时，分}',
  `optime` varchar(200) NOT NULL DEFAULT '[]' COMMENT '开启时间{时，分}',
  `race_1_pre` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛准备时间(s)',
  `race_1` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛时间(s)',
  `race_1_m_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛匹配时间(s)',
  `race_1_b_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛战斗时间(s)',
  `race_2_pre` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛准备时间(s)',
  `race_2` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛时间(s)',
  `race_2_m_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛匹配时间(s)',
  `race_2_b_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛战斗时间(s)',
  `bet_time` smallint(5) unsigned DEFAULT '0' COMMENT '竞猜时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn时间配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_hegemony 结构
DROP TABLE IF EXISTS `base_kf_hegemony`;
CREATE TABLE IF NOT EXISTS `base_kf_hegemony` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服服战常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_hegemony_ranking_reward 结构
DROP TABLE IF EXISTS `base_kf_hegemony_ranking_reward`;
CREATE TABLE IF NOT EXISTS `base_kf_hegemony_ranking_reward` (
  `min_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `att_victory_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '攻方胜利奖励',
  `att_failure_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '攻方失败奖励',
  `def_victory_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '守方胜利奖励',
  `def_failure_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '守方失败奖励',
  `season_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '赛季奖励',
  PRIMARY KEY (`min_ranking`,`max_ranking`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服服战排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_kf_hegemony_round_reward 结构
DROP TABLE IF EXISTS `base_kf_hegemony_round_reward`;
CREATE TABLE IF NOT EXISTS `base_kf_hegemony_round_reward` (
  `min_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`min_ranking`,`max_ranking`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服服战轮次奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_language 结构
DROP TABLE IF EXISTS `base_language`;
CREATE TABLE IF NOT EXISTS `base_language` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `module_id` int(11) NOT NULL COMMENT '功能id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '语言类型',
  `changed` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否变更##内容如果更新，此值置为1。初始也为1',
  `content` text NOT NULL COMMENT '内容@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_language_extra 结构
DROP TABLE IF EXISTS `base_language_extra`;
CREATE TABLE IF NOT EXISTS `base_language_extra` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `tip` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '小喇叭 0-不提示 1-提示',
  `content` text NOT NULL COMMENT '内容@lang@',
  `example` varchar(1000) NOT NULL DEFAULT '' COMMENT '例子',
  `desc` varchar(1000) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`module_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='语言额外配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_language_format 结构
DROP TABLE IF EXISTS `base_language_format`;
CREATE TABLE IF NOT EXISTS `base_language_format` (
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT 'key',
  `format` varchar(255) NOT NULL DEFAULT '' COMMENT '格式',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='传闻格式';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_lattice_kv 结构
DROP TABLE IF EXISTS `base_lattice_kv`;
CREATE TABLE IF NOT EXISTS `base_lattice_kv` (
  `key` varchar(50) NOT NULL COMMENT '主键',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='器灵寻宝-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_lattice_reset_info 结构
DROP TABLE IF EXISTS `base_lattice_reset_info`;
CREATE TABLE IF NOT EXISTS `base_lattice_reset_info` (
  `count` tinyint(5) unsigned NOT NULL COMMENT '重置次数',
  `reward` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '重置奖励',
  PRIMARY KEY (`count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='器灵寻宝-走格子重置奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_lattice_reward 结构
DROP TABLE IF EXISTS `base_lattice_reward`;
CREATE TABLE IF NOT EXISTS `base_lattice_reward` (
  `pos` int(11) NOT NULL COMMENT '位置',
  `circle` int(11) NOT NULL COMMENT '轮数',
  `type` int(11) NOT NULL COMMENT '类型',
  `rand_reward` varchar(500) NOT NULL COMMENT '随机奖励',
  `reward` varchar(500) NOT NULL COMMENT '奖励',
  `double_chance` varchar(500) NOT NULL COMMENT '双倍概率',
  `reward_show` varchar(500) NOT NULL COMMENT '奖励展示',
  PRIMARY KEY (`pos`,`circle`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='格子奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_limit_goal_main 结构
DROP TABLE IF EXISTS `base_limit_goal_main`;
CREATE TABLE IF NOT EXISTS `base_limit_goal_main` (
  `goal_id` int(10) unsigned NOT NULL COMMENT '目标id',
  `model_name` varchar(255) NOT NULL COMMENT '目标模型名称@lang@',
  `model_id` int(10) unsigned NOT NULL COMMENT '目标模型展示ID',
  `jump_cfg` varchar(255) NOT NULL COMMENT '激活跳转配置',
  `skill_id` bigint(10) unsigned NOT NULL COMMENT '技能ID',
  `skill_desc` varchar(512) NOT NULL COMMENT '技能描述@lang@',
  `precondition` varchar(512) NOT NULL COMMENT '目标解锁条件',
  `activate` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活功能',
  `countdown` int(10) unsigned NOT NULL COMMENT '目标倒计时（秒）',
  PRIMARY KEY (`goal_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-目标配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_limit_goal_soul 结构
DROP TABLE IF EXISTS `base_limit_goal_soul`;
CREATE TABLE IF NOT EXISTS `base_limit_goal_soul` (
  `goal_id` int(10) unsigned NOT NULL COMMENT '目标id',
  `soul_id` int(10) unsigned NOT NULL COMMENT '星魂id',
  `soul_name` varchar(255) NOT NULL COMMENT '星魂名字@lang@',
  `need_finish` int(10) unsigned NOT NULL COMMENT '所需完成任务数量',
  `attr` varchar(512) NOT NULL COMMENT '星魂属性',
  PRIMARY KEY (`goal_id`,`soul_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-星魂属性表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_limit_goal_task 结构
DROP TABLE IF EXISTS `base_limit_goal_task`;
CREATE TABLE IF NOT EXISTS `base_limit_goal_task` (
  `goal_id` int(10) unsigned NOT NULL COMMENT '目标id',
  `task_id` int(10) unsigned NOT NULL COMMENT '目标任务id',
  `task_desc` varchar(512) NOT NULL COMMENT '目标任务描述@lang@',
  `finish_condition` varchar(512) NOT NULL COMMENT '任务完成条件',
  `reward` varchar(512) NOT NULL COMMENT '任务奖励',
  `click_jump` varchar(255) NOT NULL COMMENT '任务前往跳转',
  PRIMARY KEY (`goal_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-任务配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_liveness_lv 结构
DROP TABLE IF EXISTS `base_liveness_lv`;
CREATE TABLE IF NOT EXISTS `base_liveness_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `awards` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `ishow` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否展示',
  `figure` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '外观ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度升级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_live_skill_food 结构
DROP TABLE IF EXISTS `base_live_skill_food`;
CREATE TABLE IF NOT EXISTS `base_live_skill_food` (
  `food_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '食物id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需技能等级',
  `weight` varchar(255) NOT NULL DEFAULT '[]' COMMENT '权重',
  PRIMARY KEY (`food_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_live_skill_food_type 结构
DROP TABLE IF EXISTS `base_live_skill_food_type`;
CREATE TABLE IF NOT EXISTS `base_live_skill_food_type` (
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `kind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '种类id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑所需等级',
  `good_id` int(11) NOT NULL DEFAULT '0' COMMENT '食谱id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '制作时间',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加熟练度',
  `cost_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需活力',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '图标',
  `eat_effect` varchar(50) NOT NULL COMMENT '食用效果@lang@',
  PRIMARY KEY (`type_id`,`kind`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_live_skill_furniture 结构
DROP TABLE IF EXISTS `base_live_skill_furniture`;
CREATE TABLE IF NOT EXISTS `base_live_skill_furniture` (
  `furniture_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家具id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需技能等级',
  `prosperity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '繁荣度',
  `area` varchar(50) NOT NULL DEFAULT '[]' COMMENT '规格',
  `weight` varchar(255) NOT NULL DEFAULT '[]' COMMENT '权重',
  `map_id` int(11) NOT NULL DEFAULT '0' COMMENT '放置面',
  `offset_x` varchar(50) NOT NULL DEFAULT '[]' COMMENT 'x偏移量',
  `offset_y` varchar(50) NOT NULL DEFAULT '[]' COMMENT 'y偏移量',
  `offset_h` varchar(50) NOT NULL DEFAULT '0' COMMENT '高度偏移',
  `res_icon` varchar(50) NOT NULL COMMENT '资源',
  `rotate` varchar(255) NOT NULL DEFAULT '[]' COMMENT '旋转角度',
  `location` varchar(255) NOT NULL DEFAULT '[]' COMMENT '位置',
  PRIMARY KEY (`furniture_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_live_skill_furniture_type 结构
DROP TABLE IF EXISTS `base_live_skill_furniture_type`;
CREATE TABLE IF NOT EXISTS `base_live_skill_furniture_type` (
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `kind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '种类id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑所需等级',
  `good_id` int(11) NOT NULL DEFAULT '0' COMMENT '打造纸id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '制作时间',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加熟练度',
  `cost_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需活力',
  `cost_res` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗资源',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '图标',
  `eat_effect` varchar(50) NOT NULL COMMENT '使用效果',
  PRIMARY KEY (`type_id`,`kind`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_live_skill_kind 结构
DROP TABLE IF EXISTS `base_live_skill_kind`;
CREATE TABLE IF NOT EXISTS `base_live_skill_kind` (
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `kind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '种类id',
  `kind_name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  PRIMARY KEY (`skill_type`,`kind`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_live_skill_lv 结构
DROP TABLE IF EXISTS `base_live_skill_lv`;
CREATE TABLE IF NOT EXISTS `base_live_skill_lv` (
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级经验',
  `lv_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级称号类型',
  `lv_type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '等级称号',
  PRIMARY KEY (`skill_type`,`lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_live_skill_name 结构
DROP TABLE IF EXISTS `base_live_skill_name`;
CREATE TABLE IF NOT EXISTS `base_live_skill_name` (
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '技能名称',
  PRIMARY KEY (`skill_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_loading_pic 结构
DROP TABLE IF EXISTS `base_loading_pic`;
CREATE TABLE IF NOT EXISTS `base_loading_pic` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '加载图id',
  `level_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '等级区间',
  `open_day` varchar(50) NOT NULL DEFAULT '[]' COMMENT '开服时间',
  `career` tinyint(1) NOT NULL DEFAULT '0' COMMENT '职业',
  `reg_day` varchar(50) NOT NULL DEFAULT '[]' COMMENT '创角天数',
  `st_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `ed_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `week_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '星期',
  `remark` varchar(512) NOT NULL DEFAULT '[]' COMMENT '备注信息@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_local_boss_kv 结构
DROP TABLE IF EXISTS `base_local_boss_kv`;
CREATE TABLE IF NOT EXISTS `base_local_boss_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服BOSS-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_login_reward_day 结构
DROP TABLE IF EXISTS `base_login_reward_day`;
CREATE TABLE IF NOT EXISTS `base_login_reward_day` (
  `day_id` int(10) unsigned NOT NULL COMMENT '天数id',
  `name` varchar(255) NOT NULL COMMENT '名字@lang@',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  `extra_reward_type` tinyint(2) unsigned NOT NULL COMMENT '额外奖励格式',
  `extra_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '额外奖励',
  `resource_id` varchar(512) NOT NULL COMMENT '资源id',
  `show_type` int(10) unsigned NOT NULL COMMENT '展示类型(1图片 2模型)',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`day_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='七天登录天数配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_login_tips 结构
DROP TABLE IF EXISTS `base_login_tips`;
CREATE TABLE IF NOT EXISTS `base_login_tips` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:显示 0:隐藏',
  `keyword` varchar(100) NOT NULL DEFAULT '' COMMENT '关键字',
  `platform` varchar(255) NOT NULL DEFAULT '' COMMENT '平台',
  `link_info` varchar(255) NOT NULL DEFAULT '' COMMENT '联系方式',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='登录报错信息配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_lucky_turntable 结构
DROP TABLE IF EXISTS `base_lucky_turntable`;
CREATE TABLE IF NOT EXISTS `base_lucky_turntable` (
  `suit` int(11) NOT NULL COMMENT '套件id',
  `times` int(11) NOT NULL COMMENT '抽奖次数',
  `type` varchar(255) NOT NULL DEFAULT '[]' COMMENT '轮盘类型',
  `golds` varchar(255) NOT NULL DEFAULT '[]' COMMENT '轮盘彩钻数',
  `weight_lucky` varchar(500) NOT NULL DEFAULT '[]' COMMENT '第一档轮盘权重',
  `weight_suprise` varchar(500) NOT NULL DEFAULT '[]' COMMENT '第二档轮盘权重',
  PRIMARY KEY (`suit`,`times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运转盘配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_lv_power 结构
DROP TABLE IF EXISTS `base_lv_power`;
CREATE TABLE IF NOT EXISTS `base_lv_power` (
  `lv` int(11) NOT NULL COMMENT '等级',
  `lv_attr` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '等级属性',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='等级战斗力表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_madness_land_continue_kill_score 结构
DROP TABLE IF EXISTS `base_madness_land_continue_kill_score`;
CREATE TABLE IF NOT EXISTS `base_madness_land_continue_kill_score` (
  `num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '连杀次数',
  `score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-连杀额外积分(自己当前连杀)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_madness_land_end_score 结构
DROP TABLE IF EXISTS `base_madness_land_end_score`;
CREATE TABLE IF NOT EXISTS `base_madness_land_end_score` (
  `num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '连杀次数',
  `score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-终结连杀额外积分(对方当前连杀)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_madness_land_kv 结构
DROP TABLE IF EXISTS `base_madness_land_kv`;
CREATE TABLE IF NOT EXISTS `base_madness_land_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_madness_land_role_reward 结构
DROP TABLE IF EXISTS `base_madness_land_role_reward`;
CREATE TABLE IF NOT EXISTS `base_madness_land_role_reward` (
  `rank_high` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `rank_low` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-个人排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_madness_land_score_reward 结构
DROP TABLE IF EXISTS `base_madness_land_score_reward`;
CREATE TABLE IF NOT EXISTS `base_madness_land_score_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-积分奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_madness_land_server_reward 结构
DROP TABLE IF EXISTS `base_madness_land_server_reward`;
CREATE TABLE IF NOT EXISTS `base_madness_land_server_reward` (
  `rank_high` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `rank_low` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名区间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-服务器排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_marble_count_reward 结构
DROP TABLE IF EXISTS `base_marble_count_reward`;
CREATE TABLE IF NOT EXISTS `base_marble_count_reward` (
  `index` int(11) NOT NULL COMMENT '主键',
  `count` int(11) NOT NULL COMMENT '次数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机奖励',
  `fixed_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '保底奖励',
  `rand_count` int(11) NOT NULL DEFAULT '0' COMMENT '随机抽取次数',
  PRIMARY KEY (`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠充能次数奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_marble_kv 结构
DROP TABLE IF EXISTS `base_marble_kv`;
CREATE TABLE IF NOT EXISTS `base_marble_kv` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `key` varchar(255) NOT NULL COMMENT '主键',
  `val` varchar(511) NOT NULL COMMENT '值',
  `desc` varchar(511) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠&商店常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_marble_qual_reward 结构
DROP TABLE IF EXISTS `base_marble_qual_reward`;
CREATE TABLE IF NOT EXISTS `base_marble_qual_reward` (
  `qual_id` int(11) NOT NULL COMMENT '品质id',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `energy_point` int(11) NOT NULL DEFAULT '0' COMMENT '充能点数',
  PRIMARY KEY (`qual_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠品质收益配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_marble_reward 结构
DROP TABLE IF EXISTS `base_marble_reward`;
CREATE TABLE IF NOT EXISTS `base_marble_reward` (
  `id` int(11) NOT NULL COMMENT 'id',
  `qualitys` varchar(255) NOT NULL DEFAULT '[]' COMMENT '品质分布',
  `val` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠品质分布权重配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_constant 结构
DROP TABLE IF EXISTS `base_market_constant`;
CREATE TABLE IF NOT EXISTS `base_market_constant` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `key` varchar(100) NOT NULL DEFAULT '' COMMENT '主键',
  `value` varchar(150) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '描述说明',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_goods_log_type 结构
DROP TABLE IF EXISTS `base_market_goods_log_type`;
CREATE TABLE IF NOT EXISTS `base_market_goods_log_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分类',
  `sell_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类Id',
  `sell_sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品子类Id',
  `quality_min` int(11) NOT NULL DEFAULT '0' COMMENT '物品品质下限',
  `quality_max` int(11) NOT NULL DEFAULT '0' COMMENT '物品品质上限',
  PRIMARY KEY (`type`,`sell_type`,`sell_sub_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-物品成交日志归属分类';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_goods_select_by_career 结构
DROP TABLE IF EXISTS `base_market_goods_select_by_career`;
CREATE TABLE IF NOT EXISTS `base_market_goods_select_by_career` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `describe` varchar(100) NOT NULL DEFAULT '' COMMENT '名称',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-职业筛选(前端使用)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_goods_select_by_color 结构
DROP TABLE IF EXISTS `base_market_goods_select_by_color`;
CREATE TABLE IF NOT EXISTS `base_market_goods_select_by_color` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `describe` varchar(100) NOT NULL DEFAULT '' COMMENT '名称',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-物品类型筛选(前段使用)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_goods_select_by_lev 结构
DROP TABLE IF EXISTS `base_market_goods_select_by_lev`;
CREATE TABLE IF NOT EXISTS `base_market_goods_select_by_lev` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-阶数或等级筛选(前段使用)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_log_type 结构
DROP TABLE IF EXISTS `base_market_log_type`;
CREATE TABLE IF NOT EXISTS `base_market_log_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分类',
  `log_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录大类Id-0表示不区分分类',
  `max_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '展示上限',
  PRIMARY KEY (`type`,`log_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-物品成交日志分类';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_recommend_type 结构
DROP TABLE IF EXISTS `base_market_recommend_type`;
CREATE TABLE IF NOT EXISTS `base_market_recommend_type` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '推荐Id',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '名称',
  `sell_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类Id',
  `sell_sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品子类Id',
  `quality_range` varchar(100) NOT NULL DEFAULT '{0,0}' COMMENT '物品品质区间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-推荐子类';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_sell_sub_type 结构
DROP TABLE IF EXISTS `base_market_sell_sub_type`;
CREATE TABLE IF NOT EXISTS `base_market_sell_sub_type` (
  `sell_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类Id',
  `sell_sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品子类Id',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '名称',
  PRIMARY KEY (`sell_type`,`sell_sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-商品子类';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_sell_type 结构
DROP TABLE IF EXISTS `base_market_sell_type`;
CREATE TABLE IF NOT EXISTS `base_market_sell_type` (
  `sell_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类Id',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '商品大类名称',
  PRIMARY KEY (`sell_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-商品大类配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_sys_buyback 结构
DROP TABLE IF EXISTS `base_market_sys_buyback`;
CREATE TABLE IF NOT EXISTS `base_market_sys_buyback` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可回购物品Id',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `sell_again` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否系统上架（1是，0否）',
  `buyback_time` varchar(100) NOT NULL DEFAULT '{0,0}' COMMENT '开售多少秒后，系统可以在此时间范围内随机回购',
  PRIMARY KEY (`goods_id`,`open_day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-系统回购';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_market_sys_sell 结构
DROP TABLE IF EXISTS `base_market_sys_sell`;
CREATE TABLE IF NOT EXISTS `base_market_sys_sell` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品Id',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `trigger_sys_sell_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累积上架多少数量后会触发系统补充机制',
  `trigger_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '市场上在售少于多少后触发系统进行补货',
  `sell_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每次补货数量',
  `sell_max_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日补货数量上限',
  PRIMARY KEY (`goods_id`,`open_day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-系统补充商品';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_anniversary 结构
DROP TABLE IF EXISTS `base_mate_anniversary`;
CREATE TABLE IF NOT EXISTS `base_mate_anniversary` (
  `day` int(11) NOT NULL DEFAULT '0' COMMENT '天数',
  `award` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `picture` int(11) NOT NULL DEFAULT '0' COMMENT '资源id',
  PRIMARY KEY (`day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-纪念日';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_boat 结构
DROP TABLE IF EXISTS `base_mate_boat`;
CREATE TABLE IF NOT EXISTS `base_mate_boat` (
  `stage` int(11) NOT NULL DEFAULT '0' COMMENT '阶数',
  `star` int(11) NOT NULL DEFAULT '0' COMMENT '星数',
  `name` varchar(50) NOT NULL DEFAULT '<<>>' COMMENT '名称',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '下一级经验值##0表示满级',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '属性##当前等级的属性',
  `picture` int(11) NOT NULL DEFAULT '0' COMMENT '形象',
  PRIMARY KEY (`stage`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-友谊的小船';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_boat_skill 结构
DROP TABLE IF EXISTS `base_mate_boat_skill`;
CREATE TABLE IF NOT EXISTS `base_mate_boat_skill` (
  `skill_id` int(11) NOT NULL DEFAULT '0' COMMENT '技能id',
  `stage` int(11) NOT NULL DEFAULT '0' COMMENT '解锁阶数',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-小船技能';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_catch_ball_award 结构
DROP TABLE IF EXISTS `base_mate_catch_ball_award`;
CREATE TABLE IF NOT EXISTS `base_mate_catch_ball_award` (
  `hit_low` int(11) NOT NULL DEFAULT '0' COMMENT '接球区间',
  `hit_high` int(11) NOT NULL DEFAULT '0' COMMENT '接球区间',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '评价等级',
  `award` varchar(500) NOT NULL DEFAULT '[]' COMMENT '等级奖励',
  PRIMARY KEY (`hit_low`,`hit_high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-抛接球结算';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_key_value 结构
DROP TABLE IF EXISTS `base_mate_key_value`;
CREATE TABLE IF NOT EXISTS `base_mate_key_value` (
  `key_content` varchar(100) NOT NULL DEFAULT '[]' COMMENT 'KEY',
  `value_content` varchar(5000) NOT NULL DEFAULT '[]' COMMENT 'VALUE',
  `desc` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '描述',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_lv 结构
DROP TABLE IF EXISTS `base_mate_lv`;
CREATE TABLE IF NOT EXISTS `base_mate_lv` (
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '羁绊等级',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '属性',
  `color` int(11) NOT NULL DEFAULT '0' COMMENT '称号品质',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-羁绊称号等级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_rhythm_master_award 结构
DROP TABLE IF EXISTS `base_mate_rhythm_master_award`;
CREATE TABLE IF NOT EXISTS `base_mate_rhythm_master_award` (
  `score_low` int(11) NOT NULL DEFAULT '0' COMMENT '积分区间',
  `score_high` int(11) NOT NULL DEFAULT '0' COMMENT '积分区间',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '评价等级',
  `award` varchar(500) NOT NULL DEFAULT '[]' COMMENT '等级奖励',
  PRIMARY KEY (`score_low`,`score_high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-舞力全开结算';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_rhythm_master_bit 结构
DROP TABLE IF EXISTS `base_mate_rhythm_master_bit`;
CREATE TABLE IF NOT EXISTS `base_mate_rhythm_master_bit` (
  `bit_group` int(11) NOT NULL DEFAULT '0' COMMENT '拍点组id',
  `bit_id` int(11) NOT NULL DEFAULT '0' COMMENT '拍点id',
  `bit_position` varchar(50) NOT NULL DEFAULT '[]' COMMENT '拍点坐标',
  `pre_time` int(11) NOT NULL DEFAULT '0' COMMENT '前置时间',
  PRIMARY KEY (`bit_group`,`bit_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-拍点配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mate_rhythm_master_music 结构
DROP TABLE IF EXISTS `base_mate_rhythm_master_music`;
CREATE TABLE IF NOT EXISTS `base_mate_rhythm_master_music` (
  `music_id` int(11) NOT NULL DEFAULT '0' COMMENT '曲谱id',
  `name` varchar(50) NOT NULL DEFAULT '<<>>' COMMENT '名称',
  `bgm` varchar(50) NOT NULL DEFAULT '<<>>' COMMENT 'BGM',
  `move` varchar(50) NOT NULL DEFAULT '<<>>' COMMENT '动作',
  `bit_group` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '拍点组',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时长',
  PRIMARY KEY (`music_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-谱面配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mobilize_task 结构
DROP TABLE IF EXISTS `base_mobilize_task`;
CREATE TABLE IF NOT EXISTS `base_mobilize_task` (
  `subtype` int(11) NOT NULL DEFAULT '0' COMMENT '活动子类',
  `day` int(11) NOT NULL DEFAULT '0' COMMENT '活动天',
  `task_type` int(11) NOT NULL DEFAULT '0' COMMENT '任务类型ID',
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT '任务排序',
  `fake_id` int(11) NOT NULL DEFAULT '0' COMMENT '全服进度ID',
  PRIMARY KEY (`subtype`,`day`,`task_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全民动员-每日任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mobilize_task_award 结构
DROP TABLE IF EXISTS `base_mobilize_task_award`;
CREATE TABLE IF NOT EXISTS `base_mobilize_task_award` (
  `task_type` int(11) NOT NULL DEFAULT '0' COMMENT '任务类型',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务ID',
  `server_pro` int(11) NOT NULL DEFAULT '0' COMMENT '全服条件',
  `person_pro` int(11) NOT NULL DEFAULT '0' COMMENT '个人条件',
  `gain_con` varchar(500) NOT NULL DEFAULT 'none' COMMENT '领取条件',
  `gain_desc` varchar(500) NOT NULL DEFAULT '' COMMENT '领取描述',
  `gain_link` varchar(500) NOT NULL DEFAULT '' COMMENT '领取跳转',
  `desc` varchar(500) NOT NULL DEFAULT '' COMMENT '任务描述',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖品',
  PRIMARY KEY (`task_type`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全民动员-任务奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mobilize_task_day 结构
DROP TABLE IF EXISTS `base_mobilize_task_day`;
CREATE TABLE IF NOT EXISTS `base_mobilize_task_day` (
  `subtype` int(11) NOT NULL DEFAULT '0' COMMENT '活动子类',
  `day` int(11) NOT NULL DEFAULT '0' COMMENT '活动天',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `show_model` varchar(500) NOT NULL DEFAULT '' COMMENT '展示模型',
  PRIMARY KEY (`subtype`,`day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全民动员-天节点奖';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mobilize_task_fake 结构
DROP TABLE IF EXISTS `base_mobilize_task_fake`;
CREATE TABLE IF NOT EXISTS `base_mobilize_task_fake` (
  `fake_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务ID',
  `check_time` varchar(500) NOT NULL DEFAULT '[]' COMMENT '检测节点',
  `check_point` varchar(500) NOT NULL DEFAULT '[]' COMMENT '节点数据',
  PRIMARY KEY (`fake_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全服数据-全员';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mobilize_task_type 结构
DROP TABLE IF EXISTS `base_mobilize_task_type`;
CREATE TABLE IF NOT EXISTS `base_mobilize_task_type` (
  `task_type` int(11) NOT NULL DEFAULT '0' COMMENT '任务类型',
  `task_string` varchar(200) NOT NULL DEFAULT 'task' COMMENT '任务原子类型',
  `desc` varchar(200) DEFAULT '' COMMENT '任务描述',
  `link` varchar(200) DEFAULT '' COMMENT '任务跳转',
  PRIMARY KEY (`task_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_module_advance 结构
DROP TABLE IF EXISTS `base_module_advance`;
CREATE TABLE IF NOT EXISTS `base_module_advance` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `index` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT '功能名称',
  `dynamic_resource` varchar(255) NOT NULL DEFAULT '' COMMENT '动态资源',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT 'icon',
  `condition` varchar(255) NOT NULL DEFAULT '' COMMENT '开放条件',
  `con_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '开放条件描述',
  `func_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '功能描述',
  `jump` varchar(255) NOT NULL DEFAULT '' COMMENT '跳转',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '功能开放奖励',
  `model_res` varchar(255) NOT NULL DEFAULT '0' COMMENT '模型资源',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数要求',
  `title_pic` varchar(255) NOT NULL DEFAULT '' COMMENT '标题图片',
  `mod_desc1` varchar(255) NOT NULL DEFAULT '' COMMENT '功能描述1',
  `mod_desc2` varchar(255) NOT NULL DEFAULT '' COMMENT '功能描述2',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能预告奖励表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_module_id 结构
DROP TABLE IF EXISTS `base_module_id`;
CREATE TABLE IF NOT EXISTS `base_module_id` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `module_name` varchar(255) NOT NULL COMMENT '功能名称@lang@',
  `open_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开放等级',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '前置任务',
  `open_day` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数',
  `icon_lv` int(11) NOT NULL DEFAULT '0' COMMENT '图标开放等级',
  `icon_task` int(11) NOT NULL DEFAULT '0' COMMENT '图标开放任务',
  `icon_day` int(11) NOT NULL DEFAULT '0' COMMENT '图标开放天数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能id配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_module_protocol 结构
DROP TABLE IF EXISTS `base_module_protocol`;
CREATE TABLE IF NOT EXISTS `base_module_protocol` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `protocol_id` int(11) unsigned NOT NULL COMMENT '协议id',
  `protocol_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '协议名称',
  `desc` varchar(255) NOT NULL DEFAULT '[]' COMMENT '描述',
  PRIMARY KEY (`protocol_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能协议';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_module_sub 结构
DROP TABLE IF EXISTS `base_module_sub`;
CREATE TABLE IF NOT EXISTS `base_module_sub` (
  `id` int(11) NOT NULL COMMENT '功能大类id(对应base_module_id里的id)',
  `sub_id` int(11) NOT NULL COMMENT '功能子类id',
  `sub_name` varchar(50) NOT NULL COMMENT '功能名@lang@',
  `desc` text NOT NULL COMMENT '描述@lang@',
  `open_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开放等级',
  `open_day` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '前置任务',
  `icon_lv` int(11) NOT NULL DEFAULT '0' COMMENT '图标开放等级',
  `icon_task` int(11) NOT NULL DEFAULT '0' COMMENT '图标开放任务',
  `icon_day` int(11) NOT NULL DEFAULT '0' COMMENT '图标开放天数',
  PRIMARY KEY (`id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mon 结构
DROP TABLE IF EXISTS `base_mon`;
CREATE TABLE IF NOT EXISTS `base_mon` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物配置id',
  `name` varchar(50) NOT NULL COMMENT '怪物名字@lang@',
  `kind` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '怪物类型 0普通怪,1采集怪,2任务采集怪,3护送怪,4拾取怪,6进击怪,7塔防怪,9自动进击怪,10非进攻巡逻怪',
  `boss` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS类型，0普通怪(普通怪),1普通野外怪(普通怪),2精英怪物(普通怪),3赏金BOSS(赏金专用),4世界BOSS(世界BOSS专用),5不死BOSS,6副本BOSS,7任务BOSS,8战场BOSS(不可被击退),9废都BOSS,10废都BOSS精英,11活动BOSS',
  `type` tinyint(3) unsigned DEFAULT '1' COMMENT '战斗类型(0被动，1主动)',
  `about` varchar(256) DEFAULT '' COMMENT '怪物描述@lang@',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业,0没职业',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '颜色(1白,2绿,3蓝,4紫,5粉,6橙,7金)',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所属模块id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所属模块子id',
  `auto` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0-读怪物表属性，1-服务器等级，2-队伍平均等级，3-队长等级（无组队时默认是队长），需要读怪物动态属性表',
  `icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源id',
  `icon_scale` varchar(10) DEFAULT '1.0' COMMENT '资源缩放[1.0-]',
  `icon_effect` varchar(100) NOT NULL DEFAULT '[]' COMMENT '怪物资源特效',
  `icon_texture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '贴图id',
  `headwear_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头饰id',
  `headwear_texture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头饰贴图id',
  `weapon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '武器模型id',
  `foot_icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '脚下资源id',
  `desc` varchar(5000) DEFAULT NULL COMMENT '默认对话##时间,怪物说话:概率,怪物说话:概率,怪物说话:概率 ',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `hp_num` int(11) unsigned DEFAULT '0' COMMENT '血条数量',
  `att` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击',
  `hp_lim` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '血上限',
  `wreck` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '破甲',
  `def` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '防御',
  `hit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '命中',
  `dodge` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '躲闪',
  `crit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '暴击',
  `ten` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '坚韧',
  `resist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抗性',
  `special_attr` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '特定属性[{AttrType, AttrValue}] = [{属性类型,属性值}]',
  `resum` varchar(200) NOT NULL DEFAULT '[]' COMMENT '回血配置,[回血模式,回复量,时间]回血模式:0不回血;1脱离战斗状态立刻回满血;2战斗中持续回复;3脱离战斗后持续回复',
  `striking_distance` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击距离(像素)',
  `tracing_distance` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跟踪距离(像素)',
  `warning_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '警戒范围(像素)',
  `hate_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '仇恨范围(像素)：表示玩家离开某区域后，怪物不追踪，清空伤害列表，不填表示没有仇恨范围',
  `speed` int(3) unsigned NOT NULL DEFAULT '0' COMMENT '速度(每秒移动的像素)',
  `skill` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '技能列表[{技能id,技能等级},...]',
  `retime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '重生时间(毫秒)',
  `att_time` int(11) unsigned NOT NULL DEFAULT '400' COMMENT '攻击间隔(毫秒)',
  `att_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0近攻，1远程攻击',
  `drop` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '掉落方式',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `out` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '挂机设置 0|1,是否玩家自动挂机可以攻击的目标',
  `collect_kind` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '采集分享类型',
  `collect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '采集时间(秒)',
  `collect_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可采集次数（每次都会有掉落）',
  `is_fight_back` tinyint(1) unsigned DEFAULT '1' COMMENT '是否会反击 ，默认为1',
  `is_be_atted` tinyint(1) unsigned DEFAULT '1' COMMENT '是否可攻击 ，默认为1',
  `is_be_clicked` tinyint(1) unsigned DEFAULT '1' COMMENT '是否可被点击，默认为1',
  `is_armor` tinyint(1) unsigned DEFAULT '0' COMMENT '是否霸体，默认为0',
  `is_patrol` tinyint(1) unsigned DEFAULT '0' COMMENT '是否可巡逻',
  `del_hp_each_time` varchar(300) NOT NULL DEFAULT '[]' COMMENT '[Min,Max]:怪物受到的每次伤害值区间,整数,小数为百分比：1:默认:[];2:hurt大于等于Min小于等于Max;3怪物Hp的百分比:Hurt大于等于Hp*Min小于等于Hp*Max',
  `figure_visible` tinyint(4) unsigned DEFAULT '1' COMMENT '是否显示形象（默认1，1：显示；0：不显示）',
  `mon_state` varchar(255) NOT NULL COMMENT '怪物出生特殊状态(特效展示),0：代表无特效，客户端使用',
  `is_hide_hp` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否隐藏血条(0|1)',
  `is_hit_ac` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '是否播放受击动作',
  `exp_share_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '经验分享类型##0所有伤害者都获得全部经验 1按伤害比例分配 2场景内共享 ',
  `anger` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '杀怪玩家增加的怒气值',
  `load_immediately` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否立即加载 0:不立即加载 1:立即加载',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='怪物信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_money_passoff_type 结构
DROP TABLE IF EXISTS `base_money_passoff_type`;
CREATE TABLE IF NOT EXISTS `base_money_passoff_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='金钱消耗类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_money_produce_type 结构
DROP TABLE IF EXISTS `base_money_produce_type`;
CREATE TABLE IF NOT EXISTS `base_money_produce_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='金钱产出类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mono_dice 结构
DROP TABLE IF EXISTS `base_mono_dice`;
CREATE TABLE IF NOT EXISTS `base_mono_dice` (
  `type` int(11) NOT NULL COMMENT '骰子类型',
  `dice_count` int(11) NOT NULL COMMENT '投掷次数',
  `weight` varchar(255) NOT NULL DEFAULT '[]' COMMENT '权重',
  PRIMARY KEY (`type`,`dice_count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级富豪-骰子点数权重配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mono_kv 结构
DROP TABLE IF EXISTS `base_mono_kv`;
CREATE TABLE IF NOT EXISTS `base_mono_kv` (
  `key` varchar(255) NOT NULL COMMENT '主键',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT '键值',
  `desc` varchar(500) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级富豪-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mono_lattice 结构
DROP TABLE IF EXISTS `base_mono_lattice`;
CREATE TABLE IF NOT EXISTS `base_mono_lattice` (
  `round` int(11) NOT NULL COMMENT '圈数',
  `lattice_index` int(11) NOT NULL COMMENT '格子编号',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '格子类型',
  PRIMARY KEY (`round`,`lattice_index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级富豪-骰子格子类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mono_luckycard 结构
DROP TABLE IF EXISTS `base_mono_luckycard`;
CREATE TABLE IF NOT EXISTS `base_mono_luckycard` (
  `index` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `type` tinyint(2) NOT NULL DEFAULT '2' COMMENT '珍稀类型',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级富豪-幸运卡奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mono_price 结构
DROP TABLE IF EXISTS `base_mono_price`;
CREATE TABLE IF NOT EXISTS `base_mono_price` (
  `count` int(11) NOT NULL COMMENT '补签次数',
  `price` int(11) NOT NULL DEFAULT '0' COMMENT '价格',
  PRIMARY KEY (`count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级富豪-补签消耗';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mono_round_rewards 结构
DROP TABLE IF EXISTS `base_mono_round_rewards`;
CREATE TABLE IF NOT EXISTS `base_mono_round_rewards` (
  `act_type` int(11) NOT NULL COMMENT '活动类型',
  `sub_type` int(11) NOT NULL COMMENT '活动子类',
  `round` int(11) NOT NULL COMMENT '圈数',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '展示资源配置',
  PRIMARY KEY (`act_type`,`sub_type`,`round`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级富豪-圈数奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mono_smallbox 结构
DROP TABLE IF EXISTS `base_mono_smallbox`;
CREATE TABLE IF NOT EXISTS `base_mono_smallbox` (
  `index` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级富豪-小宝箱奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mon_checkin_mutiple 结构
DROP TABLE IF EXISTS `base_mon_checkin_mutiple`;
CREATE TABLE IF NOT EXISTS `base_mon_checkin_mutiple` (
  `lv_node` int(20) NOT NULL COMMENT '等级节点',
  `month_id` int(11) NOT NULL COMMENT '月份',
  `multiple` decimal(20,2) NOT NULL COMMENT '普通用户倍数',
  `vip_lv` int(11) NOT NULL COMMENT '使用vip倍数需要达到的vip等级',
  `vip_multiple` decimal(20,2) NOT NULL COMMENT 'vip奖励倍数',
  PRIMARY KEY (`lv_node`,`month_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='不同等级区间配置不同的奖励倍数和vip倍数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mon_checkin_reward 结构
DROP TABLE IF EXISTS `base_mon_checkin_reward`;
CREATE TABLE IF NOT EXISTS `base_mon_checkin_reward` (
  `month_id` int(11) NOT NULL COMMENT '月份',
  `day_id` int(11) NOT NULL COMMENT '当月的第几天',
  `rewards` varchar(255) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`month_id`,`day_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通过月份和天设置奖励内容';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mon_checkin_total 结构
DROP TABLE IF EXISTS `base_mon_checkin_total`;
CREATE TABLE IF NOT EXISTS `base_mon_checkin_total` (
  `month_id` int(11) NOT NULL COMMENT '月份',
  `total_days` int(11) NOT NULL COMMENT '累计签到达到天数',
  `total_rewards` varchar(255) NOT NULL COMMENT '奖励',
  PRIMARY KEY (`month_id`,`total_days`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累计签到天数达到一定天数得到的奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mon_drop_rule 结构
DROP TABLE IF EXISTS `base_mon_drop_rule`;
CREATE TABLE IF NOT EXISTS `base_mon_drop_rule` (
  `act_id` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '活动主id',
  `sub_id` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '主动子id',
  `mon_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '怪物类型',
  `slv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '开始等级',
  `elv` int(11) unsigned NOT NULL DEFAULT '99' COMMENT '结束等级',
  `drop_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '掉落列表',
  `drop_rule` varchar(1000) DEFAULT '[]' COMMENT '掉落规则',
  PRIMARY KEY (`act_id`,`sub_id`,`mon_type`,`slv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mon_dynamic 结构
DROP TABLE IF EXISTS `base_mon_dynamic`;
CREATE TABLE IF NOT EXISTS `base_mon_dynamic` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物配置id',
  `min_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `max_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `attr_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `att` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击',
  `hp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '血量',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`id`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='怪物动态属性';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_mon_type_lv_hurt 结构
DROP TABLE IF EXISTS `base_mon_type_lv_hurt`;
CREATE TABLE IF NOT EXISTS `base_mon_type_lv_hurt` (
  `mon_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物类型',
  `blv` float(11,0) NOT NULL DEFAULT '0' COMMENT '开始等级',
  `elv` float(11,0) NOT NULL DEFAULT '0' COMMENT '结束等级',
  `role_add_hurt` float(11,2) DEFAULT '0.00' COMMENT '玩家伤害加成',
  `mon_add_hurt` float(11,2) DEFAULT '0.00' COMMENT '怪物伤害加成',
  PRIMARY KEY (`mon_type`,`blv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nature_box 结构
DROP TABLE IF EXISTS `base_nature_box`;
CREATE TABLE IF NOT EXISTS `base_nature_box` (
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景Id',
  `sub_pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子点位',
  `rand_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '每次随机点位数',
  `pos_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '刷出点列表',
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝箱怪Id',
  `create_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '刷出数量',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励性格点',
  PRIMARY KEY (`scene`,`sub_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='性格-性格宝箱配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nature_branch 结构
DROP TABLE IF EXISTS `base_nature_branch`;
CREATE TABLE IF NOT EXISTS `base_nature_branch` (
  `category` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `nature_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性格类型',
  `spot` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '位置',
  `light_times` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '点亮次数',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '节点名称',
  `need_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需求性格值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `attr_list` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT 'icon',
  `tip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '角标 1-普通奖励 2-标签 3-称号',
  `desc` varchar(500) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`category`,`nature_type`,`spot`,`light_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='性格-性格分支配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nature_category_reward 结构
DROP TABLE IF EXISTS `base_nature_category_reward`;
CREATE TABLE IF NOT EXISTS `base_nature_category_reward` (
  `category` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='性格-章节称号奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nature_kv 结构
DROP TABLE IF EXISTS `base_nature_kv`;
CREATE TABLE IF NOT EXISTS `base_nature_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `constant` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='性格-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nature_level 结构
DROP TABLE IF EXISTS `base_nature_level`;
CREATE TABLE IF NOT EXISTS `base_nature_level` (
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '突破等级',
  `cost_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗自由性格点',
  `add_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '增加属性',
  PRIMARY KEY (`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='性格-突破等级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nature_tips 结构
DROP TABLE IF EXISTS `base_nature_tips`;
CREATE TABLE IF NOT EXISTS `base_nature_tips` (
  `nature_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '标签类型',
  `tip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '标签',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `desc` varchar(500) NOT NULL DEFAULT '' COMMENT '标签描述',
  PRIMARY KEY (`nature_type`,`tip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='性格-标签配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_newer_task_awards 结构
DROP TABLE IF EXISTS `base_newer_task_awards`;
CREATE TABLE IF NOT EXISTS `base_newer_task_awards` (
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务ID',
  `awards` varchar(50) NOT NULL DEFAULT '[]' COMMENT '任务奖励',
  PRIMARY KEY (`type`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='新手任务奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_newer_task_process 结构
DROP TABLE IF EXISTS `base_newer_task_process`;
CREATE TABLE IF NOT EXISTS `base_newer_task_process` (
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务id',
  `task_pro` int(11) NOT NULL DEFAULT '0' COMMENT '任务进度',
  PRIMARY KEY (`type`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='新手任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_npc 结构
DROP TABLE IF EXISTS `base_npc`;
CREATE TABLE IF NOT EXISTS `base_npc` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT 'NPC编号',
  `target` int(11) NOT NULL DEFAULT '0' COMMENT '跨服主城NPC映射 开服N天后有效',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '称谓',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景',
  `icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '图标',
  `icon_scale` varchar(10) DEFAULT '1.0' COMMENT '资源缩放',
  `image` varchar(50) NOT NULL DEFAULT '0' COMMENT '头像',
  `arm_id` int(11) NOT NULL COMMENT '武器id',
  `x` int(11) NOT NULL DEFAULT '0',
  `y` int(11) NOT NULL DEFAULT '0',
  `talk` int(11) NOT NULL DEFAULT '0' COMMENT '对话',
  `func` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '功能',
  `action` text NOT NULL COMMENT '功能入口',
  `realm` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '所属阵营',
  `show` int(11) DEFAULT '1' COMMENT '默认是否显示 1显示 0不显示(默认显示)',
  `icon_texture` int(11) NOT NULL DEFAULT '0' COMMENT '贴图id',
  `bt_text` varchar(100) DEFAULT '' COMMENT 'NPC默认语',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='NPC信息和属性';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_equip 结构
DROP TABLE IF EXISTS `base_nucleon_equip`;
CREATE TABLE IF NOT EXISTS `base_nucleon_equip` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '装备',
  `attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `resolve` varchar(500) NOT NULL DEFAULT '[]' COMMENT '分解道具',
  `next` int(11) NOT NULL DEFAULT '0' COMMENT '突破目标',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '进化消耗',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物装备';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_exchange 结构
DROP TABLE IF EXISTS `base_nucleon_exchange`;
CREATE TABLE IF NOT EXISTS `base_nucleon_exchange` (
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT '序列',
  `goodsid` int(11) NOT NULL DEFAULT '0' COMMENT '获得道具id',
  `cost` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '消耗',
  PRIMARY KEY (`sort`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物兑换';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_hole 结构
DROP TABLE IF EXISTS `base_nucleon_hole`;
CREATE TABLE IF NOT EXISTS `base_nucleon_hole` (
  `hole` int(11) NOT NULL COMMENT '部位',
  `color` int(11) NOT NULL COMMENT '品质',
  `skill_id` varchar(1000) NOT NULL COMMENT '技能,等级',
  PRIMARY KEY (`hole`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='灵能技能激活';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_kv 结构
DROP TABLE IF EXISTS `base_nucleon_kv`;
CREATE TABLE IF NOT EXISTS `base_nucleon_kv` (
  `key` varchar(200) NOT NULL COMMENT '键',
  `value` varchar(1000) NOT NULL COMMENT '值',
  `desc` varchar(1000) NOT NULL COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_lv 结构
DROP TABLE IF EXISTS `base_nucleon_lv`;
CREATE TABLE IF NOT EXISTS `base_nucleon_lv` (
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '经验上限',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '属于阶段',
  `next` int(11) NOT NULL DEFAULT '0' COMMENT '下个等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  PRIMARY KEY (`lv`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物升级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_pool 结构
DROP TABLE IF EXISTS `base_nucleon_pool`;
CREATE TABLE IF NOT EXISTS `base_nucleon_pool` (
  `pool` int(11) NOT NULL DEFAULT '1' COMMENT '奖池类型',
  `cost` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '一次花费',
  `pay` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '十次花费',
  `base` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '基础获得',
  `rule` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '隐藏规则 ',
  `first` int(11) NOT NULL DEFAULT '0' COMMENT '首次',
  `cd` int(11) NOT NULL DEFAULT '0' COMMENT 'CD',
  `free` int(11) NOT NULL DEFAULT '0' COMMENT '每日免费',
  `open` int(11) NOT NULL DEFAULT '0' COMMENT '开服有效',
  `one` int(11) NOT NULL DEFAULT '0' COMMENT ' 单抽券',
  `ten` int(11) NOT NULL DEFAULT '0' COMMENT '十连抽券',
  PRIMARY KEY (`pool`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物奖池';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_pool_awards 结构
DROP TABLE IF EXISTS `base_nucleon_pool_awards`;
CREATE TABLE IF NOT EXISTS `base_nucleon_pool_awards` (
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT '序号',
  `awards` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `color` int(11) NOT NULL DEFAULT '0' COMMENT '品质类型',
  `pool` int(11) NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '奖品权重',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '开放等级',
  `show` int(11) NOT NULL DEFAULT '0' COMMENT '展示等级',
  `broadcast` int(11) NOT NULL DEFAULT '0' COMMENT '是否广播',
  PRIMARY KEY (`sort`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物奖池奖品';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_recast 结构
DROP TABLE IF EXISTS `base_nucleon_recast`;
CREATE TABLE IF NOT EXISTS `base_nucleon_recast` (
  `pos` int(11) NOT NULL DEFAULT '0' COMMENT '部位',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '段位',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `maxs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性上限',
  `adds` varchar(500) NOT NULL DEFAULT '[]' COMMENT '成长值',
  PRIMARY KEY (`pos`,`grade`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物洗练';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_section 结构
DROP TABLE IF EXISTS `base_nucleon_section`;
CREATE TABLE IF NOT EXISTS `base_nucleon_section` (
  `pos` int(11) NOT NULL DEFAULT '0' COMMENT '部位',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '段位',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `skill` varchar(500) NOT NULL DEFAULT '[]' COMMENT '技能激活',
  `next` int(11) NOT NULL COMMENT '下个段位',
  PRIMARY KEY (`pos`,`lv`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物觉醒';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_nucleon_title 结构
DROP TABLE IF EXISTS `base_nucleon_title`;
CREATE TABLE IF NOT EXISTS `base_nucleon_title` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '灵阶',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '名字',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '充能要求',
  `next` int(11) NOT NULL DEFAULT '0' COMMENT '下一阶',
  `attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `rate` int(11) NOT NULL DEFAULT '0' COMMENT '暴击概率',
  `dungeon` int(11) NOT NULL DEFAULT '0' COMMENT '副本要求',
  PRIMARY KEY (`lv`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='圣物称号';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_offline_hosting_act 结构
DROP TABLE IF EXISTS `base_offline_hosting_act`;
CREATE TABLE IF NOT EXISTS `base_offline_hosting_act` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能ID',
  `sub_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '子ID(默认为1)',
  `value_cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '托管值消耗',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  `order` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  `mod_sub` tinyint(2) NOT NULL COMMENT '功能子ID(对应日常子ID)',
  PRIMARY KEY (`module_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线托管-活动类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_offline_hosting_kv 结构
DROP TABLE IF EXISTS `base_offline_hosting_kv`;
CREATE TABLE IF NOT EXISTS `base_offline_hosting_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(5000) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线托管-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_onhook_exp_effiency 结构
DROP TABLE IF EXISTS `base_onhook_exp_effiency`;
CREATE TABLE IF NOT EXISTS `base_onhook_exp_effiency` (
  `wave` int(11) NOT NULL COMMENT '波数',
  `effiency` int(11) NOT NULL DEFAULT '0' COMMENT '效率(s)',
  PRIMARY KEY (`wave`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='货币类(经验)效率';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_optional_gift 结构
DROP TABLE IF EXISTS `base_optional_gift`;
CREATE TABLE IF NOT EXISTS `base_optional_gift` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `optional_num` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '自选数量',
  `list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '物品列表',
  PRIMARY KEY (`goods_id`,`career`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='自选宝箱';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pass_rewards 结构
DROP TABLE IF EXISTS `base_pass_rewards`;
CREATE TABLE IF NOT EXISTS `base_pass_rewards` (
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `sub_type` int(11) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `pass_lv` smallint(6) NOT NULL DEFAULT '0' COMMENT '等级',
  `lv_exp` int(11) NOT NULL DEFAULT '0' COMMENT '等级经验',
  `normal_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '普通奖励',
  `trump_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '王牌奖励',
  `node_reward` tinyint(1) NOT NULL DEFAULT '0' COMMENT '节点奖励',
  PRIMARY KEY (`type`,`sub_type`,`pass_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通行证宝典奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pellet_count_reward 结构
DROP TABLE IF EXISTS `base_pellet_count_reward`;
CREATE TABLE IF NOT EXISTS `base_pellet_count_reward` (
  `id` smallint(5) unsigned NOT NULL COMMENT '奖励id',
  `round` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '轮次',
  `count` smallint(3) unsigned NOT NULL DEFAULT '10' COMMENT '次数',
  `award` varchar(150) NOT NULL COMMENT '奖励',
  `broadcast` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠次数奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pellet_reward 结构
DROP TABLE IF EXISTS `base_pellet_reward`;
CREATE TABLE IF NOT EXISTS `base_pellet_reward` (
  `id` smallint(5) unsigned NOT NULL COMMENT '奖励id',
  `round_min` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '奖池轮次范围下限',
  `round_max` smallint(5) unsigned NOT NULL DEFAULT '999' COMMENT '奖池轮次范围上限',
  `weight` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '权重',
  `award` varchar(150) NOT NULL COMMENT '奖励',
  `is_show` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否展示',
  `broadcast` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠奖池配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_personal_boss_info 结构
DROP TABLE IF EXISTS `base_personal_boss_info`;
CREATE TABLE IF NOT EXISTS `base_personal_boss_info` (
  `boss_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS怪物id',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT 'BOSS代数',
  `recommend_lv` varchar(50) NOT NULL DEFAULT '' COMMENT '推荐等级',
  `recommend_power` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '推荐战力',
  `goods_normal` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '参与掉落',
  `goods_ratio` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '概率掉落',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `picture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS半身像',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人BOSS信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet 结构
DROP TABLE IF EXISTS `base_pet`;
CREATE TABLE IF NOT EXISTS `base_pet` (
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `pet_name` varchar(255) NOT NULL DEFAULT '' COMMENT '宠物名称',
  `pet_star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '宠物星级',
  `rare_degree` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '稀有度',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质色',
  `pet_race` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '宠物种族',
  `attr_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '成长属性',
  `is_native_pet` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否原始宠物',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '需求碎片',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '形象资源Id',
  `illus_range` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴序列',
  PRIMARY KEY (`pet_id`,`pet_star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物基础设定表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_awaken 结构
DROP TABLE IF EXISTS `base_pet_awaken`;
CREATE TABLE IF NOT EXISTS `base_pet_awaken` (
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `need_star` int(11) unsigned NOT NULL COMMENT '需求星级',
  `cost_material` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `add_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  `skill_list` varchar(255) NOT NULL COMMENT '技能替换',
  PRIMARY KEY (`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物觉醒配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_diamond_storage 结构
DROP TABLE IF EXISTS `base_pet_diamond_storage`;
CREATE TABLE IF NOT EXISTS `base_pet_diamond_storage` (
  `diamond_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝石Id',
  `diamond_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '宝石类型',
  `need_race` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '种族',
  `add_attr_list` varchar(500) NOT NULL DEFAULT '[]' COMMENT '属性加成列表',
  `diamond_name` varchar(255) NOT NULL DEFAULT '' COMMENT '宝石名称',
  `diamond_desc` varchar(500) NOT NULL DEFAULT '' COMMENT '宝石描述',
  PRIMARY KEY (`diamond_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物宝石栏配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_race_material 结构
DROP TABLE IF EXISTS `base_pet_race_material`;
CREATE TABLE IF NOT EXISTS `base_pet_race_material` (
  `race` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '种族',
  `cost_material` varchar(255) NOT NULL DEFAULT '[]' COMMENT '经验道具',
  PRIMARY KEY (`race`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='种族经验道具配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_skill 结构
DROP TABLE IF EXISTS `base_pet_skill`;
CREATE TABLE IF NOT EXISTS `base_pet_skill` (
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `skill_slot` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '技能槽位',
  `skill_talent_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '技能天赋类别',
  `skill_talent_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能天赋Id',
  `skill_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系数',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '技能名称',
  `desc` varchar(500) NOT NULL DEFAULT '' COMMENT '技能描述',
  `active_star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '开放星级',
  PRIMARY KEY (`pet_id`,`skill_slot`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物技能配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_story 结构
DROP TABLE IF EXISTS `base_pet_story`;
CREATE TABLE IF NOT EXISTS `base_pet_story` (
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `para_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '故事段落Id',
  `star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '需求星级',
  `title` varchar(100) NOT NULL DEFAULT '' COMMENT '正文标题',
  `content` varchar(1500) NOT NULL DEFAULT '' COMMENT '正文内容',
  PRIMARY KEY (`pet_id`,`para_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物故事配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_support_rank 结构
DROP TABLE IF EXISTS `base_pet_support_rank`;
CREATE TABLE IF NOT EXISTS `base_pet_support_rank` (
  `rank` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `top_designation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头名玩家称号',
  `server_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '全服奖励',
  `pet_expression` varchar(255) NOT NULL DEFAULT '' COMMENT '宠物随机发言',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物投票排名配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_support_slot 结构
DROP TABLE IF EXISTS `base_pet_support_slot`;
CREATE TABLE IF NOT EXISTS `base_pet_support_slot` (
  `slot_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '声援槽位',
  `attr_add_ratio` float(5,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '宠物属性加成比例',
  `open_sum_star` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '开放总星级',
  PRIMARY KEY (`slot_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物声援槽位配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pet_upgrade 结构
DROP TABLE IF EXISTS `base_pet_upgrade`;
CREATE TABLE IF NOT EXISTS `base_pet_upgrade` (
  `pet_rare_degree` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '宠物稀有度',
  `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验值',
  PRIMARY KEY (`pet_rare_degree`,`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物升级配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_phantom_task_type 结构
DROP TABLE IF EXISTS `base_phantom_task_type`;
CREATE TABLE IF NOT EXISTS `base_phantom_task_type` (
  `task_type_id` smallint(6) NOT NULL DEFAULT '0' COMMENT '任务类型id',
  `open_lv` smallint(6) NOT NULL DEFAULT '0' COMMENT '开放等级',
  `open_day` smallint(6) NOT NULL DEFAULT '0' COMMENT '开服天数',
  `task_type` varchar(255) NOT NULL DEFAULT '' COMMENT '任务类型',
  `desc` varchar(511) NOT NULL DEFAULT '' COMMENT '任务描述',
  `link` varchar(255) NOT NULL DEFAULT '[]' COMMENT '跳转',
  `point` smallint(6) NOT NULL DEFAULT '0' COMMENT '击杀积分',
  `limit_times` tinyint(4) NOT NULL DEFAULT '0' COMMENT '次数上限',
  PRIMARY KEY (`task_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻魔宝典任务配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_price_type 结构
DROP TABLE IF EXISTS `base_price_type`;
CREATE TABLE IF NOT EXISTS `base_price_type` (
  `price_type` int(11) NOT NULL COMMENT '价格类型',
  `price_name` varchar(20) NOT NULL COMMENT '价格名称',
  PRIMARY KEY (`price_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='价格类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_printer_draw 结构
DROP TABLE IF EXISTS `base_printer_draw`;
CREATE TABLE IF NOT EXISTS `base_printer_draw` (
  `id` int(11) NOT NULL COMMENT '唯一id',
  `item_suit` int(11) NOT NULL DEFAULT '0' COMMENT '主题道具',
  `exchange_item` int(11) NOT NULL DEFAULT '0' COMMENT '物品id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成机-常规奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_printer_draw_list 结构
DROP TABLE IF EXISTS `base_printer_draw_list`;
CREATE TABLE IF NOT EXISTS `base_printer_draw_list` (
  `id` int(11) NOT NULL COMMENT '唯一id',
  `exchange` varchar(255) NOT NULL DEFAULT '[]' COMMENT '兑换消耗',
  `pic` int(11) NOT NULL DEFAULT '0' COMMENT '物品图标',
  `item_suit` int(11) NOT NULL DEFAULT '0' COMMENT '主题道具id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '物品名称',
  `pool` int(11) NOT NULL DEFAULT '0' COMMENT '奖池id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成机-配方合成配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_printer_draw_pool 结构
DROP TABLE IF EXISTS `base_printer_draw_pool`;
CREATE TABLE IF NOT EXISTS `base_printer_draw_pool` (
  `id` int(11) NOT NULL COMMENT '唯一id',
  `pool` int(11) NOT NULL DEFAULT '0' COMMENT '奖池id',
  `pool_type` int(11) NOT NULL DEFAULT '0' COMMENT '套件id',
  `opday` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数',
  `goods` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成机-奖池配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_prismdraw_kv 结构
DROP TABLE IF EXISTS `base_prismdraw_kv`;
CREATE TABLE IF NOT EXISTS `base_prismdraw_kv` (
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='黑白棋-键值对';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_prismdraw_reward 结构
DROP TABLE IF EXISTS `base_prismdraw_reward`;
CREATE TABLE IF NOT EXISTS `base_prismdraw_reward` (
  `subtype` smallint(6) NOT NULL COMMENT '活动子类型',
  `grade` smallint(6) NOT NULL COMMENT '奖励档次',
  `type` smallint(6) NOT NULL COMMENT '奖池类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `weight` smallint(6) NOT NULL COMMENT '奖励权重',
  `limit` smallint(6) NOT NULL COMMENT '一轮奖池里最高出现次数',
  `total_limit` smallint(6) NOT NULL COMMENT '活动期间，最大获取次数',
  `req_limit` smallint(6) NOT NULL COMMENT '一轮奖池里第几个格子出现',
  `is_lucky` smallint(6) NOT NULL COMMENT '是否幸运大奖',
  `is_tv` tinyint(2) NOT NULL COMMENT '是否传闻',
  `lucky` varchar(255) NOT NULL DEFAULT '[]' COMMENT '幸运值限制',
  `role_lv` varchar(255) NOT NULL DEFAULT '[]' COMMENT '等级限制',
  PRIMARY KEY (`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_prismdraw_route 结构
DROP TABLE IF EXISTS `base_prismdraw_route`;
CREATE TABLE IF NOT EXISTS `base_prismdraw_route` (
  `route_id` smallint(6) NOT NULL COMMENT '路线id',
  `route_step` varchar(255) NOT NULL COMMENT '路线',
  `weight` smallint(6) NOT NULL COMMENT '路线权重',
  `total_step` smallint(6) NOT NULL COMMENT '总步数',
  `weight_temp` smallint(6) NOT NULL COMMENT '临时权重',
  `temp_lowlimit` smallint(6) NOT NULL COMMENT '临时权重下限',
  `temp_toplimit` smallint(6) NOT NULL COMMENT '临时权重上限',
  PRIMARY KEY (`route_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='棱镜抽奖路线表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_produce_type 结构
DROP TABLE IF EXISTS `base_produce_type`;
CREATE TABLE IF NOT EXISTS `base_produce_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='产出类型配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_profile_photo 结构
DROP TABLE IF EXISTS `base_profile_photo`;
CREATE TABLE IF NOT EXISTS `base_profile_photo` (
  `photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像Id',
  `name` varchar(120) NOT NULL DEFAULT '' COMMENT '头像名称',
  `career` varchar(120) NOT NULL DEFAULT '[]' COMMENT '职业：0不限职业，1男战士，2女战士，3男法师，4女法师',
  `cost` int(11) NOT NULL DEFAULT '0' COMMENT '激活消耗道具',
  `attr_list` varchar(120) NOT NULL DEFAULT '[]' COMMENT '头像属性',
  `desc` varchar(800) NOT NULL DEFAULT '' COMMENT '获取途径描述',
  `gaining_way` varchar(200) NOT NULL DEFAULT '' COMMENT '获取途径Id',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转职Id',
  `photo_resources_id` varchar(200) NOT NULL DEFAULT '' COMMENT '头像图片资源Id',
  PRIMARY KEY (`photo_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色头像配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_pushmail 结构
DROP TABLE IF EXISTS `base_pushmail`;
CREATE TABLE IF NOT EXISTS `base_pushmail` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '触发id',
  `time` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '时间触发',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `merge_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合服天数',
  `create_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建角色天数',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `career` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '职业',
  `sex` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '性别',
  `dun` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本ID',
  `other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '其他',
  `title` varchar(1024) NOT NULL COMMENT '邮件标题@lang@',
  `msg` varchar(1024) NOT NULL COMMENT '邮件内容@lang@',
  `accessory` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '邮件附件',
  `about` varchar(1024) NOT NULL COMMENT '说明@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件推送';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_quick_buy_price 结构
DROP TABLE IF EXISTS `base_quick_buy_price`;
CREATE TABLE IF NOT EXISTS `base_quick_buy_price` (
  `goods_type_id` int(10) unsigned NOT NULL COMMENT '物品类型id',
  `gold_price` int(10) unsigned NOT NULL COMMENT '钻石价格',
  `bgold_price` int(10) unsigned NOT NULL COMMENT '绑钻价格（0为不可用绑钻买）',
  `coin_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币价格（0为不可用金币买）',
  `consume_type` varchar(256) NOT NULL DEFAULT 'unknown' COMMENT '消耗类型',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='快速购买价格配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_award 结构
DROP TABLE IF EXISTS `base_race_rank_award`;
CREATE TABLE IF NOT EXISTS `base_race_rank_award` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `stage` int(11) unsigned NOT NULL COMMENT '世界等级阶段',
  `award_id` int(11) unsigned NOT NULL COMMENT '奖励Id',
  `award` varchar(150) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `loading_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '入库次数',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT '权重',
  `is_broadcast` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否发送传闻(1发 0不发)',
  `is_tv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否上电视(1上 0不上)',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '奖池归属',
  PRIMARY KEY (`act_id`,`stage`,`award_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竟榜活动-奖池奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_constant 结构
DROP TABLE IF EXISTS `base_race_rank_constant`;
CREATE TABLE IF NOT EXISTS `base_race_rank_constant` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `key` varchar(100) NOT NULL DEFAULT '' COMMENT '主键',
  `value` varchar(150) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(200) NOT NULL DEFAULT '' COMMENT '描述说明',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竟榜活动-常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_discount 结构
DROP TABLE IF EXISTS `base_race_rank_discount`;
CREATE TABLE IF NOT EXISTS `base_race_rank_discount` (
  `id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `times_min` int(11) unsigned NOT NULL COMMENT '10抽次数下限',
  `times_max` int(11) unsigned NOT NULL COMMENT '10抽次数上限',
  `cost_list` varchar(150) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `is_show` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '前端是否展示 0:不展示1:展示',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_key` (`times_min`,`times_max`) COMMENT '唯一约束'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-10连抽折扣';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_rank_award 结构
DROP TABLE IF EXISTS `base_race_rank_rank_award`;
CREATE TABLE IF NOT EXISTS `base_race_rank_rank_award` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `stage` int(11) unsigned NOT NULL COMMENT '世界等级阶段',
  `min_rank` int(11) unsigned NOT NULL COMMENT '排名上限',
  `max_rank` int(11) unsigned NOT NULL COMMENT '排名下限',
  `award` varchar(150) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`act_id`,`stage`,`min_rank`,`max_rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竟榜活动-排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_requirement 结构
DROP TABLE IF EXISTS `base_race_rank_requirement`;
CREATE TABLE IF NOT EXISTS `base_race_rank_requirement` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `ranking_upper` int(11) unsigned NOT NULL COMMENT '排名上限',
  `ranking_lower` int(11) unsigned NOT NULL COMMENT '排名下限',
  `need_score` int(11) unsigned NOT NULL COMMENT '所需积分',
  PRIMARY KEY (`act_id`,`need_score`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竟榜活动-排行榜排名积分需求';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_time 结构
DROP TABLE IF EXISTS `base_race_rank_time`;
CREATE TABLE IF NOT EXISTS `base_race_rank_time` (
  `act_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动Id',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '活动分类1冲榜2许愿池',
  `open_day` varchar(100) NOT NULL DEFAULT '0' COMMENT '开服多少天内可参与',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '活动名',
  `start_time` varchar(40) NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `end_time` varchar(40) NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `show_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '展示时间',
  `condition` varchar(300) NOT NULL DEFAULT '[]' COMMENT '条件',
  `title_name` varchar(255) NOT NULL COMMENT '标题名字',
  `title` varchar(255) NOT NULL COMMENT '碎片名字',
  `icon_res` varchar(255) NOT NULL COMMENT '图标资源',
  `jump_id` int(11) NOT NULL COMMENT '跳转id',
  `sub_id` int(11) NOT NULL COMMENT '跳转子id',
  `show_bg` varchar(255) NOT NULL COMMENT '广告图资源',
  `skill_data` varchar(1000) NOT NULL COMMENT '宠物技能数据',
  `jump_res` varchar(255) NOT NULL COMMENT '跳转资源',
  `lv` int(11) NOT NULL COMMENT '等级',
  PRIMARY KEY (`act_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竟榜活动-时间配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_times_award 结构
DROP TABLE IF EXISTS `base_race_rank_times_award`;
CREATE TABLE IF NOT EXISTS `base_race_rank_times_award` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `stage` int(11) unsigned NOT NULL COMMENT '世界等级阶段',
  `award_id` int(11) unsigned NOT NULL COMMENT '奖励Id',
  `need_score` int(11) unsigned NOT NULL COMMENT '个人所需积分',
  `server_score` int(11) NOT NULL DEFAULT '0' COMMENT '全服所需积分',
  `award` varchar(150) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`act_id`,`stage`,`award_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竟榜活动-积分阶段奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rank_world_lev 结构
DROP TABLE IF EXISTS `base_race_rank_world_lev`;
CREATE TABLE IF NOT EXISTS `base_race_rank_world_lev` (
  `stage` int(11) unsigned NOT NULL COMMENT '世界等级阶段',
  `min_lev` int(11) unsigned NOT NULL COMMENT '世界等级上限',
  `max_lev` int(11) unsigned NOT NULL COMMENT '世界等级下限',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竟榜活动-世界等级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_rune_cost 结构
DROP TABLE IF EXISTS `base_race_rune_cost`;
CREATE TABLE IF NOT EXISTS `base_race_rune_cost` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '次数',
  `num` int(11) NOT NULL DEFAULT '0' COMMENT '消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='次数消耗';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_race_wish_coin 结构
DROP TABLE IF EXISTS `base_race_wish_coin`;
CREATE TABLE IF NOT EXISTS `base_race_wish_coin` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '默认键',
  `min_gold` int(11) NOT NULL DEFAULT '0' COMMENT '充值下限',
  `max_gold` int(11) NOT NULL DEFAULT '0' COMMENT '充值上限',
  `coin` int(11) NOT NULL DEFAULT '0' COMMENT '金币',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值金币';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_ranking 结构
DROP TABLE IF EXISTS `base_ranking`;
CREATE TABLE IF NOT EXISTS `base_ranking` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `rank_name` varchar(255) NOT NULL DEFAULT '' COMMENT '榜单名字',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜最大长度',
  `rank_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前类型的最低限度',
  `title_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '首位称号Id',
  `about` varchar(1024) NOT NULL COMMENT '说明@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_rb_stronger 结构
DROP TABLE IF EXISTS `base_rb_stronger`;
CREATE TABLE IF NOT EXISTS `base_rb_stronger` (
  `lv_min` int(11) NOT NULL COMMENT '等级下限',
  `lv_max` int(11) NOT NULL COMMENT '等级上限 ',
  `grade` varchar(1000) NOT NULL COMMENT '对应阶数',
  PRIMARY KEY (`lv_min`,`lv_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_realm 结构
DROP TABLE IF EXISTS `base_realm`;
CREATE TABLE IF NOT EXISTS `base_realm` (
  `realm_id` smallint(5) NOT NULL,
  `realm_name` varchar(50) NOT NULL COMMENT '阵营@lang@',
  PRIMARY KEY (`realm_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_recharge_daily_gift 结构
DROP TABLE IF EXISTS `base_recharge_daily_gift`;
CREATE TABLE IF NOT EXISTS `base_recharge_daily_gift` (
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '商品编号',
  `level` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '档次',
  `value` int(10) unsigned NOT NULL COMMENT '充值钻石',
  `reward` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日礼包配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_recharge_first 结构
DROP TABLE IF EXISTS `base_recharge_first`;
CREATE TABLE IF NOT EXISTS `base_recharge_first` (
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '商品编号',
  `type` int(10) unsigned NOT NULL COMMENT '类型',
  `index` tinyint(3) unsigned NOT NULL COMMENT '序号',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `title` varchar(256) NOT NULL COMMENT '标题@lang@',
  `content` varchar(256) NOT NULL COMMENT '描述@lang@',
  `left_res` varchar(256) NOT NULL COMMENT '左侧资源名',
  `right_res` varchar(256) NOT NULL COMMENT '右侧资源名',
  PRIMARY KEY (`product_id`,`type`,`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='首充配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_recharge_goods 结构
DROP TABLE IF EXISTS `base_recharge_goods`;
CREATE TABLE IF NOT EXISTS `base_recharge_goods` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `type` int(11) unsigned NOT NULL COMMENT '商品类型',
  `sub_type` int(11) unsigned NOT NULL COMMENT '商品子类',
  `name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '商品名称',
  `limit` varchar(20) NOT NULL DEFAULT '[]' COMMENT '限购类型##[限购类型，限购数量]',
  `start_time` varchar(30) NOT NULL DEFAULT '[]' COMMENT '开始时间',
  `end_time` varchar(30) NOT NULL DEFAULT '[]' COMMENT '结束时间',
  `open_day` varchar(30) NOT NULL DEFAULT '[]' COMMENT '开服天数##[开始,结束]',
  `merge_day` varchar(30) NOT NULL DEFAULT '[]' COMMENT '合服天数##[开始,结束]',
  `condition` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '上架条件',
  `award` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '商品内容',
  `about` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值-商品配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_recharge_product 结构
DROP TABLE IF EXISTS `base_recharge_product`;
CREATE TABLE IF NOT EXISTS `base_recharge_product` (
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `product_name` varchar(255) NOT NULL COMMENT '商品名称@lang@',
  `product_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类',
  `product_subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品子类',
  `money` varchar(50) NOT NULL DEFAULT '0' COMMENT '商品价格',
  `game_currency` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值游戏币',
  `associate_list` varchar(1024) NOT NULL COMMENT '关联商品',
  `about` varchar(1024) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值-充值配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_recharge_return 结构
DROP TABLE IF EXISTS `base_recharge_return`;
CREATE TABLE IF NOT EXISTS `base_recharge_return` (
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `return_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利类型',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础钻石',
  `return_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利钻石',
  PRIMARY KEY (`product_id`,`return_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值返利配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_recharge_type 结构
DROP TABLE IF EXISTS `base_recharge_type`;
CREATE TABLE IF NOT EXISTS `base_recharge_type` (
  `product_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类',
  `type_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '大类名称',
  `product_subtype` int(11) unsigned NOT NULL COMMENT '商品子类',
  `subtyp_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '子类名称',
  PRIMARY KEY (`product_type`,`product_subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值-商品类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_recharge_welfare 结构
DROP TABLE IF EXISTS `base_recharge_welfare`;
CREATE TABLE IF NOT EXISTS `base_recharge_welfare` (
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品编号',
  `days` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续天数',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每日奖励',
  `double_week` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每周双倍',
  `buy_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '购买立马获得',
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利卡';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_red_envelopes_goods 结构
DROP TABLE IF EXISTS `base_red_envelopes_goods`;
CREATE TABLE IF NOT EXISTS `base_red_envelopes_goods` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包物品id',
  `ownership_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '红包的归属 1: 公会红包',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `greetings` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语@lang@',
  `money_type` tinyint(1) unsigned NOT NULL DEFAULT '2' COMMENT '货币类型',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额度',
  `min_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小拆分数量',
  `times_lim` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用次数限制',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包物品额外配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_red_packet 结构
DROP TABLE IF EXISTS `base_red_packet`;
CREATE TABLE IF NOT EXISTS `base_red_packet` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '红包名称',
  `greetings` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语',
  `trigger_interval` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周期限制',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  `kind` int(11) NOT NULL DEFAULT '1' COMMENT '货币类型',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金额',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包个数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_red_packet_reply 结构
DROP TABLE IF EXISTS `base_red_packet_reply`;
CREATE TABLE IF NOT EXISTS `base_red_packet_reply` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss_id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '红包名称',
  `greeting` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金额',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_red_packet_vip 结构
DROP TABLE IF EXISTS `base_red_packet_vip`;
CREATE TABLE IF NOT EXISTS `base_red_packet_vip` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `min_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级下限',
  `max_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级上限',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '红包名称',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金额',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_reincarnation_cfg 结构
DROP TABLE IF EXISTS `base_reincarnation_cfg`;
CREATE TABLE IF NOT EXISTS `base_reincarnation_cfg` (
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT '头像',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头部模型id',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  `unlock_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '解锁技能',
  `replace_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '强化技能',
  `unlock_other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '解锁其它',
  PRIMARY KEY (`career`,`sex`,`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转生配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_reincarnation_info_cfg 结构
DROP TABLE IF EXISTS `base_reincarnation_info_cfg`;
CREATE TABLE IF NOT EXISTS `base_reincarnation_info_cfg` (
  `turn` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '转生数',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '阶段名@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `task_ids` varchar(255) NOT NULL DEFAULT '[]' COMMENT '任务列表',
  PRIMARY KEY (`turn`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转生阶段描述';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_reincarnation_task_cfg 结构
DROP TABLE IF EXISTS `base_reincarnation_task_cfg`;
CREATE TABLE IF NOT EXISTS `base_reincarnation_task_cfg` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性奖励',
  PRIMARY KEY (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转生任务属性奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_rela_config 结构
DROP TABLE IF EXISTS `base_rela_config`;
CREATE TABLE IF NOT EXISTS `base_rela_config` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'key',
  `value` varchar(1024) NOT NULL DEFAULT '[]' COMMENT 'value',
  `about` varchar(1024) NOT NULL COMMENT '说明@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社交配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_res_act 结构
DROP TABLE IF EXISTS `base_res_act`;
CREATE TABLE IF NOT EXISTS `base_res_act` (
  `act_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `act_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `type` int(11) NOT NULL DEFAULT '2' COMMENT '找回类型',
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最小等级',
  `level_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级上限',
  `server_min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界最小等级',
  `server_max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '世界最大等级',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `guild_limit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '公会限制',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称',
  `coin_per` varchar(255) NOT NULL DEFAULT '[]' COMMENT '部分找回消耗',
  `coin_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '部分找回奖励',
  `coin_exp` int(11) NOT NULL DEFAULT '0' COMMENT '部分找回经验',
  `gold_per` varchar(255) NOT NULL DEFAULT '[]' COMMENT '完整找回消耗',
  `gold_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '完整找回奖励',
  `gold_exp` mediumint(11) NOT NULL DEFAULT '0' COMMENT '完整找回经验',
  `filter_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '筛选id',
  PRIMARY KEY (`act_id`,`act_sub`,`level`,`level_max`,`server_min_lv`,`server_max_lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='资源找回配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_res_act_type 结构
DROP TABLE IF EXISTS `base_res_act_type`;
CREATE TABLE IF NOT EXISTS `base_res_act_type` (
  `act_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `act_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  PRIMARY KEY (`act_id`,`act_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_reward_boss_info 结构
DROP TABLE IF EXISTS `base_reward_boss_info`;
CREATE TABLE IF NOT EXISTS `base_reward_boss_info` (
  `boss_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS怪物id',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT 'BOSS代数',
  `boss_name` varchar(50) NOT NULL DEFAULT '' COMMENT 'BOSS名字',
  `boss_scene` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS场景',
  `boss_position` varchar(50) NOT NULL DEFAULT '' COMMENT 'BOSS坐标',
  `reborn_cfg` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '重生时间##[{需要开服天数,秒数}]',
  `award_base` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '常规奖励',
  `award_extra_num` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '额外奖励个数',
  `award_extra` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '额外奖励',
  `enter_lv` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '进入等级',
  `award_base_show` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '常规奖励展示',
  `award_extra_show` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '额外奖励展示',
  `boss_picture` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS头像',
  `is_peace` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否和平',
  `recommend_lv` varchar(50) NOT NULL DEFAULT '[]' COMMENT '推荐等级',
  `recommend_attr` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '推荐属性',
  `recommend_power` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '推荐战力',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='赏金BOSS信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_rush_giftbag 结构
DROP TABLE IF EXISTS `base_rush_giftbag`;
CREATE TABLE IF NOT EXISTS `base_rush_giftbag` (
  `id` smallint(5) unsigned NOT NULL COMMENT '礼包id',
  `bag_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '礼包类型',
  `bag_sub_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '礼包子类',
  `bag_number` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '礼包数量',
  `bag_value` int(10) unsigned NOT NULL COMMENT '领取条件',
  `bag_name` varchar(255) NOT NULL COMMENT '礼包名称@lang@',
  `bag_gift` varchar(500) NOT NULL COMMENT '礼包奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_rush_goal_reward 结构
DROP TABLE IF EXISTS `base_rush_goal_reward`;
CREATE TABLE IF NOT EXISTS `base_rush_goal_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动Id(冲榜)',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `goal_value` varchar(255) NOT NULL DEFAULT '[]' COMMENT '目标值',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `about` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励说明',
  PRIMARY KEY (`id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲榜目标奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_rush_rank 结构
DROP TABLE IF EXISTS `base_rush_rank`;
CREATE TABLE IF NOT EXISTS `base_rush_rank` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id(冲榜)',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名称(冲榜)',
  `start_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服第几天开始',
  `clear_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服第几天结算',
  `max_len` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '榜单长度',
  `limit` varchar(255) NOT NULL DEFAULT '[]' COMMENT '上榜阈值[{字段, 值}]',
  `figure_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '第一名额外奖励展示资源',
  `rec_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源类型',
  `tips` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '大奖描述',
  `sort_id` tinyint(3) unsigned NOT NULL COMMENT '顺序id（客户端排序用）',
  `nominate` varchar(500) NOT NULL DEFAULT '' COMMENT '推荐途径',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲榜活动配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_rush_rank_reward 结构
DROP TABLE IF EXISTS `base_rush_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_rush_rank_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励Id',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `rank_limit` varchar(255) NOT NULL DEFAULT '[]' COMMENT '排名限制',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `about` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励描述',
  PRIMARY KEY (`id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲榜排行奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_scene 结构
DROP TABLE IF EXISTS `base_scene`;
CREATE TABLE IF NOT EXISTS `base_scene` (
  `id` int(11) NOT NULL COMMENT '场景id',
  `name` char(20) NOT NULL COMMENT '场景名',
  `type` int(1) NOT NULL DEFAULT '0' COMMENT '场景大类 0 主城1 野外 2 副本',
  `subtype` int(1) NOT NULL COMMENT '场景子类 0 普通,1 安全场景',
  `cls_type` int(1) NOT NULL COMMENT '是否跨服场景 0 非跨服 | 1 跨服',
  `broadcast` int(1) DEFAULT NULL COMMENT '广播类型 0九宫格 | 1全场景',
  `mount` int(1) NOT NULL COMMENT '是否可上坐骑',
  `x` int(11) NOT NULL COMMENT '默认x坐标',
  `y` int(11) NOT NULL COMMENT '默认y坐标',
  `is_have_safe_area` int(1) NOT NULL COMMENT '是否有安全区 0 否 | 1是',
  `width` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景横向长度(最大12000像素)',
  `height` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景纵向长度',
  `elem` text NOT NULL COMMENT '传送阵列表(格式:[{NextSceneId, x, y},...])',
  `npc` text NOT NULL COMMENT '场景NPC,数据结构(格式:[{NpcId, x, y},...])',
  `mon` text NOT NULL COMMENT '场景怪物,数据结构([{怪物id, x, y, 是否主动(0|1),分组id},...])',
  `mask` longtext NOT NULL COMMENT '障碍点',
  `jump` text NOT NULL COMMENT '跳跃点(格式:[{编号, 目的X, 目的Y},...])',
  `dynamicarea` text NOT NULL,
  `requirement` text NOT NULL COMMENT '进入需求(格式:[{lv, Lv},...])',
  `minimapwidth` int(10) NOT NULL DEFAULT '550',
  `minimapheight` int(10) NOT NULL DEFAULT '380',
  `scene_bright` varchar(10) NOT NULL DEFAULT '0.9',
  `is_have_minimap` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '否有小地图##0:无;1:有小地图',
  `parnter_battle_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴战斗类型',
  `fuhuoscene` int(11) NOT NULL DEFAULT '0' COMMENT '复活场景',
  `reborn_xys` text NOT NULL COMMENT '复活坐标列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='场景';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_scene_other 结构
DROP TABLE IF EXISTS `base_scene_other`;
CREATE TABLE IF NOT EXISTS `base_scene_other` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景ID',
  `room_max_people` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间最大人数（程序容错最小50人，仅野外和主城有效）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='场景其他配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_seckill_round 结构
DROP TABLE IF EXISTS `base_seckill_round`;
CREATE TABLE IF NOT EXISTS `base_seckill_round` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '场次',
  `optime` varchar(50) NOT NULL DEFAULT '[]' COMMENT '开启时间',
  `duration` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续时间',
  `label` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '边框类型',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-秒杀场次';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_sell_filter_stage 结构
DROP TABLE IF EXISTS `base_sell_filter_stage`;
CREATE TABLE IF NOT EXISTS `base_sell_filter_stage` (
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场物品阶数过滤配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_sell_filter_star 结构
DROP TABLE IF EXISTS `base_sell_filter_star`;
CREATE TABLE IF NOT EXISTS `base_sell_filter_star` (
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`color`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场物品星数过滤配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_sell_price 结构
DROP TABLE IF EXISTS `base_sell_price`;
CREATE TABLE IF NOT EXISTS `base_sell_price` (
  `min_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `num_lim` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次上架数量限制',
  `min_unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小单价',
  `max_unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大单价',
  PRIMARY KEY (`min_wlv`,`max_wlv`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场出售价格限制';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_setting 结构
DROP TABLE IF EXISTS `base_setting`;
CREATE TABLE IF NOT EXISTS `base_setting` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类别',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类别',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `is_open` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '默认开关',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='设置配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_seven_goal_score 结构
DROP TABLE IF EXISTS `base_seven_goal_score`;
CREATE TABLE IF NOT EXISTS `base_seven_goal_score` (
  `score` smallint(255) NOT NULL COMMENT '积分',
  `reward` varchar(511) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`score`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='七日目标-积分奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_seven_goal_task 结构
DROP TABLE IF EXISTS `base_seven_goal_task`;
CREATE TABLE IF NOT EXISTS `base_seven_goal_task` (
  `days` smallint(6) NOT NULL COMMENT '天数',
  `mod_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块Id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子id',
  `order_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序id',
  `difficulty` tinyint(2) NOT NULL COMMENT '任务难度',
  `name` varchar(1024) NOT NULL DEFAULT '' COMMENT '任务名称',
  `jump_id` varchar(255) NOT NULL DEFAULT '' COMMENT '跳转id',
  `reward` varchar(511) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  PRIMARY KEY (`days`,`mod_id`,`sub_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='七日目标-任务配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_seven_skill_reward 结构
DROP TABLE IF EXISTS `base_seven_skill_reward`;
CREATE TABLE IF NOT EXISTS `base_seven_skill_reward` (
  `days` smallint(6) NOT NULL COMMENT '天数',
  `skill_reward` int(11) NOT NULL COMMENT '技能奖励',
  `name` varchar(255) NOT NULL COMMENT '名称',
  PRIMARY KEY (`days`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='七日目标-技能奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_share_flop_treasure 结构
DROP TABLE IF EXISTS `base_share_flop_treasure`;
CREATE TABLE IF NOT EXISTS `base_share_flop_treasure` (
  `id` int(11) NOT NULL COMMENT '奖池id',
  `flop_cost` int(11) NOT NULL DEFAULT '0' COMMENT '祝福值消耗',
  `treasure` varchar(512) NOT NULL DEFAULT '[]' COMMENT '稀有奖池奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='共享稀有奖池配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_shop 结构
DROP TABLE IF EXISTS `base_shop`;
CREATE TABLE IF NOT EXISTS `base_shop` (
  `key_id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `shop_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '商店子类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `num` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '单次出售数量',
  `ctype` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '价格类型##1-钻石，2-绑定钻石，其他待定',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '价格##直接填数字',
  `discount` int(11) unsigned NOT NULL DEFAULT '100' COMMENT '折扣',
  `quota_type` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '限购类型',
  `quota_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限购数量',
  `on_sale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开发天数（开售）',
  `halt_sale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数（停售）',
  `wlv_sale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级（开售）##默认是0,0为不限制，若有则为到该等级开始出售',
  `wlv_unsale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级（停售）##默认是0,0为不限制，若有则为到该等级停止出售',
  `condition` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '购买条件##不限时默认[]，根据需求填条件[{lv,122,123},{vip,3}],可同时填多个',
  `counter_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数模块ID',
  `counter_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数Id',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否绑定##默认是0,0为不绑定，1为绑定',
  `preview` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否可试穿',
  `hot` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '热门推荐（0表示不进入热门推荐，大于0则是在热门推荐中的顺序）',
  `on_lev` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '上架等级-等级条件未达到商品不上架，不显示在商城中',
  `down_lev` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '下架等级-等级条件超过后商品下架，不显示在商城中',
  `tips` smallint(3) unsigned NOT NULL DEFAULT '2' COMMENT '标签-- 1.热卖2.新品3.独占4.必买',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '1,2,3,4表示4个职业，0表示全职业。不是本职业的商品看不到',
  PRIMARY KEY (`key_id`),
  KEY `shop_type` (`shop_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商城';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_shop_type 结构
DROP TABLE IF EXISTS `base_shop_type`;
CREATE TABLE IF NOT EXISTS `base_shop_type` (
  `shop_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `shop_name` varchar(255) NOT NULL COMMENT '商店名称',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店子类型',
  `name` varchar(80) NOT NULL DEFAULT '' COMMENT '子类型名称',
  PRIMARY KEY (`shop_type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商城-商品分类配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_show_resource 结构
DROP TABLE IF EXISTS `base_show_resource`;
CREATE TABLE IF NOT EXISTS `base_show_resource` (
  `item_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `seq` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '物品名称',
  `model_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '部位id',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型id',
  `show_id` varchar(50) NOT NULL DEFAULT '0' COMMENT '展示id',
  `desc` varchar(500) NOT NULL DEFAULT '[]' COMMENT '描述备注',
  PRIMARY KEY (`item_id`,`seq`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-资源展示';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_skill 结构
DROP TABLE IF EXISTS `base_skill`;
CREATE TABLE IF NOT EXISTS `base_skill` (
  `id` int(10) unsigned NOT NULL,
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '技能名称@lang@',
  `about` varchar(128) NOT NULL COMMENT '技能备注@lang@',
  `career` int(11) NOT NULL COMMENT '所属职业:1-剑客，10-通用被动，11-怪物，12-宠物，14-坐骑，15-翅膀，16-法宝，17-神兵，18-披风，19-神兽，20-公会，21-副本。这里的职业指基础职业，同一个职业多次转生，但都属于同一基础职业。',
  `type` int(11) NOT NULL COMMENT '类型：1主动技能，2辅助技能，3被动技能',
  `is_normal` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否普攻(0|1)',
  `is_combo` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否副技能(0|1)',
  `is_anger` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否怒气技能(0|1)',
  `refind_target` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否重新选取目标(0|1)',
  `mod` tinyint(2) DEFAULT '1' COMMENT '攻击模式：1单体，2群体',
  `obj` tinyint(2) NOT NULL COMMENT '目标选取类型：1自己，2最近敌方，3最近队友，4朝向，5最少血队友，6指定怪物',
  `calc` int(11) NOT NULL COMMENT '是否计算伤害：0否，1是',
  `release` int(11) DEFAULT '1' COMMENT '技能释放模式：1普通，2蓄能，3移动施法',
  `around_hurt` int(11) NOT NULL COMMENT '群攻周围伤害比：1-1000',
  `range` int(11) NOT NULL COMMENT '群攻范围模式：1圆形，2直线，3扇形',
  `talent` varchar(128) CHARACTER SET ucs2 DEFAULT '[]' COMMENT '天赋技能id列表 [{技能id,概率(千分制),持续时间(毫秒)}...]',
  `repel` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '击退距离（单位px，0为不击退）',
  `combo` text NOT NULL COMMENT '连技[{技能id,ms},...]',
  `bullet_spd` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子弹速度（填写在主技能）',
  `bullet_att_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子弹检测时间',
  `count` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '子弹判定次数',
  `time` int(11) NOT NULL COMMENT '技能施放时间,ms',
  `skill_link` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '关联技能##[技能id,技能id...]',
  `rune_skill` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '符文技能 [skill_id]',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `broadcast` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '程序用，动作播放设置#（0客户端直接播放，1等服务端返回播）',
  `lv_data` text NOT NULL COMMENT '等级属性',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_skill_buff_ui 结构
DROP TABLE IF EXISTS `base_skill_buff_ui`;
CREATE TABLE IF NOT EXISTS `base_skill_buff_ui` (
  `skill_id` int(10) unsigned NOT NULL COMMENT '技能id',
  `icon_id` int(10) unsigned NOT NULL COMMENT '图标id',
  `name` varchar(255) NOT NULL COMMENT '名字@lang@',
  `desc` varchar(1000) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能buff图标配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_skill_order 结构
DROP TABLE IF EXISTS `base_skill_order`;
CREATE TABLE IF NOT EXISTS `base_skill_order` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能Id',
  `next_skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一强化技能Id',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能配置-分支强化顺序';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_skill_power 结构
DROP TABLE IF EXISTS `base_skill_power`;
CREATE TABLE IF NOT EXISTS `base_skill_power` (
  `point` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能点数目',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能战力',
  PRIMARY KEY (`point`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能战力数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_skill_scene_setting 结构
DROP TABLE IF EXISTS `base_skill_scene_setting`;
CREATE TABLE IF NOT EXISTS `base_skill_scene_setting` (
  `scene_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景类型',
  `scheme` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '方案',
  PRIMARY KEY (`scene_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能-场景上阵方案';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_skill_talent 结构
DROP TABLE IF EXISTS `base_skill_talent`;
CREATE TABLE IF NOT EXISTS `base_skill_talent` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `sort_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序ID',
  `talent_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '天赋类型',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='天赋技能配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_smashed_egg 结构
DROP TABLE IF EXISTS `base_smashed_egg`;
CREATE TABLE IF NOT EXISTS `base_smashed_egg` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_smashed_egg_free 结构
DROP TABLE IF EXISTS `base_smashed_egg_free`;
CREATE TABLE IF NOT EXISTS `base_smashed_egg_free` (
  `times` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '第几次',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需要在线时间',
  PRIMARY KEY (`times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='免费砸蛋刷新时间';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_smashed_egg_goods 结构
DROP TABLE IF EXISTS `base_smashed_egg_goods`;
CREATE TABLE IF NOT EXISTS `base_smashed_egg_goods` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `min_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限(包含)',
  `max_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限(包含)',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `weights` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `effect` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否有特效',
  `is_tv` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否有传闻',
  `is_rare` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否稀有',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋物品奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_smashed_egg_reward 结构
DROP TABLE IF EXISTS `base_smashed_egg_reward`;
CREATE TABLE IF NOT EXISTS `base_smashed_egg_reward` (
  `min_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限(包含)',
  `max_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限(包含)',
  `times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '累计次数',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  PRIMARY KEY (`min_wlv`,`max_wlv`,`times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋累计次数奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_summon_card 结构
DROP TABLE IF EXISTS `base_summon_card`;
CREATE TABLE IF NOT EXISTS `base_summon_card` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='召唤卡配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_sup_red_packet 结构
DROP TABLE IF EXISTS `base_sup_red_packet`;
CREATE TABLE IF NOT EXISTS `base_sup_red_packet` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励Id',
  `draw_pool` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖池',
  `recharge_gold` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '充值金额',
  `mid_draw` varchar(255) NOT NULL DEFAULT '[]' COMMENT '中档奖励',
  `up_draw` varchar(255) NOT NULL DEFAULT '[]' COMMENT '上档奖励',
  `dream_draw` varchar(255) NOT NULL DEFAULT '[]' COMMENT '上上档奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='惊喜红包-配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_sup_vip_exchange 结构
DROP TABLE IF EXISTS `base_sup_vip_exchange`;
CREATE TABLE IF NOT EXISTS `base_sup_vip_exchange` (
  `goods_id` int(11) NOT NULL COMMENT '道具id',
  `price` varchar(50) NOT NULL DEFAULT '[]' COMMENT '兑换消耗',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族兑换配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_sup_vip_kv 结构
DROP TABLE IF EXISTS `base_sup_vip_kv`;
CREATE TABLE IF NOT EXISTS `base_sup_vip_kv` (
  `key` varchar(50) NOT NULL COMMENT '主键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_sup_vip_store 结构
DROP TABLE IF EXISTS `base_sup_vip_store`;
CREATE TABLE IF NOT EXISTS `base_sup_vip_store` (
  `goods_id` int(11) NOT NULL COMMENT '道具id',
  `type` tinyint(2) NOT NULL DEFAULT '1' COMMENT '道具类型',
  `index` int(11) NOT NULL DEFAULT '0' COMMENT '商店排序',
  `limit_buy` varchar(255) NOT NULL DEFAULT '[]' COMMENT '限购',
  `price` varchar(255) NOT NULL DEFAULT '[]' COMMENT '价格',
  `lv` varchar(255) NOT NULL DEFAULT '[]' COMMENT '等级段',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族商店配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_talk 结构
DROP TABLE IF EXISTS `base_talk`;
CREATE TABLE IF NOT EXISTS `base_talk` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `content` text NOT NULL COMMENT '对话内容@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='对话';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_task 结构
DROP TABLE IF EXISTS `base_task`;
CREATE TABLE IF NOT EXISTS `base_task` (
  `id` int(11) NOT NULL COMMENT '任务id',
  `name` varchar(30) NOT NULL COMMENT '任务名@lang@',
  `desc` text NOT NULL COMMENT '描述@lang@',
  `tips` text NOT NULL COMMENT '任务提示@lang@',
  `type` int(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `chapter` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '主线章节',
  `chapter_bar` int(10) NOT NULL DEFAULT '0' COMMENT '章节进度',
  `kind` int(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务种类',
  `level` int(10) unsigned NOT NULL DEFAULT '1' COMMENT '等级限制',
  `level_max` int(11) NOT NULL COMMENT '最大等级',
  `repeat` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否允许重复做',
  `realm` int(1) NOT NULL DEFAULT '0' COMMENT '阵营',
  `career` tinyint(1) NOT NULL DEFAULT '0' COMMENT '职业限制',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `prev` int(11) NOT NULL DEFAULT '0' COMMENT '上一个必须完成的任务id',
  `next` int(11) NOT NULL DEFAULT '0' COMMENT '下个关联任务id，即这个任务完成后触发任务',
  `start_item` text NOT NULL COMMENT '触发是获得物品',
  `end_item` text NOT NULL COMMENT '完成回收物品',
  `start_npc` text NOT NULL COMMENT '开始npc',
  `end_npc` int(11) NOT NULL DEFAULT '0' COMMENT '结束npc',
  `start_talk` int(11) NOT NULL DEFAULT '0' COMMENT '开始npc对话',
  `end_talk` int(11) NOT NULL DEFAULT '0' COMMENT '结束npc对话',
  `unfinished_talk` int(11) NOT NULL DEFAULT '0' COMMENT '未完成对话',
  `condition` text NOT NULL COMMENT '任务触发条件',
  `content` text NOT NULL COMMENT '任务内容',
  `state` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '任务的终结状态',
  `award_list` text NOT NULL,
  `next_cue` int(11) NOT NULL DEFAULT '0' COMMENT '是否提示下一任务',
  `trigger_pathfind` int(1) NOT NULL COMMENT '是否需要寻路触发',
  `finish_pathfind` int(1) NOT NULL COMMENT '是否需要寻路完成',
  `special_goods_list` text NOT NULL COMMENT '固定物品',
  `npc_show` text NOT NULL COMMENT '默认：[] 提示：[{npcId,是否显示(0,1),场景id,x,y},...]',
  `follow_list` text NOT NULL COMMENT '跟随NPC',
  `need_effect` int(1) NOT NULL DEFAULT '0' COMMENT '是否需要特效',
  `dun_id` int(11) NOT NULL DEFAULT '0' COMMENT '副本id',
  `sep` int(11) NOT NULL DEFAULT '0' COMMENT '同类排序',
  `double_cost` int(11) NOT NULL COMMENT '双倍奖励消耗',
  `bt_text` varchar(50) DEFAULT '' COMMENT '按钮文本',
  `qcost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '快速完成消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='任务数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_task_exp_module 结构
DROP TABLE IF EXISTS `base_task_exp_module`;
CREATE TABLE IF NOT EXISTS `base_task_exp_module` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能序号id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '功能名称',
  `icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源id',
  `jump_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跳转id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_task_exp_module_lv 结构
DROP TABLE IF EXISTS `base_task_exp_module_lv`;
CREATE TABLE IF NOT EXISTS `base_task_exp_module_lv` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能排序id',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最大等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可得经验值',
  PRIMARY KEY (`module_id`,`min_lv`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_task_goods 结构
DROP TABLE IF EXISTS `base_task_goods`;
CREATE TABLE IF NOT EXISTS `base_task_goods` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `trigger_goods` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '触发任务物品',
  `replace_goods` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '替身令完成任务物品',
  `finish_goods` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成任务物品',
  `finish_goods_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '完成任务物品数量',
  PRIMARY KEY (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='触发任务物品';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_task_lv_dynamic_id 结构
DROP TABLE IF EXISTS `base_task_lv_dynamic_id`;
CREATE TABLE IF NOT EXISTS `base_task_lv_dynamic_id` (
  `task_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `slv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始等级',
  `elv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束等级',
  `task_ids` varchar(1000) DEFAULT '[]' COMMENT '任务id,纯随机[id1,id2, ...]',
  PRIMARY KEY (`task_type`,`slv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_task_talk_event 结构
DROP TABLE IF EXISTS `base_task_talk_event`;
CREATE TABLE IF NOT EXISTS `base_task_talk_event` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增',
  `task` int(11) NOT NULL DEFAULT '0' COMMENT '任务ID',
  `delay` int(11) NOT NULL DEFAULT '0' COMMENT '延迟出现',
  `show_time` int(11) NOT NULL DEFAULT '0' COMMENT '持续时间',
  `talker` int(11) NOT NULL DEFAULT '0' COMMENT '资源ID',
  `name` varchar(11) NOT NULL DEFAULT '奥术大师' COMMENT '谈话人',
  `talk` int(11) NOT NULL DEFAULT '0' COMMENT '说话ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_task_type 结构
DROP TABLE IF EXISTS `base_task_type`;
CREATE TABLE IF NOT EXISTS `base_task_type` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '任务类型',
  `count` smallint(3) unsigned NOT NULL DEFAULT '1' COMMENT '任务类系',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块id',
  `counter_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `finish_cost` varchar(300) COLLATE utf8_unicode_ci NOT NULL DEFAULT '[]' COMMENT '任务消耗',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_teamates_exp_scale 结构
DROP TABLE IF EXISTS `base_teamates_exp_scale`;
CREATE TABLE IF NOT EXISTS `base_teamates_exp_scale` (
  `member_count` smallint(5) unsigned NOT NULL COMMENT '队员人数',
  `exp_scale` smallint(5) unsigned NOT NULL COMMENT '经验加成##千分数',
  PRIMARY KEY (`member_count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='队伍经验加成配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_team_ui 结构
DROP TABLE IF EXISTS `base_team_ui`;
CREATE TABLE IF NOT EXISTS `base_team_ui` (
  `activity_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动大类',
  `activity_name` varchar(255) NOT NULL COMMENT '大类名字',
  `subtype_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动小类',
  `subtype_name` varchar(255) NOT NULL COMMENT '子类名字',
  `module_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '模块',
  `sub_module` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '子模块',
  `dun_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对应的场景id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数要求',
  `auto_pos` varchar(1000) NOT NULL COMMENT '自动挂机点',
  `default_lv_min` int(10) unsigned NOT NULL COMMENT '最低等级',
  `default_lv_max` int(10) unsigned NOT NULL COMMENT '最高等级',
  `can_set_lv_limit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '能否设置等级限制',
  `can_set_power_limit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '否设置战力限制',
  `auto_pair` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '是否能自动匹配##1是 0否',
  `exp_scale_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '经验加成类型 0不加成 1同场景加成 2同队伍加成',
  UNIQUE KEY `type` (`activity_id`,`subtype_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='组队大厅配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_fake_man 结构
DROP TABLE IF EXISTS `base_top_pk_fake_man`;
CREATE TABLE IF NOT EXISTS `base_top_pk_fake_man` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `fake_man_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '假人ID',
  `power_range` varchar(128) NOT NULL COMMENT '战力范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技假人配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_grade_detail 结构
DROP TABLE IF EXISTS `base_top_pk_grade_detail`;
CREATE TABLE IF NOT EXISTS `base_top_pk_grade_detail` (
  `grade_num` tinyint(3) unsigned NOT NULL COMMENT '段位##不支持超过32段',
  `star_num` tinyint(3) unsigned NOT NULL COMMENT '星数',
  `win_star` tinyint(3) unsigned NOT NULL COMMENT '胜利增加星数',
  `lose_star` tinyint(3) unsigned NOT NULL COMMENT '失败扣除星数',
  `honor_value` int(10) unsigned NOT NULL COMMENT '本等级荣誉值',
  `rewards` varchar(1000) NOT NULL COMMENT '赛季结算奖励',
  PRIMARY KEY (`grade_num`,`star_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技 段位规则';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_grade_info 结构
DROP TABLE IF EXISTS `base_top_pk_grade_info`;
CREATE TABLE IF NOT EXISTS `base_top_pk_grade_info` (
  `grade_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `name` varchar(128) NOT NULL COMMENT '段位名@lang@',
  `min_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小积分',
  `max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大积分',
  `win_score` int(11) unsigned DEFAULT '0' COMMENT '胜利积分',
  `lose_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '失败积分',
  PRIMARY KEY (`grade_num`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='段位信息配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_grade_reward 结构
DROP TABLE IF EXISTS `base_top_pk_grade_reward`;
CREATE TABLE IF NOT EXISTS `base_top_pk_grade_reward` (
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `grade_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`min_world_lv`,`max_world_lv`,`grade_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='段位奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_keyvalues 结构
DROP TABLE IF EXISTS `base_top_pk_keyvalues`;
CREATE TABLE IF NOT EXISTS `base_top_pk_keyvalues` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '常量Id',
  `value` varchar(512) NOT NULL COMMENT '常量值',
  `about` varchar(512) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_match_reward 结构
DROP TABLE IF EXISTS `base_top_pk_match_reward`;
CREATE TABLE IF NOT EXISTS `base_top_pk_match_reward` (
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `match_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '匹配次数',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`min_world_lv`,`max_world_lv`,`match_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='参与奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_rank_reward 结构
DROP TABLE IF EXISTS `base_top_pk_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_top_pk_rank_reward` (
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`min_world_lv`,`max_world_lv`,`min_rank`,`max_rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排名奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_top_pk_season_rewards 结构
DROP TABLE IF EXISTS `base_top_pk_season_rewards`;
CREATE TABLE IF NOT EXISTS `base_top_pk_season_rewards` (
  `grade_num` tinyint(3) unsigned NOT NULL COMMENT '段位',
  `star` tinyint(3) unsigned NOT NULL COMMENT '星数',
  `rewards` varchar(2000) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`grade_num`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技 赛季奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_tower_dun_daily_reward 结构
DROP TABLE IF EXISTS `base_tower_dun_daily_reward`;
CREATE TABLE IF NOT EXISTS `base_tower_dun_daily_reward` (
  `id` int(11) unsigned NOT NULL COMMENT '副本id',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一副本目标',
  `rewards` varchar(511) NOT NULL DEFAULT '[]' COMMENT '每日奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='爬塔副本每日奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_tower_dun_diffcult 结构
DROP TABLE IF EXISTS `base_tower_dun_diffcult`;
CREATE TABLE IF NOT EXISTS `base_tower_dun_diffcult` (
  `id` int(11) NOT NULL COMMENT '副本id',
  `next_id` int(11) NOT NULL DEFAULT '0' COMMENT '下一困难难度副本目标',
  `need_unlock` int(11) NOT NULL DEFAULT '0' COMMENT '需解锁普通副本',
  `is_broad` int(11) NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `suggest` varchar(500) NOT NULL DEFAULT '' COMMENT '通关建议',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='爬塔困难难度副本配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_transfer 结构
DROP TABLE IF EXISTS `base_transfer`;
CREATE TABLE IF NOT EXISTS `base_transfer` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转职Id',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `need_lev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级要求',
  `open_day` int(11) NOT NULL DEFAULT '0' COMMENT '开服天数',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对应任务Id',
  `skill_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '解锁技能',
  `attr_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '附加属性',
  `equipment_series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '解锁装备代数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转职-转职流程表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_transfer_career 结构
DROP TABLE IF EXISTS `base_transfer_career`;
CREATE TABLE IF NOT EXISTS `base_transfer_career` (
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业Id',
  `transfer_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转职Id',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '名称',
  `image_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业头像',
  `model_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '等级模型',
  PRIMARY KEY (`career`,`transfer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转职-职业转职表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_treasure_evaluation_main 结构
DROP TABLE IF EXISTS `base_treasure_evaluation_main`;
CREATE TABLE IF NOT EXISTS `base_treasure_evaluation_main` (
  `main_reward_id` int(10) unsigned NOT NULL COMMENT '主奖励id',
  `reward_id` int(10) unsigned NOT NULL COMMENT '大奖id',
  `image_str` varchar(255) NOT NULL COMMENT '形象缩写',
  `power` int(10) unsigned NOT NULL COMMENT '显示战力',
  `kind_id` int(10) unsigned NOT NULL COMMENT '形象类型id',
  `image_id` int(10) unsigned NOT NULL COMMENT '形象id',
  `attr_list` varchar(255) NOT NULL COMMENT '属性列表（显示用）',
  `reward_type` tinyint(1) unsigned NOT NULL COMMENT '奖励格式',
  `goods_list` varchar(100) NOT NULL COMMENT '物品列表',
  `weight` int(10) unsigned NOT NULL COMMENT '大奖权重',
  PRIMARY KEY (`main_reward_id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝大奖配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_treasure_evaluation_weight 结构
DROP TABLE IF EXISTS `base_treasure_evaluation_weight`;
CREATE TABLE IF NOT EXISTS `base_treasure_evaluation_weight` (
  `main_reward_id` int(10) unsigned NOT NULL COMMENT '主奖励id',
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `reward_type` tinyint(1) unsigned NOT NULL COMMENT '奖励格式',
  `goods_list` varchar(100) NOT NULL COMMENT '物品列表',
  `weight` int(10) unsigned NOT NULL COMMENT '权重',
  PRIMARY KEY (`main_reward_id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝普通奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_treasure_house_count 结构
DROP TABLE IF EXISTS `base_treasure_house_count`;
CREATE TABLE IF NOT EXISTS `base_treasure_house_count` (
  `period` tinyint(3) unsigned NOT NULL COMMENT '期数',
  `round` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `count` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '保底次数',
  `awards` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`period`,`round`,`count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='珍宝阁次数奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_treasure_house_items 结构
DROP TABLE IF EXISTS `base_treasure_house_items`;
CREATE TABLE IF NOT EXISTS `base_treasure_house_items` (
  `id` int(11) unsigned NOT NULL COMMENT '奖品id',
  `awards` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `is_rare` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '珍稀度（0普通 1珍稀 2大奖）',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `show_index` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '同类型展示排序值（>0展示）',
  `broadcast` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻（0否 1是）',
  `period` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '期数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='珍宝阁奖池配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_treasure_house_kv 结构
DROP TABLE IF EXISTS `base_treasure_house_kv`;
CREATE TABLE IF NOT EXISTS `base_treasure_house_kv` (
  `key` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL COMMENT '键',
  `value` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT 'undefined' COMMENT '值',
  `desc` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' COMMENT '说明文字',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='珍宝阁其他常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_treasure_house_period 结构
DROP TABLE IF EXISTS `base_treasure_house_period`;
CREATE TABLE IF NOT EXISTS `base_treasure_house_period` (
  `period` tinyint(3) unsigned NOT NULL COMMENT '期数',
  `open_day_min` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数下限',
  `open_day_max` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数上限',
  `show` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '前端展示用的资源',
  PRIMARY KEY (`period`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='珍宝阁奖池期数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_treasure_house_task 结构
DROP TABLE IF EXISTS `base_treasure_house_task`;
CREATE TABLE IF NOT EXISTS `base_treasure_house_task` (
  `id` tinyint(3) unsigned NOT NULL COMMENT 'id',
  `index` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排序值',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '类型',
  `daily_max` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '每日可达成次数',
  `details` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '[]' COMMENT '内容',
  `desc` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '' COMMENT '说明文字',
  `link` varchar(255) NOT NULL DEFAULT '' COMMENT '前端使用的链接信息',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='珍宝阁抽奖券任务配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_type_task_dynamic 结构
DROP TABLE IF EXISTS `base_type_task_dynamic`;
CREATE TABLE IF NOT EXISTS `base_type_task_dynamic` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `slv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始等级',
  `elv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束等级',
  `start_npc` int(11) unsigned DEFAULT '0' COMMENT '开始npc',
  `end_npc` int(11) unsigned DEFAULT '0' COMMENT '结束npc',
  `scene` int(11) unsigned DEFAULT '0' COMMENT '场景id',
  `x` int(11) unsigned DEFAULT '0' COMMENT 'X',
  `y` int(11) unsigned DEFAULT '0' COMMENT 'Y',
  `content_type` int(11) unsigned DEFAULT '0' COMMENT '任务内容类型',
  `id` int(11) unsigned DEFAULT '0' COMMENT 'id(MonId|DunId|GoodId)',
  `num` int(11) unsigned DEFAULT '0' COMMENT '完成次数|采集数|收集数',
  `extra_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '环数额外奖励',
  PRIMARY KEY (`task_id`,`slv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_up_combat_power_type 结构
DROP TABLE IF EXISTS `base_up_combat_power_type`;
CREATE TABLE IF NOT EXISTS `base_up_combat_power_type` (
  `type` varchar(255) NOT NULL COMMENT '操作类型',
  `id` smallint(5) unsigned NOT NULL COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战力提升操作类型表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_uranium_grade 结构
DROP TABLE IF EXISTS `base_uranium_grade`;
CREATE TABLE IF NOT EXISTS `base_uranium_grade` (
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶',
  `name` varchar(80) NOT NULL DEFAULT '魂力' COMMENT '阶位名称',
  `skills` varchar(255) NOT NULL DEFAULT '[]' COMMENT '附加技能',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '进阶条件',
  PRIMARY KEY (`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂力阶配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_uranium_lv 结构
DROP TABLE IF EXISTS `base_uranium_lv`;
CREATE TABLE IF NOT EXISTS `base_uranium_lv` (
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `need` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗',
  `total` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '累积',
  `attrs` varchar(255) NOT NULL DEFAULT '[]' COMMENT '附加属性',
  PRIMARY KEY (`grade`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂力等级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_version_upgradebag_reward 结构
DROP TABLE IF EXISTS `base_version_upgradebag_reward`;
CREATE TABLE IF NOT EXISTS `base_version_upgradebag_reward` (
  `version_code` bigint(30) NOT NULL COMMENT '编号',
  `color` varchar(512) NOT NULL COMMENT '公告颜色',
  `content` text NOT NULL COMMENT '公告内容@lang@',
  `name` varchar(256) NOT NULL COMMENT '礼包名称@lang@',
  `rewards` varchar(1024) NOT NULL COMMENT '奖励',
  `starttime` datetime NOT NULL COMMENT '开始时间',
  `endtime` datetime NOT NULL COMMENT '结束时间',
  `state` int(8) NOT NULL COMMENT '状态',
  PRIMARY KEY (`version_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='版本更新信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_vie_rank_req 结构
DROP TABLE IF EXISTS `base_vie_rank_req`;
CREATE TABLE IF NOT EXISTS `base_vie_rank_req` (
  `type_key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `type_value` varchar(50) NOT NULL DEFAULT '' COMMENT '类型值',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  `score` int(11) unsigned DEFAULT '0' COMMENT '积分需求',
  PRIMARY KEY (`type_key`,`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-封榜积分需求';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_vip_cfg 结构
DROP TABLE IF EXISTS `base_vip_cfg`;
CREATE TABLE IF NOT EXISTS `base_vip_cfg` (
  `lv` int(11) NOT NULL COMMENT 'vip等级',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `gold` int(11) NOT NULL DEFAULT '0' COMMENT '累积元宝',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `daily_gold_limit` int(11) NOT NULL DEFAULT '0' COMMENT '每日获得元宝上限',
  `daily_bgold_limit` int(11) NOT NULL DEFAULT '0' COMMENT '每日获得绑元上限',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip等级配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_vip_gift 结构
DROP TABLE IF EXISTS `base_vip_gift`;
CREATE TABLE IF NOT EXISTS `base_vip_gift` (
  `vip_lv` int(11) NOT NULL COMMENT 'vip等级',
  `gift_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '礼包奖励',
  `cur_type` int(11) NOT NULL DEFAULT '1' COMMENT '货币类型',
  `price` int(11) NOT NULL DEFAULT '0' COMMENT '原价',
  `cur_price` int(11) NOT NULL DEFAULT '0' COMMENT '现价',
  `dicount` int(11) NOT NULL DEFAULT '0' COMMENT '折扣',
  PRIMARY KEY (`vip_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip礼包配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_vip_kv 结构
DROP TABLE IF EXISTS `base_vip_kv`;
CREATE TABLE IF NOT EXISTS `base_vip_kv` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '常量id',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '常量值',
  `desc` varchar(255) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_vip_privilege 结构
DROP TABLE IF EXISTS `base_vip_privilege`;
CREATE TABLE IF NOT EXISTS `base_vip_privilege` (
  `lv` int(11) NOT NULL COMMENT 'vip等级',
  `class_id` int(11) NOT NULL COMMENT '功能id',
  `subclass_id` int(11) NOT NULL COMMENT '功能子id',
  `type` int(11) NOT NULL COMMENT '特权类型',
  `describe` varchar(255) NOT NULL COMMENT '特权描述@lang@',
  `value` int(11) NOT NULL COMMENT '特权值',
  `can_try` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以试用',
  PRIMARY KEY (`lv`,`class_id`,`subclass_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip特权配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_visus 结构
DROP TABLE IF EXISTS `base_visus`;
CREATE TABLE IF NOT EXISTS `base_visus` (
  `id` int(11) NOT NULL COMMENT '幻光ID',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '分类',
  `color` int(11) NOT NULL DEFAULT '0' COMMENT '品质',
  `name` varchar(200) NOT NULL DEFAULT '系统' COMMENT '名称',
  `item` varchar(200) NOT NULL DEFAULT '[]' COMMENT '对应道具',
  `condition` varchar(1000) NOT NULL COMMENT '条件',
  `desc` varchar(500) NOT NULL DEFAULT '描述' COMMENT '描述',
  `guide` varchar(1000) NOT NULL COMMENT '跳转',
  `figure` int(11) NOT NULL COMMENT '模型',
  `skill` varchar(500) NOT NULL DEFAULT '{0,0}' COMMENT '技能',
  `sort` int(11) NOT NULL COMMENT '排序',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻光外形';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_visus_lv 结构
DROP TABLE IF EXISTS `base_visus_lv`;
CREATE TABLE IF NOT EXISTS `base_visus_lv` (
  `id` int(11) NOT NULL COMMENT '幻光ID',
  `grade` int(11) NOT NULL COMMENT '强度',
  `lv` int(11) NOT NULL COMMENT '等级',
  `next_grade` int(11) NOT NULL COMMENT '下一阶',
  `next_lv` int(11) NOT NULL COMMENT '下一等级',
  `cost` varchar(1000) NOT NULL COMMENT '花销',
  `ins_attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '新增属性',
  `spe_attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '特殊属性',
  `attrs` varchar(1000) NOT NULL COMMENT '属性',
  `rate` int(5) NOT NULL COMMENT '概率',
  PRIMARY KEY (`id`,`grade`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻光升级表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_void_fam 结构
DROP TABLE IF EXISTS `base_void_fam`;
CREATE TABLE IF NOT EXISTS `base_void_fam` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动常量配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_void_fam_floor 结构
DROP TABLE IF EXISTS `base_void_fam_floor`;
CREATE TABLE IF NOT EXISTS `base_void_fam_floor` (
  `floor` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '层数',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `kf_scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跨服场景',
  `nkill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '到下一层所需击杀数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '本层奖励',
  `drate` int(11) NOT NULL DEFAULT '0' COMMENT '掉层概率',
  PRIMARY KEY (`floor`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽领域层数配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_void_fam_rank 结构
DROP TABLE IF EXISTS `base_void_fam_rank`;
CREATE TABLE IF NOT EXISTS `base_void_fam_rank` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '默认键',
  `drank` int(11) NOT NULL DEFAULT '0' COMMENT '排名下限',
  `urank` int(11) NOT NULL DEFAULT '0' COMMENT '排名上限',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_void_fam_reward 结构
DROP TABLE IF EXISTS `base_void_fam_reward`;
CREATE TABLE IF NOT EXISTS `base_void_fam_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id 登顶排名 1~3:第一~三名 4:幸运奖励',
  `reward_name` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励名称',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽领域登顶奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_void_fam_stage 结构
DROP TABLE IF EXISTS `base_void_fam_stage`;
CREATE TABLE IF NOT EXISTS `base_void_fam_stage` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '默认键',
  `dscore` int(11) NOT NULL DEFAULT '0' COMMENT '积分下限',
  `uscore` int(11) NOT NULL DEFAULT '0' COMMENT '积分上限',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wardrobe_appearance 结构
DROP TABLE IF EXISTS `base_wardrobe_appearance`;
CREATE TABLE IF NOT EXISTS `base_wardrobe_appearance` (
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `level` varchar(255) NOT NULL DEFAULT '[]' COMMENT '品质',
  `appearance_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '风采值',
  `name` varchar(255) NOT NULL COMMENT '名称',
  PRIMARY KEY (`type`,`sub_type`,`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='衣橱-风采值类型配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wardrobe_open 结构
DROP TABLE IF EXISTS `base_wardrobe_open`;
CREATE TABLE IF NOT EXISTS `base_wardrobe_open` (
  `store_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '货柜Id',
  `store_name` varchar(255) NOT NULL DEFAULT '' COMMENT '货柜名称',
  `condition` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁条件',
  `icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图标展示',
  PRIMARY KEY (`store_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='衣橱-货柜开启条件配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wardrobe_stage 结构
DROP TABLE IF EXISTS `base_wardrobe_stage`;
CREATE TABLE IF NOT EXISTS `base_wardrobe_stage` (
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `low_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '风采下限值',
  `high_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '风采上限值',
  `icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图标Id',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='衣橱-风采值阶数配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wardrobe_store 结构
DROP TABLE IF EXISTS `base_wardrobe_store`;
CREATE TABLE IF NOT EXISTS `base_wardrobe_store` (
  `store_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '货柜Id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品Id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次购买数量',
  `money_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '价格类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '价格',
  `discount` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '折扣',
  `limit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '限购类型',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限购数量',
  `tag` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '标签',
  `career` varchar(255) NOT NULL DEFAULT '{0}' COMMENT '职业',
  `is_top` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否主打',
  `pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '界面中展示顺序',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '限购条件',
  PRIMARY KEY (`store_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='衣橱-积分商城配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_war_soul_array 结构
DROP TABLE IF EXISTS `base_war_soul_array`;
CREATE TABLE IF NOT EXISTS `base_war_soul_array` (
  `array_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵型id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '阵型名称',
  `condition` varchar(200) NOT NULL DEFAULT '[]' COMMENT '阵型需求',
  `attr` varchar(200) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  `picture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵型icon',
  `desc` varchar(200) NOT NULL DEFAULT '[]' COMMENT '描述',
  PRIMARY KEY (`array_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂系统-阵型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_war_soul_collect 结构
DROP TABLE IF EXISTS `base_war_soul_collect`;
CREATE TABLE IF NOT EXISTS `base_war_soul_collect` (
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '收集数量',
  `reward` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂系统-图鉴收集';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_war_soul_evolution 结构
DROP TABLE IF EXISTS `base_war_soul_evolution`;
CREATE TABLE IF NOT EXISTS `base_war_soul_evolution` (
  `from_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '原战魂id',
  `to_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标战魂id',
  `base_cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '固定消耗',
  `extra_cost` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '非固定消耗',
  `desc` varchar(200) NOT NULL DEFAULT '[]' COMMENT '描述',
  PRIMARY KEY (`from_goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂系统-战魂进化';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_war_soul_info 结构
DROP TABLE IF EXISTS `base_war_soul_info`;
CREATE TABLE IF NOT EXISTS `base_war_soul_info` (
  `goods_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '道具id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `kind` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '属性',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `attr` varchar(200) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `skill` varchar(200) NOT NULL DEFAULT '[]' COMMENT '技能',
  `strength_limit` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '强化上限',
  `model` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型',
  `effect` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '特效',
  `order` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴编号',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂系统-战魂信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_war_soul_strength 结构
DROP TABLE IF EXISTS `base_war_soul_strength`;
CREATE TABLE IF NOT EXISTS `base_war_soul_strength` (
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `attr` varchar(200) NOT NULL DEFAULT '[]' COMMENT '属性',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  PRIMARY KEY (`color`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂系统-战魂强化';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_war_soul_unlock 结构
DROP TABLE IF EXISTS `base_war_soul_unlock`;
CREATE TABLE IF NOT EXISTS `base_war_soul_unlock` (
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '阵位id',
  `condition` varchar(200) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  PRIMARY KEY (`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂系统-阵位开启';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wasteland_bleed_score 结构
DROP TABLE IF EXISTS `base_wasteland_bleed_score`;
CREATE TABLE IF NOT EXISTS `base_wasteland_bleed_score` (
  `kill_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '连杀数量',
  `kill_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连杀积分',
  `over_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '终结积分',
  PRIMARY KEY (`kill_count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='废土战场-杀人积分配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wasteland_rank_reward 结构
DROP TABLE IF EXISTS `base_wasteland_rank_reward`;
CREATE TABLE IF NOT EXISTS `base_wasteland_rank_reward` (
  `rank_low` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `rank_high` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`rank_low`,`rank_high`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='废土战场-排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wasteland_round_reward 结构
DROP TABLE IF EXISTS `base_wasteland_round_reward`;
CREATE TABLE IF NOT EXISTS `base_wasteland_round_reward` (
  `round` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '轮数',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景Id',
  `cls_scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跨服场景',
  `duration` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续时间',
  `max_crystal` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大结晶数',
  `max_role` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景最大人数',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`round`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='废土战场-轮数奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wasteland_score_reward 结构
DROP TABLE IF EXISTS `base_wasteland_score_reward`;
CREATE TABLE IF NOT EXISTS `base_wasteland_score_reward` (
  `need_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分下限',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`need_score`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='废土战场-积分奖励配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wasteland_select_pos 结构
DROP TABLE IF EXISTS `base_wasteland_select_pos`;
CREATE TABLE IF NOT EXISTS `base_wasteland_select_pos` (
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景Id',
  `pos_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机坐标点',
  PRIMARY KEY (`scene`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='废土战场-托管随机坐标点';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wasteland_war_kv 结构
DROP TABLE IF EXISTS `base_wasteland_war_kv`;
CREATE TABLE IF NOT EXISTS `base_wasteland_war_kv` (
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT '主键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='废土战场-键值配置表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_welfare_kv 结构
DROP TABLE IF EXISTS `base_welfare_kv`;
CREATE TABLE IF NOT EXISTS `base_welfare_kv` (
  `key_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'KEY',
  `value_content` varchar(255) NOT NULL DEFAULT '' COMMENT 'VALUE',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  PRIMARY KEY (`key_content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利大厅-键值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_welfare_level_award 结构
DROP TABLE IF EXISTS `base_welfare_level_award`;
CREATE TABLE IF NOT EXISTS `base_welfare_level_award` (
  `career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `level` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '名称',
  `worth` varchar(255) NOT NULL DEFAULT '[]' COMMENT '价值',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `limit_award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '职业限定奖励',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '全局限定个数',
  PRIMARY KEY (`career`,`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利大厅-冲级奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_welfare_online_award 结构
DROP TABLE IF EXISTS `base_welfare_online_award`;
CREATE TABLE IF NOT EXISTS `base_welfare_online_award` (
  `type` tinyint(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型',
  `id` tinyint(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励序号',
  `duration` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '在线时长',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利大厅-在线奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_welfare_online_words 结构
DROP TABLE IF EXISTS `base_welfare_online_words`;
CREATE TABLE IF NOT EXISTS `base_welfare_online_words` (
  `type` tinyint(11) unsigned NOT NULL DEFAULT '0' COMMENT '对话类型',
  `id` tinyint(11) unsigned NOT NULL DEFAULT '0' COMMENT '对话序号',
  `content` varchar(255) NOT NULL DEFAULT '' COMMENT '内容',
  PRIMARY KEY (`type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利大厅-在线奖励对话';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_welfare_sign_in_award 结构
DROP TABLE IF EXISTS `base_welfare_sign_in_award`;
CREATE TABLE IF NOT EXISTS `base_welfare_sign_in_award` (
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '周期',
  `day` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '第几天',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `vip_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `vip_ratio` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP倍率',
  PRIMARY KEY (`round`,`day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利大厅-签到奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_welfare_sign_in_round 结构
DROP TABLE IF EXISTS `base_welfare_sign_in_round`;
CREATE TABLE IF NOT EXISTS `base_welfare_sign_in_round` (
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '周期',
  `lv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '开放等级',
  `month_award` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '累计签到奖励##{奖励序号,累计天数,奖励}',
  PRIMARY KEY (`round`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利大厅-签到周期';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_wing_info 结构
DROP TABLE IF EXISTS `base_wing_info`;
CREATE TABLE IF NOT EXISTS `base_wing_info` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '外观类型（翅膀；法宝；神兵）',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '默认形象id',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础战力',
  PRIMARY KEY (`figure_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀基础信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_world_boss_info 结构
DROP TABLE IF EXISTS `base_world_boss_info`;
CREATE TABLE IF NOT EXISTS `base_world_boss_info` (
  `boss_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS怪物id',
  `boss_lv` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS等级',
  `boss_name` varchar(50) NOT NULL DEFAULT '' COMMENT 'BOSS名字',
  `boss_scene` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS场景',
  `boss_position` varchar(50) NOT NULL DEFAULT '' COMMENT 'BOSS坐标',
  `award_30_p` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '30%礼包',
  `award_60_p` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '60%礼包',
  `award_kill` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '击杀奖励',
  `award_assists` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '助攻奖励',
  `boss_picture` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS头像',
  `rank_type` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '榜单类型',
  `award_show_ratio` varchar(500) NOT NULL DEFAULT '[]' COMMENT '概率掉落',
  `award_show_base` varchar(500) NOT NULL DEFAULT '[]' COMMENT '参与奖励',
  `score_limit` varchar(50) NOT NULL DEFAULT '[]' COMMENT '积分仙阶限制',
  `score_limit_day` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '积分开服天数',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='世界BOSS信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_world_boss_kill_rank 结构
DROP TABLE IF EXISTS `base_world_boss_kill_rank`;
CREATE TABLE IF NOT EXISTS `base_world_boss_kill_rank` (
  `boss_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS怪物id',
  `rank_high` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '最高排名',
  `rank_low` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '最低排名',
  `award` varchar(100) NOT NULL DEFAULT '' COMMENT '奖励',
  `score` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`boss_id`,`rank_high`,`rank_low`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='世界BOSS击杀排名奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_world_boss_time 结构
DROP TABLE IF EXISTS `base_world_boss_time`;
CREATE TABLE IF NOT EXISTS `base_world_boss_time` (
  `id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动场次',
  `week_day` varchar(255) NOT NULL DEFAULT '' COMMENT '星期##周几开放该活动，正常都是每天都开',
  `time_space` varchar(255) NOT NULL DEFAULT '' COMMENT '时间##[{开始时，分，秒}，{结束时，分，秒}]',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='世界BOSS开放时间';

-- 数据导出被取消选择。

-- 导出  表 yzygame.base_world_boss_week_rank 结构
DROP TABLE IF EXISTS `base_world_boss_week_rank`;
CREATE TABLE IF NOT EXISTS `base_world_boss_week_rank` (
  `rank_type` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '榜单类型',
  `rank_name` varchar(255) NOT NULL DEFAULT '' COMMENT '榜单名称',
  `rank_high` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高排名',
  `rank_low` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最低排名',
  `award` varchar(100) NOT NULL DEFAULT '' COMMENT '奖励',
  PRIMARY KEY (`rank_type`,`rank_high`,`rank_low`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='世界BOSS周榜';

-- 数据导出被取消选择。

-- 导出  表 yzygame.beauty_contest_log 结构
DROP TABLE IF EXISTS `beauty_contest_log`;
CREATE TABLE IF NOT EXISTS `beauty_contest_log` (
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器号',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名称',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `vip` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `sup_vip` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '贵族',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '转职',
  `picture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像',
  `picture_dress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像装扮',
  `contest_data` varchar(255) NOT NULL DEFAULT '' COMMENT '参赛数据',
  `origin_rank` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '初始排名',
  `stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最后阶段',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='靓丽大赛-上期数据(合服保留主服数据)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.beauty_contest_role 结构
DROP TABLE IF EXISTS `beauty_contest_role`;
CREATE TABLE IF NOT EXISTS `beauty_contest_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名称',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `vip` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `sup_vip` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '贵族',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '转职',
  `picture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像',
  `picture_dress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像装扮',
  `contest_data` varchar(255) NOT NULL DEFAULT '' COMMENT '参赛数据',
  `vote` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '票数',
  `pick_counts` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑选次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '投票时间',
  `stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最后阶段',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `origin_rank` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '初始排名',
  `fashion_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '时装数量',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-参赛个人数据(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.beauty_contest_role_local 结构
DROP TABLE IF EXISTS `beauty_contest_role_local`;
CREATE TABLE IF NOT EXISTS `beauty_contest_role_local` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `contest_data` varchar(255) NOT NULL DEFAULT '' COMMENT '参赛数据',
  `vote` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '票数',
  `pick_counts` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑选次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '投票时间',
  `origin_rank` tinyint(8) unsigned NOT NULL DEFAULT '0' COMMENT '初始排名',
  `rank` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最后排名',
  `stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最后阶段',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='靓丽大赛-参赛个人数据本服(合服保留主服数据)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.beauty_contest_sign 结构
DROP TABLE IF EXISTS `beauty_contest_sign`;
CREATE TABLE IF NOT EXISTS `beauty_contest_sign` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `contest_data` varchar(255) NOT NULL DEFAULT '' COMMENT '参赛数据',
  `sign_award` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '报名奖励',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-报名数据(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.boss_first_blood_each 结构
DROP TABLE IF EXISTS `boss_first_blood_each`;
CREATE TABLE IF NOT EXISTS `boss_first_blood_each` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BossId',
  `killers` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '击杀玩家列表##[{role_id, name}]',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '首杀时间时间戳',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss首杀数据(合服保留主服数据，从服清除)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.boss_protect_time 结构
DROP TABLE IF EXISTS `boss_protect_time`;
CREATE TABLE IF NOT EXISTS `boss_protect_time` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `boss_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'boss类型(1-赏金 2-星域幻魔)',
  `protect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '免战时间',
  PRIMARY KEY (`role_id`,`boss_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='boss免战时间';

-- 数据导出被取消选择。

-- 导出  表 yzygame.buff 结构
DROP TABLE IF EXISTS `buff`;
CREATE TABLE IF NOT EXISTS `buff` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'BUFF类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `effect_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT 'BUFF效果',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间戳',
  `scene` varchar(255) NOT NULL DEFAULT '[]' COMMENT '场景限制',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `type` (`type`),
  KEY `goods_id` (`goods_id`),
  KEY `end_time` (`end_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家BUFF状态表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.camp_war_guild_info 结构
DROP TABLE IF EXISTS `camp_war_guild_info`;
CREATE TABLE IF NOT EXISTS `camp_war_guild_info` (
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '社团ID',
  `guild_name` varchar(300) NOT NULL DEFAULT '' COMMENT '社团名称',
  `guild_flag` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团旗帜',
  `guild_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团战力',
  `chief_info` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '社团社长信息',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '百团大战积分',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID',
  `server_num` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务num',
  `zone_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `fac_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '阵营ID',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服团战-百团大战积分信息(合跨服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.camp_war_guild_rank_log 结构
DROP TABLE IF EXISTS `camp_war_guild_rank_log`;
CREATE TABLE IF NOT EXISTS `camp_war_guild_rank_log` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `fac_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营id',
  `svr_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `svr_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `guild_name` varchar(256) NOT NULL DEFAULT '' COMMENT '社团名称',
  `hurt` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '伤害数值',
  `guild_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团战力',
  `chief_info` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '社团社长信息',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服团战阵营社团排名数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.capsule_egg_data 结构
DROP TABLE IF EXISTS `capsule_egg_data`;
CREATE TABLE IF NOT EXISTS `capsule_egg_data` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pool_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖池类型',
  `next_free_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下次免费时间',
  `draw_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖次数',
  `lucky_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人幸运值',
  `top_lucky_score` int(11) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`role_id`,`pool_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-玩家抽奖数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.capsule_egg_draw_log 结构
DROP TABLE IF EXISTS `capsule_egg_draw_log`;
CREATE TABLE IF NOT EXISTS `capsule_egg_draw_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖池类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `reward_cfg_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '奖励配置Id',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '档位',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-抽奖记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.capsule_egg_person_score 结构
DROP TABLE IF EXISTS `capsule_egg_person_score`;
CREATE TABLE IF NOT EXISTS `capsule_egg_person_score` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖总积分',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-个人抽奖积分';

-- 数据导出被取消选择。

-- 导出  表 yzygame.capsule_egg_server_score 结构
DROP TABLE IF EXISTS `capsule_egg_server_score`;
CREATE TABLE IF NOT EXISTS `capsule_egg_server_score` (
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖池类型',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖幸运值(全服积分)',
  `show_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '展示全服幸运值',
  PRIMARY KEY (`pool_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神扭蛋-全服幸运值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.capsule_egg_times_reward 结构
DROP TABLE IF EXISTS `capsule_egg_times_reward`;
CREATE TABLE IF NOT EXISTS `capsule_egg_times_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pool_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `draw_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖次数',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态 1-已领取',
  PRIMARY KEY (`role_id`,`pool_type`,`draw_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='龙神宝库-次数奖励表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.center_reg_svr 结构
DROP TABLE IF EXISTS `center_reg_svr`;
CREATE TABLE IF NOT EXISTS `center_reg_svr` (
  `server_id` smallint(5) unsigned NOT NULL COMMENT '游戏服id',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '游戏服编号',
  `svr_cid` int(11) unsigned NOT NULL COMMENT '全部跨服唯一编号（0为未正式分配）',
  `m_server_ids` varchar(5000) NOT NULL COMMENT '游戏服合服列表',
  `open_time` int(11) unsigned NOT NULL COMMENT '开服时间',
  `time` int(11) unsigned NOT NULL COMMENT '数据更新时间',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服中心已注册游戏服信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.center_rezone_info 结构
DROP TABLE IF EXISTS `center_rezone_info`;
CREATE TABLE IF NOT EXISTS `center_rezone_info` (
  `zone_id` int(11) unsigned NOT NULL COMMENT '游戏服id',
  `zone_id_2` int(11) unsigned NOT NULL COMMENT '游戏服id2',
  `next_stage` tinyint(3) unsigned NOT NULL COMMENT '下一分区阶段',
  `svr_factions` varchar(6000) NOT NULL COMMENT '分区各服阵营信息',
  `scheduled_time` int(11) unsigned NOT NULL COMMENT '计划正式分区时间',
  `confirm` tinyint(3) unsigned NOT NULL COMMENT '分区计划是否已确认过 ',
  PRIMARY KEY (`zone_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服分区-再分区数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.center_svr_base 结构
DROP TABLE IF EXISTS `center_svr_base`;
CREATE TABLE IF NOT EXISTS `center_svr_base` (
  `server_id` smallint(5) unsigned NOT NULL COMMENT '游戏服id',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '游戏服编号',
  `server_name` varchar(100) NOT NULL COMMENT '游戏服名称',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服注册服基本信息表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.center_svr_cid 结构
DROP TABLE IF EXISTS `center_svr_cid`;
CREATE TABLE IF NOT EXISTS `center_svr_cid` (
  `center_id` smallint(5) unsigned NOT NULL COMMENT '跨服中心id',
  `reg_cnt` smallint(5) unsigned NOT NULL COMMENT '当前已注册数量，程序中将此值与center_id按规则生成svr_cid',
  PRIMARY KEY (`center_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全跨服游戏服唯一id维护管理（跨服中心数据表）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.center_zones 结构
DROP TABLE IF EXISTS `center_zones`;
CREATE TABLE IF NOT EXISTS `center_zones` (
  `zone_id` int(11) NOT NULL COMMENT '分区id',
  `stage` tinyint(3) unsigned NOT NULL COMMENT '分区阶段',
  `server_ids` varchar(2000) NOT NULL COMMENT '游戏主服server_id列表',
  `faction_names` varchar(200) NOT NULL DEFAULT '[]' COMMENT '阵营名字列表（空时使用默认名）',
  PRIMARY KEY (`zone_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='标准跨服分区之分区信息表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.center_zone_svr_base 结构
DROP TABLE IF EXISTS `center_zone_svr_base`;
CREATE TABLE IF NOT EXISTS `center_zone_svr_base` (
  `server_id` smallint(5) unsigned NOT NULL COMMENT '主服游戏服server_id',
  `faction` tinyint(3) unsigned NOT NULL COMMENT '阵营',
  `world_level` smallint(5) unsigned NOT NULL COMMENT '世界等级',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='标准跨服分区单服基础信息表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.charge 结构
DROP TABLE IF EXISTS `charge`;
CREATE TABLE IF NOT EXISTS `charge` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` int(4) NOT NULL DEFAULT '0' COMMENT '充值类型',
  `pay_no` varchar(100) DEFAULT NULL COMMENT '订单号',
  `accname` varchar(50) DEFAULT NULL COMMENT '账号',
  `player_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `nickname` varchar(50) DEFAULT NULL COMMENT '昵称',
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '产品id',
  `money` decimal(12,2) DEFAULT '0.00' COMMENT '金额',
  `gold` int(11) NOT NULL DEFAULT '0' COMMENT '元宝',
  `ctime` int(10) NOT NULL COMMENT '订单时间',
  `status` tinyint(1) DEFAULT '0' COMMENT '状态0:未取1：已领取',
  `lv` int(11) DEFAULT '0' COMMENT '等级',
  `sign` varchar(50) DEFAULT NULL COMMENT '平台标志，用于混服区分',
  PRIMARY KEY (`id`),
  UNIQUE KEY `pay_no` (`pay_no`),
  KEY `ctime` (`ctime`),
  KEY `player_id` (`player_id`),
  KEY `type` (`type`),
  KEY `status` (`status`),
  KEY `product_id` (`product_id`),
  KEY `money` (`money`),
  KEY `lv` (`lv`),
  KEY `player_status` (`player_id`,`status`),
  KEY `sign` (`sign`),
  KEY `accname` (`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.chat_simulation 结构
DROP TABLE IF EXISTS `chat_simulation`;
CREATE TABLE IF NOT EXISTS `chat_simulation` (
  `accid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '平台账号id',
  `accname` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT '平台账户',
  `trigger_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上次触发id',
  `trigger_content` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '已触发分类',
  PRIMARY KEY (`accid`,`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='模拟聊天(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_be_voted_log 结构
DROP TABLE IF EXISTS `child_be_voted_log`;
CREATE TABLE IF NOT EXISTS `child_be_voted_log` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `vote_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '点赞者id',
  `vote_name` varchar(255) NOT NULL DEFAULT '' COMMENT '点赞者名字',
  `vote_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '点赞时间戳',
  `feed_back_status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '回赞状态(0-未回赞 1-已回赞)',
  PRIMARY KEY (`role_id`,`vote_id`,`vote_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子点赞记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_daily_task 结构
DROP TABLE IF EXISTS `child_daily_task`;
CREATE TABLE IF NOT EXISTS `child_daily_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `sequence` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '任务序列',
  `task_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '任务Id(列表格式)',
  `progress` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `task_state` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '任务状态(0-未完成 1-已完成未领取 2-已领取)',
  PRIMARY KEY (`role_id`,`sequence`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子每日任务数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_fashion 结构
DROP TABLE IF EXISTS `child_fashion`;
CREATE TABLE IF NOT EXISTS `child_fashion` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `fashion_id` int(11) unsigned NOT NULL COMMENT '时装Id',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '穿戴状态 0-未穿戴 1-已穿戴',
  PRIMARY KEY (`role_id`,`fashion_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-时装数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_reward 结构
DROP TABLE IF EXISTS `child_reward`;
CREATE TABLE IF NOT EXISTS `child_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `share_reward` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '分享奖励领取状态 0-未领取 1-已领取',
  `yest_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨日榜排名',
  `yest_reward` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '昨日榜奖励领取状态 0-未领取 1-已领取',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-每日分享和昨日榜奖励表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_skill 结构
DROP TABLE IF EXISTS `child_skill`;
CREATE TABLE IF NOT EXISTS `child_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能Id',
  `skill_lv` mediumint(6) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  PRIMARY KEY (`role_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-孩子技能数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_toy 结构
DROP TABLE IF EXISTS `child_toy`;
CREATE TABLE IF NOT EXISTS `child_toy` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '套装类型',
  `toy_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具Id',
  PRIMARY KEY (`role_id`,`suit_type`,`toy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子玩具数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_toy_forge 结构
DROP TABLE IF EXISTS `child_toy_forge`;
CREATE TABLE IF NOT EXISTS `child_toy_forge` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `slot_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '打造槽位Id',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始打造时间',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '状态 0-待生产 1-正在生产 2-生产完成',
  `select_id` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '打造库Id',
  PRIMARY KEY (`role_id`,`slot_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-孩子玩具打造位数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_toy_slot 结构
DROP TABLE IF EXISTS `child_toy_slot`;
CREATE TABLE IF NOT EXISTS `child_toy_slot` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `slot_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '槽位Id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品Id',
  PRIMARY KEY (`role_id`,`slot_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-玩具槽位表数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_toy_suit 结构
DROP TABLE IF EXISTS `child_toy_suit`;
CREATE TABLE IF NOT EXISTS `child_toy_suit` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具套装类型',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  `collect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '集齐时间',
  PRIMARY KEY (`role_id`,`suit_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子玩具套装数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_vehicle 结构
DROP TABLE IF EXISTS `child_vehicle`;
CREATE TABLE IF NOT EXISTS `child_vehicle` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `vehicle_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '载具Id',
  `stage` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '阶级',
  PRIMARY KEY (`role_id`,`vehicle_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子-载具数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.child_vote_rank 结构
DROP TABLE IF EXISTS `child_vote_rank`;
CREATE TABLE IF NOT EXISTS `child_vote_rank` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `child_name` varchar(255) NOT NULL DEFAULT '' COMMENT '孩子名称',
  `be_voted_count` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '点赞次数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子点赞排行榜数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.client_event_data 结构
DROP TABLE IF EXISTS `client_event_data`;
CREATE TABLE IF NOT EXISTS `client_event_data` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `event_id` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '事件id##由前端自定义，一般是从1递增',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '事件状态',
  PRIMARY KEY (`role_id`,`event_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='前端终身事件列表(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cloud_buy_kf 结构
DROP TABLE IF EXISTS `cloud_buy_kf`;
CREATE TABLE IF NOT EXISTS `cloud_buy_kf` (
  `order_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '订单id',
  `big_award_id` smallint(5) unsigned NOT NULL COMMENT '大奖id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `platform` varchar(50) NOT NULL COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器编号',
  `count` smallint(5) unsigned NOT NULL COMMENT '数量',
  `state` tinyint(3) unsigned NOT NULL COMMENT '状态 0未付款 1付款 2中奖 3未中',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  `subtype` int(10) unsigned NOT NULL COMMENT '定制活动子类型',
  PRIMARY KEY (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购跨服表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.clusters 结构
DROP TABLE IF EXISTS `clusters`;
CREATE TABLE IF NOT EXISTS `clusters` (
  `server_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `node` varchar(100) NOT NULL DEFAULT '' COMMENT '节点',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服列表（合服清理）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.comeback 结构
DROP TABLE IF EXISTS `comeback`;
CREATE TABLE IF NOT EXISTS `comeback` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account` varchar(64) NOT NULL COMMENT '账号',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '渠道来源',
  `state` tinyint(3) NOT NULL COMMENT '状态(0未返/1已返)',
  `data` text NOT NULL COMMENT '历史数据',
  `old_role` text COMMENT '旧号信息',
  `now_role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '已返利的角色id',
  PRIMARY KEY (`id`),
  KEY `account` (`account`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='封测玩家回归数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.common_rank_first_top 结构
DROP TABLE IF EXISTS `common_rank_first_top`;
CREATE TABLE IF NOT EXISTS `common_rank_first_top` (
  `rank_type` int(11) unsigned NOT NULL COMMENT '排行类型',
  `target` bigint(20) unsigned NOT NULL COMMENT '目标',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`rank_type`,`target`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜首度目标达成数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.common_rank_guild 结构
DROP TABLE IF EXISTS `common_rank_guild`;
CREATE TABLE IF NOT EXISTS `common_rank_guild` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会ID',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行类型',
  `guild_name` varchar(1024) NOT NULL DEFAULT '' COMMENT '工会名字',
  `flag` int(11) DEFAULT '0' COMMENT '旗帜',
  `chairman_id` bigint(20) NOT NULL DEFAULT '0',
  `chairman_name` varchar(1024) NOT NULL DEFAULT '',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '工会等级',
  `members_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成员数量',
  `value` bigint(20) DEFAULT NULL,
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `third_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`guild_id`,`rank_type`),
  KEY `lv` (`lv`),
  KEY `chairman_id` (`chairman_id`),
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜';

-- 数据导出被取消选择。

-- 导出  表 yzygame.common_rank_praise 结构
DROP TABLE IF EXISTS `common_rank_praise`;
CREATE TABLE IF NOT EXISTS `common_rank_praise` (
  `type` int(11) unsigned NOT NULL COMMENT '点赞类型',
  `id` bigint(20) unsigned NOT NULL COMMENT '点赞id',
  `praise_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '点赞数目',
  PRIMARY KEY (`type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜点赞数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.common_rank_role 结构
DROP TABLE IF EXISTS `common_rank_role`;
CREATE TABLE IF NOT EXISTS `common_rank_role` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `value` bigint(20) DEFAULT NULL,
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `third_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `extra_value` varchar(512) NOT NULL DEFAULT '[]' COMMENT '额外值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `off_time` int(11) NOT NULL DEFAULT '0' COMMENT '离线时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`),
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜';

-- 数据导出被取消选择。

-- 导出  表 yzygame.config_word 结构
DROP TABLE IF EXISTS `config_word`;
CREATE TABLE IF NOT EXISTS `config_word` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `word` varchar(500) NOT NULL COMMENT '过滤词',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='过滤词配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.consume_rank_act 结构
DROP TABLE IF EXISTS `consume_rank_act`;
CREATE TABLE IF NOT EXISTS `consume_rank_act` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `is_public` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否公开金额',
  `award_state` varchar(50) NOT NULL DEFAULT '[]' COMMENT '奖励领取状态',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `third_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`rank_type`,`sub_type`,`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值消费榜';

-- 数据导出被取消选择。

-- 导出  表 yzygame.counter 结构
DROP TABLE IF EXISTS `counter`;
CREATE TABLE IF NOT EXISTS `counter` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='终生次数记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.counter_daily_four 结构
DROP TABLE IF EXISTS `counter_daily_four`;
CREATE TABLE IF NOT EXISTS `counter_daily_four` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数记录(凌晨4点)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.counter_daily_twelve 结构
DROP TABLE IF EXISTS `counter_daily_twelve`;
CREATE TABLE IF NOT EXISTS `counter_daily_twelve` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数记录(凌晨12点)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.counter_global 结构
DROP TABLE IF EXISTS `counter_global`;
CREATE TABLE IF NOT EXISTS `counter_global` (
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) unsigned NOT NULL COMMENT '刷新时间',
  `first_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '第一次记录时间',
  PRIMARY KEY (`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全服次数记录器';

-- 数据导出被取消选择。

-- 导出  表 yzygame.counter_week 结构
DROP TABLE IF EXISTS `counter_week`;
CREATE TABLE IF NOT EXISTS `counter_week` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每周次数记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.counter_week_four 结构
DROP TABLE IF EXISTS `counter_week_four`;
CREATE TABLE IF NOT EXISTS `counter_week_four` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='4点周计数器';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_guild_war_city_info 结构
DROP TABLE IF EXISTS `cross_guild_war_city_info`;
CREATE TABLE IF NOT EXISTS `cross_guild_war_city_info` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `city_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '城池Id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服ServerId',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服编号(玩家看到的服数)',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派Id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '帮派名称',
  `guild_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮派战力',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮主Id',
  `chief_name` varchar(50) NOT NULL DEFAULT '' COMMENT '帮主名称',
  `chief_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮主战力',
  PRIMARY KEY (`zone_id`,`city_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战-城池占领信息(在跨服中使用-保留主跨服的)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_guild_war_guild_help_info 结构
DROP TABLE IF EXISTS `cross_guild_war_guild_help_info`;
CREATE TABLE IF NOT EXISTS `cross_guild_war_guild_help_info` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派Id(阵营)',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服ServerId',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `help_ups` varchar(6000) NOT NULL DEFAULT '[]' COMMENT '报名列表',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战-外援(报名)帮派信息(在跨服中使用-保留主跨服的)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_guild_war_guild_info 结构
DROP TABLE IF EXISTS `cross_guild_war_guild_info`;
CREATE TABLE IF NOT EXISTS `cross_guild_war_guild_info` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派Id',
  `node_name` varchar(100) NOT NULL DEFAULT '' COMMENT '所在节点',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服ServerId',
  `server_num` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '服务器编号(玩家可见的服编号)',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `guild_name` varchar(100) NOT NULL DEFAULT '' COMMENT '帮派名称',
  `guild_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派战力',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮主Id',
  `chief_name` varchar(50) NOT NULL DEFAULT '' COMMENT '帮主名称',
  `chief_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮主战力',
  `sign_ups` varchar(6000) NOT NULL DEFAULT '[]' COMMENT '报名列表',
  `help_ups` varchar(6000) NOT NULL DEFAULT '[]' COMMENT '外援列表',
  `supports` text NOT NULL COMMENT '支援列表',
  `support_num` int(11) NOT NULL DEFAULT '0' COMMENT '支援人数',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战-参战(报名)帮派信息(在跨服中使用-保留主跨服的)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_guild_war_last_zone 结构
DROP TABLE IF EXISTS `cross_guild_war_last_zone`;
CREATE TABLE IF NOT EXISTS `cross_guild_war_last_zone` (
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服ServerId',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `fact_id` int(11) NOT NULL DEFAULT '0' COMMENT '阵营ID',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战-上一次分区信息(在跨服中使用-保留主跨服的)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_guild_war_role 结构
DROP TABLE IF EXISTS `cross_guild_war_role`;
CREATE TABLE IF NOT EXISTS `cross_guild_war_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `support_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '应援次数',
  `use_free_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已使用免费应援次数',
  `support_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次应援时间戳',
  `city_award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '领取占领城池奖励记录[CityId]',
  `award_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次领取占领城池奖励时间戳',
  `last_sign` int(11) NOT NULL DEFAULT '0' COMMENT '上次报名时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服帮战-角色相关数据(保存在游戏服-合服时保留合并数据)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_point_fight_log 结构
DROP TABLE IF EXISTS `cross_point_fight_log`;
CREATE TABLE IF NOT EXISTS `cross_point_fight_log` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `point_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `hurt_part` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伤害占比',
  PRIMARY KEY (`zone_id`,`point_id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='沙盘争夺战-据点攻打记录(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_point_fight_point 结构
DROP TABLE IF EXISTS `cross_point_fight_point`;
CREATE TABLE IF NOT EXISTS `cross_point_fight_point` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `point_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
  `faction` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '攻占国家id',
  `seize_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻占时间',
  `add_up_time` varchar(255) NOT NULL DEFAULT '[]' COMMENT '其他国家在该据点累计占领时间##[{faction,time}]',
  `seize_info` varchar(255) NOT NULL DEFAULT '[]' COMMENT '据点攻占统计##[{faction,score}]',
  PRIMARY KEY (`zone_id`,`point_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='沙盘争夺战-城市信息(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_point_fight_zone 结构
DROP TABLE IF EXISTS `cross_point_fight_zone`;
CREATE TABLE IF NOT EXISTS `cross_point_fight_zone` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `season_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季##不做功能使用',
  `season_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季开始时间',
  `point_mass` varchar(255) NOT NULL DEFAULT '[]' COMMENT '据点集结信息',
  `point_buff` varchar(255) NOT NULL DEFAULT '[]' COMMENT '据点BUFF信息',
  `buff_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BUFF结束时间',
  PRIMARY KEY (`zone_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='沙盘争夺战-分区信息(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.cross_point_role_data 结构
DROP TABLE IF EXISTS `cross_point_role_data`;
CREATE TABLE IF NOT EXISTS `cross_point_role_data` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名字',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `faction` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '国家id',
  PRIMARY KEY (`zone_id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='沙盘争夺战-玩家信息(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_data 结构
DROP TABLE IF EXISTS `custom_act_data`;
CREATE TABLE IF NOT EXISTS `custom_act_data` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定制活动主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定制活动次类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动数据最后更新时间',
  `act_data` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '定制活动统计数据',
  `red_gift` varchar(500) NOT NULL DEFAULT '[]' COMMENT '红点礼包',
  PRIMARY KEY (`rid`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-活动统计数据，合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_growth_score 结构
DROP TABLE IF EXISTS `custom_act_growth_score`;
CREATE TABLE IF NOT EXISTS `custom_act_growth_score` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-成长积分（合服直接清理）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_growth_score_reward 结构
DROP TABLE IF EXISTS `custom_act_growth_score_reward`;
CREATE TABLE IF NOT EXISTS `custom_act_growth_score_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `reward_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '已领取的奖励档次',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-成长积分奖励领取情况（合服直接清理）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_investment 结构
DROP TABLE IF EXISTS `custom_act_investment`;
CREATE TABLE IF NOT EXISTS `custom_act_investment` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `subtype` smallint(5) unsigned NOT NULL COMMENT '活动子类型',
  `gear` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '投资档位',
  `invest_time` int(10) unsigned NOT NULL COMMENT '投资时间',
  PRIMARY KEY (`role_id`,`subtype`,`gear`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='运营活动投资（合服合并）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_journey 结构
DROP TABLE IF EXISTS `custom_act_journey`;
CREATE TABLE IF NOT EXISTS `custom_act_journey` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动ID',
  `map` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '地图',
  `tasks` varchar(600) NOT NULL DEFAULT '[]' COMMENT '任务',
  PRIMARY KEY (`rid`,`act`,`map`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='征途-合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_joy_wish_times 结构
DROP TABLE IF EXISTS `custom_act_joy_wish_times`;
CREATE TABLE IF NOT EXISTS `custom_act_joy_wish_times` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `times` int(11) NOT NULL DEFAULT '0' COMMENT '许愿次数',
  PRIMARY KEY (`role_id`,`act_type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动许愿次数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_opening 结构
DROP TABLE IF EXISTS `custom_act_opening`;
CREATE TABLE IF NOT EXISTS `custom_act_opening` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时的世界等级',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开启中的定制活动数据(合服清空)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_personal 结构
DROP TABLE IF EXISTS `custom_act_personal`;
CREATE TABLE IF NOT EXISTS `custom_act_personal` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定制活动主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定制活动次类型',
  `s_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `e_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动数据最后更新时间',
  `act_data` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '定制活动统计数据##具体活动类型自定义',
  `red_gift` varchar(100) NOT NULL DEFAULT '[]' COMMENT '红点礼包',
  PRIMARY KEY (`role_id`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-角色差异化活动，合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_personal_data 结构
DROP TABLE IF EXISTS `custom_act_personal_data`;
CREATE TABLE IF NOT EXISTS `custom_act_personal_data` (
  `rid` bigint(20) NOT NULL COMMENT '玩家id',
  `data` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '个人差异化活动额外数据',
  PRIMARY KEY (`rid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_receive_reward 结构
DROP TABLE IF EXISTS `custom_act_receive_reward`;
CREATE TABLE IF NOT EXISTS `custom_act_receive_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `receive_times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领取次数',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`type`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动通用奖励领取数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_turntable_record 结构
DROP TABLE IF EXISTS `custom_act_turntable_record`;
CREATE TABLE IF NOT EXISTS `custom_act_turntable_record` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `act_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL COMMENT '玩家名',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获得的奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动转盘记录（合服直接合并）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_turntable_times 结构
DROP TABLE IF EXISTS `custom_act_turntable_times`;
CREATE TABLE IF NOT EXISTS `custom_act_turntable_times` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `times` int(11) NOT NULL DEFAULT '0' COMMENT '参与次数',
  PRIMARY KEY (`role_id`,`act_type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动转盘使用次数（合服直接合并）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.custom_act_vip_bag_onsale 结构
DROP TABLE IF EXISTS `custom_act_vip_bag_onsale`;
CREATE TABLE IF NOT EXISTS `custom_act_vip_bag_onsale` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `sub_type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '礼包档次',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '特惠价格',
  `percent` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '百分比',
  PRIMARY KEY (`role_id`,`act_type`,`sub_type`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='VIP特惠记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.daily_consume_log 结构
DROP TABLE IF EXISTS `daily_consume_log`;
CREATE TABLE IF NOT EXISTS `daily_consume_log` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `zero_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '0点时间戳',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '元宝数',
  `bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '绑元数',
  `coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜币数',
  PRIMARY KEY (`role_id`,`zero_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日消费日志(合服合并保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.dance 结构
DROP TABLE IF EXISTS `dance`;
CREATE TABLE IF NOT EXISTS `dance` (
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `is_rand` tinyint(2) NOT NULL COMMENT '是否随机舞蹈',
  `dance_id` int(11) NOT NULL COMMENT '选中的舞蹈动作id',
  `dance_list` varchar(511) NOT NULL DEFAULT '[]' COMMENT '已激活的舞蹈id',
  PRIMARY KEY (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='舞姿';

-- 数据导出被取消选择。

-- 导出  表 yzygame.deserted_boss_status 结构
DROP TABLE IF EXISTS `deserted_boss_status`;
CREATE TABLE IF NOT EXISTS `deserted_boss_status` (
  `zone_id` bigint(20) unsigned NOT NULL COMMENT '分区id',
  `fac_id` int(11) unsigned NOT NULL COMMENT '阵营id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物id',
  `dead_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '死亡时间',
  `killer` varchar(255) NOT NULL DEFAULT '0' COMMENT '击杀者',
  `srv_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀者服务器编号',
  PRIMARY KEY (`zone_id`,`fac_id`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='混乱星域boss状态';

-- 数据导出被取消选择。

-- 导出  表 yzygame.designation 结构
DROP TABLE IF EXISTS `designation`;
CREATE TABLE IF NOT EXISTS `designation` (
  `player_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '称号id',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '称号状态 0未佩戴 1佩戴',
  `active_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '激活时间',
  `endtime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT ' 操作时间',
  `dress_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '����ʱ��',
  `is_replace` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '0������ 1δ������',
  PRIMARY KEY (`player_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家称号表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.draw_record_act_local 结构
DROP TABLE IF EXISTS `draw_record_act_local`;
CREATE TABLE IF NOT EXISTS `draw_record_act_local` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服抽奖记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.draw_record_kf_act 结构
DROP TABLE IF EXISTS `draw_record_kf_act`;
CREATE TABLE IF NOT EXISTS `draw_record_kf_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(128) NOT NULL DEFAULT '' COMMENT '平台名字',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在的服标示',
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服抽奖记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.draw_record_kf_act_local 结构
DROP TABLE IF EXISTS `draw_record_kf_act_local`;
CREATE TABLE IF NOT EXISTS `draw_record_kf_act_local` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服抽奖记录本服';

-- 数据导出被取消选择。

-- 导出  表 yzygame.dress_up_enabled 结构
DROP TABLE IF EXISTS `dress_up_enabled`;
CREATE TABLE IF NOT EXISTS `dress_up_enabled` (
  `player_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '用户id',
  `dress_id` int(11) NOT NULL DEFAULT '0' COMMENT '饰品id',
  `dress_type` smallint(2) NOT NULL DEFAULT '0' COMMENT '饰品类型id',
  `is_used` int(2) NOT NULL DEFAULT '0' COMMENT '是否正在使用 0-未使用 1-正使用',
  `time` int(10) NOT NULL DEFAULT '0' COMMENT '激活时间',
  PRIMARY KEY (`player_id`,`dress_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家激活的装扮';

-- 数据导出被取消选择。

-- 导出  表 yzygame.drumwar_rank 结构
DROP TABLE IF EXISTS `drumwar_rank`;
CREATE TABLE IF NOT EXISTS `drumwar_rank` (
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `gname` varchar(50) NOT NULL DEFAULT '' COMMENT '帮派名称',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(50) NOT NULL DEFAULT '' COMMENT '平台',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家VIP',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战力',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  PRIMARY KEY (`drumid`,`zone`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛榜单';

-- 数据导出被取消选择。

-- 导出  表 yzygame.drumwar_result 结构
DROP TABLE IF EXISTS `drumwar_result`;
CREATE TABLE IF NOT EXISTS `drumwar_result` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `group` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分组',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `picturev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家上传的头像版本号',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `pow` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛对战数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.drumwar_sign 结构
DROP TABLE IF EXISTS `drumwar_sign`;
CREATE TABLE IF NOT EXISTS `drumwar_sign` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '届id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `picturev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像版号',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生等级',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛报名数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.dungeon_best_record 结构
DROP TABLE IF EXISTS `dungeon_best_record`;
CREATE TABLE IF NOT EXISTS `dungeon_best_record` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `data` varchar(1000) NOT NULL COMMENT '数据',
  PRIMARY KEY (`player_id`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本最佳记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.dungeon_data 结构
DROP TABLE IF EXISTS `dungeon_data`;
CREATE TABLE IF NOT EXISTS `dungeon_data` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `data` text NOT NULL COMMENT '副本数据',
  PRIMARY KEY (`role_id`,`dun_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本相关信息记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.dun_guard_log 结构
DROP TABLE IF EXISTS `dun_guard_log`;
CREATE TABLE IF NOT EXISTS `dun_guard_log` (
  `dun_id` int(11) unsigned NOT NULL COMMENT '副本id',
  `wave` int(11) unsigned NOT NULL COMMENT '波数进度',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物ID',
  `team_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '队伍ID',
  `role_data` varchar(3000) NOT NULL COMMENT '人物信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`dun_id`,`wave`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标波数首通历史数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.dun_pet_rank 结构
DROP TABLE IF EXISTS `dun_pet_rank`;
CREATE TABLE IF NOT EXISTS `dun_pet_rank` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `dun_wave` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '通关副本波数',
  `reach_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '达成时间',
  `old_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨日积分',
  `old_dun_wave` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨日通关副本波数',
  `old_reach_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨日积分达成时间',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '日奖励领取状态',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.elite_assess_category_reward 结构
DROP TABLE IF EXISTS `elite_assess_category_reward`;
CREATE TABLE IF NOT EXISTS `elite_assess_category_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `category` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态 0: 未达成 1: 已达成 2: 已领取',
  PRIMARY KEY (`role_id`,`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='精英考核-章节奖励数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.elite_assess_login_days 结构
DROP TABLE IF EXISTS `elite_assess_login_days`;
CREATE TABLE IF NOT EXISTS `elite_assess_login_days` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `login_day` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '累计登录天数',
  `last_refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次刷新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='精英考核-累计登录天数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.elite_assess_task 结构
DROP TABLE IF EXISTS `elite_assess_task`;
CREATE TABLE IF NOT EXISTS `elite_assess_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `progress` int(2) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态 0: 未达成 1: 已达成 2: 已领取',
  PRIMARY KEY (`role_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='精英考核-任务数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.equipment 结构
DROP TABLE IF EXISTS `equipment`;
CREATE TABLE IF NOT EXISTS `equipment` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `stars` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '当前激活的星级数',
  `stars_info` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '节点选择',
  `series` tinyint(8) NOT NULL DEFAULT '0' COMMENT '当前解锁的代数',
  `follow_guard` int(11) NOT NULL DEFAULT '0' COMMENT '跟随的守护(物品id)',
  `gems_suit` varchar(255) NOT NULL DEFAULT '[]' COMMENT '宝石套装##[{series,lv}]',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-通用信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.equipment_collect 结构
DROP TABLE IF EXISTS `equipment_collect`;
CREATE TABLE IF NOT EXISTS `equipment_collect` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `active` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '激活进度',
  `collect` varchar(200) NOT NULL DEFAULT '[]' COMMENT '收集的装备',
  PRIMARY KEY (`role_id`,`series`,`color`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备收集##合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.equipment_series 结构
DROP TABLE IF EXISTS `equipment_series`;
CREATE TABLE IF NOT EXISTS `equipment_series` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '套数',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `gems` varchar(500) NOT NULL DEFAULT '[]' COMMENT '镶嵌的宝石',
  `empower_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '器灵等级',
  `sp_lv` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '成长属性等级',
  `sp_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成长属性经验',
  PRIMARY KEY (`role_id`,`series`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备-套数位置装备信息##合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.ets_switch 结构
DROP TABLE IF EXISTS `ets_switch`;
CREATE TABLE IF NOT EXISTS `ets_switch` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '唯一标志',
  `is_open` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '开关 0关;1开',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开关';

-- 数据导出被取消选择。

-- 导出  表 yzygame.extra_custom_act 结构
DROP TABLE IF EXISTS `extra_custom_act`;
CREATE TABLE IF NOT EXISTS `extra_custom_act` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `act_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '活动描述@lang@',
  `opday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服天数限制',
  `merday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服天数限制',
  `optype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '开启类型',
  `opday` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `optime` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启时间段',
  `start_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `clear_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理类型',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='额外定制活动';

-- 数据导出被取消选择。

-- 导出  表 yzygame.extra_custom_act_reward 结构
DROP TABLE IF EXISTS `extra_custom_act_reward`;
CREATE TABLE IF NOT EXISTS `extra_custom_act_reward` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励名称@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励描述@lang@',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `format` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励格式类型',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`type`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='额外定制活动奖励配置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.extra_custom_act_switch 结构
DROP TABLE IF EXISTS `extra_custom_act_switch`;
CREATE TABLE IF NOT EXISTS `extra_custom_act_switch` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `is_open` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定制活动开关',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动开关';

-- 数据导出被取消选择。

-- 导出  表 yzygame.extra_custom_act_type 结构
DROP TABLE IF EXISTS `extra_custom_act_type`;
CREATE TABLE IF NOT EXISTS `extra_custom_act_type` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='额外定制活动类型';

-- 数据导出被取消选择。

-- 导出  表 yzygame.fashion_info 结构
DROP TABLE IF EXISTS `fashion_info`;
CREATE TABLE IF NOT EXISTS `fashion_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pos_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `fashion_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时装id',
  `color_id` int(10) unsigned NOT NULL COMMENT '当前颜色',
  `color_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '时装颜色列表',
  PRIMARY KEY (`role_id`,`pos_id`,`fashion_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装信息记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.fashion_pos 结构
DROP TABLE IF EXISTS `fashion_pos`;
CREATE TABLE IF NOT EXISTS `fashion_pos` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `pos_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `wear_fashion_id` int(10) unsigned NOT NULL COMMENT '穿着时装id',
  `wear_color_id` int(10) unsigned NOT NULL COMMENT '穿着颜色',
  PRIMARY KEY (`role_id`,`pos_id`),
  KEY `player_id` (`pos_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装部位数据记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.feedback 结构
DROP TABLE IF EXISTS `feedback`;
CREATE TABLE IF NOT EXISTS `feedback` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `state` tinyint(1) unsigned DEFAULT '0' COMMENT '状态(已回复1/未回复0)',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `player_name` varchar(100) NOT NULL DEFAULT '' COMMENT '玩家名',
  `content` mediumtext NOT NULL COMMENT '内容',
  `timestamp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Unix时间戳',
  `ip` varchar(100) NOT NULL DEFAULT '' COMMENT '玩家IP',
  `server` varchar(100) NOT NULL DEFAULT '' COMMENT '服务器',
  `gm` varchar(100) DEFAULT NULL COMMENT '游戏管理员',
  `reply` text COMMENT '回复内容',
  `reply_time` int(11) unsigned DEFAULT '0' COMMENT '回复时间',
  PRIMARY KEY (`id`),
  KEY `state` (`state`),
  KEY `timestamp` (`timestamp`),
  KEY `player_name` (`player_name`) USING BTREE,
  KEY `player_id` (`player_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家反馈';

-- 数据导出被取消选择。

-- 导出  表 yzygame.fireworks_act 结构
DROP TABLE IF EXISTS `fireworks_act`;
CREATE TABLE IF NOT EXISTS `fireworks_act` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '烟花使用次数',
  `wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时世界等级',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花使用信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.fireworks_reward_info 结构
DROP TABLE IF EXISTS `fireworks_reward_info`;
CREATE TABLE IF NOT EXISTS `fireworks_reward_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励对应id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得次数',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量上限',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花奖励信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.fish_illustrated 结构
DROP TABLE IF EXISTS `fish_illustrated`;
CREATE TABLE IF NOT EXISTS `fish_illustrated` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `illustrate_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴等级',
  PRIMARY KEY (`role_id`,`illustrate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.flower 结构
DROP TABLE IF EXISTS `flower`;
CREATE TABLE IF NOT EXISTS `flower` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `flower_num` int(11) unsigned NOT NULL COMMENT '鲜花数量',
  `charm` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魅力值',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名誉',
  `week_charm` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周人气值',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周人气更新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鲜花';

-- 数据导出被取消选择。

-- 导出  表 yzygame.flower_gift_record 结构
DROP TABLE IF EXISTS `flower_gift_record`;
CREATE TABLE IF NOT EXISTS `flower_gift_record` (
  `id` bigint(20) unsigned NOT NULL,
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `other_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '送礼玩家id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `anonymous` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0: 不匿名 1:匿名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `code` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '1:送礼 2:收礼',
  `thank` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否感谢0未感谢|1已感谢',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鲜花送礼记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.galaxy_dun_chapter 结构
DROP TABLE IF EXISTS `galaxy_dun_chapter`;
CREATE TABLE IF NOT EXISTS `galaxy_dun_chapter` (
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `chapter_id` smallint(5) NOT NULL COMMENT '玩家所处章节',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰副本-玩家所在章节';

-- 数据导出被取消选择。

-- 导出  表 yzygame.galaxy_dun_chapter_reward 结构
DROP TABLE IF EXISTS `galaxy_dun_chapter_reward`;
CREATE TABLE IF NOT EXISTS `galaxy_dun_chapter_reward` (
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '人物id',
  `chapter_id` smallint(5) NOT NULL DEFAULT '0' COMMENT '章节id',
  `star_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '已领取的星数奖励列表',
  PRIMARY KEY (`role_id`,`chapter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰副本-章节奖励领取状态';

-- 数据导出被取消选择。

-- 导出  表 yzygame.gift_list 结构
DROP TABLE IF EXISTS `gift_list`;
CREATE TABLE IF NOT EXISTS `gift_list` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `gift_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `give_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '发送时间',
  `get_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取次数',
  `get_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时间',
  `offline_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下线时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态，0为未领取，1为已领取',
  UNIQUE KEY `player_id` (`player_id`,`gift_id`),
  KEY `status` (`status`),
  KEY `gift_id` (`gift_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包领取表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.god_dun_score 结构
DROP TABLE IF EXISTS `god_dun_score`;
CREATE TABLE IF NOT EXISTS `god_dun_score` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服编号',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总积分',
  `role_show` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '人物外观',
  `pass` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否通关',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本总积分信息(跨服使用)-合跨服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.god_dun_wave_score 结构
DROP TABLE IF EXISTS `god_dun_wave_score`;
CREATE TABLE IF NOT EXISTS `god_dun_wave_score` (
  `dun_id` int(11) unsigned NOT NULL COMMENT '副本id',
  `wave` int(11) unsigned NOT NULL COMMENT '波数',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服编号',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数积分',
  `role_show` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '人物外观',
  PRIMARY KEY (`dun_id`,`wave`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本波数积分信息(跨服使用)-合跨服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.god_lottery_role 结构
DROP TABLE IF EXISTS `god_lottery_role`;
CREATE TABLE IF NOT EXISTS `god_lottery_role` (
  `role_id` bigint(20) NOT NULL,
  `counts` int(11) NOT NULL DEFAULT '0' COMMENT '抽奖次数',
  `blessing` int(11) NOT NULL DEFAULT '0' COMMENT '累计值',
  `counts_award` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '保底奖励',
  `bless_award` varchar(1000) NOT NULL DEFAULT '' COMMENT '累计奖励',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神限时抽奖信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.goods 结构
DROP TABLE IF EXISTS `goods`;
CREATE TABLE IF NOT EXISTS `goods` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品子类型',
  `location` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '物品所在位置',
  `cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品格子位置',
  `num` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品创建时间',
  `expire_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效期，0为无',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '绑定状态，0不绑定，1绑定',
  `extra_data` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '额外数据[{key,value}|_]',
  PRIMARY KEY (`id`,`role_id`),
  KEY `pid` (`role_id`,`location`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品信息表'
/*!50100 PARTITION BY LINEAR HASH (role_id)
PARTITIONS 10 */;

-- 数据导出被取消选择。

-- 导出  表 yzygame.group_buy_data 结构
DROP TABLE IF EXISTS `group_buy_data`;
CREATE TABLE IF NOT EXISTS `group_buy_data` (
  `subtype` smallint(5) NOT NULL DEFAULT '1' COMMENT '活动子类型id',
  `grade` tinyint(3) NOT NULL DEFAULT '0' COMMENT '活动档次id',
  `real_buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '真实购买人数',
  `fix_buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '修正的购买人数',
  `gold_type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '货币类型',
  `original_price` smallint(5) NOT NULL DEFAULT '0' COMMENT '原始价格',
  `stime` int(11) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `etime` int(11) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `buyers` varchar(20000) NOT NULL COMMENT '购买者角色id列表',
  PRIMARY KEY (`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='团购活动数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild 结构
DROP TABLE IF EXISTS `guild`;
CREATE TABLE IF NOT EXISTS `guild` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '社团名字',
  `announce` varchar(500) NOT NULL DEFAULT '' COMMENT '社团公告',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '团长',
  `chief_name` varchar(50) NOT NULL DEFAULT '' COMMENT '社团名字',
  `agent` bigint(20) NOT NULL DEFAULT '0' COMMENT '代理团长',
  `agent_time` int(11) NOT NULL DEFAULT '0' COMMENT '代理时间',
  `lv` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `division` int(11) NOT NULL DEFAULT '0' COMMENT '评级',
  `funds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团资金',
  `arrears` int(11) NOT NULL DEFAULT '0' COMMENT '拖欠次数',
  `flag`  int(11) NOT NULL DEFAULT 0 COMMENT '社团旗帜',
  `style` int(11) NOT NULL DEFAULT '0' COMMENT '旗帜样式',
  `color` int(11) NOT NULL DEFAULT '0' COMMENT '旗帜颜色',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modify_times` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '社团修改次数',
  `approve_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '申请类型',
  `auto_approve_lv` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '自动加入的等级',
  `auto_approve_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '自动加入的战力',
  `disband_warnning_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解散警告开始时间',
  `week_labor` int(11) NOT NULL DEFAULT '0' COMMENT '周活跃',
  `week_labor_refresh` int(11) NOT NULL DEFAULT '0' COMMENT '上次刷新时间',
  `week_labor_last` int(11) NOT NULL DEFAULT '0' COMMENT '上周活跃',
  `c_rename` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以免费改名',
  `c_rename_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '改名时间',
  `badges` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '徽章',
  `party_num` int(11) NOT NULL DEFAULT '0' COMMENT '晚宴参与人次',
  `assist` int(11) NOT NULL DEFAULT '0' COMMENT '助战统计',
  `war_win` int(11) NOT NULL DEFAULT '0' COMMENT '社团战获胜',
  `last_renew` int(11) NOT NULL DEFAULT '0' COMMENT '上次更新',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_apply 结构
DROP TABLE IF EXISTS `guild_apply`;
CREATE TABLE IF NOT EXISTS `guild_apply` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `position` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '申请职位(默认申请加入:0)',
  PRIMARY KEY (`role_id`,`guild_id`),
  KEY `guild_id` (`guild_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团申请';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_boss 结构
DROP TABLE IF EXISTS `guild_boss`;
CREATE TABLE IF NOT EXISTS `guild_boss` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `act` int(11) NOT NULL DEFAULT '1' COMMENT '活动',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人排名',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `gid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团ID',
  `flag` int(11) NOT NULL DEFAULT '0' COMMENT '社团旗帜',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `gname` varchar(50) NOT NULL DEFAULT '' COMMENT '社团名字',
  `hurt` bigint(20) NOT NULL DEFAULT '0' COMMENT '伤害',
  `cash` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖返还',
  `count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '统计',
  `total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '统计总值',
  `finish` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否结算',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出手时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最终出手时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团BOSS';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_cgwar_room 结构
DROP TABLE IF EXISTS `guild_cgwar_room`;
CREATE TABLE IF NOT EXISTS `guild_cgwar_room` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派Id',
  `room` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战可参与社团(合服保留主服)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_create_act_reward 结构
DROP TABLE IF EXISTS `guild_create_act_reward`;
CREATE TABLE IF NOT EXISTS `guild_create_act_reward` (
  `act_id` smallint(5) unsigned NOT NULL COMMENT '活动子类型',
  `reward_id` smallint(5) unsigned NOT NULL COMMENT '奖励档次',
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`act_id`,`reward_id`,`guild_id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='勇者盟约奖励领取记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_guard_dungeon 结构
DROP TABLE IF EXISTS `guild_guard_dungeon`;
CREATE TABLE IF NOT EXISTS `guild_guard_dungeon` (
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `act_id` int(10) unsigned NOT NULL COMMENT '活动子类',
  `start_time` int(10) unsigned NOT NULL COMMENT '副本被开启的时间',
  `is_end` tinyint(3) unsigned NOT NULL COMMENT '是否已经结束 0未结束 1结算结束 2错误结束',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫公会数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_member 结构
DROP TABLE IF EXISTS `guild_member`;
CREATE TABLE IF NOT EXISTS `guild_member` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `position` tinyint(2) unsigned NOT NULL DEFAULT '2' COMMENT '职位',
  `precursor` tinyint(2) NOT NULL DEFAULT '0' COMMENT '代理前职位',
  `week_labor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周活跃',
  `week_labor_refresh` int(11) NOT NULL DEFAULT '0' COMMENT '上次刷新时间',
  `labors` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本社历史活跃',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团成员';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_merge 结构
DROP TABLE IF EXISTS `guild_merge`;
CREATE TABLE IF NOT EXISTS `guild_merge` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `tapply` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '发出的申请',
  `fapplys` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '收到的申请',
  `notes` varchar(500) NOT NULL DEFAULT '[]' COMMENT '历史拒绝',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团合并';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_order 结构
DROP TABLE IF EXISTS `guild_order`;
CREATE TABLE IF NOT EXISTS `guild_order` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '订单id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cfgid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置',
  `status` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `content` varchar(500) NOT NULL DEFAULT '{}' COMMENT '任务内容',
  `teams` varchar(500) NOT NULL DEFAULT '{}' COMMENT '拼单人',
  `finish_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成时间',
  PRIMARY KEY (`id`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团派单-合服合并';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_order_log 结构
DROP TABLE IF EXISTS `guild_order_log`;
CREATE TABLE IF NOT EXISTS `guild_order_log` (
  `order_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拼单唯一Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '发起者Id',
  `cfg_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '拼单配置Id',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '拼单内容',
  `chat_msg` varchar(1000) NOT NULL DEFAULT '' COMMENT '交流信息',
  `is_receive` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否领取',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`order_id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团拼单-拼单记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_order_thank 结构
DROP TABLE IF EXISTS `guild_order_thank`;
CREATE TABLE IF NOT EXISTS `guild_order_thank` (
  `order_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拼单唯一Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团Id',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '发起者Id',
  `cfg_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '拼单配置Id',
  `role_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '角色列表',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '拼单内容',
  `is_send` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已经发送',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团拼单-感谢信';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_position_name 结构
DROP TABLE IF EXISTS `guild_position_name`;
CREATE TABLE IF NOT EXISTS `guild_position_name` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `position` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `position_name` varchar(50) NOT NULL DEFAULT '' COMMENT '职位名字',
  PRIMARY KEY (`guild_id`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会职位名字';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_position_permission 结构
DROP TABLE IF EXISTS `guild_position_permission`;
CREATE TABLE IF NOT EXISTS `guild_position_permission` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `position` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `permission_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权限类型',
  `is_allow` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '是否允许',
  PRIMARY KEY (`guild_id`,`position`,`permission_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会职位权限';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_race_rank 结构
DROP TABLE IF EXISTS `guild_race_rank`;
CREATE TABLE IF NOT EXISTS `guild_race_rank` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '公会名称',
  `guild_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '社团等级',
  `captain_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '团长Id',
  `sum_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '总战力',
  `old_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '上次结算总战力',
  `old_rank` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '旧排行',
  `old_live` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '旧的总活跃值',
  `create_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团创建者',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团竞速-社团排行表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_race_rank_member 结构
DROP TABLE IF EXISTS `guild_race_rank_member`;
CREATE TABLE IF NOT EXISTS `guild_race_rank_member` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团Id',
  `position` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `old_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '上次结算战力',
  `old_rank` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '旧排行',
  `old_live` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '旧的活跃值',
  `received_power` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已领取战力榜奖励',
  `received_live` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已领取活跃榜奖励',
  `received_captain_power` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已领取团长战力奖励',
  `received_captain_live` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已领取团长活跃奖励',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团竞速-成员排行';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_race_rank_role 结构
DROP TABLE IF EXISTS `guild_race_rank_role`;
CREATE TABLE IF NOT EXISTS `guild_race_rank_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团Id',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团竞速-前七天玩家和社团映射';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_race_rank_task 结构
DROP TABLE IF EXISTS `guild_race_rank_task`;
CREATE TABLE IF NOT EXISTS `guild_race_rank_task` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `progress` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务状态 0-未完成 1-已完成 2-已领取',
  PRIMARY KEY (`guild_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团竞速-团长任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_skill 结构
DROP TABLE IF EXISTS `guild_skill`;
CREATE TABLE IF NOT EXISTS `guild_skill` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '研究等级',
  PRIMARY KEY (`guild_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_support 结构
DROP TABLE IF EXISTS `guild_support`;
CREATE TABLE IF NOT EXISTS `guild_support` (
  `support_sid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助全服唯一Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `support_cfgid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '协助配置Id(对应玩法类型)',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '请求者Id',
  `support_list` varchar(500) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT '[]' COMMENT '支援者列表',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景Id',
  `x` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '坐标X',
  `y` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '坐标Y',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '协助内容',
  `extra` varchar(500) NOT NULL DEFAULT '[]' COMMENT '其他内容(各玩法定制)',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '协助状态 0-未开始 1-正在进行 2-已经结束',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '请求创建时间',
  PRIMARY KEY (`support_sid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='公会-公会协助数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_support_log 结构
DROP TABLE IF EXISTS `guild_support_log`;
CREATE TABLE IF NOT EXISTS `guild_support_log` (
  `support_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助唯一Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '请求者Id',
  `support_cfg_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '协助配置Id',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '内容',
  `chat_msg` varchar(1000) NOT NULL DEFAULT '' COMMENT '交流信息',
  `is_receive` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否领取',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`support_id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团协助-协助记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_support_thank 结构
DROP TABLE IF EXISTS `guild_support_thank`;
CREATE TABLE IF NOT EXISTS `guild_support_thank` (
  `support_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助唯一Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团Id',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '请求者Id',
  `support_cfg_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '协助配置Id',
  `role_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '角色列表',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '协助内容',
  `is_send` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已经发送',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`support_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='社团协助-感谢信';

-- 数据导出被取消选择。

-- 导出  表 yzygame.guild_war_guild_rank 结构
DROP TABLE IF EXISTS `guild_war_guild_rank`;
CREATE TABLE IF NOT EXISTS `guild_war_guild_rank` (
  `rank` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT '排名',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团ID',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团战本服-社团排名(合服清空)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.home_boss_status 结构
DROP TABLE IF EXISTS `home_boss_status`;
CREATE TABLE IF NOT EXISTS `home_boss_status` (
  `sub_module` int(11) unsigned NOT NULL COMMENT '子功能id',
  `rank_index` int(11) unsigned NOT NULL COMMENT '序号',
  `boss_id` int(11) unsigned NOT NULL COMMENT 'boss id',
  `guild` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `born_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出生时间',
  `dead_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '死亡时间',
  `killer` varchar(255) NOT NULL DEFAULT '' COMMENT '击杀者',
  PRIMARY KEY (`sub_module`,`rank_index`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻魔之家boss信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.husong_log 结构
DROP TABLE IF EXISTS `husong_log`;
CREATE TABLE IF NOT EXISTS `husong_log` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色ID',
  `type` tinyint(4) unsigned NOT NULL COMMENT '护送类型 1.护送 2.抢夺',
  `airship_id` smallint(10) unsigned NOT NULL COMMENT '飞艇ID',
  `result` tinyint(4) unsigned NOT NULL COMMENT '护送结果 1.成功 0.失败',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `date_time` int(20) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.husong_player 结构
DROP TABLE IF EXISTS `husong_player`;
CREATE TABLE IF NOT EXISTS `husong_player` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `airship_id` int(10) unsigned NOT NULL COMMENT '飞艇ID',
  `airship_sid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '飞艇自动生成唯一ID',
  `airship_aid` varchar(50) NOT NULL COMMENT '飞艇aid',
  `scene_pool_id` smallint(2) unsigned NOT NULL COMMENT '飞艇所在pool_id',
  `icon_start_time` int(10) unsigned NOT NULL COMMENT '"劫"字图标开始时间',
  `less_hp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '剩余血量',
  `stage` int(10) unsigned NOT NULL COMMENT '当前阶段: 0,1,2',
  `reward_stage` int(10) unsigned NOT NULL COMMENT '已发放奖励阶段:0,1,2',
  `start_time` int(10) unsigned NOT NULL COMMENT '护送开始时间',
  `airship_skill` int(10) unsigned NOT NULL COMMENT '飞艇技能(一次护送只能用一次)',
  `help_list` varchar(512) NOT NULL COMMENT '协助',
  `ask_help_time` int(10) unsigned NOT NULL COMMENT '求助时间',
  `out_side` tinyint(3) unsigned NOT NULL COMMENT '是否脱离飞艇启动范围 0:未脱离 1:已脱离',
  `help_id` bigint(10) unsigned NOT NULL COMMENT '协助的护送玩家ID',
  `log` varchar(3072) NOT NULL DEFAULT '[]' COMMENT '护送历史记录',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送玩家信息记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.internal_manage 结构
DROP TABLE IF EXISTS `internal_manage`;
CREATE TABLE IF NOT EXISTS `internal_manage` (
  `id` int(11) NOT NULL COMMENT '角色ID',
  `nickname` varchar(50) NOT NULL COMMENT '角色名称',
  `truename` varchar(50) NOT NULL COMMENT '真实名称',
  `position` varchar(50) NOT NULL COMMENT '职位',
  `sid` int(11) NOT NULL COMMENT '服ID',
  `gold` int(11) NOT NULL COMMENT '总元宝',
  `rights` int(11) NOT NULL COMMENT '新手指导员权限：2：一般3：待定',
  `status` tinyint(4) DEFAULT '0' COMMENT '状态0：未通过1通过',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '类型0：内部管理员1:指导员',
  `time` int(11) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`id`,`type`),
  KEY `type` (`type`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='内部号管理';

-- 数据导出被取消选择。

-- 导出  表 yzygame.investment_data 结构
DROP TABLE IF EXISTS `investment_data`;
CREATE TABLE IF NOT EXISTS `investment_data` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` tinyint(3) unsigned NOT NULL COMMENT '投资类型',
  `lv` tinyint(3) unsigned NOT NULL COMMENT '投资档次',
  `is_buy` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否购买',
  `buy_time` int(10) unsigned NOT NULL COMMENT '购买时间',
  `reward_info` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '回报信息',
  PRIMARY KEY (`role_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家投资数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.join_log 结构
DROP TABLE IF EXISTS `join_log`;
CREATE TABLE IF NOT EXISTS `join_log` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`player_id`,`module_id`),
  KEY `module_id` (`module_id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能活动参与表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_1vn_auction 结构
DROP TABLE IF EXISTS `kf_1vn_auction`;
CREATE TABLE IF NOT EXISTS `kf_1vn_auction` (
  `issue` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '第几期',
  `optime` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `edtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  PRIMARY KEY (`issue`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者记录 合服清空';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_1vn_auction_award 结构
DROP TABLE IF EXISTS `kf_1vn_auction_award`;
CREATE TABLE IF NOT EXISTS `kf_1vn_auction_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `issue` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖期数',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出价',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励物品',
  PRIMARY KEY (`id`),
  KEY `issue` (`issue`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者记录 合服清空';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_1vn_auction_rank 结构
DROP TABLE IF EXISTS `kf_1vn_auction_rank`;
CREATE TABLE IF NOT EXISTS `kf_1vn_auction_rank` (
  `auction_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖配置id',
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出价',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  PRIMARY KEY (`auction_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者排行榜 合服清空';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_1vn_bidder 结构
DROP TABLE IF EXISTS `kf_1vn_bidder`;
CREATE TABLE IF NOT EXISTS `kf_1vn_bidder` (
  `auction_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖配置id',
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出价',
  `voucher` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '代金券数量',
  `payment_refs` text NOT NULL COMMENT '预付款引用',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`auction_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者记录 合服合并';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_1vn_def_rank 结构
DROP TABLE IF EXISTS `kf_1vn_def_rank`;
CREATE TABLE IF NOT EXISTS `kf_1vn_def_rank` (
  `area` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `server_name` varchar(50) NOT NULL DEFAULT '' COMMENT '服名',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `gname` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家帮派名字',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家vip',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家积分',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家轮次',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战力',
  `career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '玩家职业',
  `survival_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '存活时间',
  `lose` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已经失败',
  PRIMARY KEY (`player_id`),
  KEY `rank` (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂主排行榜，合服清空';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_1vn_sign 结构
DROP TABLE IF EXISTS `kf_1vn_sign`;
CREATE TABLE IF NOT EXISTS `kf_1vn_sign` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn报名列表（本服）合服合并';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_1vn_sign_center 结构
DROP TABLE IF EXISTS `kf_1vn_sign_center`;
CREATE TABLE IF NOT EXISTS `kf_1vn_sign_center` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战斗力',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名',
  `server_name` varchar(50) NOT NULL DEFAULT '' COMMENT '服名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn报名列表（跨服）合服合并';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_3v3_rank 结构
DROP TABLE IF EXISTS `kf_3v3_rank`;
CREATE TABLE IF NOT EXISTS `kf_3v3_rank` (
  `rank_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '名次',
  `server_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '服号',
  `server_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '角色所在的服务器id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `nickname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '昵称',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '性别',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `power` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `tier` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `season_pk` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '赛季参与次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上榜时间',
  PRIMARY KEY (`rank_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服3v3排行榜 合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_custom_act_opening 结构
DROP TABLE IF EXISTS `kf_custom_act_opening`;
CREATE TABLE IF NOT EXISTS `kf_custom_act_opening` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时的世界等级',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开启中的跨服定制活动数据(合跨服组清空)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.kf_town_war_apply 结构
DROP TABLE IF EXISTS `kf_town_war_apply`;
CREATE TABLE IF NOT EXISTS `kf_town_war_apply` (
  `building_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `ser_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器号',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '会长id',
  `assist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '应援总额',
  PRIMARY KEY (`building_id`,`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战宣战表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.last_rela_chat 结构
DROP TABLE IF EXISTS `last_rela_chat`;
CREATE TABLE IF NOT EXISTS `last_rela_chat` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `other_id` bigint(20) unsigned NOT NULL COMMENT '对方id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近聊天时间',
  PRIMARY KEY (`role_id`,`other_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='最近聊天信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.legion_director 结构
DROP TABLE IF EXISTS `legion_director`;
CREATE TABLE IF NOT EXISTS `legion_director` (
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `fact` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '站位',
  `rid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `name` varchar(200) NOT NULL DEFAULT '[]' COMMENT '玩家名',
  `sex` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  PRIMARY KEY (`zone`,`fact`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='指挥官数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.legion_director_log 结构
DROP TABLE IF EXISTS `legion_director_log`;
CREATE TABLE IF NOT EXISTS `legion_director_log` (
  `issue` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '期数',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '站位',
  `rid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `name` varchar(200) NOT NULL DEFAULT '[]' COMMENT '玩家名',
  `sex` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip',
  `sup_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'svip',
  `dress_list` varchar(200) NOT NULL DEFAULT '[]' COMMENT '头像框',
  `profile_photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家头像',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '当天0点',
  PRIMARY KEY (`issue`,`server_num`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='任命记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.legion_military_rank 结构
DROP TABLE IF EXISTS `legion_military_rank`;
CREATE TABLE IF NOT EXISTS `legion_military_rank` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `faction` tinyint(3) unsigned NOT NULL COMMENT '阵型',
  `server_num` int(11) unsigned NOT NULL COMMENT '服务器num',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '军衔等级',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip',
  `sup_vip` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '超级贵族',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='跨服军团-军衔排行';

-- 数据导出被取消选择。

-- 导出  表 yzygame.legion_rank_last 结构
DROP TABLE IF EXISTS `legion_rank_last`;
CREATE TABLE IF NOT EXISTS `legion_rank_last` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `name` varchar(200) NOT NULL DEFAULT '[]' COMMENT '玩家名',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `fact` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `sex` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip',
  `sup_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'svip',
  `dress_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '头像列表',
  `profile_photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家头像',
  `post` int(11) NOT NULL DEFAULT '0' COMMENT '玩家军衔',
  `gname` varchar(200) NOT NULL DEFAULT '[]' COMMENT '社团名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='昨天榜单数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.legion_rank_now 结构
DROP TABLE IF EXISTS `legion_rank_now`;
CREATE TABLE IF NOT EXISTS `legion_rank_now` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `name` varchar(200) NOT NULL DEFAULT '[]' COMMENT '玩家名',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `fact` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `sex` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip',
  `sup_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'svip',
  `dress_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '头像列表',
  `profile_photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家头像',
  `post` int(11) NOT NULL DEFAULT '0' COMMENT '玩家军衔',
  `gname` varchar(200) NOT NULL DEFAULT '[]' COMMENT '社团名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='当期榜单数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.legion_rank_week 结构
DROP TABLE IF EXISTS `legion_rank_week`;
CREATE TABLE IF NOT EXISTS `legion_rank_week` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `name` varchar(200) NOT NULL DEFAULT '[]' COMMENT '玩家名',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `fact` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `sex` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip',
  `sup_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'svip',
  `dress_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '头像列表',
  `profile_photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家头像',
  `post` int(11) NOT NULL DEFAULT '0' COMMENT '玩家军衔',
  `gname` varchar(200) NOT NULL DEFAULT '[]' COMMENT '社团名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='上期榜单数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.light_weapon_normal 结构
DROP TABLE IF EXISTS `light_weapon_normal`;
CREATE TABLE IF NOT EXISTS `light_weapon_normal` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `weapon_id` smallint(5) unsigned NOT NULL COMMENT '专武id',
  `lv` int(11) unsigned NOT NULL COMMENT '等级',
  `exp` int(11) unsigned NOT NULL COMMENT '当前经验',
  `upgrade_list` varchar(512) NOT NULL COMMENT '提升列表[{物品id,物品数量},...]',
  PRIMARY KEY (`role_id`,`weapon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-玩家专武数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.limited_mail 结构
DROP TABLE IF EXISTS `limited_mail`;
CREATE TABLE IF NOT EXISTS `limited_mail` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '邮件编号',
  `title` varchar(500) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `content` varchar(1000) NOT NULL DEFAULT '' COMMENT '邮件内容',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '彩钻',
  `bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红钻',
  `rewards` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `open_days` varchar(500) NOT NULL DEFAULT '[]' COMMENT '开服天数区间',
  `tar_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定时时间',
  `last_day_login` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近登录天数',
  `lvs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '等级区间',
  `vips` varchar(500) NOT NULL DEFAULT '[]' COMMENT 'vip区间',
  `source` varchar(500) NOT NULL DEFAULT '' COMMENT '渠道',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时邮件';

-- 数据导出被取消选择。

-- 导出  表 yzygame.limit_buy_daily_num 结构
DROP TABLE IF EXISTS `limit_buy_daily_num`;
CREATE TABLE IF NOT EXISTS `limit_buy_daily_num` (
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `grade` int(10) unsigned NOT NULL COMMENT '奖励档次',
  `daily_get_num` int(10) unsigned NOT NULL COMMENT '本服日购买数量',
  PRIMARY KEY (`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特惠商城日购买数量记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.limit_buy_daily_player 结构
DROP TABLE IF EXISTS `limit_buy_daily_player`;
CREATE TABLE IF NOT EXISTS `limit_buy_daily_player` (
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `grade` int(10) unsigned NOT NULL COMMENT '奖励档次',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `buy_num` int(10) unsigned NOT NULL COMMENT '次数',
  PRIMARY KEY (`subtype`,`grade`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特惠商城玩家日购买数量记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.limit_goal_main 结构
DROP TABLE IF EXISTS `limit_goal_main`;
CREATE TABLE IF NOT EXISTS `limit_goal_main` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goal_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '目标id',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态',
  `open_time` int(10) unsigned NOT NULL COMMENT '开放时间',
  PRIMARY KEY (`role_id`,`goal_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标主要目标数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.limit_goal_task 结构
DROP TABLE IF EXISTS `limit_goal_task`;
CREATE TABLE IF NOT EXISTS `limit_goal_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goal_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '目标id',
  `task_id` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `progress` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态',
  `extra` varchar(255) NOT NULL DEFAULT '[]' COMMENT '附加数据',
  PRIMARY KEY (`role_id`,`goal_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标任务完成数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.local_boss_focus 结构
DROP TABLE IF EXISTS `local_boss_focus`;
CREATE TABLE IF NOT EXISTS `local_boss_focus` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS',
  `boss_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'boss类型',
  PRIMARY KEY (`role_id`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服BOSS-关注信息##合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.local_boss_status 结构
DROP TABLE IF EXISTS `local_boss_status`;
CREATE TABLE IF NOT EXISTS `local_boss_status` (
  `boss_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS怪物id',
  `boss_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '怪物类型',
  `born_time` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '出生时间',
  `dead_time` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '死亡时间',
  `killer` varchar(100) NOT NULL DEFAULT '<<>>' COMMENT '击杀者',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服BOSS状态##合服清空';

-- 数据导出被取消选择。

-- 导出  表 yzygame.login_reward_player 结构
DROP TABLE IF EXISTS `login_reward_player`;
CREATE TABLE IF NOT EXISTS `login_reward_player` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `get_date` int(10) unsigned NOT NULL COMMENT '获得的当日0点时间戳',
  `refresh_days_time` int(11) unsigned NOT NULL COMMENT '更新登录天数的时间',
  `login_days` smallint(6) unsigned NOT NULL COMMENT '累计登录天数',
  `day_states` varchar(500) NOT NULL DEFAULT '[]' COMMENT '已领取天数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='七天登录玩家数据记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_3v3 结构
DROP TABLE IF EXISTS `log_3v3`;
CREATE TABLE IF NOT EXISTS `log_3v3` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1：战斗；2：周六继承',
  `old_tier` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前段位',
  `old_star` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前星数',
  `new_tier` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后段位',
  `new_star` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后星数',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:胜利；2:失败',
  `honor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '荣誉值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_3v3_pk_role 结构
DROP TABLE IF EXISTS `log_3v3_pk_role`;
CREATE TABLE IF NOT EXISTS `log_3v3_pk_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pk_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战斗id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(100) NOT NULL DEFAULT '0' COMMENT '名字',
  `group` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红蓝方',
  `old_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前段位',
  `old_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前星数',
  `old_continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前连胜',
  `new_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后段位',
  `new_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后星数',
  `new_continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后连胜',
  `kill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀次数',
  `killed` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '被击杀次数',
  `collect` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '采集神塔次数',
  `assist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '助攻次数',
  `honor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '光辉值',
  `is_mvp` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否mvp',
  `result` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`),
  KEY `group` (`group`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3战斗个人日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_3v3_pk_room 结构
DROP TABLE IF EXISTS `log_3v3_pk_room`;
CREATE TABLE IF NOT EXISTS `log_3v3_pk_room` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `scene_pool_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景池id',
  `room_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间id',
  `tower_data` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '塔数据##[{怪物id,时间,组别}]',
  `pk_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战斗id',
  `result` tinyint(1) unsigned DEFAULT '0' COMMENT '结果',
  `blue_name1` varchar(100) NOT NULL DEFAULT '' COMMENT '蓝方名字1',
  `blue_name2` varchar(100) NOT NULL DEFAULT '' COMMENT '蓝方名字2',
  `blue_name3` varchar(100) NOT NULL DEFAULT '' COMMENT '蓝方名字3',
  `blue_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蓝方积分',
  `blue_tower_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蓝方占领塔数',
  `red_name1` varchar(100) NOT NULL DEFAULT '' COMMENT '红方名字1',
  `red_name2` varchar(100) NOT NULL DEFAULT '' COMMENT '红方名字2',
  `red_name3` varchar(100) NOT NULL DEFAULT '' COMMENT '红方名字3',
  `red_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红方积分',
  `red_tower_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红方占领塔数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `room_id` (`room_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3战斗房间日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_3v3_pk_team 结构
DROP TABLE IF EXISTS `log_3v3_pk_team`;
CREATE TABLE IF NOT EXISTS `log_3v3_pk_team` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pk_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战斗id',
  `team_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '队伍id',
  `group` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红蓝方',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `kill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总击杀数',
  `killed` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总被击杀数',
  `assist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总助攻次数',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `team_id` (`team_id`),
  KEY `group` (`group`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3战斗队伍日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_3v3_rank_reward 结构
DROP TABLE IF EXISTS `log_3v3_rank_reward`;
CREATE TABLE IF NOT EXISTS `log_3v3_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `rank_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `nickname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '昵称',
  `tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `reward` varchar(3000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3榜单奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_achv 结构
DROP TABLE IF EXISTS `log_achv`;
CREATE TABLE IF NOT EXISTS `log_achv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `category` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `sub_category` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '小类',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_active_dsgt 结构
DROP TABLE IF EXISTS `log_active_dsgt`;
CREATE TABLE IF NOT EXISTS `log_active_dsgt` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `dsgt_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号id',
  `opr` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '操作时间',
  `expire_time` int(11) NOT NULL DEFAULT '0' COMMENT '时效',
  `end_time` int(11) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `return_money` varchar(255) NOT NULL DEFAULT '[]' COMMENT '补偿物品',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `player_id` (`player_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE,
  KEY `dsgt_id` (`dsgt_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='称号日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_activity_live 结构
DROP TABLE IF EXISTS `log_activity_live`;
CREATE TABLE IF NOT EXISTS `log_activity_live` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `ac_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动ID',
  `ac_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子ID',
  `ac_name` varchar(1024) NOT NULL DEFAULT '' COMMENT '活动名称',
  `live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得活跃度',
  `old_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成前活跃度',
  `new_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成后活跃度',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `ac_id` (`ac_id`),
  KEY `ac_sub` (`ac_sub`),
  KEY `ac_name` (`ac_name`(255)),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_ac_start 结构
DROP TABLE IF EXISTS `log_ac_start`;
CREATE TABLE IF NOT EXISTS `log_ac_start` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能Id',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能Id',
  `ac_sub` int(11) NOT NULL DEFAULT '0' COMMENT '功能子类',
  `state` tinyint(11) NOT NULL DEFAULT '0' COMMENT '活动状态：1日历开启，2活动开启，3活动结束',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `module` (`module`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动开启通知';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_advance_produce 结构
DROP TABLE IF EXISTS `log_advance_produce`;
CREATE TABLE IF NOT EXISTS `log_advance_produce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_lv` int(11) unsigned NOT NULL COMMENT '角色等级',
  `func_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能Id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '功能名称',
  `con_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '条件描述',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `days` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `func_id` (`func_id`) USING BTREE,
  KEY `name` (`name`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='功能预告产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_adventure_lottery 结构
DROP TABLE IF EXISTS `log_adventure_lottery`;
CREATE TABLE IF NOT EXISTS `log_adventure_lottery` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_type` int(11) NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `sub_type` int(11) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `type` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖类型',
  `grade_list` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励id列表',
  `score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '热点值',
  `progress` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '进度值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `gold_before` int(11) NOT NULL DEFAULT '0' COMMENT '操作前彩钻',
  `gold_after` int(11) NOT NULL DEFAULT '0' COMMENT '操作后彩钻',
  `bgold_before` int(11) NOT NULL DEFAULT '0' COMMENT '操作前红钻',
  `bgold_after` int(11) NOT NULL DEFAULT '0' COMMENT '操作后红钻',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='冒险征程抽奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_all_online 结构
DROP TABLE IF EXISTS `log_all_online`;
CREATE TABLE IF NOT EXISTS `log_all_online` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '在线时长',
  `log_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录节点时间',
  `logout_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '退出时间',
  `last_login_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近登录时间',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当天0点时间戳',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `logout_time` (`logout_time`),
  KEY `last_login_time` (`last_login_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='在线时间日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_arena 结构
DROP TABLE IF EXISTS `log_arena`;
CREATE TABLE IF NOT EXISTS `log_arena` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结算名次',
  `rival_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '被挑战玩家Id',
  `rival_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `rival_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '被挑战玩家排名',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '胜负情况',
  `after_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战后排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技排位赛日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_arena_buy_times 结构
DROP TABLE IF EXISTS `log_arena_buy_times`;
CREATE TABLE IF NOT EXISTS `log_arena_buy_times` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前钻石',
  `pre_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前绑钻',
  `pre_coin` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前金币',
  `buy_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数',
  `after_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后钻石',
  `after_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后绑钻',
  `after_coin` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后金币',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技购买次数日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_arena_daily_reward 结构
DROP TABLE IF EXISTS `log_arena_daily_reward`;
CREATE TABLE IF NOT EXISTS `log_arena_daily_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型##（0-每日奖励；1-每日首胜；2-每日五战）',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日奖励名次',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技联赛每日奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_arena_season_award 结构
DROP TABLE IF EXISTS `log_arena_season_award`;
CREATE TABLE IF NOT EXISTS `log_arena_season_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场赛季结算日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_ask_guild_support 结构
DROP TABLE IF EXISTS `log_ask_guild_support`;
CREATE TABLE IF NOT EXISTS `log_ask_guild_support` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '请求者Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `support_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助单Id',
  `cfg_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '协助配置Id',
  `content` varchar(255) NOT NULL DEFAULT '[]' COMMENT '协助具体内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '协助单创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='社团协助日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_auction_award 结构
DROP TABLE IF EXISTS `log_auction_award`;
CREATE TABLE IF NOT EXISTS `log_auction_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍道具id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具数量',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最终竞价',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：获得竞拍日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_auction_bonus 结构
DROP TABLE IF EXISTS `log_auction_bonus`;
CREATE TABLE IF NOT EXISTS `log_auction_bonus` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `money_list` varchar(128) NOT NULL DEFAULT '0' COMMENT '获得分红',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分红时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：分红日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_auction_pay 结构
DROP TABLE IF EXISTS `log_auction_pay`;
CREATE TABLE IF NOT EXISTS `log_auction_pay` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍道具id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具数量',
  `pay_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞价类型',
  `price_list` varchar(128) NOT NULL DEFAULT '0' COMMENT '消耗货币',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前竞价',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：竞拍日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_auction_produce 结构
DROP TABLE IF EXISTS `log_auction_produce`;
CREATE TABLE IF NOT EXISTS `log_auction_produce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖会场次id',
  `goods_list` varchar(2048) NOT NULL DEFAULT '0' COMMENT '产出物品',
  `bonus_tax_rate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分红税率',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_ban 结构
DROP TABLE IF EXISTS `log_ban`;
CREATE TABLE IF NOT EXISTS `log_ban` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) NOT NULL COMMENT '类型：0：封号，1：IP黑名单，3：禁头像/禁言，4：解除禁言，5：删除头像',
  `object` varchar(2000) NOT NULL COMMENT '对象',
  `description` varchar(100) NOT NULL COMMENT '描述',
  `time` int(10) NOT NULL COMMENT '时间',
  `admin` varchar(50) NOT NULL COMMENT '操作管理员',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='查封日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_beach_rank 结构
DROP TABLE IF EXISTS `log_beach_rank`;
CREATE TABLE IF NOT EXISTS `log_beach_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `room` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间',
  `line_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分线',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见)',
  `kf_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `votes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前投票',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '排名奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `server_num` (`server_num`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='舞池派对排名日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_beach_vote 结构
DROP TABLE IF EXISTS `log_beach_vote`;
CREATE TABLE IF NOT EXISTS `log_beach_vote` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `room` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间',
  `line_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分线',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `dancer_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '舞者id',
  `dancer_name` varchar(255) NOT NULL DEFAULT '' COMMENT '舞者名称',
  `left_free_votes` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '剩余免费次数',
  `exp_reward` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '经验奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `server_num` (`server_num`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='舞池派对投票日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_beauty_contest_rank 结构
DROP TABLE IF EXISTS `log_beauty_contest_rank`;
CREATE TABLE IF NOT EXISTS `log_beauty_contest_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `phase` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '期数',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '止步轮次',
  `rank` varchar(50) NOT NULL DEFAULT '[]' COMMENT '排名',
  `votes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结算票数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-排名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_beauty_contest_sign 结构
DROP TABLE IF EXISTS `log_beauty_contest_sign`;
CREATE TABLE IF NOT EXISTS `log_beauty_contest_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `fashion_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-主动报名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_beauty_contest_vote 结构
DROP TABLE IF EXISTS `log_beauty_contest_vote`;
CREATE TABLE IF NOT EXISTS `log_beauty_contest_vote` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `round` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `vote_info` varchar(50) NOT NULL DEFAULT '[]' COMMENT '选手信息##（格式为：[选手1昵称 - 选手2昵称，(票数高者ID)]）',
  `support_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对方ID （所支持选手ID）',
  `support_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '对方名称',
  `support_votes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对方当前票数',
  `rest_times` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '投票剩余次数',
  `is_extra` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否投票给高票数者',
  `award_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `zone_id` (`zone_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='靓丽大赛-投票日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_bonfire_buy_dinner 结构
DROP TABLE IF EXISTS `log_bonfire_buy_dinner`;
CREATE TABLE IF NOT EXISTS `log_bonfire_buy_dinner` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '购买类型',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会篝火购买晚宴日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_boss_belong 结构
DROP TABLE IF EXISTS `log_boss_belong`;
CREATE TABLE IF NOT EXISTS `log_boss_belong` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '击杀角色ID',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `is_cluster` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服模式0本服|1跨服',
  `svr_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `role_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '击杀角色LV',
  `boss_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '幻魔类型(3次元幻魔|6个人幻魔|9混乱星域幻魔|10混乱星域精英怪)',
  `boss_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '幻魔LV',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻魔ID',
  `belong_role_ids` varchar(500) NOT NULL DEFAULT '[]' COMMENT '归属者IDS',
  `first_kill` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否首次击杀(1首次击杀|0非首次击杀)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `role_name` (`role_name`),
  KEY `boss_type` (`boss_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻魔击杀归属日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_boss_change 结构
DROP TABLE IF EXISTS `log_boss_change`;
CREATE TABLE IF NOT EXISTS `log_boss_change` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `boss_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '幻魔类型(3次元幻魔|6个人幻魔|9混乱星域幻魔10混乱星域精英怪)',
  `num_aft` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '变化后次数',
  `num_bef` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '变化前次数',
  `change_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '变化原因(1击杀消耗|2自然回复|3购买回复|4首杀|5联合Buff次数消耗)',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻魔ID(只有击杀消耗时候才记录)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `role_name` (`role_name`),
  KEY `boss_type` (`boss_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻魔次数变化日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_boss_drop 结构
DROP TABLE IF EXISTS `log_boss_drop`;
CREATE TABLE IF NOT EXISTS `log_boss_drop` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `boss_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '幻魔类型(3次元幻魔|9混乱星域幻魔|10混乱星域精英怪)',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻魔ID',
  `belong_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属者ID',
  `belong_team_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属队伍ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `is_bind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否绑定(1绑定|0非绑)',
  `expired_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '过期时间(道具消失时间戳)',
  `damage_list` varchar(500) NOT NULL DEFAULT '0' COMMENT '伤害列表[{role_id,damage,team_id},{role_id,damage,team_id}]',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `boss_type` (`boss_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻魔击杀掉落日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_buy_fishing_gear 结构
DROP TABLE IF EXISTS `log_buy_fishing_gear`;
CREATE TABLE IF NOT EXISTS `log_buy_fishing_gear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '贵族等级',
  `fishing_gear` varchar(128) NOT NULL DEFAULT '[]' COMMENT '渔具',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='购买渔具日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_camp_war_rank_guild 结构
DROP TABLE IF EXISTS `log_camp_war_rank_guild`;
CREATE TABLE IF NOT EXISTS `log_camp_war_rank_guild` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团ID',
  `guild_name` varchar(256) NOT NULL DEFAULT '' COMMENT '社团名',
  `fighter` varchar(500) NOT NULL DEFAULT '[]' COMMENT '对手社团ID',
  `guild_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团伤害排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结算时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服团战社团伤害排名';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_camp_war_rank_role 结构
DROP TABLE IF EXISTS `log_camp_war_rank_role`;
CREATE TABLE IF NOT EXISTS `log_camp_war_rank_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `mirror` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '0否|1是',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结算时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服团战个人排名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_capsule_egg_award_times 结构
DROP TABLE IF EXISTS `log_capsule_egg_award_times`;
CREATE TABLE IF NOT EXISTS `log_capsule_egg_award_times` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前累计抽奖次数',
  `times_need` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励次数要求',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `pool_type` (`pool_type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='扭蛋宝库累计次数奖励日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_capsule_egg_draw 结构
DROP TABLE IF EXISTS `log_capsule_egg_draw`;
CREATE TABLE IF NOT EXISTS `log_capsule_egg_draw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pool_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖类型 1单抽 2十连 3五十连',
  `award` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `color_max` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最高奖励档位',
  `absolute` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '必出档位  1有 0无',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `pool_type` (`pool_type`) USING BTREE,
  KEY `type` (`type`) USING BTREE,
  KEY `color_max` (`color_max`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='扭蛋宝库抽奖日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_capsule_toys 结构
DROP TABLE IF EXISTS `log_capsule_toys`;
CREATE TABLE IF NOT EXISTS `log_capsule_toys` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `w_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `draw_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `cost` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级扭蛋奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cgwar_city_info 结构
DROP TABLE IF EXISTS `log_cgwar_city_info`;
CREATE TABLE IF NOT EXISTS `log_cgwar_city_info` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `city_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '城池Id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服ServerId',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服编号(玩家看到的服数)',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派Id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '帮派名称',
  `guild_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮派战力',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮主Id',
  `chief_name` varchar(50) NOT NULL DEFAULT '' COMMENT '帮主名称',
  `chief_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮主战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `chief_info` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '社团社长信息',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战往期战报';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_charge_goods 结构
DROP TABLE IF EXISTS `log_charge_goods`;
CREATE TABLE IF NOT EXISTS `log_charge_goods` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '角色ID',
  `product_id` smallint(6) NOT NULL COMMENT '商品ID',
  `type` smallint(6) NOT NULL COMMENT '商品大类',
  `sub_type` smallint(6) NOT NULL COMMENT '商品子类',
  `name` varchar(255) NOT NULL COMMENT '商品名称',
  `recharge_total` smallint(6) NOT NULL COMMENT '累计充值金额（计算金额而不是彩钻）',
  `level` smallint(6) NOT NULL COMMENT '玩家等级',
  `vip` smallint(6) NOT NULL COMMENT 'vip等级',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='充值商品购买日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_chat 结构
DROP TABLE IF EXISTS `log_chat`;
CREATE TABLE IF NOT EXISTS `log_chat` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(20) NOT NULL DEFAULT '' COMMENT '角色名',
  `level` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_level` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `address` varchar(39) NOT NULL DEFAULT '' COMMENT 'IP地址',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '聊天频道',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '帮派名',
  `chat_to_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '私聊对象角色id',
  `chat_to_name` varchar(20) NOT NULL DEFAULT '' COMMENT '私聊对象角色名',
  `content` varchar(1000) NOT NULL DEFAULT '' COMMENT '发言内容',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '聊天时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='聊天日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_child_item 结构
DROP TABLE IF EXISTS `log_child_item`;
CREATE TABLE IF NOT EXISTS `log_child_item` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '操作类型 1-激活 2-升级',
  `item_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '物品类型 1-时装 2-载具',
  `item_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `grade_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `grade_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`,`item_type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子时装/载具日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_child_link_heart 结构
DROP TABLE IF EXISTS `log_child_link_heart`;
CREATE TABLE IF NOT EXISTS `log_child_link_heart` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '操作类型 1-任务 2-消耗材料',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `link_heart_get` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得同心值',
  `link_heart_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前同心值',
  `link_heart_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后同心值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `type` (`role_id`,`type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子同心值日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_child_rank 结构
DROP TABLE IF EXISTS `log_child_rank`;
CREATE TABLE IF NOT EXISTS `log_child_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `child_name` varchar(255) NOT NULL DEFAULT '' COMMENT '孩子名称',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排行',
  `vote` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '投票数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子排行榜日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_child_skill 结构
DROP TABLE IF EXISTS `log_child_skill`;
CREATE TABLE IF NOT EXISTS `log_child_skill` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能Id',
  `lv_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `lv_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子技能日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_child_toy 结构
DROP TABLE IF EXISTS `log_child_toy`;
CREATE TABLE IF NOT EXISTS `log_child_toy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `suit_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '玩具套装类型',
  `toy_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具Id',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_child_toy_box 结构
DROP TABLE IF EXISTS `log_child_toy_box`;
CREATE TABLE IF NOT EXISTS `log_child_toy_box` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型 1-分解玩具 2-使用玩具精华',
  `lv_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `lv_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `exp_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前经验值',
  `exp_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后经验值',
  `toy_cost` varchar(500) CHARACTER SET utf8 NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin ROW_FORMAT=COMPACT;

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_child_upgrade 结构
DROP TABLE IF EXISTS `log_child_upgrade`;
CREATE TABLE IF NOT EXISTS `log_child_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `grade_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前阶数',
  `star_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前星数',
  `grade_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后阶数',
  `star_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后星数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cloud_buy_kf 结构
DROP TABLE IF EXISTS `log_cloud_buy_kf`;
CREATE TABLE IF NOT EXISTS `log_cloud_buy_kf` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `order_id` int(10) unsigned NOT NULL COMMENT '订单号',
  `role_uid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `platform` varchar(50) NOT NULL COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器编号',
  `count` smallint(5) unsigned NOT NULL COMMENT '数量',
  `event` tinyint(3) unsigned NOT NULL COMMENT '事件 1创建 2中奖',
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_collect_put 结构
DROP TABLE IF EXISTS `log_collect_put`;
CREATE TABLE IF NOT EXISTS `log_collect_put` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `all_reward_id` int(10) unsigned NOT NULL COMMENT '全服奖励id',
  `all_reward_type` int(10) unsigned NOT NULL COMMENT '全服奖励类型（0没有 1经验双倍 2副本双倍 3首领重置 4物品奖励）',
  `new_all_point` int(10) unsigned NOT NULL COMMENT '提交后全服提交量',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '触发的玩家id',
  `put_type` int(10) unsigned NOT NULL COMMENT '提交类型（1钻石 2物品）',
  `self_reward_id` int(10) unsigned NOT NULL COMMENT '个人奖励id',
  `self_reward_type` int(10) unsigned NOT NULL COMMENT '个人奖励类型（1普通 2累计）',
  `new_self_point` int(10) unsigned NOT NULL COMMENT '提交后个人提交量',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集活动提交信息日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_combat_uplv 结构
DROP TABLE IF EXISTS `log_combat_uplv`;
CREATE TABLE IF NOT EXISTS `log_combat_uplv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `career` varchar(50) NOT NULL COMMENT '职业',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `combat_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '总战力值',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `module_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '功能战力值',
  `log_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录时间',
  PRIMARY KEY (`id`),
  KEY `idx_id_lv` (`role_id`,`lv`),
  KEY `idx_time` (`log_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战力构成日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_come_back 结构
DROP TABLE IF EXISTS `log_come_back`;
CREATE TABLE IF NOT EXISTS `log_come_back` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `account` varchar(64) NOT NULL COMMENT '渠道账号',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '渠道来源',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '返利玩家Id',
  `nickname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '返利玩家名',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '1' COMMENT '返利等级',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `old_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '删测充值钻石',
  `return_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '返利列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `account` (`account`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='删测回归返利日志(合跨服直接合并)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_common_rank_guild 结构
DROP TABLE IF EXISTS `log_common_rank_guild`;
CREATE TABLE IF NOT EXISTS `log_common_rank_guild` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第一公会ID',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `sec_guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第二公会id',
  `sec_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会榜结算日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_common_rank_role 结构
DROP TABLE IF EXISTS `log_common_rank_role`;
CREATE TABLE IF NOT EXISTS `log_common_rank_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第一名玩家ID',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `sec_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第二名玩家id',
  `sec_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '第二名的值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `rank_type` (`rank_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用榜单结算日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_compose_evolution 结构
DROP TABLE IF EXISTS `log_compose_evolution`;
CREATE TABLE IF NOT EXISTS `log_compose_evolution` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `role_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `classify_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成分类',
  `subclass` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成子类',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成物品',
  `cost_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `auto_buy` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否自动购买##（1是；2否）',
  `result` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结果##（1成功；2失败）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_coin 结构
DROP TABLE IF EXISTS `log_consume_coin`;
CREATE TABLE IF NOT EXISTS `log_consume_coin` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费时间',
  `consume_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消费类型，1为购买',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `goods_id` bigint(20) unsigned DEFAULT '0' COMMENT '物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `cost_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗铜钱',
  `remain_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜钱余额',
  `about` text NOT NULL COMMENT '消费内容',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  PRIMARY KEY (`id`),
  KEY `consume_type` (`consume_type`),
  KEY `player_id` (`player_id`),
  KEY `goods_id` (`goods_id`),
  KEY `lv` (`lv`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='铜钱消费日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_currency 结构
DROP TABLE IF EXISTS `log_consume_currency`;
CREATE TABLE IF NOT EXISTS `log_consume_currency` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `currency_id` int(10) unsigned NOT NULL COMMENT '货币id',
  `value` int(10) unsigned NOT NULL COMMENT '消耗数量',
  `remain_value` int(10) unsigned NOT NULL COMMENT '剩余数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特殊货币消耗日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_exp 结构
DROP TABLE IF EXISTS `log_consume_exp`;
CREATE TABLE IF NOT EXISTS `log_consume_exp` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费时间',
  `consume_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消费类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `cost_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗经验',
  `remain_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验余额',
  `about` text NOT NULL COMMENT '消费内容',
  PRIMARY KEY (`id`),
  KEY `consume_type` (`consume_type`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验消费日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_gdonate 结构
DROP TABLE IF EXISTS `log_consume_gdonate`;
CREATE TABLE IF NOT EXISTS `log_consume_gdonate` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `consume_type` smallint(2) NOT NULL DEFAULT '0' COMMENT '消耗类型',
  `cost_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗贡献',
  `remain_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余贡献',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`),
  KEY `consume_type` (`consume_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会贡献消耗日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_gfame 结构
DROP TABLE IF EXISTS `log_consume_gfame`;
CREATE TABLE IF NOT EXISTS `log_consume_gfame` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费时间',
  `consume_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消费类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `goods_id` bigint(20) unsigned DEFAULT '0' COMMENT '物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `cost_gfame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗贡献',
  `remain_gfame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜钱贡献',
  `about` text NOT NULL COMMENT '消费内容',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  PRIMARY KEY (`id`),
  KEY `consume_type` (`consume_type`),
  KEY `player_id` (`player_id`),
  KEY `goods_id` (`goods_id`),
  KEY `lv` (`lv`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团贡献消费日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_gfunds 结构
DROP TABLE IF EXISTS `log_consume_gfunds`;
CREATE TABLE IF NOT EXISTS `log_consume_gfunds` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `consume_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗类型',
  `cost_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗资金',
  `remain_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余资金',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`),
  KEY `consume_type` (`consume_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会资金消耗日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_gold 结构
DROP TABLE IF EXISTS `log_consume_gold`;
CREATE TABLE IF NOT EXISTS `log_consume_gold` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费时间',
  `consume_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消费类型，1为购买',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `goods_id` bigint(20) unsigned DEFAULT '0' COMMENT '物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `cost_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗金币',
  `cost_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗银两',
  `cost_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗粉钻',
  `remain_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币余额',
  `remain_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '银两余额',
  `remain_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '粉钻余额',
  `about` text NOT NULL COMMENT '消费内容',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  PRIMARY KEY (`id`),
  KEY `consume_type` (`consume_type`),
  KEY `player_id` (`player_id`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`),
  KEY `lv` (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='元宝消费日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_consume_growth 结构
DROP TABLE IF EXISTS `log_consume_growth`;
CREATE TABLE IF NOT EXISTS `log_consume_growth` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `consume_type` smallint(2) NOT NULL DEFAULT '0' COMMENT '消耗类型',
  `cost_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗公会成长值',
  `remain_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余公会成长值',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`),
  KEY `consume_type` (`consume_type`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会成长值消耗日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_convoy_refresh 结构
DROP TABLE IF EXISTS `log_convoy_refresh`;
CREATE TABLE IF NOT EXISTS `log_convoy_refresh` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `old_object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧运送对象',
  `new_object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新运送对象',
  `cost_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `vip_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '玩家VIP等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送刷新表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_convoy_result 结构
DROP TABLE IF EXISTS `log_convoy_result`;
CREATE TABLE IF NOT EXISTS `log_convoy_result` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '运送对象',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结束时的阶段##（1-第一阶段；2-第二阶段）',
  `end_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结算类型',
  `if_double` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否双倍（1-否；2-是）',
  `goods_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送结果';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_convoy_take 结构
DROP TABLE IF EXISTS `log_convoy_take`;
CREATE TABLE IF NOT EXISTS `log_convoy_take` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型(1打劫|2被劫)',
  `object` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '运送对象',
  `taken_server` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对方服务器',
  `taken_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方id',
  `taken_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '对方名称',
  `award` varchar(50) NOT NULL DEFAULT '[]' COMMENT '打劫奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `taken_id` (`taken_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送拦截';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cost_honour 结构
DROP TABLE IF EXISTS `log_cost_honour`;
CREATE TABLE IF NOT EXISTS `log_cost_honour` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `old_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '旧数量',
  `new_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '新数量',
  `cost_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '消耗数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='荣誉值消耗日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cross_guild_war 结构
DROP TABLE IF EXISTS `log_cross_guild_war`;
CREATE TABLE IF NOT EXISTS `log_cross_guild_war` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `guild` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `filed` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '城区',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `guild` (`guild`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战参与日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cross_guild_war_conquer 结构
DROP TABLE IF EXISTS `log_cross_guild_war_conquer`;
CREATE TABLE IF NOT EXISTS `log_cross_guild_war_conquer` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `guild` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团',
  `is_lord` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否团长',
  `city` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '城区',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `zone` (`zone`),
  KEY `guild` (`guild`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战占领日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cross_guild_war_support 结构
DROP TABLE IF EXISTS `log_cross_guild_war_support`;
CREATE TABLE IF NOT EXISTS `log_cross_guild_war_support` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `guild` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
  `cost` varchar(255) NOT NULL DEFAULT '' COMMENT '花费',
  `retimes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `zone` (`zone`),
  KEY `guild` (`guild`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服国战应援日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cross_point_fight 结构
DROP TABLE IF EXISTS `log_cross_point_fight`;
CREATE TABLE IF NOT EXISTS `log_cross_point_fight` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '玩家名称',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会ID',
  `country` smallint(8) unsigned NOT NULL DEFAULT '0' COMMENT '所属国家',
  `point_id` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战据点ID',
  `point_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '据点名',
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型（1-挑战；2-扫荡）',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '进入消耗',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `point_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点贡献',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前战功',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-跨服沙盘挑战';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_cross_rank 结构
DROP TABLE IF EXISTS `log_cross_rank`;
CREATE TABLE IF NOT EXISTS `log_cross_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `nick_name` varchar(256) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '排名值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区编号',
  PRIMARY KEY (`id`),
  KEY `rank_type` (`rank_type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服个人排行榜日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_custom_act 结构
DROP TABLE IF EXISTS `log_custom_act`;
CREATE TABLE IF NOT EXISTS `log_custom_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `wlv` smallint(2) unsigned DEFAULT '0' COMMENT '世界等级',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `state` tinyint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动状态：0:活动结束，1:活动开启 2:手动关闭活动',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `state` (`state`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动开启结束日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_custom_act_hi_point 结构
DROP TABLE IF EXISTS `log_custom_act_hi_point`;
CREATE TABLE IF NOT EXISTS `log_custom_act_hi_point` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `old_score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '旧的积分',
  `add_score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '增加的积分',
  `new_score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '新的积分',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT '模块名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动积分日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_custom_act_reward 结构
DROP TABLE IF EXISTS `log_custom_act_reward`;
CREATE TABLE IF NOT EXISTS `log_custom_act_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `wlv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `gold_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖前彩钻',
  `gold_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖后彩钻',
  `bgold_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖前红钻',
  `bgold_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖后红钻',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动通用奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_daily_gift 结构
DROP TABLE IF EXISTS `log_daily_gift`;
CREATE TABLE IF NOT EXISTS `log_daily_gift` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `produce_type` varchar(256) NOT NULL DEFAULT '[]' COMMENT '礼包类型',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '获得道具id',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `produce_type` (`produce_type`(255)),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日礼包日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_degree_upgrade 结构
DROP TABLE IF EXISTS `log_degree_upgrade`;
CREATE TABLE IF NOT EXISTS `log_degree_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `degree_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '学位Id',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '学位经验',
  `dun_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '副本状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='学位晋升日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_devour 结构
DROP TABLE IF EXISTS `log_devour`;
CREATE TABLE IF NOT EXISTS `log_devour` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `exp_gain` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得吞噬经验',
  `lv_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬后等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备吞噬';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_dress_illu_lv 结构
DROP TABLE IF EXISTS `log_dress_illu_lv`;
CREATE TABLE IF NOT EXISTS `log_dress_illu_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `pre_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前经验',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `after_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装扮图鉴升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_dress_star 结构
DROP TABLE IF EXISTS `log_dress_star`;
CREATE TABLE IF NOT EXISTS `log_dress_star` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `dress_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装扮类型(1泡泡, 2相框)',
  `dress_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装扮id',
  `dress_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装扮星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `dress_id` (`dress_id`) USING BTREE,
  KEY `dress_type` (`dress_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装扮激活升星日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_drum_cost 结构
DROP TABLE IF EXISTS `log_drum_cost`;
CREATE TABLE IF NOT EXISTS `log_drum_cost` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cost` varchar(1024) NOT NULL COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战钻石消耗日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_drum_refuce 结构
DROP TABLE IF EXISTS `log_drum_refuce`;
CREATE TABLE IF NOT EXISTS `log_drum_refuce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `node` varchar(512) NOT NULL DEFAULT '' COMMENT '节点名',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战取消资格表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_drum_refuce_mail 结构
DROP TABLE IF EXISTS `log_drum_refuce_mail`;
CREATE TABLE IF NOT EXISTS `log_drum_refuce_mail` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战邮件发送记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_drum_sign 结构
DROP TABLE IF EXISTS `log_drum_sign`;
CREATE TABLE IF NOT EXISTS `log_drum_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(512) NOT NULL DEFAULT '' COMMENT '名字',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战报名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_drum_war 结构
DROP TABLE IF EXISTS `log_drum_war`;
CREATE TABLE IF NOT EXISTS `log_drum_war` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `drum` int(11) NOT NULL DEFAULT '0' COMMENT '期/届',
  `zone` int(11) NOT NULL DEFAULT '0' COMMENT '战区',
  `war` int(11) NOT NULL DEFAULT '0' COMMENT '场数',
  `wid` bigint(20) NOT NULL DEFAULT '0' COMMENT '胜方',
  `wname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `wsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `wform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '胜平台',
  `wnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜服号',
  `wlive` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜命数',
  `wpower` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜战力',
  `fid` bigint(20) NOT NULL DEFAULT '0' COMMENT '负方',
  `fname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `fsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `fform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '负平台',
  `fnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负服号',
  `flive` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负命数',
  `fpower` int(11) unsigned DEFAULT '0' COMMENT '负战力',
  `result` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜负类型1胜2负3轮空4超时',
  `time` int(11) unsigned DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `wid` (`wid`),
  KEY `fid` (`fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_dsgt 结构
DROP TABLE IF EXISTS `log_dsgt`;
CREATE TABLE IF NOT EXISTS `log_dsgt` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号ID',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活时间',
  `endtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  KEY `player_id` (`player_id`),
  KEY `id` (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='称号激活日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_dun_pet_rank_reward 结构
DROP TABLE IF EXISTS `log_dun_pet_rank_reward`;
CREATE TABLE IF NOT EXISTS `log_dun_pet_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='宠物副本排行榜日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_elite_assess_award 结构
DROP TABLE IF EXISTS `log_elite_assess_award`;
CREATE TABLE IF NOT EXISTS `log_elite_assess_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `category` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `sub_category` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子章节',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型 1-领取任务奖励 2-领取章节奖励',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励对应Id',
  `reward_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励对应名称',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `category` (`category`) USING BTREE,
  KEY `type` (`type`) USING BTREE,
  KEY `reward_id` (`reward_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='精英考核奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_elite_assess_task 结构
DROP TABLE IF EXISTS `log_elite_assess_task`;
CREATE TABLE IF NOT EXISTS `log_elite_assess_task` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `category` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `sub_category` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子章节',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `task_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '任务描述',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `category` (`category`) USING BTREE,
  KEY `task_id` (`task_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='精英考核任务日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_collect_reward 结构
DROP TABLE IF EXISTS `log_equipment_collect_reward`;
CREATE TABLE IF NOT EXISTS `log_equipment_collect_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '玩家名称',
  `lv` smallint(8) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `series` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '代数',
  `color` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备收集领奖';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_empower 结构
DROP TABLE IF EXISTS `log_equipment_empower`;
CREATE TABLE IF NOT EXISTS `log_equipment_empower` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备套数',
  `equip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `lv_before` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `lv_after` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备器灵';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_gems 结构
DROP TABLE IF EXISTS `log_equipment_gems`;
CREATE TABLE IF NOT EXISTS `log_equipment_gems` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型##1镶嵌;2摘除;3升级',
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备套数',
  `equip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `goods_id_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前宝石ID##无为0',
  `goods_id_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后宝石ID##无为0',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备宝石';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_great 结构
DROP TABLE IF EXISTS `log_equipment_great`;
CREATE TABLE IF NOT EXISTS `log_equipment_great` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备套数',
  `equip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备ID',
  `result` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '进化结果##1成功;0失败',
  `great_before` varchar(500) NOT NULL DEFAULT '[]' COMMENT '进化前属性',
  `great_after` varchar(500) NOT NULL DEFAULT '[]' COMMENT '进化后属性',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进化概率',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `goods_type_id` (`goods_type_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备进化';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_inherit 结构
DROP TABLE IF EXISTS `log_equipment_inherit`;
CREATE TABLE IF NOT EXISTS `log_equipment_inherit` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '继承类型##1手动继承;2自动继承',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备ID',
  `cost_equipment` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗装备ID',
  `attr_after` varchar(500) NOT NULL DEFAULT '[]' COMMENT '继承后属性',
  `attr_before` varchar(500) NOT NULL DEFAULT '[]' COMMENT '继承前属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `goods_type_id` (`goods_type_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备继承';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_star 结构
DROP TABLE IF EXISTS `log_equipment_star`;
CREATE TABLE IF NOT EXISTS `log_equipment_star` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '玩家名称',
  `lv` smallint(8) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `stars` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家星级',
  `stars_need` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需星级',
  `branch` tinyint(8) unsigned NOT NULL DEFAULT '0' COMMENT '选择分支',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备考核星级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_strength 结构
DROP TABLE IF EXISTS `log_equipment_strength`;
CREATE TABLE IF NOT EXISTS `log_equipment_strength` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `series` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备套数',
  `equip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备ID',
  `result` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '强化结果##1成功;0失败',
  `lv_before` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '强化前等级',
  `lv_after` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '强化后等级',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化概率',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `goods_type_id` (`goods_type_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备强化';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_task 结构
DROP TABLE IF EXISTS `log_equipment_task`;
CREATE TABLE IF NOT EXISTS `log_equipment_task` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '玩家名称',
  `lv` smallint(8) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `rfmt` varchar(500) NOT NULL DEFAULT '[]' COMMENT 'rfmt',
  `task_id` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `progress` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `desc` varchar(50) NOT NULL DEFAULT '[]' COMMENT '任务内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备考核任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_equipment_task_reward 结构
DROP TABLE IF EXISTS `log_equipment_task_reward`;
CREATE TABLE IF NOT EXISTS `log_equipment_task_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '玩家名称',
  `lv` smallint(8) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `rfmt` varchar(500) NOT NULL DEFAULT '[]' COMMENT 'rfmt',
  `opday` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `task_id` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-装备考核任务领奖';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_everyday_coin 结构
DROP TABLE IF EXISTS `log_everyday_coin`;
CREATE TABLE IF NOT EXISTS `log_everyday_coin` (
  `time` int(10) NOT NULL COMMENT '记录时间',
  `p_total_coin` bigint(20) NOT NULL COMMENT '当天总产出铜币',
  `c_total_coin` bigint(13) NOT NULL COMMENT '当天总消耗铜币',
  `total_coin` bigint(13) NOT NULL COMMENT '当天库存铜币',
  `p_total_bcoin` bigint(13) NOT NULL COMMENT '当天生产总的总绑铜币',
  `c_total_bcoin` bigint(13) NOT NULL COMMENT '当天消耗的总绑铜币',
  `total_bcoin` bigint(13) NOT NULL COMMENT '库存绑铜币',
  PRIMARY KEY (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每天铜币记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_everyday_gold 结构
DROP TABLE IF EXISTS `log_everyday_gold`;
CREATE TABLE IF NOT EXISTS `log_everyday_gold` (
  `time` int(10) NOT NULL COMMENT '记录时间',
  `avg_total` bigint(13) NOT NULL COMMENT '15天来的平均元宝',
  `cost_gold` bigint(13) NOT NULL COMMENT '消耗元宝',
  `cost_gold_admin` bigint(13) NOT NULL COMMENT '内部玩家消耗的元宝',
  `cost_bgold` bigint(13) NOT NULL COMMENT '当天消耗绑定元宝',
  `pay_gold` bigint(13) NOT NULL COMMENT '当日充值元宝',
  `total_gold` bigint(13) NOT NULL COMMENT '元宝',
  `total_gold_admin` bigint(13) DEFAULT '0' COMMENT '内玩库存元宝',
  `total_bgold_admin` bigint(13) DEFAULT '0' COMMENT '内玩绑元宝库存',
  `pay_cost_rate` varchar(10) NOT NULL COMMENT '产出消耗出',
  `remain_gold` bigint(13) DEFAULT '0' COMMENT '元宝结余数',
  PRIMARY KEY (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每天记录元宝库存数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_exp_dun 结构
DROP TABLE IF EXISTS `log_exp_dun`;
CREATE TABLE IF NOT EXISTS `log_exp_dun` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `chapter` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `wave` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数',
  `exp_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战后每分钟收益',
  `result_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '挑战类型',
  `exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '获得经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验副本日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_fashion_activate 结构
DROP TABLE IF EXISTS `log_fashion_activate`;
CREATE TABLE IF NOT EXISTS `log_fashion_activate` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `fashion_id` bigint(10) unsigned NOT NULL COMMENT '时装id',
  `color_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '颜色ID',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1激活 2续时）',
  `cost` varchar(255) NOT NULL COMMENT '激活消耗',
  `old_time` int(10) unsigned NOT NULL COMMENT '使用前时效(s)',
  `new_time` int(10) unsigned NOT NULL COMMENT '使用后时效(s)',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装激活日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_fashion_color 结构
DROP TABLE IF EXISTS `log_fashion_color`;
CREATE TABLE IF NOT EXISTS `log_fashion_color` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `color_id` int(10) unsigned NOT NULL COMMENT '需操作的颜色id',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1染色 2解锁）',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装染色/解锁颜色日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_fashion_star 结构
DROP TABLE IF EXISTS `log_fashion_star`;
CREATE TABLE IF NOT EXISTS `log_fashion_star` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '部位id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `color_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '颜色ID',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1激活 2升星）',
  `old_star_lv` int(10) unsigned NOT NULL COMMENT '旧时装星数',
  `new_star_lv` int(10) unsigned NOT NULL COMMENT '新时装星数',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装激活/升星日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_fireworks 结构
DROP TABLE IF EXISTS `log_fireworks`;
CREATE TABLE IF NOT EXISTS `log_fireworks` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次使用个数',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `all_use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计使用个数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花使用日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_fishing_harvest 结构
DROP TABLE IF EXISTS `log_fishing_harvest`;
CREATE TABLE IF NOT EXISTS `log_fishing_harvest` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `fishing_scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钓鱼场景ID',
  `fishing_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钓鱼等级',
  `fishing_water_area` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '水域距离',
  `fishing_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鱼类ID',
  `fish_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '鱼类品质',
  `maunal_or_auto` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为自动',
  `rods_usage_cost` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '鱼竿使用次数消耗',
  `energy_cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活力值消耗',
  `re_code` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '收杆结果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钓鱼收获日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_fish_illustrated_lv 结构
DROP TABLE IF EXISTS `log_fish_illustrated_lv`;
CREATE TABLE IF NOT EXISTS `log_fish_illustrated_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `illu_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '原来等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前等级',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钓鱼图鉴升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_flower 结构
DROP TABLE IF EXISTS `log_flower`;
CREATE TABLE IF NOT EXISTS `log_flower` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `sender_id` bigint(20) unsigned NOT NULL COMMENT '送礼者id',
  `receiver_id` bigint(20) unsigned NOT NULL COMMENT '接受者id',
  `goods_id` int(11) unsigned NOT NULL COMMENT '礼物物品id',
  `before_fame` int(11) unsigned NOT NULL COMMENT '前名誉值',
  `after_fame` int(11) unsigned NOT NULL COMMENT '新名誉值',
  `before_charm` int(11) unsigned NOT NULL COMMENT '前魅力值',
  `after_charm` int(11) unsigned NOT NULL COMMENT '后魅力值',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `sender_id` (`sender_id`),
  KEY `receiver_id` (`receiver_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='送花日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_foster_core_upgrade 结构
DROP TABLE IF EXISTS `log_foster_core_upgrade`;
CREATE TABLE IF NOT EXISTS `log_foster_core_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `core` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '核心类型',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前值',
  `costs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统核心日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_foster_equip 结构
DROP TABLE IF EXISTS `log_foster_equip`;
CREATE TABLE IF NOT EXISTS `log_foster_equip` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '阶位',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `bitem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前道具',
  `aitem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统技能日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_foster_equip_lv 结构
DROP TABLE IF EXISTS `log_foster_equip_lv`;
CREATE TABLE IF NOT EXISTS `log_foster_equip_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶位',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具',
  `before_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前等级',
  `before_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前经验',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后等级',
  `after_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后经验',
  `costs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统装备升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_foster_loop 结构
DROP TABLE IF EXISTS `log_foster_loop`;
CREATE TABLE IF NOT EXISTS `log_foster_loop` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `cons` varchar(255) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `curgrade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前阶',
  `curstar` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前星',
  `nextcons` varchar(255) NOT NULL DEFAULT '[]' COMMENT '下一档条件',
  `awards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='循环进阶日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_foster_skill_upgrade 结构
DROP TABLE IF EXISTS `log_foster_skill_upgrade`;
CREATE TABLE IF NOT EXISTS `log_foster_skill_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `costs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统技能日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_foster_skin_upgrade 结构
DROP TABLE IF EXISTS `log_foster_skin_upgrade`;
CREATE TABLE IF NOT EXISTS `log_foster_skin_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `skinid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '珍宝ID',
  `bef_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前星级',
  `aft_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后星级',
  `costs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶皮肤升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_foster_upgrade 结构
DROP TABLE IF EXISTS `log_foster_upgrade`;
CREATE TABLE IF NOT EXISTS `log_foster_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶位',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '祝福值',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效期',
  `autobuy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否自动购买',
  `costs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '花费',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶系统升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_galaxy_change 结构
DROP TABLE IF EXISTS `log_galaxy_change`;
CREATE TABLE IF NOT EXISTS `log_galaxy_change` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `gain` varchar(500) NOT NULL DEFAULT '[]' COMMENT '获得列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='星辰改造日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_galaxy_equip 结构
DROP TABLE IF EXISTS `log_galaxy_equip`;
CREATE TABLE IF NOT EXISTS `log_galaxy_equip` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '槽位类型',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '槽位',
  `old_item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧道具',
  `new_item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='星辰上阵日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_galaxy_pos 结构
DROP TABLE IF EXISTS `log_galaxy_pos`;
CREATE TABLE IF NOT EXISTS `log_galaxy_pos` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '槽位类型',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '槽位',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='星辰槽位解锁日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_galaxy_skin 结构
DROP TABLE IF EXISTS `log_galaxy_skin`;
CREATE TABLE IF NOT EXISTS `log_galaxy_skin` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `skin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '皮肤',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `old_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧等级',
  `new_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='星辰皮肤日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_gift 结构
DROP TABLE IF EXISTS `log_gift`;
CREATE TABLE IF NOT EXISTS `log_gift` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `gid` bigint(20) unsigned DEFAULT '0' COMMENT '物品唯一id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `gift_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `use_num` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '使用的数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启时间',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `gid` (`gid`),
  KEY `goods_id` (`goods_id`),
  KEY `gift_id` (`gift_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_gift_about 结构
DROP TABLE IF EXISTS `log_gift_about`;
CREATE TABLE IF NOT EXISTS `log_gift_about` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启时间',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `gift_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得道具id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '获得数量',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `gift_id` (`gift_id`),
  KEY `time` (`time`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包日志详情';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_gift_card_list 结构
DROP TABLE IF EXISTS `log_gift_card_list`;
CREATE TABLE IF NOT EXISTS `log_gift_card_list` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `card_no` char(50) NOT NULL COMMENT '卡号',
  `card_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '礼包卡类型',
  `gift_type` varchar(50) NOT NULL COMMENT '标识符',
  `award_list` varchar(1024) DEFAULT '[]' COMMENT '奖励列表',
  `cost_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '扣除道具[{goods_type_id, goods_id}]',
  `is_success` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '是否成功领取',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包卡领取日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_glamour_item 结构
DROP TABLE IF EXISTS `log_glamour_item`;
CREATE TABLE IF NOT EXISTS `log_glamour_item` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `runid` bigint(20) NOT NULL COMMENT '对方玩家id',
  `rname` varchar(255) NOT NULL DEFAULT '' COMMENT '对方角色名称',
  `item` bigint(20) NOT NULL COMMENT '物品',
  `ishit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否中',
  `isfree` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否免费',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跑马道具使用';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_glamour_like 结构
DROP TABLE IF EXISTS `log_glamour_like`;
CREATE TABLE IF NOT EXISTS `log_glamour_like` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `omoney` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧资金',
  `nmoney` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新资金',
  `round` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '回合',
  `logs` varchar(600) NOT NULL DEFAULT '' COMMENT '投注记录',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投注结果';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_glamour_rank 结构
DROP TABLE IF EXISTS `log_glamour_rank`;
CREATE TABLE IF NOT EXISTS `log_glamour_rank` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资金',
  `awards` varchar(600) NOT NULL DEFAULT '' COMMENT '奖励',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='资金投注排名';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_gm_mail 结构
DROP TABLE IF EXISTS `log_gm_mail`;
CREATE TABLE IF NOT EXISTS `log_gm_mail` (
  `mid` int(11) NOT NULL AUTO_INCREMENT,
  `id` int(11) NOT NULL,
  `accid` int(11) NOT NULL,
  `accname` varchar(50) NOT NULL,
  `last_login_time` int(10) NOT NULL,
  `server_id` int(11) NOT NULL,
  `nickname` varchar(2000) NOT NULL COMMENT '昵称',
  `title` varchar(512) NOT NULL,
  `content` varchar(1024) NOT NULL,
  `goods_id` int(11) NOT NULL,
  `goods_num` int(11) NOT NULL,
  `bcoin` int(11) NOT NULL,
  `coin` int(11) NOT NULL,
  `silver` int(11) NOT NULL,
  `gold` int(11) NOT NULL,
  `admin_name` varchar(50) NOT NULL,
  `ctime` int(11) NOT NULL,
  `stren` int(11) NOT NULL,
  `prefix` int(11) NOT NULL,
  `realname` varchar(50) NOT NULL,
  `minlv` int(11) NOT NULL,
  `maxlv` int(11) NOT NULL,
  `role_gold` int(11) NOT NULL,
  `pass_admin_name` varchar(50) NOT NULL,
  `special_attachment` varchar(1000) DEFAULT '[]' COMMENT '附件',
  `minvip` int(5) DEFAULT NULL,
  `maxvip` int(5) DEFAULT NULL,
  `days` int(5) NOT NULL,
  `res` text,
  PRIMARY KEY (`mid`),
  KEY `nickname` (`nickname`(255))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='后台GM邮件记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_gm_use 结构
DROP TABLE IF EXISTS `log_gm_use`;
CREATE TABLE IF NOT EXISTS `log_gm_use` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `lv` smallint(8) unsigned NOT NULL COMMENT '当前等级',
  `scene` int(10) unsigned NOT NULL COMMENT '当前场景',
  `fun_desc` varchar(255) NOT NULL COMMENT '秘籍名称',
  `fun_data` varchar(512) NOT NULL COMMENT '秘籍数据',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='秘籍使用日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_god_equip_upgrade 结构
DROP TABLE IF EXISTS `log_god_equip_upgrade`;
CREATE TABLE IF NOT EXISTS `log_god_equip_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '装备id',
  `god_id` int(11) NOT NULL DEFAULT '0' COMMENT '唤神id',
  `slot` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '当前等级',
  `old_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前经验',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '当前经验',
  `cost` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '消耗##[{装备id,是否绑定,装备等级,装备经验}|_]',
  `add_exp` int(11) NOT NULL DEFAULT '0' COMMENT '提供的经验',
  `time` int(11) unsigned DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神装备升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_god_lottery 结构
DROP TABLE IF EXISTS `log_god_lottery`;
CREATE TABLE IF NOT EXISTS `log_god_lottery` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `phase` smallint(4) NOT NULL DEFAULT '0' COMMENT '期数',
  `god_id` smallint(4) NOT NULL DEFAULT '0' COMMENT '主题唤神',
  `op_type` tinyint(2) NOT NULL DEFAULT '0' COMMENT '操作##1单抽/2十连抽/3祝福值奖励/4次数奖励',
  `add_blessing` int(11) NOT NULL DEFAULT '0' COMMENT '增加祝福值',
  `blessing` int(11) NOT NULL DEFAULT '0' COMMENT '当前祝福值',
  `counts` int(11) NOT NULL DEFAULT '0' COMMENT '总抽奖次数',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `award` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神抽奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_god_operate 结构
DROP TABLE IF EXISTS `log_god_operate`;
CREATE TABLE IF NOT EXISTS `log_god_operate` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `god_id` int(11) NOT NULL DEFAULT '0' COMMENT '唤神id',
  `op_type` smallint(2) NOT NULL DEFAULT '0' COMMENT '操作类型##1激活/2升星/3升级/5技能',
  `old_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前星数',
  `star` int(11) NOT NULL DEFAULT '0' COMMENT '当前星级',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '当前等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '当前经验值',
  `skill` varchar(500) NOT NULL DEFAULT '[]' COMMENT '当前技能状态',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家唤神操作日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_goods 结构
DROP TABLE IF EXISTS `log_goods`;
CREATE TABLE IF NOT EXISTS `log_goods` (
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出时间',
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型，1为怪物掉落',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出子类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `remark` varchar(500) NOT NULL DEFAULT '' COMMENT '备注',
  KEY `time` (`time`),
  KEY `type` (`type`),
  KEY `goods_id` (`goods_id`),
  KEY `subtype` (`subtype`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_goods_convert 结构
DROP TABLE IF EXISTS `log_goods_convert`;
CREATE TABLE IF NOT EXISTS `log_goods_convert` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `goods_id` bigint(20) NOT NULL COMMENT '原物品ID',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获得物品',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='物品转换日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_goods_exchange 结构
DROP TABLE IF EXISTS `log_goods_exchange`;
CREATE TABLE IF NOT EXISTS `log_goods_exchange` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用兑换日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_goods_sell 结构
DROP TABLE IF EXISTS `log_goods_sell`;
CREATE TABLE IF NOT EXISTS `log_goods_sell` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_type_list` varchar(1024) NOT NULL COMMENT '物品列表',
  `goods_id_list` varchar(1024) NOT NULL COMMENT '物品id列表',
  `object_list` varchar(256) NOT NULL COMMENT '获得货币',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品出售日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_group_buy 结构
DROP TABLE IF EXISTS `log_group_buy`;
CREATE TABLE IF NOT EXISTS `log_group_buy` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `gold_type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '货币类型',
  `gold_cost` int(11) NOT NULL DEFAULT '0' COMMENT '消耗货币数量',
  `gold_bef` int(11) NOT NULL DEFAULT '0' COMMENT '购买前彩钻',
  `bgold_bef` int(11) NOT NULL DEFAULT '0' COMMENT '购买前红钻',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `discount` tinyint(5) NOT NULL DEFAULT '10' COMMENT '购买时折扣',
  `buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '真实购买人数',
  `fix_buyer_count` smallint(5) NOT NULL DEFAULT '0' COMMENT '虚拟购买人数',
  `stage` tinyint(5) NOT NULL DEFAULT '0' COMMENT '购买时进度阶段',
  `stage_no_fix` tinyint(5) NOT NULL DEFAULT '0' COMMENT '购买时如果按真实人数计算的阶段',
  `stage_total` tinyint(5) NOT NULL DEFAULT '0' COMMENT '总进度阶段数',
  `vip` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='团购购买日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_group_buy_return 结构
DROP TABLE IF EXISTS `log_group_buy_return`;
CREATE TABLE IF NOT EXISTS `log_group_buy_return` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `gold_type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '货币类型',
  `gold_num` int(11) NOT NULL DEFAULT '0' COMMENT '领取货币数量',
  `discount` tinyint(5) NOT NULL DEFAULT '10' COMMENT '返还时折扣',
  `is_mail` tinyint(3) NOT NULL DEFAULT '0' COMMENT '是否通过邮件补发(0手动 1活动结束邮件发放)',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='团购返还日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild 结构
DROP TABLE IF EXISTS `log_guild`;
CREATE TABLE IF NOT EXISTS `log_guild` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '公会名字',
  `guild_flag` int(11) NOT NULL DEFAULT '0' COMMENT '社团标志',
  `guild_lv` int(11) NOT NULL DEFAULT '0' COMMENT '社团等级',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_name` varchar(100) NOT NULL DEFAULT '[]' COMMENT '玩家名字',
  `role_lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `role_vip` int(11) NOT NULL DEFAULT '0' COMMENT '玩家VIP',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`) USING BTREE,
  KEY `type` (`type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会创建解散日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_bonfire 结构
DROP TABLE IF EXISTS `log_guild_bonfire`;
CREATE TABLE IF NOT EXISTS `log_guild_bonfire` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `enter_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参加时玩家等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会篝火玩家参与信息日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_boss_guild 结构
DROP TABLE IF EXISTS `log_guild_boss_guild`;
CREATE TABLE IF NOT EXISTS `log_guild_boss_guild` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `guild_id` bigint(20) NOT NULL COMMENT '社团id',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `awards` varchar(600) NOT NULL DEFAULT '' COMMENT '奖励',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团BOSS社团排名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_boss_role 结构
DROP TABLE IF EXISTS `log_guild_boss_role`;
CREATE TABLE IF NOT EXISTS `log_guild_boss_role` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `guild_id` bigint(20) NOT NULL COMMENT '社团id',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
  `act_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动时间',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团BOSS个人排名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_boss_share 结构
DROP TABLE IF EXISTS `log_guild_boss_share`;
CREATE TABLE IF NOT EXISTS `log_guild_boss_share` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `guild_id` bigint(20) NOT NULL COMMENT '社团id',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '社团名称',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参与人数',
  `rate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '税率',
  `cash` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总计获得',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人均获得',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团BOSS分红日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_collect 结构
DROP TABLE IF EXISTS `log_guild_collect`;
CREATE TABLE IF NOT EXISTS `log_guild_collect` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团id',
  `round_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本场剩余可封印次数',
  `today_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日剩余可封印次数',
  `rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '封印采集时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团采集日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_guard 结构
DROP TABLE IF EXISTS `log_guild_guard`;
CREATE TABLE IF NOT EXISTS `log_guild_guard` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `wave_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成功守卫波数',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得经验',
  `boss_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '召唤boss次数',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会守卫日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_lives_award 结构
DROP TABLE IF EXISTS `log_guild_lives_award`;
CREATE TABLE IF NOT EXISTS `log_guild_lives_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned DEFAULT NULL COMMENT '社团id',
  `guild_name` varchar(50) NOT NULL COMMENT '社团名',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `total_live` int(11) unsigned NOT NULL COMMENT '活跃值',
  `need_live` int(11) unsigned NOT NULL COMMENT '活跃值需求',
  `awards` varchar(50) NOT NULL COMMENT '奖励',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团活跃奖励领取日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_lv 结构
DROP TABLE IF EXISTS `log_guild_lv`;
CREATE TABLE IF NOT EXISTS `log_guild_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned DEFAULT NULL COMMENT '社团id',
  `guild_name` varchar(50) NOT NULL COMMENT '社团名',
  `chief_id` bigint(20) unsigned NOT NULL COMMENT '团长id',
  `chief_name` varchar(50) NOT NULL COMMENT '团长名',
  `old_lv` int(11) unsigned NOT NULL COMMENT '旧等级',
  `new_lv` int(11) unsigned NOT NULL COMMENT '新等级',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团等级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_member 结构
DROP TABLE IF EXISTS `log_guild_member`;
CREATE TABLE IF NOT EXISTS `log_guild_member` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '唯一id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(100) NOT NULL DEFAULT '' COMMENT '公会名字',
  `event_type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '事件类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `event_param` varchar(256) NOT NULL DEFAULT '' COMMENT '事件参数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会成员日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_merge 结构
DROP TABLE IF EXISTS `log_guild_merge`;
CREATE TABLE IF NOT EXISTS `log_guild_merge` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `a_guild_id` bigint(20) unsigned DEFAULT NULL COMMENT '社团id',
  `a_guild_name` varchar(50) NOT NULL COMMENT '社团名',
  `a_chief_id` bigint(20) unsigned NOT NULL COMMENT '团长id',
  `a_chief_name` varchar(50) NOT NULL COMMENT '团长名',
  `a_num` int(11) unsigned NOT NULL COMMENT '人数',
  `opty` int(11) unsigned NOT NULL COMMENT '操作类型',
  `b_guild_id` bigint(20) unsigned DEFAULT NULL COMMENT '对方社团id',
  `b_guild_name` varchar(50) NOT NULL COMMENT '对方社团名',
  `b_live` int(11) unsigned NOT NULL COMMENT '对方活跃',
  `b_num` int(11) unsigned NOT NULL COMMENT '对方人数',
  `days` int(11) unsigned NOT NULL COMMENT '开服天数',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团合并日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_order 结构
DROP TABLE IF EXISTS `log_guild_order`;
CREATE TABLE IF NOT EXISTS `log_guild_order` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned DEFAULT NULL COMMENT '社团id',
  `guild_name` varchar(50) NOT NULL COMMENT '社团名',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `opty` int(11) unsigned NOT NULL COMMENT '操作类型0完成1发起感谢',
  `order_id` int(11) unsigned NOT NULL COMMENT '订单ID',
  `order_color` int(11) unsigned NOT NULL COMMENT '订单品质',
  `order_num` int(11) unsigned NOT NULL COMMENT '订单人数需求',
  `roles` varchar(500) NOT NULL COMMENT '参与人',
  `awards` varchar(100) NOT NULL COMMENT '奖励',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团派单日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_race_rank_guild 结构
DROP TABLE IF EXISTS `log_guild_race_rank_guild`;
CREATE TABLE IF NOT EXISTS `log_guild_race_rank_guild` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '公会名称',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会总战力',
  `guild_rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '公会排名',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`) USING BTREE,
  KEY `guild_name` (`guild_name`) USING BTREE,
  KEY `open_day` (`open_day`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='社团竞速社团排名日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_race_rank_role 结构
DROP TABLE IF EXISTS `log_guild_race_rank_role`;
CREATE TABLE IF NOT EXISTS `log_guild_race_rank_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '公会排名',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '个人战力',
  `role_rank` smallint(5) unsigned NOT NULL COMMENT '个人排名',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `open_day` (`open_day`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='社团竞速个人排名日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_rename 结构
DROP TABLE IF EXISTS `log_guild_rename`;
CREATE TABLE IF NOT EXISTS `log_guild_rename` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned DEFAULT NULL COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `old_name` varchar(50) NOT NULL COMMENT '原社团名',
  `new_name` varchar(50) NOT NULL COMMENT '新社团名',
  `old_flag` int(11) unsigned NOT NULL COMMENT '旧标志',
  `new_flag` int(11) unsigned NOT NULL COMMENT '新标志',
  `cost` varchar(50) NOT NULL COMMENT '花费',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团改名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_reply 结构
DROP TABLE IF EXISTS `log_guild_reply`;
CREATE TABLE IF NOT EXISTS `log_guild_reply` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_skill 结构
DROP TABLE IF EXISTS `log_guild_skill`;
CREATE TABLE IF NOT EXISTS `log_guild_skill` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会等级',
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑等级',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级前等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级后等级',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗贡献',
  `old_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前战力日志',
  `new_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_support_reward 结构
DROP TABLE IF EXISTS `log_guild_support_reward`;
CREATE TABLE IF NOT EXISTS `log_guild_support_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `supporter` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助者Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `support_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '协助单Id',
  `cfg_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '协助配置Id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '协助结果类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='协助单结算日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_war_guild_rank 结构
DROP TABLE IF EXISTS `log_guild_war_guild_rank`;
CREATE TABLE IF NOT EXISTS `log_guild_war_guild_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '社团ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-社团战本服-社团排名';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_guild_war_role_rank 结构
DROP TABLE IF EXISTS `log_guild_war_role_rank`;
CREATE TABLE IF NOT EXISTS `log_guild_war_role_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `kill_rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '击杀排名',
  `max_kill` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '击杀数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-社团战本服-个人排名';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_hope_gift_buy 结构
DROP TABLE IF EXISTS `log_hope_gift_buy`;
CREATE TABLE IF NOT EXISTS `log_hope_gift_buy` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `gold_cost` int(11) NOT NULL DEFAULT '0' COMMENT '消耗彩钻',
  `gold_before` int(11) NOT NULL DEFAULT '0' COMMENT '购买前彩钻',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `level` smallint(5) NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='明日之礼购买日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_hope_gift_draw 结构
DROP TABLE IF EXISTS `log_hope_gift_draw`;
CREATE TABLE IF NOT EXISTS `log_hope_gift_draw` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `round` smallint(5) NOT NULL DEFAULT '0' COMMENT '当前轮次',
  `cost` smallint(5) NOT NULL DEFAULT '0' COMMENT '消耗抽奖道具数量',
  `item_before` int(11) NOT NULL DEFAULT '0' COMMENT '抽奖前抽奖道具数量',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='明日之礼抽奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_hope_gift_return 结构
DROP TABLE IF EXISTS `log_hope_gift_return`;
CREATE TABLE IF NOT EXISTS `log_hope_gift_return` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `return_amount` int(11) NOT NULL DEFAULT '0' COMMENT '已返还数量',
  `return_left` int(11) NOT NULL DEFAULT '0' COMMENT '待返还数量',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='明日之礼返还日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_intimacy 结构
DROP TABLE IF EXISTS `log_intimacy`;
CREATE TABLE IF NOT EXISTS `log_intimacy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方玩家id',
  `pre_intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '之前亲密度',
  `way` smallint(2) NOT NULL DEFAULT '0' COMMENT '添加途径',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前亲密度',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `other_rid` (`other_rid`),
  KEY `way` (`way`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='亲密度日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_investment 结构
DROP TABLE IF EXISTS `log_investment`;
CREATE TABLE IF NOT EXISTS `log_investment` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '投资类型',
  `grade` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '投资档次',
  `award_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `award_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `award_condition` varchar(50) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投资领奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_join 结构
DROP TABLE IF EXISTS `log_join`;
CREATE TABLE IF NOT EXISTS `log_join` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能活动参与日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_joy_wish 结构
DROP TABLE IF EXISTS `log_joy_wish`;
CREATE TABLE IF NOT EXISTS `log_joy_wish` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `w_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `wish_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `cost` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='欢乐许愿日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_kf_1vn_auction 结构
DROP TABLE IF EXISTS `log_kf_1vn_auction`;
CREATE TABLE IF NOT EXISTS `log_kf_1vn_auction` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `auction_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖配置id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次出价',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总价',
  `voucher` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗代金券数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `auction_id` (`auction_id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_kf_1vn_bet 结构
DROP TABLE IF EXISTS `log_kf_1vn_bet`;
CREATE TABLE IF NOT EXISTS `log_kf_1vn_bet` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名字',
  `turn` tinyint(3) unsigned NOT NULL COMMENT '轮次',
  `battle_id` int(10) unsigned NOT NULL COMMENT '战斗场次',
  `bet_side` tinyint(3) unsigned NOT NULL COMMENT '押注选择',
  `money` int(10) unsigned NOT NULL COMMENT '押注金额',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn押注日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_kf_1vn_race_1 结构
DROP TABLE IF EXISTS `log_kf_1vn_race_1`;
CREATE TABLE IF NOT EXISTS `log_kf_1vn_race_1` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `area` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `win_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '胜方id',
  `win_server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜方服id',
  `win_server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜方服数',
  `win_name` varchar(200) NOT NULL DEFAULT '' COMMENT '胜方名字',
  `win_cp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜方战斗力',
  `win_score` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '胜方积分',
  `lose_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '负方id',
  `lose_server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负方服id',
  `lose_server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负方服数',
  `lose_name` varchar(200) NOT NULL DEFAULT '' COMMENT '负方名字',
  `lose_cp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负方战斗力',
  `lose_score` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '负方积分',
  `win_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '胜利方式',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `win_id` (`win_id`),
  KEY `lose_id` (`lose_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn资格赛日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_kf_1vn_race_2 结构
DROP TABLE IF EXISTS `log_kf_1vn_race_2`;
CREATE TABLE IF NOT EXISTS `log_kf_1vn_race_2` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `area` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `turn` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `battle_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗场次',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '名字',
  `cp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗力',
  `def_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否擂主',
  `win` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '胜负',
  `win_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '胜负方式',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结算状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `battle_id` (`battle_id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂台赛日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_kf_1vn_sign 结构
DROP TABLE IF EXISTS `log_kf_1vn_sign`;
CREATE TABLE IF NOT EXISTS `log_kf_1vn_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn报名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_kf_cloud_buy_draw 结构
DROP TABLE IF EXISTS `log_kf_cloud_buy_draw`;
CREATE TABLE IF NOT EXISTS `log_kf_cloud_buy_draw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `server_num` int(10) unsigned NOT NULL COMMENT '服务器标识',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `reward_lv` varchar(255) NOT NULL COMMENT '奖励类型',
  `product_name` varchar(255) NOT NULL DEFAULT '' COMMENT '商品名字',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购开奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_kf_cloud_buy_purchase 结构
DROP TABLE IF EXISTS `log_kf_cloud_buy_purchase`;
CREATE TABLE IF NOT EXISTS `log_kf_cloud_buy_purchase` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `server_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '第几服',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `product_name` varchar(255) NOT NULL DEFAULT '' COMMENT '商品名字',
  `buy_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '购买份数',
  `buy_reward` varchar(1024) NOT NULL DEFAULT '' COMMENT '购买奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购购买日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_lattice 结构
DROP TABLE IF EXISTS `log_lattice`;
CREATE TABLE IF NOT EXISTS `log_lattice` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `circle` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `pre_step` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '旧步数',
  `pass_step` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '本次行步',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='器灵寻宝-走格子日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_level_award 结构
DROP TABLE IF EXISTS `log_level_award`;
CREATE TABLE IF NOT EXISTS `log_level_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `role_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `role_career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '角色职业',
  `gift_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `lv_need` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级要求',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `limit_award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '额外奖励获取',
  `limit_remain` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '额外奖励剩余',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲级礼包日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_level_rate 结构
DROP TABLE IF EXISTS `log_level_rate`;
CREATE TABLE IF NOT EXISTS `log_level_rate` (
  `optiontime` int(10) NOT NULL COMMENT '操作时间',
  `data` text NOT NULL COMMENT '当天数据',
  `r_total` int(11) NOT NULL COMMENT '到当天为止总注册人数',
  `l_total` int(11) NOT NULL COMMENT '至当天为止24小时未登录人数',
  PRIMARY KEY (`optiontime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='等级流失表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_limit_goal_reward 结构
DROP TABLE IF EXISTS `log_limit_goal_reward`;
CREATE TABLE IF NOT EXISTS `log_limit_goal_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(10) unsigned NOT NULL COMMENT '玩家等级',
  `vip` tinyint(2) unsigned NOT NULL COMMENT '贵族等级',
  `goal_id` smallint(10) unsigned NOT NULL COMMENT '目标id',
  `task_id` smallint(10) unsigned NOT NULL COMMENT '任务id',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-奖励领取日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_limit_goal_task 结构
DROP TABLE IF EXISTS `log_limit_goal_task`;
CREATE TABLE IF NOT EXISTS `log_limit_goal_task` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(10) unsigned NOT NULL COMMENT '玩家等级',
  `vip` tinyint(2) unsigned NOT NULL COMMENT '贵族等级',
  `goal_id` smallint(10) unsigned NOT NULL COMMENT '目标id',
  `task_id` smallint(10) unsigned NOT NULL COMMENT '任务id',
  `condition` varchar(255) NOT NULL COMMENT '完成条件',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-任务完成日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_liveness_up 结构
DROP TABLE IF EXISTS `log_liveness_up`;
CREATE TABLE IF NOT EXISTS `log_liveness_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级前外形等级',
  `liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级消耗活跃度',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级后外形等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度外形升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_live_skill_handle 结构
DROP TABLE IF EXISTS `log_live_skill_handle`;
CREATE TABLE IF NOT EXISTS `log_live_skill_handle` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧技能等级',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加成熟度',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新技能等级',
  `cost_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗活力',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `reward` varchar(50) NOT NULL DEFAULT '[]' COMMENT '获得内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='生活技能烹饪/打造日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_local_picture 结构
DROP TABLE IF EXISTS `log_local_picture`;
CREATE TABLE IF NOT EXISTS `log_local_picture` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `profile_photo_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头像id',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='更改本地头像日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_local_vie_rank 结构
DROP TABLE IF EXISTS `log_local_vie_rank`;
CREATE TABLE IF NOT EXISTS `log_local_vie_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `act` int(11) unsigned NOT NULL COMMENT '活动Id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `rtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  `dtime` int(11) NOT NULL DEFAULT '0' COMMENT '有效时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='封榜活动本地日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_login 结构
DROP TABLE IF EXISTS `log_login`;
CREATE TABLE IF NOT EXISTS `log_login` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `ip` varchar(50) NOT NULL DEFAULT '' COMMENT '登录IP',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '登录时间',
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `accname` varchar(100) NOT NULL COMMENT '账号',
  `login_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '登录类型(1登录2重连)',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`),
  KEY `accname` (`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='登录日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_login_logout 结构
DROP TABLE IF EXISTS `log_login_logout`;
CREATE TABLE IF NOT EXISTS `log_login_logout` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `scene_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '场景Id',
  `ip` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家IP',
  `network_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '网络类型',
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台PID',
  `accname` varchar(100) NOT NULL COMMENT '账号',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='登录登出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_login_return_reward 结构
DROP TABLE IF EXISTS `log_login_return_reward`;
CREATE TABLE IF NOT EXISTS `log_login_return_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `cost` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `subtype` (`subtype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='0元豪礼日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_login_reward_day 结构
DROP TABLE IF EXISTS `log_login_reward_day`;
CREATE TABLE IF NOT EXISTS `log_login_reward_day` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `day_id` int(10) unsigned NOT NULL COMMENT '天数id',
  `get_date` int(10) unsigned NOT NULL COMMENT '获得的当日0点时间戳',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='七天登录奖励日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_login_statis 结构
DROP TABLE IF EXISTS `log_login_statis`;
CREATE TABLE IF NOT EXISTS `log_login_statis` (
  `time` int(10) NOT NULL COMMENT '记录时间',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '来源',
  `lv_num` int(11) NOT NULL COMMENT '10级以上人数',
  `login_num` int(11) NOT NULL COMMENT '二天登录人数',
  `login_ip_num` int(11) NOT NULL COMMENT '登录IP数',
  `lv_json` text NOT NULL COMMENT '二天登录人数对应等级分布人数',
  PRIMARY KEY (`time`,`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='连续登录统计';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_lucky_flop_draw 结构
DROP TABLE IF EXISTS `log_lucky_flop_draw`;
CREATE TABLE IF NOT EXISTS `log_lucky_flop_draw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '活动子类型',
  `cost` varchar(255) NOT NULL COMMENT '消耗列表',
  `reward` varchar(512) NOT NULL COMMENT '奖励列表',
  `now_times` tinyint(1) unsigned NOT NULL COMMENT '抽奖次数',
  `turn` smallint(5) unsigned NOT NULL COMMENT '当前轮数',
  `total_times` smallint(5) unsigned NOT NULL COMMENT '累计抽奖次数',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`),
  KEY `sub_type` (`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌-抽奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_lucky_flop_receive 结构
DROP TABLE IF EXISTS `log_lucky_flop_receive`;
CREATE TABLE IF NOT EXISTS `log_lucky_flop_receive` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '活动子类型',
  `reward` varchar(512) NOT NULL COMMENT '奖励列表',
  `times` tinyint(1) unsigned NOT NULL COMMENT '奖励档次',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`),
  KEY `sub_type` (`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌-累计奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_lucky_flop_reset 结构
DROP TABLE IF EXISTS `log_lucky_flop_reset`;
CREATE TABLE IF NOT EXISTS `log_lucky_flop_reset` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL COMMENT '重置类型(1收费 0免费)',
  `cost_list` varchar(255) NOT NULL COMMENT '重置消耗',
  `turn` int(11) unsigned NOT NULL COMMENT '当前轮数',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌-重置日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_madness_land_role_reward 结构
DROP TABLE IF EXISTS `log_madness_land_role_reward`;
CREATE TABLE IF NOT EXISTS `log_madness_land_role_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `role_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人排名',
  `guild_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '隶属社团id',
  `guild_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '社团名称',
  `guild_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-排名奖励（本服）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_madness_land_role_reward_kf 结构
DROP TABLE IF EXISTS `log_madness_land_role_reward_kf`;
CREATE TABLE IF NOT EXISTS `log_madness_land_role_reward_kf` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本服排名',
  `guild_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '隶属社团id',
  `guild_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '公会名',
  `guild_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '社团排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `zone_id` (`zone_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-排名奖励（跨服）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mail_clear 结构
DROP TABLE IF EXISTS `log_mail_clear`;
CREATE TABLE IF NOT EXISTS `log_mail_clear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '附件',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `effect_st` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '有效开始时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `rid` (`rid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件后台删除日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mail_get 结构
DROP TABLE IF EXISTS `log_mail_get`;
CREATE TABLE IF NOT EXISTS `log_mail_get` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `mail_id` bigint(20) unsigned NOT NULL COMMENT '邮件id',
  `sid` bigint(20) unsigned NOT NULL COMMENT '发件人id',
  `rid` bigint(20) unsigned NOT NULL COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '普通附件',
  `timestamp` bigint(21) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳（微秒）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '插入时间',
  PRIMARY KEY (`id`),
  KEY `sid` (`sid`),
  KEY `timestamp` (`timestamp`),
  KEY `rid` (`rid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件领取日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mail_send 结构
DROP TABLE IF EXISTS `log_mail_send`;
CREATE TABLE IF NOT EXISTS `log_mail_send` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `mail_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '邮件id',
  `sid` bigint(20) unsigned NOT NULL COMMENT '发件人id',
  `rid` bigint(20) unsigned NOT NULL COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '普通附件',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '插入时间',
  PRIMARY KEY (`id`),
  KEY `sid` (`sid`),
  KEY `rid` (`rid`),
  KEY `mail_id` (`mail_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件发送日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_marble 结构
DROP TABLE IF EXISTS `log_marble`;
CREATE TABLE IF NOT EXISTS `log_marble` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `qual_id` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '品质ID',
  `award` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `increase_point` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '增加能量点',
  `current_point` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '当前能量点',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='器灵寻宝';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_market_operation 结构
DROP TABLE IF EXISTS `log_market_operation`;
CREATE TABLE IF NOT EXISTS `log_market_operation` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `market_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家Id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '卖方名称',
  `vip` tinyint(8) unsigned NOT NULL DEFAULT '0' COMMENT '卖方VIP',
  `get_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '获得玩家Id',
  `get_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '买方名称',
  `get_vip` tinyint(8) unsigned NOT NULL DEFAULT '0' COMMENT '买方VIP',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型Id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `lev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品等级',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品品质',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交价格',
  `tax` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易税',
  `sell_type` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '上架类型：1:世界上架2:帮派上架',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `deal_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交类型:0:竞价1:一口价',
  `operation_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型:1:上架2:下架3:成交',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '物品额外特殊属性',
  `on_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上架时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_market_race 结构
DROP TABLE IF EXISTS `log_market_race`;
CREATE TABLE IF NOT EXISTS `log_market_race` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `market_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '竞拍玩家名称',
  `vip` tinyint(8) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍玩家VIP',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍玩家出价',
  `last_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '上个竞拍者ID',
  `last_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '上个竞拍者名称',
  `last_vip` tinyint(8) unsigned NOT NULL DEFAULT '0' COMMENT '上个竞拍者VIP',
  `last_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上个竞拍者出价',
  `origin_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上架价格',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `left_time` int(11) NOT NULL DEFAULT '0' COMMENT '剩余时间(秒)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `market_id` (`market_id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-拍卖竞价';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mate_anniversary 结构
DROP TABLE IF EXISTS `log_mate_anniversary`;
CREATE TABLE IF NOT EXISTS `log_mate_anniversary` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方角色ID',
  `other_rname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '获取的奖励',
  `need_day` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '需求天数',
  `own_day` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '羁绊建立天数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `other_rid` (`other_rid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-纪念日奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mate_boat 结构
DROP TABLE IF EXISTS `log_mate_boat`;
CREATE TABLE IF NOT EXISTS `log_mate_boat` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `grade` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '阶位',
  `star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成长值',
  `costs` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-小船升级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mate_rela 结构
DROP TABLE IF EXISTS `log_mate_rela`;
CREATE TABLE IF NOT EXISTS `log_mate_rela` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方角色ID',
  `other_rname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型##（1.建立羁绊，2强制解除，3协议解除）',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `other_rid` (`other_rid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-关系';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mobilize_award 结构
DROP TABLE IF EXISTS `log_mobilize_award`;
CREATE TABLE IF NOT EXISTS `log_mobilize_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '1任务奖励2天奖励',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '天数对应',
  `end_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束天数',
  `tasktype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'gold后',
  `taskid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖后积分',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`),
  KEY `act_id` (`act_id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全民动员领奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_mobilize_progress 结构
DROP TABLE IF EXISTS `log_mobilize_progress`;
CREATE TABLE IF NOT EXISTS `log_mobilize_progress` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `act` int(11) unsigned NOT NULL COMMENT '活动',
  `task_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `desc` varchar(200) NOT NULL DEFAULT '[]' COMMENT '描述',
  `fake` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '假数ID',
  `process` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `real_pro` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '真实进度',
  `day` int(11) NOT NULL DEFAULT '0' COMMENT '第几天',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全民动员进度日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_multi_dungeon 结构
DROP TABLE IF EXISTS `log_multi_dungeon`;
CREATE TABLE IF NOT EXISTS `log_multi_dungeon` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '唯一编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `node` varchar(255) NOT NULL DEFAULT 'undefined' COMMENT '玩家节点',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `diff_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本难度',
  `team_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '队伍id',
  `help_type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '是否助战##0:非助战,1:助战',
  `role_id1` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '队友1的id',
  `node1` varchar(255) NOT NULL DEFAULT 'undefined' COMMENT '玩家1节点',
  `role_id2` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '队友2的id',
  `node2` varchar(255) NOT NULL DEFAULT 'undefined' COMMENT '玩家2节点',
  `role_id3` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '队友3的id',
  `node3` varchar(255) NOT NULL DEFAULT 'undefined' COMMENT '玩家3节点',
  `reward_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '掉落奖励',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评级',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分数',
  `level_score_list` varchar(3000) NOT NULL DEFAULT '[]' COMMENT '关卡分数##[{关卡,开始时间,结束时间,关卡结算时间,分数}]',
  `intimacy_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '亲密度分数列表##[{对方id,亲密度,亲密度等级,分数}]',
  `rela_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '好友加分##[{玩家id,好友类型,是否请求加好友,分数}]',
  `guild_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '公会积分##[{玩家id,公会id,是否邀请进入公会,分数}]',
  `time_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '时间分数##[{开始时间,结束时间,通关时间,分数}]',
  `mon_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物积分',
  `result_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `result_subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `log_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `dun_id` (`dun_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='多人副本';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_normal_combat_power 结构
DROP TABLE IF EXISTS `log_normal_combat_power`;
CREATE TABLE IF NOT EXISTS `log_normal_combat_power` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `name` varchar(255) NOT NULL COMMENT '名字',
  `module_id` int(11) unsigned NOT NULL COMMENT '功能id',
  `type` int(11) unsigned NOT NULL COMMENT '操作类型',
  `old_power` int(11) unsigned NOT NULL COMMENT '操作前战力',
  `new_power` int(11) unsigned NOT NULL COMMENT '操作后战力',
  `change_power` int(11) NOT NULL COMMENT '战力变化',
  `remark` varchar(512) NOT NULL COMMENT '备注@lang@',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用战力日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_equip 结构
DROP TABLE IF EXISTS `log_nucleon_equip`;
CREATE TABLE IF NOT EXISTS `log_nucleon_equip` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型0穿1脱',
  `slot` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '槽位',
  `old_item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧道具',
  `new_item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='灵能装备穿戴日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_equip_evo 结构
DROP TABLE IF EXISTS `log_nucleon_equip_evo`;
CREATE TABLE IF NOT EXISTS `log_nucleon_equip_evo` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `item` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进化前',
  `next` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进化后',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `uid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '消耗道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='灵能进化日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_equip_recast 结构
DROP TABLE IF EXISTS `log_nucleon_equip_recast`;
CREATE TABLE IF NOT EXISTS `log_nucleon_equip_recast` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `main_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '装备ID',
  `main_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `main_attr_bef` varchar(500) NOT NULL DEFAULT '[]' COMMENT '前主属性',
  `main_attr_aft` varchar(500) NOT NULL DEFAULT '[]' COMMENT '后主属性',
  `sub_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '从装备ID',
  `sub_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '从物品ID',
  `sub_attr` varchar(500) NOT NULL DEFAULT '[]' COMMENT '从属性',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `goods_id` (`main_goods_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-灵装洗练';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_equip_upgrade 结构
DROP TABLE IF EXISTS `log_nucleon_equip_upgrade`;
CREATE TABLE IF NOT EXISTS `log_nucleon_equip_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '槽位',
  `lv_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前等级',
  `exp_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前经验',
  `lv_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后等级',
  `exp_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后经验',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-灵装升级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_exchange 结构
DROP TABLE IF EXISTS `log_nucleon_exchange`;
CREATE TABLE IF NOT EXISTS `log_nucleon_exchange` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `gain` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='灵能兑换日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_hunt 结构
DROP TABLE IF EXISTS `log_nucleon_hunt`;
CREATE TABLE IF NOT EXISTS `log_nucleon_hunt` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖池类型1普通2高级',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '1单抽2十连',
  `is_free` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否免费',
  `awards` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '获得',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-灵装抽奖';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_lv 结构
DROP TABLE IF EXISTS `log_nucleon_lv`;
CREATE TABLE IF NOT EXISTS `log_nucleon_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='灵能升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_resolve 结构
DROP TABLE IF EXISTS `log_nucleon_resolve`;
CREATE TABLE IF NOT EXISTS `log_nucleon_resolve` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `gains` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '获得',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-灵装分解';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_nucleon_section 结构
DROP TABLE IF EXISTS `log_nucleon_section`;
CREATE TABLE IF NOT EXISTS `log_nucleon_section` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-灵装觉醒';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_offline 结构
DROP TABLE IF EXISTS `log_offline`;
CREATE TABLE IF NOT EXISTS `log_offline` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `offline_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '登出类型',
  `power` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家下线时战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家登出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_offline_hosting 结构
DROP TABLE IF EXISTS `log_offline_hosting`;
CREATE TABLE IF NOT EXISTS `log_offline_hosting` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能ID',
  `sub_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '子ID',
  `cost_value` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '托管值',
  `award` varchar(2000) NOT NULL DEFAULT '' COMMENT '奖励记录',
  `duration` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '持续时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线托管日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_offline_hosting_change 结构
DROP TABLE IF EXISTS `log_offline_hosting_change`;
CREATE TABLE IF NOT EXISTS `log_offline_hosting_change` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `ai_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前托管值',
  `ai_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后托管值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='托管值结算日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_onhook_fast 结构
DROP TABLE IF EXISTS `log_onhook_fast`;
CREATE TABLE IF NOT EXISTS `log_onhook_fast` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `vip_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `times` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '今日领取次数',
  `rest_times` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '领取剩余次数',
  `pre_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前彩钻数',
  `after_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后彩钻数',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗彩钻数',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家获得经验',
  `rewards` varchar(800) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='快速放置冒险日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_onhook_result 结构
DROP TABLE IF EXISTS `log_onhook_result`;
CREATE TABLE IF NOT EXISTS `log_onhook_result` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `start_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖前等级',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖后等级',
  `exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家获得经验',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗挂机时长(s)',
  `rewards` varchar(800) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='放置冒险日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_online 结构
DROP TABLE IF EXISTS `log_online`;
CREATE TABLE IF NOT EXISTS `log_online` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总在线',
  `online` varchar(100) NOT NULL COMMENT '各线人数',
  `timestamp` int(11) unsigned NOT NULL COMMENT '时间戳',
  `onhook` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '离线挂机玩家人数',
  PRIMARY KEY (`id`),
  KEY `timestamp` (`timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='在线人数统计';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_pellet_daily 结构
DROP TABLE IF EXISTS `log_pellet_daily`;
CREATE TABLE IF NOT EXISTS `log_pellet_daily` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `subtype` smallint(5) NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) NOT NULL DEFAULT '0' COMMENT '奖励档位',
  `cond_type` tinyint(3) NOT NULL DEFAULT '0' COMMENT '条件类型（1充2消）',
  `gold_need` int(11) NOT NULL DEFAULT '0' COMMENT '领取档位奖励所需钻石数',
  `gold_total` int(11) NOT NULL DEFAULT '0' COMMENT '领取奖励时充值/消费总额',
  `is_mail` tinyint(3) NOT NULL DEFAULT '0' COMMENT '是否系统自动邮件补发（0否1是）',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `vip` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠累充累消活动档次奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_pellet_draw 结构
DROP TABLE IF EXISTS `log_pellet_draw`;
CREATE TABLE IF NOT EXISTS `log_pellet_draw` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '日志id',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `round` smallint(5) NOT NULL DEFAULT '0' COMMENT '抽奖轮次',
  `award_type` tinyint(3) NOT NULL DEFAULT '1' COMMENT '1抽奖 2次数奖励',
  `award_id` int(11) NOT NULL DEFAULT '0' COMMENT '奖励id',
  `award_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `times` smallint(3) NOT NULL DEFAULT '0' COMMENT '抽奖后本轮累计抽取次数',
  `vip` tinyint(3) NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `vaild` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '抽奖是否通过校验（仅限抽奖）',
  `draw_grade` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '抽中的品质（仅限抽奖）',
  `draw_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始抽奖时间（仅限抽奖）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获取奖励的时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累充消费弹珠抽奖奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_personal_auction 结构
DROP TABLE IF EXISTS `log_personal_auction`;
CREATE TABLE IF NOT EXISTS `log_personal_auction` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物品id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `ctrl_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型:1上架,2结算',
  `auction_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖状态',
  `top_player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '获得玩家id',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交价格',
  `close_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '预估结算时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `top_player_id` (`top_player_id`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人拍卖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_pet_grow 结构
DROP TABLE IF EXISTS `log_pet_grow`;
CREATE TABLE IF NOT EXISTS `log_pet_grow` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `stars_bef` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '培养前星数',
  `grade_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '培养前等级',
  `exp_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '培养前经验',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型 1-激活 2喂养 3升阶 4觉醒',
  `stars_aft` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '培养后星数',
  `grade_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '培养后等级',
  `exp_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '培养后经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `pet_id` (`pet_id`) USING BTREE,
  KEY `type` (`type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='宠物养成日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_pet_jewel 结构
DROP TABLE IF EXISTS `log_pet_jewel`;
CREATE TABLE IF NOT EXISTS `log_pet_jewel` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作位置 1构造 2律动 3原力 4灵能',
  `item_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前该位置物品Id',
  `item_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后该位置物品Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `pet_id` (`pet_id`) USING BTREE,
  KEY `pos` (`pos`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='宠物宝石日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_phase_exchange 结构
DROP TABLE IF EXISTS `log_phase_exchange`;
CREATE TABLE IF NOT EXISTS `log_phase_exchange` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `sub_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `lv_need` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励等级范围',
  `store_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型 1-兑换 2-开启阶段',
  `reward_list` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励列表',
  `goods_cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗物品Id',
  `num_cost` mediumint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消耗数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='阶段兑换日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_picture 结构
DROP TABLE IF EXISTS `log_picture`;
CREATE TABLE IF NOT EXISTS `log_picture` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `picture` varchar(200) NOT NULL DEFAULT '[]' COMMENT '头像地址',
  `picture_ver` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头像版本号',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='头像上传日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_pic_lv 结构
DROP TABLE IF EXISTS `log_pic_lv`;
CREATE TABLE IF NOT EXISTS `log_pic_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_player_attr 结构
DROP TABLE IF EXISTS `log_player_attr`;
CREATE TABLE IF NOT EXISTS `log_player_attr` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `hightest_combat_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '最高战力',
  `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `activity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存彩钻',
  `bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存红钻',
  `trade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存交易券',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存名望券',
  `total_money` decimal(12,2) DEFAULT '0.00' COMMENT '总充值金额',
  `total_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总充值元宝',
  `recency` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最近充值指标',
  `frequency` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '充值频率指标',
  `monetary` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '总充值指标',
  `top` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最高充值指标',
  `is_login` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '今日是否登陆',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家每日属性记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_player_daily 结构
DROP TABLE IF EXISTS `log_player_daily`;
CREATE TABLE IF NOT EXISTS `log_player_daily` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `activity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度',
  `daily_task` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '每日跑环进度',
  `guild_task` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '社团跑环进度',
  `fast_onhook_left` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '剩余超级加速次数',
  `sup_vip_state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '贵族状态（0未激活 1体验 2永久）',
  `current_hosting` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '当前总托管值',
  `today_hosting` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '今日获得托管值',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存彩钻',
  `bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存红钻',
  `trade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '库存交易券',
  `is_login` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '今日是否登陆',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家每日活跃记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_power_live 结构
DROP TABLE IF EXISTS `log_power_live`;
CREATE TABLE IF NOT EXISTS `log_power_live` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能模块',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `old_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧活力值',
  `change_live` varchar(50) NOT NULL DEFAULT '0' COMMENT '变化值',
  `new_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新活力值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活力变化日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_coin 结构
DROP TABLE IF EXISTS `log_produce_coin`;
CREATE TABLE IF NOT EXISTS `log_produce_coin` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产时间',
  `produce_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '生产类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `got_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产铜钱',
  `remain_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜钱余额',
  `about` text NOT NULL COMMENT '生产内容',
  PRIMARY KEY (`id`),
  KEY `produce_type` (`produce_type`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='铜钱生产日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_currency 结构
DROP TABLE IF EXISTS `log_produce_currency`;
CREATE TABLE IF NOT EXISTS `log_produce_currency` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `currency_id` int(10) unsigned NOT NULL COMMENT '货币id',
  `got_value` int(10) unsigned NOT NULL COMMENT '获得数量',
  `remain_value` int(10) unsigned NOT NULL COMMENT '现有数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特殊货币产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_gdonate 结构
DROP TABLE IF EXISTS `log_produce_gdonate`;
CREATE TABLE IF NOT EXISTS `log_produce_gdonate` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `produce_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `add_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得贡献',
  `remain_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余贡献',
  `historical_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史最高贡献',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `produce_type` (`produce_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会贡献产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_gfame 结构
DROP TABLE IF EXISTS `log_produce_gfame`;
CREATE TABLE IF NOT EXISTS `log_produce_gfame` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产时间',
  `produce_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '生产类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `got_gfame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产贡献',
  `remain_gfame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '贡献余额',
  `about` text NOT NULL COMMENT '生产内容',
  PRIMARY KEY (`id`),
  KEY `produce_type` (`produce_type`) USING BTREE,
  KEY `player_id` (`player_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贡献生产日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_gfunds 结构
DROP TABLE IF EXISTS `log_produce_gfunds`;
CREATE TABLE IF NOT EXISTS `log_produce_gfunds` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `produce_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `got_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得资金',
  `remain_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余资金',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `produce_type` (`produce_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会资金产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_gold 结构
DROP TABLE IF EXISTS `log_produce_gold`;
CREATE TABLE IF NOT EXISTS `log_produce_gold` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产时间',
  `produce_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '生产类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `got_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产金币',
  `got_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产银两',
  `got_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产粉钻',
  `remain_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币余额',
  `remain_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '银两余额',
  `remain_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '粉钻余额',
  `about` text NOT NULL COMMENT '生产内容',
  PRIMARY KEY (`id`),
  KEY `produce_type` (`produce_type`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='元宝生产日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_growth 结构
DROP TABLE IF EXISTS `log_produce_growth`;
CREATE TABLE IF NOT EXISTS `log_produce_growth` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `produce_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `add_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加成长值',
  `remain_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余成长值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `produce_type` (`produce_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会成长值产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_honour 结构
DROP TABLE IF EXISTS `log_produce_honour`;
CREATE TABLE IF NOT EXISTS `log_produce_honour` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `old_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '旧数量',
  `new_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '新数量',
  `got_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '获得数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='荣誉值产出日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_produce_reputation 结构
DROP TABLE IF EXISTS `log_produce_reputation`;
CREATE TABLE IF NOT EXISTS `log_produce_reputation` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '唯一编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(100) NOT NULL DEFAULT '' COMMENT '公会名字',
  `produce_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `got_reputation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得声望',
  `remain_reputation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余声望',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会声望日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_quickcharge 结构
DROP TABLE IF EXISTS `log_quickcharge`;
CREATE TABLE IF NOT EXISTS `log_quickcharge` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品Id',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币数',
  `money_gap` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值前金币差额',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='快速充值日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_quick_buy 结构
DROP TABLE IF EXISTS `log_quick_buy`;
CREATE TABLE IF NOT EXISTS `log_quick_buy` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `before_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前钻石',
  `before_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前绑钻',
  `before_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前金币',
  `after_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后钻石',
  `after_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后绑钻',
  `after_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后金币',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '购买的物品',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='快速购买日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_race_act 结构
DROP TABLE IF EXISTS `log_race_act`;
CREATE TABLE IF NOT EXISTS `log_race_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `open` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动开启日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_race_act_produce 结构
DROP TABLE IF EXISTS `log_race_act_produce`;
CREATE TABLE IF NOT EXISTS `log_race_act_produce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `ptype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动产出表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_race_act_rank 结构
DROP TABLE IF EXISTS `log_race_act_rank`;
CREATE TABLE IF NOT EXISTS `log_race_act_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(512) NOT NULL DEFAULT '' COMMENT '名字',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `act_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动第X天',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动排名日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_race_rank 结构
DROP TABLE IF EXISTS `log_race_rank`;
CREATE TABLE IF NOT EXISTS `log_race_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `rname` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间戳',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间戳',
  PRIMARY KEY (`id`),
  KEY `act_id` (`act_id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-排行榜本地日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_race_rank_draw 结构
DROP TABLE IF EXISTS `log_race_rank_draw`;
CREATE TABLE IF NOT EXISTS `log_race_rank_draw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `award` varchar(800) NOT NULL DEFAULT '[]' COMMENT '奖励:[{奖励类型,物品类型Id,数量}]',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗:[{奖励类型,物品类型Id,数量}]',
  `isbuy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否购买',
  `befgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'gold前',
  `aftgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'gold后',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖后积分',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖后积分',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-玩家抽奖记录(在游戏服中使用)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_race_rank_kf 结构
DROP TABLE IF EXISTS `log_race_rank_kf`;
CREATE TABLE IF NOT EXISTS `log_race_rank_kf` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `rname` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间戳',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间戳',
  PRIMARY KEY (`id`),
  KEY `act_id` (`act_id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-排行榜跨服日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_race_rank_times_award 结构
DROP TABLE IF EXISTS `log_race_rank_times_award`;
CREATE TABLE IF NOT EXISTS `log_race_rank_times_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `needscore` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需求积分',
  `curscore` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前积分',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜阶段奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_rank 结构
DROP TABLE IF EXISTS `log_rank`;
CREATE TABLE IF NOT EXISTS `log_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `nick_name` varchar(256) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `career` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '玩家职业',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '排名值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `rank_type` (`rank_type`) USING BTREE,
  KEY `career` (`career`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人排行榜日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_receive_degree_reward 结构
DROP TABLE IF EXISTS `log_receive_degree_reward`;
CREATE TABLE IF NOT EXISTS `log_receive_degree_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `class_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功课Id',
  `task_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `old_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '晋升前学位经验',
  `new_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '晋升后学位经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='学位日常功课奖励领取日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_receive_smashed_egg_reward 结构
DROP TABLE IF EXISTS `log_receive_smashed_egg_reward`;
CREATE TABLE IF NOT EXISTS `log_receive_smashed_egg_reward` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `subtype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `reward_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='领取砸蛋奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_recharge_consume_act 结构
DROP TABLE IF EXISTS `log_recharge_consume_act`;
CREATE TABLE IF NOT EXISTS `log_recharge_consume_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '角色名',
  `type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动分类',
  `subtype` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动子分类',
  `grade` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动奖励档次',
  `recharge_total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值总额',
  `consume_total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费总额',
  `is_mail` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否邮件发放奖励',
  `award_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `vip` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-充值消费活动日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_recharge_consume_rank_act 结构
DROP TABLE IF EXISTS `log_recharge_consume_rank_act`;
CREATE TABLE IF NOT EXISTS `log_recharge_consume_rank_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `reward` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `rank_type` (`rank_type`),
  KEY `sub_type` (`sub_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值消费榜奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_recharge_first 结构
DROP TABLE IF EXISTS `log_recharge_first`;
CREATE TABLE IF NOT EXISTS `log_recharge_first` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名字',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '产品id',
  `log_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '日志类型：1激活日志,2领取日志',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取第几天奖励',
  `object_list` varchar(512) NOT NULL COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `isnew` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否创角当天充值##1是;0否',
  `reg_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创角时间',
  `charge_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '首充开服天数',
  `last_behavior` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家行为',
  `level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计在线时长',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='首冲日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_recharge_return 结构
DROP TABLE IF EXISTS `log_recharge_return`;
CREATE TABLE IF NOT EXISTS `log_recharge_return` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `return_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '返利类型',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础钻石',
  `return_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利钻石',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值返利日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_recharge_welfare 结构
DROP TABLE IF EXISTS `log_recharge_welfare`;
CREATE TABLE IF NOT EXISTS `log_recharge_welfare` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '角色ID',
  `product_id` smallint(6) NOT NULL COMMENT '商品ID',
  `days` smallint(6) NOT NULL COMMENT '持续天数',
  `days_left` smallint(6) NOT NULL COMMENT '剩余可领天数',
  `award_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='尊享卡领奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_red_envelopes 结构
DROP TABLE IF EXISTS `log_red_envelopes`;
CREATE TABLE IF NOT EXISTS `log_red_envelopes` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `red_envelopes_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `ownership_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '归属类型',
  `ownership_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属id',
  `owner_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拥有者id',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '红包状态',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT '红包类型',
  `extra` varchar(100) NOT NULL DEFAULT '0' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `red_envelopes_id` (`red_envelopes_id`),
  KEY `ownership_id` (`ownership_id`),
  KEY `owner_id` (`owner_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用红包日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_red_envelopes_recipients 结构
DROP TABLE IF EXISTS `log_red_envelopes_recipients`;
CREATE TABLE IF NOT EXISTS `log_red_envelopes_recipients` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `red_envelopes_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `reward` varchar(50) NOT NULL DEFAULT '' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `red_envelopes_id` (`red_envelopes_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包领取记录日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_reg_statis 结构
DROP TABLE IF EXISTS `log_reg_statis`;
CREATE TABLE IF NOT EXISTS `log_reg_statis` (
  `time` int(10) NOT NULL COMMENT '统计时间',
  `source` varchar(50) NOT NULL COMMENT '来源',
  `reg_num` int(11) NOT NULL COMMENT '注册数',
  PRIMARY KEY (`time`,`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每小时统计注册数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_rela 结构
DROP TABLE IF EXISTS `log_rela`;
CREATE TABLE IF NOT EXISTS `log_rela` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方玩家id',
  `pre_rela` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '之前关系',
  `ctype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `rela` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '当前关系',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `ctype` (`ctype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社交关系变化';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_rename 结构
DROP TABLE IF EXISTS `log_rename`;
CREATE TABLE IF NOT EXISTS `log_rename` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) NOT NULL COMMENT '玩家id',
  `old_name` varchar(50) NOT NULL COMMENT '原角色名',
  `new_name` varchar(50) NOT NULL COMMENT '新角色名',
  `lv` int(11) NOT NULL COMMENT '等级',
  `cost` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色改名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_resource_back 结构
DROP TABLE IF EXISTS `log_resource_back`;
CREATE TABLE IF NOT EXISTS `log_resource_back` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块id',
  `act_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块子类',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '找回次数',
  `lefttimes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余次数',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '找回奖励',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='奖励找回日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_reversi_lottery 结构
DROP TABLE IF EXISTS `log_reversi_lottery`;
CREATE TABLE IF NOT EXISTS `log_reversi_lottery` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `op_type` tinyint(2) NOT NULL COMMENT '操作##1抽奖/2刷新奖池',
  `score` smallint(6) NOT NULL DEFAULT '0' COMMENT '当前幸运值',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `gold_before` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖前彩钻',
  `gold_after` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖后彩钻',
  `bgold_before` int(11) NOT NULL DEFAULT '0' COMMENT '操作前红钻',
  `bgold_after` int(11) NOT NULL DEFAULT '0' COMMENT '操作后红钻',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='活动-黑白棋抽奖日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_role_home_build 结构
DROP TABLE IF EXISTS `log_role_home_build`;
CREATE TABLE IF NOT EXISTS `log_role_home_build` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `create_type` tinyint(2) unsigned NOT NULL COMMENT '1创建2扩展',
  `home_id` int(11) unsigned NOT NULL COMMENT '家园规格',
  `costs` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward_list` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园建造日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_role_home_build_upgrade 结构
DROP TABLE IF EXISTS `log_role_home_build_upgrade`;
CREATE TABLE IF NOT EXISTS `log_role_home_build_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `uptype` tinyint(2) unsigned NOT NULL COMMENT '1钻石升级(加速)2普通升级',
  `start_end` tinyint(2) unsigned NOT NULL COMMENT '1开始升级2结束升级',
  `build_type` int(11) unsigned NOT NULL COMMENT '建筑类型',
  `build_lv` int(11) unsigned NOT NULL COMMENT '建筑等级',
  `upgrade_endtime` int(11) unsigned NOT NULL COMMENT '升级结束时间戳',
  `res_cost` varchar(256) NOT NULL DEFAULT '[]' COMMENT '资源消耗',
  `costs` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园建筑升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_role_home_collect_resource 结构
DROP TABLE IF EXISTS `log_role_home_collect_resource`;
CREATE TABLE IF NOT EXISTS `log_role_home_collect_resource` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `build_type` int(11) unsigned NOT NULL COMMENT '建筑类型',
  `res_get` varchar(256) NOT NULL DEFAULT '[]' COMMENT '获得资源',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园资源采集日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_role_home_pic 结构
DROP TABLE IF EXISTS `log_role_home_pic`;
CREATE TABLE IF NOT EXISTS `log_role_home_pic` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '原来等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园图鉴日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_role_home_wish 结构
DROP TABLE IF EXISTS `log_role_home_wish`;
CREATE TABLE IF NOT EXISTS `log_role_home_wish` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `wish_id` tinyint(2) unsigned NOT NULL COMMENT '许愿池id',
  `wish_coin_cost` smallint(6) unsigned NOT NULL COMMENT '许愿币消耗',
  `event_id` tinyint(2) unsigned NOT NULL COMMENT '事件id 1：得奖励 2：升品',
  `rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '获得奖励',
  `res_rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '资源奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园许愿日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_role_ltv 结构
DROP TABLE IF EXISTS `log_role_ltv`;
CREATE TABLE IF NOT EXISTS `log_role_ltv` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自动ID',
  `source` varchar(50) NOT NULL COMMENT '渠道标识',
  `ctime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '时间',
  `reg_num` int(10) NOT NULL DEFAULT '0' COMMENT '注册人数',
  `one_charge` int(10) NOT NULL DEFAULT '0' COMMENT '1日充值金额',
  `two_charge` int(10) NOT NULL DEFAULT '0' COMMENT '2日充值金额',
  `three_charge` int(10) NOT NULL DEFAULT '0' COMMENT '3日充值金额',
  `four_charge` int(10) NOT NULL DEFAULT '0' COMMENT '4日充值金额',
  `five_charge` int(10) NOT NULL DEFAULT '0' COMMENT '5日充值金额',
  `six_charge` int(10) NOT NULL DEFAULT '0' COMMENT '6日充值金额',
  `seven_charge` int(10) NOT NULL DEFAULT '0' COMMENT '7日充值金额',
  `fourteen_charge` int(10) NOT NULL DEFAULT '0' COMMENT '14日充值金额',
  `thirty_charge` int(10) NOT NULL DEFAULT '0' COMMENT '30日充值金额',
  PRIMARY KEY (`id`),
  KEY `ctime` (`ctime`),
  KEY `source` (`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='游戏玩家LifeTimeValue';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_role_retain 结构
DROP TABLE IF EXISTS `log_role_retain`;
CREATE TABLE IF NOT EXISTS `log_role_retain` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自动ID',
  `source` varchar(50) NOT NULL COMMENT '渠道标识',
  `ctime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '时间',
  `reg_num` int(10) NOT NULL DEFAULT '0' COMMENT '注册人数',
  `one_login` int(10) NOT NULL DEFAULT '0' COMMENT '1日登陆人数',
  `two_login` int(10) NOT NULL DEFAULT '0' COMMENT '2日登陆人数',
  `three_login` int(10) NOT NULL DEFAULT '0' COMMENT '3日登陆人数',
  `four_login` int(10) NOT NULL DEFAULT '0' COMMENT '4日登陆人数',
  `five_login` int(10) NOT NULL DEFAULT '0' COMMENT '5日登陆人数',
  `six_login` int(10) NOT NULL DEFAULT '0' COMMENT '6日登陆人数',
  `seven_login` int(10) NOT NULL DEFAULT '0' COMMENT '7日登陆人数',
  `fourteen_login` int(10) NOT NULL DEFAULT '0' COMMENT '14日登陆人数',
  `thirty_login` int(10) NOT NULL DEFAULT '0' COMMENT '30日登陆人数',
  PRIMARY KEY (`id`),
  KEY `ctime` (`ctime`),
  KEY `source` (`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='游戏玩家留存率';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_rule_devour 结构
DROP TABLE IF EXISTS `log_rule_devour`;
CREATE TABLE IF NOT EXISTS `log_rule_devour` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `player_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名',
  `rule_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬法则类型',
  `before_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬前数量',
  `after_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬后数量',
  `attr` varchar(255) NOT NULL DEFAULT '' COMMENT '增加属性',
  `cost` varchar(255) NOT NULL DEFAULT '' COMMENT '吞噬消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬时间',
  PRIMARY KEY (`id`,`role_id`,`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法则吞噬日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_rush_goal_reward 结构
DROP TABLE IF EXISTS `log_rush_goal_reward`;
CREATE TABLE IF NOT EXISTS `log_rush_goal_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '榜单类型',
  `goal_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '目标奖励id',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时玩家数值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `rank_type` (`rank_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜目标日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_rush_rank_reward 结构
DROP TABLE IF EXISTS `log_rush_rank_reward`;
CREATE TABLE IF NOT EXISTS `log_rush_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '榜单类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家数值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `rank_type` (`rank_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜排行日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_sell_down 结构
DROP TABLE IF EXISTS `log_sell_down`;
CREATE TABLE IF NOT EXISTS `log_sell_down` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `sell_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下架数量',
  `seller_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `down_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '下架类型 1: 手动 2:自动 3:出售',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `sell_id` (`sell_id`),
  KEY `goods_id` (`goods_id`),
  KEY `seller_id` (`seller_id`),
  KEY `down_type` (`down_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场下架日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_sell_pay 结构
DROP TABLE IF EXISTS `log_sell_pay`;
CREATE TABLE IF NOT EXISTS `log_sell_pay` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `sell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '交易类型 1:市场出售 2:指定交易',
  `sell_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易数量',
  `unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单价',
  `tax` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易税',
  `seller_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `buyer_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '购买玩家id',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `sell_type` (`sell_type`),
  KEY `sell_id` (`sell_id`),
  KEY `goods_id` (`goods_id`),
  KEY `seller_id` (`seller_id`),
  KEY `buyer_id` (`buyer_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场交易日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_sell_up 结构
DROP TABLE IF EXISTS `log_sell_up`;
CREATE TABLE IF NOT EXISTS `log_sell_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `seller_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `sell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '出售类型 1:市场出售 2:指定交易',
  `sell_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售数量',
  `unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售单价',
  `specifyer_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '指定购买玩家id',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `seller_id` (`seller_id`),
  KEY `sell_type` (`sell_type`),
  KEY `sell_id` (`sell_id`),
  KEY `goods_id` (`goods_id`) USING BTREE,
  KEY `specifyer_id` (`specifyer_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场上架日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_server_daily_clear 结构
DROP TABLE IF EXISTS `log_server_daily_clear`;
CREATE TABLE IF NOT EXISTS `log_server_daily_clear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `log_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '日志类型',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `log_type` (`log_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器日清日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_server_hot 结构
DROP TABLE IF EXISTS `log_server_hot`;
CREATE TABLE IF NOT EXISTS `log_server_hot` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `module_list` varchar(4096) NOT NULL DEFAULT '' COMMENT '热更模块列表',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器热更日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_server_interface 结构
DROP TABLE IF EXISTS `log_server_interface`;
CREATE TABLE IF NOT EXISTS `log_server_interface` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `mfa` varchar(4096) NOT NULL DEFAULT '' COMMENT '调用模块',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器web_interface日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_server_memory 结构
DROP TABLE IF EXISTS `log_server_memory`;
CREATE TABLE IF NOT EXISTS `log_server_memory` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `memory_total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存total(m)',
  `memory_processes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存processes(m)',
  `memory_atom` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存atom(m)',
  `memory_binary` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存binary(m)',
  `memory_code` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存code(m)',
  `memory_ets` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存ets(m)',
  `process_cnt` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用数量process',
  `ets_cnt` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用数量ets',
  `port_cnt` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用数量port',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器内存日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_server_open 结构
DROP TABLE IF EXISTS `log_server_open`;
CREATE TABLE IF NOT EXISTS `log_server_open` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `server_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '服务器状态',
  `server_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '服务器类型',
  `node` varchar(128) NOT NULL DEFAULT 'none' COMMENT '服务器节点',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本服服数',
  `platform` varchar(512) NOT NULL DEFAULT 'none' COMMENT '平台名',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器开启日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_server_watchdog 结构
DROP TABLE IF EXISTS `log_server_watchdog`;
CREATE TABLE IF NOT EXISTS `log_server_watchdog` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `log_list` varchar(4096) NOT NULL DEFAULT '[]' COMMENT '日志列表',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='看门狗服务日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_seven_days_goal 结构
DROP TABLE IF EXISTS `log_seven_days_goal`;
CREATE TABLE IF NOT EXISTS `log_seven_days_goal` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `type` tinyint(2) NOT NULL COMMENT '操作类型，1领取任务奖励2领取积分奖励3领取技能奖励',
  `role_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '玩家名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `grade` varchar(127) NOT NULL DEFAULT '[]' COMMENT '档次',
  `reward` varchar(511) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) NOT NULL COMMENT '领取时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='七日目标日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_seven_goal_task 结构
DROP TABLE IF EXISTS `log_seven_goal_task`;
CREATE TABLE IF NOT EXISTS `log_seven_goal_task` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) DEFAULT NULL COMMENT '角色ID',
  `role_name` varchar(255) NOT NULL COMMENT '角色名',
  `role_lv` varchar(255) DEFAULT NULL COMMENT '角色等级',
  `rfmt` varchar(255) DEFAULT NULL COMMENT 'rfmt',
  `day` varchar(255) DEFAULT NULL COMMENT '归属天数',
  `task` varchar(255) DEFAULT NULL COMMENT '任务完成情况',
  `time` int(11) NOT NULL COMMENT '完成时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='七日目标任务完成日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_shop 结构
DROP TABLE IF EXISTS `log_shop`;
CREATE TABLE IF NOT EXISTS `log_shop` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_lv` int(10) NOT NULL DEFAULT '1' COMMENT '角色等级',
  `vip_lv` smallint(10) NOT NULL DEFAULT '0' COMMENT '贵族等级',
  `shop_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具ID',
  `num` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '物品获得数量',
  `money_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '货币类型',
  `sum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买总价格',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  `buy_num` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `goods_id` (`goods_id`),
  KEY `money_type` (`money_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商城日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_sign_in 结构
DROP TABLE IF EXISTS `log_sign_in`;
CREATE TABLE IF NOT EXISTS `log_sign_in` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `role_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `round` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '周期',
  `day` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '第几天',
  `award` varchar(100) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `vip_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级要求',
  `role_vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '角色VIP等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='签到奖励日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_single_dungeon 结构
DROP TABLE IF EXISTS `log_single_dungeon`;
CREATE TABLE IF NOT EXISTS `log_single_dungeon` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `reward_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '掉落奖励',
  `result_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `result_subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `log_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录类型',
  `remark` text NOT NULL COMMENT '备注',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `dun_id` (`dun_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单人副本日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_skill_active 结构
DROP TABLE IF EXISTS `log_skill_active`;
CREATE TABLE IF NOT EXISTS `log_skill_active` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能ID',
  `lv_after` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `name` (`name`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志-技能激活';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_smashed_egg 结构
DROP TABLE IF EXISTS `log_smashed_egg`;
CREATE TABLE IF NOT EXISTS `log_smashed_egg` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `smashed_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '砸蛋类型',
  `smashed_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '本次砸蛋数量',
  `index` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '金蛋编号',
  `use_free_times` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否使用免费次数',
  `auto_buy` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否自动购买',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_star_drum 结构
DROP TABLE IF EXISTS `log_star_drum`;
CREATE TABLE IF NOT EXISTS `log_star_drum` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `drum` int(11) NOT NULL DEFAULT '0' COMMENT '期',
  `zone` int(11) NOT NULL DEFAULT '0' COMMENT '战区',
  `action` int(11) NOT NULL DEFAULT '0' COMMENT '场数',
  `sub_action` int(11) NOT NULL DEFAULT '0' COMMENT '局数',
  `wid` bigint(20) NOT NULL DEFAULT '0' COMMENT '胜方',
  `wname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `wsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `wnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜服号',
  `wpower` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜战力',
  `wstar_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '胜出战星灵id',
  `wdie_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '胜死亡星灵',
  `fid` bigint(20) NOT NULL DEFAULT '0' COMMENT '负方',
  `fname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `fsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `fnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负服号',
  `fpower` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负战力',
  `fstar_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '胜出战星灵id',
  `fdie_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '负死亡星灵',
  `result` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '1胜2负3轮空4超时5离线6无星灵出阵',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `wid` (`wid`),
  KEY `fid` (`fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星灵争霸战场日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_star_drum_refuce 结构
DROP TABLE IF EXISTS `log_star_drum_refuce`;
CREATE TABLE IF NOT EXISTS `log_star_drum_refuce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵争霸拒绝参赛日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_star_drum_sign 结构
DROP TABLE IF EXISTS `log_star_drum_sign`;
CREATE TABLE IF NOT EXISTS `log_star_drum_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵争霸报名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_supplication_reward 结构
DROP TABLE IF EXISTS `log_supplication_reward`;
CREATE TABLE IF NOT EXISTS `log_supplication_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `count` int(10) unsigned NOT NULL COMMENT '抽取次数',
  `reward_lv` tinyint(2) unsigned NOT NULL COMMENT '奖励等级',
  `cost` varchar(512) NOT NULL COMMENT '物品消耗',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  `reward_id` int(10) unsigned NOT NULL COMMENT '档次id',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-祈愿日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_supplication_task_finish 结构
DROP TABLE IF EXISTS `log_supplication_task_finish`;
CREATE TABLE IF NOT EXISTS `log_supplication_task_finish` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `task_id` tinyint(2) unsigned NOT NULL COMMENT '任务id',
  `condition` varchar(255) NOT NULL COMMENT '完成条件',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-任务完成';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_supplication_task_reward 结构
DROP TABLE IF EXISTS `log_supplication_task_reward`;
CREATE TABLE IF NOT EXISTS `log_supplication_task_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `task_id` tinyint(2) unsigned NOT NULL COMMENT '任务id',
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-任务奖励领取日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_sup_vip_exchange 结构
DROP TABLE IF EXISTS `log_sup_vip_exchange`;
CREATE TABLE IF NOT EXISTS `log_sup_vip_exchange` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(300) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `vip_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型 1彩钻|2培养丹|3商城',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `reward` varchar(300) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time_before` int(11) NOT NULL DEFAULT '0' COMMENT '兑换前次数',
  `time_after` int(11) NOT NULL DEFAULT '0' COMMENT '兑换后次数',
  `gold_before` int(11) NOT NULL DEFAULT '0' COMMENT '兑换前彩钻',
  `gold_after` int(11) NOT NULL DEFAULT '0' COMMENT '兑换后彩钻',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族兑换日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_sup_vip_status 结构
DROP TABLE IF EXISTS `log_sup_vip_status`;
CREATE TABLE IF NOT EXISTS `log_sup_vip_status` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sup_vip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '贵族状态',
  `active_type` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '变更操作',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族状态变更';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_talk_report 结构
DROP TABLE IF EXISTS `log_talk_report`;
CREATE TABLE IF NOT EXISTS `log_talk_report` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `from_id` bigint(20) unsigned NOT NULL COMMENT '举报者id',
  `to_id` bigint(20) unsigned NOT NULL COMMENT '被举报的玩家id',
  `msg` text NOT NULL COMMENT '聊天信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `from_id` (`from_id`),
  KEY `to_id` (`to_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='聊天举报日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_throw 结构
DROP TABLE IF EXISTS `log_throw`;
CREATE TABLE IF NOT EXISTS `log_throw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '类型，0销毁，1邮件过期，2时间物品过期',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `gid` bigint(20) unsigned DEFAULT '0' COMMENT '物品唯一id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `gid` (`gid`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='销毁日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_throw_dice 结构
DROP TABLE IF EXISTS `log_throw_dice`;
CREATE TABLE IF NOT EXISTS `log_throw_dice` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `move_step` tinyint(2) NOT NULL DEFAULT '0' COMMENT '点数',
  `grid_type` tinyint(2) NOT NULL DEFAULT '0' COMMENT '格子类型',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冒险之旅投色子日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_top_pk 结构
DROP TABLE IF EXISTS `log_top_pk`;
CREATE TABLE IF NOT EXISTS `log_top_pk` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '我的id',
  `fight_role_id` bigint(20) unsigned NOT NULL COMMENT '对手id',
  `fight_role_name` varchar(50) NOT NULL COMMENT '对手名字',
  `is_fake` tinyint(3) unsigned NOT NULL COMMENT '是否假人##1是0否',
  `platform` varchar(50) NOT NULL COMMENT '对手平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '对手服务器',
  `res` tinyint(3) unsigned NOT NULL COMMENT '胜负##1胜0负',
  `score_before` int(10) unsigned NOT NULL COMMENT '挑战前积分',
  `score_after` int(10) unsigned NOT NULL COMMENT '挑战后积分',
  `time` int(10) unsigned DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技挑战日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_transfer 结构
DROP TABLE IF EXISTS `log_transfer`;
CREATE TABLE IF NOT EXISTS `log_transfer` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `old_career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '旧职业',
  `old_sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '旧性别',
  `new_career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '新职业',
  `new_sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '新性别',
  `time` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转职日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_transform 结构
DROP TABLE IF EXISTS `log_transform`;
CREATE TABLE IF NOT EXISTS `log_transform` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `transform_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转职Id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色转职日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_treasure_evaluation 结构
DROP TABLE IF EXISTS `log_treasure_evaluation`;
CREATE TABLE IF NOT EXISTS `log_treasure_evaluation` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '鉴宝数量类型（1一次 2十次）',
  `old_lucky_num` int(10) unsigned NOT NULL COMMENT '旧幸运值',
  `new_lucky_num` int(10) unsigned NOT NULL COMMENT '新幸运值',
  `cost_list` varchar(200) NOT NULL COMMENT '消耗列表',
  `reward_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝抽奖日志表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_trial_sup_vip_charge 结构
DROP TABLE IF EXISTS `log_trial_sup_vip_charge`;
CREATE TABLE IF NOT EXISTS `log_trial_sup_vip_charge` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本次增加钻石数',
  `total_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总钻石数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族期间充值记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_unlock_box 结构
DROP TABLE IF EXISTS `log_unlock_box`;
CREATE TABLE IF NOT EXISTS `log_unlock_box` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type_id` int(11) NOT NULL DEFAULT '0' COMMENT '宝箱id',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冒险之旅解锁宝箱日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_uplv 结构
DROP TABLE IF EXISTS `log_uplv`;
CREATE TABLE IF NOT EXISTS `log_uplv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `turn` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '转生数',
  `fr` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '来源标识',
  `add_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '升级时添加的经验值（刷经验时查看的依据）',
  `exp_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '经验列表',
  `lv_max_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '升级需要的经验',
  `power` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级时间',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `lv` (`lv`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_uranium_upgrade 结构
DROP TABLE IF EXISTS `log_uranium_upgrade`;
CREATE TABLE IF NOT EXISTS `log_uranium_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `befgrade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧阶',
  `beflv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧等级',
  `aftgrade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新阶',
  `aftlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='魂力升级日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_version_upgradebag 结构
DROP TABLE IF EXISTS `log_version_upgradebag`;
CREATE TABLE IF NOT EXISTS `log_version_upgradebag` (
  `seq` bigint(30) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(30) NOT NULL COMMENT '玩家id',
  `version_code` bigint(30) NOT NULL COMMENT '版本号',
  `rewards_output` varchar(1024) NOT NULL COMMENT '物品输出',
  `time` int(30) NOT NULL COMMENT '时间',
  PRIMARY KEY (`seq`,`player_id`,`version_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='版本更新礼包日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_vie_rank 结构
DROP TABLE IF EXISTS `log_vie_rank`;
CREATE TABLE IF NOT EXISTS `log_vie_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `act` int(11) unsigned NOT NULL COMMENT '活动Id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `rtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  `dtime` int(11) NOT NULL DEFAULT '0' COMMENT '有效时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='封榜活动跨服日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_vie_score 结构
DROP TABLE IF EXISTS `log_vie_score`;
CREATE TABLE IF NOT EXISTS `log_vie_score` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `act` int(11) unsigned NOT NULL COMMENT '活动Id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `score_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得积分',
  `score_all` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='封榜积分获得日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_vip_giftbag 结构
DROP TABLE IF EXISTS `log_vip_giftbag`;
CREATE TABLE IF NOT EXISTS `log_vip_giftbag` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `vip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '贵族等级',
  `bag_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `send_times` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '领取个数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '花费',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '礼包内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族礼包领取日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_vip_status 结构
DROP TABLE IF EXISTS `log_vip_status`;
CREATE TABLE IF NOT EXISTS `log_vip_status` (
  `seq` bigint(25) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `player_id` bigint(20) NOT NULL COMMENT '用户id',
  `vip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `trial_lv` tinyint(6) unsigned NOT NULL DEFAULT '0' COMMENT '体验等级',
  `vip_lv` int(11) NOT NULL COMMENT 'vip等级',
  `props_id` int(20) NOT NULL COMMENT '使用的物品id（直接用钻石或无道具则为0）',
  `vip_status` int(8) unsigned NOT NULL DEFAULT '0' COMMENT 'vip状态 0激活体验|1激活永久|2体验过期|3永久升级',
  `end_time` bigint(20) NOT NULL COMMENT 'vip过期时间',
  `time` bigint(20) NOT NULL COMMENT '日志时间',
  PRIMARY KEY (`seq`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip状态变化日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_vip_upgrade 结构
DROP TABLE IF EXISTS `log_vip_upgrade`;
CREATE TABLE IF NOT EXISTS `log_vip_upgrade` (
  `seq` bigint(25) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `player_id` bigint(20) NOT NULL COMMENT '玩家id',
  `vip_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip_lv` int(11) NOT NULL COMMENT 'vip等级',
  `vip_exp` int(11) NOT NULL COMMENT 'vip总经验',
  `diamond_exp` int(11) NOT NULL COMMENT '期间消耗钻石获得的经验',
  `time` bigint(20) NOT NULL COMMENT '日志时间',
  PRIMARY KEY (`seq`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验增长日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_visus_upgrade 结构
DROP TABLE IF EXISTS `log_visus_upgrade`;
CREATE TABLE IF NOT EXISTS `log_visus_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `opty` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型0激活1升级',
  `visus` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻光',
  `old_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧等级',
  `new_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新等级',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `condition` varchar(200) NOT NULL DEFAULT '[]' COMMENT '激活条件',
  `desc` varchar(200) NOT NULL DEFAULT '0' COMMENT '描述',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='幻光激活升级';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_void_fam 结构
DROP TABLE IF EXISTS `log_void_fam`;
CREATE TABLE IF NOT EXISTS `log_void_fam` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 进入/退出',
  `floor` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '进入层数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进入积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽领域日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_void_fam_rank 结构
DROP TABLE IF EXISTS `log_void_fam_rank`;
CREATE TABLE IF NOT EXISTS `log_void_fam_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `ser_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 进入/退出',
  `floor` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '进入层数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽排名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_void_fam_rank_kf 结构
DROP TABLE IF EXISTS `log_void_fam_rank_kf`;
CREATE TABLE IF NOT EXISTS `log_void_fam_rank_kf` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区ID',
  `kf_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID(后台唯一服号)',
  `ser_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 进入/退出',
  `floor` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '进入层数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽跨服排名日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_war_soul_del 结构
DROP TABLE IF EXISTS `log_war_soul_del`;
CREATE TABLE IF NOT EXISTS `log_war_soul_del` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `soul_id` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '被分解的战魂ID（列表）',
  `gain_exp` varchar(50) NOT NULL DEFAULT '[]' COMMENT '获得的战魂经验值',
  `exp_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分解后的战魂经验值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-分解日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_war_soul_equip 结构
DROP TABLE IF EXISTS `log_war_soul_equip`;
CREATE TABLE IF NOT EXISTS `log_war_soul_equip` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '上阵位置',
  `soul_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上阵前战魂（没有则为0）',
  `soul_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上阵后战魂',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-上阵日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_war_soul_evolution 结构
DROP TABLE IF EXISTS `log_war_soul_evolution`;
CREATE TABLE IF NOT EXISTS `log_war_soul_evolution` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `soul_id` int(11) NOT NULL DEFAULT '0' COMMENT '进化前的战魂id',
  `soul_id_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进化后的战魂id',
  `cost` varchar(200) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `gain_exp` varchar(50) NOT NULL DEFAULT '[]' COMMENT '获得的战魂经验值##（如果消耗了已升级战魂的返还。没有则记为0）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-进化日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_war_soul_handbook 结构
DROP TABLE IF EXISTS `log_war_soul_handbook`;
CREATE TABLE IF NOT EXISTS `log_war_soul_handbook` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `soul_unlock_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁战魂ID',
  `soul_unlock_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁战魂数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-图鉴日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_war_soul_strength 结构
DROP TABLE IF EXISTS `log_war_soul_strength`;
CREATE TABLE IF NOT EXISTS `log_war_soul_strength` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '被强化的战魂ID',
  `cost_exp` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗的战魂经验值',
  `exp_bef` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗前的战魂经验值',
  `exp_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗后的战魂经验值',
  `lv_aft` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化后的战魂等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-强化日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_wasteland_war 结构
DROP TABLE IF EXISTS `log_wasteland_war`;
CREATE TABLE IF NOT EXISTS `log_wasteland_war` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见服编号)',
  `kf_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跨服阶段',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型(1-玩家进入场景；2-假人进入场景；3-玩家替换假人 4-主动退出场景；5-淘汰被踢出场景；6-活动结束退出场景)',
  `round` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '当前轮数',
  `rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '积分排名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `type` (`type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='废土战场参与日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.log_welfare 结构
DROP TABLE IF EXISTS `log_welfare`;
CREATE TABLE IF NOT EXISTS `log_welfare` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '福利卡类型',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钻石数',
  `op` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作##1购买2领奖',
  `left_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '剩余次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `get_time` (`op`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利卡日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.lucky_flop 结构
DROP TABLE IF EXISTS `lucky_flop`;
CREATE TABLE IF NOT EXISTS `lucky_flop` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '活动子类型',
  `now_times` int(11) unsigned NOT NULL COMMENT '当前抽奖次数',
  `total_times` int(11) unsigned NOT NULL COMMENT '累计抽奖次数',
  `turn` int(11) unsigned NOT NULL COMMENT '抽奖轮数',
  `draw_rewards` varchar(255) NOT NULL COMMENT '奖池列表[{奖励档次,是否已获取},...]',
  `receive_rewards` varchar(255) NOT NULL COMMENT '已领取累计奖励列表[奖励档次,...]',
  `time` int(11) unsigned NOT NULL COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌玩家数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.lucky_wheel_all_limit 结构
DROP TABLE IF EXISTS `lucky_wheel_all_limit`;
CREATE TABLE IF NOT EXISTS `lucky_wheel_all_limit` (
  `sub_type` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `roll_id` int(10) unsigned NOT NULL COMMENT '转盘序号',
  `times` int(10) unsigned NOT NULL COMMENT '次数',
  PRIMARY KEY (`sub_type`,`roll_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运转盘奖励全服次数记录表(合服清空)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.lucky_wheel_player_limit 结构
DROP TABLE IF EXISTS `lucky_wheel_player_limit`;
CREATE TABLE IF NOT EXISTS `lucky_wheel_player_limit` (
  `sub_type` int(10) unsigned NOT NULL,
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `roll_id` int(10) unsigned NOT NULL COMMENT '转盘序号',
  `times` int(10) unsigned DEFAULT NULL COMMENT '次数',
  PRIMARY KEY (`sub_type`,`role_id`,`roll_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运转盘奖励个人次数记录表(合服清空)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.madness_land_guild_rank 结构
DROP TABLE IF EXISTS `madness_land_guild_rank`;
CREATE TABLE IF NOT EXISTS `madness_land_guild_rank` (
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名',
  `guild_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '公会名字',
  `guild_flag` int(11) NOT NULL DEFAULT '0' COMMENT '社团旗帜',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-本服公会排名(合服清空)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.madness_land_role_rank 结构
DROP TABLE IF EXISTS `madness_land_role_rank`;
CREATE TABLE IF NOT EXISTS `madness_land_role_rank` (
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-本服个人排名(合服清空)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.madness_land_zone_guild_rank 结构
DROP TABLE IF EXISTS `madness_land_zone_guild_rank`;
CREATE TABLE IF NOT EXISTS `madness_land_zone_guild_rank` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器',
  `guild_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '公会名字',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  `guild_flag` int(11) NOT NULL DEFAULT '0' COMMENT '社团旗帜',
  PRIMARY KEY (`zone_id`,`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-跨服公会排名(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.madness_land_zone_role_rank 结构
DROP TABLE IF EXISTS `madness_land_zone_role_rank`;
CREATE TABLE IF NOT EXISTS `madness_land_zone_role_rank` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `vip` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `sup_vip` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '贵族',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器号',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  `photo` int(11) NOT NULL DEFAULT '0' COMMENT '头像',
  `photo_dress` int(11) NOT NULL DEFAULT '0' COMMENT '头像框',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '转职',
  PRIMARY KEY (`zone_id`,`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-跨服个人排名(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.madness_land_zone_server_rank 结构
DROP TABLE IF EXISTS `madness_land_zone_server_rank`;
CREATE TABLE IF NOT EXISTS `madness_land_zone_server_rank` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '排名',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器',
  `server_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '服务器名字',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`zone_id`,`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='狂战领域-跨服区服排名(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mail 结构
DROP TABLE IF EXISTS `mail`;
CREATE TABLE IF NOT EXISTS `mail` (
  `id` bigint(20) unsigned NOT NULL COMMENT '邮件id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '类型（1系统/2私人/3帮派）',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '2' COMMENT '状态（1已读/2未读）',
  `locked` tinyint(1) unsigned NOT NULL DEFAULT '2' COMMENT '锁定状态（1锁定/2未锁定）',
  `sid` bigint(20) unsigned NOT NULL COMMENT '发件人id',
  `rid` bigint(20) unsigned NOT NULL COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '普通附件',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `timestamp` bigint(21) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳（微秒）',
  `effect_st` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '有效开始时间',
  `content` varchar(1500) NOT NULL COMMENT '邮件正文',
  `important` tinyint(2) NOT NULL DEFAULT '0' COMMENT '是否重要邮件',
  PRIMARY KEY (`id`),
  KEY `timestamp` (`timestamp`),
  KEY `sid` (`sid`),
  KEY `rid` (`rid`),
  KEY `effect_st` (`effect_st`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件属性';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mail_no_review 结构
DROP TABLE IF EXISTS `mail_no_review`;
CREATE TABLE IF NOT EXISTS `mail_no_review` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ids` text NOT NULL,
  `names` text NOT NULL,
  `title` text NOT NULL,
  `content` text NOT NULL,
  `goods_id` int(11) NOT NULL,
  `goods_num` int(11) NOT NULL,
  `bind` tinyint(1) NOT NULL,
  `bcoin` int(11) NOT NULL,
  `coin` int(11) NOT NULL,
  `silver` int(11) NOT NULL,
  `gold` int(11) NOT NULL,
  `type` tinyint(1) NOT NULL,
  `ctime` int(10) NOT NULL,
  `admin_username` varchar(20) NOT NULL,
  `node` smallint(3) NOT NULL COMMENT '线路',
  `minlv` smallint(3) NOT NULL,
  `maxlv` smallint(3) NOT NULL,
  `acc_name` text NOT NULL,
  `stren` tinyint(3) NOT NULL COMMENT '强化',
  `prefix` tinyint(3) NOT NULL COMMENT '前缀',
  `realname` varchar(20) NOT NULL COMMENT '审核批准的管理员名称',
  `point` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  `special_attachment` varchar(1000) DEFAULT '[]' COMMENT '邮件附件列表',
  `source` varchar(50) DEFAULT NULL COMMENT '渠道',
  `send_time` int(10) NOT NULL DEFAULT '0' COMMENT '指定发送时间',
  `send_type` int(2) NOT NULL DEFAULT '0' COMMENT '0:无需审核;1:需要审核',
  `send_status` int(2) NOT NULL DEFAULT '0' COMMENT '0:未发送;1:已发送',
  `status` int(2) NOT NULL DEFAULT '0' COMMENT '状态：0：未审1：通过2：拒绝',
  `minvip` int(5) DEFAULT NULL,
  `maxvip` int(5) DEFAULT NULL,
  `days` int(5) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ctime` (`ctime`),
  KEY `admin_username` (`admin_username`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='后台需要等待审核的邮件';

-- 数据导出被取消选择。

-- 导出  表 yzygame.market_bid_info 结构
DROP TABLE IF EXISTS `market_bid_info`;
CREATE TABLE IF NOT EXISTS `market_bid_info` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出价玩家Id',
  `role_name` varchar(100) NOT NULL DEFAULT '' COMMENT '出价玩家名字',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞价',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次出价时间戳',
  PRIMARY KEY (`id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-玩家竞拍出价';

-- 数据导出被取消选择。

-- 导出  表 yzygame.market_deal_log 结构
DROP TABLE IF EXISTS `market_deal_log`;
CREATE TABLE IF NOT EXISTS `market_deal_log` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家Id',
  `get_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '获得者玩家Id',
  `get_role_name` varchar(100) NOT NULL DEFAULT '' COMMENT '获得者名字',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品唯一Id',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型Id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `lev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品等级',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品品质',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交价格',
  `sell_type` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '上架类型：1:世界上架2:帮派上架',
  `guild_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上架时间戳',
  `deal_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交时间戳',
  `deal_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交类型:0:竞价1:一口价',
  `log_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交记录大类',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '物品额外特殊属性',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场成交记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.market_goods 结构
DROP TABLE IF EXISTS `market_goods`;
CREATE TABLE IF NOT EXISTS `market_goods` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家Id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品唯一Id',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型Id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `lev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品等级',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品品质',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '现竞价',
  `sell_type` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '上架类型：1:世界上架2:帮派上架',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上架时间戳',
  `off_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下架时间戳',
  `sys_buyback_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统回购时间戳-0表示系统不回购',
  `is_to_world` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会上架流拍是否上架世界：0:否1:是',
  `bidder_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '最高出价玩家Id',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '物品额外特殊属性',
  `sys_buyback_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '系统回购次数',
  `off_shelf` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否流拍下架',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场出售的商品信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.market_goods_supply_info 结构
DROP TABLE IF EXISTS `market_goods_supply_info`;
CREATE TABLE IF NOT EXISTS `market_goods_supply_info` (
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型Id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家累积上架物品数量',
  `supply_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统今日累积补给数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统最近一次补给时间戳',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-系统补给商品数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.market_like_info 结构
DROP TABLE IF EXISTS `market_like_info`;
CREATE TABLE IF NOT EXISTS `market_like_info` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家角色Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关注时间戳',
  PRIMARY KEY (`id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-玩家竞拍关注';

-- 数据导出被取消选择。

-- 导出  表 yzygame.market_reminder_info 结构
DROP TABLE IF EXISTS `market_reminder_info`;
CREATE TABLE IF NOT EXISTS `market_reminder_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家角色Id',
  `reminder_list` varchar(800) NOT NULL DEFAULT '[]' COMMENT '玩家入库提醒列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场-玩家入库提醒列表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.market_role_deal_log 结构
DROP TABLE IF EXISTS `market_role_deal_log`;
CREATE TABLE IF NOT EXISTS `market_role_deal_log` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rela_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '关联玩家Id',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型Id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交价格',
  `sell_type` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '上架类型：1:世界上架2:帮派上架',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上架时间戳',
  `deal_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交时间戳',
  `deal_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交类型:1:竞价买入2:一口价买入3:卖出',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '物品额外特殊属性',
  PRIMARY KEY (`id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易市场玩家个人成交记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mate_daily_info 结构
DROP TABLE IF EXISTS `mate_daily_info`;
CREATE TABLE IF NOT EXISTS `mate_daily_info` (
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `time` int(11) NOT NULL COMMENT '上次刷新时间',
  `stranger` varchar(255) NOT NULL COMMENT '路人id列表',
  PRIMARY KEY (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='羁绊-日常信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mate_hall 结构
DROP TABLE IF EXISTS `mate_hall`;
CREATE TABLE IF NOT EXISTS `mate_hall` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '发布类型##1普通发布|2置顶发布',
  `declaration` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '交友宣言',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '发布时间',
  PRIMARY KEY (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-交友大厅(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mate_info 结构
DROP TABLE IF EXISTS `mate_info`;
CREATE TABLE IF NOT EXISTS `mate_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `other` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '羁绊玩家',
  `remarks` tinyint(2) NOT NULL DEFAULT '1' COMMENT '备注',
  `title` varchar(50) NOT NULL DEFAULT '<<>>' COMMENT '羁绊称号(自定义)',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '结交时间戳',
  `anniversary` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '纪念日奖励领取情况',
  PRIMARY KEY (`role_id`,`other`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-玩家羁绊伙伴(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mate_role 结构
DROP TABLE IF EXISTS `mate_role`;
CREATE TABLE IF NOT EXISTS `mate_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `boat_stage` tinyint(2) NOT NULL DEFAULT '0' COMMENT '友谊的小船阶数',
  `boat_star` tinyint(2) NOT NULL DEFAULT '0' COMMENT '友谊的小船星级',
  `boat_exp` int(11) NOT NULL DEFAULT '0' COMMENT '友谊的小船经验值',
  `wear_mate` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '佩戴的羁绊称号对象',
  `newbee` tinyint(2) NOT NULL DEFAULT '0' COMMENT '预告奖励',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羁绊-玩家羁绊系统信息(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mate_task_info 结构
DROP TABLE IF EXISTS `mate_task_info`;
CREATE TABLE IF NOT EXISTS `mate_task_info` (
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `mate_id` bigint(20) NOT NULL COMMENT '羁绊对象id',
  `task_id` smallint(6) NOT NULL COMMENT '任务id',
  `progress` smallint(6) NOT NULL COMMENT '进度',
  `state` tinyint(4) NOT NULL COMMENT '奖励状态',
  PRIMARY KEY (`role_id`,`mate_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='羁绊-任务进度';

-- 数据导出被取消选择。

-- 导出  表 yzygame.merge_server_center 结构
DROP TABLE IF EXISTS `merge_server_center`;
CREATE TABLE IF NOT EXISTS `merge_server_center` (
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服合服信息(合服合并保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.merge_server_local 结构
DROP TABLE IF EXISTS `merge_server_local`;
CREATE TABLE IF NOT EXISTS `merge_server_local` (
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服合服信息(合服合并保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mobilize_days_reward 结构
DROP TABLE IF EXISTS `mobilize_days_reward`;
CREATE TABLE IF NOT EXISTS `mobilize_days_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `sub_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子Id',
  `start_day` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '开始天数',
  `end_day` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '结束天数',
  `total` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '完成任务数量',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '大奖领取状态',
  PRIMARY KEY (`role_id`,`sub_type`,`start_day`,`end_day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='全民动员-天数大奖数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mobilize_fake_cord 结构
DROP TABLE IF EXISTS `mobilize_fake_cord`;
CREATE TABLE IF NOT EXISTS `mobilize_fake_cord` (
  `task_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `fake_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '假数据id',
  `act` int(11) NOT NULL DEFAULT '0' COMMENT '活动子Id',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始天数',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '截止时间',
  `ltime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次更新',
  `remain_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '应补助分',
  `per_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次补助分',
  `remain_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '补助频率',
  `remain_click` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '补助计数器',
  `process` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目前进度',
  `real_pro` int(11) NOT NULL DEFAULT '0' COMMENT '真实进度',
  PRIMARY KEY (`task_type`,`fake_id`,`act`,`day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全民动员 合服保留主服';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mobilize_power 结构
DROP TABLE IF EXISTS `mobilize_power`;
CREATE TABLE IF NOT EXISTS `mobilize_power` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '全民动员任务开启记录的战力',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='全民动员-记录登录战力';

-- 数据导出被取消选择。

-- 导出  表 yzygame.mobilize_task 结构
DROP TABLE IF EXISTS `mobilize_task`;
CREATE TABLE IF NOT EXISTS `mobilize_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `sub_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型Id',
  `start_day` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '开始天数',
  `end_day` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '结束天数',
  `task_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型Id',
  `progress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `award_log` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励领取情况',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间戳',
  PRIMARY KEY (`role_id`,`sub_type`,`start_day`,`end_day`,`task_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='全民动员-任务进度数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.module_advance_reward 结构
DROP TABLE IF EXISTS `module_advance_reward`;
CREATE TABLE IF NOT EXISTS `module_advance_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `state` bigint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励状态',
  PRIMARY KEY (`role_id`,`module_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能预告奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.node 结构
DROP TABLE IF EXISTS `node`;
CREATE TABLE IF NOT EXISTS `node` (
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `ip` varchar(50) NOT NULL DEFAULT '' COMMENT 'ip地址',
  `port` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '端口号',
  `node` varchar(100) NOT NULL COMMENT '节点',
  `cookie` varchar(100) DEFAULT '' COMMENT 'cookie',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否关闭 0开启 1关闭',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单服节点列表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.notice 结构
DROP TABLE IF EXISTS `notice`;
CREATE TABLE IF NOT EXISTS `notice` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `open_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服天数限制',
  `merge_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服天数限制',
  `source` varchar(1024) NOT NULL DEFAULT '' COMMENT '渠道',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '公告类型，0 中1 左2 右3 中左4 中右5 左右6 左中右',
  `color` varchar(7) NOT NULL DEFAULT '' COMMENT '公告颜色',
  `content` varchar(500) NOT NULL DEFAULT '' COMMENT '公告内容',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '内容链接',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总发送次数，0为不限',
  `span` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '时间间隔',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态，0为禁用，1为开启',
  PRIMARY KEY (`id`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='系统公告表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.offline_hosting_log 结构
DROP TABLE IF EXISTS `offline_hosting_log`;
CREATE TABLE IF NOT EXISTS `offline_hosting_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能ID',
  `sub_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '子ID',
  `cost_value` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '托管值',
  `award` varchar(2000) NOT NULL DEFAULT '' COMMENT '奖励记录',
  `duration` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '持续时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线托管日志(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.offline_hosting_setting 结构
DROP TABLE IF EXISTS `offline_hosting_setting`;
CREATE TABLE IF NOT EXISTS `offline_hosting_setting` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `close_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '关闭的活动列表',
  `value` int(11) NOT NULL DEFAULT '0' COMMENT '托管值',
  `u_time` int(11) NOT NULL DEFAULT '0' COMMENT '托管值刷新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线托管设置(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.overflow_gift 结构
DROP TABLE IF EXISTS `overflow_gift`;
CREATE TABLE IF NOT EXISTS `overflow_gift` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `lv_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '到达配置等级时的时间戳',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超值礼包活动信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.overlord_info 结构
DROP TABLE IF EXISTS `overlord_info`;
CREATE TABLE IF NOT EXISTS `overlord_info` (
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `times` tinyint(2) NOT NULL DEFAULT '0' COMMENT '禁言次数',
  `pro_time` int(11) NOT NULL DEFAULT '0' COMMENT '上次使用禁言特权时间',
  `rename_time` varchar(255) NOT NULL DEFAULT '[]' COMMENT '上次改名时间',
  `buy_time` int(11) NOT NULL COMMENT '上次购买时间',
  PRIMARY KEY (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='霸主特权信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pellet_award_records 结构
DROP TABLE IF EXISTS `pellet_award_records`;
CREATE TABLE IF NOT EXISTS `pellet_award_records` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `name` varchar(100) NOT NULL COMMENT '角色名',
  `goods_type_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '道具配置id',
  `goods_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '道具数量',
  `get_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '获取方式（0抽奖 1累计次数奖励）',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '获得时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠活动奖励记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.perfect_lover_reward 结构
DROP TABLE IF EXISTS `perfect_lover_reward`;
CREATE TABLE IF NOT EXISTS `perfect_lover_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `reward_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励领取状态',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='三世恋人奖励领取状态';

-- 数据导出被取消选择。

-- 导出  表 yzygame.perfect_lover_times 结构
DROP TABLE IF EXISTS `perfect_lover_times`;
CREATE TABLE IF NOT EXISTS `perfect_lover_times` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `wedding_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='完美恋人玩家婚礼次数记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pet_power_center_rank 结构
DROP TABLE IF EXISTS `pet_power_center_rank`;
CREATE TABLE IF NOT EXISTS `pet_power_center_rank` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `role_name` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '角色名',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器号',
  `vip` mediumint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip',
  `sup_vip` mediumint(5) unsigned NOT NULL DEFAULT '0' COMMENT '贵族',
  `dress_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像框',
  `photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像',
  `sum_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '宠物总战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间戳',
  PRIMARY KEY (`zone_id`,`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=COMPACT COMMENT='宠物-跨服分区宠物战力榜';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pet_power_rank 结构
DROP TABLE IF EXISTS `pet_power_rank`;
CREATE TABLE IF NOT EXISTS `pet_power_rank` (
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `role_pet_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '今日最高宠物战力',
  `sum_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '宠物总战力',
  `yest_role_id` bigint(20) unsigned NOT NULL COMMENT '昨日榜最高宠物战力玩家',
  `yest_sum_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '宠物昨日总战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物-游戏服战力排行榜';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pet_skill_diamond 结构
DROP TABLE IF EXISTS `pet_skill_diamond`;
CREATE TABLE IF NOT EXISTS `pet_skill_diamond` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `diamond_slot` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '技能石槽位',
  `diamond_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能石Id',
  PRIMARY KEY (`role_id`,`pet_id`,`diamond_slot`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物技能宝石栏数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pet_support_info 结构
DROP TABLE IF EXISTS `pet_support_info`;
CREATE TABLE IF NOT EXISTS `pet_support_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `slot_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '槽位Id',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`role_id`,`slot_id`,`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物支援槽位表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pet_support_rank 结构
DROP TABLE IF EXISTS `pet_support_rank`;
CREATE TABLE IF NOT EXISTS `pet_support_rank` (
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '今日投票榜战力头名角色Id',
  `support_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日投票数',
  `yest_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '昨日榜战力头名玩家Id',
  `yest_support_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物昨天的投票人数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物全服支援排行榜数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pet_vote_info 结构
DROP TABLE IF EXISTS `pet_vote_info`;
CREATE TABLE IF NOT EXISTS `pet_vote_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `vote_count` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '投票次数',
  `pet_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '投票的宠物列表',
  `receive_pet_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '已领取奖励宠物列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物投票信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_1vn 结构
DROP TABLE IF EXISTS `player_1vn`;
CREATE TABLE IF NOT EXISTS `player_1vn` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `def_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型（擂主or挑战者）',
  `turn` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '擂主存活到多少轮',
  `area` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '赛区',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家1vn段位记录，合服合并';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_attr 结构
DROP TABLE IF EXISTS `player_attr`;
CREATE TABLE IF NOT EXISTS `player_attr` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `cell_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '背包格子数',
  `storage_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '仓库格子数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户属性';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_daily_liveness 结构
DROP TABLE IF EXISTS `player_daily_liveness`;
CREATE TABLE IF NOT EXISTS `player_daily_liveness` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `livess_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '活跃度列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家每日活跃度记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_date_hightest_power 结构
DROP TABLE IF EXISTS `player_date_hightest_power`;
CREATE TABLE IF NOT EXISTS `player_date_hightest_power` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '记录类型',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当天0点数据',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='当天0点数据（合服直接清理）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_degree 结构
DROP TABLE IF EXISTS `player_degree`;
CREATE TABLE IF NOT EXISTS `player_degree` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `degree_id` smallint(5) unsigned NOT NULL COMMENT '学位Id(对应学位等级)',
  `degree_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '学位经验',
  `dun_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '副本完成状态，0未完成 1完成',
  `time` int(11) unsigned NOT NULL COMMENT '刷新时间戳',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='境界学位表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_degree_classwork 结构
DROP TABLE IF EXISTS `player_degree_classwork`;
CREATE TABLE IF NOT EXISTS `player_degree_classwork` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `class_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '日常功课Id',
  `content` varchar(255) NOT NULL DEFAULT '[]' COMMENT '日常功课状态数据',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新时间戳',
  PRIMARY KEY (`role_id`,`class_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='学位日常功课任务表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_devour 结构
DROP TABLE IF EXISTS `player_devour`;
CREATE TABLE IF NOT EXISTS `player_devour` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `devour_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬等级',
  `devour_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬经验',
  `is_auto` int(11) NOT NULL DEFAULT '0' COMMENT '是否自动吞噬',
  `active_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '激活的节点等级',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='背包吞噬(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_expedition 结构
DROP TABLE IF EXISTS `player_expedition`;
CREATE TABLE IF NOT EXISTS `player_expedition` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `start_online_onhook_time` int(11) unsigned NOT NULL COMMENT '最近一次开始在线远征的时间',
  `expedition_need_calc_guardians` varchar(255) NOT NULL COMMENT '远征奖励需要计算的守护列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_fishing 结构
DROP TABLE IF EXISTS `player_fishing`;
CREATE TABLE IF NOT EXISTS `player_fishing` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '钓鱼等级',
  `mastery` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '熟练度',
  `fish_rod_usage_count` varchar(512) NOT NULL DEFAULT '[]' COMMENT '{鱼竿id,剩余使用次数}',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钓鱼';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_foster 结构
DROP TABLE IF EXISTS `player_foster`;
CREATE TABLE IF NOT EXISTS `player_foster` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `grade` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '阶',
  `star` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '星',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `click` int(11) NOT NULL DEFAULT '0' COMMENT '操作次数',
  `clear` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否清零',
  `display` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前幻化',
  `isride` int(11) NOT NULL DEFAULT '0' COMMENT '骑乘状态',
  `lowcore` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初级核心',
  `highcore` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '高级核心',
  `core_ext` varchar(500) NOT NULL DEFAULT '[]' COMMENT '其他高级核心',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  `skills` varchar(500) NOT NULL DEFAULT '[]' COMMENT '技能列表',
  PRIMARY KEY (`rid`,`type`),
  KEY `type` (`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家进阶系统表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_foster_equip 结构
DROP TABLE IF EXISTS `player_foster_equip`;
CREATE TABLE IF NOT EXISTS `player_foster_equip` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `equips` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '穿戴',
  `assist` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '助战属性激活状态',
  PRIMARY KEY (`rid`,`type`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶装备';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_foster_skin 结构
DROP TABLE IF EXISTS `player_foster_skin`;
CREATE TABLE IF NOT EXISTS `player_foster_skin` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系统类型',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `display` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '展示',
  PRIMARY KEY (`rid`,`type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶珍宝';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_galaxy 结构
DROP TABLE IF EXISTS `player_galaxy`;
CREATE TABLE IF NOT EXISTS `player_galaxy` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '星群',
  `subtype` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '星团',
  `gain` varchar(500) NOT NULL DEFAULT '[]' COMMENT '已收集',
  `state` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  PRIMARY KEY (`rid`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星辰图鉴数据合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_goldmine 结构
DROP TABLE IF EXISTS `player_goldmine`;
CREATE TABLE IF NOT EXISTS `player_goldmine` (
  `role_id` bigint(20) NOT NULL,
  `mine_lv` smallint(5) NOT NULL,
  `received_times` tinyint(3) NOT NULL,
  `received_update_time` int(11) NOT NULL,
  `online_time` mediumint(8) NOT NULL,
  `online_update_time` int(11) NOT NULL,
  `miners` varchar(255) NOT NULL,
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家金币矿洞数据（合服直接合并）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_guild 结构
DROP TABLE IF EXISTS `player_guild`;
CREATE TABLE IF NOT EXISTS `player_guild` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `leave_guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '最新离开的公会id',
  `leave_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次退出公会时间',
  `red_packet` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包抢金额',
  `red_gold_packet` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钻石红包金额',
  `order` varchar(500) NOT NULL DEFAULT '[]' COMMENT '已接单',
  `deliver` int(11) NOT NULL DEFAULT '0' COMMENT '待派发',
  `support_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '支援Id',
  `is_support_asker` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否协助发送者 0-否 1-是',
  `guild_reputation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日社团声望',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家的公会信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_guild_labor 结构
DROP TABLE IF EXISTS `player_guild_labor`;
CREATE TABLE IF NOT EXISTS `player_guild_labor` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `tid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `content` varchar(500) NOT NULL DEFAULT '[]' COMMENT '任务内容',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT '领取状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`rid`,`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团劳务数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_guild_skill 结构
DROP TABLE IF EXISTS `player_guild_skill`;
CREATE TABLE IF NOT EXISTS `player_guild_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`role_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家公会技能';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_high 结构
DROP TABLE IF EXISTS `player_high`;
CREATE TABLE IF NOT EXISTS `player_high` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '元宝',
  `bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '绑定元宝',
  `fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '粉钻',
  `coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜币',
  `gcoin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会币',
  `gfame` int(11) NOT NULL DEFAULT '0' COMMENT '社团声望',
  `honour` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名望券',
  `exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `exp_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '经验列表',
  `hightest_combat_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '历史最高战力',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户高频数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_hi_point 结构
DROP TABLE IF EXISTS `player_hi_point`;
CREATE TABLE IF NOT EXISTS `player_hi_point` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '嗨点值',
  `extra_points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额外嗨点值',
  `task_info` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '任务情况',
  `reward_info` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '奖励情况',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='玩家嗨点数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_liveness 结构
DROP TABLE IF EXISTS `player_liveness`;
CREATE TABLE IF NOT EXISTS `player_liveness` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `live` int(11) NOT NULL DEFAULT '0' COMMENT '活跃',
  `olive` int(11) NOT NULL DEFAULT '0' COMMENT '昨日活跃',
  `ltime` int(11) NOT NULL DEFAULT '0' COMMENT '上次更新',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家活跃度';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_login 结构
DROP TABLE IF EXISTS `player_login`;
CREATE TABLE IF NOT EXISTS `player_login` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `server_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '初始服id',
  `accid` int(11) unsigned NOT NULL DEFAULT '0',
  `accname` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT '平台账户',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '玩家状态（0正常1禁止）',
  `reg_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '注册时间',
  `reg_ip` varchar(20) NOT NULL DEFAULT '' COMMENT '注册IP',
  `last_login_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后登陆时间',
  `last_login_ip` varchar(20) NOT NULL DEFAULT '' COMMENT '最后登陆ip',
  `gm` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'GM账号(0普通,1gm)',
  `talk_reported_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '聊天被举报的次数',
  `talk_lim_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '聊天被禁言的次数',
  `talk_lim` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '禁言(0开放,1禁言)',
  `talk_lim_type` tinyint(1) DEFAULT '0' COMMENT '禁言类型a',
  `talk_lim_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '禁言截止时间',
  `last_logout_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后退出时间',
  `online_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否在线',
  `talk_lim_right` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '禁言权限 0无权限 1有权限',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '渠道来源',
  `last_pay_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次充值时间',
  `comeback_state` tinyint(3) NOT NULL DEFAULT '0' COMMENT '封测回归处理状态',
  `last_behavior` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后行为',
  PRIMARY KEY (`id`),
  KEY `server_id` (`server_id`),
  KEY `reg_time` (`reg_time`),
  KEY `last_login_time` (`last_login_time`),
  KEY `status` (`status`),
  KEY `reg_ip` (`reg_ip`),
  KEY `account` (`accid`,`accname`),
  KEY `accname` (`accname`),
  KEY `last_logout_time` (`last_logout_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户登陆信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_login_return_reward 结构
DROP TABLE IF EXISTS `player_login_return_reward`;
CREATE TABLE IF NOT EXISTS `player_login_return_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `buy_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  `receive_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时间',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='0元豪礼';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_low 结构
DROP TABLE IF EXISTS `player_low`;
CREATE TABLE IF NOT EXISTS `player_low` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `nickname` varchar(50) NOT NULL COMMENT '角色昵称',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别:1男 2女',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '1' COMMENT '等级',
  `onhook_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '离线挂机时等级',
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `realm` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `picture` varchar(100) NOT NULL DEFAULT '' COMMENT '玩家上传的头像url',
  `picture_lim` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否禁止头像0：正常1：禁止',
  `picture_ver` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家上传的头像版本号',
  `profile_photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家头像id',
  `c_rename` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '改名标记',
  `c_rename_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家名字上一次修改时间',
  `c_recareer_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家转职cd时间',
  `c_default` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否自选职业',
  PRIMARY KEY (`id`),
  UNIQUE KEY `nickname` (`nickname`),
  KEY `lv` (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户低频数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_newer_task 结构
DROP TABLE IF EXISTS `player_newer_task`;
CREATE TABLE IF NOT EXISTS `player_newer_task` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`rid`,`type`,`task_id`),
  KEY `rid` (`rid`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='任务领取记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_npc 结构
DROP TABLE IF EXISTS `player_npc`;
CREATE TABLE IF NOT EXISTS `player_npc` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `npc_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'NPCID',
  `is_show` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'NPC状态,0不显示,1显示',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `x` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'X位置',
  `y` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Y位置',
  `args` varchar(400) NOT NULL DEFAULT '' COMMENT 'npc模型和动作参数',
  UNIQUE KEY `id` (`id`,`npc_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家NPC动态显示';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_nucleon 结构
DROP TABLE IF EXISTS `player_nucleon`;
CREATE TABLE IF NOT EXISTS `player_nucleon` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '槽位',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '经验',
  `skill` int(11) NOT NULL DEFAULT '0' COMMENT '技能',
  `skill_lv` int(11) NOT NULL DEFAULT '0' COMMENT '技能等级',
  `sec_lv` int(11) NOT NULL DEFAULT '0' COMMENT '觉醒等级',
  `attrs` varchar(100) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`rid`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='灵能槽位-合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_pic 结构
DROP TABLE IF EXISTS `player_pic`;
CREATE TABLE IF NOT EXISTS `player_pic` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴等级',
  PRIMARY KEY (`role_id`,`pic_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_recharge_rfmt 结构
DROP TABLE IF EXISTS `player_recharge_rfmt`;
CREATE TABLE IF NOT EXISTS `player_recharge_rfmt` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `last_pay_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近充值时间',
  `total_money` decimal(12,2) DEFAULT '0.00' COMMENT '总充值金额',
  `total_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总充值元宝',
  `recency` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '评级：充值间隔',
  `frequency` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '评级：充值频率',
  `monetary` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '评级：历史总充值',
  `top` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '评级：最高额充值',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家充值统计数据，合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_rename 结构
DROP TABLE IF EXISTS `player_rename`;
CREATE TABLE IF NOT EXISTS `player_rename` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `old_name` varchar(50) NOT NULL COMMENT '角色昵称',
  `c_rename_time` int(11) NOT NULL COMMENT '修改名字时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='修改昵称';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_setting 结构
DROP TABLE IF EXISTS `player_setting`;
CREATE TABLE IF NOT EXISTS `player_setting` (
  `id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '设置主类型',
  `subtype` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '设置次类型',
  `is_open` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '是否开关（1:开 0:关）',
  PRIMARY KEY (`id`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家设置';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_smashed_egg 结构
DROP TABLE IF EXISTS `player_smashed_egg`;
CREATE TABLE IF NOT EXISTS `player_smashed_egg` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计在线时间',
  `lfree_smashed_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后免费砸蛋时间戳',
  `add_refresh_times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '全砸赠送的刷新次数',
  `refresh_times` smallint(2) NOT NULL DEFAULT '0' COMMENT '刷新次数',
  `free_smashed_times` smallint(2) NOT NULL DEFAULT '0' COMMENT '免费砸蛋次数',
  `smashed_times` smallint(2) NOT NULL DEFAULT '0' COMMENT '砸蛋总次数',
  `eggs` varchar(255) NOT NULL DEFAULT '' COMMENT '金蛋列表',
  `cumulate_reward` varchar(100) NOT NULL DEFAULT '0' COMMENT '累计奖励领取状态',
  `show_ids` varchar(50) NOT NULL DEFAULT '' COMMENT '展示id列表',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_smashed_egg_reward 结构
DROP TABLE IF EXISTS `player_smashed_egg_reward`;
CREATE TABLE IF NOT EXISTS `player_smashed_egg_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `subtype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  PRIMARY KEY (`role_id`,`subtype`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋奖励列表（合服直接合并）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_special_currency 结构
DROP TABLE IF EXISTS `player_special_currency`;
CREATE TABLE IF NOT EXISTS `player_special_currency` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `currency_id` int(10) unsigned NOT NULL COMMENT '货币物品id',
  `num` int(10) unsigned NOT NULL COMMENT '数量',
  PRIMARY KEY (`player_id`,`currency_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特殊货币数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_state 结构
DROP TABLE IF EXISTS `player_state`;
CREATE TABLE IF NOT EXISTS `player_state` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景',
  `x` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'x坐标',
  `y` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'y坐标',
  `hp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '气血',
  `mp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内力',
  `pk_value` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT 'pk值',
  `pk_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'pk状态',
  `pk_status_change_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'pk转换时间',
  `guild_quit_lasttime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次退出帮派时间',
  `anger` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怒气值',
  `quickbar` varchar(1200) NOT NULL DEFAULT '[]' COMMENT '快捷栏',
  `skill_cd` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '技能cd列表',
  `sys_conf` varchar(50) NOT NULL DEFAULT '[]' COMMENT '玩家配置',
  `skill_extra_point` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额外技能点',
  `last_combat_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最后退出游戏时候的战力',
  `pk_value_change_time` int(10) unsigned DEFAULT '0' COMMENT '罪恶值修改时间(间隔12小时)',
  `last_task_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上一次完成的主线任务id',
  `last_be_kill` varchar(250) NOT NULL DEFAULT '[]' COMMENT '最后击杀自己的玩家信息',
  `passive_skill` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '被动技能列表##离线保存',
  `attr` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '玩家属性##离线保存',
  PRIMARY KEY (`id`),
  KEY `scene` (`scene`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户下线时保存信息表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_sub_foster_skin 结构
DROP TABLE IF EXISTS `player_sub_foster_skin`;
CREATE TABLE IF NOT EXISTS `player_sub_foster_skin` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '弱进阶类型',
  `skin_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '皮肤Id',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `display_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化星级',
  PRIMARY KEY (`role_id`,`type`,`skin_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='进阶-弱进阶皮肤';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_top_pk 结构
DROP TABLE IF EXISTS `player_top_pk`;
CREATE TABLE IF NOT EXISTS `player_top_pk` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季积分',
  `grade_reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '已领段位奖励列表',
  `match_reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '已领匹配次数奖励',
  `pk_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次PK时间',
  `enter_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '匹配场数',
  `continued_fail` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连续失败场次',
  `continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连续失败场次',
  PRIMARY KEY (`role_id`),
  KEY `score` (`score`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技玩家数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_visus 结构
DROP TABLE IF EXISTS `player_visus`;
CREATE TABLE IF NOT EXISTS `player_visus` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻光id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强度',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT '激活状态',
  `display` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`rid`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家幻光';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_visus_skill 结构
DROP TABLE IF EXISTS `player_visus_skill`;
CREATE TABLE IF NOT EXISTS `player_visus_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前使用的技能Id',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻光功能-玩家当前使用的技能Id';

-- 数据导出被取消选择。

-- 导出  表 yzygame.player_welfare 结构
DROP TABLE IF EXISTS `player_welfare`;
CREATE TABLE IF NOT EXISTS `player_welfare` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `round` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '签到周期',
  `days` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '签到天数',
  `online_type` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '在线奖励类型',
  `level_award_state` bigint(20) NOT NULL DEFAULT '0' COMMENT '等级礼包状态',
  `download_award_state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '资源下载奖励状态',
  `cumulative_sign_in_info` int(11) NOT NULL DEFAULT '0' COMMENT '累计签到奖励情况',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='福利大厅(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.printer_draw 结构
DROP TABLE IF EXISTS `printer_draw`;
CREATE TABLE IF NOT EXISTS `printer_draw` (
  `sub_type` int(11) unsigned NOT NULL COMMENT '活动子类',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配方id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`sub_type`,`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成机-首次合成数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.pushmail 结构
DROP TABLE IF EXISTS `pushmail`;
CREATE TABLE IF NOT EXISTS `pushmail` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `mail` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史邮件Id',
  PRIMARY KEY (`role_id`,`mail`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件推送';

-- 数据导出被取消选择。

-- 导出  表 yzygame.race_rank 结构
DROP TABLE IF EXISTS `race_rank`;
CREATE TABLE IF NOT EXISTS `race_rank` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `rname` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名字',
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`act_id`,`zone_id`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-排行榜数据(在跨服中使用-合跨服合并保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.race_rank_opening_act 结构
DROP TABLE IF EXISTS `race_rank_opening_act`;
CREATE TABLE IF NOT EXISTS `race_rank_opening_act` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `status` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已结算奖励:结算时的时间戳;还没结算奖励:0',
  PRIMARY KEY (`act_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-开启中的活动数据(在跨服中使用-合跨服保留主服数据)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.race_rank_server_score 结构
DROP TABLE IF EXISTS `race_rank_server_score`;
CREATE TABLE IF NOT EXISTS `race_rank_server_score` (
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`act_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服积分-合跨服合并保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.race_rank_zone 结构
DROP TABLE IF EXISTS `race_rank_zone`;
CREATE TABLE IF NOT EXISTS `race_rank_zone` (
  `server_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id(后台唯一服号)',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区Id',
  `platform` varchar(100) NOT NULL DEFAULT '' COMMENT '平台名',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号(玩家可见的服编号)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加入分区时间戳',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服竞榜活动-分区信息(在跨服中使用-合跨服合并保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.recharge_act 结构
DROP TABLE IF EXISTS `recharge_act`;
CREATE TABLE IF NOT EXISTS `recharge_act` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值商品ID',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次领取时间',
  `left_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '剩余数量',
  `buy_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  `end_time` int(11) NOT NULL DEFAULT '0' COMMENT '结束时间',
  PRIMARY KEY (`role_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值商品';

-- 数据导出被取消选择。

-- 导出  表 yzygame.recharge_cumulation_reward 结构
DROP TABLE IF EXISTS `recharge_cumulation_reward`;
CREATE TABLE IF NOT EXISTS `recharge_cumulation_reward` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `subtype` tinyint(3) unsigned NOT NULL COMMENT '活动子类型',
  `id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `time` int(10) unsigned NOT NULL COMMENT '时间，重置用',
  `state` tinyint(3) unsigned NOT NULL COMMENT '是否领取 0否1是',
  `info` varchar(255) NOT NULL COMMENT '信息，发邮件用',
  PRIMARY KEY (`player_id`,`subtype`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累充活动奖励领取状态';

-- 数据导出被取消选择。

-- 导出  表 yzygame.recharge_daily_gift 结构
DROP TABLE IF EXISTS `recharge_daily_gift`;
CREATE TABLE IF NOT EXISTS `recharge_daily_gift` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '商品编号',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '礼包状态',
  PRIMARY KEY (`player_id`,`product_id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日礼包';

-- 数据导出被取消选择。

-- 导出  表 yzygame.recharge_log 结构
DROP TABLE IF EXISTS `recharge_log`;
CREATE TABLE IF NOT EXISTS `recharge_log` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台账号id',
  `accname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台账号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `type` int(4) unsigned NOT NULL DEFAULT '0' COMMENT '1:充值 2:钻石卡',
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '商品id',
  `money` decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '金额',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钻石',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `product_id` (`product_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.recharge_return 结构
DROP TABLE IF EXISTS `recharge_return`;
CREATE TABLE IF NOT EXISTS `recharge_return` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `return_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '返利类型',
  `return_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利时间',
  PRIMARY KEY (`player_id`,`product_id`,`return_type`),
  KEY `return_time` (`return_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值返利表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.red_envelopes 结构
DROP TABLE IF EXISTS `red_envelopes`;
CREATE TABLE IF NOT EXISTS `red_envelopes` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '红包类型',
  `ownership_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:公会 2:世界',
  `ownership_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属id 公会红包为公会的id',
  `owner_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拥有者玩家id',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0: 未发送 1: 已发送 2: 已领完 3: 已过期',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包额度',
  `money_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '金额列表',
  `share_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '玩家id',
  `split_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '红包拆分数量',
  `extra` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '系统赠送红包为配置id 道具红包为道具id',
  `greet` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包发送时间',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `ownership_id` (`ownership_id`),
  KEY `owner_id` (`owner_id`),
  KEY `status` (`status`,`stime`),
  KEY `ownership_id_2` (`ownership_id`,`owner_id`,`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包';

-- 数据导出被取消选择。

-- 导出  表 yzygame.red_envelopes_recipients_record 结构
DROP TABLE IF EXISTS `red_envelopes_recipients_record`;
CREATE TABLE IF NOT EXISTS `red_envelopes_recipients_record` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `red_envelopes_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `ownership_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属id 公会红包为公会的id',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取到的额度',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包发送时间(用来批量删除)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`red_envelopes_id`),
  KEY `ownership_id` (`ownership_id`),
  KEY `stime` (`stime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包领取记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.relationship 结构
DROP TABLE IF EXISTS `relationship`;
CREATE TABLE IF NOT EXISTS `relationship` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '关系另一方的玩家id',
  `rela_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关系类型',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '亲密度',
  `contribute` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本方亲密度贡献比例',
  `last_chat_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后聊天时间',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关系记录创建时间',
  PRIMARY KEY (`role_id`,`other_rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='关系列表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.rela_friend_ask 结构
DROP TABLE IF EXISTS `rela_friend_ask`;
CREATE TABLE IF NOT EXISTS `rela_friend_ask` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '被请求的玩家id',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '请求的玩家id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '请求时间',
  PRIMARY KEY (`role_id`,`ask_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='好友请求';

-- 数据导出被取消选择。

-- 导出  表 yzygame.resource_back 结构
DROP TABLE IF EXISTS `resource_back`;
CREATE TABLE IF NOT EXISTS `resource_back` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cleartime` int(11) NOT NULL DEFAULT '0' COMMENT '清除时间',
  `daytype` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '日期类型',
  `act_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '活动列表',
  PRIMARY KEY (`player_id`,`daytype`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='资源找回';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_3v3 结构
DROP TABLE IF EXISTS `role_3v3`;
CREATE TABLE IF NOT EXISTS `role_3v3` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `old_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨天段位',
  `old_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨天星数',
  `tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连胜次数',
  `daily_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日胜利场次',
  `daily_pk` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日战斗场次',
  `daily_honor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日可得荣誉值',
  `pack_reward` varchar(1000) NOT NULL DEFAULT '[{1, 0}, {2, 0}, {3, 0}]' COMMENT '领取胜利场次奖励字段',
  `pack_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日领取荣誉时间',
  `daily_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日刷新时间',
  `season_pk` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '本赛季战斗次数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服3v3 玩家信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_act_reserve 结构
DROP TABLE IF EXISTS `role_act_reserve`;
CREATE TABLE IF NOT EXISTS `role_act_reserve` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `module` int(11) unsigned NOT NULL COMMENT '功能id',
  `module_sub` int(11) unsigned NOT NULL COMMENT '功能子id',
  `ac_sub` int(11) unsigned NOT NULL COMMENT '子类id',
  `reserve` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '预约与否',
  `join_act` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否参与',
  `rewards` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已领奖励',
  PRIMARY KEY (`role_id`,`module`,`module_sub`,`ac_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动预约';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_boss_first_blood 结构
DROP TABLE IF EXISTS `role_boss_first_blood`;
CREATE TABLE IF NOT EXISTS `role_boss_first_blood` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BossId',
  `self_award` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '自己首杀领取状态',
  `server_award` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '全服首杀领取状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '首杀时间时间戳',
  PRIMARY KEY (`role_id`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家boss首杀数据(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_chat_limit 结构
DROP TABLE IF EXISTS `role_chat_limit`;
CREATE TABLE IF NOT EXISTS `role_chat_limit` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `chat_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家聊天次数',
  `chat_limit` varchar(500) NOT NULL DEFAULT '[]' COMMENT '限制内容[{模块id,点击与否}]',
  `role_shield` varchar(500) NOT NULL DEFAULT '[]' COMMENT '屏蔽列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家次数监控';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_child 结构
DROP TABLE IF EXISTS `role_child`;
CREATE TABLE IF NOT EXISTS `role_child` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `child_name` varchar(255) NOT NULL DEFAULT '' COMMENT '孩子名称',
  `child_sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '孩子性别',
  `child_age_year` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '孩子年龄-年',
  `child_age_month` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '孩子年龄-月',
  `child_age_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '孩子成长进度(经验值)',
  `heart_link_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '同心经验值',
  `heart_link_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '同心经验奖励领取情况',
  `vote_times` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '当天点赞次数',
  `show_off_times` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '当天晒娃次数',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新时间',
  `last_show_off_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次晒娃时间',
  `is_follow` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '孩子跟随状态 0-不跟随 1-跟随',
  `show_vehicle` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跟随载具 0-不跟随 其他-具体载具Id',
  `box_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩具盒等级',
  `adopt_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领养时间',
  PRIMARY KEY (`role_id`),
  KEY `child_name` (`child_name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='孩子基础信息表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_convoy 结构
DROP TABLE IF EXISTS `role_convoy`;
CREATE TABLE IF NOT EXISTS `role_convoy` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `convoy_id` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '可护送对象',
  `convoying` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前护送对象##没有时为0',
  `stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `pray_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '祝福值',
  `is_double` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否选择双倍',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送信息##合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_coupon_list 结构
DROP TABLE IF EXISTS `role_coupon_list`;
CREATE TABLE IF NOT EXISTS `role_coupon_list` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `op_role` bigint(20) unsigned NOT NULL COMMENT '领取的玩家|赠送的玩家',
  `coupon_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '1社交券|2羁绊券',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '1赠送|2领取',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`op_role`,`coupon_type`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社交票券数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_cross_point_score 结构
DROP TABLE IF EXISTS `role_cross_point_score`;
CREATE TABLE IF NOT EXISTS `role_cross_point_score` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `point_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
  `single_max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次最大积分',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总积分',
  `hurt_part` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伤害占比',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点参数##对于安全据点：为输出比例/对于抢占据点，为副本波数',
  `award_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领奖次数',
  PRIMARY KEY (`role_id`,`point_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='沙盘争夺战-玩家在各个据点的总积分(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_currencywish_freelast 结构
DROP TABLE IF EXISTS `role_currencywish_freelast`;
CREATE TABLE IF NOT EXISTS `role_currencywish_freelast` (
  `roleid` bigint(20) NOT NULL DEFAULT '0',
  `ticket_free_last` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次免费使用交易券祈愿的时间',
  `luxury_free_last` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次免费使用豪华祈愿的时间',
  `expr_free_last` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次免费使用经验祈愿的时间',
  PRIMARY KEY (`roleid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户祈愿屋各祈愿方式的最后一次免费祈愿时间 备注：合服清空数据表即可';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_drum 结构
DROP TABLE IF EXISTS `role_drum`;
CREATE TABLE IF NOT EXISTS `role_drum` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '届id',
  `one` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否冠军',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `action` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次',
  `deal` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  `choice` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '竞猜列表',
  `pay_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后充值时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家擂台赛数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_dun_flop 结构
DROP TABLE IF EXISTS `role_dun_flop`;
CREATE TABLE IF NOT EXISTS `role_dun_flop` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `treasure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前稀有奖池id',
  `flop_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前祝福值进度',
  `treasured` varchar(500) NOT NULL DEFAULT '[]' COMMENT '当前奖池已领取奖励',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本翻牌数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_dun_guard_achieve 结构
DROP TABLE IF EXISTS `role_dun_guard_achieve`;
CREATE TABLE IF NOT EXISTS `role_dun_guard_achieve` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '人物id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '3400' COMMENT '副本id',
  `wave` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本进度',
  `state` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '里程碑领取状态',
  PRIMARY KEY (`role_id`,`dun_id`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_dun_pet_choose 结构
DROP TABLE IF EXISTS `role_dun_pet_choose`;
CREATE TABLE IF NOT EXISTS `role_dun_pet_choose` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '12001' COMMENT '副本Id',
  `pet_id` int(11) unsigned NOT NULL COMMENT '宠物id',
  `pos_id` smallint(5) unsigned NOT NULL COMMENT '选择位置',
  PRIMARY KEY (`role_id`,`dun_id`,`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宠物助战选择数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_dun_pet_max_score 结构
DROP TABLE IF EXISTS `role_dun_pet_max_score`;
CREATE TABLE IF NOT EXISTS `role_dun_pet_max_score` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本Id',
  `max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史最大分数',
  PRIMARY KEY (`role_id`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-副本历史最大分数';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_dun_pet_reward_choose 结构
DROP TABLE IF EXISTS `role_dun_pet_reward_choose`;
CREATE TABLE IF NOT EXISTS `role_dun_pet_reward_choose` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `index` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励选项',
  PRIMARY KEY (`role_id`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-奖励选择';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_dun_visus 结构
DROP TABLE IF EXISTS `role_dun_visus`;
CREATE TABLE IF NOT EXISTS `role_dun_visus` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `dun_id` int(11) unsigned NOT NULL COMMENT '副本id',
  `pass_waves` varchar(500) NOT NULL DEFAULT '[]' COMMENT '今日首通波数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `last_highest_wave` varchar(100) NOT NULL DEFAULT '[]' COMMENT '昨天最高波数',
  PRIMARY KEY (`role_id`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻光副本数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_equipment_task 结构
DROP TABLE IF EXISTS `role_equipment_task`;
CREATE TABLE IF NOT EXISTS `role_equipment_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务Id',
  `progress` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务进度',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家装备任务(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_exp_dun_achieve 结构
DROP TABLE IF EXISTS `role_exp_dun_achieve`;
CREATE TABLE IF NOT EXISTS `role_exp_dun_achieve` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `dun_id` int(11) unsigned NOT NULL COMMENT '副本id',
  `wave` int(11) unsigned NOT NULL COMMENT '里程碑波数',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态',
  PRIMARY KEY (`role_id`,`dun_id`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验副本里程碑数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_exp_dun_drop 结构
DROP TABLE IF EXISTS `role_exp_dun_drop`;
CREATE TABLE IF NOT EXISTS `role_exp_dun_drop` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `calc_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次结算时间',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始结算时间',
  `extra_data` varchar(500) NOT NULL DEFAULT '[]' COMMENT '额外数据',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='人物放置经验信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_exp_dun_drop_goods 结构
DROP TABLE IF EXISTS `role_exp_dun_drop_goods`;
CREATE TABLE IF NOT EXISTS `role_exp_dun_drop_goods` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `goods_type` int(11) unsigned NOT NULL COMMENT '物品类型',
  `goods_id` int(11) unsigned NOT NULL COMMENT '物品id',
  `num` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  PRIMARY KEY (`role_id`,`goods_type`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='人物放置掉落物品';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_exp_dun_off_point 结构
DROP TABLE IF EXISTS `role_exp_dun_off_point`;
CREATE TABLE IF NOT EXISTS `role_exp_dun_off_point` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `off_start` int(11) unsigned NOT NULL COMMENT '离线开始',
  `off_end` int(11) unsigned NOT NULL COMMENT '离线结束',
  PRIMARY KEY (`role_id`,`off_start`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家放置挂机离线时间节点';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_exp_dun_wave_info 结构
DROP TABLE IF EXISTS `role_exp_dun_wave_info`;
CREATE TABLE IF NOT EXISTS `role_exp_dun_wave_info` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `wave` int(11) unsigned NOT NULL COMMENT '波数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='人物经验本里程碑波数时间信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_exp_sea 结构
DROP TABLE IF EXISTS `role_exp_sea`;
CREATE TABLE IF NOT EXISTS `role_exp_sea` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验海驻留时间',
  `strength_times` varchar(500) NOT NULL DEFAULT '[]' COMMENT '强化信息',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='经验海-玩家数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_exp_wave_rank 结构
DROP TABLE IF EXISTS `role_exp_wave_rank`;
CREATE TABLE IF NOT EXISTS `role_exp_wave_rank` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `wave` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '波数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上榜时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验副本波数排行';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_fashion_suit 结构
DROP TABLE IF EXISTS `role_fashion_suit`;
CREATE TABLE IF NOT EXISTS `role_fashion_suit` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `suit_id` int(11) unsigned NOT NULL COMMENT '套装id',
  `suit_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '套装数据',
  `active` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '是否已激活',
  PRIMARY KEY (`role_id`,`suit_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装套装数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_fast_exp 结构
DROP TABLE IF EXISTS `role_fast_exp`;
CREATE TABLE IF NOT EXISTS `role_fast_exp` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `fast_hook_time` int(11) unsigned NOT NULL COMMENT '快速挂机时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验副本快速挂机数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_first_top_reward 结构
DROP TABLE IF EXISTS `role_first_top_reward`;
CREATE TABLE IF NOT EXISTS `role_first_top_reward` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `rank_type` int(11) unsigned NOT NULL COMMENT '排行类型',
  `target` bigint(20) unsigned NOT NULL COMMENT '目标',
  PRIMARY KEY (`role_id`,`rank_type`,`target`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家目标奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_flower_sp_gift 结构
DROP TABLE IF EXISTS `role_flower_sp_gift`;
CREATE TABLE IF NOT EXISTS `role_flower_sp_gift` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `sender` bigint(20) unsigned NOT NULL COMMENT '赠送者',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续天数',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `receive_time` varchar(500) NOT NULL DEFAULT '[]' COMMENT '领取时间列表',
  PRIMARY KEY (`role_id`,`start_time`,`sender`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家特殊礼品数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_galaxy 结构
DROP TABLE IF EXISTS `role_galaxy`;
CREATE TABLE IF NOT EXISTS `role_galaxy` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `pos_list` varchar(500) NOT NULL DEFAULT '[]' COMMENT '槽位开放记录',
  `display` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '展示状态',
  `skin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '皮肤状态',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新时间戳',
  `refresh_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新次数',
  `item_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '市场列表[]',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星辰-合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_galaxy_skin 结构
DROP TABLE IF EXISTS `role_galaxy_skin`;
CREATE TABLE IF NOT EXISTS `role_galaxy_skin` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `skin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '皮肤',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  PRIMARY KEY (`rid`,`skin`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星辰皮肤-合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_god 结构
DROP TABLE IF EXISTS `role_god`;
CREATE TABLE IF NOT EXISTS `role_god` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `unlock_pos` varchar(500) NOT NULL DEFAULT '[]' COMMENT '出战解锁信息[{出战位置/援助位置|_]',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家唤神神相关信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_god_dun 结构
DROP TABLE IF EXISTS `role_god_dun`;
CREATE TABLE IF NOT EXISTS `role_god_dun` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `day_shop_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '日常商品列表',
  `day_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日常商品更新时间',
  `week_shop_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '周常商品列表',
  `week_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周常商品更新时间',
  `role_attrs` varchar(500) NOT NULL DEFAULT '[]' COMMENT '人物部分基础属性汇总',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='人物唤神副本信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_god_dun_live 结构
DROP TABLE IF EXISTS `role_god_dun_live`;
CREATE TABLE IF NOT EXISTS `role_god_dun_live` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '游戏服id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='唤神副本活跃数据(跨服使用)-合跨服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_god_info 结构
DROP TABLE IF EXISTS `role_god_info`;
CREATE TABLE IF NOT EXISTS `role_god_info` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `god_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '唤神id',
  `star` int(11) NOT NULL DEFAULT '0' COMMENT '星级',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '经验',
  `pos` smallint(5) NOT NULL DEFAULT '0' COMMENT '出战位置##0未出战|1-99为出战位置|101-9999为援护位置',
  `skills` varchar(500) NOT NULL DEFAULT '[]' COMMENT '技能等级##[{技能id,技能等级}|_]',
  PRIMARY KEY (`role_id`,`god_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家唤神信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_guard_assist_rank 结构
DROP TABLE IF EXISTS `role_guard_assist_rank`;
CREATE TABLE IF NOT EXISTS `role_guard_assist_rank` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在服编号',
  `val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '支援值',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标支援周榜';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_guard_pass_log 结构
DROP TABLE IF EXISTS `role_guard_pass_log`;
CREATE TABLE IF NOT EXISTS `role_guard_pass_log` (
  `dun_id` int(11) unsigned NOT NULL COMMENT '副本id',
  `pass_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '通关时长',
  `team_mates` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '队伍成员',
  PRIMARY KEY (`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫信标通关数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_guild_collect 结构
DROP TABLE IF EXISTS `role_guild_collect`;
CREATE TABLE IF NOT EXISTS `role_guild_collect` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `last_collect_time` int(11) unsigned DEFAULT '0' COMMENT '最近一次封印时间',
  `last_enter_time` int(11) unsigned DEFAULT '0' COMMENT '最近一次参与活动时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家公会采集信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_guild_shop 结构
DROP TABLE IF EXISTS `role_guild_shop`;
CREATE TABLE IF NOT EXISTS `role_guild_shop` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cargos_daily` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '每日商品',
  `time_daily` int(11) unsigned DEFAULT '0' COMMENT '上次刷新',
  `cargos_week` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '每周商品',
  `time_week` int(11) unsigned DEFAULT '0' COMMENT '上次刷新',
  `cargos_forever` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '终身商品',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社团商店-合服合并';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_lattice 结构
DROP TABLE IF EXISTS `role_lattice`;
CREATE TABLE IF NOT EXISTS `role_lattice` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `pos` tinyint(6) unsigned NOT NULL DEFAULT '0' COMMENT '位置',
  `circle` tinyint(6) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `circle_reward` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '轮次奖励',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='器灵寻宝-玩家走格子数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_lattice_shop 结构
DROP TABLE IF EXISTS `role_lattice_shop`;
CREATE TABLE IF NOT EXISTS `role_lattice_shop` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `shop_count` tinyint(6) unsigned NOT NULL DEFAULT '0' COMMENT '手动刷新次数',
  `shop_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近操作时间',
  `shop_info` varchar(255) NOT NULL DEFAULT '[]' COMMENT '商店信息',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='器灵寻宝-玩家格子商店数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_legion 结构
DROP TABLE IF EXISTS `role_legion`;
CREATE TABLE IF NOT EXISTS `role_legion` (
  `rid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `post` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '军衔',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分积累',
  `rank_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名积分',
  `arms` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '军备值',
  `process` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度值',
  `dot_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '已领取的节点id列表',
  `click_role` varchar(255) NOT NULL DEFAULT '[]' COMMENT '已膜拜列表',
  `day_award` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日领取态',
  `tasks` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '任务',
  `ltime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次更新时间',
  `p_utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '军衔上次更新时间',
  `advance_awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '预告领取',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家战团数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_live_skill 结构
DROP TABLE IF EXISTS `role_live_skill`;
CREATE TABLE IF NOT EXISTS `role_live_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`role_id`,`skill_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='生活技能表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_live_skill_info 结构
DROP TABLE IF EXISTS `role_live_skill_info`;
CREATE TABLE IF NOT EXISTS `role_live_skill_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cook_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活食谱',
  `equip_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '打造纸激活类型',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='生活技能记录表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_marble 结构
DROP TABLE IF EXISTS `role_marble`;
CREATE TABLE IF NOT EXISTS `role_marble` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `marble_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '弹珠次数',
  `marble_reset` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '弹珠重置次数',
  `energy_pro` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充能节点进度',
  `marble_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '弹珠最近操作时间',
  `energy_rewards` varchar(511) NOT NULL DEFAULT '[]' COMMENT '充能节点奖励信息',
  `fixed_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '保底奖励',
  `qua_indexs` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机品质分布',
  `shop_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店手动刷新次数',
  `shop_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店最近操作时间',
  `shop_info` varchar(255) NOT NULL DEFAULT '[]' COMMENT '商店信息',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家弹珠&商店数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_module_advance 结构
DROP TABLE IF EXISTS `role_module_advance`;
CREATE TABLE IF NOT EXISTS `role_module_advance` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `func_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '预告功能配置Id',
  `reward_state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领奖状态',
  PRIMARY KEY (`role_id`,`func_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_nucleon 结构
DROP TABLE IF EXISTS `role_nucleon`;
CREATE TABLE IF NOT EXISTS `role_nucleon` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '灵能级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '灵能经验',
  `normal` int(11) NOT NULL DEFAULT '0' COMMENT '普通已抽次数',
  `ntime` int(11) NOT NULL DEFAULT '0' COMMENT '上次免费操作时间',
  `nfirst` int(11) NOT NULL DEFAULT '0' COMMENT '普通首次',
  `nstate` varchar(100) NOT NULL DEFAULT '[]' COMMENT '普通状态',
  `special` int(11) NOT NULL DEFAULT '0' COMMENT '特别已抽次数',
  `stime` int(11) NOT NULL DEFAULT '0' COMMENT '上次特殊已抽时间',
  `sfirst` int(11) NOT NULL DEFAULT '0' COMMENT '特殊首次',
  `estate` varchar(100) NOT NULL DEFAULT '[]' COMMENT '特殊状态',
  `rtime` int(11) NOT NULL DEFAULT '0' COMMENT '刷新时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='灵能-合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_pellet_draw 结构
DROP TABLE IF EXISTS `role_pellet_draw`;
CREATE TABLE IF NOT EXISTS `role_pellet_draw` (
  `id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `round` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '当前抽奖轮次',
  `count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '当前轮次抽奖次数',
  `got_ids` varchar(100) NOT NULL COMMENT '本轮次已领取的次数奖励id',
  `got_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次领取次数奖励',
  `draw_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次抽奖',
  `draw_subtype` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '上次抽奖的活动类型',
  `draw_key` varchar(10) NOT NULL DEFAULT '' COMMENT '上次抽奖的key',
  `draw_over` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上次抽奖的时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='弹珠活动抽奖信息（关联每日累充/消费活动）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_pet 结构
DROP TABLE IF EXISTS `role_pet`;
CREATE TABLE IF NOT EXISTS `role_pet` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物Id',
  `pet_star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '宠物星级',
  `pet_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '宠物培养等级',
  `pet_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宠物经验',
  `adopt_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领养时间',
  `is_awaken` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已觉醒',
  `old_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '旧战力',
  PRIMARY KEY (`role_id`,`pet_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物基础数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_pet_dun_reward 结构
DROP TABLE IF EXISTS `role_pet_dun_reward`;
CREATE TABLE IF NOT EXISTS `role_pet_dun_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本Id',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '里程碑奖励领取状态',
  PRIMARY KEY (`role_id`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='宠物副本-里程碑奖励领取状态';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_praise_target 结构
DROP TABLE IF EXISTS `role_praise_target`;
CREATE TABLE IF NOT EXISTS `role_praise_target` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `rank_type` int(11) unsigned NOT NULL COMMENT '排行类型',
  `praise_id` bigint(20) unsigned NOT NULL COMMENT '点赞玩家',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '点赞时间',
  PRIMARY KEY (`role_id`,`rank_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜点赞数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_profile_photo 结构
DROP TABLE IF EXISTS `role_profile_photo`;
CREATE TABLE IF NOT EXISTS `role_profile_photo` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `photo_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '激活消耗道具',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色已激活头像';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_race_rank 结构
DROP TABLE IF EXISTS `role_race_rank`;
CREATE TABLE IF NOT EXISTS `role_race_rank` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `act_id` int(11) unsigned NOT NULL COMMENT '活动Id',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计次数',
  `buy_ten_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽十次的累计次数',
  `buy_ten_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次抽十次的时间戳',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `use_free_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已使用免费次数',
  `free_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次使用免费次数的时间戳',
  `award_log` varchar(300) NOT NULL DEFAULT '[]' COMMENT '累计次数奖励领取记录[AwardId]',
  `valid_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据有效截止时间戳',
  `coin` int(11) NOT NULL DEFAULT '0' COMMENT '金币',
  `stage` int(11) NOT NULL DEFAULT '0' COMMENT '充值阶段',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '充值时间',
  `coin_draw` int(11) NOT NULL DEFAULT '0' COMMENT '金币次数',
  `coin_time` int(11) NOT NULL DEFAULT '0' COMMENT '金币时间',
  `rune_draw` int(11) NOT NULL DEFAULT '0' COMMENT '符文次数',
  `rune_time` int(11) NOT NULL DEFAULT '0' COMMENT '符文时间',
  PRIMARY KEY (`rid`,`act_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色竞榜活动数据(在游戏服中使用-合服合并保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_recharge_first 结构
DROP TABLE IF EXISTS `role_recharge_first`;
CREATE TABLE IF NOT EXISTS `role_recharge_first` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '产品id',
  `recharge` decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '充值金额',
  `trigger_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '触发时间',
  `award_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '已领奖励列表',
  PRIMARY KEY (`role_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='首充奖励表##合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_single_charge 结构
DROP TABLE IF EXISTS `role_single_charge`;
CREATE TABLE IF NOT EXISTS `role_single_charge` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `subtype` int(11) unsigned NOT NULL COMMENT '活动子类型',
  `grade_id` smallint(5) unsigned NOT NULL COMMENT '档次id',
  `receive_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已领取次数',
  `total_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '档次总次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`subtype`,`grade_id`),
  KEY `subtype` (`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='人物单笔充值辅助数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_sup_vip 结构
DROP TABLE IF EXISTS `role_sup_vip`;
CREATE TABLE IF NOT EXISTS `role_sup_vip` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '人物id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否是永久vip 0否|1是',
  `continue_charge_days` tinyint(5) unsigned NOT NULL DEFAULT '0' COMMENT '连续充值天数',
  `today_charge` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日已充值',
  `last_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近一次充值时间',
  `total_charge` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '体验阶段总充值量',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '体验贵族结束时间',
  `unlock_ids` varchar(100) NOT NULL DEFAULT '[]' COMMENT '贵族商城当前解锁序列',
  `today_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日星钻',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近更新时间',
  `login_rewards` varchar(500) NOT NULL DEFAULT '[]' COMMENT '奖励状态',
  `last_reward_rec` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次统计的领奖时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='人物贵族数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_tower_rank 结构
DROP TABLE IF EXISTS `role_tower_rank`;
CREATE TABLE IF NOT EXISTS `role_tower_rank` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总星数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上榜时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='爬塔副本星级排行数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_tower_star_reward 结构
DROP TABLE IF EXISTS `role_tower_star_reward`;
CREATE TABLE IF NOT EXISTS `role_tower_star_reward` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `index` int(11) unsigned NOT NULL COMMENT '通关星数序号',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  PRIMARY KEY (`role_id`,`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='爬塔副本星级奖励领取状态';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_treasure_house 结构
DROP TABLE IF EXISTS `role_treasure_house`;
CREATE TABLE IF NOT EXISTS `role_treasure_house` (
  `id` bigint(20) NOT NULL COMMENT '角色id',
  `period` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '期数（数据归属）',
  `round` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '当前轮次（真实，前端显示的是转换后数据）',
  `count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '当前轮次抽奖次数',
  `recv_round` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '未领完奖励的轮次（真实，前端显示的是转换后数据）',
  `data` varchar(600) NOT NULL DEFAULT '[]' COMMENT '当前在领轮次已领取的奖励次数档次+角色任务数据',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '数据时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色珍宝阁数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_treasure_map_shop_info 结构
DROP TABLE IF EXISTS `role_treasure_map_shop_info`;
CREATE TABLE IF NOT EXISTS `role_treasure_map_shop_info` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `time` int(11) unsigned NOT NULL COMMENT '过期时间',
  `limit_shops` varchar(500) NOT NULL DEFAULT '[]' COMMENT '限时商品信息',
  PRIMARY KEY (`role_id`,`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='藏宝图珍宝商品信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_uranium 结构
DROP TABLE IF EXISTS `role_uranium`;
CREATE TABLE IF NOT EXISTS `role_uranium` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶位',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `have_energy` int(11) unsigned zerofill NOT NULL COMMENT '玩家当前等级持有的能量',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家魂力(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_vip 结构
DROP TABLE IF EXISTS `role_vip`;
CREATE TABLE IF NOT EXISTS `role_vip` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `real_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '真实vip等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级经验',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否处于体验阶段0|1',
  `endtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '体验结束时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家vip数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_visus 结构
DROP TABLE IF EXISTS `role_visus`;
CREATE TABLE IF NOT EXISTS `role_visus` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `login_days` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '天数',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家幻光(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_visus_rank 结构
DROP TABLE IF EXISTS `role_visus_rank`;
CREATE TABLE IF NOT EXISTS `role_visus_rank` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '通关(扫荡)层数',
  `show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '附带展示信息',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻光扫荡排行数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_war_soul 结构
DROP TABLE IF EXISTS `role_war_soul`;
CREATE TABLE IF NOT EXISTS `role_war_soul` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `pos_list` varchar(100) NOT NULL DEFAULT '[]' COMMENT '阵位解锁状态',
  `collect_award` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '收集领奖进度',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-玩家数据(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.role_war_soul_collect 结构
DROP TABLE IF EXISTS `role_war_soul_collect`;
CREATE TABLE IF NOT EXISTS `role_war_soul_collect` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  PRIMARY KEY (`role_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战魂-收集(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.rush_rank_goal 结构
DROP TABLE IF EXISTS `rush_rank_goal`;
CREATE TABLE IF NOT EXISTS `rush_rank_goal` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `goal_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励Id',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态(1 可领 0 不可领)',
  PRIMARY KEY (`rank_type`,`sub_type`,`player_id`,`goal_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜目标奖励领取状态';

-- 数据导出被取消选择。

-- 导出  表 yzygame.rush_rank_role 结构
DROP TABLE IF EXISTS `rush_rank_role`;
CREATE TABLE IF NOT EXISTS `rush_rank_role` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `value2` int(11) NOT NULL DEFAULT '0' COMMENT '值2',
  `value3` int(11) NOT NULL DEFAULT '0' COMMENT '值3',
  `value4` int(11) NOT NULL DEFAULT '0' COMMENT '值4',
  `value5` int(11) NOT NULL DEFAULT '0' COMMENT '值5',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`,`sub_type`) USING BTREE,
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜活动';

-- 数据导出被取消选择。

-- 导出  表 yzygame.sakura_person_log 结构
DROP TABLE IF EXISTS `sakura_person_log`;
CREATE TABLE IF NOT EXISTS `sakura_person_log` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `id` int(11) unsigned NOT NULL COMMENT 'id',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录时间',
  PRIMARY KEY (`role_id`,`sub_type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='源樱之礼-个人记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.sakura_server_log 结构
DROP TABLE IF EXISTS `sakura_server_log`;
CREATE TABLE IF NOT EXISTS `sakura_server_log` (
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `id` int(11) unsigned NOT NULL COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `tag` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录时间',
  PRIMARY KEY (`sub_type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='源樱之礼-全服记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.sakura_store 结构
DROP TABLE IF EXISTS `sakura_store`;
CREATE TABLE IF NOT EXISTS `sakura_store` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子id',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '兑换次数',
  PRIMARY KEY (`role_id`,`sub_type`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='源樱之礼-积分商城';

-- 数据导出被取消选择。

-- 导出  表 yzygame.seckill_goods 结构
DROP TABLE IF EXISTS `seckill_goods`;
CREATE TABLE IF NOT EXISTS `seckill_goods` (
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '购买数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  PRIMARY KEY (`zone_id`,`grade_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='秒杀-商品数据(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.seckill_log 结构
DROP TABLE IF EXISTS `seckill_log`;
CREATE TABLE IF NOT EXISTS `seckill_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分区id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `server` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '购买玩家',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '花费',
  `tv_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '传闻id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='秒杀-购买记录(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.server_env 结构
DROP TABLE IF EXISTS `server_env`;
CREATE TABLE IF NOT EXISTS `server_env` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型（1合服时间）',
  `args` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参数',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='游戏服环境参数表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.server_kv 结构
DROP TABLE IF EXISTS `server_kv`;
CREATE TABLE IF NOT EXISTS `server_kv` (
  `key` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'KEY',
  `value` varchar(1024) NOT NULL COMMENT 'VALUE',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间戳',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器KEY_VALUE表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.server_zone 结构
DROP TABLE IF EXISTS `server_zone`;
CREATE TABLE IF NOT EXISTS `server_zone` (
  `zone_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '分区类型',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区域id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服时间',
  `world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `merge_ids` text NOT NULL COMMENT '合服id列表',
  PRIMARY KEY (`zone_type`,`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服分区表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.seven_days_goal 结构
DROP TABLE IF EXISTS `seven_days_goal`;
CREATE TABLE IF NOT EXISTS `seven_days_goal` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `open_time` int(11) NOT NULL COMMENT '功能开启时间戳',
  `days` smallint(6) unsigned NOT NULL COMMENT '累计登录天数',
  `score` smallint(6) unsigned NOT NULL COMMENT '积分',
  `task_reward` varchar(3000) NOT NULL DEFAULT '[]',
  `score_reward` varchar(255) NOT NULL DEFAULT '[]',
  `skill_reward` varchar(255) NOT NULL DEFAULT '[]',
  `other_data` varchar(255) NOT NULL DEFAULT '[]' COMMENT '其他数据',
  PRIMARY KEY (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='七日目标人物数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.seven_day_task 结构
DROP TABLE IF EXISTS `seven_day_task`;
CREATE TABLE IF NOT EXISTS `seven_day_task` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `days` smallint(6) NOT NULL COMMENT '天数',
  `mod_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块Id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子id',
  `progress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  PRIMARY KEY (`role_id`,`days`,`mod_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='七日目标任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.skill 结构
DROP TABLE IF EXISTS `skill`;
CREATE TABLE IF NOT EXISTS `skill` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能ID',
  `lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  UNIQUE KEY `id_2` (`id`,`skill_id`),
  KEY `skill_id` (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能';

-- 数据导出被取消选择。

-- 导出  表 yzygame.spec_sell_act 结构
DROP TABLE IF EXISTS `spec_sell_act`;
CREATE TABLE IF NOT EXISTS `spec_sell_act` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `lv_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '到达配置等级时的时间戳',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='精品特卖活动信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.sql_version 结构
DROP TABLE IF EXISTS `sql_version`;
CREATE TABLE IF NOT EXISTS `sql_version` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '版本类型',
  `version` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '版本号',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='数据库版本信息表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.supplication 结构
DROP TABLE IF EXISTS `supplication`;
CREATE TABLE IF NOT EXISTS `supplication` (
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `sub_type` smallint(10) unsigned NOT NULL COMMENT '活动子类型',
  `self_log` varchar(255) NOT NULL COMMENT '抽奖记录[奖励ID]',
  `select_reward` varchar(255) NOT NULL COMMENT '已选择奖励列表[{奖励等级,[奖励ID]}]',
  `count` int(10) unsigned NOT NULL COMMENT '已抽奖次数',
  `counter` varchar(255) NOT NULL DEFAULT '[]' COMMENT '抽奖统计列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家祈愿数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.supplication_broadcast 结构
DROP TABLE IF EXISTS `supplication_broadcast`;
CREATE TABLE IF NOT EXISTS `supplication_broadcast` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `role_name` varchar(255) NOT NULL COMMENT '角色名字',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器标识',
  `reward_id` smallint(5) unsigned NOT NULL COMMENT '奖励ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿广播数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.supplication_counter 结构
DROP TABLE IF EXISTS `supplication_counter`;
CREATE TABLE IF NOT EXISTS `supplication_counter` (
  `reward_lv` tinyint(2) unsigned NOT NULL COMMENT '奖励等级',
  `count` int(10) unsigned NOT NULL COMMENT '抽到奖励后抽取次数',
  `reward_count` int(10) unsigned NOT NULL COMMENT '获得该奖励等级次数',
  PRIMARY KEY (`reward_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-全服玩家抽奖统计';

-- 数据导出被取消选择。

-- 导出  表 yzygame.supplication_task 结构
DROP TABLE IF EXISTS `supplication_task`;
CREATE TABLE IF NOT EXISTS `supplication_task` (
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `task_id` int(10) unsigned NOT NULL COMMENT '任务id',
  `sub_type` smallint(10) unsigned NOT NULL COMMENT '活动子类型',
  `progress` int(10) unsigned NOT NULL COMMENT '任务进度',
  `extra` varchar(512) NOT NULL COMMENT '额外记录',
  `task_status` tinyint(1) unsigned NOT NULL COMMENT '任务状态（0未完成1已完成2已领取）',
  `time` int(10) unsigned NOT NULL COMMENT '任务开始时间',
  PRIMARY KEY (`role_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家祈愿任务完成数据表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.sync_config_status 结构
DROP TABLE IF EXISTS `sync_config_status`;
CREATE TABLE IF NOT EXISTS `sync_config_status` (
  `cf_name` varchar(128) NOT NULL DEFAULT '' COMMENT '配置名称',
  `cf_status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '配置状态',
  PRIMARY KEY (`cf_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开发环境配置同步状态表';

-- 数据导出被取消选择。

-- 导出  表 yzygame.sys_env 结构
DROP TABLE IF EXISTS `sys_env`;
CREATE TABLE IF NOT EXISTS `sys_env` (
  `type` varchar(255) NOT NULL COMMENT '键名',
  `value` mediumtext NOT NULL COMMENT '值',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='系统变量数据，合服保留主服';

-- 数据导出被取消选择。

-- 导出  表 yzygame.talent_skill 结构
DROP TABLE IF EXISTS `talent_skill`;
CREATE TABLE IF NOT EXISTS `talent_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  PRIMARY KEY (`role_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家天赋技能';

-- 数据导出被取消选择。

-- 导出  表 yzygame.task_bag 结构
DROP TABLE IF EXISTS `task_bag`;
CREATE TABLE IF NOT EXISTS `task_bag` (
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务id',
  `trigger_time` int(11) NOT NULL DEFAULT '0' COMMENT '触发时间',
  `state` smallint(5) NOT NULL DEFAULT '0' COMMENT '任务状态',
  `end_state` smallint(5) NOT NULL DEFAULT '0' COMMENT '结束状态',
  `mark` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '任务步骤记录',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  PRIMARY KEY (`role_id`,`task_id`),
  KEY `task_id` (`task_id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色任务';

-- 数据导出被取消选择。

-- 导出  表 yzygame.task_daily 结构
DROP TABLE IF EXISTS `task_daily`;
CREATE TABLE IF NOT EXISTS `task_daily` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `dailys` varchar(300) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家跑环奖励(合服保留)';

-- 数据导出被取消选择。

-- 导出  表 yzygame.task_log 结构
DROP TABLE IF EXISTS `task_log`;
CREATE TABLE IF NOT EXISTS `task_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `trigger_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '接受时间',
  `finish_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成时间',
  PRIMARY KEY (`id`),
  KEY `role_task_id` (`role_id`,`task_id`),
  KEY `task_id` (`task_id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色任务日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.task_log_clear 结构
DROP TABLE IF EXISTS `task_log_clear`;
CREATE TABLE IF NOT EXISTS `task_log_clear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `trigger_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '接受时间',
  `finish_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成时间',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '悬赏和公会周任务记录次数',
  PRIMARY KEY (`id`),
  KEY `role_task_id` (`role_id`,`task_id`),
  KEY `task_id` (`task_id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色可清除任务日志';

-- 数据导出被取消选择。

-- 导出  表 yzygame.ta_agent_wait_upload 结构
DROP TABLE IF EXISTS `ta_agent_wait_upload`;
CREATE TABLE IF NOT EXISTS `ta_agent_wait_upload` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '数据键',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '数据类型[1-normal/2-delay]',
  `data` text COMMENT '数据',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ta_agent关服时临时存储未及时上报的数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.top_pk_rank_center 结构
DROP TABLE IF EXISTS `top_pk_rank_center`;
CREATE TABLE IF NOT EXISTS `top_pk_rank_center` (
  `role_id` bigint(20) unsigned NOT NULL,
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `career` tinyint(3) unsigned NOT NULL COMMENT '职业',
  `power` int(10) unsigned NOT NULL COMMENT '战力',
  `platform` varchar(50) NOT NULL COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器编号',
  `server_id` int(10) unsigned NOT NULL COMMENT '服务器id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季积分',
  `pk_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次PK时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技排行榜（跨服）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.transform_info 结构
DROP TABLE IF EXISTS `transform_info`;
CREATE TABLE IF NOT EXISTS `transform_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `transform_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转职Id',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色转职数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.treasure_evaluation_lucky_num 结构
DROP TABLE IF EXISTS `treasure_evaluation_lucky_num`;
CREATE TABLE IF NOT EXISTS `treasure_evaluation_lucky_num` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '子类型',
  `choose_big_reward_id` int(11) unsigned NOT NULL COMMENT '选择的大奖id',
  `lucky_num` int(11) unsigned NOT NULL COMMENT '幸运值',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝幸运值记录表（合服合并）';

-- 数据导出被取消选择。

-- 导出  表 yzygame.treasure_map_montly_times 结构
DROP TABLE IF EXISTS `treasure_map_montly_times`;
CREATE TABLE IF NOT EXISTS `treasure_map_montly_times` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '月度挖宝次数',
  `receive_list` varchar(500) NOT NULL DEFAULT '[]' COMMENT '已领取奖励次数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='高级藏宝图次数奖励';

-- 数据导出被取消选择。

-- 导出  表 yzygame.turntable_lottery_record 结构
DROP TABLE IF EXISTS `turntable_lottery_record`;
CREATE TABLE IF NOT EXISTS `turntable_lottery_record` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `sub_type` smallint(6) NOT NULL COMMENT '活动子类型',
  `name` varchar(255) NOT NULL COMMENT '玩家名',
  `goods_id` int(11) NOT NULL COMMENT '物品类型ID',
  `num` smallint(6) NOT NULL COMMENT '数量',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `key` (`sub_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='源能转盘抽奖记录';

-- 数据导出被取消选择。

-- 导出  表 yzygame.unite_buff_mgr 结构
DROP TABLE IF EXISTS `unite_buff_mgr`;
CREATE TABLE IF NOT EXISTS `unite_buff_mgr` (
  `act` int(11) NOT NULL DEFAULT '0' COMMENT '活动',
  `stime` int(11) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `etime` int(11) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `process` int(11) NOT NULL DEFAULT '0' COMMENT '全服进度',
  `click` int(11) NOT NULL DEFAULT '0' COMMENT '已累计',
  `need_add` int(11) NOT NULL DEFAULT '0' COMMENT '时段需累计',
  `add_per` int(11) NOT NULL DEFAULT '0' COMMENT '单次增加',
  `buffs` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '加成BUFF',
  PRIMARY KEY (`act`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='材料上交管理';

-- 数据导出被取消选择。

-- 导出  表 yzygame.version_upgradebag 结构
DROP TABLE IF EXISTS `version_upgradebag`;
CREATE TABLE IF NOT EXISTS `version_upgradebag` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `version_code` int(10) unsigned NOT NULL COMMENT '版本号',
  `time` int(10) unsigned NOT NULL COMMENT '领取时间',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='版本更新礼包';

-- 数据导出被取消选择。

-- 导出  表 yzygame.vie_rank 结构
DROP TABLE IF EXISTS `vie_rank`;
CREATE TABLE IF NOT EXISTS `vie_rank` (
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `server_id` int(11) unsigned DEFAULT '0' COMMENT '服务器ID',
  `server_num` int(11) DEFAULT '0' COMMENT '服务器Num',
  `vip` int(11) unsigned DEFAULT '0' COMMENT 'vip',
  `svip` int(11) DEFAULT '0' COMMENT 'vip至尊',
  `score` int(11) unsigned DEFAULT '0' COMMENT '积分',
  `rtime` int(11) DEFAULT '0' COMMENT '数据更新时间',
  `dtime` int(11) DEFAULT '0' COMMENT '数据有效时间',
  PRIMARY KEY (`act`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='封榜合服保留';

-- 数据导出被取消选择。

-- 导出  表 yzygame.void_fam_kf_rank 结构
DROP TABLE IF EXISTS `void_fam_kf_rank`;
CREATE TABLE IF NOT EXISTS `void_fam_kf_rank` (
  `rank` int(10) unsigned NOT NULL COMMENT '排序',
  `zone` int(10) NOT NULL DEFAULT '0' COMMENT '分区',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `ser_num` int(20) NOT NULL DEFAULT '0' COMMENT '所在服号',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `floor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高层',
  `kills` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀',
  `combo` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连斩',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `vip` int(11) NOT NULL DEFAULT '0' COMMENT 'Vip',
  `sex` int(11) NOT NULL DEFAULT '0' COMMENT '性别',
  `carrer` int(11) NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` int(11) NOT NULL DEFAULT '0' COMMENT '转生',
  `vtype` int(11) NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `svip` int(11) NOT NULL DEFAULT '0' COMMENT 'svip',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`rank`,`zone`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽领域跨服榜单 合服清理';

-- 数据导出被取消选择。

-- 导出  表 yzygame.void_fam_rank 结构
DROP TABLE IF EXISTS `void_fam_rank`;
CREATE TABLE IF NOT EXISTS `void_fam_rank` (
  `rank` int(10) unsigned NOT NULL COMMENT '排序',
  `zone` int(10) NOT NULL DEFAULT '0' COMMENT '分区',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `ser_num` int(20) NOT NULL DEFAULT '0' COMMENT '所在服号',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `floor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高层',
  `kills` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀',
  `combo` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连斩',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `vip` int(11) NOT NULL DEFAULT '0' COMMENT 'Vip',
  `sex` int(11) NOT NULL DEFAULT '0' COMMENT '性别',
  `carrer` int(11) NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` int(11) NOT NULL DEFAULT '0' COMMENT '转生',
  `vtype` int(11) NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `svip` int(11) NOT NULL DEFAULT '0' COMMENT 'svip',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`rank`,`zone`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽领域本地榜单 合服清理';

-- 数据导出被取消选择。

-- 导出  表 yzygame.void_server_zone 结构
DROP TABLE IF EXISTS `void_server_zone`;
CREATE TABLE IF NOT EXISTS `void_server_zone` (
  `server_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `zone` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '分区号',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '分区时间',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='无尽分区表,合服清理';

-- 数据导出被取消选择。

-- 导出  表 yzygame.wardrobe_value 结构
DROP TABLE IF EXISTS `wardrobe_value`;
CREATE TABLE IF NOT EXISTS `wardrobe_value` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '外观类型',
  `collect` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '收集进度',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '风采值',
  PRIMARY KEY (`role_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='衣橱-风采值';

-- 数据导出被取消选择。

-- 导出  表 yzygame.wasteland_war 结构
DROP TABLE IF EXISTS `wasteland_war`;
CREATE TABLE IF NOT EXISTS `wasteland_war` (
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '角色名称',
  `war_field` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战场数',
  `round` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '轮数',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `kill_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大击杀数',
  `max_combo` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大连杀数',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `sup_vip` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '贵族',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器号',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`server_id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='废土战场-排行榜数据';

-- 数据导出被取消选择。

-- 导出  表 yzygame.workroom_forge_target 结构
DROP TABLE IF EXISTS `workroom_forge_target`;
CREATE TABLE IF NOT EXISTS `workroom_forge_target` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pos` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '位置',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品Id',
  PRIMARY KEY (`role_id`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='时装工坊-打造目标';

-- 数据导出被取消选择。

-- 导出  表 yzygame.workroom_shop 结构
DROP TABLE IF EXISTS `workroom_shop`;
CREATE TABLE IF NOT EXISTS `workroom_shop` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `last_refresh` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次刷新时间',
  `refresh_count` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '刷新次数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='时装工坊-商城刷新信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.workroom_shop_goods 结构
DROP TABLE IF EXISTS `workroom_shop_goods`;
CREATE TABLE IF NOT EXISTS `workroom_shop_goods` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `pos` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '位置',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品Id',
  `has_buy` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已经购买',
  PRIMARY KEY (`role_id`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='时装工坊-商品信息';

-- 数据导出被取消选择。

-- 导出  表 yzygame.workroom_suit 结构
DROP TABLE IF EXISTS `workroom_suit`;
CREATE TABLE IF NOT EXISTS `workroom_suit` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `suit_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '套装Id',
  `own_num` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '拥有数量',
  `active_num` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '激活数量',
  `sum_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总星数',
  PRIMARY KEY (`role_id`,`suit_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='时装工坊-套装信息';

-- 数据导出被取消选择。

/*!40103 SET TIME_ZONE=IFNULL(@OLD_TIME_ZONE, 'system') */;
/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
