%%%---------------------------------------
%%% module      : data_child
%%% description : 孩子配置
%%%
%%%---------------------------------------
-module(data_child).
-compile(export_all).
-include("child.hrl").



get_child_kv_cfg(active_cost) ->
    #child_constant_cfg{id = 1,key = "active_cost",constant = [{2,0,0}],remark = "激活消耗"};

get_child_kv_cfg(low_feed) ->
    #child_constant_cfg{id = 2,key = "low_feed",constant = [{260002,10}],remark = "低级喂养道具及消耗"};

get_child_kv_cfg(mid_feed) ->
    #child_constant_cfg{id = 3,key = "mid_feed",constant = [{260003,50}],remark = "中级喂养道具及消耗"};

get_child_kv_cfg(high_feed) ->
    #child_constant_cfg{id = 4,key = "high_feed",constant = [{260004,300}],remark = "高级喂养道具及消耗"};

get_child_kv_cfg(rename_cost) ->
    #child_constant_cfg{id = 5,key = "rename_cost",constant = [{2,0,100}],remark = "改名消耗"};

get_child_kv_cfg(share_limit) ->
    #child_constant_cfg{id = 6,key = "share_limit",constant = 50,remark = "每日分享次数上限"};

get_child_kv_cfg(like_limit) ->
    #child_constant_cfg{id = 7,key = "like_limit",constant = 50,remark = "每日点赞次数上限"};

get_child_kv_cfg(growth_open_lv) ->
    #child_constant_cfg{id = 8,key = "growth_open_lv",constant = 1,remark = "成长功能开启同心等级限制(已废弃)"};

get_child_kv_cfg(heart_feed) ->
    #child_constant_cfg{id = 9,key = "heart_feed",constant = [{260001,1}],remark = "同心值培养材料"};

get_child_kv_cfg(like_lv) ->
    #child_constant_cfg{id = 10,key = "like_lv",constant = 50,remark = "点赞等级需求"};

get_child_kv_cfg(skill_open_stage) ->
    #child_constant_cfg{id = 11,key = "skill_open_stage",constant = 1,remark = "技能和时装开启需要的孩子成长阶段(对应年份)"};

get_child_kv_cfg(heart_link_exp) ->
    #child_constant_cfg{id = 12,key = "heart_link_exp",constant = 260001,remark = "同心值物品Id"};

get_child_kv_cfg(original_model) ->
    #child_constant_cfg{id = 13,key = "original_model",constant = [{1001,1002}],remark = "活动界面展示模型"};

get_child_kv_cfg(receive_open) ->
    #child_constant_cfg{id = 14,key = "receive_open",constant = 6,remark = "一键领取开放时间（开服第6天）"};

get_child_kv_cfg(baby_month) ->
    #child_constant_cfg{id = 15,key = "baby_month",constant = 1,remark = "此月份(星级)之前都是襁褓期"};

get_child_kv_cfg(show_gift) ->
    #child_constant_cfg{id = 16,key = "show_gift",constant = [{0,260002,1}],remark = "宝宝每日分享奖励"};

get_child_kv_cfg(_Key) ->
    [].

get_child_link_heart_cfg(1) ->
    #child_link_heart_cfg{reward_id = 1,need_exp = 30,reward = [{0,260002,1}]};

get_child_link_heart_cfg(2) ->
    #child_link_heart_cfg{reward_id = 2,need_exp = 80,reward = [{0,260002,1}]};

get_child_link_heart_cfg(3) ->
    #child_link_heart_cfg{reward_id = 3,need_exp = 140,reward = [{0,260003,1}]};

get_child_link_heart_cfg(4) ->
    #child_link_heart_cfg{reward_id = 4,need_exp = 210,reward = []};

get_child_link_heart_cfg(_Rewardid) ->
    [].

get_all_reward() ->
    [1,2,3,4].

get_child_max_heart_link_exp() -> 210.

get_max_reward() -> 4.

get_child_daily_task_cfg(1) ->
    #child_daily_task_cfg{task_id = 1,open_level = 0,desc = "获得120点日常活跃",task_content = [{liveness,0,120}],reward_exp = 20,client_skip = [{157,0}]};

get_child_daily_task_cfg(3) ->
    #child_daily_task_cfg{task_id = 3,open_level = 0,desc = "击杀3次赏金幻魔",task_content = [{reward_boss,0,3}],reward_exp = 15,client_skip = [{460,3}]};

get_child_daily_task_cfg(5) ->
    #child_daily_task_cfg{task_id = 5,open_level = 0,desc = "完成2次装备副本",task_content = [{multi_dun,0,2}],reward_exp = 15,client_skip = [{215,1}]};

get_child_daily_task_cfg(6) ->
    #child_daily_task_cfg{task_id = 6,open_level = 0,desc = "挑战经验闯关提升收益",task_content = [{dun_exp,2,1}],reward_exp = 5,client_skip = [{610,2}]};

get_child_daily_task_cfg(7) ->
    #child_daily_task_cfg{task_id = 7,open_level = 0,desc = "参与舞池派对",task_content = [{charm_beach,0,1}],reward_exp = 5,client_skip = [{157,2}]};

get_child_daily_task_cfg(8) ->
    #child_daily_task_cfg{task_id = 8,open_level = 0,desc = "参与护送",task_content = [{husong,0,1}],reward_exp = 10,client_skip = [{500,0}]};

get_child_daily_task_cfg(_Taskid) ->
    [].

get_all_child_daily_task_cfg() ->
    [1,3,5,6,7,8].

get_child_grow_up_cfg(0,0) ->
    #child_grow_up_cfg{year = 0,month = 0,next_year = 1,need_exp = 19,attr_list = [{1,0},{2,0},{4,0},{5,0},{8,0}],can_carry_weight = 8};

get_child_grow_up_cfg(0,1) ->
    #child_grow_up_cfg{year = 0,month = 1,next_year = 1,need_exp = 29,attr_list = [{1,327},{2,3734},{4,140},{5,19},{8,12}],can_carry_weight = 8};

get_child_grow_up_cfg(0,2) ->
    #child_grow_up_cfg{year = 0,month = 2,next_year = 1,need_exp = 39,attr_list = [{1,334},{2,3818},{4,143},{5,19},{8,13}],can_carry_weight = 8};

get_child_grow_up_cfg(0,3) ->
    #child_grow_up_cfg{year = 0,month = 3,next_year = 1,need_exp = 49,attr_list = [{1,343},{2,3924},{4,147},{5,20},{8,13}],can_carry_weight = 8};

get_child_grow_up_cfg(0,4) ->
    #child_grow_up_cfg{year = 0,month = 4,next_year = 1,need_exp = 59,attr_list = [{1,355},{2,4052},{4,152},{5,20},{8,14}],can_carry_weight = 8};

get_child_grow_up_cfg(0,5) ->
    #child_grow_up_cfg{year = 0,month = 5,next_year = 1,need_exp = 69,attr_list = [{1,368},{2,4202},{4,158},{5,21},{8,14}],can_carry_weight = 8};

get_child_grow_up_cfg(0,6) ->
    #child_grow_up_cfg{year = 0,month = 6,next_year = 1,need_exp = 79,attr_list = [{1,383},{2,4374},{4,164},{5,22},{8,15}],can_carry_weight = 8};

get_child_grow_up_cfg(0,7) ->
    #child_grow_up_cfg{year = 0,month = 7,next_year = 1,need_exp = 89,attr_list = [{1,400},{2,4568},{4,171},{5,23},{8,15}],can_carry_weight = 8};

get_child_grow_up_cfg(0,8) ->
    #child_grow_up_cfg{year = 0,month = 8,next_year = 1,need_exp = 99,attr_list = [{1,419},{2,4784},{4,179},{5,24},{8,16}],can_carry_weight = 8};

get_child_grow_up_cfg(0,9) ->
    #child_grow_up_cfg{year = 0,month = 9,next_year = 1,need_exp = 109,attr_list = [{1,439},{2,5022},{4,188},{5,25},{8,17}],can_carry_weight = 8};

get_child_grow_up_cfg(1,10) ->
    #child_grow_up_cfg{year = 1,month = 10,next_year = 2,need_exp = 119,attr_list = [{1,462},{2,5282},{4,198},{5,26},{8,18}],can_carry_weight = 10};

get_child_grow_up_cfg(1,11) ->
    #child_grow_up_cfg{year = 1,month = 11,next_year = 2,need_exp = 129,attr_list = [{1,487},{2,5564},{4,209},{5,28},{8,19}],can_carry_weight = 10};

get_child_grow_up_cfg(1,12) ->
    #child_grow_up_cfg{year = 1,month = 12,next_year = 2,need_exp = 139,attr_list = [{1,513},{2,5868},{4,220},{5,29},{8,20}],can_carry_weight = 10};

get_child_grow_up_cfg(1,13) ->
    #child_grow_up_cfg{year = 1,month = 13,next_year = 2,need_exp = 149,attr_list = [{1,542},{2,6194},{4,232},{5,31},{8,21}],can_carry_weight = 10};

get_child_grow_up_cfg(1,14) ->
    #child_grow_up_cfg{year = 1,month = 14,next_year = 2,need_exp = 159,attr_list = [{1,572},{2,6542},{4,245},{5,33},{8,22}],can_carry_weight = 10};

get_child_grow_up_cfg(1,15) ->
    #child_grow_up_cfg{year = 1,month = 15,next_year = 2,need_exp = 169,attr_list = [{1,605},{2,6912},{4,259},{5,35},{8,23}],can_carry_weight = 10};

get_child_grow_up_cfg(1,16) ->
    #child_grow_up_cfg{year = 1,month = 16,next_year = 2,need_exp = 179,attr_list = [{1,639},{2,7304},{4,274},{5,37},{8,24}],can_carry_weight = 10};

get_child_grow_up_cfg(1,17) ->
    #child_grow_up_cfg{year = 1,month = 17,next_year = 2,need_exp = 189,attr_list = [{1,675},{2,7718},{4,289},{5,39},{8,26}],can_carry_weight = 10};

get_child_grow_up_cfg(1,18) ->
    #child_grow_up_cfg{year = 1,month = 18,next_year = 2,need_exp = 199,attr_list = [{1,713},{2,8154},{4,306},{5,41},{8,27}],can_carry_weight = 10};

get_child_grow_up_cfg(1,19) ->
    #child_grow_up_cfg{year = 1,month = 19,next_year = 2,need_exp = 209,attr_list = [{1,754},{2,8612},{4,323},{5,43},{8,29}],can_carry_weight = 10};

get_child_grow_up_cfg(2,20) ->
    #child_grow_up_cfg{year = 2,month = 20,next_year = 3,need_exp = 220,attr_list = [{1,796},{2,9092},{4,341},{5,45},{8,30}],can_carry_weight = 12};

get_child_grow_up_cfg(2,21) ->
    #child_grow_up_cfg{year = 2,month = 21,next_year = 3,need_exp = 231,attr_list = [{1,839},{2,9594},{4,360},{5,48},{8,32}],can_carry_weight = 12};

get_child_grow_up_cfg(2,22) ->
    #child_grow_up_cfg{year = 2,month = 22,next_year = 3,need_exp = 242,attr_list = [{1,885},{2,10118},{4,379},{5,51},{8,34}],can_carry_weight = 12};

get_child_grow_up_cfg(2,23) ->
    #child_grow_up_cfg{year = 2,month = 23,next_year = 3,need_exp = 253,attr_list = [{1,933},{2,10664},{4,400},{5,53},{8,36}],can_carry_weight = 12};

get_child_grow_up_cfg(2,24) ->
    #child_grow_up_cfg{year = 2,month = 24,next_year = 3,need_exp = 264,attr_list = [{1,983},{2,11232},{4,421},{5,56},{8,37}],can_carry_weight = 12};

get_child_grow_up_cfg(2,25) ->
    #child_grow_up_cfg{year = 2,month = 25,next_year = 3,need_exp = 275,attr_list = [{1,1034},{2,11822},{4,443},{5,59},{8,39}],can_carry_weight = 12};

get_child_grow_up_cfg(2,26) ->
    #child_grow_up_cfg{year = 2,month = 26,next_year = 3,need_exp = 286,attr_list = [{1,1088},{2,12434},{4,466},{5,62},{8,41}],can_carry_weight = 12};

get_child_grow_up_cfg(2,27) ->
    #child_grow_up_cfg{year = 2,month = 27,next_year = 3,need_exp = 297,attr_list = [{1,1143},{2,13068},{4,490},{5,65},{8,44}],can_carry_weight = 12};

get_child_grow_up_cfg(2,28) ->
    #child_grow_up_cfg{year = 2,month = 28,next_year = 3,need_exp = 308,attr_list = [{1,1201},{2,13724},{4,515},{5,69},{8,46}],can_carry_weight = 12};

get_child_grow_up_cfg(2,29) ->
    #child_grow_up_cfg{year = 2,month = 29,next_year = 3,need_exp = 319,attr_list = [{1,1260},{2,14402},{4,540},{5,72},{8,48}],can_carry_weight = 12};

get_child_grow_up_cfg(3,30) ->
    #child_grow_up_cfg{year = 3,month = 30,next_year = 4,need_exp = 330,attr_list = [{1,1321},{2,15102},{4,566},{5,76},{8,50}],can_carry_weight = 15};

get_child_grow_up_cfg(3,31) ->
    #child_grow_up_cfg{year = 3,month = 31,next_year = 4,need_exp = 341,attr_list = [{1,1385},{2,15824},{4,593},{5,79},{8,53}],can_carry_weight = 15};

get_child_grow_up_cfg(3,32) ->
    #child_grow_up_cfg{year = 3,month = 32,next_year = 4,need_exp = 352,attr_list = [{1,1450},{2,16568},{4,621},{5,83},{8,55}],can_carry_weight = 15};

get_child_grow_up_cfg(3,33) ->
    #child_grow_up_cfg{year = 3,month = 33,next_year = 4,need_exp = 363,attr_list = [{1,1517},{2,17334},{4,650},{5,87},{8,58}],can_carry_weight = 15};

get_child_grow_up_cfg(3,34) ->
    #child_grow_up_cfg{year = 3,month = 34,next_year = 4,need_exp = 374,attr_list = [{1,1586},{2,18122},{4,680},{5,91},{8,60}],can_carry_weight = 15};

get_child_grow_up_cfg(3,35) ->
    #child_grow_up_cfg{year = 3,month = 35,next_year = 4,need_exp = 385,attr_list = [{1,1657},{2,18932},{4,710},{5,95},{8,63}],can_carry_weight = 15};

get_child_grow_up_cfg(3,36) ->
    #child_grow_up_cfg{year = 3,month = 36,next_year = 4,need_exp = 396,attr_list = [{1,1729},{2,19764},{4,741},{5,99},{8,66}],can_carry_weight = 15};

get_child_grow_up_cfg(3,37) ->
    #child_grow_up_cfg{year = 3,month = 37,next_year = 4,need_exp = 407,attr_list = [{1,1804},{2,20618},{4,773},{5,103},{8,69}],can_carry_weight = 15};

get_child_grow_up_cfg(3,38) ->
    #child_grow_up_cfg{year = 3,month = 38,next_year = 4,need_exp = 419,attr_list = [{1,1881},{2,21494},{4,806},{5,107},{8,72}],can_carry_weight = 15};

get_child_grow_up_cfg(3,39) ->
    #child_grow_up_cfg{year = 3,month = 39,next_year = 4,need_exp = 431,attr_list = [{1,1959},{2,22392},{4,840},{5,112},{8,75}],can_carry_weight = 15};

get_child_grow_up_cfg(4,40) ->
    #child_grow_up_cfg{year = 4,month = 40,next_year = 5,need_exp = 443,attr_list = [{1,2040},{2,23312},{4,874},{5,117},{8,78}],can_carry_weight = 18};

get_child_grow_up_cfg(4,41) ->
    #child_grow_up_cfg{year = 4,month = 41,next_year = 5,need_exp = 455,attr_list = [{1,2122},{2,24254},{4,910},{5,121},{8,81}],can_carry_weight = 18};

get_child_grow_up_cfg(4,42) ->
    #child_grow_up_cfg{year = 4,month = 42,next_year = 5,need_exp = 467,attr_list = [{1,2207},{2,25218},{4,946},{5,126},{8,84}],can_carry_weight = 18};

get_child_grow_up_cfg(4,43) ->
    #child_grow_up_cfg{year = 4,month = 43,next_year = 5,need_exp = 479,attr_list = [{1,2293},{2,26204},{4,983},{5,131},{8,87}],can_carry_weight = 18};

get_child_grow_up_cfg(4,44) ->
    #child_grow_up_cfg{year = 4,month = 44,next_year = 5,need_exp = 491,attr_list = [{1,2381},{2,27212},{4,1020},{5,136},{8,91}],can_carry_weight = 18};

get_child_grow_up_cfg(4,45) ->
    #child_grow_up_cfg{year = 4,month = 45,next_year = 5,need_exp = 503,attr_list = [{1,2471},{2,28242},{4,1059},{5,141},{8,94}],can_carry_weight = 18};

get_child_grow_up_cfg(4,46) ->
    #child_grow_up_cfg{year = 4,month = 46,next_year = 5,need_exp = 515,attr_list = [{1,2563},{2,29294},{4,1099},{5,146},{8,98}],can_carry_weight = 18};

get_child_grow_up_cfg(4,47) ->
    #child_grow_up_cfg{year = 4,month = 47,next_year = 5,need_exp = 527,attr_list = [{1,2657},{2,30368},{4,1139},{5,152},{8,101}],can_carry_weight = 18};

get_child_grow_up_cfg(4,48) ->
    #child_grow_up_cfg{year = 4,month = 48,next_year = 5,need_exp = 539,attr_list = [{1,2753},{2,31464},{4,1180},{5,157},{8,105}],can_carry_weight = 18};

get_child_grow_up_cfg(4,49) ->
    #child_grow_up_cfg{year = 4,month = 49,next_year = 5,need_exp = 551,attr_list = [{1,2851},{2,32582},{4,1222},{5,163},{8,109}],can_carry_weight = 18};

get_child_grow_up_cfg(5,50) ->
    #child_grow_up_cfg{year = 5,month = 50,next_year = 6,need_exp = 563,attr_list = [{1,2951},{2,33722},{4,1265},{5,169},{8,112}],can_carry_weight = 22};

get_child_grow_up_cfg(5,51) ->
    #child_grow_up_cfg{year = 5,month = 51,next_year = 6,need_exp = 575,attr_list = [{1,3052},{2,34884},{4,1308},{5,174},{8,116}],can_carry_weight = 22};

get_child_grow_up_cfg(5,52) ->
    #child_grow_up_cfg{year = 5,month = 52,next_year = 6,need_exp = 587,attr_list = [{1,3156},{2,36068},{4,1353},{5,180},{8,120}],can_carry_weight = 22};

get_child_grow_up_cfg(5,53) ->
    #child_grow_up_cfg{year = 5,month = 53,next_year = 6,need_exp = 599,attr_list = [{1,3261},{2,37274},{4,1398},{5,186},{8,124}],can_carry_weight = 22};

get_child_grow_up_cfg(5,54) ->
    #child_grow_up_cfg{year = 5,month = 54,next_year = 6,need_exp = 611,attr_list = [{1,3369},{2,38502},{4,1444},{5,193},{8,128}],can_carry_weight = 22};

get_child_grow_up_cfg(5,55) ->
    #child_grow_up_cfg{year = 5,month = 55,next_year = 6,need_exp = 624,attr_list = [{1,3478},{2,39752},{4,1491},{5,199},{8,133}],can_carry_weight = 22};

get_child_grow_up_cfg(5,56) ->
    #child_grow_up_cfg{year = 5,month = 56,next_year = 6,need_exp = 637,attr_list = [{1,3590},{2,41024},{4,1538},{5,205},{8,137}],can_carry_weight = 22};

get_child_grow_up_cfg(5,57) ->
    #child_grow_up_cfg{year = 5,month = 57,next_year = 6,need_exp = 650,attr_list = [{1,3703},{2,42318},{4,1587},{5,212},{8,141}],can_carry_weight = 22};

get_child_grow_up_cfg(5,58) ->
    #child_grow_up_cfg{year = 5,month = 58,next_year = 6,need_exp = 663,attr_list = [{1,3818},{2,43634},{4,1636},{5,218},{8,145}],can_carry_weight = 22};

get_child_grow_up_cfg(5,59) ->
    #child_grow_up_cfg{year = 5,month = 59,next_year = 6,need_exp = 676,attr_list = [{1,3935},{2,44972},{4,1686},{5,225},{8,150}],can_carry_weight = 22};

get_child_grow_up_cfg(6,60) ->
    #child_grow_up_cfg{year = 6,month = 60,next_year = 7,need_exp = 689,attr_list = [{1,4054},{2,46332},{4,1737},{5,232},{8,154}],can_carry_weight = 26};

get_child_grow_up_cfg(6,61) ->
    #child_grow_up_cfg{year = 6,month = 61,next_year = 7,need_exp = 702,attr_list = [{1,4175},{2,47714},{4,1789},{5,239},{8,159}],can_carry_weight = 26};

get_child_grow_up_cfg(6,62) ->
    #child_grow_up_cfg{year = 6,month = 62,next_year = 7,need_exp = 715,attr_list = [{1,4298},{2,49118},{4,1842},{5,246},{8,164}],can_carry_weight = 26};

get_child_grow_up_cfg(6,63) ->
    #child_grow_up_cfg{year = 6,month = 63,next_year = 7,need_exp = 728,attr_list = [{1,4423},{2,50544},{4,1895},{5,253},{8,168}],can_carry_weight = 26};

get_child_grow_up_cfg(6,64) ->
    #child_grow_up_cfg{year = 6,month = 64,next_year = 7,need_exp = 741,attr_list = [{1,4549},{2,51992},{4,1950},{5,260},{8,173}],can_carry_weight = 26};

get_child_grow_up_cfg(6,65) ->
    #child_grow_up_cfg{year = 6,month = 65,next_year = 7,need_exp = 754,attr_list = [{1,4678},{2,53462},{4,2005},{5,267},{8,178}],can_carry_weight = 26};

get_child_grow_up_cfg(6,66) ->
    #child_grow_up_cfg{year = 6,month = 66,next_year = 7,need_exp = 767,attr_list = [{1,4808},{2,54954},{4,2061},{5,275},{8,183}],can_carry_weight = 26};

get_child_grow_up_cfg(6,67) ->
    #child_grow_up_cfg{year = 6,month = 67,next_year = 7,need_exp = 780,attr_list = [{1,4941},{2,56468},{4,2118},{5,282},{8,188}],can_carry_weight = 26};

get_child_grow_up_cfg(6,68) ->
    #child_grow_up_cfg{year = 6,month = 68,next_year = 7,need_exp = 793,attr_list = [{1,5075},{2,58004},{4,2175},{5,290},{8,193}],can_carry_weight = 26};

get_child_grow_up_cfg(6,69) ->
    #child_grow_up_cfg{year = 6,month = 69,next_year = 7,need_exp = 806,attr_list = [{1,5212},{2,59562},{4,2234},{5,298},{8,199}],can_carry_weight = 26};

get_child_grow_up_cfg(7,70) ->
    #child_grow_up_cfg{year = 7,month = 70,next_year = 8,need_exp = 820,attr_list = [{1,5350},{2,61142},{4,2293},{5,306},{8,204}],can_carry_weight = 30};

get_child_grow_up_cfg(7,71) ->
    #child_grow_up_cfg{year = 7,month = 71,next_year = 8,need_exp = 834,attr_list = [{1,5490},{2,62744},{4,2353},{5,314},{8,209}],can_carry_weight = 30};

get_child_grow_up_cfg(7,72) ->
    #child_grow_up_cfg{year = 7,month = 72,next_year = 8,need_exp = 848,attr_list = [{1,5632},{2,64368},{4,2414},{5,322},{8,215}],can_carry_weight = 30};

get_child_grow_up_cfg(7,73) ->
    #child_grow_up_cfg{year = 7,month = 73,next_year = 8,need_exp = 862,attr_list = [{1,5776},{2,66014},{4,2476},{5,330},{8,220}],can_carry_weight = 30};

get_child_grow_up_cfg(7,74) ->
    #child_grow_up_cfg{year = 7,month = 74,next_year = 8,need_exp = 876,attr_list = [{1,5922},{2,67682},{4,2538},{5,338},{8,226}],can_carry_weight = 30};

get_child_grow_up_cfg(7,75) ->
    #child_grow_up_cfg{year = 7,month = 75,next_year = 8,need_exp = 890,attr_list = [{1,6070},{2,69372},{4,2601},{5,347},{8,231}],can_carry_weight = 30};

get_child_grow_up_cfg(7,76) ->
    #child_grow_up_cfg{year = 7,month = 76,next_year = 8,need_exp = 904,attr_list = [{1,6220},{2,71084},{4,2666},{5,355},{8,237}],can_carry_weight = 30};

get_child_grow_up_cfg(7,77) ->
    #child_grow_up_cfg{year = 7,month = 77,next_year = 8,need_exp = 918,attr_list = [{1,6372},{2,72818},{4,2731},{5,364},{8,243}],can_carry_weight = 30};

get_child_grow_up_cfg(7,78) ->
    #child_grow_up_cfg{year = 7,month = 78,next_year = 8,need_exp = 932,attr_list = [{1,6525},{2,74574},{4,2797},{5,373},{8,249}],can_carry_weight = 30};

get_child_grow_up_cfg(7,79) ->
    #child_grow_up_cfg{year = 7,month = 79,next_year = 8,need_exp = 946,attr_list = [{1,6681},{2,76352},{4,2863},{5,382},{8,255}],can_carry_weight = 30};

get_child_grow_up_cfg(8,80) ->
    #child_grow_up_cfg{year = 8,month = 80,next_year = 9,need_exp = 960,attr_list = [{1,6838},{2,78152},{4,2931},{5,391},{8,261}],can_carry_weight = 35};

get_child_grow_up_cfg(8,81) ->
    #child_grow_up_cfg{year = 8,month = 81,next_year = 9,need_exp = 974,attr_list = [{1,6998},{2,79974},{4,2999},{5,400},{8,267}],can_carry_weight = 35};

get_child_grow_up_cfg(8,82) ->
    #child_grow_up_cfg{year = 8,month = 82,next_year = 9,need_exp = 988,attr_list = [{1,7159},{2,81818},{4,3068},{5,409},{8,273}],can_carry_weight = 35};

get_child_grow_up_cfg(8,83) ->
    #child_grow_up_cfg{year = 8,month = 83,next_year = 9,need_exp = 1002,attr_list = [{1,7322},{2,83684},{4,3138},{5,418},{8,279}],can_carry_weight = 35};

get_child_grow_up_cfg(8,84) ->
    #child_grow_up_cfg{year = 8,month = 84,next_year = 9,need_exp = 1017,attr_list = [{1,7488},{2,85572},{4,3209},{5,428},{8,285}],can_carry_weight = 35};

get_child_grow_up_cfg(8,85) ->
    #child_grow_up_cfg{year = 8,month = 85,next_year = 9,need_exp = 1032,attr_list = [{1,7655},{2,87482},{4,3281},{5,437},{8,292}],can_carry_weight = 35};

get_child_grow_up_cfg(8,86) ->
    #child_grow_up_cfg{year = 8,month = 86,next_year = 9,need_exp = 1047,attr_list = [{1,7824},{2,89414},{4,3353},{5,447},{8,298}],can_carry_weight = 35};

get_child_grow_up_cfg(8,87) ->
    #child_grow_up_cfg{year = 8,month = 87,next_year = 9,need_exp = 1062,attr_list = [{1,7995},{2,91368},{4,3426},{5,457},{8,305}],can_carry_weight = 35};

get_child_grow_up_cfg(8,88) ->
    #child_grow_up_cfg{year = 8,month = 88,next_year = 9,need_exp = 1077,attr_list = [{1,8168},{2,93344},{4,3500},{5,467},{8,311}],can_carry_weight = 35};

get_child_grow_up_cfg(8,89) ->
    #child_grow_up_cfg{year = 8,month = 89,next_year = 9,need_exp = 1092,attr_list = [{1,8342},{2,95342},{4,3575},{5,477},{8,318}],can_carry_weight = 35};

get_child_grow_up_cfg(9,90) ->
    #child_grow_up_cfg{year = 9,month = 90,next_year = 10,need_exp = 1107,attr_list = [{1,8519},{2,97362},{4,3651},{5,487},{8,325}],can_carry_weight = 40};

get_child_grow_up_cfg(9,91) ->
    #child_grow_up_cfg{year = 9,month = 91,next_year = 10,need_exp = 1122,attr_list = [{1,8698},{2,99404},{4,3728},{5,497},{8,331}],can_carry_weight = 40};

get_child_grow_up_cfg(9,92) ->
    #child_grow_up_cfg{year = 9,month = 92,next_year = 10,need_exp = 1137,attr_list = [{1,8878},{2,101468},{4,3805},{5,507},{8,338}],can_carry_weight = 40};

get_child_grow_up_cfg(9,93) ->
    #child_grow_up_cfg{year = 9,month = 93,next_year = 10,need_exp = 1152,attr_list = [{1,9061},{2,103554},{4,3883},{5,518},{8,345}],can_carry_weight = 40};

get_child_grow_up_cfg(9,94) ->
    #child_grow_up_cfg{year = 9,month = 94,next_year = 10,need_exp = 1167,attr_list = [{1,9245},{2,105662},{4,3962},{5,528},{8,352}],can_carry_weight = 40};

get_child_grow_up_cfg(9,95) ->
    #child_grow_up_cfg{year = 9,month = 95,next_year = 10,need_exp = 1182,attr_list = [{1,9432},{2,107792},{4,4042},{5,539},{8,359}],can_carry_weight = 40};

get_child_grow_up_cfg(9,96) ->
    #child_grow_up_cfg{year = 9,month = 96,next_year = 10,need_exp = 1197,attr_list = [{1,9620},{2,109944},{4,4123},{5,550},{8,366}],can_carry_weight = 40};

get_child_grow_up_cfg(9,97) ->
    #child_grow_up_cfg{year = 9,month = 97,next_year = 10,need_exp = 1212,attr_list = [{1,9810},{2,112118},{4,4204},{5,561},{8,374}],can_carry_weight = 40};

get_child_grow_up_cfg(9,98) ->
    #child_grow_up_cfg{year = 9,month = 98,next_year = 10,need_exp = 1228,attr_list = [{1,10002},{2,114314},{4,4287},{5,572},{8,381}],can_carry_weight = 40};

get_child_grow_up_cfg(9,99) ->
    #child_grow_up_cfg{year = 9,month = 99,next_year = 10,need_exp = 1244,attr_list = [{1,10197},{2,116532},{4,4370},{5,583},{8,388}],can_carry_weight = 40};

get_child_grow_up_cfg(10,100) ->
    #child_grow_up_cfg{year = 10,month = 100,next_year = 11,need_exp = 1260,attr_list = [{1,10393},{2,118772},{4,4454},{5,594},{8,396}],can_carry_weight = 45};

get_child_grow_up_cfg(10,101) ->
    #child_grow_up_cfg{year = 10,month = 101,next_year = 11,need_exp = 1276,attr_list = [{1,10590},{2,121034},{4,4539},{5,605},{8,403}],can_carry_weight = 45};

get_child_grow_up_cfg(10,102) ->
    #child_grow_up_cfg{year = 10,month = 102,next_year = 11,need_exp = 1292,attr_list = [{1,10790},{2,123318},{4,4624},{5,617},{8,411}],can_carry_weight = 45};

get_child_grow_up_cfg(10,103) ->
    #child_grow_up_cfg{year = 10,month = 103,next_year = 11,need_exp = 1308,attr_list = [{1,10992},{2,125624},{4,4711},{5,628},{8,419}],can_carry_weight = 45};

get_child_grow_up_cfg(10,104) ->
    #child_grow_up_cfg{year = 10,month = 104,next_year = 11,need_exp = 1324,attr_list = [{1,11196},{2,127952},{4,4798},{5,640},{8,427}],can_carry_weight = 45};

get_child_grow_up_cfg(10,105) ->
    #child_grow_up_cfg{year = 10,month = 105,next_year = 11,need_exp = 1340,attr_list = [{1,11401},{2,130302},{4,4886},{5,652},{8,434}],can_carry_weight = 45};

get_child_grow_up_cfg(10,106) ->
    #child_grow_up_cfg{year = 10,month = 106,next_year = 11,need_exp = 1356,attr_list = [{1,11609},{2,132674},{4,4975},{5,663},{8,442}],can_carry_weight = 45};

get_child_grow_up_cfg(10,107) ->
    #child_grow_up_cfg{year = 10,month = 107,next_year = 11,need_exp = 1372,attr_list = [{1,11818},{2,135068},{4,5065},{5,675},{8,450}],can_carry_weight = 45};

get_child_grow_up_cfg(10,108) ->
    #child_grow_up_cfg{year = 10,month = 108,next_year = 11,need_exp = 1388,attr_list = [{1,12030},{2,137484},{4,5156},{5,687},{8,458}],can_carry_weight = 45};

get_child_grow_up_cfg(10,109) ->
    #child_grow_up_cfg{year = 10,month = 109,next_year = 11,need_exp = 1404,attr_list = [{1,12243},{2,139922},{4,5247},{5,700},{8,466}],can_carry_weight = 45};

get_child_grow_up_cfg(11,110) ->
    #child_grow_up_cfg{year = 11,month = 110,next_year = 12,need_exp = 1421,attr_list = [{1,12458},{2,142382},{4,5339},{5,712},{8,475}],can_carry_weight = 50};

get_child_grow_up_cfg(11,111) ->
    #child_grow_up_cfg{year = 11,month = 111,next_year = 12,need_exp = 1438,attr_list = [{1,12676},{2,144864},{4,5432},{5,724},{8,483}],can_carry_weight = 50};

get_child_grow_up_cfg(11,112) ->
    #child_grow_up_cfg{year = 11,month = 112,next_year = 12,need_exp = 1455,attr_list = [{1,12895},{2,147368},{4,5526},{5,737},{8,491}],can_carry_weight = 50};

get_child_grow_up_cfg(11,113) ->
    #child_grow_up_cfg{year = 11,month = 113,next_year = 12,need_exp = 1472,attr_list = [{1,13116},{2,149894},{4,5621},{5,749},{8,500}],can_carry_weight = 50};

get_child_grow_up_cfg(11,114) ->
    #child_grow_up_cfg{year = 11,month = 114,next_year = 12,need_exp = 1489,attr_list = [{1,13339},{2,152442},{4,5717},{5,762},{8,508}],can_carry_weight = 50};

get_child_grow_up_cfg(11,115) ->
    #child_grow_up_cfg{year = 11,month = 115,next_year = 12,need_exp = 1506,attr_list = [{1,13564},{2,155012},{4,5813},{5,775},{8,517}],can_carry_weight = 50};

get_child_grow_up_cfg(11,116) ->
    #child_grow_up_cfg{year = 11,month = 116,next_year = 12,need_exp = 1523,attr_list = [{1,13790},{2,157604},{4,5910},{5,788},{8,525}],can_carry_weight = 50};

get_child_grow_up_cfg(11,117) ->
    #child_grow_up_cfg{year = 11,month = 117,next_year = 12,need_exp = 1540,attr_list = [{1,14019},{2,160218},{4,6008},{5,801},{8,534}],can_carry_weight = 50};

get_child_grow_up_cfg(11,118) ->
    #child_grow_up_cfg{year = 11,month = 118,next_year = 12,need_exp = 1557,attr_list = [{1,14250},{2,162854},{4,6107},{5,814},{8,543}],can_carry_weight = 50};

get_child_grow_up_cfg(11,119) ->
    #child_grow_up_cfg{year = 11,month = 119,next_year = 12,need_exp = 1574,attr_list = [{1,14482},{2,165512},{4,6207},{5,828},{8,552}],can_carry_weight = 50};

get_child_grow_up_cfg(12,120) ->
    #child_grow_up_cfg{year = 12,month = 120,next_year = 13,need_exp = 1591,attr_list = [{1,14717},{2,168192},{4,6307},{5,841},{8,561}],can_carry_weight = 55};

get_child_grow_up_cfg(12,121) ->
    #child_grow_up_cfg{year = 12,month = 121,next_year = 13,need_exp = 1608,attr_list = [{1,14953},{2,170894},{4,6409},{5,854},{8,570}],can_carry_weight = 55};

get_child_grow_up_cfg(12,122) ->
    #child_grow_up_cfg{year = 12,month = 122,next_year = 13,need_exp = 1626,attr_list = [{1,15192},{2,173618},{4,6511},{5,868},{8,579}],can_carry_weight = 55};

get_child_grow_up_cfg(12,123) ->
    #child_grow_up_cfg{year = 12,month = 123,next_year = 13,need_exp = 1644,attr_list = [{1,15432},{2,176364},{4,6614},{5,882},{8,588}],can_carry_weight = 55};

get_child_grow_up_cfg(12,124) ->
    #child_grow_up_cfg{year = 12,month = 124,next_year = 13,need_exp = 1662,attr_list = [{1,15674},{2,179132},{4,6717},{5,896},{8,597}],can_carry_weight = 55};

get_child_grow_up_cfg(12,125) ->
    #child_grow_up_cfg{year = 12,month = 125,next_year = 13,need_exp = 1680,attr_list = [{1,15918},{2,181922},{4,6822},{5,910},{8,606}],can_carry_weight = 55};

get_child_grow_up_cfg(12,126) ->
    #child_grow_up_cfg{year = 12,month = 126,next_year = 13,need_exp = 1698,attr_list = [{1,16164},{2,184734},{4,6928},{5,924},{8,616}],can_carry_weight = 55};

get_child_grow_up_cfg(12,127) ->
    #child_grow_up_cfg{year = 12,month = 127,next_year = 13,need_exp = 1716,attr_list = [{1,16412},{2,187568},{4,7034},{5,938},{8,625}],can_carry_weight = 55};

get_child_grow_up_cfg(12,128) ->
    #child_grow_up_cfg{year = 12,month = 128,next_year = 13,need_exp = 1734,attr_list = [{1,16662},{2,190424},{4,7141},{5,952},{8,635}],can_carry_weight = 55};

get_child_grow_up_cfg(12,129) ->
    #child_grow_up_cfg{year = 12,month = 129,next_year = 13,need_exp = 1752,attr_list = [{1,16914},{2,193302},{4,7249},{5,967},{8,644}],can_carry_weight = 55};

get_child_grow_up_cfg(13,130) ->
    #child_grow_up_cfg{year = 13,month = 130,next_year = 14,need_exp = 1770,attr_list = [{1,17168},{2,196202},{4,7358},{5,981},{8,654}],can_carry_weight = 60};

get_child_grow_up_cfg(13,131) ->
    #child_grow_up_cfg{year = 13,month = 131,next_year = 14,need_exp = 1788,attr_list = [{1,17423},{2,199124},{4,7467},{5,996},{8,664}],can_carry_weight = 60};

get_child_grow_up_cfg(13,132) ->
    #child_grow_up_cfg{year = 13,month = 132,next_year = 14,need_exp = 1806,attr_list = [{1,17681},{2,202068},{4,7578},{5,1010},{8,674}],can_carry_weight = 60};

get_child_grow_up_cfg(13,133) ->
    #child_grow_up_cfg{year = 13,month = 133,next_year = 14,need_exp = 1825,attr_list = [{1,17940},{2,205034},{4,7689},{5,1025},{8,683}],can_carry_weight = 60};

get_child_grow_up_cfg(13,134) ->
    #child_grow_up_cfg{year = 13,month = 134,next_year = 14,need_exp = 1844,attr_list = [{1,18202},{2,208022},{4,7801},{5,1040},{8,693}],can_carry_weight = 60};

get_child_grow_up_cfg(13,135) ->
    #child_grow_up_cfg{year = 13,month = 135,next_year = 14,need_exp = 1863,attr_list = [{1,18465},{2,211032},{4,7914},{5,1055},{8,703}],can_carry_weight = 60};

get_child_grow_up_cfg(13,136) ->
    #child_grow_up_cfg{year = 13,month = 136,next_year = 14,need_exp = 1882,attr_list = [{1,18731},{2,214064},{4,8027},{5,1070},{8,714}],can_carry_weight = 60};

get_child_grow_up_cfg(13,137) ->
    #child_grow_up_cfg{year = 13,month = 137,next_year = 14,need_exp = 1901,attr_list = [{1,18998},{2,217118},{4,8142},{5,1086},{8,724}],can_carry_weight = 60};

get_child_grow_up_cfg(13,138) ->
    #child_grow_up_cfg{year = 13,month = 138,next_year = 14,need_exp = 1920,attr_list = [{1,19267},{2,220194},{4,8257},{5,1101},{8,734}],can_carry_weight = 60};

get_child_grow_up_cfg(13,139) ->
    #child_grow_up_cfg{year = 13,month = 139,next_year = 14,need_exp = 1939,attr_list = [{1,19538},{2,223292},{4,8373},{5,1116},{8,744}],can_carry_weight = 60};

get_child_grow_up_cfg(14,140) ->
    #child_grow_up_cfg{year = 14,month = 140,next_year = 15,need_exp = 1958,attr_list = [{1,19811},{2,226412},{4,8490},{5,1132},{8,755}],can_carry_weight = 60};

get_child_grow_up_cfg(14,141) ->
    #child_grow_up_cfg{year = 14,month = 141,next_year = 15,need_exp = 1977,attr_list = [{1,20086},{2,229554},{4,8608},{5,1148},{8,765}],can_carry_weight = 60};

get_child_grow_up_cfg(14,142) ->
    #child_grow_up_cfg{year = 14,month = 142,next_year = 15,need_exp = 1996,attr_list = [{1,20363},{2,232718},{4,8727},{5,1164},{8,776}],can_carry_weight = 60};

get_child_grow_up_cfg(14,143) ->
    #child_grow_up_cfg{year = 14,month = 143,next_year = 15,need_exp = 2015,attr_list = [{1,20642},{2,235904},{4,8846},{5,1180},{8,786}],can_carry_weight = 60};

get_child_grow_up_cfg(14,144) ->
    #child_grow_up_cfg{year = 14,month = 144,next_year = 15,need_exp = 2035,attr_list = [{1,20922},{2,239112},{4,8967},{5,1196},{8,797}],can_carry_weight = 60};

get_child_grow_up_cfg(14,145) ->
    #child_grow_up_cfg{year = 14,month = 145,next_year = 15,need_exp = 2055,attr_list = [{1,21205},{2,242342},{4,9088},{5,1212},{8,808}],can_carry_weight = 60};

get_child_grow_up_cfg(14,146) ->
    #child_grow_up_cfg{year = 14,month = 146,next_year = 15,need_exp = 2075,attr_list = [{1,21489},{2,245594},{4,9210},{5,1228},{8,819}],can_carry_weight = 60};

get_child_grow_up_cfg(14,147) ->
    #child_grow_up_cfg{year = 14,month = 147,next_year = 15,need_exp = 2095,attr_list = [{1,21776},{2,248868},{4,9333},{5,1244},{8,830}],can_carry_weight = 60};

get_child_grow_up_cfg(14,148) ->
    #child_grow_up_cfg{year = 14,month = 148,next_year = 15,need_exp = 2115,attr_list = [{1,22064},{2,252164},{4,9456},{5,1261},{8,841}],can_carry_weight = 60};

get_child_grow_up_cfg(14,149) ->
    #child_grow_up_cfg{year = 14,month = 149,next_year = 15,need_exp = 2135,attr_list = [{1,22355},{2,255482},{4,9581},{5,1277},{8,852}],can_carry_weight = 60};

get_child_grow_up_cfg(15,150) ->
    #child_grow_up_cfg{year = 15,month = 150,next_year = 16,need_exp = 2155,attr_list = [{1,22647},{2,258822},{4,9706},{5,1294},{8,863}],can_carry_weight = 60};

get_child_grow_up_cfg(15,151) ->
    #child_grow_up_cfg{year = 15,month = 151,next_year = 16,need_exp = 2175,attr_list = [{1,22941},{2,262184},{4,9832},{5,1311},{8,874}],can_carry_weight = 60};

get_child_grow_up_cfg(15,152) ->
    #child_grow_up_cfg{year = 15,month = 152,next_year = 16,need_exp = 2195,attr_list = [{1,23237},{2,265568},{4,9959},{5,1328},{8,885}],can_carry_weight = 60};

get_child_grow_up_cfg(15,153) ->
    #child_grow_up_cfg{year = 15,month = 153,next_year = 16,need_exp = 2215,attr_list = [{1,23535},{2,268974},{4,10087},{5,1345},{8,897}],can_carry_weight = 60};

get_child_grow_up_cfg(15,154) ->
    #child_grow_up_cfg{year = 15,month = 154,next_year = 16,need_exp = 2236,attr_list = [{1,23835},{2,272402},{4,10215},{5,1362},{8,908}],can_carry_weight = 60};

get_child_grow_up_cfg(15,155) ->
    #child_grow_up_cfg{year = 15,month = 155,next_year = 16,need_exp = 2257,attr_list = [{1,24137},{2,275852},{4,10344},{5,1379},{8,920}],can_carry_weight = 60};

get_child_grow_up_cfg(15,156) ->
    #child_grow_up_cfg{year = 15,month = 156,next_year = 16,need_exp = 2278,attr_list = [{1,24441},{2,279324},{4,10475},{5,1397},{8,931}],can_carry_weight = 60};

get_child_grow_up_cfg(15,157) ->
    #child_grow_up_cfg{year = 15,month = 157,next_year = 16,need_exp = 2299,attr_list = [{1,24747},{2,282818},{4,10606},{5,1414},{8,943}],can_carry_weight = 60};

get_child_grow_up_cfg(15,158) ->
    #child_grow_up_cfg{year = 15,month = 158,next_year = 16,need_exp = 2320,attr_list = [{1,25054},{2,286334},{4,10738},{5,1432},{8,954}],can_carry_weight = 60};

get_child_grow_up_cfg(15,159) ->
    #child_grow_up_cfg{year = 15,month = 159,next_year = 16,need_exp = 2341,attr_list = [{1,25364},{2,289872},{4,10870},{5,1449},{8,966}],can_carry_weight = 60};

get_child_grow_up_cfg(16,160) ->
    #child_grow_up_cfg{year = 16,month = 160,next_year = 17,need_exp = 2362,attr_list = [{1,25675},{2,293432},{4,11004},{5,1467},{8,978}],can_carry_weight = 60};

get_child_grow_up_cfg(16,161) ->
    #child_grow_up_cfg{year = 16,month = 161,next_year = 17,need_exp = 2383,attr_list = [{1,25989},{2,297014},{4,11138},{5,1485},{8,990}],can_carry_weight = 60};

get_child_grow_up_cfg(16,162) ->
    #child_grow_up_cfg{year = 16,month = 162,next_year = 17,need_exp = 2404,attr_list = [{1,26304},{2,300618},{4,11273},{5,1503},{8,1002}],can_carry_weight = 60};

get_child_grow_up_cfg(16,163) ->
    #child_grow_up_cfg{year = 16,month = 163,next_year = 17,need_exp = 2426,attr_list = [{1,26621},{2,304244},{4,11409},{5,1521},{8,1014}],can_carry_weight = 60};

get_child_grow_up_cfg(16,164) ->
    #child_grow_up_cfg{year = 16,month = 164,next_year = 17,need_exp = 2448,attr_list = [{1,26941},{2,307892},{4,11546},{5,1539},{8,1026}],can_carry_weight = 60};

get_child_grow_up_cfg(16,165) ->
    #child_grow_up_cfg{year = 16,month = 165,next_year = 17,need_exp = 2470,attr_list = [{1,27262},{2,311562},{4,11684},{5,1558},{8,1039}],can_carry_weight = 60};

get_child_grow_up_cfg(16,166) ->
    #child_grow_up_cfg{year = 16,month = 166,next_year = 17,need_exp = 2492,attr_list = [{1,27585},{2,315254},{4,11822},{5,1576},{8,1051}],can_carry_weight = 60};

get_child_grow_up_cfg(16,167) ->
    #child_grow_up_cfg{year = 16,month = 167,next_year = 17,need_exp = 2514,attr_list = [{1,27910},{2,318968},{4,11961},{5,1595},{8,1063}],can_carry_weight = 60};

get_child_grow_up_cfg(16,168) ->
    #child_grow_up_cfg{year = 16,month = 168,next_year = 17,need_exp = 2536,attr_list = [{1,28237},{2,322704},{4,12101},{5,1614},{8,1076}],can_carry_weight = 60};

get_child_grow_up_cfg(16,169) ->
    #child_grow_up_cfg{year = 16,month = 169,next_year = 17,need_exp = 2558,attr_list = [{1,28565},{2,326462},{4,12242},{5,1632},{8,1088}],can_carry_weight = 60};

get_child_grow_up_cfg(17,170) ->
    #child_grow_up_cfg{year = 17,month = 170,next_year = 18,need_exp = 2580,attr_list = [{1,28896},{2,330242},{4,12384},{5,1651},{8,1101}],can_carry_weight = 60};

get_child_grow_up_cfg(17,171) ->
    #child_grow_up_cfg{year = 17,month = 171,next_year = 18,need_exp = 2602,attr_list = [{1,29229},{2,334044},{4,12527},{5,1670},{8,1113}],can_carry_weight = 60};

get_child_grow_up_cfg(17,172) ->
    #child_grow_up_cfg{year = 17,month = 172,next_year = 18,need_exp = 2625,attr_list = [{1,29563},{2,337868},{4,12670},{5,1689},{8,1126}],can_carry_weight = 60};

get_child_grow_up_cfg(17,173) ->
    #child_grow_up_cfg{year = 17,month = 173,next_year = 18,need_exp = 2648,attr_list = [{1,29900},{2,341714},{4,12814},{5,1709},{8,1139}],can_carry_weight = 60};

get_child_grow_up_cfg(17,174) ->
    #child_grow_up_cfg{year = 17,month = 174,next_year = 18,need_exp = 2671,attr_list = [{1,30238},{2,345582},{4,12959},{5,1728},{8,1152}],can_carry_weight = 60};

get_child_grow_up_cfg(17,175) ->
    #child_grow_up_cfg{year = 17,month = 175,next_year = 18,need_exp = 2694,attr_list = [{1,30579},{2,349472},{4,13105},{5,1747},{8,1165}],can_carry_weight = 60};

get_child_grow_up_cfg(17,176) ->
    #child_grow_up_cfg{year = 17,month = 176,next_year = 18,need_exp = 2717,attr_list = [{1,30921},{2,353384},{4,13252},{5,1767},{8,1178}],can_carry_weight = 60};

get_child_grow_up_cfg(17,177) ->
    #child_grow_up_cfg{year = 17,month = 177,next_year = 18,need_exp = 2740,attr_list = [{1,31265},{2,357318},{4,13399},{5,1787},{8,1191}],can_carry_weight = 60};

get_child_grow_up_cfg(17,178) ->
    #child_grow_up_cfg{year = 17,month = 178,next_year = 18,need_exp = 2763,attr_list = [{1,31611},{2,361274},{4,13548},{5,1806},{8,1204}],can_carry_weight = 60};

get_child_grow_up_cfg(17,179) ->
    #child_grow_up_cfg{year = 17,month = 179,next_year = 18,need_exp = 2786,attr_list = [{1,31960},{2,365252},{4,13697},{5,1826},{8,1218}],can_carry_weight = 60};

get_child_grow_up_cfg(18,180) ->
    #child_grow_up_cfg{year = 18,month = 180,next_year = 0,need_exp = 2809,attr_list = [{1,32310},{2,369252},{4,13847},{5,1846},{8,1231}],can_carry_weight = 60};

get_child_grow_up_cfg(18,181) ->
    #child_grow_up_cfg{year = 18,month = 181,next_year = 0,need_exp = 2833,attr_list = [{1,32661},{2,373274},{4,13998},{5,1866},{8,1244}],can_carry_weight = 60};

get_child_grow_up_cfg(18,182) ->
    #child_grow_up_cfg{year = 18,month = 182,next_year = 0,need_exp = 2857,attr_list = [{1,33015},{2,377318},{4,14149},{5,1887},{8,1258}],can_carry_weight = 60};

get_child_grow_up_cfg(18,183) ->
    #child_grow_up_cfg{year = 18,month = 183,next_year = 0,need_exp = 2881,attr_list = [{1,33371},{2,381384},{4,14302},{5,1907},{8,1271}],can_carry_weight = 60};

get_child_grow_up_cfg(18,184) ->
    #child_grow_up_cfg{year = 18,month = 184,next_year = 0,need_exp = 2905,attr_list = [{1,33729},{2,385472},{4,14455},{5,1927},{8,1285}],can_carry_weight = 60};

get_child_grow_up_cfg(18,185) ->
    #child_grow_up_cfg{year = 18,month = 185,next_year = 0,need_exp = 2929,attr_list = [{1,34088},{2,389582},{4,14609},{5,1948},{8,1299}],can_carry_weight = 60};

get_child_grow_up_cfg(18,186) ->
    #child_grow_up_cfg{year = 18,month = 186,next_year = 0,need_exp = 2953,attr_list = [{1,34450},{2,393714},{4,14764},{5,1969},{8,1312}],can_carry_weight = 60};

get_child_grow_up_cfg(18,187) ->
    #child_grow_up_cfg{year = 18,month = 187,next_year = 0,need_exp = 2977,attr_list = [{1,34813},{2,397868},{4,14920},{5,1989},{8,1326}],can_carry_weight = 60};

get_child_grow_up_cfg(18,188) ->
    #child_grow_up_cfg{year = 18,month = 188,next_year = 0,need_exp = 3001,attr_list = [{1,35179},{2,402044},{4,15077},{5,2010},{8,1340}],can_carry_weight = 60};

get_child_grow_up_cfg(18,189) ->
    #child_grow_up_cfg{year = 18,month = 189,next_year = 0,need_exp = 3026,attr_list = [{1,35546},{2,406242},{4,15234},{5,2031},{8,1354}],can_carry_weight = 60};

get_child_grow_up_cfg(_Year,_Month) ->
    [].

get_child_vote_reward_cfg(Rank) when Rank >= 1, Rank =< 1 ->
	#child_vote_reward_cfg{rank_high=1,rank_low=1,reward_list=[{0,260008,1},{0,450053,1},{0,260003,20},{0,260006,20}]};
get_child_vote_reward_cfg(Rank) when Rank >= 2, Rank =< 3 ->
	#child_vote_reward_cfg{rank_high=2,rank_low=3,reward_list=[{0,450053,1},{0,260003,15},{0,260006,15}]};
get_child_vote_reward_cfg(Rank) when Rank >= 4, Rank =< 10 ->
	#child_vote_reward_cfg{rank_high=4,rank_low=10,reward_list=[{0,260003,10},{0,260006,5}]};
get_child_vote_reward_cfg(Rank) when Rank >= 11, Rank =< 20 ->
	#child_vote_reward_cfg{rank_high=11,rank_low=20,reward_list=[{0,260003,8},{0,260006,3}]};
get_child_vote_reward_cfg(Rank) when Rank >= 21, Rank =< 50 ->
	#child_vote_reward_cfg{rank_high=21,rank_low=50,reward_list=[{0,260003,5},{0,260006,2}]};
get_child_vote_reward_cfg(_Rank) ->
    [].

get_max_vote_rank() -> 50.

get_child_figure_cfg(1,0) ->
    #child_figure_cfg{child_sex = 1,grow_up_level = 0,model_id = 1001};

get_child_figure_cfg(1,1) ->
    #child_figure_cfg{child_sex = 1,grow_up_level = 1,model_id = 1011};

get_child_figure_cfg(1,10) ->
    #child_figure_cfg{child_sex = 1,grow_up_level = 10,model_id = 1021};

get_child_figure_cfg(2,0) ->
    #child_figure_cfg{child_sex = 2,grow_up_level = 0,model_id = 1002};

get_child_figure_cfg(2,1) ->
    #child_figure_cfg{child_sex = 2,grow_up_level = 1,model_id = 1012};

get_child_figure_cfg(2,10) ->
    #child_figure_cfg{child_sex = 2,grow_up_level = 10,model_id = 1022};

get_child_figure_cfg(_Childsex,_Growuplevel) ->
    [].

get_child_skill_cfg(1,1) ->
    #child_skill_cfg{sequence = 1,level = 1,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）110%的伤害，20%概率触发主角受到怪物攻击20%伤害减免效果，持续2秒",active_skill = [{500000,1}],add_attr_list = [{1,412},{2,8240},{4,206}],active_cost = [{0,260005,2}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,2) ->
    #child_skill_cfg{sequence = 1,level = 2,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）110%的伤害，20%概率触发主角受到怪物攻击20%伤害减免效果，持续2秒",active_skill = [{500000,1}],add_attr_list = [{1,428},{2,8560},{4,214}],active_cost = [{0,260006,6}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,3) ->
    #child_skill_cfg{sequence = 1,level = 3,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）110%的伤害，20%概率触发主角受到怪物攻击20%伤害减免效果，持续2秒",active_skill = [{500000,1}],add_attr_list = [{1,448},{2,8960},{4,224}],active_cost = [{0,260006,10}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,4) ->
    #child_skill_cfg{sequence = 1,level = 4,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）110%的伤害，20%概率触发主角受到怪物攻击20%伤害减免效果，持续2秒",active_skill = [{500000,1}],add_attr_list = [{1,472},{2,9440},{4,236}],active_cost = [{0,260006,14}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,5) ->
    #child_skill_cfg{sequence = 1,level = 5,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）110%的伤害，20%概率触发主角受到怪物攻击20%伤害减免效果，持续2秒",active_skill = [{500000,1}],add_attr_list = [{1,500},{2,10000},{4,250}],active_cost = [{0,260006,18}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,6) ->
    #child_skill_cfg{sequence = 1,level = 6,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）120%的伤害，20%概率触发主角受到怪物攻击24%伤害减免效果，持续2秒",active_skill = [{500000,2}],add_attr_list = [{1,532},{2,10640},{4,266}],active_cost = [{0,260006,22}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,7) ->
    #child_skill_cfg{sequence = 1,level = 7,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）120%的伤害，20%概率触发主角受到怪物攻击24%伤害减免效果，持续2秒",active_skill = [{500000,2}],add_attr_list = [{1,568},{2,11360},{4,284}],active_cost = [{0,260006,27}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,8) ->
    #child_skill_cfg{sequence = 1,level = 8,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）120%的伤害，20%概率触发主角受到怪物攻击24%伤害减免效果，持续2秒",active_skill = [{500000,2}],add_attr_list = [{1,608},{2,12160},{4,304}],active_cost = [{0,260006,32}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,9) ->
    #child_skill_cfg{sequence = 1,level = 9,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）120%的伤害，20%概率触发主角受到怪物攻击24%伤害减免效果，持续2秒",active_skill = [{500000,2}],add_attr_list = [{1,652},{2,13040},{4,326}],active_cost = [{0,260006,37}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,10) ->
    #child_skill_cfg{sequence = 1,level = 10,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）120%的伤害，20%概率触发主角受到怪物攻击24%伤害减免效果，持续2秒",active_skill = [{500000,2}],add_attr_list = [{1,700},{2,14000},{4,350}],active_cost = [{0,260006,42}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,11) ->
    #child_skill_cfg{sequence = 1,level = 11,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）130%的伤害，20%概率触发主角受到怪物攻击26%伤害减免效果，持续2秒",active_skill = [{500000,3}],add_attr_list = [{1,752},{2,15040},{4,376}],active_cost = [{0,260006,48}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,12) ->
    #child_skill_cfg{sequence = 1,level = 12,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）130%的伤害，20%概率触发主角受到怪物攻击26%伤害减免效果，持续2秒",active_skill = [{500000,3}],add_attr_list = [{1,808},{2,16160},{4,404}],active_cost = [{0,260006,54}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,13) ->
    #child_skill_cfg{sequence = 1,level = 13,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）130%的伤害，20%概率触发主角受到怪物攻击26%伤害减免效果，持续2秒",active_skill = [{500000,3}],add_attr_list = [{1,868},{2,17360},{4,434}],active_cost = [{0,260006,60}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,14) ->
    #child_skill_cfg{sequence = 1,level = 14,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）130%的伤害，20%概率触发主角受到怪物攻击26%伤害减免效果，持续2秒",active_skill = [{500000,3}],add_attr_list = [{1,932},{2,18640},{4,466}],active_cost = [{0,260006,67}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,15) ->
    #child_skill_cfg{sequence = 1,level = 15,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）130%的伤害，20%概率触发主角受到怪物攻击26%伤害减免效果，持续2秒",active_skill = [{500000,3}],add_attr_list = [{1,1000},{2,20000},{4,500}],active_cost = [{0,260006,74}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,16) ->
    #child_skill_cfg{sequence = 1,level = 16,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）140%的伤害，20%概率触发主角受到怪物攻击28%伤害减免效果，持续2秒",active_skill = [{500000,4}],add_attr_list = [{1,1072},{2,21440},{4,536}],active_cost = [{0,260006,81}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,17) ->
    #child_skill_cfg{sequence = 1,level = 17,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）140%的伤害，20%概率触发主角受到怪物攻击28%伤害减免效果，持续2秒",active_skill = [{500000,4}],add_attr_list = [{1,1148},{2,22960},{4,574}],active_cost = [{0,260006,89}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,18) ->
    #child_skill_cfg{sequence = 1,level = 18,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）140%的伤害，20%概率触发主角受到怪物攻击28%伤害减免效果，持续2秒",active_skill = [{500000,4}],add_attr_list = [{1,1228},{2,24560},{4,614}],active_cost = [{0,260006,97}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,19) ->
    #child_skill_cfg{sequence = 1,level = 19,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）140%的伤害，20%概率触发主角受到怪物攻击28%伤害减免效果，持续2秒",active_skill = [{500000,4}],add_attr_list = [{1,1312},{2,26240},{4,656}],active_cost = [{0,260006,105}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,20) ->
    #child_skill_cfg{sequence = 1,level = 20,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）140%的伤害，20%概率触发主角受到怪物攻击28%伤害减免效果，持续2秒",active_skill = [{500000,4}],add_attr_list = [{1,1400},{2,28000},{4,700}],active_cost = [{0,260006,114}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,21) ->
    #child_skill_cfg{sequence = 1,level = 21,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）150%的伤害，20%概率触发主角受到怪物攻击30%伤害减免效果，持续2秒",active_skill = [{500000,5}],add_attr_list = [{1,1492},{2,29840},{4,746}],active_cost = [{0,260006,123}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,22) ->
    #child_skill_cfg{sequence = 1,level = 22,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）150%的伤害，20%概率触发主角受到怪物攻击30%伤害减免效果，持续2秒",active_skill = [{500000,5}],add_attr_list = [{1,1588},{2,31760},{4,794}],active_cost = [{0,260006,133}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,23) ->
    #child_skill_cfg{sequence = 1,level = 23,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）150%的伤害，20%概率触发主角受到怪物攻击30%伤害减免效果，持续2秒",active_skill = [{500000,5}],add_attr_list = [{1,1688},{2,33760},{4,844}],active_cost = [{0,260006,143}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,24) ->
    #child_skill_cfg{sequence = 1,level = 24,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）150%的伤害，20%概率触发主角受到怪物攻击30%伤害减免效果，持续2秒",active_skill = [{500000,5}],add_attr_list = [{1,1792},{2,35840},{4,896}],active_cost = [{0,260006,154}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(1,25) ->
    #child_skill_cfg{sequence = 1,level = 25,skill_name = "丢榔头",skill_desc = "造成（主角攻击10%+宝宝属性）150%的伤害，20%概率触发主角受到怪物攻击30%伤害减免效果，持续2秒",active_skill = [{500000,5}],add_attr_list = [{1,1900},{2,38000},{4,950}],active_cost = [{0,260006,165}],pre_sequence = 0,need_power = 10000};

get_child_skill_cfg(2,1) ->
    #child_skill_cfg{sequence = 2,level = 1,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）150%的伤害，主角25%的几率获得BOSS伤害加成20%，持续5秒",active_skill = [{500001,1}],add_attr_list = [{1,818},{2,16360},{4,409}],active_cost = [{0,260005,5}],pre_sequence = 1,need_power = 130000};

get_child_skill_cfg(2,2) ->
    #child_skill_cfg{sequence = 2,level = 2,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）150%的伤害，主角25%的几率获得BOSS伤害加成20%，持续5秒",active_skill = [{500001,1}],add_attr_list = [{1,842},{2,16840},{4,421}],active_cost = [{0,260006,10}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,3) ->
    #child_skill_cfg{sequence = 2,level = 3,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）150%的伤害，主角25%的几率获得BOSS伤害加成20%，持续5秒",active_skill = [{500001,1}],add_attr_list = [{1,872},{2,17440},{4,436}],active_cost = [{0,260006,15}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,4) ->
    #child_skill_cfg{sequence = 2,level = 4,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）150%的伤害，主角25%的几率获得BOSS伤害加成20%，持续5秒",active_skill = [{500001,1}],add_attr_list = [{1,908},{2,18160},{4,454}],active_cost = [{0,260006,20}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,5) ->
    #child_skill_cfg{sequence = 2,level = 5,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）150%的伤害，主角25%的几率获得BOSS伤害加成20%，持续5秒",active_skill = [{500001,1}],add_attr_list = [{1,950},{2,19000},{4,475}],active_cost = [{0,260006,25}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,6) ->
    #child_skill_cfg{sequence = 2,level = 6,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）160%的伤害，主角25%的几率获得BOSS伤害加成24%，持续5秒",active_skill = [{500001,2}],add_attr_list = [{1,998},{2,19960},{4,499}],active_cost = [{0,260006,31}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,7) ->
    #child_skill_cfg{sequence = 2,level = 7,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）160%的伤害，主角25%的几率获得BOSS伤害加成24%，持续5秒",active_skill = [{500001,2}],add_attr_list = [{1,1052},{2,21040},{4,526}],active_cost = [{0,260006,37}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,8) ->
    #child_skill_cfg{sequence = 2,level = 8,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）160%的伤害，主角25%的几率获得BOSS伤害加成24%，持续5秒",active_skill = [{500001,2}],add_attr_list = [{1,1112},{2,22240},{4,556}],active_cost = [{0,260006,43}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,9) ->
    #child_skill_cfg{sequence = 2,level = 9,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）160%的伤害，主角25%的几率获得BOSS伤害加成24%，持续5秒",active_skill = [{500001,2}],add_attr_list = [{1,1178},{2,23560},{4,589}],active_cost = [{0,260006,49}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,10) ->
    #child_skill_cfg{sequence = 2,level = 10,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）160%的伤害，主角25%的几率获得BOSS伤害加成24%，持续5秒",active_skill = [{500001,2}],add_attr_list = [{1,1250},{2,25000},{4,625}],active_cost = [{0,260006,55}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,11) ->
    #child_skill_cfg{sequence = 2,level = 11,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）170%的伤害，主角25%的几率获得BOSS伤害加成26%，持续5秒",active_skill = [{500001,3}],add_attr_list = [{1,1328},{2,26560},{4,664}],active_cost = [{0,260006,62}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,12) ->
    #child_skill_cfg{sequence = 2,level = 12,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）170%的伤害，主角25%的几率获得BOSS伤害加成26%，持续5秒",active_skill = [{500001,3}],add_attr_list = [{1,1412},{2,28240},{4,706}],active_cost = [{0,260006,69}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,13) ->
    #child_skill_cfg{sequence = 2,level = 13,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）170%的伤害，主角25%的几率获得BOSS伤害加成26%，持续5秒",active_skill = [{500001,3}],add_attr_list = [{1,1502},{2,30040},{4,751}],active_cost = [{0,260006,76}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,14) ->
    #child_skill_cfg{sequence = 2,level = 14,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）170%的伤害，主角25%的几率获得BOSS伤害加成26%，持续5秒",active_skill = [{500001,3}],add_attr_list = [{1,1598},{2,31960},{4,799}],active_cost = [{0,260006,84}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,15) ->
    #child_skill_cfg{sequence = 2,level = 15,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）170%的伤害，主角25%的几率获得BOSS伤害加成26%，持续5秒",active_skill = [{500001,3}],add_attr_list = [{1,1700},{2,34000},{4,850}],active_cost = [{0,260006,92}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,16) ->
    #child_skill_cfg{sequence = 2,level = 16,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）180%的伤害，主角25%的几率获得BOSS伤害加成28%，持续5秒",active_skill = [{500001,4}],add_attr_list = [{1,1808},{2,36160},{4,904}],active_cost = [{0,260006,100}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,17) ->
    #child_skill_cfg{sequence = 2,level = 17,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）180%的伤害，主角25%的几率获得BOSS伤害加成28%，持续5秒",active_skill = [{500001,4}],add_attr_list = [{1,1922},{2,38440},{4,961}],active_cost = [{0,260006,109}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,18) ->
    #child_skill_cfg{sequence = 2,level = 18,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）180%的伤害，主角25%的几率获得BOSS伤害加成28%，持续5秒",active_skill = [{500001,4}],add_attr_list = [{1,2042},{2,40840},{4,1021}],active_cost = [{0,260006,118}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,19) ->
    #child_skill_cfg{sequence = 2,level = 19,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）180%的伤害，主角25%的几率获得BOSS伤害加成28%，持续5秒",active_skill = [{500001,4}],add_attr_list = [{1,2168},{2,43360},{4,1084}],active_cost = [{0,260006,127}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,20) ->
    #child_skill_cfg{sequence = 2,level = 20,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）180%的伤害，主角25%的几率获得BOSS伤害加成28%，持续5秒",active_skill = [{500001,4}],add_attr_list = [{1,2300},{2,46000},{4,1150}],active_cost = [{0,260006,137}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,21) ->
    #child_skill_cfg{sequence = 2,level = 21,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）190%的伤害，主角25%的几率获得BOSS伤害加成30%，持续5秒",active_skill = [{500001,5}],add_attr_list = [{1,2438},{2,48760},{4,1219}],active_cost = [{0,260006,147}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,22) ->
    #child_skill_cfg{sequence = 2,level = 22,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）190%的伤害，主角25%的几率获得BOSS伤害加成30%，持续5秒",active_skill = [{500001,5}],add_attr_list = [{1,2582},{2,51640},{4,1291}],active_cost = [{0,260006,157}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,23) ->
    #child_skill_cfg{sequence = 2,level = 23,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）190%的伤害，主角25%的几率获得BOSS伤害加成30%，持续5秒",active_skill = [{500001,5}],add_attr_list = [{1,2732},{2,54640},{4,1366}],active_cost = [{0,260006,168}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,24) ->
    #child_skill_cfg{sequence = 2,level = 24,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）190%的伤害，主角25%的几率获得BOSS伤害加成30%，持续5秒",active_skill = [{500001,5}],add_attr_list = [{1,2888},{2,57760},{4,1444}],active_cost = [{0,260006,179}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,25) ->
    #child_skill_cfg{sequence = 2,level = 25,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）190%的伤害，主角25%的几率获得BOSS伤害加成30%，持续5秒",active_skill = [{500001,5}],add_attr_list = [{1,3050},{2,61000},{4,1525}],active_cost = [{0,260006,191}],pre_sequence = 1,need_power = 10000};

get_child_skill_cfg(2,26) ->
    #child_skill_cfg{sequence = 2,level = 26,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角25%的几率获得BOSS伤害加成32%，持续5秒",active_skill = [{500001,6}],add_attr_list = [{1,3218},{2,64360},{4,1609}],active_cost = [{0,260006,203}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(2,27) ->
    #child_skill_cfg{sequence = 2,level = 27,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角25%的几率获得BOSS伤害加成32%，持续5秒",active_skill = [{500001,6}],add_attr_list = [{1,3392},{2,67840},{4,1696}],active_cost = [{0,260006,216}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(2,28) ->
    #child_skill_cfg{sequence = 2,level = 28,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角25%的几率获得BOSS伤害加成32%，持续5秒",active_skill = [{500001,6}],add_attr_list = [{1,3572},{2,71440},{4,1786}],active_cost = [{0,260006,229}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(2,29) ->
    #child_skill_cfg{sequence = 2,level = 29,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角25%的几率获得BOSS伤害加成32%，持续5秒",active_skill = [{500001,6}],add_attr_list = [{1,3758},{2,75160},{4,1879}],active_cost = [{0,260006,243}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(2,30) ->
    #child_skill_cfg{sequence = 2,level = 30,skill_name = "强化榔头",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角25%的几率获得BOSS伤害加成32%，持续5秒",active_skill = [{500001,6}],add_attr_list = [{1,3950},{2,79000},{4,1975}],active_cost = [{0,260006,257}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,1) ->
    #child_skill_cfg{sequence = 3,level = 1,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角30%的几率获得20%暴击抵抗，持续5秒",active_skill = [{500002,1}],add_attr_list = [{1,1619},{2,32384},{4,810}],active_cost = [{0,260005,10}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,2) ->
    #child_skill_cfg{sequence = 3,level = 2,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角30%的几率获得20%暴击抵抗，持续5秒",active_skill = [{500002,1}],add_attr_list = [{1,1645},{2,32896},{4,822}],active_cost = [{0,260006,11}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,3) ->
    #child_skill_cfg{sequence = 3,level = 3,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角30%的几率获得20%暴击抵抗，持续5秒",active_skill = [{500002,1}],add_attr_list = [{1,1677},{2,33536},{4,838}],active_cost = [{0,260006,17}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,4) ->
    #child_skill_cfg{sequence = 3,level = 4,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角30%的几率获得20%暴击抵抗，持续5秒",active_skill = [{500002,1}],add_attr_list = [{1,1715},{2,34304},{4,858}],active_cost = [{0,260006,23}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,5) ->
    #child_skill_cfg{sequence = 3,level = 5,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）200%的伤害，主角30%的几率获得20%暴击抵抗，持续5秒",active_skill = [{500002,1}],add_attr_list = [{1,1760},{2,35200},{4,880}],active_cost = [{0,260006,29}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,6) ->
    #child_skill_cfg{sequence = 3,level = 6,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）220%的伤害，主角30%的几率获得22%暴击抵抗，持续5秒",active_skill = [{500002,2}],add_attr_list = [{1,1811},{2,36224},{4,906}],active_cost = [{0,260006,35}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,7) ->
    #child_skill_cfg{sequence = 3,level = 7,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）220%的伤害，主角30%的几率获得22%暴击抵抗，持续5秒",active_skill = [{500002,2}],add_attr_list = [{1,1869},{2,37376},{4,934}],active_cost = [{0,260006,42}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,8) ->
    #child_skill_cfg{sequence = 3,level = 8,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）220%的伤害，主角30%的几率获得22%暴击抵抗，持续5秒",active_skill = [{500002,2}],add_attr_list = [{1,1933},{2,38656},{4,966}],active_cost = [{0,260006,49}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,9) ->
    #child_skill_cfg{sequence = 3,level = 9,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）220%的伤害，主角30%的几率获得22%暴击抵抗，持续5秒",active_skill = [{500002,2}],add_attr_list = [{1,2003},{2,40064},{4,1002}],active_cost = [{0,260006,56}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,10) ->
    #child_skill_cfg{sequence = 3,level = 10,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）220%的伤害，主角30%的几率获得22%暴击抵抗，持续5秒",active_skill = [{500002,2}],add_attr_list = [{1,2080},{2,41600},{4,1040}],active_cost = [{0,260006,63}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,11) ->
    #child_skill_cfg{sequence = 3,level = 11,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）230%的伤害，主角30%的几率获得23%暴击抵抗，持续5秒",active_skill = [{500002,3}],add_attr_list = [{1,2163},{2,43264},{4,1082}],active_cost = [{0,260006,70}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,12) ->
    #child_skill_cfg{sequence = 3,level = 12,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）230%的伤害，主角30%的几率获得23%暴击抵抗，持续5秒",active_skill = [{500002,3}],add_attr_list = [{1,2253},{2,45056},{4,1126}],active_cost = [{0,260006,78}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,13) ->
    #child_skill_cfg{sequence = 3,level = 13,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）230%的伤害，主角30%的几率获得23%暴击抵抗，持续5秒",active_skill = [{500002,3}],add_attr_list = [{1,2349},{2,46976},{4,1174}],active_cost = [{0,260006,86}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,14) ->
    #child_skill_cfg{sequence = 3,level = 14,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）230%的伤害，主角30%的几率获得23%暴击抵抗，持续5秒",active_skill = [{500002,3}],add_attr_list = [{1,2451},{2,49024},{4,1226}],active_cost = [{0,260006,94}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,15) ->
    #child_skill_cfg{sequence = 3,level = 15,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）230%的伤害，主角30%的几率获得23%暴击抵抗，持续5秒",active_skill = [{500002,3}],add_attr_list = [{1,2560},{2,51200},{4,1280}],active_cost = [{0,260006,102}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,16) ->
    #child_skill_cfg{sequence = 3,level = 16,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）240%的伤害，主角30%的几率获得24%暴击抵抗，持续5秒",active_skill = [{500002,4}],add_attr_list = [{1,2675},{2,53504},{4,1338}],active_cost = [{0,260006,111}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,17) ->
    #child_skill_cfg{sequence = 3,level = 17,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）240%的伤害，主角30%的几率获得24%暴击抵抗，持续5秒",active_skill = [{500002,4}],add_attr_list = [{1,2797},{2,55936},{4,1398}],active_cost = [{0,260006,120}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,18) ->
    #child_skill_cfg{sequence = 3,level = 18,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）240%的伤害，主角30%的几率获得24%暴击抵抗，持续5秒",active_skill = [{500002,4}],add_attr_list = [{1,2925},{2,58496},{4,1462}],active_cost = [{0,260006,129}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,19) ->
    #child_skill_cfg{sequence = 3,level = 19,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）240%的伤害，主角30%的几率获得24%暴击抵抗，持续5秒",active_skill = [{500002,4}],add_attr_list = [{1,3059},{2,61184},{4,1530}],active_cost = [{0,260006,138}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,20) ->
    #child_skill_cfg{sequence = 3,level = 20,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）240%的伤害，主角30%的几率获得24%暴击抵抗，持续5秒",active_skill = [{500002,4}],add_attr_list = [{1,3200},{2,64000},{4,1600}],active_cost = [{0,260006,148}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,21) ->
    #child_skill_cfg{sequence = 3,level = 21,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）250%的伤害，主角30%的几率获得25%暴击抵抗，持续5秒",active_skill = [{500002,5}],add_attr_list = [{1,3347},{2,66944},{4,1674}],active_cost = [{0,260006,158}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,22) ->
    #child_skill_cfg{sequence = 3,level = 22,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）250%的伤害，主角30%的几率获得25%暴击抵抗，持续5秒",active_skill = [{500002,5}],add_attr_list = [{1,3501},{2,70016},{4,1750}],active_cost = [{0,260006,168}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,23) ->
    #child_skill_cfg{sequence = 3,level = 23,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）250%的伤害，主角30%的几率获得25%暴击抵抗，持续5秒",active_skill = [{500002,5}],add_attr_list = [{1,3661},{2,73216},{4,1830}],active_cost = [{0,260006,179}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,24) ->
    #child_skill_cfg{sequence = 3,level = 24,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）250%的伤害，主角30%的几率获得25%暴击抵抗，持续5秒",active_skill = [{500002,5}],add_attr_list = [{1,3827},{2,76544},{4,1914}],active_cost = [{0,260006,190}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,25) ->
    #child_skill_cfg{sequence = 3,level = 25,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）250%的伤害，主角30%的几率获得25%暴击抵抗，持续5秒",active_skill = [{500002,5}],add_attr_list = [{1,4000},{2,80000},{4,2000}],active_cost = [{0,260006,201}],pre_sequence = 2,need_power = 10000};

get_child_skill_cfg(3,26) ->
    #child_skill_cfg{sequence = 3,level = 26,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）260%的伤害，主角30%的几率获得26%暴击抵抗，持续5秒",active_skill = [{500002,6}],add_attr_list = [{1,4179},{2,83584},{4,2090}],active_cost = [{0,260006,213}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,27) ->
    #child_skill_cfg{sequence = 3,level = 27,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）260%的伤害，主角30%的几率获得26%暴击抵抗，持续5秒",active_skill = [{500002,6}],add_attr_list = [{1,4365},{2,87296},{4,2182}],active_cost = [{0,260006,225}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,28) ->
    #child_skill_cfg{sequence = 3,level = 28,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）260%的伤害，主角30%的几率获得26%暴击抵抗，持续5秒",active_skill = [{500002,6}],add_attr_list = [{1,4557},{2,91136},{4,2278}],active_cost = [{0,260006,237}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,29) ->
    #child_skill_cfg{sequence = 3,level = 29,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）260%的伤害，主角30%的几率获得26%暴击抵抗，持续5秒",active_skill = [{500002,6}],add_attr_list = [{1,4755},{2,95104},{4,2378}],active_cost = [{0,260006,250}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,30) ->
    #child_skill_cfg{sequence = 3,level = 30,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）260%的伤害，主角30%的几率获得26%暴击抵抗，持续5秒",active_skill = [{500002,6}],add_attr_list = [{1,4960},{2,99200},{4,2480}],active_cost = [{0,260006,263}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,31) ->
    #child_skill_cfg{sequence = 3,level = 31,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）270%的伤害，主角30%的几率获得27%暴击抵抗，持续5秒",active_skill = [{500002,7}],add_attr_list = [{1,5171},{2,103424},{4,2586}],active_cost = [{0,260006,276}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,32) ->
    #child_skill_cfg{sequence = 3,level = 32,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）270%的伤害，主角30%的几率获得27%暴击抵抗，持续5秒",active_skill = [{500002,7}],add_attr_list = [{1,5389},{2,107776},{4,2694}],active_cost = [{0,260006,290}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,33) ->
    #child_skill_cfg{sequence = 3,level = 33,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）270%的伤害，主角30%的几率获得27%暴击抵抗，持续5秒",active_skill = [{500002,7}],add_attr_list = [{1,5613},{2,112256},{4,2806}],active_cost = [{0,260006,304}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,34) ->
    #child_skill_cfg{sequence = 3,level = 34,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）270%的伤害，主角30%的几率获得27%暴击抵抗，持续5秒",active_skill = [{500002,7}],add_attr_list = [{1,5843},{2,116864},{4,2922}],active_cost = [{0,260006,319}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,35) ->
    #child_skill_cfg{sequence = 3,level = 35,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）270%的伤害，主角30%的几率获得27%暴击抵抗，持续5秒",active_skill = [{500002,7}],add_attr_list = [{1,6080},{2,121600},{4,3040}],active_cost = [{0,260006,334}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,36) ->
    #child_skill_cfg{sequence = 3,level = 36,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）280%的伤害，主角30%的几率获得28%暴击抵抗，持续5秒",active_skill = [{500002,8}],add_attr_list = [{1,6323},{2,126464},{4,3162}],active_cost = [{0,260006,350}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,37) ->
    #child_skill_cfg{sequence = 3,level = 37,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）280%的伤害，主角30%的几率获得28%暴击抵抗，持续5秒",active_skill = [{500002,8}],add_attr_list = [{1,6573},{2,131456},{4,3286}],active_cost = [{0,260006,366}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,38) ->
    #child_skill_cfg{sequence = 3,level = 38,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）280%的伤害，主角30%的几率获得28%暴击抵抗，持续5秒",active_skill = [{500002,8}],add_attr_list = [{1,6829},{2,136576},{4,3414}],active_cost = [{0,260006,382}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,39) ->
    #child_skill_cfg{sequence = 3,level = 39,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）280%的伤害，主角30%的几率获得28%暴击抵抗，持续5秒",active_skill = [{500002,8}],add_attr_list = [{1,7091},{2,141824},{4,3546}],active_cost = [{0,260006,399}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(3,40) ->
    #child_skill_cfg{sequence = 3,level = 40,skill_name = "次元锤击",skill_desc = "对前方敌人造成（主角攻击10%+宝宝属性）280%的伤害，主角30%的几率获得28%暴击抵抗，持续5秒",active_skill = [{500002,8}],add_attr_list = [{1,7360},{2,147200},{4,3680}],active_cost = [{0,260006,416}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,1) ->
    #child_skill_cfg{sequence = 4,level = 1,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限50%的生命，持续5秒",active_skill = [{500003,1}],add_attr_list = [{1,2021},{2,40420},{4,1011}],active_cost = [{0,260005,12}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,2) ->
    #child_skill_cfg{sequence = 4,level = 2,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限50%的生命，持续5秒",active_skill = [{500003,1}],add_attr_list = [{1,2049},{2,40980},{4,1025}],active_cost = [{0,260006,12}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,3) ->
    #child_skill_cfg{sequence = 4,level = 3,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限50%的生命，持续5秒",active_skill = [{500003,1}],add_attr_list = [{1,2084},{2,41680},{4,1042}],active_cost = [{0,260006,19}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,4) ->
    #child_skill_cfg{sequence = 4,level = 4,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限50%的生命，持续5秒",active_skill = [{500003,1}],add_attr_list = [{1,2126},{2,42520},{4,1063}],active_cost = [{0,260006,26}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,5) ->
    #child_skill_cfg{sequence = 4,level = 5,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限50%的生命，持续5秒",active_skill = [{500003,1}],add_attr_list = [{1,2175},{2,43500},{4,1088}],active_cost = [{0,260006,33}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,6) ->
    #child_skill_cfg{sequence = 4,level = 6,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限60%的生命，持续5秒",active_skill = [{500003,2}],add_attr_list = [{1,2231},{2,44620},{4,1116}],active_cost = [{0,260006,40}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,7) ->
    #child_skill_cfg{sequence = 4,level = 7,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限60%的生命，持续5秒",active_skill = [{500003,2}],add_attr_list = [{1,2294},{2,45880},{4,1147}],active_cost = [{0,260006,48}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,8) ->
    #child_skill_cfg{sequence = 4,level = 8,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限60%的生命，持续5秒",active_skill = [{500003,2}],add_attr_list = [{1,2364},{2,47280},{4,1182}],active_cost = [{0,260006,56}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,9) ->
    #child_skill_cfg{sequence = 4,level = 9,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限60%的生命，持续5秒",active_skill = [{500003,2}],add_attr_list = [{1,2441},{2,48820},{4,1221}],active_cost = [{0,260006,64}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,10) ->
    #child_skill_cfg{sequence = 4,level = 10,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限60%的生命，持续5秒",active_skill = [{500003,2}],add_attr_list = [{1,2525},{2,50500},{4,1263}],active_cost = [{0,260006,72}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,11) ->
    #child_skill_cfg{sequence = 4,level = 11,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限70%的生命，持续5秒",active_skill = [{500003,3}],add_attr_list = [{1,2616},{2,52320},{4,1308}],active_cost = [{0,260006,80}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,12) ->
    #child_skill_cfg{sequence = 4,level = 12,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限70%的生命，持续5秒",active_skill = [{500003,3}],add_attr_list = [{1,2714},{2,54280},{4,1357}],active_cost = [{0,260006,89}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,13) ->
    #child_skill_cfg{sequence = 4,level = 13,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限70%的生命，持续5秒",active_skill = [{500003,3}],add_attr_list = [{1,2819},{2,56380},{4,1410}],active_cost = [{0,260006,98}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,14) ->
    #child_skill_cfg{sequence = 4,level = 14,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限70%的生命，持续5秒",active_skill = [{500003,3}],add_attr_list = [{1,2931},{2,58620},{4,1466}],active_cost = [{0,260006,107}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,15) ->
    #child_skill_cfg{sequence = 4,level = 15,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限70%的生命，持续5秒",active_skill = [{500003,3}],add_attr_list = [{1,3050},{2,61000},{4,1525}],active_cost = [{0,260006,116}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,16) ->
    #child_skill_cfg{sequence = 4,level = 16,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限80%的生命，持续5秒",active_skill = [{500003,4}],add_attr_list = [{1,3176},{2,63520},{4,1588}],active_cost = [{0,260006,125}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,17) ->
    #child_skill_cfg{sequence = 4,level = 17,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限80%的生命，持续5秒",active_skill = [{500003,4}],add_attr_list = [{1,3309},{2,66180},{4,1655}],active_cost = [{0,260006,135}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,18) ->
    #child_skill_cfg{sequence = 4,level = 18,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限80%的生命，持续5秒",active_skill = [{500003,4}],add_attr_list = [{1,3449},{2,68980},{4,1725}],active_cost = [{0,260006,145}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,19) ->
    #child_skill_cfg{sequence = 4,level = 19,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限80%的生命，持续5秒",active_skill = [{500003,4}],add_attr_list = [{1,3596},{2,71920},{4,1798}],active_cost = [{0,260006,155}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,20) ->
    #child_skill_cfg{sequence = 4,level = 20,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限80%的生命，持续5秒",active_skill = [{500003,4}],add_attr_list = [{1,3750},{2,75000},{4,1875}],active_cost = [{0,260006,165}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,21) ->
    #child_skill_cfg{sequence = 4,level = 21,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限90%的生命，持续5秒",active_skill = [{500003,5}],add_attr_list = [{1,3911},{2,78220},{4,1956}],active_cost = [{0,260006,176}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,22) ->
    #child_skill_cfg{sequence = 4,level = 22,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限90%的生命，持续5秒",active_skill = [{500003,5}],add_attr_list = [{1,4079},{2,81580},{4,2040}],active_cost = [{0,260006,187}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,23) ->
    #child_skill_cfg{sequence = 4,level = 23,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限90%的生命，持续5秒",active_skill = [{500003,5}],add_attr_list = [{1,4254},{2,85080},{4,2127}],active_cost = [{0,260006,198}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,24) ->
    #child_skill_cfg{sequence = 4,level = 24,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限90%的生命，持续5秒",active_skill = [{500003,5}],add_attr_list = [{1,4436},{2,88720},{4,2218}],active_cost = [{0,260006,209}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,25) ->
    #child_skill_cfg{sequence = 4,level = 25,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限90%的生命，持续5秒",active_skill = [{500003,5}],add_attr_list = [{1,4625},{2,92500},{4,2313}],active_cost = [{0,260006,221}],pre_sequence = 3,need_power = 10000};

get_child_skill_cfg(4,26) ->
    #child_skill_cfg{sequence = 4,level = 26,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限100%的生命，持续5秒",active_skill = [{500003,6}],add_attr_list = [{1,4821},{2,96420},{4,2411}],active_cost = [{0,260006,233}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,27) ->
    #child_skill_cfg{sequence = 4,level = 27,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限100%的生命，持续5秒",active_skill = [{500003,6}],add_attr_list = [{1,5024},{2,100480},{4,2512}],active_cost = [{0,260006,245}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,28) ->
    #child_skill_cfg{sequence = 4,level = 28,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限100%的生命，持续5秒",active_skill = [{500003,6}],add_attr_list = [{1,5234},{2,104680},{4,2617}],active_cost = [{0,260006,258}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,29) ->
    #child_skill_cfg{sequence = 4,level = 29,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限100%的生命，持续5秒",active_skill = [{500003,6}],add_attr_list = [{1,5451},{2,109020},{4,2726}],active_cost = [{0,260006,271}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,30) ->
    #child_skill_cfg{sequence = 4,level = 30,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限100%的生命，持续5秒",active_skill = [{500003,6}],add_attr_list = [{1,5675},{2,113500},{4,2838}],active_cost = [{0,260006,284}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,31) ->
    #child_skill_cfg{sequence = 4,level = 31,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限110%的生命，持续5秒",active_skill = [{500003,7}],add_attr_list = [{1,5906},{2,118120},{4,2953}],active_cost = [{0,260006,298}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,32) ->
    #child_skill_cfg{sequence = 4,level = 32,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限110%的生命，持续5秒",active_skill = [{500003,7}],add_attr_list = [{1,6144},{2,122880},{4,3072}],active_cost = [{0,260006,312}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,33) ->
    #child_skill_cfg{sequence = 4,level = 33,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限110%的生命，持续5秒",active_skill = [{500003,7}],add_attr_list = [{1,6389},{2,127780},{4,3195}],active_cost = [{0,260006,326}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,34) ->
    #child_skill_cfg{sequence = 4,level = 34,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限110%的生命，持续5秒",active_skill = [{500003,7}],add_attr_list = [{1,6641},{2,132820},{4,3321}],active_cost = [{0,260006,341}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,35) ->
    #child_skill_cfg{sequence = 4,level = 35,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限110%的生命，持续5秒",active_skill = [{500003,7}],add_attr_list = [{1,6900},{2,138000},{4,3450}],active_cost = [{0,260006,356}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,36) ->
    #child_skill_cfg{sequence = 4,level = 36,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限120%的生命，持续5秒",active_skill = [{500003,8}],add_attr_list = [{1,7166},{2,143320},{4,3583}],active_cost = [{0,260006,371}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,37) ->
    #child_skill_cfg{sequence = 4,level = 37,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限120%的生命，持续5秒",active_skill = [{500003,8}],add_attr_list = [{1,7439},{2,148780},{4,3720}],active_cost = [{0,260006,387}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,38) ->
    #child_skill_cfg{sequence = 4,level = 38,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限120%的生命，持续5秒",active_skill = [{500003,8}],add_attr_list = [{1,7719},{2,154380},{4,3860}],active_cost = [{0,260006,403}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,39) ->
    #child_skill_cfg{sequence = 4,level = 39,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限120%的生命，持续5秒",active_skill = [{500003,8}],add_attr_list = [{1,8006},{2,160120},{4,4003}],active_cost = [{0,260006,420}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,40) ->
    #child_skill_cfg{sequence = 4,level = 40,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限120%的生命，持续5秒",active_skill = [{500003,8}],add_attr_list = [{1,8300},{2,166000},{4,4150}],active_cost = [{0,260006,437}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,41) ->
    #child_skill_cfg{sequence = 4,level = 41,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限130%的生命，持续5秒",active_skill = [{500003,9}],add_attr_list = [{1,8601},{2,172020},{4,4301}],active_cost = [{0,260006,454}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,42) ->
    #child_skill_cfg{sequence = 4,level = 42,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限130%的生命，持续5秒",active_skill = [{500003,9}],add_attr_list = [{1,8909},{2,178180},{4,4455}],active_cost = [{0,260006,472}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,43) ->
    #child_skill_cfg{sequence = 4,level = 43,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限130%的生命，持续5秒",active_skill = [{500003,9}],add_attr_list = [{1,9224},{2,184480},{4,4612}],active_cost = [{0,260006,490}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,44) ->
    #child_skill_cfg{sequence = 4,level = 44,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限130%的生命，持续5秒",active_skill = [{500003,9}],add_attr_list = [{1,9546},{2,190920},{4,4773}],active_cost = [{0,260006,509}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,45) ->
    #child_skill_cfg{sequence = 4,level = 45,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限130%的生命，持续5秒",active_skill = [{500003,9}],add_attr_list = [{1,9875},{2,197500},{4,4938}],active_cost = [{0,260006,528}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,46) ->
    #child_skill_cfg{sequence = 4,level = 46,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限140%的生命，持续5秒",active_skill = [{500003,10}],add_attr_list = [{1,10211},{2,204220},{4,5106}],active_cost = [{0,260006,548}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,47) ->
    #child_skill_cfg{sequence = 4,level = 47,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限140%的生命，持续5秒",active_skill = [{500003,10}],add_attr_list = [{1,10554},{2,211080},{4,5277}],active_cost = [{0,260006,568}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,48) ->
    #child_skill_cfg{sequence = 4,level = 48,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限140%的生命，持续5秒",active_skill = [{500003,10}],add_attr_list = [{1,10904},{2,218080},{4,5452}],active_cost = [{0,260006,589}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,49) ->
    #child_skill_cfg{sequence = 4,level = 49,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限140%的生命，持续5秒",active_skill = [{500003,10}],add_attr_list = [{1,11261},{2,225220},{4,5631}],active_cost = [{0,260006,610}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(4,50) ->
    #child_skill_cfg{sequence = 4,level = 50,skill_name = "亲爱的你呀",skill_desc = "在目标范围内召唤图腾，每秒为队友回复宝宝上限140%的生命，持续5秒",active_skill = [{500003,10}],add_attr_list = [{1,11625},{2,232500},{4,5813}],active_cost = [{0,260006,632}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,1) ->
    #child_skill_cfg{sequence = 5,level = 1,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得10%的会心几率（不可叠加），持续5秒",active_skill = [{500011,1}],add_attr_list = [{1,2423},{2,48456},{4,1211}],active_cost = [{0,260005,15}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,2) ->
    #child_skill_cfg{sequence = 5,level = 2,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得10%的会心几率（不可叠加），持续5秒",active_skill = [{500011,1}],add_attr_list = [{1,2453},{2,49064},{4,1227}],active_cost = [{0,260006,13}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,3) ->
    #child_skill_cfg{sequence = 5,level = 3,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得10%的会心几率（不可叠加），持续5秒",active_skill = [{500011,1}],add_attr_list = [{1,2491},{2,49824},{4,1246}],active_cost = [{0,260006,21}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,4) ->
    #child_skill_cfg{sequence = 5,level = 4,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得10%的会心几率（不可叠加），持续5秒",active_skill = [{500011,1}],add_attr_list = [{1,2537},{2,50736},{4,1268}],active_cost = [{0,260006,29}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,5) ->
    #child_skill_cfg{sequence = 5,level = 5,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得10%的会心几率（不可叠加），持续5秒",active_skill = [{500011,1}],add_attr_list = [{1,2590},{2,51800},{4,1295}],active_cost = [{0,260006,37}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,6) ->
    #child_skill_cfg{sequence = 5,level = 6,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得12%的会心几率（不可叠加），持续5秒",active_skill = [{500011,2}],add_attr_list = [{1,2651},{2,53016},{4,1325}],active_cost = [{0,260006,45}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,7) ->
    #child_skill_cfg{sequence = 5,level = 7,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得12%的会心几率（不可叠加），持续5秒",active_skill = [{500011,2}],add_attr_list = [{1,2719},{2,54384},{4,1360}],active_cost = [{0,260006,53}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,8) ->
    #child_skill_cfg{sequence = 5,level = 8,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得12%的会心几率（不可叠加），持续5秒",active_skill = [{500011,2}],add_attr_list = [{1,2795},{2,55904},{4,1398}],active_cost = [{0,260006,62}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,9) ->
    #child_skill_cfg{sequence = 5,level = 9,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得12%的会心几率（不可叠加），持续5秒",active_skill = [{500011,2}],add_attr_list = [{1,2879},{2,57576},{4,1439}],active_cost = [{0,260006,71}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,10) ->
    #child_skill_cfg{sequence = 5,level = 10,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得12%的会心几率（不可叠加），持续5秒",active_skill = [{500011,2}],add_attr_list = [{1,2970},{2,59400},{4,1485}],active_cost = [{0,260006,80}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,11) ->
    #child_skill_cfg{sequence = 5,level = 11,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得13%的会心几率（不可叠加），持续5秒",active_skill = [{500011,3}],add_attr_list = [{1,3069},{2,61376},{4,1534}],active_cost = [{0,260006,89}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,12) ->
    #child_skill_cfg{sequence = 5,level = 12,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得13%的会心几率（不可叠加），持续5秒",active_skill = [{500011,3}],add_attr_list = [{1,3175},{2,63504},{4,1588}],active_cost = [{0,260006,98}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,13) ->
    #child_skill_cfg{sequence = 5,level = 13,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得13%的会心几率（不可叠加），持续5秒",active_skill = [{500011,3}],add_attr_list = [{1,3289},{2,65784},{4,1645}],active_cost = [{0,260006,107}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,14) ->
    #child_skill_cfg{sequence = 5,level = 14,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得13%的会心几率（不可叠加），持续5秒",active_skill = [{500011,3}],add_attr_list = [{1,3411},{2,68216},{4,1705}],active_cost = [{0,260006,117}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,15) ->
    #child_skill_cfg{sequence = 5,level = 15,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得13%的会心几率（不可叠加），持续5秒",active_skill = [{500011,3}],add_attr_list = [{1,3540},{2,70800},{4,1770}],active_cost = [{0,260006,127}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,16) ->
    #child_skill_cfg{sequence = 5,level = 16,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得14%的会心几率（不可叠加），持续5秒",active_skill = [{500011,4}],add_attr_list = [{1,3677},{2,73536},{4,1838}],active_cost = [{0,260006,137}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,17) ->
    #child_skill_cfg{sequence = 5,level = 17,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得14%的会心几率（不可叠加），持续5秒",active_skill = [{500011,4}],add_attr_list = [{1,3821},{2,76424},{4,1911}],active_cost = [{0,260006,147}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,18) ->
    #child_skill_cfg{sequence = 5,level = 18,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得14%的会心几率（不可叠加），持续5秒",active_skill = [{500011,4}],add_attr_list = [{1,3973},{2,79464},{4,1987}],active_cost = [{0,260006,157}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,19) ->
    #child_skill_cfg{sequence = 5,level = 19,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得14%的会心几率（不可叠加），持续5秒",active_skill = [{500011,4}],add_attr_list = [{1,4133},{2,82656},{4,2066}],active_cost = [{0,260006,168}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,20) ->
    #child_skill_cfg{sequence = 5,level = 20,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得14%的会心几率（不可叠加），持续5秒",active_skill = [{500011,4}],add_attr_list = [{1,4300},{2,86000},{4,2150}],active_cost = [{0,260006,179}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,21) ->
    #child_skill_cfg{sequence = 5,level = 21,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得15%的会心几率（不可叠加），持续5秒",active_skill = [{500011,5}],add_attr_list = [{1,4475},{2,89496},{4,2237}],active_cost = [{0,260006,190}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,22) ->
    #child_skill_cfg{sequence = 5,level = 22,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得15%的会心几率（不可叠加），持续5秒",active_skill = [{500011,5}],add_attr_list = [{1,4657},{2,93144},{4,2329}],active_cost = [{0,260006,201}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,23) ->
    #child_skill_cfg{sequence = 5,level = 23,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得15%的会心几率（不可叠加），持续5秒",active_skill = [{500011,5}],add_attr_list = [{1,4847},{2,96944},{4,2424}],active_cost = [{0,260006,213}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,24) ->
    #child_skill_cfg{sequence = 5,level = 24,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得15%的会心几率（不可叠加），持续5秒",active_skill = [{500011,5}],add_attr_list = [{1,5045},{2,100896},{4,2522}],active_cost = [{0,260006,225}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,25) ->
    #child_skill_cfg{sequence = 5,level = 25,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得15%的会心几率（不可叠加），持续5秒",active_skill = [{500011,5}],add_attr_list = [{1,5250},{2,105000},{4,2625}],active_cost = [{0,260006,237}],pre_sequence = 4,need_power = 10000};

get_child_skill_cfg(5,26) ->
    #child_skill_cfg{sequence = 5,level = 26,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得16%的会心几率（不可叠加），持续5秒",active_skill = [{500011,6}],add_attr_list = [{1,5463},{2,109256},{4,2731}],active_cost = [{0,260006,249}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,27) ->
    #child_skill_cfg{sequence = 5,level = 27,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得16%的会心几率（不可叠加），持续5秒",active_skill = [{500011,6}],add_attr_list = [{1,5683},{2,113664},{4,2842}],active_cost = [{0,260006,261}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,28) ->
    #child_skill_cfg{sequence = 5,level = 28,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得16%的会心几率（不可叠加），持续5秒",active_skill = [{500011,6}],add_attr_list = [{1,5911},{2,118224},{4,2956}],active_cost = [{0,260006,274}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,29) ->
    #child_skill_cfg{sequence = 5,level = 29,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得16%的会心几率（不可叠加），持续5秒",active_skill = [{500011,6}],add_attr_list = [{1,6147},{2,122936},{4,3073}],active_cost = [{0,260006,287}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,30) ->
    #child_skill_cfg{sequence = 5,level = 30,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得16%的会心几率（不可叠加），持续5秒",active_skill = [{500011,6}],add_attr_list = [{1,6390},{2,127800},{4,3195}],active_cost = [{0,260006,300}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,31) ->
    #child_skill_cfg{sequence = 5,level = 31,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得17%的会心几率（不可叠加），持续5秒",active_skill = [{500011,7}],add_attr_list = [{1,6641},{2,132816},{4,3320}],active_cost = [{0,260006,314}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,32) ->
    #child_skill_cfg{sequence = 5,level = 32,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得17%的会心几率（不可叠加），持续5秒",active_skill = [{500011,7}],add_attr_list = [{1,6899},{2,137984},{4,3450}],active_cost = [{0,260006,328}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,33) ->
    #child_skill_cfg{sequence = 5,level = 33,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得17%的会心几率（不可叠加），持续5秒",active_skill = [{500011,7}],add_attr_list = [{1,7165},{2,143304},{4,3583}],active_cost = [{0,260006,342}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,34) ->
    #child_skill_cfg{sequence = 5,level = 34,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得17%的会心几率（不可叠加），持续5秒",active_skill = [{500011,7}],add_attr_list = [{1,7439},{2,148776},{4,3719}],active_cost = [{0,260006,356}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,35) ->
    #child_skill_cfg{sequence = 5,level = 35,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得17%的会心几率（不可叠加），持续5秒",active_skill = [{500011,7}],add_attr_list = [{1,7720},{2,154400},{4,3860}],active_cost = [{0,260006,371}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,36) ->
    #child_skill_cfg{sequence = 5,level = 36,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得18%的会心几率（不可叠加），持续5秒",active_skill = [{500011,8}],add_attr_list = [{1,8009},{2,160176},{4,4004}],active_cost = [{0,260006,386}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,37) ->
    #child_skill_cfg{sequence = 5,level = 37,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得18%的会心几率（不可叠加），持续5秒",active_skill = [{500011,8}],add_attr_list = [{1,8305},{2,166104},{4,4153}],active_cost = [{0,260006,401}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,38) ->
    #child_skill_cfg{sequence = 5,level = 38,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得18%的会心几率（不可叠加），持续5秒",active_skill = [{500011,8}],add_attr_list = [{1,8609},{2,172184},{4,4305}],active_cost = [{0,260006,417}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,39) ->
    #child_skill_cfg{sequence = 5,level = 39,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得18%的会心几率（不可叠加），持续5秒",active_skill = [{500011,8}],add_attr_list = [{1,8921},{2,178416},{4,4460}],active_cost = [{0,260006,433}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,40) ->
    #child_skill_cfg{sequence = 5,level = 40,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得18%的会心几率（不可叠加），持续5秒",active_skill = [{500011,8}],add_attr_list = [{1,9240},{2,184800},{4,4620}],active_cost = [{0,260006,449}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,41) ->
    #child_skill_cfg{sequence = 5,level = 41,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得19%的会心几率（不可叠加），持续5秒",active_skill = [{500011,9}],add_attr_list = [{1,9567},{2,191336},{4,4783}],active_cost = [{0,260006,465}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,42) ->
    #child_skill_cfg{sequence = 5,level = 42,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得19%的会心几率（不可叠加），持续5秒",active_skill = [{500011,9}],add_attr_list = [{1,9901},{2,198024},{4,4951}],active_cost = [{0,260006,482}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,43) ->
    #child_skill_cfg{sequence = 5,level = 43,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得19%的会心几率（不可叠加），持续5秒",active_skill = [{500011,9}],add_attr_list = [{1,10243},{2,204864},{4,5122}],active_cost = [{0,260006,499}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,44) ->
    #child_skill_cfg{sequence = 5,level = 44,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得19%的会心几率（不可叠加），持续5秒",active_skill = [{500011,9}],add_attr_list = [{1,10593},{2,211856},{4,5296}],active_cost = [{0,260006,516}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,45) ->
    #child_skill_cfg{sequence = 5,level = 45,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得19%的会心几率（不可叠加），持续5秒",active_skill = [{500011,9}],add_attr_list = [{1,10950},{2,219000},{4,5475}],active_cost = [{0,260006,534}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,46) ->
    #child_skill_cfg{sequence = 5,level = 46,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得20%的会心几率（不可叠加），持续5秒",active_skill = [{500011,10}],add_attr_list = [{1,11315},{2,226296},{4,5657}],active_cost = [{0,260006,552}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,47) ->
    #child_skill_cfg{sequence = 5,level = 47,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得20%的会心几率（不可叠加），持续5秒",active_skill = [{500011,10}],add_attr_list = [{1,11687},{2,233744},{4,5844}],active_cost = [{0,260006,571}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,48) ->
    #child_skill_cfg{sequence = 5,level = 48,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得20%的会心几率（不可叠加），持续5秒",active_skill = [{500011,10}],add_attr_list = [{1,12067},{2,241344},{4,6034}],active_cost = [{0,260006,590}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,49) ->
    #child_skill_cfg{sequence = 5,level = 49,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得20%的会心几率（不可叠加），持续5秒",active_skill = [{500011,10}],add_attr_list = [{1,12455},{2,249096},{4,6227}],active_cost = [{0,260006,609}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(5,50) ->
    #child_skill_cfg{sequence = 5,level = 50,skill_name = "糖果满载",skill_desc = "主角击败敌方玩家后获得宝宝的敬仰，获得20%的会心几率（不可叠加），持续5秒",active_skill = [{500011,10}],add_attr_list = [{1,12850},{2,257000},{4,6425}],active_cost = [{0,260006,629}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,1) ->
    #child_skill_cfg{sequence = 6,level = 1,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有20%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,1}],add_attr_list = [{1,3224},{2,64480},{4,1612}],active_cost = [{0,260005,20}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,2) ->
    #child_skill_cfg{sequence = 6,level = 2,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有20%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,1}],add_attr_list = [{1,3256},{2,65120},{4,1628}],active_cost = [{0,260006,14}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,3) ->
    #child_skill_cfg{sequence = 6,level = 3,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有20%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,1}],add_attr_list = [{1,3296},{2,65920},{4,1648}],active_cost = [{0,260006,23}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,4) ->
    #child_skill_cfg{sequence = 6,level = 4,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有20%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,1}],add_attr_list = [{1,3344},{2,66880},{4,1672}],active_cost = [{0,260006,32}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,5) ->
    #child_skill_cfg{sequence = 6,level = 5,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有20%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,1}],add_attr_list = [{1,3400},{2,68000},{4,1700}],active_cost = [{0,260006,41}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,6) ->
    #child_skill_cfg{sequence = 6,level = 6,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有22%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,2}],add_attr_list = [{1,3464},{2,69280},{4,1732}],active_cost = [{0,260006,50}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,7) ->
    #child_skill_cfg{sequence = 6,level = 7,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有22%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,2}],add_attr_list = [{1,3536},{2,70720},{4,1768}],active_cost = [{0,260006,60}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,8) ->
    #child_skill_cfg{sequence = 6,level = 8,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有22%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,2}],add_attr_list = [{1,3616},{2,72320},{4,1808}],active_cost = [{0,260006,70}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,9) ->
    #child_skill_cfg{sequence = 6,level = 9,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有22%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,2}],add_attr_list = [{1,3704},{2,74080},{4,1852}],active_cost = [{0,260006,80}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,10) ->
    #child_skill_cfg{sequence = 6,level = 10,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有22%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,2}],add_attr_list = [{1,3800},{2,76000},{4,1900}],active_cost = [{0,260006,90}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,11) ->
    #child_skill_cfg{sequence = 6,level = 11,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有24%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,3}],add_attr_list = [{1,3904},{2,78080},{4,1952}],active_cost = [{0,260006,100}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,12) ->
    #child_skill_cfg{sequence = 6,level = 12,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有24%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,3}],add_attr_list = [{1,4016},{2,80320},{4,2008}],active_cost = [{0,260006,111}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,13) ->
    #child_skill_cfg{sequence = 6,level = 13,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有24%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,3}],add_attr_list = [{1,4136},{2,82720},{4,2068}],active_cost = [{0,260006,122}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,14) ->
    #child_skill_cfg{sequence = 6,level = 14,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有24%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,3}],add_attr_list = [{1,4264},{2,85280},{4,2132}],active_cost = [{0,260006,133}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,15) ->
    #child_skill_cfg{sequence = 6,level = 15,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有24%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,3}],add_attr_list = [{1,4400},{2,88000},{4,2200}],active_cost = [{0,260006,144}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,16) ->
    #child_skill_cfg{sequence = 6,level = 16,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有26%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,4}],add_attr_list = [{1,4544},{2,90880},{4,2272}],active_cost = [{0,260006,155}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,17) ->
    #child_skill_cfg{sequence = 6,level = 17,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有26%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,4}],add_attr_list = [{1,4696},{2,93920},{4,2348}],active_cost = [{0,260006,167}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,18) ->
    #child_skill_cfg{sequence = 6,level = 18,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有26%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,4}],add_attr_list = [{1,4856},{2,97120},{4,2428}],active_cost = [{0,260006,179}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,19) ->
    #child_skill_cfg{sequence = 6,level = 19,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有26%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,4}],add_attr_list = [{1,5024},{2,100480},{4,2512}],active_cost = [{0,260006,191}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,20) ->
    #child_skill_cfg{sequence = 6,level = 20,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有26%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,4}],add_attr_list = [{1,5200},{2,104000},{4,2600}],active_cost = [{0,260006,203}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,21) ->
    #child_skill_cfg{sequence = 6,level = 21,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有28%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,5}],add_attr_list = [{1,5384},{2,107680},{4,2692}],active_cost = [{0,260006,216}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,22) ->
    #child_skill_cfg{sequence = 6,level = 22,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有28%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,5}],add_attr_list = [{1,5576},{2,111520},{4,2788}],active_cost = [{0,260006,229}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,23) ->
    #child_skill_cfg{sequence = 6,level = 23,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有28%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,5}],add_attr_list = [{1,5776},{2,115520},{4,2888}],active_cost = [{0,260006,242}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,24) ->
    #child_skill_cfg{sequence = 6,level = 24,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有28%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,5}],add_attr_list = [{1,5984},{2,119680},{4,2992}],active_cost = [{0,260006,255}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,25) ->
    #child_skill_cfg{sequence = 6,level = 25,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有28%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,5}],add_attr_list = [{1,6200},{2,124000},{4,3100}],active_cost = [{0,260006,269}],pre_sequence = 5,need_power = 10000};

get_child_skill_cfg(6,26) ->
    #child_skill_cfg{sequence = 6,level = 26,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有30%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,6}],add_attr_list = [{1,6424},{2,128480},{4,3212}],active_cost = [{0,260006,283}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,27) ->
    #child_skill_cfg{sequence = 6,level = 27,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有30%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,6}],add_attr_list = [{1,6656},{2,133120},{4,3328}],active_cost = [{0,260006,297}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,28) ->
    #child_skill_cfg{sequence = 6,level = 28,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有30%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,6}],add_attr_list = [{1,6896},{2,137920},{4,3448}],active_cost = [{0,260006,311}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,29) ->
    #child_skill_cfg{sequence = 6,level = 29,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有30%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,6}],add_attr_list = [{1,7144},{2,142880},{4,3572}],active_cost = [{0,260006,326}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,30) ->
    #child_skill_cfg{sequence = 6,level = 30,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有30%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,6}],add_attr_list = [{1,7400},{2,148000},{4,3700}],active_cost = [{0,260006,341}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,31) ->
    #child_skill_cfg{sequence = 6,level = 31,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有32%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,7}],add_attr_list = [{1,7664},{2,153280},{4,3832}],active_cost = [{0,260006,356}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,32) ->
    #child_skill_cfg{sequence = 6,level = 32,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有32%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,7}],add_attr_list = [{1,7936},{2,158720},{4,3968}],active_cost = [{0,260006,372}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,33) ->
    #child_skill_cfg{sequence = 6,level = 33,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有32%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,7}],add_attr_list = [{1,8216},{2,164320},{4,4108}],active_cost = [{0,260006,388}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,34) ->
    #child_skill_cfg{sequence = 6,level = 34,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有32%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,7}],add_attr_list = [{1,8504},{2,170080},{4,4252}],active_cost = [{0,260006,404}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,35) ->
    #child_skill_cfg{sequence = 6,level = 35,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有32%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,7}],add_attr_list = [{1,8800},{2,176000},{4,4400}],active_cost = [{0,260006,421}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,36) ->
    #child_skill_cfg{sequence = 6,level = 36,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有34%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,8}],add_attr_list = [{1,9104},{2,182080},{4,4552}],active_cost = [{0,260006,438}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,37) ->
    #child_skill_cfg{sequence = 6,level = 37,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有34%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,8}],add_attr_list = [{1,9416},{2,188320},{4,4708}],active_cost = [{0,260006,455}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,38) ->
    #child_skill_cfg{sequence = 6,level = 38,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有34%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,8}],add_attr_list = [{1,9736},{2,194720},{4,4868}],active_cost = [{0,260006,473}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,39) ->
    #child_skill_cfg{sequence = 6,level = 39,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有34%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,8}],add_attr_list = [{1,10064},{2,201280},{4,5032}],active_cost = [{0,260006,491}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,40) ->
    #child_skill_cfg{sequence = 6,level = 40,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有34%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,8}],add_attr_list = [{1,10400},{2,208000},{4,5200}],active_cost = [{0,260006,509}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,41) ->
    #child_skill_cfg{sequence = 6,level = 41,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有36%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,9}],add_attr_list = [{1,10744},{2,214880},{4,5372}],active_cost = [{0,260006,528}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,42) ->
    #child_skill_cfg{sequence = 6,level = 42,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有36%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,9}],add_attr_list = [{1,11096},{2,221920},{4,5548}],active_cost = [{0,260006,547}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,43) ->
    #child_skill_cfg{sequence = 6,level = 43,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有36%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,9}],add_attr_list = [{1,11456},{2,229120},{4,5728}],active_cost = [{0,260006,566}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,44) ->
    #child_skill_cfg{sequence = 6,level = 44,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有36%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,9}],add_attr_list = [{1,11824},{2,236480},{4,5912}],active_cost = [{0,260006,586}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,45) ->
    #child_skill_cfg{sequence = 6,level = 45,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有36%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,9}],add_attr_list = [{1,12200},{2,244000},{4,6100}],active_cost = [{0,260006,606}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,46) ->
    #child_skill_cfg{sequence = 6,level = 46,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有38%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,10}],add_attr_list = [{1,12584},{2,251680},{4,6292}],active_cost = [{0,260006,627}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,47) ->
    #child_skill_cfg{sequence = 6,level = 47,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有38%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,10}],add_attr_list = [{1,12976},{2,259520},{4,6488}],active_cost = [{0,260006,648}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,48) ->
    #child_skill_cfg{sequence = 6,level = 48,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有38%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,10}],add_attr_list = [{1,13376},{2,267520},{4,6688}],active_cost = [{0,260006,669}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,49) ->
    #child_skill_cfg{sequence = 6,level = 49,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有38%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,10}],add_attr_list = [{1,13784},{2,275680},{4,6892}],active_cost = [{0,260006,691}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(6,50) ->
    #child_skill_cfg{sequence = 6,level = 50,skill_name = "元气鼓励",skill_desc = "主角攻击触发会心一击时，有38%几率对目标额外造成主角生命上限10%的固定伤害附加",active_skill = [{500012,10}],add_attr_list = [{1,14200},{2,284000},{4,7100}],active_cost = [{0,260006,713}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,1) ->
    #child_skill_cfg{sequence = 7,level = 1,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升32%",active_skill = [{500013,1}],add_attr_list = [{1,4025},{2,80504},{4,2013}],active_cost = [{0,260005,25}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,2) ->
    #child_skill_cfg{sequence = 7,level = 2,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升32%",active_skill = [{500013,1}],add_attr_list = [{1,4059},{2,81176},{4,2029}],active_cost = [{0,260006,15}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,3) ->
    #child_skill_cfg{sequence = 7,level = 3,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升32%",active_skill = [{500013,1}],add_attr_list = [{1,4101},{2,82016},{4,2050}],active_cost = [{0,260006,25}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,4) ->
    #child_skill_cfg{sequence = 7,level = 4,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升32%",active_skill = [{500013,1}],add_attr_list = [{1,4151},{2,83024},{4,2076}],active_cost = [{0,260006,35}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,5) ->
    #child_skill_cfg{sequence = 7,level = 5,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升32%",active_skill = [{500013,1}],add_attr_list = [{1,4210},{2,84200},{4,2105}],active_cost = [{0,260006,45}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,6) ->
    #child_skill_cfg{sequence = 7,level = 6,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升34%",active_skill = [{500013,2}],add_attr_list = [{1,4277},{2,85544},{4,2139}],active_cost = [{0,260006,55}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,7) ->
    #child_skill_cfg{sequence = 7,level = 7,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升34%",active_skill = [{500013,2}],add_attr_list = [{1,4353},{2,87056},{4,2176}],active_cost = [{0,260006,66}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,8) ->
    #child_skill_cfg{sequence = 7,level = 8,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升34%",active_skill = [{500013,2}],add_attr_list = [{1,4437},{2,88736},{4,2218}],active_cost = [{0,260006,77}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,9) ->
    #child_skill_cfg{sequence = 7,level = 9,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升34%",active_skill = [{500013,2}],add_attr_list = [{1,4529},{2,90584},{4,2265}],active_cost = [{0,260006,88}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,10) ->
    #child_skill_cfg{sequence = 7,level = 10,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升34%",active_skill = [{500013,2}],add_attr_list = [{1,4630},{2,92600},{4,2315}],active_cost = [{0,260006,99}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,11) ->
    #child_skill_cfg{sequence = 7,level = 11,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升36%",active_skill = [{500013,3}],add_attr_list = [{1,4739},{2,94784},{4,2370}],active_cost = [{0,260006,110}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,12) ->
    #child_skill_cfg{sequence = 7,level = 12,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升36%",active_skill = [{500013,3}],add_attr_list = [{1,4857},{2,97136},{4,2428}],active_cost = [{0,260006,122}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,13) ->
    #child_skill_cfg{sequence = 7,level = 13,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升36%",active_skill = [{500013,3}],add_attr_list = [{1,4983},{2,99656},{4,2491}],active_cost = [{0,260006,134}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,14) ->
    #child_skill_cfg{sequence = 7,level = 14,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升36%",active_skill = [{500013,3}],add_attr_list = [{1,5117},{2,102344},{4,2559}],active_cost = [{0,260006,146}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,15) ->
    #child_skill_cfg{sequence = 7,level = 15,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升36%",active_skill = [{500013,3}],add_attr_list = [{1,5260},{2,105200},{4,2630}],active_cost = [{0,260006,158}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,16) ->
    #child_skill_cfg{sequence = 7,level = 16,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升38%",active_skill = [{500013,4}],add_attr_list = [{1,5411},{2,108224},{4,2706}],active_cost = [{0,260006,171}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,17) ->
    #child_skill_cfg{sequence = 7,level = 17,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升38%",active_skill = [{500013,4}],add_attr_list = [{1,5571},{2,111416},{4,2785}],active_cost = [{0,260006,184}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,18) ->
    #child_skill_cfg{sequence = 7,level = 18,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升38%",active_skill = [{500013,4}],add_attr_list = [{1,5739},{2,114776},{4,2869}],active_cost = [{0,260006,197}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,19) ->
    #child_skill_cfg{sequence = 7,level = 19,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升38%",active_skill = [{500013,4}],add_attr_list = [{1,5915},{2,118304},{4,2958}],active_cost = [{0,260006,210}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,20) ->
    #child_skill_cfg{sequence = 7,level = 20,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升38%",active_skill = [{500013,4}],add_attr_list = [{1,6100},{2,122000},{4,3050}],active_cost = [{0,260006,224}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,21) ->
    #child_skill_cfg{sequence = 7,level = 21,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升40%",active_skill = [{500013,5}],add_attr_list = [{1,6293},{2,125864},{4,3147}],active_cost = [{0,260006,238}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,22) ->
    #child_skill_cfg{sequence = 7,level = 22,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升40%",active_skill = [{500013,5}],add_attr_list = [{1,6495},{2,129896},{4,3247}],active_cost = [{0,260006,252}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,23) ->
    #child_skill_cfg{sequence = 7,level = 23,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升40%",active_skill = [{500013,5}],add_attr_list = [{1,6705},{2,134096},{4,3352}],active_cost = [{0,260006,267}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,24) ->
    #child_skill_cfg{sequence = 7,level = 24,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升40%",active_skill = [{500013,5}],add_attr_list = [{1,6923},{2,138464},{4,3462}],active_cost = [{0,260006,282}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,25) ->
    #child_skill_cfg{sequence = 7,level = 25,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升40%",active_skill = [{500013,5}],add_attr_list = [{1,7150},{2,143000},{4,3575}],active_cost = [{0,260006,297}],pre_sequence = 6,need_power = 10000};

get_child_skill_cfg(7,26) ->
    #child_skill_cfg{sequence = 7,level = 26,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升42%",active_skill = [{500013,6}],add_attr_list = [{1,7385},{2,147704},{4,3693}],active_cost = [{0,260006,312}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,27) ->
    #child_skill_cfg{sequence = 7,level = 27,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升42%",active_skill = [{500013,6}],add_attr_list = [{1,7629},{2,152576},{4,3814}],active_cost = [{0,260006,328}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,28) ->
    #child_skill_cfg{sequence = 7,level = 28,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升42%",active_skill = [{500013,6}],add_attr_list = [{1,7881},{2,157616},{4,3940}],active_cost = [{0,260006,344}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,29) ->
    #child_skill_cfg{sequence = 7,level = 29,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升42%",active_skill = [{500013,6}],add_attr_list = [{1,8141},{2,162824},{4,4071}],active_cost = [{0,260006,360}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,30) ->
    #child_skill_cfg{sequence = 7,level = 30,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升42%",active_skill = [{500013,6}],add_attr_list = [{1,8410},{2,168200},{4,4205}],active_cost = [{0,260006,377}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,31) ->
    #child_skill_cfg{sequence = 7,level = 31,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升44%",active_skill = [{500013,7}],add_attr_list = [{1,8687},{2,173744},{4,4344}],active_cost = [{0,260006,394}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,32) ->
    #child_skill_cfg{sequence = 7,level = 32,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升44%",active_skill = [{500013,7}],add_attr_list = [{1,8973},{2,179456},{4,4486}],active_cost = [{0,260006,411}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,33) ->
    #child_skill_cfg{sequence = 7,level = 33,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升44%",active_skill = [{500013,7}],add_attr_list = [{1,9267},{2,185336},{4,4633}],active_cost = [{0,260006,429}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,34) ->
    #child_skill_cfg{sequence = 7,level = 34,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升44%",active_skill = [{500013,7}],add_attr_list = [{1,9569},{2,191384},{4,4785}],active_cost = [{0,260006,447}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,35) ->
    #child_skill_cfg{sequence = 7,level = 35,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升44%",active_skill = [{500013,7}],add_attr_list = [{1,9880},{2,197600},{4,4940}],active_cost = [{0,260006,465}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,36) ->
    #child_skill_cfg{sequence = 7,level = 36,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升46%",active_skill = [{500013,8}],add_attr_list = [{1,10199},{2,203984},{4,5100}],active_cost = [{0,260006,484}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,37) ->
    #child_skill_cfg{sequence = 7,level = 37,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升46%",active_skill = [{500013,8}],add_attr_list = [{1,10527},{2,210536},{4,5263}],active_cost = [{0,260006,503}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,38) ->
    #child_skill_cfg{sequence = 7,level = 38,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升46%",active_skill = [{500013,8}],add_attr_list = [{1,10863},{2,217256},{4,5431}],active_cost = [{0,260006,523}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,39) ->
    #child_skill_cfg{sequence = 7,level = 39,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升46%",active_skill = [{500013,8}],add_attr_list = [{1,11207},{2,224144},{4,5604}],active_cost = [{0,260006,543}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,40) ->
    #child_skill_cfg{sequence = 7,level = 40,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升46%",active_skill = [{500013,8}],add_attr_list = [{1,11560},{2,231200},{4,5780}],active_cost = [{0,260006,563}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,41) ->
    #child_skill_cfg{sequence = 7,level = 41,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升48%",active_skill = [{500013,9}],add_attr_list = [{1,11921},{2,238424},{4,5961}],active_cost = [{0,260006,584}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,42) ->
    #child_skill_cfg{sequence = 7,level = 42,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升48%",active_skill = [{500013,9}],add_attr_list = [{1,12291},{2,245816},{4,6145}],active_cost = [{0,260006,605}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,43) ->
    #child_skill_cfg{sequence = 7,level = 43,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升48%",active_skill = [{500013,9}],add_attr_list = [{1,12669},{2,253376},{4,6334}],active_cost = [{0,260006,627}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,44) ->
    #child_skill_cfg{sequence = 7,level = 44,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升48%",active_skill = [{500013,9}],add_attr_list = [{1,13055},{2,261104},{4,6528}],active_cost = [{0,260006,649}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,45) ->
    #child_skill_cfg{sequence = 7,level = 45,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升48%",active_skill = [{500013,9}],add_attr_list = [{1,13450},{2,269000},{4,6725}],active_cost = [{0,260006,671}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,46) ->
    #child_skill_cfg{sequence = 7,level = 46,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升50%",active_skill = [{500013,10}],add_attr_list = [{1,13853},{2,277064},{4,6927}],active_cost = [{0,260006,694}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,47) ->
    #child_skill_cfg{sequence = 7,level = 47,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升50%",active_skill = [{500013,10}],add_attr_list = [{1,14265},{2,285296},{4,7132}],active_cost = [{0,260006,717}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,48) ->
    #child_skill_cfg{sequence = 7,level = 48,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升50%",active_skill = [{500013,10}],add_attr_list = [{1,14685},{2,293696},{4,7342}],active_cost = [{0,260006,741}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,49) ->
    #child_skill_cfg{sequence = 7,level = 49,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升50%",active_skill = [{500013,10}],add_attr_list = [{1,15113},{2,302264},{4,7557}],active_cost = [{0,260006,765}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(7,50) ->
    #child_skill_cfg{sequence = 7,level = 50,skill_name = "玩具护甲",skill_desc = "主角被眩晕时获得宝宝的守护，伤害减免提升50%",active_skill = [{500013,10}],add_attr_list = [{1,15550},{2,311000},{4,7775}],active_cost = [{0,260006,790}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,1) ->
    #child_skill_cfg{sequence = 8,level = 1,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得10%群伤加成效果，持续5秒",active_skill = [{500014,1}],add_attr_list = [{1,4827},{2,96540},{4,2414}],active_cost = [{0,260005,30}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,2) ->
    #child_skill_cfg{sequence = 8,level = 2,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得10%群伤加成效果，持续5秒",active_skill = [{500014,1}],add_attr_list = [{1,4863},{2,97260},{4,2432}],active_cost = [{0,260006,15}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,3) ->
    #child_skill_cfg{sequence = 8,level = 3,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得10%群伤加成效果，持续5秒",active_skill = [{500014,1}],add_attr_list = [{1,4908},{2,98160},{4,2454}],active_cost = [{0,260006,25}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,4) ->
    #child_skill_cfg{sequence = 8,level = 4,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得10%群伤加成效果，持续5秒",active_skill = [{500014,1}],add_attr_list = [{1,4962},{2,99240},{4,2481}],active_cost = [{0,260006,35}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,5) ->
    #child_skill_cfg{sequence = 8,level = 5,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得10%群伤加成效果，持续5秒",active_skill = [{500014,1}],add_attr_list = [{1,5025},{2,100500},{4,2513}],active_cost = [{0,260006,45}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,6) ->
    #child_skill_cfg{sequence = 8,level = 6,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得12%群伤加成效果，持续5秒",active_skill = [{500014,2}],add_attr_list = [{1,5097},{2,101940},{4,2549}],active_cost = [{0,260006,55}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,7) ->
    #child_skill_cfg{sequence = 8,level = 7,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得12%群伤加成效果，持续5秒",active_skill = [{500014,2}],add_attr_list = [{1,5178},{2,103560},{4,2589}],active_cost = [{0,260006,66}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,8) ->
    #child_skill_cfg{sequence = 8,level = 8,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得12%群伤加成效果，持续5秒",active_skill = [{500014,2}],add_attr_list = [{1,5268},{2,105360},{4,2634}],active_cost = [{0,260006,77}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,9) ->
    #child_skill_cfg{sequence = 8,level = 9,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得12%群伤加成效果，持续5秒",active_skill = [{500014,2}],add_attr_list = [{1,5367},{2,107340},{4,2684}],active_cost = [{0,260006,88}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,10) ->
    #child_skill_cfg{sequence = 8,level = 10,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得12%群伤加成效果，持续5秒",active_skill = [{500014,2}],add_attr_list = [{1,5475},{2,109500},{4,2738}],active_cost = [{0,260006,99}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,11) ->
    #child_skill_cfg{sequence = 8,level = 11,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得14%群伤加成效果，持续5秒",active_skill = [{500014,3}],add_attr_list = [{1,5592},{2,111840},{4,2796}],active_cost = [{0,260006,110}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,12) ->
    #child_skill_cfg{sequence = 8,level = 12,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得14%群伤加成效果，持续5秒",active_skill = [{500014,3}],add_attr_list = [{1,5718},{2,114360},{4,2859}],active_cost = [{0,260006,122}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,13) ->
    #child_skill_cfg{sequence = 8,level = 13,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得14%群伤加成效果，持续5秒",active_skill = [{500014,3}],add_attr_list = [{1,5853},{2,117060},{4,2927}],active_cost = [{0,260006,134}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,14) ->
    #child_skill_cfg{sequence = 8,level = 14,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得14%群伤加成效果，持续5秒",active_skill = [{500014,3}],add_attr_list = [{1,5997},{2,119940},{4,2999}],active_cost = [{0,260006,146}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,15) ->
    #child_skill_cfg{sequence = 8,level = 15,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得14%群伤加成效果，持续5秒",active_skill = [{500014,3}],add_attr_list = [{1,6150},{2,123000},{4,3075}],active_cost = [{0,260006,158}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,16) ->
    #child_skill_cfg{sequence = 8,level = 16,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得15%群伤加成效果，持续5秒",active_skill = [{500014,4}],add_attr_list = [{1,6312},{2,126240},{4,3156}],active_cost = [{0,260006,171}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,17) ->
    #child_skill_cfg{sequence = 8,level = 17,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得15%群伤加成效果，持续5秒",active_skill = [{500014,4}],add_attr_list = [{1,6483},{2,129660},{4,3242}],active_cost = [{0,260006,184}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,18) ->
    #child_skill_cfg{sequence = 8,level = 18,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得15%群伤加成效果，持续5秒",active_skill = [{500014,4}],add_attr_list = [{1,6663},{2,133260},{4,3332}],active_cost = [{0,260006,197}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,19) ->
    #child_skill_cfg{sequence = 8,level = 19,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得15%群伤加成效果，持续5秒",active_skill = [{500014,4}],add_attr_list = [{1,6852},{2,137040},{4,3426}],active_cost = [{0,260006,210}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,20) ->
    #child_skill_cfg{sequence = 8,level = 20,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得15%群伤加成效果，持续5秒",active_skill = [{500014,4}],add_attr_list = [{1,7050},{2,141000},{4,3525}],active_cost = [{0,260006,224}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,21) ->
    #child_skill_cfg{sequence = 8,level = 21,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得16%群伤加成效果，持续5秒",active_skill = [{500014,5}],add_attr_list = [{1,7257},{2,145140},{4,3629}],active_cost = [{0,260006,238}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,22) ->
    #child_skill_cfg{sequence = 8,level = 22,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得16%群伤加成效果，持续5秒",active_skill = [{500014,5}],add_attr_list = [{1,7473},{2,149460},{4,3737}],active_cost = [{0,260006,252}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,23) ->
    #child_skill_cfg{sequence = 8,level = 23,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得16%群伤加成效果，持续5秒",active_skill = [{500014,5}],add_attr_list = [{1,7698},{2,153960},{4,3849}],active_cost = [{0,260006,267}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,24) ->
    #child_skill_cfg{sequence = 8,level = 24,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得16%群伤加成效果，持续5秒",active_skill = [{500014,5}],add_attr_list = [{1,7932},{2,158640},{4,3966}],active_cost = [{0,260006,282}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,25) ->
    #child_skill_cfg{sequence = 8,level = 25,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得16%群伤加成效果，持续5秒",active_skill = [{500014,5}],add_attr_list = [{1,8175},{2,163500},{4,4088}],active_cost = [{0,260006,297}],pre_sequence = 7,need_power = 10000};

get_child_skill_cfg(8,26) ->
    #child_skill_cfg{sequence = 8,level = 26,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得17%群伤加成效果，持续5秒",active_skill = [{500014,6}],add_attr_list = [{1,8427},{2,168540},{4,4214}],active_cost = [{0,260006,312}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,27) ->
    #child_skill_cfg{sequence = 8,level = 27,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得17%群伤加成效果，持续5秒",active_skill = [{500014,6}],add_attr_list = [{1,8688},{2,173760},{4,4344}],active_cost = [{0,260006,328}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,28) ->
    #child_skill_cfg{sequence = 8,level = 28,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得17%群伤加成效果，持续5秒",active_skill = [{500014,6}],add_attr_list = [{1,8958},{2,179160},{4,4479}],active_cost = [{0,260006,344}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,29) ->
    #child_skill_cfg{sequence = 8,level = 29,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得17%群伤加成效果，持续5秒",active_skill = [{500014,6}],add_attr_list = [{1,9237},{2,184740},{4,4619}],active_cost = [{0,260006,360}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,30) ->
    #child_skill_cfg{sequence = 8,level = 30,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得17%群伤加成效果，持续5秒",active_skill = [{500014,6}],add_attr_list = [{1,9525},{2,190500},{4,4763}],active_cost = [{0,260006,377}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,31) ->
    #child_skill_cfg{sequence = 8,level = 31,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得18%群伤加成效果，持续5秒",active_skill = [{500014,7}],add_attr_list = [{1,9822},{2,196440},{4,4911}],active_cost = [{0,260006,394}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,32) ->
    #child_skill_cfg{sequence = 8,level = 32,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得18%群伤加成效果，持续5秒",active_skill = [{500014,7}],add_attr_list = [{1,10128},{2,202560},{4,5064}],active_cost = [{0,260006,411}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,33) ->
    #child_skill_cfg{sequence = 8,level = 33,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得18%群伤加成效果，持续5秒",active_skill = [{500014,7}],add_attr_list = [{1,10443},{2,208860},{4,5222}],active_cost = [{0,260006,429}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,34) ->
    #child_skill_cfg{sequence = 8,level = 34,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得18%群伤加成效果，持续5秒",active_skill = [{500014,7}],add_attr_list = [{1,10767},{2,215340},{4,5384}],active_cost = [{0,260006,447}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,35) ->
    #child_skill_cfg{sequence = 8,level = 35,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得18%群伤加成效果，持续5秒",active_skill = [{500014,7}],add_attr_list = [{1,11100},{2,222000},{4,5550}],active_cost = [{0,260006,465}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,36) ->
    #child_skill_cfg{sequence = 8,level = 36,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得19%群伤加成效果，持续5秒",active_skill = [{500014,8}],add_attr_list = [{1,11442},{2,228840},{4,5721}],active_cost = [{0,260006,484}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,37) ->
    #child_skill_cfg{sequence = 8,level = 37,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得19%群伤加成效果，持续5秒",active_skill = [{500014,8}],add_attr_list = [{1,11793},{2,235860},{4,5897}],active_cost = [{0,260006,503}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,38) ->
    #child_skill_cfg{sequence = 8,level = 38,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得19%群伤加成效果，持续5秒",active_skill = [{500014,8}],add_attr_list = [{1,12153},{2,243060},{4,6077}],active_cost = [{0,260006,523}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,39) ->
    #child_skill_cfg{sequence = 8,level = 39,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得19%群伤加成效果，持续5秒",active_skill = [{500014,8}],add_attr_list = [{1,12522},{2,250440},{4,6261}],active_cost = [{0,260006,543}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,40) ->
    #child_skill_cfg{sequence = 8,level = 40,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得19%群伤加成效果，持续5秒",active_skill = [{500014,8}],add_attr_list = [{1,12900},{2,258000},{4,6450}],active_cost = [{0,260006,563}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,41) ->
    #child_skill_cfg{sequence = 8,level = 41,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得20%群伤加成效果，持续5秒",active_skill = [{500014,9}],add_attr_list = [{1,13287},{2,265740},{4,6644}],active_cost = [{0,260006,584}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,42) ->
    #child_skill_cfg{sequence = 8,level = 42,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得20%群伤加成效果，持续5秒",active_skill = [{500014,9}],add_attr_list = [{1,13683},{2,273660},{4,6842}],active_cost = [{0,260006,605}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,43) ->
    #child_skill_cfg{sequence = 8,level = 43,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得20%群伤加成效果，持续5秒",active_skill = [{500014,9}],add_attr_list = [{1,14088},{2,281760},{4,7044}],active_cost = [{0,260006,627}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,44) ->
    #child_skill_cfg{sequence = 8,level = 44,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得20%群伤加成效果，持续5秒",active_skill = [{500014,9}],add_attr_list = [{1,14502},{2,290040},{4,7251}],active_cost = [{0,260006,649}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,45) ->
    #child_skill_cfg{sequence = 8,level = 45,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得20%群伤加成效果，持续5秒",active_skill = [{500014,9}],add_attr_list = [{1,14925},{2,298500},{4,7463}],active_cost = [{0,260006,671}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,46) ->
    #child_skill_cfg{sequence = 8,level = 46,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得22%群伤加成效果，持续5秒",active_skill = [{500014,10}],add_attr_list = [{1,15357},{2,307140},{4,7679}],active_cost = [{0,260006,694}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,47) ->
    #child_skill_cfg{sequence = 8,level = 47,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得22%群伤加成效果，持续5秒",active_skill = [{500014,10}],add_attr_list = [{1,15798},{2,315960},{4,7899}],active_cost = [{0,260006,717}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,48) ->
    #child_skill_cfg{sequence = 8,level = 48,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得22%群伤加成效果，持续5秒",active_skill = [{500014,10}],add_attr_list = [{1,16248},{2,324960},{4,8124}],active_cost = [{0,260006,741}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,49) ->
    #child_skill_cfg{sequence = 8,level = 49,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得22%群伤加成效果，持续5秒",active_skill = [{500014,10}],add_attr_list = [{1,16707},{2,334140},{4,8354}],active_cost = [{0,260006,765}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(8,50) ->
    #child_skill_cfg{sequence = 8,level = 50,skill_name = "涂蜜之刃",skill_desc = "主角成功闪避时，获得22%群伤加成效果，持续5秒",active_skill = [{500014,10}],add_attr_list = [{1,17175},{2,343500},{4,8588}],active_cost = [{0,260006,790}],pre_sequence = 8,need_power = 10000};

get_child_skill_cfg(_Sequence,_Level) ->
    [].

get_child_skill_sequence_list_cfg() ->
    [1,2,3,4,5,6,7,8].

get_child_vehicle_cfg(260101,1) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 1,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,5}],add_attr = [{1,2000},{2,12000},{4,800}],active_skill = 501011,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,2) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 2,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,10}],add_attr = [{1,4000},{2,24000},{4,1600}],active_skill = 501012,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,3) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 3,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,15}],add_attr = [{1,8000},{2,48000},{4,3200}],active_skill = 501013,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,4) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 4,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,20}],add_attr = [{1,14000},{2,84000},{4,5600}],active_skill = 0,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,5) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 5,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,25}],add_attr = [{1,22000},{2,132000},{4,8800}],active_skill = 501014,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,6) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 6,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,30}],add_attr = [{1,32000},{2,192000},{4,12800}],active_skill = 0,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,7) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 7,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,35}],add_attr = [{1,42000},{2,252000},{4,16800}],active_skill = 0,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,8) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 8,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,40}],add_attr = [{1,52000},{2,312000},{4,20800}],active_skill = 0,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,9) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 9,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,45}],add_attr = [{1,62000},{2,372000},{4,24800}],active_skill = 0,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260101,10) ->
    #child_vehicle_cfg{vehicle_id = 260101,stage = 10,vehicle_name = "婴儿车",upgrade_cost = [{0,260101,50}],add_attr = [{1,72000},{2,432000},{4,28800}],active_skill = 0,add_carry_weight = 0,can_on_age = 1,model_id = 1001};

get_child_vehicle_cfg(260102,1) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 1,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,5}],add_attr = [{1,2000},{2,12000},{4,800}],active_skill = 501021,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,2) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 2,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,10}],add_attr = [{1,4000},{2,24000},{4,1600}],active_skill = 501022,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,3) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 3,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,15}],add_attr = [{1,8000},{2,48000},{4,3200}],active_skill = 501023,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,4) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 4,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,20}],add_attr = [{1,14000},{2,84000},{4,5600}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,5) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 5,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,25}],add_attr = [{1,22000},{2,132000},{4,8800}],active_skill = 501024,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,6) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 6,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,30}],add_attr = [{1,32000},{2,192000},{4,12800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,7) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 7,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,35}],add_attr = [{1,42000},{2,252000},{4,16800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,8) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 8,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,40}],add_attr = [{1,52000},{2,312000},{4,20800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,9) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 9,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,45}],add_attr = [{1,62000},{2,372000},{4,24800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260102,10) ->
    #child_vehicle_cfg{vehicle_id = 260102,stage = 10,vehicle_name = "童趣摩托",upgrade_cost = [{0,260102,50}],add_attr = [{1,72000},{2,432000},{4,28800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1002};

get_child_vehicle_cfg(260103,1) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 1,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,5}],add_attr = [{1,2000},{2,12000},{4,800}],active_skill = 501031,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,2) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 2,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,10}],add_attr = [{1,4000},{2,24000},{4,1600}],active_skill = 501032,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,3) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 3,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,15}],add_attr = [{1,8000},{2,48000},{4,3200}],active_skill = 501033,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,4) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 4,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,20}],add_attr = [{1,14000},{2,84000},{4,5600}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,5) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 5,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,25}],add_attr = [{1,22000},{2,132000},{4,8800}],active_skill = 501034,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,6) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 6,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,30}],add_attr = [{1,32000},{2,192000},{4,12800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,7) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 7,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,35}],add_attr = [{1,42000},{2,252000},{4,16800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,8) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 8,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,40}],add_attr = [{1,52000},{2,312000},{4,20800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,9) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 9,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,45}],add_attr = [{1,62000},{2,372000},{4,24800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260103,10) ->
    #child_vehicle_cfg{vehicle_id = 260103,stage = 10,vehicle_name = "悬浮童车",upgrade_cost = [{0,260103,50}],add_attr = [{1,72000},{2,432000},{4,28800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1003};

get_child_vehicle_cfg(260104,1) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 1,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,5}],add_attr = [{1,2000},{2,12000},{4,800}],active_skill = 501041,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,2) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 2,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,10}],add_attr = [{1,4000},{2,24000},{4,1600}],active_skill = 501042,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,3) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 3,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,15}],add_attr = [{1,8000},{2,48000},{4,3200}],active_skill = 501043,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,4) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 4,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,20}],add_attr = [{1,14000},{2,84000},{4,5600}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,5) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 5,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,25}],add_attr = [{1,22000},{2,132000},{4,8800}],active_skill = 501044,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,6) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 6,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,30}],add_attr = [{1,32000},{2,192000},{4,12800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,7) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 7,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,35}],add_attr = [{1,42000},{2,252000},{4,16800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,8) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 8,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,40}],add_attr = [{1,52000},{2,312000},{4,20800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,9) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 9,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,45}],add_attr = [{1,62000},{2,372000},{4,24800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260104,10) ->
    #child_vehicle_cfg{vehicle_id = 260104,stage = 10,vehicle_name = "萌萌恐龙",upgrade_cost = [{0,260104,50}],add_attr = [{1,72000},{2,432000},{4,28800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1004};

get_child_vehicle_cfg(260105,1) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 1,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,5}],add_attr = [{1,2000},{2,12000},{4,800}],active_skill = 501051,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,2) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 2,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,10}],add_attr = [{1,4000},{2,24000},{4,1600}],active_skill = 501052,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,3) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 3,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,15}],add_attr = [{1,8000},{2,48000},{4,3200}],active_skill = 501053,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,4) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 4,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,20}],add_attr = [{1,14000},{2,84000},{4,5600}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,5) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 5,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,25}],add_attr = [{1,22000},{2,132000},{4,8800}],active_skill = 501054,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,6) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 6,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,30}],add_attr = [{1,32000},{2,192000},{4,12800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,7) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 7,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,35}],add_attr = [{1,42000},{2,252000},{4,16800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,8) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 8,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,40}],add_attr = [{1,52000},{2,312000},{4,20800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,9) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 9,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,45}],add_attr = [{1,62000},{2,372000},{4,24800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(260105,10) ->
    #child_vehicle_cfg{vehicle_id = 260105,stage = 10,vehicle_name = "坦克突击",upgrade_cost = [{0,260105,50}],add_attr = [{1,72000},{2,432000},{4,28800}],active_skill = 0,add_carry_weight = 0,can_on_age = 3,model_id = 1005};

get_child_vehicle_cfg(_Vehicleid,_Stage) ->
    [].

get_all_child_vehicles() ->
    [260101,260102,260103,260104,260105].

get_child_toy_cfg(261001) ->
    #child_toy_cfg{toy_id = 261001,toy_type = 1,toy_name = "重一玩具",toy_weight = 1,toy_color = 1,strength_high = 15,attr_list = [{1,150},{2,1500},{4,75}],target_toy = 262001};

get_child_toy_cfg(261002) ->
    #child_toy_cfg{toy_id = 261002,toy_type = 2,toy_name = "重二玩具",toy_weight = 2,toy_color = 1,strength_high = 15,attr_list = [{1,250},{2,2500},{4,125}],target_toy = 262002};

get_child_toy_cfg(261003) ->
    #child_toy_cfg{toy_id = 261003,toy_type = 3,toy_name = "重三玩具",toy_weight = 3,toy_color = 1,strength_high = 15,attr_list = [{1,350},{2,3500},{4,175}],target_toy = 262003};

get_child_toy_cfg(261004) ->
    #child_toy_cfg{toy_id = 261004,toy_type = 4,toy_name = "重四玩具",toy_weight = 4,toy_color = 1,strength_high = 15,attr_list = [{1,450},{2,4500},{4,225}],target_toy = 262004};

get_child_toy_cfg(261005) ->
    #child_toy_cfg{toy_id = 261005,toy_type = 5,toy_name = "重五玩具",toy_weight = 5,toy_color = 1,strength_high = 15,attr_list = [{1,550},{2,5500},{4,275}],target_toy = 262005};

get_child_toy_cfg(261006) ->
    #child_toy_cfg{toy_id = 261006,toy_type = 6,toy_name = "重六玩具",toy_weight = 6,toy_color = 1,strength_high = 15,attr_list = [{1,650},{2,6500},{4,325}],target_toy = 262006};

get_child_toy_cfg(261007) ->
    #child_toy_cfg{toy_id = 261007,toy_type = 7,toy_name = "重七玩具",toy_weight = 7,toy_color = 1,strength_high = 15,attr_list = [{1,750},{2,7500},{4,375}],target_toy = 262007};

get_child_toy_cfg(261008) ->
    #child_toy_cfg{toy_id = 261008,toy_type = 8,toy_name = "重八玩具",toy_weight = 8,toy_color = 1,strength_high = 15,attr_list = [{1,850},{2,8500},{4,425}],target_toy = 262008};

get_child_toy_cfg(261009) ->
    #child_toy_cfg{toy_id = 261009,toy_type = 9,toy_name = "重九玩具",toy_weight = 9,toy_color = 1,strength_high = 15,attr_list = [{1,950},{2,9500},{4,475}],target_toy = 262009};

get_child_toy_cfg(261010) ->
    #child_toy_cfg{toy_id = 261010,toy_type = 10,toy_name = "重十玩具",toy_weight = 10,toy_color = 1,strength_high = 15,attr_list = [{1,1050},{2,10500},{4,525}],target_toy = 262010};

get_child_toy_cfg(262001) ->
    #child_toy_cfg{toy_id = 262001,toy_type = 1,toy_name = "重一玩具",toy_weight = 1,toy_color = 2,strength_high = 20,attr_list = [{1,200},{2,2000},{4,100}],target_toy = 263001};

get_child_toy_cfg(262002) ->
    #child_toy_cfg{toy_id = 262002,toy_type = 2,toy_name = "重二玩具",toy_weight = 2,toy_color = 2,strength_high = 20,attr_list = [{1,300},{2,3000},{4,150}],target_toy = 263002};

get_child_toy_cfg(262003) ->
    #child_toy_cfg{toy_id = 262003,toy_type = 3,toy_name = "重三玩具",toy_weight = 3,toy_color = 2,strength_high = 20,attr_list = [{1,400},{2,4000},{4,200}],target_toy = 263003};

get_child_toy_cfg(262004) ->
    #child_toy_cfg{toy_id = 262004,toy_type = 4,toy_name = "重四玩具",toy_weight = 4,toy_color = 2,strength_high = 20,attr_list = [{1,500},{2,5000},{4,250}],target_toy = 263004};

get_child_toy_cfg(262005) ->
    #child_toy_cfg{toy_id = 262005,toy_type = 5,toy_name = "重五玩具",toy_weight = 5,toy_color = 2,strength_high = 20,attr_list = [{1,600},{2,6000},{4,300}],target_toy = 263005};

get_child_toy_cfg(262006) ->
    #child_toy_cfg{toy_id = 262006,toy_type = 6,toy_name = "重六玩具",toy_weight = 6,toy_color = 2,strength_high = 20,attr_list = [{1,700},{2,7000},{4,350}],target_toy = 263006};

get_child_toy_cfg(262007) ->
    #child_toy_cfg{toy_id = 262007,toy_type = 7,toy_name = "重七玩具",toy_weight = 7,toy_color = 2,strength_high = 20,attr_list = [{1,800},{2,8000},{4,400}],target_toy = 263007};

get_child_toy_cfg(262008) ->
    #child_toy_cfg{toy_id = 262008,toy_type = 8,toy_name = "重八玩具",toy_weight = 8,toy_color = 2,strength_high = 20,attr_list = [{1,900},{2,9000},{4,450}],target_toy = 263008};

get_child_toy_cfg(262009) ->
    #child_toy_cfg{toy_id = 262009,toy_type = 9,toy_name = "重九玩具",toy_weight = 9,toy_color = 2,strength_high = 20,attr_list = [{1,1000},{2,10000},{4,500}],target_toy = 263009};

get_child_toy_cfg(262010) ->
    #child_toy_cfg{toy_id = 262010,toy_type = 10,toy_name = "重十玩具",toy_weight = 10,toy_color = 2,strength_high = 20,attr_list = [{1,1100},{2,11000},{4,550}],target_toy = 263010};

get_child_toy_cfg(263001) ->
    #child_toy_cfg{toy_id = 263001,toy_type = 1,toy_name = "重一玩具",toy_weight = 1,toy_color = 3,strength_high = 25,attr_list = [{1,250},{2,2500},{4,125}],target_toy = 264001};

get_child_toy_cfg(263002) ->
    #child_toy_cfg{toy_id = 263002,toy_type = 2,toy_name = "重二玩具",toy_weight = 2,toy_color = 3,strength_high = 25,attr_list = [{1,350},{2,3500},{4,175}],target_toy = 264002};

get_child_toy_cfg(263003) ->
    #child_toy_cfg{toy_id = 263003,toy_type = 3,toy_name = "重三玩具",toy_weight = 3,toy_color = 3,strength_high = 25,attr_list = [{1,450},{2,4500},{4,225}],target_toy = 264003};

get_child_toy_cfg(263004) ->
    #child_toy_cfg{toy_id = 263004,toy_type = 4,toy_name = "重四玩具",toy_weight = 4,toy_color = 3,strength_high = 25,attr_list = [{1,550},{2,5500},{4,275}],target_toy = 264004};

get_child_toy_cfg(263005) ->
    #child_toy_cfg{toy_id = 263005,toy_type = 5,toy_name = "重五玩具",toy_weight = 5,toy_color = 3,strength_high = 25,attr_list = [{1,650},{2,6500},{4,325}],target_toy = 264005};

get_child_toy_cfg(263006) ->
    #child_toy_cfg{toy_id = 263006,toy_type = 6,toy_name = "重六玩具",toy_weight = 6,toy_color = 3,strength_high = 25,attr_list = [{1,750},{2,7500},{4,375}],target_toy = 264006};

get_child_toy_cfg(263007) ->
    #child_toy_cfg{toy_id = 263007,toy_type = 7,toy_name = "重七玩具",toy_weight = 7,toy_color = 3,strength_high = 25,attr_list = [{1,850},{2,8500},{4,425}],target_toy = 264007};

get_child_toy_cfg(263008) ->
    #child_toy_cfg{toy_id = 263008,toy_type = 8,toy_name = "重八玩具",toy_weight = 8,toy_color = 3,strength_high = 25,attr_list = [{1,950},{2,9500},{4,475}],target_toy = 264008};

get_child_toy_cfg(263009) ->
    #child_toy_cfg{toy_id = 263009,toy_type = 9,toy_name = "重九玩具",toy_weight = 9,toy_color = 3,strength_high = 25,attr_list = [{1,1050},{2,10500},{4,525}],target_toy = 264009};

get_child_toy_cfg(263010) ->
    #child_toy_cfg{toy_id = 263010,toy_type = 10,toy_name = "重十玩具",toy_weight = 10,toy_color = 3,strength_high = 25,attr_list = [{1,1150},{2,11500},{4,575}],target_toy = 264010};

get_child_toy_cfg(264001) ->
    #child_toy_cfg{toy_id = 264001,toy_type = 1,toy_name = "重一玩具",toy_weight = 1,toy_color = 4,strength_high = 30,attr_list = [{1,300},{2,3000},{4,150}],target_toy = 265001};

get_child_toy_cfg(264002) ->
    #child_toy_cfg{toy_id = 264002,toy_type = 2,toy_name = "重二玩具",toy_weight = 2,toy_color = 4,strength_high = 30,attr_list = [{1,400},{2,4000},{4,200}],target_toy = 265002};

get_child_toy_cfg(264003) ->
    #child_toy_cfg{toy_id = 264003,toy_type = 3,toy_name = "重三玩具",toy_weight = 3,toy_color = 4,strength_high = 30,attr_list = [{1,500},{2,5000},{4,250}],target_toy = 265003};

get_child_toy_cfg(264004) ->
    #child_toy_cfg{toy_id = 264004,toy_type = 4,toy_name = "重四玩具",toy_weight = 4,toy_color = 4,strength_high = 30,attr_list = [{1,600},{2,6000},{4,300}],target_toy = 265004};

get_child_toy_cfg(264005) ->
    #child_toy_cfg{toy_id = 264005,toy_type = 5,toy_name = "重五玩具",toy_weight = 5,toy_color = 4,strength_high = 30,attr_list = [{1,700},{2,7000},{4,350}],target_toy = 265005};

get_child_toy_cfg(264006) ->
    #child_toy_cfg{toy_id = 264006,toy_type = 6,toy_name = "重六玩具",toy_weight = 6,toy_color = 4,strength_high = 30,attr_list = [{1,800},{2,8000},{4,400}],target_toy = 265006};

get_child_toy_cfg(264007) ->
    #child_toy_cfg{toy_id = 264007,toy_type = 7,toy_name = "重七玩具",toy_weight = 7,toy_color = 4,strength_high = 30,attr_list = [{1,900},{2,9000},{4,450}],target_toy = 265007};

get_child_toy_cfg(264008) ->
    #child_toy_cfg{toy_id = 264008,toy_type = 8,toy_name = "重八玩具",toy_weight = 8,toy_color = 4,strength_high = 30,attr_list = [{1,1000},{2,10000},{4,500}],target_toy = 265008};

get_child_toy_cfg(264009) ->
    #child_toy_cfg{toy_id = 264009,toy_type = 9,toy_name = "重九玩具",toy_weight = 9,toy_color = 4,strength_high = 30,attr_list = [{1,1100},{2,11000},{4,550}],target_toy = 265009};

get_child_toy_cfg(264010) ->
    #child_toy_cfg{toy_id = 264010,toy_type = 10,toy_name = "重十玩具",toy_weight = 10,toy_color = 4,strength_high = 30,attr_list = [{1,1200},{2,12000},{4,600}],target_toy = 265010};

get_child_toy_cfg(265001) ->
    #child_toy_cfg{toy_id = 265001,toy_type = 1,toy_name = "重一玩具",toy_weight = 1,toy_color = 5,strength_high = 35,attr_list = [{1,350},{2,3500},{4,175}],target_toy = 0};

get_child_toy_cfg(265002) ->
    #child_toy_cfg{toy_id = 265002,toy_type = 2,toy_name = "重二玩具",toy_weight = 2,toy_color = 5,strength_high = 35,attr_list = [{1,450},{2,4500},{4,225}],target_toy = 0};

get_child_toy_cfg(265003) ->
    #child_toy_cfg{toy_id = 265003,toy_type = 3,toy_name = "重三玩具",toy_weight = 3,toy_color = 5,strength_high = 35,attr_list = [{1,550},{2,5500},{4,275}],target_toy = 0};

get_child_toy_cfg(265004) ->
    #child_toy_cfg{toy_id = 265004,toy_type = 4,toy_name = "重四玩具",toy_weight = 4,toy_color = 5,strength_high = 35,attr_list = [{1,650},{2,6500},{4,325}],target_toy = 0};

get_child_toy_cfg(265005) ->
    #child_toy_cfg{toy_id = 265005,toy_type = 5,toy_name = "重五玩具",toy_weight = 5,toy_color = 5,strength_high = 35,attr_list = [{1,750},{2,7500},{4,375}],target_toy = 0};

get_child_toy_cfg(265006) ->
    #child_toy_cfg{toy_id = 265006,toy_type = 6,toy_name = "重六玩具",toy_weight = 6,toy_color = 5,strength_high = 35,attr_list = [{1,850},{2,8500},{4,425}],target_toy = 0};

get_child_toy_cfg(265007) ->
    #child_toy_cfg{toy_id = 265007,toy_type = 7,toy_name = "重七玩具",toy_weight = 7,toy_color = 5,strength_high = 35,attr_list = [{1,950},{2,9500},{4,475}],target_toy = 0};

get_child_toy_cfg(265008) ->
    #child_toy_cfg{toy_id = 265008,toy_type = 8,toy_name = "重八玩具",toy_weight = 8,toy_color = 5,strength_high = 35,attr_list = [{1,1050},{2,10500},{4,525}],target_toy = 0};

get_child_toy_cfg(265009) ->
    #child_toy_cfg{toy_id = 265009,toy_type = 9,toy_name = "重九玩具",toy_weight = 9,toy_color = 5,strength_high = 35,attr_list = [{1,1150},{2,11500},{4,575}],target_toy = 0};

get_child_toy_cfg(265010) ->
    #child_toy_cfg{toy_id = 265010,toy_type = 10,toy_name = "重十玩具",toy_weight = 10,toy_color = 5,strength_high = 35,attr_list = [{1,1250},{2,12500},{4,625}],target_toy = 0};

get_child_toy_cfg(_Toyid) ->
    [].

get_child_toy_cfg2(1,1) ->
    [261001];

get_child_toy_cfg2(1,2) ->
    [262001];

get_child_toy_cfg2(1,3) ->
    [263001];

get_child_toy_cfg2(1,4) ->
    [264001];

get_child_toy_cfg2(1,5) ->
    [265001];

get_child_toy_cfg2(2,1) ->
    [261002];

get_child_toy_cfg2(2,2) ->
    [262002];

get_child_toy_cfg2(2,3) ->
    [263002];

get_child_toy_cfg2(2,4) ->
    [264002];

get_child_toy_cfg2(2,5) ->
    [265002];

get_child_toy_cfg2(3,1) ->
    [261003];

get_child_toy_cfg2(3,2) ->
    [262003];

get_child_toy_cfg2(3,3) ->
    [263003];

get_child_toy_cfg2(3,4) ->
    [264003];

get_child_toy_cfg2(3,5) ->
    [265003];

get_child_toy_cfg2(4,1) ->
    [261004];

get_child_toy_cfg2(4,2) ->
    [262004];

get_child_toy_cfg2(4,3) ->
    [263004];

get_child_toy_cfg2(4,4) ->
    [264004];

get_child_toy_cfg2(4,5) ->
    [265004];

get_child_toy_cfg2(5,1) ->
    [261005];

get_child_toy_cfg2(5,2) ->
    [262005];

get_child_toy_cfg2(5,3) ->
    [263005];

get_child_toy_cfg2(5,4) ->
    [264005];

get_child_toy_cfg2(5,5) ->
    [265005];

get_child_toy_cfg2(6,1) ->
    [261006];

get_child_toy_cfg2(6,2) ->
    [262006];

get_child_toy_cfg2(6,3) ->
    [263006];

get_child_toy_cfg2(6,4) ->
    [264006];

get_child_toy_cfg2(6,5) ->
    [265006];

get_child_toy_cfg2(7,1) ->
    [261007];

get_child_toy_cfg2(7,2) ->
    [262007];

get_child_toy_cfg2(7,3) ->
    [263007];

get_child_toy_cfg2(7,4) ->
    [264007];

get_child_toy_cfg2(7,5) ->
    [265007];

get_child_toy_cfg2(8,1) ->
    [261008];

get_child_toy_cfg2(8,2) ->
    [262008];

get_child_toy_cfg2(8,3) ->
    [263008];

get_child_toy_cfg2(8,4) ->
    [264008];

get_child_toy_cfg2(8,5) ->
    [265008];

get_child_toy_cfg2(9,1) ->
    [261009];

get_child_toy_cfg2(9,2) ->
    [262009];

get_child_toy_cfg2(9,3) ->
    [263009];

get_child_toy_cfg2(9,4) ->
    [264009];

get_child_toy_cfg2(9,5) ->
    [265009];

get_child_toy_cfg2(10,1) ->
    [261010];

get_child_toy_cfg2(10,2) ->
    [262010];

get_child_toy_cfg2(10,3) ->
    [263010];

get_child_toy_cfg2(10,4) ->
    [264010];

get_child_toy_cfg2(10,5) ->
    [265010];

get_child_toy_cfg2(_Toytype,_Toycolor) ->
    [].

get_toy_stren_cfg(1,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,20}]};

get_toy_stren_cfg(1,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(1,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(1,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(1,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(1,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(1,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(1,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(1,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(1,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(1,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(1,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(1,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(1,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(1,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 1,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(2,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,330},{4,15}]};

get_toy_stren_cfg(2,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(2,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(2,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(2,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(2,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(2,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(2,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(2,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(2,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(2,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(2,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(2,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(2,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(2,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 2,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(3,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(3,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(3,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(3,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(3,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(3,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(3,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(3,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(3,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(3,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(3,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(3,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(3,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(3,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(3,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 3,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(4,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(4,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(4,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(4,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(4,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(4,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(4,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(4,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(4,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(4,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(4,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(4,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(4,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(4,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(4,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 4,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(5,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(5,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(5,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(5,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(5,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(5,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(5,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(5,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(5,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(5,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(5,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(5,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(5,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(5,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(5,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 5,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(6,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(6,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(6,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(6,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(6,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(6,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(6,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(6,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(6,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(6,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(6,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(6,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(6,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(6,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(6,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 6,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(7,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(7,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(7,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(7,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(7,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(7,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(7,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(7,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(7,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(7,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(7,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(7,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(7,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(7,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(7,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 7,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(8,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(8,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(8,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(8,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(8,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(8,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(8,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(8,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(8,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(8,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(8,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(8,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(8,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(8,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(8,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 8,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(9,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(9,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(9,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(9,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(9,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(9,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(9,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(9,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(9,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(9,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(9,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(9,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(9,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(9,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(9,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 9,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(10,1,1) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(10,1,2) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(10,1,3) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(10,1,4) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(10,1,5) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(10,1,6) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(10,1,7) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(10,1,8) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(10,1,9) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(10,1,10) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(10,1,11) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(10,1,12) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(10,1,13) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(10,1,14) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(10,1,15) ->
    #child_toy_stren_cfg{toy_color = 1,toy_type = 10,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(1,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 1,cost = [{0,260007,2}],add_attr = [{1,40},{2,300},{4,15}]};

get_toy_stren_cfg(1,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(1,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(1,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(1,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(1,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(1,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(1,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(1,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(1,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(1,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(1,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(1,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(1,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(1,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(1,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(1,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(1,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(1,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(1,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 1,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(2,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(2,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(2,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(2,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(2,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(2,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(2,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(2,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(2,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(2,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(2,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(2,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(2,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(2,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(2,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(2,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(2,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(2,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(2,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(2,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 2,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(3,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(3,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(3,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(3,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(3,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(3,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(3,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(3,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(3,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(3,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(3,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(3,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(3,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(3,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(3,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(3,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(3,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(3,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(3,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(3,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 3,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(4,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(4,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(4,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(4,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(4,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(4,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(4,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(4,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(4,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(4,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(4,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(4,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(4,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(4,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(4,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(4,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(4,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(4,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(4,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(4,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 4,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(5,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(5,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(5,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(5,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(5,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(5,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(5,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(5,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(5,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(5,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(5,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(5,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(5,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(5,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(5,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(5,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(5,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(5,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(5,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(5,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 5,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(6,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(6,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(6,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(6,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(6,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(6,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(6,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(6,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(6,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(6,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(6,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(6,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(6,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(6,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(6,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(6,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(6,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(6,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(6,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(6,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 6,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(7,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(7,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(7,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(7,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(7,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(7,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(7,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(7,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(7,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(7,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(7,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(7,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(7,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(7,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(7,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(7,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(7,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(7,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(7,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(7,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 7,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(8,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(8,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(8,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(8,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(8,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(8,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(8,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(8,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(8,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(8,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(8,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(8,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(8,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(8,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(8,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(8,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(8,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(8,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(8,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(8,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 8,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(9,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(9,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(9,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(9,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(9,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(9,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(9,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(9,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(9,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(9,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(9,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(9,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(9,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(9,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(9,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(9,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(9,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(9,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(9,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(9,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 9,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(10,2,1) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(10,2,2) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(10,2,3) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(10,2,4) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(10,2,5) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(10,2,6) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(10,2,7) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(10,2,8) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(10,2,9) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(10,2,10) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(10,2,11) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(10,2,12) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(10,2,13) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(10,2,14) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(10,2,15) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(10,2,16) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(10,2,17) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(10,2,18) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(10,2,19) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(10,2,20) ->
    #child_toy_stren_cfg{toy_color = 2,toy_type = 10,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(1,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(1,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(1,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(1,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(1,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(1,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(1,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(1,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(1,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(1,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(1,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(1,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(1,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(1,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(1,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(1,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(1,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(1,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(1,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(1,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(1,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(1,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(1,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(1,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(1,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 1,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(2,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(2,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(2,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(2,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(2,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(2,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(2,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(2,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(2,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(2,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(2,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(2,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(2,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(2,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(2,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(2,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(2,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(2,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(2,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(2,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(2,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(2,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(2,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(2,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(2,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 2,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(3,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(3,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(3,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(3,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(3,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(3,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(3,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(3,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(3,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(3,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(3,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(3,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(3,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(3,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(3,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(3,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(3,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(3,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(3,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(3,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(3,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(3,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(3,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(3,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(3,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 3,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(4,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(4,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(4,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(4,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(4,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(4,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(4,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(4,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(4,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(4,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(4,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(4,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(4,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(4,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(4,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(4,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(4,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(4,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(4,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(4,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(4,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(4,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(4,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(4,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(4,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 4,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(5,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(5,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(5,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(5,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(5,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(5,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(5,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(5,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(5,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(5,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(5,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(5,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(5,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(5,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(5,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(5,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(5,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(5,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(5,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(5,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(5,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(5,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(5,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(5,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(5,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 5,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(6,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(6,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(6,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(6,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(6,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(6,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(6,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(6,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(6,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(6,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(6,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(6,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(6,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(6,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(6,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(6,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(6,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(6,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(6,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(6,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(6,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(6,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(6,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(6,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(6,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 6,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(7,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(7,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(7,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(7,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(7,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(7,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(7,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(7,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(7,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(7,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(7,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(7,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(7,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(7,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(7,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(7,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(7,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(7,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(7,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(7,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(7,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(7,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(7,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(7,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(7,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 7,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(8,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(8,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(8,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(8,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(8,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(8,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(8,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(8,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(8,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(8,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(8,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(8,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(8,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(8,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(8,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(8,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(8,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(8,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(8,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(8,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(8,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(8,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(8,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(8,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(8,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 8,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(9,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(9,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(9,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(9,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(9,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(9,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(9,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(9,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(9,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(9,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(9,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(9,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(9,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(9,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(9,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(9,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(9,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(9,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(9,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(9,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(9,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(9,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(9,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(9,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(9,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 9,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(10,3,1) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(10,3,2) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(10,3,3) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(10,3,4) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(10,3,5) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(10,3,6) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(10,3,7) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(10,3,8) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(10,3,9) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(10,3,10) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(10,3,11) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(10,3,12) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(10,3,13) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(10,3,14) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(10,3,15) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(10,3,16) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(10,3,17) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(10,3,18) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(10,3,19) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(10,3,20) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(10,3,21) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(10,3,22) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(10,3,23) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(10,3,24) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(10,3,25) ->
    #child_toy_stren_cfg{toy_color = 3,toy_type = 10,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(1,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(1,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(1,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(1,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(1,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(1,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(1,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(1,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(1,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(1,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(1,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(1,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(1,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(1,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(1,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(1,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(1,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(1,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(1,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(1,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(1,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(1,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(1,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(1,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(1,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(1,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(1,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(1,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(1,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(1,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 1,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(2,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(2,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(2,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(2,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(2,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(2,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(2,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(2,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(2,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(2,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(2,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(2,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(2,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(2,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(2,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(2,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(2,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(2,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(2,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(2,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(2,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(2,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(2,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(2,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(2,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(2,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(2,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(2,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(2,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(2,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 2,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(3,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(3,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(3,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(3,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(3,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(3,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(3,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(3,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(3,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(3,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(3,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(3,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(3,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(3,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(3,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(3,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(3,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(3,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(3,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(3,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(3,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(3,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(3,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(3,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(3,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(3,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(3,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(3,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(3,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(3,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 3,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(4,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(4,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(4,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(4,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(4,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(4,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(4,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(4,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(4,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(4,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(4,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(4,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(4,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(4,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(4,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(4,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(4,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(4,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(4,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(4,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(4,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(4,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(4,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(4,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(4,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(4,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(4,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(4,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(4,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(4,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 4,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(5,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(5,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(5,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(5,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(5,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(5,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(5,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(5,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(5,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(5,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(5,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(5,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(5,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(5,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(5,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(5,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(5,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(5,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(5,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(5,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(5,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(5,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(5,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(5,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(5,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(5,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(5,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(5,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(5,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(5,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 5,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(6,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(6,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(6,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(6,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(6,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(6,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(6,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(6,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(6,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(6,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(6,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(6,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(6,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(6,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(6,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(6,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(6,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(6,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(6,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(6,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(6,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(6,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(6,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(6,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(6,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(6,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(6,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(6,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(6,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(6,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 6,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(7,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(7,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(7,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(7,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(7,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(7,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(7,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(7,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(7,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(7,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(7,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(7,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(7,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(7,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(7,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(7,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(7,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(7,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(7,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(7,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(7,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(7,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(7,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(7,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(7,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(7,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(7,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(7,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(7,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(7,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 7,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(8,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(8,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(8,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(8,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(8,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(8,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(8,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(8,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(8,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(8,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(8,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(8,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(8,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(8,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(8,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(8,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(8,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(8,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(8,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(8,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(8,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(8,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(8,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(8,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(8,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(8,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(8,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(8,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(8,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(8,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 8,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(9,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(9,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(9,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(9,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(9,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(9,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(9,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(9,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(9,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(9,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(9,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(9,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(9,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(9,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(9,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(9,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(9,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(9,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(9,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(9,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(9,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(9,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(9,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(9,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(9,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(9,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(9,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(9,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(9,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(9,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 9,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(10,4,1) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(10,4,2) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(10,4,3) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(10,4,4) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(10,4,5) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(10,4,6) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(10,4,7) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(10,4,8) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(10,4,9) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(10,4,10) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(10,4,11) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(10,4,12) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(10,4,13) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(10,4,14) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(10,4,15) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(10,4,16) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(10,4,17) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(10,4,18) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(10,4,19) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(10,4,20) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(10,4,21) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(10,4,22) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(10,4,23) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(10,4,24) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(10,4,25) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(10,4,26) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(10,4,27) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(10,4,28) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(10,4,29) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(10,4,30) ->
    #child_toy_stren_cfg{toy_color = 4,toy_type = 10,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(1,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(1,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(1,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(1,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(1,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(1,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(1,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(1,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(1,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(1,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(1,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(1,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(1,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(1,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(1,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(1,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(1,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(1,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(1,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(1,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(1,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(1,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(1,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(1,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(1,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(1,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(1,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(1,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(1,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(1,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(1,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(1,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(1,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(1,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(1,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 1,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(2,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(2,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(2,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(2,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(2,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(2,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(2,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(2,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(2,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(2,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(2,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(2,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(2,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(2,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(2,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(2,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(2,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(2,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(2,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(2,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(2,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(2,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(2,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(2,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(2,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(2,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(2,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(2,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(2,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(2,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(2,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(2,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(2,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(2,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(2,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 2,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(3,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(3,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(3,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(3,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(3,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(3,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(3,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(3,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(3,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(3,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(3,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(3,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(3,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(3,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(3,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(3,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(3,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(3,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(3,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(3,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(3,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(3,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(3,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(3,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(3,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(3,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(3,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(3,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(3,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(3,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(3,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(3,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(3,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(3,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(3,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 3,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(4,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(4,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(4,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(4,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(4,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(4,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(4,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(4,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(4,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(4,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(4,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(4,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(4,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(4,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(4,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(4,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(4,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(4,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(4,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(4,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(4,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(4,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(4,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(4,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(4,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(4,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(4,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(4,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(4,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(4,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(4,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(4,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(4,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(4,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(4,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 4,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(5,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(5,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(5,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(5,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(5,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(5,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(5,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(5,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(5,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(5,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(5,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(5,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(5,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(5,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(5,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(5,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(5,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(5,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(5,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(5,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(5,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(5,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(5,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(5,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(5,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(5,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(5,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(5,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(5,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(5,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(5,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(5,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(5,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(5,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(5,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 5,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(6,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(6,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(6,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(6,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(6,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(6,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(6,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(6,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(6,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(6,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(6,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(6,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(6,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(6,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(6,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(6,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(6,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(6,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(6,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(6,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(6,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(6,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(6,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(6,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(6,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(6,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(6,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(6,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(6,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(6,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(6,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(6,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(6,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(6,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(6,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 6,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(7,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(7,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(7,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(7,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(7,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(7,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(7,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(7,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(7,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(7,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(7,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(7,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(7,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(7,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(7,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(7,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(7,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(7,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(7,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(7,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(7,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(7,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(7,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(7,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(7,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(7,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(7,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(7,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(7,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(7,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(7,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(7,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(7,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(7,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(7,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 7,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(8,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(8,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(8,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(8,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(8,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(8,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(8,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(8,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(8,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(8,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(8,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(8,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(8,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(8,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(8,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(8,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(8,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(8,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(8,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(8,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(8,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(8,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(8,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(8,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(8,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(8,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(8,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(8,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(8,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(8,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(8,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(8,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(8,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(8,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(8,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 8,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(9,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(9,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(9,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(9,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(9,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(9,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(9,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(9,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(9,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(9,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(9,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(9,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(9,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(9,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(9,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(9,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(9,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(9,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(9,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(9,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(9,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(9,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(9,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(9,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(9,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(9,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(9,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(9,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(9,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(9,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(9,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(9,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(9,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(9,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(9,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 9,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(10,5,1) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 1,cost = [{0,260007,1}],add_attr = [{1,30},{2,300},{4,15}]};

get_toy_stren_cfg(10,5,2) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 2,cost = [{0,260007,4}],add_attr = [{1,50},{2,500},{4,25}]};

get_toy_stren_cfg(10,5,3) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 3,cost = [{0,260007,7}],add_attr = [{1,70},{2,700},{4,35}]};

get_toy_stren_cfg(10,5,4) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 4,cost = [{0,260007,10}],add_attr = [{1,90},{2,900},{4,45}]};

get_toy_stren_cfg(10,5,5) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 5,cost = [{0,260007,13}],add_attr = [{1,110},{2,1100},{4,55}]};

get_toy_stren_cfg(10,5,6) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 6,cost = [{0,260007,16}],add_attr = [{1,130},{2,1300},{4,65}]};

get_toy_stren_cfg(10,5,7) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 7,cost = [{0,260007,19}],add_attr = [{1,150},{2,1500},{4,75}]};

get_toy_stren_cfg(10,5,8) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 8,cost = [{0,260007,22}],add_attr = [{1,170},{2,1700},{4,85}]};

get_toy_stren_cfg(10,5,9) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 9,cost = [{0,260007,25}],add_attr = [{1,190},{2,1900},{4,95}]};

get_toy_stren_cfg(10,5,10) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 10,cost = [{0,260007,28}],add_attr = [{1,210},{2,2100},{4,105}]};

get_toy_stren_cfg(10,5,11) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 11,cost = [{0,260007,31}],add_attr = [{1,230},{2,2300},{4,115}]};

get_toy_stren_cfg(10,5,12) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 12,cost = [{0,260007,34}],add_attr = [{1,250},{2,2500},{4,125}]};

get_toy_stren_cfg(10,5,13) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 13,cost = [{0,260007,37}],add_attr = [{1,270},{2,2700},{4,135}]};

get_toy_stren_cfg(10,5,14) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 14,cost = [{0,260007,40}],add_attr = [{1,290},{2,2900},{4,145}]};

get_toy_stren_cfg(10,5,15) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 15,cost = [{0,260007,43}],add_attr = [{1,310},{2,3100},{4,155}]};

get_toy_stren_cfg(10,5,16) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 16,cost = [{0,260007,46}],add_attr = [{1,330},{2,3300},{4,165}]};

get_toy_stren_cfg(10,5,17) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 17,cost = [{0,260007,49}],add_attr = [{1,350},{2,3500},{4,175}]};

get_toy_stren_cfg(10,5,18) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 18,cost = [{0,260007,52}],add_attr = [{1,370},{2,3700},{4,185}]};

get_toy_stren_cfg(10,5,19) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 19,cost = [{0,260007,55}],add_attr = [{1,390},{2,3900},{4,195}]};

get_toy_stren_cfg(10,5,20) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 20,cost = [{0,260007,58}],add_attr = [{1,410},{2,4100},{4,205}]};

get_toy_stren_cfg(10,5,21) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 21,cost = [{0,260007,61}],add_attr = [{1,430},{2,4300},{4,215}]};

get_toy_stren_cfg(10,5,22) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 22,cost = [{0,260007,64}],add_attr = [{1,450},{2,4500},{4,225}]};

get_toy_stren_cfg(10,5,23) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 23,cost = [{0,260007,67}],add_attr = [{1,470},{2,4700},{4,235}]};

get_toy_stren_cfg(10,5,24) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 24,cost = [{0,260007,70}],add_attr = [{1,490},{2,4900},{4,245}]};

get_toy_stren_cfg(10,5,25) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 25,cost = [{0,260007,73}],add_attr = [{1,510},{2,5100},{4,255}]};

get_toy_stren_cfg(10,5,26) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 26,cost = [{0,260007,76}],add_attr = [{1,530},{2,5300},{4,265}]};

get_toy_stren_cfg(10,5,27) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 27,cost = [{0,260007,79}],add_attr = [{1,550},{2,5500},{4,275}]};

get_toy_stren_cfg(10,5,28) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 28,cost = [{0,260007,82}],add_attr = [{1,570},{2,5700},{4,285}]};

get_toy_stren_cfg(10,5,29) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 29,cost = [{0,260007,85}],add_attr = [{1,590},{2,5900},{4,295}]};

get_toy_stren_cfg(10,5,30) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 30,cost = [{0,260007,88}],add_attr = [{1,610},{2,6100},{4,305}]};

get_toy_stren_cfg(10,5,31) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 31,cost = [{0,260007,91}],add_attr = [{1,630},{2,6300},{4,315}]};

get_toy_stren_cfg(10,5,32) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 32,cost = [{0,260007,94}],add_attr = [{1,650},{2,6500},{4,325}]};

get_toy_stren_cfg(10,5,33) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 33,cost = [{0,260007,97}],add_attr = [{1,670},{2,6700},{4,335}]};

get_toy_stren_cfg(10,5,34) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 34,cost = [{0,260007,100}],add_attr = [{1,690},{2,6900},{4,345}]};

get_toy_stren_cfg(10,5,35) ->
    #child_toy_stren_cfg{toy_color = 5,toy_type = 10,stren_lv = 35,cost = [{0,260007,103}],add_attr = [{1,710},{2,7100},{4,355}]};

get_toy_stren_cfg(_Toytype,_Toycolor,_Strenlv) ->
    [].

get_toy_forge_time_cfg(1) ->
    #toy_forge_time_cfg{id = 1,weight = 1400,need_time = 120};

get_toy_forge_time_cfg(2) ->
    #toy_forge_time_cfg{id = 2,weight = 1200,need_time = 300};

get_toy_forge_time_cfg(3) ->
    #toy_forge_time_cfg{id = 3,weight = 1000,need_time = 600};

get_toy_forge_time_cfg(4) ->
    #toy_forge_time_cfg{id = 4,weight = 950,need_time = 1200};

get_toy_forge_time_cfg(5) ->
    #toy_forge_time_cfg{id = 5,weight = 900,need_time = 2400};

get_toy_forge_time_cfg(6) ->
    #toy_forge_time_cfg{id = 6,weight = 800,need_time = 3600};

get_toy_forge_time_cfg(_Id) ->
    [].

get_all_forge_time_cfg() ->
    [1,2,3,4,5,6].

get_toy_forge_content_cfg(1,1,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 1,weight = 1500,select_least = 0,reward_content = [{0,261001,1}]};

get_toy_forge_content_cfg(1,2,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 2,weight = 1500,select_least = 0,reward_content = [{0,261002,1}]};

get_toy_forge_content_cfg(1,3,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 3,weight = 1500,select_least = 0,reward_content = [{0,261003,1}]};

get_toy_forge_content_cfg(1,4,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 4,weight = 1500,select_least = 0,reward_content = [{0,261004,1}]};

get_toy_forge_content_cfg(1,5,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 5,weight = 1500,select_least = 0,reward_content = [{0,261005,1}]};

get_toy_forge_content_cfg(1,6,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 6,weight = 1200,select_least = 0,reward_content = [{0,262001,1}]};

get_toy_forge_content_cfg(1,7,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 7,weight = 1200,select_least = 0,reward_content = [{0,262002,1}]};

get_toy_forge_content_cfg(1,8,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 8,weight = 1200,select_least = 0,reward_content = [{0,262003,1}]};

get_toy_forge_content_cfg(1,9,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 9,weight = 1200,select_least = 0,reward_content = [{0,262004,1}]};

get_toy_forge_content_cfg(1,10,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 10,weight = 1200,select_least = 0,reward_content = [{0,262005,1}]};

get_toy_forge_content_cfg(1,11,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 11,weight = 1000,select_least = 0,reward_content = [{0,261006,1}]};

get_toy_forge_content_cfg(1,12,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 12,weight = 1000,select_least = 0,reward_content = [{0,261007,1}]};

get_toy_forge_content_cfg(1,13,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 13,weight = 1000,select_least = 0,reward_content = [{0,261008,1}]};

get_toy_forge_content_cfg(1,14,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 14,weight = 1000,select_least = 0,reward_content = [{0,261009,1}]};

get_toy_forge_content_cfg(1,15,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 15,weight = 1000,select_least = 0,reward_content = [{0,261010,1}]};

get_toy_forge_content_cfg(1,16,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 16,weight = 900,select_least = 0,reward_content = [{0,262006,1}]};

get_toy_forge_content_cfg(1,17,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 17,weight = 900,select_least = 0,reward_content = [{0,262007,1}]};

get_toy_forge_content_cfg(1,18,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 18,weight = 900,select_least = 0,reward_content = [{0,262008,1}]};

get_toy_forge_content_cfg(1,19,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 19,weight = 900,select_least = 0,reward_content = [{0,262009,1}]};

get_toy_forge_content_cfg(1,20,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 20,weight = 900,select_least = 0,reward_content = [{0,262010,1}]};

get_toy_forge_content_cfg(1,21,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 21,weight = 800,select_least = 0,reward_content = [{0,263001,1}]};

get_toy_forge_content_cfg(1,22,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 22,weight = 800,select_least = 0,reward_content = [{0,263002,1}]};

get_toy_forge_content_cfg(1,23,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 23,weight = 800,select_least = 0,reward_content = [{0,263003,1}]};

get_toy_forge_content_cfg(1,24,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 24,weight = 800,select_least = 0,reward_content = [{0,263004,1}]};

get_toy_forge_content_cfg(1,25,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 25,weight = 800,select_least = 0,reward_content = [{0,263005,1}]};

get_toy_forge_content_cfg(1,26,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 26,weight = 700,select_least = 0,reward_content = [{0,263006,1}]};

get_toy_forge_content_cfg(1,27,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 27,weight = 700,select_least = 0,reward_content = [{0,263007,1}]};

get_toy_forge_content_cfg(1,28,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 28,weight = 700,select_least = 0,reward_content = [{0,263008,1}]};

get_toy_forge_content_cfg(1,29,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 29,weight = 700,select_least = 0,reward_content = [{0,263009,1}]};

get_toy_forge_content_cfg(1,30,0) ->
    #toy_forge_content_cfg{id = 1,reward_id = 30,weight = 700,select_least = 0,reward_content = [{0,263010,1}]};

get_toy_forge_content_cfg(1,31,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 31,weight = 300,select_least = 20,reward_content = [{0,264001,1}]};

get_toy_forge_content_cfg(1,32,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 32,weight = 300,select_least = 20,reward_content = [{0,264002,1}]};

get_toy_forge_content_cfg(1,33,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 33,weight = 300,select_least = 20,reward_content = [{0,264003,1}]};

get_toy_forge_content_cfg(1,34,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 34,weight = 300,select_least = 20,reward_content = [{0,264004,1}]};

get_toy_forge_content_cfg(1,35,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 35,weight = 300,select_least = 20,reward_content = [{0,264005,1}]};

get_toy_forge_content_cfg(1,36,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 36,weight = 100,select_least = 20,reward_content = [{0,264006,1}]};

get_toy_forge_content_cfg(1,37,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 37,weight = 100,select_least = 20,reward_content = [{0,264007,1}]};

get_toy_forge_content_cfg(1,38,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 38,weight = 100,select_least = 20,reward_content = [{0,264008,1}]};

get_toy_forge_content_cfg(1,39,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 39,weight = 100,select_least = 20,reward_content = [{0,264009,1}]};

get_toy_forge_content_cfg(1,40,20) ->
    #toy_forge_content_cfg{id = 1,reward_id = 40,weight = 100,select_least = 20,reward_content = [{0,264010,1}]};

get_toy_forge_content_cfg(2,1,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 1,weight = 1500,select_least = 0,reward_content = [{0,261001,1}]};

get_toy_forge_content_cfg(2,2,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 2,weight = 1500,select_least = 0,reward_content = [{0,261002,1}]};

get_toy_forge_content_cfg(2,3,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 3,weight = 1500,select_least = 0,reward_content = [{0,261003,1}]};

get_toy_forge_content_cfg(2,4,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 4,weight = 1500,select_least = 0,reward_content = [{0,261004,1}]};

get_toy_forge_content_cfg(2,5,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 5,weight = 1500,select_least = 0,reward_content = [{0,261005,1}]};

get_toy_forge_content_cfg(2,6,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 6,weight = 1200,select_least = 0,reward_content = [{0,262001,1}]};

get_toy_forge_content_cfg(2,7,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 7,weight = 1200,select_least = 0,reward_content = [{0,262002,1}]};

get_toy_forge_content_cfg(2,8,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 8,weight = 1200,select_least = 0,reward_content = [{0,262003,1}]};

get_toy_forge_content_cfg(2,9,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 9,weight = 1200,select_least = 0,reward_content = [{0,262004,1}]};

get_toy_forge_content_cfg(2,10,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 10,weight = 1200,select_least = 0,reward_content = [{0,262005,1}]};

get_toy_forge_content_cfg(2,11,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 11,weight = 1000,select_least = 0,reward_content = [{0,261006,1}]};

get_toy_forge_content_cfg(2,12,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 12,weight = 1000,select_least = 0,reward_content = [{0,261007,1}]};

get_toy_forge_content_cfg(2,13,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 13,weight = 1000,select_least = 0,reward_content = [{0,261008,1}]};

get_toy_forge_content_cfg(2,14,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 14,weight = 1000,select_least = 0,reward_content = [{0,261009,1}]};

get_toy_forge_content_cfg(2,15,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 15,weight = 1000,select_least = 0,reward_content = [{0,261010,1}]};

get_toy_forge_content_cfg(2,16,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 16,weight = 1000,select_least = 0,reward_content = [{0,262006,1}]};

get_toy_forge_content_cfg(2,17,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 17,weight = 1000,select_least = 0,reward_content = [{0,262007,1}]};

get_toy_forge_content_cfg(2,18,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 18,weight = 1000,select_least = 0,reward_content = [{0,262008,1}]};

get_toy_forge_content_cfg(2,19,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 19,weight = 1000,select_least = 0,reward_content = [{0,262009,1}]};

get_toy_forge_content_cfg(2,20,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 20,weight = 1000,select_least = 0,reward_content = [{0,262010,1}]};

get_toy_forge_content_cfg(2,21,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 21,weight = 900,select_least = 0,reward_content = [{0,263001,1}]};

get_toy_forge_content_cfg(2,22,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 22,weight = 900,select_least = 0,reward_content = [{0,263002,1}]};

get_toy_forge_content_cfg(2,23,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 23,weight = 900,select_least = 0,reward_content = [{0,263003,1}]};

get_toy_forge_content_cfg(2,24,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 24,weight = 900,select_least = 0,reward_content = [{0,263004,1}]};

get_toy_forge_content_cfg(2,25,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 25,weight = 900,select_least = 0,reward_content = [{0,263005,1}]};

get_toy_forge_content_cfg(2,26,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 26,weight = 800,select_least = 0,reward_content = [{0,263006,1}]};

get_toy_forge_content_cfg(2,27,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 27,weight = 800,select_least = 0,reward_content = [{0,263007,1}]};

get_toy_forge_content_cfg(2,28,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 28,weight = 800,select_least = 0,reward_content = [{0,263008,1}]};

get_toy_forge_content_cfg(2,29,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 29,weight = 800,select_least = 0,reward_content = [{0,263009,1}]};

get_toy_forge_content_cfg(2,30,0) ->
    #toy_forge_content_cfg{id = 2,reward_id = 30,weight = 800,select_least = 0,reward_content = [{0,263010,1}]};

get_toy_forge_content_cfg(2,31,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 31,weight = 400,select_least = 20,reward_content = [{0,264001,1}]};

get_toy_forge_content_cfg(2,32,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 32,weight = 400,select_least = 20,reward_content = [{0,264002,1}]};

get_toy_forge_content_cfg(2,33,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 33,weight = 400,select_least = 20,reward_content = [{0,264003,1}]};

get_toy_forge_content_cfg(2,34,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 34,weight = 400,select_least = 20,reward_content = [{0,264004,1}]};

get_toy_forge_content_cfg(2,35,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 35,weight = 400,select_least = 20,reward_content = [{0,264005,1}]};

get_toy_forge_content_cfg(2,36,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 36,weight = 200,select_least = 20,reward_content = [{0,264006,1}]};

get_toy_forge_content_cfg(2,37,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 37,weight = 200,select_least = 20,reward_content = [{0,264007,1}]};

get_toy_forge_content_cfg(2,38,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 38,weight = 200,select_least = 20,reward_content = [{0,264008,1}]};

get_toy_forge_content_cfg(2,39,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 39,weight = 200,select_least = 20,reward_content = [{0,264009,1}]};

get_toy_forge_content_cfg(2,40,20) ->
    #toy_forge_content_cfg{id = 2,reward_id = 40,weight = 200,select_least = 20,reward_content = [{0,264010,1}]};

get_toy_forge_content_cfg(3,1,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 1,weight = 1300,select_least = 0,reward_content = [{0,261001,1}]};

get_toy_forge_content_cfg(3,2,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 2,weight = 1300,select_least = 0,reward_content = [{0,261002,1}]};

get_toy_forge_content_cfg(3,3,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 3,weight = 1300,select_least = 0,reward_content = [{0,261003,1}]};

get_toy_forge_content_cfg(3,4,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 4,weight = 1300,select_least = 0,reward_content = [{0,261004,1}]};

get_toy_forge_content_cfg(3,5,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 5,weight = 1300,select_least = 0,reward_content = [{0,261005,1}]};

get_toy_forge_content_cfg(3,6,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 6,weight = 1000,select_least = 0,reward_content = [{0,262001,1}]};

get_toy_forge_content_cfg(3,7,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 7,weight = 1000,select_least = 0,reward_content = [{0,262002,1}]};

get_toy_forge_content_cfg(3,8,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 8,weight = 1000,select_least = 0,reward_content = [{0,262003,1}]};

get_toy_forge_content_cfg(3,9,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 9,weight = 1000,select_least = 0,reward_content = [{0,262004,1}]};

get_toy_forge_content_cfg(3,10,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 10,weight = 1000,select_least = 0,reward_content = [{0,262005,1}]};

get_toy_forge_content_cfg(3,11,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 11,weight = 800,select_least = 0,reward_content = [{0,261006,1}]};

get_toy_forge_content_cfg(3,12,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 12,weight = 800,select_least = 0,reward_content = [{0,261007,1}]};

get_toy_forge_content_cfg(3,13,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 13,weight = 800,select_least = 0,reward_content = [{0,261008,1}]};

get_toy_forge_content_cfg(3,14,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 14,weight = 800,select_least = 0,reward_content = [{0,261009,1}]};

get_toy_forge_content_cfg(3,15,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 15,weight = 800,select_least = 0,reward_content = [{0,261010,1}]};

get_toy_forge_content_cfg(3,16,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 16,weight = 1100,select_least = 0,reward_content = [{0,262006,1}]};

get_toy_forge_content_cfg(3,17,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 17,weight = 1100,select_least = 0,reward_content = [{0,262007,1}]};

get_toy_forge_content_cfg(3,18,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 18,weight = 1100,select_least = 0,reward_content = [{0,262008,1}]};

get_toy_forge_content_cfg(3,19,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 19,weight = 1100,select_least = 0,reward_content = [{0,262009,1}]};

get_toy_forge_content_cfg(3,20,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 20,weight = 1100,select_least = 0,reward_content = [{0,262010,1}]};

get_toy_forge_content_cfg(3,21,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 21,weight = 1000,select_least = 0,reward_content = [{0,263001,1}]};

get_toy_forge_content_cfg(3,22,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 22,weight = 1000,select_least = 0,reward_content = [{0,263002,1}]};

get_toy_forge_content_cfg(3,23,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 23,weight = 1000,select_least = 0,reward_content = [{0,263003,1}]};

get_toy_forge_content_cfg(3,24,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 24,weight = 1000,select_least = 0,reward_content = [{0,263004,1}]};

get_toy_forge_content_cfg(3,25,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 25,weight = 1000,select_least = 0,reward_content = [{0,263005,1}]};

get_toy_forge_content_cfg(3,26,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 26,weight = 900,select_least = 0,reward_content = [{0,263006,1}]};

get_toy_forge_content_cfg(3,27,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 27,weight = 900,select_least = 0,reward_content = [{0,263007,1}]};

get_toy_forge_content_cfg(3,28,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 28,weight = 900,select_least = 0,reward_content = [{0,263008,1}]};

get_toy_forge_content_cfg(3,29,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 29,weight = 900,select_least = 0,reward_content = [{0,263009,1}]};

get_toy_forge_content_cfg(3,30,0) ->
    #toy_forge_content_cfg{id = 3,reward_id = 30,weight = 900,select_least = 0,reward_content = [{0,263010,1}]};

get_toy_forge_content_cfg(3,31,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 31,weight = 500,select_least = 20,reward_content = [{0,264001,1}]};

get_toy_forge_content_cfg(3,32,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 32,weight = 500,select_least = 20,reward_content = [{0,264002,1}]};

get_toy_forge_content_cfg(3,33,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 33,weight = 500,select_least = 20,reward_content = [{0,264003,1}]};

get_toy_forge_content_cfg(3,34,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 34,weight = 500,select_least = 20,reward_content = [{0,264004,1}]};

get_toy_forge_content_cfg(3,35,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 35,weight = 500,select_least = 20,reward_content = [{0,264005,1}]};

get_toy_forge_content_cfg(3,36,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 36,weight = 300,select_least = 20,reward_content = [{0,264006,1}]};

get_toy_forge_content_cfg(3,37,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 37,weight = 300,select_least = 20,reward_content = [{0,264007,1}]};

get_toy_forge_content_cfg(3,38,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 38,weight = 300,select_least = 20,reward_content = [{0,264008,1}]};

get_toy_forge_content_cfg(3,39,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 39,weight = 300,select_least = 20,reward_content = [{0,264009,1}]};

get_toy_forge_content_cfg(3,40,20) ->
    #toy_forge_content_cfg{id = 3,reward_id = 40,weight = 300,select_least = 20,reward_content = [{0,264010,1}]};

get_toy_forge_content_cfg(4,1,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 1,weight = 900,select_least = 0,reward_content = [{0,261001,1}]};

get_toy_forge_content_cfg(4,2,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 2,weight = 900,select_least = 0,reward_content = [{0,261002,1}]};

get_toy_forge_content_cfg(4,3,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 3,weight = 900,select_least = 0,reward_content = [{0,261003,1}]};

get_toy_forge_content_cfg(4,4,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 4,weight = 900,select_least = 0,reward_content = [{0,261004,1}]};

get_toy_forge_content_cfg(4,5,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 5,weight = 900,select_least = 0,reward_content = [{0,261005,1}]};

get_toy_forge_content_cfg(4,6,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 6,weight = 600,select_least = 0,reward_content = [{0,262001,1}]};

get_toy_forge_content_cfg(4,7,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 7,weight = 600,select_least = 0,reward_content = [{0,262002,1}]};

get_toy_forge_content_cfg(4,8,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 8,weight = 600,select_least = 0,reward_content = [{0,262003,1}]};

get_toy_forge_content_cfg(4,9,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 9,weight = 600,select_least = 0,reward_content = [{0,262004,1}]};

get_toy_forge_content_cfg(4,10,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 10,weight = 600,select_least = 0,reward_content = [{0,262005,1}]};

get_toy_forge_content_cfg(4,11,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 11,weight = 400,select_least = 0,reward_content = [{0,261006,1}]};

get_toy_forge_content_cfg(4,12,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 12,weight = 400,select_least = 0,reward_content = [{0,261007,1}]};

get_toy_forge_content_cfg(4,13,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 13,weight = 400,select_least = 0,reward_content = [{0,261008,1}]};

get_toy_forge_content_cfg(4,14,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 14,weight = 400,select_least = 0,reward_content = [{0,261009,1}]};

get_toy_forge_content_cfg(4,15,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 15,weight = 400,select_least = 0,reward_content = [{0,261010,1}]};

get_toy_forge_content_cfg(4,16,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 16,weight = 1100,select_least = 0,reward_content = [{0,262006,1}]};

get_toy_forge_content_cfg(4,17,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 17,weight = 1100,select_least = 0,reward_content = [{0,262007,1}]};

get_toy_forge_content_cfg(4,18,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 18,weight = 1100,select_least = 0,reward_content = [{0,262008,1}]};

get_toy_forge_content_cfg(4,19,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 19,weight = 1100,select_least = 0,reward_content = [{0,262009,1}]};

get_toy_forge_content_cfg(4,20,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 20,weight = 1100,select_least = 0,reward_content = [{0,262010,1}]};

get_toy_forge_content_cfg(4,21,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 21,weight = 1000,select_least = 0,reward_content = [{0,263001,1}]};

get_toy_forge_content_cfg(4,22,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 22,weight = 1000,select_least = 0,reward_content = [{0,263002,1}]};

get_toy_forge_content_cfg(4,23,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 23,weight = 1000,select_least = 0,reward_content = [{0,263003,1}]};

get_toy_forge_content_cfg(4,24,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 24,weight = 1000,select_least = 0,reward_content = [{0,263004,1}]};

get_toy_forge_content_cfg(4,25,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 25,weight = 1000,select_least = 0,reward_content = [{0,263005,1}]};

get_toy_forge_content_cfg(4,26,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 26,weight = 900,select_least = 0,reward_content = [{0,263006,1}]};

get_toy_forge_content_cfg(4,27,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 27,weight = 900,select_least = 0,reward_content = [{0,263007,1}]};

get_toy_forge_content_cfg(4,28,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 28,weight = 900,select_least = 0,reward_content = [{0,263008,1}]};

get_toy_forge_content_cfg(4,29,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 29,weight = 900,select_least = 0,reward_content = [{0,263009,1}]};

get_toy_forge_content_cfg(4,30,0) ->
    #toy_forge_content_cfg{id = 4,reward_id = 30,weight = 900,select_least = 0,reward_content = [{0,263010,1}]};

get_toy_forge_content_cfg(4,31,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 31,weight = 600,select_least = 10,reward_content = [{0,264001,1}]};

get_toy_forge_content_cfg(4,32,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 32,weight = 600,select_least = 10,reward_content = [{0,264002,1}]};

get_toy_forge_content_cfg(4,33,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 33,weight = 600,select_least = 10,reward_content = [{0,264003,1}]};

get_toy_forge_content_cfg(4,34,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 34,weight = 600,select_least = 10,reward_content = [{0,264004,1}]};

get_toy_forge_content_cfg(4,35,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 35,weight = 600,select_least = 10,reward_content = [{0,264005,1}]};

get_toy_forge_content_cfg(4,36,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 36,weight = 400,select_least = 10,reward_content = [{0,264006,1}]};

get_toy_forge_content_cfg(4,37,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 37,weight = 400,select_least = 10,reward_content = [{0,264007,1}]};

get_toy_forge_content_cfg(4,38,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 38,weight = 400,select_least = 10,reward_content = [{0,264008,1}]};

get_toy_forge_content_cfg(4,39,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 39,weight = 400,select_least = 10,reward_content = [{0,264009,1}]};

get_toy_forge_content_cfg(4,40,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 40,weight = 400,select_least = 10,reward_content = [{0,264010,1}]};

get_toy_forge_content_cfg(4,41,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 41,weight = 200,select_least = 10,reward_content = [{0,265001,1}]};

get_toy_forge_content_cfg(4,42,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 42,weight = 200,select_least = 10,reward_content = [{0,265002,1}]};

get_toy_forge_content_cfg(4,43,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 43,weight = 200,select_least = 10,reward_content = [{0,265003,1}]};

get_toy_forge_content_cfg(4,44,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 44,weight = 200,select_least = 10,reward_content = [{0,265004,1}]};

get_toy_forge_content_cfg(4,45,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 45,weight = 200,select_least = 10,reward_content = [{0,265005,1}]};

get_toy_forge_content_cfg(4,46,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 46,weight = 100,select_least = 10,reward_content = [{0,265006,1}]};

get_toy_forge_content_cfg(4,47,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 47,weight = 100,select_least = 10,reward_content = [{0,265007,1}]};

get_toy_forge_content_cfg(4,48,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 48,weight = 100,select_least = 10,reward_content = [{0,265008,1}]};

get_toy_forge_content_cfg(4,49,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 49,weight = 100,select_least = 10,reward_content = [{0,265009,1}]};

get_toy_forge_content_cfg(4,50,10) ->
    #toy_forge_content_cfg{id = 4,reward_id = 50,weight = 100,select_least = 10,reward_content = [{0,265010,1}]};

get_toy_forge_content_cfg(5,1,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 1,weight = 200,select_least = 0,reward_content = [{0,261001,1}]};

get_toy_forge_content_cfg(5,2,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 2,weight = 200,select_least = 0,reward_content = [{0,261002,1}]};

get_toy_forge_content_cfg(5,3,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 3,weight = 200,select_least = 0,reward_content = [{0,261003,1}]};

get_toy_forge_content_cfg(5,4,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 4,weight = 200,select_least = 0,reward_content = [{0,261004,1}]};

get_toy_forge_content_cfg(5,5,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 5,weight = 200,select_least = 0,reward_content = [{0,261005,1}]};

get_toy_forge_content_cfg(5,6,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 6,weight = 200,select_least = 0,reward_content = [{0,262001,1}]};

get_toy_forge_content_cfg(5,7,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 7,weight = 200,select_least = 0,reward_content = [{0,262002,1}]};

get_toy_forge_content_cfg(5,8,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 8,weight = 200,select_least = 0,reward_content = [{0,262003,1}]};

get_toy_forge_content_cfg(5,9,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 9,weight = 200,select_least = 0,reward_content = [{0,262004,1}]};

get_toy_forge_content_cfg(5,10,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 10,weight = 200,select_least = 0,reward_content = [{0,262005,1}]};

get_toy_forge_content_cfg(5,11,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 11,weight = 200,select_least = 0,reward_content = [{0,261006,1}]};

get_toy_forge_content_cfg(5,12,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 12,weight = 200,select_least = 0,reward_content = [{0,261007,1}]};

get_toy_forge_content_cfg(5,13,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 13,weight = 200,select_least = 0,reward_content = [{0,261008,1}]};

get_toy_forge_content_cfg(5,14,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 14,weight = 200,select_least = 0,reward_content = [{0,261009,1}]};

get_toy_forge_content_cfg(5,15,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 15,weight = 200,select_least = 0,reward_content = [{0,261010,1}]};

get_toy_forge_content_cfg(5,16,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 16,weight = 200,select_least = 0,reward_content = [{0,262006,1}]};

get_toy_forge_content_cfg(5,17,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 17,weight = 200,select_least = 0,reward_content = [{0,262007,1}]};

get_toy_forge_content_cfg(5,18,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 18,weight = 200,select_least = 0,reward_content = [{0,262008,1}]};

get_toy_forge_content_cfg(5,19,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 19,weight = 200,select_least = 0,reward_content = [{0,262009,1}]};

get_toy_forge_content_cfg(5,20,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 20,weight = 200,select_least = 0,reward_content = [{0,262010,1}]};

get_toy_forge_content_cfg(5,21,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 21,weight = 1100,select_least = 0,reward_content = [{0,263001,1}]};

get_toy_forge_content_cfg(5,22,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 22,weight = 1100,select_least = 0,reward_content = [{0,263002,1}]};

get_toy_forge_content_cfg(5,23,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 23,weight = 1100,select_least = 0,reward_content = [{0,263003,1}]};

get_toy_forge_content_cfg(5,24,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 24,weight = 1100,select_least = 0,reward_content = [{0,263004,1}]};

get_toy_forge_content_cfg(5,25,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 25,weight = 1100,select_least = 0,reward_content = [{0,263005,1}]};

get_toy_forge_content_cfg(5,26,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 26,weight = 1000,select_least = 0,reward_content = [{0,263006,1}]};

get_toy_forge_content_cfg(5,27,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 27,weight = 1000,select_least = 0,reward_content = [{0,263007,1}]};

get_toy_forge_content_cfg(5,28,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 28,weight = 1000,select_least = 0,reward_content = [{0,263008,1}]};

get_toy_forge_content_cfg(5,29,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 29,weight = 1000,select_least = 0,reward_content = [{0,263009,1}]};

get_toy_forge_content_cfg(5,30,0) ->
    #toy_forge_content_cfg{id = 5,reward_id = 30,weight = 1000,select_least = 0,reward_content = [{0,263010,1}]};

get_toy_forge_content_cfg(5,31,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 31,weight = 700,select_least = 10,reward_content = [{0,264001,1}]};

get_toy_forge_content_cfg(5,32,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 32,weight = 700,select_least = 10,reward_content = [{0,264002,1}]};

get_toy_forge_content_cfg(5,33,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 33,weight = 700,select_least = 10,reward_content = [{0,264003,1}]};

get_toy_forge_content_cfg(5,34,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 34,weight = 700,select_least = 10,reward_content = [{0,264004,1}]};

get_toy_forge_content_cfg(5,35,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 35,weight = 700,select_least = 10,reward_content = [{0,264005,1}]};

get_toy_forge_content_cfg(5,36,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 36,weight = 500,select_least = 10,reward_content = [{0,264006,1}]};

get_toy_forge_content_cfg(5,37,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 37,weight = 500,select_least = 10,reward_content = [{0,264007,1}]};

get_toy_forge_content_cfg(5,38,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 38,weight = 500,select_least = 10,reward_content = [{0,264008,1}]};

get_toy_forge_content_cfg(5,39,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 39,weight = 500,select_least = 10,reward_content = [{0,264009,1}]};

get_toy_forge_content_cfg(5,40,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 40,weight = 500,select_least = 10,reward_content = [{0,264010,1}]};

get_toy_forge_content_cfg(5,41,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 41,weight = 300,select_least = 10,reward_content = [{0,265001,1}]};

get_toy_forge_content_cfg(5,42,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 42,weight = 300,select_least = 10,reward_content = [{0,265002,1}]};

get_toy_forge_content_cfg(5,43,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 43,weight = 300,select_least = 10,reward_content = [{0,265003,1}]};

get_toy_forge_content_cfg(5,44,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 44,weight = 300,select_least = 10,reward_content = [{0,265004,1}]};

get_toy_forge_content_cfg(5,45,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 45,weight = 300,select_least = 10,reward_content = [{0,265005,1}]};

get_toy_forge_content_cfg(5,46,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 46,weight = 200,select_least = 10,reward_content = [{0,265006,1}]};

get_toy_forge_content_cfg(5,47,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 47,weight = 200,select_least = 10,reward_content = [{0,265007,1}]};

get_toy_forge_content_cfg(5,48,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 48,weight = 200,select_least = 10,reward_content = [{0,265008,1}]};

get_toy_forge_content_cfg(5,49,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 49,weight = 200,select_least = 10,reward_content = [{0,265009,1}]};

get_toy_forge_content_cfg(5,50,10) ->
    #toy_forge_content_cfg{id = 5,reward_id = 50,weight = 200,select_least = 10,reward_content = [{0,265010,1}]};

get_toy_forge_content_cfg(6,1,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 1,weight = 200,select_least = 0,reward_content = [{0,262006,1}]};

get_toy_forge_content_cfg(6,2,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 2,weight = 200,select_least = 0,reward_content = [{0,262007,1}]};

get_toy_forge_content_cfg(6,3,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 3,weight = 200,select_least = 0,reward_content = [{0,262008,1}]};

get_toy_forge_content_cfg(6,4,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 4,weight = 200,select_least = 0,reward_content = [{0,262009,1}]};

get_toy_forge_content_cfg(6,5,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 5,weight = 200,select_least = 0,reward_content = [{0,262010,1}]};

get_toy_forge_content_cfg(6,6,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 6,weight = 1100,select_least = 0,reward_content = [{0,263001,1}]};

get_toy_forge_content_cfg(6,7,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 7,weight = 1100,select_least = 0,reward_content = [{0,263002,1}]};

get_toy_forge_content_cfg(6,8,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 8,weight = 1100,select_least = 0,reward_content = [{0,263003,1}]};

get_toy_forge_content_cfg(6,9,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 9,weight = 1100,select_least = 0,reward_content = [{0,263004,1}]};

get_toy_forge_content_cfg(6,10,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 10,weight = 1100,select_least = 0,reward_content = [{0,263005,1}]};

get_toy_forge_content_cfg(6,11,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 11,weight = 1000,select_least = 0,reward_content = [{0,263006,1}]};

get_toy_forge_content_cfg(6,12,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 12,weight = 1000,select_least = 0,reward_content = [{0,263007,1}]};

get_toy_forge_content_cfg(6,13,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 13,weight = 1000,select_least = 0,reward_content = [{0,263008,1}]};

get_toy_forge_content_cfg(6,14,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 14,weight = 1000,select_least = 0,reward_content = [{0,263009,1}]};

get_toy_forge_content_cfg(6,15,0) ->
    #toy_forge_content_cfg{id = 6,reward_id = 15,weight = 1000,select_least = 0,reward_content = [{0,263010,1}]};

get_toy_forge_content_cfg(6,16,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 16,weight = 700,select_least = 10,reward_content = [{0,264001,1}]};

get_toy_forge_content_cfg(6,17,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 17,weight = 700,select_least = 10,reward_content = [{0,264002,1}]};

get_toy_forge_content_cfg(6,18,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 18,weight = 700,select_least = 10,reward_content = [{0,264003,1}]};

get_toy_forge_content_cfg(6,19,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 19,weight = 700,select_least = 10,reward_content = [{0,264004,1}]};

get_toy_forge_content_cfg(6,20,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 20,weight = 700,select_least = 10,reward_content = [{0,264005,1}]};

get_toy_forge_content_cfg(6,21,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 21,weight = 500,select_least = 10,reward_content = [{0,264006,1}]};

get_toy_forge_content_cfg(6,22,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 22,weight = 500,select_least = 10,reward_content = [{0,264007,1}]};

get_toy_forge_content_cfg(6,23,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 23,weight = 500,select_least = 10,reward_content = [{0,264008,1}]};

get_toy_forge_content_cfg(6,24,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 24,weight = 500,select_least = 10,reward_content = [{0,264009,1}]};

get_toy_forge_content_cfg(6,25,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 25,weight = 500,select_least = 10,reward_content = [{0,264010,1}]};

get_toy_forge_content_cfg(6,26,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 26,weight = 500,select_least = 10,reward_content = [{0,265001,1}]};

get_toy_forge_content_cfg(6,27,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 27,weight = 500,select_least = 10,reward_content = [{0,265002,1}]};

get_toy_forge_content_cfg(6,28,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 28,weight = 500,select_least = 10,reward_content = [{0,265003,1}]};

get_toy_forge_content_cfg(6,29,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 29,weight = 500,select_least = 10,reward_content = [{0,265004,1}]};

get_toy_forge_content_cfg(6,30,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 30,weight = 500,select_least = 10,reward_content = [{0,265005,1}]};

get_toy_forge_content_cfg(6,31,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 31,weight = 500,select_least = 10,reward_content = [{0,265006,1}]};

get_toy_forge_content_cfg(6,32,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 32,weight = 500,select_least = 10,reward_content = [{0,265007,1}]};

get_toy_forge_content_cfg(6,33,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 33,weight = 500,select_least = 10,reward_content = [{0,265008,1}]};

get_toy_forge_content_cfg(6,34,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 34,weight = 500,select_least = 10,reward_content = [{0,265009,1}]};

get_toy_forge_content_cfg(6,35,10) ->
    #toy_forge_content_cfg{id = 6,reward_id = 35,weight = 500,select_least = 10,reward_content = [{0,265010,1}]};

get_toy_forge_content_cfg(_Id,_Rewardid,_Selectleast) ->
    [].

get_all_least_count_cfg() ->
    [0,20,10].


get_reward_by_id_cfg(1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40];


get_reward_by_id_cfg(2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40];


get_reward_by_id_cfg(3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40];


get_reward_by_id_cfg(4) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50];


get_reward_by_id_cfg(5) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50];


get_reward_by_id_cfg(6) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35];

get_reward_by_id_cfg(_Id) ->
    [].

get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 0, SpeedTime =< 60 ->
		[];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 61, SpeedTime =< 300 ->
		[{1,50}];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 301, SpeedTime =< 600 ->
		[{1,100}];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 601, SpeedTime =< 1200 ->
		[{1,150}];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 1201, SpeedTime =< 1800 ->
		[{1,200}];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 1801, SpeedTime =< 2400 ->
		[{1,250}];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 2401, SpeedTime =< 3000 ->
		[{1,300}];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 3001, SpeedTime =< 3600 ->
		[{1,350}];
get_toy_speed_up_cfg(SpeedTime) when SpeedTime >= 3601, SpeedTime =< 9999 ->
		[{1,400}];
get_toy_speed_up_cfg(_SpeedTime) ->
    [].


get_toy_slot_open_cfg(1) ->
    [{free,0}];


get_toy_slot_open_cfg(2) ->
    [{child_age,1}];


get_toy_slot_open_cfg(3) ->
    [{child_age,2}];


get_toy_slot_open_cfg(4) ->
    [{child_age,3}];


get_toy_slot_open_cfg(5) ->
    [{child_age,5}];


get_toy_slot_open_cfg(6) ->
    [{child_age,7}];

get_toy_slot_open_cfg(_Slotid) ->
    [].

get_child_fashion_cfg(260201,1) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 1,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,5}],attr_list = [{1,1600},{2,16000},{4,800}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,2) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 2,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,10}],attr_list = [{1,3200},{2,32000},{4,1600}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,3) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 3,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,15}],attr_list = [{1,6400},{2,64000},{4,3200}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,4) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 4,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,20}],attr_list = [{1,11200},{2,112000},{4,5600}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,5) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 5,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,25}],attr_list = [{1,17600},{2,176000},{4,8800}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,6) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 6,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,30}],attr_list = [{1,25600},{2,256000},{4,12800}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,7) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 7,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,35}],attr_list = [{1,33600},{2,336000},{4,16800}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,8) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 8,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,40}],attr_list = [{1,41600},{2,416000},{4,20800}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,9) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 9,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,45}],attr_list = [{1,49600},{2,496000},{4,24800}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260201,10) ->
    #child_fashion_cfg{fashion_id = 260201,lv = 10,fashion_type = 1,fashion_name = "运动气质",upgrade_cost = [{0,260201,50}],attr_list = [{1,57600},{2,576000},{4,28800}],model_id = [{1,1031},{2,1032}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,1) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 1,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,5}],attr_list = [{1,1600},{2,16000},{4,800}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,2) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 2,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,10}],attr_list = [{1,3200},{2,32000},{4,1600}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,3) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 3,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,15}],attr_list = [{1,6400},{2,64000},{4,3200}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,4) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 4,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,20}],attr_list = [{1,11200},{2,112000},{4,5600}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,5) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 5,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,25}],attr_list = [{1,17600},{2,176000},{4,8800}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,6) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 6,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,30}],attr_list = [{1,25600},{2,256000},{4,12800}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,7) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 7,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,35}],attr_list = [{1,33600},{2,336000},{4,16800}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,8) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 8,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,40}],attr_list = [{1,41600},{2,416000},{4,20800}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,9) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 9,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,45}],attr_list = [{1,49600},{2,496000},{4,24800}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260202,10) ->
    #child_fashion_cfg{fashion_id = 260202,lv = 10,fashion_type = 1,fashion_name = "英伦风潮",upgrade_cost = [{0,260202,50}],attr_list = [{1,57600},{2,576000},{4,28800}],model_id = [{1,1041},{2,1042}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,1) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 1,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,5}],attr_list = [{1,1600},{2,16000},{4,800}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,2) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 2,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,10}],attr_list = [{1,3200},{2,32000},{4,1600}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,3) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 3,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,15}],attr_list = [{1,6400},{2,64000},{4,3200}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,4) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 4,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,20}],attr_list = [{1,11200},{2,112000},{4,5600}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,5) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 5,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,25}],attr_list = [{1,17600},{2,176000},{4,8800}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,6) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 6,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,30}],attr_list = [{1,25600},{2,256000},{4,12800}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,7) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 7,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,35}],attr_list = [{1,33600},{2,336000},{4,16800}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,8) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 8,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,40}],attr_list = [{1,41600},{2,416000},{4,20800}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,9) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 9,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,45}],attr_list = [{1,49600},{2,496000},{4,24800}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260203,10) ->
    #child_fashion_cfg{fashion_id = 260203,lv = 10,fashion_type = 1,fashion_name = "炎炎夏日",upgrade_cost = [{0,260203,50}],attr_list = [{1,57600},{2,576000},{4,28800}],model_id = [{1,1051},{2,1052}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {409,0},desc = "运营获得获得"};

get_child_fashion_cfg(260204,1) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 1,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,5}],attr_list = [{1,1600},{2,16000},{4,800}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,2) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 2,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,10}],attr_list = [{1,3200},{2,32000},{4,1600}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,3) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 3,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,15}],attr_list = [{1,6400},{2,64000},{4,3200}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,4) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 4,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,20}],attr_list = [{1,11200},{2,112000},{4,5600}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,5) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 5,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,25}],attr_list = [{1,17600},{2,176000},{4,8800}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,6) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 6,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,30}],attr_list = [{1,25600},{2,256000},{4,12800}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,7) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 7,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,35}],attr_list = [{1,33600},{2,336000},{4,16800}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,8) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 8,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,40}],attr_list = [{1,41600},{2,416000},{4,20800}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,9) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 9,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,45}],attr_list = [{1,49600},{2,496000},{4,24800}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(260204,10) ->
    #child_fashion_cfg{fashion_id = 260204,lv = 10,fashion_type = 1,fashion_name = "人小鬼大",upgrade_cost = [{0,260204,50}],attr_list = [{1,57600},{2,576000},{4,28800}],model_id = [{1,1061},{2,1062}],buy_type = 1,buy_price = {},add_carry_weight = 0,client_skip = {153,1},desc = "运营获得获得"};

get_child_fashion_cfg(_Fashionid,_Lv) ->
    [].

get_all_fashion() ->
    [260201,260202,260203,260204].


get_toy_forge_slot_cfg(1) ->
    [];


get_toy_forge_slot_cfg(2) ->
    [];


get_toy_forge_slot_cfg(3) ->
    [{1,500}];


get_toy_forge_slot_cfg(4) ->
    [{1,1500}];

get_toy_forge_slot_cfg(_Slotid) ->
    [].

get_toy_suit_cfg(1) ->
    #child_toy_suit_cfg{suit_type = 1,suit_name = "机人都市",sequence = 1,collect_reward = [{0,260004,2},{0,260006,10}]};

get_toy_suit_cfg(2) ->
    #child_toy_suit_cfg{suit_type = 2,suit_name = "绒绒萌物",sequence = 2,collect_reward = [{0,260004,3},{0,260006,15}]};

get_toy_suit_cfg(3) ->
    #child_toy_suit_cfg{suit_type = 3,suit_name = "乐队战士",sequence = 3,collect_reward = [{0,260004,5},{0,260006,20}]};

get_toy_suit_cfg(4) ->
    #child_toy_suit_cfg{suit_type = 4,suit_name = "发条国度",sequence = 4,collect_reward = [{0,260004,10},{0,260006,25}]};

get_toy_suit_cfg(5) ->
    #child_toy_suit_cfg{suit_type = 5,suit_name = "午后甜点",sequence = 5,collect_reward = [{0,260004,15},{0,260006,30}]};

get_toy_suit_cfg(_Suittype) ->
    [].

get_all_toy_suit_cfg() ->
    [1,2,3,4,5].

get_child_toy_new_cfg(261001) ->
    #child_toy_new_cfg{toy_id = 261001,toy_name = "汽车机器人",suit_type = 1,color = 1,attr_list = [{1,40},{2,400},{4,20}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(261002) ->
    #child_toy_new_cfg{toy_id = 261002,toy_name = "火车机器人",suit_type = 1,color = 2,attr_list = [{1,80},{2,800},{4,40}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(261003) ->
    #child_toy_new_cfg{toy_id = 261003,toy_name = "飞机机器人",suit_type = 1,color = 3,attr_list = [{1,160},{2,1600},{4,80}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(261004) ->
    #child_toy_new_cfg{toy_id = 261004,toy_name = "轮船机器人",suit_type = 1,color = 3,attr_list = [{1,160},{2,1600},{4,80}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(261005) ->
    #child_toy_new_cfg{toy_id = 261005,toy_name = "潜艇机器人",suit_type = 1,color = 4,attr_list = [{1,400},{2,4000},{4,200}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(261006) ->
    #child_toy_new_cfg{toy_id = 261006,toy_name = "火箭机器人",suit_type = 1,color = 4,attr_list = [{1,400},{2,4000},{4,200}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(261007) ->
    #child_toy_new_cfg{toy_id = 261007,toy_name = "飞碟机器人",suit_type = 1,color = 5,attr_list = [{1,800},{2,8000},{4,400}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(261008) ->
    #child_toy_new_cfg{toy_id = 261008,toy_name = "挖掘机器人",suit_type = 1,color = 5,attr_list = [{1,800},{2,8000},{4,400}],decompose_reward = [{23,260007,100}]};

get_child_toy_new_cfg(262001) ->
    #child_toy_new_cfg{toy_id = 262001,toy_name = "毛绒绒兔子",suit_type = 2,color = 1,attr_list = [{1,38},{2,420},{4,7}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(262002) ->
    #child_toy_new_cfg{toy_id = 262002,toy_name = "毛绒绒小熊",suit_type = 2,color = 2,attr_list = [{1,76},{2,840},{4,13}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(262003) ->
    #child_toy_new_cfg{toy_id = 262003,toy_name = "毛绒绒绵羊",suit_type = 2,color = 3,attr_list = [{1,152},{2,1680},{4,27}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(262004) ->
    #child_toy_new_cfg{toy_id = 262004,toy_name = "毛绒绒狐狸",suit_type = 2,color = 3,attr_list = [{1,152},{2,1680},{4,27}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(262005) ->
    #child_toy_new_cfg{toy_id = 262005,toy_name = "毛绒绒小狗",suit_type = 2,color = 4,attr_list = [{1,380},{2,4200},{4,67}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(262006) ->
    #child_toy_new_cfg{toy_id = 262006,toy_name = "毛绒绒猫咪",suit_type = 2,color = 4,attr_list = [{1,380},{2,4200},{4,67}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(262007) ->
    #child_toy_new_cfg{toy_id = 262007,toy_name = "毛绒绒大马",suit_type = 2,color = 5,attr_list = [{1,760},{2,8400},{4,133}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(262008) ->
    #child_toy_new_cfg{toy_id = 262008,toy_name = "毛绒绒狮子",suit_type = 2,color = 5,attr_list = [{1,760},{2,8400},{4,133}],decompose_reward = [{23,260007,100}]};

get_child_toy_new_cfg(263001) ->
    #child_toy_new_cfg{toy_id = 263001,toy_name = "圆号战士",suit_type = 3,color = 1,attr_list = [{1,40},{2,450},{4,15}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(263002) ->
    #child_toy_new_cfg{toy_id = 263002,toy_name = "单簧管战士",suit_type = 3,color = 2,attr_list = [{1,80},{2,900},{4,30}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(263003) ->
    #child_toy_new_cfg{toy_id = 263003,toy_name = "贝司战士",suit_type = 3,color = 3,attr_list = [{1,160},{2,1800},{4,60}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(263004) ->
    #child_toy_new_cfg{toy_id = 263004,toy_name = "萨克斯战士",suit_type = 3,color = 3,attr_list = [{1,160},{2,1800},{4,60}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(263005) ->
    #child_toy_new_cfg{toy_id = 263005,toy_name = "架子鼓战士",suit_type = 3,color = 4,attr_list = [{1,400},{2,4500},{4,150}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(263006) ->
    #child_toy_new_cfg{toy_id = 263006,toy_name = "吉他战士",suit_type = 3,color = 4,attr_list = [{1,400},{2,4500},{4,150}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(263007) ->
    #child_toy_new_cfg{toy_id = 263007,toy_name = "钢琴战士",suit_type = 3,color = 5,attr_list = [{1,800},{2,9000},{4,300}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(263008) ->
    #child_toy_new_cfg{toy_id = 263008,toy_name = "大提琴战士",suit_type = 3,color = 5,attr_list = [{1,800},{2,9000},{4,300}],decompose_reward = [{23,260007,100}]};

get_child_toy_new_cfg(264001) ->
    #child_toy_new_cfg{toy_id = 264001,toy_name = "发条青蛙",suit_type = 4,color = 1,attr_list = [{1,40},{2,500},{5,5}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(264002) ->
    #child_toy_new_cfg{toy_id = 264002,toy_name = "发条蜗牛",suit_type = 4,color = 2,attr_list = [{1,80},{2,1000},{5,10}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(264003) ->
    #child_toy_new_cfg{toy_id = 264003,toy_name = "发条蝙蝠",suit_type = 4,color = 3,attr_list = [{1,160},{2,2000},{5,20}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(264004) ->
    #child_toy_new_cfg{toy_id = 264004,toy_name = "发条法师",suit_type = 4,color = 3,attr_list = [{1,160},{2,2000},{5,20}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(264005) ->
    #child_toy_new_cfg{toy_id = 264005,toy_name = "发条战士",suit_type = 4,color = 4,attr_list = [{1,400},{2,5000},{5,50}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(264006) ->
    #child_toy_new_cfg{toy_id = 264006,toy_name = "发条国王",suit_type = 4,color = 4,attr_list = [{1,400},{2,5000},{5,50}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(264007) ->
    #child_toy_new_cfg{toy_id = 264007,toy_name = "发条火车",suit_type = 4,color = 5,attr_list = [{1,800},{2,10000},{5,100}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(264008) ->
    #child_toy_new_cfg{toy_id = 264008,toy_name = "发条巨舰",suit_type = 4,color = 5,attr_list = [{1,800},{2,10000},{5,100}],decompose_reward = [{23,260007,100}]};

get_child_toy_new_cfg(265001) ->
    #child_toy_new_cfg{toy_id = 265001,toy_name = "泡芙甜点",suit_type = 5,color = 1,attr_list = [{1,42},{2,400},{8,6}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(265002) ->
    #child_toy_new_cfg{toy_id = 265002,toy_name = "布丁甜点",suit_type = 5,color = 2,attr_list = [{1,84},{2,800},{8,12}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(265003) ->
    #child_toy_new_cfg{toy_id = 265003,toy_name = "水果挞甜点",suit_type = 5,color = 3,attr_list = [{1,168},{2,1600},{8,24}],decompose_reward = [{23,260007,10}]};

get_child_toy_new_cfg(265004) ->
    #child_toy_new_cfg{toy_id = 265004,toy_name = "巧克力甜点",suit_type = 5,color = 3,attr_list = [{1,168},{2,1600},{8,24}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(265005) ->
    #child_toy_new_cfg{toy_id = 265005,toy_name = "华夫饼甜点",suit_type = 5,color = 4,attr_list = [{1,420},{2,4000},{8,60}],decompose_reward = [{23,260007,20}]};

get_child_toy_new_cfg(265006) ->
    #child_toy_new_cfg{toy_id = 265006,toy_name = "千层酥甜点",suit_type = 5,color = 4,attr_list = [{1,420},{2,4000},{8,60}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(265007) ->
    #child_toy_new_cfg{toy_id = 265007,toy_name = "铜锣烧甜点",suit_type = 5,color = 5,attr_list = [{1,840},{2,8000},{8,120}],decompose_reward = [{23,260007,50}]};

get_child_toy_new_cfg(265008) ->
    #child_toy_new_cfg{toy_id = 265008,toy_name = "马卡龙甜点",suit_type = 5,color = 5,attr_list = [{1,840},{2,8000},{8,120}],decompose_reward = [{23,260007,100}]};

get_child_toy_new_cfg(_Toyid) ->
    [].


get_suit_all_toy_cfg(1) ->
    [261001,261002,261003,261004,261005,261006,261007,261008];


get_suit_all_toy_cfg(2) ->
    [262001,262002,262003,262004,262005,262006,262007,262008];


get_suit_all_toy_cfg(3) ->
    [263001,263002,263003,263004,263005,263006,263007,263008];


get_suit_all_toy_cfg(4) ->
    [264001,264002,264003,264004,264005,264006,264007,264008];


get_suit_all_toy_cfg(5) ->
    [265001,265002,265003,265004,265005,265006,265007,265008];

get_suit_all_toy_cfg(_Suittype) ->
    [].

get_child_toy_box_upgrade_cfg(0) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 0,next_cost = [{23,260007,10}],add_attr = [{1,16},{2,160},{4,8}]};

get_child_toy_box_upgrade_cfg(1) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 1,next_cost = [{23,260007,15}],add_attr = [{1,32},{2,320},{4,16}]};

get_child_toy_box_upgrade_cfg(2) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 2,next_cost = [{23,260007,20}],add_attr = [{1,48},{2,480},{4,24}]};

get_child_toy_box_upgrade_cfg(3) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 3,next_cost = [{23,260007,25}],add_attr = [{1,64},{2,640},{4,32}]};

get_child_toy_box_upgrade_cfg(4) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 4,next_cost = [{23,260007,30}],add_attr = [{1,80},{2,800},{4,40}]};

get_child_toy_box_upgrade_cfg(5) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 5,next_cost = [{23,260007,35}],add_attr = [{1,96},{2,960},{4,48}]};

get_child_toy_box_upgrade_cfg(6) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 6,next_cost = [{23,260007,40}],add_attr = [{1,112},{2,1120},{4,56}]};

get_child_toy_box_upgrade_cfg(7) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 7,next_cost = [{23,260007,45}],add_attr = [{1,128},{2,1280},{4,64}]};

get_child_toy_box_upgrade_cfg(8) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 8,next_cost = [{23,260007,50}],add_attr = [{1,144},{2,1440},{4,72}]};

get_child_toy_box_upgrade_cfg(9) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 9,next_cost = [{23,260007,60}],add_attr = [{1,160},{2,1600},{4,80}]};

get_child_toy_box_upgrade_cfg(10) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 10,next_cost = [{23,260007,70}],add_attr = [{1,176},{2,1760},{4,88}]};

get_child_toy_box_upgrade_cfg(11) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 11,next_cost = [{23,260007,80}],add_attr = [{1,192},{2,1920},{4,96}]};

get_child_toy_box_upgrade_cfg(12) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 12,next_cost = [{23,260007,90}],add_attr = [{1,208},{2,2080},{4,104}]};

get_child_toy_box_upgrade_cfg(13) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 13,next_cost = [{23,260007,100}],add_attr = [{1,224},{2,2240},{4,112}]};

get_child_toy_box_upgrade_cfg(14) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 14,next_cost = [{23,260007,110}],add_attr = [{1,240},{2,2400},{4,120}]};

get_child_toy_box_upgrade_cfg(15) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 15,next_cost = [{23,260007,120}],add_attr = [{1,256},{2,2560},{4,128}]};

get_child_toy_box_upgrade_cfg(16) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 16,next_cost = [{23,260007,130}],add_attr = [{1,272},{2,2720},{4,136}]};

get_child_toy_box_upgrade_cfg(17) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 17,next_cost = [{23,260007,140}],add_attr = [{1,288},{2,2880},{4,144}]};

get_child_toy_box_upgrade_cfg(18) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 18,next_cost = [{23,260007,150}],add_attr = [{1,304},{2,3040},{4,152}]};

get_child_toy_box_upgrade_cfg(19) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 19,next_cost = [{23,260007,160}],add_attr = [{1,320},{2,3200},{4,160}]};

get_child_toy_box_upgrade_cfg(20) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 20,next_cost = [{23,260007,170}],add_attr = [{1,336},{2,3360},{4,168}]};

get_child_toy_box_upgrade_cfg(21) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 21,next_cost = [{23,260007,180}],add_attr = [{1,352},{2,3520},{4,176}]};

get_child_toy_box_upgrade_cfg(22) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 22,next_cost = [{23,260007,190}],add_attr = [{1,368},{2,3680},{4,184}]};

get_child_toy_box_upgrade_cfg(23) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 23,next_cost = [{23,260007,200}],add_attr = [{1,384},{2,3840},{4,192}]};

get_child_toy_box_upgrade_cfg(24) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 24,next_cost = [{23,260007,210}],add_attr = [{1,400},{2,4000},{4,200}]};

get_child_toy_box_upgrade_cfg(25) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 25,next_cost = [{23,260007,220}],add_attr = [{1,416},{2,4160},{4,208}]};

get_child_toy_box_upgrade_cfg(26) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 26,next_cost = [{23,260007,230}],add_attr = [{1,432},{2,4320},{4,216}]};

get_child_toy_box_upgrade_cfg(27) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 27,next_cost = [{23,260007,240}],add_attr = [{1,448},{2,4480},{4,224}]};

get_child_toy_box_upgrade_cfg(28) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 28,next_cost = [{23,260007,250}],add_attr = [{1,464},{2,4640},{4,232}]};

get_child_toy_box_upgrade_cfg(29) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 29,next_cost = [{23,260007,260}],add_attr = [{1,480},{2,4800},{4,240}]};

get_child_toy_box_upgrade_cfg(30) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 30,next_cost = [{23,260007,270}],add_attr = [{1,496},{2,4960},{4,248}]};

get_child_toy_box_upgrade_cfg(31) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 31,next_cost = [{23,260007,280}],add_attr = [{1,512},{2,5120},{4,256}]};

get_child_toy_box_upgrade_cfg(32) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 32,next_cost = [{23,260007,290}],add_attr = [{1,528},{2,5280},{4,264}]};

get_child_toy_box_upgrade_cfg(33) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 33,next_cost = [{23,260007,300}],add_attr = [{1,544},{2,5440},{4,272}]};

get_child_toy_box_upgrade_cfg(34) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 34,next_cost = [{23,260007,310}],add_attr = [{1,560},{2,5600},{4,280}]};

get_child_toy_box_upgrade_cfg(35) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 35,next_cost = [{23,260007,320}],add_attr = [{1,576},{2,5760},{4,288}]};

get_child_toy_box_upgrade_cfg(36) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 36,next_cost = [{23,260007,330}],add_attr = [{1,592},{2,5920},{4,296}]};

get_child_toy_box_upgrade_cfg(37) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 37,next_cost = [{23,260007,340}],add_attr = [{1,608},{2,6080},{4,304}]};

get_child_toy_box_upgrade_cfg(38) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 38,next_cost = [{23,260007,350}],add_attr = [{1,624},{2,6240},{4,312}]};

get_child_toy_box_upgrade_cfg(39) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 39,next_cost = [{23,260007,360}],add_attr = [{1,640},{2,6400},{4,320}]};

get_child_toy_box_upgrade_cfg(40) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 40,next_cost = [{23,260007,370}],add_attr = [{1,656},{2,6560},{4,328}]};

get_child_toy_box_upgrade_cfg(41) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 41,next_cost = [{23,260007,380}],add_attr = [{1,672},{2,6720},{4,336}]};

get_child_toy_box_upgrade_cfg(42) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 42,next_cost = [{23,260007,390}],add_attr = [{1,688},{2,6880},{4,344}]};

get_child_toy_box_upgrade_cfg(43) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 43,next_cost = [{23,260007,400}],add_attr = [{1,704},{2,7040},{4,352}]};

get_child_toy_box_upgrade_cfg(44) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 44,next_cost = [{23,260007,410}],add_attr = [{1,720},{2,7200},{4,360}]};

get_child_toy_box_upgrade_cfg(45) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 45,next_cost = [{23,260007,420}],add_attr = [{1,736},{2,7360},{4,368}]};

get_child_toy_box_upgrade_cfg(46) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 46,next_cost = [{23,260007,430}],add_attr = [{1,752},{2,7520},{4,376}]};

get_child_toy_box_upgrade_cfg(47) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 47,next_cost = [{23,260007,440}],add_attr = [{1,768},{2,7680},{4,384}]};

get_child_toy_box_upgrade_cfg(48) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 48,next_cost = [{23,260007,450}],add_attr = [{1,784},{2,7840},{4,392}]};

get_child_toy_box_upgrade_cfg(49) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 49,next_cost = [{23,260007,460}],add_attr = [{1,800},{2,8000},{4,400}]};

get_child_toy_box_upgrade_cfg(50) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 50,next_cost = [{23,260007,470}],add_attr = [{1,816},{2,8160},{4,408}]};

get_child_toy_box_upgrade_cfg(51) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 51,next_cost = [{23,260007,480}],add_attr = [{1,832},{2,8320},{4,416}]};

get_child_toy_box_upgrade_cfg(52) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 52,next_cost = [{23,260007,490}],add_attr = [{1,848},{2,8480},{4,424}]};

get_child_toy_box_upgrade_cfg(53) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 53,next_cost = [{23,260007,500}],add_attr = [{1,864},{2,8640},{4,432}]};

get_child_toy_box_upgrade_cfg(54) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 54,next_cost = [{23,260007,510}],add_attr = [{1,880},{2,8800},{4,440}]};

get_child_toy_box_upgrade_cfg(55) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 55,next_cost = [{23,260007,520}],add_attr = [{1,896},{2,8960},{4,448}]};

get_child_toy_box_upgrade_cfg(56) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 56,next_cost = [{23,260007,530}],add_attr = [{1,912},{2,9120},{4,456}]};

get_child_toy_box_upgrade_cfg(57) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 57,next_cost = [{23,260007,540}],add_attr = [{1,928},{2,9280},{4,464}]};

get_child_toy_box_upgrade_cfg(58) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 58,next_cost = [{23,260007,550}],add_attr = [{1,944},{2,9440},{4,472}]};

get_child_toy_box_upgrade_cfg(59) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 59,next_cost = [{23,260007,560}],add_attr = [{1,960},{2,9600},{4,480}]};

get_child_toy_box_upgrade_cfg(60) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 60,next_cost = [{23,260007,570}],add_attr = [{1,976},{2,9760},{4,488}]};

get_child_toy_box_upgrade_cfg(61) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 61,next_cost = [{23,260007,580}],add_attr = [{1,992},{2,9920},{4,496}]};

get_child_toy_box_upgrade_cfg(62) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 62,next_cost = [{23,260007,590}],add_attr = [{1,1008},{2,10080},{4,504}]};

get_child_toy_box_upgrade_cfg(63) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 63,next_cost = [{23,260007,600}],add_attr = [{1,1024},{2,10240},{4,512}]};

get_child_toy_box_upgrade_cfg(64) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 64,next_cost = [{23,260007,610}],add_attr = [{1,1040},{2,10400},{4,520}]};

get_child_toy_box_upgrade_cfg(65) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 65,next_cost = [{23,260007,620}],add_attr = [{1,1056},{2,10560},{4,528}]};

get_child_toy_box_upgrade_cfg(66) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 66,next_cost = [{23,260007,630}],add_attr = [{1,1072},{2,10720},{4,536}]};

get_child_toy_box_upgrade_cfg(67) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 67,next_cost = [{23,260007,640}],add_attr = [{1,1088},{2,10880},{4,544}]};

get_child_toy_box_upgrade_cfg(68) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 68,next_cost = [{23,260007,650}],add_attr = [{1,1104},{2,11040},{4,552}]};

get_child_toy_box_upgrade_cfg(69) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 69,next_cost = [{23,260007,660}],add_attr = [{1,1120},{2,11200},{4,560}]};

get_child_toy_box_upgrade_cfg(70) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 70,next_cost = [{23,260007,670}],add_attr = [{1,1136},{2,11360},{4,568}]};

get_child_toy_box_upgrade_cfg(71) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 71,next_cost = [{23,260007,680}],add_attr = [{1,1152},{2,11520},{4,576}]};

get_child_toy_box_upgrade_cfg(72) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 72,next_cost = [{23,260007,690}],add_attr = [{1,1168},{2,11680},{4,584}]};

get_child_toy_box_upgrade_cfg(73) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 73,next_cost = [{23,260007,700}],add_attr = [{1,1184},{2,11840},{4,592}]};

get_child_toy_box_upgrade_cfg(74) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 74,next_cost = [{23,260007,710}],add_attr = [{1,1200},{2,12000},{4,600}]};

get_child_toy_box_upgrade_cfg(75) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 75,next_cost = [{23,260007,720}],add_attr = [{1,1216},{2,12160},{4,608}]};

get_child_toy_box_upgrade_cfg(76) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 76,next_cost = [{23,260007,730}],add_attr = [{1,1232},{2,12320},{4,616}]};

get_child_toy_box_upgrade_cfg(77) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 77,next_cost = [{23,260007,740}],add_attr = [{1,1248},{2,12480},{4,624}]};

get_child_toy_box_upgrade_cfg(78) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 78,next_cost = [{23,260007,750}],add_attr = [{1,1264},{2,12640},{4,632}]};

get_child_toy_box_upgrade_cfg(79) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 79,next_cost = [{23,260007,760}],add_attr = [{1,1280},{2,12800},{4,640}]};

get_child_toy_box_upgrade_cfg(80) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 80,next_cost = [{23,260007,770}],add_attr = [{1,1296},{2,12960},{4,648}]};

get_child_toy_box_upgrade_cfg(81) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 81,next_cost = [{23,260007,780}],add_attr = [{1,1312},{2,13120},{4,656}]};

get_child_toy_box_upgrade_cfg(82) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 82,next_cost = [{23,260007,790}],add_attr = [{1,1328},{2,13280},{4,664}]};

get_child_toy_box_upgrade_cfg(83) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 83,next_cost = [{23,260007,800}],add_attr = [{1,1344},{2,13440},{4,672}]};

get_child_toy_box_upgrade_cfg(84) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 84,next_cost = [{23,260007,810}],add_attr = [{1,1360},{2,13600},{4,680}]};

get_child_toy_box_upgrade_cfg(85) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 85,next_cost = [{23,260007,820}],add_attr = [{1,1376},{2,13760},{4,688}]};

get_child_toy_box_upgrade_cfg(86) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 86,next_cost = [{23,260007,830}],add_attr = [{1,1392},{2,13920},{4,696}]};

get_child_toy_box_upgrade_cfg(87) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 87,next_cost = [{23,260007,840}],add_attr = [{1,1408},{2,14080},{4,704}]};

get_child_toy_box_upgrade_cfg(88) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 88,next_cost = [{23,260007,850}],add_attr = [{1,1424},{2,14240},{4,712}]};

get_child_toy_box_upgrade_cfg(89) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 89,next_cost = [{23,260007,860}],add_attr = [{1,1440},{2,14400},{4,720}]};

get_child_toy_box_upgrade_cfg(90) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 90,next_cost = [{23,260007,870}],add_attr = [{1,1456},{2,14560},{4,728}]};

get_child_toy_box_upgrade_cfg(91) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 91,next_cost = [{23,260007,880}],add_attr = [{1,1472},{2,14720},{4,736}]};

get_child_toy_box_upgrade_cfg(92) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 92,next_cost = [{23,260007,890}],add_attr = [{1,1488},{2,14880},{4,744}]};

get_child_toy_box_upgrade_cfg(93) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 93,next_cost = [{23,260007,900}],add_attr = [{1,1504},{2,15040},{4,752}]};

get_child_toy_box_upgrade_cfg(94) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 94,next_cost = [{23,260007,910}],add_attr = [{1,1520},{2,15200},{4,760}]};

get_child_toy_box_upgrade_cfg(95) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 95,next_cost = [{23,260007,920}],add_attr = [{1,1536},{2,15360},{4,768}]};

get_child_toy_box_upgrade_cfg(96) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 96,next_cost = [{23,260007,930}],add_attr = [{1,1552},{2,15520},{4,776}]};

get_child_toy_box_upgrade_cfg(97) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 97,next_cost = [{23,260007,940}],add_attr = [{1,1568},{2,15680},{4,784}]};

get_child_toy_box_upgrade_cfg(98) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 98,next_cost = [{23,260007,950}],add_attr = [{1,1584},{2,15840},{4,792}]};

get_child_toy_box_upgrade_cfg(99) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 99,next_cost = [{23,260007,960}],add_attr = [{1,1600},{2,16000},{4,800}]};

get_child_toy_box_upgrade_cfg(100) ->
    #child_toy_box_upgrade_cfg{toy_box_lv = 100,next_cost = [{23,260007,970}],add_attr = [{1,1616},{2,16160},{4,808}]};

get_child_toy_box_upgrade_cfg(_Toyboxlv) ->
    [].

