%%%---------------------------------------
%%% module      : data_error_code
%%% description : 错误码配置
%%%
%%%---------------------------------------
-module(data_error_code).
-compile(export_all).
-include("common.hrl").



%%操作失败
get(fail) ->
    0;

%%操作成功
get(success) ->
    1;

%%您的彩钻余额不足哦~
get(gold_not_enough) ->
    1001;

%%您的交易券余额不足哦~
get(coin_not_enough) ->
    1002;

%%物品不足
get(goods_not_enough) ->
    1003;

%%您的金额不足
get(money_not_enough) ->
    1004;

%%缺失配置
get(missing_config) ->
    1005;

%%您的红钻余额不足哦~
get(bgold_not_enough) ->
    1006;

%%经验 +{1}
get(player_add_exp) ->
    1007;

%%长度为2-6个单位
get(not_enough_length) ->
    1008;

%%该名称已存在
get(name_exist) ->
    1009;

%%非法字符
get(illegal_character) ->
    1010;

%%改名卡数量不足
get(not_have_free_card) ->
    1011;

%%等级不足，功能暂未开放
get(lv_limit) ->
    1012;

%%VIP等级不足
get(vip_limit) ->
    1013;

%%当前场景不能进入！
get(cannot_transferable_scene) ->
    1014;

%%非安全区不能进入！
get(cannot_transferable_area) ->
    1015;

%%配置出错
get(err_config) ->
    1016;

%%形象已激活
get(figure_actived) ->
    1017;

%%数据异常，请稍后再试！
get(data_error) ->
    1018;

%%格子超出上限！
get(cell_beyond) ->
    1019;

%%经验 +{1}（+{2}%）
get(player_add_exp_extra) ->
    1020;

%%您的等级小于{1}
get(player_lv_less) ->
    1021;

%%您的等级大于{1}
get(player_lv_large) ->
    1022;

%%您的操作过快
get(operation_too_quickly) ->
    1023;

%%系统繁忙，请稍后再操作
get(system_busy) ->
    1024;

%%您的荣誉值不足
get(honour_not_enough) ->
    1025;

%%玩家当前状态不能释放技能
get(in_forbid_pk_status) ->
    1026;

%%当前处于死亡状态，请复活后再操作！
get(player_die) ->
    1027;

%%奖励已领取
get(reward_is_got) ->
    1028;

%%{1}不足
get(what_not_enough) ->
    1029;

%%您的战力小于{1}
get(player_power_less) ->
    1030;

%%经验值不足
get(exp_not_enough) ->
    1031;

%%配置错误
get(config_err) ->
    1032;

%%操作无效，转生次数不足
get(turn_not_enough) ->
    1033;

%%连接不上跨服中心
get(not_connect_center) ->
    1034;

%%参数错误
get(args_error) ->
    1035;

%%您的粉钻余额不足
get(fgold_not_enough) ->
    1036;

%%羁绊点不足
get(mate_not_enough) ->
    1037;

%%背包已满，奖励已通过邮件发送
get(bag_not_enough) ->
    1038;

%%您的星钻不足
get(star_no_enough) ->
    1039;

%%当前文本暂时无法修改，请等待恢复修改功能哦~
get(txt_forbid) ->
    1040;

%%游戏设置类型不存在
get(err102_setting_key_not_exist) ->
    1020001;

%%玩家当前操作太频繁，请{1}秒后再重新操作
get(err102_too_frequent) ->
    1020002;

%%您的语音已经失效了，稍后再试试
get(err110_voice_lose_efficacy) ->
    1100001;

%%您还未达到此频道开放等级，继续加油！
get(err110_lv_limit) ->
    1100002;

%%您不能在此频道发送信息哟！
get(err110_unknow_channel) ->
    1100003;

%%聊天冷却中，稍后再试试哟！
get(err110_in_cd) ->
    1100004;

%%内容重复了！
get(err110_content_repeat) ->
    1100005;

%%次数不足
get(err110_times_not_enough) ->
    1100006;

%%无法对自己进行操作
get(err110_shield_self) ->
    1100007;

%%已屏蔽对方，不用重复操作了
get(err110_have_shield) ->
    1100008;

%%屏蔽人数已达上限
get(err110_shield_num) ->
    1100009;

%%您与对方亲密度不够，无法离线聊天哦
get(err110_intimacy_limit) ->
    1100010;

%%操作太频繁了，请过一段时间后再试试
get(err110_cmd_frequent) ->
    1100011;

%%对方被禁言，无法聊天哦
get(err110_talk_limit) ->
    1100012;

%%聊天冷却中，请{1}秒后再试。
get(err110_cd_limit) ->
    1100013;

%%内容太长了咯~
get(err110_content_len) ->
    1100014;

%%装扮不存在
get(err112_dress_not_exist) ->
    1120001;

%%装扮已激活
get(err112_dress_has_enabled) ->
    1120002;

%%装扮未激活
get(err112_dress_not_enabled) ->
    1120003;

%%未使用装扮不需要卸下
get(err112_dress_not_used) ->
    1120004;

%%装扮已经达到最高等级
get(err112_dress_max_level) ->
    1120005;

%%碎片数量必须大于零！
get(err112_debrisnum_illegal) ->
    1120006;

%%没有提供升级的碎片
get(err112_dress_arg_empty) ->
    1120007;

%%你没有选择要使用的装扮喔
get(err112_dress_not_selected) ->
    1120008;

%%不是默认装扮喔
get(err112_dress_not_default) ->
    1120009;

%%等级不足
get(err112_lv_not_satisfy) ->
    1120010;

%%装扮还没激活，暂时不能回收喔
get(err112_dress_has_not_enabled) ->
    1120011;

%%不能选择相同类型装扮哟
get(err112_dress_same_type) ->
    1120012;

%%不可再次领取
get(err114_cant_fetch_again) ->
    1140001;

%%需要先完成任务
get(err114_need_finish_task) ->
    1140002;

%%当前场景不能进入！
get(err120_cannot_transfer_scene) ->
    1200001;

%%非安全区不能进入！
get(err120_cannot_transfer_not_in_safe) ->
    1200002;

%%切换场景时间不足，请再次切换场景！
get(err120_cannot_transfer_pre_scene_time) ->
    1200003;

%%排队换线中，请稍后再切换场景！
get(err120_cannot_transfer_change_scene_sign) ->
    1200004;

%%目标场景数据不存在！
get(err120_cannot_transfer_scene_not_exist) ->
    1200005;

%%等级不足，不能切换到目标场景！
get(err120_cannot_transfer_lv_not_reach) ->
    1200006;

%%副本地图无法传送！
get(err120_cannot_transfer_in_dungeon) ->
    1200007;

%%已在当前线路
get(err120_same_line) ->
    1200008;

%%此线路玩家太多，请选择另外的线路
get(err120_too_many_people) ->
    1200009;

%%正在寻路安全区，或者脱离战斗再参加
get(err120_is_on_battle) ->
    1200010;

%%处于战斗状态无法传送
get(err120_cannot_transfer_on_battle) ->
    1200011;

%%当前场景还没有加载完，请稍后！
get(err120_scene_loading) ->
    1200012;

%%您已经在附近，不需要飞行！
get(err120_is_near) ->
    1200013;

%%正在切换场景，不能进行攻击
get(err120_cannot_battle_change_scene_sign) ->
    1200015;

%%场景人数已达上限，无法进入！
get(err120_max_user) ->
    1200016;

%%暂时不能使用小飞鞋！
get(err120_transtype) ->
    1200017;

%%已经在当前场景，无须再次进入！
get(err120_already_in_scene) ->
    1200018;

%%目标场景不可进入
get(err120_cannot_transfer_to_target_scene) ->
    1200019;

%%当前处于死亡状态，请复活后再操作！
get(err120_ghost_state_limit) ->
    1200020;

%%没有小飞鞋！
get(err120_no_fly_shoes) ->
    1200021;

%%换线中，不能切换战斗状态
get(err130_change_pk_change_line) ->
    1300001;

%%和平状态切换正在冷却中
get(err130_change_pk_cd) ->
    1300002;

%%此场景不能手动切换战斗模式
get(err130_user_cant_change_pk) ->
    1300003;

%%低于20级不能切换pk状态
get(err130_change_pk_lv_lim) ->
    1300004;

%%此场景不能切换和平模式
get(err130_no_peace) ->
    1300005;

%%当前不能切换战斗状态
get(err130_not_change) ->
    1300006;

%%不能切换此模式
get(err130_no_peace_ultimate) ->
    1300007;

%%{1}级后开启变性功能
get(err130_transfer_lv_limit) ->
    1300008;

%%非单身的玩家需离婚或分手后才可转变为其他性别
get(err130_transfer_sex_limit) ->
    1300009;

%%已经是本职业，不需要进行转职
get(err130_transfer_career_same_limit) ->
    1300010;

%%处于冷却期内，无法变性
get(err130_transfer_cd_limit) ->
    1300011;

%%职业数据错误
get(err130_transfer_career_err) ->
    1300012;

%%非跨服场景不能切换服务器模式
get(err130_change_pk_not_cluster_scene) ->
    1300013;

%%没有此头像配置
get(err130_no_profile_photo_cfg) ->
    1300014;

%%已激活
get(err130_is_activated) ->
    1300015;

%%头像还没激活
get(err130_is_not_activated) ->
    1300016;

%%不可切换为杀戮模式！
get(err130_no_kill_all) ->
    1300017;

%%回复参数错误
get(err131_reply_error) ->
    1310001;

%%人物死亡，无法回复
get(err131_player_die) ->
    1310002;

%%气血已满，无需回复
get(err131_hp_max) ->
    1310003;

%%回复时间未到
get(err131_time_error) ->
    1310004;

%%场景限制
get(err131_scene_limit) ->
    1310005;

%%请先打坐，方可按打坐方式回复
get(err131_sit_down_first) ->
    1310006;

%%非报名阶段
get(err137_not_sign_state) ->
    1370001;

%%已报名
get(err137_has_sign) ->
    1370002;

%%道具不足
get(err137_tool_not_enough) ->
    1370003;

%%未达到参赛等级
get(err137_lv_not_enough) ->
    1370004;

%%已达购买上限
get(err137_buy_limit) ->
    1370005;

%%未报名
get(err137_not_sign) ->
    1370006;

%%非准备阶段
get(err137_not_prepare_state) ->
    1370007;

%%已在准备区
get(err137_is_in_prepare) ->
    1370008;

%%不可重复选同个候选人
get(err137_not_allow_select_same) ->
    1370009;

%%参数错误
get(err137_cfg_error) ->
    1370010;

%%非擂台赛场景,不需退出
get(err137_not_need_to_leave) ->
    1370011;

%%非竞猜阶段
get(err137_not_guess_state) ->
    1370012;

%%非可选战区候选人
get(err137_not_guess_zone_role) ->
    1370013;

%%非可选战场候选人
get(err137_not_guess_act_role) ->
    1370014;

%%轮空玩家不可选
get(err137_not_select_empty_role) ->
    1370015;

%%不可同时选同台候选人
get(err137_not_select_same_plat) ->
    1370016;

%%技能未冷却
get(err137_skill_cd) ->
    1370017;

%%技能擂台中可使用
get(err137_fight_allow_use) ->
    1370018;

%%非法技能
get(err137_error_skill) ->
    1370019;

%%不在准备区中
get(err137_not_in_prepare) ->
    1370020;

%%您已被淘汰，不可购买
get(err137_be_kill_not_buy) ->
    1370021;

%%战力跌出4096名，失去比赛资格
get(err137_power_out) ->
    1370022;

%%已被淘汰
get(err137_not_enter_lose) ->
    1370023;

%%当前阶段不能进入
get(err137_not_enter_state) ->
    1370024;

%%已过了进入时间，故被淘汰
get(err137_not_enter_sub_state) ->
    1370025;

%%在钻石大战中
get(err137_can_not_change_scene_in_drumwar) ->
    1370026;

%%已获得冠军
get(err137_has_winner) ->
    1370027;

%%征途地图错误
get(err138_journey_map_err) ->
    1380001;

%%征途任务已完成
get(err138_journey_has_finished) ->
    1380002;

%%征途奖励不可重复领取
get(err138_journey_cant_fetch_again) ->
    1380003;

%%需要先完成任务
get(err138_journey_need_finish) ->
    1380004;

%%征途地图未解锁
get(err138_journey_map_locked) ->
    1380005;

%%任务未解锁
get(err138_journey_task_locked) ->
    1380006;

%%装备分解失败
get(err139_reslove_fail) ->
    1390001;

%%需要至少1条属性洗练达到满值才可突破！
get(err139_need_attr_max) ->
    1390002;

%%奖池为空
get(err139_pool_empty) ->
    1390003;

%%道具不存在
get(err139_goods_not_exist) ->
    1390004;

%%装备已达最大阶位
get(err139_max_grade_reached) ->
    1390005;

%%已达最大等级
get(err139_max_lv_reached) ->
    1390006;

%%装备已达最高段位
get(err139_section_max_reached) ->
    1390007;

%%需要突破更高阶位
get(err139_need_up_grade) ->
    1390008;

%%圣物需要升级至满级才可突破！
get(err139_need_more_exp) ->
    1390009;

%%需要更高等级
get(err139_need_up_lv) ->
    1390010;

%%已达最高圣物阶位
get(err139_max_title_reached) ->
    1390011;

%%功能未开放
get(err139_sys_not_open) ->
    1390012;

%%圣物已升至满级！
get(err139_need_active_next) ->
    1390013;

%%需要先完成指定副本
get(err139_need_finish_dun) ->
    1390014;

%%圣物需要升级至满级才可突破！
get(err139_need_more_power) ->
    1390015;

%%需要先穿戴装备
get(err139_need_equip_goods) ->
    1390016;

%%所有属性已达上限值
get(err139_all_attr_max_reached) ->
    1390017;

%%需要准备更高级装备
get(err139_need_equip_higher_goods) ->
    1390018;

%%本人好友人数达到上限
get(err140_1_myself_friend_num_limit) ->
    1400001;

%%对方好友人数达到上限
get(err140_2_other_friend_num_limit) ->
    1400002;

%%玩家不存在
get(err140_3_role_no_exist) ->
    1400003;

%%对方已经是您的好友
get(err140_4_is_friend) ->
    1400004;

%%不可添加自己为好友
get(err140_5_not_reply_myself_ask) ->
    1400005;

%%对方不是好友
get(err140_6_not_friend) ->
    1400006;

%%非对应关系
get(err140_7_not_exist_by_type) ->
    1400007;

%%已经添加过了~
get(err140_9_exist_rela) ->
    1400009;

%%不是仇人~
get(err140_10_not_enemy) ->
    1400010;

%%赠送礼物次数已达上限
get(err140_12_present_max) ->
    1400012;

%%亲密度已达上限
get(err140_13_intimacy_max) ->
    1400013;

%%该玩家不在线
get(err140_14_not_online) ->
    1400014;

%%暂时没有好友申请
get(err140_19_no_ask_to_be_friend) ->
    1400019;

%%无申请信息
get(err140_20_no_friend_ask) ->
    1400020;

%%名字不合法
get(err140_21_name_is_wrongful) ->
    1400021;

%%在主城或安全区才能进行该操作
get(err140_22_not_scene) ->
    1400022;

%%该玩家已被您拉黑，需要移除黑名单才能添加好友
get(err140_25_in_blacklist) ->
    1400025;

%%推荐太频繁了，休息下再来
get(err140_26_recommended_too_often) ->
    1400026;

%%黑名单人数已达上限
get(err140_27_myself_black_list_num_limit) ->
    1400027;

%%您在对方的黑名单，无法添加好友
get(err140_28_in_another_blacklist) ->
    1400028;

%%不是同服玩家暂时不能查看
get(err140_29_not_same_server_player) ->
    1400029;

%%您或对方在黑名单中，不可聊天。
get(err140_30_in_blacklist) ->
    1400030;

%%对不起，你们还存在着情侣/伴侣关系
get(err140_is_lover) ->
    1400031;

%%您今日已给对方赠送过礼物
get(err140_32_repeat_send) ->
    1400032;

%%每日赠送次数已达数量上限
get(err140_send_num_limit) ->
    1400033;

%%每日领取次数已达上限
get(err140_gift_num_limit) ->
    1400034;

%%对方没有赠送礼物，无法操作
get(err140_role_not_send) ->
    1400035;

%%你已领取，请勿重复操作
get(err140_you_have_received) ->
    1400036;

%%一键赠送失败
get(err140_batch_send_error) ->
    1400037;

%%一键领取失败
get(err140_batch_receive_error) ->
    1400038;

%%不是同服玩家无法操作
get(err140_not_same_svr) ->
    1400039;

%%不在投注时间内
get(err142_not_guess_time) ->
    1420001;

%%选手已有生效道具
get(err142_still_item_buff) ->
    1420002;

%%选手BUFF冷却中
get(err142_buff_cding) ->
    1420003;

%%没有这位选手
get(err142_find_no_runer) ->
    1420004;

%%没有足够资金
get(err142_has_no_enough_money) ->
    1420005;

%%现在不可使用
get(err142_cant_use_now) ->
    1420006;

%%没有足够道具
get(err142_no_enough_item) ->
    1420007;

%%战魂背包不足！
get(err143_warsoul_no_cell) ->
    1430000;

%%阵位尚未开放！
get(err143_pos_not_open) ->
    1430001;

%%已上阵相同类型战魂！
get(err143_same_warsoul) ->
    1430002;

%%已达最高等级！
get(err143_warsoul_max_lv) ->
    1430003;

%%进化材料不足！
get(err143_evolution_less_stuff) ->
    1430004;

%%暂无可领取的奖励！
get(err143_collect_max) ->
    1430005;

%%领取条件不足！
get(err143_collect_condition) ->
    1430006;

%%不可上阵！
get(err143_cannot_wear) ->
    1430007;

%%不可进化！
get(err143_cannot_evolution) ->
    1430008;

%%进化材料出错！
get(err143_evolution_stuff_error) ->
    1430009;

%%强化后可以进行回退！
get(err143_nothing_to_back) ->
    1430010;

%%阵位尚未解锁！
get(err143_err143_pos_lock) ->
    1430011;

%%阵位已经解锁！
get(err143_err143_pos_unlock) ->
    1430012;

%%经验材料战魂不可培养！
get(err143_cannot_strength) ->
    1430013;

%%玩家等级不足
get(err144_lv_unreach) ->
    1440001;

%%副本通关层数不足
get(err144_floor_unreach) ->
    1440002;

%%已达最大阶位
get(err144_has_been_grade_max) ->
    1440003;

%%需要等待储备更多时间
get(err144_need_wait_more_time) ->
    1440004;

%%魂力未达本阶最大等级
get(err144_need_enough_lv) ->
    1440005;

%%已达本阶最大等级
get(err144_has_been_lv_max) ->
    1440006;

%%不需要充能
get(err144_no_need_quick) ->
    1440007;

%%玩家战力不足
get(err144_power_unreach) ->
    1440008;

%%经验副本层数不足
get(err144_expdun_floor_unreach) ->
    1440009;

%%战魂星级不足
get(err144_warsoul_stars_unreach) ->
    1440010;

%%您的领取条件不足！
get(err145_task_conditon) ->
    1450001;

%%转生条件不足！
get(err145_turn_lower) ->
    1450002;

%%等级不足！
get(err145_lv_lower) ->
    1450003;

%%已经领取完奖励！
get(err145_already_get) ->
    1450004;

%%尚未击杀该幻魔！
get(err145_not_kill_yet) ->
    1450005;

%%含有敏感词，无法操作
get(err145_2_word_is_sensitive) ->
    1450006;

%%功能未开放
get(err146_foster_not_open) ->
    1460001;

%%达到使用上限
get(err146_limit_usage_reached) ->
    1460002;

%%需要更高阶位
get(err146_need_more_grade) ->
    1460003;

%%已达到最高阶位
get(err146_foster_max_grade) ->
    1460004;

%%幻化重复
get(err146_display_repeat) ->
    1460005;

%%已达到技能满级
get(err146_lv_max_reached) ->
    1460006;

%%道具不可吞噬
get(err146_some_cant_resolve) ->
    1460007;

%%道具不存在
get(err146_gooods_no_exist) ->
    1460008;

%%已达到装备最高等级
get(err146_equip_lv_max_reached) ->
    1460009;

%%已达到最高星
get(err146_already_max_star) ->
    1460010;

%%需要先激活对应珍宝
get(err146_need_active_skin) ->
    1460011;

%%该皮肤已激活
get(err146_foster_skin_already_active) ->
    1460012;

%%未激活对应阶位
get(err146_grade_limit) ->
    1460013;

%%穿满6件且含有要求品质装备，即可激活助战
get(err146_assist_state_error) ->
    1460014;

%%助战状态已激活，请勿重复操作
get(err146_have_actived) ->
    1460015;

%%已经达到最大等级了
get(err146_foster_max_lv) ->
    1460016;

%%进阶类型错误
get(err146_foster_type_err) ->
    1460017;

%%进阶升级材料配置错误
get(err146_sub_foster_material_err) ->
    1460018;

%%进阶升级材料参数错误
get(err146_material_type_err) ->
    1460019;

%%皮肤未激活哟
get(err146_sub_foster_skin_has_no_active) ->
    1460020;

%%还未提升到该星级喔
get(err146_sub_foster_star_not_enough) ->
    1460021;

%%已经达到最大星级了
get(err146_foster_skin_max) ->
    1460022;

%%皮肤升星材料配置错误
get(err146_foster_skin_material_err) ->
    1460023;

%%皮肤配置错误
get(err146_foster_skin) ->
    1460024;

%%升级失败
get(err147_fail_upgrade) ->
    1470001;

%%不需要重复激活
get(err147_need_no_active_again) ->
    1470002;

%%需要先激活
get(err147_need_active) ->
    1470003;

%%条件不符合
get(err147_conditions_not_met) ->
    1470004;

%%已满级
get(err147_has_max_lv) ->
    1470005;

%%技能还没激活
get(err147_there_is_not_skill) ->
    1470006;

%%道具不存在
get(err148_not_goods) ->
    1480001;

%%星辰已达最大等级
get(err148_galaxy_max_lev) ->
    1480002;

%%槽位已开启
get(err148_pos_opened) ->
    1480003;

%%需要按照顺序激活
get(err148_need_active_sort) ->
    1480004;

%%槽位未激活
get(err148_pos_not_open) ->
    1480005;

%%已有相同类型星辰
get(err148_have_same_galaxy) ->
    1480006;

%%现在不可购买
get(err142_cant_buy_now) ->
    1480007;

%%技能重复
get(err148_skill_pertivive) ->
    1480008;

%%超出技能槽位
get(err148_out_skill_pos) ->
    1480009;

%%固定技能不可替换
get(err148_is_settlet_skill) ->
    1480010;

%%皮肤已满级
get(err148_skin_max_star) ->
    1480011;

%%不需重复幻化
get(err148_use_same_skin) ->
    1480012;

%%不可重复领取
get(err148_cant_fetch_again) ->
    1480013;

%%需要完成收集
get(err148_need_finish_collect) ->
    1480014;

%%对方等级不足！
get(err149_less_lv) ->
    1490001;

%%对方羁绊数量已达上限！
get(err149_mates_enough) ->
    1490002;

%%对方未添加你为好友哦~
get(err149_not_friends) ->
    1490003;

%%亲密度不足
get(err149_less_intimacy) ->
    1490004;

%%你们已经结成羁绊了
get(err149_already_mate) ->
    1490005;

%%存在尚未回应的申请
get(err149_exist_no_response) ->
    1490006;

%%申请已过期
get(err149_ask_not_exist) ->
    1490007;

%%你们还没有结成羁绊
get(err149_not_mate) ->
    1490008;

%%存在敏感词汇，请重新输入
get(err149_word_sensitive) ->
    1490009;

%%小船已达最高级
get(err149_boat_max_lv) ->
    1490010;

%%活动尚未开启
get(err149_act_not_open) ->
    1490011;

%%对方不在线
get(err149_target_offline) ->
    1490012;

%%正在参与其他玩法
get(err149_already_in_act) ->
    1490013;

%%当前场景无法进行游戏
get(err149_area_cannot_play) ->
    1490014;

%%奖励不存在
get(err149_no_award) ->
    1490015;

%%条件不足
get(err149_less_day) ->
    1490016;

%%已经领取了奖励
get(err149_already_get_award) ->
    1490017;

%%已经佩戴了称号
get(err149_already_wear_title) ->
    1490018;

%%已经卸下了称号
get(err149_already_unwear_title) ->
    1490019;

%%请先解除羁绊关系
get(err149_is_mate) ->
    1490020;

%%对方金额不足
get(err149_other_less_gold) ->
    1490021;

%%羁绊信息已过期
get(err149_mate_info_overdue) ->
    1490022;

%%正在进行羁绊小游戏
get(err149_on_game) ->
    1490023;

%%您的羁绊数量已达上限！
get(err149_mates_enough_myself) ->
    1490024;

%%您未添加对方为好友！
get(err149_not_friends_self) ->
    1490025;

%%您的等级不足！
get(err149_less_lv_self) ->
    1490026;

%%请先同意邀请！
get(err149_not_response_self) ->
    1490027;

%%对方还未同意！
get(err149_not_response) ->
    1490028;

%%已经处理了该邀请！
get(err149_already_response) ->
    1490029;

%%对方关闭了活动！
get(err149_close_act) ->
    1490030;

%%宣言超出最大长度！
get(err149_msg_length) ->
    1490031;

%%拍照准备中！
get(err149_photo_ready) ->
    1490032;

%%今日拍照活动已经完成！
get(err149_photo_invite) ->
    1490033;

%%没有羁绊好友在线！
get(err149_photo_offline) ->
    1490034;

%%邀请者不在当前场景！
get(err149_photo_away_invite) ->
    1490035;

%%请前往拍照场景准备！
get(err149_photo_wrong_scene) ->
    1490036;

%%请前往拍照位置准备！
get(err149_photo_wrong_pos) ->
    1490037;

%%您还没有羁绊！
get(err149_not_one_mate) ->
    1490038;

%%奖励已领取
get(err149_reward_alreday_receive) ->
    1490039;

%%任务还未完成！
get(err149_task_not_final) ->
    1490040;

%%物品操作失败
get(err150_fail) ->
    1500000;

%%物品不存在
get(err150_no_goods) ->
    1500001;

%%金额不足
get(err150_no_money) ->
    1500002;

%%背包空间不足，请先清理背包
get(err150_no_cell) ->
    1500003;

%%兑换次数不足！
get(err150_exchange_counts_limit) ->
    1500004;

%%正在交易中
get(err150_in_sell) ->
    1500005;

%%物品价格错误
get(err150_price_err) ->
    1500006;

%%物品所有者错误
get(err150_palyer_err) ->
    1500007;

%%物品位置错误
get(err150_location_err) ->
    1500008;

%%物品不可出售
get(err150_not_sell) ->
    1500009;

%%物品数量错误
get(err150_num_err) ->
    1500010;

%%背包空间已达上限
get(err150_cell_max) ->
    1500011;

%%物品类型错误
get(err150_type_err) ->
    1500012;

%%条件不符
get(err150_require_err) ->
    1500013;

%%信息已过期
get(err150_info_overdue) ->
    1500014;

%%物品类型不存在
get(err150_no_goods_type) ->
    1500015;

%%冷却时间
get(err150_in_cd) ->
    1500016;

%%物品等级限制
get(err150_lv_err) ->
    1500017;

%%当前处于死亡状态，请复活后再操作！
get(err150_player_die) ->
    1500018;

%%物品不可销毁
get(err150_not_trhow) ->
    1500019;

%%该掉落已被拾取
get(err150_no_drop) ->
    1500020;

%%不是您的掉落，无法拾取哦
get(err150_no_drop_per) ->
    1500021;

%%时间还未到
get(err150_time_not_start) ->
    1500022;

%%时间已经结束
get(err150_time_end) ->
    1500023;

%%礼包未生效
get(err150_gift_unactive) ->
    1500024;

%%规则不存在
get(err150_no_rule) ->
    1500025;

%%规则未生效
get(err150_rule_unactive) ->
    1500026;

%%限时物品一天只能购买一次
get(err150_shop_time_limit) ->
    1500027;

%%物品已经卖完
get(err150_goods_num_zero) ->
    1500028;

%%礼包已领取
get(err150_gift_got) ->
    1500029;

%%次数已达上限
get(err150_num_limit) ->
    1500030;

%%仓库空间不足
get(err150_storage_no_cell) ->
    1500031;

%%本场景无法使用
get(err150_scene_wrong) ->
    1500032;

%%npc类型错误
get(err150_npc_type_err) ->
    1500033;

%%使用量超出上限，无法使用
get(err150_hp_mp_full) ->
    1500034;

%%次数超出每天上限
get(err150_num_over) ->
    1500035;

%%技能学习失败
get(err150_skill_fail) ->
    1500036;

%%装备已经过期，不可穿戴
get(err150_fashion_expire) ->
    1500037;

%%使用地图坐标不正确
get(err150_scene_pos) ->
    1500038;

%%无触发事件
get(err150_not_event) ->
    1500039;

%%物品使用后什么都没有
get(err150_nothing) ->
    1500040;

%%当前增益状态不能替换中级增益状态
get(err150_cannot_replace_mid) ->
    1500041;

%%当前增益状态不能替换高级增益状态
get(err150_cannot_replace_big) ->
    1500042;

%%没有帮派
get(err150_no_guild) ->
    1500043;

%%单个物品次数已达上限
get(err150_num_single_limit) ->
    1500044;

%%单个物品兑换数量超过每天上限
get(err150_num_single_over) ->
    1500045;

%%距离掉落包过远
get(err150_distance) ->
    1500046;

%%无法使用等级道具
get(err150_lv_goods) ->
    1500048;

%%自选物品数量异常
get(err150_num_notmatch) ->
    1500049;

%%找不到自选礼包奖励内容
get(err150_seqlist_notmatch) ->
    1500050;

%%打开宝箱配置不存在
get(err150_no_gift_type) ->
    1500051;

%%物品已过有效期
get(err150_goods_expired) ->
    1500052;

%%职业不符，无法打开
get(err150_no_career_gift) ->
    1500053;

%%剩余历练次数不足
get(err150_exper_error) ->
    1500054;

%%材料不足，无法合成
get(err150_compose_goods_not_enough) ->
    1500055;

%%物品类型id有误
get(err150_goods_id_err) ->
    1500056;

%%智慧药水最多累积7小时
get(err150_exper_time_more_than_7hour) ->
    1500057;

%%礼包数据不存在
get(err150_gift_cfg_missing) ->
    1500058;

%%礼包状态为无效
get(err150_gift_status_error) ->
    1500059;

%%未到领取礼包时间
get(err150_gift_nobegin) ->
    1500060;

%%已过了领取礼包时间
get(err150_gift_overtime) ->
    1500061;

%%礼包数据错误
get(err150_gift_data_error) ->
    1500062;

%%领取礼包失败
get(err150_gift_fetch_error) ->
    1500063;

%%礼包卡长度错误
get(err150_gift_card_err_len) ->
    1500064;

%%卡号错误
get(err150_gift_card_not_exist) ->
    1500065;

%%卡号没有绑定礼包
get(err150_gift_card_no_gift_type) ->
    1500066;

%%平台不对
get(err150_gift_card_platform_error) ->
    1500067;

%%卡号已经被领取
get(err150_gift_card_has_trigger) ->
    1500068;

%%未到领取卡号时间
get(err150_gift_card_nobegin) ->
    1500069;

%%卡号过期
get(err150_gift_card_overtime) ->
    1500070;

%%已经使用过同类卡号
get(err150_gift_card_has_use_same_card) ->
    1500071;

%%礼包数据不存在
get(err150_gift_card_gift_not_exist) ->
    1500072;

%%等级不足，暂时无法使用
get(err150_lv_gfit_cfg_err) ->
    1500073;

%%物品还未过期
get(err150_good_in_expire) ->
    1500074;

%%红名值值为0，不需要使用洗恶卡
get(err150_pk_value_0) ->
    1500075;

%%所选物品不属于合成材料
get(err150_not_compose_mat) ->
    1500076;

%%背包已满，无法合成
get(err150_no_cell_to_compose) ->
    1500077;

%%货币不足，无法合成
get(err150_no_money_to_compose) ->
    1500078;

%%角色等级不够，无法合成
get(err150_not_satisfy_compose_lv) ->
    1500079;

%%合成成功
get(err150_compose_success) ->
    1500080;

%%合成失败
get(err150_compose_fail) ->
    1500081;

%%背包空位不足，拆解失败
get(err150_no_null_cell_decompose_fail) ->
    1500082;

%%称号已经激活，返还{1}金币
get(err150_user_use_dsgt) ->
    1500083;

%%物品续费配置缺失
get(err150_renew_cf_miss) ->
    1500084;

%%背包类型配置错误
get(err150_bag_location_fail) ->
    1500085;

%%该合成方式未解锁
get(err150_compose_type_lock) ->
    1500086;

%%场景不同，不能拾取
get(err150_notin_drop_scene) ->
    1500087;

%%房间不同，不能拾取
get(err150_not_drop_copyid) ->
    1500088;

%%您已经死亡，不能拾取
get(err150_drop_no_hp) ->
    1500089;

%%您没有对首领造成伤害，暂时不能拾取该掉落
get(err150_no_hurt_drop) ->
    1500090;

%%您的等级超过首领等级100级，无法获得掉落
get(err150_drop_overlv) ->
    1500091;

%%您的首领疲劳值还未消耗，无须使用该物品
get(err150_no_boss_tired) ->
    1500092;

%%您的首领疲劳已满不能拾取掉落
get(err150_no_drop_boss_tired) ->
    1500093;

%%礼包奖励内容不存在
get(err150_gift_reward_miss) ->
    1500094;

%%等级不足，玩法使用！
get(err150_lv_not_enough) ->
    1500095;

%%不能拆解已经穿戴的物品
get(err150_decompose_wear) ->
    1500096;

%%{1}数量不足
get(err150_currency_not_enough) ->
    1500097;

%%再登录{1}天可开启哦!{2}
get(err150_day_not_enough) ->
    1500098;

%%纹章背包已满
get(err150_soul_bag_full) ->
    1500099;

%%星辰背包空间不足！
get(err150_galaxy_no_cell) ->
    1500100;

%%神座座印库空间不足！
get(err150_god_no_cell) ->
    1500101;

%%宝宝玩具背包空间不足！
get(err150_baby_no_cell) ->
    1500102;

%%奖励已发送至邮箱~
get(err150_card_ok_send) ->
    1500104;

%%宠物技能宝石背包空间不足！
get(err150_pet_stone_no_cell) ->
    1500105;

%%AI娘装备背包空间不足！
get(err150_fjarvis_no_cell) ->
    1500106;

%%座驾装备背包空间不足！
get(err150_mount_no_cell) ->
    1500107;

%%存在未过期的物品
get(err150_goods_not_timeout) ->
    1500111;

%%战魂背包空间不足！
get(err150_warsoul_no_cell) ->
    1500112;

%%合成次数不能为0
get(err150_compose_times) ->
    1500113;

%%职业限制，无法合成
get(err150_not_satisfy_compose_career) ->
    1500114;

%%符文印记背包空间不足
get(err150_god_rune_no_cell) ->
    1500115;

%%已超出该物品使用期限
get(err150_no_use) ->
    1500116;

%%今日彩钻产出已达上限
get(err150_gold_daily_limit) ->
    1500117;

%%今日红钻产出已达上限
get(err150_bgold_daily_limit) ->
    1500118;

%%今日名望券获得已达上限
get(err150_honour_max) ->
    1500119;

%%激活条件不足！
get(err150_devour_condition) ->
    1500120;

%%暂无可激活的属性！
get(err150_devour_max) ->
    1500121;

%%{1}级以上使用
get(err150_goods_lv_limit) ->
    1500122;

%%橙装碎片拾取次数已达上限，无法拾取！
get(err150_color_drop_limit) ->
    1500123;

%%紫装拾取次数已达上限，无法拾取！
get(err150_purple_drop_limit) ->
    1500124;

%%珍宝皮肤碎片获得次数已达上限，无法拾取！
get(err150_zhenbao_drop_limit) ->
    1500125;

%%合成材料出错
get(err151_compose_stuff_error) ->
    1510001;

%%不可合成
get(err151_cannot_compose) ->
    1510002;

%%合成材料不足
get(err151_stuff_not_enough) ->
    1510003;

%%已达到商品上架上限
get(err151_max_sell_up_num) ->
    1510004;

%%商品信息有误，请重新打开界面
get(err151_goods_info_err) ->
    1510005;

%%该商品已下架
get(err151_goods_not_exist) ->
    1510006;

%%该商品不属于你
get(err151_not_seller) ->
    1510007;

%%背包已满，请先清理背包
get(err151_no_null_cells) ->
    1510008;

%%对方未达到交易等级
get(err151_specify_role_lv_not_enough) ->
    1510009;

%%不能购买自己出售的商品
get(err151_can_not_buy_self_goods) ->
    1510010;

%%您不是改商品的指定购买者
get(err151_not_specify_role) ->
    1510011;

%%该物品不能出售
get(err151_bind_cannot_sell) ->
    1510012;

%%钻石不足
get(err151_not_enough_gold) ->
    1510013;

%%商品已经下架，请重新刷新界面
get(err151_goods_sell_down) ->
    1510014;

%%单价设置不在范围内
get(err151_unit_price_fail) ->
    1510016;

%%超过上架数量上限
get(err151_num_limit) ->
    1510017;

%%装备不存在
get(err152_not_exist) ->
    1520001;

%%未达到装备穿戴等级
get(err152_lv_err) ->
    1520002;

%%转生限制
get(err152_series_err) ->
    1520003;

%%物品类型不符
get(err152_type_err) ->
    1520004;

%%强化等级达到上限
get(err152_stren_limit) ->
    1520014;

%%缺失配置
get(err152_missing_cfg) ->
    1520017;

%%装备位置参数错误
get(err152_equip_pos_err) ->
    1520019;

%%守护无法进行强化
get(err152_cannot_be_guard) ->
    1520020;

%%装备穿戴才能进行操作
get(err152_must_wear) ->
    1520024;

%%请先穿戴装备
get(err152_pos_no_equip) ->
    1520025;

%%职业不合适,不能穿戴
get(err152_career_error) ->
    1520026;

%%未知装备类型
get(err152_equip_type_error) ->
    1520029;

%%该装备类型无法进化
get(err152_cannot_rise_star) ->
    1520035;

%%进化已达上限
get(err152_max_star) ->
    1520036;

%%进化材料出错
get(err152_rise_star_stuff) ->
    1520037;

%%相同装备类型才能继承
get(err152_must_same) ->
    1520038;

%%该装备无法继承
get(err152_inherit_type_err) ->
    1520039;

%%只能继承给高品质装备
get(err152_inherit_color) ->
    1520040;

%%已经激活了
get(err152_already_active) ->
    1520041;

%%尚未激活
get(err152_not_active) ->
    1520042;

%%该装备已无法进行进化
get(err152_can_not_star_anymore) ->
    1520044;

%%市场商品不足
get(err152_market_no_goods) ->
    1520045;

%%条件不足
get(err152_err_condition) ->
    1520046;

%%已达最高等级
get(err152_empower_max_lv) ->
    1520047;

%%该装备无法升品
get(err152_evolution_type_err) ->
    1520048;

%%请先镶嵌宝石
get(err152_no_inlay_gem) ->
    1520049;

%%宝石已达满级
get(err152_gem_max_lv) ->
    1520050;

%%激活条件不足！
get(err152_collect_condition) ->
    1520051;

%%尚未解锁当前代数！
get(err152_series_lock) ->
    1520052;

%%解锁等级不足！
get(err152_unlock_lv_limit) ->
    1520053;

%%完成支线任务解锁！
get(err152_series_task) ->
    1520054;

%%暂无可激活的属性！
get(err152_gem_suit_max) ->
    1520055;

%%暂无可镶嵌的宝石！
get(err152_has_no_gems) ->
    1520057;

%%该装备不可进行升级！
get(err152_cannot_empower) ->
    1520059;

%%升级条件不足！
get(err152_empower_conditon) ->
    1520062;

%%不可更换低品质装备！
get(err152_cannot_equip_lower_color) ->
    1520069;

%%未达对应转生，不能穿戴
get(err152_turn_error) ->
    1520070;

%%材料不足，提升失败
get(err152_equip_skill_no_cost_upgrade) ->
    1520078;

%%请选择属性
get(err152_no_choice) ->
    1520079;

%%无需选择属性
get(err152_choice_not_needed) ->
    1520081;

%%vip等级不足
get(err152_vip_lv_error) ->
    1520082;

%%没有装备可升级宝石
get(err152_not_equip_cannot_upgrade_stone) ->
    1520083;

%%没有这件装备
get(err152_no_this_equip) ->
    1520086;

%%没有这件物品
get(err152_no_this_goods) ->
    1520087;

%%消耗数量错误
get(err152_cost_num_error) ->
    1520088;

%%钻石不足
get(err152_gold_not_enough) ->
    1520089;

%%道具不足
get(err152_goods_not_enough) ->
    1520090;

%%可保留的属性列表为空
get(err152_no_attr_can_ensure) ->
    1520091;

%%已是最高阶
get(err152_stage_max) ->
    1520092;

%%打造装备材料类型错误
get(err152_build_goods_error) ->
    1520093;

%%未达对应转生数，打造条件不符
get(err152_build_turn_error) ->
    1520094;

%%您当前精炼值已满
get(err152_refine_value_max) ->
    1520095;

%%该宝石只能镶嵌在vip孔哦~
get(err152_vip_stone_limit) ->
    1520096;

%%重铸次数已达上限
get(err152_max_prefix_error) ->
    1520097;

%%该部位装备不能升星
get(err152_not_upgrade_star_pos) ->
    1520099;

%%未穿戴装备，不能升星
get(err152_not_equip_cannot_upgrade_star) ->
    1520100;

%%装备的品质、阶数不足，不能升星
get(err152_not_upgrade_star_quality) ->
    1520101;

%%洗炼参数错误
get(err152_wash_args_error) ->
    1520102;

%%商品不在架上
get(err153_goods_not_on_sale) ->
    1530000;

%%该道具已售空，请耐心等待补货。
get(err153_goods_sold_out) ->
    1530001;

%%数据错误
get(err153_goods_not_equal) ->
    1530002;

%%您拥有的背包空间不足，请清理后再来。
get(err153_bag_not_enough) ->
    1530003;

%%派送物品失败
get(err153_give_goods_failure) ->
    1530004;

%%购买数量超过上限
get(err153_not_enough_goods_to_buy) ->
    1530005;

%%不能用此金钱支付
get(err153_money_type_wrong) ->
    1530006;

%%请求错误
get(err153_send_error) ->
    1530007;

%%世界等级未到达购买要求！
get(err153_not_enough_world_lv) ->
    1530008;

%%开发天数未达到购买要求！
get(err153_not_enough_server_time) ->
    1530009;

%%您的等级未达到购买要求！
get(err153_not_enough_lv) ->
    1530010;

%%不能用这种货币购买
get(err153_qb_not_right_money) ->
    1530011;

%%您的坐骑背包空间不足，请清理后再来。
get(err153_mount_bag_not_enough) ->
    1530012;

%%职业不匹配
get(err153_error_career) ->
    1530013;

%%非法竞价类型
get(err154_error_pricetype) ->
    1540001;

%%缺失物品配置
get(err154_missing_config) ->
    1540002;

%%物品已拍出
get(err154_goods_sellout) ->
    1540003;

%%竞价已发生变化
get(err154_price_change) ->
    1540004;

%%价格参数错误
get(err154_error_price) ->
    1540005;

%%该物品已结束拍卖~
get(err154_goods_closed) ->
    1540006;

%%你当前已是最高竞价者
get(err154_player_top_price) ->
    1540007;

%%不是你所在社团物品
get(err154_error_guild_id) ->
    1540008;

%%拍卖未开启，请稍加等待
get(err154_auction_not_start) ->
    1540009;

%%本商品只能使用钻石参与拍卖
get(err154_only_pay_by_gold) ->
    1540010;

%%该商品只能一口价交易
get(err155_market_guild_cannot_bid) ->
    1550001;

%%强化等级超过当前装备强化上限
get(err155_stren_stage_limit) ->
    1550002;

%%需要穿戴圣印才能强化
get(err155_stren_no_equip) ->
    1550003;

%%当前使用次数已达上限
get(err150_soul_count_limit) ->
    1550004;

%%装备孔还未开放
get(err155_pos_not_open) ->
    1550005;

%%物品已过有效期
get(err155_expire_time) ->
    1550006;

%%本物品不可交易
get(err155_cannot_trade) ->
    1550007;

%%该物品不可交易
get(err155_bind_cannot_sell) ->
    1550008;

%%本物品不可交易
get(err155_not_sell_category) ->
    1550009;

%%货架数量不足
get(err155_shelves_are_full) ->
    1550010;

%%物品不在出售中
get(err155_market_goods_not_exist) ->
    1550011;

%%物品竞拍已结束
get(err155_market_goods_off) ->
    1550012;

%%物品还在公示中
get(err155_market_goods_is_showing) ->
    1550013;

%%不能竞拍/购买自己上架的物品
get(err155_market_goods_yourself) ->
    1550014;

%%不是你上架的物品，不可操作
get(err155_market_goods_not_yours) ->
    1550015;

%%已有人出价，不可下架
get(err155_market_goods_is_offer) ->
    1550016;

%%还没下架
get(err155_market_goods_not_off) ->
    1550017;

%%价格不对
get(err155_market_goods_price_error) ->
    1550018;

%%你已是最高竞价者
get(err155_market_goods_your_price_max) ->
    1550019;

%%已关注
get(err155_already_like) ->
    1550020;

%%关注数量已达上限
get(err155_like_num_max) ->
    1550021;

%%不能关注自己上架的物品
get(err155_cannot_like_yourself) ->
    1550022;

%%物品不存在
get(err155_goods_not_exist) ->
    1550023;

%%还没加入公会，不能公会上架
get(err155_no_guild_for_guild_sell_type) ->
    1550024;

%%此物品不能世界上架
get(err155_cannot_sell_to_world) ->
    1550025;

%%此物品不能公会上架
get(err155_cannot_sell_to_guild) ->
    1550026;

%%不在同一个公会不可以购买
get(err155_market_goods_not_your_guild) ->
    1550027;

%%添加入库提醒已达上限
get(err155_reminder_limit) ->
    1550028;

%%暂无可以上架的商品
get(err155_no_goods_put) ->
    1550029;

%%活跃度不够
get(err157_1_live_not_enough) ->
    1570001;

%%不能重复领取
get(err157_2_live_aready_get) ->
    1570002;

%%背包不足
get(err157_3_bag_not_enough) ->
    1570003;

%%等级不足，无法打开活动日历
get(err157_4_lv_not_enough) ->
    1570004;

%%配置错误
get(err157_5_cfg_err) ->
    1570005;

%%活跃度不够
get(err157_6_live_not_enough) ->
    1570006;

%%活跃度等级已达最高
get(err157_7_max_lv) ->
    1570007;

%%活跃度等级不够
get(err157_8_live_lv_limit) ->
    1570008;

%%开服天数不足
get(err157_9_open_day_limit) ->
    1570009;

%%活动未开启
get(err157_act_not_open) ->
    1570010;

%%已幻化当前形象
get(err157_figure_already) ->
    1570011;

%%活力已达上限
get(err157_power_live_limit) ->
    1570012;

%%活动已预约
get(err157_reserved) ->
    1570013;

%%已参与活动无需预约
get(err157_have_joined) ->
    1570014;

%%已领取奖励，无法预约
get(err157_have_rewards) ->
    1570015;

%%活动无预约，无法领取
get(err157_not_reserve) ->
    1570016;

%%没有参与活动，无法领取
get(err157_not_joined) ->
    1570017;

%%不是当天未开启的活动，无法预约
get(err157_act_opening) ->
    1570018;

%%该充值商品暂未开启
get(err158_time_error) ->
    1580001;

%%您不符合该充值商品使用条件
get(err158_condition_error) ->
    1580002;

%%该充值商品缺失基础配置
get(err158_product_error) ->
    1580003;

%%该充值商品缺失控制信息配置
get(err158_product_ctrl_error) ->
    1580004;

%%该充值商品缺失返利配置
get(err158_recharge_return_error) ->
    1580005;

%%未知充值商品类型
get(err158_product_type_error) ->
    1580006;

%%已购买该充值商品
get(err158_already_buy) ->
    1580007;

%%该充值商品暂未开放，敬请期待！
get(err158_not_open) ->
    1580008;

%%等级未到达购买要求！
get(err158_not_enough_lv) ->
    1580009;

%%购买次数不足
get(err158_not_enough_times) ->
    1580010;

%%VIP等级不足
get(err158_not_enough_vip) ->
    1580011;

%%每日礼包类型错误!
get(err159_daily_type_err) ->
    1590001;

%%今天礼包已经被购买~
get(err159_daily_purchased) ->
    1590002;

%%礼包配置错误~
get(err159_daily_cfg_err) ->
    1590003;

%%礼包未购买,领取失败~
get(err159_daily_not_purchase) ->
    1590004;

%%礼包已经领取,无法再次领取~
get(err159_daily_is_get) ->
    1590005;

%%非福利卡
get(err159_1_not_welfare) ->
    1590006;

%%福利卡已过期
get(err159_2_welfare_timeout) ->
    1590007;

%%未购买相关产品
get(err159_3_not_buy) ->
    1590008;

%%已领取
get(err159_4_already_get) ->
    1590009;

%%背包已满
get(err159_5_bag_not_enough) ->
    1590010;

%%领取时间未到
get(err159_not_the_time) ->
    1590013;

%%首充商品未开放
get(err159_first_recharge_product_not_open) ->
    1590014;

%%首充奖励参数错误
get(err159_first_recharge_error_index) ->
    1590015;

%%签到奖励已全部领取
get(err160_sign_in_over) ->
    1600001;

%%VIP等级不足
get(err160_sign_in_vip) ->
    1600002;

%%奖励已经领取
get(err160_repeat_get) ->
    1600003;

%%尚未达到领奖等级
get(err160_level_low) ->
    1600004;

%%在线时长不足
get(err160_online_time_less) ->
    1600005;

%%条件不足
get(err160_condition_error) ->
    1600006;

%%形象未激活
get(err162_figure_unactive) ->
    1620001;

%%已佩戴
get(err162_up_ride) ->
    1620002;

%%已卸下
get(err162_not_up_ride) ->
    1620003;

%%形象已激活
get(err162_already_active) ->
    1620004;

%%宠物已经领养过啦
get(err163_already_adopt) ->
    1630001;

%%材料不足
get(err163_debris_not_enough) ->
    1630002;

%%宠物已达到最高等级
get(err163_is_max_lv) ->
    1630003;

%%宠物已达到最高品质
get(err163_pet_max_stage) ->
    1630004;

%%还未领养本宠物喔~
get(err163_not_adopt) ->
    1630005;

%%没有该宝石
get(err163_no_diamond) ->
    1630006;

%%没有该宝石槽位
get(err163_not_diamond_slot) ->
    1630007;

%%该技能石已经镶嵌
get(err163_diamond_has_inlay) ->
    1630008;

%%支援槽位未开启
get(err163_slot_not_active) ->
    1630009;

%%相同支援类型的宠物间不能相互替换哟~
get(err163_slot_type_cannot_same) ->
    1630010;

%%该槽位与支援类型没对应上喔
get(err163_slot_type_not_satisfy) ->
    1630011;

%%不存在该支援类型
get(err163_slot_type_not_exit) ->
    1630012;

%%同一只宠物不能重复支援喔~
get(err163_pet_cannot_support_again) ->
    1630013;

%%没有该宠物哟~
get(err163_not_pet) ->
    1630014;

%%不是对应的升级材料
get(err163_not_grow_up_matrial) ->
    1630015;

%%技能石不是对应的种族喔
get(err163_not_pet_race) ->
    1630016;

%%宠物配置错误
get(err163_pet_cfg_err) ->
    1630017;

%%不能镶嵌同类型的技能石喔~
get(err163_same_diamond_type) ->
    1630018;

%%TA的宠物信息不存在哟
get(err163_role_not_adopt_pet) ->
    1630019;

%%您的奖励已经通过邮件发放啦
get(err163_first_role_not_receive) ->
    1630020;

%%该宠物没有奖励可以领取哟
get(err163_not_reward) ->
    1630021;

%%今天投票次数已经用完咯
get(err163_vote_times_not_enough) ->
    1630022;

%%你已经为本宠投过票啦
get(err163_has_vote) ->
    1630023;

%%还未达到觉醒星级哟
get(err163_star_not_reach) ->
    1630024;

%%本宠无法进行觉醒喔
get(err163_cannot_awaken) ->
    1630025;

%%不需要重复上阵啦
get(err163_not_need_support_again) ->
    1630026;

%%合成材料不足哦
get(err163_compound_diamond_not_enough) ->
    1630027;

%%合成配置错误
get(err163_compound_cfg_err) ->
    1630028;

%%您还没有领养宝宝喔~
get(err165_child_not_adopt) ->
    1650001;

%%您已经领养过宝宝啦~
get(err165_child_has_adopt) ->
    1650002;

%%您起的宝宝名字已经存在了喔~
get(err165_child_name_exits) ->
    1650003;

%%还没有达到同心度呐
get(err165_child_open_lv_not_reach) ->
    1650004;

%%您的宝宝已经最大等级了
get(err165_child_max_age) ->
    1650005;

%%不是宝宝成长材料喔
get(err165_not_child_grow_up_material) ->
    1650006;

%%成长材料不够喔
get(err165_child_good_num_err) ->
    1650007;

%%不是同心培养材料哟
get(err165_not_upgrade_link_heart_material) ->
    1650008;

%%同心材料不够喔
get(err165_upgrade_link_heart_material_not_enough) ->
    1650009;

%%新的名字与旧名字相同喔~
get(err165_child_same_name) ->
    1650010;

%%同心度培养类型错误
get(err165_child_upgrade_link_heart_type_err) ->
    1650011;

%%今天的点赞次数用完了啦
get(err165_child_vote_times_not_enough) ->
    1650012;

%%今天给TA点赞的次数已经用完了哦~
get(err165_has_vote_for_this_child) ->
    1650013;

%%还没有触发该任务
get(err165_child_has_not_trigger_task) ->
    1650014;

%%任务未完成
get(err165_child_task_unfinish) ->
    1650015;

%%已经领取过任务奖励啦
get(err165_child_task_reward_has_received) ->
    1650016;

%%不能点赞自己的宝宝喔
get(err165_cannot_vote_my_child) ->
    1650017;

%%今天的晒娃次数用完了啦
get(err165_show_off_times_not_enough) ->
    1650018;

%%宝宝的性别错误
get(err165_child_sex_err) ->
    1650019;

%%同心等级已经达到最大啦~
get(err165_max_link_heart_level) ->
    1650020;

%%晒娃太频繁啦~
get(err165_in_show_off_time_cd) ->
    1650021;

%%对方还未领取宝宝，点赞失效喔
get(err165_opp_not_adopt_child) ->
    1650022;

%%还没达到点赞的等级喔
get(err165_child_role_lv_not_reach) ->
    1650023;

%%存在敏感词汇
get(err165_exits_word_sensitive) ->
    1650024;

%%不是宝宝技能喔
get(err165_is_not_child_skill) ->
    1650025;

%%未达到技能激活等级喔
get(err165_child_not_reach_skill_open_lv) ->
    1650026;

%%要先激活前一顺位技能喔
get(err165_pre_skill_not_active) ->
    1650027;

%%未达到激活的战力喔
get(err165_power_not_enough) ->
    1650028;

%%材料不够啦
get(err165_skill_material_not_enough) ->
    1650029;

%%还没有激活技能呢
get(err165_not_active_child_skill) ->
    1650030;

%%已经达到满级啦
get(err165_child_skill_max_lv) ->
    1650031;

%%不是宝宝载具喔
get(err165_not_child_vehicle) ->
    1650032;

%%宝宝载具已经激活啦
get(err165_has_active_child_vehicle) ->
    1650033;

%%载具材料不足喔
get(err165_vehicle_material_not_enough) ->
    1650034;

%%宝宝载具已经达到最大阶啦
get(err165_child_vehicle_max_stage) ->
    1650035;

%%载具还没激活喔
get(err165_child_vehicle_not_active) ->
    1650036;

%%技能已经激活啦
get(err165_child_skill_has_active) ->
    1650037;

%%选择的等级不能小于当前等级喔
get(err165_toy_aim_lv_err) ->
    1650038;

%%选择的等级超过最大等级啦
get(err165_toy_aim_lv_max) ->
    1650039;

%%玩具已经升到最高等级啦
get(err165_toy_max_lv) ->
    1650040;

%%您还没拥有该玩具喔
get(err165_has_not_toy) ->
    1650041;

%%玩具位还没开启哟
get(err165_toy_slot_not_open) ->
    1650042;

%%选择的玩具超重啦
get(err165_can_not_carry_toy) ->
    1650043;

%%槽位上已经没有玩具啦
get(err165_slot_not_good) ->
    1650044;

%%合成材料不够六个喔
get(err165_forge_material_not_enough) ->
    1650045;

%%合成材料需要同品质哟
get(err165_not_same_color) ->
    1650046;

%%槽位中的玩具，不能作合成材料喔
get(err165_toy_has_inlay) ->
    1650047;

%%玩具配置错误
get(err165_toy_config_err) ->
    1650048;

%%槽位中的玩具，不能分解喔
get(err165_toy_is_on_slot) ->
    1650049;

%%打造槽位还没开启哟
get(err165_forge_slot_not_open) ->
    1650050;

%%打造位正在使用啦
get(err165_forge_slot_is_using) ->
    1650051;

%%打造还没完成喔
get(err165_forge_has_not_finish) ->
    1650052;

%%打造已经完成，不需要加速啦
get(err165_forge_has_finish) ->
    1650053;

%%加速费用不足喔
get(err165_money_not_enough) ->
    1650054;

%%打造加速配置错误
get(err165_toy_speed_up_cfg) ->
    1650055;

%%不是玩具喔
get(err165_not_toy) ->
    1650056;

%%宝宝还没拥有这件时装哟
get(err165_has_not_fashion) ->
    1650057;

%%宝宝已经穿上这件时装啦
get(err165_has_dress_up) ->
    1650058;

%%时装已经激活过啦
get(err165_fashion_has_active) ->
    1650059;

%%不是宝宝时装喔
get(err165_not_fashion) ->
    1650060;

%%时装已经达到最大等级啦
get(err165_fashion_max_lv) ->
    1650061;

%%玩具已经是最大品质，无法合成啦
get(err165_toy_max_color) ->
    1650062;

%%打造库Id错误
get(err165_select_id_err) ->
    1650063;

%%时装类型错误
get(err165_dress_type_err) ->
    1650064;

%%槽位已经开启了哟
get(err165_slot_has_open) ->
    1650065;

%%槽位达到条件就会激活啦
get(err165_slot_auto_open) ->
    1650066;

%%不是槽位喔
get(err165_not_slot) ->
    1650067;

%%打造还没开始喔
get(err165_forge_has_not_start) ->
    1650068;

%%玩具没有强化过哟
get(err165_toy_has_not_stren) ->
    1650069;

%%不是玩具套装类型喔~
get(err165_child_not_suit_type) ->
    1650070;

%%玩具套装还没激活噢
get(err165_child_not_active_toy) ->
    1650071;

%%套装还没有集齐喔
get(err165_child_progress_not_reach) ->
    1650072;

%%已经领取过套装奖励啦
get(err165_child_suit_has_receive) ->
    1650073;

%%已经拥有这个玩具啦
get(err165_child_toy_has_active) ->
    1650074;

%%道具不足，继续努力哟
get(err165_toy_material_not_enough) ->
    1650075;

%%玩具盒升级配置错误
get(err165_toy_box_upgrade_cfg_err) ->
    1650076;

%%套装配置错误
get(err_165_toy_suit_cfg_err) ->
    1650077;

%%玩具套装类型错误
get(err165_toy_suit_type_err) ->
    1650078;

%%没有这个玩具喔
get(err165_toy_cfg_err) ->
    1650079;

%%您有玩具未激活，不可以分解喔
get(err165_has_toy_not_active) ->
    1650080;

%%玩具盒已经达到最大等级啦
get(err165_toy_box_max_lv) ->
    1650081;

%%技能配置错误
get(err165_skill_err) ->
    1650082;

%%奖励已经领取过啦
get(err165_child_heart_link_reward_received) ->
    1650083;

%%当前还不能领取喔
get(err165_child_heart_link_exp_not_enough) ->
    1650084;

%%同心值已达到最大值啦
get(err165_max_link_heart_exp) ->
    1650085;

%%同心配置错误
get(err165_link_heart_cfg_err) ->
    1650086;

%%还未达到领养宝宝同心值哟
get(err165_link_heart_not_finish) ->
    1650087;

%%还没穿上这件时装，不需要脱下哟
get(err165_has_not_dress_up) ->
    1650088;

%%玩家精华不足
get(err165_child_toy_debris_not_enough) ->
    1650089;

%%还没达到时装开启阶段哟
get(err165_child_not_reach_fashion_open_lv) ->
    1650090;

%%开服天数不满足
get(err165_not_receive_open_day) ->
    1650091;

%%还有奖励未领取完哟
get(err165_not_receive_all_reward) ->
    1650092;

%%请先领取前一个奖励哟
get(err165_child_reward_not_receive_pre) ->
    1650093;

%%所有奖励已经领取完了哟
get(err165_has_receive_all_reward) ->
    1650094;

%%未达到跟随等级喔
get(err165_follow_month_not_enough) ->
    1650095;

%%您还未晒娃，不能领取喔
get(err165_has_not_show_off) ->
    1650096;

%%奖励已经领取过了
get(err165_has_received_reward) ->
    1650097;

%%奖励配置错误
get(err165_reward_cfg_err) ->
    1650098;

%%当前排名无奖励可领取
get(err165_rank_has_not_reward) ->
    1650099;

%%你已经晋升到最高学位啦！
get(err166_max_degree) ->
    1660001;

%%经验不足继续加油喔~
get(err166_exp_no_enough) ->
    1660002;

%%副本目标未完成
get(err166_dun_unfinish) ->
    1660003;

%%收集材料不足
get(err166_matrial_no_enough) ->
    1660004;

%%不存在这门功课喔
get(err166_classwork_no_exit) ->
    1660005;

%%功课还没完成继续加油喔~
get(err166_classwork_unfinish) ->
    1660006;

%%奖励已经领取过了
get(err166_reward_received) ->
    1660007;

%%功课已经完成啦！
get(err166_classwork_finished) ->
    1660008;

%%你今天还没有领取这门功课喔
get(err166_classwork_no_get) ->
    1660009;

%%抽奖池类型错误
get(err170_pool_type_err) ->
    1700001;

%%抽奖次数配置错误
get(err170_draw_times_cfg_err) ->
    1700002;

%%您没有参与到相关抽奖哟
get(err170_not_capsule_egg_data) ->
    1700003;

%%兑换次数不够啦
get(err170_exchange_count_not_enough) ->
    1700004;

%%选取的兑换商品错误哟
get(err170_exchange_pos_err) ->
    1700005;

%%积分不够了喔
get(err170_score_not_enough) ->
    1700006;

%%仓库空间不足，请先提取
get(err170_warehose_not_enough) ->
    1700007;

%%宝库抽奖券配置错误
get(err170_config_err) ->
    1700008;

%%您还没到开放等级喔
get(err170_lv_not_enough) ->
    1700009;

%%前置任务未完成哟
get(err170_pre_task_not_finish) ->
    1700010;

%%本活动还没开放哟
get(err170_open_day_err) ->
    1700011;

%%次数参数错误
get(err170_times_err) ->
    1700012;

%%已经领取过次数奖励啦
get(err170_times_has_received) ->
    1700013;

%%还未达成领取条件哟
get(err170_times_cannot_receive) ->
    1700014;

%%您已经激活了该式神！
get(err173_have_active_god) ->
    1730001;

%%您还没有激活该式神哦！
get(err173_have_not_active) ->
    1730002;

%%式神已达最高星级！
get(err173_god_star_max) ->
    1730003;

%%式神等级不足！
get(err173_god_lv_not_satisfy) ->
    1730004;

%%式神已达最高等级！
get(err173_god_lv_max) ->
    1730005;

%%唤神技能不存在
get(err173_god_skill_not_exist) ->
    1730006;

%%该唤神技能已达最高等级
get(err173_god_skill_lv_max) ->
    1730007;

%%唤神装备位置参数错误
get(err173_god_equip_pos_error) ->
    1730008;

%%装备已达满级！
get(err173_god_equip_lv_max) ->
    1730009;

%%重复操作，请稍后！
get(err173_god_pos_repeat) ->
    1730010;

%%解锁条件不足！
get(err173_god_unlock_con_error) ->
    1730011;

%%位置尚未解锁！
get(err173_god_pos_not_unlock) ->
    1730012;

%%请先下阵援护式神！
get(err173_need_off_help_god) ->
    1730013;

%%当前状态无法召唤！
get(err173_without_con_to_summon) ->
    1730014;

%%没有上阵的式神！
get(err173_no_on_pos_god) ->
    1730015;

%%次数不足，无法领取
get(err173_not_enough_times) ->
    1730016;

%%奖励已经领取过
get(err173_have_receive) ->
    1730017;

%%配置错误
get(err173_error_config) ->
    1730018;

%%唤神召唤冷却中
get(err173_summon_cd) ->
    1730019;

%%请勿重复召唤唤神
get(err173_god_summon) ->
    1730020;

%%唤神未上阵，无法操作
get(err173_god_have_not_in_pos) ->
    1730021;

%%七天登录活动已关闭
get(err175_login_reward_closed) ->
    1750001;

%%今日已经领取
get(err175_today_already_get) ->
    1750002;

%%登录天数不足
get(err175_not_enough_days) ->
    1750003;

%%该天数已领取，请勿重复操作
get(err175_the_day_have_rewarded) ->
    1750004;

%%活动已经结束
get(err176_act_end) ->
    1760001;

%%完成本日所有目标可领取！
get(err176_today_task_no_finish) ->
    1760002;

%%活力值不足
get(err177_short_of_energy_value) ->
    1770001;

%%选择的鱼竿数量不足
get(err177_short_of_fishing_rod) ->
    1770002;

%%选择的鱼饵数量不足
get(err177_short_of_bait) ->
    1770003;

%%请选择渔具
get(err177_please_select_fishing_gear) ->
    1770004;

%%不在钓鱼区内
get(err177_no_in_fishing_scene) ->
    1770005;

%%配置数据不存在
get(err177_data_no_exist) ->
    1770006;

%%参数类型错误
get(err177_args_type_error) ->
    1770007;

%%鱼儿没有上钩
get(err177_fish_do_not_bite) ->
    1770008;

%%没有选择渔具
get(err_177_no_select_tool) ->
    1770009;

%%场景切换失败
get(err_177_scene_change_failure) ->
    1770010;

%%等级未达到开放等级
get(err177_lv_not_reach_the_open_level) ->
    1770011;

%%钓鱼等级未达到开放等级
get(err177_fishing_lv_not_reach_the_open_level) ->
    1770012;

%%鱼竿配置不存在
get(err177_rod_data_no_exist) ->
    1770013;

%%鱼饵配置不存在
get(err177_bait_data_no_exist) ->
    1770014;

%%购买数量错误
get(err_177_buy_num_error) ->
    1770015;

%%渔具类道具不能存入仓库
get(err177_fishing_gear_can_not_storage) ->
    1770016;

%%钓鱼模式中不能切换场景
get(err177_fishing_cant_change_scene) ->
    1770017;

%%已达升阶上限
get(err179_baby_max_stage) ->
    1790002;

%%不正确的物品类型
get(err179_wrong_goods_type) ->
    1790003;

%%已幻化
get(err179_already_figure) ->
    1790008;

%%已领取奖励
get(err181_award_received) ->
    1810001;

%%未达到领取条件
get(err181_condition_not_met) ->
    1810002;

%%参数类型错误
get(err181_args_type_error) ->
    1810003;

%%不可镶嵌在该位置
get(err181_not_inlay_pos) ->
    1810004;

%%未解锁
get(err181_pos_lock) ->
    1810005;

%%已镶嵌
get(err181_pos_has_been_inlay) ->
    1810006;

%%未达到领取条件
get(err182_condition_not_met) ->
    1820000;

%%奖励已经领取过啦
get(err182_reward_has_received) ->
    1820001;

%%没有邮件
get(err190_no_mail) ->
    1900001;

%%读取邮件失败
get(err190_read_mail_content_fail) ->
    1900002;

%%没有邮件附件
get(err190_no_mail_attachment) ->
    1900003;

%%没有邮件可以删除
get(err190_no_mail_to_delete) ->
    1900004;

%%无法删除带附件的邮件
get(err190_have_attachment_not_to_delete) ->
    1900005;

%%背包已满,无法领取剩余附件
get(err190_bag_full) ->
    1900006;

%%邮件已经失效，无法删除
get(err190_mail_timeout_to_delete) ->
    1900007;

%%邮件已经失效，无法领取
get(err190_mail_timeout_to_extract_attachment) ->
    1900008;

%%邮件标题过长
get(err190_mail_title_len) ->
    1900009;

%%邮件标题含有敏感字
get(err190_mail_title_sensitive) ->
    1900010;

%%邮件内容过长
get(err190_mail_content_len) ->
    1900011;

%%邮件内容含有敏感字
get(err190_mail_content_sensitive) ->
    1900012;

%%发送邮件次数不足
get(err190_send_guild_mail_count_not_enough) ->
    1900013;

%%必须在社团才能发社团邮件
get(err190_must_on_guild_to_send_guild_mail) ->
    1900014;

%%没有权限发社团邮件
get(err190_not_permisssion_to_send_guild_mail) ->
    1900015;

%%处于反馈的冷却时间内
get(err190_on_feedback_cd) ->
    1900016;

%%反馈内容过长或者存在敏感字
get(err190_feedback_not_valid) ->
    1900017;

%%附件已领取
get(err190_have_receive_attachment) ->
    1900018;

%%开始采集
get(err200_start_collect) ->
    2000001;

%%结束采集
get(err200_finish_collect) ->
    2000002;

%%距离太远
get(err200_long_distance) ->
    2000003;

%%已完成的采集
get(err200_have_collected) ->
    2000004;

%%采集时间不足
get(err200_not_enough_time) ->
    2000005;

%%采集怪不属于本公会
get(err200_belong_error) ->
    2000006;

%%采集次数已满
get(err200_collect_count_limit) ->
    2000007;

%%采集怪配置id不对应
get(err200_collect_mon_error) ->
    2000008;

%%幻兽之域普通采集次数已满
get(err200_eudemons_count_max) ->
    2000009;

%%幻兽之域珍惜采集次数已满
get(err200_priceless_count_max) ->
    2000010;

%%已达宝箱开启上限
get(err200_box_collect_max) ->
    2000011;

%%开启青云夺宝的等级不足
get(err200_collect_lv_limit) ->
    2000012;

%%该物品正在被他人采集
get(err200_be_collecting) ->
    2000013;

%%中断采集成功
get(err200_stop_collect) ->
    2000014;

%%背包空间不足
get(err200_goods_bag_limit) ->
    2000015;

%%不是本组的攻城器械
get(err200_not_the_city_equip) ->
    2000016;

%%已经在攻城器械上了
get(err200_have_on_city_equip) ->
    2000017;

%%该水晶已被我方占领
get(err200_have_invaded) ->
    2000018;

%%普通资源采集次数已达上限
get(err200_normal_res_count_limit) ->
    2000019;

%%限时资源采集次数已达上限
get(err200_limited_res_count_limit) ->
    2000020;

%%社团采集每日参与活动次数已达上限
get(err200_guild_collect_join_limit) ->
    2000021;

%%本次活动的封印次数已达上限
get(err200_guild_collect_count_limit) ->
    2000022;

%%角色未死亡
get(err200_role_not_die) ->
    2000023;

%%复活时间未到
get(err200_revive_time_error) ->
    2000024;

%%复活冷却时间未到
get(err200_revive_time_cd) ->
    2000025;

%%复活次数已满
get(err200_revive_count_error) ->
    2000026;

%%彩钻复活次数已满
get(error_gold_revive_count_limit) ->
    2000027;

%%本副本不允许复活
get(err200_dun_not_allow_revive) ->
    2000028;

%%复活方式出错
get(err200_revive_type_error) ->
    2000029;

%%助战状态无法采集
get(err200_help_cant_collect) ->
    2000030;

%%采集失败
get(err200_collec_wrong) ->
    2000031;

%%该技能已经达到最大等级
get(err210_skill_max_lv) ->
    2100001;

%%技能配置错误
get(err210_skill_error) ->
    2100002;

%%人物等级不足，无法升级技能
get(err210_lv_not_enough) ->
    2100003;

%%铜币不足
get(err210_coin_not_enough) ->
    2100004;

%%前置技能未学习
get(err210_no_pre_skill) ->
    2100005;

%%前置技能等级不足，无法学习
get(err210_no_pre_skill_lv) ->
    2100006;

%%技能点不足，无法升级技能
get(err210_point_not_enough) ->
    2100007;

%%技能投入点不足，无法学习或升级技能
get(err210_no_pre_skill_point) ->
    2100008;

%%未学习天赋技能，不能重置
get(err210_no_learn_talent_skill) ->
    2100009;

%%不能学习非本职业天赋技能
get(err210_not_mycarrer_talent_skill) ->
    2100010;

%%不是铭文技能，无法升级
get(err210_not_rune_upgrade) ->
    2100011;

%%不是天赋技能，无法学习
get(err_not_talent_learn) ->
    2100012;

%%不是主动技能
get(err210_not_active_skill) ->
    2100013;

%%vip等级不足
get(err210_vip_lev_not_enough) ->
    2100014;

%%激活贵族可自动获得
get(err210_active_sup_vip) ->
    2100015;

%%不在队伍中
get(err215_not_in_team) ->
    2150001;

%%不是跨服组队
get(err215_not_dun_multi) ->
    2150002;

%%所有成员都为助战
get(err215_not_all_help_type) ->
    2150003;

%%操作太快
get(err215_quick_handle) ->
    2150004;

%%有队员等级不足，无法进入
get(err215_not_enough_lv_to_enter_dungeon) ->
    2150005;

%%有队员已无次数，无法进入
get(err215_dungeon_count_daily) ->
    2150006;

%%有队员已无助战次数,无法进入
get(err215_dungeon_count_daily_help) ->
    2150007;

%%已经有队伍
get(err215_have_team) ->
    2150008;

%%不存在该队伍
get(err215_no_team) ->
    2150009;

%%队伍正在副本中
get(err215_is_on_dungeon) ->
    2150010;

%%战力不匹配
get(err215_less_power) ->
    2150011;

%%等级不匹配
get(err215_less_lv) ->
    2150012;

%%队伍正在切换状态中
get(err215_is_change_now) ->
    2150013;

%%正在跨服组队中
get(err215_on_multi_team) ->
    2150014;

%%已满员
get(err215_team_max_member) ->
    2150015;

%%有队员无准备,无法进入
get(err215_not_all_ready) ->
    2150016;

%%不是队长
get(err215_not_leader) ->
    2150017;

%%有队员条件不足，无法切换
get(err215_member_not_condition) ->
    2150018;

%%不能委任给自己
get(err215_not_change_self) ->
    2150019;

%%队员不存在
get(err215_member_not_exit) ->
    2150020;

%%不能催促自己
get(err215_not_prompt_self) ->
    2150021;

%%超过目标最大人数
get(err215_target_limit_num) ->
    2150022;

%%不能委任给假人
get(err215_not_to_dummy) ->
    2150023;

%%不能加入系统假人队伍
get(err215_is_dummy_team) ->
    2150024;

%%每日次数已用完
get(err215_not_daily_times) ->
    2150025;

%%助战次数已用完
get(err215_not_help_times) ->
    2150026;

%%已超过该副本的进入人数
get(err215_is_max_num) ->
    2150027;

%%连接不上跨服中心
get(err215_not_connect_center) ->
    2150028;

%%请求跨服中心超时
get(err215_time_out_request) ->
    2150029;

%%请勿重复切换匹配状态
get(err215_repeat_match_state) ->
    2150030;

%%讨伐类型有误
get(err215_subtype_error) ->
    2150031;

%%无法匹配此类组队活动
get(err215_role_match_dun_error) ->
    2150032;

%%队伍密码错误，无法操作
get(err215_password_error) ->
    2150033;

%%已在队伍中，请勿重复操作
get(err215_have_in_team) ->
    2150034;

%%对方分身已在此队伍中，请勿重复操作
get(err215_mirror_in_this_team) ->
    2150035;

%%对方等级不足，无法邀请
get(err215_oppo_lv_limit) ->
    2150036;

%%等级不足，无法操作
get(err215_lv_limit) ->
    2150037;

%%支援次数不足，请等待恢复
get(err215_assist_count_limt) ->
    2150038;

%%未通关波数，无法接受邀请
get(err215_have_not_finish_wave) ->
    2150039;

%%还未有人通关副本，无法领取奖励
get(err215_have_not_pass_dun) ->
    2150040;

%%当前无队伍匹配，助战状态无法创队
get(err215_help_can_not_create_team) ->
    2150041;

%%非投票阶段，无法操作
get(err215_not_in_vote) ->
    2150042;

%%当前处于投票阶段，无法操作
get(err215_in_vote) ->
    2150043;

%%您已投票，无法操作
get(err215_have_voted) ->
    2150044;

%%请勿重复切换审批状态
get(err215_repeat_approve_state) ->
    2150045;

%%审批状态有误
get(err215_approve_state_error) ->
    2150046;

%%无法切换队伍目标
get(err215_cant_change_team_target) ->
    2150047;

%%您正处于此目标队伍中，请勿重复操作
get(err215_have_in_target) ->
    2150048;

%%队员无法满足切换目标条件,无法操作
get(err215_mate_can_match) ->
    2150049;

%%成功提交入队申请
get(err215_join_req_done) ->
    2150050;

%%当前多人副本队伍匹配中
get(err215_in_dun_multi_match) ->
    2150051;

%%有队员处于其他活动中
get(err215_in_other_act) ->
    2150052;

%%你已发出申请，无需重复操作!
get(err215_have_req) ->
    2150053;

%%请勿重复切换协助状态
get(err215_not_repeat_change_help) ->
    2150054;

%%挑战次数不足，无法切换协助状态
get(err215_count_max) ->
    2150055;

%%队长无法切换协助状态
get(err215_leader_limit) ->
    2150056;

%%目标副本协助状态有误，无法操作
get(err215_help_dun_error) ->
    2150057;

%%请先通关前置副本
get(err215_pass_pre_dun) ->
    2150058;

%%队长处于协助状态，无法操作
get(err215_leader_help_type) ->
    2150059;

%%多人组队无法合并次数
get(err215_merge_count_error) ->
    2150060;

%%次数不足，无法合并
get(err215_merge_count_limit) ->
    2150061;

%%合并操作重复，无法切换
get(err215_same_merge_type) ->
    2150062;

%%当前榜单点赞已上限
get(err211_praise_num_limit) ->
    2210001;

%%目标未达成，无法操作
get(err211_first_top_limit) ->
    2210002;

%%该无该类型跨服排名
get(err211_rank_data_error) ->
    2210003;

%%分区数据准备中
get(err211_not_finish) ->
    2210004;

%%物品不够
get(err222_goods_not_enough) ->
    2220001;

%%战力不够
get(err222_combat_not_enough) ->
    2220002;

%%职称与服务器不对应
get(err222_title_not_equel) ->
    2220003;

%%配置出错
get(err222_title_config_error) ->
    2220004;

%%扣除物品失败
get(err222_deduction_goods_error) ->
    2220005;

%%开服天数不够
get(err222_6_not_enough_server_day) ->
    2220006;

%%头衔等级已达最高
get(err222_title_lv_max) ->
    2220007;

%%砸蛋次数不足
get(err223_num_not_enough) ->
    2230001;

%%等级不足
get(err223_lv_not_enough) ->
    2230002;

%%商城没有出售该商品
get(err223_shop_not_provide) ->
    2230004;

%%当前为重置时间
get(err223_reset_time) ->
    2230005;

%%未达到赠送条件
get(err223_dissatisfy_send_gift_condition) ->
    2230006;

%%未达到赠送条件
get(err223_receiver_lv_not_enough) ->
    2230007;

%%对方玩家不在线
get(err223_player_not_online) ->
    2230008;

%%对方魅力值为0，太可怜了，不要砸蛋了
get(err223_player_charm_is_zero) ->
    2230009;

%%砸蛋次数不足
get(err223_egg_time_lim) ->
    2230010;

%%每日购买次数不足
get(err223_sp_gift_limit_count) ->
    2230011;

%%已发出感谢，请勿重复操作
get(err223_have_thanked) ->
    2230012;

%%未达到奖励领取要求
get(err225_goal_reward_limit) ->
    2250001;

%%您已经有队伍
get(err240_in_team) ->
    2400001;

%%您正在切换场景
get(err240_changing_scene) ->
    2400002;

%%该玩家没有队伍
get(err240_no_team) ->
    2400003;

%%您不能踢除您自己
get(err240_kick_himself) ->
    2400004;

%%队伍人数已满
get(err240_max_member) ->
    2400005;

%%您不是队长
get(err240_not_leader) ->
    2400006;

%%不能踢队长
get(err240_not_kick_leader) ->
    2400007;

%%对方拒绝您的加入
get(err240_leader_reject) ->
    2400008;

%%对方不在线
get(err240_other_offline) ->
    2400009;

%%对方已经有队伍
get(err240_other_in_team) ->
    2400010;

%%该队伍已解散
get(err240_team_disappear) ->
    2400011;

%%对方已经下线
get(err240_offline) ->
    2400012;

%%入场投票超时
get(err240_arbitrate_timeout) ->
    2400013;

%%{1}拒绝进入
get(err240_arbitrate_refuse) ->
    2400014;

%%投票已经过期
get(err240_not_current_aribirate_req) ->
    2400015;

%%没有投票
get(err240_not_on_arbitrate_req_to_vote) ->
    2400017;

%%只有队长可以发起入场投票
get(err240_not_leader_to_arbitrate_req) ->
    2400018;

%%在副本中无法发起入场投票
get(err240_not_arbitrate_req_in_dungeon) ->
    2400019;

%%不能重复发起入场投票
get(err240_not_again_arbitrate_req) ->
    2400020;

%%不是队伍副本
get(err240_not_team_dungeon) ->
    2400021;

%%您加入了新的队伍
get(err240_join_team) ->
    2400022;

%%{1}加入队伍
get(err240_new_member) ->
    2400023;

%%您离开了队伍
get(err240_self_out_team) ->
    2400024;

%%{1}离开了队伍
get(err240_out_team) ->
    2400025;

%%您被请出了队伍
get(err240_self_shot_of_team) ->
    2400026;

%%{1}被请出了队伍
get(err240_shot_of_team) ->
    2400027;

%%当前没有队员跟战
get(err240_no_member_follow) ->
    2400028;

%%取消队员跟战成功
get(err240_cancel_follow_success) ->
    2400029;

%%队伍状态改变,投票中断
get(err240_change_state_to_interrput_arbitrate) ->
    2400030;

%%队伍处于副本中无法进行操作
get(err240_on_dungeon_not_to_do) ->
    2400031;

%%不在队伍中，无法操作
get(err240_not_on_team) ->
    2400032;

%%本队伍处于副本中，无法加入
get(err240_this_team_on_dungeon) ->
    2400033;

%%无邀请对象
get(err240_34_no_invite_role) ->
    2400034;

%%{1}同意,正玩命赶回安全区.
get(err240_agree_to_enter_safety_scene) ->
    2400035;

%%等级不足，无法创建队伍
get(err240_not_enough_lv_to_create_team) ->
    2400036;

%%等级不足，无法加入队伍
get(err240_not_enough_lv_to_join_team) ->
    2400037;

%%没有达到进入该目标的等级
get(err240_not_enough_lv_to_enter_target) ->
    2400038;

%%{1}没有达到进入该目标的等级
get(err240_not_enough_lv_to_enter_target_with_name) ->
    2400039;

%%您没有达到目标的最低等级，无法创建
get(err240_not_enough_lv_to_create_target) ->
    2400040;

%%{1}所在场景无法进入
get(err240_not_on_safe_scene_to_outdoor_by_other) ->
    2400047;

%%等级范围不合法
get(err240_choose_lv_error) ->
    2400048;

%%该目标不可匹配
get(err240_auto_pair_limit) ->
    2400049;

%%正在自动匹配中，请先取消自动匹配
get(err240_change_when_matching) ->
    2400050;

%%全员均助战，无法进入副本
get(err240_all_for_help_other) ->
    2400051;

%%{1}不在线
get(err240_teammates_offline) ->
    2400052;

%%{1}物品不足
get(err240_cost_error) ->
    2400053;

%%该副本类型不能设置助战
get(err240_help_type_setup_limit) ->
    2400054;

%%队伍人数超过新目标限定人数
get(err240_too_many_members) ->
    2400055;

%%正在创建队伍中，请勿进行其它操作
get(err240_team_create_unfinished) ->
    2400056;

%%请先把队伍目标改成{1}
get(err240_cls_type_error) ->
    2400057;

%%当前正在队伍投票中，无法操作
get(err240_in_arbitrate) ->
    2400058;

%%{1}{2}
get(err240_me_to_other) ->
    2400059;

%%队伍里有跨服成员无法切换成本服队伍
get(err240_local_team_with_other_serv) ->
    2400061;

%%该队伍正在匹配诛邪战场，无法加入
get(err240_this_team_matching) ->
    2400062;

%%您已经投过票了
get(err240_arbitrate_vote_repeat) ->
    2400063;

%%队员无法邀请伴侣，请先退队
get(err240_invite_diff_target_error) ->
    2400064;

%%没有可匹配的队伍
get(err240_no_teams_for_match) ->
    2400065;

%%请先选择组队目标
get(err240_choose_target_first) ->
    2400066;

%%请选择正确队伍目标
get(err240_team_target_not_exist) ->
    2400067;

%%当前目标不可设置等级限制
get(err240_cannot_choose_lv) ->
    2400068;

%%当前目标不可设置战力限制
get(err240_cannot_choose_power) ->
    2400069;

%%{1}没有达到进入该目标的战力
get(err240_not_enough_power_to_enter_target_with_name) ->
    2400070;

%%亲密度不足{1}，无法进入该副本
get(err240_couple_intimacy_not_enough) ->
    2400071;

%%处于副本中，无法退出队伍
get(err240_cannot_quit_in_dun) ->
    2400072;

%%战力不足
get(err240_lower_power) ->
    2400073;

%%无法设置密码
get(err240_cannot_set_password) ->
    2400074;

%%目标活动不存在
get(err240_act_not_exist) ->
    2400075;

%%组队不存在
get(err240_team_not_exist) ->
    2400076;

%%队伍正在组队匹配中，请退出当前玩法再操作
get(err240_error_team_need_free) ->
    2400077;

%%密码错误
get(err240_password_error) ->
    2400078;

%%需要输入密码
get(err240_need_password) ->
    2400079;

%%对方尚未完成前置副本
get(err240_the_other_not_pre_dun) ->
    2400080;

%%战力不足
get(err240_not_enough_power) ->
    2400081;

%%特殊的组队活动不可切换
get(err240_not_same_act) ->
    2400082;

%%无法切换目标，队员等级不符合要求
get(err240_error_not_change) ->
    2400083;

%%召唤信息已过期！
get(err240_member_call_overdue) ->
    2400084;

%%目标场景不可进入！
get(err240_cannot_enter) ->
    2400085;

%%无法加入跨服队伍
get(err240_cls_team_join) ->
    2400086;

%%无法进行跨服间组队
get(err240_cls_team_limit) ->
    2400087;

%%该队伍不存在
get(err240_team_not_exist_1) ->
    2400088;

%%对方等级不足，无法操作
get(err240_oppo_lv_litmit) ->
    2400089;

%%超出可购买次数
get(err280_over_max_buy_num) ->
    2800001;

%%排名发生改变，请刷新！
get(err280_rank_had_changed) ->
    2800002;

%%挑战次数错误
get(err280_arena_num) ->
    2800003;

%%没有奖励
get(err280_none_reward) ->
    2800004;

%%已领取奖励
get(err280_already_receive_reward) ->
    2800005;

%%对手排名已改变
get(err280_rival_rank_change) ->
    2800006;

%%自己排名已改变
get(err280_self_rank_change) ->
    2800007;

%%挑战次数不足
get(err280_arena_num_not_enough) ->
    2800008;

%%等级不足
get(err280_lv_not_enough) ->
    2800009;

%%该玩家正在战斗中，请稍后
get(err280_on_battle_state) ->
    2800010;

%%只能查看前100名玩家信息
get(err280_page_not_vaild) ->
    2800011;

%%未达到要求的历史最高排名
get(err280_history_rank_not_enough) ->
    2800012;

%%您正在被挑战中，请稍后
get(err280_role_on_battle_state) ->
    2800013;

%%不能挑战自己
get(err280_challenge_self) ->
    2800014;

%%条件不足！
get(err280_reward_condition) ->
    2800015;

%%冷却时间没过
get(err280_cooldown_cd) ->
    2800016;

%%错误参数
get(err280_error_args) ->
    2800017;

%%vip等级不足
get(err280_vip_less) ->
    2800018;

%%只有竞技大神才可领取每日福利！
get(err280_sp_award_only) ->
    2800019;

%%只有排位前50的玩家可发起大神挑战！
get(err280_sp_rank_need) ->
    2800020;

%%挑战冷却中哦~
get(err280_arena_in_cooldown) ->
    2800021;

%%奖励已经领取
get(err281_award_is_got) ->
    2810001;

%%参与次数不足
get(err281_daily_enter_count_error) ->
    2810002;

%%您的可购买次数不足
get(err281_buy_count_limit) ->
    2810003;

%%您已经在匹配中
get(err281_match_repeat) ->
    2810004;

%%当前正在巅峰竞技匹配中
get(err281_on_matching_state) ->
    2810005;

%%当前不在匹配状态中
get(err281_not_on_match_state) ->
    2810006;

%%当前正在参与巅峰竞技中
get(err281_on_battle_state) ->
    2810007;

%%您的段位不足
get(err281_grade_limit) ->
    2810008;

%%没有可领取的荣誉值
get(err281_no_honor_reward) ->
    2810009;

%%由于您的对手不能及时到场，您获得胜利
get(err281_enemy_is_late) ->
    2810010;

%%此任务已接取
get(err300_task_trigger) ->
    3000001;

%%任务配置错误（无此任务）
get(err300_task_config_null) ->
    3000002;

%%等级不足，无法接取任务
get(err300_lv_not_enough) ->
    3000003;

%%请加入帮派后再接取此任务
get(err300_not_guild) ->
    3000004;

%%阵营不符，无法接取
get(err300_realm_diff) ->
    3000005;

%%职业不符，无法接取
get(err300_career_diff) ->
    3000006;

%%前置任务未完成
get(err300_prev_not_fin) ->
    3000007;

%%任务已完成
get(err300_fin) ->
    3000008;

%%条件不满足，无法接取（暂定提示）
get(err300_condition_err) ->
    3000009;

%%背包空间不足，请清理后再完成
get(err300_not_enough_cell) ->
    3000010;

%%转生次数不符，无法领取
get(err300_turn_diff) ->
    3000011;

%%今日日常任务已全部完成
get(err300_daily_task_finished) ->
    3000012;

%%社团任务已全部完成
get(err300_guild_task_finished) ->
    3000013;

%%此任务未领取
get(err300_no_task_trigger) ->
    3000014;

%%任务没有完成
get(err300_task_no_finish) ->
    3000015;

%%您的等级段没有相应的任务
get(err300_lv_no_task) ->
    3000016;

%%该任务没有双倍奖励
get(err300_not_double_reward) ->
    3000017;

%%需要完成更多环任务
get(err300_need_finish_more_task) ->
    3000018;

%%活动未开启
get(err331_act_closed) ->
    3310001;

%%没有活动奖励配置
get(err331_no_act_reward_cfg) ->
    3310002;

%%条件不足,不能领取
get(err331_act_can_not_get) ->
    3310003;

%%奖励已领取
get(err331_already_get_reward) ->
    3310004;

%%已经评价过
get(err331_fs_already_evaluate) ->
    3310005;

%%奖励超时
get(err331_act_time_out) ->
    3310006;

%%刷新失败，您今天的砸蛋次数已用完
get(err331_smashed_egg_refresh_fail) ->
    3310007;

%%本日钻石砸蛋次数已达到上限
get(err331_smashed_egg_times_lim) ->
    3310008;

%%本日数量已卖完
get(err331_limit_buy_daily_num_max) ->
    3310009;

%%这个金蛋已经被砸过了
get(err331_egg_has_smashed) ->
    3310010;

%%购买时间已结束，下次请早
get(err331_cloud_buy_end) ->
    3310011;

%%上一订单尚未完成
get(err331_cloud_buy_order_unfinished) ->
    3310012;

%%当前个人限购次数已达上限
get(err331_cloud_buy_personal_limit) ->
    3310013;

%%剩余份数不足，购买失败
get(err331_cloud_buy_not_enough) ->
    3310014;

%%无法获悉首领的入侵地点，请小心搜索
get(err331_act_boss_scene_tips) ->
    3310015;

%%该场景已满人，建议到别处剿灭首领
get(err331_act_boss_scene_people_lim) ->
    3310016;

%%该场景内的首领已全部被击退，建议到别处继续剿灭
get(err331_act_boss_scene_no_boss) ->
    3310017;

%%本轮活动已完成
get(err331_act_mission_complete) ->
    3310018;

%%奖励已被领完
get(err331_count_limit) ->
    3310019;

%%只有社团团长才可领取该奖励
get(err331_only_president_reward) ->
    3310020;

%%抽奖券不足
get(err331_ticket_limit) ->
    3310021;

%%该商品本日个人次数已买完
get(err331_limit_buy_daily_player_max) ->
    3310022;

%%本次活动购买时间已截止~
get(err331_not_in_buy_day) ->
    3310023;

%%已购买该豪礼~
get(err331_login_return_reward_has_buy) ->
    3310024;

%%采集怪采完用，该场景内的采集物已全部被采完，建议到别处继续采集
get(err331_act_boss_scene_no_collect) ->
    3310025;

%%奖池已领完，请刷新奖池
get(err331_flop_times_lim) ->
    3310026;

%%兑换次数已用尽
get(err331_receive_time_limit) ->
    3310027;

%%无法选择大奖
get(err331_te_cant_choose_big) ->
    3310028;

%%没有该类型大奖
get(err331_te_big_id_wrong) ->
    3310029;

%%当前无法再次选择大奖
get(err331_te_not_choose_again) ->
    3310030;

%%请先选择大奖
get(err331_te_not_choose_big) ->
    3310031;

%%奖励选择数量不正确
get(err331_wrong_reward_num) ->
    3310032;

%%祈愿时间只限:周一12:00-24:00
get(err331_not_supplication_time) ->
    3310033;

%%已投资该档位
get(err331_invest_repeat) ->
    3310034;

%%没有转盘次数啦
get(err331_turntable_no_times) ->
    3310035;

%%积分不足，无法兑换奖励
get(err331_score_not_enough) ->
    3310036;

%%个人购买次数已达上限
get(err331_kf_cloud_buy_personal_buy_num_lim) ->
    3310037;

%%商品总购买次数已达上限
get(err331_kf_cloud_buy_total_buy_num_lim) ->
    3310038;

%%商品id错误
get(err331_kf_cloud_buy_product_id_err) ->
    3310039;

%%请等待下次活动开启
get(err331_pls_wait_for_next_act) ->
    3310040;

%%已开奖
get(err331_kf_cloud_buy_drawing) ->
    3310041;

%%不可领取
get(err331_can_not_pick_up) ->
    3310042;

%%奖池已锁定
get(err331_lucky_flop_cant_select) ->
    3310043;

%%选择奖励重复
get(err331_lucky_flop_reward_repeat) ->
    3310044;

%%奖励不存在
get(err331_lucky_flop_no_reward) ->
    3310045;

%%选择奖励失败
get(err331_lucky_flop_select_error) ->
    3310046;

%%奖励未选取
get(err331_lucky_flop_no_select) ->
    3310047;

%%奖励已抽完，请重置奖池
get(err331_lucky_flop_need_reset) ->
    3310048;

%%还有未领取的累计奖励哦
get(err331_lucky_flop_cant_reset) ->
    3310049;

%%没有剩余次数
get(err331_has_no_more_times) ->
    3310050;

%%充值金额不足
get(err331_need_recharge_more) ->
    3310051;

%%不符合等级条件
get(err331_lv_unreach) ->
    3310052;

%%超出购买上限
get(err331_over_limit_num) ->
    3310053;

%%已购买还没到可领取时间
get(err331_award_not_due) ->
    3310054;

%%已过期不可购买
get(err331_act_overdue) ->
    3310055;

%%所有轮次均已抽取完毕
get(err331_all_round_over) ->
    3310056;

%%投掷次数不足，无法操作
get(err331_have_not_dice_count) ->
    3310057;

%%投掷类型错误
get(err331_dice_type_error) ->
    3310058;

%%投掷次数不足
get(err331_dice_count_limit) ->
    3310059;

%%您已完成本期所有圈数，无法再操作
get(err331_max_round) ->
    3310060;

%%补签次数不足
get(err331_reissue_count_limit) ->
    3310061;

%%圈数奖励已领取
get(err331_round_rewarded) ->
    3310062;

%%圈数未完成,无法领取
get(err331_round_not_fin) ->
    3310063;

%%圈数数据有误
get(err331_round_data_error) ->
    3310064;

%%宝典任务未达成,无法领取
get(err331_contract_task_not_fin) ->
    3310065;

%%宝典任务类型有误,请重新操作
get(err331_task_type_error) ->
    3310066;

%%宝典奖励已领取
get(err331_have_contract_reward) ->
    3310067;

%%宝典等级不足，无法领取等级奖励
get(err331_contract_lv_limit) ->
    3310068;

%%宝典等级奖励已领取
get(err331_contract_lv_rewarded) ->
    3310069;

%%无法使用折扣卡,请重新操作
get(err331_dicount_limit) ->
    3310070;

%%您已购买尊享宝典,请勿重复操作
get(err331_contract_haved_buy) ->
    3310071;

%%当前等级的奖励都领取完了哦！
get(err331_phantom_not_reward) ->
    3310072;

%%还未能领取当前奖励哟
get(err331_hi_points_not_receive) ->
    3310073;

%%不能领取本期的奖励喔
get(err331_hi_points_subtype_err) ->
    3310074;

%%转盘次数不足
get(err331_turntable_times_limit) ->
    3310075;

%%活动数据已过期！
get(err331_seckill_overdue) ->
    3310076;

%%秒杀尚未开始！
get(err331_seckill_not_open) ->
    3310077;

%%本场秒杀已结束！
get(err331_seckill_closed) ->
    3310078;

%%本场商品无法购买！
get(err331_seckill_cannot_buy) ->
    3310079;

%%您的购买次数不足！
get(err331_seckill_role_limit) ->
    3310080;

%%商品已售空！
get(err331_seckill_total_limit) ->
    3310081;

%%天数不足
get(err331_need_more_day) ->
    3310082;

%%已经全部刮完，先刷新一下哟
get(err331_all_scratch) ->
    3310083;

%%刮卡选项错误
get(err331_scratch_option_err) ->
    3310084;

%%选择的刮卡位置不对哟
get(err331_scratch_pos_err) ->
    3310085;

%%刮奖奖励错误
get(err331_scratch_reward_err) ->
    3310086;

%%还没全部刮完，不需要刷新哟
get(err331_not_scratch_all) ->
    3310087;

%%抽奖消耗配置错误
get(err331_draw_cost_config_err) ->
    3310088;

%%抽奖积分不足哟
get(err331_draw_cost_not_enough) ->
    3310089;

%%刮奖材料不足哟
get(err331_scratch_cost_not_enough) ->
    3310090;

%%存货准备中,请在{1}秒后重试
get(err331_vie_bag_cding) ->
    3310091;

%%已达可领最大数量{1}
get(err331_vie_bag_max) ->
    3310092;

%%请先达成上一档奖励哟
get(err331_last_reward) ->
    3310093;

%%达成条件即可领取红包哟
get(err331_receive_red_packet) ->
    3310094;

%%惊喜红包数据有误
get(err331_red_packet_err) ->
    3310095;

%%充值金额未达标哟
get(err331_recharge_not_enough) ->
    3310096;

%%红包配置错误
get(err331_red_packet_cfg_err) ->
    3310097;

%%红包已经全部抽取完啦
get(err331_red_packet_all_receive) ->
    3310098;

%%还未可以领取奖励
get(err331_red_packet_not_receive) ->
    3310099;

%%商品价格错误！
get(err331_discount_price_error) ->
    3310100;

%%商品已售罄！
get(err331_discount_times_limit) ->
    3310101;

%%玩家等级不足！
get(err331_discount_lv_limit) ->
    3310102;

%%优惠券错误！
get(err331_discount_coupon_error) ->
    3310103;

%%折扣券未达使用条件！
get(err331_discount_condition) ->
    3310104;

%%满减券未达使用条件！
get(err331_discount_ab_condition) ->
    3310105;

%%需要先抽奖哟
get(err331_box_need_draw_first) ->
    3310106;

%%宝箱已经领取过啦
get(err331_box_has_received) ->
    3310107;

%%宝箱配置错误
get(err331_box_cfg_err) ->
    3310108;

%%卡牌张数有误，请联系客服
get(err331_tarot_count_error) ->
    3310109;

%%卡牌奖池有误，请联系客服
get(err331_tarot_reward_error) ->
    3310110;

%%该位置已翻牌，请勿重复操作
get(err331_tarot_pos_error) ->
    3310111;

%%卡牌消耗异常，请联系客服
get(err331_tarot_cost_cfg_error) ->
    3310112;

%%翻牌次数不足
get(err331_tarot_num_error) ->
    3310113;

%%您还未翻牌，无需重置
get(err331_no_need_refresh_tarot) ->
    3310114;

%%进度值不足，无法领取
get(err331_progress_lack) ->
    3310115;

%%您的冒险点数不足哦~
get(err331_score_lack) ->
    3310116;

%%阶段错误
get(err331_phase_err) ->
    3310117;

%%兑换次数错误
get(err331_exchage_times_err) ->
    3310118;

%%已经兑换完啦
get(err331_exchange_times_not_enough) ->
    3310119;

%%奖励配置错误
get(err331_reward_cfg_err) ->
    3310120;

%%定制活动配置错误
get(err331_act_cfg_err) ->
    3310121;

%%阶段还未开启哟！
get(err331_receive_phase_err) ->
    3310122;

%%阶段奖励已经领取过啦
get(err331_phase_reward_received) ->
    3310123;

%%兑换等级错误
get(err331_exchange_lv_err) ->
    3310124;

%%今日已达到最大抽奖次数，请明天再来
get(err331_daily_max_draw) ->
    3310125;

%%今日已领取
get(err331_has_fetch_today) ->
    3310126;

%%需要先存入彩钻
get(err331_need_loans_gold) ->
    3310127;

%%彩钻已存满
get(err331_been_full_loans) ->
    3310128;

%%需先刷新奖池
get(err331_refresh_pool) ->
    3310129;

%%今日剩余次数已用完~！
get(err331_puzzle_times_limit) ->
    3310130;

%%请先完成上一次拼图哟
get(err331_puzzle_not_finish) ->
    3310131;

%%拼图替换位置错误
get(err331_puzzle_change_err) ->
    3310132;

%%请先开始拼图哟
get(err331_puzzle_not_start) ->
    3310133;

%%当前还是记忆时间哟
get(err331_puzzle_remember_time) ->
    3310134;

%%超时了喔
get(err331_puzzle_over_time) ->
    3310135;

%%还未购买解锁哦~
get(err331_not_buy) ->
    3310136;

%%冷却中，无法操作
get(err331_cd_chat) ->
    3310137;

%%已有玩家回答，无需重复操作
get(err331_have_answered) ->
    3310138;

%%无人提问，无法操作
get(err331_no_people_quiz) ->
    3310139;

%%该配方还未被发现，无法操作
get(err331_formula_need_unlock) ->
    3310140;

%%未达到领取奖励等级哟
get(err331_great_reward_lv_err) ->
    3310141;

%%当前充值金额不满足哟
get(err331_great_reward_recharge_not_enough) ->
    3310142;

%%当前消费金额不满足哟
get(err331_great_reward_consume_not_enough) ->
    3310143;

%%奖励参数类型错误
get(err331_great_reward_type_err) ->
    3310144;

%%超能大奖奖励配置错误
get(err331_great_reward_reward_err) ->
    3310145;

%%奖励已经领取过了喔
get(err331_great_reward_has_received) ->
    3310146;

%%无法自问自答
get(err331_cannot_answer_yourself) ->
    3310147;

%%需要先领取完前面的奖励哟
get(err331_great_reward_must_receive_all) ->
    3310148;

%%您已解锁该配方，无法操作
get(err331_have_unlocked_formula) ->
    3310149;

%%您还未解锁该配方，无法操作
get(err331_have_not_unlocked_formula) ->
    3310150;

%%该配方还未发现，无法操作
get(err331_not_discover_fomula) ->
    3310151;

%%活动未开放
get(err333_act_closed) ->
    3330001;

%%未连接跨服
get(err333_not_connect_center) ->
    3330002;

%%缺配置
get(err333_no_cost_config) ->
    3330003;

%%缺奖池配置
get(err333_no_pool_cfg) ->
    3330004;

%%玩家等级不足
get(err333_role_lev_less) ->
    3330005;

%%奖励不可重复领取
get(err333_already_get_reward) ->
    3330006;

%%缺配置
get(err333_no_times_reward_cfg) ->
    3330007;

%%不可领取
get(err333_can_not_get) ->
    3330008;

%%全服积分未达标
get(err333_server_score_unreached) ->
    3330009;

%%活动还未开启
get(err338_act_not_open) ->
    3380001;

%%已领取
get(err338_has_got) ->
    3380002;

%%积分不足
get(err338_lack_of_score) ->
    3380003;

%%没有该抽奖次数
get(err338_not_this_choice) ->
    3380004;

%%当前重置时间，请稍后点击
get(err338_point_later) ->
    3380005;

%%红包个数不能超过金额/社团人数上限
get(err339_split_max_num_err) ->
    3390000;

%%红包个数不能小于最小数量限制
get(err339_split_min_num_err) ->
    3390001;

%%红包不存在
get(err339_not_exist) ->
    3390002;

%%红包已过期
get(err339_has_expired) ->
    3390003;

%%红包为未发送状态，不能领取
get(err339_not_send) ->
    3390004;

%%今天该红包的发送次数已用完
get(err339_daily_times_no_enough) ->
    3390005;

%%没有加入社团，不能发红包
get(err339_not_join_guild) ->
    3390006;

%%该红包不属于你，不能发送
get(err339_not_owner) ->
    3390007;

%%vip等级不足
get(err339_vip_lv_not_enough) ->
    3390008;

%%红包已被发出，不能重复发送
get(err339_cannot_send_again) ->
    3390009;

%%领取金额达上限
get(err339_is_limit) ->
    3390010;

%%击杀当时不在场
get(err339_no_in_scene) ->
    3390011;

%%祝福语长度不匹配
get(err339_length_not_match) ->
    3390012;

%%手慢了
get(err339_has_over) ->
    3390013;

%%当日祈愿超过上限
get(err340_check_currencywish_fail) ->
    3400001;

%%非法祈愿类型
get(err340_undefined_currencywish_type) ->
    3400002;

%%祈愿所需消耗物品不足
get(err340_no_enough_consume) ->
    3400003;

%%社团名字长度不匹配
get(err400_guild_name_len) ->
    4000001;

%%社团名字含有敏感字
get(err400_guild_name_sensitive) ->
    4000002;

%%社团公告长度不匹配
get(err400_tenet_len) ->
    4000003;

%%社团宣言含有敏感字
get(err400_tenet_sensitive) ->
    4000004;

%%您已经有社团了~
get(err400_on_guild_not_to_create) ->
    4000005;

%%创建社团出错
get(err400_create_guild_cfg) ->
    4000006;

%%无法退出社团驻地
get(err400_not_station_scene_to_leave) ->
    4000007;

%%公告有敏感字
get(err400_announce_sensitive) ->
    4000008;

%%公告过长
get(err400_announce_len) ->
    4000009;

%%没有社团无法修改公告
get(err400_not_on_guild_to_modify_announce) ->
    4000010;

%%输入自动加入战力错误
get(err400_auto_approve_power_error) ->
    4000011;

%%输入自动加入等级错误
get(err400_auto_approve_lv_error) ->
    4000012;

%%设置审批类型出错
get(err400_approve_type_error) ->
    4000013;

%%本场景无法进入社团驻地
get(err400_this_scene_not_to_enter_station) ->
    4000014;

%%无社团无法进入社团驻地
get(err400_not_on_guild_to_station) ->
    4000015;

%%处于社团中无法申请加入社团
get(err400_on_guild_not_to_apply) ->
    4000016;

%%您没有权限~
get(err400_not_permission_to_clean_apply) ->
    4000017;

%%不在社团无法清理社团申请
get(err400_not_on_guild_to_clean_apply) ->
    4000018;

%%不能修改对方的权限
get(err400_can_not_modify_other_permission) ->
    4000019;

%%不在社团无法修改权限
get(err400_not_on_guild_to_modify_permission) ->
    4000020;

%%发送的权限修改参数出错
get(err400_not_right_is_allow_on_modify_permission) ->
    4000021;

%%该权限不能被修改
get(err400_not_modifiable_permission) ->
    4000022;

%%本职位不能被修改权限
get(err400_not_modified_permission_pos) ->
    4000023;

%%没有向该社团申请
get(err400_not_guild_apply) ->
    4000024;

%%没有权限设置称谓
get(err400_not_permission_to_rename_position) ->
    4000025;

%%不在社团无法设置称谓
get(err400_not_on_guild_to_rename_position) ->
    4000026;

%%本职位名字不能被修改
get(err400_not_modified_name_pos) ->
    4000027;

%%输入称谓含有敏感字
get(err400_position_name_sensitive) ->
    4000028;

%%输入称谓过长
get(err400_position_name_len) ->
    4000029;

%%你的权限不足
get(err400_this_position_can_not_kick_member) ->
    4000030;

%%没有权限踢除玩家
get(err400_not_permission_to_kick) ->
    4000031;

%%只能踢出本社团的玩家
get(err400_not_same_guild_to_kick) ->
    4000032;

%%对方不在社团无法被踢出
get(err400_not_on_guild_to_kicked) ->
    4000033;

%%不在社团无法踢除玩家
get(err400_not_on_guild_to_kick) ->
    4000034;

%%本职位无法辞退
get(err400_this_position_can_not_resign) ->
    4000035;

%%不在社团不能辞退
get(err400_not_on_guild_to_resign_position) ->
    4000036;

%%没有权限修改公告
get(err400_not_permission_to_modify_announce) ->
    4000037;

%%不在社团无法修改宣言
get(err400_not_on_guild_to_modify_tenet) ->
    4000038;

%%没有权限修改宣言
get(err400_not_permission_to_modify_tenet) ->
    4000039;

%%没有权限修改审批设置
get(err400_not_permission_to_modify_approve_setting) ->
    4000040;

%%不在社团无法审批设置
get(err400_not_on_guild_to_modify_approve_setting) ->
    4000041;

%%团长无法直接退出社团
get(err400_chief_not_to_quit) ->
    4000042;

%%不在社团无法退出社团
get(err400_not_on_guild_to_quit) ->
    4000043;

%%社团名字相同无法创建
get(err400_guild_name_same_not_to_create) ->
    4000044;

%%本职位已经满人
get(err400_this_position_full) ->
    4000045;

%%团长不存在
get(err400_chief_not_exist) ->
    4000046;

%%不允许任命
get(err400_not_allow_appoint) ->
    4000048;

%%必须要有团长哦
get(err400_must_have_chief) ->
    4000049;

%%任命新职位相同
get(err400_same_target_position) ->
    4000051;

%%只能任命同社团
get(err400_not_same_guild_to_appoint) ->
    4000052;

%%社团不存在
get(err400_guild_not_exist) ->
    4000053;

%%对方不在社团不能被任命
get(err400_not_on_guild_to_appointed) ->
    4000054;

%%不在社团无法任命
get(err400_not_on_guild_to_appoint) ->
    4000056;

%%没有权限审批
get(err400_not_permission_to_approve) ->
    4000057;

%%没有该社团申请
get(err400_not_apply) ->
    4000058;

%%申请人不在社团
get(err400_approver_not_on_guild) ->
    4000059;

%%不能加入社团
get(err400_can_not_join) ->
    4000061;

%%社团申请列表已满
get(err400_guild_apply_len_limit) ->
    4000062;

%%社团人数已满
get(err400_member_enough) ->
    4000063;

%%申请的社团阵营不同
get(err400_apply_realm_not_same) ->
    4000064;

%%无法申请不存在的社团
get(err400_this_guild_not_exist_to_apply) ->
    4000065;

%%已经申请过本社团
get(err400_is_apply_this_guild) ->
    4000066;

%%缺失配置
get(err400_not_config) ->
    4000083;

%%不在社团无法处理请求
get(err400_not_on_guild_to_modify_approve) ->
    4000094;

%%不能重复任命
get(err400_not_allow_appoint_again) ->
    4000095;

%%只允许任命一个领袖
get(err400_appoint_position_to_leader_only) ->
    4000096;

%%不能重复任命哦~
get(err400_not_allow_appoint_to_chief_again) ->
    4000097;

%%只允许任命一个团长
get(err400_appoint_position_to_chief_only) ->
    4000098;

%%对方已有社团，无法加入
get(err400_other_have_guild_not_to_join) ->
    4000101;

%%被邀请者已经在社团
get(err400_invitee_having_on_guild) ->
    4000106;

%%等级不足，无法加入社团
get(err400_not_enough_lv_to_apply_join_guild) ->
    4000107;

%%等级不足，无法创建社团
get(err400_not_enough_lv_to_create_guild) ->
    4000108;

%%未找到社团
get(err400_not_find_guild) ->
    4000109;

%%对方拒绝了你的申请
get(err400_refuse_apply) ->
    4000110;

%%社团名不能为空
get(err400_guild_name_null) ->
    4000111;

%%您没有权限
get(err400_no_permission) ->
    4000112;

%%社团已满级
get(err400_guild_full_lv) ->
    4000113;

%%不满足升级社团条件
get(err400_not_satisfy_upgrade_guild_condition) ->
    4000114;

%%已经领取过本日工资，不能重复领取
get(err400_has_receive_salary) ->
    4000115;

%%没有加入社团
get(err400_not_join_guild) ->
    4000116;

%%您没有权限研究社团技能
get(err400_not_peimission_research) ->
    4000117;

%%社团技能未解锁
get(err400_gskill_locked) ->
    4000118;

%%社团资金不足
get(err400_gfunds_not_enough) ->
    4000119;

%%社团等级不满足技能研究要求
get(err400_guild_lv_not_satisfy_research) ->
    4000120;

%%技能研究已满级
get(err400_max_research_lv) ->
    4000121;

%%已达社团研究上限，无法学习
get(err400_research_lv_limit) ->
    4000122;

%%玩家等级不满足技能学习要求
get(err400_role_lv_not_satisfy_learn) ->
    4000123;

%%社团贡献值不足，无法学习
get(err400_gdonate_not_satisfy_learn) ->
    4000124;

%%批准成功
get(err400_approve_success) ->
    4000125;

%%拒绝成功
get(err400_apply_refuse) ->
    4000126;

%%王者社团不能解散
get(err400_dominator_guild_can_not_disband) ->
    4000127;

%%玩家未加入社团
get(err400_no_guild) ->
    4000128;

%%和当前社团名相同，请重新输入
get(err400_guild_name_same) ->
    4000129;

%%和其他社团名重复了哦，请重新输入
get(err400_guild_name_repeat) ->
    4000130;

%%距离上次退出社团不足1小时
get(err400_leave_again_apply) ->
    4000131;

%%所在职位不可领取
get(err400_position_not_allow) ->
    4000132;

%%建筑还未激活
get(err400_building_not_active) ->
    4000133;

%%已达上限
get(err400_has_limit) ->
    4000134;

%%数量不足
get(err400_num_not_enough) ->
    4000135;

%%建筑已达最高级
get(err400_building_has_limit) ->
    4000136;

%%没有权限升级建筑
get(err400_not_allow_upgrade_building) ->
    4000137;

%%本服团战期间，无法进行该操作！
get(err400_not_allow_when_guild_war) ->
    4000138;

%%社团活动期间，无法进行该项操作
get(err400_not_allow_when_guard) ->
    4000140;

%%创建社团不足24小时
get(err400_time_not_enough) ->
    4000141;

%%人数大于最低人数限制
get(err400_member_num_enough) ->
    4000142;

%%请先选择
get(err400_please_select) ->
    4000143;

%%建筑等级不足
get(err400_building_lv_not_enough) ->
    4000144;

%%手速太快
get(err400_point_quickly) ->
    4000145;

%%个人活跃度不足100，无法领取
get(err400_liveness_not_enough) ->
    4000146;

%%不能超过社团大厅等级
get(err400_not_than_guild_lv) ->
    4000148;

%%公告修改次数达每日上限
get(err400_modify_times_limit) ->
    4000149;

%%条件不足
get(err400_condition_not_enough) ->
    4000150;

%%社团旗帜已被使用
get(err400_guild_flag_used) ->
    4000151;

%%已经申请了一个公会职位
get(err400_is_apply_position) ->
    4000152;

%%你已经是代理团长
get(err400_has_been_agent) ->
    4000153;

%%还未到可申请时间
get(err400_cant_apply_now) ->
    4000155;

%%已任职本职位
get(err400_apply_same_position) ->
    4000156;

%%团长不可申请
get(err400_chief_cannot_apply) ->
    4000157;

%%已有代理团长
get(err400_no_need_more_agent) ->
    4000158;

%%社团等级不符
get(err400_guild_lv_not_enough) ->
    4000159;

%%玩家等级不符
get(err400_role_lv_not_reached) ->
    4000160;

%%超过购买上限
get(err400_limit_buy_more) ->
    4000161;

%%有合并申请还未处理
get(err400_has_apply_unfinished) ->
    4000162;

%%不可连续发起重复的合并申请
get(err400_cant_apply_again) ->
    4000163;

%%社团内没有足够位置
get(err400_no_enough_capacity) ->
    4000164;

%%对方社团没有足够位置
get(err400_opposite_no_enough_capacity) ->
    4000165;

%%对方已有未处理的合并事务
get(err400_opposite_has_apply_unfinished) ->
    4000166;

%%未收到合并申请
get(err400_iden_err) ->
    4000167;

%%对方不是你的合并对象
get(err400_iden_applyer) ->
    4000168;

%%订单已过期
get(err400_order_overdue) ->
    4000171;

%%存在已接订单未处理
get(err400_exist_order_undeal) ->
    4000173;

%%已在社团驻地中
get(err400_already_in_tribe) ->
    4000178;

%%100级才可进入社团驻地喔
get(err400_lv_unreachable_enter) ->
    4000179;

%%社团BOSS活动期间不可退出
get(err400_not_allow_kickout_when_guild_boss) ->
    4000180;

%%支援不存在
get(err400_support_not_exits) ->
    4000181;

%%您正在协助啦
get(err400_is_supporting) ->
    4000182;

%%您已经发送请求了
get(err400_has_ask) ->
    4000183;

%%不是队长，不能发请求喔
get(err400_not_team_leader) ->
    4000184;

%%您还没有进入公会
get(err400_not_in_guild) ->
    4000185;

%%已经在队伍中，不能去协助喔
get(err400_in_team) ->
    4000186;

%%请求者不能协助自己的请求
get(err400_can_not_be_asker) ->
    4000187;

%%协助已经完成了
get(err400_support_has_finish) ->
    4000188;

%%协助还没开始喔
get(err400_support_not_action) ->
    4000189;

%%协助队伍已经满了
get(err400_support_role_num_max) ->
    4000190;

%%已经达到今天最大的声望值啦
get(err400_max_daily_reputation) ->
    4000191;

%%支援奖励不存在
get(err400_support_reward_not_exits) ->
    4000192;

%%不是支援奖励礼包，不可直接使用喔
get(err400_not_support_reward_good) ->
    4000193;

%%发送协助的社团不存在喔
get(err400_guild_not_exists) ->
    4000194;

%%您已经请求协助，不能去协助其他玩家喔
get(err400_is_asker) ->
    4000195;

%%不符合合并条件
get(err400_inconformity_merge_condition) ->
    4000196;

%%玩家等级不足
get(err400_refuse_apply_lv) ->
    4000197;

%%玩家战力不足
get(err400_refuse_apply_power) ->
    4000198;

%%还没达到玩法的等级喔
get(err400_lv_not_enough) ->
    4000199;

%%社团幻魔期间不可进行合并
get(err400_not_allow_merge_when_guild_boss) ->
    4000200;

%%召唤太频繁了
get(err400_guild_call_frequent) ->
    4000201;

%%需要相同社团
get(err400_need_same_guild) ->
    4000202;

%%不需要重复加入
get(err400_no_need_join_again) ->
    4000203;

%%已经找到协助者啦
get(err400_no_need_more_team) ->
    4000204;

%%已错过任务拼单
get(err400_guild_order_miss) ->
    4000205;

%%需要先选中任务
get(err400_need_anchor_order) ->
    4000206;

%%任务处于待完成状态
get(err400_order_already_alive) ->
    4000207;

%%不需要重复选中
get(err400_order_repeate_anchor) ->
    4000208;

%%需要先选定任务
get(err400_order_need_anchor) ->
    4000209;

%%需要更多的协助者
get(err400_order_need_more_helper) ->
    4000210;

%%已达今日拼单最大次数
get(err400_guild_order_max) ->
    4000211;

%%拼单任务已完成
get(err400_order_already_over) ->
    4000212;

%%不在社团驻地
get(err400_not_in_tribe) ->
    4000213;

%%无小助手
get(err400_has_no_fake_helper) ->
    4000214;

%%不可邀请更多小助手
get(err400_need_no_more_fake_helper) ->
    4000215;

%%当前玩法中不能前往协助喔
get(err400_cannot_support) ->
    4000216;

%%请先退出驻地再操作！
get(err400_pls_exit_guild_scene) ->
    4000217;

%%协助输入数据错误
get(err400_support_input_err) ->
    4000218;

%%感谢奖励已经领取过了哦~
get(err400_support_thank_has_receive) ->
    4000219;

%%已经发送过感谢了哦~
get(err400_has_thank) ->
    4000220;

%%感谢信过期了哦~
get(err400_support_thank_overdue) ->
    4000221;

%%当前活动协助次数不足喔~
get(err400_support_count_not_enough) ->
    4000222;

%%该拼单已经完成
get(err400_this_order_over) ->
    4000223;

%%拼单人数已达上限
get(err400_order_max_people_num) ->
    4000224;

%%开服第八天才可进行社团合并
get(err400_guild_merge_need_more_day) ->
    4000225;

%%对方为高活跃社团，无法进行合并
get(err400_tar_guild_living) ->
    4000226;

%%社团采集中
get(err400_in_guild_collect) ->
    4000227;

%%评级待定社团不能被合并
get(err400_tar_guild_wait) ->
    4000228;

%%仓库已满，无法继续捐献
get(err401_not_in_depot) ->
    4010000;

%%该道具不在社团仓库里面
get(err401_goods_not_in_depot) ->
    4010001;

%%该道具不能捐献
get(err401_goods_can_not_add_to_depot) ->
    4010002;

%%仓库积分不足，无法兑换
get(err401_depot_score_not_enough) ->
    4010003;

%%背包空间不足，无法兑换
get(err401_bag_cell_not_enough) ->
    4010004;

%%兑换数量错误
get(err401_exchange_num_err) ->
    4010005;

%%您没有权限销毁仓库的物品
get(err401_no_permission_to_destory) ->
    4010006;

%%已超过上限
get(err401_has_limit) ->
    4010007;

%%数量异常
get(err401_num_error) ->
    4010008;

%%操作太快
get(err401_handle_quickly) ->
    4010009;

%%请选择装备
get(err401_please_select) ->
    4010010;

%%不在活动场景
get(err402_no_in_act_scene) ->
    4020000;

%%您未加入社团，不能进入活动场景
get(err402_no_join_guild) ->
    4020001;

%%等级不足，无法参与活动
get(err402_no_enough_lv_join) ->
    4020002;

%%活动未开启
get(err402_act_close) ->
    4020003;

%%不在活动时间，不能开启活动
get(err402_not_in_act_cfg_open_time) ->
    4021009;

%%挑战次数不足
get(err402_no_challenge_times) ->
    4021013;

%%您所在社团的守卫活动已结束
get(err402_guild_guard_end) ->
    4021014;

%%战斗尚未开启
get(err402_not_battle_stage) ->
    4021015;

%%所属社团没有参与资格
get(err402_gwar_no_qualification) ->
    4021016;

%%玩家正处于社团争霸活动，不能参加其他活动
get(err402_can_not_change_scene_in_gwar) ->
    4021017;

%%该赛区战斗已结束
get(err402_gwar_battle_end) ->
    4021018;

%%加入社团超过1小时的成员才可参与
get(err402_join_in_guild_not_enough_time) ->
    4021019;

%%当前场景无法进入活动
get(err402_can_not_join_action_this_scene) ->
    4021020;

%%您的社团不是冠军社团
get(err402_not_dominator) ->
    4021021;

%%加入社团时间不足24小时，无法领取
get(err402_join_in_guild_not_enough_time_can_not_receive) ->
    4021022;

%%今天已领取过俸禄
get(err402_has_receive_salary_paul) ->
    4021023;

%%背包已满，请整理后再来领取
get(err402_no_null_cell_receive_salary_paul) ->
    4021024;

%%该玩家和您不在同一个社团
get(err402_not_in_guild) ->
    4021025;

%%未达成连胜条件
get(err402_unacommpolished_streak_times) ->
    4021026;

%%奖励已经分配过了
get(err402_reward_has_allot) ->
    4021027;

%%职位权限不够，无法分配
get(err402_no_permission_allot) ->
    4021028;

%%未达成奖励条件
get(err402_unacommpolished) ->
    4021029;

%%社团争霸期间不能退出社团/踢除社团成员
get(err402_cant_quit_guild_when_gwar_open) ->
    4021030;

%%社团争霸开启期间不能任命社团团长
get(err402_cant_appoint_chief_when_gwar_open) ->
    4021031;

%%社团争霸开启期间不能解散社团
get(err402_cant_disband_when_gwar_open) ->
    4021032;

%%战场人数已满
get(err402_gwar_role_num_lim) ->
    4021033;

%%本社团未开启该活动
get(err402_guild_not_open) ->
    4021035;

%%当前不是召唤阶段
get(err402_not_summon_stage) ->
    4021036;

%%已有人召唤
get(err402_has_summon) ->
    4021037;

%%已达上限
get(err402_has_add_limit) ->
    4021038;

%%没有鼓舞次数了
get(err402_no_inspire_times) ->
    4021039;

%%后备攻城器械不足
get(err402_equip_not_enouht) ->
    4021040;

%%社团贡献不足
get(err402_donate_not_enough) ->
    4021041;

%%只能同时存在两辆冲车
get(err402_too_much_blunt) ->
    4021042;

%%只能同时存在两辆炮车
get(err402_too_much_camion) ->
    4021043;

%%所属赛区战斗轮空，本社团获得胜利
get(err402_gwar_direct_win) ->
    4021044;

%%鼓舞成功，当前伤害减免加成{1}%
get(err402_inspire_success) ->
    4021045;

%%本社团达到召唤次数上限
get(err402_guild_limit_times) ->
    4021046;

%%个人召唤次数达到上限
get(err402_role_limit_times) ->
    4021047;

%%150级可参与
get(err402_guard_lv_limit) ->
    4021048;

%%需要更多的社团活跃值
get(err404_need_more_lador) ->
    4040001;

%%需要更多的个人活跃值
get(err404_need_more_role_lador) ->
    4040002;

%%参与本服团战中！
get(err405_in_guild_war) ->
    4050000;

%%加入社团即可参加本服团战！
get(err405_has_no_guild) ->
    4050001;

%%活动尚未开始！
get(err405_guild_war_not_open) ->
    4050002;

%%请前往提交物资！
get(err405_guild_war_distance) ->
    4050003;

%%请前往收集物资！
get(err405_guild_war_no_collection) ->
    4050004;

%%已经采集到物资了！
get(err405_guild_war_repeat_collect) ->
    4050005;

%%当前战区已经爆满！
get(err405_max_role) ->
    4050006;

%%技能冷却中！
get(err405_skill_cd) ->
    4050007;

%%鼓舞次数不足
get(err406_inspire_times_limit) ->
    4060001;

%%活动没开
get(err406_not_open) ->
    4060002;

%%正在采集
get(err406_now_collecting) ->
    4060003;

%%需要完成采集
get(err406_need_finish_collect) ->
    4060004;

%%没有该掉落哟
get(err406_not_drop) ->
    4060005;

%%您已经错过该掉落roll点了
get(err406_has_refuse) ->
    4060006;

%%您已经摇过骰子了哟
get(err406_has_roll) ->
    4060007;

%%摇骰子时间已经过了哟
get(err406_time_pass) ->
    4060008;

%%还未到奖励领取时间哟
get(err407_not_receive_time) ->
    4070001;

%%已经领取过奖励了哟
get(err407_has_received) ->
    4070002;

%%您未能领取奖励哟
get(err407_cannot_receive) ->
    4070003;

%%您还不能领取这份奖励喔
get(err407_not_captain) ->
    4070004;

%%不是团长不能领取哟
get(err407_is_not_captain) ->
    4070005;

%%任务还未完成喔
get(err407_not_finish_task) ->
    4070006;

%%任务配置错误
get(err407_task_cfg_err) ->
    4070007;

%%成就未达成，无法领取奖励喔
get(err409_not_finish) ->
    4090001;

%%已经领取过奖励
get(err409_has_received) ->
    4090002;

%%您还未达到领取特权奖励的等级喔
get(err409_lv_not_reach) ->
    4090003;

%%章节未完成，无法领取奖励喔
get(err409_category_not_finish) ->
    4090004;

%%特权配置错误
get(err409_config_err) ->
    4090005;

%%兑换次数用完啦
get(err409_count_not_enough) ->
    4090006;

%%参数错误
get(err409_param_err) ->
    4090007;

%%先领取上一个任务的奖励哟
get(err409_pre_id) ->
    4090008;

%%开服天数不足，无法操作
get(err410_open_day_limit) ->
    4100001;

%%正处于本国团战中
get(err410_on_camp_war) ->
    4100002;

%%不在本国团战中
get(err410_not_on_camp_war) ->
    4100003;

%%服务器分区数据异常
get(err410_serv_zone_error) ->
    4100004;

%%请先参加本服团战！
get(err410_need_guild_war) ->
    4100005;

%%召唤太频繁啦!
get(err410_frequent) ->
    4100006;

%%当前使用的称号不存在
get(err411_current_not_exist) ->
    4110001;

%%切换的是当前使用的称号，不需切换
get(err411_not_need_change) ->
    4110002;

%%隐藏称号错误
get(err411_hide_error) ->
    4110003;

%%称号未激活，切换称号失败
get(err411_change_error) ->
    4110004;

%%称号已过期
get(err411_is_expired) ->
    4110005;

%%[称号已拥有，无需再次激活]
get(err411_already_exist) ->
    4110006;

%%称号配置有误
get(err411_config_error) ->
    4110007;

%%该称号无法叠加
get(err411_dgst_can_not_overlay) ->
    4110008;

%%配置不存在
get(err412_cfg_not_exist) ->
    4120001;

%%物品不存在
get(err412_goods_not_exist) ->
    4120002;

%%没有可用技能位置
get(err412_learn_sk_err1) ->
    4120003;

%%学习技能的位置超出范围
get(err412_learn_sk_err2) ->
    4120004;

%%学习的技能已存在
get(err412_learn_sk_err3) ->
    4120005;

%%被替换的位置不存在技能
get(err412_replace_sk_err1) ->
    4120006;

%%没有合适的技能书
get(err412_no_sk_book) ->
    4120007;

%%非免费招募
get(err412_recruit_not_free) ->
    4120008;

%%伙伴不存在
get(err412_partner_not_exist) ->
    4120009;

%%洗髓物品不足
get(err412_wash_goods_err1) ->
    4120010;

%%伙伴状态不对
get(err412_partner_state_err) ->
    4120011;

%%升级错误,伙伴等级已大于等于玩家等级
get(err412_upgrade_lv_err) ->
    4120012;

%%洗髓的伙伴内存中不存在
get(err412_wash_replace_err) ->
    4120013;

%%突破等级有错
get(err412_break_err) ->
    4120014;

%%资质提升错误,已超出上限
get(err412_promote_err) ->
    4120015;

%%没有可上阵的位置
get(err412_battle_err1) ->
    4120016;

%%上阵错误,玩家等级不足
get(err412_battle_err2) ->
    4120017;

%%布阵错误,原位置没有伙伴
get(err412_embattle_err1) ->
    4120018;

%%布阵错误,目标位置超出范围
get(err412_embattle_err2) ->
    4120019;

%%激活专属,已激活
get(err412_weapon_err1) ->
    4120020;

%%专属激活,伙伴没招募过
get(err412_weapon_err2) ->
    4120021;

%%伙伴遣散,伙伴上阵无法遣散
get(err412_disband_err) ->
    4120022;

%%以前没招募过
get(err412_callback_err) ->
    4120023;

%%上阵位置错误
get(err412_battle_err3) ->
    4120024;

%%非保底招募,没找到候选伙伴
get(err412_recruit_err1) ->
    4120025;

%%保底招募,没找到候选伙伴
get(err412_recruit_err2) ->
    4120026;

%%已经有相同伙伴出战
get(err412_partner_is_battle) ->
    4120027;

%%没有该时装部位
get(err413_fashion_not_pos) ->
    4130001;

%%该时装未激活
get(err413_fashion_not_fashion) ->
    4130002;

%%重复穿戴，请重新操作
get(err413_fashion_not_same_color) ->
    4130003;

%%颜色未激活
get(err413_fashion_color_not_active) ->
    4130004;

%%颜色不存在
get(err413_fashion_not_color) ->
    4130005;

%%当前时装正在穿着
get(err413_fashion_wear) ->
    4130006;

%%身上穿着不是这件时装
get(err413_fashion_not_wear) ->
    4130007;

%%时装已激活
get(err413_fashion_active) ->
    4130008;

%%时装部位已满级
get(err413_fashion_max_lv) ->
    4130009;

%%时装精华不足
get(err413_fashion_not_enough_point) ->
    4130010;

%%该道具不能分解
get(err413_fashion_not_resolve) ->
    4130011;

%%星级已满级
get(err413_fashion_max_star) ->
    4130012;

%%星级未满级
get(err413_fashion_not_max_star) ->
    4130013;

%%颜色已激活
get(err413_fashion_color_active) ->
    4130014;

%%时装没永久激活
get(err413_fashion_not_forever) ->
    4130015;

%%限时时装无法分解
get(err143_fashion_type_error) ->
    4130016;

%%限时时装无法升星
get(err413_expire_fashion_not_upgrade) ->
    4130017;

%%限时时装无法操作
get(err413_expire_fashion_not_dye_color) ->
    4130018;

%%永久时装激活消耗有误
get(err413_fahsion_expire_active_error) ->
    4130019;

%%限时性时装消耗有误
get(err413_trial_fashion_cost_error) ->
    4130020;

%%参数有误，无法续时
get(err413_trial_fashion_error) ->
    4130021;

%%参数有误，无法激活
get(err413_fahsion_cannot_active) ->
    4130022;

%%不是限时物品，无法使用
get(err413_not_trial_goods) ->
    4130023;

%%不是限时时装,无法激活
get(err413_not_trial_fashion) ->
    4130024;

%%该时装颜色无法叠加
get(err413_fashion_cannot_overlay) ->
    4130025;

%%该颜色道具无法叠加使用
get(err413_color_goods_cannot_overlay) ->
    4130026;

%%套装激活条件不足
get(err413_suit_con_limit) ->
    4130027;

%%您已激活，无需重复操作
get(err413_have_actived) ->
    4130028;

%%已经领取过奖励
get(err414_has_receive) ->
    4140001;

%%商店参数有误
get(err414_shop_config) ->
    4140002;

%%商店重置有误
get(err414_shop_reset) ->
    4140003;

%%弹珠操作正在进行中，请勿重复操作
get(err414_have_marbled) ->
    4140004;

%%充能点数不足，无法领取奖励
get(err414_energy_point) ->
    4140005;

%%重置次数不足，是否前往提升VIP等级
get(err414_marble_reset_count) ->
    4140006;

%%重置次数异常
get(err414_count_cost) ->
    4140007;

%%弹珠消耗参数异常
get(err414_marble_cost) ->
    4140008;

%%兑换参数有误
get(err414_exchange_error) ->
    4140009;

%%弹珠操作异常，无法领取奖励
get(err414_marble_error) ->
    4140010;

%%弹珠时间参数有误，请重新操作
get(err414_marble_time_error) ->
    4140011;

%%弹射优先扣除参数异常，无法操作
get(err414_cost_option_error) ->
    4140012;

%%充能进度已满，无法操作
get(err414_max_energy) ->
    4140013;

%%已结算请重置后再继续
get(err414_max_step) ->
    4140014;

%%购买次数不足
get(err414_have_no_count) ->
    4140015;

%%剩余重置次数不足，无法重置
get(err414_vip_count_limit) ->
    4140016;

%%格子还未走完，无法重置
get(err414_have_not_finish) ->
    4140017;

%%狂战领域中！
get(err415_in_madness_land) ->
    4150000;

%%等级不足！
get(err415_level_limit) ->
    4150001;

%%活动将在晚上19:30开启
get(err415_not_open) ->
    4150002;

%%狂战领域不可进行该操作！
get(err415_on_madness_ban) ->
    4150003;

%%不在报名阶段！
get(err416_not_in_sign_stage) ->
    4160001;

%%不在报名时间内！
get(err401_not_in_sign_time) ->
    4160002;

%%已经报名啦！
get(err416_already_sign) ->
    4160003;

%%请先报名！
get(err416_not_sign_yet) ->
    4160004;

%%活动尚未开始！
get(err416_act_close) ->
    4160005;

%%已经领取完奖励了！
get(err416_already_get_award) ->
    4160006;

%%结算阶段无法进行操作！
get(err416_in_settlement) ->
    4160007;

%%搭配中有未解锁的装扮，保存失败
get(err416_look_unlock) ->
    4160008;

%%您已淘汰！
get(err416_already_out) ->
    4160009;

%%您没有报名参加本次活动！
get(err416_no_sign) ->
    4160010;

%%投票参数错误！
get(err416_vote_error) ->
    4160011;

%%数据已过期，请刷新！
get(err416_vote_overdue) ->
    4160012;

%%今日投票次数已达上限！
get(err416_daily_vote_limit) ->
    4160013;

%%不在投票阶段！
get(err416_not_in_vote_stage) ->
    4160014;

%%包含有未解锁的外观！
get(err416_look_lock) ->
    4160015;

%%没有接取跑环协助任务，无法操作
get(err417_not_in_guild_run_assist) ->
    4170001;

%%没有接取答题的跑环协助任务，无法操作
get(err417_not_in_assist_quiz) ->
    4170002;

%%答题已完成，无法操作
get(err417_quiz_success) ->
    4170003;

%%答题已失败，无法操作
get(err417_quiz_fail) ->
    4170004;

%%请先完成当前题目
get(err417_in_quiz) ->
    4170005;

%%答题状态异常
get(err417_quiz_error) ->
    4170006;

%%操作失败
get(err417_operation_fail) ->
    4170007;

%%任务失败，无法再接取此任务
get(err417_have_failed) ->
    4170008;

%%当前场景不可接此任务
get(err417_not_receive) ->
    4170009;

%%您不在舞池派对场景中！
get(err418_not_in_scene) ->
    4180001;

%%活动未开始！
get(err418_not_open) ->
    4180002;

%%经验配置错误！
get(err418_basic_exp_not_set) ->
    4180003;

%%不存在该道具！
get(err418_gift_props_not_exists) ->
    4180004;

%%对方没有参加舞池派对活动，不能赠送给他（她）！
get(err418_getter_not_join) ->
    4180005;

%%您购买的次数超过限制啦~
get(err418_buy_times_not_enougth) ->
    4180006;

%%不能给自己赠送礼物！
get(err418_send_to_self) ->
    4180007;

%%您还没有对象呢！
get(err418_no_partner) ->
    4180008;

%%您未参与舞池派对活动，请重新进入哟~
get(err418_not_join_act) ->
    4180009;

%%对方已经在约会状态中，请邀请其他玩家！
get(err418_opp_has_engaged) ->
    4180010;

%%舞池派对活动配置错误！
get(err418_cfg_fault) ->
    4180011;

%%您未达到开放等级，不能参加活动
get(err418_lv_invalid) ->
    4180012;

%%您已经在场景中了！
get(err418_has_in_scene) ->
    4180013;

%%您已经在约会中，不能再邀请其他人咯！
get(err418_has_on_engaged) ->
    4180014;

%%增加经验频率不对哦！
get(err418_add_exp_cd) ->
    4180015;

%%邀请玩家频率太高了，稍后继续邀请！
get(err418_invite_cd) ->
    4180016;

%%没找到这条拉票信息哦
get(err418_not_find_vote) ->
    4180017;

%%不能置顶别人的拉票信息哦
get(err418_not_your_vote) ->
    4180018;

%%置顶太频繁了，给别人点机会吧
get(err418_stick_vote_too_ofent) ->
    4180019;

%%该拉票信息可投票数已满
get(err418_vote_max) ->
    4180020;

%%剩余投票次数不足
get(err418_not_vote_times) ->
    4180021;

%%已为该条拉票信息投票过了
get(err418_already_voted) ->
    4180022;

%%不能给自己投票
get(err418_self_vote) ->
    4180023;

%%只能给自己置顶
get(err418_stick_other_vote) ->
    4180024;

%%您已经发布太多拉票了，给别人点机会吧
get(err418_too_much_vote) ->
    4180025;

%%对方拒绝了你的约会邀请
get(err418_refuse_invite) ->
    4180026;

%%对方不在活动场景中
get(err418_someone_not_in_scene) ->
    4180027;

%%对方没有邀请你啦~
get(err418_not_invate) ->
    4180028;

%%正在约会中，请不要三心二意呀
get(err418_is_engaging) ->
    4180029;

%%已经在椅子上啦，给别人留点位置吧
get(err418_already_on_chair) ->
    4180030;

%%这把椅子已经有人坐了
get(err418_chair_has_owner) ->
    4180031;

%%不在椅子上
get(err418_not_on_chair) ->
    4180032;

%%已达到购买次数上限
get(err418_buy_times_max) ->
    4180033;

%%对方还没在活动中喔
get(err418_opp_not_in_act) ->
    4180034;

%%奖励找回中没有此活动
get(err419_no_res_act) ->
    4190001;

%%次数不足
get(err419_no_more_times) ->
    4190002;

%%没有通关副本
get(err419_no_dun_finish) ->
    4190003;

%%已超过该奖励等级
get(err419_lv_not_match) ->
    4190004;

%%已经购买了
get(err420_already_buy) ->
    4200001;

%%您没有投资该项目
get(err420_no_investment) ->
    4200002;

%%投资{1}天后可以领取该奖励
get(err420_need_more_day) ->
    4200003;

%%该投资回报已经领取
get(err420_reward_is_got) ->
    4200004;

%%等级不足
get(err420_lv_low) ->
    4200005;

%%时装打造配置错误
get(err421_forge_cfg_err) ->
    4210001;

%%已经在目标列表中
get(err421_has_on_pos) ->
    4210002;

%%打造材料不够哟
get(err421_material_not_enough) ->
    4210003;

%%套装配置错误
get(err421_suit_cfg_err) ->
    4210004;

%%已经激活最大套数了哟
get(err421_max_suit_num) ->
    4210005;

%%未达到激活套数条件喔
get(err421_cannot_active) ->
    4210006;

%%没有该商品喔
get(err421_has_not_good) ->
    4210007;

%%已经购买该商品了
get(err421_has_buy) ->
    4210008;

%%商品配置错误
get(err421_good_cfg_err) ->
    4210009;

%%时装币不足
get(err421_fashion_coin_not_enough) ->
    4210010;

%%目标列表错误
get(err421_goods_list_err) ->
    4210011;

%%购买次数错误
get(err422_buy_times_err) ->
    4220001;

%%购买等级不足
get(err422_lv_not_enough) ->
    4220002;

%%您的职业与商品信息不符哟
get(err422_career_err) ->
    4220003;

%%商品职业配置错误
get(err422_career_cfg_err) ->
    4220004;

%%购买商品次数不足哟
get(err422_buy_times_not_enough) ->
    4220005;

%%货柜还未开启哟
get(err422_store_not_open) ->
    4220006;

%%商品价格配置错误
get(err422_store_price_err) ->
    4220007;

%%正在远征中
get(err423_already_onhook) ->
    4230001;

%%未达到开放等级
get(err423_lv_limit) ->
    4230002;

%%没有挂机时间了
get(err423_no_onhook_time) ->
    4230003;

%%并没有进行远征
get(err423_not_in_onhook) ->
    4230004;

%%您尚未拥有该守护
get(err423_have_not_guardian) ->
    4230005;

%%没有领取次数咯
get(err423_not_enough_times) ->
    4230006;

%%该守护已经上阵了
get(err423_guardian_already_working) ->
    4230007;

%%小恶魔不想挖矿
get(err423_devil_can_not_work) ->
    4230008;

%%我不想去这里
get(err423_guardian_can_not_work) ->
    4230009;

%%矿洞已达最高等级
get(err423_mine_max_lv) ->
    4230010;

%%尚未满足升级条件
get(err423_conditions_error) ->
    4230011;

%%矿工已雇佣
get(err423_actived_miner) ->
    4230012;

%%尚未达到可领取时间
get(err423_received_time_limit) ->
    4230013;

%%当前处于挖宝阶段，无法操作
get(err424_in_treasure_map) ->
    4240001;

%%藏宝使用次数已达上限
get(err424_count_limit) ->
    4240002;

%%距离太远，无法操作
get(err424_distance_far_away) ->
    4240003;

%%上一次挖宝还未完成哟
get(err424_last_not_finish) ->
    4240004;

%%奖励配置错误
get(err424_reward_err) ->
    4240005;

%%挖宝类型错误
get(err424_type_err) ->
    4240006;

%%未能领取本次数奖励哟
get(err424_cannot_receive) ->
    4240007;

%%还未有可以领取的奖励哟
get(err424_not_reward_can_receive) ->
    4240008;

%%次数奖励配置错误
get(err424_times_reward_err) ->
    4240009;

%%已领取过本奖励了喔
get(err424_reward_has_received) ->
    4240010;

%%无法获取目的地，无法使用
get(err424_coordinate_error) ->
    4240011;

%%当前不处于挖宝阶段，无法操作
get(err424_not_in_treasure_map) ->
    4240012;

%%不在答题活动中，无法操作
get(err424_not_in_quiz_event) ->
    4240013;

%%不在限时之门活动中，无法操作
get(err424_not_in_shop_event) ->
    4240014;

%%没有触发怪物事件，无法操作
get(err424_not_in_mon_event) ->
    4240015;

%%请先完成当前的怪物事件
get(err424_pls_fin_now_mon_event) ->
    4240016;

%%您不处于此事件中，无法操作
get(err424_not_in_type_event) ->
    4240017;

%%请先完成当前的限时之门事件
get(error424_pls_finish_shop_event) ->
    4240018;

%%此类商品已售罄
get(err424_shop_reward_fin) ->
    4240019;

%%商品已过期，无法操作
get(err424_shop_expire) ->
    4240020;

%%该商品不存在
get(err424_not_exist_shop_info) ->
    4240021;

%%购买次数已超上限
get(err424_buy_num_limit) ->
    4240022;

%%该坐标无法到达
get(err424_scene_block) ->
    4240023;

%%您还未习得该动作
get(err_425_not_activate) ->
    4250001;

%%您已习得该动作
get(err_425_already_activate) ->
    4250002;

%%已报名，无法操作
get(err427_have_signed) ->
    4270001;

%%未处于活动报名阶段
get(err427_not_in_sign_time) ->
    4270002;

%%报名人数已满
get(err427_apply_num_limit) ->
    4270003;

%%没有报名，无法操作
get(err427_havent_applied) ->
    4270004;

%%本轮竞猜已关闭
get(err427_round_guess_close) ->
    4270005;

%%竞猜人物数据有误
get(err427_guess_role_error) ->
    4270006;

%%竞猜数据有误
get(err427_guess_data_error) ->
    4270007;

%%您已竞猜，请勿重复操作
get(err427_room_guessed) ->
    4270008;

%%当前不在备战区，无法购买
get(err427_buy_life_scene_limit) ->
    4270009;

%%正在参与钻石擂台活动
get(err427_in_diamond_pk) ->
    4270010;

%%当前不处于备战场景，无法操作
get(err427_not_in_ready_scene) ->
    4270011;

%%不在钻石战场中，无法操作
get(err427_not_in_dia_battle) ->
    4270012;

%%培养失败
get(err428_grow_up_fail) ->
    4280001;

%%激活失败
get(err428_active_fail) ->
    4280002;

%%请先开启对应圣灵
get(err428_spirit_not_active) ->
    4280003;

%%操作参数错误
get(err428_args_error) ->
    4280005;

%%已达满级
get(err428_has_limit) ->
    4280006;

%%没有装备配置
get(err433_no_equip_cfg) ->
    4330000;

%%装备部位类型错误
get(err433_equip_pos_type_error) ->
    4330001;

%%缺少强化配置
get(err433_no_stren_cfg) ->
    4330002;

%%错误的装备类型
get(err433_error_equip_type) ->
    4330003;

%%已达到最高级
get(err433_already_max_lv) ->
    4330004;

%%未达到突破等级
get(err433_failed_to_reach_breakthrough_level) ->
    4330005;

%%目标装备不存在
get(err433_target_equip_no_exist) ->
    4330007;

%%没有可分解的装备
get(err433_can_not_resolve_equip) ->
    4330008;

%%配置异常
get(err435_cfg_error) ->
    4350001;

%%没有可烹饪的
get(err435_not_can_cook) ->
    4350002;

%%没有可打造的
get(err435_not_can_equip) ->
    4350003;

%%建筑所需等级不足
get(err435_build_lv_not_enough) ->
    4350004;

%%技能等级不足
get(err435_skill_lv_not_enough) ->
    4350005;

%%活力不足
get(err435_power_live_not_enough) ->
    4350006;

%%找不到对应食物
get(err435_not_cook_book) ->
    4350007;

%%已激活该食谱
get(err435_has_cook_book) ->
    4350008;

%%不是增益类食物
get(err435_not_gain_food) ->
    4350009;

%%人物等级不足
get(err435_lv_not_enough) ->
    4350010;

%%已激活该图纸
get(err435_has_equip_paper) ->
    4350011;

%%找不到对应图纸
get(err435_not_equip_paper) ->
    4350012;

%%未激活该类型
get(err435_not_active) ->
    4350013;

%%等级不足
get(err440_lv_not_enough) ->
    4400001;

%%已激活
get(err440_has_active) ->
    4400002;

%%配置不存在
get(err440_cfg_error) ->
    4400004;

%%灵气未蓄满
get(err440_cd_not_end) ->
    4400006;

%%已达满级
get(err440_is_limit) ->
    4400008;

%%喂养道具不匹配
get(err440_feed_kind_fail) ->
    4400009;

%%已经在出战位
get(err440_in_pos) ->
    4400010;

%%变身中不能替换
get(err440_trans_not_handle) ->
    4400011;

%%喂养数量错误
get(err440_feed_num_error) ->
    4400012;

%%未激活印记
get(err440_not_active_seal) ->
    4400014;

%%未激活符文
get(err440_not_active_rune) ->
    4400015;

%%该槽位未开启
get(err440_pos_not_open) ->
    4400016;

%%该物品不属于印记
get(err440_is_not_goods) ->
    4400017;

%%不能穿戴相同类型的印记
get(err440_not_equip_same_type) ->
    4400018;

%%印记无穿戴在身上
get(err440_not_equip) ->
    4400019;

%%不是合成材料
get(err440_not_compose_goods) ->
    4400020;

%%合成材料阶数不足
get(err440_compose_goods_not_lv) ->
    4400021;

%%不能穿戴同类型低阶印记
get(err440_not_equip_low) ->
    4400022;

%%请正确选择消耗材料
get(err440_please_select_compose) ->
    4400023;

%%您正处于体验VIP阶段，无法操作
get(err450_trial_vip) ->
    4500001;

%%vip等级不足
get(err450_vip_limit) ->
    4500002;

%%您已购买此vip等级特权礼包，请勿重复操作
get(err450_have_buy_vip_bag) ->
    4500003;

%%vip配置有误
get(err450_cfg_error) ->
    4500004;

%%您正处于体验VIP阶段，无需重复操作
get(err450_trial_vip_1) ->
    4500005;

%%您已拥有VIP特权，无法操作
get(err450_in_vip) ->
    4500006;

%%vip体验卡无法叠加使用多次
get(err450_goods_num) ->
    4500007;

%%进阶未达到道具使用等级，无法操作
get(err450_foster_data_error) ->
    4500008;

%%您的vip特权不足，无法使用此技能
get(err450_vip_skill_limit) ->
    4500009;

%%V4开放贵族特权激活
get(err451_sup_vip_active_limit) ->
    4510001;

%%您已是贵族，无需重复激活
get(err451_actived_sup_vip) ->
    4510002;

%%您已是贵族，无需重复激活
get(err451_in_trial_sup_vip) ->
    4510003;

%%激活贵族特权，可免费1.25倍提取经验
get(err451_no_sup_vip) ->
    4510004;

%%您的每日礼包次数不足，无法领取
get(err451_sup_vip_count_limit) ->
    4510005;

%%您的兑换次数已用完，无法操作
get(err451_exchange_count) ->
    4510006;

%%请先升级二阶贵族再操作！
get(err451_permanent_sup_vip) ->
    4510007;

%%此物品还未解锁，无法购买
get(err451_unlock_limit) ->
    4510008;

%%终生限购道具无法再次购买
get(err451_permanent_goods) ->
    4510009;

%%道具购买次数不足，无法操作
get(err451_limit_count_error) ->
    4510010;

%%贵族道具等级限制，无法操作
get(err451_goods_lv_limit) ->
    4510011;

%%参数有误，请先领完首次礼包
get(err451_need_first_reward) ->
    4510012;

%%参数有误，无法兑换
get(err451_echange_arg_error) ->
    4510013;

%%章节类型错误
get(err452_category_err) ->
    4520001;

%%本章节还未全部完成哟
get(err452_category_not_finish) ->
    4520002;

%%已经领取过章节奖励啦
get(err452_category_has_received) ->
    4520003;

%%[精英考核]任务Id错误
get(err452_task_id_err) ->
    4520004;

%%任务还未完成哟
get(err452_can_not_receive) ->
    4520005;

%%请先完成前面的小章节喔
get(err452_pre_sub_category) ->
    4520006;

%%奖励已经领取过了
get(err452_reward_has_received) ->
    4520007;

%%奖励不存在！
get(err458_no_award) ->
    4580001;

%%奖励已经领取！
get(err458_already_get) ->
    4580002;

%%该奖励不可领取！
get(err458_cannot_get_award) ->
    4580003;

%%领取条件不足！
get(err458_award_condition_error) ->
    4580004;

%%活动尚未开始！
get(err458_act_not_begin) ->
    4580005;

%%活动已经结束！
get(err458_is_end) ->
    4580006;

%%血魔已经被击杀！
get(err458_dun_boss_die) ->
    4580007;

%%商品未上架！
get(err458_goods_none) ->
    4580008;

%%商品已售罄！
get(err458_goods_sold_out) ->
    4580009;

%%兑换次数不足！
get(err458_goods_limit) ->
    4580010;

%%您当前正在跳一跳玩法匹配中，请先退出匹配再尝试！
get(err459_jump_matching) ->
    4590000;

%%您当前正在参与跳一跳，专心点哦~！
get(err459_jump_playing) ->
    4590001;

%%当前无场次开放，请留意下一场开放时间~！
get(err459_jump_close) ->
    4590002;

%%今日已达最大参与次数，请改日再来！
get(err459_max_match_count) ->
    4590003;

%%今日已达最大练习次数，请改日再来！
get(err459_max_single_count) ->
    4590004;

%%请先完成单人模式，再参与多人匹配~！
get(err459_single_first) ->
    4590005;

%%幻魔战斗中
get(err460_in_reward_boss) ->
    4600000;

%%幻魔尚未复活！
get(err460_boss_dead) ->
    4600001;

%%鼓舞次数不足！
get(err460_encourage_limit) ->
    4600002;

%%赏金幻魔奖励次数不足！
get(err460_tried_max) ->
    4600003;

%%等级不足！
get(err460_lv_limit) ->
    4600004;

%%您的等级不足！
get(err460_no_lv) ->
    4600005;

%%您已经关注了，无需重复关注
get(err460_no_remind) ->
    4600006;

%%您还没有关注，无需取消关注
get(err460_no_unremind) ->
    4600007;

%%请先退出队伍
get(err460_quit_team) ->
    4600008;

%%该场景不能使用
get(err460_not_in_scene) ->
    4600009;

%%次数已达上限
get(err460_has_limit) ->
    4600010;

%%协助状态无法获得归属！
get(err460_supporter_no_award) ->
    4600011;

%%活动场景已经爆满，请稍后再进！
get(err460_too_many_roles) ->
    4600012;

%%BOSS已经消失！
get(err460_boss_has_gone) ->
    4600013;

%%尚未发现BOSS！
get(err460_never_find_boss) ->
    4600014;

%%只可在大世界场景中使用噢
get(err461_not_in_normal_scene) ->
    4600015;

%%boss不处于等待重生期间
get(err460_boss_not_die) ->
    4600016;

%%您的赏金幻魔次数已满
get(err460_has_max_times) ->
    4600017;

%%没有这个boss噢
get(err460_not_this_boss) ->
    4600018;

%%击杀当前幻魔后可继续召唤！
get(err460_already_refresh) ->
    4600019;

%%野外场景才可以召唤！
get(err460_not_outside) ->
    4600020;

%%当前区域不可进行召唤！
get(err460_pos_not_ok) ->
    4600021;

%%等级不足，不可召唤！
get(err460_lv_not_ok) ->
    4600022;

%%免战次数已经用完了哟
get(err460_protect_time_not_enough) ->
    4600023;

%%不需要重复使用哟
get(err460_not_need_use) ->
    4600024;

%%还不能使用免战喔
get(err460_cannot_use_protect_time) ->
    4600025;

%%还有奖励次数，无需购买
get(err460_has_count) ->
    4600026;

%%购买次数不足
get(err460_buy_count_limit) ->
    4600027;

%%已在星域boss场景中
get(err461_in_deserted_boss_scene) ->
    4610001;

%%次数不足,无法发起协助
get(err461_tire_max) ->
    4610002;

%%请退出当前场景再进行操作！
get(err461_pls_quit_scene) ->
    4610003;

%%您的星域幻魔次数已满
get(err461_has_max_times) ->
    4610004;

%%只可在混乱星域场景中使用噢
get(err461_not_in_scene) ->
    4610005;

%%免战次数已经用完了哟
get(err461_protect_time_not_enough) ->
    4610006;

%%当前不需要重复使用哟
get(err461_not_need_use) ->
    4610007;

%%还不能使用免战喔
get(err461_cannot_use_protect_time) ->
    4610008;

%%只有 TOP3 社团玩家可进入哦！
get(err462_not_top_3) ->
    4620001;

%%当前不是经验海场景
get(err463_not_exp_sea_scene) ->
    4630001;

%%次数不足
get(err463_times_not_enough) ->
    4630002;

%%强化材料配置错误
get(err463_strength_cost_err) ->
    4630003;

%%层数配置错误
get(err463_floor_cfg_err) ->
    4630004;

%%今日挂机时间已用完
get(err463_time_err) ->
    4630005;

%%当前人数过多，请稍后再尝试
get(err463_floor_to_many_people) ->
    4630006;

%%已经在沧海场景中
get(err463_has_in_scene) ->
    4630007;

%%正在护送中
get(err500_husong_start) ->
    5000001;

%%今日护送次数已经用完
get(err500_husong_end) ->
    5000002;

%%未完成上一个阶段
get(err500_husong_unfinish_last_stage) ->
    5000003;

%%品质已达上限
get(err500_husong_quality_max) ->
    5000004;

%%开始了护送无法切换场景
get(err500_husong_cant_change_scene) ->
    5000005;

%%护送还没开始
get(err500_husong_not_start) ->
    5000006;

%%护送阶段不正确
get(err500_husong_stage_wrong) ->
    5000007;

%%等级不足！
get(err500_husong_lv_low) ->
    5000009;

%%协助状态不可参与护送！
get(err500_husong_supporting) ->
    5000012;

%%拦截奖励次数已达上限，无法继续获得奖励
get(err500_husong_take_num_max) ->
    5000014;

%%拦截成功
get(err500_husong_take_success) ->
    5000015;

%%庇护已用完
get(err500_husong_invincible_max) ->
    5000016;

%%已经提升到了对应品质！
get(err500_husong_reflesh_to_goal) ->
    5000017;

%%提升成功，获得<color='{1}'>{2}</color>天使
get(err500_husong_reflesh_success) ->
    5000018;

%%请前往参与护送！
get(err500_not_near_npc) ->
    5000020;

%%不在护送npc场景
get(err500_not_now_scene_packup) ->
    5000025;

%%祝福值不足，无法操作
get(err500_pray_val_limit) ->
    5000026;

%%请先加入社团，再来参加活动！
get(err501_please_join_guild) ->
    5010001;

%%请勿抢夺好友积分！
get(err501_cannot_attack_friend) ->
    5010002;

%%冷却未冷却！
get(err501_in_attack_cd) ->
    5010004;

%%缺失玩家数据
get(err501_player_not_exist) ->
    5010005;

%%对方玩家数据异常
get(err501_oppplayer_not_exist) ->
    5010006;

%%对方处于抢夺保护时间
get(err501_in_protect_cd) ->
    5010007;

%%请勿抢夺比自己名次差距太大的玩家
get(err501_cannot_attack) ->
    5010008;

%%请等当前战斗结束后，再来操作！
get(err501_not_in_attack_idel) ->
    5010009;

%%请勿抢夺你自己
get(err501_cannot_attack_self) ->
    5010010;

%%在主城和安全区才能参加活动！
get(err501_cannot_transferable) ->
    5010011;

%%该玩法尚未解锁
get(err501_goal_lock) ->
    5010013;

%%奖励已领取
get(err501_has_receive_reward) ->
    5010014;

%%进度未完成
get(err501_progress_not_finish) ->
    5010015;

%%在主城和安全区才能参与活动！
get(err503_cannot_transferable) ->
    5030001;

%%您未达到活动开启等级！
get(err503_lv_error) ->
    5030002;

%%英雄战场对手不足，暂时无法开启！
get(err503_rival_not_enough) ->
    5030003;

%%对手数据初始化异常
get(err503_init_rival_error) ->
    5030004;

%%请刷新，客户端获取的对手数据不是最新的！
get(err503_client_init_rival_error) ->
    5030005;

%%您已挑战完所有对手！
get(err503_finish_all_attack) ->
    5030006;

%%您当前处于挑战状态，请先挑战！
get(err503_in_battle_status) ->
    5030007;

%%无可领取的奖励！
get(err503_no_award) ->
    5030008;

%%剩余挑战次数不足！
get(err503_not_enough_attack_count) ->
    5030009;

%%英雄战场正在重置，无法挑战
get(err503_reset_status) ->
    5030010;

%%领取失败，缺失奖励配置
get(err503_missing_award_cfg) ->
    5030011;

%%结算中，请稍后退出！
get(err503_settlement_plase_wait) ->
    5030012;

%%退出失败，不在英雄战场中！
get(err503_not_in_hero_war) ->
    5030013;

%%无尽领域战斗中
get(err600_cant_change_scene_in_void_fam) ->
    6000001;

%%已经在场景中
get(err600_already_in_scene) ->
    6000003;

%%活动将在每周一、三、五、日的19:30开启
get(err600_act_close) ->
    6000004;

%%等级不足
get(err600_no_enough_lv) ->
    6000005;

%%不在无尽领域中
get(err600_no_in_act_scene) ->
    6000006;

%%需要先加入社团
get(err601_no_guild) ->
    6010001;

%%不需要重复进入
get(err601_no_repeate_enter) ->
    6010002;

%%跨国团战中
get(err601_cant_change_scene_cross_gwar) ->
    6010003;

%%不在跨国团战战场中
get(err601_not_in_cgw_scene) ->
    6010004;

%%没有权限
get(err601_no_permission) ->
    6010005;

%%非法城池
get(err601_not_city) ->
    6010006;

%%已达最大支持数
get(err601_support_max) ->
    6010007;

%%不可重复获得奖励
get(err601_cant_repeate_get_award) ->
    6010008;

%%社团未参加国战
get(err601_guild_donot_join) ->
    6010009;

%%分区不存在
get(err601_no_server_zone) ->
    6010010;

%%战场不存在
get(err601_no_battle_pid) ->
    6010011;

%%未占领城池
get(err601_donot_own_city) ->
    6010012;

%%战力不足
get(err601_power_lower) ->
    6010013;

%%已报名
get(err601_have_sign_up) ->
    6010014;

%%社团不存在
get(err601_the_guild_is_no_exist) ->
    6010015;

%%不在报名期
get(err601_cant_sign_now) ->
    6010016;

%%未报名
get(err601_not_in_sign_up_list) ->
    6010017;

%%现在不能进入战场
get(err601_cant_enter_now) ->
    6010018;

%%本服未参与本国团战
get(err601_no_zone_data) ->
    6010019;

%%当前时间不可应援
get(err601_support_time) ->
    6010020;

%%您还没有该特权！
get(err601_not_king) ->
    6010021;

%%今日的禁言次数已用完~
get(err601_exceed_times) ->
    6010022;

%%cd冷却中
get(err601_not_enough_cd) ->
    6010023;

%%国家名字不能为空
get(err601_faction_name_null) ->
    6010024;

%%国家名字存在敏感词
get(err601_faction_name_sensitive) ->
    6010025;

%%国家名字长度错误
get(err601_faction_name_len) ->
    6010026;

%%已有该国家名
get(err601_faction_name_same) ->
    6010027;

%%不可重复购买
get(err601_cant_buy) ->
    6010028;

%%活动期间,不允许进入哟
get(err602_in_act) ->
    6020001;

%%您已经被淘汰,不准进入喔
get(err602_game_over) ->
    6020002;

%%活动已经在托管中啦
get(err602_is_hosting) ->
    6020003;

%%复活冷却中，请稍后再试
get(err602_cd_err) ->
    6020004;

%%活动将在每周一、三、五、日的20:30开启
get(err602_not_open) ->
    6020005;

%%您当前等级不足哟
get(err602_lv_not_enough) ->
    6020006;

%%还没到活动开放时间哟
get(err602_act_not_open) ->
    6020007;

%%明日再试试
get(err603_try_again_tommorow) ->
    6030001;

%%不可重复领取
get(err603_cant_fetch_again) ->
    6030002;

%%需要膜拜更高排名玩家
get(err603_need_high_rank) ->
    6030003;

%%今日已膜拜
get(err603_has_click_done) ->
    6030004;

%%需要更多活跃
get(err603_need_more_active) ->
    6030005;

%%需要先完成任务
get(err603_need_finish_task) ->
    6030006;

%%已经达到最高军衔
get(err603_post_max_now) ->
    6030007;

%%军功值不足
get(err603_need_more_score) ->
    6030008;

%%军备值不足
get(err603_legion_arms_not_enough) ->
    6030009;

%%已经膜拜过该玩家了喔
get(err603_cant_same_people) ->
    6030010;

%%开服天数不足
get(err603_opday_not_enough) ->
    6030011;

%%沙盘争夺尚未开启！
get(err604_not_open) ->
    6040001;

%%已经成功占领了该据点！
get(err604_already_seize) ->
    6040002;

%%没有领地与该据点相连！
get(err604_not_connect) ->
    6040003;

%%尚未占领该据点！
get(err604_not_seize) ->
    6040004;

%%领奖时间未到！
get(err604_not_award_time) ->
    6040005;

%%您尚未攻打过该据点！
get(err604_never_attack) ->
    6040006;

%%国家首席官员拥有召集权限！
get(err604_mass_right) ->
    6040007;

%%不可攻打安全据点！
get(err604_others_point) ->
    6040008;

%%{1}秒后可以继续发起集结！
get(err604_mass_cd) ->
    6040009;

%%只有团长和副团长才可进行宣战哦
get(err607_not_allow) ->
    6070001;

%%社团活跃度不足
get(err607_liveness_not_enough) ->
    6070002;

%%不在活动内
get(err607_not_in_war) ->
    6070003;

%%已经领取过
get(err607_has_got) ->
    6070004;

%%该物品没有上架
get(err607_not_in_sell) ->
    6070005;

%%手速太快了
get(err607_point_quickly) ->
    6070006;

%%已达上限
get(err607_is_limit) ->
    6070007;

%%不是宣战阶段
get(err607_not_apply_stage) ->
    6070008;

%%不是活动时间
get(err607_not_fight_stage) ->
    6070009;

%%异常情况
get(err607_cfg_error) ->
    6070010;

%%您所在社团没有参战资格哦
get(err607_not_apply) ->
    6070011;

%%未占领该领地
get(err607_not_own) ->
    6070012;

%%已经占领领地，无法宣战新的领地
get(err607_is_own) ->
    6070013;

%%已经宣战过
get(err607_has_apply) ->
    6070014;

%%宣战社团已达上限
get(err607_apply_has_limit) ->
    6070015;

%%积分不足
get(err607_score_not_enough) ->
    6070016;

%%跨服城战期间不可进行操作！
get(err607_not_allow_kickout_when_kftown) ->
    6070017;

%%只有要塞领地才可以宣战
get(err607_not_apply_building) ->
    6070019;

%%社团参加人数已满
get(err607_is_max_limit) ->
    6070020;

%%只有要塞领地才可以应援
get(err607_not_assist_building) ->
    6070021;

%%没有宣战该领地
get(err607_not_apply_assist) ->
    6070022;

%%购买等级不足
get(ererr607_lv_not_buy) ->
    6070025;

%%正处于世界主城，不能参加其它活动
get(err608_cant_change_scene_in_kf_city) ->
    6080001;

%%正处于跨服入侵活动，不能参加其它活动
get(err609_cant_change_scene_in_kf_invade) ->
    6090001;

%%活动未开启，不能进去他服
get(err609_act_close) ->
    6090002;

%%目标服务器条件不符
get(err609_target_server_not_open) ->
    6090003;

%%服务器条件不符，数量不足2个
get(err609_not_enough_server) ->
    6090004;

%%目标服务器场景人数已达上限
get(err609_role_num_limit) ->
    6090005;

%%请先前往世界主城
get(err609_enter_kf_city_first) ->
    6090006;

%%你所在的服务器未开启跨服入侵
get(err609_server_not_open) ->
    6090007;

%%状态异常，请直接退出进入世界主城
get(err609_back_kf_city_error) ->
    6090008;

%%你未处于跨服入侵场景
get(err609_not_in_kf_invade_scene) ->
    6090009;

%%目标服务器场景已关闭
get(err609_target_server_close) ->
    6090010;

%%积分条件不足
get(err609_stage_reward_unreach) ->
    6090011;

%%已领取积分奖励
get(err609_stage_reward_geted) ->
    6090012;

%%副本玩家不存在
get(err610_dungeon_role_not_exist) ->
    6100001;

%%副本的队伍参数错误
get(err610_dungeon_team_args_error) ->
    6100002;

%%你不在安全区域无法进去副本
get(err610_not_on_safe_scene_to_enter_dungeon) ->
    6100003;

%%{1}所在场景无法进入副本
get(err610_not_on_safe_scene_to_enter_dungeon_by_other) ->
    6100004;

%%{1}等级不足无法进入副本
get(err610_not_enough_lv_to_enter_dungeon_by_other) ->
    6100005;

%%{1}助战次数不足
get(err610_dungeon_count_daily_help_by_other) ->
    6100006;

%%{1}副本次数不足，终生最多进去{2}次
get(err610_dungeon_count_permanent_by_other) ->
    6100007;

%%{1}副本次数不足，每周最多进去{2}次
get(err610_dungeon_count_week_by_other) ->
    6100008;

%%{1}副本次数不足
get(err610_dungeon_count_daily_by_other) ->
    6100009;

%%副本没有开启
get(err610_dungeon_not_open) ->
    6100010;

%%副本已经通关，不能重复挑战
get(err610_just_once_finish) ->
    6100011;

%%需要完成前置副本
get(err610_need_finish_dun_id) ->
    6100012;

%%等级不足，无法进入副本
get(err610_not_enough_lv_to_enter_dungeon) ->
    6100013;

%%人数不足，无法进入副本
get(err610_dungeon_num_not_satisfy) ->
    6100014;

%%副本配置出错
get(err610_dungeon_count_cfg_error) ->
    6100015;

%%你的副本次数不足，每天助战最多进去{1}次
get(err610_dungeon_count_daily_help) ->
    6100016;

%%副本已经通关，不能重复挑战
get(err610_dungeon_count_permanent) ->
    6100017;

%%你的副本次数不足，每周最多进去{1}次
get(err610_dungeon_count_week) ->
    6100018;

%%你的副本次数不足，每天最多进去{1}次
get(err610_dungeon_count_daily) ->
    6100019;

%%跨服队伍无法进入本副本
get(err610_cls_team_not_enter_dungeon) ->
    6100020;

%%玩家已经在副本中
get(err610_on_dungeon) ->
    6100021;

%%副本不存在
get(err610_dungeon_not_exist) ->
    6100022;

%%你不在副本进入所需场景
get(err610_not_on_enter_scene) ->
    6100029;

%%{1}不在副本进入所需场景
get(err610_not_on_enter_scene_by_other) ->
    6100030;

%%副本异常,请联系GM
get(err610_dungeon_error) ->
    6100031;

%%副本场景不存在
get(err610_dungeon_scene_not_exist) ->
    6100032;

%%已经在副本
get(err610_had_on_dungeon) ->
    6100033;

%%脱离战斗状态才能进入副本
get(err610_cannot_join_act_on_battle) ->
    6100034;

%%{1}同意，正在脱离战斗，前往安全位置
get(err610_cannot_join_act_on_battle_with_name) ->
    6100035;

%%{1}的次数为0，无法进入目标
get(err610_have_no_count_to_enter_target_with_name) ->
    6100038;

%%您的次数为0，无法进入目标
get(err610_have_no_count_to_enter_target) ->
    6100039;

%%您的次数为0，无法创建目标
get(err610_have_no_count_to_create_target) ->
    6100040;

%%您的门票不足，无法进入副本
get(err610_enter_cost_error) ->
    6100041;

%%您的钻石余额不足，无法购买次数
get(err610_buy_cost_error) ->
    6100042;

%%您的vip特权等级不足，无法购买次数
get(err610_buy_vip_error) ->
    6100043;

%%今日购买次数已达上限
get(err610_buy_limit_error) ->
    6100044;

%%该副本不能扫荡
get(err610_sweep_limit_error) ->
    6100045;

%%扫荡该副本需要角色达到{1}级
get(err610_sweep_lv_limit) ->
    6100046;

%%需要通关副本才能扫荡
get(err610_sweep_never_finish) ->
    6100047;

%%剩余次数不足
get(err610_dungeon_count_daily_sweep) ->
    6100048;

%%周次数不足
get(err610_dungeon_count_weekly_sweep) ->
    6100049;

%%终生次数不足
get(err610_dungeon_count_permanent_sweep) ->
    6100050;

%%助战奖励已发送到背包，今日还可获得{1}次助战奖励
get(err610_help_times_left) ->
    6100051;

%%鼓舞次数已达上限
get(err610_encourage_count_limit) ->
    6100052;

%%鼓舞次数已达上限
get(err610_encourage_coin_count_limit) ->
    6100053;

%%重置次数不足
get(err610_reset_count_limit) ->
    6100054;

%%没有可重置的关卡
get(err610_nothing_reset) ->
    6100055;

%%当前无可扫荡的副本
get(err610_nothing_sweep) ->
    6100056;

%%今日助战次数已用完，无法再获得助战奖励
get(err610_help_reward_time_limit) ->
    6100057;

%%该副本进入人数不能超过{1}人
get(err610_too_many_members) ->
    6100058;

%%当前已经结算，无法进入
get(err610_dungeon_is_end) ->
    6100059;

%%该副本不能购买次数
get(err610_buy_count_error) ->
    6100060;

%%该副本只能互为异性或者情侣夫妻才可进入
get(err610_only_couple_enter) ->
    6100061;

%%宝库入场券不足，请到商城购买
get(err240_my_cost_error_exp) ->
    6100062;

%%当前已是最高关卡
get(err610_is_final_dun) ->
    6100063;

%%减速正在冷却中
get(err610_slowdown_cd) ->
    6100064;

%%评分不足以扫荡
get(err610_not_sweep) ->
    6100065;

%%传奇等级不足
get(err610_legend_lv_not_enough) ->
    6100066;

%%已过了翻牌时间
get(err610_flop_time_out) ->
    6100067;

%%评分不足
get(err610_score_not_flop) ->
    6100068;

%%vip等级不足
get(err610_vip_not_flop) ->
    6100069;

%%无翻牌次数
get(err610_not_flop_times) ->
    6100070;

%%已经领取过
get(err610_has_got) ->
    6100071;

%%互为情侣才能使用技能
get(err610_not_couple_can_use) ->
    6100072;

%%恩爱分不足，无法使用情侣技能
get(err610_love_score_not_enough) ->
    6100073;

%%冷却中
get(err610_is_cd) ->
    6100074;

%%已经回答过
get(err610_has_answer) ->
    6100075;

%%请先退出队伍
get(err610_quit_team) ->
    6100076;

%%使用次数已达上限
get(err610_times_is_limit) ->
    6100079;

%%不存在该道具
get(err610_not_dungeon_goods) ->
    6100080;

%%条件不足
get(err610_conditon_not_enough) ->
    6100081;

%%当前是重置时间,请稍后进入
get(err610_reset_time) ->
    6100082;

%%已达今日最高波数，不可扫荡
get(err610_is_max_wave) ->
    6100083;

%%未达到记录点，不可扫荡
get(err610_is_max_point) ->
    6100084;

%%塔未解锁
get(err610_not_unlock) ->
    6100085;

%%请先领取每日奖励
get(err610_please_got_sweep_reward) ->
    6100086;

%%符文印记战力不足
get(err610_rune_power_not_enough) ->
    6100087;

%%跨天才能领取
get(err610_got_tomorrow) ->
    6100088;

%%未达到解锁的条件
get(err610_not_unlock_condition) ->
    6100089;

%%该塔已经解锁
get(err610_has_unlock) ->
    6100090;

%%请先领取完阶段奖励
get(err610_please_got_stage_reward) ->
    6100091;

%%此位置已翻过，请勿重复操作
get(err610_pos_repeated) ->
    6100092;

%%请先首通副本
get(err610_today_not_pass) ->
    6100093;

%%VIP等级不足，无法购买扫荡次数
get(err610_vip_buy_count_limit) ->
    6100094;

%%副本类型数据有误
get(err610_dun_type_error) ->
    6100095;

%%该水晶宝藏已开启
get(err610_dun_flop_have_opened) ->
    6100096;

%%副本已扫荡,请勿重复操作
get(err610_dun_have_all_sweeped) ->
    6100097;

%%扫荡数据异常，无法扫荡
get(err610_sweep_data_error) ->
    6100098;

%%VIP等级不足
get(err610_not_enough_vip_to_enter_dungeon) ->
    6100099;

%%暂无放置奖励可领取
get(err610_not_exp_drop_reward) ->
    6100100;

%%放置掉落时长已超上限
get(err610_drop_time_limit) ->
    6100101;

%%好友波数信息加载中,请稍后再试
get(err610_friend_wave_loading) ->
    6100102;

%%副本未首通，无法领取每日奖励
get(err610_not_first_pass) ->
    6100103;

%%暂无奖励可领取
get(err610_tower_dun_rewarded) ->
    6100104;

%%前置困难副本未三星通关，无法操作
get(err610_dun_score_limit) ->
    6100105;

%%{1}级解锁
get(err610_lv_limit) ->
    6100106;

%%{1}级主线任务解锁
get(err610_lv_task_limit) ->
    6100107;

%%副本翻牌进行中，无法操作
get(err610_dun_flop_not_finish) ->
    6100108;

%%奖励已经领取过啦
get(err610_dun_pet_reward_has_receive) ->
    6100109;

%%宠物副本奖励配置错误
get(err610_dun_pet_reward_err) ->
    6100110;

%%需要先通关上一层哟
get(err610_dun_pet_pre_must) ->
    6100111;

%%没有该商品，无法购买
get(err610_god_dun_not_exist_shop) ->
    6100112;

%%该商品购买次数不足
get(err610_shop_use_count_max) ->
    6100113;

%%积分不足
get(err610_score_not_enough) ->
    6100114;

%%副本进行中无法操作
get(err610_on_dungeon_cannot_operate) ->
    6100115;

%%今天宠物副本次数用完咯
get(err610_dun_pet_count_not_enough) ->
    6100116;

%%星数不足
get(err610_star_not_enough) ->
    6100117;

%%放置塔配置错误
get(err610_dun_child_mon_err) ->
    6100118;

%%您不在副本中哟
get(err610_not_in_dun) ->
    6100119;

%%今天没有可以扫荡的进度哟
get(err610_cannot_sweep) ->
    6100120;

%%放置冷却中，请稍后再试哟
get(err610_create_tower_cd) ->
    6100121;

%%未上榜，不能领取每日奖励哟
get(err610_dun_pet_rank_none) ->
    6100122;

%%宠物副本每日奖励配置错误
get(err610_dun_pet_rank_reward_err) ->
    6100123;

%%已经领取过日奖励喔
get(err610_dun_pet_rank_has_received) ->
    6100124;

%%您已经通关最大波数了哟
get(err610_max_wave) ->
    6100125;

%%还没通关当前章节哦~
get(err610_not_through_chapter) ->
    6100126;

%%不在此章节哦~
get(err610_not_in_chapter) ->
    6100127;

%%已经是最后的星座了哦~
get(err610_already_max_chapter) ->
    6100128;

%%快速通关操作冷却中
get(err610_quick_pass_cd) ->
    6100129;

%%当前召唤已达最大波数，无法再召唤
get(err610_guard_pass_max_wave) ->
    6100130;

%%当前同时存在的波数已达上限
get(err610_guard_wave_exist_max) ->
    6100131;

%%副本还未开始，无法操作
get(err610_have_not_start) ->
    6100132;

%%您的个人幻魔次数已满
get(err610_has_max_times) ->
    6100133;

%%选择的协战宠物有误哟
get(err610_pet_choose_err) ->
    6100134;

%%选择奖励参数有误
get(err610_choose_reward_err) ->
    6100135;

%%未领养的宠物不能协战哟
get(err610_pet_choose_not_adopt) ->
    6100136;

%%副本中不能切换协战宠物哟
get(err610_cannot_choose_pet_on_dungeon) ->
    6100137;

%%副本中不能选择奖励哟
get(err610_cannot_choose_reward_on_dungeon) ->
    6100138;

%%不能选择主战宠物哟
get(err610_cannot_choose_follow_pet) ->
    6100139;

%%总星数未达到领取条件
get(err610_star_not_access) ->
    6100140;

%%放置挂机未开启，无法操作
get(err610_exp_dun_not_pass) ->
    6100141;

%%放置挂机结算中，无法操作
get(err610_exp_drop_rewarding) ->
    6100142;

%%离线挂机增加时长已达上限
get(err610_exp_drop_offline_limit) ->
    6100143;

%%开服天数条件无法满足
get(err610_open_day_error) ->
    6100144;

%%挑战次数不足
get(err610_challen_count_limit) ->
    6100145;

%%您还未通关副本哦~
get(err610_dun_pet_not_finish) ->
    6100146;

%%还未三星通过哟
get(err610_dun_pet_not_finish_three) ->
    6100147;

%%副本需达3S评级，无法操作
get(err610_max_rating_limit) ->
    6100148;

%%副本已三星通关，无法操作
get(err610_dun_have_three_star) ->
    6100149;

%%副本未三星通关，无法操作
get(err610_dun_score_need_max) ->
    6100150;

%%今日已扫荡
get(err610_have_sweeped) ->
    6100151;

%%您未通关任何波数或副本，无法扫荡
get(err610_have_not_pass) ->
    6100152;

%%今日还未扫荡，无法操作
get(err610_have_not_sweeped) ->
    6100153;

%%等级不足，无法选择合并次数
get(err610_mer_lv_limit) ->
    6100154;

%%击破所有幻魔后解锁次数合并
get(err610_mer_kill_all) ->
    6100155;

%%请先首杀所有专属幻魔
get(err610_boss_need_all_pass) ->
    6100156;

%%不是跨服1vn的挑战者
get(err621_not_kf_1vn_challenger) ->
    6210001;

%%参与过的比赛轮数不足
get(err621_turn_not_enough) ->
    6210002;

%%不能投注自己那场
get(err621_no_bet_self) ->
    6210003;

%%您未报名，无法参与活动
get(err621_no_sign) ->
    6210004;

%%您已押注过
get(err621_has_betted) ->
    6210005;

%%不在活动中
get(err621_no_enter) ->
    6210006;

%%未找到该场比赛
get(err621_not_battle) ->
    6210007;

%%该场比赛已结束
get(err621_battle_is_end) ->
    6210008;

%%暂未匹配到对手，请耐心等待
get(err621_not_match_yet) ->
    6210009;

%%道具不足
get(err621_goods_not_enough) ->
    6210010;

%%已达到最大观战人数
get(err621_watch_max_num) ->
    6210011;

%%当前阶段不可竞猜
get(err621_not_bet_stage) ->
    6210012;

%%您已报名
get(err621_is_signed) ->
    6210013;

%%正在跨服1vn活动中
get(err621_in_kf_1vn) ->
    6210014;

%%不在守擂赛准备阶段，不可进入
get(err621_not_in_race_2) ->
    6210015;

%%不是跨服1vn的擂主
get(err621_not_kf_1vn_def) ->
    6210016;

%%不在该赛区
get(err621_not_kf_1vn_area) ->
    6210017;

%%跨服1vn商城未开启
get(err621_shop_not_open) ->
    6210018;

%%本次竞拍的最小加价为{1}
get(err621_min_auction_price) ->
    6210019;

%%不在备战区
get(err621_not_in_pre_scene) ->
    6210020;

%%拍卖尚未开启
get(err621_auction_close) ->
    6210021;

%%社团等级不足
get(err647_lv_not_enough) ->
    6470001;

%%你没有参加任何社团
get(err647_not_has_guild) ->
    6470002;

%%社团试炼活动还没开始
get(err647_activity_not_open) ->
    6470003;

%%主城和安全区才可以前往活动
get(err647_not_in_safe_area) ->
    6470004;

%%不在社团试炼中
get(err647_not_in_guild_war) ->
    6470005;

%%已在活动中
get(err647_in_guild_war) ->
    6470006;

%%活动期间不能以新社团再次进入
get(err647_forbid_enter_again) ->
    6470007;

%%您社团的试炼活动已经结束
get(err647_self_guild_is_over) ->
    6470008;

%%杀戮战场不能进入3v3
get(err650_kf_3v3_in_kill_scene) ->
    6500001;

%%连接不上跨服中心
get(err650_kf_3v3_not_conn) ->
    6500002;

%%未达领取条件
get(err650_kf_3v3_lack_wincount) ->
    6500003;

%%无奖励可领取
get(err650_kf_3v3_lack_reward) ->
    6500004;

%%已领取奖励
get(err650_kf_3v3_is_packed) ->
    6500005;

%%不能踢出自己
get(err650_kf_3v3_kick_self) ->
    6500006;

%%密码长度超长
get(err650_kf_3v3_long_pasm) ->
    6500007;

%%活动即将结束不可进入战斗
get(err650_kf_3v3_come_to_end) ->
    6500008;

%%等待回复
get(err650_kf_3v3_watting) ->
    6500009;

%%活动还未开始
get(err650_kf_3v3_not_start) ->
    6500010;

%%删除单个队伍
get(err650_kf_3v3_delete_team) ->
    6500011;

%%刷新单个队伍
get(err650_kf_3v3_update_team) ->
    6500012;

%%刷新队列
get(err650_kf_3v3_update_teamlist) ->
    6500013;

%%战力不足
get(err650_kf_3v3_low_power) ->
    6500014;

%%等级不足
get(err650_kf_3v3_low_lv) ->
    6500015;

%%密码不对
get(err650_kf_3v3_wrong_pswd) ->
    6500016;

%%该玩家不在队伍中
get(err650_kf_3v3_no_member) ->
    6500017;

%%战争已结束
get(err650_kf_3v3_war_end) ->
    6500018;

%%未加入队伍
get(err650_kf_3v3_not_joined) ->
    6500019;

%%队长不能取消准备
get(err650_kf_3v3_cannot_reset_ready) ->
    6500020;

%%有玩家未准备好
get(err650_kf_3v3_not_ready) ->
    6500021;

%%已在匹配队伍中
get(err650_kf_3v3_matching) ->
    6500022;

%%人数不足，无法开始
get(err650_kf_3v3_lack_member) ->
    6500023;

%%战斗中，请稍后再操作
get(err650_kf_3v3_fighting) ->
    6500024;

%%不是队长，没有权限开始匹配
get(err650_kf_3v3_not_captain) ->
    6500025;

%%队伍已解散
get(err650_kf_3v3_no_team) ->
    6500026;

%%队伍已满员
get(err650_kf_3v3_full_member) ->
    6500027;

%%已有队伍
get(err650_kf_3v3_in_team) ->
    6500028;

%%正在3v3队伍中
get(err650_in_kf_3v3_act) ->
    6500029;

%%参与次数不足
get(err650_kf_3v3_lack_count) ->
    6500030;

%%3v3段位不足，无法兑换
get(err650_tier_not_enough) ->
    6500031;

%%声望不足，参加3V3可以获得更多声望哦
get(err650_hornor_limit) ->
    6500032;

%%队伍已满员，无用招募了
get(err650_kf_3v3_call_member_full) ->
    6500033;

%%超过了限购次数噢
get(err331_exceed_max_times) ->
    33110152;

%%您的积分不足
get(err331_lack_score) ->
    33110153;

%%奖励还不可兑换噢~
get(err331_lack_phase) ->
    33110154;

%%源樱之礼抽奖类型错误
get(err331_draw_type_err) ->
    33110155;

%%源樱之礼活动套数配置错误
get(err331_suit_err) ->
    33110156;

%%源樱之礼商城物品配置错误
get(err331_sakura_store_reward_err) ->
    33110157;

%%源樱积分配置错误
get(err331_sakura_store_points_err) ->
    33110158;

%%兑换个数错误
get(err331_sakura_exchange_num_err) ->
    33110159;

%%源樱积分不足哟
get(err331_sakur_points_not_enough) ->
    33110160;

%%补签次数不足
get(err331_no_resign_times) ->
    33110161;

%%不需要补签
get(err331_no_need_resign) ->
    33110162;

%%无法直接购买
get(err331_cannot_buy_directly) ->
    33110163;

%%等级异常，无法操作
get(err331_contract_lv_error) ->
    33110164;

%%等级已激活，无法操作
get(err331_lv_have_actived) ->
    33110165;

%%已达到最大等级，无法操作
get(err331_contract_lv_max) ->
    33110166;

%%需要先重置奖励哦
get(err331_cannot_select) ->
    33110167;

%%已经选过了哟
get(err331_has_select) ->
    33110168;

%%已经选满了喔
get(err331_finished_select) ->
    33110169;

%%自选扭蛋配置错误
get(err331_select_egg_reward_err) ->
    33110170;

%%还没有选择扭蛋喔
get(err331_select_egg_reward_none) ->
    33110171;

%%先选完奖励哟
get(err331_not_finish_select) ->
    33110172;

%%当前不需要重置哟
get(err331_not_need_reset) ->
    33110173;

%%重置次数不足
get(err331_reset_time_not_enough) ->
    33110174;

%%当前不能删除奖励哟
get(err331_cannot_cancel) ->
    33110175;

%%没有这个扭蛋奖励哟
get(err331_has_not_reward) ->
    33110176;

%%需要先确认奖励哟
get(err331_select_egg_hasnot_ensure) ->
    33110177;

%%已自动领取 <color=#2cf89a>[{1}]</color> 活动奖励！
get(err331_circle_foster_return) ->
    33110178;

%%未达到可领取进度
get(err331_process_unreached) ->
    33110179;

%%没有离线经验可赎回
get(err132_no_redemption_exp) ->
    132000001;

get(_Type) ->
    ?INFO("miss err cfg:~p~n",[_Type]),0.

