%%%---------------------------------------
%%% module      : data_errorcode_msg
%%% description : 错误码描述
%%%
%%%---------------------------------------
-module(data_errorcode_msg).
-compile(export_all).
-include("common.hrl").



get(0) ->
    #errorcode_msg{type = fail,about = "操作失败"};

get(1) ->
    #errorcode_msg{type = success,about = "操作成功"};

get(1001) ->
    #errorcode_msg{type = gold_not_enough,about = "您的彩钻余额不足哦~"};

get(1002) ->
    #errorcode_msg{type = coin_not_enough,about = "您的交易券余额不足哦~"};

get(1003) ->
    #errorcode_msg{type = goods_not_enough,about = "物品不足"};

get(1004) ->
    #errorcode_msg{type = money_not_enough,about = "您的金额不足"};

get(1005) ->
    #errorcode_msg{type = missing_config,about = "缺失配置"};

get(1006) ->
    #errorcode_msg{type = bgold_not_enough,about = "您的红钻余额不足哦~"};

get(1007) ->
    #errorcode_msg{type = player_add_exp,about = "经验 +{1}"};

get(1008) ->
    #errorcode_msg{type = not_enough_length,about = "长度为2-6个单位"};

get(1009) ->
    #errorcode_msg{type = name_exist,about = "该名称已存在"};

get(1010) ->
    #errorcode_msg{type = illegal_character,about = "非法字符"};

get(1011) ->
    #errorcode_msg{type = not_have_free_card,about = "改名卡数量不足"};

get(1012) ->
    #errorcode_msg{type = lv_limit,about = "等级不足，功能暂未开放"};

get(1013) ->
    #errorcode_msg{type = vip_limit,about = "VIP等级不足"};

get(1014) ->
    #errorcode_msg{type = cannot_transferable_scene,about = "当前场景不能进入！"};

get(1015) ->
    #errorcode_msg{type = cannot_transferable_area,about = "非安全区不能进入！"};

get(1016) ->
    #errorcode_msg{type = err_config,about = "配置出错"};

get(1017) ->
    #errorcode_msg{type = figure_actived,about = "形象已激活"};

get(1018) ->
    #errorcode_msg{type = data_error,about = "数据异常，请稍后再试！"};

get(1019) ->
    #errorcode_msg{type = cell_beyond,about = "格子超出上限！"};

get(1020) ->
    #errorcode_msg{type = player_add_exp_extra,about = "经验 +{1}（+{2}%）"};

get(1021) ->
    #errorcode_msg{type = player_lv_less,about = "您的等级小于{1}"};

get(1022) ->
    #errorcode_msg{type = player_lv_large,about = "您的等级大于{1}"};

get(1023) ->
    #errorcode_msg{type = operation_too_quickly,about = "您的操作过快"};

get(1024) ->
    #errorcode_msg{type = system_busy,about = "系统繁忙，请稍后再操作"};

get(1025) ->
    #errorcode_msg{type = honour_not_enough,about = "您的荣誉值不足"};

get(1026) ->
    #errorcode_msg{type = in_forbid_pk_status,about = "玩家当前状态不能释放技能"};

get(1027) ->
    #errorcode_msg{type = player_die,about = "当前处于死亡状态，请复活后再操作！"};

get(1028) ->
    #errorcode_msg{type = reward_is_got,about = "奖励已领取"};

get(1029) ->
    #errorcode_msg{type = what_not_enough,about = "{1}不足"};

get(1030) ->
    #errorcode_msg{type = player_power_less,about = "您的战力小于{1}"};

get(1031) ->
    #errorcode_msg{type = exp_not_enough,about = "经验值不足"};

get(1032) ->
    #errorcode_msg{type = config_err,about = "配置错误"};

get(1033) ->
    #errorcode_msg{type = turn_not_enough,about = "操作无效，转生次数不足"};

get(1034) ->
    #errorcode_msg{type = not_connect_center,about = "连接不上跨服中心"};

get(1035) ->
    #errorcode_msg{type = args_error,about = "参数错误"};

get(1036) ->
    #errorcode_msg{type = fgold_not_enough,about = "您的粉钻余额不足"};

get(1037) ->
    #errorcode_msg{type = mate_not_enough,about = "羁绊点不足"};

get(1038) ->
    #errorcode_msg{type = bag_not_enough,about = "背包已满，奖励已通过邮件发送"};

get(1039) ->
    #errorcode_msg{type = star_no_enough,about = "您的星钻不足"};

get(1040) ->
    #errorcode_msg{type = txt_forbid,about = "当前文本暂时无法修改，请等待恢复修改功能哦~"};

get(1020001) ->
    #errorcode_msg{type = err102_setting_key_not_exist,about = "游戏设置类型不存在"};

get(1020002) ->
    #errorcode_msg{type = err102_too_frequent,about = "玩家当前操作太频繁，请{1}秒后再重新操作"};

get(1100001) ->
    #errorcode_msg{type = err110_voice_lose_efficacy,about = "您的语音已经失效了，稍后再试试"};

get(1100002) ->
    #errorcode_msg{type = err110_lv_limit,about = "您还未达到此频道开放等级，继续加油！"};

get(1100003) ->
    #errorcode_msg{type = err110_unknow_channel,about = "您不能在此频道发送信息哟！"};

get(1100004) ->
    #errorcode_msg{type = err110_in_cd,about = "聊天冷却中，稍后再试试哟！"};

get(1100005) ->
    #errorcode_msg{type = err110_content_repeat,about = "内容重复了！"};

get(1100006) ->
    #errorcode_msg{type = err110_times_not_enough,about = "次数不足"};

get(1100007) ->
    #errorcode_msg{type = err110_shield_self,about = "无法对自己进行操作"};

get(1100008) ->
    #errorcode_msg{type = err110_have_shield,about = "已屏蔽对方，不用重复操作了"};

get(1100009) ->
    #errorcode_msg{type = err110_shield_num,about = "屏蔽人数已达上限"};

get(1100010) ->
    #errorcode_msg{type = err110_intimacy_limit,about = "您与对方亲密度不够，无法离线聊天哦"};

get(1100011) ->
    #errorcode_msg{type = err110_cmd_frequent,about = "操作太频繁了，请过一段时间后再试试"};

get(1100012) ->
    #errorcode_msg{type = err110_talk_limit,about = "对方被禁言，无法聊天哦"};

get(1100013) ->
    #errorcode_msg{type = err110_cd_limit,about = "聊天冷却中，请{1}秒后再试。"};

get(1100014) ->
    #errorcode_msg{type = err110_content_len,about = "内容太长了咯~"};

get(1120001) ->
    #errorcode_msg{type = err112_dress_not_exist,about = "装扮不存在"};

get(1120002) ->
    #errorcode_msg{type = err112_dress_has_enabled,about = "装扮已激活"};

get(1120003) ->
    #errorcode_msg{type = err112_dress_not_enabled,about = "装扮未激活"};

get(1120004) ->
    #errorcode_msg{type = err112_dress_not_used,about = "未使用装扮不需要卸下"};

get(1120005) ->
    #errorcode_msg{type = err112_dress_max_level,about = "装扮已经达到最高等级"};

get(1120006) ->
    #errorcode_msg{type = err112_debrisnum_illegal,about = "碎片数量必须大于零！"};

get(1120007) ->
    #errorcode_msg{type = err112_dress_arg_empty,about = "没有提供升级的碎片"};

get(1120008) ->
    #errorcode_msg{type = err112_dress_not_selected,about = "你没有选择要使用的装扮喔"};

get(1120009) ->
    #errorcode_msg{type = err112_dress_not_default,about = "不是默认装扮喔"};

get(1120010) ->
    #errorcode_msg{type = err112_lv_not_satisfy,about = "等级不足"};

get(1120011) ->
    #errorcode_msg{type = err112_dress_has_not_enabled,about = "装扮还没激活，暂时不能回收喔"};

get(1120012) ->
    #errorcode_msg{type = err112_dress_same_type,about = "不能选择相同类型装扮哟"};

get(1140001) ->
    #errorcode_msg{type = err114_cant_fetch_again,about = "不可再次领取"};

get(1140002) ->
    #errorcode_msg{type = err114_need_finish_task,about = "需要先完成任务"};

get(1200001) ->
    #errorcode_msg{type = err120_cannot_transfer_scene,about = "当前场景不能进入！"};

get(1200002) ->
    #errorcode_msg{type = err120_cannot_transfer_not_in_safe,about = "非安全区不能进入！"};

get(1200003) ->
    #errorcode_msg{type = err120_cannot_transfer_pre_scene_time,about = "切换场景时间不足，请再次切换场景！"};

get(1200004) ->
    #errorcode_msg{type = err120_cannot_transfer_change_scene_sign,about = "排队换线中，请稍后再切换场景！"};

get(1200005) ->
    #errorcode_msg{type = err120_cannot_transfer_scene_not_exist,about = "目标场景数据不存在！"};

get(1200006) ->
    #errorcode_msg{type = err120_cannot_transfer_lv_not_reach,about = "等级不足，不能切换到目标场景！"};

get(1200007) ->
    #errorcode_msg{type = err120_cannot_transfer_in_dungeon,about = "副本地图无法传送！"};

get(1200008) ->
    #errorcode_msg{type = err120_same_line,about = "已在当前线路"};

get(1200009) ->
    #errorcode_msg{type = err120_too_many_people,about = "此线路玩家太多，请选择另外的线路"};

get(1200010) ->
    #errorcode_msg{type = err120_is_on_battle,about = "正在寻路安全区，或者脱离战斗再参加"};

get(1200011) ->
    #errorcode_msg{type = err120_cannot_transfer_on_battle,about = "处于战斗状态无法传送"};

get(1200012) ->
    #errorcode_msg{type = err120_scene_loading,about = "当前场景还没有加载完，请稍后！"};

get(1200013) ->
    #errorcode_msg{type = err120_is_near,about = "您已经在附近，不需要飞行！"};

get(1200015) ->
    #errorcode_msg{type = err120_cannot_battle_change_scene_sign,about = "正在切换场景，不能进行攻击"};

get(1200016) ->
    #errorcode_msg{type = err120_max_user,about = "场景人数已达上限，无法进入！"};

get(1200017) ->
    #errorcode_msg{type = err120_transtype,about = "暂时不能使用小飞鞋！"};

get(1200018) ->
    #errorcode_msg{type = err120_already_in_scene,about = "已经在当前场景，无须再次进入！"};

get(1200019) ->
    #errorcode_msg{type = err120_cannot_transfer_to_target_scene,about = "目标场景不可进入"};

get(1200020) ->
    #errorcode_msg{type = err120_ghost_state_limit,about = "当前处于死亡状态，请复活后再操作！"};

get(1200021) ->
    #errorcode_msg{type = err120_no_fly_shoes,about = "没有小飞鞋！"};

get(1300001) ->
    #errorcode_msg{type = err130_change_pk_change_line,about = "换线中，不能切换战斗状态"};

get(1300002) ->
    #errorcode_msg{type = err130_change_pk_cd,about = "和平状态切换正在冷却中"};

get(1300003) ->
    #errorcode_msg{type = err130_user_cant_change_pk,about = "此场景不能手动切换战斗模式"};

get(1300004) ->
    #errorcode_msg{type = err130_change_pk_lv_lim,about = "低于20级不能切换pk状态"};

get(1300005) ->
    #errorcode_msg{type = err130_no_peace,about = "此场景不能切换和平模式"};

get(1300006) ->
    #errorcode_msg{type = err130_not_change,about = "当前不能切换战斗状态"};

get(1300007) ->
    #errorcode_msg{type = err130_no_peace_ultimate,about = "不能切换此模式"};

get(1300008) ->
    #errorcode_msg{type = err130_transfer_lv_limit,about = "{1}级后开启变性功能"};

get(1300009) ->
    #errorcode_msg{type = err130_transfer_sex_limit,about = "非单身的玩家需离婚或分手后才可转变为其他性别"};

get(1300010) ->
    #errorcode_msg{type = err130_transfer_career_same_limit,about = "已经是本职业，不需要进行转职"};

get(1300011) ->
    #errorcode_msg{type = err130_transfer_cd_limit,about = "处于冷却期内，无法变性"};

get(1300012) ->
    #errorcode_msg{type = err130_transfer_career_err,about = "职业数据错误"};

get(1300013) ->
    #errorcode_msg{type = err130_change_pk_not_cluster_scene,about = "非跨服场景不能切换服务器模式"};

get(1300014) ->
    #errorcode_msg{type = err130_no_profile_photo_cfg,about = "没有此头像配置"};

get(1300015) ->
    #errorcode_msg{type = err130_is_activated,about = "已激活"};

get(1300016) ->
    #errorcode_msg{type = err130_is_not_activated,about = "头像还没激活"};

get(1300017) ->
    #errorcode_msg{type = err130_no_kill_all,about = "不可切换为杀戮模式！"};

get(1310001) ->
    #errorcode_msg{type = err131_reply_error,about = "回复参数错误"};

get(1310002) ->
    #errorcode_msg{type = err131_player_die,about = "人物死亡，无法回复"};

get(1310003) ->
    #errorcode_msg{type = err131_hp_max,about = "气血已满，无需回复"};

get(1310004) ->
    #errorcode_msg{type = err131_time_error,about = "回复时间未到"};

get(1310005) ->
    #errorcode_msg{type = err131_scene_limit,about = "场景限制"};

get(1310006) ->
    #errorcode_msg{type = err131_sit_down_first,about = "请先打坐，方可按打坐方式回复"};

get(1370001) ->
    #errorcode_msg{type = err137_not_sign_state,about = "非报名阶段"};

get(1370002) ->
    #errorcode_msg{type = err137_has_sign,about = "已报名"};

get(1370003) ->
    #errorcode_msg{type = err137_tool_not_enough,about = "道具不足"};

get(1370004) ->
    #errorcode_msg{type = err137_lv_not_enough,about = "未达到参赛等级"};

get(1370005) ->
    #errorcode_msg{type = err137_buy_limit,about = "已达购买上限"};

get(1370006) ->
    #errorcode_msg{type = err137_not_sign,about = "未报名"};

get(1370007) ->
    #errorcode_msg{type = err137_not_prepare_state,about = "非准备阶段"};

get(1370008) ->
    #errorcode_msg{type = err137_is_in_prepare,about = "已在准备区"};

get(1370009) ->
    #errorcode_msg{type = err137_not_allow_select_same,about = "不可重复选同个候选人"};

get(1370010) ->
    #errorcode_msg{type = err137_cfg_error,about = "参数错误"};

get(1370011) ->
    #errorcode_msg{type = err137_not_need_to_leave,about = "非擂台赛场景,不需退出"};

get(1370012) ->
    #errorcode_msg{type = err137_not_guess_state,about = "非竞猜阶段"};

get(1370013) ->
    #errorcode_msg{type = err137_not_guess_zone_role,about = "非可选战区候选人"};

get(1370014) ->
    #errorcode_msg{type = err137_not_guess_act_role,about = "非可选战场候选人"};

get(1370015) ->
    #errorcode_msg{type = err137_not_select_empty_role,about = "轮空玩家不可选"};

get(1370016) ->
    #errorcode_msg{type = err137_not_select_same_plat,about = "不可同时选同台候选人"};

get(1370017) ->
    #errorcode_msg{type = err137_skill_cd,about = "技能未冷却"};

get(1370018) ->
    #errorcode_msg{type = err137_fight_allow_use,about = "技能擂台中可使用"};

get(1370019) ->
    #errorcode_msg{type = err137_error_skill,about = "非法技能"};

get(1370020) ->
    #errorcode_msg{type = err137_not_in_prepare,about = "不在准备区中"};

get(1370021) ->
    #errorcode_msg{type = err137_be_kill_not_buy,about = "您已被淘汰，不可购买"};

get(1370022) ->
    #errorcode_msg{type = err137_power_out,about = "战力跌出4096名，失去比赛资格"};

get(1370023) ->
    #errorcode_msg{type = err137_not_enter_lose,about = "已被淘汰"};

get(1370024) ->
    #errorcode_msg{type = err137_not_enter_state,about = "当前阶段不能进入"};

get(1370025) ->
    #errorcode_msg{type = err137_not_enter_sub_state,about = "已过了进入时间，故被淘汰"};

get(1370026) ->
    #errorcode_msg{type = err137_can_not_change_scene_in_drumwar,about = "在钻石大战中"};

get(1370027) ->
    #errorcode_msg{type = err137_has_winner,about = "已获得冠军"};

get(1380001) ->
    #errorcode_msg{type = err138_journey_map_err,about = "征途地图错误"};

get(1380002) ->
    #errorcode_msg{type = err138_journey_has_finished,about = "征途任务已完成"};

get(1380003) ->
    #errorcode_msg{type = err138_journey_cant_fetch_again,about = "征途奖励不可重复领取"};

get(1380004) ->
    #errorcode_msg{type = err138_journey_need_finish,about = "需要先完成任务"};

get(1380005) ->
    #errorcode_msg{type = err138_journey_map_locked,about = "征途地图未解锁"};

get(1380006) ->
    #errorcode_msg{type = err138_journey_task_locked,about = "任务未解锁"};

get(1390001) ->
    #errorcode_msg{type = err139_reslove_fail,about = "装备分解失败"};

get(1390002) ->
    #errorcode_msg{type = err139_need_attr_max,about = "需要至少1条属性洗练达到满值才可突破！"};

get(1390003) ->
    #errorcode_msg{type = err139_pool_empty,about = "奖池为空"};

get(1390004) ->
    #errorcode_msg{type = err139_goods_not_exist,about = "道具不存在"};

get(1390005) ->
    #errorcode_msg{type = err139_max_grade_reached,about = "装备已达最大阶位"};

get(1390006) ->
    #errorcode_msg{type = err139_max_lv_reached,about = "已达最大等级"};

get(1390007) ->
    #errorcode_msg{type = err139_section_max_reached,about = "装备已达最高段位"};

get(1390008) ->
    #errorcode_msg{type = err139_need_up_grade,about = "需要突破更高阶位"};

get(1390009) ->
    #errorcode_msg{type = err139_need_more_exp,about = "圣物需要升级至满级才可突破！"};

get(1390010) ->
    #errorcode_msg{type = err139_need_up_lv,about = "需要更高等级"};

get(1390011) ->
    #errorcode_msg{type = err139_max_title_reached,about = "已达最高圣物阶位"};

get(1390012) ->
    #errorcode_msg{type = err139_sys_not_open,about = "功能未开放"};

get(1390013) ->
    #errorcode_msg{type = err139_need_active_next,about = "圣物已升至满级！"};

get(1390014) ->
    #errorcode_msg{type = err139_need_finish_dun,about = "需要先完成指定副本"};

get(1390015) ->
    #errorcode_msg{type = err139_need_more_power,about = "圣物需要升级至满级才可突破！"};

get(1390016) ->
    #errorcode_msg{type = err139_need_equip_goods,about = "需要先穿戴装备"};

get(1390017) ->
    #errorcode_msg{type = err139_all_attr_max_reached,about = "所有属性已达上限值"};

get(1390018) ->
    #errorcode_msg{type = err139_need_equip_higher_goods,about = "需要准备更高级装备"};

get(1400001) ->
    #errorcode_msg{type = err140_1_myself_friend_num_limit,about = "本人好友人数达到上限"};

get(1400002) ->
    #errorcode_msg{type = err140_2_other_friend_num_limit,about = "对方好友人数达到上限"};

get(1400003) ->
    #errorcode_msg{type = err140_3_role_no_exist,about = "玩家不存在"};

get(1400004) ->
    #errorcode_msg{type = err140_4_is_friend,about = "对方已经是您的好友"};

get(1400005) ->
    #errorcode_msg{type = err140_5_not_reply_myself_ask,about = "不可添加自己为好友"};

get(1400006) ->
    #errorcode_msg{type = err140_6_not_friend,about = "对方不是好友"};

get(1400007) ->
    #errorcode_msg{type = err140_7_not_exist_by_type,about = "非对应关系"};

get(1400009) ->
    #errorcode_msg{type = err140_9_exist_rela,about = "已经添加过了~"};

get(1400010) ->
    #errorcode_msg{type = err140_10_not_enemy,about = "不是仇人~"};

get(1400012) ->
    #errorcode_msg{type = err140_12_present_max,about = "赠送礼物次数已达上限"};

get(1400013) ->
    #errorcode_msg{type = err140_13_intimacy_max,about = "亲密度已达上限"};

get(1400014) ->
    #errorcode_msg{type = err140_14_not_online,about = "该玩家不在线"};

get(1400019) ->
    #errorcode_msg{type = err140_19_no_ask_to_be_friend,about = "暂时没有好友申请"};

get(1400020) ->
    #errorcode_msg{type = err140_20_no_friend_ask,about = "无申请信息"};

get(1400021) ->
    #errorcode_msg{type = err140_21_name_is_wrongful,about = "名字不合法"};

get(1400022) ->
    #errorcode_msg{type = err140_22_not_scene,about = "在主城或安全区才能进行该操作"};

get(1400025) ->
    #errorcode_msg{type = err140_25_in_blacklist,about = "该玩家已被您拉黑，需要移除黑名单才能添加好友"};

get(1400026) ->
    #errorcode_msg{type = err140_26_recommended_too_often,about = "推荐太频繁了，休息下再来"};

get(1400027) ->
    #errorcode_msg{type = err140_27_myself_black_list_num_limit,about = "黑名单人数已达上限"};

get(1400028) ->
    #errorcode_msg{type = err140_28_in_another_blacklist,about = "您在对方的黑名单，无法添加好友"};

get(1400029) ->
    #errorcode_msg{type = err140_29_not_same_server_player,about = "不是同服玩家暂时不能查看"};

get(1400030) ->
    #errorcode_msg{type = err140_30_in_blacklist,about = "您或对方在黑名单中，不可聊天。"};

get(1400031) ->
    #errorcode_msg{type = err140_is_lover,about = "对不起，你们还存在着情侣/伴侣关系"};

get(1400032) ->
    #errorcode_msg{type = err140_32_repeat_send,about = "您今日已给对方赠送过礼物"};

get(1400033) ->
    #errorcode_msg{type = err140_send_num_limit,about = "每日赠送次数已达数量上限"};

get(1400034) ->
    #errorcode_msg{type = err140_gift_num_limit,about = "每日领取次数已达上限"};

get(1400035) ->
    #errorcode_msg{type = err140_role_not_send,about = "对方没有赠送礼物，无法操作"};

get(1400036) ->
    #errorcode_msg{type = err140_you_have_received,about = "你已领取，请勿重复操作"};

get(1400037) ->
    #errorcode_msg{type = err140_batch_send_error,about = "一键赠送失败"};

get(1400038) ->
    #errorcode_msg{type = err140_batch_receive_error,about = "一键领取失败"};

get(1400039) ->
    #errorcode_msg{type = err140_not_same_svr,about = "不是同服玩家无法操作"};

get(1420001) ->
    #errorcode_msg{type = err142_not_guess_time,about = "不在投注时间内"};

get(1420002) ->
    #errorcode_msg{type = err142_still_item_buff,about = "选手已有生效道具"};

get(1420003) ->
    #errorcode_msg{type = err142_buff_cding,about = "选手BUFF冷却中"};

get(1420004) ->
    #errorcode_msg{type = err142_find_no_runer,about = "没有这位选手"};

get(1420005) ->
    #errorcode_msg{type = err142_has_no_enough_money,about = "没有足够资金"};

get(1420006) ->
    #errorcode_msg{type = err142_cant_use_now,about = "现在不可使用"};

get(1420007) ->
    #errorcode_msg{type = err142_no_enough_item,about = "没有足够道具"};

get(1430000) ->
    #errorcode_msg{type = err143_warsoul_no_cell,about = "战魂背包不足！"};

get(1430001) ->
    #errorcode_msg{type = err143_pos_not_open,about = "阵位尚未开放！"};

get(1430002) ->
    #errorcode_msg{type = err143_same_warsoul,about = "已上阵相同类型战魂！"};

get(1430003) ->
    #errorcode_msg{type = err143_warsoul_max_lv,about = "已达最高等级！"};

get(1430004) ->
    #errorcode_msg{type = err143_evolution_less_stuff,about = "进化材料不足！"};

get(1430005) ->
    #errorcode_msg{type = err143_collect_max,about = "暂无可领取的奖励！"};

get(1430006) ->
    #errorcode_msg{type = err143_collect_condition,about = "领取条件不足！"};

get(1430007) ->
    #errorcode_msg{type = err143_cannot_wear,about = "不可上阵！"};

get(1430008) ->
    #errorcode_msg{type = err143_cannot_evolution,about = "不可进化！"};

get(1430009) ->
    #errorcode_msg{type = err143_evolution_stuff_error,about = "进化材料出错！"};

get(1430010) ->
    #errorcode_msg{type = err143_nothing_to_back,about = "强化后可以进行回退！"};

get(1430011) ->
    #errorcode_msg{type = err143_err143_pos_lock,about = "阵位尚未解锁！"};

get(1430012) ->
    #errorcode_msg{type = err143_err143_pos_unlock,about = "阵位已经解锁！"};

get(1430013) ->
    #errorcode_msg{type = err143_cannot_strength,about = "经验材料战魂不可培养！"};

get(1440001) ->
    #errorcode_msg{type = err144_lv_unreach,about = "玩家等级不足"};

get(1440002) ->
    #errorcode_msg{type = err144_floor_unreach,about = "副本通关层数不足"};

get(1440003) ->
    #errorcode_msg{type = err144_has_been_grade_max,about = "已达最大阶位"};

get(1440004) ->
    #errorcode_msg{type = err144_need_wait_more_time,about = "需要等待储备更多时间"};

get(1440005) ->
    #errorcode_msg{type = err144_need_enough_lv,about = "魂力未达本阶最大等级"};

get(1440006) ->
    #errorcode_msg{type = err144_has_been_lv_max,about = "已达本阶最大等级"};

get(1440007) ->
    #errorcode_msg{type = err144_no_need_quick,about = "不需要充能"};

get(1440008) ->
    #errorcode_msg{type = err144_power_unreach,about = "玩家战力不足"};

get(1440009) ->
    #errorcode_msg{type = err144_expdun_floor_unreach,about = "经验副本层数不足"};

get(1440010) ->
    #errorcode_msg{type = err144_warsoul_stars_unreach,about = "战魂星级不足"};

get(1450001) ->
    #errorcode_msg{type = err145_task_conditon,about = "您的领取条件不足！"};

get(1450002) ->
    #errorcode_msg{type = err145_turn_lower,about = "转生条件不足！"};

get(1450003) ->
    #errorcode_msg{type = err145_lv_lower,about = "等级不足！"};

get(1450004) ->
    #errorcode_msg{type = err145_already_get,about = "已经领取完奖励！"};

get(1450005) ->
    #errorcode_msg{type = err145_not_kill_yet,about = "尚未击杀该幻魔！"};

get(1450006) ->
    #errorcode_msg{type = err145_2_word_is_sensitive,about = "含有敏感词，无法操作"};

get(1460001) ->
    #errorcode_msg{type = err146_foster_not_open,about = "功能未开放"};

get(1460002) ->
    #errorcode_msg{type = err146_limit_usage_reached,about = "达到使用上限"};

get(1460003) ->
    #errorcode_msg{type = err146_need_more_grade,about = "需要更高阶位"};

get(1460004) ->
    #errorcode_msg{type = err146_foster_max_grade,about = "已达到最高阶位"};

get(1460005) ->
    #errorcode_msg{type = err146_display_repeat,about = "幻化重复"};

get(1460006) ->
    #errorcode_msg{type = err146_lv_max_reached,about = "已达到技能满级"};

get(1460007) ->
    #errorcode_msg{type = err146_some_cant_resolve,about = "道具不可吞噬"};

get(1460008) ->
    #errorcode_msg{type = err146_gooods_no_exist,about = "道具不存在"};

get(1460009) ->
    #errorcode_msg{type = err146_equip_lv_max_reached,about = "已达到装备最高等级"};

get(1460010) ->
    #errorcode_msg{type = err146_already_max_star,about = "已达到最高星"};

get(1460011) ->
    #errorcode_msg{type = err146_need_active_skin,about = "需要先激活对应珍宝"};

get(1460012) ->
    #errorcode_msg{type = err146_foster_skin_already_active,about = "该皮肤已激活"};

get(1460013) ->
    #errorcode_msg{type = err146_grade_limit,about = "未激活对应阶位"};

get(1460014) ->
    #errorcode_msg{type = err146_assist_state_error,about = "穿满6件且含有要求品质装备，即可激活助战"};

get(1460015) ->
    #errorcode_msg{type = err146_have_actived,about = "助战状态已激活，请勿重复操作"};

get(1460016) ->
    #errorcode_msg{type = err146_foster_max_lv,about = "已经达到最大等级了"};

get(1460017) ->
    #errorcode_msg{type = err146_foster_type_err,about = "进阶类型错误"};

get(1460018) ->
    #errorcode_msg{type = err146_sub_foster_material_err,about = "进阶升级材料配置错误"};

get(1460019) ->
    #errorcode_msg{type = err146_material_type_err,about = "进阶升级材料参数错误"};

get(1460020) ->
    #errorcode_msg{type = err146_sub_foster_skin_has_no_active,about = "皮肤未激活哟"};

get(1460021) ->
    #errorcode_msg{type = err146_sub_foster_star_not_enough,about = "还未提升到该星级喔"};

get(1460022) ->
    #errorcode_msg{type = err146_foster_skin_max,about = "已经达到最大星级了"};

get(1460023) ->
    #errorcode_msg{type = err146_foster_skin_material_err,about = "皮肤升星材料配置错误"};

get(1460024) ->
    #errorcode_msg{type = err146_foster_skin,about = "皮肤配置错误"};

get(1470001) ->
    #errorcode_msg{type = err147_fail_upgrade,about = "升级失败"};

get(1470002) ->
    #errorcode_msg{type = err147_need_no_active_again,about = "不需要重复激活"};

get(1470003) ->
    #errorcode_msg{type = err147_need_active,about = "需要先激活"};

get(1470004) ->
    #errorcode_msg{type = err147_conditions_not_met,about = "条件不符合"};

get(1470005) ->
    #errorcode_msg{type = err147_has_max_lv,about = "已满级"};

get(1470006) ->
    #errorcode_msg{type = err147_there_is_not_skill,about = "技能还没激活"};

get(1480001) ->
    #errorcode_msg{type = err148_not_goods,about = "道具不存在"};

get(1480002) ->
    #errorcode_msg{type = err148_galaxy_max_lev,about = "星辰已达最大等级"};

get(1480003) ->
    #errorcode_msg{type = err148_pos_opened,about = "槽位已开启"};

get(1480004) ->
    #errorcode_msg{type = err148_need_active_sort,about = "需要按照顺序激活"};

get(1480005) ->
    #errorcode_msg{type = err148_pos_not_open,about = "槽位未激活"};

get(1480006) ->
    #errorcode_msg{type = err148_have_same_galaxy,about = "已有相同类型星辰"};

get(1480007) ->
    #errorcode_msg{type = err142_cant_buy_now,about = "现在不可购买"};

get(1480008) ->
    #errorcode_msg{type = err148_skill_pertivive,about = "技能重复"};

get(1480009) ->
    #errorcode_msg{type = err148_out_skill_pos,about = "超出技能槽位"};

get(1480010) ->
    #errorcode_msg{type = err148_is_settlet_skill,about = "固定技能不可替换"};

get(1480011) ->
    #errorcode_msg{type = err148_skin_max_star,about = "皮肤已满级"};

get(1480012) ->
    #errorcode_msg{type = err148_use_same_skin,about = "不需重复幻化"};

get(1480013) ->
    #errorcode_msg{type = err148_cant_fetch_again,about = "不可重复领取"};

get(1480014) ->
    #errorcode_msg{type = err148_need_finish_collect,about = "需要完成收集"};

get(1490001) ->
    #errorcode_msg{type = err149_less_lv,about = "对方等级不足！"};

get(1490002) ->
    #errorcode_msg{type = err149_mates_enough,about = "对方羁绊数量已达上限！"};

get(1490003) ->
    #errorcode_msg{type = err149_not_friends,about = "对方未添加你为好友哦~"};

get(1490004) ->
    #errorcode_msg{type = err149_less_intimacy,about = "亲密度不足"};

get(1490005) ->
    #errorcode_msg{type = err149_already_mate,about = "你们已经结成羁绊了"};

get(1490006) ->
    #errorcode_msg{type = err149_exist_no_response,about = "存在尚未回应的申请"};

get(1490007) ->
    #errorcode_msg{type = err149_ask_not_exist,about = "申请已过期"};

get(1490008) ->
    #errorcode_msg{type = err149_not_mate,about = "你们还没有结成羁绊"};

get(1490009) ->
    #errorcode_msg{type = err149_word_sensitive,about = "存在敏感词汇，请重新输入"};

get(1490010) ->
    #errorcode_msg{type = err149_boat_max_lv,about = "小船已达最高级"};

get(1490011) ->
    #errorcode_msg{type = err149_act_not_open,about = "活动尚未开启"};

get(1490012) ->
    #errorcode_msg{type = err149_target_offline,about = "对方不在线"};

get(1490013) ->
    #errorcode_msg{type = err149_already_in_act,about = "正在参与其他玩法"};

get(1490014) ->
    #errorcode_msg{type = err149_area_cannot_play,about = "当前场景无法进行游戏"};

get(1490015) ->
    #errorcode_msg{type = err149_no_award,about = "奖励不存在"};

get(1490016) ->
    #errorcode_msg{type = err149_less_day,about = "条件不足"};

get(1490017) ->
    #errorcode_msg{type = err149_already_get_award,about = "已经领取了奖励"};

get(1490018) ->
    #errorcode_msg{type = err149_already_wear_title,about = "已经佩戴了称号"};

get(1490019) ->
    #errorcode_msg{type = err149_already_unwear_title,about = "已经卸下了称号"};

get(1490020) ->
    #errorcode_msg{type = err149_is_mate,about = "请先解除羁绊关系"};

get(1490021) ->
    #errorcode_msg{type = err149_other_less_gold,about = "对方金额不足"};

get(1490022) ->
    #errorcode_msg{type = err149_mate_info_overdue,about = "羁绊信息已过期"};

get(1490023) ->
    #errorcode_msg{type = err149_on_game,about = "正在进行羁绊小游戏"};

get(1490024) ->
    #errorcode_msg{type = err149_mates_enough_myself,about = "您的羁绊数量已达上限！"};

get(1490025) ->
    #errorcode_msg{type = err149_not_friends_self,about = "您未添加对方为好友！"};

get(1490026) ->
    #errorcode_msg{type = err149_less_lv_self,about = "您的等级不足！"};

get(1490027) ->
    #errorcode_msg{type = err149_not_response_self,about = "请先同意邀请！"};

get(1490028) ->
    #errorcode_msg{type = err149_not_response,about = "对方还未同意！"};

get(1490029) ->
    #errorcode_msg{type = err149_already_response,about = "已经处理了该邀请！"};

get(1490030) ->
    #errorcode_msg{type = err149_close_act,about = "对方关闭了活动！"};

get(1490031) ->
    #errorcode_msg{type = err149_msg_length,about = "宣言超出最大长度！"};

get(1490032) ->
    #errorcode_msg{type = err149_photo_ready,about = "拍照准备中！"};

get(1490033) ->
    #errorcode_msg{type = err149_photo_invite,about = "今日拍照活动已经完成！"};

get(1490034) ->
    #errorcode_msg{type = err149_photo_offline,about = "没有羁绊好友在线！"};

get(1490035) ->
    #errorcode_msg{type = err149_photo_away_invite,about = "邀请者不在当前场景！"};

get(1490036) ->
    #errorcode_msg{type = err149_photo_wrong_scene,about = "请前往拍照场景准备！"};

get(1490037) ->
    #errorcode_msg{type = err149_photo_wrong_pos,about = "请前往拍照位置准备！"};

get(1490038) ->
    #errorcode_msg{type = err149_not_one_mate,about = "您还没有羁绊！"};

get(1490039) ->
    #errorcode_msg{type = err149_reward_alreday_receive,about = "奖励已领取"};

get(1490040) ->
    #errorcode_msg{type = err149_task_not_final,about = "任务还未完成！"};

get(1500000) ->
    #errorcode_msg{type = err150_fail,about = "物品操作失败"};

get(1500001) ->
    #errorcode_msg{type = err150_no_goods,about = "物品不存在"};

get(1500002) ->
    #errorcode_msg{type = err150_no_money,about = "金额不足"};

get(1500003) ->
    #errorcode_msg{type = err150_no_cell,about = "背包空间不足，请先清理背包"};

get(1500004) ->
    #errorcode_msg{type = err150_exchange_counts_limit,about = "兑换次数不足！"};

get(1500005) ->
    #errorcode_msg{type = err150_in_sell,about = "正在交易中"};

get(1500006) ->
    #errorcode_msg{type = err150_price_err,about = "物品价格错误"};

get(1500007) ->
    #errorcode_msg{type = err150_palyer_err,about = "物品所有者错误"};

get(1500008) ->
    #errorcode_msg{type = err150_location_err,about = "物品位置错误"};

get(1500009) ->
    #errorcode_msg{type = err150_not_sell,about = "物品不可出售"};

get(1500010) ->
    #errorcode_msg{type = err150_num_err,about = "物品数量错误"};

get(1500011) ->
    #errorcode_msg{type = err150_cell_max,about = "背包空间已达上限"};

get(1500012) ->
    #errorcode_msg{type = err150_type_err,about = "物品类型错误"};

get(1500013) ->
    #errorcode_msg{type = err150_require_err,about = "条件不符"};

get(1500014) ->
    #errorcode_msg{type = err150_info_overdue,about = "信息已过期"};

get(1500015) ->
    #errorcode_msg{type = err150_no_goods_type,about = "物品类型不存在"};

get(1500016) ->
    #errorcode_msg{type = err150_in_cd,about = "冷却时间"};

get(1500017) ->
    #errorcode_msg{type = err150_lv_err,about = "物品等级限制"};

get(1500018) ->
    #errorcode_msg{type = err150_player_die,about = "当前处于死亡状态，请复活后再操作！"};

get(1500019) ->
    #errorcode_msg{type = err150_not_trhow,about = "物品不可销毁"};

get(1500020) ->
    #errorcode_msg{type = err150_no_drop,about = "该掉落已被拾取"};

get(1500021) ->
    #errorcode_msg{type = err150_no_drop_per,about = "不是您的掉落，无法拾取哦"};

get(1500022) ->
    #errorcode_msg{type = err150_time_not_start,about = "时间还未到"};

get(1500023) ->
    #errorcode_msg{type = err150_time_end,about = "时间已经结束"};

get(1500024) ->
    #errorcode_msg{type = err150_gift_unactive,about = "礼包未生效"};

get(1500025) ->
    #errorcode_msg{type = err150_no_rule,about = "规则不存在"};

get(1500026) ->
    #errorcode_msg{type = err150_rule_unactive,about = "规则未生效"};

get(1500027) ->
    #errorcode_msg{type = err150_shop_time_limit,about = "限时物品一天只能购买一次"};

get(1500028) ->
    #errorcode_msg{type = err150_goods_num_zero,about = "物品已经卖完"};

get(1500029) ->
    #errorcode_msg{type = err150_gift_got,about = "礼包已领取"};

get(1500030) ->
    #errorcode_msg{type = err150_num_limit,about = "次数已达上限"};

get(1500031) ->
    #errorcode_msg{type = err150_storage_no_cell,about = "仓库空间不足"};

get(1500032) ->
    #errorcode_msg{type = err150_scene_wrong,about = "本场景无法使用"};

get(1500033) ->
    #errorcode_msg{type = err150_npc_type_err,about = "npc类型错误"};

get(1500034) ->
    #errorcode_msg{type = err150_hp_mp_full,about = "使用量超出上限，无法使用"};

get(1500035) ->
    #errorcode_msg{type = err150_num_over,about = "次数超出每天上限"};

get(1500036) ->
    #errorcode_msg{type = err150_skill_fail,about = "技能学习失败"};

get(1500037) ->
    #errorcode_msg{type = err150_fashion_expire,about = "装备已经过期，不可穿戴"};

get(1500038) ->
    #errorcode_msg{type = err150_scene_pos,about = "使用地图坐标不正确"};

get(1500039) ->
    #errorcode_msg{type = err150_not_event,about = "无触发事件"};

get(1500040) ->
    #errorcode_msg{type = err150_nothing,about = "物品使用后什么都没有"};

get(1500041) ->
    #errorcode_msg{type = err150_cannot_replace_mid,about = "当前增益状态不能替换中级增益状态"};

get(1500042) ->
    #errorcode_msg{type = err150_cannot_replace_big,about = "当前增益状态不能替换高级增益状态"};

get(1500043) ->
    #errorcode_msg{type = err150_no_guild,about = "没有帮派"};

get(1500044) ->
    #errorcode_msg{type = err150_num_single_limit,about = "单个物品次数已达上限"};

get(1500045) ->
    #errorcode_msg{type = err150_num_single_over,about = "单个物品兑换数量超过每天上限"};

get(1500046) ->
    #errorcode_msg{type = err150_distance,about = "距离掉落包过远"};

get(1500048) ->
    #errorcode_msg{type = err150_lv_goods,about = "无法使用等级道具"};

get(1500049) ->
    #errorcode_msg{type = err150_num_notmatch,about = "自选物品数量异常"};

get(1500050) ->
    #errorcode_msg{type = err150_seqlist_notmatch,about = "找不到自选礼包奖励内容"};

get(1500051) ->
    #errorcode_msg{type = err150_no_gift_type,about = "打开宝箱配置不存在"};

get(1500052) ->
    #errorcode_msg{type = err150_goods_expired,about = "物品已过有效期"};

get(1500053) ->
    #errorcode_msg{type = err150_no_career_gift,about = "职业不符，无法打开"};

get(1500054) ->
    #errorcode_msg{type = err150_exper_error,about = "剩余历练次数不足"};

get(1500055) ->
    #errorcode_msg{type = err150_compose_goods_not_enough,about = "材料不足，无法合成"};

get(1500056) ->
    #errorcode_msg{type = err150_goods_id_err,about = "物品类型id有误"};

get(1500057) ->
    #errorcode_msg{type = err150_exper_time_more_than_7hour,about = "智慧药水最多累积7小时"};

get(1500058) ->
    #errorcode_msg{type = err150_gift_cfg_missing,about = "礼包数据不存在"};

get(1500059) ->
    #errorcode_msg{type = err150_gift_status_error,about = "礼包状态为无效"};

get(1500060) ->
    #errorcode_msg{type = err150_gift_nobegin,about = "未到领取礼包时间"};

get(1500061) ->
    #errorcode_msg{type = err150_gift_overtime,about = "已过了领取礼包时间"};

get(1500062) ->
    #errorcode_msg{type = err150_gift_data_error,about = "礼包数据错误"};

get(1500063) ->
    #errorcode_msg{type = err150_gift_fetch_error,about = "领取礼包失败"};

get(1500064) ->
    #errorcode_msg{type = err150_gift_card_err_len,about = "礼包卡长度错误"};

get(1500065) ->
    #errorcode_msg{type = err150_gift_card_not_exist,about = "卡号错误"};

get(1500066) ->
    #errorcode_msg{type = err150_gift_card_no_gift_type,about = "卡号没有绑定礼包"};

get(1500067) ->
    #errorcode_msg{type = err150_gift_card_platform_error,about = "平台不对"};

get(1500068) ->
    #errorcode_msg{type = err150_gift_card_has_trigger,about = "卡号已经被领取"};

get(1500069) ->
    #errorcode_msg{type = err150_gift_card_nobegin,about = "未到领取卡号时间"};

get(1500070) ->
    #errorcode_msg{type = err150_gift_card_overtime,about = "卡号过期"};

get(1500071) ->
    #errorcode_msg{type = err150_gift_card_has_use_same_card,about = "已经使用过同类卡号"};

get(1500072) ->
    #errorcode_msg{type = err150_gift_card_gift_not_exist,about = "礼包数据不存在"};

get(1500073) ->
    #errorcode_msg{type = err150_lv_gfit_cfg_err,about = "等级不足，暂时无法使用"};

get(1500074) ->
    #errorcode_msg{type = err150_good_in_expire,about = "物品还未过期"};

get(1500075) ->
    #errorcode_msg{type = err150_pk_value_0,about = "红名值值为0，不需要使用洗恶卡"};

get(1500076) ->
    #errorcode_msg{type = err150_not_compose_mat,about = "所选物品不属于合成材料"};

get(1500077) ->
    #errorcode_msg{type = err150_no_cell_to_compose,about = "背包已满，无法合成"};

get(1500078) ->
    #errorcode_msg{type = err150_no_money_to_compose,about = "货币不足，无法合成"};

get(1500079) ->
    #errorcode_msg{type = err150_not_satisfy_compose_lv,about = "角色等级不够，无法合成"};

get(1500080) ->
    #errorcode_msg{type = err150_compose_success,about = "合成成功"};

get(1500081) ->
    #errorcode_msg{type = err150_compose_fail,about = "合成失败"};

get(1500082) ->
    #errorcode_msg{type = err150_no_null_cell_decompose_fail,about = "背包空位不足，拆解失败"};

get(1500083) ->
    #errorcode_msg{type = err150_user_use_dsgt,about = "称号已经激活，返还{1}金币"};

get(1500084) ->
    #errorcode_msg{type = err150_renew_cf_miss,about = "物品续费配置缺失"};

get(1500085) ->
    #errorcode_msg{type = err150_bag_location_fail,about = "背包类型配置错误"};

get(1500086) ->
    #errorcode_msg{type = err150_compose_type_lock,about = "该合成方式未解锁"};

get(1500087) ->
    #errorcode_msg{type = err150_notin_drop_scene,about = "场景不同，不能拾取"};

get(1500088) ->
    #errorcode_msg{type = err150_not_drop_copyid,about = "房间不同，不能拾取"};

get(1500089) ->
    #errorcode_msg{type = err150_drop_no_hp,about = "您已经死亡，不能拾取"};

get(1500090) ->
    #errorcode_msg{type = err150_no_hurt_drop,about = "您没有对首领造成伤害，暂时不能拾取该掉落"};

get(1500091) ->
    #errorcode_msg{type = err150_drop_overlv,about = "您的等级超过首领等级100级，无法获得掉落"};

get(1500092) ->
    #errorcode_msg{type = err150_no_boss_tired,about = "您的首领疲劳值还未消耗，无须使用该物品"};

get(1500093) ->
    #errorcode_msg{type = err150_no_drop_boss_tired,about = "您的首领疲劳已满不能拾取掉落"};

get(1500094) ->
    #errorcode_msg{type = err150_gift_reward_miss,about = "礼包奖励内容不存在"};

get(1500095) ->
    #errorcode_msg{type = err150_lv_not_enough,about = "等级不足，玩法使用！"};

get(1500096) ->
    #errorcode_msg{type = err150_decompose_wear,about = "不能拆解已经穿戴的物品"};

get(1500097) ->
    #errorcode_msg{type = err150_currency_not_enough,about = "{1}数量不足"};

get(1500098) ->
    #errorcode_msg{type = err150_day_not_enough,about = "再登录{1}天可开启哦!{2}"};

get(1500099) ->
    #errorcode_msg{type = err150_soul_bag_full,about = "纹章背包已满"};

get(1500100) ->
    #errorcode_msg{type = err150_galaxy_no_cell,about = "星辰背包空间不足！"};

get(1500101) ->
    #errorcode_msg{type = err150_god_no_cell,about = "神座座印库空间不足！"};

get(1500102) ->
    #errorcode_msg{type = err150_baby_no_cell,about = "宝宝玩具背包空间不足！"};

get(1500104) ->
    #errorcode_msg{type = err150_card_ok_send,about = "奖励已发送至邮箱~"};

get(1500105) ->
    #errorcode_msg{type = err150_pet_stone_no_cell,about = "宠物技能宝石背包空间不足！"};

get(1500106) ->
    #errorcode_msg{type = err150_fjarvis_no_cell,about = "AI娘装备背包空间不足！"};

get(1500107) ->
    #errorcode_msg{type = err150_mount_no_cell,about = "座驾装备背包空间不足！"};

get(1500111) ->
    #errorcode_msg{type = err150_goods_not_timeout,about = "存在未过期的物品"};

get(1500112) ->
    #errorcode_msg{type = err150_warsoul_no_cell,about = "战魂背包空间不足！"};

get(1500113) ->
    #errorcode_msg{type = err150_compose_times,about = "合成次数不能为0"};

get(1500114) ->
    #errorcode_msg{type = err150_not_satisfy_compose_career,about = "职业限制，无法合成"};

get(1500115) ->
    #errorcode_msg{type = err150_god_rune_no_cell,about = "符文印记背包空间不足"};

get(1500116) ->
    #errorcode_msg{type = err150_no_use,about = "已超出该物品使用期限"};

get(1500117) ->
    #errorcode_msg{type = err150_gold_daily_limit,about = "今日彩钻产出已达上限"};

get(1500118) ->
    #errorcode_msg{type = err150_bgold_daily_limit,about = "今日红钻产出已达上限"};

get(1500119) ->
    #errorcode_msg{type = err150_honour_max,about = "今日名望券获得已达上限"};

get(1500120) ->
    #errorcode_msg{type = err150_devour_condition,about = "激活条件不足！"};

get(1500121) ->
    #errorcode_msg{type = err150_devour_max,about = "暂无可激活的属性！"};

get(1500122) ->
    #errorcode_msg{type = err150_goods_lv_limit,about = "{1}级以上使用"};

get(1500123) ->
    #errorcode_msg{type = err150_color_drop_limit,about = "橙装碎片拾取次数已达上限，无法拾取！"};

get(1500124) ->
    #errorcode_msg{type = err150_purple_drop_limit,about = "紫装拾取次数已达上限，无法拾取！"};

get(1500125) ->
    #errorcode_msg{type = err150_zhenbao_drop_limit,about = "珍宝皮肤碎片获得次数已达上限，无法拾取！"};

get(1510001) ->
    #errorcode_msg{type = err151_compose_stuff_error,about = "合成材料出错"};

get(1510002) ->
    #errorcode_msg{type = err151_cannot_compose,about = "不可合成"};

get(1510003) ->
    #errorcode_msg{type = err151_stuff_not_enough,about = "合成材料不足"};

get(1510004) ->
    #errorcode_msg{type = err151_max_sell_up_num,about = "已达到商品上架上限"};

get(1510005) ->
    #errorcode_msg{type = err151_goods_info_err,about = "商品信息有误，请重新打开界面"};

get(1510006) ->
    #errorcode_msg{type = err151_goods_not_exist,about = "该商品已下架"};

get(1510007) ->
    #errorcode_msg{type = err151_not_seller,about = "该商品不属于你"};

get(1510008) ->
    #errorcode_msg{type = err151_no_null_cells,about = "背包已满，请先清理背包"};

get(1510009) ->
    #errorcode_msg{type = err151_specify_role_lv_not_enough,about = "对方未达到交易等级"};

get(1510010) ->
    #errorcode_msg{type = err151_can_not_buy_self_goods,about = "不能购买自己出售的商品"};

get(1510011) ->
    #errorcode_msg{type = err151_not_specify_role,about = "您不是改商品的指定购买者"};

get(1510012) ->
    #errorcode_msg{type = err151_bind_cannot_sell,about = "该物品不能出售"};

get(1510013) ->
    #errorcode_msg{type = err151_not_enough_gold,about = "钻石不足"};

get(1510014) ->
    #errorcode_msg{type = err151_goods_sell_down,about = "商品已经下架，请重新刷新界面"};

get(1510016) ->
    #errorcode_msg{type = err151_unit_price_fail,about = "单价设置不在范围内"};

get(1510017) ->
    #errorcode_msg{type = err151_num_limit,about = "超过上架数量上限"};

get(1520001) ->
    #errorcode_msg{type = err152_not_exist,about = "装备不存在"};

get(1520002) ->
    #errorcode_msg{type = err152_lv_err,about = "未达到装备穿戴等级"};

get(1520003) ->
    #errorcode_msg{type = err152_series_err,about = "转生限制"};

get(1520004) ->
    #errorcode_msg{type = err152_type_err,about = "物品类型不符"};

get(1520014) ->
    #errorcode_msg{type = err152_stren_limit,about = "强化等级达到上限"};

get(1520017) ->
    #errorcode_msg{type = err152_missing_cfg,about = "缺失配置"};

get(1520019) ->
    #errorcode_msg{type = err152_equip_pos_err,about = "装备位置参数错误"};

get(1520020) ->
    #errorcode_msg{type = err152_cannot_be_guard,about = "守护无法进行强化"};

get(1520024) ->
    #errorcode_msg{type = err152_must_wear,about = "装备穿戴才能进行操作"};

get(1520025) ->
    #errorcode_msg{type = err152_pos_no_equip,about = "请先穿戴装备"};

get(1520026) ->
    #errorcode_msg{type = err152_career_error,about = "职业不合适,不能穿戴"};

get(1520029) ->
    #errorcode_msg{type = err152_equip_type_error,about = "未知装备类型"};

get(1520035) ->
    #errorcode_msg{type = err152_cannot_rise_star,about = "该装备类型无法进化"};

get(1520036) ->
    #errorcode_msg{type = err152_max_star,about = "进化已达上限"};

get(1520037) ->
    #errorcode_msg{type = err152_rise_star_stuff,about = "进化材料出错"};

get(1520038) ->
    #errorcode_msg{type = err152_must_same,about = "相同装备类型才能继承"};

get(1520039) ->
    #errorcode_msg{type = err152_inherit_type_err,about = "该装备无法继承"};

get(1520040) ->
    #errorcode_msg{type = err152_inherit_color,about = "只能继承给高品质装备"};

get(1520041) ->
    #errorcode_msg{type = err152_already_active,about = "已经激活了"};

get(1520042) ->
    #errorcode_msg{type = err152_not_active,about = "尚未激活"};

get(1520044) ->
    #errorcode_msg{type = err152_can_not_star_anymore,about = "该装备已无法进行进化"};

get(1520045) ->
    #errorcode_msg{type = err152_market_no_goods,about = "市场商品不足"};

get(1520046) ->
    #errorcode_msg{type = err152_err_condition,about = "条件不足"};

get(1520047) ->
    #errorcode_msg{type = err152_empower_max_lv,about = "已达最高等级"};

get(1520048) ->
    #errorcode_msg{type = err152_evolution_type_err,about = "该装备无法升品"};

get(1520049) ->
    #errorcode_msg{type = err152_no_inlay_gem,about = "请先镶嵌宝石"};

get(1520050) ->
    #errorcode_msg{type = err152_gem_max_lv,about = "宝石已达满级"};

get(1520051) ->
    #errorcode_msg{type = err152_collect_condition,about = "激活条件不足！"};

get(1520052) ->
    #errorcode_msg{type = err152_series_lock,about = "尚未解锁当前代数！"};

get(1520053) ->
    #errorcode_msg{type = err152_unlock_lv_limit,about = "解锁等级不足！"};

get(1520054) ->
    #errorcode_msg{type = err152_series_task,about = "完成支线任务解锁！"};

get(1520055) ->
    #errorcode_msg{type = err152_gem_suit_max,about = "暂无可激活的属性！"};

get(1520057) ->
    #errorcode_msg{type = err152_has_no_gems,about = "暂无可镶嵌的宝石！"};

get(1520059) ->
    #errorcode_msg{type = err152_cannot_empower,about = "该装备不可进行升级！"};

get(1520062) ->
    #errorcode_msg{type = err152_empower_conditon,about = "升级条件不足！"};

get(1520069) ->
    #errorcode_msg{type = err152_cannot_equip_lower_color,about = "不可更换低品质装备！"};

get(1520070) ->
    #errorcode_msg{type = err152_turn_error,about = "未达对应转生，不能穿戴"};

get(1520078) ->
    #errorcode_msg{type = err152_equip_skill_no_cost_upgrade,about = "材料不足，提升失败"};

get(1520079) ->
    #errorcode_msg{type = err152_no_choice,about = "请选择属性"};

get(1520081) ->
    #errorcode_msg{type = err152_choice_not_needed,about = "无需选择属性"};

get(1520082) ->
    #errorcode_msg{type = err152_vip_lv_error,about = "vip等级不足"};

get(1520083) ->
    #errorcode_msg{type = err152_not_equip_cannot_upgrade_stone,about = "没有装备可升级宝石"};

get(1520086) ->
    #errorcode_msg{type = err152_no_this_equip,about = "没有这件装备"};

get(1520087) ->
    #errorcode_msg{type = err152_no_this_goods,about = "没有这件物品"};

get(1520088) ->
    #errorcode_msg{type = err152_cost_num_error,about = "消耗数量错误"};

get(1520089) ->
    #errorcode_msg{type = err152_gold_not_enough,about = "钻石不足"};

get(1520090) ->
    #errorcode_msg{type = err152_goods_not_enough,about = "道具不足"};

get(1520091) ->
    #errorcode_msg{type = err152_no_attr_can_ensure,about = "可保留的属性列表为空"};

get(1520092) ->
    #errorcode_msg{type = err152_stage_max,about = "已是最高阶"};

get(1520093) ->
    #errorcode_msg{type = err152_build_goods_error,about = "打造装备材料类型错误"};

get(1520094) ->
    #errorcode_msg{type = err152_build_turn_error,about = "未达对应转生数，打造条件不符"};

get(1520095) ->
    #errorcode_msg{type = err152_refine_value_max,about = "您当前精炼值已满"};

get(1520096) ->
    #errorcode_msg{type = err152_vip_stone_limit,about = "该宝石只能镶嵌在vip孔哦~"};

get(1520097) ->
    #errorcode_msg{type = err152_max_prefix_error,about = "重铸次数已达上限"};

get(1520099) ->
    #errorcode_msg{type = err152_not_upgrade_star_pos,about = "该部位装备不能升星"};

get(1520100) ->
    #errorcode_msg{type = err152_not_equip_cannot_upgrade_star,about = "未穿戴装备，不能升星"};

get(1520101) ->
    #errorcode_msg{type = err152_not_upgrade_star_quality,about = "装备的品质、阶数不足，不能升星"};

get(1520102) ->
    #errorcode_msg{type = err152_wash_args_error,about = "洗炼参数错误"};

get(1530000) ->
    #errorcode_msg{type = err153_goods_not_on_sale,about = "商品不在架上"};

get(1530001) ->
    #errorcode_msg{type = err153_goods_sold_out,about = "该道具已售空，请耐心等待补货。"};

get(1530002) ->
    #errorcode_msg{type = err153_goods_not_equal,about = "数据错误"};

get(1530003) ->
    #errorcode_msg{type = err153_bag_not_enough,about = "您拥有的背包空间不足，请清理后再来。"};

get(1530004) ->
    #errorcode_msg{type = err153_give_goods_failure,about = "派送物品失败"};

get(1530005) ->
    #errorcode_msg{type = err153_not_enough_goods_to_buy,about = "购买数量超过上限"};

get(1530006) ->
    #errorcode_msg{type = err153_money_type_wrong,about = "不能用此金钱支付"};

get(1530007) ->
    #errorcode_msg{type = err153_send_error,about = "请求错误"};

get(1530008) ->
    #errorcode_msg{type = err153_not_enough_world_lv,about = "世界等级未到达购买要求！"};

get(1530009) ->
    #errorcode_msg{type = err153_not_enough_server_time,about = "开发天数未达到购买要求！"};

get(1530010) ->
    #errorcode_msg{type = err153_not_enough_lv,about = "您的等级未达到购买要求！"};

get(1530011) ->
    #errorcode_msg{type = err153_qb_not_right_money,about = "不能用这种货币购买"};

get(1530012) ->
    #errorcode_msg{type = err153_mount_bag_not_enough,about = "您的坐骑背包空间不足，请清理后再来。"};

get(1530013) ->
    #errorcode_msg{type = err153_error_career,about = "职业不匹配"};

get(1540001) ->
    #errorcode_msg{type = err154_error_pricetype,about = "非法竞价类型"};

get(1540002) ->
    #errorcode_msg{type = err154_missing_config,about = "缺失物品配置"};

get(1540003) ->
    #errorcode_msg{type = err154_goods_sellout,about = "物品已拍出"};

get(1540004) ->
    #errorcode_msg{type = err154_price_change,about = "竞价已发生变化"};

get(1540005) ->
    #errorcode_msg{type = err154_error_price,about = "价格参数错误"};

get(1540006) ->
    #errorcode_msg{type = err154_goods_closed,about = "该物品已结束拍卖~"};

get(1540007) ->
    #errorcode_msg{type = err154_player_top_price,about = "你当前已是最高竞价者"};

get(1540008) ->
    #errorcode_msg{type = err154_error_guild_id,about = "不是你所在社团物品"};

get(1540009) ->
    #errorcode_msg{type = err154_auction_not_start,about = "拍卖未开启，请稍加等待"};

get(1540010) ->
    #errorcode_msg{type = err154_only_pay_by_gold,about = "本商品只能使用钻石参与拍卖"};

get(1550001) ->
    #errorcode_msg{type = err155_market_guild_cannot_bid,about = "该商品只能一口价交易"};

get(1550002) ->
    #errorcode_msg{type = err155_stren_stage_limit,about = "强化等级超过当前装备强化上限"};

get(1550003) ->
    #errorcode_msg{type = err155_stren_no_equip,about = "需要穿戴圣印才能强化"};

get(1550004) ->
    #errorcode_msg{type = err150_soul_count_limit,about = "当前使用次数已达上限"};

get(1550005) ->
    #errorcode_msg{type = err155_pos_not_open,about = "装备孔还未开放"};

get(1550006) ->
    #errorcode_msg{type = err155_expire_time,about = "物品已过有效期"};

get(1550007) ->
    #errorcode_msg{type = err155_cannot_trade,about = "本物品不可交易"};

get(1550008) ->
    #errorcode_msg{type = err155_bind_cannot_sell,about = "该物品不可交易"};

get(1550009) ->
    #errorcode_msg{type = err155_not_sell_category,about = "本物品不可交易"};

get(1550010) ->
    #errorcode_msg{type = err155_shelves_are_full,about = "货架数量不足"};

get(1550011) ->
    #errorcode_msg{type = err155_market_goods_not_exist,about = "物品不在出售中"};

get(1550012) ->
    #errorcode_msg{type = err155_market_goods_off,about = "物品竞拍已结束"};

get(1550013) ->
    #errorcode_msg{type = err155_market_goods_is_showing,about = "物品还在公示中"};

get(1550014) ->
    #errorcode_msg{type = err155_market_goods_yourself,about = "不能竞拍/购买自己上架的物品"};

get(1550015) ->
    #errorcode_msg{type = err155_market_goods_not_yours,about = "不是你上架的物品，不可操作"};

get(1550016) ->
    #errorcode_msg{type = err155_market_goods_is_offer,about = "已有人出价，不可下架"};

get(1550017) ->
    #errorcode_msg{type = err155_market_goods_not_off,about = "还没下架"};

get(1550018) ->
    #errorcode_msg{type = err155_market_goods_price_error,about = "价格不对"};

get(1550019) ->
    #errorcode_msg{type = err155_market_goods_your_price_max,about = "你已是最高竞价者"};

get(1550020) ->
    #errorcode_msg{type = err155_already_like,about = "已关注"};

get(1550021) ->
    #errorcode_msg{type = err155_like_num_max,about = "关注数量已达上限"};

get(1550022) ->
    #errorcode_msg{type = err155_cannot_like_yourself,about = "不能关注自己上架的物品"};

get(1550023) ->
    #errorcode_msg{type = err155_goods_not_exist,about = "物品不存在"};

get(1550024) ->
    #errorcode_msg{type = err155_no_guild_for_guild_sell_type,about = "还没加入公会，不能公会上架"};

get(1550025) ->
    #errorcode_msg{type = err155_cannot_sell_to_world,about = "此物品不能世界上架"};

get(1550026) ->
    #errorcode_msg{type = err155_cannot_sell_to_guild,about = "此物品不能公会上架"};

get(1550027) ->
    #errorcode_msg{type = err155_market_goods_not_your_guild,about = "不在同一个公会不可以购买"};

get(1550028) ->
    #errorcode_msg{type = err155_reminder_limit,about = "添加入库提醒已达上限"};

get(1550029) ->
    #errorcode_msg{type = err155_no_goods_put,about = "暂无可以上架的商品"};

get(1570001) ->
    #errorcode_msg{type = err157_1_live_not_enough,about = "活跃度不够"};

get(1570002) ->
    #errorcode_msg{type = err157_2_live_aready_get,about = "不能重复领取"};

get(1570003) ->
    #errorcode_msg{type = err157_3_bag_not_enough,about = "背包不足"};

get(1570004) ->
    #errorcode_msg{type = err157_4_lv_not_enough,about = "等级不足，无法打开活动日历"};

get(1570005) ->
    #errorcode_msg{type = err157_5_cfg_err,about = "配置错误"};

get(1570006) ->
    #errorcode_msg{type = err157_6_live_not_enough,about = "活跃度不够"};

get(1570007) ->
    #errorcode_msg{type = err157_7_max_lv,about = "活跃度等级已达最高"};

get(1570008) ->
    #errorcode_msg{type = err157_8_live_lv_limit,about = "活跃度等级不够"};

get(1570009) ->
    #errorcode_msg{type = err157_9_open_day_limit,about = "开服天数不足"};

get(1570010) ->
    #errorcode_msg{type = err157_act_not_open,about = "活动未开启"};

get(1570011) ->
    #errorcode_msg{type = err157_figure_already,about = "已幻化当前形象"};

get(1570012) ->
    #errorcode_msg{type = err157_power_live_limit,about = "活力已达上限"};

get(1570013) ->
    #errorcode_msg{type = err157_reserved,about = "活动已预约"};

get(1570014) ->
    #errorcode_msg{type = err157_have_joined,about = "已参与活动无需预约"};

get(1570015) ->
    #errorcode_msg{type = err157_have_rewards,about = "已领取奖励，无法预约"};

get(1570016) ->
    #errorcode_msg{type = err157_not_reserve,about = "活动无预约，无法领取"};

get(1570017) ->
    #errorcode_msg{type = err157_not_joined,about = "没有参与活动，无法领取"};

get(1570018) ->
    #errorcode_msg{type = err157_act_opening,about = "不是当天未开启的活动，无法预约"};

get(1580001) ->
    #errorcode_msg{type = err158_time_error,about = "该充值商品暂未开启"};

get(1580002) ->
    #errorcode_msg{type = err158_condition_error,about = "您不符合该充值商品使用条件"};

get(1580003) ->
    #errorcode_msg{type = err158_product_error,about = "该充值商品缺失基础配置"};

get(1580004) ->
    #errorcode_msg{type = err158_product_ctrl_error,about = "该充值商品缺失控制信息配置"};

get(1580005) ->
    #errorcode_msg{type = err158_recharge_return_error,about = "该充值商品缺失返利配置"};

get(1580006) ->
    #errorcode_msg{type = err158_product_type_error,about = "未知充值商品类型"};

get(1580007) ->
    #errorcode_msg{type = err158_already_buy,about = "已购买该充值商品"};

get(1580008) ->
    #errorcode_msg{type = err158_not_open,about = "该充值商品暂未开放，敬请期待！"};

get(1580009) ->
    #errorcode_msg{type = err158_not_enough_lv,about = "等级未到达购买要求！"};

get(1580010) ->
    #errorcode_msg{type = err158_not_enough_times,about = "购买次数不足"};

get(1580011) ->
    #errorcode_msg{type = err158_not_enough_vip,about = "VIP等级不足"};

get(1590001) ->
    #errorcode_msg{type = err159_daily_type_err,about = "每日礼包类型错误!"};

get(1590002) ->
    #errorcode_msg{type = err159_daily_purchased,about = "今天礼包已经被购买~"};

get(1590003) ->
    #errorcode_msg{type = err159_daily_cfg_err,about = "礼包配置错误~"};

get(1590004) ->
    #errorcode_msg{type = err159_daily_not_purchase,about = "礼包未购买,领取失败~"};

get(1590005) ->
    #errorcode_msg{type = err159_daily_is_get,about = "礼包已经领取,无法再次领取~"};

get(1590006) ->
    #errorcode_msg{type = err159_1_not_welfare,about = "非福利卡"};

get(1590007) ->
    #errorcode_msg{type = err159_2_welfare_timeout,about = "福利卡已过期"};

get(1590008) ->
    #errorcode_msg{type = err159_3_not_buy,about = "未购买相关产品"};

get(1590009) ->
    #errorcode_msg{type = err159_4_already_get,about = "已领取"};

get(1590010) ->
    #errorcode_msg{type = err159_5_bag_not_enough,about = "背包已满"};

get(1590013) ->
    #errorcode_msg{type = err159_not_the_time,about = "领取时间未到"};

get(1590014) ->
    #errorcode_msg{type = err159_first_recharge_product_not_open,about = "首充商品未开放"};

get(1590015) ->
    #errorcode_msg{type = err159_first_recharge_error_index,about = "首充奖励参数错误"};

get(1600001) ->
    #errorcode_msg{type = err160_sign_in_over,about = "签到奖励已全部领取"};

get(1600002) ->
    #errorcode_msg{type = err160_sign_in_vip,about = "VIP等级不足"};

get(1600003) ->
    #errorcode_msg{type = err160_repeat_get,about = "奖励已经领取"};

get(1600004) ->
    #errorcode_msg{type = err160_level_low,about = "尚未达到领奖等级"};

get(1600005) ->
    #errorcode_msg{type = err160_online_time_less,about = "在线时长不足"};

get(1600006) ->
    #errorcode_msg{type = err160_condition_error,about = "条件不足"};

get(1620001) ->
    #errorcode_msg{type = err162_figure_unactive,about = "形象未激活"};

get(1620002) ->
    #errorcode_msg{type = err162_up_ride,about = "已佩戴"};

get(1620003) ->
    #errorcode_msg{type = err162_not_up_ride,about = "已卸下"};

get(1620004) ->
    #errorcode_msg{type = err162_already_active,about = "形象已激活"};

get(1630001) ->
    #errorcode_msg{type = err163_already_adopt,about = "宠物已经领养过啦"};

get(1630002) ->
    #errorcode_msg{type = err163_debris_not_enough,about = "材料不足"};

get(1630003) ->
    #errorcode_msg{type = err163_is_max_lv,about = "宠物已达到最高等级"};

get(1630004) ->
    #errorcode_msg{type = err163_pet_max_stage,about = "宠物已达到最高品质"};

get(1630005) ->
    #errorcode_msg{type = err163_not_adopt,about = "还未领养本宠物喔~"};

get(1630006) ->
    #errorcode_msg{type = err163_no_diamond,about = "没有该宝石"};

get(1630007) ->
    #errorcode_msg{type = err163_not_diamond_slot,about = "没有该宝石槽位"};

get(1630008) ->
    #errorcode_msg{type = err163_diamond_has_inlay,about = "该技能石已经镶嵌"};

get(1630009) ->
    #errorcode_msg{type = err163_slot_not_active,about = "支援槽位未开启"};

get(1630010) ->
    #errorcode_msg{type = err163_slot_type_cannot_same,about = "相同支援类型的宠物间不能相互替换哟~"};

get(1630011) ->
    #errorcode_msg{type = err163_slot_type_not_satisfy,about = "该槽位与支援类型没对应上喔"};

get(1630012) ->
    #errorcode_msg{type = err163_slot_type_not_exit,about = "不存在该支援类型"};

get(1630013) ->
    #errorcode_msg{type = err163_pet_cannot_support_again,about = "同一只宠物不能重复支援喔~"};

get(1630014) ->
    #errorcode_msg{type = err163_not_pet,about = "没有该宠物哟~"};

get(1630015) ->
    #errorcode_msg{type = err163_not_grow_up_matrial,about = "不是对应的升级材料"};

get(1630016) ->
    #errorcode_msg{type = err163_not_pet_race,about = "技能石不是对应的种族喔"};

get(1630017) ->
    #errorcode_msg{type = err163_pet_cfg_err,about = "宠物配置错误"};

get(1630018) ->
    #errorcode_msg{type = err163_same_diamond_type,about = "不能镶嵌同类型的技能石喔~"};

get(1630019) ->
    #errorcode_msg{type = err163_role_not_adopt_pet,about = "TA的宠物信息不存在哟"};

get(1630020) ->
    #errorcode_msg{type = err163_first_role_not_receive,about = "您的奖励已经通过邮件发放啦"};

get(1630021) ->
    #errorcode_msg{type = err163_not_reward,about = "该宠物没有奖励可以领取哟"};

get(1630022) ->
    #errorcode_msg{type = err163_vote_times_not_enough,about = "今天投票次数已经用完咯"};

get(1630023) ->
    #errorcode_msg{type = err163_has_vote,about = "你已经为本宠投过票啦"};

get(1630024) ->
    #errorcode_msg{type = err163_star_not_reach,about = "还未达到觉醒星级哟"};

get(1630025) ->
    #errorcode_msg{type = err163_cannot_awaken,about = "本宠无法进行觉醒喔"};

get(1630026) ->
    #errorcode_msg{type = err163_not_need_support_again,about = "不需要重复上阵啦"};

get(1630027) ->
    #errorcode_msg{type = err163_compound_diamond_not_enough,about = "合成材料不足哦"};

get(1630028) ->
    #errorcode_msg{type = err163_compound_cfg_err,about = "合成配置错误"};

get(1650001) ->
    #errorcode_msg{type = err165_child_not_adopt,about = "您还没有领养宝宝喔~"};

get(1650002) ->
    #errorcode_msg{type = err165_child_has_adopt,about = "您已经领养过宝宝啦~"};

get(1650003) ->
    #errorcode_msg{type = err165_child_name_exits,about = "您起的宝宝名字已经存在了喔~"};

get(1650004) ->
    #errorcode_msg{type = err165_child_open_lv_not_reach,about = "还没有达到同心度呐"};

get(1650005) ->
    #errorcode_msg{type = err165_child_max_age,about = "您的宝宝已经最大等级了"};

get(1650006) ->
    #errorcode_msg{type = err165_not_child_grow_up_material,about = "不是宝宝成长材料喔"};

get(1650007) ->
    #errorcode_msg{type = err165_child_good_num_err,about = "成长材料不够喔"};

get(1650008) ->
    #errorcode_msg{type = err165_not_upgrade_link_heart_material,about = "不是同心培养材料哟"};

get(1650009) ->
    #errorcode_msg{type = err165_upgrade_link_heart_material_not_enough,about = "同心材料不够喔"};

get(1650010) ->
    #errorcode_msg{type = err165_child_same_name,about = "新的名字与旧名字相同喔~"};

get(1650011) ->
    #errorcode_msg{type = err165_child_upgrade_link_heart_type_err,about = "同心度培养类型错误"};

get(1650012) ->
    #errorcode_msg{type = err165_child_vote_times_not_enough,about = "今天的点赞次数用完了啦"};

get(1650013) ->
    #errorcode_msg{type = err165_has_vote_for_this_child,about = "今天给TA点赞的次数已经用完了哦~"};

get(1650014) ->
    #errorcode_msg{type = err165_child_has_not_trigger_task,about = "还没有触发该任务"};

get(1650015) ->
    #errorcode_msg{type = err165_child_task_unfinish,about = "任务未完成"};

get(1650016) ->
    #errorcode_msg{type = err165_child_task_reward_has_received,about = "已经领取过任务奖励啦"};

get(1650017) ->
    #errorcode_msg{type = err165_cannot_vote_my_child,about = "不能点赞自己的宝宝喔"};

get(1650018) ->
    #errorcode_msg{type = err165_show_off_times_not_enough,about = "今天的晒娃次数用完了啦"};

get(1650019) ->
    #errorcode_msg{type = err165_child_sex_err,about = "宝宝的性别错误"};

get(1650020) ->
    #errorcode_msg{type = err165_max_link_heart_level,about = "同心等级已经达到最大啦~"};

get(1650021) ->
    #errorcode_msg{type = err165_in_show_off_time_cd,about = "晒娃太频繁啦~"};

get(1650022) ->
    #errorcode_msg{type = err165_opp_not_adopt_child,about = "对方还未领取宝宝，点赞失效喔"};

get(1650023) ->
    #errorcode_msg{type = err165_child_role_lv_not_reach,about = "还没达到点赞的等级喔"};

get(1650024) ->
    #errorcode_msg{type = err165_exits_word_sensitive,about = "存在敏感词汇"};

get(1650025) ->
    #errorcode_msg{type = err165_is_not_child_skill,about = "不是宝宝技能喔"};

get(1650026) ->
    #errorcode_msg{type = err165_child_not_reach_skill_open_lv,about = "未达到技能激活等级喔"};

get(1650027) ->
    #errorcode_msg{type = err165_pre_skill_not_active,about = "要先激活前一顺位技能喔"};

get(1650028) ->
    #errorcode_msg{type = err165_power_not_enough,about = "未达到激活的战力喔"};

get(1650029) ->
    #errorcode_msg{type = err165_skill_material_not_enough,about = "材料不够啦"};

get(1650030) ->
    #errorcode_msg{type = err165_not_active_child_skill,about = "还没有激活技能呢"};

get(1650031) ->
    #errorcode_msg{type = err165_child_skill_max_lv,about = "已经达到满级啦"};

get(1650032) ->
    #errorcode_msg{type = err165_not_child_vehicle,about = "不是宝宝载具喔"};

get(1650033) ->
    #errorcode_msg{type = err165_has_active_child_vehicle,about = "宝宝载具已经激活啦"};

get(1650034) ->
    #errorcode_msg{type = err165_vehicle_material_not_enough,about = "载具材料不足喔"};

get(1650035) ->
    #errorcode_msg{type = err165_child_vehicle_max_stage,about = "宝宝载具已经达到最大阶啦"};

get(1650036) ->
    #errorcode_msg{type = err165_child_vehicle_not_active,about = "载具还没激活喔"};

get(1650037) ->
    #errorcode_msg{type = err165_child_skill_has_active,about = "技能已经激活啦"};

get(1650038) ->
    #errorcode_msg{type = err165_toy_aim_lv_err,about = "选择的等级不能小于当前等级喔"};

get(1650039) ->
    #errorcode_msg{type = err165_toy_aim_lv_max,about = "选择的等级超过最大等级啦"};

get(1650040) ->
    #errorcode_msg{type = err165_toy_max_lv,about = "玩具已经升到最高等级啦"};

get(1650041) ->
    #errorcode_msg{type = err165_has_not_toy,about = "您还没拥有该玩具喔"};

get(1650042) ->
    #errorcode_msg{type = err165_toy_slot_not_open,about = "玩具位还没开启哟"};

get(1650043) ->
    #errorcode_msg{type = err165_can_not_carry_toy,about = "选择的玩具超重啦"};

get(1650044) ->
    #errorcode_msg{type = err165_slot_not_good,about = "槽位上已经没有玩具啦"};

get(1650045) ->
    #errorcode_msg{type = err165_forge_material_not_enough,about = "合成材料不够六个喔"};

get(1650046) ->
    #errorcode_msg{type = err165_not_same_color,about = "合成材料需要同品质哟"};

get(1650047) ->
    #errorcode_msg{type = err165_toy_has_inlay,about = "槽位中的玩具，不能作合成材料喔"};

get(1650048) ->
    #errorcode_msg{type = err165_toy_config_err,about = "玩具配置错误"};

get(1650049) ->
    #errorcode_msg{type = err165_toy_is_on_slot,about = "槽位中的玩具，不能分解喔"};

get(1650050) ->
    #errorcode_msg{type = err165_forge_slot_not_open,about = "打造槽位还没开启哟"};

get(1650051) ->
    #errorcode_msg{type = err165_forge_slot_is_using,about = "打造位正在使用啦"};

get(1650052) ->
    #errorcode_msg{type = err165_forge_has_not_finish,about = "打造还没完成喔"};

get(1650053) ->
    #errorcode_msg{type = err165_forge_has_finish,about = "打造已经完成，不需要加速啦"};

get(1650054) ->
    #errorcode_msg{type = err165_money_not_enough,about = "加速费用不足喔"};

get(1650055) ->
    #errorcode_msg{type = err165_toy_speed_up_cfg,about = "打造加速配置错误"};

get(1650056) ->
    #errorcode_msg{type = err165_not_toy,about = "不是玩具喔"};

get(1650057) ->
    #errorcode_msg{type = err165_has_not_fashion,about = "宝宝还没拥有这件时装哟"};

get(1650058) ->
    #errorcode_msg{type = err165_has_dress_up,about = "宝宝已经穿上这件时装啦"};

get(1650059) ->
    #errorcode_msg{type = err165_fashion_has_active,about = "时装已经激活过啦"};

get(1650060) ->
    #errorcode_msg{type = err165_not_fashion,about = "不是宝宝时装喔"};

get(1650061) ->
    #errorcode_msg{type = err165_fashion_max_lv,about = "时装已经达到最大等级啦"};

get(1650062) ->
    #errorcode_msg{type = err165_toy_max_color,about = "玩具已经是最大品质，无法合成啦"};

get(1650063) ->
    #errorcode_msg{type = err165_select_id_err,about = "打造库Id错误"};

get(1650064) ->
    #errorcode_msg{type = err165_dress_type_err,about = "时装类型错误"};

get(1650065) ->
    #errorcode_msg{type = err165_slot_has_open,about = "槽位已经开启了哟"};

get(1650066) ->
    #errorcode_msg{type = err165_slot_auto_open,about = "槽位达到条件就会激活啦"};

get(1650067) ->
    #errorcode_msg{type = err165_not_slot,about = "不是槽位喔"};

get(1650068) ->
    #errorcode_msg{type = err165_forge_has_not_start,about = "打造还没开始喔"};

get(1650069) ->
    #errorcode_msg{type = err165_toy_has_not_stren,about = "玩具没有强化过哟"};

get(1650070) ->
    #errorcode_msg{type = err165_child_not_suit_type,about = "不是玩具套装类型喔~"};

get(1650071) ->
    #errorcode_msg{type = err165_child_not_active_toy,about = "玩具套装还没激活噢"};

get(1650072) ->
    #errorcode_msg{type = err165_child_progress_not_reach,about = "套装还没有集齐喔"};

get(1650073) ->
    #errorcode_msg{type = err165_child_suit_has_receive,about = "已经领取过套装奖励啦"};

get(1650074) ->
    #errorcode_msg{type = err165_child_toy_has_active,about = "已经拥有这个玩具啦"};

get(1650075) ->
    #errorcode_msg{type = err165_toy_material_not_enough,about = "道具不足，继续努力哟"};

get(1650076) ->
    #errorcode_msg{type = err165_toy_box_upgrade_cfg_err,about = "玩具盒升级配置错误"};

get(1650077) ->
    #errorcode_msg{type = err_165_toy_suit_cfg_err,about = "套装配置错误"};

get(1650078) ->
    #errorcode_msg{type = err165_toy_suit_type_err,about = "玩具套装类型错误"};

get(1650079) ->
    #errorcode_msg{type = err165_toy_cfg_err,about = "没有这个玩具喔"};

get(1650080) ->
    #errorcode_msg{type = err165_has_toy_not_active,about = "您有玩具未激活，不可以分解喔"};

get(1650081) ->
    #errorcode_msg{type = err165_toy_box_max_lv,about = "玩具盒已经达到最大等级啦"};

get(1650082) ->
    #errorcode_msg{type = err165_skill_err,about = "技能配置错误"};

get(1650083) ->
    #errorcode_msg{type = err165_child_heart_link_reward_received,about = "奖励已经领取过啦"};

get(1650084) ->
    #errorcode_msg{type = err165_child_heart_link_exp_not_enough,about = "当前还不能领取喔"};

get(1650085) ->
    #errorcode_msg{type = err165_max_link_heart_exp,about = "同心值已达到最大值啦"};

get(1650086) ->
    #errorcode_msg{type = err165_link_heart_cfg_err,about = "同心配置错误"};

get(1650087) ->
    #errorcode_msg{type = err165_link_heart_not_finish,about = "还未达到领养宝宝同心值哟"};

get(1650088) ->
    #errorcode_msg{type = err165_has_not_dress_up,about = "还没穿上这件时装，不需要脱下哟"};

get(1650089) ->
    #errorcode_msg{type = err165_child_toy_debris_not_enough,about = "玩家精华不足"};

get(1650090) ->
    #errorcode_msg{type = err165_child_not_reach_fashion_open_lv,about = "还没达到时装开启阶段哟"};

get(1650091) ->
    #errorcode_msg{type = err165_not_receive_open_day,about = "开服天数不满足"};

get(1650092) ->
    #errorcode_msg{type = err165_not_receive_all_reward,about = "还有奖励未领取完哟"};

get(1650093) ->
    #errorcode_msg{type = err165_child_reward_not_receive_pre,about = "请先领取前一个奖励哟"};

get(1650094) ->
    #errorcode_msg{type = err165_has_receive_all_reward,about = "所有奖励已经领取完了哟"};

get(1650095) ->
    #errorcode_msg{type = err165_follow_month_not_enough,about = "未达到跟随等级喔"};

get(1650096) ->
    #errorcode_msg{type = err165_has_not_show_off,about = "您还未晒娃，不能领取喔"};

get(1650097) ->
    #errorcode_msg{type = err165_has_received_reward,about = "奖励已经领取过了"};

get(1650098) ->
    #errorcode_msg{type = err165_reward_cfg_err,about = "奖励配置错误"};

get(1650099) ->
    #errorcode_msg{type = err165_rank_has_not_reward,about = "当前排名无奖励可领取"};

get(1660001) ->
    #errorcode_msg{type = err166_max_degree,about = "你已经晋升到最高学位啦！"};

get(1660002) ->
    #errorcode_msg{type = err166_exp_no_enough,about = "经验不足继续加油喔~"};

get(1660003) ->
    #errorcode_msg{type = err166_dun_unfinish,about = "副本目标未完成"};

get(1660004) ->
    #errorcode_msg{type = err166_matrial_no_enough,about = "收集材料不足"};

get(1660005) ->
    #errorcode_msg{type = err166_classwork_no_exit,about = "不存在这门功课喔"};

get(1660006) ->
    #errorcode_msg{type = err166_classwork_unfinish,about = "功课还没完成继续加油喔~"};

get(1660007) ->
    #errorcode_msg{type = err166_reward_received,about = "奖励已经领取过了"};

get(1660008) ->
    #errorcode_msg{type = err166_classwork_finished,about = "功课已经完成啦！"};

get(1660009) ->
    #errorcode_msg{type = err166_classwork_no_get,about = "你今天还没有领取这门功课喔"};

get(1700001) ->
    #errorcode_msg{type = err170_pool_type_err,about = "抽奖池类型错误"};

get(1700002) ->
    #errorcode_msg{type = err170_draw_times_cfg_err,about = "抽奖次数配置错误"};

get(1700003) ->
    #errorcode_msg{type = err170_not_capsule_egg_data,about = "您没有参与到相关抽奖哟"};

get(1700004) ->
    #errorcode_msg{type = err170_exchange_count_not_enough,about = "兑换次数不够啦"};

get(1700005) ->
    #errorcode_msg{type = err170_exchange_pos_err,about = "选取的兑换商品错误哟"};

get(1700006) ->
    #errorcode_msg{type = err170_score_not_enough,about = "积分不够了喔"};

get(1700007) ->
    #errorcode_msg{type = err170_warehose_not_enough,about = "仓库空间不足，请先提取"};

get(1700008) ->
    #errorcode_msg{type = err170_config_err,about = "宝库抽奖券配置错误"};

get(1700009) ->
    #errorcode_msg{type = err170_lv_not_enough,about = "您还没到开放等级喔"};

get(1700010) ->
    #errorcode_msg{type = err170_pre_task_not_finish,about = "前置任务未完成哟"};

get(1700011) ->
    #errorcode_msg{type = err170_open_day_err,about = "本活动还没开放哟"};

get(1700012) ->
    #errorcode_msg{type = err170_times_err,about = "次数参数错误"};

get(1700013) ->
    #errorcode_msg{type = err170_times_has_received,about = "已经领取过次数奖励啦"};

get(1700014) ->
    #errorcode_msg{type = err170_times_cannot_receive,about = "还未达成领取条件哟"};

get(1730001) ->
    #errorcode_msg{type = err173_have_active_god,about = "您已经激活了该式神！"};

get(1730002) ->
    #errorcode_msg{type = err173_have_not_active,about = "您还没有激活该式神哦！"};

get(1730003) ->
    #errorcode_msg{type = err173_god_star_max,about = "式神已达最高星级！"};

get(1730004) ->
    #errorcode_msg{type = err173_god_lv_not_satisfy,about = "式神等级不足！"};

get(1730005) ->
    #errorcode_msg{type = err173_god_lv_max,about = "式神已达最高等级！"};

get(1730006) ->
    #errorcode_msg{type = err173_god_skill_not_exist,about = "唤神技能不存在"};

get(1730007) ->
    #errorcode_msg{type = err173_god_skill_lv_max,about = "该唤神技能已达最高等级"};

get(1730008) ->
    #errorcode_msg{type = err173_god_equip_pos_error,about = "唤神装备位置参数错误"};

get(1730009) ->
    #errorcode_msg{type = err173_god_equip_lv_max,about = "装备已达满级！"};

get(1730010) ->
    #errorcode_msg{type = err173_god_pos_repeat,about = "重复操作，请稍后！"};

get(1730011) ->
    #errorcode_msg{type = err173_god_unlock_con_error,about = "解锁条件不足！"};

get(1730012) ->
    #errorcode_msg{type = err173_god_pos_not_unlock,about = "位置尚未解锁！"};

get(1730013) ->
    #errorcode_msg{type = err173_need_off_help_god,about = "请先下阵援护式神！"};

get(1730014) ->
    #errorcode_msg{type = err173_without_con_to_summon,about = "当前状态无法召唤！"};

get(1730015) ->
    #errorcode_msg{type = err173_no_on_pos_god,about = "没有上阵的式神！"};

get(1730016) ->
    #errorcode_msg{type = err173_not_enough_times,about = "次数不足，无法领取"};

get(1730017) ->
    #errorcode_msg{type = err173_have_receive,about = "奖励已经领取过"};

get(1730018) ->
    #errorcode_msg{type = err173_error_config,about = "配置错误"};

get(1730019) ->
    #errorcode_msg{type = err173_summon_cd,about = "唤神召唤冷却中"};

get(1730020) ->
    #errorcode_msg{type = err173_god_summon,about = "请勿重复召唤唤神"};

get(1730021) ->
    #errorcode_msg{type = err173_god_have_not_in_pos,about = "唤神未上阵，无法操作"};

get(1750001) ->
    #errorcode_msg{type = err175_login_reward_closed,about = "七天登录活动已关闭"};

get(1750002) ->
    #errorcode_msg{type = err175_today_already_get,about = "今日已经领取"};

get(1750003) ->
    #errorcode_msg{type = err175_not_enough_days,about = "登录天数不足"};

get(1750004) ->
    #errorcode_msg{type = err175_the_day_have_rewarded,about = "该天数已领取，请勿重复操作"};

get(1760001) ->
    #errorcode_msg{type = err176_act_end,about = "活动已经结束"};

get(1760002) ->
    #errorcode_msg{type = err176_today_task_no_finish,about = "完成本日所有目标可领取！"};

get(1770001) ->
    #errorcode_msg{type = err177_short_of_energy_value,about = "活力值不足"};

get(1770002) ->
    #errorcode_msg{type = err177_short_of_fishing_rod,about = "选择的鱼竿数量不足"};

get(1770003) ->
    #errorcode_msg{type = err177_short_of_bait,about = "选择的鱼饵数量不足"};

get(1770004) ->
    #errorcode_msg{type = err177_please_select_fishing_gear,about = "请选择渔具"};

get(1770005) ->
    #errorcode_msg{type = err177_no_in_fishing_scene,about = "不在钓鱼区内"};

get(1770006) ->
    #errorcode_msg{type = err177_data_no_exist,about = "配置数据不存在"};

get(1770007) ->
    #errorcode_msg{type = err177_args_type_error,about = "参数类型错误"};

get(1770008) ->
    #errorcode_msg{type = err177_fish_do_not_bite,about = "鱼儿没有上钩"};

get(1770009) ->
    #errorcode_msg{type = err_177_no_select_tool,about = "没有选择渔具"};

get(1770010) ->
    #errorcode_msg{type = err_177_scene_change_failure,about = "场景切换失败"};

get(1770011) ->
    #errorcode_msg{type = err177_lv_not_reach_the_open_level,about = "等级未达到开放等级"};

get(1770012) ->
    #errorcode_msg{type = err177_fishing_lv_not_reach_the_open_level,about = "钓鱼等级未达到开放等级"};

get(1770013) ->
    #errorcode_msg{type = err177_rod_data_no_exist,about = "鱼竿配置不存在"};

get(1770014) ->
    #errorcode_msg{type = err177_bait_data_no_exist,about = "鱼饵配置不存在"};

get(1770015) ->
    #errorcode_msg{type = err_177_buy_num_error,about = "购买数量错误"};

get(1770016) ->
    #errorcode_msg{type = err177_fishing_gear_can_not_storage,about = "渔具类道具不能存入仓库"};

get(1770017) ->
    #errorcode_msg{type = err177_fishing_cant_change_scene,about = "钓鱼模式中不能切换场景"};

get(1790002) ->
    #errorcode_msg{type = err179_baby_max_stage,about = "已达升阶上限"};

get(1790003) ->
    #errorcode_msg{type = err179_wrong_goods_type,about = "不正确的物品类型"};

get(1790008) ->
    #errorcode_msg{type = err179_already_figure,about = "已幻化"};

get(1810001) ->
    #errorcode_msg{type = err181_award_received,about = "已领取奖励"};

get(1810002) ->
    #errorcode_msg{type = err181_condition_not_met,about = "未达到领取条件"};

get(1810003) ->
    #errorcode_msg{type = err181_args_type_error,about = "参数类型错误"};

get(1810004) ->
    #errorcode_msg{type = err181_not_inlay_pos,about = "不可镶嵌在该位置"};

get(1810005) ->
    #errorcode_msg{type = err181_pos_lock,about = "未解锁"};

get(1810006) ->
    #errorcode_msg{type = err181_pos_has_been_inlay,about = "已镶嵌"};

get(1820000) ->
    #errorcode_msg{type = err182_condition_not_met,about = "未达到领取条件"};

get(1820001) ->
    #errorcode_msg{type = err182_reward_has_received,about = "奖励已经领取过啦"};

get(1900001) ->
    #errorcode_msg{type = err190_no_mail,about = "没有邮件"};

get(1900002) ->
    #errorcode_msg{type = err190_read_mail_content_fail,about = "读取邮件失败"};

get(1900003) ->
    #errorcode_msg{type = err190_no_mail_attachment,about = "没有邮件附件"};

get(1900004) ->
    #errorcode_msg{type = err190_no_mail_to_delete,about = "没有邮件可以删除"};

get(1900005) ->
    #errorcode_msg{type = err190_have_attachment_not_to_delete,about = "无法删除带附件的邮件"};

get(1900006) ->
    #errorcode_msg{type = err190_bag_full,about = "背包已满,无法领取剩余附件"};

get(1900007) ->
    #errorcode_msg{type = err190_mail_timeout_to_delete,about = "邮件已经失效，无法删除"};

get(1900008) ->
    #errorcode_msg{type = err190_mail_timeout_to_extract_attachment,about = "邮件已经失效，无法领取"};

get(1900009) ->
    #errorcode_msg{type = err190_mail_title_len,about = "邮件标题过长"};

get(1900010) ->
    #errorcode_msg{type = err190_mail_title_sensitive,about = "邮件标题含有敏感字"};

get(1900011) ->
    #errorcode_msg{type = err190_mail_content_len,about = "邮件内容过长"};

get(1900012) ->
    #errorcode_msg{type = err190_mail_content_sensitive,about = "邮件内容含有敏感字"};

get(1900013) ->
    #errorcode_msg{type = err190_send_guild_mail_count_not_enough,about = "发送邮件次数不足"};

get(1900014) ->
    #errorcode_msg{type = err190_must_on_guild_to_send_guild_mail,about = "必须在社团才能发社团邮件"};

get(1900015) ->
    #errorcode_msg{type = err190_not_permisssion_to_send_guild_mail,about = "没有权限发社团邮件"};

get(1900016) ->
    #errorcode_msg{type = err190_on_feedback_cd,about = "处于反馈的冷却时间内"};

get(1900017) ->
    #errorcode_msg{type = err190_feedback_not_valid,about = "反馈内容过长或者存在敏感字"};

get(1900018) ->
    #errorcode_msg{type = err190_have_receive_attachment,about = "附件已领取"};

get(2000001) ->
    #errorcode_msg{type = err200_start_collect,about = "开始采集"};

get(2000002) ->
    #errorcode_msg{type = err200_finish_collect,about = "结束采集"};

get(2000003) ->
    #errorcode_msg{type = err200_long_distance,about = "距离太远"};

get(2000004) ->
    #errorcode_msg{type = err200_have_collected,about = "已完成的采集"};

get(2000005) ->
    #errorcode_msg{type = err200_not_enough_time,about = "采集时间不足"};

get(2000006) ->
    #errorcode_msg{type = err200_belong_error,about = "采集怪不属于本公会"};

get(2000007) ->
    #errorcode_msg{type = err200_collect_count_limit,about = "采集次数已满"};

get(2000008) ->
    #errorcode_msg{type = err200_collect_mon_error,about = "采集怪配置id不对应"};

get(2000009) ->
    #errorcode_msg{type = err200_eudemons_count_max,about = "幻兽之域普通采集次数已满"};

get(2000010) ->
    #errorcode_msg{type = err200_priceless_count_max,about = "幻兽之域珍惜采集次数已满"};

get(2000011) ->
    #errorcode_msg{type = err200_box_collect_max,about = "已达宝箱开启上限"};

get(2000012) ->
    #errorcode_msg{type = err200_collect_lv_limit,about = "开启青云夺宝的等级不足"};

get(2000013) ->
    #errorcode_msg{type = err200_be_collecting,about = "该物品正在被他人采集"};

get(2000014) ->
    #errorcode_msg{type = err200_stop_collect,about = "中断采集成功"};

get(2000015) ->
    #errorcode_msg{type = err200_goods_bag_limit,about = "背包空间不足"};

get(2000016) ->
    #errorcode_msg{type = err200_not_the_city_equip,about = "不是本组的攻城器械"};

get(2000017) ->
    #errorcode_msg{type = err200_have_on_city_equip,about = "已经在攻城器械上了"};

get(2000018) ->
    #errorcode_msg{type = err200_have_invaded,about = "该水晶已被我方占领"};

get(2000019) ->
    #errorcode_msg{type = err200_normal_res_count_limit,about = "普通资源采集次数已达上限"};

get(2000020) ->
    #errorcode_msg{type = err200_limited_res_count_limit,about = "限时资源采集次数已达上限"};

get(2000021) ->
    #errorcode_msg{type = err200_guild_collect_join_limit,about = "社团采集每日参与活动次数已达上限"};

get(2000022) ->
    #errorcode_msg{type = err200_guild_collect_count_limit,about = "本次活动的封印次数已达上限"};

get(2000023) ->
    #errorcode_msg{type = err200_role_not_die,about = "角色未死亡"};

get(2000024) ->
    #errorcode_msg{type = err200_revive_time_error,about = "复活时间未到"};

get(2000025) ->
    #errorcode_msg{type = err200_revive_time_cd,about = "复活冷却时间未到"};

get(2000026) ->
    #errorcode_msg{type = err200_revive_count_error,about = "复活次数已满"};

get(2000027) ->
    #errorcode_msg{type = error_gold_revive_count_limit,about = "彩钻复活次数已满"};

get(2000028) ->
    #errorcode_msg{type = err200_dun_not_allow_revive,about = "本副本不允许复活"};

get(2000029) ->
    #errorcode_msg{type = err200_revive_type_error,about = "复活方式出错"};

get(2000030) ->
    #errorcode_msg{type = err200_help_cant_collect,about = "助战状态无法采集"};

get(2000031) ->
    #errorcode_msg{type = err200_collec_wrong,about = "采集失败"};

get(2100001) ->
    #errorcode_msg{type = err210_skill_max_lv,about = "该技能已经达到最大等级"};

get(2100002) ->
    #errorcode_msg{type = err210_skill_error,about = "技能配置错误"};

get(2100003) ->
    #errorcode_msg{type = err210_lv_not_enough,about = "人物等级不足，无法升级技能"};

get(2100004) ->
    #errorcode_msg{type = err210_coin_not_enough,about = "铜币不足"};

get(2100005) ->
    #errorcode_msg{type = err210_no_pre_skill,about = "前置技能未学习"};

get(2100006) ->
    #errorcode_msg{type = err210_no_pre_skill_lv,about = "前置技能等级不足，无法学习"};

get(2100007) ->
    #errorcode_msg{type = err210_point_not_enough,about = "技能点不足，无法升级技能"};

get(2100008) ->
    #errorcode_msg{type = err210_no_pre_skill_point,about = "技能投入点不足，无法学习或升级技能"};

get(2100009) ->
    #errorcode_msg{type = err210_no_learn_talent_skill,about = "未学习天赋技能，不能重置"};

get(2100010) ->
    #errorcode_msg{type = err210_not_mycarrer_talent_skill,about = "不能学习非本职业天赋技能"};

get(2100011) ->
    #errorcode_msg{type = err210_not_rune_upgrade,about = "不是铭文技能，无法升级"};

get(2100012) ->
    #errorcode_msg{type = err_not_talent_learn,about = "不是天赋技能，无法学习"};

get(2100013) ->
    #errorcode_msg{type = err210_not_active_skill,about = "不是主动技能"};

get(2100014) ->
    #errorcode_msg{type = err210_vip_lev_not_enough,about = "vip等级不足"};

get(2100015) ->
    #errorcode_msg{type = err210_active_sup_vip,about = "激活贵族可自动获得"};

get(2150001) ->
    #errorcode_msg{type = err215_not_in_team,about = "不在队伍中"};

get(2150002) ->
    #errorcode_msg{type = err215_not_dun_multi,about = "不是跨服组队"};

get(2150003) ->
    #errorcode_msg{type = err215_not_all_help_type,about = "所有成员都为助战"};

get(2150004) ->
    #errorcode_msg{type = err215_quick_handle,about = "操作太快"};

get(2150005) ->
    #errorcode_msg{type = err215_not_enough_lv_to_enter_dungeon,about = "有队员等级不足，无法进入"};

get(2150006) ->
    #errorcode_msg{type = err215_dungeon_count_daily,about = "有队员已无次数，无法进入"};

get(2150007) ->
    #errorcode_msg{type = err215_dungeon_count_daily_help,about = "有队员已无助战次数,无法进入"};

get(2150008) ->
    #errorcode_msg{type = err215_have_team,about = "已经有队伍"};

get(2150009) ->
    #errorcode_msg{type = err215_no_team,about = "不存在该队伍"};

get(2150010) ->
    #errorcode_msg{type = err215_is_on_dungeon,about = "队伍正在副本中"};

get(2150011) ->
    #errorcode_msg{type = err215_less_power,about = "战力不匹配"};

get(2150012) ->
    #errorcode_msg{type = err215_less_lv,about = "等级不匹配"};

get(2150013) ->
    #errorcode_msg{type = err215_is_change_now,about = "队伍正在切换状态中"};

get(2150014) ->
    #errorcode_msg{type = err215_on_multi_team,about = "正在跨服组队中"};

get(2150015) ->
    #errorcode_msg{type = err215_team_max_member,about = "已满员"};

get(2150016) ->
    #errorcode_msg{type = err215_not_all_ready,about = "有队员无准备,无法进入"};

get(2150017) ->
    #errorcode_msg{type = err215_not_leader,about = "不是队长"};

get(2150018) ->
    #errorcode_msg{type = err215_member_not_condition,about = "有队员条件不足，无法切换"};

get(2150019) ->
    #errorcode_msg{type = err215_not_change_self,about = "不能委任给自己"};

get(2150020) ->
    #errorcode_msg{type = err215_member_not_exit,about = "队员不存在"};

get(2150021) ->
    #errorcode_msg{type = err215_not_prompt_self,about = "不能催促自己"};

get(2150022) ->
    #errorcode_msg{type = err215_target_limit_num,about = "超过目标最大人数"};

get(2150023) ->
    #errorcode_msg{type = err215_not_to_dummy,about = "不能委任给假人"};

get(2150024) ->
    #errorcode_msg{type = err215_is_dummy_team,about = "不能加入系统假人队伍"};

get(2150025) ->
    #errorcode_msg{type = err215_not_daily_times,about = "每日次数已用完"};

get(2150026) ->
    #errorcode_msg{type = err215_not_help_times,about = "助战次数已用完"};

get(2150027) ->
    #errorcode_msg{type = err215_is_max_num,about = "已超过该副本的进入人数"};

get(2150028) ->
    #errorcode_msg{type = err215_not_connect_center,about = "连接不上跨服中心"};

get(2150029) ->
    #errorcode_msg{type = err215_time_out_request,about = "请求跨服中心超时"};

get(2150030) ->
    #errorcode_msg{type = err215_repeat_match_state,about = "请勿重复切换匹配状态"};

get(2150031) ->
    #errorcode_msg{type = err215_subtype_error,about = "讨伐类型有误"};

get(2150032) ->
    #errorcode_msg{type = err215_role_match_dun_error,about = "无法匹配此类组队活动"};

get(2150033) ->
    #errorcode_msg{type = err215_password_error,about = "队伍密码错误，无法操作"};

get(2150034) ->
    #errorcode_msg{type = err215_have_in_team,about = "已在队伍中，请勿重复操作"};

get(2150035) ->
    #errorcode_msg{type = err215_mirror_in_this_team,about = "对方分身已在此队伍中，请勿重复操作"};

get(2150036) ->
    #errorcode_msg{type = err215_oppo_lv_limit,about = "对方等级不足，无法邀请"};

get(2150037) ->
    #errorcode_msg{type = err215_lv_limit,about = "等级不足，无法操作"};

get(2150038) ->
    #errorcode_msg{type = err215_assist_count_limt,about = "支援次数不足，请等待恢复"};

get(2150039) ->
    #errorcode_msg{type = err215_have_not_finish_wave,about = "未通关波数，无法接受邀请"};

get(2150040) ->
    #errorcode_msg{type = err215_have_not_pass_dun,about = "还未有人通关副本，无法领取奖励"};

get(2150041) ->
    #errorcode_msg{type = err215_help_can_not_create_team,about = "当前无队伍匹配，助战状态无法创队"};

get(2150042) ->
    #errorcode_msg{type = err215_not_in_vote,about = "非投票阶段，无法操作"};

get(2150043) ->
    #errorcode_msg{type = err215_in_vote,about = "当前处于投票阶段，无法操作"};

get(2150044) ->
    #errorcode_msg{type = err215_have_voted,about = "您已投票，无法操作"};

get(2150045) ->
    #errorcode_msg{type = err215_repeat_approve_state,about = "请勿重复切换审批状态"};

get(2150046) ->
    #errorcode_msg{type = err215_approve_state_error,about = "审批状态有误"};

get(2150047) ->
    #errorcode_msg{type = err215_cant_change_team_target,about = "无法切换队伍目标"};

get(2150048) ->
    #errorcode_msg{type = err215_have_in_target,about = "您正处于此目标队伍中，请勿重复操作"};

get(2150049) ->
    #errorcode_msg{type = err215_mate_can_match,about = "队员无法满足切换目标条件,无法操作"};

get(2150050) ->
    #errorcode_msg{type = err215_join_req_done,about = "成功提交入队申请"};

get(2150051) ->
    #errorcode_msg{type = err215_in_dun_multi_match,about = "当前多人副本队伍匹配中"};

get(2150052) ->
    #errorcode_msg{type = err215_in_other_act,about = "有队员处于其他活动中"};

get(2150053) ->
    #errorcode_msg{type = err215_have_req,about = "你已发出申请，无需重复操作!"};

get(2150054) ->
    #errorcode_msg{type = err215_not_repeat_change_help,about = "请勿重复切换协助状态"};

get(2150055) ->
    #errorcode_msg{type = err215_count_max,about = "挑战次数不足，无法切换协助状态"};

get(2150056) ->
    #errorcode_msg{type = err215_leader_limit,about = "队长无法切换协助状态"};

get(2150057) ->
    #errorcode_msg{type = err215_help_dun_error,about = "目标副本协助状态有误，无法操作"};

get(2150058) ->
    #errorcode_msg{type = err215_pass_pre_dun,about = "请先通关前置副本"};

get(2150059) ->
    #errorcode_msg{type = err215_leader_help_type,about = "队长处于协助状态，无法操作"};

get(2150060) ->
    #errorcode_msg{type = err215_merge_count_error,about = "多人组队无法合并次数"};

get(2150061) ->
    #errorcode_msg{type = err215_merge_count_limit,about = "次数不足，无法合并"};

get(2150062) ->
    #errorcode_msg{type = err215_same_merge_type,about = "合并操作重复，无法切换"};

get(2210001) ->
    #errorcode_msg{type = err211_praise_num_limit,about = "当前榜单点赞已上限"};

get(2210002) ->
    #errorcode_msg{type = err211_first_top_limit,about = "目标未达成，无法操作"};

get(2210003) ->
    #errorcode_msg{type = err211_rank_data_error,about = "该无该类型跨服排名"};

get(2210004) ->
    #errorcode_msg{type = err211_not_finish,about = "分区数据准备中"};

get(2220001) ->
    #errorcode_msg{type = err222_goods_not_enough,about = "物品不够"};

get(2220002) ->
    #errorcode_msg{type = err222_combat_not_enough,about = "战力不够"};

get(2220003) ->
    #errorcode_msg{type = err222_title_not_equel,about = "职称与服务器不对应"};

get(2220004) ->
    #errorcode_msg{type = err222_title_config_error,about = "配置出错"};

get(2220005) ->
    #errorcode_msg{type = err222_deduction_goods_error,about = "扣除物品失败"};

get(2220006) ->
    #errorcode_msg{type = err222_6_not_enough_server_day,about = "开服天数不够"};

get(2220007) ->
    #errorcode_msg{type = err222_title_lv_max,about = "头衔等级已达最高"};

get(2230001) ->
    #errorcode_msg{type = err223_num_not_enough,about = "砸蛋次数不足"};

get(2230002) ->
    #errorcode_msg{type = err223_lv_not_enough,about = "等级不足"};

get(2230004) ->
    #errorcode_msg{type = err223_shop_not_provide,about = "商城没有出售该商品"};

get(2230005) ->
    #errorcode_msg{type = err223_reset_time,about = "当前为重置时间"};

get(2230006) ->
    #errorcode_msg{type = err223_dissatisfy_send_gift_condition,about = "未达到赠送条件"};

get(2230007) ->
    #errorcode_msg{type = err223_receiver_lv_not_enough,about = "未达到赠送条件"};

get(2230008) ->
    #errorcode_msg{type = err223_player_not_online,about = "对方玩家不在线"};

get(2230009) ->
    #errorcode_msg{type = err223_player_charm_is_zero,about = "对方魅力值为0，太可怜了，不要砸蛋了"};

get(2230010) ->
    #errorcode_msg{type = err223_egg_time_lim,about = "砸蛋次数不足"};

get(2230011) ->
    #errorcode_msg{type = err223_sp_gift_limit_count,about = "每日购买次数不足"};

get(2230012) ->
    #errorcode_msg{type = err223_have_thanked,about = "已发出感谢，请勿重复操作"};

get(2250001) ->
    #errorcode_msg{type = err225_goal_reward_limit,about = "未达到奖励领取要求"};

get(2400001) ->
    #errorcode_msg{type = err240_in_team,about = "您已经有队伍"};

get(2400002) ->
    #errorcode_msg{type = err240_changing_scene,about = "您正在切换场景"};

get(2400003) ->
    #errorcode_msg{type = err240_no_team,about = "该玩家没有队伍"};

get(2400004) ->
    #errorcode_msg{type = err240_kick_himself,about = "您不能踢除您自己"};

get(2400005) ->
    #errorcode_msg{type = err240_max_member,about = "队伍人数已满"};

get(2400006) ->
    #errorcode_msg{type = err240_not_leader,about = "您不是队长"};

get(2400007) ->
    #errorcode_msg{type = err240_not_kick_leader,about = "不能踢队长"};

get(2400008) ->
    #errorcode_msg{type = err240_leader_reject,about = "对方拒绝您的加入"};

get(2400009) ->
    #errorcode_msg{type = err240_other_offline,about = "对方不在线"};

get(2400010) ->
    #errorcode_msg{type = err240_other_in_team,about = "对方已经有队伍"};

get(2400011) ->
    #errorcode_msg{type = err240_team_disappear,about = "该队伍已解散"};

get(2400012) ->
    #errorcode_msg{type = err240_offline,about = "对方已经下线"};

get(2400013) ->
    #errorcode_msg{type = err240_arbitrate_timeout,about = "入场投票超时"};

get(2400014) ->
    #errorcode_msg{type = err240_arbitrate_refuse,about = "{1}拒绝进入"};

get(2400015) ->
    #errorcode_msg{type = err240_not_current_aribirate_req,about = "投票已经过期"};

get(2400017) ->
    #errorcode_msg{type = err240_not_on_arbitrate_req_to_vote,about = "没有投票"};

get(2400018) ->
    #errorcode_msg{type = err240_not_leader_to_arbitrate_req,about = "只有队长可以发起入场投票"};

get(2400019) ->
    #errorcode_msg{type = err240_not_arbitrate_req_in_dungeon,about = "在副本中无法发起入场投票"};

get(2400020) ->
    #errorcode_msg{type = err240_not_again_arbitrate_req,about = "不能重复发起入场投票"};

get(2400021) ->
    #errorcode_msg{type = err240_not_team_dungeon,about = "不是队伍副本"};

get(2400022) ->
    #errorcode_msg{type = err240_join_team,about = "您加入了新的队伍"};

get(2400023) ->
    #errorcode_msg{type = err240_new_member,about = "{1}加入队伍"};

get(2400024) ->
    #errorcode_msg{type = err240_self_out_team,about = "您离开了队伍"};

get(2400025) ->
    #errorcode_msg{type = err240_out_team,about = "{1}离开了队伍"};

get(2400026) ->
    #errorcode_msg{type = err240_self_shot_of_team,about = "您被请出了队伍"};

get(2400027) ->
    #errorcode_msg{type = err240_shot_of_team,about = "{1}被请出了队伍"};

get(2400028) ->
    #errorcode_msg{type = err240_no_member_follow,about = "当前没有队员跟战"};

get(2400029) ->
    #errorcode_msg{type = err240_cancel_follow_success,about = "取消队员跟战成功"};

get(2400030) ->
    #errorcode_msg{type = err240_change_state_to_interrput_arbitrate,about = "队伍状态改变,投票中断"};

get(2400031) ->
    #errorcode_msg{type = err240_on_dungeon_not_to_do,about = "队伍处于副本中无法进行操作"};

get(2400032) ->
    #errorcode_msg{type = err240_not_on_team,about = "不在队伍中，无法操作"};

get(2400033) ->
    #errorcode_msg{type = err240_this_team_on_dungeon,about = "本队伍处于副本中，无法加入"};

get(2400034) ->
    #errorcode_msg{type = err240_34_no_invite_role,about = "无邀请对象"};

get(2400035) ->
    #errorcode_msg{type = err240_agree_to_enter_safety_scene,about = "{1}同意,正玩命赶回安全区."};

get(2400036) ->
    #errorcode_msg{type = err240_not_enough_lv_to_create_team,about = "等级不足，无法创建队伍"};

get(2400037) ->
    #errorcode_msg{type = err240_not_enough_lv_to_join_team,about = "等级不足，无法加入队伍"};

get(2400038) ->
    #errorcode_msg{type = err240_not_enough_lv_to_enter_target,about = "没有达到进入该目标的等级"};

get(2400039) ->
    #errorcode_msg{type = err240_not_enough_lv_to_enter_target_with_name,about = "{1}没有达到进入该目标的等级"};

get(2400040) ->
    #errorcode_msg{type = err240_not_enough_lv_to_create_target,about = "您没有达到目标的最低等级，无法创建"};

get(2400047) ->
    #errorcode_msg{type = err240_not_on_safe_scene_to_outdoor_by_other,about = "{1}所在场景无法进入"};

get(2400048) ->
    #errorcode_msg{type = err240_choose_lv_error,about = "等级范围不合法"};

get(2400049) ->
    #errorcode_msg{type = err240_auto_pair_limit,about = "该目标不可匹配"};

get(2400050) ->
    #errorcode_msg{type = err240_change_when_matching,about = "正在自动匹配中，请先取消自动匹配"};

get(2400051) ->
    #errorcode_msg{type = err240_all_for_help_other,about = "全员均助战，无法进入副本"};

get(2400052) ->
    #errorcode_msg{type = err240_teammates_offline,about = "{1}不在线"};

get(2400053) ->
    #errorcode_msg{type = err240_cost_error,about = "{1}物品不足"};

get(2400054) ->
    #errorcode_msg{type = err240_help_type_setup_limit,about = "该副本类型不能设置助战"};

get(2400055) ->
    #errorcode_msg{type = err240_too_many_members,about = "队伍人数超过新目标限定人数"};

get(2400056) ->
    #errorcode_msg{type = err240_team_create_unfinished,about = "正在创建队伍中，请勿进行其它操作"};

get(2400057) ->
    #errorcode_msg{type = err240_cls_type_error,about = "请先把队伍目标改成{1}"};

get(2400058) ->
    #errorcode_msg{type = err240_in_arbitrate,about = "当前正在队伍投票中，无法操作"};

get(2400059) ->
    #errorcode_msg{type = err240_me_to_other,about = "{1}{2}"};

get(2400061) ->
    #errorcode_msg{type = err240_local_team_with_other_serv,about = "队伍里有跨服成员无法切换成本服队伍"};

get(2400062) ->
    #errorcode_msg{type = err240_this_team_matching,about = "该队伍正在匹配诛邪战场，无法加入"};

get(2400063) ->
    #errorcode_msg{type = err240_arbitrate_vote_repeat,about = "您已经投过票了"};

get(2400064) ->
    #errorcode_msg{type = err240_invite_diff_target_error,about = "队员无法邀请伴侣，请先退队"};

get(2400065) ->
    #errorcode_msg{type = err240_no_teams_for_match,about = "没有可匹配的队伍"};

get(2400066) ->
    #errorcode_msg{type = err240_choose_target_first,about = "请先选择组队目标"};

get(2400067) ->
    #errorcode_msg{type = err240_team_target_not_exist,about = "请选择正确队伍目标"};

get(2400068) ->
    #errorcode_msg{type = err240_cannot_choose_lv,about = "当前目标不可设置等级限制"};

get(2400069) ->
    #errorcode_msg{type = err240_cannot_choose_power,about = "当前目标不可设置战力限制"};

get(2400070) ->
    #errorcode_msg{type = err240_not_enough_power_to_enter_target_with_name,about = "{1}没有达到进入该目标的战力"};

get(2400071) ->
    #errorcode_msg{type = err240_couple_intimacy_not_enough,about = "亲密度不足{1}，无法进入该副本"};

get(2400072) ->
    #errorcode_msg{type = err240_cannot_quit_in_dun,about = "处于副本中，无法退出队伍"};

get(2400073) ->
    #errorcode_msg{type = err240_lower_power,about = "战力不足"};

get(2400074) ->
    #errorcode_msg{type = err240_cannot_set_password,about = "无法设置密码"};

get(2400075) ->
    #errorcode_msg{type = err240_act_not_exist,about = "目标活动不存在"};

get(2400076) ->
    #errorcode_msg{type = err240_team_not_exist,about = "组队不存在"};

get(2400077) ->
    #errorcode_msg{type = err240_error_team_need_free,about = "队伍正在组队匹配中，请退出当前玩法再操作"};

get(2400078) ->
    #errorcode_msg{type = err240_password_error,about = "密码错误"};

get(2400079) ->
    #errorcode_msg{type = err240_need_password,about = "需要输入密码"};

get(2400080) ->
    #errorcode_msg{type = err240_the_other_not_pre_dun,about = "对方尚未完成前置副本"};

get(2400081) ->
    #errorcode_msg{type = err240_not_enough_power,about = "战力不足"};

get(2400082) ->
    #errorcode_msg{type = err240_not_same_act,about = "特殊的组队活动不可切换"};

get(2400083) ->
    #errorcode_msg{type = err240_error_not_change,about = "无法切换目标，队员等级不符合要求"};

get(2400084) ->
    #errorcode_msg{type = err240_member_call_overdue,about = "召唤信息已过期！"};

get(2400085) ->
    #errorcode_msg{type = err240_cannot_enter,about = "目标场景不可进入！"};

get(2400086) ->
    #errorcode_msg{type = err240_cls_team_join,about = "无法加入跨服队伍"};

get(2400087) ->
    #errorcode_msg{type = err240_cls_team_limit,about = "无法进行跨服间组队"};

get(2400088) ->
    #errorcode_msg{type = err240_team_not_exist_1,about = "该队伍不存在"};

get(2400089) ->
    #errorcode_msg{type = err240_oppo_lv_litmit,about = "对方等级不足，无法操作"};

get(2800001) ->
    #errorcode_msg{type = err280_over_max_buy_num,about = "超出可购买次数"};

get(2800002) ->
    #errorcode_msg{type = err280_rank_had_changed,about = "排名发生改变，请刷新！"};

get(2800003) ->
    #errorcode_msg{type = err280_arena_num,about = "挑战次数错误"};

get(2800004) ->
    #errorcode_msg{type = err280_none_reward,about = "没有奖励"};

get(2800005) ->
    #errorcode_msg{type = err280_already_receive_reward,about = "已领取奖励"};

get(2800006) ->
    #errorcode_msg{type = err280_rival_rank_change,about = "对手排名已改变"};

get(2800007) ->
    #errorcode_msg{type = err280_self_rank_change,about = "自己排名已改变"};

get(2800008) ->
    #errorcode_msg{type = err280_arena_num_not_enough,about = "挑战次数不足"};

get(2800009) ->
    #errorcode_msg{type = err280_lv_not_enough,about = "等级不足"};

get(2800010) ->
    #errorcode_msg{type = err280_on_battle_state,about = "该玩家正在战斗中，请稍后"};

get(2800011) ->
    #errorcode_msg{type = err280_page_not_vaild,about = "只能查看前100名玩家信息"};

get(2800012) ->
    #errorcode_msg{type = err280_history_rank_not_enough,about = "未达到要求的历史最高排名"};

get(2800013) ->
    #errorcode_msg{type = err280_role_on_battle_state,about = "您正在被挑战中，请稍后"};

get(2800014) ->
    #errorcode_msg{type = err280_challenge_self,about = "不能挑战自己"};

get(2800015) ->
    #errorcode_msg{type = err280_reward_condition,about = "条件不足！"};

get(2800016) ->
    #errorcode_msg{type = err280_cooldown_cd,about = "冷却时间没过"};

get(2800017) ->
    #errorcode_msg{type = err280_error_args,about = "错误参数"};

get(2800018) ->
    #errorcode_msg{type = err280_vip_less,about = "vip等级不足"};

get(2800019) ->
    #errorcode_msg{type = err280_sp_award_only,about = "只有竞技大神才可领取每日福利！"};

get(2800020) ->
    #errorcode_msg{type = err280_sp_rank_need,about = "只有排位前50的玩家可发起大神挑战！"};

get(2800021) ->
    #errorcode_msg{type = err280_arena_in_cooldown,about = "挑战冷却中哦~"};

get(2810001) ->
    #errorcode_msg{type = err281_award_is_got,about = "奖励已经领取"};

get(2810002) ->
    #errorcode_msg{type = err281_daily_enter_count_error,about = "参与次数不足"};

get(2810003) ->
    #errorcode_msg{type = err281_buy_count_limit,about = "您的可购买次数不足"};

get(2810004) ->
    #errorcode_msg{type = err281_match_repeat,about = "您已经在匹配中"};

get(2810005) ->
    #errorcode_msg{type = err281_on_matching_state,about = "当前正在巅峰竞技匹配中"};

get(2810006) ->
    #errorcode_msg{type = err281_not_on_match_state,about = "当前不在匹配状态中"};

get(2810007) ->
    #errorcode_msg{type = err281_on_battle_state,about = "当前正在参与巅峰竞技中"};

get(2810008) ->
    #errorcode_msg{type = err281_grade_limit,about = "您的段位不足"};

get(2810009) ->
    #errorcode_msg{type = err281_no_honor_reward,about = "没有可领取的荣誉值"};

get(2810010) ->
    #errorcode_msg{type = err281_enemy_is_late,about = "由于您的对手不能及时到场，您获得胜利"};

get(3000001) ->
    #errorcode_msg{type = err300_task_trigger,about = "此任务已接取"};

get(3000002) ->
    #errorcode_msg{type = err300_task_config_null,about = "任务配置错误（无此任务）"};

get(3000003) ->
    #errorcode_msg{type = err300_lv_not_enough,about = "等级不足，无法接取任务"};

get(3000004) ->
    #errorcode_msg{type = err300_not_guild,about = "请加入帮派后再接取此任务"};

get(3000005) ->
    #errorcode_msg{type = err300_realm_diff,about = "阵营不符，无法接取"};

get(3000006) ->
    #errorcode_msg{type = err300_career_diff,about = "职业不符，无法接取"};

get(3000007) ->
    #errorcode_msg{type = err300_prev_not_fin,about = "前置任务未完成"};

get(3000008) ->
    #errorcode_msg{type = err300_fin,about = "任务已完成"};

get(3000009) ->
    #errorcode_msg{type = err300_condition_err,about = "条件不满足，无法接取（暂定提示）"};

get(3000010) ->
    #errorcode_msg{type = err300_not_enough_cell,about = "背包空间不足，请清理后再完成"};

get(3000011) ->
    #errorcode_msg{type = err300_turn_diff,about = "转生次数不符，无法领取"};

get(3000012) ->
    #errorcode_msg{type = err300_daily_task_finished,about = "今日日常任务已全部完成"};

get(3000013) ->
    #errorcode_msg{type = err300_guild_task_finished,about = "社团任务已全部完成"};

get(3000014) ->
    #errorcode_msg{type = err300_no_task_trigger,about = "此任务未领取"};

get(3000015) ->
    #errorcode_msg{type = err300_task_no_finish,about = "任务没有完成"};

get(3000016) ->
    #errorcode_msg{type = err300_lv_no_task,about = "您的等级段没有相应的任务"};

get(3000017) ->
    #errorcode_msg{type = err300_not_double_reward,about = "该任务没有双倍奖励"};

get(3000018) ->
    #errorcode_msg{type = err300_need_finish_more_task,about = "需要完成更多环任务"};

get(3310001) ->
    #errorcode_msg{type = err331_act_closed,about = "活动未开启"};

get(3310002) ->
    #errorcode_msg{type = err331_no_act_reward_cfg,about = "没有活动奖励配置"};

get(3310003) ->
    #errorcode_msg{type = err331_act_can_not_get,about = "条件不足,不能领取"};

get(3310004) ->
    #errorcode_msg{type = err331_already_get_reward,about = "奖励已领取"};

get(3310005) ->
    #errorcode_msg{type = err331_fs_already_evaluate,about = "已经评价过"};

get(3310006) ->
    #errorcode_msg{type = err331_act_time_out,about = "奖励超时"};

get(3310007) ->
    #errorcode_msg{type = err331_smashed_egg_refresh_fail,about = "刷新失败，您今天的砸蛋次数已用完"};

get(3310008) ->
    #errorcode_msg{type = err331_smashed_egg_times_lim,about = "本日钻石砸蛋次数已达到上限"};

get(3310009) ->
    #errorcode_msg{type = err331_limit_buy_daily_num_max,about = "本日数量已卖完"};

get(3310010) ->
    #errorcode_msg{type = err331_egg_has_smashed,about = "这个金蛋已经被砸过了"};

get(3310011) ->
    #errorcode_msg{type = err331_cloud_buy_end,about = "购买时间已结束，下次请早"};

get(3310012) ->
    #errorcode_msg{type = err331_cloud_buy_order_unfinished,about = "上一订单尚未完成"};

get(3310013) ->
    #errorcode_msg{type = err331_cloud_buy_personal_limit,about = "当前个人限购次数已达上限"};

get(3310014) ->
    #errorcode_msg{type = err331_cloud_buy_not_enough,about = "剩余份数不足，购买失败"};

get(3310015) ->
    #errorcode_msg{type = err331_act_boss_scene_tips,about = "无法获悉首领的入侵地点，请小心搜索"};

get(3310016) ->
    #errorcode_msg{type = err331_act_boss_scene_people_lim,about = "该场景已满人，建议到别处剿灭首领"};

get(3310017) ->
    #errorcode_msg{type = err331_act_boss_scene_no_boss,about = "该场景内的首领已全部被击退，建议到别处继续剿灭"};

get(3310018) ->
    #errorcode_msg{type = err331_act_mission_complete,about = "本轮活动已完成"};

get(3310019) ->
    #errorcode_msg{type = err331_count_limit,about = "奖励已被领完"};

get(3310020) ->
    #errorcode_msg{type = err331_only_president_reward,about = "只有社团团长才可领取该奖励"};

get(3310021) ->
    #errorcode_msg{type = err331_ticket_limit,about = "抽奖券不足"};

get(3310022) ->
    #errorcode_msg{type = err331_limit_buy_daily_player_max,about = "该商品本日个人次数已买完"};

get(3310023) ->
    #errorcode_msg{type = err331_not_in_buy_day,about = "本次活动购买时间已截止~"};

get(3310024) ->
    #errorcode_msg{type = err331_login_return_reward_has_buy,about = "已购买该豪礼~"};

get(3310025) ->
    #errorcode_msg{type = err331_act_boss_scene_no_collect,about = "采集怪采完用，该场景内的采集物已全部被采完，建议到别处继续采集"};

get(3310026) ->
    #errorcode_msg{type = err331_flop_times_lim,about = "奖池已领完，请刷新奖池"};

get(3310027) ->
    #errorcode_msg{type = err331_receive_time_limit,about = "兑换次数已用尽"};

get(3310028) ->
    #errorcode_msg{type = err331_te_cant_choose_big,about = "无法选择大奖"};

get(3310029) ->
    #errorcode_msg{type = err331_te_big_id_wrong,about = "没有该类型大奖"};

get(3310030) ->
    #errorcode_msg{type = err331_te_not_choose_again,about = "当前无法再次选择大奖"};

get(3310031) ->
    #errorcode_msg{type = err331_te_not_choose_big,about = "请先选择大奖"};

get(3310032) ->
    #errorcode_msg{type = err331_wrong_reward_num,about = "奖励选择数量不正确"};

get(3310033) ->
    #errorcode_msg{type = err331_not_supplication_time,about = "祈愿时间只限:周一12:00-24:00"};

get(3310034) ->
    #errorcode_msg{type = err331_invest_repeat,about = "已投资该档位"};

get(3310035) ->
    #errorcode_msg{type = err331_turntable_no_times,about = "没有转盘次数啦"};

get(3310036) ->
    #errorcode_msg{type = err331_score_not_enough,about = "积分不足，无法兑换奖励"};

get(3310037) ->
    #errorcode_msg{type = err331_kf_cloud_buy_personal_buy_num_lim,about = "个人购买次数已达上限"};

get(3310038) ->
    #errorcode_msg{type = err331_kf_cloud_buy_total_buy_num_lim,about = "商品总购买次数已达上限"};

get(3310039) ->
    #errorcode_msg{type = err331_kf_cloud_buy_product_id_err,about = "商品id错误"};

get(3310040) ->
    #errorcode_msg{type = err331_pls_wait_for_next_act,about = "请等待下次活动开启"};

get(3310041) ->
    #errorcode_msg{type = err331_kf_cloud_buy_drawing,about = "已开奖"};

get(3310042) ->
    #errorcode_msg{type = err331_can_not_pick_up,about = "不可领取"};

get(3310043) ->
    #errorcode_msg{type = err331_lucky_flop_cant_select,about = "奖池已锁定"};

get(3310044) ->
    #errorcode_msg{type = err331_lucky_flop_reward_repeat,about = "选择奖励重复"};

get(3310045) ->
    #errorcode_msg{type = err331_lucky_flop_no_reward,about = "奖励不存在"};

get(3310046) ->
    #errorcode_msg{type = err331_lucky_flop_select_error,about = "选择奖励失败"};

get(3310047) ->
    #errorcode_msg{type = err331_lucky_flop_no_select,about = "奖励未选取"};

get(3310048) ->
    #errorcode_msg{type = err331_lucky_flop_need_reset,about = "奖励已抽完，请重置奖池"};

get(3310049) ->
    #errorcode_msg{type = err331_lucky_flop_cant_reset,about = "还有未领取的累计奖励哦"};

get(3310050) ->
    #errorcode_msg{type = err331_has_no_more_times,about = "没有剩余次数"};

get(3310051) ->
    #errorcode_msg{type = err331_need_recharge_more,about = "充值金额不足"};

get(3310052) ->
    #errorcode_msg{type = err331_lv_unreach,about = "不符合等级条件"};

get(3310053) ->
    #errorcode_msg{type = err331_over_limit_num,about = "超出购买上限"};

get(3310054) ->
    #errorcode_msg{type = err331_award_not_due,about = "已购买还没到可领取时间"};

get(3310055) ->
    #errorcode_msg{type = err331_act_overdue,about = "已过期不可购买"};

get(3310056) ->
    #errorcode_msg{type = err331_all_round_over,about = "所有轮次均已抽取完毕"};

get(3310057) ->
    #errorcode_msg{type = err331_have_not_dice_count,about = "投掷次数不足，无法操作"};

get(3310058) ->
    #errorcode_msg{type = err331_dice_type_error,about = "投掷类型错误"};

get(3310059) ->
    #errorcode_msg{type = err331_dice_count_limit,about = "投掷次数不足"};

get(3310060) ->
    #errorcode_msg{type = err331_max_round,about = "您已完成本期所有圈数，无法再操作"};

get(3310061) ->
    #errorcode_msg{type = err331_reissue_count_limit,about = "补签次数不足"};

get(3310062) ->
    #errorcode_msg{type = err331_round_rewarded,about = "圈数奖励已领取"};

get(3310063) ->
    #errorcode_msg{type = err331_round_not_fin,about = "圈数未完成,无法领取"};

get(3310064) ->
    #errorcode_msg{type = err331_round_data_error,about = "圈数数据有误"};

get(3310065) ->
    #errorcode_msg{type = err331_contract_task_not_fin,about = "宝典任务未达成,无法领取"};

get(3310066) ->
    #errorcode_msg{type = err331_task_type_error,about = "宝典任务类型有误,请重新操作"};

get(3310067) ->
    #errorcode_msg{type = err331_have_contract_reward,about = "宝典奖励已领取"};

get(3310068) ->
    #errorcode_msg{type = err331_contract_lv_limit,about = "宝典等级不足，无法领取等级奖励"};

get(3310069) ->
    #errorcode_msg{type = err331_contract_lv_rewarded,about = "宝典等级奖励已领取"};

get(3310070) ->
    #errorcode_msg{type = err331_dicount_limit,about = "无法使用折扣卡,请重新操作"};

get(3310071) ->
    #errorcode_msg{type = err331_contract_haved_buy,about = "您已购买尊享宝典,请勿重复操作"};

get(3310072) ->
    #errorcode_msg{type = err331_phantom_not_reward,about = "当前等级的奖励都领取完了哦！"};

get(3310073) ->
    #errorcode_msg{type = err331_hi_points_not_receive,about = "还未能领取当前奖励哟"};

get(3310074) ->
    #errorcode_msg{type = err331_hi_points_subtype_err,about = "不能领取本期的奖励喔"};

get(3310075) ->
    #errorcode_msg{type = err331_turntable_times_limit,about = "转盘次数不足"};

get(3310076) ->
    #errorcode_msg{type = err331_seckill_overdue,about = "活动数据已过期！"};

get(3310077) ->
    #errorcode_msg{type = err331_seckill_not_open,about = "秒杀尚未开始！"};

get(3310078) ->
    #errorcode_msg{type = err331_seckill_closed,about = "本场秒杀已结束！"};

get(3310079) ->
    #errorcode_msg{type = err331_seckill_cannot_buy,about = "本场商品无法购买！"};

get(3310080) ->
    #errorcode_msg{type = err331_seckill_role_limit,about = "您的购买次数不足！"};

get(3310081) ->
    #errorcode_msg{type = err331_seckill_total_limit,about = "商品已售空！"};

get(3310082) ->
    #errorcode_msg{type = err331_need_more_day,about = "天数不足"};

get(3310083) ->
    #errorcode_msg{type = err331_all_scratch,about = "已经全部刮完，先刷新一下哟"};

get(3310084) ->
    #errorcode_msg{type = err331_scratch_option_err,about = "刮卡选项错误"};

get(3310085) ->
    #errorcode_msg{type = err331_scratch_pos_err,about = "选择的刮卡位置不对哟"};

get(3310086) ->
    #errorcode_msg{type = err331_scratch_reward_err,about = "刮奖奖励错误"};

get(3310087) ->
    #errorcode_msg{type = err331_not_scratch_all,about = "还没全部刮完，不需要刷新哟"};

get(3310088) ->
    #errorcode_msg{type = err331_draw_cost_config_err,about = "抽奖消耗配置错误"};

get(3310089) ->
    #errorcode_msg{type = err331_draw_cost_not_enough,about = "抽奖积分不足哟"};

get(3310090) ->
    #errorcode_msg{type = err331_scratch_cost_not_enough,about = "刮奖材料不足哟"};

get(3310091) ->
    #errorcode_msg{type = err331_vie_bag_cding,about = "存货准备中,请在{1}秒后重试"};

get(3310092) ->
    #errorcode_msg{type = err331_vie_bag_max,about = "已达可领最大数量{1}"};

get(3310093) ->
    #errorcode_msg{type = err331_last_reward,about = "请先达成上一档奖励哟"};

get(3310094) ->
    #errorcode_msg{type = err331_receive_red_packet,about = "达成条件即可领取红包哟"};

get(3310095) ->
    #errorcode_msg{type = err331_red_packet_err,about = "惊喜红包数据有误"};

get(3310096) ->
    #errorcode_msg{type = err331_recharge_not_enough,about = "充值金额未达标哟"};

get(3310097) ->
    #errorcode_msg{type = err331_red_packet_cfg_err,about = "红包配置错误"};

get(3310098) ->
    #errorcode_msg{type = err331_red_packet_all_receive,about = "红包已经全部抽取完啦"};

get(3310099) ->
    #errorcode_msg{type = err331_red_packet_not_receive,about = "还未可以领取奖励"};

get(3310100) ->
    #errorcode_msg{type = err331_discount_price_error,about = "商品价格错误！"};

get(3310101) ->
    #errorcode_msg{type = err331_discount_times_limit,about = "商品已售罄！"};

get(3310102) ->
    #errorcode_msg{type = err331_discount_lv_limit,about = "玩家等级不足！"};

get(3310103) ->
    #errorcode_msg{type = err331_discount_coupon_error,about = "优惠券错误！"};

get(3310104) ->
    #errorcode_msg{type = err331_discount_condition,about = "折扣券未达使用条件！"};

get(3310105) ->
    #errorcode_msg{type = err331_discount_ab_condition,about = "满减券未达使用条件！"};

get(3310106) ->
    #errorcode_msg{type = err331_box_need_draw_first,about = "需要先抽奖哟"};

get(3310107) ->
    #errorcode_msg{type = err331_box_has_received,about = "宝箱已经领取过啦"};

get(3310108) ->
    #errorcode_msg{type = err331_box_cfg_err,about = "宝箱配置错误"};

get(3310109) ->
    #errorcode_msg{type = err331_tarot_count_error,about = "卡牌张数有误，请联系客服"};

get(3310110) ->
    #errorcode_msg{type = err331_tarot_reward_error,about = "卡牌奖池有误，请联系客服"};

get(3310111) ->
    #errorcode_msg{type = err331_tarot_pos_error,about = "该位置已翻牌，请勿重复操作"};

get(3310112) ->
    #errorcode_msg{type = err331_tarot_cost_cfg_error,about = "卡牌消耗异常，请联系客服"};

get(3310113) ->
    #errorcode_msg{type = err331_tarot_num_error,about = "翻牌次数不足"};

get(3310114) ->
    #errorcode_msg{type = err331_no_need_refresh_tarot,about = "您还未翻牌，无需重置"};

get(3310115) ->
    #errorcode_msg{type = err331_progress_lack,about = "进度值不足，无法领取"};

get(3310116) ->
    #errorcode_msg{type = err331_score_lack,about = "您的冒险点数不足哦~"};

get(3310117) ->
    #errorcode_msg{type = err331_phase_err,about = "阶段错误"};

get(3310118) ->
    #errorcode_msg{type = err331_exchage_times_err,about = "兑换次数错误"};

get(3310119) ->
    #errorcode_msg{type = err331_exchange_times_not_enough,about = "已经兑换完啦"};

get(3310120) ->
    #errorcode_msg{type = err331_reward_cfg_err,about = "奖励配置错误"};

get(3310121) ->
    #errorcode_msg{type = err331_act_cfg_err,about = "定制活动配置错误"};

get(3310122) ->
    #errorcode_msg{type = err331_receive_phase_err,about = "阶段还未开启哟！"};

get(3310123) ->
    #errorcode_msg{type = err331_phase_reward_received,about = "阶段奖励已经领取过啦"};

get(3310124) ->
    #errorcode_msg{type = err331_exchange_lv_err,about = "兑换等级错误"};

get(3310125) ->
    #errorcode_msg{type = err331_daily_max_draw,about = "今日已达到最大抽奖次数，请明天再来"};

get(3310126) ->
    #errorcode_msg{type = err331_has_fetch_today,about = "今日已领取"};

get(3310127) ->
    #errorcode_msg{type = err331_need_loans_gold,about = "需要先存入彩钻"};

get(3310128) ->
    #errorcode_msg{type = err331_been_full_loans,about = "彩钻已存满"};

get(3310129) ->
    #errorcode_msg{type = err331_refresh_pool,about = "需先刷新奖池"};

get(3310130) ->
    #errorcode_msg{type = err331_puzzle_times_limit,about = "今日剩余次数已用完~！"};

get(3310131) ->
    #errorcode_msg{type = err331_puzzle_not_finish,about = "请先完成上一次拼图哟"};

get(3310132) ->
    #errorcode_msg{type = err331_puzzle_change_err,about = "拼图替换位置错误"};

get(3310133) ->
    #errorcode_msg{type = err331_puzzle_not_start,about = "请先开始拼图哟"};

get(3310134) ->
    #errorcode_msg{type = err331_puzzle_remember_time,about = "当前还是记忆时间哟"};

get(3310135) ->
    #errorcode_msg{type = err331_puzzle_over_time,about = "超时了喔"};

get(3310136) ->
    #errorcode_msg{type = err331_not_buy,about = "还未购买解锁哦~"};

get(3310137) ->
    #errorcode_msg{type = err331_cd_chat,about = "冷却中，无法操作"};

get(3310138) ->
    #errorcode_msg{type = err331_have_answered,about = "已有玩家回答，无需重复操作"};

get(3310139) ->
    #errorcode_msg{type = err331_no_people_quiz,about = "无人提问，无法操作"};

get(3310140) ->
    #errorcode_msg{type = err331_formula_need_unlock,about = "该配方还未被发现，无法操作"};

get(3310141) ->
    #errorcode_msg{type = err331_great_reward_lv_err,about = "未达到领取奖励等级哟"};

get(3310142) ->
    #errorcode_msg{type = err331_great_reward_recharge_not_enough,about = "当前充值金额不满足哟"};

get(3310143) ->
    #errorcode_msg{type = err331_great_reward_consume_not_enough,about = "当前消费金额不满足哟"};

get(3310144) ->
    #errorcode_msg{type = err331_great_reward_type_err,about = "奖励参数类型错误"};

get(3310145) ->
    #errorcode_msg{type = err331_great_reward_reward_err,about = "超能大奖奖励配置错误"};

get(3310146) ->
    #errorcode_msg{type = err331_great_reward_has_received,about = "奖励已经领取过了喔"};

get(3310147) ->
    #errorcode_msg{type = err331_cannot_answer_yourself,about = "无法自问自答"};

get(3310148) ->
    #errorcode_msg{type = err331_great_reward_must_receive_all,about = "需要先领取完前面的奖励哟"};

get(3310149) ->
    #errorcode_msg{type = err331_have_unlocked_formula,about = "您已解锁该配方，无法操作"};

get(3310150) ->
    #errorcode_msg{type = err331_have_not_unlocked_formula,about = "您还未解锁该配方，无法操作"};

get(3310151) ->
    #errorcode_msg{type = err331_not_discover_fomula,about = "该配方还未发现，无法操作"};

get(3330001) ->
    #errorcode_msg{type = err333_act_closed,about = "活动未开放"};

get(3330002) ->
    #errorcode_msg{type = err333_not_connect_center,about = "未连接跨服"};

get(3330003) ->
    #errorcode_msg{type = err333_no_cost_config,about = "缺配置"};

get(3330004) ->
    #errorcode_msg{type = err333_no_pool_cfg,about = "缺奖池配置"};

get(3330005) ->
    #errorcode_msg{type = err333_role_lev_less,about = "玩家等级不足"};

get(3330006) ->
    #errorcode_msg{type = err333_already_get_reward,about = "奖励不可重复领取"};

get(3330007) ->
    #errorcode_msg{type = err333_no_times_reward_cfg,about = "缺配置"};

get(3330008) ->
    #errorcode_msg{type = err333_can_not_get,about = "不可领取"};

get(3330009) ->
    #errorcode_msg{type = err333_server_score_unreached,about = "全服积分未达标"};

get(3380001) ->
    #errorcode_msg{type = err338_act_not_open,about = "活动还未开启"};

get(3380002) ->
    #errorcode_msg{type = err338_has_got,about = "已领取"};

get(3380003) ->
    #errorcode_msg{type = err338_lack_of_score,about = "积分不足"};

get(3380004) ->
    #errorcode_msg{type = err338_not_this_choice,about = "没有该抽奖次数"};

get(3380005) ->
    #errorcode_msg{type = err338_point_later,about = "当前重置时间，请稍后点击"};

get(3390000) ->
    #errorcode_msg{type = err339_split_max_num_err,about = "红包个数不能超过金额/社团人数上限"};

get(3390001) ->
    #errorcode_msg{type = err339_split_min_num_err,about = "红包个数不能小于最小数量限制"};

get(3390002) ->
    #errorcode_msg{type = err339_not_exist,about = "红包不存在"};

get(3390003) ->
    #errorcode_msg{type = err339_has_expired,about = "红包已过期"};

get(3390004) ->
    #errorcode_msg{type = err339_not_send,about = "红包为未发送状态，不能领取"};

get(3390005) ->
    #errorcode_msg{type = err339_daily_times_no_enough,about = "今天该红包的发送次数已用完"};

get(3390006) ->
    #errorcode_msg{type = err339_not_join_guild,about = "没有加入社团，不能发红包"};

get(3390007) ->
    #errorcode_msg{type = err339_not_owner,about = "该红包不属于你，不能发送"};

get(3390008) ->
    #errorcode_msg{type = err339_vip_lv_not_enough,about = "vip等级不足"};

get(3390009) ->
    #errorcode_msg{type = err339_cannot_send_again,about = "红包已被发出，不能重复发送"};

get(3390010) ->
    #errorcode_msg{type = err339_is_limit,about = "领取金额达上限"};

get(3390011) ->
    #errorcode_msg{type = err339_no_in_scene,about = "击杀当时不在场"};

get(3390012) ->
    #errorcode_msg{type = err339_length_not_match,about = "祝福语长度不匹配"};

get(3390013) ->
    #errorcode_msg{type = err339_has_over,about = "手慢了"};

get(3400001) ->
    #errorcode_msg{type = err340_check_currencywish_fail,about = "当日祈愿超过上限"};

get(3400002) ->
    #errorcode_msg{type = err340_undefined_currencywish_type,about = "非法祈愿类型"};

get(3400003) ->
    #errorcode_msg{type = err340_no_enough_consume,about = "祈愿所需消耗物品不足"};

get(4000001) ->
    #errorcode_msg{type = err400_guild_name_len,about = "社团名字长度不匹配"};

get(4000002) ->
    #errorcode_msg{type = err400_guild_name_sensitive,about = "社团名字含有敏感字"};

get(4000003) ->
    #errorcode_msg{type = err400_tenet_len,about = "社团公告长度不匹配"};

get(4000004) ->
    #errorcode_msg{type = err400_tenet_sensitive,about = "社团宣言含有敏感字"};

get(4000005) ->
    #errorcode_msg{type = err400_on_guild_not_to_create,about = "您已经有社团了~"};

get(4000006) ->
    #errorcode_msg{type = err400_create_guild_cfg,about = "创建社团出错"};

get(4000007) ->
    #errorcode_msg{type = err400_not_station_scene_to_leave,about = "无法退出社团驻地"};

get(4000008) ->
    #errorcode_msg{type = err400_announce_sensitive,about = "公告有敏感字"};

get(4000009) ->
    #errorcode_msg{type = err400_announce_len,about = "公告过长"};

get(4000010) ->
    #errorcode_msg{type = err400_not_on_guild_to_modify_announce,about = "没有社团无法修改公告"};

get(4000011) ->
    #errorcode_msg{type = err400_auto_approve_power_error,about = "输入自动加入战力错误"};

get(4000012) ->
    #errorcode_msg{type = err400_auto_approve_lv_error,about = "输入自动加入等级错误"};

get(4000013) ->
    #errorcode_msg{type = err400_approve_type_error,about = "设置审批类型出错"};

get(4000014) ->
    #errorcode_msg{type = err400_this_scene_not_to_enter_station,about = "本场景无法进入社团驻地"};

get(4000015) ->
    #errorcode_msg{type = err400_not_on_guild_to_station,about = "无社团无法进入社团驻地"};

get(4000016) ->
    #errorcode_msg{type = err400_on_guild_not_to_apply,about = "处于社团中无法申请加入社团"};

get(4000017) ->
    #errorcode_msg{type = err400_not_permission_to_clean_apply,about = "您没有权限~"};

get(4000018) ->
    #errorcode_msg{type = err400_not_on_guild_to_clean_apply,about = "不在社团无法清理社团申请"};

get(4000019) ->
    #errorcode_msg{type = err400_can_not_modify_other_permission,about = "不能修改对方的权限"};

get(4000020) ->
    #errorcode_msg{type = err400_not_on_guild_to_modify_permission,about = "不在社团无法修改权限"};

get(4000021) ->
    #errorcode_msg{type = err400_not_right_is_allow_on_modify_permission,about = "发送的权限修改参数出错"};

get(4000022) ->
    #errorcode_msg{type = err400_not_modifiable_permission,about = "该权限不能被修改"};

get(4000023) ->
    #errorcode_msg{type = err400_not_modified_permission_pos,about = "本职位不能被修改权限"};

get(4000024) ->
    #errorcode_msg{type = err400_not_guild_apply,about = "没有向该社团申请"};

get(4000025) ->
    #errorcode_msg{type = err400_not_permission_to_rename_position,about = "没有权限设置称谓"};

get(4000026) ->
    #errorcode_msg{type = err400_not_on_guild_to_rename_position,about = "不在社团无法设置称谓"};

get(4000027) ->
    #errorcode_msg{type = err400_not_modified_name_pos,about = "本职位名字不能被修改"};

get(4000028) ->
    #errorcode_msg{type = err400_position_name_sensitive,about = "输入称谓含有敏感字"};

get(4000029) ->
    #errorcode_msg{type = err400_position_name_len,about = "输入称谓过长"};

get(4000030) ->
    #errorcode_msg{type = err400_this_position_can_not_kick_member,about = "你的权限不足"};

get(4000031) ->
    #errorcode_msg{type = err400_not_permission_to_kick,about = "没有权限踢除玩家"};

get(4000032) ->
    #errorcode_msg{type = err400_not_same_guild_to_kick,about = "只能踢出本社团的玩家"};

get(4000033) ->
    #errorcode_msg{type = err400_not_on_guild_to_kicked,about = "对方不在社团无法被踢出"};

get(4000034) ->
    #errorcode_msg{type = err400_not_on_guild_to_kick,about = "不在社团无法踢除玩家"};

get(4000035) ->
    #errorcode_msg{type = err400_this_position_can_not_resign,about = "本职位无法辞退"};

get(4000036) ->
    #errorcode_msg{type = err400_not_on_guild_to_resign_position,about = "不在社团不能辞退"};

get(4000037) ->
    #errorcode_msg{type = err400_not_permission_to_modify_announce,about = "没有权限修改公告"};

get(4000038) ->
    #errorcode_msg{type = err400_not_on_guild_to_modify_tenet,about = "不在社团无法修改宣言"};

get(4000039) ->
    #errorcode_msg{type = err400_not_permission_to_modify_tenet,about = "没有权限修改宣言"};

get(4000040) ->
    #errorcode_msg{type = err400_not_permission_to_modify_approve_setting,about = "没有权限修改审批设置"};

get(4000041) ->
    #errorcode_msg{type = err400_not_on_guild_to_modify_approve_setting,about = "不在社团无法审批设置"};

get(4000042) ->
    #errorcode_msg{type = err400_chief_not_to_quit,about = "团长无法直接退出社团"};

get(4000043) ->
    #errorcode_msg{type = err400_not_on_guild_to_quit,about = "不在社团无法退出社团"};

get(4000044) ->
    #errorcode_msg{type = err400_guild_name_same_not_to_create,about = "社团名字相同无法创建"};

get(4000045) ->
    #errorcode_msg{type = err400_this_position_full,about = "本职位已经满人"};

get(4000046) ->
    #errorcode_msg{type = err400_chief_not_exist,about = "团长不存在"};

get(4000048) ->
    #errorcode_msg{type = err400_not_allow_appoint,about = "不允许任命"};

get(4000049) ->
    #errorcode_msg{type = err400_must_have_chief,about = "必须要有团长哦"};

get(4000051) ->
    #errorcode_msg{type = err400_same_target_position,about = "任命新职位相同"};

get(4000052) ->
    #errorcode_msg{type = err400_not_same_guild_to_appoint,about = "只能任命同社团"};

get(4000053) ->
    #errorcode_msg{type = err400_guild_not_exist,about = "社团不存在"};

get(4000054) ->
    #errorcode_msg{type = err400_not_on_guild_to_appointed,about = "对方不在社团不能被任命"};

get(4000056) ->
    #errorcode_msg{type = err400_not_on_guild_to_appoint,about = "不在社团无法任命"};

get(4000057) ->
    #errorcode_msg{type = err400_not_permission_to_approve,about = "没有权限审批"};

get(4000058) ->
    #errorcode_msg{type = err400_not_apply,about = "没有该社团申请"};

get(4000059) ->
    #errorcode_msg{type = err400_approver_not_on_guild,about = "申请人不在社团"};

get(4000061) ->
    #errorcode_msg{type = err400_can_not_join,about = "不能加入社团"};

get(4000062) ->
    #errorcode_msg{type = err400_guild_apply_len_limit,about = "社团申请列表已满"};

get(4000063) ->
    #errorcode_msg{type = err400_member_enough,about = "社团人数已满"};

get(4000064) ->
    #errorcode_msg{type = err400_apply_realm_not_same,about = "申请的社团阵营不同"};

get(4000065) ->
    #errorcode_msg{type = err400_this_guild_not_exist_to_apply,about = "无法申请不存在的社团"};

get(4000066) ->
    #errorcode_msg{type = err400_is_apply_this_guild,about = "已经申请过本社团"};

get(4000083) ->
    #errorcode_msg{type = err400_not_config,about = "缺失配置"};

get(4000094) ->
    #errorcode_msg{type = err400_not_on_guild_to_modify_approve,about = "不在社团无法处理请求"};

get(4000095) ->
    #errorcode_msg{type = err400_not_allow_appoint_again,about = "不能重复任命"};

get(4000096) ->
    #errorcode_msg{type = err400_appoint_position_to_leader_only,about = "只允许任命一个领袖"};

get(4000097) ->
    #errorcode_msg{type = err400_not_allow_appoint_to_chief_again,about = "不能重复任命哦~"};

get(4000098) ->
    #errorcode_msg{type = err400_appoint_position_to_chief_only,about = "只允许任命一个团长"};

get(4000101) ->
    #errorcode_msg{type = err400_other_have_guild_not_to_join,about = "对方已有社团，无法加入"};

get(4000106) ->
    #errorcode_msg{type = err400_invitee_having_on_guild,about = "被邀请者已经在社团"};

get(4000107) ->
    #errorcode_msg{type = err400_not_enough_lv_to_apply_join_guild,about = "等级不足，无法加入社团"};

get(4000108) ->
    #errorcode_msg{type = err400_not_enough_lv_to_create_guild,about = "等级不足，无法创建社团"};

get(4000109) ->
    #errorcode_msg{type = err400_not_find_guild,about = "未找到社团"};

get(4000110) ->
    #errorcode_msg{type = err400_refuse_apply,about = "对方拒绝了你的申请"};

get(4000111) ->
    #errorcode_msg{type = err400_guild_name_null,about = "社团名不能为空"};

get(4000112) ->
    #errorcode_msg{type = err400_no_permission,about = "您没有权限"};

get(4000113) ->
    #errorcode_msg{type = err400_guild_full_lv,about = "社团已满级"};

get(4000114) ->
    #errorcode_msg{type = err400_not_satisfy_upgrade_guild_condition,about = "不满足升级社团条件"};

get(4000115) ->
    #errorcode_msg{type = err400_has_receive_salary,about = "已经领取过本日工资，不能重复领取"};

get(4000116) ->
    #errorcode_msg{type = err400_not_join_guild,about = "没有加入社团"};

get(4000117) ->
    #errorcode_msg{type = err400_not_peimission_research,about = "您没有权限研究社团技能"};

get(4000118) ->
    #errorcode_msg{type = err400_gskill_locked,about = "社团技能未解锁"};

get(4000119) ->
    #errorcode_msg{type = err400_gfunds_not_enough,about = "社团资金不足"};

get(4000120) ->
    #errorcode_msg{type = err400_guild_lv_not_satisfy_research,about = "社团等级不满足技能研究要求"};

get(4000121) ->
    #errorcode_msg{type = err400_max_research_lv,about = "技能研究已满级"};

get(4000122) ->
    #errorcode_msg{type = err400_research_lv_limit,about = "已达社团研究上限，无法学习"};

get(4000123) ->
    #errorcode_msg{type = err400_role_lv_not_satisfy_learn,about = "玩家等级不满足技能学习要求"};

get(4000124) ->
    #errorcode_msg{type = err400_gdonate_not_satisfy_learn,about = "社团贡献值不足，无法学习"};

get(4000125) ->
    #errorcode_msg{type = err400_approve_success,about = "批准成功"};

get(4000126) ->
    #errorcode_msg{type = err400_apply_refuse,about = "拒绝成功"};

get(4000127) ->
    #errorcode_msg{type = err400_dominator_guild_can_not_disband,about = "王者社团不能解散"};

get(4000128) ->
    #errorcode_msg{type = err400_no_guild,about = "玩家未加入社团"};

get(4000129) ->
    #errorcode_msg{type = err400_guild_name_same,about = "和当前社团名相同，请重新输入"};

get(4000130) ->
    #errorcode_msg{type = err400_guild_name_repeat,about = "和其他社团名重复了哦，请重新输入"};

get(4000131) ->
    #errorcode_msg{type = err400_leave_again_apply,about = "距离上次退出社团不足1小时"};

get(4000132) ->
    #errorcode_msg{type = err400_position_not_allow,about = "所在职位不可领取"};

get(4000133) ->
    #errorcode_msg{type = err400_building_not_active,about = "建筑还未激活"};

get(4000134) ->
    #errorcode_msg{type = err400_has_limit,about = "已达上限"};

get(4000135) ->
    #errorcode_msg{type = err400_num_not_enough,about = "数量不足"};

get(4000136) ->
    #errorcode_msg{type = err400_building_has_limit,about = "建筑已达最高级"};

get(4000137) ->
    #errorcode_msg{type = err400_not_allow_upgrade_building,about = "没有权限升级建筑"};

get(4000138) ->
    #errorcode_msg{type = err400_not_allow_when_guild_war,about = "本服团战期间，无法进行该操作！"};

get(4000140) ->
    #errorcode_msg{type = err400_not_allow_when_guard,about = "社团活动期间，无法进行该项操作"};

get(4000141) ->
    #errorcode_msg{type = err400_time_not_enough,about = "创建社团不足24小时"};

get(4000142) ->
    #errorcode_msg{type = err400_member_num_enough,about = "人数大于最低人数限制"};

get(4000143) ->
    #errorcode_msg{type = err400_please_select,about = "请先选择"};

get(4000144) ->
    #errorcode_msg{type = err400_building_lv_not_enough,about = "建筑等级不足"};

get(4000145) ->
    #errorcode_msg{type = err400_point_quickly,about = "手速太快"};

get(4000146) ->
    #errorcode_msg{type = err400_liveness_not_enough,about = "个人活跃度不足100，无法领取"};

get(4000148) ->
    #errorcode_msg{type = err400_not_than_guild_lv,about = "不能超过社团大厅等级"};

get(4000149) ->
    #errorcode_msg{type = err400_modify_times_limit,about = "公告修改次数达每日上限"};

get(4000150) ->
    #errorcode_msg{type = err400_condition_not_enough,about = "条件不足"};

get(4000151) ->
    #errorcode_msg{type = err400_guild_flag_used,about = "社团旗帜已被使用"};

get(4000152) ->
    #errorcode_msg{type = err400_is_apply_position,about = "已经申请了一个公会职位"};

get(4000153) ->
    #errorcode_msg{type = err400_has_been_agent,about = "你已经是代理团长"};

get(4000155) ->
    #errorcode_msg{type = err400_cant_apply_now,about = "还未到可申请时间"};

get(4000156) ->
    #errorcode_msg{type = err400_apply_same_position,about = "已任职本职位"};

get(4000157) ->
    #errorcode_msg{type = err400_chief_cannot_apply,about = "团长不可申请"};

get(4000158) ->
    #errorcode_msg{type = err400_no_need_more_agent,about = "已有代理团长"};

get(4000159) ->
    #errorcode_msg{type = err400_guild_lv_not_enough,about = "社团等级不符"};

get(4000160) ->
    #errorcode_msg{type = err400_role_lv_not_reached,about = "玩家等级不符"};

get(4000161) ->
    #errorcode_msg{type = err400_limit_buy_more,about = "超过购买上限"};

get(4000162) ->
    #errorcode_msg{type = err400_has_apply_unfinished,about = "有合并申请还未处理"};

get(4000163) ->
    #errorcode_msg{type = err400_cant_apply_again,about = "不可连续发起重复的合并申请"};

get(4000164) ->
    #errorcode_msg{type = err400_no_enough_capacity,about = "社团内没有足够位置"};

get(4000165) ->
    #errorcode_msg{type = err400_opposite_no_enough_capacity,about = "对方社团没有足够位置"};

get(4000166) ->
    #errorcode_msg{type = err400_opposite_has_apply_unfinished,about = "对方已有未处理的合并事务"};

get(4000167) ->
    #errorcode_msg{type = err400_iden_err,about = "未收到合并申请"};

get(4000168) ->
    #errorcode_msg{type = err400_iden_applyer,about = "对方不是你的合并对象"};

get(4000171) ->
    #errorcode_msg{type = err400_order_overdue,about = "订单已过期"};

get(4000173) ->
    #errorcode_msg{type = err400_exist_order_undeal,about = "存在已接订单未处理"};

get(4000178) ->
    #errorcode_msg{type = err400_already_in_tribe,about = "已在社团驻地中"};

get(4000179) ->
    #errorcode_msg{type = err400_lv_unreachable_enter,about = "100级才可进入社团驻地喔"};

get(4000180) ->
    #errorcode_msg{type = err400_not_allow_kickout_when_guild_boss,about = "社团BOSS活动期间不可退出"};

get(4000181) ->
    #errorcode_msg{type = err400_support_not_exits,about = "支援不存在"};

get(4000182) ->
    #errorcode_msg{type = err400_is_supporting,about = "您正在协助啦"};

get(4000183) ->
    #errorcode_msg{type = err400_has_ask,about = "您已经发送请求了"};

get(4000184) ->
    #errorcode_msg{type = err400_not_team_leader,about = "不是队长，不能发请求喔"};

get(4000185) ->
    #errorcode_msg{type = err400_not_in_guild,about = "您还没有进入公会"};

get(4000186) ->
    #errorcode_msg{type = err400_in_team,about = "已经在队伍中，不能去协助喔"};

get(4000187) ->
    #errorcode_msg{type = err400_can_not_be_asker,about = "请求者不能协助自己的请求"};

get(4000188) ->
    #errorcode_msg{type = err400_support_has_finish,about = "协助已经完成了"};

get(4000189) ->
    #errorcode_msg{type = err400_support_not_action,about = "协助还没开始喔"};

get(4000190) ->
    #errorcode_msg{type = err400_support_role_num_max,about = "协助队伍已经满了"};

get(4000191) ->
    #errorcode_msg{type = err400_max_daily_reputation,about = "已经达到今天最大的声望值啦"};

get(4000192) ->
    #errorcode_msg{type = err400_support_reward_not_exits,about = "支援奖励不存在"};

get(4000193) ->
    #errorcode_msg{type = err400_not_support_reward_good,about = "不是支援奖励礼包，不可直接使用喔"};

get(4000194) ->
    #errorcode_msg{type = err400_guild_not_exists,about = "发送协助的社团不存在喔"};

get(4000195) ->
    #errorcode_msg{type = err400_is_asker,about = "您已经请求协助，不能去协助其他玩家喔"};

get(4000196) ->
    #errorcode_msg{type = err400_inconformity_merge_condition,about = "不符合合并条件"};

get(4000197) ->
    #errorcode_msg{type = err400_refuse_apply_lv,about = "玩家等级不足"};

get(4000198) ->
    #errorcode_msg{type = err400_refuse_apply_power,about = "玩家战力不足"};

get(4000199) ->
    #errorcode_msg{type = err400_lv_not_enough,about = "还没达到玩法的等级喔"};

get(4000200) ->
    #errorcode_msg{type = err400_not_allow_merge_when_guild_boss,about = "社团幻魔期间不可进行合并"};

get(4000201) ->
    #errorcode_msg{type = err400_guild_call_frequent,about = "召唤太频繁了"};

get(4000202) ->
    #errorcode_msg{type = err400_need_same_guild,about = "需要相同社团"};

get(4000203) ->
    #errorcode_msg{type = err400_no_need_join_again,about = "不需要重复加入"};

get(4000204) ->
    #errorcode_msg{type = err400_no_need_more_team,about = "已经找到协助者啦"};

get(4000205) ->
    #errorcode_msg{type = err400_guild_order_miss,about = "已错过任务拼单"};

get(4000206) ->
    #errorcode_msg{type = err400_need_anchor_order,about = "需要先选中任务"};

get(4000207) ->
    #errorcode_msg{type = err400_order_already_alive,about = "任务处于待完成状态"};

get(4000208) ->
    #errorcode_msg{type = err400_order_repeate_anchor,about = "不需要重复选中"};

get(4000209) ->
    #errorcode_msg{type = err400_order_need_anchor,about = "需要先选定任务"};

get(4000210) ->
    #errorcode_msg{type = err400_order_need_more_helper,about = "需要更多的协助者"};

get(4000211) ->
    #errorcode_msg{type = err400_guild_order_max,about = "已达今日拼单最大次数"};

get(4000212) ->
    #errorcode_msg{type = err400_order_already_over,about = "拼单任务已完成"};

get(4000213) ->
    #errorcode_msg{type = err400_not_in_tribe,about = "不在社团驻地"};

get(4000214) ->
    #errorcode_msg{type = err400_has_no_fake_helper,about = "无小助手"};

get(4000215) ->
    #errorcode_msg{type = err400_need_no_more_fake_helper,about = "不可邀请更多小助手"};

get(4000216) ->
    #errorcode_msg{type = err400_cannot_support,about = "当前玩法中不能前往协助喔"};

get(4000217) ->
    #errorcode_msg{type = err400_pls_exit_guild_scene,about = "请先退出驻地再操作！"};

get(4000218) ->
    #errorcode_msg{type = err400_support_input_err,about = "协助输入数据错误"};

get(4000219) ->
    #errorcode_msg{type = err400_support_thank_has_receive,about = "感谢奖励已经领取过了哦~"};

get(4000220) ->
    #errorcode_msg{type = err400_has_thank,about = "已经发送过感谢了哦~"};

get(4000221) ->
    #errorcode_msg{type = err400_support_thank_overdue,about = "感谢信过期了哦~"};

get(4000222) ->
    #errorcode_msg{type = err400_support_count_not_enough,about = "当前活动协助次数不足喔~"};

get(4000223) ->
    #errorcode_msg{type = err400_this_order_over,about = "该拼单已经完成"};

get(4000224) ->
    #errorcode_msg{type = err400_order_max_people_num,about = "拼单人数已达上限"};

get(4000225) ->
    #errorcode_msg{type = err400_guild_merge_need_more_day,about = "开服第八天才可进行社团合并"};

get(4000226) ->
    #errorcode_msg{type = err400_tar_guild_living,about = "对方为高活跃社团，无法进行合并"};

get(4000227) ->
    #errorcode_msg{type = err400_in_guild_collect,about = "社团采集中"};

get(4000228) ->
    #errorcode_msg{type = err400_tar_guild_wait,about = "评级待定社团不能被合并"};

get(4010000) ->
    #errorcode_msg{type = err401_not_in_depot,about = "仓库已满，无法继续捐献"};

get(4010001) ->
    #errorcode_msg{type = err401_goods_not_in_depot,about = "该道具不在社团仓库里面"};

get(4010002) ->
    #errorcode_msg{type = err401_goods_can_not_add_to_depot,about = "该道具不能捐献"};

get(4010003) ->
    #errorcode_msg{type = err401_depot_score_not_enough,about = "仓库积分不足，无法兑换"};

get(4010004) ->
    #errorcode_msg{type = err401_bag_cell_not_enough,about = "背包空间不足，无法兑换"};

get(4010005) ->
    #errorcode_msg{type = err401_exchange_num_err,about = "兑换数量错误"};

get(4010006) ->
    #errorcode_msg{type = err401_no_permission_to_destory,about = "您没有权限销毁仓库的物品"};

get(4010007) ->
    #errorcode_msg{type = err401_has_limit,about = "已超过上限"};

get(4010008) ->
    #errorcode_msg{type = err401_num_error,about = "数量异常"};

get(4010009) ->
    #errorcode_msg{type = err401_handle_quickly,about = "操作太快"};

get(4010010) ->
    #errorcode_msg{type = err401_please_select,about = "请选择装备"};

get(4020000) ->
    #errorcode_msg{type = err402_no_in_act_scene,about = "不在活动场景"};

get(4020001) ->
    #errorcode_msg{type = err402_no_join_guild,about = "您未加入社团，不能进入活动场景"};

get(4020002) ->
    #errorcode_msg{type = err402_no_enough_lv_join,about = "等级不足，无法参与活动"};

get(4020003) ->
    #errorcode_msg{type = err402_act_close,about = "活动未开启"};

get(4021009) ->
    #errorcode_msg{type = err402_not_in_act_cfg_open_time,about = "不在活动时间，不能开启活动"};

get(4021013) ->
    #errorcode_msg{type = err402_no_challenge_times,about = "挑战次数不足"};

get(4021014) ->
    #errorcode_msg{type = err402_guild_guard_end,about = "您所在社团的守卫活动已结束"};

get(4021015) ->
    #errorcode_msg{type = err402_not_battle_stage,about = "战斗尚未开启"};

get(4021016) ->
    #errorcode_msg{type = err402_gwar_no_qualification,about = "所属社团没有参与资格"};

get(4021017) ->
    #errorcode_msg{type = err402_can_not_change_scene_in_gwar,about = "玩家正处于社团争霸活动，不能参加其他活动"};

get(4021018) ->
    #errorcode_msg{type = err402_gwar_battle_end,about = "该赛区战斗已结束"};

get(4021019) ->
    #errorcode_msg{type = err402_join_in_guild_not_enough_time,about = "加入社团超过1小时的成员才可参与"};

get(4021020) ->
    #errorcode_msg{type = err402_can_not_join_action_this_scene,about = "当前场景无法进入活动"};

get(4021021) ->
    #errorcode_msg{type = err402_not_dominator,about = "您的社团不是冠军社团"};

get(4021022) ->
    #errorcode_msg{type = err402_join_in_guild_not_enough_time_can_not_receive,about = "加入社团时间不足24小时，无法领取"};

get(4021023) ->
    #errorcode_msg{type = err402_has_receive_salary_paul,about = "今天已领取过俸禄"};

get(4021024) ->
    #errorcode_msg{type = err402_no_null_cell_receive_salary_paul,about = "背包已满，请整理后再来领取"};

get(4021025) ->
    #errorcode_msg{type = err402_not_in_guild,about = "该玩家和您不在同一个社团"};

get(4021026) ->
    #errorcode_msg{type = err402_unacommpolished_streak_times,about = "未达成连胜条件"};

get(4021027) ->
    #errorcode_msg{type = err402_reward_has_allot,about = "奖励已经分配过了"};

get(4021028) ->
    #errorcode_msg{type = err402_no_permission_allot,about = "职位权限不够，无法分配"};

get(4021029) ->
    #errorcode_msg{type = err402_unacommpolished,about = "未达成奖励条件"};

get(4021030) ->
    #errorcode_msg{type = err402_cant_quit_guild_when_gwar_open,about = "社团争霸期间不能退出社团/踢除社团成员"};

get(4021031) ->
    #errorcode_msg{type = err402_cant_appoint_chief_when_gwar_open,about = "社团争霸开启期间不能任命社团团长"};

get(4021032) ->
    #errorcode_msg{type = err402_cant_disband_when_gwar_open,about = "社团争霸开启期间不能解散社团"};

get(4021033) ->
    #errorcode_msg{type = err402_gwar_role_num_lim,about = "战场人数已满"};

get(4021035) ->
    #errorcode_msg{type = err402_guild_not_open,about = "本社团未开启该活动"};

get(4021036) ->
    #errorcode_msg{type = err402_not_summon_stage,about = "当前不是召唤阶段"};

get(4021037) ->
    #errorcode_msg{type = err402_has_summon,about = "已有人召唤"};

get(4021038) ->
    #errorcode_msg{type = err402_has_add_limit,about = "已达上限"};

get(4021039) ->
    #errorcode_msg{type = err402_no_inspire_times,about = "没有鼓舞次数了"};

get(4021040) ->
    #errorcode_msg{type = err402_equip_not_enouht,about = "后备攻城器械不足"};

get(4021041) ->
    #errorcode_msg{type = err402_donate_not_enough,about = "社团贡献不足"};

get(4021042) ->
    #errorcode_msg{type = err402_too_much_blunt,about = "只能同时存在两辆冲车"};

get(4021043) ->
    #errorcode_msg{type = err402_too_much_camion,about = "只能同时存在两辆炮车"};

get(4021044) ->
    #errorcode_msg{type = err402_gwar_direct_win,about = "所属赛区战斗轮空，本社团获得胜利"};

get(4021045) ->
    #errorcode_msg{type = err402_inspire_success,about = "鼓舞成功，当前伤害减免加成{1}%"};

get(4021046) ->
    #errorcode_msg{type = err402_guild_limit_times,about = "本社团达到召唤次数上限"};

get(4021047) ->
    #errorcode_msg{type = err402_role_limit_times,about = "个人召唤次数达到上限"};

get(4021048) ->
    #errorcode_msg{type = err402_guard_lv_limit,about = "150级可参与"};

get(4040001) ->
    #errorcode_msg{type = err404_need_more_lador,about = "需要更多的社团活跃值"};

get(4040002) ->
    #errorcode_msg{type = err404_need_more_role_lador,about = "需要更多的个人活跃值"};

get(4050000) ->
    #errorcode_msg{type = err405_in_guild_war,about = "参与本服团战中！"};

get(4050001) ->
    #errorcode_msg{type = err405_has_no_guild,about = "加入社团即可参加本服团战！"};

get(4050002) ->
    #errorcode_msg{type = err405_guild_war_not_open,about = "活动尚未开始！"};

get(4050003) ->
    #errorcode_msg{type = err405_guild_war_distance,about = "请前往提交物资！"};

get(4050004) ->
    #errorcode_msg{type = err405_guild_war_no_collection,about = "请前往收集物资！"};

get(4050005) ->
    #errorcode_msg{type = err405_guild_war_repeat_collect,about = "已经采集到物资了！"};

get(4050006) ->
    #errorcode_msg{type = err405_max_role,about = "当前战区已经爆满！"};

get(4050007) ->
    #errorcode_msg{type = err405_skill_cd,about = "技能冷却中！"};

get(4060001) ->
    #errorcode_msg{type = err406_inspire_times_limit,about = "鼓舞次数不足"};

get(4060002) ->
    #errorcode_msg{type = err406_not_open,about = "活动没开"};

get(4060003) ->
    #errorcode_msg{type = err406_now_collecting,about = "正在采集"};

get(4060004) ->
    #errorcode_msg{type = err406_need_finish_collect,about = "需要完成采集"};

get(4060005) ->
    #errorcode_msg{type = err406_not_drop,about = "没有该掉落哟"};

get(4060006) ->
    #errorcode_msg{type = err406_has_refuse,about = "您已经错过该掉落roll点了"};

get(4060007) ->
    #errorcode_msg{type = err406_has_roll,about = "您已经摇过骰子了哟"};

get(4060008) ->
    #errorcode_msg{type = err406_time_pass,about = "摇骰子时间已经过了哟"};

get(4070001) ->
    #errorcode_msg{type = err407_not_receive_time,about = "还未到奖励领取时间哟"};

get(4070002) ->
    #errorcode_msg{type = err407_has_received,about = "已经领取过奖励了哟"};

get(4070003) ->
    #errorcode_msg{type = err407_cannot_receive,about = "您未能领取奖励哟"};

get(4070004) ->
    #errorcode_msg{type = err407_not_captain,about = "您还不能领取这份奖励喔"};

get(4070005) ->
    #errorcode_msg{type = err407_is_not_captain,about = "不是团长不能领取哟"};

get(4070006) ->
    #errorcode_msg{type = err407_not_finish_task,about = "任务还未完成喔"};

get(4070007) ->
    #errorcode_msg{type = err407_task_cfg_err,about = "任务配置错误"};

get(4090001) ->
    #errorcode_msg{type = err409_not_finish,about = "成就未达成，无法领取奖励喔"};

get(4090002) ->
    #errorcode_msg{type = err409_has_received,about = "已经领取过奖励"};

get(4090003) ->
    #errorcode_msg{type = err409_lv_not_reach,about = "您还未达到领取特权奖励的等级喔"};

get(4090004) ->
    #errorcode_msg{type = err409_category_not_finish,about = "章节未完成，无法领取奖励喔"};

get(4090005) ->
    #errorcode_msg{type = err409_config_err,about = "特权配置错误"};

get(4090006) ->
    #errorcode_msg{type = err409_count_not_enough,about = "兑换次数用完啦"};

get(4090007) ->
    #errorcode_msg{type = err409_param_err,about = "参数错误"};

get(4090008) ->
    #errorcode_msg{type = err409_pre_id,about = "先领取上一个任务的奖励哟"};

get(4100001) ->
    #errorcode_msg{type = err410_open_day_limit,about = "开服天数不足，无法操作"};

get(4100002) ->
    #errorcode_msg{type = err410_on_camp_war,about = "正处于本国团战中"};

get(4100003) ->
    #errorcode_msg{type = err410_not_on_camp_war,about = "不在本国团战中"};

get(4100004) ->
    #errorcode_msg{type = err410_serv_zone_error,about = "服务器分区数据异常"};

get(4100005) ->
    #errorcode_msg{type = err410_need_guild_war,about = "请先参加本服团战！"};

get(4100006) ->
    #errorcode_msg{type = err410_frequent,about = "召唤太频繁啦!"};

get(4110001) ->
    #errorcode_msg{type = err411_current_not_exist,about = "当前使用的称号不存在"};

get(4110002) ->
    #errorcode_msg{type = err411_not_need_change,about = "切换的是当前使用的称号，不需切换"};

get(4110003) ->
    #errorcode_msg{type = err411_hide_error,about = "隐藏称号错误"};

get(4110004) ->
    #errorcode_msg{type = err411_change_error,about = "称号未激活，切换称号失败"};

get(4110005) ->
    #errorcode_msg{type = err411_is_expired,about = "称号已过期"};

get(4110006) ->
    #errorcode_msg{type = err411_already_exist,about = "[称号已拥有，无需再次激活]"};

get(4110007) ->
    #errorcode_msg{type = err411_config_error,about = "称号配置有误"};

get(4110008) ->
    #errorcode_msg{type = err411_dgst_can_not_overlay,about = "该称号无法叠加"};

get(4120001) ->
    #errorcode_msg{type = err412_cfg_not_exist,about = "配置不存在"};

get(4120002) ->
    #errorcode_msg{type = err412_goods_not_exist,about = "物品不存在"};

get(4120003) ->
    #errorcode_msg{type = err412_learn_sk_err1,about = "没有可用技能位置"};

get(4120004) ->
    #errorcode_msg{type = err412_learn_sk_err2,about = "学习技能的位置超出范围"};

get(4120005) ->
    #errorcode_msg{type = err412_learn_sk_err3,about = "学习的技能已存在"};

get(4120006) ->
    #errorcode_msg{type = err412_replace_sk_err1,about = "被替换的位置不存在技能"};

get(4120007) ->
    #errorcode_msg{type = err412_no_sk_book,about = "没有合适的技能书"};

get(4120008) ->
    #errorcode_msg{type = err412_recruit_not_free,about = "非免费招募"};

get(4120009) ->
    #errorcode_msg{type = err412_partner_not_exist,about = "伙伴不存在"};

get(4120010) ->
    #errorcode_msg{type = err412_wash_goods_err1,about = "洗髓物品不足"};

get(4120011) ->
    #errorcode_msg{type = err412_partner_state_err,about = "伙伴状态不对"};

get(4120012) ->
    #errorcode_msg{type = err412_upgrade_lv_err,about = "升级错误,伙伴等级已大于等于玩家等级"};

get(4120013) ->
    #errorcode_msg{type = err412_wash_replace_err,about = "洗髓的伙伴内存中不存在"};

get(4120014) ->
    #errorcode_msg{type = err412_break_err,about = "突破等级有错"};

get(4120015) ->
    #errorcode_msg{type = err412_promote_err,about = "资质提升错误,已超出上限"};

get(4120016) ->
    #errorcode_msg{type = err412_battle_err1,about = "没有可上阵的位置"};

get(4120017) ->
    #errorcode_msg{type = err412_battle_err2,about = "上阵错误,玩家等级不足"};

get(4120018) ->
    #errorcode_msg{type = err412_embattle_err1,about = "布阵错误,原位置没有伙伴"};

get(4120019) ->
    #errorcode_msg{type = err412_embattle_err2,about = "布阵错误,目标位置超出范围"};

get(4120020) ->
    #errorcode_msg{type = err412_weapon_err1,about = "激活专属,已激活"};

get(4120021) ->
    #errorcode_msg{type = err412_weapon_err2,about = "专属激活,伙伴没招募过"};

get(4120022) ->
    #errorcode_msg{type = err412_disband_err,about = "伙伴遣散,伙伴上阵无法遣散"};

get(4120023) ->
    #errorcode_msg{type = err412_callback_err,about = "以前没招募过"};

get(4120024) ->
    #errorcode_msg{type = err412_battle_err3,about = "上阵位置错误"};

get(4120025) ->
    #errorcode_msg{type = err412_recruit_err1,about = "非保底招募,没找到候选伙伴"};

get(4120026) ->
    #errorcode_msg{type = err412_recruit_err2,about = "保底招募,没找到候选伙伴"};

get(4120027) ->
    #errorcode_msg{type = err412_partner_is_battle,about = "已经有相同伙伴出战"};

get(4130001) ->
    #errorcode_msg{type = err413_fashion_not_pos,about = "没有该时装部位"};

get(4130002) ->
    #errorcode_msg{type = err413_fashion_not_fashion,about = "该时装未激活"};

get(4130003) ->
    #errorcode_msg{type = err413_fashion_not_same_color,about = "重复穿戴，请重新操作"};

get(4130004) ->
    #errorcode_msg{type = err413_fashion_color_not_active,about = "颜色未激活"};

get(4130005) ->
    #errorcode_msg{type = err413_fashion_not_color,about = "颜色不存在"};

get(4130006) ->
    #errorcode_msg{type = err413_fashion_wear,about = "当前时装正在穿着"};

get(4130007) ->
    #errorcode_msg{type = err413_fashion_not_wear,about = "身上穿着不是这件时装"};

get(4130008) ->
    #errorcode_msg{type = err413_fashion_active,about = "时装已激活"};

get(4130009) ->
    #errorcode_msg{type = err413_fashion_max_lv,about = "时装部位已满级"};

get(4130010) ->
    #errorcode_msg{type = err413_fashion_not_enough_point,about = "时装精华不足"};

get(4130011) ->
    #errorcode_msg{type = err413_fashion_not_resolve,about = "该道具不能分解"};

get(4130012) ->
    #errorcode_msg{type = err413_fashion_max_star,about = "星级已满级"};

get(4130013) ->
    #errorcode_msg{type = err413_fashion_not_max_star,about = "星级未满级"};

get(4130014) ->
    #errorcode_msg{type = err413_fashion_color_active,about = "颜色已激活"};

get(4130015) ->
    #errorcode_msg{type = err413_fashion_not_forever,about = "时装没永久激活"};

get(4130016) ->
    #errorcode_msg{type = err143_fashion_type_error,about = "限时时装无法分解"};

get(4130017) ->
    #errorcode_msg{type = err413_expire_fashion_not_upgrade,about = "限时时装无法升星"};

get(4130018) ->
    #errorcode_msg{type = err413_expire_fashion_not_dye_color,about = "限时时装无法操作"};

get(4130019) ->
    #errorcode_msg{type = err413_fahsion_expire_active_error,about = "永久时装激活消耗有误"};

get(4130020) ->
    #errorcode_msg{type = err413_trial_fashion_cost_error,about = "限时性时装消耗有误"};

get(4130021) ->
    #errorcode_msg{type = err413_trial_fashion_error,about = "参数有误，无法续时"};

get(4130022) ->
    #errorcode_msg{type = err413_fahsion_cannot_active,about = "参数有误，无法激活"};

get(4130023) ->
    #errorcode_msg{type = err413_not_trial_goods,about = "不是限时物品，无法使用"};

get(4130024) ->
    #errorcode_msg{type = err413_not_trial_fashion,about = "不是限时时装,无法激活"};

get(4130025) ->
    #errorcode_msg{type = err413_fashion_cannot_overlay,about = "该时装颜色无法叠加"};

get(4130026) ->
    #errorcode_msg{type = err413_color_goods_cannot_overlay,about = "该颜色道具无法叠加使用"};

get(4130027) ->
    #errorcode_msg{type = err413_suit_con_limit,about = "套装激活条件不足"};

get(4130028) ->
    #errorcode_msg{type = err413_have_actived,about = "您已激活，无需重复操作"};

get(4140001) ->
    #errorcode_msg{type = err414_has_receive,about = "已经领取过奖励"};

get(4140002) ->
    #errorcode_msg{type = err414_shop_config,about = "商店参数有误"};

get(4140003) ->
    #errorcode_msg{type = err414_shop_reset,about = "商店重置有误"};

get(4140004) ->
    #errorcode_msg{type = err414_have_marbled,about = "弹珠操作正在进行中，请勿重复操作"};

get(4140005) ->
    #errorcode_msg{type = err414_energy_point,about = "充能点数不足，无法领取奖励"};

get(4140006) ->
    #errorcode_msg{type = err414_marble_reset_count,about = "重置次数不足，是否前往提升VIP等级"};

get(4140007) ->
    #errorcode_msg{type = err414_count_cost,about = "重置次数异常"};

get(4140008) ->
    #errorcode_msg{type = err414_marble_cost,about = "弹珠消耗参数异常"};

get(4140009) ->
    #errorcode_msg{type = err414_exchange_error,about = "兑换参数有误"};

get(4140010) ->
    #errorcode_msg{type = err414_marble_error,about = "弹珠操作异常，无法领取奖励"};

get(4140011) ->
    #errorcode_msg{type = err414_marble_time_error,about = "弹珠时间参数有误，请重新操作"};

get(4140012) ->
    #errorcode_msg{type = err414_cost_option_error,about = "弹射优先扣除参数异常，无法操作"};

get(4140013) ->
    #errorcode_msg{type = err414_max_energy,about = "充能进度已满，无法操作"};

get(4140014) ->
    #errorcode_msg{type = err414_max_step,about = "已结算请重置后再继续"};

get(4140015) ->
    #errorcode_msg{type = err414_have_no_count,about = "购买次数不足"};

get(4140016) ->
    #errorcode_msg{type = err414_vip_count_limit,about = "剩余重置次数不足，无法重置"};

get(4140017) ->
    #errorcode_msg{type = err414_have_not_finish,about = "格子还未走完，无法重置"};

get(4150000) ->
    #errorcode_msg{type = err415_in_madness_land,about = "狂战领域中！"};

get(4150001) ->
    #errorcode_msg{type = err415_level_limit,about = "等级不足！"};

get(4150002) ->
    #errorcode_msg{type = err415_not_open,about = "活动将在晚上19:30开启"};

get(4150003) ->
    #errorcode_msg{type = err415_on_madness_ban,about = "狂战领域不可进行该操作！"};

get(4160001) ->
    #errorcode_msg{type = err416_not_in_sign_stage,about = "不在报名阶段！"};

get(4160002) ->
    #errorcode_msg{type = err401_not_in_sign_time,about = "不在报名时间内！"};

get(4160003) ->
    #errorcode_msg{type = err416_already_sign,about = "已经报名啦！"};

get(4160004) ->
    #errorcode_msg{type = err416_not_sign_yet,about = "请先报名！"};

get(4160005) ->
    #errorcode_msg{type = err416_act_close,about = "活动尚未开始！"};

get(4160006) ->
    #errorcode_msg{type = err416_already_get_award,about = "已经领取完奖励了！"};

get(4160007) ->
    #errorcode_msg{type = err416_in_settlement,about = "结算阶段无法进行操作！"};

get(4160008) ->
    #errorcode_msg{type = err416_look_unlock,about = "搭配中有未解锁的装扮，保存失败"};

get(4160009) ->
    #errorcode_msg{type = err416_already_out,about = "您已淘汰！"};

get(4160010) ->
    #errorcode_msg{type = err416_no_sign,about = "您没有报名参加本次活动！"};

get(4160011) ->
    #errorcode_msg{type = err416_vote_error,about = "投票参数错误！"};

get(4160012) ->
    #errorcode_msg{type = err416_vote_overdue,about = "数据已过期，请刷新！"};

get(4160013) ->
    #errorcode_msg{type = err416_daily_vote_limit,about = "今日投票次数已达上限！"};

get(4160014) ->
    #errorcode_msg{type = err416_not_in_vote_stage,about = "不在投票阶段！"};

get(4160015) ->
    #errorcode_msg{type = err416_look_lock,about = "包含有未解锁的外观！"};

get(4170001) ->
    #errorcode_msg{type = err417_not_in_guild_run_assist,about = "没有接取跑环协助任务，无法操作"};

get(4170002) ->
    #errorcode_msg{type = err417_not_in_assist_quiz,about = "没有接取答题的跑环协助任务，无法操作"};

get(4170003) ->
    #errorcode_msg{type = err417_quiz_success,about = "答题已完成，无法操作"};

get(4170004) ->
    #errorcode_msg{type = err417_quiz_fail,about = "答题已失败，无法操作"};

get(4170005) ->
    #errorcode_msg{type = err417_in_quiz,about = "请先完成当前题目"};

get(4170006) ->
    #errorcode_msg{type = err417_quiz_error,about = "答题状态异常"};

get(4170007) ->
    #errorcode_msg{type = err417_operation_fail,about = "操作失败"};

get(4170008) ->
    #errorcode_msg{type = err417_have_failed,about = "任务失败，无法再接取此任务"};

get(4170009) ->
    #errorcode_msg{type = err417_not_receive,about = "当前场景不可接此任务"};

get(4180001) ->
    #errorcode_msg{type = err418_not_in_scene,about = "您不在舞池派对场景中！"};

get(4180002) ->
    #errorcode_msg{type = err418_not_open,about = "活动未开始！"};

get(4180003) ->
    #errorcode_msg{type = err418_basic_exp_not_set,about = "经验配置错误！"};

get(4180004) ->
    #errorcode_msg{type = err418_gift_props_not_exists,about = "不存在该道具！"};

get(4180005) ->
    #errorcode_msg{type = err418_getter_not_join,about = "对方没有参加舞池派对活动，不能赠送给他（她）！"};

get(4180006) ->
    #errorcode_msg{type = err418_buy_times_not_enougth,about = "您购买的次数超过限制啦~"};

get(4180007) ->
    #errorcode_msg{type = err418_send_to_self,about = "不能给自己赠送礼物！"};

get(4180008) ->
    #errorcode_msg{type = err418_no_partner,about = "您还没有对象呢！"};

get(4180009) ->
    #errorcode_msg{type = err418_not_join_act,about = "您未参与舞池派对活动，请重新进入哟~"};

get(4180010) ->
    #errorcode_msg{type = err418_opp_has_engaged,about = "对方已经在约会状态中，请邀请其他玩家！"};

get(4180011) ->
    #errorcode_msg{type = err418_cfg_fault,about = "舞池派对活动配置错误！"};

get(4180012) ->
    #errorcode_msg{type = err418_lv_invalid,about = "您未达到开放等级，不能参加活动"};

get(4180013) ->
    #errorcode_msg{type = err418_has_in_scene,about = "您已经在场景中了！"};

get(4180014) ->
    #errorcode_msg{type = err418_has_on_engaged,about = "您已经在约会中，不能再邀请其他人咯！"};

get(4180015) ->
    #errorcode_msg{type = err418_add_exp_cd,about = "增加经验频率不对哦！"};

get(4180016) ->
    #errorcode_msg{type = err418_invite_cd,about = "邀请玩家频率太高了，稍后继续邀请！"};

get(4180017) ->
    #errorcode_msg{type = err418_not_find_vote,about = "没找到这条拉票信息哦"};

get(4180018) ->
    #errorcode_msg{type = err418_not_your_vote,about = "不能置顶别人的拉票信息哦"};

get(4180019) ->
    #errorcode_msg{type = err418_stick_vote_too_ofent,about = "置顶太频繁了，给别人点机会吧"};

get(4180020) ->
    #errorcode_msg{type = err418_vote_max,about = "该拉票信息可投票数已满"};

get(4180021) ->
    #errorcode_msg{type = err418_not_vote_times,about = "剩余投票次数不足"};

get(4180022) ->
    #errorcode_msg{type = err418_already_voted,about = "已为该条拉票信息投票过了"};

get(4180023) ->
    #errorcode_msg{type = err418_self_vote,about = "不能给自己投票"};

get(4180024) ->
    #errorcode_msg{type = err418_stick_other_vote,about = "只能给自己置顶"};

get(4180025) ->
    #errorcode_msg{type = err418_too_much_vote,about = "您已经发布太多拉票了，给别人点机会吧"};

get(4180026) ->
    #errorcode_msg{type = err418_refuse_invite,about = "对方拒绝了你的约会邀请"};

get(4180027) ->
    #errorcode_msg{type = err418_someone_not_in_scene,about = "对方不在活动场景中"};

get(4180028) ->
    #errorcode_msg{type = err418_not_invate,about = "对方没有邀请你啦~"};

get(4180029) ->
    #errorcode_msg{type = err418_is_engaging,about = "正在约会中，请不要三心二意呀"};

get(4180030) ->
    #errorcode_msg{type = err418_already_on_chair,about = "已经在椅子上啦，给别人留点位置吧"};

get(4180031) ->
    #errorcode_msg{type = err418_chair_has_owner,about = "这把椅子已经有人坐了"};

get(4180032) ->
    #errorcode_msg{type = err418_not_on_chair,about = "不在椅子上"};

get(4180033) ->
    #errorcode_msg{type = err418_buy_times_max,about = "已达到购买次数上限"};

get(4180034) ->
    #errorcode_msg{type = err418_opp_not_in_act,about = "对方还没在活动中喔"};

get(4190001) ->
    #errorcode_msg{type = err419_no_res_act,about = "奖励找回中没有此活动"};

get(4190002) ->
    #errorcode_msg{type = err419_no_more_times,about = "次数不足"};

get(4190003) ->
    #errorcode_msg{type = err419_no_dun_finish,about = "没有通关副本"};

get(4190004) ->
    #errorcode_msg{type = err419_lv_not_match,about = "已超过该奖励等级"};

get(4200001) ->
    #errorcode_msg{type = err420_already_buy,about = "已经购买了"};

get(4200002) ->
    #errorcode_msg{type = err420_no_investment,about = "您没有投资该项目"};

get(4200003) ->
    #errorcode_msg{type = err420_need_more_day,about = "投资{1}天后可以领取该奖励"};

get(4200004) ->
    #errorcode_msg{type = err420_reward_is_got,about = "该投资回报已经领取"};

get(4200005) ->
    #errorcode_msg{type = err420_lv_low,about = "等级不足"};

get(4210001) ->
    #errorcode_msg{type = err421_forge_cfg_err,about = "时装打造配置错误"};

get(4210002) ->
    #errorcode_msg{type = err421_has_on_pos,about = "已经在目标列表中"};

get(4210003) ->
    #errorcode_msg{type = err421_material_not_enough,about = "打造材料不够哟"};

get(4210004) ->
    #errorcode_msg{type = err421_suit_cfg_err,about = "套装配置错误"};

get(4210005) ->
    #errorcode_msg{type = err421_max_suit_num,about = "已经激活最大套数了哟"};

get(4210006) ->
    #errorcode_msg{type = err421_cannot_active,about = "未达到激活套数条件喔"};

get(4210007) ->
    #errorcode_msg{type = err421_has_not_good,about = "没有该商品喔"};

get(4210008) ->
    #errorcode_msg{type = err421_has_buy,about = "已经购买该商品了"};

get(4210009) ->
    #errorcode_msg{type = err421_good_cfg_err,about = "商品配置错误"};

get(4210010) ->
    #errorcode_msg{type = err421_fashion_coin_not_enough,about = "时装币不足"};

get(4210011) ->
    #errorcode_msg{type = err421_goods_list_err,about = "目标列表错误"};

get(4220001) ->
    #errorcode_msg{type = err422_buy_times_err,about = "购买次数错误"};

get(4220002) ->
    #errorcode_msg{type = err422_lv_not_enough,about = "购买等级不足"};

get(4220003) ->
    #errorcode_msg{type = err422_career_err,about = "您的职业与商品信息不符哟"};

get(4220004) ->
    #errorcode_msg{type = err422_career_cfg_err,about = "商品职业配置错误"};

get(4220005) ->
    #errorcode_msg{type = err422_buy_times_not_enough,about = "购买商品次数不足哟"};

get(4220006) ->
    #errorcode_msg{type = err422_store_not_open,about = "货柜还未开启哟"};

get(4220007) ->
    #errorcode_msg{type = err422_store_price_err,about = "商品价格配置错误"};

get(4230001) ->
    #errorcode_msg{type = err423_already_onhook,about = "正在远征中"};

get(4230002) ->
    #errorcode_msg{type = err423_lv_limit,about = "未达到开放等级"};

get(4230003) ->
    #errorcode_msg{type = err423_no_onhook_time,about = "没有挂机时间了"};

get(4230004) ->
    #errorcode_msg{type = err423_not_in_onhook,about = "并没有进行远征"};

get(4230005) ->
    #errorcode_msg{type = err423_have_not_guardian,about = "您尚未拥有该守护"};

get(4230006) ->
    #errorcode_msg{type = err423_not_enough_times,about = "没有领取次数咯"};

get(4230007) ->
    #errorcode_msg{type = err423_guardian_already_working,about = "该守护已经上阵了"};

get(4230008) ->
    #errorcode_msg{type = err423_devil_can_not_work,about = "小恶魔不想挖矿"};

get(4230009) ->
    #errorcode_msg{type = err423_guardian_can_not_work,about = "我不想去这里"};

get(4230010) ->
    #errorcode_msg{type = err423_mine_max_lv,about = "矿洞已达最高等级"};

get(4230011) ->
    #errorcode_msg{type = err423_conditions_error,about = "尚未满足升级条件"};

get(4230012) ->
    #errorcode_msg{type = err423_actived_miner,about = "矿工已雇佣"};

get(4230013) ->
    #errorcode_msg{type = err423_received_time_limit,about = "尚未达到可领取时间"};

get(4240001) ->
    #errorcode_msg{type = err424_in_treasure_map,about = "当前处于挖宝阶段，无法操作"};

get(4240002) ->
    #errorcode_msg{type = err424_count_limit,about = "藏宝使用次数已达上限"};

get(4240003) ->
    #errorcode_msg{type = err424_distance_far_away,about = "距离太远，无法操作"};

get(4240004) ->
    #errorcode_msg{type = err424_last_not_finish,about = "上一次挖宝还未完成哟"};

get(4240005) ->
    #errorcode_msg{type = err424_reward_err,about = "奖励配置错误"};

get(4240006) ->
    #errorcode_msg{type = err424_type_err,about = "挖宝类型错误"};

get(4240007) ->
    #errorcode_msg{type = err424_cannot_receive,about = "未能领取本次数奖励哟"};

get(4240008) ->
    #errorcode_msg{type = err424_not_reward_can_receive,about = "还未有可以领取的奖励哟"};

get(4240009) ->
    #errorcode_msg{type = err424_times_reward_err,about = "次数奖励配置错误"};

get(4240010) ->
    #errorcode_msg{type = err424_reward_has_received,about = "已领取过本奖励了喔"};

get(4240011) ->
    #errorcode_msg{type = err424_coordinate_error,about = "无法获取目的地，无法使用"};

get(4240012) ->
    #errorcode_msg{type = err424_not_in_treasure_map,about = "当前不处于挖宝阶段，无法操作"};

get(4240013) ->
    #errorcode_msg{type = err424_not_in_quiz_event,about = "不在答题活动中，无法操作"};

get(4240014) ->
    #errorcode_msg{type = err424_not_in_shop_event,about = "不在限时之门活动中，无法操作"};

get(4240015) ->
    #errorcode_msg{type = err424_not_in_mon_event,about = "没有触发怪物事件，无法操作"};

get(4240016) ->
    #errorcode_msg{type = err424_pls_fin_now_mon_event,about = "请先完成当前的怪物事件"};

get(4240017) ->
    #errorcode_msg{type = err424_not_in_type_event,about = "您不处于此事件中，无法操作"};

get(4240018) ->
    #errorcode_msg{type = error424_pls_finish_shop_event,about = "请先完成当前的限时之门事件"};

get(4240019) ->
    #errorcode_msg{type = err424_shop_reward_fin,about = "此类商品已售罄"};

get(4240020) ->
    #errorcode_msg{type = err424_shop_expire,about = "商品已过期，无法操作"};

get(4240021) ->
    #errorcode_msg{type = err424_not_exist_shop_info,about = "该商品不存在"};

get(4240022) ->
    #errorcode_msg{type = err424_buy_num_limit,about = "购买次数已超上限"};

get(4240023) ->
    #errorcode_msg{type = err424_scene_block,about = "该坐标无法到达"};

get(4250001) ->
    #errorcode_msg{type = err_425_not_activate,about = "您还未习得该动作"};

get(4250002) ->
    #errorcode_msg{type = err_425_already_activate,about = "您已习得该动作"};

get(4270001) ->
    #errorcode_msg{type = err427_have_signed,about = "已报名，无法操作"};

get(4270002) ->
    #errorcode_msg{type = err427_not_in_sign_time,about = "未处于活动报名阶段"};

get(4270003) ->
    #errorcode_msg{type = err427_apply_num_limit,about = "报名人数已满"};

get(4270004) ->
    #errorcode_msg{type = err427_havent_applied,about = "没有报名，无法操作"};

get(4270005) ->
    #errorcode_msg{type = err427_round_guess_close,about = "本轮竞猜已关闭"};

get(4270006) ->
    #errorcode_msg{type = err427_guess_role_error,about = "竞猜人物数据有误"};

get(4270007) ->
    #errorcode_msg{type = err427_guess_data_error,about = "竞猜数据有误"};

get(4270008) ->
    #errorcode_msg{type = err427_room_guessed,about = "您已竞猜，请勿重复操作"};

get(4270009) ->
    #errorcode_msg{type = err427_buy_life_scene_limit,about = "当前不在备战区，无法购买"};

get(4270010) ->
    #errorcode_msg{type = err427_in_diamond_pk,about = "正在参与钻石擂台活动"};

get(4270011) ->
    #errorcode_msg{type = err427_not_in_ready_scene,about = "当前不处于备战场景，无法操作"};

get(4270012) ->
    #errorcode_msg{type = err427_not_in_dia_battle,about = "不在钻石战场中，无法操作"};

get(4280001) ->
    #errorcode_msg{type = err428_grow_up_fail,about = "培养失败"};

get(4280002) ->
    #errorcode_msg{type = err428_active_fail,about = "激活失败"};

get(4280003) ->
    #errorcode_msg{type = err428_spirit_not_active,about = "请先开启对应圣灵"};

get(4280005) ->
    #errorcode_msg{type = err428_args_error,about = "操作参数错误"};

get(4280006) ->
    #errorcode_msg{type = err428_has_limit,about = "已达满级"};

get(4330000) ->
    #errorcode_msg{type = err433_no_equip_cfg,about = "没有装备配置"};

get(4330001) ->
    #errorcode_msg{type = err433_equip_pos_type_error,about = "装备部位类型错误"};

get(4330002) ->
    #errorcode_msg{type = err433_no_stren_cfg,about = "缺少强化配置"};

get(4330003) ->
    #errorcode_msg{type = err433_error_equip_type,about = "错误的装备类型"};

get(4330004) ->
    #errorcode_msg{type = err433_already_max_lv,about = "已达到最高级"};

get(4330005) ->
    #errorcode_msg{type = err433_failed_to_reach_breakthrough_level,about = "未达到突破等级"};

get(4330007) ->
    #errorcode_msg{type = err433_target_equip_no_exist,about = "目标装备不存在"};

get(4330008) ->
    #errorcode_msg{type = err433_can_not_resolve_equip,about = "没有可分解的装备"};

get(4350001) ->
    #errorcode_msg{type = err435_cfg_error,about = "配置异常"};

get(4350002) ->
    #errorcode_msg{type = err435_not_can_cook,about = "没有可烹饪的"};

get(4350003) ->
    #errorcode_msg{type = err435_not_can_equip,about = "没有可打造的"};

get(4350004) ->
    #errorcode_msg{type = err435_build_lv_not_enough,about = "建筑所需等级不足"};

get(4350005) ->
    #errorcode_msg{type = err435_skill_lv_not_enough,about = "技能等级不足"};

get(4350006) ->
    #errorcode_msg{type = err435_power_live_not_enough,about = "活力不足"};

get(4350007) ->
    #errorcode_msg{type = err435_not_cook_book,about = "找不到对应食物"};

get(4350008) ->
    #errorcode_msg{type = err435_has_cook_book,about = "已激活该食谱"};

get(4350009) ->
    #errorcode_msg{type = err435_not_gain_food,about = "不是增益类食物"};

get(4350010) ->
    #errorcode_msg{type = err435_lv_not_enough,about = "人物等级不足"};

get(4350011) ->
    #errorcode_msg{type = err435_has_equip_paper,about = "已激活该图纸"};

get(4350012) ->
    #errorcode_msg{type = err435_not_equip_paper,about = "找不到对应图纸"};

get(4350013) ->
    #errorcode_msg{type = err435_not_active,about = "未激活该类型"};

get(4400001) ->
    #errorcode_msg{type = err440_lv_not_enough,about = "等级不足"};

get(4400002) ->
    #errorcode_msg{type = err440_has_active,about = "已激活"};

get(4400004) ->
    #errorcode_msg{type = err440_cfg_error,about = "配置不存在"};

get(4400006) ->
    #errorcode_msg{type = err440_cd_not_end,about = "灵气未蓄满"};

get(4400008) ->
    #errorcode_msg{type = err440_is_limit,about = "已达满级"};

get(4400009) ->
    #errorcode_msg{type = err440_feed_kind_fail,about = "喂养道具不匹配"};

get(4400010) ->
    #errorcode_msg{type = err440_in_pos,about = "已经在出战位"};

get(4400011) ->
    #errorcode_msg{type = err440_trans_not_handle,about = "变身中不能替换"};

get(4400012) ->
    #errorcode_msg{type = err440_feed_num_error,about = "喂养数量错误"};

get(4400014) ->
    #errorcode_msg{type = err440_not_active_seal,about = "未激活印记"};

get(4400015) ->
    #errorcode_msg{type = err440_not_active_rune,about = "未激活符文"};

get(4400016) ->
    #errorcode_msg{type = err440_pos_not_open,about = "该槽位未开启"};

get(4400017) ->
    #errorcode_msg{type = err440_is_not_goods,about = "该物品不属于印记"};

get(4400018) ->
    #errorcode_msg{type = err440_not_equip_same_type,about = "不能穿戴相同类型的印记"};

get(4400019) ->
    #errorcode_msg{type = err440_not_equip,about = "印记无穿戴在身上"};

get(4400020) ->
    #errorcode_msg{type = err440_not_compose_goods,about = "不是合成材料"};

get(4400021) ->
    #errorcode_msg{type = err440_compose_goods_not_lv,about = "合成材料阶数不足"};

get(4400022) ->
    #errorcode_msg{type = err440_not_equip_low,about = "不能穿戴同类型低阶印记"};

get(4400023) ->
    #errorcode_msg{type = err440_please_select_compose,about = "请正确选择消耗材料"};

get(4500001) ->
    #errorcode_msg{type = err450_trial_vip,about = "您正处于体验VIP阶段，无法操作"};

get(4500002) ->
    #errorcode_msg{type = err450_vip_limit,about = "vip等级不足"};

get(4500003) ->
    #errorcode_msg{type = err450_have_buy_vip_bag,about = "您已购买此vip等级特权礼包，请勿重复操作"};

get(4500004) ->
    #errorcode_msg{type = err450_cfg_error,about = "vip配置有误"};

get(4500005) ->
    #errorcode_msg{type = err450_trial_vip_1,about = "您正处于体验VIP阶段，无需重复操作"};

get(4500006) ->
    #errorcode_msg{type = err450_in_vip,about = "您已拥有VIP特权，无法操作"};

get(4500007) ->
    #errorcode_msg{type = err450_goods_num,about = "vip体验卡无法叠加使用多次"};

get(4500008) ->
    #errorcode_msg{type = err450_foster_data_error,about = "进阶未达到道具使用等级，无法操作"};

get(4500009) ->
    #errorcode_msg{type = err450_vip_skill_limit,about = "您的vip特权不足，无法使用此技能"};

get(4510001) ->
    #errorcode_msg{type = err451_sup_vip_active_limit,about = "V4开放贵族特权激活"};

get(4510002) ->
    #errorcode_msg{type = err451_actived_sup_vip,about = "您已是贵族，无需重复激活"};

get(4510003) ->
    #errorcode_msg{type = err451_in_trial_sup_vip,about = "您已是贵族，无需重复激活"};

get(4510004) ->
    #errorcode_msg{type = err451_no_sup_vip,about = "激活贵族特权，可免费1.25倍提取经验"};

get(4510005) ->
    #errorcode_msg{type = err451_sup_vip_count_limit,about = "您的每日礼包次数不足，无法领取"};

get(4510006) ->
    #errorcode_msg{type = err451_exchange_count,about = "您的兑换次数已用完，无法操作"};

get(4510007) ->
    #errorcode_msg{type = err451_permanent_sup_vip,about = "请先升级二阶贵族再操作！"};

get(4510008) ->
    #errorcode_msg{type = err451_unlock_limit,about = "此物品还未解锁，无法购买"};

get(4510009) ->
    #errorcode_msg{type = err451_permanent_goods,about = "终生限购道具无法再次购买"};

get(4510010) ->
    #errorcode_msg{type = err451_limit_count_error,about = "道具购买次数不足，无法操作"};

get(4510011) ->
    #errorcode_msg{type = err451_goods_lv_limit,about = "贵族道具等级限制，无法操作"};

get(4510012) ->
    #errorcode_msg{type = err451_need_first_reward,about = "参数有误，请先领完首次礼包"};

get(4510013) ->
    #errorcode_msg{type = err451_echange_arg_error,about = "参数有误，无法兑换"};

get(4520001) ->
    #errorcode_msg{type = err452_category_err,about = "章节类型错误"};

get(4520002) ->
    #errorcode_msg{type = err452_category_not_finish,about = "本章节还未全部完成哟"};

get(4520003) ->
    #errorcode_msg{type = err452_category_has_received,about = "已经领取过章节奖励啦"};

get(4520004) ->
    #errorcode_msg{type = err452_task_id_err,about = "[精英考核]任务Id错误"};

get(4520005) ->
    #errorcode_msg{type = err452_can_not_receive,about = "任务还未完成哟"};

get(4520006) ->
    #errorcode_msg{type = err452_pre_sub_category,about = "请先完成前面的小章节喔"};

get(4520007) ->
    #errorcode_msg{type = err452_reward_has_received,about = "奖励已经领取过了"};

get(4580001) ->
    #errorcode_msg{type = err458_no_award,about = "奖励不存在！"};

get(4580002) ->
    #errorcode_msg{type = err458_already_get,about = "奖励已经领取！"};

get(4580003) ->
    #errorcode_msg{type = err458_cannot_get_award,about = "该奖励不可领取！"};

get(4580004) ->
    #errorcode_msg{type = err458_award_condition_error,about = "领取条件不足！"};

get(4580005) ->
    #errorcode_msg{type = err458_act_not_begin,about = "活动尚未开始！"};

get(4580006) ->
    #errorcode_msg{type = err458_is_end,about = "活动已经结束！"};

get(4580007) ->
    #errorcode_msg{type = err458_dun_boss_die,about = "血魔已经被击杀！"};

get(4580008) ->
    #errorcode_msg{type = err458_goods_none,about = "商品未上架！"};

get(4580009) ->
    #errorcode_msg{type = err458_goods_sold_out,about = "商品已售罄！"};

get(4580010) ->
    #errorcode_msg{type = err458_goods_limit,about = "兑换次数不足！"};

get(4590000) ->
    #errorcode_msg{type = err459_jump_matching,about = "您当前正在跳一跳玩法匹配中，请先退出匹配再尝试！"};

get(4590001) ->
    #errorcode_msg{type = err459_jump_playing,about = "您当前正在参与跳一跳，专心点哦~！"};

get(4590002) ->
    #errorcode_msg{type = err459_jump_close,about = "当前无场次开放，请留意下一场开放时间~！"};

get(4590003) ->
    #errorcode_msg{type = err459_max_match_count,about = "今日已达最大参与次数，请改日再来！"};

get(4590004) ->
    #errorcode_msg{type = err459_max_single_count,about = "今日已达最大练习次数，请改日再来！"};

get(4590005) ->
    #errorcode_msg{type = err459_single_first,about = "请先完成单人模式，再参与多人匹配~！"};

get(4600000) ->
    #errorcode_msg{type = err460_in_reward_boss,about = "幻魔战斗中"};

get(4600001) ->
    #errorcode_msg{type = err460_boss_dead,about = "幻魔尚未复活！"};

get(4600002) ->
    #errorcode_msg{type = err460_encourage_limit,about = "鼓舞次数不足！"};

get(4600003) ->
    #errorcode_msg{type = err460_tried_max,about = "赏金幻魔奖励次数不足！"};

get(4600004) ->
    #errorcode_msg{type = err460_lv_limit,about = "等级不足！"};

get(4600005) ->
    #errorcode_msg{type = err460_no_lv,about = "您的等级不足！"};

get(4600006) ->
    #errorcode_msg{type = err460_no_remind,about = "您已经关注了，无需重复关注"};

get(4600007) ->
    #errorcode_msg{type = err460_no_unremind,about = "您还没有关注，无需取消关注"};

get(4600008) ->
    #errorcode_msg{type = err460_quit_team,about = "请先退出队伍"};

get(4600009) ->
    #errorcode_msg{type = err460_not_in_scene,about = "该场景不能使用"};

get(4600010) ->
    #errorcode_msg{type = err460_has_limit,about = "次数已达上限"};

get(4600011) ->
    #errorcode_msg{type = err460_supporter_no_award,about = "协助状态无法获得归属！"};

get(4600012) ->
    #errorcode_msg{type = err460_too_many_roles,about = "活动场景已经爆满，请稍后再进！"};

get(4600013) ->
    #errorcode_msg{type = err460_boss_has_gone,about = "BOSS已经消失！"};

get(4600014) ->
    #errorcode_msg{type = err460_never_find_boss,about = "尚未发现BOSS！"};

get(4600015) ->
    #errorcode_msg{type = err461_not_in_normal_scene,about = "只可在大世界场景中使用噢"};

get(4600016) ->
    #errorcode_msg{type = err460_boss_not_die,about = "boss不处于等待重生期间"};

get(4600017) ->
    #errorcode_msg{type = err460_has_max_times,about = "您的赏金幻魔次数已满"};

get(4600018) ->
    #errorcode_msg{type = err460_not_this_boss,about = "没有这个boss噢"};

get(4600019) ->
    #errorcode_msg{type = err460_already_refresh,about = "击杀当前幻魔后可继续召唤！"};

get(4600020) ->
    #errorcode_msg{type = err460_not_outside,about = "野外场景才可以召唤！"};

get(4600021) ->
    #errorcode_msg{type = err460_pos_not_ok,about = "当前区域不可进行召唤！"};

get(4600022) ->
    #errorcode_msg{type = err460_lv_not_ok,about = "等级不足，不可召唤！"};

get(4600023) ->
    #errorcode_msg{type = err460_protect_time_not_enough,about = "免战次数已经用完了哟"};

get(4600024) ->
    #errorcode_msg{type = err460_not_need_use,about = "不需要重复使用哟"};

get(4600025) ->
    #errorcode_msg{type = err460_cannot_use_protect_time,about = "还不能使用免战喔"};

get(4600026) ->
    #errorcode_msg{type = err460_has_count,about = "还有奖励次数，无需购买"};

get(4600027) ->
    #errorcode_msg{type = err460_buy_count_limit,about = "购买次数不足"};

get(4610001) ->
    #errorcode_msg{type = err461_in_deserted_boss_scene,about = "已在星域boss场景中"};

get(4610002) ->
    #errorcode_msg{type = err461_tire_max,about = "次数不足,无法发起协助"};

get(4610003) ->
    #errorcode_msg{type = err461_pls_quit_scene,about = "请退出当前场景再进行操作！"};

get(4610004) ->
    #errorcode_msg{type = err461_has_max_times,about = "您的星域幻魔次数已满"};

get(4610005) ->
    #errorcode_msg{type = err461_not_in_scene,about = "只可在混乱星域场景中使用噢"};

get(4610006) ->
    #errorcode_msg{type = err461_protect_time_not_enough,about = "免战次数已经用完了哟"};

get(4610007) ->
    #errorcode_msg{type = err461_not_need_use,about = "当前不需要重复使用哟"};

get(4610008) ->
    #errorcode_msg{type = err461_cannot_use_protect_time,about = "还不能使用免战喔"};

get(4620001) ->
    #errorcode_msg{type = err462_not_top_3,about = "只有 TOP3 社团玩家可进入哦！"};

get(4630001) ->
    #errorcode_msg{type = err463_not_exp_sea_scene,about = "当前不是经验海场景"};

get(4630002) ->
    #errorcode_msg{type = err463_times_not_enough,about = "次数不足"};

get(4630003) ->
    #errorcode_msg{type = err463_strength_cost_err,about = "强化材料配置错误"};

get(4630004) ->
    #errorcode_msg{type = err463_floor_cfg_err,about = "层数配置错误"};

get(4630005) ->
    #errorcode_msg{type = err463_time_err,about = "今日挂机时间已用完"};

get(4630006) ->
    #errorcode_msg{type = err463_floor_to_many_people,about = "当前人数过多，请稍后再尝试"};

get(4630007) ->
    #errorcode_msg{type = err463_has_in_scene,about = "已经在沧海场景中"};

get(5000001) ->
    #errorcode_msg{type = err500_husong_start,about = "正在护送中"};

get(5000002) ->
    #errorcode_msg{type = err500_husong_end,about = "今日护送次数已经用完"};

get(5000003) ->
    #errorcode_msg{type = err500_husong_unfinish_last_stage,about = "未完成上一个阶段"};

get(5000004) ->
    #errorcode_msg{type = err500_husong_quality_max,about = "品质已达上限"};

get(5000005) ->
    #errorcode_msg{type = err500_husong_cant_change_scene,about = "开始了护送无法切换场景"};

get(5000006) ->
    #errorcode_msg{type = err500_husong_not_start,about = "护送还没开始"};

get(5000007) ->
    #errorcode_msg{type = err500_husong_stage_wrong,about = "护送阶段不正确"};

get(5000009) ->
    #errorcode_msg{type = err500_husong_lv_low,about = "等级不足！"};

get(5000012) ->
    #errorcode_msg{type = err500_husong_supporting,about = "协助状态不可参与护送！"};

get(5000014) ->
    #errorcode_msg{type = err500_husong_take_num_max,about = "拦截奖励次数已达上限，无法继续获得奖励"};

get(5000015) ->
    #errorcode_msg{type = err500_husong_take_success,about = "拦截成功"};

get(5000016) ->
    #errorcode_msg{type = err500_husong_invincible_max,about = "庇护已用完"};

get(5000017) ->
    #errorcode_msg{type = err500_husong_reflesh_to_goal,about = "已经提升到了对应品质！"};

get(5000018) ->
    #errorcode_msg{type = err500_husong_reflesh_success,about = "提升成功，获得<color='{1}'>{2}</color>天使"};

get(5000020) ->
    #errorcode_msg{type = err500_not_near_npc,about = "请前往参与护送！"};

get(5000025) ->
    #errorcode_msg{type = err500_not_now_scene_packup,about = "不在护送npc场景"};

get(5000026) ->
    #errorcode_msg{type = err500_pray_val_limit,about = "祝福值不足，无法操作"};

get(5010001) ->
    #errorcode_msg{type = err501_please_join_guild,about = "请先加入社团，再来参加活动！"};

get(5010002) ->
    #errorcode_msg{type = err501_cannot_attack_friend,about = "请勿抢夺好友积分！"};

get(5010004) ->
    #errorcode_msg{type = err501_in_attack_cd,about = "冷却未冷却！"};

get(5010005) ->
    #errorcode_msg{type = err501_player_not_exist,about = "缺失玩家数据"};

get(5010006) ->
    #errorcode_msg{type = err501_oppplayer_not_exist,about = "对方玩家数据异常"};

get(5010007) ->
    #errorcode_msg{type = err501_in_protect_cd,about = "对方处于抢夺保护时间"};

get(5010008) ->
    #errorcode_msg{type = err501_cannot_attack,about = "请勿抢夺比自己名次差距太大的玩家"};

get(5010009) ->
    #errorcode_msg{type = err501_not_in_attack_idel,about = "请等当前战斗结束后，再来操作！"};

get(5010010) ->
    #errorcode_msg{type = err501_cannot_attack_self,about = "请勿抢夺你自己"};

get(5010011) ->
    #errorcode_msg{type = err501_cannot_transferable,about = "在主城和安全区才能参加活动！"};

get(5010013) ->
    #errorcode_msg{type = err501_goal_lock,about = "该玩法尚未解锁"};

get(5010014) ->
    #errorcode_msg{type = err501_has_receive_reward,about = "奖励已领取"};

get(5010015) ->
    #errorcode_msg{type = err501_progress_not_finish,about = "进度未完成"};

get(5030001) ->
    #errorcode_msg{type = err503_cannot_transferable,about = "在主城和安全区才能参与活动！"};

get(5030002) ->
    #errorcode_msg{type = err503_lv_error,about = "您未达到活动开启等级！"};

get(5030003) ->
    #errorcode_msg{type = err503_rival_not_enough,about = "英雄战场对手不足，暂时无法开启！"};

get(5030004) ->
    #errorcode_msg{type = err503_init_rival_error,about = "对手数据初始化异常"};

get(5030005) ->
    #errorcode_msg{type = err503_client_init_rival_error,about = "请刷新，客户端获取的对手数据不是最新的！"};

get(5030006) ->
    #errorcode_msg{type = err503_finish_all_attack,about = "您已挑战完所有对手！"};

get(5030007) ->
    #errorcode_msg{type = err503_in_battle_status,about = "您当前处于挑战状态，请先挑战！"};

get(5030008) ->
    #errorcode_msg{type = err503_no_award,about = "无可领取的奖励！"};

get(5030009) ->
    #errorcode_msg{type = err503_not_enough_attack_count,about = "剩余挑战次数不足！"};

get(5030010) ->
    #errorcode_msg{type = err503_reset_status,about = "英雄战场正在重置，无法挑战"};

get(5030011) ->
    #errorcode_msg{type = err503_missing_award_cfg,about = "领取失败，缺失奖励配置"};

get(5030012) ->
    #errorcode_msg{type = err503_settlement_plase_wait,about = "结算中，请稍后退出！"};

get(5030013) ->
    #errorcode_msg{type = err503_not_in_hero_war,about = "退出失败，不在英雄战场中！"};

get(6000001) ->
    #errorcode_msg{type = err600_cant_change_scene_in_void_fam,about = "无尽领域战斗中"};

get(6000003) ->
    #errorcode_msg{type = err600_already_in_scene,about = "已经在场景中"};

get(6000004) ->
    #errorcode_msg{type = err600_act_close,about = "活动将在每周一、三、五、日的19:30开启"};

get(6000005) ->
    #errorcode_msg{type = err600_no_enough_lv,about = "等级不足"};

get(6000006) ->
    #errorcode_msg{type = err600_no_in_act_scene,about = "不在无尽领域中"};

get(6010001) ->
    #errorcode_msg{type = err601_no_guild,about = "需要先加入社团"};

get(6010002) ->
    #errorcode_msg{type = err601_no_repeate_enter,about = "不需要重复进入"};

get(6010003) ->
    #errorcode_msg{type = err601_cant_change_scene_cross_gwar,about = "跨国团战中"};

get(6010004) ->
    #errorcode_msg{type = err601_not_in_cgw_scene,about = "不在跨国团战战场中"};

get(6010005) ->
    #errorcode_msg{type = err601_no_permission,about = "没有权限"};

get(6010006) ->
    #errorcode_msg{type = err601_not_city,about = "非法城池"};

get(6010007) ->
    #errorcode_msg{type = err601_support_max,about = "已达最大支持数"};

get(6010008) ->
    #errorcode_msg{type = err601_cant_repeate_get_award,about = "不可重复获得奖励"};

get(6010009) ->
    #errorcode_msg{type = err601_guild_donot_join,about = "社团未参加国战"};

get(6010010) ->
    #errorcode_msg{type = err601_no_server_zone,about = "分区不存在"};

get(6010011) ->
    #errorcode_msg{type = err601_no_battle_pid,about = "战场不存在"};

get(6010012) ->
    #errorcode_msg{type = err601_donot_own_city,about = "未占领城池"};

get(6010013) ->
    #errorcode_msg{type = err601_power_lower,about = "战力不足"};

get(6010014) ->
    #errorcode_msg{type = err601_have_sign_up,about = "已报名"};

get(6010015) ->
    #errorcode_msg{type = err601_the_guild_is_no_exist,about = "社团不存在"};

get(6010016) ->
    #errorcode_msg{type = err601_cant_sign_now,about = "不在报名期"};

get(6010017) ->
    #errorcode_msg{type = err601_not_in_sign_up_list,about = "未报名"};

get(6010018) ->
    #errorcode_msg{type = err601_cant_enter_now,about = "现在不能进入战场"};

get(6010019) ->
    #errorcode_msg{type = err601_no_zone_data,about = "本服未参与本国团战"};

get(6010020) ->
    #errorcode_msg{type = err601_support_time,about = "当前时间不可应援"};

get(6010021) ->
    #errorcode_msg{type = err601_not_king,about = "您还没有该特权！"};

get(6010022) ->
    #errorcode_msg{type = err601_exceed_times,about = "今日的禁言次数已用完~"};

get(6010023) ->
    #errorcode_msg{type = err601_not_enough_cd,about = "cd冷却中"};

get(6010024) ->
    #errorcode_msg{type = err601_faction_name_null,about = "国家名字不能为空"};

get(6010025) ->
    #errorcode_msg{type = err601_faction_name_sensitive,about = "国家名字存在敏感词"};

get(6010026) ->
    #errorcode_msg{type = err601_faction_name_len,about = "国家名字长度错误"};

get(6010027) ->
    #errorcode_msg{type = err601_faction_name_same,about = "已有该国家名"};

get(6010028) ->
    #errorcode_msg{type = err601_cant_buy,about = "不可重复购买"};

get(6020001) ->
    #errorcode_msg{type = err602_in_act,about = "活动期间,不允许进入哟"};

get(6020002) ->
    #errorcode_msg{type = err602_game_over,about = "您已经被淘汰,不准进入喔"};

get(6020003) ->
    #errorcode_msg{type = err602_is_hosting,about = "活动已经在托管中啦"};

get(6020004) ->
    #errorcode_msg{type = err602_cd_err,about = "复活冷却中，请稍后再试"};

get(6020005) ->
    #errorcode_msg{type = err602_not_open,about = "活动将在每周一、三、五、日的20:30开启"};

get(6020006) ->
    #errorcode_msg{type = err602_lv_not_enough,about = "您当前等级不足哟"};

get(6020007) ->
    #errorcode_msg{type = err602_act_not_open,about = "还没到活动开放时间哟"};

get(6030001) ->
    #errorcode_msg{type = err603_try_again_tommorow,about = "明日再试试"};

get(6030002) ->
    #errorcode_msg{type = err603_cant_fetch_again,about = "不可重复领取"};

get(6030003) ->
    #errorcode_msg{type = err603_need_high_rank,about = "需要膜拜更高排名玩家"};

get(6030004) ->
    #errorcode_msg{type = err603_has_click_done,about = "今日已膜拜"};

get(6030005) ->
    #errorcode_msg{type = err603_need_more_active,about = "需要更多活跃"};

get(6030006) ->
    #errorcode_msg{type = err603_need_finish_task,about = "需要先完成任务"};

get(6030007) ->
    #errorcode_msg{type = err603_post_max_now,about = "已经达到最高军衔"};

get(6030008) ->
    #errorcode_msg{type = err603_need_more_score,about = "军功值不足"};

get(6030009) ->
    #errorcode_msg{type = err603_legion_arms_not_enough,about = "军备值不足"};

get(6030010) ->
    #errorcode_msg{type = err603_cant_same_people,about = "已经膜拜过该玩家了喔"};

get(6030011) ->
    #errorcode_msg{type = err603_opday_not_enough,about = "开服天数不足"};

get(6040001) ->
    #errorcode_msg{type = err604_not_open,about = "沙盘争夺尚未开启！"};

get(6040002) ->
    #errorcode_msg{type = err604_already_seize,about = "已经成功占领了该据点！"};

get(6040003) ->
    #errorcode_msg{type = err604_not_connect,about = "没有领地与该据点相连！"};

get(6040004) ->
    #errorcode_msg{type = err604_not_seize,about = "尚未占领该据点！"};

get(6040005) ->
    #errorcode_msg{type = err604_not_award_time,about = "领奖时间未到！"};

get(6040006) ->
    #errorcode_msg{type = err604_never_attack,about = "您尚未攻打过该据点！"};

get(6040007) ->
    #errorcode_msg{type = err604_mass_right,about = "国家首席官员拥有召集权限！"};

get(6040008) ->
    #errorcode_msg{type = err604_others_point,about = "不可攻打安全据点！"};

get(6040009) ->
    #errorcode_msg{type = err604_mass_cd,about = "{1}秒后可以继续发起集结！"};

get(6070001) ->
    #errorcode_msg{type = err607_not_allow,about = "只有团长和副团长才可进行宣战哦"};

get(6070002) ->
    #errorcode_msg{type = err607_liveness_not_enough,about = "社团活跃度不足"};

get(6070003) ->
    #errorcode_msg{type = err607_not_in_war,about = "不在活动内"};

get(6070004) ->
    #errorcode_msg{type = err607_has_got,about = "已经领取过"};

get(6070005) ->
    #errorcode_msg{type = err607_not_in_sell,about = "该物品没有上架"};

get(6070006) ->
    #errorcode_msg{type = err607_point_quickly,about = "手速太快了"};

get(6070007) ->
    #errorcode_msg{type = err607_is_limit,about = "已达上限"};

get(6070008) ->
    #errorcode_msg{type = err607_not_apply_stage,about = "不是宣战阶段"};

get(6070009) ->
    #errorcode_msg{type = err607_not_fight_stage,about = "不是活动时间"};

get(6070010) ->
    #errorcode_msg{type = err607_cfg_error,about = "异常情况"};

get(6070011) ->
    #errorcode_msg{type = err607_not_apply,about = "您所在社团没有参战资格哦"};

get(6070012) ->
    #errorcode_msg{type = err607_not_own,about = "未占领该领地"};

get(6070013) ->
    #errorcode_msg{type = err607_is_own,about = "已经占领领地，无法宣战新的领地"};

get(6070014) ->
    #errorcode_msg{type = err607_has_apply,about = "已经宣战过"};

get(6070015) ->
    #errorcode_msg{type = err607_apply_has_limit,about = "宣战社团已达上限"};

get(6070016) ->
    #errorcode_msg{type = err607_score_not_enough,about = "积分不足"};

get(6070017) ->
    #errorcode_msg{type = err607_not_allow_kickout_when_kftown,about = "跨服城战期间不可进行操作！"};

get(6070019) ->
    #errorcode_msg{type = err607_not_apply_building,about = "只有要塞领地才可以宣战"};

get(6070020) ->
    #errorcode_msg{type = err607_is_max_limit,about = "社团参加人数已满"};

get(6070021) ->
    #errorcode_msg{type = err607_not_assist_building,about = "只有要塞领地才可以应援"};

get(6070022) ->
    #errorcode_msg{type = err607_not_apply_assist,about = "没有宣战该领地"};

get(6070025) ->
    #errorcode_msg{type = ererr607_lv_not_buy,about = "购买等级不足"};

get(6080001) ->
    #errorcode_msg{type = err608_cant_change_scene_in_kf_city,about = "正处于世界主城，不能参加其它活动"};

get(6090001) ->
    #errorcode_msg{type = err609_cant_change_scene_in_kf_invade,about = "正处于跨服入侵活动，不能参加其它活动"};

get(6090002) ->
    #errorcode_msg{type = err609_act_close,about = "活动未开启，不能进去他服"};

get(6090003) ->
    #errorcode_msg{type = err609_target_server_not_open,about = "目标服务器条件不符"};

get(6090004) ->
    #errorcode_msg{type = err609_not_enough_server,about = "服务器条件不符，数量不足2个"};

get(6090005) ->
    #errorcode_msg{type = err609_role_num_limit,about = "目标服务器场景人数已达上限"};

get(6090006) ->
    #errorcode_msg{type = err609_enter_kf_city_first,about = "请先前往世界主城"};

get(6090007) ->
    #errorcode_msg{type = err609_server_not_open,about = "你所在的服务器未开启跨服入侵"};

get(6090008) ->
    #errorcode_msg{type = err609_back_kf_city_error,about = "状态异常，请直接退出进入世界主城"};

get(6090009) ->
    #errorcode_msg{type = err609_not_in_kf_invade_scene,about = "你未处于跨服入侵场景"};

get(6090010) ->
    #errorcode_msg{type = err609_target_server_close,about = "目标服务器场景已关闭"};

get(6090011) ->
    #errorcode_msg{type = err609_stage_reward_unreach,about = "积分条件不足"};

get(6090012) ->
    #errorcode_msg{type = err609_stage_reward_geted,about = "已领取积分奖励"};

get(6100001) ->
    #errorcode_msg{type = err610_dungeon_role_not_exist,about = "副本玩家不存在"};

get(6100002) ->
    #errorcode_msg{type = err610_dungeon_team_args_error,about = "副本的队伍参数错误"};

get(6100003) ->
    #errorcode_msg{type = err610_not_on_safe_scene_to_enter_dungeon,about = "你不在安全区域无法进去副本"};

get(6100004) ->
    #errorcode_msg{type = err610_not_on_safe_scene_to_enter_dungeon_by_other,about = "{1}所在场景无法进入副本"};

get(6100005) ->
    #errorcode_msg{type = err610_not_enough_lv_to_enter_dungeon_by_other,about = "{1}等级不足无法进入副本"};

get(6100006) ->
    #errorcode_msg{type = err610_dungeon_count_daily_help_by_other,about = "{1}助战次数不足"};

get(6100007) ->
    #errorcode_msg{type = err610_dungeon_count_permanent_by_other,about = "{1}副本次数不足，终生最多进去{2}次"};

get(6100008) ->
    #errorcode_msg{type = err610_dungeon_count_week_by_other,about = "{1}副本次数不足，每周最多进去{2}次"};

get(6100009) ->
    #errorcode_msg{type = err610_dungeon_count_daily_by_other,about = "{1}副本次数不足"};

get(6100010) ->
    #errorcode_msg{type = err610_dungeon_not_open,about = "副本没有开启"};

get(6100011) ->
    #errorcode_msg{type = err610_just_once_finish,about = "副本已经通关，不能重复挑战"};

get(6100012) ->
    #errorcode_msg{type = err610_need_finish_dun_id,about = "需要完成前置副本"};

get(6100013) ->
    #errorcode_msg{type = err610_not_enough_lv_to_enter_dungeon,about = "等级不足，无法进入副本"};

get(6100014) ->
    #errorcode_msg{type = err610_dungeon_num_not_satisfy,about = "人数不足，无法进入副本"};

get(6100015) ->
    #errorcode_msg{type = err610_dungeon_count_cfg_error,about = "副本配置出错"};

get(6100016) ->
    #errorcode_msg{type = err610_dungeon_count_daily_help,about = "你的副本次数不足，每天助战最多进去{1}次"};

get(6100017) ->
    #errorcode_msg{type = err610_dungeon_count_permanent,about = "副本已经通关，不能重复挑战"};

get(6100018) ->
    #errorcode_msg{type = err610_dungeon_count_week,about = "你的副本次数不足，每周最多进去{1}次"};

get(6100019) ->
    #errorcode_msg{type = err610_dungeon_count_daily,about = "你的副本次数不足，每天最多进去{1}次"};

get(6100020) ->
    #errorcode_msg{type = err610_cls_team_not_enter_dungeon,about = "跨服队伍无法进入本副本"};

get(6100021) ->
    #errorcode_msg{type = err610_on_dungeon,about = "玩家已经在副本中"};

get(6100022) ->
    #errorcode_msg{type = err610_dungeon_not_exist,about = "副本不存在"};

get(6100029) ->
    #errorcode_msg{type = err610_not_on_enter_scene,about = "你不在副本进入所需场景"};

get(6100030) ->
    #errorcode_msg{type = err610_not_on_enter_scene_by_other,about = "{1}不在副本进入所需场景"};

get(6100031) ->
    #errorcode_msg{type = err610_dungeon_error,about = "副本异常,请联系GM"};

get(6100032) ->
    #errorcode_msg{type = err610_dungeon_scene_not_exist,about = "副本场景不存在"};

get(6100033) ->
    #errorcode_msg{type = err610_had_on_dungeon,about = "已经在副本"};

get(6100034) ->
    #errorcode_msg{type = err610_cannot_join_act_on_battle,about = "脱离战斗状态才能进入副本"};

get(6100035) ->
    #errorcode_msg{type = err610_cannot_join_act_on_battle_with_name,about = "{1}同意，正在脱离战斗，前往安全位置"};

get(6100038) ->
    #errorcode_msg{type = err610_have_no_count_to_enter_target_with_name,about = "{1}的次数为0，无法进入目标"};

get(6100039) ->
    #errorcode_msg{type = err610_have_no_count_to_enter_target,about = "您的次数为0，无法进入目标"};

get(6100040) ->
    #errorcode_msg{type = err610_have_no_count_to_create_target,about = "您的次数为0，无法创建目标"};

get(6100041) ->
    #errorcode_msg{type = err610_enter_cost_error,about = "您的门票不足，无法进入副本"};

get(6100042) ->
    #errorcode_msg{type = err610_buy_cost_error,about = "您的钻石余额不足，无法购买次数"};

get(6100043) ->
    #errorcode_msg{type = err610_buy_vip_error,about = "您的vip特权等级不足，无法购买次数"};

get(6100044) ->
    #errorcode_msg{type = err610_buy_limit_error,about = "今日购买次数已达上限"};

get(6100045) ->
    #errorcode_msg{type = err610_sweep_limit_error,about = "该副本不能扫荡"};

get(6100046) ->
    #errorcode_msg{type = err610_sweep_lv_limit,about = "扫荡该副本需要角色达到{1}级"};

get(6100047) ->
    #errorcode_msg{type = err610_sweep_never_finish,about = "需要通关副本才能扫荡"};

get(6100048) ->
    #errorcode_msg{type = err610_dungeon_count_daily_sweep,about = "剩余次数不足"};

get(6100049) ->
    #errorcode_msg{type = err610_dungeon_count_weekly_sweep,about = "周次数不足"};

get(6100050) ->
    #errorcode_msg{type = err610_dungeon_count_permanent_sweep,about = "终生次数不足"};

get(6100051) ->
    #errorcode_msg{type = err610_help_times_left,about = "助战奖励已发送到背包，今日还可获得{1}次助战奖励"};

get(6100052) ->
    #errorcode_msg{type = err610_encourage_count_limit,about = "鼓舞次数已达上限"};

get(6100053) ->
    #errorcode_msg{type = err610_encourage_coin_count_limit,about = "鼓舞次数已达上限"};

get(6100054) ->
    #errorcode_msg{type = err610_reset_count_limit,about = "重置次数不足"};

get(6100055) ->
    #errorcode_msg{type = err610_nothing_reset,about = "没有可重置的关卡"};

get(6100056) ->
    #errorcode_msg{type = err610_nothing_sweep,about = "当前无可扫荡的副本"};

get(6100057) ->
    #errorcode_msg{type = err610_help_reward_time_limit,about = "今日助战次数已用完，无法再获得助战奖励"};

get(6100058) ->
    #errorcode_msg{type = err610_too_many_members,about = "该副本进入人数不能超过{1}人"};

get(6100059) ->
    #errorcode_msg{type = err610_dungeon_is_end,about = "当前已经结算，无法进入"};

get(6100060) ->
    #errorcode_msg{type = err610_buy_count_error,about = "该副本不能购买次数"};

get(6100061) ->
    #errorcode_msg{type = err610_only_couple_enter,about = "该副本只能互为异性或者情侣夫妻才可进入"};

get(6100062) ->
    #errorcode_msg{type = err240_my_cost_error_exp,about = "宝库入场券不足，请到商城购买"};

get(6100063) ->
    #errorcode_msg{type = err610_is_final_dun,about = "当前已是最高关卡"};

get(6100064) ->
    #errorcode_msg{type = err610_slowdown_cd,about = "减速正在冷却中"};

get(6100065) ->
    #errorcode_msg{type = err610_not_sweep,about = "评分不足以扫荡"};

get(6100066) ->
    #errorcode_msg{type = err610_legend_lv_not_enough,about = "传奇等级不足"};

get(6100067) ->
    #errorcode_msg{type = err610_flop_time_out,about = "已过了翻牌时间"};

get(6100068) ->
    #errorcode_msg{type = err610_score_not_flop,about = "评分不足"};

get(6100069) ->
    #errorcode_msg{type = err610_vip_not_flop,about = "vip等级不足"};

get(6100070) ->
    #errorcode_msg{type = err610_not_flop_times,about = "无翻牌次数"};

get(6100071) ->
    #errorcode_msg{type = err610_has_got,about = "已经领取过"};

get(6100072) ->
    #errorcode_msg{type = err610_not_couple_can_use,about = "互为情侣才能使用技能"};

get(6100073) ->
    #errorcode_msg{type = err610_love_score_not_enough,about = "恩爱分不足，无法使用情侣技能"};

get(6100074) ->
    #errorcode_msg{type = err610_is_cd,about = "冷却中"};

get(6100075) ->
    #errorcode_msg{type = err610_has_answer,about = "已经回答过"};

get(6100076) ->
    #errorcode_msg{type = err610_quit_team,about = "请先退出队伍"};

get(6100079) ->
    #errorcode_msg{type = err610_times_is_limit,about = "使用次数已达上限"};

get(6100080) ->
    #errorcode_msg{type = err610_not_dungeon_goods,about = "不存在该道具"};

get(6100081) ->
    #errorcode_msg{type = err610_conditon_not_enough,about = "条件不足"};

get(6100082) ->
    #errorcode_msg{type = err610_reset_time,about = "当前是重置时间,请稍后进入"};

get(6100083) ->
    #errorcode_msg{type = err610_is_max_wave,about = "已达今日最高波数，不可扫荡"};

get(6100084) ->
    #errorcode_msg{type = err610_is_max_point,about = "未达到记录点，不可扫荡"};

get(6100085) ->
    #errorcode_msg{type = err610_not_unlock,about = "塔未解锁"};

get(6100086) ->
    #errorcode_msg{type = err610_please_got_sweep_reward,about = "请先领取每日奖励"};

get(6100087) ->
    #errorcode_msg{type = err610_rune_power_not_enough,about = "符文印记战力不足"};

get(6100088) ->
    #errorcode_msg{type = err610_got_tomorrow,about = "跨天才能领取"};

get(6100089) ->
    #errorcode_msg{type = err610_not_unlock_condition,about = "未达到解锁的条件"};

get(6100090) ->
    #errorcode_msg{type = err610_has_unlock,about = "该塔已经解锁"};

get(6100091) ->
    #errorcode_msg{type = err610_please_got_stage_reward,about = "请先领取完阶段奖励"};

get(6100092) ->
    #errorcode_msg{type = err610_pos_repeated,about = "此位置已翻过，请勿重复操作"};

get(6100093) ->
    #errorcode_msg{type = err610_today_not_pass,about = "请先首通副本"};

get(6100094) ->
    #errorcode_msg{type = err610_vip_buy_count_limit,about = "VIP等级不足，无法购买扫荡次数"};

get(6100095) ->
    #errorcode_msg{type = err610_dun_type_error,about = "副本类型数据有误"};

get(6100096) ->
    #errorcode_msg{type = err610_dun_flop_have_opened,about = "该水晶宝藏已开启"};

get(6100097) ->
    #errorcode_msg{type = err610_dun_have_all_sweeped,about = "副本已扫荡,请勿重复操作"};

get(6100098) ->
    #errorcode_msg{type = err610_sweep_data_error,about = "扫荡数据异常，无法扫荡"};

get(6100099) ->
    #errorcode_msg{type = err610_not_enough_vip_to_enter_dungeon,about = "VIP等级不足"};

get(6100100) ->
    #errorcode_msg{type = err610_not_exp_drop_reward,about = "暂无放置奖励可领取"};

get(6100101) ->
    #errorcode_msg{type = err610_drop_time_limit,about = "放置掉落时长已超上限"};

get(6100102) ->
    #errorcode_msg{type = err610_friend_wave_loading,about = "好友波数信息加载中,请稍后再试"};

get(6100103) ->
    #errorcode_msg{type = err610_not_first_pass,about = "副本未首通，无法领取每日奖励"};

get(6100104) ->
    #errorcode_msg{type = err610_tower_dun_rewarded,about = "暂无奖励可领取"};

get(6100105) ->
    #errorcode_msg{type = err610_dun_score_limit,about = "前置困难副本未三星通关，无法操作"};

get(6100106) ->
    #errorcode_msg{type = err610_lv_limit,about = "{1}级解锁"};

get(6100107) ->
    #errorcode_msg{type = err610_lv_task_limit,about = "{1}级主线任务解锁"};

get(6100108) ->
    #errorcode_msg{type = err610_dun_flop_not_finish,about = "副本翻牌进行中，无法操作"};

get(6100109) ->
    #errorcode_msg{type = err610_dun_pet_reward_has_receive,about = "奖励已经领取过啦"};

get(6100110) ->
    #errorcode_msg{type = err610_dun_pet_reward_err,about = "宠物副本奖励配置错误"};

get(6100111) ->
    #errorcode_msg{type = err610_dun_pet_pre_must,about = "需要先通关上一层哟"};

get(6100112) ->
    #errorcode_msg{type = err610_god_dun_not_exist_shop,about = "没有该商品，无法购买"};

get(6100113) ->
    #errorcode_msg{type = err610_shop_use_count_max,about = "该商品购买次数不足"};

get(6100114) ->
    #errorcode_msg{type = err610_score_not_enough,about = "积分不足"};

get(6100115) ->
    #errorcode_msg{type = err610_on_dungeon_cannot_operate,about = "副本进行中无法操作"};

get(6100116) ->
    #errorcode_msg{type = err610_dun_pet_count_not_enough,about = "今天宠物副本次数用完咯"};

get(6100117) ->
    #errorcode_msg{type = err610_star_not_enough,about = "星数不足"};

get(6100118) ->
    #errorcode_msg{type = err610_dun_child_mon_err,about = "放置塔配置错误"};

get(6100119) ->
    #errorcode_msg{type = err610_not_in_dun,about = "您不在副本中哟"};

get(6100120) ->
    #errorcode_msg{type = err610_cannot_sweep,about = "今天没有可以扫荡的进度哟"};

get(6100121) ->
    #errorcode_msg{type = err610_create_tower_cd,about = "放置冷却中，请稍后再试哟"};

get(6100122) ->
    #errorcode_msg{type = err610_dun_pet_rank_none,about = "未上榜，不能领取每日奖励哟"};

get(6100123) ->
    #errorcode_msg{type = err610_dun_pet_rank_reward_err,about = "宠物副本每日奖励配置错误"};

get(6100124) ->
    #errorcode_msg{type = err610_dun_pet_rank_has_received,about = "已经领取过日奖励喔"};

get(6100125) ->
    #errorcode_msg{type = err610_max_wave,about = "您已经通关最大波数了哟"};

get(6100126) ->
    #errorcode_msg{type = err610_not_through_chapter,about = "还没通关当前章节哦~"};

get(6100127) ->
    #errorcode_msg{type = err610_not_in_chapter,about = "不在此章节哦~"};

get(6100128) ->
    #errorcode_msg{type = err610_already_max_chapter,about = "已经是最后的星座了哦~"};

get(6100129) ->
    #errorcode_msg{type = err610_quick_pass_cd,about = "快速通关操作冷却中"};

get(6100130) ->
    #errorcode_msg{type = err610_guard_pass_max_wave,about = "当前召唤已达最大波数，无法再召唤"};

get(6100131) ->
    #errorcode_msg{type = err610_guard_wave_exist_max,about = "当前同时存在的波数已达上限"};

get(6100132) ->
    #errorcode_msg{type = err610_have_not_start,about = "副本还未开始，无法操作"};

get(6100133) ->
    #errorcode_msg{type = err610_has_max_times,about = "您的个人幻魔次数已满"};

get(6100134) ->
    #errorcode_msg{type = err610_pet_choose_err,about = "选择的协战宠物有误哟"};

get(6100135) ->
    #errorcode_msg{type = err610_choose_reward_err,about = "选择奖励参数有误"};

get(6100136) ->
    #errorcode_msg{type = err610_pet_choose_not_adopt,about = "未领养的宠物不能协战哟"};

get(6100137) ->
    #errorcode_msg{type = err610_cannot_choose_pet_on_dungeon,about = "副本中不能切换协战宠物哟"};

get(6100138) ->
    #errorcode_msg{type = err610_cannot_choose_reward_on_dungeon,about = "副本中不能选择奖励哟"};

get(6100139) ->
    #errorcode_msg{type = err610_cannot_choose_follow_pet,about = "不能选择主战宠物哟"};

get(6100140) ->
    #errorcode_msg{type = err610_star_not_access,about = "总星数未达到领取条件"};

get(6100141) ->
    #errorcode_msg{type = err610_exp_dun_not_pass,about = "放置挂机未开启，无法操作"};

get(6100142) ->
    #errorcode_msg{type = err610_exp_drop_rewarding,about = "放置挂机结算中，无法操作"};

get(6100143) ->
    #errorcode_msg{type = err610_exp_drop_offline_limit,about = "离线挂机增加时长已达上限"};

get(6100144) ->
    #errorcode_msg{type = err610_open_day_error,about = "开服天数条件无法满足"};

get(6100145) ->
    #errorcode_msg{type = err610_challen_count_limit,about = "挑战次数不足"};

get(6100146) ->
    #errorcode_msg{type = err610_dun_pet_not_finish,about = "您还未通关副本哦~"};

get(6100147) ->
    #errorcode_msg{type = err610_dun_pet_not_finish_three,about = "还未三星通过哟"};

get(6100148) ->
    #errorcode_msg{type = err610_max_rating_limit,about = "副本需达3S评级，无法操作"};

get(6100149) ->
    #errorcode_msg{type = err610_dun_have_three_star,about = "副本已三星通关，无法操作"};

get(6100150) ->
    #errorcode_msg{type = err610_dun_score_need_max,about = "副本未三星通关，无法操作"};

get(6100151) ->
    #errorcode_msg{type = err610_have_sweeped,about = "今日已扫荡"};

get(6100152) ->
    #errorcode_msg{type = err610_have_not_pass,about = "您未通关任何波数或副本，无法扫荡"};

get(6100153) ->
    #errorcode_msg{type = err610_have_not_sweeped,about = "今日还未扫荡，无法操作"};

get(6100154) ->
    #errorcode_msg{type = err610_mer_lv_limit,about = "等级不足，无法选择合并次数"};

get(6100155) ->
    #errorcode_msg{type = err610_mer_kill_all,about = "击破所有幻魔后解锁次数合并"};

get(6100156) ->
    #errorcode_msg{type = err610_boss_need_all_pass,about = "请先首杀所有专属幻魔"};

get(6210001) ->
    #errorcode_msg{type = err621_not_kf_1vn_challenger,about = "不是跨服1vn的挑战者"};

get(6210002) ->
    #errorcode_msg{type = err621_turn_not_enough,about = "参与过的比赛轮数不足"};

get(6210003) ->
    #errorcode_msg{type = err621_no_bet_self,about = "不能投注自己那场"};

get(6210004) ->
    #errorcode_msg{type = err621_no_sign,about = "您未报名，无法参与活动"};

get(6210005) ->
    #errorcode_msg{type = err621_has_betted,about = "您已押注过"};

get(6210006) ->
    #errorcode_msg{type = err621_no_enter,about = "不在活动中"};

get(6210007) ->
    #errorcode_msg{type = err621_not_battle,about = "未找到该场比赛"};

get(6210008) ->
    #errorcode_msg{type = err621_battle_is_end,about = "该场比赛已结束"};

get(6210009) ->
    #errorcode_msg{type = err621_not_match_yet,about = "暂未匹配到对手，请耐心等待"};

get(6210010) ->
    #errorcode_msg{type = err621_goods_not_enough,about = "道具不足"};

get(6210011) ->
    #errorcode_msg{type = err621_watch_max_num,about = "已达到最大观战人数"};

get(6210012) ->
    #errorcode_msg{type = err621_not_bet_stage,about = "当前阶段不可竞猜"};

get(6210013) ->
    #errorcode_msg{type = err621_is_signed,about = "您已报名"};

get(6210014) ->
    #errorcode_msg{type = err621_in_kf_1vn,about = "正在跨服1vn活动中"};

get(6210015) ->
    #errorcode_msg{type = err621_not_in_race_2,about = "不在守擂赛准备阶段，不可进入"};

get(6210016) ->
    #errorcode_msg{type = err621_not_kf_1vn_def,about = "不是跨服1vn的擂主"};

get(6210017) ->
    #errorcode_msg{type = err621_not_kf_1vn_area,about = "不在该赛区"};

get(6210018) ->
    #errorcode_msg{type = err621_shop_not_open,about = "跨服1vn商城未开启"};

get(6210019) ->
    #errorcode_msg{type = err621_min_auction_price,about = "本次竞拍的最小加价为{1}"};

get(6210020) ->
    #errorcode_msg{type = err621_not_in_pre_scene,about = "不在备战区"};

get(6210021) ->
    #errorcode_msg{type = err621_auction_close,about = "拍卖尚未开启"};

get(6470001) ->
    #errorcode_msg{type = err647_lv_not_enough,about = "社团等级不足"};

get(6470002) ->
    #errorcode_msg{type = err647_not_has_guild,about = "你没有参加任何社团"};

get(6470003) ->
    #errorcode_msg{type = err647_activity_not_open,about = "社团试炼活动还没开始"};

get(6470004) ->
    #errorcode_msg{type = err647_not_in_safe_area,about = "主城和安全区才可以前往活动"};

get(6470005) ->
    #errorcode_msg{type = err647_not_in_guild_war,about = "不在社团试炼中"};

get(6470006) ->
    #errorcode_msg{type = err647_in_guild_war,about = "已在活动中"};

get(6470007) ->
    #errorcode_msg{type = err647_forbid_enter_again,about = "活动期间不能以新社团再次进入"};

get(6470008) ->
    #errorcode_msg{type = err647_self_guild_is_over,about = "您社团的试炼活动已经结束"};

get(6500001) ->
    #errorcode_msg{type = err650_kf_3v3_in_kill_scene,about = "杀戮战场不能进入3v3"};

get(6500002) ->
    #errorcode_msg{type = err650_kf_3v3_not_conn,about = "连接不上跨服中心"};

get(6500003) ->
    #errorcode_msg{type = err650_kf_3v3_lack_wincount,about = "未达领取条件"};

get(6500004) ->
    #errorcode_msg{type = err650_kf_3v3_lack_reward,about = "无奖励可领取"};

get(6500005) ->
    #errorcode_msg{type = err650_kf_3v3_is_packed,about = "已领取奖励"};

get(6500006) ->
    #errorcode_msg{type = err650_kf_3v3_kick_self,about = "不能踢出自己"};

get(6500007) ->
    #errorcode_msg{type = err650_kf_3v3_long_pasm,about = "密码长度超长"};

get(6500008) ->
    #errorcode_msg{type = err650_kf_3v3_come_to_end,about = "活动即将结束不可进入战斗"};

get(6500009) ->
    #errorcode_msg{type = err650_kf_3v3_watting,about = "等待回复"};

get(6500010) ->
    #errorcode_msg{type = err650_kf_3v3_not_start,about = "活动还未开始"};

get(6500011) ->
    #errorcode_msg{type = err650_kf_3v3_delete_team,about = "删除单个队伍"};

get(6500012) ->
    #errorcode_msg{type = err650_kf_3v3_update_team,about = "刷新单个队伍"};

get(6500013) ->
    #errorcode_msg{type = err650_kf_3v3_update_teamlist,about = "刷新队列"};

get(6500014) ->
    #errorcode_msg{type = err650_kf_3v3_low_power,about = "战力不足"};

get(6500015) ->
    #errorcode_msg{type = err650_kf_3v3_low_lv,about = "等级不足"};

get(6500016) ->
    #errorcode_msg{type = err650_kf_3v3_wrong_pswd,about = "密码不对"};

get(6500017) ->
    #errorcode_msg{type = err650_kf_3v3_no_member,about = "该玩家不在队伍中"};

get(6500018) ->
    #errorcode_msg{type = err650_kf_3v3_war_end,about = "战争已结束"};

get(6500019) ->
    #errorcode_msg{type = err650_kf_3v3_not_joined,about = "未加入队伍"};

get(6500020) ->
    #errorcode_msg{type = err650_kf_3v3_cannot_reset_ready,about = "队长不能取消准备"};

get(6500021) ->
    #errorcode_msg{type = err650_kf_3v3_not_ready,about = "有玩家未准备好"};

get(6500022) ->
    #errorcode_msg{type = err650_kf_3v3_matching,about = "已在匹配队伍中"};

get(6500023) ->
    #errorcode_msg{type = err650_kf_3v3_lack_member,about = "人数不足，无法开始"};

get(6500024) ->
    #errorcode_msg{type = err650_kf_3v3_fighting,about = "战斗中，请稍后再操作"};

get(6500025) ->
    #errorcode_msg{type = err650_kf_3v3_not_captain,about = "不是队长，没有权限开始匹配"};

get(6500026) ->
    #errorcode_msg{type = err650_kf_3v3_no_team,about = "队伍已解散"};

get(6500027) ->
    #errorcode_msg{type = err650_kf_3v3_full_member,about = "队伍已满员"};

get(6500028) ->
    #errorcode_msg{type = err650_kf_3v3_in_team,about = "已有队伍"};

get(6500029) ->
    #errorcode_msg{type = err650_in_kf_3v3_act,about = "正在3v3队伍中"};

get(6500030) ->
    #errorcode_msg{type = err650_kf_3v3_lack_count,about = "参与次数不足"};

get(6500031) ->
    #errorcode_msg{type = err650_tier_not_enough,about = "3v3段位不足，无法兑换"};

get(6500032) ->
    #errorcode_msg{type = err650_hornor_limit,about = "声望不足，参加3V3可以获得更多声望哦"};

get(6500033) ->
    #errorcode_msg{type = err650_kf_3v3_call_member_full,about = "队伍已满员，无用招募了"};

get(33110152) ->
    #errorcode_msg{type = err331_exceed_max_times,about = "超过了限购次数噢"};

get(33110153) ->
    #errorcode_msg{type = err331_lack_score,about = "您的积分不足"};

get(33110154) ->
    #errorcode_msg{type = err331_lack_phase,about = "奖励还不可兑换噢~"};

get(33110155) ->
    #errorcode_msg{type = err331_draw_type_err,about = "源樱之礼抽奖类型错误"};

get(33110156) ->
    #errorcode_msg{type = err331_suit_err,about = "源樱之礼活动套数配置错误"};

get(33110157) ->
    #errorcode_msg{type = err331_sakura_store_reward_err,about = "源樱之礼商城物品配置错误"};

get(33110158) ->
    #errorcode_msg{type = err331_sakura_store_points_err,about = "源樱积分配置错误"};

get(33110159) ->
    #errorcode_msg{type = err331_sakura_exchange_num_err,about = "兑换个数错误"};

get(33110160) ->
    #errorcode_msg{type = err331_sakur_points_not_enough,about = "源樱积分不足哟"};

get(33110161) ->
    #errorcode_msg{type = err331_no_resign_times,about = "补签次数不足"};

get(33110162) ->
    #errorcode_msg{type = err331_no_need_resign,about = "不需要补签"};

get(33110163) ->
    #errorcode_msg{type = err331_cannot_buy_directly,about = "无法直接购买"};

get(33110164) ->
    #errorcode_msg{type = err331_contract_lv_error,about = "等级异常，无法操作"};

get(33110165) ->
    #errorcode_msg{type = err331_lv_have_actived,about = "等级已激活，无法操作"};

get(33110166) ->
    #errorcode_msg{type = err331_contract_lv_max,about = "已达到最大等级，无法操作"};

get(33110167) ->
    #errorcode_msg{type = err331_cannot_select,about = "需要先重置奖励哦"};

get(33110168) ->
    #errorcode_msg{type = err331_has_select,about = "已经选过了哟"};

get(33110169) ->
    #errorcode_msg{type = err331_finished_select,about = "已经选满了喔"};

get(33110170) ->
    #errorcode_msg{type = err331_select_egg_reward_err,about = "自选扭蛋配置错误"};

get(33110171) ->
    #errorcode_msg{type = err331_select_egg_reward_none,about = "还没有选择扭蛋喔"};

get(33110172) ->
    #errorcode_msg{type = err331_not_finish_select,about = "先选完奖励哟"};

get(33110173) ->
    #errorcode_msg{type = err331_not_need_reset,about = "当前不需要重置哟"};

get(33110174) ->
    #errorcode_msg{type = err331_reset_time_not_enough,about = "重置次数不足"};

get(33110175) ->
    #errorcode_msg{type = err331_cannot_cancel,about = "当前不能删除奖励哟"};

get(33110176) ->
    #errorcode_msg{type = err331_has_not_reward,about = "没有这个扭蛋奖励哟"};

get(33110177) ->
    #errorcode_msg{type = err331_select_egg_hasnot_ensure,about = "需要先确认奖励哟"};

get(33110178) ->
    #errorcode_msg{type = err331_circle_foster_return,about = "已自动领取 <color=#2cf89a>[{1}]</color> 活动奖励！"};

get(33110179) ->
    #errorcode_msg{type = err331_process_unreached,about = "未达到可领取进度"};

get(132000001) ->
    #errorcode_msg{type = err132_no_redemption_exp,about = "没有离线经验可赎回"};

get(_Id) ->
    [].

