%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc 物品配置
%%% -------------------------------------------------------
-module(data_goods_type).
-export([get_name/1, get/1, get_type/0, get_subtype/1, get_by_type/2, get_bag_default_size/1, get_bag_max_size/1]).
-include("goods.hrl").
-include("def_goods.hrl").

get_name(Id) ->
    case data_goods_type:get(Id) of
        [] -> <<>>;
        Info -> Info#ets_goods_type.goods_name
    end.

%% 内部接口 - 背包位置计算
loc(Type, SubType) ->
	SubTypeLocation = get_location_by_subtype(Type, SubType),
	TypeLocation = get_location_by_type(Type),
	if
		SubTypeLocation =/=0 -> SubTypeLocation;
		SubTypeLocation == 0 andalso TypeLocation =/= 0 -> TypeLocation;
		true -> ?GOODS_LOC_BAG
	end.

get(99999) ->
	#ets_goods_type{goods_id = 99999,goods_name = "这里是游戏货币类道具",type = 1,subtype = 1,max_overlap = 9999,color = 6,bag_location = loc(1,1)};
get(100000) ->
	#ets_goods_type{goods_id = 100000,goods_name = "彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 4,use = 1,bag_location = loc(19,1)};
get(100001) ->
	#ets_goods_type{goods_id = 100001,goods_name = "红钻",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(100002) ->
	#ets_goods_type{goods_id = 100002,goods_name = "交易券",bind = 1,type = 1,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(1,3)};
get(100003) ->
	#ets_goods_type{goods_id = 100003,goods_name = "名望券",bind = 1,type = 1,subtype = 4,max_overlap = 9999,color = 3,bag_location = loc(1,4)};
get(100004) ->
	#ets_goods_type{goods_id = 100004,goods_name = "社团贡献",bind = 1,type = 1,subtype = 5,max_overlap = 9999,color = 2,bag_location = loc(1,5)};
get(100006) ->
	#ets_goods_type{goods_id = 100006,goods_name = "社团经验值",bind = 1,type = 1,subtype = 7,max_overlap = 9999,color = 2,bag_location = loc(1,7)};
get(100007) ->
	#ets_goods_type{goods_id = 100007,goods_name = "经验值",bind = 1,type = 1,subtype = 8,max_overlap = 9999,color = 3,bag_location = loc(1,8)};
get(100008) ->
	#ets_goods_type{goods_id = 100008,goods_name = "人气值",bind = 1,type = 1,subtype = 9,max_overlap = 9999,color = 3,bag_location = loc(1,9)};
get(100009) ->
	#ets_goods_type{goods_id = 100009,goods_name = "豪气值",bind = 1,type = 1,subtype = 10,max_overlap = 9999,color = 3,bag_location = loc(1,10)};
get(100011) ->
	#ets_goods_type{goods_id = 100011,goods_name = "羁绊点",bind = 1,type = 1,subtype = 19,max_overlap = 9999,color = 3,bag_location = loc(1,19)};
get(100013) ->
	#ets_goods_type{goods_id = 100013,goods_name = "神域积分",bind = 1,type = 1,subtype = 26,max_overlap = 9999,color = 3,bag_location = loc(1,26)};
get(100014) ->
	#ets_goods_type{goods_id = 100014,goods_name = "VIP经验",bind = 1,type = 1,subtype = 27,max_overlap = 9999,color = 4,bag_location = loc(1,27)};
get(100015) ->
	#ets_goods_type{goods_id = 100015,goods_name = "嗨点值",bind = 1,type = 1,subtype = 29,max_overlap = 9999,color = 3,bag_location = loc(1,29)};
get(100017) ->
	#ets_goods_type{goods_id = 100017,goods_name = "冒险远征值",bind = 1,type = 1,subtype = 31,max_overlap = 9999,color = 3,bag_location = loc(1,31)};
get(100018) ->
	#ets_goods_type{goods_id = 100018,goods_name = "星域活跃",bind = 1,type = 1,subtype = 34,max_overlap = 9999,color = 3,bag_location = loc(1,34)};
get(100019) ->
	#ets_goods_type{goods_id = 100019,goods_name = "晋升指令",bind = 1,type = 1,subtype = 35,max_overlap = 9999,color = 3,bag_location = loc(1,35)};
get(100020) ->
	#ets_goods_type{goods_id = 100020,goods_name = "国家活跃",bind = 1,type = 1,subtype = 39,max_overlap = 9999,color = 3,bag_location = loc(1,39)};
get(100021) ->
	#ets_goods_type{goods_id = 100021,goods_name = "时装币",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 4,use = 1,bag_location = loc(19,1)};
get(100999) ->
	#ets_goods_type{goods_id = 100999,goods_name = "这里是货币类充值卡",bind = 1,type = 1,subtype = 1,max_overlap = 9999,color = 6,bag_location = loc(1,1)};
get(101000) ->
	#ets_goods_type{goods_id = 101000,goods_name = "60彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101001) ->
	#ets_goods_type{goods_id = 101001,goods_name = "300彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101002) ->
	#ets_goods_type{goods_id = 101002,goods_name = "680彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101003) ->
	#ets_goods_type{goods_id = 101003,goods_name = "1280彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101004) ->
	#ets_goods_type{goods_id = 101004,goods_name = "1980彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101005) ->
	#ets_goods_type{goods_id = 101005,goods_name = "3280彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101006) ->
	#ets_goods_type{goods_id = 101006,goods_name = "4880彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101007) ->
	#ets_goods_type{goods_id = 101007,goods_name = "6480彩钻卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101008) ->
	#ets_goods_type{goods_id = 101008,goods_name = "1红钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(101009) ->
	#ets_goods_type{goods_id = 101009,goods_name = "5红钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(101010) ->
	#ets_goods_type{goods_id = 101010,goods_name = "10红钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(101011) ->
	#ets_goods_type{goods_id = 101011,goods_name = "20红钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(101012) ->
	#ets_goods_type{goods_id = 101012,goods_name = "50红钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(101013) ->
	#ets_goods_type{goods_id = 101013,goods_name = "100红钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(101014) ->
	#ets_goods_type{goods_id = 101014,goods_name = "10交易券卡",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(101015) ->
	#ets_goods_type{goods_id = 101015,goods_name = "10名望券卡",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(101016) ->
	#ets_goods_type{goods_id = 101016,goods_name = "100社团贡献卡",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(101017) ->
	#ets_goods_type{goods_id = 101017,goods_name = "高级名望券卡",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 4,use = 1,bag_location = loc(19,1)};
get(101018) ->
	#ets_goods_type{goods_id = 101018,goods_name = "超级名望券卡",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 5,use = 1,bag_location = loc(19,1)};
get(101019) ->
	#ets_goods_type{goods_id = 101019,goods_name = "1嗨点",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(101020) ->
	#ets_goods_type{goods_id = 101020,goods_name = "10嗨点",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(101021) ->
	#ets_goods_type{goods_id = 101021,goods_name = "1冒险远征点数",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(101022) ->
	#ets_goods_type{goods_id = 101022,goods_name = "10冒险远征点数",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(101050) ->
	#ets_goods_type{goods_id = 101050,goods_name = "1彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101051) ->
	#ets_goods_type{goods_id = 101051,goods_name = "10彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101052) ->
	#ets_goods_type{goods_id = 101052,goods_name = "100彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101053) ->
	#ets_goods_type{goods_id = 101053,goods_name = "1000彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101054) ->
	#ets_goods_type{goods_id = 101054,goods_name = "300彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101055) ->
	#ets_goods_type{goods_id = 101055,goods_name = "980彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101056) ->
	#ets_goods_type{goods_id = 101056,goods_name = "1980彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101057) ->
	#ets_goods_type{goods_id = 101057,goods_name = "3280彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101058) ->
	#ets_goods_type{goods_id = 101058,goods_name = "4880彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101059) ->
	#ets_goods_type{goods_id = 101059,goods_name = "6480彩钻",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(101101) ->
	#ets_goods_type{goods_id = 101101,goods_name = "万物宝典激活卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101102) ->
	#ets_goods_type{goods_id = 101102,goods_name = "祝运宝典激活卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101150) ->
	#ets_goods_type{goods_id = 101150,goods_name = "幻魔周卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101151) ->
	#ets_goods_type{goods_id = 101151,goods_name = "幻魔月卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101152) ->
	#ets_goods_type{goods_id = 101152,goods_name = "幻魔季卡",bind = 1,type = 1,subtype = 12,max_overlap = 99999,color = 4,use = 1,bag_location = loc(1,12)};
get(101999) ->
	#ets_goods_type{goods_id = 101999,goods_name = "这里是杂物道具",bind = 1,type = 1,subtype = 1,max_overlap = 9999,color = 6,bag_location = loc(1,1)};
get(102000) ->
	#ets_goods_type{goods_id = 102000,goods_name = "复活券",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 2,bag_location = loc(1,13)};
get(102001) ->
	#ets_goods_type{goods_id = 102001,goods_name = "免罪券",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,13)};
get(102002) ->
	#ets_goods_type{goods_id = 102002,goods_name = "改名券",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,13)};
get(102003) ->
	#ets_goods_type{goods_id = 102003,goods_name = "沧海拾宝强化卡",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 3,bag_location = loc(1,13)};
get(102004) ->
	#ets_goods_type{goods_id = 102004,goods_name = "鼓舞券",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 2,bag_location = loc(1,13)};
get(102005) ->
	#ets_goods_type{goods_id = 102005,goods_name = "小特权经验卡",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,13)};
get(102006) ->
	#ets_goods_type{goods_id = 102006,goods_name = "中特权经验卡",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,13)};
get(102007) ->
	#ets_goods_type{goods_id = 102007,goods_name = "大特权经验卡",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,13)};
get(102008) ->
	#ets_goods_type{goods_id = 102008,goods_name = "vip1体验卡",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 5,use = 1,quick_use = 1,bag_location = loc(1,13)};
get(102009) ->
	#ets_goods_type{goods_id = 102009,goods_name = "外送凭证",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 2,bag_location = loc(1,13)};
get(102011) ->
	#ets_goods_type{goods_id = 102011,goods_name = "座驾直升7阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102012) ->
	#ets_goods_type{goods_id = 102012,goods_name = "炫翼直升7阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102013) ->
	#ets_goods_type{goods_id = 102013,goods_name = "宝具直升7阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102014) ->
	#ets_goods_type{goods_id = 102014,goods_name = "武器直升7阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102015) ->
	#ets_goods_type{goods_id = 102015,goods_name = "座驾直升6阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102016) ->
	#ets_goods_type{goods_id = 102016,goods_name = "炫翼直升6阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102017) ->
	#ets_goods_type{goods_id = 102017,goods_name = "宝具直升6阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102018) ->
	#ets_goods_type{goods_id = 102018,goods_name = "武器直升6阶丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102041) ->
	#ets_goods_type{goods_id = 102041,goods_name = "座驾7阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102042) ->
	#ets_goods_type{goods_id = 102042,goods_name = "炫翼7阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102043) ->
	#ets_goods_type{goods_id = 102043,goods_name = "宝具7阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102044) ->
	#ets_goods_type{goods_id = 102044,goods_name = "武器7阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102045) ->
	#ets_goods_type{goods_id = 102045,goods_name = "座驾6阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102046) ->
	#ets_goods_type{goods_id = 102046,goods_name = "炫翼6阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102047) ->
	#ets_goods_type{goods_id = 102047,goods_name = "宝具6阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102048) ->
	#ets_goods_type{goods_id = 102048,goods_name = "武器6阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,24)};
get(102051) ->
	#ets_goods_type{goods_id = 102051,goods_name = "座驾5阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,24)};
get(102052) ->
	#ets_goods_type{goods_id = 102052,goods_name = "炫翼5阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,24)};
get(102053) ->
	#ets_goods_type{goods_id = 102053,goods_name = "宝具5阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,24)};
get(102054) ->
	#ets_goods_type{goods_id = 102054,goods_name = "武器5阶升星丹",bind = 1,type = 1,subtype = 24,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,24)};
get(102099) ->
	#ets_goods_type{goods_id = 102099,goods_name = "vip体验卡（活动）",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,13)};
get(102100) ->
	#ets_goods_type{goods_id = 102100,goods_name = "1.5倍经验药",bind = 1,type = 1,subtype = 17,max_overlap = 9999,color = 2,use = 1,bag_location = loc(1,17)};
get(102101) ->
	#ets_goods_type{goods_id = 102101,goods_name = "一品固定经验药",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,15)};
get(102102) ->
	#ets_goods_type{goods_id = 102102,goods_name = "120级直升1级丹",bind = 1,type = 1,subtype = 16,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,16)};
get(102103) ->
	#ets_goods_type{goods_id = 102103,goods_name = "二品固定经验药",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,15)};
get(102104) ->
	#ets_goods_type{goods_id = 102104,goods_name = "三品固定经验药",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,15)};
get(102105) ->
	#ets_goods_type{goods_id = 102105,goods_name = "四品固定经验药",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,15)};
get(102106) ->
	#ets_goods_type{goods_id = 102106,goods_name = "五品固定经验药",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,15)};
get(102107) ->
	#ets_goods_type{goods_id = 102107,goods_name = "140级直升1级丹",bind = 1,type = 1,subtype = 16,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,16)};
get(102108) ->
	#ets_goods_type{goods_id = 102108,goods_name = "165级直升1级丹",bind = 1,type = 1,subtype = 16,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,16)};
get(102109) ->
	#ets_goods_type{goods_id = 102109,goods_name = "190级直升1级丹",bind = 1,type = 1,subtype = 16,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,16)};
get(102110) ->
	#ets_goods_type{goods_id = 102110,goods_name = "145级直升1级丹",bind = 1,type = 1,subtype = 16,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,16)};
get(102113) ->
	#ets_goods_type{goods_id = 102113,goods_name = "10万经验存储罐",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,15)};
get(102114) ->
	#ets_goods_type{goods_id = 102114,goods_name = "12万经验存储罐",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,15)};
get(102115) ->
	#ets_goods_type{goods_id = 102115,goods_name = "5万经验存储罐",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,15)};
get(102116) ->
	#ets_goods_type{goods_id = 102116,goods_name = "20万经验存储罐",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,15)};
get(102117) ->
	#ets_goods_type{goods_id = 102117,goods_name = "30万经验存储罐",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,15)};
get(102118) ->
	#ets_goods_type{goods_id = 102118,goods_name = "50万经验存储罐",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,15)};
get(102119) ->
	#ets_goods_type{goods_id = 102119,goods_name = "60万经验存储罐",bind = 1,type = 1,subtype = 15,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,15)};
get(102120) ->
	#ets_goods_type{goods_id = 102120,goods_name = "离线放置卡",bind = 1,type = 1,subtype = 41,max_overlap = 999,color = 3,use = 1,bag_location = loc(1,41)};
get(102121) ->
	#ets_goods_type{goods_id = 102121,goods_name = "魂力结晶",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 3,bag_location = loc(1,13)};
get(102200) ->
	#ets_goods_type{goods_id = 102200,goods_name = "制衣刷新券",bind = 1,type = 25,subtype = 6,max_overlap = 99,color = 3,use = 1,bag_location = loc(25,6)};
get(102300) ->
	#ets_goods_type{goods_id = 102300,goods_name = "各类抽奖券段",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 3,bag_location = loc(1,13)};
get(102301) ->
	#ets_goods_type{goods_id = 102301,goods_name = "白银灵匙",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 3,bag_location = loc(1,13)};
get(102302) ->
	#ets_goods_type{goods_id = 102302,goods_name = "白银灵匙串",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102303) ->
	#ets_goods_type{goods_id = 102303,goods_name = "黄金灵匙",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102304) ->
	#ets_goods_type{goods_id = 102304,goods_name = "黄金灵匙串",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 5,bag_location = loc(1,13)};
get(102305) ->
	#ets_goods_type{goods_id = 102305,goods_name = "龙神单抽券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 3,use = 1,bag_location = loc(1,13)};
get(102306) ->
	#ets_goods_type{goods_id = 102306,goods_name = "龙神十连券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102307) ->
	#ets_goods_type{goods_id = 102307,goods_name = "龙神五十连券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 5,bag_location = loc(1,13)};
get(102308) ->
	#ets_goods_type{goods_id = 102308,goods_name = "炫武单抽券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 3,bag_location = loc(1,13)};
get(102309) ->
	#ets_goods_type{goods_id = 102309,goods_name = "炫武十连券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102310) ->
	#ets_goods_type{goods_id = 102310,goods_name = "炫武五十连券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 5,bag_location = loc(1,13)};
get(102311) ->
	#ets_goods_type{goods_id = 102311,goods_name = "华裳单抽券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 3,bag_location = loc(1,13)};
get(102312) ->
	#ets_goods_type{goods_id = 102312,goods_name = "华裳十连券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102313) ->
	#ets_goods_type{goods_id = 102313,goods_name = "华裳五十连券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 5,bag_location = loc(1,13)};
get(102314) ->
	#ets_goods_type{goods_id = 102314,goods_name = "珍宝阁秘钥",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102320) ->
	#ets_goods_type{goods_id = 102320,goods_name = "赏金幻魔次数卡",bind = 1,type = 1,subtype = 36,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,36)};
get(102321) ->
	#ets_goods_type{goods_id = 102321,goods_name = "专属幻魔次数卡",bind = 1,type = 1,subtype = 36,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,36)};
get(102322) ->
	#ets_goods_type{goods_id = 102322,goods_name = "星域幻魔次数卡",bind = 1,type = 1,subtype = 36,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,36)};
get(102323) ->
	#ets_goods_type{goods_id = 102323,goods_name = "赏金幻魔刷新卡",bind = 1,type = 1,subtype = 37,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,37)};
get(102324) ->
	#ets_goods_type{goods_id = 102324,goods_name = "星域幻魔刷新卡",bind = 1,type = 1,subtype = 37,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,37)};
get(102325) ->
	#ets_goods_type{goods_id = 102325,goods_name = "赏金幻魔独享卡",bind = 1,type = 1,subtype = 40,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,40)};
get(102326) ->
	#ets_goods_type{goods_id = 102326,goods_name = "星域幻魔独享卡",bind = 1,type = 1,subtype = 40,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,40)};
get(102350) ->
	#ets_goods_type{goods_id = 102350,goods_name = "抽奖券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102351) ->
	#ets_goods_type{goods_id = 102351,goods_name = "弹珠币",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102352) ->
	#ets_goods_type{goods_id = 102352,goods_name = "源能币",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102353) ->
	#ets_goods_type{goods_id = 102353,goods_name = "纯净水滴",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102354) ->
	#ets_goods_type{goods_id = 102354,goods_name = "扭蛋币",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102355) ->
	#ets_goods_type{goods_id = 102355,goods_name = "擂台入场券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102356) ->
	#ets_goods_type{goods_id = 102356,goods_name = "能量结晶",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102357) ->
	#ets_goods_type{goods_id = 102357,goods_name = "占卜水晶",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102358) ->
	#ets_goods_type{goods_id = 102358,goods_name = "塔罗牌刷新券",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 5,bag_location = loc(1,13)};
get(102359) ->
	#ets_goods_type{goods_id = 102359,goods_name = "棋子",bind = 1,type = 1,subtype = 13,max_overlap = 999,color = 4,bag_location = loc(1,13)};
get(102400) ->
	#ets_goods_type{goods_id = 102400,goods_name = "各类鲜花段",bind = 1,type = 1,subtype = 13,max_overlap = 9999,bag_location = loc(1,13)};
get(102401) ->
	#ets_goods_type{goods_id = 102401,goods_name = "杨树林口红",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 2,use = 1,bag_location = loc(1,13)};
get(102402) ->
	#ets_goods_type{goods_id = 102402,goods_name = "黄桃机械键盘",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 2,use = 1,bag_location = loc(1,13)};
get(102403) ->
	#ets_goods_type{goods_id = 102403,goods_name = "任地狱掌机",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,13)};
get(102404) ->
	#ets_goods_type{goods_id = 102404,goods_name = "AOJ",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 3,use = 1,bag_location = loc(1,13)};
get(102405) ->
	#ets_goods_type{goods_id = 102405,goods_name = "爱疯20",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,13)};
get(102406) ->
	#ets_goods_type{goods_id = 102406,goods_name = "LU包包",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,13)};
get(102407) ->
	#ets_goods_type{goods_id = 102407,goods_name = "劳办土手表",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,13)};
get(102408) ->
	#ets_goods_type{goods_id = 102408,goods_name = "法拉拉跑车",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 6,use = 1,bag_location = loc(1,13)};
get(102409) ->
	#ets_goods_type{goods_id = 102409,goods_name = "亲友卡",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,use = 1,bag_location = loc(1,13)};
get(102410) ->
	#ets_goods_type{goods_id = 102410,goods_name = "亲友周卡",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 5,use = 1,bag_location = loc(1,13)};
get(102500) ->
	#ets_goods_type{goods_id = 102500,goods_name = "各类婚礼道具段",bind = 1,type = 1,subtype = 14,max_overlap = 9999,bag_location = loc(1,14)};
get(102501) ->
	#ets_goods_type{goods_id = 102501,goods_name = "牵绊枝",bind = 1,type = 4,subtype = 99,max_overlap = 9999,color = 3,bag_location = loc(4,99)};
get(102600) ->
	#ets_goods_type{goods_id = 102600,goods_name = "其余杂物顺序添加",bind = 1,type = 1,subtype = 14,max_overlap = 9999,bag_location = loc(1,14)};
get(102601) ->
	#ets_goods_type{goods_id = 102601,goods_name = "扩容钥匙",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 2,bag_location = loc(1,13)};
get(102602) ->
	#ets_goods_type{goods_id = 102602,goods_name = "小飞鞋",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 2,bag_location = loc(1,13)};
get(102603) ->
	#ets_goods_type{goods_id = 102603,goods_name = "精炼石",bind = 1,type = 1,subtype = 20,max_overlap = 9999,color = 3,bag_location = loc(1,20)};
get(102604) ->
	#ets_goods_type{goods_id = 102604,goods_name = "精炼晶块",bind = 1,type = 1,subtype = 20,max_overlap = 9999,color = 4,bag_location = loc(1,20)};
get(102605) ->
	#ets_goods_type{goods_id = 102605,goods_name = "精炼曜石粉尘",bind = 1,type = 1,subtype = 20,max_overlap = 9999,color = 3,bag_location = loc(1,20)};
get(102606) ->
	#ets_goods_type{goods_id = 102606,goods_name = "精炼曜石晶块",bind = 1,type = 1,subtype = 20,max_overlap = 9999,color = 4,bag_location = loc(1,20)};
get(102607) ->
	#ets_goods_type{goods_id = 102607,goods_name = "升星芯片",bind = 1,type = 1,subtype = 21,max_overlap = 9999,color = 3,bag_location = loc(1,21)};
get(102608) ->
	#ets_goods_type{goods_id = 102608,goods_name = "高级升星代码",bind = 1,type = 1,subtype = 21,max_overlap = 9999,color = 5,bag_location = loc(1,21)};
get(102610) ->
	#ets_goods_type{goods_id = 102610,goods_name = "大械灵之魂",type = 1,subtype = 22,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 8000,price_markup = 500,buyout_price = 12000,market_show_time = 7200,selling_time = 28800,is_to_market = 1,bag_location = loc(1,22)};
get(102611) ->
	#ets_goods_type{goods_id = 102611,goods_name = "终端械灵之魂",type = 1,subtype = 22,max_overlap = 9999,color = 5,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 20000,price_markup = 1000,buyout_price = 35000,market_show_time = 14400,selling_time = 43200,is_to_market = 1,bag_location = loc(1,22)};
get(102612) ->
	#ets_goods_type{goods_id = 102612,goods_name = "大天使之魂",type = 1,subtype = 22,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 8000,price_markup = 500,buyout_price = 12000,market_show_time = 7200,selling_time = 28800,is_to_market = 1,bag_location = loc(1,22)};
get(102613) ->
	#ets_goods_type{goods_id = 102613,goods_name = "神圣天使之魂",type = 1,subtype = 22,max_overlap = 9999,color = 5,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 20000,price_markup = 1000,buyout_price = 35000,market_show_time = 14400,selling_time = 43200,is_to_market = 1,bag_location = loc(1,22)};
get(102614) ->
	#ets_goods_type{goods_id = 102614,goods_name = "大精灵之魂",type = 1,subtype = 22,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 8000,price_markup = 500,buyout_price = 12000,market_show_time = 7200,selling_time = 28800,is_to_market = 1,bag_location = loc(1,22)};
get(102615) ->
	#ets_goods_type{goods_id = 102615,goods_name = "繁花精灵之魂",type = 1,subtype = 22,max_overlap = 9999,color = 5,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 20000,price_markup = 1000,buyout_price = 35000,market_show_time = 14400,selling_time = 43200,is_to_market = 1,bag_location = loc(1,22)};
get(102616) ->
	#ets_goods_type{goods_id = 102616,goods_name = "大人鱼之魂",type = 1,subtype = 22,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 8000,price_markup = 500,buyout_price = 12000,market_show_time = 7200,selling_time = 28800,is_to_market = 1,bag_location = loc(1,22)};
get(102617) ->
	#ets_goods_type{goods_id = 102617,goods_name = "深海人鱼之魂",type = 1,subtype = 22,max_overlap = 9999,color = 5,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 20000,price_markup = 1000,buyout_price = 35000,market_show_time = 14400,selling_time = 43200,is_to_market = 1,bag_location = loc(1,22)};
get(102618) ->
	#ets_goods_type{goods_id = 102618,goods_name = "大弓手之魂",type = 1,subtype = 22,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 8000,price_markup = 500,buyout_price = 12000,market_show_time = 7200,selling_time = 28800,is_to_market = 1,bag_location = loc(1,22)};
get(102619) ->
	#ets_goods_type{goods_id = 102619,goods_name = "森林弓手之魂",type = 1,subtype = 22,max_overlap = 9999,color = 5,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 20000,price_markup = 1000,buyout_price = 35000,market_show_time = 14400,selling_time = 43200,is_to_market = 1,bag_location = loc(1,22)};
get(102620) ->
	#ets_goods_type{goods_id = 102620,goods_name = "大凤凰之魂",type = 1,subtype = 22,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 8000,price_markup = 500,buyout_price = 12000,market_show_time = 7200,selling_time = 28800,is_to_market = 1,bag_location = loc(1,22)};
get(102621) ->
	#ets_goods_type{goods_id = 102621,goods_name = "涅槃凤凰之魂",type = 1,subtype = 22,max_overlap = 9999,color = 5,use = 1,sell_category = 6,sell_subcategory = 1,trade_price = 20000,price_markup = 1000,buyout_price = 35000,market_show_time = 14400,selling_time = 43200,is_to_market = 1,bag_location = loc(1,22)};
get(102631) ->
	#ets_goods_type{goods_id = 102631,goods_name = "升级星尘",type = 1,subtype = 13,max_overlap = 9999,color = 3,bag_location = loc(1,13)};
get(102632) ->
	#ets_goods_type{goods_id = 102632,goods_name = "突破星辉",type = 1,subtype = 13,max_overlap = 9999,color = 4,bag_location = loc(1,13)};
get(102633) ->
	#ets_goods_type{goods_id = 102633,goods_name = "星核解锁权",type = 1,subtype = 13,max_overlap = 9999,color = 5,bag_location = loc(1,13)};
get(102634) ->
	#ets_goods_type{goods_id = 102634,goods_name = "救世之心",bind = 1,type = 1,subtype = 43,max_overlap = 9999,color = 3,expire_type = 5,bag_location = loc(1,43)};
get(102635) ->
	#ets_goods_type{goods_id = 102635,goods_name = "救世积分",bind = 1,type = 1,subtype = 43,max_overlap = 9999,color = 3,expire_type = 5,bag_location = loc(1,43)};
get(102701) ->
	#ets_goods_type{goods_id = 102701,goods_name = "赛马：润滑油",bind = 1,type = 1,subtype = 14,max_overlap = 9999,color = 3,bag_location = loc(1,14)};
get(102702) ->
	#ets_goods_type{goods_id = 102702,goods_name = "赛马：千斤坠",bind = 1,type = 1,subtype = 14,max_overlap = 9999,color = 3,bag_location = loc(1,14)};
get(102703) ->
	#ets_goods_type{goods_id = 102703,goods_name = "赛马：加速器",bind = 1,type = 1,subtype = 14,max_overlap = 9999,color = 3,bag_location = loc(1,14)};
get(102704) ->
	#ets_goods_type{goods_id = 102704,goods_name = "赛马：减速器",bind = 1,type = 1,subtype = 14,max_overlap = 9999,color = 3,bag_location = loc(1,14)};
get(102705) ->
	#ets_goods_type{goods_id = 102705,goods_name = "赛博末世",bind = 1,type = 1,subtype = 22,max_overlap = 9999,color = 5,bag_location = loc(1,22)};
get(102706) ->
	#ets_goods_type{goods_id = 102706,goods_name = "奇点",bind = 1,type = 1,subtype = 22,max_overlap = 9999,color = 5,bag_location = loc(1,22)};
get(102707) ->
	#ets_goods_type{goods_id = 102707,goods_name = "奇点",bind = 1,type = 1,subtype = 22,max_overlap = 9999,color = 5,bag_location = loc(1,22)};
get(102708) ->
	#ets_goods_type{goods_id = 102708,goods_name = "利爪血蝠",bind = 1,type = 1,subtype = 22,max_overlap = 9999,color = 5,bag_location = loc(1,22)};
get(102709) ->
	#ets_goods_type{goods_id = 102709,goods_name = "元素宝石",bind = 1,type = 1,subtype = 22,max_overlap = 9999,color = 5,bag_location = loc(1,22)};
get(102710) ->
	#ets_goods_type{goods_id = 102710,goods_name = "奇点",bind = 1,type = 1,subtype = 22,max_overlap = 9999,color = 5,bag_location = loc(1,22)};
get(102711) ->
	#ets_goods_type{goods_id = 102711,goods_name = "奇点",bind = 1,type = 1,subtype = 22,max_overlap = 9999,color = 5,bag_location = loc(1,22)};
get(105000) ->
	#ets_goods_type{goods_id = 105000,goods_name = "各类运营道具段",bind = 1,type = 1,subtype = 14,max_overlap = 9999,bag_location = loc(1,14)};
get(105001) ->
	#ets_goods_type{goods_id = 105001,goods_name = "宝典积分",bind = 1,type = 1,subtype = 28,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,quick_use = 1,bag_location = loc(1,28)};
get(105002) ->
	#ets_goods_type{goods_id = 105002,goods_name = "祝运宝典·八折卡",bind = 1,type = 1,subtype = 14,max_overlap = 9999,color = 4,bag_location = loc(1,14)};
get(105005) ->
	#ets_goods_type{goods_id = 105005,goods_name = "幻魔宝典积分",bind = 1,type = 1,subtype = 28,max_overlap = 9999,color = 4,use = 1,sell_category = 6,sell_subcategory = 1,quick_use = 1,bag_location = loc(1,28)};
get(105200) ->
	#ets_goods_type{goods_id = 105200,goods_name = "折扣抽奖券",bind = 1,type = 1,subtype = 14,max_overlap = 9999,color = 5,bag_location = loc(1,14)};
get(105201) ->
	#ets_goods_type{goods_id = 105201,goods_name = "九折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 3,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105202) ->
	#ets_goods_type{goods_id = 105202,goods_name = "八折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 3,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105203) ->
	#ets_goods_type{goods_id = 105203,goods_name = "七折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 4,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105204) ->
	#ets_goods_type{goods_id = 105204,goods_name = "六折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 5,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105205) ->
	#ets_goods_type{goods_id = 105205,goods_name = "五折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 5,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105206) ->
	#ets_goods_type{goods_id = 105206,goods_name = "四折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 5,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105207) ->
	#ets_goods_type{goods_id = 105207,goods_name = "三折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 5,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105208) ->
	#ets_goods_type{goods_id = 105208,goods_name = "两折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 6,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105209) ->
	#ets_goods_type{goods_id = 105209,goods_name = "一折券",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 6,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105210) ->
	#ets_goods_type{goods_id = 105210,goods_name = "满300-200",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 5,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105211) ->
	#ets_goods_type{goods_id = 105211,goods_name = "满400-300",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 5,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105212) ->
	#ets_goods_type{goods_id = 105212,goods_name = "满200-100",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 4,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105213) ->
	#ets_goods_type{goods_id = 105213,goods_name = "满100-50",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 4,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105214) ->
	#ets_goods_type{goods_id = 105214,goods_name = "满20-10",bind = 1,type = 1,subtype = 14,max_overlap = 9,color = 3,expire_type = 5,expire_time = 432000,jump = 1,bag_location = loc(1,14)};
get(105300) ->
	#ets_goods_type{goods_id = 105300,goods_name = "集字道具·开",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 3,expire_time = 8,bag_location = loc(1,30)};
get(105301) ->
	#ets_goods_type{goods_id = 105301,goods_name = "集字道具·服",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 3,expire_time = 8,bag_location = loc(1,30)};
get(105302) ->
	#ets_goods_type{goods_id = 105302,goods_name = "集字道具·狂",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 3,expire_time = 8,bag_location = loc(1,30)};
get(105303) ->
	#ets_goods_type{goods_id = 105303,goods_name = "集字道具·欢",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 3,expire_time = 8,bag_location = loc(1,30)};
get(105304) ->
	#ets_goods_type{goods_id = 105304,goods_name = "集字道具·礼",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,expire_type = 3,expire_time = 8,bag_location = loc(1,30)};
get(105305) ->
	#ets_goods_type{goods_id = 105305,goods_name = "集字道具·下",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 2,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105306) ->
	#ets_goods_type{goods_id = 105306,goods_name = "集字道具·中",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 2,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105307) ->
	#ets_goods_type{goods_id = 105307,goods_name = "集字道具·上",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105308) ->
	#ets_goods_type{goods_id = 105308,goods_name = "集字道具·顶",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105309) ->
	#ets_goods_type{goods_id = 105309,goods_name = "集字道具·超",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105310) ->
	#ets_goods_type{goods_id = 105310,goods_name = "集字道具·土",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 2,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105311) ->
	#ets_goods_type{goods_id = 105311,goods_name = "集字道具·火",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 2,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105312) ->
	#ets_goods_type{goods_id = 105312,goods_name = "集字道具·水",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105313) ->
	#ets_goods_type{goods_id = 105313,goods_name = "集字道具·木",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105314) ->
	#ets_goods_type{goods_id = 105314,goods_name = "集字道具·金",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,expire_type = 5,expire_time = 432000,bag_location = loc(1,30)};
get(105401) ->
	#ets_goods_type{goods_id = 105401,goods_name = "黑白棋刷新券",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,bag_location = loc(1,13)};
get(105402) ->
	#ets_goods_type{goods_id = 105402,goods_name = "黑白棋抽奖券",bind = 1,type = 1,subtype = 13,max_overlap = 9999,color = 4,bag_location = loc(1,13)};
get(105501) ->
	#ets_goods_type{goods_id = 105501,goods_name = "智能芯片",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 5,bag_location = loc(1,30)};
get(105502) ->
	#ets_goods_type{goods_id = 105502,goods_name = "电路板",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,bag_location = loc(1,30)};
get(105503) ->
	#ets_goods_type{goods_id = 105503,goods_name = "透明材料",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,bag_location = loc(1,30)};
get(105504) ->
	#ets_goods_type{goods_id = 105504,goods_name = "电池",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,bag_location = loc(1,30)};
get(105505) ->
	#ets_goods_type{goods_id = 105505,goods_name = "线材",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 3,bag_location = loc(1,30)};
get(105506) ->
	#ets_goods_type{goods_id = 105506,goods_name = "材料2-1",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,bag_location = loc(1,30)};
get(105507) ->
	#ets_goods_type{goods_id = 105507,goods_name = "材料2-2",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,bag_location = loc(1,30)};
get(105508) ->
	#ets_goods_type{goods_id = 105508,goods_name = "材料2-3",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,bag_location = loc(1,30)};
get(105509) ->
	#ets_goods_type{goods_id = 105509,goods_name = "材料2-4",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,bag_location = loc(1,30)};
get(105510) ->
	#ets_goods_type{goods_id = 105510,goods_name = "材料2-5",bind = 1,type = 1,subtype = 30,max_overlap = 9999,color = 4,bag_location = loc(1,30)};
get(106000) ->
	#ets_goods_type{goods_id = 106000,goods_name = "活动兑换道具",type = 1,subtype = 33,max_overlap = 999,color = 5,expire_type = 5,expire_time = 345600,bag_location = loc(1,33)};
get(106001) ->
	#ets_goods_type{goods_id = 106001,goods_name = "纯净能量",type = 1,subtype = 33,max_overlap = 999,color = 3,expire_type = 5,expire_time = 345600,bag_location = loc(1,33)};
get(106002) ->
	#ets_goods_type{goods_id = 106002,goods_name = "战功勋章",type = 1,subtype = 33,max_overlap = 999,color = 3,expire_type = 5,expire_time = 345600,bag_location = loc(1,33)};
get(108012) ->
	#ets_goods_type{goods_id = 108012,goods_name = "1代橙装碎片",bind = 1,type = 1,subtype = 44,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,44)};
get(108022) ->
	#ets_goods_type{goods_id = 108022,goods_name = "2代橙装碎片",bind = 1,type = 1,subtype = 44,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,44)};
get(108032) ->
	#ets_goods_type{goods_id = 108032,goods_name = "3代橙装碎片",bind = 1,type = 1,subtype = 44,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,44)};
get(108042) ->
	#ets_goods_type{goods_id = 108042,goods_name = "4代橙装碎片",bind = 1,type = 1,subtype = 44,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,44)};
get(108052) ->
	#ets_goods_type{goods_id = 108052,goods_name = "5代橙装碎片",bind = 1,type = 1,subtype = 44,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,44)};
get(108062) ->
	#ets_goods_type{goods_id = 108062,goods_name = "6代橙装碎片",bind = 1,type = 1,subtype = 44,max_overlap = 999,color = 4,use = 1,bag_location = loc(1,44)};
get(109001) ->
	#ets_goods_type{goods_id = 109001,goods_name = "一级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 1,bag_location = loc(1,23)};
get(109002) ->
	#ets_goods_type{goods_id = 109002,goods_name = "二级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 2,bag_location = loc(1,23)};
get(109003) ->
	#ets_goods_type{goods_id = 109003,goods_name = "三级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 3,bag_location = loc(1,23)};
get(109004) ->
	#ets_goods_type{goods_id = 109004,goods_name = "四级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 4,bag_location = loc(1,23)};
get(109005) ->
	#ets_goods_type{goods_id = 109005,goods_name = "五级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 4,bag_location = loc(1,23)};
get(109006) ->
	#ets_goods_type{goods_id = 109006,goods_name = "六级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109007) ->
	#ets_goods_type{goods_id = 109007,goods_name = "七级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109008) ->
	#ets_goods_type{goods_id = 109008,goods_name = "八级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109009) ->
	#ets_goods_type{goods_id = 109009,goods_name = "九级红宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109011) ->
	#ets_goods_type{goods_id = 109011,goods_name = "一级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 1,bag_location = loc(1,23)};
get(109012) ->
	#ets_goods_type{goods_id = 109012,goods_name = "二级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 2,bag_location = loc(1,23)};
get(109013) ->
	#ets_goods_type{goods_id = 109013,goods_name = "三级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 3,bag_location = loc(1,23)};
get(109014) ->
	#ets_goods_type{goods_id = 109014,goods_name = "四级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 4,bag_location = loc(1,23)};
get(109015) ->
	#ets_goods_type{goods_id = 109015,goods_name = "五级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 4,bag_location = loc(1,23)};
get(109016) ->
	#ets_goods_type{goods_id = 109016,goods_name = "六级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109017) ->
	#ets_goods_type{goods_id = 109017,goods_name = "七级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109018) ->
	#ets_goods_type{goods_id = 109018,goods_name = "八级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109019) ->
	#ets_goods_type{goods_id = 109019,goods_name = "九级蓝宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109021) ->
	#ets_goods_type{goods_id = 109021,goods_name = "一级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 1,bag_location = loc(1,23)};
get(109022) ->
	#ets_goods_type{goods_id = 109022,goods_name = "二级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 2,bag_location = loc(1,23)};
get(109023) ->
	#ets_goods_type{goods_id = 109023,goods_name = "三级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 3,bag_location = loc(1,23)};
get(109024) ->
	#ets_goods_type{goods_id = 109024,goods_name = "四级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 4,bag_location = loc(1,23)};
get(109025) ->
	#ets_goods_type{goods_id = 109025,goods_name = "五级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 4,bag_location = loc(1,23)};
get(109026) ->
	#ets_goods_type{goods_id = 109026,goods_name = "六级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109027) ->
	#ets_goods_type{goods_id = 109027,goods_name = "七级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109028) ->
	#ets_goods_type{goods_id = 109028,goods_name = "八级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109029) ->
	#ets_goods_type{goods_id = 109029,goods_name = "九级绿宝石",bind = 1,type = 1,subtype = 23,max_overlap = 9999,color = 5,bag_location = loc(1,23)};
get(109031) ->
	#ets_goods_type{goods_id = 109031,goods_name = "1级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 1,use = 1,bag_location = loc(19,1)};
get(109032) ->
	#ets_goods_type{goods_id = 109032,goods_name = "2级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 2,use = 1,bag_location = loc(19,1)};
get(109033) ->
	#ets_goods_type{goods_id = 109033,goods_name = "3级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(109034) ->
	#ets_goods_type{goods_id = 109034,goods_name = "4级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(109035) ->
	#ets_goods_type{goods_id = 109035,goods_name = "5级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(109036) ->
	#ets_goods_type{goods_id = 109036,goods_name = "6级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 5,use = 1,bag_location = loc(19,1)};
get(109037) ->
	#ets_goods_type{goods_id = 109037,goods_name = "7级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 5,use = 1,bag_location = loc(19,1)};
get(109038) ->
	#ets_goods_type{goods_id = 109038,goods_name = "8级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 5,use = 1,bag_location = loc(19,1)};
get(109039) ->
	#ets_goods_type{goods_id = 109039,goods_name = "9级宝石礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 5,use = 1,bag_location = loc(19,1)};
get(209999) ->
	#ets_goods_type{goods_id = 209999,goods_name = "这里是各系统段（各均1w空位）",bind = 1,type = 2,subtype = 1,max_overlap = 9999,color = 6,bag_location = loc(2,1)};
get(210000) ->
	#ets_goods_type{goods_id = 210000,goods_name = "人物技能书段",bind = 1,type = 2,subtype = 1,max_overlap = 9999,bag_location = loc(2,1)};
get(210101) ->
	#ets_goods_type{goods_id = 210101,goods_name = "【职】火轮舞",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 1,bag_location = loc(2,1)};
get(210102) ->
	#ets_goods_type{goods_id = 210102,goods_name = "【职】影之溯",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 1,bag_location = loc(2,1)};
get(210103) ->
	#ets_goods_type{goods_id = 210103,goods_name = "【职】剑星雨",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 1,bag_location = loc(2,1)};
get(210104) ->
	#ets_goods_type{goods_id = 210104,goods_name = "【职】次元云梭",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 1,bag_location = loc(2,1)};
get(210105) ->
	#ets_goods_type{goods_id = 210105,goods_name = "【职】蓄能破刃",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 1,bag_location = loc(2,1)};
get(210106) ->
	#ets_goods_type{goods_id = 210106,goods_name = "【职】妖刀乱杀",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 1,bag_location = loc(2,1)};
get(210107) ->
	#ets_goods_type{goods_id = 210107,goods_name = "【职】爆破冰炎",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 1,bag_location = loc(2,1)};
get(210108) ->
	#ets_goods_type{goods_id = 210108,goods_name = "【职】魂力汲取",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 1,bag_location = loc(2,1)};
get(210109) ->
	#ets_goods_type{goods_id = 210109,goods_name = "【怒】百万剑宝库",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,career = 1,bag_location = loc(2,1)};
get(210111) ->
	#ets_goods_type{goods_id = 210111,goods_name = "【传说】火轮舞",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210112) ->
	#ets_goods_type{goods_id = 210112,goods_name = "【传说】影之溯",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210113) ->
	#ets_goods_type{goods_id = 210113,goods_name = "【传说】剑星雨",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210114) ->
	#ets_goods_type{goods_id = 210114,goods_name = "【传说】次元云梭",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210115) ->
	#ets_goods_type{goods_id = 210115,goods_name = "【传说】蓄能破刃",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210116) ->
	#ets_goods_type{goods_id = 210116,goods_name = "【传说】妖刀乱杀",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210117) ->
	#ets_goods_type{goods_id = 210117,goods_name = "【传说】爆破冰炎",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210118) ->
	#ets_goods_type{goods_id = 210118,goods_name = "【传说】魂力汲取",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 1,bag_location = loc(2,1)};
get(210201) ->
	#ets_goods_type{goods_id = 210201,goods_name = "【职】火轮舞",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 2,bag_location = loc(2,1)};
get(210202) ->
	#ets_goods_type{goods_id = 210202,goods_name = "【职】影之溯",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 2,bag_location = loc(2,1)};
get(210203) ->
	#ets_goods_type{goods_id = 210203,goods_name = "【职】剑星雨",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 2,bag_location = loc(2,1)};
get(210204) ->
	#ets_goods_type{goods_id = 210204,goods_name = "【职】次元云梭",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 2,bag_location = loc(2,1)};
get(210205) ->
	#ets_goods_type{goods_id = 210205,goods_name = "【职】蓄能破刃",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 2,bag_location = loc(2,1)};
get(210206) ->
	#ets_goods_type{goods_id = 210206,goods_name = "【职】妖刀乱杀",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 2,bag_location = loc(2,1)};
get(210207) ->
	#ets_goods_type{goods_id = 210207,goods_name = "【职】爆破冰炎",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 2,bag_location = loc(2,1)};
get(210208) ->
	#ets_goods_type{goods_id = 210208,goods_name = "【职】魂力汲取",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 2,bag_location = loc(2,1)};
get(210209) ->
	#ets_goods_type{goods_id = 210209,goods_name = "【怒】百万剑宝库",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,career = 2,bag_location = loc(2,1)};
get(210211) ->
	#ets_goods_type{goods_id = 210211,goods_name = "【传说】火轮舞",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210212) ->
	#ets_goods_type{goods_id = 210212,goods_name = "【传说】影之溯",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210213) ->
	#ets_goods_type{goods_id = 210213,goods_name = "【传说】剑星雨",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210214) ->
	#ets_goods_type{goods_id = 210214,goods_name = "【传说】次元云梭",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210215) ->
	#ets_goods_type{goods_id = 210215,goods_name = "【传说】蓄能破刃",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210216) ->
	#ets_goods_type{goods_id = 210216,goods_name = "【传说】妖刀乱杀",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210217) ->
	#ets_goods_type{goods_id = 210217,goods_name = "【传说】爆破冰炎",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210218) ->
	#ets_goods_type{goods_id = 210218,goods_name = "【传说】魂力汲取",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 2,bag_location = loc(2,1)};
get(210301) ->
	#ets_goods_type{goods_id = 210301,goods_name = "【职】轮转枪",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 3,bag_location = loc(2,1)};
get(210302) ->
	#ets_goods_type{goods_id = 210302,goods_name = "【职】暗能炮",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 3,bag_location = loc(2,1)};
get(210303) ->
	#ets_goods_type{goods_id = 210303,goods_name = "【职】散华弹",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 3,bag_location = loc(2,1)};
get(210304) ->
	#ets_goods_type{goods_id = 210304,goods_name = "【职】制空核爆",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 3,bag_location = loc(2,1)};
get(210305) ->
	#ets_goods_type{goods_id = 210305,goods_name = "【职】分身连射",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 3,bag_location = loc(2,1)};
get(210306) ->
	#ets_goods_type{goods_id = 210306,goods_name = "【职】重能炮台",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 3,bag_location = loc(2,1)};
get(210307) ->
	#ets_goods_type{goods_id = 210307,goods_name = "【职】熔岩爆破",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 3,bag_location = loc(2,1)};
get(210308) ->
	#ets_goods_type{goods_id = 210308,goods_name = "【职】火力充能",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 3,bag_location = loc(2,1)};
get(210309) ->
	#ets_goods_type{goods_id = 210309,goods_name = "【怒】魔弹辰星落",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,career = 3,bag_location = loc(2,1)};
get(210311) ->
	#ets_goods_type{goods_id = 210311,goods_name = "【传说】轮转枪",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210312) ->
	#ets_goods_type{goods_id = 210312,goods_name = "【传说】暗能炮",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210313) ->
	#ets_goods_type{goods_id = 210313,goods_name = "【传说】散华弹",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210314) ->
	#ets_goods_type{goods_id = 210314,goods_name = "【传说】制空核爆",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210315) ->
	#ets_goods_type{goods_id = 210315,goods_name = "【传说】分身连射",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210316) ->
	#ets_goods_type{goods_id = 210316,goods_name = "【传说】重能炮台",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210317) ->
	#ets_goods_type{goods_id = 210317,goods_name = "【传说】熔岩爆破",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210318) ->
	#ets_goods_type{goods_id = 210318,goods_name = "【传说】火力充能",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 3,bag_location = loc(2,1)};
get(210401) ->
	#ets_goods_type{goods_id = 210401,goods_name = "【职】轮转枪",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 4,bag_location = loc(2,1)};
get(210402) ->
	#ets_goods_type{goods_id = 210402,goods_name = "【职】暗能炮",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 4,bag_location = loc(2,1)};
get(210403) ->
	#ets_goods_type{goods_id = 210403,goods_name = "【职】散华弹",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 4,bag_location = loc(2,1)};
get(210404) ->
	#ets_goods_type{goods_id = 210404,goods_name = "【职】制空核爆",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,career = 4,bag_location = loc(2,1)};
get(210405) ->
	#ets_goods_type{goods_id = 210405,goods_name = "【职】分身连射",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 4,bag_location = loc(2,1)};
get(210406) ->
	#ets_goods_type{goods_id = 210406,goods_name = "【职】重能炮台",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 4,bag_location = loc(2,1)};
get(210407) ->
	#ets_goods_type{goods_id = 210407,goods_name = "【职】熔岩爆破",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 4,bag_location = loc(2,1)};
get(210408) ->
	#ets_goods_type{goods_id = 210408,goods_name = "【职】火力充能",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,career = 4,bag_location = loc(2,1)};
get(210409) ->
	#ets_goods_type{goods_id = 210409,goods_name = "【怒】魔弹辰星落",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,career = 4,bag_location = loc(2,1)};
get(210411) ->
	#ets_goods_type{goods_id = 210411,goods_name = "【传说】轮转枪",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210412) ->
	#ets_goods_type{goods_id = 210412,goods_name = "【传说】暗能炮",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210413) ->
	#ets_goods_type{goods_id = 210413,goods_name = "【传说】散华弹",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210414) ->
	#ets_goods_type{goods_id = 210414,goods_name = "【传说】制空核爆",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210415) ->
	#ets_goods_type{goods_id = 210415,goods_name = "【传说】分身连射",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210416) ->
	#ets_goods_type{goods_id = 210416,goods_name = "【传说】重能炮台",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210417) ->
	#ets_goods_type{goods_id = 210417,goods_name = "【传说】熔岩爆破",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210418) ->
	#ets_goods_type{goods_id = 210418,goods_name = "【传说】火力充能",bind = 1,type = 2,subtype = 1,level = 350,max_overlap = 999,color = 5,career = 4,bag_location = loc(2,1)};
get(210499) ->
	#ets_goods_type{goods_id = 210499,goods_name = "VIP技能EX升级礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 5,use = 1,bag_location = loc(19,1)};
get(210901) ->
	#ets_goods_type{goods_id = 210901,goods_name = "【辅】幻魔狩猎",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(210902) ->
	#ets_goods_type{goods_id = 210902,goods_name = "【辅】精英狩猎",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(210903) ->
	#ets_goods_type{goods_id = 210903,goods_name = "【辅】同心勉励",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(210904) ->
	#ets_goods_type{goods_id = 210904,goods_name = "【辅】复生庇佑",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(210905) ->
	#ets_goods_type{goods_id = 210905,goods_name = "【辅】浴血庇佑",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(210906) ->
	#ets_goods_type{goods_id = 210906,goods_name = "【辅】灵魂压制",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(210907) ->
	#ets_goods_type{goods_id = 210907,goods_name = "【辅】灵魂冲击",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(210908) ->
	#ets_goods_type{goods_id = 210908,goods_name = "【辅】暴击护盾",bind = 1,type = 2,subtype = 1,level = 230,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(211001) ->
	#ets_goods_type{goods_id = 211001,goods_name = "【被】攻击",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,bag_location = loc(2,1)};
get(211002) ->
	#ets_goods_type{goods_id = 211002,goods_name = "【被】防御",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,bag_location = loc(2,1)};
get(211003) ->
	#ets_goods_type{goods_id = 211003,goods_name = "【被】生命",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,bag_location = loc(2,1)};
get(211004) ->
	#ets_goods_type{goods_id = 211004,goods_name = "【被】命中",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,bag_location = loc(2,1)};
get(211005) ->
	#ets_goods_type{goods_id = 211005,goods_name = "【被】闪避",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,bag_location = loc(2,1)};
get(211006) ->
	#ets_goods_type{goods_id = 211006,goods_name = "【被】暴击",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,bag_location = loc(2,1)};
get(211007) ->
	#ets_goods_type{goods_id = 211007,goods_name = "【被】坚韧",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 3,bag_location = loc(2,1)};
get(211008) ->
	#ets_goods_type{goods_id = 211008,goods_name = "【辅】永恒回复",bind = 1,type = 2,subtype = 1,max_overlap = 999,color = 4,bag_location = loc(2,1)};
get(220000) ->
	#ets_goods_type{goods_id = 220000,goods_name = "幻光剑池段",bind = 1,type = 3,subtype = 1,max_overlap = 9999,bag_location = loc(3,1)};
get(221001) ->
	#ets_goods_type{goods_id = 221001,goods_name = "幻相光影",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(3,1)};
get(222001) ->
	#ets_goods_type{goods_id = 222001,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222002) ->
	#ets_goods_type{goods_id = 222002,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222003) ->
	#ets_goods_type{goods_id = 222003,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222004) ->
	#ets_goods_type{goods_id = 222004,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222005) ->
	#ets_goods_type{goods_id = 222005,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222006) ->
	#ets_goods_type{goods_id = 222006,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222007) ->
	#ets_goods_type{goods_id = 222007,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222008) ->
	#ets_goods_type{goods_id = 222008,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(222009) ->
	#ets_goods_type{goods_id = 222009,goods_name = "幻光突破",bind = 1,type = 3,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(3,1)};
get(230000) ->
	#ets_goods_type{goods_id = 230000,goods_name = "进阶系统段",bind = 1,type = 4,subtype = 1,max_overlap = 9999,bag_location = loc(4,1)};
get(230001) ->
	#ets_goods_type{goods_id = 230001,goods_name = "座驾进阶材料",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230002) ->
	#ets_goods_type{goods_id = 230002,goods_name = "炫翼进阶材料",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230003) ->
	#ets_goods_type{goods_id = 230003,goods_name = "宝具进阶材料",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230004) ->
	#ets_goods_type{goods_id = 230004,goods_name = "武器进阶材料",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230005) ->
	#ets_goods_type{goods_id = 230005,goods_name = "AI娘进阶方砖",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(4,1)};
get(230006) ->
	#ets_goods_type{goods_id = 230006,goods_name = "磁炮进阶方砖",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(4,1)};
get(230007) ->
	#ets_goods_type{goods_id = 230007,goods_name = "星翼进阶方砖",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(4,1)};
get(230008) ->
	#ets_goods_type{goods_id = 230008,goods_name = "幻甲进阶方砖",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(4,1)};
get(230009) ->
	#ets_goods_type{goods_id = 230009,goods_name = "AI娘进阶晶体",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230010) ->
	#ets_goods_type{goods_id = 230010,goods_name = "AI娘进阶碎片",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 2,bag_location = loc(4,1)};
get(230011) ->
	#ets_goods_type{goods_id = 230011,goods_name = "磁炮进阶晶体",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230012) ->
	#ets_goods_type{goods_id = 230012,goods_name = "磁炮进阶碎片",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 2,bag_location = loc(4,1)};
get(230013) ->
	#ets_goods_type{goods_id = 230013,goods_name = "星翼进阶晶体",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230014) ->
	#ets_goods_type{goods_id = 230014,goods_name = "星翼进阶碎片",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 2,bag_location = loc(4,1)};
get(230015) ->
	#ets_goods_type{goods_id = 230015,goods_name = "幻甲进阶晶体",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(4,1)};
get(230016) ->
	#ets_goods_type{goods_id = 230016,goods_name = "幻甲进阶碎片",bind = 1,type = 4,subtype = 1,max_overlap = 9999,color = 2,bag_location = loc(4,1)};
get(230051) ->
	#ets_goods_type{goods_id = 230051,goods_name = "座驾基础芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 2,bag_location = loc(4,2)};
get(230052) ->
	#ets_goods_type{goods_id = 230052,goods_name = "炫翼基础芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 2,bag_location = loc(4,2)};
get(230053) ->
	#ets_goods_type{goods_id = 230053,goods_name = "宝具基础芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 2,bag_location = loc(4,2)};
get(230054) ->
	#ets_goods_type{goods_id = 230054,goods_name = "武器基础芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 2,bag_location = loc(4,2)};
get(230101) ->
	#ets_goods_type{goods_id = 230101,goods_name = "座驾初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230102) ->
	#ets_goods_type{goods_id = 230102,goods_name = "炫翼初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230103) ->
	#ets_goods_type{goods_id = 230103,goods_name = "宝具初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230104) ->
	#ets_goods_type{goods_id = 230104,goods_name = "武器初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230105) ->
	#ets_goods_type{goods_id = 230105,goods_name = "AI娘初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230106) ->
	#ets_goods_type{goods_id = 230106,goods_name = "磁炮初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230107) ->
	#ets_goods_type{goods_id = 230107,goods_name = "星翼初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230108) ->
	#ets_goods_type{goods_id = 230108,goods_name = "幻甲初级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(4,2)};
get(230151) ->
	#ets_goods_type{goods_id = 230151,goods_name = "座驾中级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(4,2)};
get(230152) ->
	#ets_goods_type{goods_id = 230152,goods_name = "炫翼中级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(4,2)};
get(230153) ->
	#ets_goods_type{goods_id = 230153,goods_name = "宝具中级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(4,2)};
get(230154) ->
	#ets_goods_type{goods_id = 230154,goods_name = "武器中级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(4,2)};
get(230201) ->
	#ets_goods_type{goods_id = 230201,goods_name = "座驾高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230202) ->
	#ets_goods_type{goods_id = 230202,goods_name = "炫翼高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230203) ->
	#ets_goods_type{goods_id = 230203,goods_name = "宝具高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230204) ->
	#ets_goods_type{goods_id = 230204,goods_name = "武器高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230205) ->
	#ets_goods_type{goods_id = 230205,goods_name = "AI娘高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230206) ->
	#ets_goods_type{goods_id = 230206,goods_name = "磁炮高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230207) ->
	#ets_goods_type{goods_id = 230207,goods_name = "星翼高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230208) ->
	#ets_goods_type{goods_id = 230208,goods_name = "幻甲高级芯片",bind = 1,type = 4,subtype = 2,max_overlap = 9999,color = 6,bag_location = loc(4,2)};
get(230301) ->
	#ets_goods_type{goods_id = 230301,goods_name = "座驾技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230302) ->
	#ets_goods_type{goods_id = 230302,goods_name = "炫翼技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230303) ->
	#ets_goods_type{goods_id = 230303,goods_name = "宝具技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230304) ->
	#ets_goods_type{goods_id = 230304,goods_name = "武器技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230305) ->
	#ets_goods_type{goods_id = 230305,goods_name = "AI娘技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230306) ->
	#ets_goods_type{goods_id = 230306,goods_name = "磁炮技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230307) ->
	#ets_goods_type{goods_id = 230307,goods_name = "星翼技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230308) ->
	#ets_goods_type{goods_id = 230308,goods_name = "幻甲技能书",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230401) ->
	#ets_goods_type{goods_id = 230401,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230402) ->
	#ets_goods_type{goods_id = 230402,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230403) ->
	#ets_goods_type{goods_id = 230403,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230404) ->
	#ets_goods_type{goods_id = 230404,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230405) ->
	#ets_goods_type{goods_id = 230405,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230406) ->
	#ets_goods_type{goods_id = 230406,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230407) ->
	#ets_goods_type{goods_id = 230407,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230408) ->
	#ets_goods_type{goods_id = 230408,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230501) ->
	#ets_goods_type{goods_id = 230501,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230502) ->
	#ets_goods_type{goods_id = 230502,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230503) ->
	#ets_goods_type{goods_id = 230503,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230504) ->
	#ets_goods_type{goods_id = 230504,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230505) ->
	#ets_goods_type{goods_id = 230505,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230506) ->
	#ets_goods_type{goods_id = 230506,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230507) ->
	#ets_goods_type{goods_id = 230507,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230508) ->
	#ets_goods_type{goods_id = 230508,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230601) ->
	#ets_goods_type{goods_id = 230601,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230602) ->
	#ets_goods_type{goods_id = 230602,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230603) ->
	#ets_goods_type{goods_id = 230603,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230604) ->
	#ets_goods_type{goods_id = 230604,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230605) ->
	#ets_goods_type{goods_id = 230605,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230606) ->
	#ets_goods_type{goods_id = 230606,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230607) ->
	#ets_goods_type{goods_id = 230607,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(230608) ->
	#ets_goods_type{goods_id = 230608,goods_name = "备用字段",bind = 1,type = 4,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(4,3)};
get(231001) ->
	#ets_goods_type{goods_id = 231001,goods_name = "座驾核心",type = 4,subtype = 4,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231002) ->
	#ets_goods_type{goods_id = 231002,goods_name = "座驾喷射器",type = 4,subtype = 4,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231003) ->
	#ets_goods_type{goods_id = 231003,goods_name = "座驾坐垫",type = 4,subtype = 4,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231004) ->
	#ets_goods_type{goods_id = 231004,goods_name = "座驾稳定器",type = 4,subtype = 4,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231005) ->
	#ets_goods_type{goods_id = 231005,goods_name = "座驾头甲",type = 4,subtype = 4,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231006) ->
	#ets_goods_type{goods_id = 231006,goods_name = "座驾导航",type = 4,subtype = 4,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231011) ->
	#ets_goods_type{goods_id = 231011,goods_name = "座驾核心",type = 4,subtype = 4,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231012) ->
	#ets_goods_type{goods_id = 231012,goods_name = "座驾喷射器",type = 4,subtype = 4,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231013) ->
	#ets_goods_type{goods_id = 231013,goods_name = "座驾坐垫",type = 4,subtype = 4,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231014) ->
	#ets_goods_type{goods_id = 231014,goods_name = "座驾稳定器",type = 4,subtype = 4,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231015) ->
	#ets_goods_type{goods_id = 231015,goods_name = "座驾头甲",type = 4,subtype = 4,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231016) ->
	#ets_goods_type{goods_id = 231016,goods_name = "座驾导航",type = 4,subtype = 4,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,4)};
get(231021) ->
	#ets_goods_type{goods_id = 231021,goods_name = "座驾核心",type = 4,subtype = 4,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,4)};
get(231022) ->
	#ets_goods_type{goods_id = 231022,goods_name = "座驾喷射器",type = 4,subtype = 4,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,4)};
get(231023) ->
	#ets_goods_type{goods_id = 231023,goods_name = "座驾坐垫",type = 4,subtype = 4,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,4)};
get(231024) ->
	#ets_goods_type{goods_id = 231024,goods_name = "座驾稳定器",type = 4,subtype = 4,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,4)};
get(231025) ->
	#ets_goods_type{goods_id = 231025,goods_name = "座驾头甲",type = 4,subtype = 4,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,4)};
get(231026) ->
	#ets_goods_type{goods_id = 231026,goods_name = "座驾导航",type = 4,subtype = 4,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,4)};
get(231031) ->
	#ets_goods_type{goods_id = 231031,goods_name = "座驾核心",type = 4,subtype = 4,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,4)};
get(231032) ->
	#ets_goods_type{goods_id = 231032,goods_name = "座驾喷射器",type = 4,subtype = 4,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,4)};
get(231033) ->
	#ets_goods_type{goods_id = 231033,goods_name = "座驾坐垫",type = 4,subtype = 4,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,4)};
get(231034) ->
	#ets_goods_type{goods_id = 231034,goods_name = "座驾稳定器",type = 4,subtype = 4,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,4)};
get(231035) ->
	#ets_goods_type{goods_id = 231035,goods_name = "座驾头甲",type = 4,subtype = 4,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,4)};
get(231036) ->
	#ets_goods_type{goods_id = 231036,goods_name = "座驾导航",type = 4,subtype = 4,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,4)};
get(231041) ->
	#ets_goods_type{goods_id = 231041,goods_name = "座驾核心",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,4)};
get(231042) ->
	#ets_goods_type{goods_id = 231042,goods_name = "座驾喷射器",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,4)};
get(231043) ->
	#ets_goods_type{goods_id = 231043,goods_name = "座驾坐垫",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,4)};
get(231044) ->
	#ets_goods_type{goods_id = 231044,goods_name = "座驾稳定器",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,4)};
get(231045) ->
	#ets_goods_type{goods_id = 231045,goods_name = "座驾头甲",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,4)};
get(231046) ->
	#ets_goods_type{goods_id = 231046,goods_name = "座驾导航",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,4)};
get(231051) ->
	#ets_goods_type{goods_id = 231051,goods_name = "座驾核心",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(4,4)};
get(231052) ->
	#ets_goods_type{goods_id = 231052,goods_name = "座驾喷射器",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(4,4)};
get(231053) ->
	#ets_goods_type{goods_id = 231053,goods_name = "座驾坐垫",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(4,4)};
get(231054) ->
	#ets_goods_type{goods_id = 231054,goods_name = "座驾稳定器",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(4,4)};
get(231055) ->
	#ets_goods_type{goods_id = 231055,goods_name = "座驾头甲",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(4,4)};
get(231056) ->
	#ets_goods_type{goods_id = 231056,goods_name = "座驾导航",bind = 1,type = 4,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(4,4)};
get(232001) ->
	#ets_goods_type{goods_id = 232001,goods_name = "AI娘核心",type = 4,subtype = 5,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232002) ->
	#ets_goods_type{goods_id = 232002,goods_name = "AI娘能源",type = 4,subtype = 5,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232003) ->
	#ets_goods_type{goods_id = 232003,goods_name = "AI娘发饰",type = 4,subtype = 5,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232004) ->
	#ets_goods_type{goods_id = 232004,goods_name = "AI娘战斗服",type = 4,subtype = 5,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232005) ->
	#ets_goods_type{goods_id = 232005,goods_name = "AI娘战斗裙",type = 4,subtype = 5,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232006) ->
	#ets_goods_type{goods_id = 232006,goods_name = "AI娘战斗靴",type = 4,subtype = 5,max_overlap = 1,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 1000,price_markup = 200,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232011) ->
	#ets_goods_type{goods_id = 232011,goods_name = "AI娘核心",type = 4,subtype = 5,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232012) ->
	#ets_goods_type{goods_id = 232012,goods_name = "AI娘能源",type = 4,subtype = 5,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232013) ->
	#ets_goods_type{goods_id = 232013,goods_name = "AI娘发饰",type = 4,subtype = 5,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232014) ->
	#ets_goods_type{goods_id = 232014,goods_name = "AI娘战斗服",type = 4,subtype = 5,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232015) ->
	#ets_goods_type{goods_id = 232015,goods_name = "AI娘战斗裙",type = 4,subtype = 5,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232016) ->
	#ets_goods_type{goods_id = 232016,goods_name = "AI娘战斗靴",type = 4,subtype = 5,max_overlap = 1,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(4,5)};
get(232021) ->
	#ets_goods_type{goods_id = 232021,goods_name = "AI娘核心",type = 4,subtype = 5,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,5)};
get(232022) ->
	#ets_goods_type{goods_id = 232022,goods_name = "AI娘能源",type = 4,subtype = 5,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,5)};
get(232023) ->
	#ets_goods_type{goods_id = 232023,goods_name = "AI娘发饰",type = 4,subtype = 5,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,5)};
get(232024) ->
	#ets_goods_type{goods_id = 232024,goods_name = "AI娘战斗服",type = 4,subtype = 5,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,5)};
get(232025) ->
	#ets_goods_type{goods_id = 232025,goods_name = "AI娘战斗裙",type = 4,subtype = 5,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,5)};
get(232026) ->
	#ets_goods_type{goods_id = 232026,goods_name = "AI娘战斗靴",type = 4,subtype = 5,max_overlap = 1,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 3200,price_markup = 640,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(4,5)};
get(232031) ->
	#ets_goods_type{goods_id = 232031,goods_name = "AI娘核心",type = 4,subtype = 5,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,5)};
get(232032) ->
	#ets_goods_type{goods_id = 232032,goods_name = "AI娘能源",type = 4,subtype = 5,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,5)};
get(232033) ->
	#ets_goods_type{goods_id = 232033,goods_name = "AI娘发饰",type = 4,subtype = 5,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,5)};
get(232034) ->
	#ets_goods_type{goods_id = 232034,goods_name = "AI娘战斗服",type = 4,subtype = 5,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,5)};
get(232035) ->
	#ets_goods_type{goods_id = 232035,goods_name = "AI娘战斗裙",type = 4,subtype = 5,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,5)};
get(232036) ->
	#ets_goods_type{goods_id = 232036,goods_name = "AI娘战斗靴",type = 4,subtype = 5,max_overlap = 1,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 4500,price_markup = 900,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(4,5)};
get(232041) ->
	#ets_goods_type{goods_id = 232041,goods_name = "AI娘核心",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,5)};
get(232042) ->
	#ets_goods_type{goods_id = 232042,goods_name = "AI娘能源",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,5)};
get(232043) ->
	#ets_goods_type{goods_id = 232043,goods_name = "AI娘发饰",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,5)};
get(232044) ->
	#ets_goods_type{goods_id = 232044,goods_name = "AI娘战斗服",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,5)};
get(232045) ->
	#ets_goods_type{goods_id = 232045,goods_name = "AI娘战斗裙",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,5)};
get(232046) ->
	#ets_goods_type{goods_id = 232046,goods_name = "AI娘战斗靴",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 7500,price_markup = 1500,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(4,5)};
get(232051) ->
	#ets_goods_type{goods_id = 232051,goods_name = "AI娘核心",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(4,5)};
get(232052) ->
	#ets_goods_type{goods_id = 232052,goods_name = "AI娘能源",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(4,5)};
get(232053) ->
	#ets_goods_type{goods_id = 232053,goods_name = "AI娘发饰",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(4,5)};
get(232054) ->
	#ets_goods_type{goods_id = 232054,goods_name = "AI娘战斗服",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(4,5)};
get(232055) ->
	#ets_goods_type{goods_id = 232055,goods_name = "AI娘战斗裙",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(4,5)};
get(232056) ->
	#ets_goods_type{goods_id = 232056,goods_name = "AI娘战斗靴",bind = 1,type = 4,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(4,5)};
get(250000) ->
	#ets_goods_type{goods_id = 250000,goods_name = "宠物系统段",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250001) ->
	#ets_goods_type{goods_id = 250001,goods_name = "特种兵猪崽",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(6,1)};
get(250002) ->
	#ets_goods_type{goods_id = 250002,goods_name = "绿荫之精",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(6,1)};
get(250003) ->
	#ets_goods_type{goods_id = 250003,goods_name = "王牌飞行员",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(6,1)};
get(250004) ->
	#ets_goods_type{goods_id = 250004,goods_name = "绵羊魔灵",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(6,1)};
get(250005) ->
	#ets_goods_type{goods_id = 250005,goods_name = "星击小兔",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(6,1)};
get(250006) ->
	#ets_goods_type{goods_id = 250006,goods_name = "动森菇灵",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(6,1)};
get(250101) ->
	#ets_goods_type{goods_id = 250101,goods_name = "电枪少女Z",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250102) ->
	#ets_goods_type{goods_id = 250102,goods_name = "电动少女Q",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250103) ->
	#ets_goods_type{goods_id = 250103,goods_name = "傀儡兽娘",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250104) ->
	#ets_goods_type{goods_id = 250104,goods_name = "超能雇佣喵",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250105) ->
	#ets_goods_type{goods_id = 250105,goods_name = "南瓜魔灵",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250106) ->
	#ets_goods_type{goods_id = 250106,goods_name = "无解战斗鸡",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250107) ->
	#ets_goods_type{goods_id = 250107,goods_name = "弹丸X小丑",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(6,1)};
get(250201) ->
	#ets_goods_type{goods_id = 250201,goods_name = "绷带兔X",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(250202) ->
	#ets_goods_type{goods_id = 250202,goods_name = "神奇小迪",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(250203) ->
	#ets_goods_type{goods_id = 250203,goods_name = "月辰星王子",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(250204) ->
	#ets_goods_type{goods_id = 250204,goods_name = "日曜星王子",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(250205) ->
	#ets_goods_type{goods_id = 250205,goods_name = "异星龙娘",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(250206) ->
	#ets_goods_type{goods_id = 250206,goods_name = "微星王女",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(250207) ->
	#ets_goods_type{goods_id = 250207,goods_name = "狐面忍生",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(250208) ->
	#ets_goods_type{goods_id = 250208,goods_name = "嘚儿啵啵",bind = 1,type = 6,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(6,1)};
get(251001) ->
	#ets_goods_type{goods_id = 251001,goods_name = "宠物小药水（生物）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 1,bag_location = loc(6,2)};
get(251002) ->
	#ets_goods_type{goods_id = 251002,goods_name = "宠物中药水（生物）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 2,bag_location = loc(6,2)};
get(251003) ->
	#ets_goods_type{goods_id = 251003,goods_name = "宠物大药水（生物）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(6,2)};
get(251004) ->
	#ets_goods_type{goods_id = 251004,goods_name = "宠物小药水（异能）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 1,bag_location = loc(6,2)};
get(251005) ->
	#ets_goods_type{goods_id = 251005,goods_name = "宠物中药水（异能）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 2,bag_location = loc(6,2)};
get(251006) ->
	#ets_goods_type{goods_id = 251006,goods_name = "宠物大药水（异能）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(6,2)};
get(251007) ->
	#ets_goods_type{goods_id = 251007,goods_name = "宠物小药水（机械）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 1,bag_location = loc(6,2)};
get(251008) ->
	#ets_goods_type{goods_id = 251008,goods_name = "宠物中药水（机械）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 2,bag_location = loc(6,2)};
get(251009) ->
	#ets_goods_type{goods_id = 251009,goods_name = "宠物大药水（机械）",bind = 1,type = 6,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(6,2)};
get(252011) ->
	#ets_goods_type{goods_id = 252011,goods_name = "原力宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252012) ->
	#ets_goods_type{goods_id = 252012,goods_name = "构造宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252013) ->
	#ets_goods_type{goods_id = 252013,goods_name = "律动宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252014) ->
	#ets_goods_type{goods_id = 252014,goods_name = "幻能宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252021) ->
	#ets_goods_type{goods_id = 252021,goods_name = "原力宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252022) ->
	#ets_goods_type{goods_id = 252022,goods_name = "构造宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252023) ->
	#ets_goods_type{goods_id = 252023,goods_name = "律动宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252024) ->
	#ets_goods_type{goods_id = 252024,goods_name = "幻能宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252031) ->
	#ets_goods_type{goods_id = 252031,goods_name = "原力宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252032) ->
	#ets_goods_type{goods_id = 252032,goods_name = "构造宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252033) ->
	#ets_goods_type{goods_id = 252033,goods_name = "律动宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252034) ->
	#ets_goods_type{goods_id = 252034,goods_name = "幻能宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252041) ->
	#ets_goods_type{goods_id = 252041,goods_name = "原力宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252042) ->
	#ets_goods_type{goods_id = 252042,goods_name = "构造宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252043) ->
	#ets_goods_type{goods_id = 252043,goods_name = "律动宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252044) ->
	#ets_goods_type{goods_id = 252044,goods_name = "幻能宝石（生物）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252051) ->
	#ets_goods_type{goods_id = 252051,goods_name = "原力宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252052) ->
	#ets_goods_type{goods_id = 252052,goods_name = "构造宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252053) ->
	#ets_goods_type{goods_id = 252053,goods_name = "律动宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252054) ->
	#ets_goods_type{goods_id = 252054,goods_name = "幻能宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252061) ->
	#ets_goods_type{goods_id = 252061,goods_name = "原力宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252062) ->
	#ets_goods_type{goods_id = 252062,goods_name = "构造宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252063) ->
	#ets_goods_type{goods_id = 252063,goods_name = "律动宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252064) ->
	#ets_goods_type{goods_id = 252064,goods_name = "幻能宝石（生物）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252111) ->
	#ets_goods_type{goods_id = 252111,goods_name = "原力宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252112) ->
	#ets_goods_type{goods_id = 252112,goods_name = "构造宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252113) ->
	#ets_goods_type{goods_id = 252113,goods_name = "律动宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252114) ->
	#ets_goods_type{goods_id = 252114,goods_name = "幻能宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252121) ->
	#ets_goods_type{goods_id = 252121,goods_name = "原力宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252122) ->
	#ets_goods_type{goods_id = 252122,goods_name = "构造宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252123) ->
	#ets_goods_type{goods_id = 252123,goods_name = "律动宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252124) ->
	#ets_goods_type{goods_id = 252124,goods_name = "幻能宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252131) ->
	#ets_goods_type{goods_id = 252131,goods_name = "原力宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252132) ->
	#ets_goods_type{goods_id = 252132,goods_name = "构造宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252133) ->
	#ets_goods_type{goods_id = 252133,goods_name = "律动宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252134) ->
	#ets_goods_type{goods_id = 252134,goods_name = "幻能宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252141) ->
	#ets_goods_type{goods_id = 252141,goods_name = "原力宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252142) ->
	#ets_goods_type{goods_id = 252142,goods_name = "构造宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252143) ->
	#ets_goods_type{goods_id = 252143,goods_name = "律动宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252144) ->
	#ets_goods_type{goods_id = 252144,goods_name = "幻能宝石（异能）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252151) ->
	#ets_goods_type{goods_id = 252151,goods_name = "原力宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252152) ->
	#ets_goods_type{goods_id = 252152,goods_name = "构造宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252153) ->
	#ets_goods_type{goods_id = 252153,goods_name = "律动宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252154) ->
	#ets_goods_type{goods_id = 252154,goods_name = "幻能宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252161) ->
	#ets_goods_type{goods_id = 252161,goods_name = "原力宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252162) ->
	#ets_goods_type{goods_id = 252162,goods_name = "构造宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252163) ->
	#ets_goods_type{goods_id = 252163,goods_name = "律动宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252164) ->
	#ets_goods_type{goods_id = 252164,goods_name = "幻能宝石（异能）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252211) ->
	#ets_goods_type{goods_id = 252211,goods_name = "原力宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252212) ->
	#ets_goods_type{goods_id = 252212,goods_name = "构造宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252213) ->
	#ets_goods_type{goods_id = 252213,goods_name = "律动宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252214) ->
	#ets_goods_type{goods_id = 252214,goods_name = "幻能宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 1,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 400,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252221) ->
	#ets_goods_type{goods_id = 252221,goods_name = "原力宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252222) ->
	#ets_goods_type{goods_id = 252222,goods_name = "构造宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252223) ->
	#ets_goods_type{goods_id = 252223,goods_name = "律动宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252224) ->
	#ets_goods_type{goods_id = 252224,goods_name = "幻能宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 2,sell_category = 6,sell_subcategory = 2,trade_price = 4000,price_markup = 800,market_show_time = 120,selling_time = 600,market_range = 2,bag_location = loc(6,3)};
get(252231) ->
	#ets_goods_type{goods_id = 252231,goods_name = "原力宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252232) ->
	#ets_goods_type{goods_id = 252232,goods_name = "构造宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252233) ->
	#ets_goods_type{goods_id = 252233,goods_name = "律动宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252234) ->
	#ets_goods_type{goods_id = 252234,goods_name = "幻能宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 3,sell_category = 6,sell_subcategory = 2,trade_price = 6000,price_markup = 1200,market_show_time = 300,selling_time = 7200,market_range = 2,bag_location = loc(6,3)};
get(252241) ->
	#ets_goods_type{goods_id = 252241,goods_name = "原力宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252242) ->
	#ets_goods_type{goods_id = 252242,goods_name = "构造宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252243) ->
	#ets_goods_type{goods_id = 252243,goods_name = "律动宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252244) ->
	#ets_goods_type{goods_id = 252244,goods_name = "幻能宝石（机械）",type = 6,subtype = 3,max_overlap = 9999,color = 4,sell_category = 6,sell_subcategory = 2,trade_price = 8000,price_markup = 1600,market_show_time = 600,selling_time = 14400,market_range = 2,bag_location = loc(6,3)};
get(252251) ->
	#ets_goods_type{goods_id = 252251,goods_name = "原力宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252252) ->
	#ets_goods_type{goods_id = 252252,goods_name = "构造宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252253) ->
	#ets_goods_type{goods_id = 252253,goods_name = "律动宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252254) ->
	#ets_goods_type{goods_id = 252254,goods_name = "幻能宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 12000,price_markup = 2400,market_show_time = 1200,selling_time = 28800,market_range = 2,bag_location = loc(6,3)};
get(252261) ->
	#ets_goods_type{goods_id = 252261,goods_name = "原力宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252262) ->
	#ets_goods_type{goods_id = 252262,goods_name = "构造宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252263) ->
	#ets_goods_type{goods_id = 252263,goods_name = "律动宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(252264) ->
	#ets_goods_type{goods_id = 252264,goods_name = "幻能宝石（机械）",bind = 1,type = 6,subtype = 3,max_overlap = 9999,color = 6,bag_location = loc(6,3)};
get(253000) ->
	#ets_goods_type{goods_id = 253000,goods_name = "宠物觉醒石",bind = 1,type = 6,subtype = 4,max_overlap = 9999,color = 5,bag_location = loc(6,4)};
get(260000) ->
	#ets_goods_type{goods_id = 260000,goods_name = "宝宝系统段",bind = 1,type = 7,subtype = 1,max_overlap = 9999,bag_location = loc(7,1)};
get(260001) ->
	#ets_goods_type{goods_id = 260001,goods_name = "异热同心",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 4,use = 1,bag_location = loc(7,1)};
get(260002) ->
	#ets_goods_type{goods_id = 260002,goods_name = "宝宝低级成长胶囊",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 2,bag_location = loc(7,1)};
get(260003) ->
	#ets_goods_type{goods_id = 260003,goods_name = "宝宝中级成长胶囊",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(7,1)};
get(260004) ->
	#ets_goods_type{goods_id = 260004,goods_name = "宝宝高级成长胶囊",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(7,1)};
get(260005) ->
	#ets_goods_type{goods_id = 260005,goods_name = "宝宝觉醒之心",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(7,1)};
get(260006) ->
	#ets_goods_type{goods_id = 260006,goods_name = "宝宝觉醒材料",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(7,1)};
get(260007) ->
	#ets_goods_type{goods_id = 260007,goods_name = "玩具零件",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(7,1)};
get(260008) ->
	#ets_goods_type{goods_id = 260008,goods_name = "觉醒之心碎片",bind = 1,type = 7,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(7,1)};
get(260101) ->
	#ets_goods_type{goods_id = 260101,goods_name = "婴儿车·足印",bind = 1,type = 7,subtype = 2,max_overlap = 9999,color = 4,bag_location = loc(7,2)};
get(260102) ->
	#ets_goods_type{goods_id = 260102,goods_name = "童趣摩托·足印",bind = 1,type = 7,subtype = 2,max_overlap = 9999,color = 4,bag_location = loc(7,2)};
get(260103) ->
	#ets_goods_type{goods_id = 260103,goods_name = "悬浮童车·足印",bind = 1,type = 7,subtype = 2,max_overlap = 9999,color = 4,bag_location = loc(7,2)};
get(260104) ->
	#ets_goods_type{goods_id = 260104,goods_name = "萌萌恐龙·足印",bind = 1,type = 7,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(7,2)};
get(260105) ->
	#ets_goods_type{goods_id = 260105,goods_name = "坦克突击·足印",bind = 1,type = 7,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(7,2)};
get(260201) ->
	#ets_goods_type{goods_id = 260201,goods_name = "运动气质·锦丝",bind = 1,type = 7,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(7,3)};
get(260202) ->
	#ets_goods_type{goods_id = 260202,goods_name = "英伦风潮·锦丝",bind = 1,type = 7,subtype = 3,max_overlap = 9999,color = 4,bag_location = loc(7,3)};
get(260203) ->
	#ets_goods_type{goods_id = 260203,goods_name = "炎炎夏日·锦丝",bind = 1,type = 7,subtype = 3,max_overlap = 9999,color = 4,bag_location = loc(7,3)};
get(260204) ->
	#ets_goods_type{goods_id = 260204,goods_name = "人小鬼大·锦丝",bind = 1,type = 7,subtype = 3,max_overlap = 9999,color = 4,bag_location = loc(7,3)};
get(261001) ->
	#ets_goods_type{goods_id = 261001,goods_name = "汽车机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(7,4)};
get(261002) ->
	#ets_goods_type{goods_id = 261002,goods_name = "火车机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(7,4)};
get(261003) ->
	#ets_goods_type{goods_id = 261003,goods_name = "飞机机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(261004) ->
	#ets_goods_type{goods_id = 261004,goods_name = "轮船机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(261005) ->
	#ets_goods_type{goods_id = 261005,goods_name = "潜艇机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(261006) ->
	#ets_goods_type{goods_id = 261006,goods_name = "火箭机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(261007) ->
	#ets_goods_type{goods_id = 261007,goods_name = "飞碟机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(261008) ->
	#ets_goods_type{goods_id = 261008,goods_name = "挖掘机器人",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(262001) ->
	#ets_goods_type{goods_id = 262001,goods_name = "毛绒绒兔子",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(7,4)};
get(262002) ->
	#ets_goods_type{goods_id = 262002,goods_name = "毛绒绒小熊",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(7,4)};
get(262003) ->
	#ets_goods_type{goods_id = 262003,goods_name = "毛绒绒绵羊",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(262004) ->
	#ets_goods_type{goods_id = 262004,goods_name = "毛绒绒狐狸",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(262005) ->
	#ets_goods_type{goods_id = 262005,goods_name = "毛绒绒小狗",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(262006) ->
	#ets_goods_type{goods_id = 262006,goods_name = "毛绒绒猫咪",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(262007) ->
	#ets_goods_type{goods_id = 262007,goods_name = "毛绒绒大马",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(262008) ->
	#ets_goods_type{goods_id = 262008,goods_name = "毛绒绒狮子",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(263001) ->
	#ets_goods_type{goods_id = 263001,goods_name = "圆号战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(7,4)};
get(263002) ->
	#ets_goods_type{goods_id = 263002,goods_name = "单簧管战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(7,4)};
get(263003) ->
	#ets_goods_type{goods_id = 263003,goods_name = "贝司战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(263004) ->
	#ets_goods_type{goods_id = 263004,goods_name = "萨克斯战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(263005) ->
	#ets_goods_type{goods_id = 263005,goods_name = "架子鼓战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(263006) ->
	#ets_goods_type{goods_id = 263006,goods_name = "吉他战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(263007) ->
	#ets_goods_type{goods_id = 263007,goods_name = "钢琴战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(263008) ->
	#ets_goods_type{goods_id = 263008,goods_name = "大提琴战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(264001) ->
	#ets_goods_type{goods_id = 264001,goods_name = "发条青蛙",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(7,4)};
get(264002) ->
	#ets_goods_type{goods_id = 264002,goods_name = "发条蜗牛",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(7,4)};
get(264003) ->
	#ets_goods_type{goods_id = 264003,goods_name = "发条蝙蝠",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(264004) ->
	#ets_goods_type{goods_id = 264004,goods_name = "发条法师",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(264005) ->
	#ets_goods_type{goods_id = 264005,goods_name = "发条战士",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(264006) ->
	#ets_goods_type{goods_id = 264006,goods_name = "发条国王",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(264007) ->
	#ets_goods_type{goods_id = 264007,goods_name = "发条火车",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(264008) ->
	#ets_goods_type{goods_id = 264008,goods_name = "发条巨舰",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(265001) ->
	#ets_goods_type{goods_id = 265001,goods_name = "泡芙甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(7,4)};
get(265002) ->
	#ets_goods_type{goods_id = 265002,goods_name = "布丁甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(7,4)};
get(265003) ->
	#ets_goods_type{goods_id = 265003,goods_name = "水果挞甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(265004) ->
	#ets_goods_type{goods_id = 265004,goods_name = "巧克力甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(7,4)};
get(265005) ->
	#ets_goods_type{goods_id = 265005,goods_name = "华夫饼甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(265006) ->
	#ets_goods_type{goods_id = 265006,goods_name = "千层酥甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(7,4)};
get(265007) ->
	#ets_goods_type{goods_id = 265007,goods_name = "铜锣烧甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(265008) ->
	#ets_goods_type{goods_id = 265008,goods_name = "马卡龙甜点",bind = 1,type = 7,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(7,4)};
get(270000) ->
	#ets_goods_type{goods_id = 270000,goods_name = "红装系统段",bind = 1,type = 8,subtype = 1,max_overlap = 9999,bag_location = loc(8,1)};
get(270001) ->
	#ets_goods_type{goods_id = 270001,goods_name = "武器升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270002) ->
	#ets_goods_type{goods_id = 270002,goods_name = "帽子升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270003) ->
	#ets_goods_type{goods_id = 270003,goods_name = "上衣升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270004) ->
	#ets_goods_type{goods_id = 270004,goods_name = "外套升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270005) ->
	#ets_goods_type{goods_id = 270005,goods_name = "手套升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270006) ->
	#ets_goods_type{goods_id = 270006,goods_name = "裤子升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270007) ->
	#ets_goods_type{goods_id = 270007,goods_name = "鞋子升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270008) ->
	#ets_goods_type{goods_id = 270008,goods_name = "项链升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270009) ->
	#ets_goods_type{goods_id = 270009,goods_name = "戒指升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270010) ->
	#ets_goods_type{goods_id = 270010,goods_name = "耳饰升品石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270011) ->
	#ets_goods_type{goods_id = 270011,goods_name = "升品进阶石",bind = 1,type = 8,subtype = 1,max_overlap = 9999,color = 3,bag_location = loc(8,1)};
get(270012) ->
	#ets_goods_type{goods_id = 270012,goods_name = "升品之路代金券",bind = 1,type = 8,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(8,2)};
get(270013) ->
	#ets_goods_type{goods_id = 270013,goods_name = "万能升品石",bind = 1,type = 8,subtype = 2,max_overlap = 9999,color = 4,bag_location = loc(8,2)};
get(280000) ->
	#ets_goods_type{goods_id = 280000,goods_name = "圣者凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(9,1)};
get(280001) ->
	#ets_goods_type{goods_id = 280001,goods_name = "圣士凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(9,1)};
get(280002) ->
	#ets_goods_type{goods_id = 280002,goods_name = "圣师凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(9,1)};
get(280003) ->
	#ets_goods_type{goods_id = 280003,goods_name = "圣主凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(9,1)};
get(280004) ->
	#ets_goods_type{goods_id = 280004,goods_name = "圣尊凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 4,bag_location = loc(9,1)};
get(280005) ->
	#ets_goods_type{goods_id = 280005,goods_name = "圣宗凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(9,1)};
get(280006) ->
	#ets_goods_type{goods_id = 280006,goods_name = "圣王凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(9,1)};
get(280007) ->
	#ets_goods_type{goods_id = 280007,goods_name = "圣帝凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(9,1)};
get(280008) ->
	#ets_goods_type{goods_id = 280008,goods_name = "半神凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(9,1)};
get(280009) ->
	#ets_goods_type{goods_id = 280009,goods_name = "亚神凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(9,1)};
get(280010) ->
	#ets_goods_type{goods_id = 280010,goods_name = "真神凭证（收藏品）",bind = 1,type = 9,subtype = 1,max_overlap = 9999,color = 5,bag_location = loc(9,1)};
get(280101) ->
	#ets_goods_type{goods_id = 280101,goods_name = "圣物升级能量",bind = 1,type = 9,subtype = 2,max_overlap = 9999,color = 3,bag_location = loc(9,2)};
get(280102) ->
	#ets_goods_type{goods_id = 280102,goods_name = "圣书觉醒能量",bind = 1,type = 9,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(9,2)};
get(280103) ->
	#ets_goods_type{goods_id = 280103,goods_name = "圣球觉醒能量",bind = 1,type = 9,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(9,2)};
get(280104) ->
	#ets_goods_type{goods_id = 280104,goods_name = "圣杯觉醒能量",bind = 1,type = 9,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(9,2)};
get(280105) ->
	#ets_goods_type{goods_id = 280105,goods_name = "圣冠觉醒能量",bind = 1,type = 9,subtype = 2,max_overlap = 9999,color = 5,bag_location = loc(9,2)};
get(280201) ->
	#ets_goods_type{goods_id = 280201,goods_name = "通用觉醒碎片",bind = 1,type = 9,subtype = 3,max_overlap = 9999,color = 3,bag_location = loc(9,3)};
get(280202) ->
	#ets_goods_type{goods_id = 280202,goods_name = "圣书觉醒碎片",bind = 1,type = 9,subtype = 3,max_overlap = 9999,color = 4,bag_location = loc(9,3)};
get(280203) ->
	#ets_goods_type{goods_id = 280203,goods_name = "圣球觉醒碎片",bind = 1,type = 9,subtype = 3,max_overlap = 9999,color = 4,bag_location = loc(9,3)};
get(280204) ->
	#ets_goods_type{goods_id = 280204,goods_name = "圣杯觉醒碎片",bind = 1,type = 9,subtype = 3,max_overlap = 9999,color = 4,bag_location = loc(9,3)};
get(280205) ->
	#ets_goods_type{goods_id = 280205,goods_name = "圣冠觉醒碎片",bind = 1,type = 9,subtype = 3,max_overlap = 9999,color = 4,bag_location = loc(9,3)};
get(280301) ->
	#ets_goods_type{goods_id = 280301,goods_name = "圣物洗练碎片",bind = 1,type = 9,subtype = 8,max_overlap = 9999,color = 3,bag_location = loc(9,8)};
get(281021) ->
	#ets_goods_type{goods_id = 281021,goods_name = "珈蓝圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(9,4)};
get(281031) ->
	#ets_goods_type{goods_id = 281031,goods_name = "紫临圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(9,4)};
get(281032) ->
	#ets_goods_type{goods_id = 281032,goods_name = "紫冰圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(9,4)};
get(281033) ->
	#ets_goods_type{goods_id = 281033,goods_name = "紫斗圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(9,4)};
get(281034) ->
	#ets_goods_type{goods_id = 281034,goods_name = "紫魔圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(9,4)};
get(281035) ->
	#ets_goods_type{goods_id = 281035,goods_name = "紫幻圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(9,4)};
get(281036) ->
	#ets_goods_type{goods_id = 281036,goods_name = "紫伊圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(9,4)};
get(281041) ->
	#ets_goods_type{goods_id = 281041,goods_name = "烈阳圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(9,4)};
get(281042) ->
	#ets_goods_type{goods_id = 281042,goods_name = "天阳圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(9,4)};
get(281043) ->
	#ets_goods_type{goods_id = 281043,goods_name = "魔阳圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(9,4)};
get(281044) ->
	#ets_goods_type{goods_id = 281044,goods_name = "灵阳圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(9,4)};
get(281045) ->
	#ets_goods_type{goods_id = 281045,goods_name = "幻阳圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(9,4)};
get(281046) ->
	#ets_goods_type{goods_id = 281046,goods_name = "湮阳圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(9,4)};
get(281051) ->
	#ets_goods_type{goods_id = 281051,goods_name = "雷火圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(9,4)};
get(281052) ->
	#ets_goods_type{goods_id = 281052,goods_name = "炎火圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(9,4)};
get(281053) ->
	#ets_goods_type{goods_id = 281053,goods_name = "天火圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(9,4)};
get(281054) ->
	#ets_goods_type{goods_id = 281054,goods_name = "熔火圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(9,4)};
get(281055) ->
	#ets_goods_type{goods_id = 281055,goods_name = "凰火圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(9,4)};
get(281056) ->
	#ets_goods_type{goods_id = 281056,goods_name = "狱火圣书",bind = 1,type = 9,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(9,4)};
get(282021) ->
	#ets_goods_type{goods_id = 282021,goods_name = "珈蓝圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(9,5)};
get(282031) ->
	#ets_goods_type{goods_id = 282031,goods_name = "紫临圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(9,5)};
get(282032) ->
	#ets_goods_type{goods_id = 282032,goods_name = "紫冰圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(9,5)};
get(282033) ->
	#ets_goods_type{goods_id = 282033,goods_name = "紫斗圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(9,5)};
get(282034) ->
	#ets_goods_type{goods_id = 282034,goods_name = "紫魔圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(9,5)};
get(282035) ->
	#ets_goods_type{goods_id = 282035,goods_name = "紫幻圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(9,5)};
get(282036) ->
	#ets_goods_type{goods_id = 282036,goods_name = "紫伊圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(9,5)};
get(282041) ->
	#ets_goods_type{goods_id = 282041,goods_name = "烈阳圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(9,5)};
get(282042) ->
	#ets_goods_type{goods_id = 282042,goods_name = "天阳圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(9,5)};
get(282043) ->
	#ets_goods_type{goods_id = 282043,goods_name = "魔阳圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(9,5)};
get(282044) ->
	#ets_goods_type{goods_id = 282044,goods_name = "灵阳圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(9,5)};
get(282045) ->
	#ets_goods_type{goods_id = 282045,goods_name = "幻阳圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(9,5)};
get(282046) ->
	#ets_goods_type{goods_id = 282046,goods_name = "湮阳圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(9,5)};
get(282051) ->
	#ets_goods_type{goods_id = 282051,goods_name = "雷火圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(9,5)};
get(282052) ->
	#ets_goods_type{goods_id = 282052,goods_name = "炎火圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(9,5)};
get(282053) ->
	#ets_goods_type{goods_id = 282053,goods_name = "天火圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(9,5)};
get(282054) ->
	#ets_goods_type{goods_id = 282054,goods_name = "熔火圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(9,5)};
get(282055) ->
	#ets_goods_type{goods_id = 282055,goods_name = "凰火圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(9,5)};
get(282056) ->
	#ets_goods_type{goods_id = 282056,goods_name = "狱火圣球",bind = 1,type = 9,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(9,5)};
get(283021) ->
	#ets_goods_type{goods_id = 283021,goods_name = "珈蓝圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(9,6)};
get(283031) ->
	#ets_goods_type{goods_id = 283031,goods_name = "紫临圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(9,6)};
get(283032) ->
	#ets_goods_type{goods_id = 283032,goods_name = "紫冰圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(9,6)};
get(283033) ->
	#ets_goods_type{goods_id = 283033,goods_name = "紫斗圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(9,6)};
get(283034) ->
	#ets_goods_type{goods_id = 283034,goods_name = "紫魔圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(9,6)};
get(283035) ->
	#ets_goods_type{goods_id = 283035,goods_name = "紫幻圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(9,6)};
get(283036) ->
	#ets_goods_type{goods_id = 283036,goods_name = "紫伊圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(9,6)};
get(283041) ->
	#ets_goods_type{goods_id = 283041,goods_name = "烈阳圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(9,6)};
get(283042) ->
	#ets_goods_type{goods_id = 283042,goods_name = "天阳圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(9,6)};
get(283043) ->
	#ets_goods_type{goods_id = 283043,goods_name = "魔阳圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(9,6)};
get(283044) ->
	#ets_goods_type{goods_id = 283044,goods_name = "灵阳圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(9,6)};
get(283045) ->
	#ets_goods_type{goods_id = 283045,goods_name = "幻阳圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(9,6)};
get(283046) ->
	#ets_goods_type{goods_id = 283046,goods_name = "湮阳圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(9,6)};
get(283051) ->
	#ets_goods_type{goods_id = 283051,goods_name = "雷火圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(9,6)};
get(283052) ->
	#ets_goods_type{goods_id = 283052,goods_name = "炎火圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(9,6)};
get(283053) ->
	#ets_goods_type{goods_id = 283053,goods_name = "天火圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(9,6)};
get(283054) ->
	#ets_goods_type{goods_id = 283054,goods_name = "熔火圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(9,6)};
get(283055) ->
	#ets_goods_type{goods_id = 283055,goods_name = "凰火圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(9,6)};
get(283056) ->
	#ets_goods_type{goods_id = 283056,goods_name = "狱火圣杯",bind = 1,type = 9,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(9,6)};
get(284021) ->
	#ets_goods_type{goods_id = 284021,goods_name = "珈蓝圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 2,bag_location = loc(9,7)};
get(284031) ->
	#ets_goods_type{goods_id = 284031,goods_name = "紫临圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 3,bag_location = loc(9,7)};
get(284032) ->
	#ets_goods_type{goods_id = 284032,goods_name = "紫冰圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 3,bag_location = loc(9,7)};
get(284033) ->
	#ets_goods_type{goods_id = 284033,goods_name = "紫斗圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 3,bag_location = loc(9,7)};
get(284034) ->
	#ets_goods_type{goods_id = 284034,goods_name = "紫魔圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 3,bag_location = loc(9,7)};
get(284035) ->
	#ets_goods_type{goods_id = 284035,goods_name = "紫幻圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 3,bag_location = loc(9,7)};
get(284036) ->
	#ets_goods_type{goods_id = 284036,goods_name = "紫伊圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 3,bag_location = loc(9,7)};
get(284041) ->
	#ets_goods_type{goods_id = 284041,goods_name = "烈阳圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 4,bag_location = loc(9,7)};
get(284042) ->
	#ets_goods_type{goods_id = 284042,goods_name = "天阳圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 4,bag_location = loc(9,7)};
get(284043) ->
	#ets_goods_type{goods_id = 284043,goods_name = "魔阳圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 4,bag_location = loc(9,7)};
get(284044) ->
	#ets_goods_type{goods_id = 284044,goods_name = "灵阳圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 4,bag_location = loc(9,7)};
get(284045) ->
	#ets_goods_type{goods_id = 284045,goods_name = "幻阳圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 4,bag_location = loc(9,7)};
get(284046) ->
	#ets_goods_type{goods_id = 284046,goods_name = "湮阳圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 4,bag_location = loc(9,7)};
get(284051) ->
	#ets_goods_type{goods_id = 284051,goods_name = "雷火圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 5,bag_location = loc(9,7)};
get(284052) ->
	#ets_goods_type{goods_id = 284052,goods_name = "炎火圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 5,bag_location = loc(9,7)};
get(284053) ->
	#ets_goods_type{goods_id = 284053,goods_name = "天火圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 5,bag_location = loc(9,7)};
get(284054) ->
	#ets_goods_type{goods_id = 284054,goods_name = "熔火圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 5,bag_location = loc(9,7)};
get(284055) ->
	#ets_goods_type{goods_id = 284055,goods_name = "凰火圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 5,bag_location = loc(9,7)};
get(284056) ->
	#ets_goods_type{goods_id = 284056,goods_name = "狱火圣冠",bind = 1,type = 9,subtype = 7,max_overlap = 1,color = 5,bag_location = loc(9,7)};
get(290000) ->
	#ets_goods_type{goods_id = 290000,goods_name = "式神系统段",bind = 1,type = 10,subtype = 1,max_overlap = 9999,bag_location = loc(10,1)};
get(290001) ->
	#ets_goods_type{goods_id = 290001,goods_name = "普通神源",bind = 1,type = 10,subtype = 3,max_overlap = 99,color = 2,bag_location = loc(10,3)};
get(290002) ->
	#ets_goods_type{goods_id = 290002,goods_name = "中级神源",bind = 1,type = 10,subtype = 3,max_overlap = 99,color = 3,bag_location = loc(10,3)};
get(290003) ->
	#ets_goods_type{goods_id = 290003,goods_name = "高级神源",bind = 1,type = 10,subtype = 3,max_overlap = 99,color = 4,bag_location = loc(10,3)};
get(290004) ->
	#ets_goods_type{goods_id = 290004,goods_name = "技能进阶源",bind = 1,type = 10,subtype = 3,max_overlap = 99,color = 4,bag_location = loc(10,3)};
get(290005) ->
	#ets_goods_type{goods_id = 290005,goods_name = "神座召唤卡",bind = 1,type = 10,subtype = 3,max_overlap = 30,color = 4,bag_location = loc(10,3)};
get(290006) ->
	#ets_goods_type{goods_id = 290006,goods_name = "阵位解锁石",bind = 1,type = 10,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(10,3)};
get(291000) ->
	#ets_goods_type{goods_id = 291000,goods_name = "暗夜星龙",bind = 1,type = 10,subtype = 1,max_overlap = 30,color = 4,bag_location = loc(10,1)};
get(291001) ->
	#ets_goods_type{goods_id = 291001,goods_name = "命运之瞳",bind = 1,type = 10,subtype = 1,max_overlap = 30,color = 4,bag_location = loc(10,1)};
get(291002) ->
	#ets_goods_type{goods_id = 291002,goods_name = "七罪蛇魔",bind = 1,type = 10,subtype = 1,max_overlap = 30,color = 4,bag_location = loc(10,1)};
get(291003) ->
	#ets_goods_type{goods_id = 291003,goods_name = "创世冰神龙",bind = 1,type = 10,subtype = 1,max_overlap = 30,color = 4,bag_location = loc(10,1)};
get(291004) ->
	#ets_goods_type{goods_id = 291004,goods_name = "妄想夜叉",bind = 1,type = 10,subtype = 1,max_overlap = 30,color = 4,bag_location = loc(10,1)};
get(291005) ->
	#ets_goods_type{goods_id = 291005,goods_name = "水星兰蒂斯",bind = 1,type = 10,subtype = 1,max_overlap = 30,color = 4,bag_location = loc(10,1)};
get(291006) ->
	#ets_goods_type{goods_id = 291006,goods_name = "雀灵幻神",bind = 1,type = 10,subtype = 1,max_overlap = 30,color = 4,bag_location = loc(10,1)};
get(292000) ->
	#ets_goods_type{goods_id = 292000,goods_name = "暗夜星龙",bind = 1,type = 10,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(10,2)};
get(292001) ->
	#ets_goods_type{goods_id = 292001,goods_name = "命运之瞳",bind = 1,type = 10,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(10,2)};
get(292002) ->
	#ets_goods_type{goods_id = 292002,goods_name = "七罪蛇魔",bind = 1,type = 10,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(10,2)};
get(292003) ->
	#ets_goods_type{goods_id = 292003,goods_name = "创世冰神龙",bind = 1,type = 10,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(10,2)};
get(292004) ->
	#ets_goods_type{goods_id = 292004,goods_name = "妄想夜叉",bind = 1,type = 10,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(10,2)};
get(292005) ->
	#ets_goods_type{goods_id = 292005,goods_name = "水星兰蒂斯",bind = 1,type = 10,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(10,2)};
get(292006) ->
	#ets_goods_type{goods_id = 292006,goods_name = "雀灵幻神",bind = 1,type = 10,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(10,2)};
get(300000) ->
	#ets_goods_type{goods_id = 300000,goods_name = "座印装备",bind = 1,type = 21,subtype = 1,max_overlap = 1,bag_location = loc(21,1)};
get(300111) ->
	#ets_goods_type{goods_id = 300111,goods_name = "恶魔印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300112) ->
	#ets_goods_type{goods_id = 300112,goods_name = "恶魔印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300113) ->
	#ets_goods_type{goods_id = 300113,goods_name = "恶魔印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300114) ->
	#ets_goods_type{goods_id = 300114,goods_name = "恶魔印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300115) ->
	#ets_goods_type{goods_id = 300115,goods_name = "恶魔印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300116) ->
	#ets_goods_type{goods_id = 300116,goods_name = "恶魔印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300121) ->
	#ets_goods_type{goods_id = 300121,goods_name = "恶魔印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300122) ->
	#ets_goods_type{goods_id = 300122,goods_name = "恶魔印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300123) ->
	#ets_goods_type{goods_id = 300123,goods_name = "恶魔印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300124) ->
	#ets_goods_type{goods_id = 300124,goods_name = "恶魔印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300125) ->
	#ets_goods_type{goods_id = 300125,goods_name = "恶魔印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300126) ->
	#ets_goods_type{goods_id = 300126,goods_name = "恶魔印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300131) ->
	#ets_goods_type{goods_id = 300131,goods_name = "恶魔印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300132) ->
	#ets_goods_type{goods_id = 300132,goods_name = "恶魔印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300133) ->
	#ets_goods_type{goods_id = 300133,goods_name = "恶魔印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300134) ->
	#ets_goods_type{goods_id = 300134,goods_name = "恶魔印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300135) ->
	#ets_goods_type{goods_id = 300135,goods_name = "恶魔印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300136) ->
	#ets_goods_type{goods_id = 300136,goods_name = "恶魔印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300141) ->
	#ets_goods_type{goods_id = 300141,goods_name = "恶魔印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300142) ->
	#ets_goods_type{goods_id = 300142,goods_name = "恶魔印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300143) ->
	#ets_goods_type{goods_id = 300143,goods_name = "恶魔印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300144) ->
	#ets_goods_type{goods_id = 300144,goods_name = "恶魔印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300145) ->
	#ets_goods_type{goods_id = 300145,goods_name = "恶魔印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300146) ->
	#ets_goods_type{goods_id = 300146,goods_name = "恶魔印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300151) ->
	#ets_goods_type{goods_id = 300151,goods_name = "恶魔印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300152) ->
	#ets_goods_type{goods_id = 300152,goods_name = "恶魔印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300153) ->
	#ets_goods_type{goods_id = 300153,goods_name = "恶魔印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300154) ->
	#ets_goods_type{goods_id = 300154,goods_name = "恶魔印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300155) ->
	#ets_goods_type{goods_id = 300155,goods_name = "恶魔印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300156) ->
	#ets_goods_type{goods_id = 300156,goods_name = "恶魔印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300161) ->
	#ets_goods_type{goods_id = 300161,goods_name = "恶魔印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300162) ->
	#ets_goods_type{goods_id = 300162,goods_name = "恶魔印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300163) ->
	#ets_goods_type{goods_id = 300163,goods_name = "恶魔印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300164) ->
	#ets_goods_type{goods_id = 300164,goods_name = "恶魔印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300165) ->
	#ets_goods_type{goods_id = 300165,goods_name = "恶魔印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300166) ->
	#ets_goods_type{goods_id = 300166,goods_name = "恶魔印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300211) ->
	#ets_goods_type{goods_id = 300211,goods_name = "守望印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300212) ->
	#ets_goods_type{goods_id = 300212,goods_name = "守望印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300213) ->
	#ets_goods_type{goods_id = 300213,goods_name = "守望印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300214) ->
	#ets_goods_type{goods_id = 300214,goods_name = "守望印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300215) ->
	#ets_goods_type{goods_id = 300215,goods_name = "守望印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300216) ->
	#ets_goods_type{goods_id = 300216,goods_name = "守望印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300221) ->
	#ets_goods_type{goods_id = 300221,goods_name = "守望印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300222) ->
	#ets_goods_type{goods_id = 300222,goods_name = "守望印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300223) ->
	#ets_goods_type{goods_id = 300223,goods_name = "守望印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300224) ->
	#ets_goods_type{goods_id = 300224,goods_name = "守望印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300225) ->
	#ets_goods_type{goods_id = 300225,goods_name = "守望印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300226) ->
	#ets_goods_type{goods_id = 300226,goods_name = "守望印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300231) ->
	#ets_goods_type{goods_id = 300231,goods_name = "守望印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300232) ->
	#ets_goods_type{goods_id = 300232,goods_name = "守望印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300233) ->
	#ets_goods_type{goods_id = 300233,goods_name = "守望印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300234) ->
	#ets_goods_type{goods_id = 300234,goods_name = "守望印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300235) ->
	#ets_goods_type{goods_id = 300235,goods_name = "守望印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300236) ->
	#ets_goods_type{goods_id = 300236,goods_name = "守望印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300241) ->
	#ets_goods_type{goods_id = 300241,goods_name = "守望印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300242) ->
	#ets_goods_type{goods_id = 300242,goods_name = "守望印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300243) ->
	#ets_goods_type{goods_id = 300243,goods_name = "守望印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300244) ->
	#ets_goods_type{goods_id = 300244,goods_name = "守望印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300245) ->
	#ets_goods_type{goods_id = 300245,goods_name = "守望印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300246) ->
	#ets_goods_type{goods_id = 300246,goods_name = "守望印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300251) ->
	#ets_goods_type{goods_id = 300251,goods_name = "守望印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300252) ->
	#ets_goods_type{goods_id = 300252,goods_name = "守望印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300253) ->
	#ets_goods_type{goods_id = 300253,goods_name = "守望印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300254) ->
	#ets_goods_type{goods_id = 300254,goods_name = "守望印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300255) ->
	#ets_goods_type{goods_id = 300255,goods_name = "守望印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300256) ->
	#ets_goods_type{goods_id = 300256,goods_name = "守望印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300261) ->
	#ets_goods_type{goods_id = 300261,goods_name = "守望印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300262) ->
	#ets_goods_type{goods_id = 300262,goods_name = "守望印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300263) ->
	#ets_goods_type{goods_id = 300263,goods_name = "守望印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300264) ->
	#ets_goods_type{goods_id = 300264,goods_name = "守望印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300265) ->
	#ets_goods_type{goods_id = 300265,goods_name = "守望印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300266) ->
	#ets_goods_type{goods_id = 300266,goods_name = "守望印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300311) ->
	#ets_goods_type{goods_id = 300311,goods_name = "灵兽印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300312) ->
	#ets_goods_type{goods_id = 300312,goods_name = "灵兽印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300313) ->
	#ets_goods_type{goods_id = 300313,goods_name = "灵兽印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300314) ->
	#ets_goods_type{goods_id = 300314,goods_name = "灵兽印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300315) ->
	#ets_goods_type{goods_id = 300315,goods_name = "灵兽印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300316) ->
	#ets_goods_type{goods_id = 300316,goods_name = "灵兽印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300321) ->
	#ets_goods_type{goods_id = 300321,goods_name = "灵兽印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300322) ->
	#ets_goods_type{goods_id = 300322,goods_name = "灵兽印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300323) ->
	#ets_goods_type{goods_id = 300323,goods_name = "灵兽印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300324) ->
	#ets_goods_type{goods_id = 300324,goods_name = "灵兽印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300325) ->
	#ets_goods_type{goods_id = 300325,goods_name = "灵兽印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300326) ->
	#ets_goods_type{goods_id = 300326,goods_name = "灵兽印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300331) ->
	#ets_goods_type{goods_id = 300331,goods_name = "灵兽印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300332) ->
	#ets_goods_type{goods_id = 300332,goods_name = "灵兽印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300333) ->
	#ets_goods_type{goods_id = 300333,goods_name = "灵兽印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300334) ->
	#ets_goods_type{goods_id = 300334,goods_name = "灵兽印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300335) ->
	#ets_goods_type{goods_id = 300335,goods_name = "灵兽印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300336) ->
	#ets_goods_type{goods_id = 300336,goods_name = "灵兽印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300341) ->
	#ets_goods_type{goods_id = 300341,goods_name = "灵兽印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300342) ->
	#ets_goods_type{goods_id = 300342,goods_name = "灵兽印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300343) ->
	#ets_goods_type{goods_id = 300343,goods_name = "灵兽印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300344) ->
	#ets_goods_type{goods_id = 300344,goods_name = "灵兽印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300345) ->
	#ets_goods_type{goods_id = 300345,goods_name = "灵兽印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300346) ->
	#ets_goods_type{goods_id = 300346,goods_name = "灵兽印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300351) ->
	#ets_goods_type{goods_id = 300351,goods_name = "灵兽印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300352) ->
	#ets_goods_type{goods_id = 300352,goods_name = "灵兽印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300353) ->
	#ets_goods_type{goods_id = 300353,goods_name = "灵兽印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300354) ->
	#ets_goods_type{goods_id = 300354,goods_name = "灵兽印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300355) ->
	#ets_goods_type{goods_id = 300355,goods_name = "灵兽印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300356) ->
	#ets_goods_type{goods_id = 300356,goods_name = "灵兽印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300361) ->
	#ets_goods_type{goods_id = 300361,goods_name = "灵兽印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300362) ->
	#ets_goods_type{goods_id = 300362,goods_name = "灵兽印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300363) ->
	#ets_goods_type{goods_id = 300363,goods_name = "灵兽印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300364) ->
	#ets_goods_type{goods_id = 300364,goods_name = "灵兽印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300365) ->
	#ets_goods_type{goods_id = 300365,goods_name = "灵兽印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300366) ->
	#ets_goods_type{goods_id = 300366,goods_name = "灵兽印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300411) ->
	#ets_goods_type{goods_id = 300411,goods_name = "盾击印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300412) ->
	#ets_goods_type{goods_id = 300412,goods_name = "盾击印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300413) ->
	#ets_goods_type{goods_id = 300413,goods_name = "盾击印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300414) ->
	#ets_goods_type{goods_id = 300414,goods_name = "盾击印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300415) ->
	#ets_goods_type{goods_id = 300415,goods_name = "盾击印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300416) ->
	#ets_goods_type{goods_id = 300416,goods_name = "盾击印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300421) ->
	#ets_goods_type{goods_id = 300421,goods_name = "盾击印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300422) ->
	#ets_goods_type{goods_id = 300422,goods_name = "盾击印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300423) ->
	#ets_goods_type{goods_id = 300423,goods_name = "盾击印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300424) ->
	#ets_goods_type{goods_id = 300424,goods_name = "盾击印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300425) ->
	#ets_goods_type{goods_id = 300425,goods_name = "盾击印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300426) ->
	#ets_goods_type{goods_id = 300426,goods_name = "盾击印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300431) ->
	#ets_goods_type{goods_id = 300431,goods_name = "盾击印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300432) ->
	#ets_goods_type{goods_id = 300432,goods_name = "盾击印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300433) ->
	#ets_goods_type{goods_id = 300433,goods_name = "盾击印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300434) ->
	#ets_goods_type{goods_id = 300434,goods_name = "盾击印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300435) ->
	#ets_goods_type{goods_id = 300435,goods_name = "盾击印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300436) ->
	#ets_goods_type{goods_id = 300436,goods_name = "盾击印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300441) ->
	#ets_goods_type{goods_id = 300441,goods_name = "盾击印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300442) ->
	#ets_goods_type{goods_id = 300442,goods_name = "盾击印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300443) ->
	#ets_goods_type{goods_id = 300443,goods_name = "盾击印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300444) ->
	#ets_goods_type{goods_id = 300444,goods_name = "盾击印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300445) ->
	#ets_goods_type{goods_id = 300445,goods_name = "盾击印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300446) ->
	#ets_goods_type{goods_id = 300446,goods_name = "盾击印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300451) ->
	#ets_goods_type{goods_id = 300451,goods_name = "盾击印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300452) ->
	#ets_goods_type{goods_id = 300452,goods_name = "盾击印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300453) ->
	#ets_goods_type{goods_id = 300453,goods_name = "盾击印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300454) ->
	#ets_goods_type{goods_id = 300454,goods_name = "盾击印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300455) ->
	#ets_goods_type{goods_id = 300455,goods_name = "盾击印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300456) ->
	#ets_goods_type{goods_id = 300456,goods_name = "盾击印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300461) ->
	#ets_goods_type{goods_id = 300461,goods_name = "盾击印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300462) ->
	#ets_goods_type{goods_id = 300462,goods_name = "盾击印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300463) ->
	#ets_goods_type{goods_id = 300463,goods_name = "盾击印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300464) ->
	#ets_goods_type{goods_id = 300464,goods_name = "盾击印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300465) ->
	#ets_goods_type{goods_id = 300465,goods_name = "盾击印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300466) ->
	#ets_goods_type{goods_id = 300466,goods_name = "盾击印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300511) ->
	#ets_goods_type{goods_id = 300511,goods_name = "领航印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300512) ->
	#ets_goods_type{goods_id = 300512,goods_name = "领航印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300513) ->
	#ets_goods_type{goods_id = 300513,goods_name = "领航印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300514) ->
	#ets_goods_type{goods_id = 300514,goods_name = "领航印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300515) ->
	#ets_goods_type{goods_id = 300515,goods_name = "领航印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300516) ->
	#ets_goods_type{goods_id = 300516,goods_name = "领航印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300521) ->
	#ets_goods_type{goods_id = 300521,goods_name = "领航印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300522) ->
	#ets_goods_type{goods_id = 300522,goods_name = "领航印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300523) ->
	#ets_goods_type{goods_id = 300523,goods_name = "领航印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300524) ->
	#ets_goods_type{goods_id = 300524,goods_name = "领航印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300525) ->
	#ets_goods_type{goods_id = 300525,goods_name = "领航印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300526) ->
	#ets_goods_type{goods_id = 300526,goods_name = "领航印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300531) ->
	#ets_goods_type{goods_id = 300531,goods_name = "领航印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300532) ->
	#ets_goods_type{goods_id = 300532,goods_name = "领航印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300533) ->
	#ets_goods_type{goods_id = 300533,goods_name = "领航印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300534) ->
	#ets_goods_type{goods_id = 300534,goods_name = "领航印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300535) ->
	#ets_goods_type{goods_id = 300535,goods_name = "领航印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300536) ->
	#ets_goods_type{goods_id = 300536,goods_name = "领航印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300541) ->
	#ets_goods_type{goods_id = 300541,goods_name = "领航印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300542) ->
	#ets_goods_type{goods_id = 300542,goods_name = "领航印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300543) ->
	#ets_goods_type{goods_id = 300543,goods_name = "领航印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300544) ->
	#ets_goods_type{goods_id = 300544,goods_name = "领航印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300545) ->
	#ets_goods_type{goods_id = 300545,goods_name = "领航印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300546) ->
	#ets_goods_type{goods_id = 300546,goods_name = "领航印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300551) ->
	#ets_goods_type{goods_id = 300551,goods_name = "领航印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300552) ->
	#ets_goods_type{goods_id = 300552,goods_name = "领航印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300553) ->
	#ets_goods_type{goods_id = 300553,goods_name = "领航印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300554) ->
	#ets_goods_type{goods_id = 300554,goods_name = "领航印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300555) ->
	#ets_goods_type{goods_id = 300555,goods_name = "领航印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300556) ->
	#ets_goods_type{goods_id = 300556,goods_name = "领航印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300561) ->
	#ets_goods_type{goods_id = 300561,goods_name = "领航印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300562) ->
	#ets_goods_type{goods_id = 300562,goods_name = "领航印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300563) ->
	#ets_goods_type{goods_id = 300563,goods_name = "领航印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300564) ->
	#ets_goods_type{goods_id = 300564,goods_name = "领航印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300565) ->
	#ets_goods_type{goods_id = 300565,goods_name = "领航印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300566) ->
	#ets_goods_type{goods_id = 300566,goods_name = "领航印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300611) ->
	#ets_goods_type{goods_id = 300611,goods_name = "祭祀印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300612) ->
	#ets_goods_type{goods_id = 300612,goods_name = "祭祀印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300613) ->
	#ets_goods_type{goods_id = 300613,goods_name = "祭祀印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300614) ->
	#ets_goods_type{goods_id = 300614,goods_name = "祭祀印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300615) ->
	#ets_goods_type{goods_id = 300615,goods_name = "祭祀印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300616) ->
	#ets_goods_type{goods_id = 300616,goods_name = "祭祀印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300621) ->
	#ets_goods_type{goods_id = 300621,goods_name = "祭祀印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300622) ->
	#ets_goods_type{goods_id = 300622,goods_name = "祭祀印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300623) ->
	#ets_goods_type{goods_id = 300623,goods_name = "祭祀印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300624) ->
	#ets_goods_type{goods_id = 300624,goods_name = "祭祀印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300625) ->
	#ets_goods_type{goods_id = 300625,goods_name = "祭祀印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300626) ->
	#ets_goods_type{goods_id = 300626,goods_name = "祭祀印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300631) ->
	#ets_goods_type{goods_id = 300631,goods_name = "祭祀印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300632) ->
	#ets_goods_type{goods_id = 300632,goods_name = "祭祀印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300633) ->
	#ets_goods_type{goods_id = 300633,goods_name = "祭祀印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300634) ->
	#ets_goods_type{goods_id = 300634,goods_name = "祭祀印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300635) ->
	#ets_goods_type{goods_id = 300635,goods_name = "祭祀印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300636) ->
	#ets_goods_type{goods_id = 300636,goods_name = "祭祀印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300641) ->
	#ets_goods_type{goods_id = 300641,goods_name = "祭祀印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300642) ->
	#ets_goods_type{goods_id = 300642,goods_name = "祭祀印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300643) ->
	#ets_goods_type{goods_id = 300643,goods_name = "祭祀印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300644) ->
	#ets_goods_type{goods_id = 300644,goods_name = "祭祀印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300645) ->
	#ets_goods_type{goods_id = 300645,goods_name = "祭祀印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300646) ->
	#ets_goods_type{goods_id = 300646,goods_name = "祭祀印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300651) ->
	#ets_goods_type{goods_id = 300651,goods_name = "祭祀印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300652) ->
	#ets_goods_type{goods_id = 300652,goods_name = "祭祀印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300653) ->
	#ets_goods_type{goods_id = 300653,goods_name = "祭祀印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300654) ->
	#ets_goods_type{goods_id = 300654,goods_name = "祭祀印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300655) ->
	#ets_goods_type{goods_id = 300655,goods_name = "祭祀印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300656) ->
	#ets_goods_type{goods_id = 300656,goods_name = "祭祀印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300661) ->
	#ets_goods_type{goods_id = 300661,goods_name = "祭祀印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300662) ->
	#ets_goods_type{goods_id = 300662,goods_name = "祭祀印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300663) ->
	#ets_goods_type{goods_id = 300663,goods_name = "祭祀印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300664) ->
	#ets_goods_type{goods_id = 300664,goods_name = "祭祀印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300665) ->
	#ets_goods_type{goods_id = 300665,goods_name = "祭祀印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300666) ->
	#ets_goods_type{goods_id = 300666,goods_name = "祭祀印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300711) ->
	#ets_goods_type{goods_id = 300711,goods_name = "风纪印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300712) ->
	#ets_goods_type{goods_id = 300712,goods_name = "风纪印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300713) ->
	#ets_goods_type{goods_id = 300713,goods_name = "风纪印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300714) ->
	#ets_goods_type{goods_id = 300714,goods_name = "风纪印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300715) ->
	#ets_goods_type{goods_id = 300715,goods_name = "风纪印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300716) ->
	#ets_goods_type{goods_id = 300716,goods_name = "风纪印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300721) ->
	#ets_goods_type{goods_id = 300721,goods_name = "风纪印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300722) ->
	#ets_goods_type{goods_id = 300722,goods_name = "风纪印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300723) ->
	#ets_goods_type{goods_id = 300723,goods_name = "风纪印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300724) ->
	#ets_goods_type{goods_id = 300724,goods_name = "风纪印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300725) ->
	#ets_goods_type{goods_id = 300725,goods_name = "风纪印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300726) ->
	#ets_goods_type{goods_id = 300726,goods_name = "风纪印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300731) ->
	#ets_goods_type{goods_id = 300731,goods_name = "风纪印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300732) ->
	#ets_goods_type{goods_id = 300732,goods_name = "风纪印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300733) ->
	#ets_goods_type{goods_id = 300733,goods_name = "风纪印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300734) ->
	#ets_goods_type{goods_id = 300734,goods_name = "风纪印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300735) ->
	#ets_goods_type{goods_id = 300735,goods_name = "风纪印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300736) ->
	#ets_goods_type{goods_id = 300736,goods_name = "风纪印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300741) ->
	#ets_goods_type{goods_id = 300741,goods_name = "风纪印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300742) ->
	#ets_goods_type{goods_id = 300742,goods_name = "风纪印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300743) ->
	#ets_goods_type{goods_id = 300743,goods_name = "风纪印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300744) ->
	#ets_goods_type{goods_id = 300744,goods_name = "风纪印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300745) ->
	#ets_goods_type{goods_id = 300745,goods_name = "风纪印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300746) ->
	#ets_goods_type{goods_id = 300746,goods_name = "风纪印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300751) ->
	#ets_goods_type{goods_id = 300751,goods_name = "风纪印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300752) ->
	#ets_goods_type{goods_id = 300752,goods_name = "风纪印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300753) ->
	#ets_goods_type{goods_id = 300753,goods_name = "风纪印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300754) ->
	#ets_goods_type{goods_id = 300754,goods_name = "风纪印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300755) ->
	#ets_goods_type{goods_id = 300755,goods_name = "风纪印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300756) ->
	#ets_goods_type{goods_id = 300756,goods_name = "风纪印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300761) ->
	#ets_goods_type{goods_id = 300761,goods_name = "风纪印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300762) ->
	#ets_goods_type{goods_id = 300762,goods_name = "风纪印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300763) ->
	#ets_goods_type{goods_id = 300763,goods_name = "风纪印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300764) ->
	#ets_goods_type{goods_id = 300764,goods_name = "风纪印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300765) ->
	#ets_goods_type{goods_id = 300765,goods_name = "风纪印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300766) ->
	#ets_goods_type{goods_id = 300766,goods_name = "风纪印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300811) ->
	#ets_goods_type{goods_id = 300811,goods_name = "制裁印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300812) ->
	#ets_goods_type{goods_id = 300812,goods_name = "制裁印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300813) ->
	#ets_goods_type{goods_id = 300813,goods_name = "制裁印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300814) ->
	#ets_goods_type{goods_id = 300814,goods_name = "制裁印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300815) ->
	#ets_goods_type{goods_id = 300815,goods_name = "制裁印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300816) ->
	#ets_goods_type{goods_id = 300816,goods_name = "制裁印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300821) ->
	#ets_goods_type{goods_id = 300821,goods_name = "制裁印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300822) ->
	#ets_goods_type{goods_id = 300822,goods_name = "制裁印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300823) ->
	#ets_goods_type{goods_id = 300823,goods_name = "制裁印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300824) ->
	#ets_goods_type{goods_id = 300824,goods_name = "制裁印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300825) ->
	#ets_goods_type{goods_id = 300825,goods_name = "制裁印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300826) ->
	#ets_goods_type{goods_id = 300826,goods_name = "制裁印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300831) ->
	#ets_goods_type{goods_id = 300831,goods_name = "制裁印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300832) ->
	#ets_goods_type{goods_id = 300832,goods_name = "制裁印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300833) ->
	#ets_goods_type{goods_id = 300833,goods_name = "制裁印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300834) ->
	#ets_goods_type{goods_id = 300834,goods_name = "制裁印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300835) ->
	#ets_goods_type{goods_id = 300835,goods_name = "制裁印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300836) ->
	#ets_goods_type{goods_id = 300836,goods_name = "制裁印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300841) ->
	#ets_goods_type{goods_id = 300841,goods_name = "制裁印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300842) ->
	#ets_goods_type{goods_id = 300842,goods_name = "制裁印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300843) ->
	#ets_goods_type{goods_id = 300843,goods_name = "制裁印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300844) ->
	#ets_goods_type{goods_id = 300844,goods_name = "制裁印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300845) ->
	#ets_goods_type{goods_id = 300845,goods_name = "制裁印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300846) ->
	#ets_goods_type{goods_id = 300846,goods_name = "制裁印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300851) ->
	#ets_goods_type{goods_id = 300851,goods_name = "制裁印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300852) ->
	#ets_goods_type{goods_id = 300852,goods_name = "制裁印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300853) ->
	#ets_goods_type{goods_id = 300853,goods_name = "制裁印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300854) ->
	#ets_goods_type{goods_id = 300854,goods_name = "制裁印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300855) ->
	#ets_goods_type{goods_id = 300855,goods_name = "制裁印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300856) ->
	#ets_goods_type{goods_id = 300856,goods_name = "制裁印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300861) ->
	#ets_goods_type{goods_id = 300861,goods_name = "制裁印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300862) ->
	#ets_goods_type{goods_id = 300862,goods_name = "制裁印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300863) ->
	#ets_goods_type{goods_id = 300863,goods_name = "制裁印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300864) ->
	#ets_goods_type{goods_id = 300864,goods_name = "制裁印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300865) ->
	#ets_goods_type{goods_id = 300865,goods_name = "制裁印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300866) ->
	#ets_goods_type{goods_id = 300866,goods_name = "制裁印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(300911) ->
	#ets_goods_type{goods_id = 300911,goods_name = "执行印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 1,bag_location = loc(21,1)};
get(300912) ->
	#ets_goods_type{goods_id = 300912,goods_name = "执行印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 2,bag_location = loc(21,1)};
get(300913) ->
	#ets_goods_type{goods_id = 300913,goods_name = "执行印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 3,bag_location = loc(21,1)};
get(300914) ->
	#ets_goods_type{goods_id = 300914,goods_name = "执行印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 4,bag_location = loc(21,1)};
get(300915) ->
	#ets_goods_type{goods_id = 300915,goods_name = "执行印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 5,bag_location = loc(21,1)};
get(300916) ->
	#ets_goods_type{goods_id = 300916,goods_name = "执行印·一",bind = 1,type = 21,subtype = 1,max_overlap = 1,color = 6,bag_location = loc(21,1)};
get(300921) ->
	#ets_goods_type{goods_id = 300921,goods_name = "执行印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 1,bag_location = loc(21,2)};
get(300922) ->
	#ets_goods_type{goods_id = 300922,goods_name = "执行印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 2,bag_location = loc(21,2)};
get(300923) ->
	#ets_goods_type{goods_id = 300923,goods_name = "执行印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 3,bag_location = loc(21,2)};
get(300924) ->
	#ets_goods_type{goods_id = 300924,goods_name = "执行印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 4,bag_location = loc(21,2)};
get(300925) ->
	#ets_goods_type{goods_id = 300925,goods_name = "执行印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 5,bag_location = loc(21,2)};
get(300926) ->
	#ets_goods_type{goods_id = 300926,goods_name = "执行印·二",bind = 1,type = 21,subtype = 2,max_overlap = 1,color = 6,bag_location = loc(21,2)};
get(300931) ->
	#ets_goods_type{goods_id = 300931,goods_name = "执行印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 1,bag_location = loc(21,3)};
get(300932) ->
	#ets_goods_type{goods_id = 300932,goods_name = "执行印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 2,bag_location = loc(21,3)};
get(300933) ->
	#ets_goods_type{goods_id = 300933,goods_name = "执行印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 3,bag_location = loc(21,3)};
get(300934) ->
	#ets_goods_type{goods_id = 300934,goods_name = "执行印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 4,bag_location = loc(21,3)};
get(300935) ->
	#ets_goods_type{goods_id = 300935,goods_name = "执行印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 5,bag_location = loc(21,3)};
get(300936) ->
	#ets_goods_type{goods_id = 300936,goods_name = "执行印·三",bind = 1,type = 21,subtype = 3,max_overlap = 1,color = 6,bag_location = loc(21,3)};
get(300941) ->
	#ets_goods_type{goods_id = 300941,goods_name = "执行印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 1,bag_location = loc(21,4)};
get(300942) ->
	#ets_goods_type{goods_id = 300942,goods_name = "执行印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 2,bag_location = loc(21,4)};
get(300943) ->
	#ets_goods_type{goods_id = 300943,goods_name = "执行印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 3,bag_location = loc(21,4)};
get(300944) ->
	#ets_goods_type{goods_id = 300944,goods_name = "执行印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 4,bag_location = loc(21,4)};
get(300945) ->
	#ets_goods_type{goods_id = 300945,goods_name = "执行印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 5,bag_location = loc(21,4)};
get(300946) ->
	#ets_goods_type{goods_id = 300946,goods_name = "执行印·四",bind = 1,type = 21,subtype = 4,max_overlap = 1,color = 6,bag_location = loc(21,4)};
get(300951) ->
	#ets_goods_type{goods_id = 300951,goods_name = "执行印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 1,bag_location = loc(21,5)};
get(300952) ->
	#ets_goods_type{goods_id = 300952,goods_name = "执行印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 2,bag_location = loc(21,5)};
get(300953) ->
	#ets_goods_type{goods_id = 300953,goods_name = "执行印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 3,bag_location = loc(21,5)};
get(300954) ->
	#ets_goods_type{goods_id = 300954,goods_name = "执行印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 4,bag_location = loc(21,5)};
get(300955) ->
	#ets_goods_type{goods_id = 300955,goods_name = "执行印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 5,bag_location = loc(21,5)};
get(300956) ->
	#ets_goods_type{goods_id = 300956,goods_name = "执行印·五",bind = 1,type = 21,subtype = 5,max_overlap = 1,color = 6,bag_location = loc(21,5)};
get(300961) ->
	#ets_goods_type{goods_id = 300961,goods_name = "执行印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 1,bag_location = loc(21,6)};
get(300962) ->
	#ets_goods_type{goods_id = 300962,goods_name = "执行印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 2,bag_location = loc(21,6)};
get(300963) ->
	#ets_goods_type{goods_id = 300963,goods_name = "执行印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 3,bag_location = loc(21,6)};
get(300964) ->
	#ets_goods_type{goods_id = 300964,goods_name = "执行印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 4,bag_location = loc(21,6)};
get(300965) ->
	#ets_goods_type{goods_id = 300965,goods_name = "执行印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 5,bag_location = loc(21,6)};
get(300966) ->
	#ets_goods_type{goods_id = 300966,goods_name = "执行印·六",bind = 1,type = 21,subtype = 6,max_overlap = 1,color = 6,bag_location = loc(21,6)};
get(310101) ->
	#ets_goods_type{goods_id = 310101,goods_name = "1星恶魔礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310102) ->
	#ets_goods_type{goods_id = 310102,goods_name = "2星恶魔礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310103) ->
	#ets_goods_type{goods_id = 310103,goods_name = "3星恶魔礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310104) ->
	#ets_goods_type{goods_id = 310104,goods_name = "4星恶魔礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310105) ->
	#ets_goods_type{goods_id = 310105,goods_name = "5星恶魔礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310106) ->
	#ets_goods_type{goods_id = 310106,goods_name = "6星恶魔礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310201) ->
	#ets_goods_type{goods_id = 310201,goods_name = "1星守望礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310202) ->
	#ets_goods_type{goods_id = 310202,goods_name = "2星守望礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310203) ->
	#ets_goods_type{goods_id = 310203,goods_name = "3星守望礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310204) ->
	#ets_goods_type{goods_id = 310204,goods_name = "4星守望礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310205) ->
	#ets_goods_type{goods_id = 310205,goods_name = "5星守望礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310206) ->
	#ets_goods_type{goods_id = 310206,goods_name = "6星守望礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310301) ->
	#ets_goods_type{goods_id = 310301,goods_name = "1星灵兽礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310302) ->
	#ets_goods_type{goods_id = 310302,goods_name = "2星灵兽礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310303) ->
	#ets_goods_type{goods_id = 310303,goods_name = "3星灵兽礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310304) ->
	#ets_goods_type{goods_id = 310304,goods_name = "4星灵兽礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310305) ->
	#ets_goods_type{goods_id = 310305,goods_name = "5星灵兽礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310306) ->
	#ets_goods_type{goods_id = 310306,goods_name = "6星灵兽礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310401) ->
	#ets_goods_type{goods_id = 310401,goods_name = "1星盾击礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310402) ->
	#ets_goods_type{goods_id = 310402,goods_name = "2星盾击礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310403) ->
	#ets_goods_type{goods_id = 310403,goods_name = "3星盾击礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310404) ->
	#ets_goods_type{goods_id = 310404,goods_name = "4星盾击礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310405) ->
	#ets_goods_type{goods_id = 310405,goods_name = "5星盾击礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310406) ->
	#ets_goods_type{goods_id = 310406,goods_name = "6星盾击礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310501) ->
	#ets_goods_type{goods_id = 310501,goods_name = "1星领航礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310502) ->
	#ets_goods_type{goods_id = 310502,goods_name = "2星领航礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310503) ->
	#ets_goods_type{goods_id = 310503,goods_name = "3星领航礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310504) ->
	#ets_goods_type{goods_id = 310504,goods_name = "4星领航礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310505) ->
	#ets_goods_type{goods_id = 310505,goods_name = "5星领航礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310506) ->
	#ets_goods_type{goods_id = 310506,goods_name = "6星领航礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310601) ->
	#ets_goods_type{goods_id = 310601,goods_name = "1星祭祀礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310602) ->
	#ets_goods_type{goods_id = 310602,goods_name = "2星祭祀礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310603) ->
	#ets_goods_type{goods_id = 310603,goods_name = "3星祭祀礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310604) ->
	#ets_goods_type{goods_id = 310604,goods_name = "4星祭祀礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310605) ->
	#ets_goods_type{goods_id = 310605,goods_name = "5星祭祀礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310606) ->
	#ets_goods_type{goods_id = 310606,goods_name = "6星祭祀礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310701) ->
	#ets_goods_type{goods_id = 310701,goods_name = "1星风纪礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310702) ->
	#ets_goods_type{goods_id = 310702,goods_name = "2星风纪礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310703) ->
	#ets_goods_type{goods_id = 310703,goods_name = "3星风纪礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310704) ->
	#ets_goods_type{goods_id = 310704,goods_name = "4星风纪礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310705) ->
	#ets_goods_type{goods_id = 310705,goods_name = "5星风纪礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310706) ->
	#ets_goods_type{goods_id = 310706,goods_name = "6星风纪礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310801) ->
	#ets_goods_type{goods_id = 310801,goods_name = "1星制裁礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310802) ->
	#ets_goods_type{goods_id = 310802,goods_name = "2星制裁礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310803) ->
	#ets_goods_type{goods_id = 310803,goods_name = "3星制裁礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310804) ->
	#ets_goods_type{goods_id = 310804,goods_name = "4星制裁礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310805) ->
	#ets_goods_type{goods_id = 310805,goods_name = "5星制裁礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310806) ->
	#ets_goods_type{goods_id = 310806,goods_name = "6星制裁礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(310901) ->
	#ets_goods_type{goods_id = 310901,goods_name = "1星执行礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(19,1)};
get(310902) ->
	#ets_goods_type{goods_id = 310902,goods_name = "2星执行礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(19,1)};
get(310903) ->
	#ets_goods_type{goods_id = 310903,goods_name = "3星执行礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(310904) ->
	#ets_goods_type{goods_id = 310904,goods_name = "4星执行礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(310905) ->
	#ets_goods_type{goods_id = 310905,goods_name = "5星执行礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(310906) ->
	#ets_goods_type{goods_id = 310906,goods_name = "6星执行礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(19,1)};
get(330000) ->
	#ets_goods_type{goods_id = 330000,goods_name = "战意",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 3,use = 1,bag_location = loc(19,1)};
get(330101) ->
	#ets_goods_type{goods_id = 330101,goods_name = "风·防护",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(23,1)};
get(330102) ->
	#ets_goods_type{goods_id = 330102,goods_name = "风·活跃",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(23,1)};
get(330103) ->
	#ets_goods_type{goods_id = 330103,goods_name = "风·防护ex",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(23,1)};
get(330104) ->
	#ets_goods_type{goods_id = 330104,goods_name = "风·活跃ex",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(23,1)};
get(330105) ->
	#ets_goods_type{goods_id = 330105,goods_name = "风·防护max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330106) ->
	#ets_goods_type{goods_id = 330106,goods_name = "风·活跃max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330107) ->
	#ets_goods_type{goods_id = 330107,goods_name = "风·精准max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330108) ->
	#ets_goods_type{goods_id = 330108,goods_name = "风·镰鼬",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330109) ->
	#ets_goods_type{goods_id = 330109,goods_name = "风·飞鹏",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330110) ->
	#ets_goods_type{goods_id = 330110,goods_name = "风·猎鹰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330111) ->
	#ets_goods_type{goods_id = 330111,goods_name = "风·雷蛇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330112) ->
	#ets_goods_type{goods_id = 330112,goods_name = "风·龙卷",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330113) ->
	#ets_goods_type{goods_id = 330113,goods_name = "风·嘲星龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330114) ->
	#ets_goods_type{goods_id = 330114,goods_name = "风·弥天鲲鹏",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330115) ->
	#ets_goods_type{goods_id = 330115,goods_name = "风·斯芬克斯",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330116) ->
	#ets_goods_type{goods_id = 330116,goods_name = "风·天空狮鹫",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330117) ->
	#ets_goods_type{goods_id = 330117,goods_name = "风·闪电千鸟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330201) ->
	#ets_goods_type{goods_id = 330201,goods_name = "火·强攻",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(23,1)};
get(330202) ->
	#ets_goods_type{goods_id = 330202,goods_name = "火·固伤",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(23,1)};
get(330203) ->
	#ets_goods_type{goods_id = 330203,goods_name = "火·强攻ex",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(23,1)};
get(330204) ->
	#ets_goods_type{goods_id = 330204,goods_name = "火·固伤ex",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(23,1)};
get(330205) ->
	#ets_goods_type{goods_id = 330205,goods_name = "火·强攻max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330206) ->
	#ets_goods_type{goods_id = 330206,goods_name = "火·固伤max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330207) ->
	#ets_goods_type{goods_id = 330207,goods_name = "火·爆发max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330208) ->
	#ets_goods_type{goods_id = 330208,goods_name = "火·三尾火狐",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330209) ->
	#ets_goods_type{goods_id = 330209,goods_name = "火·不死鸟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330210) ->
	#ets_goods_type{goods_id = 330210,goods_name = "火·炎鬼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330211) ->
	#ets_goods_type{goods_id = 330211,goods_name = "火·巨象",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330212) ->
	#ets_goods_type{goods_id = 330212,goods_name = "火·地狱犬",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330213) ->
	#ets_goods_type{goods_id = 330213,goods_name = "火·黯灭龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330214) ->
	#ets_goods_type{goods_id = 330214,goods_name = "火·火焰凤凰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330215) ->
	#ets_goods_type{goods_id = 330215,goods_name = "火·火焰麒麟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330216) ->
	#ets_goods_type{goods_id = 330216,goods_name = "火·黑暗孔雀",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330217) ->
	#ets_goods_type{goods_id = 330217,goods_name = "火·火焰巨人",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330301) ->
	#ets_goods_type{goods_id = 330301,goods_name = "水·活力",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(23,1)};
get(330302) ->
	#ets_goods_type{goods_id = 330302,goods_name = "水·稳固",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 1,use = 1,bag_location = loc(23,1)};
get(330303) ->
	#ets_goods_type{goods_id = 330303,goods_name = "水·活力ex",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(23,1)};
get(330304) ->
	#ets_goods_type{goods_id = 330304,goods_name = "水·稳固ex",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(23,1)};
get(330305) ->
	#ets_goods_type{goods_id = 330305,goods_name = "水·活力max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330306) ->
	#ets_goods_type{goods_id = 330306,goods_name = "水·稳固max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330307) ->
	#ets_goods_type{goods_id = 330307,goods_name = "水·灵敏max",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(23,1)};
get(330308) ->
	#ets_goods_type{goods_id = 330308,goods_name = "水·河童",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330309) ->
	#ets_goods_type{goods_id = 330309,goods_name = "水·人鱼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330310) ->
	#ets_goods_type{goods_id = 330310,goods_name = "水·雪女",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330311) ->
	#ets_goods_type{goods_id = 330311,goods_name = "水·仙水母",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330312) ->
	#ets_goods_type{goods_id = 330312,goods_name = "水·巨鲸",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(330313) ->
	#ets_goods_type{goods_id = 330313,goods_name = "水·古鱼龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330314) ->
	#ets_goods_type{goods_id = 330314,goods_name = "水·玄武巨龟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330315) ->
	#ets_goods_type{goods_id = 330315,goods_name = "水·九尾金鱼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330316) ->
	#ets_goods_type{goods_id = 330316,goods_name = "水·水星君主",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330317) ->
	#ets_goods_type{goods_id = 330317,goods_name = "水·霸王狂鲨",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(330901) ->
	#ets_goods_type{goods_id = 330901,goods_name = "战魂·供养",bind = 1,type = 23,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(23,2)};
get(330902) ->
	#ets_goods_type{goods_id = 330902,goods_name = "战魂·供养",bind = 1,type = 23,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(23,2)};
get(330903) ->
	#ets_goods_type{goods_id = 330903,goods_name = "战魂·供养",bind = 1,type = 23,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(23,2)};
get(331108) ->
	#ets_goods_type{goods_id = 331108,goods_name = "风·飞镰鼬",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331109) ->
	#ets_goods_type{goods_id = 331109,goods_name = "风·薰风鹏",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331110) ->
	#ets_goods_type{goods_id = 331110,goods_name = "风·战猎鹰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331111) ->
	#ets_goods_type{goods_id = 331111,goods_name = "风·雷光蛇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331112) ->
	#ets_goods_type{goods_id = 331112,goods_name = "风·大龙卷",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331113) ->
	#ets_goods_type{goods_id = 331113,goods_name = "风·圣言龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331114) ->
	#ets_goods_type{goods_id = 331114,goods_name = "风·弥天巨鲲",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331115) ->
	#ets_goods_type{goods_id = 331115,goods_name = "风·海尔拉克",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331116) ->
	#ets_goods_type{goods_id = 331116,goods_name = "风·苍穹狮鹫",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331117) ->
	#ets_goods_type{goods_id = 331117,goods_name = "风·闪电万鸟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331208) ->
	#ets_goods_type{goods_id = 331208,goods_name = "火·六尾火狐",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331209) ->
	#ets_goods_type{goods_id = 331209,goods_name = "火·不死大鹏",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331210) ->
	#ets_goods_type{goods_id = 331210,goods_name = "火·炎狱鬼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331211) ->
	#ets_goods_type{goods_id = 331211,goods_name = "火·战争巨象",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331212) ->
	#ets_goods_type{goods_id = 331212,goods_name = "火·刻耳柏斯",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331213) ->
	#ets_goods_type{goods_id = 331213,goods_name = "火·终焉龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331214) ->
	#ets_goods_type{goods_id = 331214,goods_name = "火·圣火凤凰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331215) ->
	#ets_goods_type{goods_id = 331215,goods_name = "火·圣火麒麟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331216) ->
	#ets_goods_type{goods_id = 331216,goods_name = "火·寂灭孔雀",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331217) ->
	#ets_goods_type{goods_id = 331217,goods_name = "火·圣火巨人",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331308) ->
	#ets_goods_type{goods_id = 331308,goods_name = "水·兵主部",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331309) ->
	#ets_goods_type{goods_id = 331309,goods_name = "水·美人鱼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331310) ->
	#ets_goods_type{goods_id = 331310,goods_name = "水·零冰雪女",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331311) ->
	#ets_goods_type{goods_id = 331311,goods_name = "水·巨舰水母",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331312) ->
	#ets_goods_type{goods_id = 331312,goods_name = "水·古巨鲸",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(23,1)};
get(331313) ->
	#ets_goods_type{goods_id = 331313,goods_name = "水·深渊龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331314) ->
	#ets_goods_type{goods_id = 331314,goods_name = "水·盖亚巨龟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331315) ->
	#ets_goods_type{goods_id = 331315,goods_name = "水·虹彩金鱼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331316) ->
	#ets_goods_type{goods_id = 331316,goods_name = "水·水星霸主",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(331317) ->
	#ets_goods_type{goods_id = 331317,goods_name = "水·深海狂鲨",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(23,1)};
get(332113) ->
	#ets_goods_type{goods_id = 332113,goods_name = "风·万仞龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332114) ->
	#ets_goods_type{goods_id = 332114,goods_name = "风·擎天巨鲲",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332115) ->
	#ets_goods_type{goods_id = 332115,goods_name = "风·艾克佐德",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332116) ->
	#ets_goods_type{goods_id = 332116,goods_name = "风·烈风狮鹫",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332117) ->
	#ets_goods_type{goods_id = 332117,goods_name = "风·雷击万鸟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332213) ->
	#ets_goods_type{goods_id = 332213,goods_name = "火·灭世龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332214) ->
	#ets_goods_type{goods_id = 332214,goods_name = "火·阳炎凤凰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332215) ->
	#ets_goods_type{goods_id = 332215,goods_name = "火·阳炎麒麟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332216) ->
	#ets_goods_type{goods_id = 332216,goods_name = "火·九蛇孔雀",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332217) ->
	#ets_goods_type{goods_id = 332217,goods_name = "火·阳炎巨人",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332313) ->
	#ets_goods_type{goods_id = 332313,goods_name = "水·古神龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332314) ->
	#ets_goods_type{goods_id = 332314,goods_name = "水·盖亚板块",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332315) ->
	#ets_goods_type{goods_id = 332315,goods_name = "水·斗气金鱼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332316) ->
	#ets_goods_type{goods_id = 332316,goods_name = "水·水星圣主",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(332317) ->
	#ets_goods_type{goods_id = 332317,goods_name = "水·巨口狂鲨",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333113) ->
	#ets_goods_type{goods_id = 333113,goods_name = "风·圣愈龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333114) ->
	#ets_goods_type{goods_id = 333114,goods_name = "风·瞒天巨鲲",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333115) ->
	#ets_goods_type{goods_id = 333115,goods_name = "风·克莱欧",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333116) ->
	#ets_goods_type{goods_id = 333116,goods_name = "风·飓风狮鹫",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333117) ->
	#ets_goods_type{goods_id = 333117,goods_name = "风·雷击万鹰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333213) ->
	#ets_goods_type{goods_id = 333213,goods_name = "火·焚天龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333214) ->
	#ets_goods_type{goods_id = 333214,goods_name = "火·光轮凤凰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333215) ->
	#ets_goods_type{goods_id = 333215,goods_name = "火·光轮麒麟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333216) ->
	#ets_goods_type{goods_id = 333216,goods_name = "火·圣王孔雀",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333217) ->
	#ets_goods_type{goods_id = 333217,goods_name = "火·光轮巨人",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333313) ->
	#ets_goods_type{goods_id = 333313,goods_name = "水·化石龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333314) ->
	#ets_goods_type{goods_id = 333314,goods_name = "水·盖亚地母",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333315) ->
	#ets_goods_type{goods_id = 333315,goods_name = "水·神海金鱼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333316) ->
	#ets_goods_type{goods_id = 333316,goods_name = "水·水星英灵",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(333317) ->
	#ets_goods_type{goods_id = 333317,goods_name = "水·巡洋巨鲨",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 6,use = 1,bag_location = loc(23,1)};
get(334113) ->
	#ets_goods_type{goods_id = 334113,goods_name = "风·愈世龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334114) ->
	#ets_goods_type{goods_id = 334114,goods_name = "风·吞天巨鲲",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334115) ->
	#ets_goods_type{goods_id = 334115,goods_name = "风·阿图姆",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334116) ->
	#ets_goods_type{goods_id = 334116,goods_name = "风·大气狮鹫",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334117) ->
	#ets_goods_type{goods_id = 334117,goods_name = "风·雷鸣万鹰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334213) ->
	#ets_goods_type{goods_id = 334213,goods_name = "火·创世龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334214) ->
	#ets_goods_type{goods_id = 334214,goods_name = "火·红莲凤凰",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334215) ->
	#ets_goods_type{goods_id = 334215,goods_name = "火·红莲麒麟",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334216) ->
	#ets_goods_type{goods_id = 334216,goods_name = "火·开辟孔雀",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334217) ->
	#ets_goods_type{goods_id = 334217,goods_name = "火·红莲巨人",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334313) ->
	#ets_goods_type{goods_id = 334313,goods_name = "水·录世龙皇",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334314) ->
	#ets_goods_type{goods_id = 334314,goods_name = "水·承世地母",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334315) ->
	#ets_goods_type{goods_id = 334315,goods_name = "水·辟海金鱼",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334316) ->
	#ets_goods_type{goods_id = 334316,goods_name = "水·水星英主",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(334317) ->
	#ets_goods_type{goods_id = 334317,goods_name = "水·航空巨鲨",bind = 1,type = 23,subtype = 1,max_overlap = 1,color = 7,use = 1,bag_location = loc(23,1)};
get(340001) ->
	#ets_goods_type{goods_id = 340001,goods_name = "1级信物",bind = 1,type = 1,subtype = 32,max_overlap = 1,color = 1,use = 1,bag_location = loc(1,32)};
get(340002) ->
	#ets_goods_type{goods_id = 340002,goods_name = "2级信物",bind = 1,type = 1,subtype = 32,max_overlap = 1,color = 2,use = 1,bag_location = loc(1,32)};
get(340003) ->
	#ets_goods_type{goods_id = 340003,goods_name = "3级信物",bind = 1,type = 1,subtype = 32,max_overlap = 1,color = 3,use = 1,bag_location = loc(1,32)};
get(340004) ->
	#ets_goods_type{goods_id = 340004,goods_name = "4级信物",bind = 1,type = 1,subtype = 32,max_overlap = 1,color = 4,use = 1,bag_location = loc(1,32)};
get(340005) ->
	#ets_goods_type{goods_id = 340005,goods_name = "5级信物",bind = 1,type = 1,subtype = 32,max_overlap = 1,color = 5,use = 1,bag_location = loc(1,32)};
get(340006) ->
	#ets_goods_type{goods_id = 340006,goods_name = "6级信物",bind = 1,type = 1,subtype = 32,max_overlap = 1,color = 6,use = 1,bag_location = loc(1,32)};
get(340007) ->
	#ets_goods_type{goods_id = 340007,goods_name = "7级信物",bind = 1,type = 1,subtype = 32,max_overlap = 1,color = 7,use = 1,bag_location = loc(1,32)};
get(360001) ->
	#ets_goods_type{goods_id = 360001,goods_name = "普通藏宝图",bind = 1,type = 1,subtype = 38,max_overlap = 999,color = 2,use = 1,sell_subcategory = 1,bag_location = loc(1,38)};
get(360002) ->
	#ets_goods_type{goods_id = 360002,goods_name = "高级藏宝图",bind = 1,type = 1,subtype = 38,color = 5,use = 1,sell_subcategory = 1,bag_location = loc(1,38)};
get(360011) ->
	#ets_goods_type{goods_id = 360011,goods_name = "宝图残片（上）",bind = 1,type = 1,subtype = 38,max_overlap = 999,color = 4,sell_subcategory = 1,bag_location = loc(1,38)};
get(360012) ->
	#ets_goods_type{goods_id = 360012,goods_name = "宝图残片（中）",bind = 1,type = 1,subtype = 38,max_overlap = 999,color = 4,sell_subcategory = 1,bag_location = loc(1,38)};
get(360013) ->
	#ets_goods_type{goods_id = 360013,goods_name = "宝图残片（下）",bind = 1,type = 1,subtype = 38,max_overlap = 999,color = 4,sell_subcategory = 1,bag_location = loc(1,38)};
get(399999) ->
	#ets_goods_type{goods_id = 399999,goods_name = "这里是运营资源段",bind = 1,type = 11,subtype = 1,max_overlap = 9999,color = 6,bag_location = loc(11,1)};
get(400000) ->
	#ets_goods_type{goods_id = 400000,goods_name = "珍宝外观段",bind = 1,type = 11,subtype = 1,max_overlap = 9999,bag_location = loc(11,1)};
get(400001) ->
	#ets_goods_type{goods_id = 400001,goods_name = "皮肤：战术希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400002) ->
	#ets_goods_type{goods_id = 400002,goods_name = "皮肤：异能希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400003) ->
	#ets_goods_type{goods_id = 400003,goods_name = "皮肤：暗魇希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400004) ->
	#ets_goods_type{goods_id = 400004,goods_name = "皮肤：超战术希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400005) ->
	#ets_goods_type{goods_id = 400005,goods_name = "皮肤：落棋者希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400006) ->
	#ets_goods_type{goods_id = 400006,goods_name = "皮肤：指挥官希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400007) ->
	#ets_goods_type{goods_id = 400007,goods_name = "皮肤：领航星希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400008) ->
	#ets_goods_type{goods_id = 400008,goods_name = "皮肤：顶之爵希亚",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400009) ->
	#ets_goods_type{goods_id = 400009,goods_name = "皮肤：远空星皇女",bind = 1,type = 4,subtype = 6,max_overlap = 99,color = 5,bag_location = loc(4,6)};
get(400010) ->
	#ets_goods_type{goods_id = 400010,goods_name = "皮肤：磁力磁炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400011) ->
	#ets_goods_type{goods_id = 400011,goods_name = "皮肤：量子磁炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400012) ->
	#ets_goods_type{goods_id = 400012,goods_name = "皮肤：魔力磁炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400013) ->
	#ets_goods_type{goods_id = 400013,goods_name = "皮肤：空间磁炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400014) ->
	#ets_goods_type{goods_id = 400014,goods_name = "皮肤：微缩时空炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400015) ->
	#ets_goods_type{goods_id = 400015,goods_name = "皮肤：追星光子炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400016) ->
	#ets_goods_type{goods_id = 400016,goods_name = "皮肤：爱梦迫击炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400017) ->
	#ets_goods_type{goods_id = 400017,goods_name = "皮肤：碎陨重神炮",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400018) ->
	#ets_goods_type{goods_id = 400018,goods_name = "皮肤：耀星光惩戒",bind = 1,type = 4,subtype = 7,max_overlap = 99,color = 5,bag_location = loc(4,7)};
get(400019) ->
	#ets_goods_type{goods_id = 400019,goods_name = "皮肤：镜花之翼",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400020) ->
	#ets_goods_type{goods_id = 400020,goods_name = "皮肤：赛博之光",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400021) ->
	#ets_goods_type{goods_id = 400021,goods_name = "皮肤：光子火羽",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400022) ->
	#ets_goods_type{goods_id = 400022,goods_name = "皮肤：光路紫翼",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400023) ->
	#ets_goods_type{goods_id = 400023,goods_name = "皮肤：黄金庇佑",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400024) ->
	#ets_goods_type{goods_id = 400024,goods_name = "皮肤：超能晶羽",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400025) ->
	#ets_goods_type{goods_id = 400025,goods_name = "皮肤：破世焰图腾",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400026) ->
	#ets_goods_type{goods_id = 400026,goods_name = "皮肤：光阴颂世羽",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400027) ->
	#ets_goods_type{goods_id = 400027,goods_name = "皮肤：金色未来界",bind = 1,type = 4,subtype = 8,max_overlap = 99,color = 5,bag_location = loc(4,8)};
get(400028) ->
	#ets_goods_type{goods_id = 400028,goods_name = "皮肤：星甲守护",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400029) ->
	#ets_goods_type{goods_id = 400029,goods_name = "皮肤：魔能守护",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400030) ->
	#ets_goods_type{goods_id = 400030,goods_name = "皮肤：异能幻甲",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400031) ->
	#ets_goods_type{goods_id = 400031,goods_name = "皮肤：炼色幻甲",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400032) ->
	#ets_goods_type{goods_id = 400032,goods_name = "皮肤：祷世牌面",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400033) ->
	#ets_goods_type{goods_id = 400033,goods_name = "皮肤：微星蜂骑士",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400034) ->
	#ets_goods_type{goods_id = 400034,goods_name = "皮肤：微星守护者",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400035) ->
	#ets_goods_type{goods_id = 400035,goods_name = "皮肤：筑世远空甲",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(400036) ->
	#ets_goods_type{goods_id = 400036,goods_name = "皮肤：穹顶之镜面",bind = 1,type = 4,subtype = 9,max_overlap = 99,color = 5,bag_location = loc(4,9)};
get(401000) ->
	#ets_goods_type{goods_id = 401000,goods_name = "诺亚号II型·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401001) ->
	#ets_goods_type{goods_id = 401001,goods_name = "蛙歌王子·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401002) ->
	#ets_goods_type{goods_id = 401002,goods_name = "赛博幻鹿·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401003) ->
	#ets_goods_type{goods_id = 401003,goods_name = "蒸汽龙马·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401004) ->
	#ets_goods_type{goods_id = 401004,goods_name = "海风盛夏·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401005) ->
	#ets_goods_type{goods_id = 401005,goods_name = "恶鲨火箭·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401006) ->
	#ets_goods_type{goods_id = 401006,goods_name = "魄影拘灵·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401007) ->
	#ets_goods_type{goods_id = 401007,goods_name = "哆咩飞车·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401008) ->
	#ets_goods_type{goods_id = 401008,goods_name = "促销熊推车·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401009) ->
	#ets_goods_type{goods_id = 401009,goods_name = "魅影飞车·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401010) ->
	#ets_goods_type{goods_id = 401010,goods_name = "电竞摩蝎·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401011) ->
	#ets_goods_type{goods_id = 401011,goods_name = "异星噬鲲·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401012) ->
	#ets_goods_type{goods_id = 401012,goods_name = "黯灭龙皇·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401013) ->
	#ets_goods_type{goods_id = 401013,goods_name = "星云穿梭号·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401014) ->
	#ets_goods_type{goods_id = 401014,goods_name = "恶灵骑士·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401015) ->
	#ets_goods_type{goods_id = 401015,goods_name = "洗浴之王·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(401016) ->
	#ets_goods_type{goods_id = 401016,goods_name = "越野烈雄·模块",bind = 1,type = 11,subtype = 1,max_overlap = 99,color = 5,bag_location = loc(11,1)};
get(402000) ->
	#ets_goods_type{goods_id = 402000,goods_name = "末世荒轮·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 200,market_show_time = 1200,selling_time = 7200,market_range = 2,bag_location = loc(11,2)};
get(402001) ->
	#ets_goods_type{goods_id = 402001,goods_name = "夜辰魔翼·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,sell_category = 6,sell_subcategory = 2,trade_price = 2000,price_markup = 200,market_show_time = 1200,selling_time = 7200,market_range = 2,bag_location = loc(11,2)};
get(402002) ->
	#ets_goods_type{goods_id = 402002,goods_name = "荒神刹羽·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402003) ->
	#ets_goods_type{goods_id = 402003,goods_name = "冰璃梦羽·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402004) ->
	#ets_goods_type{goods_id = 402004,goods_name = "血月魔羽·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402005) ->
	#ets_goods_type{goods_id = 402005,goods_name = "钢炼刺芒·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402006) ->
	#ets_goods_type{goods_id = 402006,goods_name = "电离屏障·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402007) ->
	#ets_goods_type{goods_id = 402007,goods_name = "瞬时脉冲·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402008) ->
	#ets_goods_type{goods_id = 402008,goods_name = "国风意志·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402009) ->
	#ets_goods_type{goods_id = 402009,goods_name = "磁元离锥·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402010) ->
	#ets_goods_type{goods_id = 402010,goods_name = "敢达械翼·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(402011) ->
	#ets_goods_type{goods_id = 402011,goods_name = "慑梦幻翼·灵羽",bind = 1,type = 11,subtype = 2,max_overlap = 99,color = 5,bag_location = loc(11,2)};
get(403000) ->
	#ets_goods_type{goods_id = 403000,goods_name = "祈愿星月·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403001) ->
	#ets_goods_type{goods_id = 403001,goods_name = "智能小歪·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403002) ->
	#ets_goods_type{goods_id = 403002,goods_name = "E-伊妹儿·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403003) ->
	#ets_goods_type{goods_id = 403003,goods_name = "笼中机巧·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403004) ->
	#ets_goods_type{goods_id = 403004,goods_name = "甜品喵喵·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403005) ->
	#ets_goods_type{goods_id = 403005,goods_name = "异星源力·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403006) ->
	#ets_goods_type{goods_id = 403006,goods_name = "Aio-泡泡枪·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403007) ->
	#ets_goods_type{goods_id = 403007,goods_name = "冰雪童话·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403008) ->
	#ets_goods_type{goods_id = 403008,goods_name = "多元宙象·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403009) ->
	#ets_goods_type{goods_id = 403009,goods_name = "次元菱锥·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403010) ->
	#ets_goods_type{goods_id = 403010,goods_name = "祈愿星瓶·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403011) ->
	#ets_goods_type{goods_id = 403011,goods_name = "械影魔星·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(403012) ->
	#ets_goods_type{goods_id = 403012,goods_name = "零时谜钟·结晶",bind = 1,type = 11,subtype = 3,max_overlap = 99,color = 5,bag_location = loc(11,3)};
get(404000) ->
	#ets_goods_type{goods_id = 404000,goods_name = "命运汲取者·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404001) ->
	#ets_goods_type{goods_id = 404001,goods_name = "血源诅咒·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404002) ->
	#ets_goods_type{goods_id = 404002,goods_name = "雷霆重器·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404003) ->
	#ets_goods_type{goods_id = 404003,goods_name = "破世预言·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404004) ->
	#ets_goods_type{goods_id = 404004,goods_name = "末世开拓者·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404005) ->
	#ets_goods_type{goods_id = 404005,goods_name = "赛博迷集·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404006) ->
	#ets_goods_type{goods_id = 404006,goods_name = "废土囚徒·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404007) ->
	#ets_goods_type{goods_id = 404007,goods_name = "重击铁拳·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404008) ->
	#ets_goods_type{goods_id = 404008,goods_name = "武器珍宝外观9·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(404009) ->
	#ets_goods_type{goods_id = 404009,goods_name = "武器珍宝外观10·源力",bind = 1,type = 11,subtype = 4,max_overlap = 99,color = 5,bag_location = loc(11,4)};
get(405000) ->
	#ets_goods_type{goods_id = 405000,goods_name = "白雪恋歌·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405001) ->
	#ets_goods_type{goods_id = 405001,goods_name = "纯洁花嫁·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 4,bag_location = loc(11,5)};
get(405002) ->
	#ets_goods_type{goods_id = 405002,goods_name = "朋克少女·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405003) ->
	#ets_goods_type{goods_id = 405003,goods_name = "影月祭秋·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405004) ->
	#ets_goods_type{goods_id = 405004,goods_name = "海棠春意·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405005) ->
	#ets_goods_type{goods_id = 405005,goods_name = "英伦玫瑰·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405006) ->
	#ets_goods_type{goods_id = 405006,goods_name = "浪花朵朵·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405007) ->
	#ets_goods_type{goods_id = 405007,goods_name = "Black Cat·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405008) ->
	#ets_goods_type{goods_id = 405008,goods_name = "梦魇公主·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405009) ->
	#ets_goods_type{goods_id = 405009,goods_name = "波斯舞娘·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405010) ->
	#ets_goods_type{goods_id = 405010,goods_name = "兔女郎学姐·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405011) ->
	#ets_goods_type{goods_id = 405011,goods_name = "歌剧丽影·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(405012) ->
	#ets_goods_type{goods_id = 405012,goods_name = "星舰指挥娘·芯片",bind = 1,type = 11,subtype = 5,max_overlap = 99,color = 5,bag_location = loc(11,5)};
get(406001) ->
	#ets_goods_type{goods_id = 406001,goods_name = "利爪血蝠",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(3,1)};
get(406002) ->
	#ets_goods_type{goods_id = 406002,goods_name = "寒霜冰狐",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(3,1)};
get(406003) ->
	#ets_goods_type{goods_id = 406003,goods_name = "鬼爪战蝠",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(3,1)};
get(406004) ->
	#ets_goods_type{goods_id = 406004,goods_name = "麻痹战锤",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(3,1)};
get(406005) ->
	#ets_goods_type{goods_id = 406005,goods_name = "双生冰狐",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(3,1)};
get(406006) ->
	#ets_goods_type{goods_id = 406006,goods_name = "闪电灵锤",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(3,1)};
get(406007) ->
	#ets_goods_type{goods_id = 406007,goods_name = "血蝠幻阵",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(3,1)};
get(406008) ->
	#ets_goods_type{goods_id = 406008,goods_name = "细雪狐舞",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(3,1)};
get(406009) ->
	#ets_goods_type{goods_id = 406009,goods_name = "圣锤雷鸣",bind = 1,type = 3,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(3,1)};
get(410000) ->
	#ets_goods_type{goods_id = 410000,goods_name = "时装外观段",bind = 1,type = 12,subtype = 2,max_overlap = 9999,bag_location = loc(12,2)};
get(410001) ->
	#ets_goods_type{goods_id = 410001,goods_name = "赛博骇客·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410002) ->
	#ets_goods_type{goods_id = 410002,goods_name = "赛博幽客·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410003) ->
	#ets_goods_type{goods_id = 410003,goods_name = "赛博心灵·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410011) ->
	#ets_goods_type{goods_id = 410011,goods_name = "酷萌朋克·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410012) ->
	#ets_goods_type{goods_id = 410012,goods_name = "幽影朋克·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410013) ->
	#ets_goods_type{goods_id = 410013,goods_name = "潮流朋克·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410021) ->
	#ets_goods_type{goods_id = 410021,goods_name = "东瀛风物·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410022) ->
	#ets_goods_type{goods_id = 410022,goods_name = "东瀛华裳·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410023) ->
	#ets_goods_type{goods_id = 410023,goods_name = "东瀛雅韵·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410031) ->
	#ets_goods_type{goods_id = 410031,goods_name = "活力守护·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410032) ->
	#ets_goods_type{goods_id = 410032,goods_name = "活力战纪·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410033) ->
	#ets_goods_type{goods_id = 410033,goods_name = "活力热情·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410041) ->
	#ets_goods_type{goods_id = 410041,goods_name = "职场新秀·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410042) ->
	#ets_goods_type{goods_id = 410042,goods_name = "职场新星·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410043) ->
	#ets_goods_type{goods_id = 410043,goods_name = "职场精英·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410051) ->
	#ets_goods_type{goods_id = 410051,goods_name = "碳酸泡泡·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410052) ->
	#ets_goods_type{goods_id = 410052,goods_name = "碳酸炫舞·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410053) ->
	#ets_goods_type{goods_id = 410053,goods_name = "碳酸元气·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410061) ->
	#ets_goods_type{goods_id = 410061,goods_name = "甜蜜派对·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410062) ->
	#ets_goods_type{goods_id = 410062,goods_name = "潮流派对·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410063) ->
	#ets_goods_type{goods_id = 410063,goods_name = "青春派对·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410071) ->
	#ets_goods_type{goods_id = 410071,goods_name = "风雅锦绣·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410072) ->
	#ets_goods_type{goods_id = 410072,goods_name = "风雅天华·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410073) ->
	#ets_goods_type{goods_id = 410073,goods_name = "风雅幽韵·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410081) ->
	#ets_goods_type{goods_id = 410081,goods_name = "夏日海滩·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410082) ->
	#ets_goods_type{goods_id = 410082,goods_name = "夏日热浪·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410083) ->
	#ets_goods_type{goods_id = 410083,goods_name = "夏日风情·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410091) ->
	#ets_goods_type{goods_id = 410091,goods_name = "高街镭射·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410092) ->
	#ets_goods_type{goods_id = 410092,goods_name = "波谱镭射·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410093) ->
	#ets_goods_type{goods_id = 410093,goods_name = "赤霞镭射·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410101) ->
	#ets_goods_type{goods_id = 410101,goods_name = "夜影枭歌·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410111) ->
	#ets_goods_type{goods_id = 410111,goods_name = "绝对制裁·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410121) ->
	#ets_goods_type{goods_id = 410121,goods_name = "国潮风尚·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410122) ->
	#ets_goods_type{goods_id = 410122,goods_name = "国潮庆典·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410123) ->
	#ets_goods_type{goods_id = 410123,goods_name = "国潮世代·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410131) ->
	#ets_goods_type{goods_id = 410131,goods_name = "纯白誓约·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410132) ->
	#ets_goods_type{goods_id = 410132,goods_name = "幻梦誓约·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410133) ->
	#ets_goods_type{goods_id = 410133,goods_name = "甜蜜誓约·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410141) ->
	#ets_goods_type{goods_id = 410141,goods_name = "暗黑龙裔·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410142) ->
	#ets_goods_type{goods_id = 410142,goods_name = "光耀龙裔·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410143) ->
	#ets_goods_type{goods_id = 410143,goods_name = "末世龙裔·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410151) ->
	#ets_goods_type{goods_id = 410151,goods_name = "风纪委员·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410152) ->
	#ets_goods_type{goods_id = 410152,goods_name = "文娱委员·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410153) ->
	#ets_goods_type{goods_id = 410153,goods_name = "监察委员·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410161) ->
	#ets_goods_type{goods_id = 410161,goods_name = "异域灵媒·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410162) ->
	#ets_goods_type{goods_id = 410162,goods_name = "炽火灵媒·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(410163) ->
	#ets_goods_type{goods_id = 410163,goods_name = "幽晶灵媒·时装",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,2)};
get(412000) ->
	#ets_goods_type{goods_id = 412000,goods_name = "发型段",bind = 1,type = 12,subtype = 6,max_overlap = 99,use = 1,bag_location = loc(12,6)};
get(412001) ->
	#ets_goods_type{goods_id = 412001,goods_name = "赛博骇客·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412002) ->
	#ets_goods_type{goods_id = 412002,goods_name = "赛博幽客·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412003) ->
	#ets_goods_type{goods_id = 412003,goods_name = "赛博心灵·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412011) ->
	#ets_goods_type{goods_id = 412011,goods_name = "酷萌朋克·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412012) ->
	#ets_goods_type{goods_id = 412012,goods_name = "幽影朋克·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412013) ->
	#ets_goods_type{goods_id = 412013,goods_name = "潮流朋克·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412021) ->
	#ets_goods_type{goods_id = 412021,goods_name = "东瀛风物·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412022) ->
	#ets_goods_type{goods_id = 412022,goods_name = "东瀛华裳·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412023) ->
	#ets_goods_type{goods_id = 412023,goods_name = "东瀛雅韵·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412031) ->
	#ets_goods_type{goods_id = 412031,goods_name = "活力守护·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412032) ->
	#ets_goods_type{goods_id = 412032,goods_name = "活力战纪·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412033) ->
	#ets_goods_type{goods_id = 412033,goods_name = "活力热情·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412041) ->
	#ets_goods_type{goods_id = 412041,goods_name = "职场新秀·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412042) ->
	#ets_goods_type{goods_id = 412042,goods_name = "职场新星·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412043) ->
	#ets_goods_type{goods_id = 412043,goods_name = "职场精英·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412051) ->
	#ets_goods_type{goods_id = 412051,goods_name = "碳酸泡泡·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412052) ->
	#ets_goods_type{goods_id = 412052,goods_name = "碳酸炫舞·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412053) ->
	#ets_goods_type{goods_id = 412053,goods_name = "碳酸元气·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412061) ->
	#ets_goods_type{goods_id = 412061,goods_name = "甜蜜派对·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412062) ->
	#ets_goods_type{goods_id = 412062,goods_name = "潮流派对·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412063) ->
	#ets_goods_type{goods_id = 412063,goods_name = "青春派对·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412071) ->
	#ets_goods_type{goods_id = 412071,goods_name = "风雅锦绣·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412072) ->
	#ets_goods_type{goods_id = 412072,goods_name = "风雅天华·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412073) ->
	#ets_goods_type{goods_id = 412073,goods_name = "风雅幽韵·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412081) ->
	#ets_goods_type{goods_id = 412081,goods_name = "夏日海滩·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412082) ->
	#ets_goods_type{goods_id = 412082,goods_name = "夏日激情·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412083) ->
	#ets_goods_type{goods_id = 412083,goods_name = "夏日风情·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412091) ->
	#ets_goods_type{goods_id = 412091,goods_name = "高街镭射·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412092) ->
	#ets_goods_type{goods_id = 412092,goods_name = "波谱镭射·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412093) ->
	#ets_goods_type{goods_id = 412093,goods_name = "赤霞镭射·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412101) ->
	#ets_goods_type{goods_id = 412101,goods_name = "夜影枭歌·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412111) ->
	#ets_goods_type{goods_id = 412111,goods_name = "绝对制裁·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412121) ->
	#ets_goods_type{goods_id = 412121,goods_name = "国潮风尚·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412122) ->
	#ets_goods_type{goods_id = 412122,goods_name = "国潮庆典·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412123) ->
	#ets_goods_type{goods_id = 412123,goods_name = "国潮世代·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412131) ->
	#ets_goods_type{goods_id = 412131,goods_name = "纯白誓约·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412132) ->
	#ets_goods_type{goods_id = 412132,goods_name = "幻梦誓约·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412133) ->
	#ets_goods_type{goods_id = 412133,goods_name = "甜蜜誓约·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412141) ->
	#ets_goods_type{goods_id = 412141,goods_name = "暗黑龙裔·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412142) ->
	#ets_goods_type{goods_id = 412142,goods_name = "光耀龙裔·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412143) ->
	#ets_goods_type{goods_id = 412143,goods_name = "末世龙裔·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412151) ->
	#ets_goods_type{goods_id = 412151,goods_name = "风纪委员·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412152) ->
	#ets_goods_type{goods_id = 412152,goods_name = "文娱委员·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412153) ->
	#ets_goods_type{goods_id = 412153,goods_name = "监察委员·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412161) ->
	#ets_goods_type{goods_id = 412161,goods_name = "异域灵媒·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412162) ->
	#ets_goods_type{goods_id = 412162,goods_name = "炽火灵媒·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(412163) ->
	#ets_goods_type{goods_id = 412163,goods_name = "幽晶灵媒·发型",bind = 1,type = 12,subtype = 6,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,6)};
get(413000) ->
	#ets_goods_type{goods_id = 413000,goods_name = "头饰段",bind = 1,type = 12,subtype = 3,max_overlap = 99,use = 1,bag_location = loc(12,3)};
get(413001) ->
	#ets_goods_type{goods_id = 413001,goods_name = "颜文字",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413011) ->
	#ets_goods_type{goods_id = 413011,goods_name = "元气鼓舞",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413021) ->
	#ets_goods_type{goods_id = 413021,goods_name = "科技半环",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413031) ->
	#ets_goods_type{goods_id = 413031,goods_name = "外星飞船",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413041) ->
	#ets_goods_type{goods_id = 413041,goods_name = "灵皇冠冕",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413051) ->
	#ets_goods_type{goods_id = 413051,goods_name = "天使之证",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413061) ->
	#ets_goods_type{goods_id = 413061,goods_name = "萌宠海豹",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413071) ->
	#ets_goods_type{goods_id = 413071,goods_name = "神圣荆棘",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413081) ->
	#ets_goods_type{goods_id = 413081,goods_name = "兔耳音箱",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413091) ->
	#ets_goods_type{goods_id = 413091,goods_name = "竹蜻蜓",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413101) ->
	#ets_goods_type{goods_id = 413101,goods_name = "梦想咸鱼",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413111) ->
	#ets_goods_type{goods_id = 413111,goods_name = "圣诞颂歌",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413121) ->
	#ets_goods_type{goods_id = 413121,goods_name = "好奇宝宝",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413131) ->
	#ets_goods_type{goods_id = 413131,goods_name = "热带气泡",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413141) ->
	#ets_goods_type{goods_id = 413141,goods_name = "日月星云",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413151) ->
	#ets_goods_type{goods_id = 413151,goods_name = "纸飞机",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413161) ->
	#ets_goods_type{goods_id = 413161,goods_name = "和平圣冕",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413171) ->
	#ets_goods_type{goods_id = 413171,goods_name = "精灵末裔",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413181) ->
	#ets_goods_type{goods_id = 413181,goods_name = "熊猫嘟嘟",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(413191) ->
	#ets_goods_type{goods_id = 413191,goods_name = "幻音未来",bind = 1,type = 12,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,3)};
get(416000) ->
	#ets_goods_type{goods_id = 416000,goods_name = "背饰段",bind = 1,type = 12,subtype = 4,max_overlap = 99,use = 1,bag_location = loc(12,4)};
get(416001) ->
	#ets_goods_type{goods_id = 416001,goods_name = "牵缘之结",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416011) ->
	#ets_goods_type{goods_id = 416011,goods_name = "可爱小黄鸭",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416021) ->
	#ets_goods_type{goods_id = 416021,goods_name = "捕梦网",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416031) ->
	#ets_goods_type{goods_id = 416031,goods_name = "夜色霓虹",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416041) ->
	#ets_goods_type{goods_id = 416041,goods_name = "伞兵一号",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416051) ->
	#ets_goods_type{goods_id = 416051,goods_name = "百斩鬼面",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416061) ->
	#ets_goods_type{goods_id = 416061,goods_name = "圣诞颂歌",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416071) ->
	#ets_goods_type{goods_id = 416071,goods_name = "发条魔偶",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416081) ->
	#ets_goods_type{goods_id = 416081,goods_name = "朋克背包",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416091) ->
	#ets_goods_type{goods_id = 416091,goods_name = "飞天扫帚",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416101) ->
	#ets_goods_type{goods_id = 416101,goods_name = "彩色风车",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416111) ->
	#ets_goods_type{goods_id = 416111,goods_name = "魔龙幼崽",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416121) ->
	#ets_goods_type{goods_id = 416121,goods_name = "机动战队",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416131) ->
	#ets_goods_type{goods_id = 416131,goods_name = "机械蝴蝶",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416141) ->
	#ets_goods_type{goods_id = 416141,goods_name = "森林精灵",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416151) ->
	#ets_goods_type{goods_id = 416151,goods_name = "暗灵盾",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416161) ->
	#ets_goods_type{goods_id = 416161,goods_name = "国潮风尚",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416171) ->
	#ets_goods_type{goods_id = 416171,goods_name = "蒸汽面具",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416181) ->
	#ets_goods_type{goods_id = 416181,goods_name = "邪灵祭祀",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(416191) ->
	#ets_goods_type{goods_id = 416191,goods_name = "意志战旗",bind = 1,type = 12,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,4)};
get(418000) ->
	#ets_goods_type{goods_id = 418000,goods_name = "武器时装段",bind = 1,type = 12,subtype = 5,max_overlap = 99,use = 1,bag_location = loc(12,5)};
get(418011) ->
	#ets_goods_type{goods_id = 418011,goods_name = "深海洋流",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418021) ->
	#ets_goods_type{goods_id = 418021,goods_name = "电音声浪",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418031) ->
	#ets_goods_type{goods_id = 418031,goods_name = "朋克街头",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418041) ->
	#ets_goods_type{goods_id = 418041,goods_name = "医疗先锋",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418051) ->
	#ets_goods_type{goods_id = 418051,goods_name = "沙漠探险",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418061) ->
	#ets_goods_type{goods_id = 418061,goods_name = "离子科技",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418071) ->
	#ets_goods_type{goods_id = 418071,goods_name = "西瓜雪冰",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418081) ->
	#ets_goods_type{goods_id = 418081,goods_name = "血色蔷薇",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418091) ->
	#ets_goods_type{goods_id = 418091,goods_name = "雨过天晴",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(418101) ->
	#ets_goods_type{goods_id = 418101,goods_name = "盛典餐具",bind = 1,type = 12,subtype = 5,max_overlap = 99,color = 4,use = 1,bag_location = loc(12,5)};
get(419000) ->
	#ets_goods_type{goods_id = 419000,goods_name = "时装体验卡段",bind = 1,type = 12,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(12,1)};
get(419001) ->
	#ets_goods_type{goods_id = 419001,goods_name = "服饰1体验卡",bind = 1,type = 12,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,1)};
get(419002) ->
	#ets_goods_type{goods_id = 419002,goods_name = "服饰1体验卡",bind = 1,type = 12,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,1)};
get(419003) ->
	#ets_goods_type{goods_id = 419003,goods_name = "服饰2体验卡",bind = 1,type = 12,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,1)};
get(420000) ->
	#ets_goods_type{goods_id = 420000,goods_name = "头像外框段",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(13,1)};
get(420001) ->
	#ets_goods_type{goods_id = 420001,goods_name = "源像框",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(13,1)};
get(420002) ->
	#ets_goods_type{goods_id = 420002,goods_name = "尊贵用户",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(13,1)};
get(420003) ->
	#ets_goods_type{goods_id = 420003,goods_name = "落樱季",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420004) ->
	#ets_goods_type{goods_id = 420004,goods_name = "黑白漫画",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420005) ->
	#ets_goods_type{goods_id = 420005,goods_name = "冰雪盛典",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420006) ->
	#ets_goods_type{goods_id = 420006,goods_name = "超级英雄",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420007) ->
	#ets_goods_type{goods_id = 420007,goods_name = "炫彩电音",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420008) ->
	#ets_goods_type{goods_id = 420008,goods_name = "钱不是问题",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420009) ->
	#ets_goods_type{goods_id = 420009,goods_name = "锦鲤跃空",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420010) ->
	#ets_goods_type{goods_id = 420010,goods_name = "萌宠柯基",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420011) ->
	#ets_goods_type{goods_id = 420011,goods_name = "冰与火之歌",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420012) ->
	#ets_goods_type{goods_id = 420012,goods_name = "这不是绵羊",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420013) ->
	#ets_goods_type{goods_id = 420013,goods_name = "清凉夏日",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420014) ->
	#ets_goods_type{goods_id = 420014,goods_name = "未来战士",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420015) ->
	#ets_goods_type{goods_id = 420015,goods_name = "唱跳RAP",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420016) ->
	#ets_goods_type{goods_id = 420016,goods_name = "燃烧炸裂",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420017) ->
	#ets_goods_type{goods_id = 420017,goods_name = "年度纪念",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(420018) ->
	#ets_goods_type{goods_id = 420018,goods_name = "荣耀勋章",bind = 1,type = 13,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(13,1)};
get(422500) ->
	#ets_goods_type{goods_id = 422500,goods_name = "鬼猎",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422501) ->
	#ets_goods_type{goods_id = 422501,goods_name = "猛鬼猎",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422502) ->
	#ets_goods_type{goods_id = 422502,goods_name = "传说鬼猎",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422503) ->
	#ets_goods_type{goods_id = 422503,goods_name = "三转鬼猎",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422504) ->
	#ets_goods_type{goods_id = 422504,goods_name = "四转鬼猎",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422505) ->
	#ets_goods_type{goods_id = 422505,goods_name = "五转鬼猎",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422510) ->
	#ets_goods_type{goods_id = 422510,goods_name = "夙星",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422511) ->
	#ets_goods_type{goods_id = 422511,goods_name = "天夙星",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422512) ->
	#ets_goods_type{goods_id = 422512,goods_name = "传说夙星",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422513) ->
	#ets_goods_type{goods_id = 422513,goods_name = "三转夙星",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422514) ->
	#ets_goods_type{goods_id = 422514,goods_name = "四转夙星",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422515) ->
	#ets_goods_type{goods_id = 422515,goods_name = "五转夙星",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422520) ->
	#ets_goods_type{goods_id = 422520,goods_name = "暗鸦",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422521) ->
	#ets_goods_type{goods_id = 422521,goods_name = "地暗鸦",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422522) ->
	#ets_goods_type{goods_id = 422522,goods_name = "传说暗鸦",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422523) ->
	#ets_goods_type{goods_id = 422523,goods_name = "三转暗鸦",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422524) ->
	#ets_goods_type{goods_id = 422524,goods_name = "四转暗鸦",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422525) ->
	#ets_goods_type{goods_id = 422525,goods_name = "五转暗鸦",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422530) ->
	#ets_goods_type{goods_id = 422530,goods_name = "梦枭",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422531) ->
	#ets_goods_type{goods_id = 422531,goods_name = "幻梦枭",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422532) ->
	#ets_goods_type{goods_id = 422532,goods_name = "传说梦枭",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422533) ->
	#ets_goods_type{goods_id = 422533,goods_name = "三转梦枭",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422534) ->
	#ets_goods_type{goods_id = 422534,goods_name = "四转梦枭",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(422535) ->
	#ets_goods_type{goods_id = 422535,goods_name = "五转梦枭",bind = 1,type = 14,subtype = 1,max_overlap = 99,color = 3,bag_location = loc(14,1)};
get(423000) ->
	#ets_goods_type{goods_id = 423000,goods_name = "性别头像",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423001) ->
	#ets_goods_type{goods_id = 423001,goods_name = "军礼服",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423002) ->
	#ets_goods_type{goods_id = 423002,goods_name = "军礼服",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423011) ->
	#ets_goods_type{goods_id = 423011,goods_name = "冒险者",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423012) ->
	#ets_goods_type{goods_id = 423012,goods_name = "冒险者",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423021) ->
	#ets_goods_type{goods_id = 423021,goods_name = "异瞳反派",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423022) ->
	#ets_goods_type{goods_id = 423022,goods_name = "异瞳反派",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423031) ->
	#ets_goods_type{goods_id = 423031,goods_name = "异乡人",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423032) ->
	#ets_goods_type{goods_id = 423032,goods_name = "异乡人",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423041) ->
	#ets_goods_type{goods_id = 423041,goods_name = "赛博朋克",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423042) ->
	#ets_goods_type{goods_id = 423042,goods_name = "赛博朋克",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423051) ->
	#ets_goods_type{goods_id = 423051,goods_name = "清爽夏日",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423052) ->
	#ets_goods_type{goods_id = 423052,goods_name = "清爽夏日",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423061) ->
	#ets_goods_type{goods_id = 423061,goods_name = "神秘人",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423062) ->
	#ets_goods_type{goods_id = 423062,goods_name = "神秘人",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423071) ->
	#ets_goods_type{goods_id = 423071,goods_name = "邪魅狂狷",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(423072) ->
	#ets_goods_type{goods_id = 423072,goods_name = "邪魅狂狷",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(424000) ->
	#ets_goods_type{goods_id = 424000,goods_name = "通用头像",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(14,2)};
get(424001) ->
	#ets_goods_type{goods_id = 424001,goods_name = "玻璃撞脸",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424002) ->
	#ets_goods_type{goods_id = 424002,goods_name = "蠢萌熊猫",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424003) ->
	#ets_goods_type{goods_id = 424003,goods_name = "缝合玩偶",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424004) ->
	#ets_goods_type{goods_id = 424004,goods_name = "卡通骷髅",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424005) ->
	#ets_goods_type{goods_id = 424005,goods_name = "喵武士",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424006) ->
	#ets_goods_type{goods_id = 424006,goods_name = "朋克死神",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424007) ->
	#ets_goods_type{goods_id = 424007,goods_name = "七彩爆炸头",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424008) ->
	#ets_goods_type{goods_id = 424008,goods_name = "智能机甲",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424009) ->
	#ets_goods_type{goods_id = 424009,goods_name = "邪眸魔童",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(424010) ->
	#ets_goods_type{goods_id = 424010,goods_name = "日光柴犬",bind = 1,type = 14,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(14,2)};
get(425000) ->
	#ets_goods_type{goods_id = 425000,goods_name = "聊天气泡段",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,bag_location = loc(15,1)};
get(425001) ->
	#ets_goods_type{goods_id = 425001,goods_name = "源气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425002) ->
	#ets_goods_type{goods_id = 425002,goods_name = "尊贵用户·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(15,1)};
get(425003) ->
	#ets_goods_type{goods_id = 425003,goods_name = "落樱季·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425004) ->
	#ets_goods_type{goods_id = 425004,goods_name = "黑白漫画·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425005) ->
	#ets_goods_type{goods_id = 425005,goods_name = "冰雪盛典·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425006) ->
	#ets_goods_type{goods_id = 425006,goods_name = "超级英雄·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425007) ->
	#ets_goods_type{goods_id = 425007,goods_name = "炫彩电音·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425008) ->
	#ets_goods_type{goods_id = 425008,goods_name = "钱不是问题·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425009) ->
	#ets_goods_type{goods_id = 425009,goods_name = "飞天锦鲤·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425010) ->
	#ets_goods_type{goods_id = 425010,goods_name = "萌宠柯基·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425011) ->
	#ets_goods_type{goods_id = 425011,goods_name = "冰与火之歌·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425012) ->
	#ets_goods_type{goods_id = 425012,goods_name = "这不是绵羊·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425013) ->
	#ets_goods_type{goods_id = 425013,goods_name = "清凉夏日·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425014) ->
	#ets_goods_type{goods_id = 425014,goods_name = "飞向宇宙·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425015) ->
	#ets_goods_type{goods_id = 425015,goods_name = "坐看云起·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425016) ->
	#ets_goods_type{goods_id = 425016,goods_name = "千里相思·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425017) ->
	#ets_goods_type{goods_id = 425017,goods_name = "奔月科技·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(425018) ->
	#ets_goods_type{goods_id = 425018,goods_name = "春暖花开·气泡",bind = 1,type = 15,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(15,1)};
get(427500) ->
	#ets_goods_type{goods_id = 427500,goods_name = "聊天背景段",bind = 1,type = 16,subtype = 1,max_overlap = 9999,bag_location = loc(16,1)};
get(430000) ->
	#ets_goods_type{goods_id = 430000,goods_name = "称号道具段",bind = 1,type = 17,subtype = 1,max_overlap = 9999,bag_location = loc(17,1)};
get(430001) ->
	#ets_goods_type{goods_id = 430001,goods_name = "小白驾到",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(430002) ->
	#ets_goods_type{goods_id = 430002,goods_name = "冉冉升起",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430003) ->
	#ets_goods_type{goods_id = 430003,goods_name = "闪耀新星",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430004) ->
	#ets_goods_type{goods_id = 430004,goods_name = "认证高玩",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430005) ->
	#ets_goods_type{goods_id = 430005,goods_name = "资深达人",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430006) ->
	#ets_goods_type{goods_id = 430006,goods_name = "核心精英",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430007) ->
	#ets_goods_type{goods_id = 430007,goods_name = "大佬现身",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430008) ->
	#ets_goods_type{goods_id = 430008,goods_name = "光耀之子",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430009) ->
	#ets_goods_type{goods_id = 430009,goods_name = "无双翘楚",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430010) ->
	#ets_goods_type{goods_id = 430010,goods_name = "通关·独孤求败",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430011) ->
	#ets_goods_type{goods_id = 430011,goods_name = "回廊·启程",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(430012) ->
	#ets_goods_type{goods_id = 430012,goods_name = "回廊·初探",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(430013) ->
	#ets_goods_type{goods_id = 430013,goods_name = "回廊·萌新",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(430014) ->
	#ets_goods_type{goods_id = 430014,goods_name = "回廊·曲折",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(430015) ->
	#ets_goods_type{goods_id = 430015,goods_name = "回廊·风雨",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(430016) ->
	#ets_goods_type{goods_id = 430016,goods_name = "回廊·求索",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(430017) ->
	#ets_goods_type{goods_id = 430017,goods_name = "回廊·争夺",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430018) ->
	#ets_goods_type{goods_id = 430018,goods_name = "回廊·前行",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430019) ->
	#ets_goods_type{goods_id = 430019,goods_name = "回廊·跋涉",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430020) ->
	#ets_goods_type{goods_id = 430020,goods_name = "回廊·无畏",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430021) ->
	#ets_goods_type{goods_id = 430021,goods_name = "回廊·磨砺",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430022) ->
	#ets_goods_type{goods_id = 430022,goods_name = "回廊·探索",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430023) ->
	#ets_goods_type{goods_id = 430023,goods_name = "回廊·远眺",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(430024) ->
	#ets_goods_type{goods_id = 430024,goods_name = "回廊·历程",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430025) ->
	#ets_goods_type{goods_id = 430025,goods_name = "回廊·信念",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430026) ->
	#ets_goods_type{goods_id = 430026,goods_name = "回廊·回首",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430027) ->
	#ets_goods_type{goods_id = 430027,goods_name = "回廊·追梦",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430028) ->
	#ets_goods_type{goods_id = 430028,goods_name = "回廊·起飞",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430029) ->
	#ets_goods_type{goods_id = 430029,goods_name = "回廊·升腾",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430030) ->
	#ets_goods_type{goods_id = 430030,goods_name = "回廊·登顶",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430031) ->
	#ets_goods_type{goods_id = 430031,goods_name = "回廊·俯瞰",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430032) ->
	#ets_goods_type{goods_id = 430032,goods_name = "回廊·天际",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430033) ->
	#ets_goods_type{goods_id = 430033,goods_name = "回廊·圆满",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430034) ->
	#ets_goods_type{goods_id = 430034,goods_name = "回廊·无尽",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430035) ->
	#ets_goods_type{goods_id = 430035,goods_name = "无尽·启程",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430036) ->
	#ets_goods_type{goods_id = 430036,goods_name = "无尽·初探",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430037) ->
	#ets_goods_type{goods_id = 430037,goods_name = "无尽·萌新",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430038) ->
	#ets_goods_type{goods_id = 430038,goods_name = "无尽·曲折",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430039) ->
	#ets_goods_type{goods_id = 430039,goods_name = "无尽·风雨",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430040) ->
	#ets_goods_type{goods_id = 430040,goods_name = "无尽·求索",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430041) ->
	#ets_goods_type{goods_id = 430041,goods_name = "无尽·争夺",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430042) ->
	#ets_goods_type{goods_id = 430042,goods_name = "无尽·前行",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430043) ->
	#ets_goods_type{goods_id = 430043,goods_name = "无尽·跋涉",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430044) ->
	#ets_goods_type{goods_id = 430044,goods_name = "无尽·无畏",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430045) ->
	#ets_goods_type{goods_id = 430045,goods_name = "无尽·磨砺",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430046) ->
	#ets_goods_type{goods_id = 430046,goods_name = "无尽·探索",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430047) ->
	#ets_goods_type{goods_id = 430047,goods_name = "无尽·远眺",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430048) ->
	#ets_goods_type{goods_id = 430048,goods_name = "无尽·历程",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430049) ->
	#ets_goods_type{goods_id = 430049,goods_name = "无尽·信念",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430050) ->
	#ets_goods_type{goods_id = 430050,goods_name = "无尽·回首",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430051) ->
	#ets_goods_type{goods_id = 430051,goods_name = "无尽·追梦",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430052) ->
	#ets_goods_type{goods_id = 430052,goods_name = "无尽·起飞",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430053) ->
	#ets_goods_type{goods_id = 430053,goods_name = "无尽·升腾",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430054) ->
	#ets_goods_type{goods_id = 430054,goods_name = "无尽·登顶",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430055) ->
	#ets_goods_type{goods_id = 430055,goods_name = "无尽·俯瞰",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430056) ->
	#ets_goods_type{goods_id = 430056,goods_name = "无尽·天际",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430057) ->
	#ets_goods_type{goods_id = 430057,goods_name = "无尽·圆满",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430058) ->
	#ets_goods_type{goods_id = 430058,goods_name = "无尽·究极",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,1)};
get(430101) ->
	#ets_goods_type{goods_id = 430101,goods_name = "深度觉醒",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430102) ->
	#ets_goods_type{goods_id = 430102,goods_name = "异能觉醒",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430103) ->
	#ets_goods_type{goods_id = 430103,goods_name = "护送之星",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,1)};
get(430104) ->
	#ets_goods_type{goods_id = 430104,goods_name = "天赋血脉",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,2)};
get(431000) ->
	#ets_goods_type{goods_id = 431000,goods_name = "声名远扬",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,2)};
get(431001) ->
	#ets_goods_type{goods_id = 431001,goods_name = "精明之眼",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,2)};
get(431002) ->
	#ets_goods_type{goods_id = 431002,goods_name = "小有成就",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,2)};
get(431003) ->
	#ets_goods_type{goods_id = 431003,goods_name = "成功人士",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,2)};
get(431004) ->
	#ets_goods_type{goods_id = 431004,goods_name = "社会精英",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(431005) ->
	#ets_goods_type{goods_id = 431005,goods_name = "无尽领主",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(431006) ->
	#ets_goods_type{goods_id = 431006,goods_name = "至尊宠物家",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(431007) ->
	#ets_goods_type{goods_id = 431007,goods_name = "高贵宠物家",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,3)};
get(431008) ->
	#ets_goods_type{goods_id = 431008,goods_name = "优秀宠物家",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,3)};
get(432001) ->
	#ets_goods_type{goods_id = 432001,goods_name = "地表最强·团长",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432002) ->
	#ets_goods_type{goods_id = 432002,goods_name = "地表最强·成员",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,3)};
get(432003) ->
	#ets_goods_type{goods_id = 432003,goods_name = "派对之星",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432004) ->
	#ets_goods_type{goods_id = 432004,goods_name = "第一社团",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,3)};
get(432005) ->
	#ets_goods_type{goods_id = 432005,goods_name = "第二社团",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,3)};
get(432006) ->
	#ets_goods_type{goods_id = 432006,goods_name = "第三社团",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,3)};
get(432007) ->
	#ets_goods_type{goods_id = 432007,goods_name = "十大恶人",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,3)};
get(432008) ->
	#ets_goods_type{goods_id = 432008,goods_name = "第一恶人",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432009) ->
	#ets_goods_type{goods_id = 432009,goods_name = "第二恶人",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432010) ->
	#ets_goods_type{goods_id = 432010,goods_name = "第三恶人",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,3)};
get(432011) ->
	#ets_goods_type{goods_id = 432011,goods_name = "大佬别打我",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,3)};
get(432012) ->
	#ets_goods_type{goods_id = 432012,goods_name = "单排王者",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,3)};
get(432013) ->
	#ets_goods_type{goods_id = 432013,goods_name = "单排大师",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,3)};
get(432014) ->
	#ets_goods_type{goods_id = 432014,goods_name = "金钱的香气",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,3)};
get(432015) ->
	#ets_goods_type{goods_id = 432015,goods_name = "圣城城主",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,3)};
get(432016) ->
	#ets_goods_type{goods_id = 432016,goods_name = "卫城领主",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432017) ->
	#ets_goods_type{goods_id = 432017,goods_name = "圣城居民",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432018) ->
	#ets_goods_type{goods_id = 432018,goods_name = "幸运之子",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432019) ->
	#ets_goods_type{goods_id = 432019,goods_name = "天降正义",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432020) ->
	#ets_goods_type{goods_id = 432020,goods_name = "一掷千金",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432021) ->
	#ets_goods_type{goods_id = 432021,goods_name = "龙裔使徒",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432022) ->
	#ets_goods_type{goods_id = 432022,goods_name = "正义的伙伴",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432023) ->
	#ets_goods_type{goods_id = 432023,goods_name = "前方高能",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432024) ->
	#ets_goods_type{goods_id = 432024,goods_name = "招招致命",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432025) ->
	#ets_goods_type{goods_id = 432025,goods_name = "黄金王冠",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432026) ->
	#ets_goods_type{goods_id = 432026,goods_name = "屠龙勇士",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432027) ->
	#ets_goods_type{goods_id = 432027,goods_name = "原地起飞",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432028) ->
	#ets_goods_type{goods_id = 432028,goods_name = "飞龙在天",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432029) ->
	#ets_goods_type{goods_id = 432029,goods_name = "我有小钱钱",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432030) ->
	#ets_goods_type{goods_id = 432030,goods_name = "护花使者",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432031) ->
	#ets_goods_type{goods_id = 432031,goods_name = "交个朋友",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432032) ->
	#ets_goods_type{goods_id = 432032,goods_name = "暗灭龙皇",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432033) ->
	#ets_goods_type{goods_id = 432033,goods_name = "我太好看了",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432034) ->
	#ets_goods_type{goods_id = 432034,goods_name = "跟我摇摆",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432035) ->
	#ets_goods_type{goods_id = 432035,goods_name = "人见人爱",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432036) ->
	#ets_goods_type{goods_id = 432036,goods_name = "正道的光",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(432037) ->
	#ets_goods_type{goods_id = 432037,goods_name = "超级能吃",bind = 1,type = 17,subtype = 3,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,3)};
get(433000) ->
	#ets_goods_type{goods_id = 433000,goods_name = "风驰电掣",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433001) ->
	#ets_goods_type{goods_id = 433001,goods_name = "翼飞冲天",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433002) ->
	#ets_goods_type{goods_id = 433002,goods_name = "绝世神兵",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433003) ->
	#ets_goods_type{goods_id = 433003,goods_name = "S级宝具",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433004) ->
	#ets_goods_type{goods_id = 433004,goods_name = "最强AI",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433005) ->
	#ets_goods_type{goods_id = 433005,goods_name = "移动炮台",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433006) ->
	#ets_goods_type{goods_id = 433006,goods_name = "战争堡垒",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433007) ->
	#ets_goods_type{goods_id = 433007,goods_name = "闪耀星翼",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433008) ->
	#ets_goods_type{goods_id = 433008,goods_name = "闪光的大佬",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433009) ->
	#ets_goods_type{goods_id = 433009,goods_name = "尊贵的一哥",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 6,use = 1,bag_location = loc(17,4)};
get(433010) ->
	#ets_goods_type{goods_id = 433010,goods_name = "超炫的总裁",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 6,use = 1,bag_location = loc(17,4)};
get(433011) ->
	#ets_goods_type{goods_id = 433011,goods_name = "跪下叫霸霸",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 6,use = 1,bag_location = loc(17,4)};
get(433012) ->
	#ets_goods_type{goods_id = 433012,goods_name = "战力·全服制霸",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,4)};
get(433013) ->
	#ets_goods_type{goods_id = 433013,goods_name = "等级·全服制霸",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,4)};
get(433017) ->
	#ets_goods_type{goods_id = 433017,goods_name = "耀钻霸主",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433018) ->
	#ets_goods_type{goods_id = 433018,goods_name = "耀钻英杰",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433019) ->
	#ets_goods_type{goods_id = 433019,goods_name = "耀钻先锋",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433025) ->
	#ets_goods_type{goods_id = 433025,goods_name = "世界第一美",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433026) ->
	#ets_goods_type{goods_id = 433026,goods_name = "世界第二美",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,4)};
get(433027) ->
	#ets_goods_type{goods_id = 433027,goods_name = "靓丽四强",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,4)};
get(433028) ->
	#ets_goods_type{goods_id = 433028,goods_name = "靓丽八强",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 4,use = 1,bag_location = loc(17,4)};
get(433029) ->
	#ets_goods_type{goods_id = 433029,goods_name = "靓丽十六强",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,4)};
get(433030) ->
	#ets_goods_type{goods_id = 433030,goods_name = "战神降临",bind = 1,type = 17,subtype = 4,max_overlap = 1,color = 5,use = 1,bag_location = loc(17,4)};
get(433031) ->
	#ets_goods_type{goods_id = 433031,goods_name = "首席·执政官",bind = 1,type = 17,subtype = 3,max_overlap = 1,color = 5,use = 1,bag_location = loc(17,3)};
get(433032) ->
	#ets_goods_type{goods_id = 433032,goods_name = "战斗·指挥官",bind = 1,type = 17,subtype = 3,max_overlap = 1,color = 5,use = 1,bag_location = loc(17,3)};
get(433098) ->
	#ets_goods_type{goods_id = 433098,goods_name = "红装闪耀",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(433099) ->
	#ets_goods_type{goods_id = 433099,goods_name = "无敌战魂",bind = 1,type = 17,subtype = 4,max_overlap = 99,color = 5,use = 1,bag_location = loc(17,4)};
get(434001) ->
	#ets_goods_type{goods_id = 434001,goods_name = "一代绿装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(434002) ->
	#ets_goods_type{goods_id = 434002,goods_name = "一代蓝装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(434003) ->
	#ets_goods_type{goods_id = 434003,goods_name = "一代紫装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(434004) ->
	#ets_goods_type{goods_id = 434004,goods_name = "一代橙装",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,2)};
get(434005) ->
	#ets_goods_type{goods_id = 434005,goods_name = "二代蓝装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(434006) ->
	#ets_goods_type{goods_id = 434006,goods_name = "二代紫装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(434007) ->
	#ets_goods_type{goods_id = 434007,goods_name = "二代橙装",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,2)};
get(434008) ->
	#ets_goods_type{goods_id = 434008,goods_name = "三代蓝装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(434009) ->
	#ets_goods_type{goods_id = 434009,goods_name = "三代紫装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(434010) ->
	#ets_goods_type{goods_id = 434010,goods_name = "三代橙装",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,2)};
get(434011) ->
	#ets_goods_type{goods_id = 434011,goods_name = "四代蓝装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(434012) ->
	#ets_goods_type{goods_id = 434012,goods_name = "四代紫装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(434013) ->
	#ets_goods_type{goods_id = 434013,goods_name = "四代橙装",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,2)};
get(434014) ->
	#ets_goods_type{goods_id = 434014,goods_name = "五代蓝装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(434015) ->
	#ets_goods_type{goods_id = 434015,goods_name = "五代紫装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(434016) ->
	#ets_goods_type{goods_id = 434016,goods_name = "五代橙装",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,2)};
get(434017) ->
	#ets_goods_type{goods_id = 434017,goods_name = "六代蓝装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 2,use = 1,bag_location = loc(17,1)};
get(434018) ->
	#ets_goods_type{goods_id = 434018,goods_name = "六代紫装",bind = 1,type = 17,subtype = 1,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,1)};
get(434019) ->
	#ets_goods_type{goods_id = 434019,goods_name = "六代橙装",bind = 1,type = 17,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(17,2)};
get(439001) ->
	#ets_goods_type{goods_id = 439001,goods_name = "羁绊称号占用",bind = 1,type = 17,subtype = 5,max_overlap = 1,color = 3,use = 1,bag_location = loc(17,5)};
get(439002) ->
	#ets_goods_type{goods_id = 439002,goods_name = "羁绊称号占用",bind = 1,type = 17,subtype = 5,max_overlap = 1,color = 3,use = 1,bag_location = loc(17,5)};
get(439003) ->
	#ets_goods_type{goods_id = 439003,goods_name = "羁绊称号占用",bind = 1,type = 17,subtype = 5,max_overlap = 1,color = 3,use = 1,bag_location = loc(17,5)};
get(439004) ->
	#ets_goods_type{goods_id = 439004,goods_name = "羁绊称号占用",bind = 1,type = 17,subtype = 99,max_overlap = 1,color = 3,use = 1,bag_location = loc(17,99)};
get(440000) ->
	#ets_goods_type{goods_id = 440000,goods_name = "服饰外观碎片段",bind = 1,type = 18,subtype = 1,max_overlap = 9999,bag_location = loc(18,1)};
get(440001) ->
	#ets_goods_type{goods_id = 440001,goods_name = "赛博骇客·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440002) ->
	#ets_goods_type{goods_id = 440002,goods_name = "赛博幽客·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440003) ->
	#ets_goods_type{goods_id = 440003,goods_name = "赛博心灵·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440011) ->
	#ets_goods_type{goods_id = 440011,goods_name = "酷萌朋克·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440012) ->
	#ets_goods_type{goods_id = 440012,goods_name = "幽影朋克·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440013) ->
	#ets_goods_type{goods_id = 440013,goods_name = "潮流朋克·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440021) ->
	#ets_goods_type{goods_id = 440021,goods_name = "东瀛风物·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440022) ->
	#ets_goods_type{goods_id = 440022,goods_name = "东瀛华裳·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440023) ->
	#ets_goods_type{goods_id = 440023,goods_name = "东瀛雅韵·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440031) ->
	#ets_goods_type{goods_id = 440031,goods_name = "活力守护·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440032) ->
	#ets_goods_type{goods_id = 440032,goods_name = "活力战纪·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440033) ->
	#ets_goods_type{goods_id = 440033,goods_name = "活力热情·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440041) ->
	#ets_goods_type{goods_id = 440041,goods_name = "职场新秀·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440042) ->
	#ets_goods_type{goods_id = 440042,goods_name = "职场新星·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440043) ->
	#ets_goods_type{goods_id = 440043,goods_name = "职场精英·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440051) ->
	#ets_goods_type{goods_id = 440051,goods_name = "碳酸泡泡·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440052) ->
	#ets_goods_type{goods_id = 440052,goods_name = "碳酸炫舞·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440053) ->
	#ets_goods_type{goods_id = 440053,goods_name = "碳酸元气·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440061) ->
	#ets_goods_type{goods_id = 440061,goods_name = "甜蜜派对·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440062) ->
	#ets_goods_type{goods_id = 440062,goods_name = "潮流派对·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440063) ->
	#ets_goods_type{goods_id = 440063,goods_name = "青春派对·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440071) ->
	#ets_goods_type{goods_id = 440071,goods_name = "风雅锦绣·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440072) ->
	#ets_goods_type{goods_id = 440072,goods_name = "风雅天华·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440073) ->
	#ets_goods_type{goods_id = 440073,goods_name = "风雅幽韵·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440081) ->
	#ets_goods_type{goods_id = 440081,goods_name = "夏日海滩·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440082) ->
	#ets_goods_type{goods_id = 440082,goods_name = "夏日热浪·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440083) ->
	#ets_goods_type{goods_id = 440083,goods_name = "夏日风情·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(440091) ->
	#ets_goods_type{goods_id = 440091,goods_name = "高街镭射·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440092) ->
	#ets_goods_type{goods_id = 440092,goods_name = "波谱镭射·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440093) ->
	#ets_goods_type{goods_id = 440093,goods_name = "赤霞镭射·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440101) ->
	#ets_goods_type{goods_id = 440101,goods_name = "夜影枭歌·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440111) ->
	#ets_goods_type{goods_id = 440111,goods_name = "绝对制裁·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440121) ->
	#ets_goods_type{goods_id = 440121,goods_name = "国潮风尚·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440122) ->
	#ets_goods_type{goods_id = 440122,goods_name = "国潮庆典·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440123) ->
	#ets_goods_type{goods_id = 440123,goods_name = "国潮世代·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440131) ->
	#ets_goods_type{goods_id = 440131,goods_name = "纯白誓约·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440132) ->
	#ets_goods_type{goods_id = 440132,goods_name = "幻梦誓约·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440133) ->
	#ets_goods_type{goods_id = 440133,goods_name = "甜蜜誓约·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440141) ->
	#ets_goods_type{goods_id = 440141,goods_name = "暗黑龙裔·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440142) ->
	#ets_goods_type{goods_id = 440142,goods_name = "光耀龙裔·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440143) ->
	#ets_goods_type{goods_id = 440143,goods_name = "末世龙裔·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440151) ->
	#ets_goods_type{goods_id = 440151,goods_name = "风纪委员·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440152) ->
	#ets_goods_type{goods_id = 440152,goods_name = "文娱委员·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440153) ->
	#ets_goods_type{goods_id = 440153,goods_name = "监察委员·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440161) ->
	#ets_goods_type{goods_id = 440161,goods_name = "异域灵媒·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440162) ->
	#ets_goods_type{goods_id = 440162,goods_name = "炽火灵媒·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(440163) ->
	#ets_goods_type{goods_id = 440163,goods_name = "幽晶灵媒·碎片",bind = 1,type = 12,subtype = 2,max_overlap = 99,color = 3,use = 1,bag_location = loc(12,2)};
get(442000) ->
	#ets_goods_type{goods_id = 442000,goods_name = "发型段",bind = 1,type = 18,subtype = 1,max_overlap = 999,use = 1,bag_location = loc(18,1)};
get(442001) ->
	#ets_goods_type{goods_id = 442001,goods_name = "赛博骇客·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442002) ->
	#ets_goods_type{goods_id = 442002,goods_name = "赛博幽客·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442003) ->
	#ets_goods_type{goods_id = 442003,goods_name = "赛博心灵·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442011) ->
	#ets_goods_type{goods_id = 442011,goods_name = "酷萌朋克·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442012) ->
	#ets_goods_type{goods_id = 442012,goods_name = "幽影朋克·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442013) ->
	#ets_goods_type{goods_id = 442013,goods_name = "潮流朋克·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442021) ->
	#ets_goods_type{goods_id = 442021,goods_name = "东瀛风物·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442022) ->
	#ets_goods_type{goods_id = 442022,goods_name = "东瀛华裳·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442023) ->
	#ets_goods_type{goods_id = 442023,goods_name = "东瀛雅韵·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442031) ->
	#ets_goods_type{goods_id = 442031,goods_name = "活力守护·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442032) ->
	#ets_goods_type{goods_id = 442032,goods_name = "活力战纪·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442033) ->
	#ets_goods_type{goods_id = 442033,goods_name = "活力热情·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442041) ->
	#ets_goods_type{goods_id = 442041,goods_name = "职场新秀·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442042) ->
	#ets_goods_type{goods_id = 442042,goods_name = "职场新星·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442043) ->
	#ets_goods_type{goods_id = 442043,goods_name = "职场精英·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442051) ->
	#ets_goods_type{goods_id = 442051,goods_name = "碳酸泡泡·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442052) ->
	#ets_goods_type{goods_id = 442052,goods_name = "碳酸炫舞·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442053) ->
	#ets_goods_type{goods_id = 442053,goods_name = "碳酸元气·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442061) ->
	#ets_goods_type{goods_id = 442061,goods_name = "甜蜜派对·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442062) ->
	#ets_goods_type{goods_id = 442062,goods_name = "潮流派对·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442063) ->
	#ets_goods_type{goods_id = 442063,goods_name = "青春派对·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442071) ->
	#ets_goods_type{goods_id = 442071,goods_name = "风雅锦绣·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442072) ->
	#ets_goods_type{goods_id = 442072,goods_name = "风雅天华·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442073) ->
	#ets_goods_type{goods_id = 442073,goods_name = "风雅幽韵·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442081) ->
	#ets_goods_type{goods_id = 442081,goods_name = "夏日海滩·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442082) ->
	#ets_goods_type{goods_id = 442082,goods_name = "夏日激情·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442083) ->
	#ets_goods_type{goods_id = 442083,goods_name = "夏日风情·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(442091) ->
	#ets_goods_type{goods_id = 442091,goods_name = "高街镭射·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442092) ->
	#ets_goods_type{goods_id = 442092,goods_name = "波谱镭射·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442093) ->
	#ets_goods_type{goods_id = 442093,goods_name = "赤霞镭射·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442101) ->
	#ets_goods_type{goods_id = 442101,goods_name = "夜影枭歌·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442111) ->
	#ets_goods_type{goods_id = 442111,goods_name = "绝对制裁·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442121) ->
	#ets_goods_type{goods_id = 442121,goods_name = "国潮风尚·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442122) ->
	#ets_goods_type{goods_id = 442122,goods_name = "国潮庆典·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442123) ->
	#ets_goods_type{goods_id = 442123,goods_name = "国潮世代·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442131) ->
	#ets_goods_type{goods_id = 442131,goods_name = "纯白誓约·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442132) ->
	#ets_goods_type{goods_id = 442132,goods_name = "幻梦誓约·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442133) ->
	#ets_goods_type{goods_id = 442133,goods_name = "甜蜜誓约·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442141) ->
	#ets_goods_type{goods_id = 442141,goods_name = "暗黑龙裔·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442142) ->
	#ets_goods_type{goods_id = 442142,goods_name = "光耀龙裔·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442143) ->
	#ets_goods_type{goods_id = 442143,goods_name = "末世龙裔·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442151) ->
	#ets_goods_type{goods_id = 442151,goods_name = "风纪委员·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442152) ->
	#ets_goods_type{goods_id = 442152,goods_name = "文娱委员·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442153) ->
	#ets_goods_type{goods_id = 442153,goods_name = "监察委员·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442161) ->
	#ets_goods_type{goods_id = 442161,goods_name = "异域灵媒·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442162) ->
	#ets_goods_type{goods_id = 442162,goods_name = "炽火灵媒·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(442163) ->
	#ets_goods_type{goods_id = 442163,goods_name = "幽晶灵媒·碎片",bind = 1,type = 12,subtype = 6,max_overlap = 999,color = 3,use = 1,bag_location = loc(12,6)};
get(443000) ->
	#ets_goods_type{goods_id = 443000,goods_name = "头饰段·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,use = 1,bag_location = loc(18,1)};
get(443001) ->
	#ets_goods_type{goods_id = 443001,goods_name = "颜文字·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443011) ->
	#ets_goods_type{goods_id = 443011,goods_name = "元气鼓舞·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443021) ->
	#ets_goods_type{goods_id = 443021,goods_name = "科技半环·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443031) ->
	#ets_goods_type{goods_id = 443031,goods_name = "外星飞船·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443041) ->
	#ets_goods_type{goods_id = 443041,goods_name = "灵皇冠冕·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443051) ->
	#ets_goods_type{goods_id = 443051,goods_name = "天使之证·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443061) ->
	#ets_goods_type{goods_id = 443061,goods_name = "萌宠海豹·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443071) ->
	#ets_goods_type{goods_id = 443071,goods_name = "神圣荆棘·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443081) ->
	#ets_goods_type{goods_id = 443081,goods_name = "兔耳音箱·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443091) ->
	#ets_goods_type{goods_id = 443091,goods_name = "竹蜻蜓·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443101) ->
	#ets_goods_type{goods_id = 443101,goods_name = "梦想咸鱼·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443111) ->
	#ets_goods_type{goods_id = 443111,goods_name = "圣诞颂歌·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443121) ->
	#ets_goods_type{goods_id = 443121,goods_name = "好奇宝宝·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443131) ->
	#ets_goods_type{goods_id = 443131,goods_name = "热带气泡·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443141) ->
	#ets_goods_type{goods_id = 443141,goods_name = "日月星云·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443151) ->
	#ets_goods_type{goods_id = 443151,goods_name = "纸飞机·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443161) ->
	#ets_goods_type{goods_id = 443161,goods_name = "和平圣冕·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443171) ->
	#ets_goods_type{goods_id = 443171,goods_name = "精灵末裔·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443181) ->
	#ets_goods_type{goods_id = 443181,goods_name = "熊猫嘟嘟·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(443191) ->
	#ets_goods_type{goods_id = 443191,goods_name = "幻音未来·组件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446000) ->
	#ets_goods_type{goods_id = 446000,goods_name = "背饰段·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,use = 1,bag_location = loc(18,1)};
get(446001) ->
	#ets_goods_type{goods_id = 446001,goods_name = "牵缘之结·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446011) ->
	#ets_goods_type{goods_id = 446011,goods_name = "可爱小黄鸭·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446021) ->
	#ets_goods_type{goods_id = 446021,goods_name = "捕梦网·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446031) ->
	#ets_goods_type{goods_id = 446031,goods_name = "夜色霓虹·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446041) ->
	#ets_goods_type{goods_id = 446041,goods_name = "伞兵一号·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446051) ->
	#ets_goods_type{goods_id = 446051,goods_name = "百斩鬼面·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446061) ->
	#ets_goods_type{goods_id = 446061,goods_name = "圣诞颂歌·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446071) ->
	#ets_goods_type{goods_id = 446071,goods_name = "发条魔偶·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446081) ->
	#ets_goods_type{goods_id = 446081,goods_name = "朋克背包·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446091) ->
	#ets_goods_type{goods_id = 446091,goods_name = "飞天扫帚·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446101) ->
	#ets_goods_type{goods_id = 446101,goods_name = "彩色风车·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446111) ->
	#ets_goods_type{goods_id = 446111,goods_name = "魔龙幼崽·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446121) ->
	#ets_goods_type{goods_id = 446121,goods_name = "机动战队·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446131) ->
	#ets_goods_type{goods_id = 446131,goods_name = "机械蝴蝶·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446141) ->
	#ets_goods_type{goods_id = 446141,goods_name = "森林精灵·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446151) ->
	#ets_goods_type{goods_id = 446151,goods_name = "暗灵盾·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446161) ->
	#ets_goods_type{goods_id = 446161,goods_name = "国潮风尚·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446171) ->
	#ets_goods_type{goods_id = 446171,goods_name = "蒸汽面具·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446181) ->
	#ets_goods_type{goods_id = 446181,goods_name = "邪灵祭祀·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(446191) ->
	#ets_goods_type{goods_id = 446191,goods_name = "意志战旗·配件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448000) ->
	#ets_goods_type{goods_id = 448000,goods_name = "武器时装段·碎片",bind = 1,type = 18,subtype = 1,max_overlap = 999,use = 1,bag_location = loc(18,1)};
get(448011) ->
	#ets_goods_type{goods_id = 448011,goods_name = "深海洋流·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448021) ->
	#ets_goods_type{goods_id = 448021,goods_name = "电音声浪·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448031) ->
	#ets_goods_type{goods_id = 448031,goods_name = "朋克街头·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448041) ->
	#ets_goods_type{goods_id = 448041,goods_name = "医疗先锋·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448051) ->
	#ets_goods_type{goods_id = 448051,goods_name = "沙漠探险·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448061) ->
	#ets_goods_type{goods_id = 448061,goods_name = "离子科技·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448071) ->
	#ets_goods_type{goods_id = 448071,goods_name = "西瓜雪冰·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448081) ->
	#ets_goods_type{goods_id = 448081,goods_name = "血色蔷薇·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448091) ->
	#ets_goods_type{goods_id = 448091,goods_name = "雨过天晴·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(448101) ->
	#ets_goods_type{goods_id = 448101,goods_name = "盛典餐具·部件",bind = 1,type = 18,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(18,1)};
get(450000) ->
	#ets_goods_type{goods_id = 450000,goods_name = "各类礼包占用段",bind = 1,type = 19,subtype = 1,max_overlap = 9999,bag_location = loc(19,1)};
get(450001) ->
	#ets_goods_type{goods_id = 450001,goods_name = "普通礼包测试1",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(450002) ->
	#ets_goods_type{goods_id = 450002,goods_name = "普通礼包测试2",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(450003) ->
	#ets_goods_type{goods_id = 450003,goods_name = "自选礼包测试1",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(450004) ->
	#ets_goods_type{goods_id = 450004,goods_name = "自选礼包测试2",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,1)};
get(450005) ->
	#ets_goods_type{goods_id = 450005,goods_name = "感谢礼包",bind = 1,type = 19,subtype = 3,max_overlap = 999,color = 2,use = 1,bag_location = loc(19,3)};
get(450006) ->
	#ets_goods_type{goods_id = 450006,goods_name = "发起协助礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 2,use = 1,bag_location = loc(19,1)};
get(450007) ->
	#ets_goods_type{goods_id = 450007,goods_name = "座驾绿装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 1,use = 1,bag_location = loc(19,1)};
get(450008) ->
	#ets_goods_type{goods_id = 450008,goods_name = "座驾蓝装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 2,use = 1,bag_location = loc(19,1)};
get(450009) ->
	#ets_goods_type{goods_id = 450009,goods_name = "座驾紫装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,1)};
get(450010) ->
	#ets_goods_type{goods_id = 450010,goods_name = "座驾橙装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(450011) ->
	#ets_goods_type{goods_id = 450011,goods_name = "座驾红装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,1)};
get(450012) ->
	#ets_goods_type{goods_id = 450012,goods_name = "座驾粉装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 6,use = 1,bag_location = loc(19,1)};
get(450013) ->
	#ets_goods_type{goods_id = 450013,goods_name = "AI娘绿装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 1,use = 1,bag_location = loc(19,1)};
get(450014) ->
	#ets_goods_type{goods_id = 450014,goods_name = "AI娘蓝装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 2,use = 1,bag_location = loc(19,1)};
get(450015) ->
	#ets_goods_type{goods_id = 450015,goods_name = "AI娘紫装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,1)};
get(450016) ->
	#ets_goods_type{goods_id = 450016,goods_name = "AI娘橙装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(450017) ->
	#ets_goods_type{goods_id = 450017,goods_name = "AI娘红装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,1)};
get(450018) ->
	#ets_goods_type{goods_id = 450018,goods_name = "AI娘粉装礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 6,use = 1,bag_location = loc(19,1)};
get(450019) ->
	#ets_goods_type{goods_id = 450019,goods_name = "座驾装备大礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,1)};
get(450020) ->
	#ets_goods_type{goods_id = 450020,goods_name = "座驾装备珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(450021) ->
	#ets_goods_type{goods_id = 450021,goods_name = "AI娘装备大礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,1)};
get(450022) ->
	#ets_goods_type{goods_id = 450022,goods_name = "AI娘装备珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(450023) ->
	#ets_goods_type{goods_id = 450023,goods_name = "随机进阶材料礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,1)};
get(450024) ->
	#ets_goods_type{goods_id = 450024,goods_name = "随机初级芯片礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(450025) ->
	#ets_goods_type{goods_id = 450025,goods_name = "进阶技能书礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,1)};
get(450026) ->
	#ets_goods_type{goods_id = 450026,goods_name = "被动技能书礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,1)};
get(450027) ->
	#ets_goods_type{goods_id = 450027,goods_name = "二日签到礼包",bind = 1,type = 19,subtype = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450028) ->
	#ets_goods_type{goods_id = 450028,goods_name = "三日签到礼包",bind = 1,type = 19,subtype = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450029) ->
	#ets_goods_type{goods_id = 450029,goods_name = "五日签到礼包",bind = 1,type = 19,subtype = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450030) ->
	#ets_goods_type{goods_id = 450030,goods_name = "七日签到礼包",bind = 1,type = 19,subtype = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450031) ->
	#ets_goods_type{goods_id = 450031,goods_name = "14日签到礼包",bind = 1,type = 19,subtype = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450032) ->
	#ets_goods_type{goods_id = 450032,goods_name = "21日签到礼包",bind = 1,type = 19,subtype = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450033) ->
	#ets_goods_type{goods_id = 450033,goods_name = "28日签到礼包",bind = 1,type = 19,subtype = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450034) ->
	#ets_goods_type{goods_id = 450034,goods_name = "采集奖励礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(450035) ->
	#ets_goods_type{goods_id = 450035,goods_name = "采集协助礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(450036) ->
	#ets_goods_type{goods_id = 450036,goods_name = "宠物宝石大礼包（生物）",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450037) ->
	#ets_goods_type{goods_id = 450037,goods_name = "宠物宝石珍品礼包（生物）",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450038) ->
	#ets_goods_type{goods_id = 450038,goods_name = "宠物宝石大礼包（异能）",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450039) ->
	#ets_goods_type{goods_id = 450039,goods_name = "宠物宝石珍品礼包（异能）",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450040) ->
	#ets_goods_type{goods_id = 450040,goods_name = "宠物宝石大礼包（机械）",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450041) ->
	#ets_goods_type{goods_id = 450041,goods_name = "宠物宝石珍品礼包（机械）",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450042) ->
	#ets_goods_type{goods_id = 450042,goods_name = "伤害第1礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450043) ->
	#ets_goods_type{goods_id = 450043,goods_name = "伤害前3礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450044) ->
	#ets_goods_type{goods_id = 450044,goods_name = "伤害前5礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450045) ->
	#ets_goods_type{goods_id = 450045,goods_name = "伤害前10礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450046) ->
	#ets_goods_type{goods_id = 450046,goods_name = "伤害礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450047) ->
	#ets_goods_type{goods_id = 450047,goods_name = "击杀礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450048) ->
	#ets_goods_type{goods_id = 450048,goods_name = "参与礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450049) ->
	#ets_goods_type{goods_id = 450049,goods_name = "BOSS采集礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(450050) ->
	#ets_goods_type{goods_id = 450050,goods_name = "自选升品礼包",bind = 1,type = 19,subtype = 2,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,2)};
get(450051) ->
	#ets_goods_type{goods_id = 450051,goods_name = "随机升品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 99999,color = 3,use = 1,bag_location = loc(19,1)};
get(450052) ->
	#ets_goods_type{goods_id = 450052,goods_name = "装备升品礼包",bind = 1,type = 19,subtype = 2,max_overlap = 99999,color = 4,use = 1,bag_location = loc(19,2)};
get(450053) ->
	#ets_goods_type{goods_id = 450053,goods_name = "玩具小礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450054) ->
	#ets_goods_type{goods_id = 450054,goods_name = "玩具大礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450055) ->
	#ets_goods_type{goods_id = 450055,goods_name = "玩具礼包·精英",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450056) ->
	#ets_goods_type{goods_id = 450056,goods_name = "玩具礼包·极品",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450057) ->
	#ets_goods_type{goods_id = 450057,goods_name = "玩具礼包·史诗",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(450058) ->
	#ets_goods_type{goods_id = 450058,goods_name = "发起拼单礼包",bind = 1,type = 19,subtype = 1,max_overlap = 9999,color = 2,use = 1,bag_location = loc(19,1)};
get(450059) ->
	#ets_goods_type{goods_id = 450059,goods_name = "拼单礼包",bind = 1,type = 19,subtype = 3,max_overlap = 9999,color = 2,use = 1,bag_location = loc(19,3)};
get(450060) ->
	#ets_goods_type{goods_id = 450060,goods_name = "SR战魂礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450061) ->
	#ets_goods_type{goods_id = 450061,goods_name = "SSR战魂礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450062) ->
	#ets_goods_type{goods_id = 450062,goods_name = "USR战魂礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(450063) ->
	#ets_goods_type{goods_id = 450063,goods_name = "战魂珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(450064) ->
	#ets_goods_type{goods_id = 450064,goods_name = "风系5星战魂礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(450065) ->
	#ets_goods_type{goods_id = 450065,goods_name = "火系5星战魂礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(450066) ->
	#ets_goods_type{goods_id = 450066,goods_name = "水系5星战魂礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(450067) ->
	#ets_goods_type{goods_id = 450067,goods_name = "圣物礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(450068) ->
	#ets_goods_type{goods_id = 450068,goods_name = "高级圣物礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(450069) ->
	#ets_goods_type{goods_id = 450069,goods_name = "城池礼包",bind = 1,type = 19,subtype = 1,max_overlap = 30,color = 4,use = 1,bag_location = loc(19,1)};
get(450070) ->
	#ets_goods_type{goods_id = 450070,goods_name = "自选SSR宠物碎片礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,2)};
get(450071) ->
	#ets_goods_type{goods_id = 450071,goods_name = "随机SSR宠物碎片礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(450072) ->
	#ets_goods_type{goods_id = 450072,goods_name = "自选极品星核碎片礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,2)};
get(450073) ->
	#ets_goods_type{goods_id = 450073,goods_name = "自选神品星核碎片礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,2)};
get(450074) ->
	#ets_goods_type{goods_id = 450074,goods_name = "幻魔次数自选卡",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,2)};
get(450075) ->
	#ets_goods_type{goods_id = 450075,goods_name = "幻魔刷新自选卡",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,2)};
get(450076) ->
	#ets_goods_type{goods_id = 450076,goods_name = "幻魔独享自选卡",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,2)};
get(450077) ->
	#ets_goods_type{goods_id = 450077,goods_name = "自选进阶材料礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,2)};
get(450078) ->
	#ets_goods_type{goods_id = 450078,goods_name = "自选初级芯片礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,2)};
get(450079) ->
	#ets_goods_type{goods_id = 450079,goods_name = "自选中级芯片礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,2)};
get(450080) ->
	#ets_goods_type{goods_id = 450080,goods_name = "座驾紫装自选礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,2)};
get(450081) ->
	#ets_goods_type{goods_id = 450081,goods_name = "座驾橙装自选礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,2)};
get(450082) ->
	#ets_goods_type{goods_id = 450082,goods_name = "AI娘紫装自选礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(19,2)};
get(450083) ->
	#ets_goods_type{goods_id = 450083,goods_name = "AI娘橙装自选礼包",bind = 1,type = 19,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,2)};
get(450084) ->
	#ets_goods_type{goods_id = 450084,goods_name = "自选USR战魂礼包",bind = 1,type = 19,subtype = 2,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,2)};
get(450085) ->
	#ets_goods_type{goods_id = 450085,goods_name = "随机中级芯片礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 5,use = 1,bag_location = loc(19,1)};
get(450086) ->
	#ets_goods_type{goods_id = 450086,goods_name = "随机宠物宝石礼包(异能)",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(450087) ->
	#ets_goods_type{goods_id = 450087,goods_name = "极品龙马礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(450088) ->
	#ets_goods_type{goods_id = 450088,goods_name = "随机宠物宝石礼包(机械)",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 4,use = 1,bag_location = loc(19,1)};
get(451001) ->
	#ets_goods_type{goods_id = 451001,goods_name = "1代装备宝箱",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(451002) ->
	#ets_goods_type{goods_id = 451002,goods_name = "2代装备宝箱",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(451003) ->
	#ets_goods_type{goods_id = 451003,goods_name = "3代装备宝箱",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(451004) ->
	#ets_goods_type{goods_id = 451004,goods_name = "4代装备宝箱",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(451005) ->
	#ets_goods_type{goods_id = 451005,goods_name = "5代装备宝箱",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(451006) ->
	#ets_goods_type{goods_id = 451006,goods_name = "6代装备宝箱",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(452001) ->
	#ets_goods_type{goods_id = 452001,goods_name = "BOSS护盾礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(452002) ->
	#ets_goods_type{goods_id = 452002,goods_name = "BOSS护盾礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(452003) ->
	#ets_goods_type{goods_id = 452003,goods_name = "BOSS护盾礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(452004) ->
	#ets_goods_type{goods_id = 452004,goods_name = "BOSS护盾礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(452005) ->
	#ets_goods_type{goods_id = 452005,goods_name = "BOSS护盾礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(452006) ->
	#ets_goods_type{goods_id = 452006,goods_name = "BOSS护盾礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(453001) ->
	#ets_goods_type{goods_id = 453001,goods_name = "座驾冲榜豪华礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453002) ->
	#ets_goods_type{goods_id = 453002,goods_name = "座驾冲榜超值礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,4)};
get(453003) ->
	#ets_goods_type{goods_id = 453003,goods_name = "(测试5)冲榜礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453004) ->
	#ets_goods_type{goods_id = 453004,goods_name = "(测试1)冲榜礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,4)};
get(453005) ->
	#ets_goods_type{goods_id = 453005,goods_name = "(测试3)冲榜礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,4)};
get(453006) ->
	#ets_goods_type{goods_id = 453006,goods_name = "道具排行测试礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(19,1)};
get(453007) ->
	#ets_goods_type{goods_id = 453007,goods_name = "武器大礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453008) ->
	#ets_goods_type{goods_id = 453008,goods_name = "宝具大礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453009) ->
	#ets_goods_type{goods_id = 453009,goods_name = "AI娘大礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453010) ->
	#ets_goods_type{goods_id = 453010,goods_name = "磁炮大礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453011) ->
	#ets_goods_type{goods_id = 453011,goods_name = "星翼大礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453012) ->
	#ets_goods_type{goods_id = 453012,goods_name = "感谢礼包",bind = 1,type = 19,subtype = 3,max_overlap = 999,color = 2,use = 1,bag_location = loc(19,3)};
get(453013) ->
	#ets_goods_type{goods_id = 453013,goods_name = "发起协助礼包",bind = 1,type = 19,subtype = 1,max_overlap = 999,color = 2,use = 1,bag_location = loc(19,1)};
get(453014) ->
	#ets_goods_type{goods_id = 453014,goods_name = "座驾福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453015) ->
	#ets_goods_type{goods_id = 453015,goods_name = "座驾入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 1,use = 1,bag_location = loc(19,4)};
get(453016) ->
	#ets_goods_type{goods_id = 453016,goods_name = "座驾成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 1,use = 1,bag_location = loc(19,4)};
get(453017) ->
	#ets_goods_type{goods_id = 453017,goods_name = "座驾飞跃礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 1,use = 1,bag_location = loc(19,4)};
get(453018) ->
	#ets_goods_type{goods_id = 453018,goods_name = "炫翼福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453019) ->
	#ets_goods_type{goods_id = 453019,goods_name = "炫翼入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 2,use = 1,bag_location = loc(19,4)};
get(453020) ->
	#ets_goods_type{goods_id = 453020,goods_name = "炫翼成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 2,use = 1,bag_location = loc(19,4)};
get(453021) ->
	#ets_goods_type{goods_id = 453021,goods_name = "炫翼飞跃礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 2,use = 1,bag_location = loc(19,4)};
get(453022) ->
	#ets_goods_type{goods_id = 453022,goods_name = "武器福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453023) ->
	#ets_goods_type{goods_id = 453023,goods_name = "武器入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 3,use = 1,bag_location = loc(19,4)};
get(453024) ->
	#ets_goods_type{goods_id = 453024,goods_name = "武器成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 3,use = 1,bag_location = loc(19,4)};
get(453025) ->
	#ets_goods_type{goods_id = 453025,goods_name = "武器增益礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 3,use = 1,bag_location = loc(19,4)};
get(453026) ->
	#ets_goods_type{goods_id = 453026,goods_name = "武器完型礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 3,use = 1,bag_location = loc(19,4)};
get(453027) ->
	#ets_goods_type{goods_id = 453027,goods_name = "宝具福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453028) ->
	#ets_goods_type{goods_id = 453028,goods_name = "宝具入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 4,use = 1,bag_location = loc(19,4)};
get(453029) ->
	#ets_goods_type{goods_id = 453029,goods_name = "宝具成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 4,use = 1,bag_location = loc(19,4)};
get(453030) ->
	#ets_goods_type{goods_id = 453030,goods_name = "宝具增益礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 4,use = 1,bag_location = loc(19,4)};
get(453031) ->
	#ets_goods_type{goods_id = 453031,goods_name = "宝具完型礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 4,use = 1,bag_location = loc(19,4)};
get(453032) ->
	#ets_goods_type{goods_id = 453032,goods_name = "宝具飞升礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 4,use = 1,bag_location = loc(19,4)};
get(453033) ->
	#ets_goods_type{goods_id = 453033,goods_name = "战魂福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453034) ->
	#ets_goods_type{goods_id = 453034,goods_name = "战魂入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 5,use = 1,bag_location = loc(19,4)};
get(453035) ->
	#ets_goods_type{goods_id = 453035,goods_name = "战魂成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 5,use = 1,bag_location = loc(19,4)};
get(453036) ->
	#ets_goods_type{goods_id = 453036,goods_name = "战魂增益礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 5,use = 1,bag_location = loc(19,4)};
get(453037) ->
	#ets_goods_type{goods_id = 453037,goods_name = "战魂完型礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 5,use = 1,bag_location = loc(19,4)};
get(453038) ->
	#ets_goods_type{goods_id = 453038,goods_name = "战魂飞升礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 5,use = 1,bag_location = loc(19,4)};
get(453039) ->
	#ets_goods_type{goods_id = 453039,goods_name = "红装福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453040) ->
	#ets_goods_type{goods_id = 453040,goods_name = "红装入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 6,use = 1,bag_location = loc(19,4)};
get(453041) ->
	#ets_goods_type{goods_id = 453041,goods_name = "红装成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 6,use = 1,bag_location = loc(19,4)};
get(453042) ->
	#ets_goods_type{goods_id = 453042,goods_name = "红装增益礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 6,use = 1,bag_location = loc(19,4)};
get(453043) ->
	#ets_goods_type{goods_id = 453043,goods_name = "红装完型礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 6,use = 1,bag_location = loc(19,4)};
get(453044) ->
	#ets_goods_type{goods_id = 453044,goods_name = "红装飞升礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 6,use = 1,bag_location = loc(19,4)};
get(453045) ->
	#ets_goods_type{goods_id = 453045,goods_name = "升战福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453046) ->
	#ets_goods_type{goods_id = 453046,goods_name = "升战入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453047) ->
	#ets_goods_type{goods_id = 453047,goods_name = "升战成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453048) ->
	#ets_goods_type{goods_id = 453048,goods_name = "升战增益礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453049) ->
	#ets_goods_type{goods_id = 453049,goods_name = "升战完型礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453050) ->
	#ets_goods_type{goods_id = 453050,goods_name = "升战飞升礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453051) ->
	#ets_goods_type{goods_id = 453051,goods_name = "冲榜福利礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,4)};
get(453052) ->
	#ets_goods_type{goods_id = 453052,goods_name = "冲榜入门礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453053) ->
	#ets_goods_type{goods_id = 453053,goods_name = "冲榜成长礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453054) ->
	#ets_goods_type{goods_id = 453054,goods_name = "冲榜增益礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453055) ->
	#ets_goods_type{goods_id = 453055,goods_name = "冲榜完型礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453056) ->
	#ets_goods_type{goods_id = 453056,goods_name = "冲榜飞升礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 8,use = 1,bag_location = loc(19,4)};
get(453057) ->
	#ets_goods_type{goods_id = 453057,goods_name = "超能0元礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453061) ->
	#ets_goods_type{goods_id = 453061,goods_name = "座驾中级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453062) ->
	#ets_goods_type{goods_id = 453062,goods_name = "座驾高级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453063) ->
	#ets_goods_type{goods_id = 453063,goods_name = "炫翼中级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453064) ->
	#ets_goods_type{goods_id = 453064,goods_name = "炫翼高级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453065) ->
	#ets_goods_type{goods_id = 453065,goods_name = "宝具中级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453066) ->
	#ets_goods_type{goods_id = 453066,goods_name = "宝具高级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453067) ->
	#ets_goods_type{goods_id = 453067,goods_name = "武器中级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453068) ->
	#ets_goods_type{goods_id = 453068,goods_name = "武器高级进阶礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453070) ->
	#ets_goods_type{goods_id = 453070,goods_name = "座驾6阶冲刺礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 1,use = 1,bag_location = loc(19,4)};
get(453071) ->
	#ets_goods_type{goods_id = 453071,goods_name = "座驾7阶冲刺礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 1,use = 1,bag_location = loc(19,4)};
get(453072) ->
	#ets_goods_type{goods_id = 453072,goods_name = "炫翼7阶冲刺礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 2,use = 1,bag_location = loc(19,4)};
get(453073) ->
	#ets_goods_type{goods_id = 453073,goods_name = "宝具7阶冲刺礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 4,use = 1,bag_location = loc(19,4)};
get(453074) ->
	#ets_goods_type{goods_id = 453074,goods_name = "武器7阶冲刺礼包",bind = 1,type = 19,subtype = 4,max_overlap = 1,color = 4,expire_type = 3,expire_time = 3,use = 1,bag_location = loc(19,4)};
get(453099) ->
	#ets_goods_type{goods_id = 453099,goods_name = "红钻礼盒",bind = 1,type = 19,subtype = 1,max_overlap = 99,color = 4,use = 1,bag_location = loc(19,1)};
get(453100) ->
	#ets_goods_type{goods_id = 453100,goods_name = "座驾超值礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453101) ->
	#ets_goods_type{goods_id = 453101,goods_name = "座驾技能礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453102) ->
	#ets_goods_type{goods_id = 453102,goods_name = "座驾珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453103) ->
	#ets_goods_type{goods_id = 453103,goods_name = "座驾豪华礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(453104) ->
	#ets_goods_type{goods_id = 453104,goods_name = "炫翼超值礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453105) ->
	#ets_goods_type{goods_id = 453105,goods_name = "炫翼技能礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453106) ->
	#ets_goods_type{goods_id = 453106,goods_name = "炫翼珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453107) ->
	#ets_goods_type{goods_id = 453107,goods_name = "炫翼豪华礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(453108) ->
	#ets_goods_type{goods_id = 453108,goods_name = "武器超值礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453109) ->
	#ets_goods_type{goods_id = 453109,goods_name = "武器技能礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453110) ->
	#ets_goods_type{goods_id = 453110,goods_name = "武器珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453111) ->
	#ets_goods_type{goods_id = 453111,goods_name = "武器豪华礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(453112) ->
	#ets_goods_type{goods_id = 453112,goods_name = "宝具超值礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453113) ->
	#ets_goods_type{goods_id = 453113,goods_name = "宝具技能礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453114) ->
	#ets_goods_type{goods_id = 453114,goods_name = "宝具珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453115) ->
	#ets_goods_type{goods_id = 453115,goods_name = "宝具豪华礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(453116) ->
	#ets_goods_type{goods_id = 453116,goods_name = "战魂超值礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453117) ->
	#ets_goods_type{goods_id = 453117,goods_name = "战魂精英礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453118) ->
	#ets_goods_type{goods_id = 453118,goods_name = "战魂高级礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(19,1)};
get(453119) ->
	#ets_goods_type{goods_id = 453119,goods_name = "战魂珍品礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(453120) ->
	#ets_goods_type{goods_id = 453120,goods_name = "战魂豪华礼包",bind = 1,type = 19,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(19,1)};
get(600000) ->
	#ets_goods_type{goods_id = 600000,goods_name = "制衣商城道具",bind = 1,type = 25,subtype = 1,max_overlap = 1,use = 1,bag_location = loc(25,1)};
get(601001) ->
	#ets_goods_type{goods_id = 601001,goods_name = "布匹",bind = 1,type = 25,subtype = 1,max_overlap = 30,color = 3,use = 1,bag_location = loc(25,1)};
get(601002) ->
	#ets_goods_type{goods_id = 601002,goods_name = "丝绸",bind = 1,type = 25,subtype = 1,max_overlap = 30,color = 4,use = 1,bag_location = loc(25,1)};
get(601003) ->
	#ets_goods_type{goods_id = 601003,goods_name = "新疆棉",bind = 1,type = 25,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(25,1)};
get(602001) ->
	#ets_goods_type{goods_id = 602001,goods_name = "残缺图纸",bind = 1,type = 25,subtype = 2,max_overlap = 30,color = 3,use = 1,bag_location = loc(25,2)};
get(602002) ->
	#ets_goods_type{goods_id = 602002,goods_name = "完美图纸",bind = 1,type = 25,subtype = 2,max_overlap = 30,color = 4,use = 1,bag_location = loc(25,2)};
get(603001) ->
	#ets_goods_type{goods_id = 603001,goods_name = "羽毛",bind = 1,type = 25,subtype = 3,max_overlap = 30,color = 3,use = 1,bag_location = loc(25,3)};
get(603002) ->
	#ets_goods_type{goods_id = 603002,goods_name = "雀羽",bind = 1,type = 25,subtype = 3,max_overlap = 30,color = 4,use = 1,bag_location = loc(25,3)};
get(603003) ->
	#ets_goods_type{goods_id = 603003,goods_name = "凤羽",bind = 1,type = 25,subtype = 3,max_overlap = 1,color = 5,use = 1,bag_location = loc(25,3)};
get(604001) ->
	#ets_goods_type{goods_id = 604001,goods_name = "铁矿",bind = 1,type = 25,subtype = 4,max_overlap = 30,color = 3,use = 1,bag_location = loc(25,4)};
get(604002) ->
	#ets_goods_type{goods_id = 604002,goods_name = "银精",bind = 1,type = 25,subtype = 4,max_overlap = 30,color = 4,use = 1,bag_location = loc(25,4)};
get(604003) ->
	#ets_goods_type{goods_id = 604003,goods_name = "晶钻",bind = 1,type = 25,subtype = 4,max_overlap = 1,color = 5,use = 1,bag_location = loc(25,4)};
get(605001) ->
	#ets_goods_type{goods_id = 605001,goods_name = "染发剂",bind = 1,type = 25,subtype = 5,max_overlap = 30,color = 3,use = 1,bag_location = loc(25,5)};
get(605002) ->
	#ets_goods_type{goods_id = 605002,goods_name = "护发素",bind = 1,type = 25,subtype = 5,max_overlap = 30,color = 4,use = 1,bag_location = loc(25,5)};
get(710201) ->
	#ets_goods_type{goods_id = 710201,goods_name = "神·吸血星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(22,1)};
get(710202) ->
	#ets_goods_type{goods_id = 710202,goods_name = "神·神佑星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(22,1)};
get(710203) ->
	#ets_goods_type{goods_id = 710203,goods_name = "神·刷新星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(22,1)};
get(710204) ->
	#ets_goods_type{goods_id = 710204,goods_name = "神·鬼王星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(22,1)};
get(710205) ->
	#ets_goods_type{goods_id = 710205,goods_name = "神·斩杀星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(22,1)};
get(710206) ->
	#ets_goods_type{goods_id = 710206,goods_name = "神·护身星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(22,1)};
get(710207) ->
	#ets_goods_type{goods_id = 710207,goods_name = "神·避血星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 5,use = 1,bag_location = loc(22,1)};
get(710301) ->
	#ets_goods_type{goods_id = 710301,goods_name = "极·伤害星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(22,1)};
get(710302) ->
	#ets_goods_type{goods_id = 710302,goods_name = "极·会心星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(22,1)};
get(710303) ->
	#ets_goods_type{goods_id = 710303,goods_name = "极·闪避星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(22,1)};
get(710304) ->
	#ets_goods_type{goods_id = 710304,goods_name = "极·格挡星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(22,1)};
get(710305) ->
	#ets_goods_type{goods_id = 710305,goods_name = "极·暴击星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(22,1)};
get(710306) ->
	#ets_goods_type{goods_id = 710306,goods_name = "极·生命星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(22,1)};
get(710307) ->
	#ets_goods_type{goods_id = 710307,goods_name = "极·攻击星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 4,use = 1,bag_location = loc(22,1)};
get(710401) ->
	#ets_goods_type{goods_id = 710401,goods_name = "精·会抗星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(22,1)};
get(710402) ->
	#ets_goods_type{goods_id = 710402,goods_name = "精·命中星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(22,1)};
get(710403) ->
	#ets_goods_type{goods_id = 710403,goods_name = "精·穿透星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(22,1)};
get(710404) ->
	#ets_goods_type{goods_id = 710404,goods_name = "精·抗暴星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(22,1)};
get(710405) ->
	#ets_goods_type{goods_id = 710405,goods_name = "精·经验星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(22,1)};
get(710406) ->
	#ets_goods_type{goods_id = 710406,goods_name = "精·固伤星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(22,1)};
get(710407) ->
	#ets_goods_type{goods_id = 710407,goods_name = "精·防御星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(22,1)};
get(710501) ->
	#ets_goods_type{goods_id = 710501,goods_name = "凡·生命星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(22,1)};
get(710502) ->
	#ets_goods_type{goods_id = 710502,goods_name = "凡·攻击星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(22,1)};
get(710503) ->
	#ets_goods_type{goods_id = 710503,goods_name = "凡·固伤星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(22,1)};
get(710504) ->
	#ets_goods_type{goods_id = 710504,goods_name = "凡·命中星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(22,1)};
get(710505) ->
	#ets_goods_type{goods_id = 710505,goods_name = "凡·闪避星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(22,1)};
get(710506) ->
	#ets_goods_type{goods_id = 710506,goods_name = "凡·暴击星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(22,1)};
get(710507) ->
	#ets_goods_type{goods_id = 710507,goods_name = "凡·坚韧星",bind = 1,type = 22,subtype = 1,max_overlap = 1,color = 2,use = 1,bag_location = loc(22,1)};
get(720201) ->
	#ets_goods_type{goods_id = 720201,goods_name = "星技·吸血",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720202) ->
	#ets_goods_type{goods_id = 720202,goods_name = "星技·次数护盾",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720203) ->
	#ets_goods_type{goods_id = 720203,goods_name = "星技·极速冷却",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720204) ->
	#ets_goods_type{goods_id = 720204,goods_name = "星技·BOSS伤害",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720205) ->
	#ets_goods_type{goods_id = 720205,goods_name = "星技·PVP伤害",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720206) ->
	#ets_goods_type{goods_id = 720206,goods_name = "星技·PVP减伤",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720207) ->
	#ets_goods_type{goods_id = 720207,goods_name = "星技·吸血抵抗",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720301) ->
	#ets_goods_type{goods_id = 720301,goods_name = "星技·伤害加深",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720302) ->
	#ets_goods_type{goods_id = 720302,goods_name = "星技·会心几率",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720303) ->
	#ets_goods_type{goods_id = 720303,goods_name = "星技·闪避几率",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720304) ->
	#ets_goods_type{goods_id = 720304,goods_name = "星技·格挡几率",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720305) ->
	#ets_goods_type{goods_id = 720305,goods_name = "星技·暴击几率",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720306) ->
	#ets_goods_type{goods_id = 720306,goods_name = "星技·生命加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720307) ->
	#ets_goods_type{goods_id = 720307,goods_name = "星技·攻击加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720401) ->
	#ets_goods_type{goods_id = 720401,goods_name = "星技·会心抵抗",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720402) ->
	#ets_goods_type{goods_id = 720402,goods_name = "星技·命中几率",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720403) ->
	#ets_goods_type{goods_id = 720403,goods_name = "星技·格挡穿透",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720404) ->
	#ets_goods_type{goods_id = 720404,goods_name = "星技·暴击抵抗",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720405) ->
	#ets_goods_type{goods_id = 720405,goods_name = "星技·经验加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720406) ->
	#ets_goods_type{goods_id = 720406,goods_name = "星技·固伤加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720407) ->
	#ets_goods_type{goods_id = 720407,goods_name = "星技·防御加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720501) ->
	#ets_goods_type{goods_id = 720501,goods_name = "星技·生命",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(720502) ->
	#ets_goods_type{goods_id = 720502,goods_name = "星技·攻击",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(720503) ->
	#ets_goods_type{goods_id = 720503,goods_name = "星技·固伤",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(720504) ->
	#ets_goods_type{goods_id = 720504,goods_name = "星技·命中",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(720505) ->
	#ets_goods_type{goods_id = 720505,goods_name = "星技·闪避",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(720506) ->
	#ets_goods_type{goods_id = 720506,goods_name = "星技·暴击",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(720507) ->
	#ets_goods_type{goods_id = 720507,goods_name = "星技·坚韧",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(720601) ->
	#ets_goods_type{goods_id = 720601,goods_name = "星技·伤害减免",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,2)};
get(720602) ->
	#ets_goods_type{goods_id = 720602,goods_name = "星技·技能伤害",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720603) ->
	#ets_goods_type{goods_id = 720603,goods_name = "星技·技能减伤",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720604) ->
	#ets_goods_type{goods_id = 720604,goods_name = "星技·暴击伤害",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720605) ->
	#ets_goods_type{goods_id = 720605,goods_name = "星技·暴伤减免",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720606) ->
	#ets_goods_type{goods_id = 720606,goods_name = "星技·会心伤害",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720607) ->
	#ets_goods_type{goods_id = 720607,goods_name = "星技·会心减伤",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,2)};
get(720608) ->
	#ets_goods_type{goods_id = 720608,goods_name = "星技·命中加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720609) ->
	#ets_goods_type{goods_id = 720609,goods_name = "星技·闪避加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720610) ->
	#ets_goods_type{goods_id = 720610,goods_name = "星技·暴击加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720611) ->
	#ets_goods_type{goods_id = 720611,goods_name = "星技·坚韧加成",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,2)};
get(720612) ->
	#ets_goods_type{goods_id = 720612,goods_name = "星技·防御",bind = 1,type = 22,subtype = 2,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,2)};
get(730010) ->
	#ets_goods_type{goods_id = 730010,goods_name = "星·能量魔方",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2000,bag_location = loc(22,3)};
get(730011) ->
	#ets_goods_type{goods_id = 730011,goods_name = "魔方·简",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2000,bag_location = loc(22,3)};
get(730012) ->
	#ets_goods_type{goods_id = 730012,goods_name = "魔方·形",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2000,bag_location = loc(22,3)};
get(730013) ->
	#ets_goods_type{goods_id = 730013,goods_name = "魔方·律",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2000,bag_location = loc(22,3)};
get(730014) ->
	#ets_goods_type{goods_id = 730014,goods_name = "魔方·法",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2000,bag_location = loc(22,3)};
get(730020) ->
	#ets_goods_type{goods_id = 730020,goods_name = "星·幻光水瓶",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2001,bag_location = loc(22,3)};
get(730021) ->
	#ets_goods_type{goods_id = 730021,goods_name = "水瓶·空",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2001,bag_location = loc(22,3)};
get(730022) ->
	#ets_goods_type{goods_id = 730022,goods_name = "水瓶·存",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2001,bag_location = loc(22,3)};
get(730023) ->
	#ets_goods_type{goods_id = 730023,goods_name = "水瓶·满",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2001,bag_location = loc(22,3)};
get(730024) ->
	#ets_goods_type{goods_id = 730024,goods_name = "水瓶·溢",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2001,bag_location = loc(22,3)};
get(730030) ->
	#ets_goods_type{goods_id = 730030,goods_name = "星·虚无领跌",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2002,bag_location = loc(22,3)};
get(730031) ->
	#ets_goods_type{goods_id = 730031,goods_name = "灵蝶·静",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2002,bag_location = loc(22,3)};
get(730032) ->
	#ets_goods_type{goods_id = 730032,goods_name = "灵蝶·起",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2002,bag_location = loc(22,3)};
get(730033) ->
	#ets_goods_type{goods_id = 730033,goods_name = "灵蝶·动",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2002,bag_location = loc(22,3)};
get(730034) ->
	#ets_goods_type{goods_id = 730034,goods_name = "灵蝶·舞",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2002,bag_location = loc(22,3)};
get(730040) ->
	#ets_goods_type{goods_id = 730040,goods_name = "星·幻世睡莲",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2003,bag_location = loc(22,3)};
get(730041) ->
	#ets_goods_type{goods_id = 730041,goods_name = "睡莲·谧",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2003,bag_location = loc(22,3)};
get(730042) ->
	#ets_goods_type{goods_id = 730042,goods_name = "睡莲·幽",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2003,bag_location = loc(22,3)};
get(730043) ->
	#ets_goods_type{goods_id = 730043,goods_name = "睡莲·韵",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2003,bag_location = loc(22,3)};
get(730044) ->
	#ets_goods_type{goods_id = 730044,goods_name = "睡莲·禅",bind = 1,type = 22,subtype = 3,max_overlap = 999,color = 5,use = 1,model_id = 2003,bag_location = loc(22,3)};
get(740201) ->
	#ets_goods_type{goods_id = 740201,goods_name = "神·吸血星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,4)};
get(740202) ->
	#ets_goods_type{goods_id = 740202,goods_name = "神·神佑星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,4)};
get(740203) ->
	#ets_goods_type{goods_id = 740203,goods_name = "神·刷新星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,4)};
get(740204) ->
	#ets_goods_type{goods_id = 740204,goods_name = "神·鬼王星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,4)};
get(740205) ->
	#ets_goods_type{goods_id = 740205,goods_name = "神·斩杀星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,4)};
get(740206) ->
	#ets_goods_type{goods_id = 740206,goods_name = "神·护身星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,4)};
get(740207) ->
	#ets_goods_type{goods_id = 740207,goods_name = "神·避血星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 5,use = 1,bag_location = loc(22,4)};
get(740301) ->
	#ets_goods_type{goods_id = 740301,goods_name = "极·伤害星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,4)};
get(740302) ->
	#ets_goods_type{goods_id = 740302,goods_name = "极·会心星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,4)};
get(740303) ->
	#ets_goods_type{goods_id = 740303,goods_name = "极·闪避星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,4)};
get(740304) ->
	#ets_goods_type{goods_id = 740304,goods_name = "极·格挡星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,4)};
get(740305) ->
	#ets_goods_type{goods_id = 740305,goods_name = "极·暴击星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,4)};
get(740306) ->
	#ets_goods_type{goods_id = 740306,goods_name = "极·生命星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,4)};
get(740307) ->
	#ets_goods_type{goods_id = 740307,goods_name = "极·攻击星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 4,use = 1,bag_location = loc(22,4)};
get(740401) ->
	#ets_goods_type{goods_id = 740401,goods_name = "精·会抗星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,4)};
get(740402) ->
	#ets_goods_type{goods_id = 740402,goods_name = "精·命中星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,4)};
get(740403) ->
	#ets_goods_type{goods_id = 740403,goods_name = "精·穿透星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,4)};
get(740404) ->
	#ets_goods_type{goods_id = 740404,goods_name = "精·抗暴星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,4)};
get(740405) ->
	#ets_goods_type{goods_id = 740405,goods_name = "精·经验星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,4)};
get(740406) ->
	#ets_goods_type{goods_id = 740406,goods_name = "精·固伤星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,4)};
get(740407) ->
	#ets_goods_type{goods_id = 740407,goods_name = "精·防御星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 3,use = 1,bag_location = loc(22,4)};
get(740501) ->
	#ets_goods_type{goods_id = 740501,goods_name = "凡·生命星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,4)};
get(740502) ->
	#ets_goods_type{goods_id = 740502,goods_name = "凡·攻击星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,4)};
get(740503) ->
	#ets_goods_type{goods_id = 740503,goods_name = "凡·固伤星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,4)};
get(740504) ->
	#ets_goods_type{goods_id = 740504,goods_name = "凡·命中星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,4)};
get(740505) ->
	#ets_goods_type{goods_id = 740505,goods_name = "凡·闪避星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,4)};
get(740506) ->
	#ets_goods_type{goods_id = 740506,goods_name = "凡·暴击星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,4)};
get(740507) ->
	#ets_goods_type{goods_id = 740507,goods_name = "凡·坚韧星碎片",bind = 1,type = 22,subtype = 4,max_overlap = 999,color = 2,use = 1,bag_location = loc(22,4)};
get(800000) ->
	#ets_goods_type{goods_id = 800000,goods_name = "舞蹈动作道具段",bind = 1,type = 24,subtype = 1,max_overlap = 9999,bag_location = loc(24,1)};
get(800001) ->
	#ets_goods_type{goods_id = 800001,goods_name = "时代召唤",bind = 1,type = 24,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(24,1)};
get(800002) ->
	#ets_goods_type{goods_id = 800002,goods_name = "动感街舞",bind = 1,type = 24,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(24,1)};
get(800003) ->
	#ets_goods_type{goods_id = 800003,goods_name = "闪耀新星",bind = 1,type = 24,subtype = 1,max_overlap = 1,color = 3,use = 1,bag_location = loc(24,1)};
get(24000011) ->
	#ets_goods_type{goods_id = 24000011,goods_name = "小械灵",bind = 1,type = 5,subtype = 11,level = 1,color = 1,model_id = 1010,bag_location = loc(5,11)};
get(24000012) ->
	#ets_goods_type{goods_id = 24000012,goods_name = "大械灵",bind = 1,type = 5,subtype = 11,level = 1,color = 4,model_id = 1011,bag_location = loc(5,11)};
get(24000013) ->
	#ets_goods_type{goods_id = 24000013,goods_name = "终端械灵",bind = 1,type = 5,subtype = 11,level = 1,color = 5,model_id = 1012,bag_location = loc(5,11)};
get(24000021) ->
	#ets_goods_type{goods_id = 24000021,goods_name = "小天使",bind = 1,type = 5,subtype = 11,level = 115,color = 1,model_id = 1020,bag_location = loc(5,11)};
get(24000022) ->
	#ets_goods_type{goods_id = 24000022,goods_name = "大天使",bind = 1,type = 5,subtype = 11,level = 115,color = 4,model_id = 1021,bag_location = loc(5,11)};
get(24000023) ->
	#ets_goods_type{goods_id = 24000023,goods_name = "神圣天使",bind = 1,type = 5,subtype = 11,level = 115,color = 5,model_id = 1022,bag_location = loc(5,11)};
get(24000031) ->
	#ets_goods_type{goods_id = 24000031,goods_name = "小精灵",bind = 1,type = 5,subtype = 11,level = 145,color = 1,model_id = 1000,bag_location = loc(5,11)};
get(24000032) ->
	#ets_goods_type{goods_id = 24000032,goods_name = "大精灵",bind = 1,type = 5,subtype = 11,level = 145,color = 4,model_id = 1001,bag_location = loc(5,11)};
get(24000033) ->
	#ets_goods_type{goods_id = 24000033,goods_name = "繁花精灵",bind = 1,type = 5,subtype = 11,level = 145,color = 5,model_id = 1002,bag_location = loc(5,11)};
get(24000041) ->
	#ets_goods_type{goods_id = 24000041,goods_name = "小人鱼",bind = 1,type = 5,subtype = 11,level = 175,color = 1,model_id = 1040,bag_location = loc(5,11)};
get(24000042) ->
	#ets_goods_type{goods_id = 24000042,goods_name = "大人鱼",bind = 1,type = 5,subtype = 11,level = 175,color = 4,model_id = 1041,bag_location = loc(5,11)};
get(24000043) ->
	#ets_goods_type{goods_id = 24000043,goods_name = "深海人鱼",bind = 1,type = 5,subtype = 11,level = 175,color = 5,model_id = 1042,bag_location = loc(5,11)};
get(24000051) ->
	#ets_goods_type{goods_id = 24000051,goods_name = "小弓手",bind = 1,type = 5,subtype = 11,level = 250,color = 1,model_id = 1060,bag_location = loc(5,11)};
get(24000052) ->
	#ets_goods_type{goods_id = 24000052,goods_name = "大弓手",bind = 1,type = 5,subtype = 11,level = 250,color = 4,model_id = 1061,bag_location = loc(5,11)};
get(24000053) ->
	#ets_goods_type{goods_id = 24000053,goods_name = "森林弓手",bind = 1,type = 5,subtype = 11,level = 250,color = 5,model_id = 1062,bag_location = loc(5,11)};
get(24000061) ->
	#ets_goods_type{goods_id = 24000061,goods_name = "小凤凰",bind = 1,type = 5,subtype = 11,level = 350,color = 1,model_id = 1070,bag_location = loc(5,11)};
get(24000062) ->
	#ets_goods_type{goods_id = 24000062,goods_name = "大凤凰",bind = 1,type = 5,subtype = 11,level = 350,color = 4,model_id = 1071,bag_location = loc(5,11)};
get(24000063) ->
	#ets_goods_type{goods_id = 24000063,goods_name = "涅槃凤凰",bind = 1,type = 5,subtype = 11,level = 350,color = 5,model_id = 1072,bag_location = loc(5,11)};
get(24000071) ->
	#ets_goods_type{goods_id = 24000071,goods_name = "小战士",bind = 1,type = 5,subtype = 11,level = 450,color = 1,model_id = 1030,bag_location = loc(5,11)};
get(24000072) ->
	#ets_goods_type{goods_id = 24000072,goods_name = "大战士",bind = 1,type = 5,subtype = 11,level = 450,color = 4,model_id = 1031,bag_location = loc(5,11)};
get(24000073) ->
	#ets_goods_type{goods_id = 24000073,goods_name = "基因战士",bind = 1,type = 5,subtype = 11,level = 450,color = 5,model_id = 1032,bag_location = loc(5,11)};
get(24000081) ->
	#ets_goods_type{goods_id = 24000081,goods_name = "小陆行龙",bind = 1,type = 5,subtype = 11,level = 550,color = 1,model_id = 1080,bag_location = loc(5,11)};
get(24000082) ->
	#ets_goods_type{goods_id = 24000082,goods_name = "大陆行龙",bind = 1,type = 5,subtype = 11,level = 550,color = 4,model_id = 1081,bag_location = loc(5,11)};
get(24000083) ->
	#ets_goods_type{goods_id = 24000083,goods_name = "疾驰地龙",bind = 1,type = 5,subtype = 11,level = 550,color = 5,model_id = 1082,bag_location = loc(5,11)};
get(24000091) ->
	#ets_goods_type{goods_id = 24000091,goods_name = "小雪人",bind = 1,type = 5,subtype = 11,level = 650,color = 1,model_id = 1050,bag_location = loc(5,11)};
get(24000092) ->
	#ets_goods_type{goods_id = 24000092,goods_name = "大雪人",bind = 1,type = 5,subtype = 11,level = 650,color = 4,model_id = 1051,bag_location = loc(5,11)};
get(24000093) ->
	#ets_goods_type{goods_id = 24000093,goods_name = "急冻雪人",bind = 1,type = 5,subtype = 11,level = 650,color = 5,model_id = 1052,bag_location = loc(5,11)};
get(24001080) ->
	#ets_goods_type{goods_id = 24001080,goods_name = "潮牌项链",bind = 1,type = 5,subtype = 8,level = 1,bag_location = loc(5,8)};
get(24001081) ->
	#ets_goods_type{goods_id = 24001081,goods_name = "潮牌项链",bind = 1,type = 5,subtype = 8,level = 1,color = 1,bag_location = loc(5,8)};
get(24001082) ->
	#ets_goods_type{goods_id = 24001082,goods_name = "潮牌项链",bind = 1,type = 5,subtype = 8,level = 1,color = 2,bag_location = loc(5,8)};
get(24001083) ->
	#ets_goods_type{goods_id = 24001083,goods_name = "潮牌项链",bind = 1,type = 5,subtype = 8,level = 1,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 120,bag_location = loc(5,8)};
get(24001084) ->
	#ets_goods_type{goods_id = 24001084,goods_name = "潮牌项链",bind = 1,type = 5,subtype = 8,level = 1,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,is_to_market = 1,bag_location = loc(5,8)};
get(24001090) ->
	#ets_goods_type{goods_id = 24001090,goods_name = "潮牌戒指",bind = 1,type = 5,subtype = 9,level = 1,bag_location = loc(5,9)};
get(24001091) ->
	#ets_goods_type{goods_id = 24001091,goods_name = "潮牌戒指",bind = 1,type = 5,subtype = 9,level = 1,color = 1,bag_location = loc(5,9)};
get(24001092) ->
	#ets_goods_type{goods_id = 24001092,goods_name = "潮牌戒指",bind = 1,type = 5,subtype = 9,level = 1,color = 2,bag_location = loc(5,9)};
get(24001093) ->
	#ets_goods_type{goods_id = 24001093,goods_name = "潮牌戒指",bind = 1,type = 5,subtype = 9,level = 1,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 120,bag_location = loc(5,9)};
get(24001094) ->
	#ets_goods_type{goods_id = 24001094,goods_name = "潮牌戒指",bind = 1,type = 5,subtype = 9,level = 1,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,is_to_market = 1,bag_location = loc(5,9)};
get(24001100) ->
	#ets_goods_type{goods_id = 24001100,goods_name = "潮牌耳饰",bind = 1,type = 5,subtype = 10,level = 1,bag_location = loc(5,10)};
get(24001101) ->
	#ets_goods_type{goods_id = 24001101,goods_name = "潮牌耳饰",bind = 1,type = 5,subtype = 10,level = 1,color = 1,bag_location = loc(5,10)};
get(24001102) ->
	#ets_goods_type{goods_id = 24001102,goods_name = "潮牌耳饰",bind = 1,type = 5,subtype = 10,level = 1,color = 2,bag_location = loc(5,10)};
get(24001103) ->
	#ets_goods_type{goods_id = 24001103,goods_name = "潮牌耳饰",bind = 1,type = 5,subtype = 10,level = 1,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 120,bag_location = loc(5,10)};
get(24001104) ->
	#ets_goods_type{goods_id = 24001104,goods_name = "潮牌耳饰",bind = 1,type = 5,subtype = 10,level = 1,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,is_to_market = 1,bag_location = loc(5,10)};
get(24002080) ->
	#ets_goods_type{goods_id = 24002080,goods_name = "新星项链",bind = 1,type = 5,subtype = 8,level = 115,bag_location = loc(5,8)};
get(24002081) ->
	#ets_goods_type{goods_id = 24002081,goods_name = "新星项链",bind = 1,type = 5,subtype = 8,level = 115,color = 1,bag_location = loc(5,8)};
get(24002082) ->
	#ets_goods_type{goods_id = 24002082,goods_name = "新星项链",bind = 1,type = 5,subtype = 8,level = 115,color = 2,bag_location = loc(5,8)};
get(24002083) ->
	#ets_goods_type{goods_id = 24002083,goods_name = "新星项链",bind = 1,type = 5,subtype = 8,level = 115,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 120,bag_location = loc(5,8)};
get(24002084) ->
	#ets_goods_type{goods_id = 24002084,goods_name = "新星项链",bind = 1,type = 5,subtype = 8,level = 115,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,8)};
get(24002090) ->
	#ets_goods_type{goods_id = 24002090,goods_name = "新星戒指",bind = 1,type = 5,subtype = 9,level = 115,bag_location = loc(5,9)};
get(24002091) ->
	#ets_goods_type{goods_id = 24002091,goods_name = "新星戒指",bind = 1,type = 5,subtype = 9,level = 115,color = 1,bag_location = loc(5,9)};
get(24002092) ->
	#ets_goods_type{goods_id = 24002092,goods_name = "新星戒指",bind = 1,type = 5,subtype = 9,level = 115,color = 2,bag_location = loc(5,9)};
get(24002093) ->
	#ets_goods_type{goods_id = 24002093,goods_name = "新星戒指",bind = 1,type = 5,subtype = 9,level = 115,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 120,bag_location = loc(5,9)};
get(24002094) ->
	#ets_goods_type{goods_id = 24002094,goods_name = "新星戒指",bind = 1,type = 5,subtype = 9,level = 115,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 10,selling_time = 120,bag_location = loc(5,9)};
get(24002100) ->
	#ets_goods_type{goods_id = 24002100,goods_name = "新星耳饰",bind = 1,type = 5,subtype = 10,level = 115,bag_location = loc(5,10)};
get(24002101) ->
	#ets_goods_type{goods_id = 24002101,goods_name = "新星耳饰",bind = 1,type = 5,subtype = 10,level = 115,color = 1,bag_location = loc(5,10)};
get(24002102) ->
	#ets_goods_type{goods_id = 24002102,goods_name = "新星耳饰",bind = 1,type = 5,subtype = 10,level = 115,color = 2,bag_location = loc(5,10)};
get(24002103) ->
	#ets_goods_type{goods_id = 24002103,goods_name = "新星耳饰",bind = 1,type = 5,subtype = 10,level = 115,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 120,bag_location = loc(5,10)};
get(24002104) ->
	#ets_goods_type{goods_id = 24002104,goods_name = "新星耳饰",bind = 1,type = 5,subtype = 10,level = 115,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 10,selling_time = 120,bag_location = loc(5,10)};
get(24003080) ->
	#ets_goods_type{goods_id = 24003080,goods_name = "量子项链",bind = 1,type = 5,subtype = 8,level = 145,bag_location = loc(5,8)};
get(24003081) ->
	#ets_goods_type{goods_id = 24003081,goods_name = "量子项链",bind = 1,type = 5,subtype = 8,level = 145,color = 1,bag_location = loc(5,8)};
get(24003082) ->
	#ets_goods_type{goods_id = 24003082,goods_name = "量子项链",bind = 1,type = 5,subtype = 8,level = 145,color = 2,bag_location = loc(5,8)};
get(24003083) ->
	#ets_goods_type{goods_id = 24003083,goods_name = "量子项链",bind = 1,type = 5,subtype = 8,level = 145,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 3600,bag_location = loc(5,8)};
get(24003084) ->
	#ets_goods_type{goods_id = 24003084,goods_name = "量子项链",bind = 1,type = 5,subtype = 8,level = 145,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 3600,bag_location = loc(5,8)};
get(24003090) ->
	#ets_goods_type{goods_id = 24003090,goods_name = "量子戒指",bind = 1,type = 5,subtype = 9,level = 145,bag_location = loc(5,9)};
get(24003091) ->
	#ets_goods_type{goods_id = 24003091,goods_name = "量子戒指",bind = 1,type = 5,subtype = 9,level = 145,color = 1,bag_location = loc(5,9)};
get(24003092) ->
	#ets_goods_type{goods_id = 24003092,goods_name = "量子戒指",bind = 1,type = 5,subtype = 9,level = 145,color = 2,bag_location = loc(5,9)};
get(24003093) ->
	#ets_goods_type{goods_id = 24003093,goods_name = "量子戒指",bind = 1,type = 5,subtype = 9,level = 145,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 3600,bag_location = loc(5,9)};
get(24003094) ->
	#ets_goods_type{goods_id = 24003094,goods_name = "量子戒指",bind = 1,type = 5,subtype = 9,level = 145,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 3600,bag_location = loc(5,9)};
get(24003100) ->
	#ets_goods_type{goods_id = 24003100,goods_name = "量子耳饰",bind = 1,type = 5,subtype = 10,level = 145,bag_location = loc(5,10)};
get(24003101) ->
	#ets_goods_type{goods_id = 24003101,goods_name = "量子耳饰",bind = 1,type = 5,subtype = 10,level = 145,color = 1,bag_location = loc(5,10)};
get(24003102) ->
	#ets_goods_type{goods_id = 24003102,goods_name = "量子耳饰",bind = 1,type = 5,subtype = 10,level = 145,color = 2,bag_location = loc(5,10)};
get(24003103) ->
	#ets_goods_type{goods_id = 24003103,goods_name = "量子耳饰",bind = 1,type = 5,subtype = 10,level = 145,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,10)};
get(24003104) ->
	#ets_goods_type{goods_id = 24003104,goods_name = "量子耳饰",bind = 1,type = 5,subtype = 10,level = 145,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,10)};
get(24004080) ->
	#ets_goods_type{goods_id = 24004080,goods_name = "宵暗项链",bind = 1,type = 5,subtype = 8,level = 175,bag_location = loc(5,8)};
get(24004081) ->
	#ets_goods_type{goods_id = 24004081,goods_name = "宵暗项链",bind = 1,type = 5,subtype = 8,level = 175,color = 1,bag_location = loc(5,8)};
get(24004082) ->
	#ets_goods_type{goods_id = 24004082,goods_name = "宵暗项链",bind = 1,type = 5,subtype = 8,level = 175,color = 2,bag_location = loc(5,8)};
get(24004083) ->
	#ets_goods_type{goods_id = 24004083,goods_name = "宵暗项链",bind = 1,type = 5,subtype = 8,level = 175,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,8)};
get(24004084) ->
	#ets_goods_type{goods_id = 24004084,goods_name = "宵暗项链",bind = 1,type = 5,subtype = 8,level = 175,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,8)};
get(24004090) ->
	#ets_goods_type{goods_id = 24004090,goods_name = "宵暗戒指",bind = 1,type = 5,subtype = 9,level = 175,bag_location = loc(5,9)};
get(24004091) ->
	#ets_goods_type{goods_id = 24004091,goods_name = "宵暗戒指",bind = 1,type = 5,subtype = 9,level = 175,color = 1,bag_location = loc(5,9)};
get(24004092) ->
	#ets_goods_type{goods_id = 24004092,goods_name = "宵暗戒指",bind = 1,type = 5,subtype = 9,level = 175,color = 2,bag_location = loc(5,9)};
get(24004093) ->
	#ets_goods_type{goods_id = 24004093,goods_name = "宵暗戒指",bind = 1,type = 5,subtype = 9,level = 175,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,9)};
get(24004094) ->
	#ets_goods_type{goods_id = 24004094,goods_name = "宵暗戒指",bind = 1,type = 5,subtype = 9,level = 175,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,9)};
get(24004100) ->
	#ets_goods_type{goods_id = 24004100,goods_name = "宵暗耳饰",bind = 1,type = 5,subtype = 10,level = 175,bag_location = loc(5,10)};
get(24004101) ->
	#ets_goods_type{goods_id = 24004101,goods_name = "宵暗耳饰",bind = 1,type = 5,subtype = 10,level = 175,color = 1,bag_location = loc(5,10)};
get(24004102) ->
	#ets_goods_type{goods_id = 24004102,goods_name = "宵暗耳饰",bind = 1,type = 5,subtype = 10,level = 175,color = 2,bag_location = loc(5,10)};
get(24004103) ->
	#ets_goods_type{goods_id = 24004103,goods_name = "宵暗耳饰",bind = 1,type = 5,subtype = 10,level = 175,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,10)};
get(24004104) ->
	#ets_goods_type{goods_id = 24004104,goods_name = "宵暗耳饰",bind = 1,type = 5,subtype = 10,level = 175,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,10)};
get(24005080) ->
	#ets_goods_type{goods_id = 24005080,goods_name = "群星项链",bind = 1,type = 5,subtype = 8,level = 250,bag_location = loc(5,8)};
get(24005081) ->
	#ets_goods_type{goods_id = 24005081,goods_name = "群星项链",bind = 1,type = 5,subtype = 8,level = 250,color = 1,bag_location = loc(5,8)};
get(24005082) ->
	#ets_goods_type{goods_id = 24005082,goods_name = "群星项链",bind = 1,type = 5,subtype = 8,level = 250,color = 2,bag_location = loc(5,8)};
get(24005083) ->
	#ets_goods_type{goods_id = 24005083,goods_name = "群星项链",bind = 1,type = 5,subtype = 8,level = 250,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,8)};
get(24005084) ->
	#ets_goods_type{goods_id = 24005084,goods_name = "群星项链",bind = 1,type = 5,subtype = 8,level = 250,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,8)};
get(24005090) ->
	#ets_goods_type{goods_id = 24005090,goods_name = "群星戒指",bind = 1,type = 5,subtype = 9,level = 250,bag_location = loc(5,9)};
get(24005091) ->
	#ets_goods_type{goods_id = 24005091,goods_name = "群星戒指",bind = 1,type = 5,subtype = 9,level = 250,color = 1,bag_location = loc(5,9)};
get(24005092) ->
	#ets_goods_type{goods_id = 24005092,goods_name = "群星戒指",bind = 1,type = 5,subtype = 9,level = 250,color = 2,bag_location = loc(5,9)};
get(24005093) ->
	#ets_goods_type{goods_id = 24005093,goods_name = "群星戒指",bind = 1,type = 5,subtype = 9,level = 250,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,9)};
get(24005094) ->
	#ets_goods_type{goods_id = 24005094,goods_name = "群星戒指",bind = 1,type = 5,subtype = 9,level = 250,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,9)};
get(24005100) ->
	#ets_goods_type{goods_id = 24005100,goods_name = "群星耳饰",bind = 1,type = 5,subtype = 10,level = 250,bag_location = loc(5,10)};
get(24005101) ->
	#ets_goods_type{goods_id = 24005101,goods_name = "群星耳饰",bind = 1,type = 5,subtype = 10,level = 250,color = 1,bag_location = loc(5,10)};
get(24005102) ->
	#ets_goods_type{goods_id = 24005102,goods_name = "群星耳饰",bind = 1,type = 5,subtype = 10,level = 250,color = 2,bag_location = loc(5,10)};
get(24005103) ->
	#ets_goods_type{goods_id = 24005103,goods_name = "群星耳饰",bind = 1,type = 5,subtype = 10,level = 250,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,10)};
get(24005104) ->
	#ets_goods_type{goods_id = 24005104,goods_name = "群星耳饰",bind = 1,type = 5,subtype = 10,level = 250,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,10)};
get(24006080) ->
	#ets_goods_type{goods_id = 24006080,goods_name = "秩序项链",bind = 1,type = 5,subtype = 8,level = 350,bag_location = loc(5,8)};
get(24006081) ->
	#ets_goods_type{goods_id = 24006081,goods_name = "秩序项链",bind = 1,type = 5,subtype = 8,level = 350,color = 1,bag_location = loc(5,8)};
get(24006082) ->
	#ets_goods_type{goods_id = 24006082,goods_name = "秩序项链",bind = 1,type = 5,subtype = 8,level = 350,color = 2,bag_location = loc(5,8)};
get(24006083) ->
	#ets_goods_type{goods_id = 24006083,goods_name = "秩序项链",bind = 1,type = 5,subtype = 8,level = 350,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,8)};
get(24006084) ->
	#ets_goods_type{goods_id = 24006084,goods_name = "秩序项链",bind = 1,type = 5,subtype = 8,level = 350,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,8)};
get(24006090) ->
	#ets_goods_type{goods_id = 24006090,goods_name = "秩序戒指",bind = 1,type = 5,subtype = 9,level = 350,bag_location = loc(5,9)};
get(24006091) ->
	#ets_goods_type{goods_id = 24006091,goods_name = "秩序戒指",bind = 1,type = 5,subtype = 9,level = 350,color = 1,bag_location = loc(5,9)};
get(24006092) ->
	#ets_goods_type{goods_id = 24006092,goods_name = "秩序戒指",bind = 1,type = 5,subtype = 9,level = 350,color = 2,bag_location = loc(5,9)};
get(24006093) ->
	#ets_goods_type{goods_id = 24006093,goods_name = "秩序戒指",bind = 1,type = 5,subtype = 9,level = 350,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,9)};
get(24006094) ->
	#ets_goods_type{goods_id = 24006094,goods_name = "秩序戒指",bind = 1,type = 5,subtype = 9,level = 350,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,9)};
get(24006100) ->
	#ets_goods_type{goods_id = 24006100,goods_name = "秩序耳饰",bind = 1,type = 5,subtype = 10,level = 350,bag_location = loc(5,10)};
get(24006101) ->
	#ets_goods_type{goods_id = 24006101,goods_name = "秩序耳饰",bind = 1,type = 5,subtype = 10,level = 350,color = 1,bag_location = loc(5,10)};
get(24006102) ->
	#ets_goods_type{goods_id = 24006102,goods_name = "秩序耳饰",bind = 1,type = 5,subtype = 10,level = 350,color = 2,bag_location = loc(5,10)};
get(24006103) ->
	#ets_goods_type{goods_id = 24006103,goods_name = "秩序耳饰",bind = 1,type = 5,subtype = 10,level = 350,color = 3,trade_price = 400,price_markup = 100,buyout_price = 800,selling_time = 60,bag_location = loc(5,10)};
get(24006104) ->
	#ets_goods_type{goods_id = 24006104,goods_name = "秩序耳饰",bind = 1,type = 5,subtype = 10,level = 350,color = 4,trade_price = 400,price_markup = 100,buyout_price = 800,market_show_time = 60,selling_time = 120,bag_location = loc(5,10)};
get(24101010) ->
	#ets_goods_type{goods_id = 24101010,goods_name = "潮牌唐刀",bind = 1,type = 5,subtype = 1,level = 1,bag_location = loc(5,1)};
get(24101011) ->
	#ets_goods_type{goods_id = 24101011,goods_name = "潮牌唐刀",bind = 1,type = 5,subtype = 1,level = 1,color = 1,bag_location = loc(5,1)};
get(24101012) ->
	#ets_goods_type{goods_id = 24101012,goods_name = "潮牌唐刀",bind = 1,type = 5,subtype = 1,level = 1,color = 2,bag_location = loc(5,1)};
get(24101013) ->
	#ets_goods_type{goods_id = 24101013,goods_name = "潮牌唐刀",type = 5,subtype = 1,level = 1,color = 3,sell_category = 3,sell_subcategory = 1,buyout_price = 400,selling_time = 7200,bag_location = loc(5,1)};
get(24101014) ->
	#ets_goods_type{goods_id = 24101014,goods_name = "潮牌唐刀",type = 5,subtype = 1,level = 1,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24101020) ->
	#ets_goods_type{goods_id = 24101020,goods_name = "潮牌帽子",bind = 1,type = 5,subtype = 2,level = 1,bag_location = loc(5,2)};
get(24101021) ->
	#ets_goods_type{goods_id = 24101021,goods_name = "潮牌帽子",bind = 1,type = 5,subtype = 2,level = 1,color = 1,bag_location = loc(5,2)};
get(24101022) ->
	#ets_goods_type{goods_id = 24101022,goods_name = "潮牌帽子",bind = 1,type = 5,subtype = 2,level = 1,color = 2,bag_location = loc(5,2)};
get(24101023) ->
	#ets_goods_type{goods_id = 24101023,goods_name = "潮牌帽子",type = 5,subtype = 2,level = 1,color = 3,sell_category = 1,sell_subcategory = 1,buyout_price = 400,selling_time = 7200,bag_location = loc(5,2)};
get(24101024) ->
	#ets_goods_type{goods_id = 24101024,goods_name = "潮牌帽子",type = 5,subtype = 2,level = 1,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,2)};
get(24101030) ->
	#ets_goods_type{goods_id = 24101030,goods_name = "潮牌上衣",bind = 1,type = 5,subtype = 3,level = 1,bag_location = loc(5,3)};
get(24101031) ->
	#ets_goods_type{goods_id = 24101031,goods_name = "潮牌上衣",bind = 1,type = 5,subtype = 3,level = 1,color = 1,bag_location = loc(5,3)};
get(24101032) ->
	#ets_goods_type{goods_id = 24101032,goods_name = "潮牌上衣",bind = 1,type = 5,subtype = 3,level = 1,color = 2,bag_location = loc(5,3)};
get(24101033) ->
	#ets_goods_type{goods_id = 24101033,goods_name = "潮牌上衣",type = 5,subtype = 3,level = 1,color = 3,sell_category = 1,sell_subcategory = 2,buyout_price = 400,selling_time = 7200,bag_location = loc(5,3)};
get(24101034) ->
	#ets_goods_type{goods_id = 24101034,goods_name = "潮牌上衣",type = 5,subtype = 3,level = 1,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,3)};
get(24101040) ->
	#ets_goods_type{goods_id = 24101040,goods_name = "潮牌外套",bind = 1,type = 5,subtype = 4,level = 1,bag_location = loc(5,4)};
get(24101041) ->
	#ets_goods_type{goods_id = 24101041,goods_name = "潮牌外套",bind = 1,type = 5,subtype = 4,level = 1,color = 1,bag_location = loc(5,4)};
get(24101042) ->
	#ets_goods_type{goods_id = 24101042,goods_name = "潮牌外套",bind = 1,type = 5,subtype = 4,level = 1,color = 2,bag_location = loc(5,4)};
get(24101043) ->
	#ets_goods_type{goods_id = 24101043,goods_name = "潮牌外套",type = 5,subtype = 4,level = 1,color = 3,sell_category = 1,sell_subcategory = 3,buyout_price = 400,selling_time = 7200,bag_location = loc(5,4)};
get(24101044) ->
	#ets_goods_type{goods_id = 24101044,goods_name = "潮牌外套",type = 5,subtype = 4,level = 1,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,4)};
get(24101050) ->
	#ets_goods_type{goods_id = 24101050,goods_name = "潮牌手套",bind = 1,type = 5,subtype = 5,level = 1,bag_location = loc(5,5)};
get(24101051) ->
	#ets_goods_type{goods_id = 24101051,goods_name = "潮牌护腕",bind = 1,type = 5,subtype = 5,level = 1,color = 1,bag_location = loc(5,5)};
get(24101052) ->
	#ets_goods_type{goods_id = 24101052,goods_name = "潮牌手套",bind = 1,type = 5,subtype = 5,level = 1,color = 2,bag_location = loc(5,5)};
get(24101053) ->
	#ets_goods_type{goods_id = 24101053,goods_name = "潮牌手套",type = 5,subtype = 5,level = 1,color = 3,sell_category = 1,sell_subcategory = 4,buyout_price = 400,selling_time = 7200,bag_location = loc(5,5)};
get(24101054) ->
	#ets_goods_type{goods_id = 24101054,goods_name = "潮牌手套",type = 5,subtype = 5,level = 1,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,5)};
get(24101060) ->
	#ets_goods_type{goods_id = 24101060,goods_name = "潮牌裤子",bind = 1,type = 5,subtype = 6,level = 1,bag_location = loc(5,6)};
get(24101061) ->
	#ets_goods_type{goods_id = 24101061,goods_name = "潮牌裤子",bind = 1,type = 5,subtype = 6,level = 1,color = 1,bag_location = loc(5,6)};
get(24101062) ->
	#ets_goods_type{goods_id = 24101062,goods_name = "潮牌裤子",bind = 1,type = 5,subtype = 6,level = 1,color = 2,bag_location = loc(5,6)};
get(24101063) ->
	#ets_goods_type{goods_id = 24101063,goods_name = "潮牌裤子",type = 5,subtype = 6,level = 1,color = 3,sell_category = 1,sell_subcategory = 5,buyout_price = 400,selling_time = 7200,bag_location = loc(5,6)};
get(24101064) ->
	#ets_goods_type{goods_id = 24101064,goods_name = "潮牌裤子",type = 5,subtype = 6,level = 1,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,6)};
get(24101070) ->
	#ets_goods_type{goods_id = 24101070,goods_name = "潮牌鞋子",bind = 1,type = 5,subtype = 7,level = 1,bag_location = loc(5,7)};
get(24101071) ->
	#ets_goods_type{goods_id = 24101071,goods_name = "潮牌鞋子",bind = 1,type = 5,subtype = 7,level = 1,color = 1,bag_location = loc(5,7)};
get(24101072) ->
	#ets_goods_type{goods_id = 24101072,goods_name = "潮牌鞋子",bind = 1,type = 5,subtype = 7,level = 1,color = 2,bag_location = loc(5,7)};
get(24101073) ->
	#ets_goods_type{goods_id = 24101073,goods_name = "潮牌鞋子",type = 5,subtype = 7,level = 1,color = 3,sell_category = 1,sell_subcategory = 6,buyout_price = 400,selling_time = 7200,bag_location = loc(5,7)};
get(24101074) ->
	#ets_goods_type{goods_id = 24101074,goods_name = "潮牌鞋子",type = 5,subtype = 7,level = 1,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,7)};
get(24102010) ->
	#ets_goods_type{goods_id = 24102010,goods_name = "新星唐刀",bind = 1,type = 5,subtype = 1,level = 115,bag_location = loc(5,1)};
get(24102011) ->
	#ets_goods_type{goods_id = 24102011,goods_name = "新星唐刀",bind = 1,type = 5,subtype = 1,level = 115,color = 1,bag_location = loc(5,1)};
get(24102012) ->
	#ets_goods_type{goods_id = 24102012,goods_name = "新星唐刀",bind = 1,type = 5,subtype = 1,level = 115,color = 2,bag_location = loc(5,1)};
get(24102013) ->
	#ets_goods_type{goods_id = 24102013,goods_name = "新星唐刀",type = 5,subtype = 1,level = 115,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,1)};
get(24102014) ->
	#ets_goods_type{goods_id = 24102014,goods_name = "新星唐刀",type = 5,subtype = 1,level = 115,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24102020) ->
	#ets_goods_type{goods_id = 24102020,goods_name = "新星帽子",bind = 1,type = 5,subtype = 2,level = 115,bag_location = loc(5,2)};
get(24102021) ->
	#ets_goods_type{goods_id = 24102021,goods_name = "新星帽子",bind = 1,type = 5,subtype = 2,level = 115,color = 1,bag_location = loc(5,2)};
get(24102022) ->
	#ets_goods_type{goods_id = 24102022,goods_name = "新星帽子",bind = 1,type = 5,subtype = 2,level = 115,color = 2,bag_location = loc(5,2)};
get(24102023) ->
	#ets_goods_type{goods_id = 24102023,goods_name = "新星帽子",type = 5,subtype = 2,level = 115,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,2)};
get(24102024) ->
	#ets_goods_type{goods_id = 24102024,goods_name = "新星帽子",type = 5,subtype = 2,level = 115,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,bag_location = loc(5,2)};
get(24102030) ->
	#ets_goods_type{goods_id = 24102030,goods_name = "新星上衣",bind = 1,type = 5,subtype = 3,level = 115,bag_location = loc(5,3)};
get(24102031) ->
	#ets_goods_type{goods_id = 24102031,goods_name = "新星上衣",bind = 1,type = 5,subtype = 3,level = 115,color = 1,bag_location = loc(5,3)};
get(24102032) ->
	#ets_goods_type{goods_id = 24102032,goods_name = "新星上衣",bind = 1,type = 5,subtype = 3,level = 115,color = 2,bag_location = loc(5,3)};
get(24102033) ->
	#ets_goods_type{goods_id = 24102033,goods_name = "新星上衣",type = 5,subtype = 3,level = 115,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,3)};
get(24102034) ->
	#ets_goods_type{goods_id = 24102034,goods_name = "新星上衣",type = 5,subtype = 3,level = 115,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,bag_location = loc(5,3)};
get(24102040) ->
	#ets_goods_type{goods_id = 24102040,goods_name = "新星外套",bind = 1,type = 5,subtype = 4,level = 115,bag_location = loc(5,4)};
get(24102041) ->
	#ets_goods_type{goods_id = 24102041,goods_name = "新星外套",bind = 1,type = 5,subtype = 4,level = 115,color = 1,bag_location = loc(5,4)};
get(24102042) ->
	#ets_goods_type{goods_id = 24102042,goods_name = "新星外套",bind = 1,type = 5,subtype = 4,level = 115,color = 2,bag_location = loc(5,4)};
get(24102043) ->
	#ets_goods_type{goods_id = 24102043,goods_name = "新星外套",type = 5,subtype = 4,level = 115,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,4)};
get(24102044) ->
	#ets_goods_type{goods_id = 24102044,goods_name = "新星外套",type = 5,subtype = 4,level = 115,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,bag_location = loc(5,4)};
get(24102050) ->
	#ets_goods_type{goods_id = 24102050,goods_name = "新星手套",bind = 1,type = 5,subtype = 5,level = 115,bag_location = loc(5,5)};
get(24102051) ->
	#ets_goods_type{goods_id = 24102051,goods_name = "新星手套",bind = 1,type = 5,subtype = 5,level = 115,color = 1,bag_location = loc(5,5)};
get(24102052) ->
	#ets_goods_type{goods_id = 24102052,goods_name = "新星手套",bind = 1,type = 5,subtype = 5,level = 115,color = 2,bag_location = loc(5,5)};
get(24102053) ->
	#ets_goods_type{goods_id = 24102053,goods_name = "新星手套",type = 5,subtype = 5,level = 115,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,5)};
get(24102054) ->
	#ets_goods_type{goods_id = 24102054,goods_name = "新星手套",type = 5,subtype = 5,level = 115,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,bag_location = loc(5,5)};
get(24102060) ->
	#ets_goods_type{goods_id = 24102060,goods_name = "新星裤子",bind = 1,type = 5,subtype = 6,level = 115,bag_location = loc(5,6)};
get(24102061) ->
	#ets_goods_type{goods_id = 24102061,goods_name = "新星裤子",bind = 1,type = 5,subtype = 6,level = 115,color = 1,bag_location = loc(5,6)};
get(24102062) ->
	#ets_goods_type{goods_id = 24102062,goods_name = "新星裤子",bind = 1,type = 5,subtype = 6,level = 115,color = 2,bag_location = loc(5,6)};
get(24102063) ->
	#ets_goods_type{goods_id = 24102063,goods_name = "新星裤子",type = 5,subtype = 6,level = 115,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,6)};
get(24102064) ->
	#ets_goods_type{goods_id = 24102064,goods_name = "新星裤子",type = 5,subtype = 6,level = 115,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,bag_location = loc(5,6)};
get(24102070) ->
	#ets_goods_type{goods_id = 24102070,goods_name = "新星鞋子",bind = 1,type = 5,subtype = 7,level = 115,bag_location = loc(5,7)};
get(24102071) ->
	#ets_goods_type{goods_id = 24102071,goods_name = "新星鞋子",bind = 1,type = 5,subtype = 7,level = 115,color = 1,bag_location = loc(5,7)};
get(24102072) ->
	#ets_goods_type{goods_id = 24102072,goods_name = "新星鞋子",bind = 1,type = 5,subtype = 7,level = 115,color = 2,bag_location = loc(5,7)};
get(24102073) ->
	#ets_goods_type{goods_id = 24102073,goods_name = "新星鞋子",type = 5,subtype = 7,level = 115,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,7)};
get(24102074) ->
	#ets_goods_type{goods_id = 24102074,goods_name = "新星鞋子",type = 5,subtype = 7,level = 115,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,bag_location = loc(5,7)};
get(24103010) ->
	#ets_goods_type{goods_id = 24103010,goods_name = "量子唐刀",bind = 1,type = 5,subtype = 1,level = 145,bag_location = loc(5,1)};
get(24103011) ->
	#ets_goods_type{goods_id = 24103011,goods_name = "量子唐刀",bind = 1,type = 5,subtype = 1,level = 145,color = 1,bag_location = loc(5,1)};
get(24103012) ->
	#ets_goods_type{goods_id = 24103012,goods_name = "量子唐刀",bind = 1,type = 5,subtype = 1,level = 145,color = 2,bag_location = loc(5,1)};
get(24103013) ->
	#ets_goods_type{goods_id = 24103013,goods_name = "量子唐刀",type = 5,subtype = 1,level = 145,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,1)};
get(24103014) ->
	#ets_goods_type{goods_id = 24103014,goods_name = "量子唐刀",type = 5,subtype = 1,level = 145,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,bag_location = loc(5,1)};
get(24103020) ->
	#ets_goods_type{goods_id = 24103020,goods_name = "量子帽子",bind = 1,type = 5,subtype = 2,level = 145,bag_location = loc(5,2)};
get(24103021) ->
	#ets_goods_type{goods_id = 24103021,goods_name = "量子帽子",bind = 1,type = 5,subtype = 2,level = 145,color = 1,bag_location = loc(5,2)};
get(24103022) ->
	#ets_goods_type{goods_id = 24103022,goods_name = "量子帽子",bind = 1,type = 5,subtype = 2,level = 145,color = 2,bag_location = loc(5,2)};
get(24103023) ->
	#ets_goods_type{goods_id = 24103023,goods_name = "量子帽子",type = 5,subtype = 2,level = 145,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,2)};
get(24103024) ->
	#ets_goods_type{goods_id = 24103024,goods_name = "量子帽子",type = 5,subtype = 2,level = 145,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,bag_location = loc(5,2)};
get(24103030) ->
	#ets_goods_type{goods_id = 24103030,goods_name = "量子上衣",bind = 1,type = 5,subtype = 3,level = 145,bag_location = loc(5,3)};
get(24103031) ->
	#ets_goods_type{goods_id = 24103031,goods_name = "量子上衣",bind = 1,type = 5,subtype = 3,level = 145,color = 1,bag_location = loc(5,3)};
get(24103032) ->
	#ets_goods_type{goods_id = 24103032,goods_name = "量子上衣",bind = 1,type = 5,subtype = 3,level = 145,color = 2,bag_location = loc(5,3)};
get(24103033) ->
	#ets_goods_type{goods_id = 24103033,goods_name = "量子上衣",type = 5,subtype = 3,level = 145,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,3)};
get(24103034) ->
	#ets_goods_type{goods_id = 24103034,goods_name = "量子上衣",type = 5,subtype = 3,level = 145,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,bag_location = loc(5,3)};
get(24103040) ->
	#ets_goods_type{goods_id = 24103040,goods_name = "量子外套",bind = 1,type = 5,subtype = 4,level = 145,bag_location = loc(5,4)};
get(24103041) ->
	#ets_goods_type{goods_id = 24103041,goods_name = "量子外套",bind = 1,type = 5,subtype = 4,level = 145,color = 1,bag_location = loc(5,4)};
get(24103042) ->
	#ets_goods_type{goods_id = 24103042,goods_name = "量子外套",bind = 1,type = 5,subtype = 4,level = 145,color = 2,bag_location = loc(5,4)};
get(24103043) ->
	#ets_goods_type{goods_id = 24103043,goods_name = "量子外套",type = 5,subtype = 4,level = 145,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,4)};
get(24103044) ->
	#ets_goods_type{goods_id = 24103044,goods_name = "量子外套",type = 5,subtype = 4,level = 145,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,bag_location = loc(5,4)};
get(24103050) ->
	#ets_goods_type{goods_id = 24103050,goods_name = "量子手套",bind = 1,type = 5,subtype = 5,level = 145,bag_location = loc(5,5)};
get(24103051) ->
	#ets_goods_type{goods_id = 24103051,goods_name = "量子手套",bind = 1,type = 5,subtype = 5,level = 145,color = 1,bag_location = loc(5,5)};
get(24103052) ->
	#ets_goods_type{goods_id = 24103052,goods_name = "量子手套",bind = 1,type = 5,subtype = 5,level = 145,color = 2,bag_location = loc(5,5)};
get(24103053) ->
	#ets_goods_type{goods_id = 24103053,goods_name = "量子手套",type = 5,subtype = 5,level = 145,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,5)};
get(24103054) ->
	#ets_goods_type{goods_id = 24103054,goods_name = "量子手套",type = 5,subtype = 5,level = 145,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,bag_location = loc(5,5)};
get(24103060) ->
	#ets_goods_type{goods_id = 24103060,goods_name = "量子裤子",bind = 1,type = 5,subtype = 6,level = 145,bag_location = loc(5,6)};
get(24103061) ->
	#ets_goods_type{goods_id = 24103061,goods_name = "量子裤子",bind = 1,type = 5,subtype = 6,level = 145,color = 1,bag_location = loc(5,6)};
get(24103062) ->
	#ets_goods_type{goods_id = 24103062,goods_name = "量子裤子",bind = 1,type = 5,subtype = 6,level = 145,color = 2,bag_location = loc(5,6)};
get(24103063) ->
	#ets_goods_type{goods_id = 24103063,goods_name = "量子裤子",type = 5,subtype = 6,level = 145,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,6)};
get(24103064) ->
	#ets_goods_type{goods_id = 24103064,goods_name = "量子裤子",type = 5,subtype = 6,level = 145,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,bag_location = loc(5,6)};
get(24103070) ->
	#ets_goods_type{goods_id = 24103070,goods_name = "量子鞋子",bind = 1,type = 5,subtype = 7,level = 145,bag_location = loc(5,7)};
get(24103071) ->
	#ets_goods_type{goods_id = 24103071,goods_name = "量子鞋子",bind = 1,type = 5,subtype = 7,level = 145,color = 1,bag_location = loc(5,7)};
get(24103072) ->
	#ets_goods_type{goods_id = 24103072,goods_name = "量子鞋子",bind = 1,type = 5,subtype = 7,level = 145,color = 2,bag_location = loc(5,7)};
get(24103073) ->
	#ets_goods_type{goods_id = 24103073,goods_name = "量子鞋子",type = 5,subtype = 7,level = 145,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,7)};
get(24103074) ->
	#ets_goods_type{goods_id = 24103074,goods_name = "量子鞋子",type = 5,subtype = 7,level = 145,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,bag_location = loc(5,7)};
get(24104010) ->
	#ets_goods_type{goods_id = 24104010,goods_name = "宵暗唐刀",bind = 1,type = 5,subtype = 1,level = 175,bag_location = loc(5,1)};
get(24104011) ->
	#ets_goods_type{goods_id = 24104011,goods_name = "宵暗唐刀",bind = 1,type = 5,subtype = 1,level = 175,color = 1,bag_location = loc(5,1)};
get(24104012) ->
	#ets_goods_type{goods_id = 24104012,goods_name = "宵暗唐刀",bind = 1,type = 5,subtype = 1,level = 175,color = 2,bag_location = loc(5,1)};
get(24104013) ->
	#ets_goods_type{goods_id = 24104013,goods_name = "宵暗唐刀",type = 5,subtype = 1,level = 175,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,1)};
get(24104014) ->
	#ets_goods_type{goods_id = 24104014,goods_name = "宵暗唐刀",type = 5,subtype = 1,level = 175,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,bag_location = loc(5,1)};
get(24104020) ->
	#ets_goods_type{goods_id = 24104020,goods_name = "宵暗帽子",bind = 1,type = 5,subtype = 2,level = 175,bag_location = loc(5,2)};
get(24104021) ->
	#ets_goods_type{goods_id = 24104021,goods_name = "宵暗帽子",bind = 1,type = 5,subtype = 2,level = 175,color = 1,bag_location = loc(5,2)};
get(24104022) ->
	#ets_goods_type{goods_id = 24104022,goods_name = "宵暗帽子",bind = 1,type = 5,subtype = 2,level = 175,color = 2,bag_location = loc(5,2)};
get(24104023) ->
	#ets_goods_type{goods_id = 24104023,goods_name = "宵暗帽子",type = 5,subtype = 2,level = 175,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,2)};
get(24104024) ->
	#ets_goods_type{goods_id = 24104024,goods_name = "宵暗帽子",type = 5,subtype = 2,level = 175,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,bag_location = loc(5,2)};
get(24104030) ->
	#ets_goods_type{goods_id = 24104030,goods_name = "宵暗上衣",bind = 1,type = 5,subtype = 3,level = 175,bag_location = loc(5,3)};
get(24104031) ->
	#ets_goods_type{goods_id = 24104031,goods_name = "宵暗上衣",bind = 1,type = 5,subtype = 3,level = 175,color = 1,bag_location = loc(5,3)};
get(24104032) ->
	#ets_goods_type{goods_id = 24104032,goods_name = "宵暗上衣",bind = 1,type = 5,subtype = 3,level = 175,color = 2,bag_location = loc(5,3)};
get(24104033) ->
	#ets_goods_type{goods_id = 24104033,goods_name = "宵暗上衣",type = 5,subtype = 3,level = 175,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,3)};
get(24104034) ->
	#ets_goods_type{goods_id = 24104034,goods_name = "宵暗上衣",type = 5,subtype = 3,level = 175,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,bag_location = loc(5,3)};
get(24104040) ->
	#ets_goods_type{goods_id = 24104040,goods_name = "宵暗外套",bind = 1,type = 5,subtype = 4,level = 175,bag_location = loc(5,4)};
get(24104041) ->
	#ets_goods_type{goods_id = 24104041,goods_name = "宵暗外套",bind = 1,type = 5,subtype = 4,level = 175,color = 1,bag_location = loc(5,4)};
get(24104042) ->
	#ets_goods_type{goods_id = 24104042,goods_name = "宵暗外套",bind = 1,type = 5,subtype = 4,level = 175,color = 2,bag_location = loc(5,4)};
get(24104043) ->
	#ets_goods_type{goods_id = 24104043,goods_name = "宵暗外套",type = 5,subtype = 4,level = 175,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,4)};
get(24104044) ->
	#ets_goods_type{goods_id = 24104044,goods_name = "宵暗外套",type = 5,subtype = 4,level = 175,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,bag_location = loc(5,4)};
get(24104050) ->
	#ets_goods_type{goods_id = 24104050,goods_name = "宵暗手套",bind = 1,type = 5,subtype = 5,level = 175,bag_location = loc(5,5)};
get(24104051) ->
	#ets_goods_type{goods_id = 24104051,goods_name = "宵暗手套",bind = 1,type = 5,subtype = 5,level = 175,color = 1,bag_location = loc(5,5)};
get(24104052) ->
	#ets_goods_type{goods_id = 24104052,goods_name = "宵暗手套",bind = 1,type = 5,subtype = 5,level = 175,color = 2,bag_location = loc(5,5)};
get(24104053) ->
	#ets_goods_type{goods_id = 24104053,goods_name = "宵暗手套",type = 5,subtype = 5,level = 175,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,5)};
get(24104054) ->
	#ets_goods_type{goods_id = 24104054,goods_name = "宵暗手套",type = 5,subtype = 5,level = 175,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,bag_location = loc(5,5)};
get(24104060) ->
	#ets_goods_type{goods_id = 24104060,goods_name = "宵暗裤子",bind = 1,type = 5,subtype = 6,level = 175,bag_location = loc(5,6)};
get(24104061) ->
	#ets_goods_type{goods_id = 24104061,goods_name = "宵暗裤子",bind = 1,type = 5,subtype = 6,level = 175,color = 1,bag_location = loc(5,6)};
get(24104062) ->
	#ets_goods_type{goods_id = 24104062,goods_name = "宵暗裤子",bind = 1,type = 5,subtype = 6,level = 175,color = 2,bag_location = loc(5,6)};
get(24104063) ->
	#ets_goods_type{goods_id = 24104063,goods_name = "宵暗裤子",type = 5,subtype = 6,level = 175,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,6)};
get(24104064) ->
	#ets_goods_type{goods_id = 24104064,goods_name = "宵暗裤子",type = 5,subtype = 6,level = 175,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,bag_location = loc(5,6)};
get(24104070) ->
	#ets_goods_type{goods_id = 24104070,goods_name = "宵暗鞋子",bind = 1,type = 5,subtype = 7,level = 175,bag_location = loc(5,7)};
get(24104071) ->
	#ets_goods_type{goods_id = 24104071,goods_name = "宵暗鞋子",bind = 1,type = 5,subtype = 7,level = 175,color = 1,bag_location = loc(5,7)};
get(24104072) ->
	#ets_goods_type{goods_id = 24104072,goods_name = "宵暗鞋子",bind = 1,type = 5,subtype = 7,level = 175,color = 2,bag_location = loc(5,7)};
get(24104073) ->
	#ets_goods_type{goods_id = 24104073,goods_name = "宵暗鞋子",type = 5,subtype = 7,level = 175,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,7)};
get(24104074) ->
	#ets_goods_type{goods_id = 24104074,goods_name = "宵暗鞋子",type = 5,subtype = 7,level = 175,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,bag_location = loc(5,7)};
get(24105010) ->
	#ets_goods_type{goods_id = 24105010,goods_name = "群星唐刀",bind = 1,type = 5,subtype = 1,level = 250,bag_location = loc(5,1)};
get(24105011) ->
	#ets_goods_type{goods_id = 24105011,goods_name = "群星唐刀",bind = 1,type = 5,subtype = 1,level = 250,color = 1,bag_location = loc(5,1)};
get(24105012) ->
	#ets_goods_type{goods_id = 24105012,goods_name = "群星唐刀",bind = 1,type = 5,subtype = 1,level = 250,color = 2,bag_location = loc(5,1)};
get(24105013) ->
	#ets_goods_type{goods_id = 24105013,goods_name = "群星唐刀",type = 5,subtype = 1,level = 250,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,1)};
get(24105014) ->
	#ets_goods_type{goods_id = 24105014,goods_name = "群星唐刀",type = 5,subtype = 1,level = 250,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,bag_location = loc(5,1)};
get(24105020) ->
	#ets_goods_type{goods_id = 24105020,goods_name = "群星帽子",bind = 1,type = 5,subtype = 2,level = 250,bag_location = loc(5,2)};
get(24105021) ->
	#ets_goods_type{goods_id = 24105021,goods_name = "群星帽子",bind = 1,type = 5,subtype = 2,level = 250,color = 1,bag_location = loc(5,2)};
get(24105022) ->
	#ets_goods_type{goods_id = 24105022,goods_name = "群星帽子",bind = 1,type = 5,subtype = 2,level = 250,color = 2,bag_location = loc(5,2)};
get(24105023) ->
	#ets_goods_type{goods_id = 24105023,goods_name = "群星帽子",type = 5,subtype = 2,level = 250,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,2)};
get(24105024) ->
	#ets_goods_type{goods_id = 24105024,goods_name = "群星帽子",type = 5,subtype = 2,level = 250,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,bag_location = loc(5,2)};
get(24105030) ->
	#ets_goods_type{goods_id = 24105030,goods_name = "群星上衣",bind = 1,type = 5,subtype = 3,level = 250,bag_location = loc(5,3)};
get(24105031) ->
	#ets_goods_type{goods_id = 24105031,goods_name = "群星上衣",bind = 1,type = 5,subtype = 3,level = 250,color = 1,bag_location = loc(5,3)};
get(24105032) ->
	#ets_goods_type{goods_id = 24105032,goods_name = "群星上衣",bind = 1,type = 5,subtype = 3,level = 250,color = 2,bag_location = loc(5,3)};
get(24105033) ->
	#ets_goods_type{goods_id = 24105033,goods_name = "群星上衣",type = 5,subtype = 3,level = 250,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,3)};
get(24105034) ->
	#ets_goods_type{goods_id = 24105034,goods_name = "群星上衣",type = 5,subtype = 3,level = 250,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,bag_location = loc(5,3)};
get(24105040) ->
	#ets_goods_type{goods_id = 24105040,goods_name = "群星外套",bind = 1,type = 5,subtype = 4,level = 250,bag_location = loc(5,4)};
get(24105041) ->
	#ets_goods_type{goods_id = 24105041,goods_name = "群星外套",bind = 1,type = 5,subtype = 4,level = 250,color = 1,bag_location = loc(5,4)};
get(24105042) ->
	#ets_goods_type{goods_id = 24105042,goods_name = "群星外套",bind = 1,type = 5,subtype = 4,level = 250,color = 2,bag_location = loc(5,4)};
get(24105043) ->
	#ets_goods_type{goods_id = 24105043,goods_name = "群星外套",type = 5,subtype = 4,level = 250,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,4)};
get(24105044) ->
	#ets_goods_type{goods_id = 24105044,goods_name = "群星外套",type = 5,subtype = 4,level = 250,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,bag_location = loc(5,4)};
get(24105050) ->
	#ets_goods_type{goods_id = 24105050,goods_name = "群星手套",bind = 1,type = 5,subtype = 5,level = 250,bag_location = loc(5,5)};
get(24105051) ->
	#ets_goods_type{goods_id = 24105051,goods_name = "群星手套",bind = 1,type = 5,subtype = 5,level = 250,color = 1,bag_location = loc(5,5)};
get(24105052) ->
	#ets_goods_type{goods_id = 24105052,goods_name = "群星手套",bind = 1,type = 5,subtype = 5,level = 250,color = 2,bag_location = loc(5,5)};
get(24105053) ->
	#ets_goods_type{goods_id = 24105053,goods_name = "群星手套",type = 5,subtype = 5,level = 250,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,5)};
get(24105054) ->
	#ets_goods_type{goods_id = 24105054,goods_name = "群星手套",type = 5,subtype = 5,level = 250,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,bag_location = loc(5,5)};
get(24105060) ->
	#ets_goods_type{goods_id = 24105060,goods_name = "群星裤子",bind = 1,type = 5,subtype = 6,level = 250,bag_location = loc(5,6)};
get(24105061) ->
	#ets_goods_type{goods_id = 24105061,goods_name = "群星裤子",bind = 1,type = 5,subtype = 6,level = 250,color = 1,bag_location = loc(5,6)};
get(24105062) ->
	#ets_goods_type{goods_id = 24105062,goods_name = "群星裤子",bind = 1,type = 5,subtype = 6,level = 250,color = 2,bag_location = loc(5,6)};
get(24105063) ->
	#ets_goods_type{goods_id = 24105063,goods_name = "群星裤子",type = 5,subtype = 6,level = 250,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,6)};
get(24105064) ->
	#ets_goods_type{goods_id = 24105064,goods_name = "群星裤子",type = 5,subtype = 6,level = 250,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,bag_location = loc(5,6)};
get(24105070) ->
	#ets_goods_type{goods_id = 24105070,goods_name = "群星鞋子",bind = 1,type = 5,subtype = 7,level = 250,bag_location = loc(5,7)};
get(24105071) ->
	#ets_goods_type{goods_id = 24105071,goods_name = "群星鞋子",bind = 1,type = 5,subtype = 7,level = 250,color = 1,bag_location = loc(5,7)};
get(24105072) ->
	#ets_goods_type{goods_id = 24105072,goods_name = "群星鞋子",bind = 1,type = 5,subtype = 7,level = 250,color = 2,bag_location = loc(5,7)};
get(24105073) ->
	#ets_goods_type{goods_id = 24105073,goods_name = "群星鞋子",type = 5,subtype = 7,level = 250,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,7)};
get(24105074) ->
	#ets_goods_type{goods_id = 24105074,goods_name = "群星鞋子",type = 5,subtype = 7,level = 250,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,bag_location = loc(5,7)};
get(24106010) ->
	#ets_goods_type{goods_id = 24106010,goods_name = "秩序唐刀",bind = 1,type = 5,subtype = 1,level = 350,bag_location = loc(5,1)};
get(24106011) ->
	#ets_goods_type{goods_id = 24106011,goods_name = "秩序唐刀",bind = 1,type = 5,subtype = 1,level = 350,color = 1,bag_location = loc(5,1)};
get(24106012) ->
	#ets_goods_type{goods_id = 24106012,goods_name = "秩序唐刀",bind = 1,type = 5,subtype = 1,level = 350,color = 2,bag_location = loc(5,1)};
get(24106013) ->
	#ets_goods_type{goods_id = 24106013,goods_name = "秩序唐刀",type = 5,subtype = 1,level = 350,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,1)};
get(24106014) ->
	#ets_goods_type{goods_id = 24106014,goods_name = "秩序唐刀",type = 5,subtype = 1,level = 350,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,bag_location = loc(5,1)};
get(24106020) ->
	#ets_goods_type{goods_id = 24106020,goods_name = "秩序帽子",bind = 1,type = 5,subtype = 2,level = 350,bag_location = loc(5,2)};
get(24106021) ->
	#ets_goods_type{goods_id = 24106021,goods_name = "秩序帽子",bind = 1,type = 5,subtype = 2,level = 350,color = 1,bag_location = loc(5,2)};
get(24106022) ->
	#ets_goods_type{goods_id = 24106022,goods_name = "秩序帽子",bind = 1,type = 5,subtype = 2,level = 350,color = 2,bag_location = loc(5,2)};
get(24106023) ->
	#ets_goods_type{goods_id = 24106023,goods_name = "秩序帽子",type = 5,subtype = 2,level = 350,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,2)};
get(24106024) ->
	#ets_goods_type{goods_id = 24106024,goods_name = "秩序帽子",type = 5,subtype = 2,level = 350,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,bag_location = loc(5,2)};
get(24106030) ->
	#ets_goods_type{goods_id = 24106030,goods_name = "秩序上衣",bind = 1,type = 5,subtype = 3,level = 350,bag_location = loc(5,3)};
get(24106031) ->
	#ets_goods_type{goods_id = 24106031,goods_name = "秩序上衣",bind = 1,type = 5,subtype = 3,level = 350,color = 1,bag_location = loc(5,3)};
get(24106032) ->
	#ets_goods_type{goods_id = 24106032,goods_name = "秩序上衣",bind = 1,type = 5,subtype = 3,level = 350,color = 2,bag_location = loc(5,3)};
get(24106033) ->
	#ets_goods_type{goods_id = 24106033,goods_name = "秩序上衣",type = 5,subtype = 3,level = 350,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,3)};
get(24106034) ->
	#ets_goods_type{goods_id = 24106034,goods_name = "秩序上衣",type = 5,subtype = 3,level = 350,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,bag_location = loc(5,3)};
get(24106040) ->
	#ets_goods_type{goods_id = 24106040,goods_name = "秩序外套",bind = 1,type = 5,subtype = 4,level = 350,bag_location = loc(5,4)};
get(24106041) ->
	#ets_goods_type{goods_id = 24106041,goods_name = "秩序外套",bind = 1,type = 5,subtype = 4,level = 350,color = 1,bag_location = loc(5,4)};
get(24106042) ->
	#ets_goods_type{goods_id = 24106042,goods_name = "秩序外套",bind = 1,type = 5,subtype = 4,level = 350,color = 2,bag_location = loc(5,4)};
get(24106043) ->
	#ets_goods_type{goods_id = 24106043,goods_name = "秩序外套",type = 5,subtype = 4,level = 350,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,4)};
get(24106044) ->
	#ets_goods_type{goods_id = 24106044,goods_name = "秩序外套",type = 5,subtype = 4,level = 350,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,bag_location = loc(5,4)};
get(24106050) ->
	#ets_goods_type{goods_id = 24106050,goods_name = "秩序手套",bind = 1,type = 5,subtype = 5,level = 350,bag_location = loc(5,5)};
get(24106051) ->
	#ets_goods_type{goods_id = 24106051,goods_name = "秩序手套",bind = 1,type = 5,subtype = 5,level = 350,color = 1,bag_location = loc(5,5)};
get(24106052) ->
	#ets_goods_type{goods_id = 24106052,goods_name = "秩序手套",bind = 1,type = 5,subtype = 5,level = 350,color = 2,bag_location = loc(5,5)};
get(24106053) ->
	#ets_goods_type{goods_id = 24106053,goods_name = "秩序手套",type = 5,subtype = 5,level = 350,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,5)};
get(24106054) ->
	#ets_goods_type{goods_id = 24106054,goods_name = "秩序手套",type = 5,subtype = 5,level = 350,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,bag_location = loc(5,5)};
get(24106060) ->
	#ets_goods_type{goods_id = 24106060,goods_name = "秩序裤子",bind = 1,type = 5,subtype = 6,level = 350,bag_location = loc(5,6)};
get(24106061) ->
	#ets_goods_type{goods_id = 24106061,goods_name = "秩序裤子",bind = 1,type = 5,subtype = 6,level = 350,color = 1,bag_location = loc(5,6)};
get(24106062) ->
	#ets_goods_type{goods_id = 24106062,goods_name = "秩序裤子",bind = 1,type = 5,subtype = 6,level = 350,color = 2,bag_location = loc(5,6)};
get(24106063) ->
	#ets_goods_type{goods_id = 24106063,goods_name = "秩序裤子",type = 5,subtype = 6,level = 350,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,6)};
get(24106064) ->
	#ets_goods_type{goods_id = 24106064,goods_name = "秩序裤子",type = 5,subtype = 6,level = 350,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,bag_location = loc(5,6)};
get(24106070) ->
	#ets_goods_type{goods_id = 24106070,goods_name = "秩序鞋子",bind = 1,type = 5,subtype = 7,level = 350,bag_location = loc(5,7)};
get(24106071) ->
	#ets_goods_type{goods_id = 24106071,goods_name = "秩序鞋子",bind = 1,type = 5,subtype = 7,level = 350,color = 1,bag_location = loc(5,7)};
get(24106072) ->
	#ets_goods_type{goods_id = 24106072,goods_name = "秩序鞋子",bind = 1,type = 5,subtype = 7,level = 350,color = 2,bag_location = loc(5,7)};
get(24106073) ->
	#ets_goods_type{goods_id = 24106073,goods_name = "秩序鞋子",type = 5,subtype = 7,level = 350,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,7)};
get(24106074) ->
	#ets_goods_type{goods_id = 24106074,goods_name = "秩序鞋子",type = 5,subtype = 7,level = 350,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,bag_location = loc(5,7)};
get(24191014) ->
	#ets_goods_type{goods_id = 24191014,goods_name = "潮牌唐刀",type = 5,subtype = 1,level = 1,color = 4,bag_location = loc(5,1)};
get(24191015) ->
	#ets_goods_type{goods_id = 24191015,goods_name = "绝版·潮牌唐刀",type = 5,subtype = 1,level = 1,color = 5,bag_location = loc(5,1)};
get(24191024) ->
	#ets_goods_type{goods_id = 24191024,goods_name = "潮牌帽子",type = 5,subtype = 2,level = 1,color = 4,bag_location = loc(5,2)};
get(24191034) ->
	#ets_goods_type{goods_id = 24191034,goods_name = "潮牌上衣",type = 5,subtype = 3,level = 1,color = 4,bag_location = loc(5,3)};
get(24191044) ->
	#ets_goods_type{goods_id = 24191044,goods_name = "潮牌外套",type = 5,subtype = 4,level = 1,color = 4,bag_location = loc(5,4)};
get(24191054) ->
	#ets_goods_type{goods_id = 24191054,goods_name = "潮牌手套",type = 5,subtype = 5,level = 1,color = 4,bag_location = loc(5,5)};
get(24191064) ->
	#ets_goods_type{goods_id = 24191064,goods_name = "潮牌裤子",type = 5,subtype = 6,level = 1,color = 4,bag_location = loc(5,6)};
get(24191074) ->
	#ets_goods_type{goods_id = 24191074,goods_name = "潮牌鞋子",type = 5,subtype = 7,level = 1,color = 4,bag_location = loc(5,7)};
get(24192014) ->
	#ets_goods_type{goods_id = 24192014,goods_name = "新星唐刀",type = 5,subtype = 1,level = 115,color = 4,bag_location = loc(5,1)};
get(24192024) ->
	#ets_goods_type{goods_id = 24192024,goods_name = "新星帽子",type = 5,subtype = 2,level = 115,color = 4,bag_location = loc(5,2)};
get(24192034) ->
	#ets_goods_type{goods_id = 24192034,goods_name = "新星上衣",type = 5,subtype = 3,level = 115,color = 4,bag_location = loc(5,3)};
get(24192044) ->
	#ets_goods_type{goods_id = 24192044,goods_name = "新星外套",type = 5,subtype = 4,level = 115,color = 4,bag_location = loc(5,4)};
get(24192054) ->
	#ets_goods_type{goods_id = 24192054,goods_name = "新星手套",type = 5,subtype = 5,level = 115,color = 4,bag_location = loc(5,5)};
get(24192064) ->
	#ets_goods_type{goods_id = 24192064,goods_name = "新星裤子",type = 5,subtype = 6,level = 115,color = 4,bag_location = loc(5,6)};
get(24192074) ->
	#ets_goods_type{goods_id = 24192074,goods_name = "新星鞋子",type = 5,subtype = 7,level = 115,color = 4,bag_location = loc(5,7)};
get(24201010) ->
	#ets_goods_type{goods_id = 24201010,goods_name = "潮牌双枪",bind = 1,type = 5,subtype = 1,level = 1,bag_location = loc(5,1)};
get(24201011) ->
	#ets_goods_type{goods_id = 24201011,goods_name = "潮牌双枪",bind = 1,type = 5,subtype = 1,level = 1,color = 1,bag_location = loc(5,1)};
get(24201012) ->
	#ets_goods_type{goods_id = 24201012,goods_name = "潮牌双枪",bind = 1,type = 5,subtype = 1,level = 1,color = 2,bag_location = loc(5,1)};
get(24201013) ->
	#ets_goods_type{goods_id = 24201013,goods_name = "潮牌双枪",type = 5,subtype = 1,level = 1,color = 3,sell_category = 3,sell_subcategory = 1,buyout_price = 400,selling_time = 7200,bag_location = loc(5,1)};
get(24201014) ->
	#ets_goods_type{goods_id = 24201014,goods_name = "潮牌双枪",type = 5,subtype = 1,level = 1,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24201020) ->
	#ets_goods_type{goods_id = 24201020,goods_name = "潮牌帽子",bind = 1,type = 5,subtype = 2,level = 1,bag_location = loc(5,2)};
get(24201021) ->
	#ets_goods_type{goods_id = 24201021,goods_name = "潮牌帽子",bind = 1,type = 5,subtype = 2,level = 1,color = 1,bag_location = loc(5,2)};
get(24201022) ->
	#ets_goods_type{goods_id = 24201022,goods_name = "潮牌帽子",bind = 1,type = 5,subtype = 2,level = 1,color = 2,bag_location = loc(5,2)};
get(24201023) ->
	#ets_goods_type{goods_id = 24201023,goods_name = "潮牌帽子",type = 5,subtype = 2,level = 1,color = 3,sell_category = 1,sell_subcategory = 1,buyout_price = 400,selling_time = 7200,bag_location = loc(5,2)};
get(24201024) ->
	#ets_goods_type{goods_id = 24201024,goods_name = "潮牌帽子",type = 5,subtype = 2,level = 1,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,2)};
get(24201030) ->
	#ets_goods_type{goods_id = 24201030,goods_name = "潮牌上衣",bind = 1,type = 5,subtype = 3,level = 1,bag_location = loc(5,3)};
get(24201031) ->
	#ets_goods_type{goods_id = 24201031,goods_name = "潮牌上衣",bind = 1,type = 5,subtype = 3,level = 1,color = 1,bag_location = loc(5,3)};
get(24201032) ->
	#ets_goods_type{goods_id = 24201032,goods_name = "潮牌上衣",bind = 1,type = 5,subtype = 3,level = 1,color = 2,bag_location = loc(5,3)};
get(24201033) ->
	#ets_goods_type{goods_id = 24201033,goods_name = "潮牌上衣",type = 5,subtype = 3,level = 1,color = 3,sell_category = 1,sell_subcategory = 2,buyout_price = 400,selling_time = 7200,bag_location = loc(5,3)};
get(24201034) ->
	#ets_goods_type{goods_id = 24201034,goods_name = "潮牌上衣",type = 5,subtype = 3,level = 1,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,3)};
get(24201040) ->
	#ets_goods_type{goods_id = 24201040,goods_name = "潮牌外套",bind = 1,type = 5,subtype = 4,level = 1,bag_location = loc(5,4)};
get(24201041) ->
	#ets_goods_type{goods_id = 24201041,goods_name = "潮牌外套",bind = 1,type = 5,subtype = 4,level = 1,color = 1,bag_location = loc(5,4)};
get(24201042) ->
	#ets_goods_type{goods_id = 24201042,goods_name = "潮牌外套",bind = 1,type = 5,subtype = 4,level = 1,color = 2,bag_location = loc(5,4)};
get(24201043) ->
	#ets_goods_type{goods_id = 24201043,goods_name = "潮牌外套",type = 5,subtype = 4,level = 1,color = 3,sell_category = 1,sell_subcategory = 3,buyout_price = 400,selling_time = 7200,bag_location = loc(5,4)};
get(24201044) ->
	#ets_goods_type{goods_id = 24201044,goods_name = "潮牌外套",type = 5,subtype = 4,level = 1,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,4)};
get(24201050) ->
	#ets_goods_type{goods_id = 24201050,goods_name = "潮牌手套",bind = 1,type = 5,subtype = 5,level = 1,bag_location = loc(5,5)};
get(24201051) ->
	#ets_goods_type{goods_id = 24201051,goods_name = "潮牌护腕",bind = 1,type = 5,subtype = 5,level = 1,color = 1,bag_location = loc(5,5)};
get(24201052) ->
	#ets_goods_type{goods_id = 24201052,goods_name = "潮牌手套",bind = 1,type = 5,subtype = 5,level = 1,color = 2,bag_location = loc(5,5)};
get(24201053) ->
	#ets_goods_type{goods_id = 24201053,goods_name = "潮牌手套",type = 5,subtype = 5,level = 1,color = 3,sell_category = 1,sell_subcategory = 4,buyout_price = 400,selling_time = 7200,bag_location = loc(5,5)};
get(24201054) ->
	#ets_goods_type{goods_id = 24201054,goods_name = "潮牌手套",type = 5,subtype = 5,level = 1,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,5)};
get(24201060) ->
	#ets_goods_type{goods_id = 24201060,goods_name = "潮牌裤子",bind = 1,type = 5,subtype = 6,level = 1,bag_location = loc(5,6)};
get(24201061) ->
	#ets_goods_type{goods_id = 24201061,goods_name = "潮牌裤子",bind = 1,type = 5,subtype = 6,level = 1,color = 1,bag_location = loc(5,6)};
get(24201062) ->
	#ets_goods_type{goods_id = 24201062,goods_name = "潮牌裤子",bind = 1,type = 5,subtype = 6,level = 1,color = 2,bag_location = loc(5,6)};
get(24201063) ->
	#ets_goods_type{goods_id = 24201063,goods_name = "潮牌裤子",type = 5,subtype = 6,level = 1,color = 3,sell_category = 1,sell_subcategory = 5,buyout_price = 400,selling_time = 7200,bag_location = loc(5,6)};
get(24201064) ->
	#ets_goods_type{goods_id = 24201064,goods_name = "潮牌裤子",type = 5,subtype = 6,level = 1,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,6)};
get(24201070) ->
	#ets_goods_type{goods_id = 24201070,goods_name = "潮牌鞋子",bind = 1,type = 5,subtype = 7,level = 1,bag_location = loc(5,7)};
get(24201071) ->
	#ets_goods_type{goods_id = 24201071,goods_name = "潮牌鞋子",bind = 1,type = 5,subtype = 7,level = 1,color = 1,bag_location = loc(5,7)};
get(24201072) ->
	#ets_goods_type{goods_id = 24201072,goods_name = "潮牌鞋子",bind = 1,type = 5,subtype = 7,level = 1,color = 2,bag_location = loc(5,7)};
get(24201073) ->
	#ets_goods_type{goods_id = 24201073,goods_name = "潮牌鞋子",type = 5,subtype = 7,level = 1,color = 3,sell_category = 1,sell_subcategory = 6,buyout_price = 400,selling_time = 7200,bag_location = loc(5,7)};
get(24201074) ->
	#ets_goods_type{goods_id = 24201074,goods_name = "潮牌鞋子",type = 5,subtype = 7,level = 1,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1200,price_markup = 300,buyout_price = 3600,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,7)};
get(24202010) ->
	#ets_goods_type{goods_id = 24202010,goods_name = "新星双枪",bind = 1,type = 5,subtype = 1,level = 115,bag_location = loc(5,1)};
get(24202011) ->
	#ets_goods_type{goods_id = 24202011,goods_name = "新星双枪",bind = 1,type = 5,subtype = 1,level = 115,color = 1,bag_location = loc(5,1)};
get(24202012) ->
	#ets_goods_type{goods_id = 24202012,goods_name = "新星双枪",bind = 1,type = 5,subtype = 1,level = 115,color = 2,bag_location = loc(5,1)};
get(24202013) ->
	#ets_goods_type{goods_id = 24202013,goods_name = "新星双枪",type = 5,subtype = 1,level = 115,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,1)};
get(24202014) ->
	#ets_goods_type{goods_id = 24202014,goods_name = "新星双枪",type = 5,subtype = 1,level = 115,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24202020) ->
	#ets_goods_type{goods_id = 24202020,goods_name = "新星帽子",bind = 1,type = 5,subtype = 2,level = 115,bag_location = loc(5,2)};
get(24202021) ->
	#ets_goods_type{goods_id = 24202021,goods_name = "新星帽子",bind = 1,type = 5,subtype = 2,level = 115,color = 1,bag_location = loc(5,2)};
get(24202022) ->
	#ets_goods_type{goods_id = 24202022,goods_name = "新星帽子",bind = 1,type = 5,subtype = 2,level = 115,color = 2,bag_location = loc(5,2)};
get(24202023) ->
	#ets_goods_type{goods_id = 24202023,goods_name = "新星帽子",type = 5,subtype = 2,level = 115,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,2)};
get(24202024) ->
	#ets_goods_type{goods_id = 24202024,goods_name = "新星帽子",type = 5,subtype = 2,level = 115,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,2)};
get(24202030) ->
	#ets_goods_type{goods_id = 24202030,goods_name = "新星上衣",bind = 1,type = 5,subtype = 3,level = 115,bag_location = loc(5,3)};
get(24202031) ->
	#ets_goods_type{goods_id = 24202031,goods_name = "新星上衣",bind = 1,type = 5,subtype = 3,level = 115,color = 1,bag_location = loc(5,3)};
get(24202032) ->
	#ets_goods_type{goods_id = 24202032,goods_name = "新星上衣",bind = 1,type = 5,subtype = 3,level = 115,color = 2,bag_location = loc(5,3)};
get(24202033) ->
	#ets_goods_type{goods_id = 24202033,goods_name = "新星上衣",type = 5,subtype = 3,level = 115,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,3)};
get(24202034) ->
	#ets_goods_type{goods_id = 24202034,goods_name = "新星上衣",type = 5,subtype = 3,level = 115,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,3)};
get(24202040) ->
	#ets_goods_type{goods_id = 24202040,goods_name = "新星外套",bind = 1,type = 5,subtype = 4,level = 115,bag_location = loc(5,4)};
get(24202041) ->
	#ets_goods_type{goods_id = 24202041,goods_name = "新星外套",bind = 1,type = 5,subtype = 4,level = 115,color = 1,bag_location = loc(5,4)};
get(24202042) ->
	#ets_goods_type{goods_id = 24202042,goods_name = "新星外套",bind = 1,type = 5,subtype = 4,level = 115,color = 2,bag_location = loc(5,4)};
get(24202043) ->
	#ets_goods_type{goods_id = 24202043,goods_name = "新星外套",type = 5,subtype = 4,level = 115,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,4)};
get(24202044) ->
	#ets_goods_type{goods_id = 24202044,goods_name = "新星外套",type = 5,subtype = 4,level = 115,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,4)};
get(24202050) ->
	#ets_goods_type{goods_id = 24202050,goods_name = "新星手套",bind = 1,type = 5,subtype = 5,level = 115,bag_location = loc(5,5)};
get(24202051) ->
	#ets_goods_type{goods_id = 24202051,goods_name = "新星手套",bind = 1,type = 5,subtype = 5,level = 115,color = 1,bag_location = loc(5,5)};
get(24202052) ->
	#ets_goods_type{goods_id = 24202052,goods_name = "新星手套",bind = 1,type = 5,subtype = 5,level = 115,color = 2,bag_location = loc(5,5)};
get(24202053) ->
	#ets_goods_type{goods_id = 24202053,goods_name = "新星手套",type = 5,subtype = 5,level = 115,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,5)};
get(24202054) ->
	#ets_goods_type{goods_id = 24202054,goods_name = "新星手套",type = 5,subtype = 5,level = 115,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,5)};
get(24202060) ->
	#ets_goods_type{goods_id = 24202060,goods_name = "新星裤子",bind = 1,type = 5,subtype = 6,level = 115,bag_location = loc(5,6)};
get(24202061) ->
	#ets_goods_type{goods_id = 24202061,goods_name = "新星裤子",bind = 1,type = 5,subtype = 6,level = 115,color = 1,bag_location = loc(5,6)};
get(24202062) ->
	#ets_goods_type{goods_id = 24202062,goods_name = "新星裤子",bind = 1,type = 5,subtype = 6,level = 115,color = 2,bag_location = loc(5,6)};
get(24202063) ->
	#ets_goods_type{goods_id = 24202063,goods_name = "新星裤子",type = 5,subtype = 6,level = 115,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,6)};
get(24202064) ->
	#ets_goods_type{goods_id = 24202064,goods_name = "新星裤子",type = 5,subtype = 6,level = 115,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,6)};
get(24202070) ->
	#ets_goods_type{goods_id = 24202070,goods_name = "新星鞋子",bind = 1,type = 5,subtype = 7,level = 115,bag_location = loc(5,7)};
get(24202071) ->
	#ets_goods_type{goods_id = 24202071,goods_name = "新星鞋子",bind = 1,type = 5,subtype = 7,level = 115,color = 1,bag_location = loc(5,7)};
get(24202072) ->
	#ets_goods_type{goods_id = 24202072,goods_name = "新星鞋子",bind = 1,type = 5,subtype = 7,level = 115,color = 2,bag_location = loc(5,7)};
get(24202073) ->
	#ets_goods_type{goods_id = 24202073,goods_name = "新星鞋子",type = 5,subtype = 7,level = 115,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 360,price_markup = 20,buyout_price = 450,selling_time = 7200,bag_location = loc(5,7)};
get(24202074) ->
	#ets_goods_type{goods_id = 24202074,goods_name = "新星鞋子",type = 5,subtype = 7,level = 115,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1350,price_markup = 300,buyout_price = 4050,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,7)};
get(24203010) ->
	#ets_goods_type{goods_id = 24203010,goods_name = "量子双枪",bind = 1,type = 5,subtype = 1,level = 145,bag_location = loc(5,1)};
get(24203011) ->
	#ets_goods_type{goods_id = 24203011,goods_name = "量子双枪",bind = 1,type = 5,subtype = 1,level = 145,color = 1,bag_location = loc(5,1)};
get(24203012) ->
	#ets_goods_type{goods_id = 24203012,goods_name = "量子双枪",bind = 1,type = 5,subtype = 1,level = 145,color = 2,bag_location = loc(5,1)};
get(24203013) ->
	#ets_goods_type{goods_id = 24203013,goods_name = "量子双枪",type = 5,subtype = 1,level = 145,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,1)};
get(24203014) ->
	#ets_goods_type{goods_id = 24203014,goods_name = "量子双枪",type = 5,subtype = 1,level = 145,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24203020) ->
	#ets_goods_type{goods_id = 24203020,goods_name = "量子帽子",bind = 1,type = 5,subtype = 2,level = 145,bag_location = loc(5,2)};
get(24203021) ->
	#ets_goods_type{goods_id = 24203021,goods_name = "量子帽子",bind = 1,type = 5,subtype = 2,level = 145,color = 1,bag_location = loc(5,2)};
get(24203022) ->
	#ets_goods_type{goods_id = 24203022,goods_name = "量子帽子",bind = 1,type = 5,subtype = 2,level = 145,color = 2,bag_location = loc(5,2)};
get(24203023) ->
	#ets_goods_type{goods_id = 24203023,goods_name = "量子帽子",type = 5,subtype = 2,level = 145,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,2)};
get(24203024) ->
	#ets_goods_type{goods_id = 24203024,goods_name = "量子帽子",type = 5,subtype = 2,level = 145,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,2)};
get(24203030) ->
	#ets_goods_type{goods_id = 24203030,goods_name = "量子上衣",bind = 1,type = 5,subtype = 3,level = 145,bag_location = loc(5,3)};
get(24203031) ->
	#ets_goods_type{goods_id = 24203031,goods_name = "量子上衣",bind = 1,type = 5,subtype = 3,level = 145,color = 1,bag_location = loc(5,3)};
get(24203032) ->
	#ets_goods_type{goods_id = 24203032,goods_name = "量子上衣",bind = 1,type = 5,subtype = 3,level = 145,color = 2,bag_location = loc(5,3)};
get(24203033) ->
	#ets_goods_type{goods_id = 24203033,goods_name = "量子上衣",type = 5,subtype = 3,level = 145,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,3)};
get(24203034) ->
	#ets_goods_type{goods_id = 24203034,goods_name = "量子上衣",type = 5,subtype = 3,level = 145,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,3)};
get(24203040) ->
	#ets_goods_type{goods_id = 24203040,goods_name = "量子外套",bind = 1,type = 5,subtype = 4,level = 145,bag_location = loc(5,4)};
get(24203041) ->
	#ets_goods_type{goods_id = 24203041,goods_name = "量子外套",bind = 1,type = 5,subtype = 4,level = 145,color = 1,bag_location = loc(5,4)};
get(24203042) ->
	#ets_goods_type{goods_id = 24203042,goods_name = "量子外套",bind = 1,type = 5,subtype = 4,level = 145,color = 2,bag_location = loc(5,4)};
get(24203043) ->
	#ets_goods_type{goods_id = 24203043,goods_name = "量子外套",type = 5,subtype = 4,level = 145,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,4)};
get(24203044) ->
	#ets_goods_type{goods_id = 24203044,goods_name = "量子外套",type = 5,subtype = 4,level = 145,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,4)};
get(24203050) ->
	#ets_goods_type{goods_id = 24203050,goods_name = "量子手套",bind = 1,type = 5,subtype = 5,level = 145,bag_location = loc(5,5)};
get(24203051) ->
	#ets_goods_type{goods_id = 24203051,goods_name = "量子手套",bind = 1,type = 5,subtype = 5,level = 145,color = 1,bag_location = loc(5,5)};
get(24203052) ->
	#ets_goods_type{goods_id = 24203052,goods_name = "量子手套",bind = 1,type = 5,subtype = 5,level = 145,color = 2,bag_location = loc(5,5)};
get(24203053) ->
	#ets_goods_type{goods_id = 24203053,goods_name = "量子手套",type = 5,subtype = 5,level = 145,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,5)};
get(24203054) ->
	#ets_goods_type{goods_id = 24203054,goods_name = "量子手套",type = 5,subtype = 5,level = 145,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,5)};
get(24203060) ->
	#ets_goods_type{goods_id = 24203060,goods_name = "量子裤子",bind = 1,type = 5,subtype = 6,level = 145,bag_location = loc(5,6)};
get(24203061) ->
	#ets_goods_type{goods_id = 24203061,goods_name = "量子裤子",bind = 1,type = 5,subtype = 6,level = 145,color = 1,bag_location = loc(5,6)};
get(24203062) ->
	#ets_goods_type{goods_id = 24203062,goods_name = "量子裤子",bind = 1,type = 5,subtype = 6,level = 145,color = 2,bag_location = loc(5,6)};
get(24203063) ->
	#ets_goods_type{goods_id = 24203063,goods_name = "量子裤子",type = 5,subtype = 6,level = 145,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,6)};
get(24203064) ->
	#ets_goods_type{goods_id = 24203064,goods_name = "量子裤子",type = 5,subtype = 6,level = 145,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,6)};
get(24203070) ->
	#ets_goods_type{goods_id = 24203070,goods_name = "量子鞋子",bind = 1,type = 5,subtype = 7,level = 145,bag_location = loc(5,7)};
get(24203071) ->
	#ets_goods_type{goods_id = 24203071,goods_name = "量子鞋子",bind = 1,type = 5,subtype = 7,level = 145,color = 1,bag_location = loc(5,7)};
get(24203072) ->
	#ets_goods_type{goods_id = 24203072,goods_name = "量子鞋子",bind = 1,type = 5,subtype = 7,level = 145,color = 2,bag_location = loc(5,7)};
get(24203073) ->
	#ets_goods_type{goods_id = 24203073,goods_name = "量子鞋子",type = 5,subtype = 7,level = 145,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 400,price_markup = 20,buyout_price = 500,selling_time = 7200,bag_location = loc(5,7)};
get(24203074) ->
	#ets_goods_type{goods_id = 24203074,goods_name = "量子鞋子",type = 5,subtype = 7,level = 145,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1500,price_markup = 300,buyout_price = 4500,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,7)};
get(24204010) ->
	#ets_goods_type{goods_id = 24204010,goods_name = "宵暗双枪",bind = 1,type = 5,subtype = 1,level = 175,bag_location = loc(5,1)};
get(24204011) ->
	#ets_goods_type{goods_id = 24204011,goods_name = "宵暗双枪",bind = 1,type = 5,subtype = 1,level = 175,color = 1,bag_location = loc(5,1)};
get(24204012) ->
	#ets_goods_type{goods_id = 24204012,goods_name = "宵暗双枪",bind = 1,type = 5,subtype = 1,level = 175,color = 2,bag_location = loc(5,1)};
get(24204013) ->
	#ets_goods_type{goods_id = 24204013,goods_name = "宵暗双枪",type = 5,subtype = 1,level = 175,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,1)};
get(24204014) ->
	#ets_goods_type{goods_id = 24204014,goods_name = "宵暗双枪",type = 5,subtype = 1,level = 175,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24204020) ->
	#ets_goods_type{goods_id = 24204020,goods_name = "宵暗帽子",bind = 1,type = 5,subtype = 2,level = 175,bag_location = loc(5,2)};
get(24204021) ->
	#ets_goods_type{goods_id = 24204021,goods_name = "宵暗帽子",bind = 1,type = 5,subtype = 2,level = 175,color = 1,bag_location = loc(5,2)};
get(24204022) ->
	#ets_goods_type{goods_id = 24204022,goods_name = "宵暗帽子",bind = 1,type = 5,subtype = 2,level = 175,color = 2,bag_location = loc(5,2)};
get(24204023) ->
	#ets_goods_type{goods_id = 24204023,goods_name = "宵暗帽子",type = 5,subtype = 2,level = 175,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,2)};
get(24204024) ->
	#ets_goods_type{goods_id = 24204024,goods_name = "宵暗帽子",type = 5,subtype = 2,level = 175,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,2)};
get(24204030) ->
	#ets_goods_type{goods_id = 24204030,goods_name = "宵暗上衣",bind = 1,type = 5,subtype = 3,level = 175,bag_location = loc(5,3)};
get(24204031) ->
	#ets_goods_type{goods_id = 24204031,goods_name = "宵暗上衣",bind = 1,type = 5,subtype = 3,level = 175,color = 1,bag_location = loc(5,3)};
get(24204032) ->
	#ets_goods_type{goods_id = 24204032,goods_name = "宵暗上衣",bind = 1,type = 5,subtype = 3,level = 175,color = 2,bag_location = loc(5,3)};
get(24204033) ->
	#ets_goods_type{goods_id = 24204033,goods_name = "宵暗上衣",type = 5,subtype = 3,level = 175,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,3)};
get(24204034) ->
	#ets_goods_type{goods_id = 24204034,goods_name = "宵暗上衣",type = 5,subtype = 3,level = 175,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,3)};
get(24204040) ->
	#ets_goods_type{goods_id = 24204040,goods_name = "宵暗外套",bind = 1,type = 5,subtype = 4,level = 175,bag_location = loc(5,4)};
get(24204041) ->
	#ets_goods_type{goods_id = 24204041,goods_name = "宵暗外套",bind = 1,type = 5,subtype = 4,level = 175,color = 1,bag_location = loc(5,4)};
get(24204042) ->
	#ets_goods_type{goods_id = 24204042,goods_name = "宵暗外套",bind = 1,type = 5,subtype = 4,level = 175,color = 2,bag_location = loc(5,4)};
get(24204043) ->
	#ets_goods_type{goods_id = 24204043,goods_name = "宵暗外套",type = 5,subtype = 4,level = 175,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,4)};
get(24204044) ->
	#ets_goods_type{goods_id = 24204044,goods_name = "宵暗外套",type = 5,subtype = 4,level = 175,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,4)};
get(24204050) ->
	#ets_goods_type{goods_id = 24204050,goods_name = "宵暗手套",bind = 1,type = 5,subtype = 5,level = 175,bag_location = loc(5,5)};
get(24204051) ->
	#ets_goods_type{goods_id = 24204051,goods_name = "宵暗手套",bind = 1,type = 5,subtype = 5,level = 175,color = 1,bag_location = loc(5,5)};
get(24204052) ->
	#ets_goods_type{goods_id = 24204052,goods_name = "宵暗手套",bind = 1,type = 5,subtype = 5,level = 175,color = 2,bag_location = loc(5,5)};
get(24204053) ->
	#ets_goods_type{goods_id = 24204053,goods_name = "宵暗手套",type = 5,subtype = 5,level = 175,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,5)};
get(24204054) ->
	#ets_goods_type{goods_id = 24204054,goods_name = "宵暗手套",type = 5,subtype = 5,level = 175,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,5)};
get(24204060) ->
	#ets_goods_type{goods_id = 24204060,goods_name = "宵暗裤子",bind = 1,type = 5,subtype = 6,level = 175,bag_location = loc(5,6)};
get(24204061) ->
	#ets_goods_type{goods_id = 24204061,goods_name = "宵暗裤子",bind = 1,type = 5,subtype = 6,level = 175,color = 1,bag_location = loc(5,6)};
get(24204062) ->
	#ets_goods_type{goods_id = 24204062,goods_name = "宵暗裤子",bind = 1,type = 5,subtype = 6,level = 175,color = 2,bag_location = loc(5,6)};
get(24204063) ->
	#ets_goods_type{goods_id = 24204063,goods_name = "宵暗裤子",type = 5,subtype = 6,level = 175,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,6)};
get(24204064) ->
	#ets_goods_type{goods_id = 24204064,goods_name = "宵暗裤子",type = 5,subtype = 6,level = 175,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,6)};
get(24204070) ->
	#ets_goods_type{goods_id = 24204070,goods_name = "宵暗鞋子",bind = 1,type = 5,subtype = 7,level = 175,bag_location = loc(5,7)};
get(24204071) ->
	#ets_goods_type{goods_id = 24204071,goods_name = "宵暗鞋子",bind = 1,type = 5,subtype = 7,level = 175,color = 1,bag_location = loc(5,7)};
get(24204072) ->
	#ets_goods_type{goods_id = 24204072,goods_name = "宵暗鞋子",bind = 1,type = 5,subtype = 7,level = 175,color = 2,bag_location = loc(5,7)};
get(24204073) ->
	#ets_goods_type{goods_id = 24204073,goods_name = "宵暗鞋子",type = 5,subtype = 7,level = 175,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 440,price_markup = 20,buyout_price = 550,selling_time = 7200,bag_location = loc(5,7)};
get(24204074) ->
	#ets_goods_type{goods_id = 24204074,goods_name = "宵暗鞋子",type = 5,subtype = 7,level = 175,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1650,price_markup = 300,buyout_price = 4950,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,7)};
get(24205010) ->
	#ets_goods_type{goods_id = 24205010,goods_name = "群星双枪",bind = 1,type = 5,subtype = 1,level = 250,bag_location = loc(5,1)};
get(24205011) ->
	#ets_goods_type{goods_id = 24205011,goods_name = "群星双枪",bind = 1,type = 5,subtype = 1,level = 250,color = 1,bag_location = loc(5,1)};
get(24205012) ->
	#ets_goods_type{goods_id = 24205012,goods_name = "群星双枪",bind = 1,type = 5,subtype = 1,level = 250,color = 2,bag_location = loc(5,1)};
get(24205013) ->
	#ets_goods_type{goods_id = 24205013,goods_name = "群星双枪",type = 5,subtype = 1,level = 250,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,1)};
get(24205014) ->
	#ets_goods_type{goods_id = 24205014,goods_name = "群星双枪",type = 5,subtype = 1,level = 250,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24205020) ->
	#ets_goods_type{goods_id = 24205020,goods_name = "群星帽子",bind = 1,type = 5,subtype = 2,level = 250,bag_location = loc(5,2)};
get(24205021) ->
	#ets_goods_type{goods_id = 24205021,goods_name = "群星帽子",bind = 1,type = 5,subtype = 2,level = 250,color = 1,bag_location = loc(5,2)};
get(24205022) ->
	#ets_goods_type{goods_id = 24205022,goods_name = "群星帽子",bind = 1,type = 5,subtype = 2,level = 250,color = 2,bag_location = loc(5,2)};
get(24205023) ->
	#ets_goods_type{goods_id = 24205023,goods_name = "群星帽子",type = 5,subtype = 2,level = 250,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,2)};
get(24205024) ->
	#ets_goods_type{goods_id = 24205024,goods_name = "群星帽子",type = 5,subtype = 2,level = 250,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,2)};
get(24205030) ->
	#ets_goods_type{goods_id = 24205030,goods_name = "群星上衣",bind = 1,type = 5,subtype = 3,level = 250,bag_location = loc(5,3)};
get(24205031) ->
	#ets_goods_type{goods_id = 24205031,goods_name = "群星上衣",bind = 1,type = 5,subtype = 3,level = 250,color = 1,bag_location = loc(5,3)};
get(24205032) ->
	#ets_goods_type{goods_id = 24205032,goods_name = "群星上衣",bind = 1,type = 5,subtype = 3,level = 250,color = 2,bag_location = loc(5,3)};
get(24205033) ->
	#ets_goods_type{goods_id = 24205033,goods_name = "群星上衣",type = 5,subtype = 3,level = 250,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,3)};
get(24205034) ->
	#ets_goods_type{goods_id = 24205034,goods_name = "群星上衣",type = 5,subtype = 3,level = 250,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,3)};
get(24205040) ->
	#ets_goods_type{goods_id = 24205040,goods_name = "群星外套",bind = 1,type = 5,subtype = 4,level = 250,bag_location = loc(5,4)};
get(24205041) ->
	#ets_goods_type{goods_id = 24205041,goods_name = "群星外套",bind = 1,type = 5,subtype = 4,level = 250,color = 1,bag_location = loc(5,4)};
get(24205042) ->
	#ets_goods_type{goods_id = 24205042,goods_name = "群星外套",bind = 1,type = 5,subtype = 4,level = 250,color = 2,bag_location = loc(5,4)};
get(24205043) ->
	#ets_goods_type{goods_id = 24205043,goods_name = "群星外套",type = 5,subtype = 4,level = 250,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,4)};
get(24205044) ->
	#ets_goods_type{goods_id = 24205044,goods_name = "群星外套",type = 5,subtype = 4,level = 250,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,4)};
get(24205050) ->
	#ets_goods_type{goods_id = 24205050,goods_name = "群星手套",bind = 1,type = 5,subtype = 5,level = 250,bag_location = loc(5,5)};
get(24205051) ->
	#ets_goods_type{goods_id = 24205051,goods_name = "群星手套",bind = 1,type = 5,subtype = 5,level = 250,color = 1,bag_location = loc(5,5)};
get(24205052) ->
	#ets_goods_type{goods_id = 24205052,goods_name = "群星手套",bind = 1,type = 5,subtype = 5,level = 250,color = 2,bag_location = loc(5,5)};
get(24205053) ->
	#ets_goods_type{goods_id = 24205053,goods_name = "群星手套",type = 5,subtype = 5,level = 250,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,5)};
get(24205054) ->
	#ets_goods_type{goods_id = 24205054,goods_name = "群星手套",type = 5,subtype = 5,level = 250,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,5)};
get(24205060) ->
	#ets_goods_type{goods_id = 24205060,goods_name = "群星裤子",bind = 1,type = 5,subtype = 6,level = 250,bag_location = loc(5,6)};
get(24205061) ->
	#ets_goods_type{goods_id = 24205061,goods_name = "群星裤子",bind = 1,type = 5,subtype = 6,level = 250,color = 1,bag_location = loc(5,6)};
get(24205062) ->
	#ets_goods_type{goods_id = 24205062,goods_name = "群星裤子",bind = 1,type = 5,subtype = 6,level = 250,color = 2,bag_location = loc(5,6)};
get(24205063) ->
	#ets_goods_type{goods_id = 24205063,goods_name = "群星裤子",type = 5,subtype = 6,level = 250,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,6)};
get(24205064) ->
	#ets_goods_type{goods_id = 24205064,goods_name = "群星裤子",type = 5,subtype = 6,level = 250,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,6)};
get(24205070) ->
	#ets_goods_type{goods_id = 24205070,goods_name = "群星鞋子",bind = 1,type = 5,subtype = 7,level = 250,bag_location = loc(5,7)};
get(24205071) ->
	#ets_goods_type{goods_id = 24205071,goods_name = "群星鞋子",bind = 1,type = 5,subtype = 7,level = 250,color = 1,bag_location = loc(5,7)};
get(24205072) ->
	#ets_goods_type{goods_id = 24205072,goods_name = "群星鞋子",bind = 1,type = 5,subtype = 7,level = 250,color = 2,bag_location = loc(5,7)};
get(24205073) ->
	#ets_goods_type{goods_id = 24205073,goods_name = "群星鞋子",type = 5,subtype = 7,level = 250,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 480,price_markup = 20,buyout_price = 600,selling_time = 7200,bag_location = loc(5,7)};
get(24205074) ->
	#ets_goods_type{goods_id = 24205074,goods_name = "群星鞋子",type = 5,subtype = 7,level = 250,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1800,price_markup = 300,buyout_price = 5400,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,7)};
get(24206010) ->
	#ets_goods_type{goods_id = 24206010,goods_name = "秩序双枪",bind = 1,type = 5,subtype = 1,level = 350,bag_location = loc(5,1)};
get(24206011) ->
	#ets_goods_type{goods_id = 24206011,goods_name = "秩序双枪",bind = 1,type = 5,subtype = 1,level = 350,color = 1,bag_location = loc(5,1)};
get(24206012) ->
	#ets_goods_type{goods_id = 24206012,goods_name = "秩序双枪",bind = 1,type = 5,subtype = 1,level = 350,color = 2,bag_location = loc(5,1)};
get(24206013) ->
	#ets_goods_type{goods_id = 24206013,goods_name = "秩序双枪",type = 5,subtype = 1,level = 350,color = 3,sell_category = 3,sell_subcategory = 1,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,1)};
get(24206014) ->
	#ets_goods_type{goods_id = 24206014,goods_name = "秩序双枪",type = 5,subtype = 1,level = 350,color = 4,sell_category = 3,sell_subcategory = 1,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,1)};
get(24206020) ->
	#ets_goods_type{goods_id = 24206020,goods_name = "秩序帽子",bind = 1,type = 5,subtype = 2,level = 350,bag_location = loc(5,2)};
get(24206021) ->
	#ets_goods_type{goods_id = 24206021,goods_name = "秩序帽子",bind = 1,type = 5,subtype = 2,level = 350,color = 1,bag_location = loc(5,2)};
get(24206022) ->
	#ets_goods_type{goods_id = 24206022,goods_name = "秩序帽子",bind = 1,type = 5,subtype = 2,level = 350,color = 2,bag_location = loc(5,2)};
get(24206023) ->
	#ets_goods_type{goods_id = 24206023,goods_name = "秩序帽子",type = 5,subtype = 2,level = 350,color = 3,sell_category = 1,sell_subcategory = 1,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,2)};
get(24206024) ->
	#ets_goods_type{goods_id = 24206024,goods_name = "秩序帽子",type = 5,subtype = 2,level = 350,color = 4,sell_category = 1,sell_subcategory = 1,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,2)};
get(24206030) ->
	#ets_goods_type{goods_id = 24206030,goods_name = "秩序上衣",bind = 1,type = 5,subtype = 3,level = 350,bag_location = loc(5,3)};
get(24206031) ->
	#ets_goods_type{goods_id = 24206031,goods_name = "秩序上衣",bind = 1,type = 5,subtype = 3,level = 350,color = 1,bag_location = loc(5,3)};
get(24206032) ->
	#ets_goods_type{goods_id = 24206032,goods_name = "秩序上衣",bind = 1,type = 5,subtype = 3,level = 350,color = 2,bag_location = loc(5,3)};
get(24206033) ->
	#ets_goods_type{goods_id = 24206033,goods_name = "秩序上衣",type = 5,subtype = 3,level = 350,color = 3,sell_category = 1,sell_subcategory = 2,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,3)};
get(24206034) ->
	#ets_goods_type{goods_id = 24206034,goods_name = "秩序上衣",type = 5,subtype = 3,level = 350,color = 4,sell_category = 1,sell_subcategory = 2,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,3)};
get(24206040) ->
	#ets_goods_type{goods_id = 24206040,goods_name = "秩序外套",bind = 1,type = 5,subtype = 4,level = 350,bag_location = loc(5,4)};
get(24206041) ->
	#ets_goods_type{goods_id = 24206041,goods_name = "秩序外套",bind = 1,type = 5,subtype = 4,level = 350,color = 1,bag_location = loc(5,4)};
get(24206042) ->
	#ets_goods_type{goods_id = 24206042,goods_name = "秩序外套",bind = 1,type = 5,subtype = 4,level = 350,color = 2,bag_location = loc(5,4)};
get(24206043) ->
	#ets_goods_type{goods_id = 24206043,goods_name = "秩序外套",type = 5,subtype = 4,level = 350,color = 3,sell_category = 1,sell_subcategory = 3,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,4)};
get(24206044) ->
	#ets_goods_type{goods_id = 24206044,goods_name = "秩序外套",type = 5,subtype = 4,level = 350,color = 4,sell_category = 1,sell_subcategory = 3,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,4)};
get(24206050) ->
	#ets_goods_type{goods_id = 24206050,goods_name = "秩序手套",bind = 1,type = 5,subtype = 5,level = 350,bag_location = loc(5,5)};
get(24206051) ->
	#ets_goods_type{goods_id = 24206051,goods_name = "秩序手套",bind = 1,type = 5,subtype = 5,level = 350,color = 1,bag_location = loc(5,5)};
get(24206052) ->
	#ets_goods_type{goods_id = 24206052,goods_name = "秩序手套",bind = 1,type = 5,subtype = 5,level = 350,color = 2,bag_location = loc(5,5)};
get(24206053) ->
	#ets_goods_type{goods_id = 24206053,goods_name = "秩序手套",type = 5,subtype = 5,level = 350,color = 3,sell_category = 1,sell_subcategory = 4,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,5)};
get(24206054) ->
	#ets_goods_type{goods_id = 24206054,goods_name = "秩序手套",type = 5,subtype = 5,level = 350,color = 4,sell_category = 1,sell_subcategory = 4,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,5)};
get(24206060) ->
	#ets_goods_type{goods_id = 24206060,goods_name = "秩序裤子",bind = 1,type = 5,subtype = 6,level = 350,bag_location = loc(5,6)};
get(24206061) ->
	#ets_goods_type{goods_id = 24206061,goods_name = "秩序裤子",bind = 1,type = 5,subtype = 6,level = 350,color = 1,bag_location = loc(5,6)};
get(24206062) ->
	#ets_goods_type{goods_id = 24206062,goods_name = "秩序裤子",bind = 1,type = 5,subtype = 6,level = 350,color = 2,bag_location = loc(5,6)};
get(24206063) ->
	#ets_goods_type{goods_id = 24206063,goods_name = "秩序裤子",type = 5,subtype = 6,level = 350,color = 3,sell_category = 1,sell_subcategory = 5,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,6)};
get(24206064) ->
	#ets_goods_type{goods_id = 24206064,goods_name = "秩序裤子",type = 5,subtype = 6,level = 350,color = 4,sell_category = 1,sell_subcategory = 5,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,6)};
get(24206070) ->
	#ets_goods_type{goods_id = 24206070,goods_name = "秩序鞋子",bind = 1,type = 5,subtype = 7,level = 350,bag_location = loc(5,7)};
get(24206071) ->
	#ets_goods_type{goods_id = 24206071,goods_name = "秩序鞋子",bind = 1,type = 5,subtype = 7,level = 350,color = 1,bag_location = loc(5,7)};
get(24206072) ->
	#ets_goods_type{goods_id = 24206072,goods_name = "秩序鞋子",bind = 1,type = 5,subtype = 7,level = 350,color = 2,bag_location = loc(5,7)};
get(24206073) ->
	#ets_goods_type{goods_id = 24206073,goods_name = "秩序鞋子",type = 5,subtype = 7,level = 350,color = 3,sell_category = 1,sell_subcategory = 6,trade_price = 520,price_markup = 20,buyout_price = 650,selling_time = 7200,bag_location = loc(5,7)};
get(24206074) ->
	#ets_goods_type{goods_id = 24206074,goods_name = "秩序鞋子",type = 5,subtype = 7,level = 350,color = 4,sell_category = 1,sell_subcategory = 6,trade_price = 1950,price_markup = 300,buyout_price = 5850,market_show_time = 300,selling_time = 7200,is_to_market = 1,bag_location = loc(5,7)};
get(24291014) ->
	#ets_goods_type{goods_id = 24291014,goods_name = "潮牌双枪",type = 5,subtype = 1,level = 1,color = 4,bag_location = loc(5,1)};
get(24291015) ->
	#ets_goods_type{goods_id = 24291015,goods_name = "绝版·潮牌双枪",type = 5,subtype = 1,level = 1,color = 5,bag_location = loc(5,1)};
get(24291024) ->
	#ets_goods_type{goods_id = 24291024,goods_name = "潮牌帽子",type = 5,subtype = 2,level = 1,color = 4,bag_location = loc(5,2)};
get(24291034) ->
	#ets_goods_type{goods_id = 24291034,goods_name = "潮牌上衣",type = 5,subtype = 3,level = 1,color = 4,bag_location = loc(5,3)};
get(24291044) ->
	#ets_goods_type{goods_id = 24291044,goods_name = "潮牌外套",type = 5,subtype = 4,level = 1,color = 4,bag_location = loc(5,4)};
get(24291054) ->
	#ets_goods_type{goods_id = 24291054,goods_name = "潮牌手套",type = 5,subtype = 5,level = 1,color = 4,bag_location = loc(5,5)};
get(24291064) ->
	#ets_goods_type{goods_id = 24291064,goods_name = "潮牌裤子",type = 5,subtype = 6,level = 1,color = 4,bag_location = loc(5,6)};
get(24291074) ->
	#ets_goods_type{goods_id = 24291074,goods_name = "潮牌鞋子",type = 5,subtype = 7,level = 1,color = 4,bag_location = loc(5,7)};
get(24292014) ->
	#ets_goods_type{goods_id = 24292014,goods_name = "新星双枪",type = 5,subtype = 1,level = 115,color = 4,bag_location = loc(5,1)};
get(24292024) ->
	#ets_goods_type{goods_id = 24292024,goods_name = "新星帽子",type = 5,subtype = 2,level = 115,color = 4,bag_location = loc(5,2)};
get(24292034) ->
	#ets_goods_type{goods_id = 24292034,goods_name = "新星上衣",type = 5,subtype = 3,level = 115,color = 4,bag_location = loc(5,3)};
get(24292044) ->
	#ets_goods_type{goods_id = 24292044,goods_name = "新星外套",type = 5,subtype = 4,level = 115,color = 4,bag_location = loc(5,4)};
get(24292054) ->
	#ets_goods_type{goods_id = 24292054,goods_name = "新星手套",type = 5,subtype = 5,level = 115,color = 4,bag_location = loc(5,5)};
get(24292064) ->
	#ets_goods_type{goods_id = 24292064,goods_name = "新星裤子",type = 5,subtype = 6,level = 115,color = 4,bag_location = loc(5,6)};
get(24292074) ->
	#ets_goods_type{goods_id = 24292074,goods_name = "新星鞋子",type = 5,subtype = 7,level = 115,color = 4,bag_location = loc(5,7)};

get(_Id) -> [].

get_type() -> [1,19,25,4,2,3,6,7,8,9,10,21,23,11,12,13,14,15,16,17,18,22,24,5].

get_subtype(1) -> [1,3,4,5,7,8,9,10,19,26,27,29,31,34,35,39,12,13,24,17,15,16,41,36,37,40,14,20,21,22,43,28,30,33,44,23,32,38];
get_subtype(19) -> [1,3,2,4];
get_subtype(25) -> [6,1,2,3,4,5];
get_subtype(4) -> [99,1,2,3,4,5,6,7,8,9];
get_subtype(2) -> [1];
get_subtype(3) -> [1];
get_subtype(6) -> [1,2,3,4];
get_subtype(7) -> [1,2,3,4];
get_subtype(8) -> [1,2];
get_subtype(9) -> [1,2,3,8,4,5,6,7];
get_subtype(10) -> [1,3,2];
get_subtype(21) -> [1,2,3,4,5,6];
get_subtype(23) -> [1,2];
get_subtype(11) -> [1,2,3,4,5];
get_subtype(12) -> [2,6,3,4,5,1];
get_subtype(13) -> [1];
get_subtype(14) -> [1,2];
get_subtype(15) -> [1];
get_subtype(16) -> [1];
get_subtype(17) -> [1,2,3,4,5,99];
get_subtype(18) -> [1];
get_subtype(22) -> [1,2,3,4];
get_subtype(24) -> [1];
get_subtype(5) -> [11,8,9,10,1,2,3,4,5,6,7];
get_subtype(_Id) -> [].

get_by_type(1,1) -> [99999,100999,101999];
get_by_type(1,3) -> [100002];
get_by_type(1,4) -> [100003];
get_by_type(1,5) -> [100004];
get_by_type(1,7) -> [100006];
get_by_type(1,8) -> [100007];
get_by_type(1,9) -> [100008];
get_by_type(1,10) -> [100009];
get_by_type(1,19) -> [100011];
get_by_type(1,26) -> [100013];
get_by_type(1,27) -> [100014];
get_by_type(1,29) -> [100015];
get_by_type(1,31) -> [100017];
get_by_type(1,34) -> [100018];
get_by_type(1,35) -> [100019];
get_by_type(1,39) -> [100020];
get_by_type(1,12) -> [101000,101001,101002,101003,101004,101005,101006,101007,101101,101102,101150,101151,101152];
get_by_type(1,13) -> [102000,102001,102002,102003,102004,102005,102006,102007,102008,102009,102099,102121,102300,102301,102302,102303,102304,102305,102306,102307,102308,102309,102310,102311,102312,102313,102314,102350,102351,102352,102353,102354,102355,102356,102357,102358,102359,102400,102401,102402,102403,102404,102405,102406,102407,102408,102409,102410,102601,102602,102631,102632,102633,105401,105402];
get_by_type(1,24) -> [102011,102012,102013,102014,102015,102016,102017,102018,102041,102042,102043,102044,102045,102046,102047,102048,102051,102052,102053,102054];
get_by_type(1,17) -> [102100];
get_by_type(1,15) -> [102101,102103,102104,102105,102106,102113,102114,102115,102116,102117,102118,102119];
get_by_type(1,16) -> [102102,102107,102108,102109,102110];
get_by_type(1,41) -> [102120];
get_by_type(1,36) -> [102320,102321,102322];
get_by_type(1,37) -> [102323,102324];
get_by_type(1,40) -> [102325,102326];
get_by_type(1,14) -> [102500,102600,102701,102702,102703,102704,105000,105002,105200,105201,105202,105203,105204,105205,105206,105207,105208,105209,105210,105211,105212,105213,105214];
get_by_type(1,20) -> [102603,102604,102605,102606];
get_by_type(1,21) -> [102607,102608];
get_by_type(1,22) -> [102610,102611,102612,102613,102614,102615,102616,102617,102618,102619,102620,102621,102705,102706,102707,102708,102709,102710,102711];
get_by_type(1,43) -> [102634,102635];
get_by_type(1,28) -> [105001,105005];
get_by_type(1,30) -> [105300,105301,105302,105303,105304,105305,105306,105307,105308,105309,105310,105311,105312,105313,105314,105501,105502,105503,105504,105505,105506,105507,105508,105509,105510];
get_by_type(1,33) -> [106000,106001,106002];
get_by_type(1,44) -> [108012,108022,108032,108042,108052,108062];
get_by_type(1,23) -> [109001,109002,109003,109004,109005,109006,109007,109008,109009,109011,109012,109013,109014,109015,109016,109017,109018,109019,109021,109022,109023,109024,109025,109026,109027,109028,109029];
get_by_type(1,32) -> [340001,340002,340003,340004,340005,340006,340007];
get_by_type(1,38) -> [360001,360002,360011,360012,360013];
get_by_type(19,1) -> [100000,100001,100021,101008,101009,101010,101011,101012,101013,101014,101015,101016,101017,101018,101019,101020,101021,101022,101050,101051,101052,101053,101054,101055,101056,101057,101058,101059,109031,109032,109033,109034,109035,109036,109037,109038,109039,210499,310101,310102,310103,310104,310105,310106,310201,310202,310203,310204,310205,310206,310301,310302,310303,310304,310305,310306,310401,310402,310403,310404,310405,310406,310501,310502,310503,310504,310505,310506,310601,310602,310603,310604,310605,310606,310701,310702,310703,310704,310705,310706,310801,310802,310803,310804,310805,310806,310901,310902,310903,310904,310905,310906,330000,450000,450001,450002,450003,450004,450006,450007,450008,450009,450010,450011,450012,450013,450014,450015,450016,450017,450018,450019,450020,450021,450022,450023,450024,450025,450026,450027,450028,450029,450030,450031,450032,450033,450034,450035,450036,450037,450038,450039,450040,450041,450042,450043,450044,450045,450046,450047,450048,450049,450051,450053,450054,450055,450056,450057,450058,450060,450061,450062,450063,450064,450065,450066,450067,450068,450069,450071,450085,450086,450087,450088,451001,451002,451003,451004,451005,451006,452001,452002,452003,452004,452005,452006,453006,453013,453057,453061,453062,453063,453064,453065,453066,453067,453068,453099,453100,453101,453102,453103,453104,453105,453106,453107,453108,453109,453110,453111,453112,453113,453114,453115,453116,453117,453118,453119,453120];
get_by_type(19,3) -> [450005,450059,453012];
get_by_type(19,2) -> [450050,450052,450070,450072,450073,450074,450075,450076,450077,450078,450079,450080,450081,450082,450083,450084];
get_by_type(19,4) -> [453001,453002,453003,453004,453005,453007,453008,453009,453010,453011,453014,453015,453016,453017,453018,453019,453020,453021,453022,453023,453024,453025,453026,453027,453028,453029,453030,453031,453032,453033,453034,453035,453036,453037,453038,453039,453040,453041,453042,453043,453044,453045,453046,453047,453048,453049,453050,453051,453052,453053,453054,453055,453056,453070,453071,453072,453073,453074];
get_by_type(25,6) -> [102200];
get_by_type(25,1) -> [600000,601001,601002,601003];
get_by_type(25,2) -> [602001,602002];
get_by_type(25,3) -> [603001,603002,603003];
get_by_type(25,4) -> [604001,604002,604003];
get_by_type(25,5) -> [605001,605002];
get_by_type(4,99) -> [102501];
get_by_type(4,1) -> [230000,230001,230002,230003,230004,230005,230006,230007,230008,230009,230010,230011,230012,230013,230014,230015,230016];
get_by_type(4,2) -> [230051,230052,230053,230054,230101,230102,230103,230104,230105,230106,230107,230108,230151,230152,230153,230154,230201,230202,230203,230204,230205,230206,230207,230208];
get_by_type(4,3) -> [230301,230302,230303,230304,230305,230306,230307,230308,230401,230402,230403,230404,230405,230406,230407,230408,230501,230502,230503,230504,230505,230506,230507,230508,230601,230602,230603,230604,230605,230606,230607,230608];
get_by_type(4,4) -> [231001,231002,231003,231004,231005,231006,231011,231012,231013,231014,231015,231016,231021,231022,231023,231024,231025,231026,231031,231032,231033,231034,231035,231036,231041,231042,231043,231044,231045,231046,231051,231052,231053,231054,231055,231056];
get_by_type(4,5) -> [232001,232002,232003,232004,232005,232006,232011,232012,232013,232014,232015,232016,232021,232022,232023,232024,232025,232026,232031,232032,232033,232034,232035,232036,232041,232042,232043,232044,232045,232046,232051,232052,232053,232054,232055,232056];
get_by_type(4,6) -> [400001,400002,400003,400004,400005,400006,400007,400008,400009];
get_by_type(4,7) -> [400010,400011,400012,400013,400014,400015,400016,400017,400018];
get_by_type(4,8) -> [400019,400020,400021,400022,400023,400024,400025,400026,400027];
get_by_type(4,9) -> [400028,400029,400030,400031,400032,400033,400034,400035,400036];
get_by_type(2,1) -> [209999,210000,210101,210102,210103,210104,210105,210106,210107,210108,210109,210111,210112,210113,210114,210115,210116,210117,210118,210201,210202,210203,210204,210205,210206,210207,210208,210209,210211,210212,210213,210214,210215,210216,210217,210218,210301,210302,210303,210304,210305,210306,210307,210308,210309,210311,210312,210313,210314,210315,210316,210317,210318,210401,210402,210403,210404,210405,210406,210407,210408,210409,210411,210412,210413,210414,210415,210416,210417,210418,210901,210902,210903,210904,210905,210906,210907,210908,211001,211002,211003,211004,211005,211006,211007,211008];
get_by_type(3,1) -> [220000,221001,222001,222002,222003,222004,222005,222006,222007,222008,222009,406001,406002,406003,406004,406005,406006,406007,406008,406009];
get_by_type(6,1) -> [250000,250001,250002,250003,250004,250005,250006,250101,250102,250103,250104,250105,250106,250107,250201,250202,250203,250204,250205,250206,250207,250208];
get_by_type(6,2) -> [251001,251002,251003,251004,251005,251006,251007,251008,251009];
get_by_type(6,3) -> [252011,252012,252013,252014,252021,252022,252023,252024,252031,252032,252033,252034,252041,252042,252043,252044,252051,252052,252053,252054,252061,252062,252063,252064,252111,252112,252113,252114,252121,252122,252123,252124,252131,252132,252133,252134,252141,252142,252143,252144,252151,252152,252153,252154,252161,252162,252163,252164,252211,252212,252213,252214,252221,252222,252223,252224,252231,252232,252233,252234,252241,252242,252243,252244,252251,252252,252253,252254,252261,252262,252263,252264];
get_by_type(6,4) -> [253000];
get_by_type(7,1) -> [260000,260001,260002,260003,260004,260005,260006,260007,260008];
get_by_type(7,2) -> [260101,260102,260103,260104,260105];
get_by_type(7,3) -> [260201,260202,260203,260204];
get_by_type(7,4) -> [261001,261002,261003,261004,261005,261006,261007,261008,262001,262002,262003,262004,262005,262006,262007,262008,263001,263002,263003,263004,263005,263006,263007,263008,264001,264002,264003,264004,264005,264006,264007,264008,265001,265002,265003,265004,265005,265006,265007,265008];
get_by_type(8,1) -> [270000,270001,270002,270003,270004,270005,270006,270007,270008,270009,270010,270011];
get_by_type(8,2) -> [270012,270013];
get_by_type(9,1) -> [280000,280001,280002,280003,280004,280005,280006,280007,280008,280009,280010];
get_by_type(9,2) -> [280101,280102,280103,280104,280105];
get_by_type(9,3) -> [280201,280202,280203,280204,280205];
get_by_type(9,8) -> [280301];
get_by_type(9,4) -> [281021,281031,281032,281033,281034,281035,281036,281041,281042,281043,281044,281045,281046,281051,281052,281053,281054,281055,281056];
get_by_type(9,5) -> [282021,282031,282032,282033,282034,282035,282036,282041,282042,282043,282044,282045,282046,282051,282052,282053,282054,282055,282056];
get_by_type(9,6) -> [283021,283031,283032,283033,283034,283035,283036,283041,283042,283043,283044,283045,283046,283051,283052,283053,283054,283055,283056];
get_by_type(9,7) -> [284021,284031,284032,284033,284034,284035,284036,284041,284042,284043,284044,284045,284046,284051,284052,284053,284054,284055,284056];
get_by_type(10,1) -> [290000,291000,291001,291002,291003,291004,291005,291006];
get_by_type(10,3) -> [290001,290002,290003,290004,290005,290006];
get_by_type(10,2) -> [292000,292001,292002,292003,292004,292005,292006];
get_by_type(21,1) -> [300000,300111,300112,300113,300114,300115,300116,300211,300212,300213,300214,300215,300216,300311,300312,300313,300314,300315,300316,300411,300412,300413,300414,300415,300416,300511,300512,300513,300514,300515,300516,300611,300612,300613,300614,300615,300616,300711,300712,300713,300714,300715,300716,300811,300812,300813,300814,300815,300816,300911,300912,300913,300914,300915,300916];
get_by_type(21,2) -> [300121,300122,300123,300124,300125,300126,300221,300222,300223,300224,300225,300226,300321,300322,300323,300324,300325,300326,300421,300422,300423,300424,300425,300426,300521,300522,300523,300524,300525,300526,300621,300622,300623,300624,300625,300626,300721,300722,300723,300724,300725,300726,300821,300822,300823,300824,300825,300826,300921,300922,300923,300924,300925,300926];
get_by_type(21,3) -> [300131,300132,300133,300134,300135,300136,300231,300232,300233,300234,300235,300236,300331,300332,300333,300334,300335,300336,300431,300432,300433,300434,300435,300436,300531,300532,300533,300534,300535,300536,300631,300632,300633,300634,300635,300636,300731,300732,300733,300734,300735,300736,300831,300832,300833,300834,300835,300836,300931,300932,300933,300934,300935,300936];
get_by_type(21,4) -> [300141,300142,300143,300144,300145,300146,300241,300242,300243,300244,300245,300246,300341,300342,300343,300344,300345,300346,300441,300442,300443,300444,300445,300446,300541,300542,300543,300544,300545,300546,300641,300642,300643,300644,300645,300646,300741,300742,300743,300744,300745,300746,300841,300842,300843,300844,300845,300846,300941,300942,300943,300944,300945,300946];
get_by_type(21,5) -> [300151,300152,300153,300154,300155,300156,300251,300252,300253,300254,300255,300256,300351,300352,300353,300354,300355,300356,300451,300452,300453,300454,300455,300456,300551,300552,300553,300554,300555,300556,300651,300652,300653,300654,300655,300656,300751,300752,300753,300754,300755,300756,300851,300852,300853,300854,300855,300856,300951,300952,300953,300954,300955,300956];
get_by_type(21,6) -> [300161,300162,300163,300164,300165,300166,300261,300262,300263,300264,300265,300266,300361,300362,300363,300364,300365,300366,300461,300462,300463,300464,300465,300466,300561,300562,300563,300564,300565,300566,300661,300662,300663,300664,300665,300666,300761,300762,300763,300764,300765,300766,300861,300862,300863,300864,300865,300866,300961,300962,300963,300964,300965,300966];
get_by_type(23,1) -> [330101,330102,330103,330104,330105,330106,330107,330108,330109,330110,330111,330112,330113,330114,330115,330116,330117,330201,330202,330203,330204,330205,330206,330207,330208,330209,330210,330211,330212,330213,330214,330215,330216,330217,330301,330302,330303,330304,330305,330306,330307,330308,330309,330310,330311,330312,330313,330314,330315,330316,330317,331108,331109,331110,331111,331112,331113,331114,331115,331116,331117,331208,331209,331210,331211,331212,331213,331214,331215,331216,331217,331308,331309,331310,331311,331312,331313,331314,331315,331316,331317,332113,332114,332115,332116,332117,332213,332214,332215,332216,332217,332313,332314,332315,332316,332317,333113,333114,333115,333116,333117,333213,333214,333215,333216,333217,333313,333314,333315,333316,333317,334113,334114,334115,334116,334117,334213,334214,334215,334216,334217,334313,334314,334315,334316,334317];
get_by_type(23,2) -> [330901,330902,330903];
get_by_type(11,1) -> [399999,400000,401000,401001,401002,401003,401004,401005,401006,401007,401008,401009,401010,401011,401012,401013,401014,401015,401016];
get_by_type(11,2) -> [402000,402001,402002,402003,402004,402005,402006,402007,402008,402009,402010,402011];
get_by_type(11,3) -> [403000,403001,403002,403003,403004,403005,403006,403007,403008,403009,403010,403011,403012];
get_by_type(11,4) -> [404000,404001,404002,404003,404004,404005,404006,404007,404008,404009];
get_by_type(11,5) -> [405000,405001,405002,405003,405004,405005,405006,405007,405008,405009,405010,405011,405012];
get_by_type(12,2) -> [410000,410001,410002,410003,410011,410012,410013,410021,410022,410023,410031,410032,410033,410041,410042,410043,410051,410052,410053,410061,410062,410063,410071,410072,410073,410081,410082,410083,410091,410092,410093,410101,410111,410121,410122,410123,410131,410132,410133,410141,410142,410143,410151,410152,410153,410161,410162,410163,440091,440092,440093,440101,440111,440121,440122,440123,440131,440132,440133,440141,440142,440143,440151,440152,440153,440161,440162,440163];
get_by_type(12,6) -> [412000,412001,412002,412003,412011,412012,412013,412021,412022,412023,412031,412032,412033,412041,412042,412043,412051,412052,412053,412061,412062,412063,412071,412072,412073,412081,412082,412083,412091,412092,412093,412101,412111,412121,412122,412123,412131,412132,412133,412141,412142,412143,412151,412152,412153,412161,412162,412163,442091,442092,442093,442101,442111,442121,442122,442123,442131,442132,442133,442141,442142,442143,442151,442152,442153,442161,442162,442163];
get_by_type(12,3) -> [413000,413001,413011,413021,413031,413041,413051,413061,413071,413081,413091,413101,413111,413121,413131,413141,413151,413161,413171,413181,413191];
get_by_type(12,4) -> [416000,416001,416011,416021,416031,416041,416051,416061,416071,416081,416091,416101,416111,416121,416131,416141,416151,416161,416171,416181,416191];
get_by_type(12,5) -> [418000,418011,418021,418031,418041,418051,418061,418071,418081,418091,418101];
get_by_type(12,1) -> [419000,419001,419002,419003];
get_by_type(13,1) -> [420000,420001,420002,420003,420004,420005,420006,420007,420008,420009,420010,420011,420012,420013,420014,420015,420016,420017,420018];
get_by_type(14,1) -> [422500,422501,422502,422503,422504,422505,422510,422511,422512,422513,422514,422515,422520,422521,422522,422523,422524,422525,422530,422531,422532,422533,422534,422535];
get_by_type(14,2) -> [423000,423001,423002,423011,423012,423021,423022,423031,423032,423041,423042,423051,423052,423061,423062,423071,423072,424000,424001,424002,424003,424004,424005,424006,424007,424008,424009,424010];
get_by_type(15,1) -> [425000,425001,425002,425003,425004,425005,425006,425007,425008,425009,425010,425011,425012,425013,425014,425015,425016,425017,425018];
get_by_type(16,1) -> [427500];
get_by_type(17,1) -> [430000,430001,430002,430003,430004,430005,430006,430007,430008,430009,430010,430011,430012,430013,430014,430015,430016,430017,430018,430019,430020,430021,430022,430023,430024,430025,430026,430027,430028,430029,430030,430031,430032,430033,430034,430035,430036,430037,430038,430039,430040,430041,430042,430043,430044,430045,430046,430047,430048,430049,430050,430051,430052,430053,430054,430055,430056,430057,430058,430101,430102,430103,434001,434002,434003,434005,434006,434008,434009,434011,434012,434014,434015,434017,434018];
get_by_type(17,2) -> [430104,431000,431001,431002,431003,434004,434007,434010,434013,434016,434019];
get_by_type(17,3) -> [431004,431005,431006,431007,431008,432001,432002,432003,432004,432005,432006,432007,432008,432009,432010,432011,432012,432013,432014,432015,432016,432017,432018,432019,432020,432021,432022,432023,432024,432025,432026,432027,432028,432029,432030,432031,432032,432033,432034,432035,432036,432037,433031,433032];
get_by_type(17,4) -> [433000,433001,433002,433003,433004,433005,433006,433007,433008,433009,433010,433011,433012,433013,433017,433018,433019,433025,433026,433027,433028,433029,433030,433098,433099];
get_by_type(17,5) -> [439001,439002,439003];
get_by_type(17,99) -> [439004];
get_by_type(18,1) -> [440000,440001,440002,440003,440011,440012,440013,440021,440022,440023,440031,440032,440033,440041,440042,440043,440051,440052,440053,440061,440062,440063,440071,440072,440073,440081,440082,440083,442000,442001,442002,442003,442011,442012,442013,442021,442022,442023,442031,442032,442033,442041,442042,442043,442051,442052,442053,442061,442062,442063,442071,442072,442073,442081,442082,442083,443000,443001,443011,443021,443031,443041,443051,443061,443071,443081,443091,443101,443111,443121,443131,443141,443151,443161,443171,443181,443191,446000,446001,446011,446021,446031,446041,446051,446061,446071,446081,446091,446101,446111,446121,446131,446141,446151,446161,446171,446181,446191,448000,448011,448021,448031,448041,448051,448061,448071,448081,448091,448101];
get_by_type(22,1) -> [710201,710202,710203,710204,710205,710206,710207,710301,710302,710303,710304,710305,710306,710307,710401,710402,710403,710404,710405,710406,710407,710501,710502,710503,710504,710505,710506,710507];
get_by_type(22,2) -> [720201,720202,720203,720204,720205,720206,720207,720301,720302,720303,720304,720305,720306,720307,720401,720402,720403,720404,720405,720406,720407,720501,720502,720503,720504,720505,720506,720507,720601,720602,720603,720604,720605,720606,720607,720608,720609,720610,720611,720612];
get_by_type(22,3) -> [730010,730011,730012,730013,730014,730020,730021,730022,730023,730024,730030,730031,730032,730033,730034,730040,730041,730042,730043,730044];
get_by_type(22,4) -> [740201,740202,740203,740204,740205,740206,740207,740301,740302,740303,740304,740305,740306,740307,740401,740402,740403,740404,740405,740406,740407,740501,740502,740503,740504,740505,740506,740507];
get_by_type(24,1) -> [800000,800001,800002,800003];
get_by_type(5,11) -> [24000011,24000012,24000013,24000021,24000022,24000023,24000031,24000032,24000033,24000041,24000042,24000043,24000051,24000052,24000053,24000061,24000062,24000063,24000071,24000072,24000073,24000081,24000082,24000083,24000091,24000092,24000093];
get_by_type(5,8) -> [24001080,24001081,24001082,24001083,24001084,24002080,24002081,24002082,24002083,24002084,24003080,24003081,24003082,24003083,24003084,24004080,24004081,24004082,24004083,24004084,24005080,24005081,24005082,24005083,24005084,24006080,24006081,24006082,24006083,24006084];
get_by_type(5,9) -> [24001090,24001091,24001092,24001093,24001094,24002090,24002091,24002092,24002093,24002094,24003090,24003091,24003092,24003093,24003094,24004090,24004091,24004092,24004093,24004094,24005090,24005091,24005092,24005093,24005094,24006090,24006091,24006092,24006093,24006094];
get_by_type(5,10) -> [24001100,24001101,24001102,24001103,24001104,24002100,24002101,24002102,24002103,24002104,24003100,24003101,24003102,24003103,24003104,24004100,24004101,24004102,24004103,24004104,24005100,24005101,24005102,24005103,24005104,24006100,24006101,24006102,24006103,24006104];
get_by_type(5,1) -> [24101010,24101011,24101012,24101013,24101014,24102010,24102011,24102012,24102013,24102014,24103010,24103011,24103012,24103013,24103014,24104010,24104011,24104012,24104013,24104014,24105010,24105011,24105012,24105013,24105014,24106010,24106011,24106012,24106013,24106014,24191014,24191015,24192014,24201010,24201011,24201012,24201013,24201014,24202010,24202011,24202012,24202013,24202014,24203010,24203011,24203012,24203013,24203014,24204010,24204011,24204012,24204013,24204014,24205010,24205011,24205012,24205013,24205014,24206010,24206011,24206012,24206013,24206014,24291014,24291015,24292014];
get_by_type(5,2) -> [24101020,24101021,24101022,24101023,24101024,24102020,24102021,24102022,24102023,24102024,24103020,24103021,24103022,24103023,24103024,24104020,24104021,24104022,24104023,24104024,24105020,24105021,24105022,24105023,24105024,24106020,24106021,24106022,24106023,24106024,24191024,24192024,24201020,24201021,24201022,24201023,24201024,24202020,24202021,24202022,24202023,24202024,24203020,24203021,24203022,24203023,24203024,24204020,24204021,24204022,24204023,24204024,24205020,24205021,24205022,24205023,24205024,24206020,24206021,24206022,24206023,24206024,24291024,24292024];
get_by_type(5,3) -> [24101030,24101031,24101032,24101033,24101034,24102030,24102031,24102032,24102033,24102034,24103030,24103031,24103032,24103033,24103034,24104030,24104031,24104032,24104033,24104034,24105030,24105031,24105032,24105033,24105034,24106030,24106031,24106032,24106033,24106034,24191034,24192034,24201030,24201031,24201032,24201033,24201034,24202030,24202031,24202032,24202033,24202034,24203030,24203031,24203032,24203033,24203034,24204030,24204031,24204032,24204033,24204034,24205030,24205031,24205032,24205033,24205034,24206030,24206031,24206032,24206033,24206034,24291034,24292034];
get_by_type(5,4) -> [24101040,24101041,24101042,24101043,24101044,24102040,24102041,24102042,24102043,24102044,24103040,24103041,24103042,24103043,24103044,24104040,24104041,24104042,24104043,24104044,24105040,24105041,24105042,24105043,24105044,24106040,24106041,24106042,24106043,24106044,24191044,24192044,24201040,24201041,24201042,24201043,24201044,24202040,24202041,24202042,24202043,24202044,24203040,24203041,24203042,24203043,24203044,24204040,24204041,24204042,24204043,24204044,24205040,24205041,24205042,24205043,24205044,24206040,24206041,24206042,24206043,24206044,24291044,24292044];
get_by_type(5,5) -> [24101050,24101051,24101052,24101053,24101054,24102050,24102051,24102052,24102053,24102054,24103050,24103051,24103052,24103053,24103054,24104050,24104051,24104052,24104053,24104054,24105050,24105051,24105052,24105053,24105054,24106050,24106051,24106052,24106053,24106054,24191054,24192054,24201050,24201051,24201052,24201053,24201054,24202050,24202051,24202052,24202053,24202054,24203050,24203051,24203052,24203053,24203054,24204050,24204051,24204052,24204053,24204054,24205050,24205051,24205052,24205053,24205054,24206050,24206051,24206052,24206053,24206054,24291054,24292054];
get_by_type(5,6) -> [24101060,24101061,24101062,24101063,24101064,24102060,24102061,24102062,24102063,24102064,24103060,24103061,24103062,24103063,24103064,24104060,24104061,24104062,24104063,24104064,24105060,24105061,24105062,24105063,24105064,24106060,24106061,24106062,24106063,24106064,24191064,24192064,24201060,24201061,24201062,24201063,24201064,24202060,24202061,24202062,24202063,24202064,24203060,24203061,24203062,24203063,24203064,24204060,24204061,24204062,24204063,24204064,24205060,24205061,24205062,24205063,24205064,24206060,24206061,24206062,24206063,24206064,24291064,24292064];
get_by_type(5,7) -> [24101070,24101071,24101072,24101073,24101074,24102070,24102071,24102072,24102073,24102074,24103070,24103071,24103072,24103073,24103074,24104070,24104071,24104072,24104073,24104074,24105070,24105071,24105072,24105073,24105074,24106070,24106071,24106072,24106073,24106074,24191074,24192074,24201070,24201071,24201072,24201073,24201074,24202070,24202071,24202072,24202073,24202074,24203070,24203071,24203072,24203073,24203074,24204070,24204071,24204072,24204073,24204074,24205070,24205071,24205072,24205073,24205074,24206070,24206071,24206072,24206073,24206074,24291074,24292074];
get_by_type(_Type, _Subtype) -> [].

get_location_by_type(1) -> 2;
get_location_by_type(2) -> 2;
get_location_by_type(3) -> 2;
get_location_by_type(4) -> 2;
get_location_by_type(5) -> 2;
get_location_by_type(6) -> 2;
get_location_by_type(7) -> 2;
get_location_by_type(8) -> 2;
get_location_by_type(9) -> 2;
get_location_by_type(10) -> 2;
get_location_by_type(11) -> 2;
get_location_by_type(12) -> 2;
get_location_by_type(13) -> 2;
get_location_by_type(14) -> 2;
get_location_by_type(15) -> 2;
get_location_by_type(17) -> 2;
get_location_by_type(18) -> 2;
get_location_by_type(19) -> 2;
get_location_by_type(20) -> 2;
get_location_by_type(21) -> 15;
get_location_by_type(22) -> 0;
get_location_by_type(23) -> 0;
get_location_by_type(24) -> 2;
get_location_by_type(25) -> 0;
get_location_by_type(_Type) -> 0.

get_location_by_subtype(1,1) -> 2;
get_location_by_subtype(1,2) -> 2;
get_location_by_subtype(1,3) -> 2;
get_location_by_subtype(1,4) -> 2;
get_location_by_subtype(1,5) -> 2;
get_location_by_subtype(1,6) -> 2;
get_location_by_subtype(1,7) -> 2;
get_location_by_subtype(1,8) -> 2;
get_location_by_subtype(1,9) -> 2;
get_location_by_subtype(1,10) -> 2;
get_location_by_subtype(1,11) -> 2;
get_location_by_subtype(1,12) -> 2;
get_location_by_subtype(1,13) -> 2;
get_location_by_subtype(1,14) -> 2;
get_location_by_subtype(1,15) -> 2;
get_location_by_subtype(1,16) -> 2;
get_location_by_subtype(1,17) -> 2;
get_location_by_subtype(1,19) -> 2;
get_location_by_subtype(1,20) -> 2;
get_location_by_subtype(1,21) -> 2;
get_location_by_subtype(1,22) -> 2;
get_location_by_subtype(1,23) -> 2;
get_location_by_subtype(1,24) -> 2;
get_location_by_subtype(1,25) -> 2;
get_location_by_subtype(1,26) -> 2;
get_location_by_subtype(1,27) -> 2;
get_location_by_subtype(1,28) -> 2;
get_location_by_subtype(1,29) -> 2;
get_location_by_subtype(1,30) -> 2;
get_location_by_subtype(1,31) -> 2;
get_location_by_subtype(1,32) -> 2;
get_location_by_subtype(1,33) -> 2;
get_location_by_subtype(1,34) -> 2;
get_location_by_subtype(1,35) -> 2;
get_location_by_subtype(1,36) -> 2;
get_location_by_subtype(1,37) -> 2;
get_location_by_subtype(1,38) -> 0;
get_location_by_subtype(1,39) -> 2;
get_location_by_subtype(1,40) -> 2;
get_location_by_subtype(1,41) -> 2;
get_location_by_subtype(1,42) -> 2;
get_location_by_subtype(1,43) -> 2;
get_location_by_subtype(1,44) -> 2;
get_location_by_subtype(2,1) -> 2;
get_location_by_subtype(3,1) -> 2;
get_location_by_subtype(4,1) -> 2;
get_location_by_subtype(4,2) -> 2;
get_location_by_subtype(4,3) -> 2;
get_location_by_subtype(4,4) -> 4;
get_location_by_subtype(4,5) -> 6;
get_location_by_subtype(4,6) -> 2;
get_location_by_subtype(4,7) -> 2;
get_location_by_subtype(4,8) -> 2;
get_location_by_subtype(4,9) -> 2;
get_location_by_subtype(5,1) -> 2;
get_location_by_subtype(5,2) -> 2;
get_location_by_subtype(5,3) -> 2;
get_location_by_subtype(5,4) -> 2;
get_location_by_subtype(5,5) -> 2;
get_location_by_subtype(5,6) -> 2;
get_location_by_subtype(5,7) -> 2;
get_location_by_subtype(5,8) -> 2;
get_location_by_subtype(5,9) -> 2;
get_location_by_subtype(5,10) -> 2;
get_location_by_subtype(5,11) -> 2;
get_location_by_subtype(6,1) -> 2;
get_location_by_subtype(6,2) -> 2;
get_location_by_subtype(6,3) -> 8;
get_location_by_subtype(6,4) -> 2;
get_location_by_subtype(7,1) -> 2;
get_location_by_subtype(7,2) -> 2;
get_location_by_subtype(7,3) -> 2;
get_location_by_subtype(7,4) -> 2;
get_location_by_subtype(8,1) -> 2;
get_location_by_subtype(8,2) -> 2;
get_location_by_subtype(9,1) -> 2;
get_location_by_subtype(9,2) -> 2;
get_location_by_subtype(9,3) -> 2;
get_location_by_subtype(9,4) -> 12;
get_location_by_subtype(9,5) -> 12;
get_location_by_subtype(9,6) -> 12;
get_location_by_subtype(9,7) -> 12;
get_location_by_subtype(9,8) -> 2;
get_location_by_subtype(10,1) -> 2;
get_location_by_subtype(10,2) -> 2;
get_location_by_subtype(10,3) -> 2;
get_location_by_subtype(11,1) -> 2;
get_location_by_subtype(11,2) -> 2;
get_location_by_subtype(11,3) -> 2;
get_location_by_subtype(11,4) -> 2;
get_location_by_subtype(11,5) -> 2;
get_location_by_subtype(12,1) -> 2;
get_location_by_subtype(12,2) -> 2;
get_location_by_subtype(12,3) -> 2;
get_location_by_subtype(12,4) -> 2;
get_location_by_subtype(12,5) -> 2;
get_location_by_subtype(12,6) -> 2;
get_location_by_subtype(13,1) -> 2;
get_location_by_subtype(14,1) -> 2;
get_location_by_subtype(14,2) -> 2;
get_location_by_subtype(15,1) -> 2;
get_location_by_subtype(17,1) -> 2;
get_location_by_subtype(17,2) -> 2;
get_location_by_subtype(17,3) -> 2;
get_location_by_subtype(17,4) -> 2;
get_location_by_subtype(17,5) -> 2;
get_location_by_subtype(18,1) -> 2;
get_location_by_subtype(18,6) -> 2;
get_location_by_subtype(19,1) -> 2;
get_location_by_subtype(19,2) -> 2;
get_location_by_subtype(19,3) -> 2;
get_location_by_subtype(19,4) -> 2;
get_location_by_subtype(20,1) -> 2;
get_location_by_subtype(20,2) -> 2;
get_location_by_subtype(20,3) -> 2;
get_location_by_subtype(20,4) -> 2;
get_location_by_subtype(20,5) -> 2;
get_location_by_subtype(20,6) -> 2;
get_location_by_subtype(20,7) -> 2;
get_location_by_subtype(20,8) -> 2;
get_location_by_subtype(20,9) -> 2;
get_location_by_subtype(20,10) -> 2;
get_location_by_subtype(20,11) -> 2;
get_location_by_subtype(21,1) -> 15;
get_location_by_subtype(21,2) -> 15;
get_location_by_subtype(21,3) -> 15;
get_location_by_subtype(21,4) -> 15;
get_location_by_subtype(21,5) -> 15;
get_location_by_subtype(21,6) -> 15;
get_location_by_subtype(22,1) -> 17;
get_location_by_subtype(22,2) -> 2;
get_location_by_subtype(22,3) -> 2;
get_location_by_subtype(22,4) -> 2;
get_location_by_subtype(23,1) -> 19;
get_location_by_subtype(23,2) -> 19;
get_location_by_subtype(24,1) -> 2;
get_location_by_subtype(25,1) -> 21;
get_location_by_subtype(25,2) -> 21;
get_location_by_subtype(25,3) -> 21;
get_location_by_subtype(25,4) -> 21;
get_location_by_subtype(25,5) -> 21;
get_location_by_subtype(25,6) -> 2;
get_location_by_subtype(_Type,_Subtype) -> 0.

get_bag_default_size(1) -> 0;
get_bag_default_size(2) -> 200;
get_bag_default_size(3) -> 200;
get_bag_default_size(4) -> 200;
get_bag_default_size(6) -> 200;
get_bag_default_size(8) -> 200;
get_bag_default_size(10) -> 250;
get_bag_default_size(12) -> 200;
get_bag_default_size(13) -> 0;
get_bag_default_size(14) -> 200;
get_bag_default_size(15) -> 200;
get_bag_default_size(17) -> 200;
get_bag_default_size(18) -> 100;
get_bag_default_size(19) -> 250;
get_bag_default_size(21) -> 250;
get_bag_default_size(_) -> 0.

get_bag_max_size(1) -> 0;
get_bag_max_size(2) -> 250;
get_bag_max_size(3) -> 250;
get_bag_max_size(4) -> 200;
get_bag_max_size(6) -> 200;
get_bag_max_size(8) -> 200;
get_bag_max_size(10) -> 250;
get_bag_max_size(12) -> 200;
get_bag_max_size(13) -> 0;
get_bag_max_size(14) -> 200;
get_bag_max_size(15) -> 200;
get_bag_max_size(17) -> 200;
get_bag_max_size(18) -> 100;
get_bag_max_size(19) -> 250;
get_bag_max_size(21) -> 250;
get_bag_max_size(_) -> 0.
