%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc
%%% 怪物配置数据（0/6）
%%% @end
%%% -------------------------------------------------------
-module(data_mon_0).
-export([
		get/2
	]).
-include("scene.hrl").

%% 获取怪物配置
%% Rem是求余结果，
%%   主要目的是为了拆散编译期生成大的literal字面常量，
%%   减少热更新移除旧模块时literal拷贝引发内存暴涨问题，
%%   此值请勿用于它处，不保证未来取值
-spec get(MonTypeId, Rem) -> #mon{} | [] when
	MonTypeId :: non_neg_integer(), Rem :: any().
get(6,Rem) ->
	#mon{id = 6,name = "队伍掉落测试",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 200,att = 1000,hp_lim = 160000,def = 4000,hit = 2000,dodge = 2000,crit = 2000,ten = 2000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 5000,att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(12,Rem) ->
	#mon{id = 12,name = "掉落绿装",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 500,att = 34530,hp_lim = 20770508,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(18,Rem) ->
	#mon{id = 18,name = "掉落1个",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(24,Rem) ->
	#mon{id = 24,name = "百万经验怪",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 550,att = 1630,hp_lim = 467627728,def = 3000,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(30,Rem) ->
	#mon{id = 30,name = "掉落概率队伍",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(120,Rem) ->
	#mon{id = 120,name = "随机分配伤害最高",color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 120,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 120,is_fight_back = 0,is_be_atted = 0,rem_flag = Rem};
get(132,Rem) ->
	#mon{id = 132,name = "均等分配最后一击",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 132,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 132,rem_flag = Rem};
get(1002,Rem) ->
	#mon{id = 1002,name = "精致外送",kind = 3,boss = 7,color = 4,icon = 10060102,icon_effect = <<"0"/utf8>>,weapon_id = 10060102,lv = 100,att = 100,hp_lim = 100,striking_distance = 250,speed = 300,is_fight_back = 0,del_hp_each_time = [1,1],rem_flag = Rem};
get(9006,Rem) ->
	#mon{id = 9006,name = "暴虐兽人",boss = 6,type = 1,color = 1,auto = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 110000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(9012,Rem) ->
	#mon{id = 9012,name = "暴虐发明家",boss = 6,type = 1,color = 1,auto = 1,icon = 100200062,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 113000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(9018,Rem) ->
	#mon{id = 9018,name = "巨刃少女",boss = 6,type = 1,color = 1,auto = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 116000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10002,Rem) ->
	#mon{id = 10002,name = "感染柴犬",type = 1,color = 1,auto = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 100000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10008,Rem) ->
	#mon{id = 10008,name = "巡逻护卫",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 103000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10014,Rem) ->
	#mon{id = 10014,name = "感染鲛人",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 106000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10020,Rem) ->
	#mon{id = 10020,name = "机甲老鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 109000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(400002,Rem) ->
	#mon{id = 400002,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 40,att = 822,hp_lim = 44404,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400302,Rem) ->
	#mon{id = 400302,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 70,att = 1112,hp_lim = 60091,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400602,Rem) ->
	#mon{id = 400602,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 100,att = 2747,hp_lim = 148339,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500004,Rem) ->
	#mon{id = 500004,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 66,att = 168,hp_lim = 5706,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500010,Rem) ->
	#mon{id = 500010,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 775,hp_lim = 52500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500016,Rem) ->
	#mon{id = 500016,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 107,att = 1343,hp_lim = 91000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500022,Rem) ->
	#mon{id = 500022,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 119,att = 2273,hp_lim = 154000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500028,Rem) ->
	#mon{id = 500028,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 131,att = 3875,hp_lim = 262500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500034,Rem) ->
	#mon{id = 500034,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 143,att = 5683,hp_lim = 385000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500040,Rem) ->
	#mon{id = 500040,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 155,att = 7750,hp_lim = 525000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500046,Rem) ->
	#mon{id = 500046,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 167,att = 9747,hp_lim = 660333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500052,Rem) ->
	#mon{id = 500052,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 179,att = 11831,hp_lim = 801500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500058,Rem) ->
	#mon{id = 500058,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 191,att = 13795,hp_lim = 934500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500064,Rem) ->
	#mon{id = 500064,name = "绿衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 203,att = 15603,hp_lim = 1057000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500070,Rem) ->
	#mon{id = 500070,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 210,att = 17670,hp_lim = 1197000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500076,Rem) ->
	#mon{id = 500076,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 216,att = 19478,hp_lim = 1319500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500082,Rem) ->
	#mon{id = 500082,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 222,att = 21286,hp_lim = 1442000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500088,Rem) ->
	#mon{id = 500088,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 228,att = 23112,hp_lim = 1565666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500094,Rem) ->
	#mon{id = 500094,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 234,att = 24955,hp_lim = 1690500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500100,Rem) ->
	#mon{id = 500100,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 240,att = 27090,hp_lim = 1835166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500106,Rem) ->
	#mon{id = 500106,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 245,att = 28985,hp_lim = 1963500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500112,Rem) ->
	#mon{id = 500112,name = "蓝衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 250,att = 30896,hp_lim = 2093000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500118,Rem) ->
	#mon{id = 500118,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 255,att = 32825,hp_lim = 2223666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500124,Rem) ->
	#mon{id = 500124,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 260,att = 34788,hp_lim = 2356666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500130,Rem) ->
	#mon{id = 500130,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 264,att = 37062,hp_lim = 2510666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500136,Rem) ->
	#mon{id = 500136,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 269,att = 39060,hp_lim = 2646000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500142,Rem) ->
	#mon{id = 500142,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 274,att = 41109,hp_lim = 2784833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500148,Rem) ->
	#mon{id = 500148,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 279,att = 43158,hp_lim = 2923666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500154,Rem) ->
	#mon{id = 500154,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 284,att = 45242,hp_lim = 3064833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500160,Rem) ->
	#mon{id = 500160,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 288,att = 47653,hp_lim = 3228166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500166,Rem) ->
	#mon{id = 500166,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 293,att = 49755,hp_lim = 3370500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500172,Rem) ->
	#mon{id = 500172,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 298,att = 51925,hp_lim = 3517500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500178,Rem) ->
	#mon{id = 500178,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 303,att = 54112,hp_lim = 3665666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500184,Rem) ->
	#mon{id = 500184,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 308,att = 56316,hp_lim = 3815000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500190,Rem) ->
	#mon{id = 500190,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 312,att = 58865,hp_lim = 3987666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500196,Rem) ->
	#mon{id = 500196,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 317,att = 61121,hp_lim = 4140500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500202,Rem) ->
	#mon{id = 500202,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 322,att = 63412,hp_lim = 4295666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500208,Rem) ->
	#mon{id = 500208,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 327,att = 65737,hp_lim = 4453166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500214,Rem) ->
	#mon{id = 500214,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 332,att = 68079,hp_lim = 4611833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500220,Rem) ->
	#mon{id = 500220,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 336,att = 70783,hp_lim = 4795000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500226,Rem) ->
	#mon{id = 500226,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 341,att = 73177,hp_lim = 4957166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500232,Rem) ->
	#mon{id = 500232,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 346,att = 75605,hp_lim = 5121666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500238,Rem) ->
	#mon{id = 500238,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 351,att = 78068,hp_lim = 5288500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500244,Rem) ->
	#mon{id = 500244,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 356,att = 80548,hp_lim = 5456500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500250,Rem) ->
	#mon{id = 500250,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 360,att = 83424,hp_lim = 5651333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500256,Rem) ->
	#mon{id = 500256,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 365,att = 85956,hp_lim = 5822833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500262,Rem) ->
	#mon{id = 500262,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 370,att = 88539,hp_lim = 5997833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500268,Rem) ->
	#mon{id = 500268,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 375,att = 91157,hp_lim = 6175166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500274,Rem) ->
	#mon{id = 500274,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 380,att = 93775,hp_lim = 6352500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500280,Rem) ->
	#mon{id = 500280,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 384,att = 96840,hp_lim = 6560166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500286,Rem) ->
	#mon{id = 500286,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 389,att = 99544,hp_lim = 6743333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500292,Rem) ->
	#mon{id = 500292,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 394,att = 102282,hp_lim = 6928833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500298,Rem) ->
	#mon{id = 500298,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 399,att = 118626,hp_lim = 8036000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510006,Rem) ->
	#mon{id = 510006,name = "病毒异形",boss = 6,type = 1,color = 1,auto = 1,icon = 10040003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 135,att = 15300,hp_lim = 2835000,hit = 405,dodge = 270,ten = 216,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510012,Rem) ->
	#mon{id = 510012,name = "病毒暴君",boss = 6,type = 1,color = 1,auto = 1,icon = 100400011,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 195,att = 47940,hp_lim = 8883000,hit = 1269,dodge = 846,ten = 676,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510018,Rem) ->
	#mon{id = 510018,name = "执行者铁角",boss = 6,type = 1,color = 1,auto = 1,icon = 100400021,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 230,att = 78653,hp_lim = 14574000,hit = 2082,dodge = 1388,ten = 1110,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510024,Rem) ->
	#mon{id = 510024,name = "三头吼兽",boss = 6,type = 1,color = 1,auto = 1,icon = 100300011,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 256,att = 110783,hp_lim = 20527500,hit = 2932,dodge = 1955,ten = 1564,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510030,Rem) ->
	#mon{id = 510030,name = "兵武女刺",boss = 6,type = 1,color = 1,auto = 1,icon = 100100072,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 280,att = 144953,hp_lim = 26859000,hit = 3837,dodge = 2558,ten = 2046,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510036,Rem) ->
	#mon{id = 510036,name = "灵魂收割者",boss = 6,type = 1,color = 1,auto = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 304,att = 181163,hp_lim = 33568500,hit = 4795,dodge = 3197,ten = 2557,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510042,Rem) ->
	#mon{id = 510042,name = "武装女神",boss = 6,type = 1,color = 1,auto = 1,icon = 100200041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 328,att = 219583,hp_lim = 40687500,hit = 5812,dodge = 3875,ten = 3100,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510048,Rem) ->
	#mon{id = 510048,name = "海神祭祀",boss = 6,type = 1,color = 1,auto = 1,icon = 100100101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 352,att = 260383,hp_lim = 48247500,hit = 6892,dodge = 4595,ten = 3676,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510054,Rem) ->
	#mon{id = 510054,name = "铁甲战姬",boss = 6,type = 1,color = 1,auto = 1,icon = 100100052,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 376,att = 303620,hp_lim = 56259000,hit = 8037,dodge = 5358,ten = 4286,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510060,Rem) ->
	#mon{id = 510060,name = "末世利爪",boss = 6,type = 1,color = 1,auto = 1,icon = 100100042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 400,att = 438883,hp_lim = 81322500,hit = 11617,dodge = 7745,ten = 6196,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(650010,Rem) ->
	#mon{id = 650010,name = "社团篝火",boss = 1,color = 1,icon = 2040012,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 100,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,del_hp_each_time = [0.02,0.02],is_hide_hp = 1,rem_flag = Rem};
get(651102,Rem) ->
	#mon{id = 651102,name = "社团晚间计时怪",type = 1,color = 1,icon = 203008,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 100,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,del_hp_each_time = [0.02,0.02],rem_flag = Rem};
get(653004,Rem) ->
	#mon{id = 653004,name = "月冕结晶",kind = 1,color = 1,icon = 10020202,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(653106,Rem) ->
	#mon{id = 653106,name = "幻影图腾",boss = 5,type = 1,color = 1,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 100000,hp_lim = 999987654321,hit = 166666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,is_armor = 1,rem_flag = Rem};
get(1001004,Rem) ->
	#mon{id = 1001004,name = "海族护卫",type = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 1811,hp_lim = 118906,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001010,Rem) ->
	#mon{id = 1001010,name = "生化卫兵",type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 323,hp_lim = 21233,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001016,Rem) ->
	#mon{id = 1001016,name = "机械穿山甲",type = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 1941,hp_lim = 127400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001022,Rem) ->
	#mon{id = 1001022,name = "机械娜迦",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 5176,hp_lim = 339733,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1200102,Rem) ->
	#mon{id = 1200102,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 104,att = 1748,hp_lim = 85828,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200108,Rem) ->
	#mon{id = 1200108,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 116,att = 7893,hp_lim = 412965,hit = 258,dodge = 172,ten = 138,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200114,Rem) ->
	#mon{id = 1200114,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 140,att = 5544,hp_lim = 272160,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200204,Rem) ->
	#mon{id = 1200204,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 125,att = 4851,hp_lim = 238140,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200210,Rem) ->
	#mon{id = 1200210,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 155,att = 8893,hp_lim = 436590,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200216,Rem) ->
	#mon{id = 1200216,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 185,att = 16978,hp_lim = 833490,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200306,Rem) ->
	#mon{id = 1200306,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 165,att = 12320,hp_lim = 604800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200312,Rem) ->
	#mon{id = 1200312,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 195,att = 33813,hp_lim = 1769040,hit = 1170,dodge = 780,ten = 624,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200402,Rem) ->
	#mon{id = 1200402,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 178,att = 14553,hp_lim = 714420,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200408,Rem) ->
	#mon{id = 1200408,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 205,att = 42555,hp_lim = 2226420,hit = 1395,dodge = 930,ten = 744,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200414,Rem) ->
	#mon{id = 1200414,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 235,att = 35652,hp_lim = 1750215,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200504,Rem) ->
	#mon{id = 1200504,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 210,att = 23870,hp_lim = 1171800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200510,Rem) ->
	#mon{id = 1200510,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 240,att = 35652,hp_lim = 1750215,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200516,Rem) ->
	#mon{id = 1200516,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 270,att = 56914,hp_lim = 2793979,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200606,Rem) ->
	#mon{id = 1200606,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 245,att = 39738,hp_lim = 1950783,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200612,Rem) ->
	#mon{id = 1200612,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 275,att = 115272,hp_lim = 6030841,hit = 3589,dodge = 2393,ten = 1914,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200702,Rem) ->
	#mon{id = 1200702,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 248,att = 43905,hp_lim = 2155363,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200708,Rem) ->
	#mon{id = 1200708,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 275,att = 115272,hp_lim = 6030841,hit = 3589,dodge = 2393,ten = 1914,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200714,Rem) ->
	#mon{id = 1200714,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 305,att = 80389,hp_lim = 3946369,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200804,Rem) ->
	#mon{id = 1200804,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 275,att = 61425,hp_lim = 3015420,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200810,Rem) ->
	#mon{id = 1200810,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 305,att = 80389,hp_lim = 3946369,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200816,Rem) ->
	#mon{id = 1200816,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 335,att = 111805,hp_lim = 5488633,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200906,Rem) ->
	#mon{id = 1200906,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 305,att = 80389,hp_lim = 3946369,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200912,Rem) ->
	#mon{id = 1200912,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 335,att = 209816,hp_lim = 10977266,hit = 6534,dodge = 4356,ten = 3484,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201002,Rem) ->
	#mon{id = 1201002,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 308,att = 85369,hp_lim = 4190857,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201008,Rem) ->
	#mon{id = 1201008,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 335,att = 209816,hp_lim = 10977266,hit = 6534,dodge = 4356,ten = 3484,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201014,Rem) ->
	#mon{id = 1201014,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 365,att = 140904,hp_lim = 6917135,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201104,Rem) ->
	#mon{id = 1201104,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 335,att = 111805,hp_lim = 5488633,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201110,Rem) ->
	#mon{id = 1201110,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 365,att = 140904,hp_lim = 6917135,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201116,Rem) ->
	#mon{id = 1201116,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 395,att = 178915,hp_lim = 8783145,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201206,Rem) ->
	#mon{id = 1201206,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 365,att = 140904,hp_lim = 6917135,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201212,Rem) ->
	#mon{id = 1201212,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 395,att = 335757,hp_lim = 17566290,hit = 10456,dodge = 6970,ten = 5576,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201302,Rem) ->
	#mon{id = 1201302,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 368,att = 147006,hp_lim = 7216677,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201308,Rem) ->
	#mon{id = 1201308,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 395,att = 335757,hp_lim = 17566290,hit = 10456,dodge = 6970,ten = 5576,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201314,Rem) ->
	#mon{id = 1201314,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 425,att = 220478,hp_lim = 10823509,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201404,Rem) ->
	#mon{id = 1201404,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 395,att = 178915,hp_lim = 8783145,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201410,Rem) ->
	#mon{id = 1201410,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 425,att = 220478,hp_lim = 10823509,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201416,Rem) ->
	#mon{id = 1201416,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 455,att = 273785,hp_lim = 13440368,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201506,Rem) ->
	#mon{id = 1201506,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 425,att = 220478,hp_lim = 10823509,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201512,Rem) ->
	#mon{id = 1201512,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 455,att = 513791,hp_lim = 26880736,hit = 16000,dodge = 10666,ten = 8533,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201602,Rem) ->
	#mon{id = 1201602,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 428,att = 227774,hp_lim = 11181644,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201608,Rem) ->
	#mon{id = 1201608,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 455,att = 513791,hp_lim = 26880736,hit = 16000,dodge = 10666,ten = 8533,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201614,Rem) ->
	#mon{id = 1201614,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 485,att = 331331,hp_lim = 16265385,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201704,Rem) ->
	#mon{id = 1201704,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 455,att = 273785,hp_lim = 13440368,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201710,Rem) ->
	#mon{id = 1201710,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 485,att = 331331,hp_lim = 16265385,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201716,Rem) ->
	#mon{id = 1201716,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 515,att = 411461,hp_lim = 20199038,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201806,Rem) ->
	#mon{id = 1201806,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 485,att = 331331,hp_lim = 16265385,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201812,Rem) ->
	#mon{id = 1201812,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 515,att = 772159,hp_lim = 40398077,hit = 24046,dodge = 16030,ten = 12824,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201902,Rem) ->
	#mon{id = 1201902,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 488,att = 331331,hp_lim = 16265385,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201908,Rem) ->
	#mon{id = 1201908,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 515,att = 772159,hp_lim = 40398077,hit = 24046,dodge = 16030,ten = 12824,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201914,Rem) ->
	#mon{id = 1201914,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 545,att = 572899,hp_lim = 28124148,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202004,Rem) ->
	#mon{id = 1202004,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 515,att = 411461,hp_lim = 20199038,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202010,Rem) ->
	#mon{id = 1202010,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 545,att = 572899,hp_lim = 28124148,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202016,Rem) ->
	#mon{id = 1202016,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 575,att = 770703,hp_lim = 37834547,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202106,Rem) ->
	#mon{id = 1202106,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 545,att = 572899,hp_lim = 28124148,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202112,Rem) ->
	#mon{id = 1202112,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 575,att = 1446320,hp_lim = 75669095,hit = 45041,dodge = 30027,ten = 24021,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202202,Rem) ->
	#mon{id = 1202202,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 548,att = 594946,hp_lim = 29206469,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202208,Rem) ->
	#mon{id = 1202208,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 575,att = 1446320,hp_lim = 75669095,hit = 45041,dodge = 30027,ten = 24021,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202214,Rem) ->
	#mon{id = 1202214,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 605,att = 1058011,hp_lim = 51938727,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202304,Rem) ->
	#mon{id = 1202304,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 575,att = 770703,hp_lim = 37834547,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202310,Rem) ->
	#mon{id = 1202310,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 605,att = 1058011,hp_lim = 51938727,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202316,Rem) ->
	#mon{id = 1202316,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 635,att = 1423943,hp_lim = 69902688,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202406,Rem) ->
	#mon{id = 1202406,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 605,att = 1058011,hp_lim = 51938727,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202412,Rem) ->
	#mon{id = 1202412,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 635,att = 2672205,hp_lim = 139805376,hit = 83217,dodge = 55478,ten = 44382,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(2001102,Rem) ->
	#mon{id = 2001102,name = "赛博暴民",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 80,att = 313,hp_lim = 8493,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2003202,Rem) ->
	#mon{id = 2003202,name = "生化护卫",type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 115,att = 2821,hp_lim = 76440,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2004102,Rem) ->
	#mon{id = 2004102,name = "海族迦娜",type = 1,color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 3134,hp_lim = 84933,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2006202,Rem) ->
	#mon{id = 2006202,name = "地底狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 140,att = 6268,hp_lim = 169866,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2007102,Rem) ->
	#mon{id = 2007102,name = "赛博暴民",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 160,att = 6582,hp_lim = 178360,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2009202,Rem) ->
	#mon{id = 2009202,name = "机械触须",type = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 175,att = 8619,hp_lim = 233566,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2010102,Rem) ->
	#mon{id = 2010102,name = "病毒行者",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 9089,hp_lim = 246306,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2012202,Rem) ->
	#mon{id = 2012202,name = "地底狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 220,att = 13791,hp_lim = 373706,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2013102,Rem) ->
	#mon{id = 2013102,name = "赛博暴民",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 12537,hp_lim = 339733,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2015202,Rem) ->
	#mon{id = 2015202,name = "地底狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 380,att = 54852,hp_lim = 1486333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2100102,Rem) ->
	#mon{id = 2100102,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 1378,hp_lim = 924000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 778,is_hit_ac = 1,rem_flag = Rem};
get(2100108,Rem) ->
	#mon{id = 2100108,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 155,att = 2757,hp_lim = 1848000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 787,is_hit_ac = 1,rem_flag = Rem};
get(2100204,Rem) ->
	#mon{id = 2100204,name = "生化守卫",color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 4825,hp_lim = 3234000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 816,is_hit_ac = 1,rem_flag = Rem};
get(2100210,Rem) ->
	#mon{id = 2100210,name = "赛博先锋",color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 215,att = 7123,hp_lim = 4774000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 868,is_hit_ac = 1,rem_flag = Rem};
get(2100306,Rem) ->
	#mon{id = 2100306,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 245,att = 10780,hp_lim = 7225127,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 933,is_hit_ac = 1,rem_flag = Rem};
get(2100402,Rem) ->
	#mon{id = 2100402,name = "音乐丧民",color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 275,att = 16663,hp_lim = 11168227,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1003,is_hit_ac = 1,rem_flag = Rem};
get(2100408,Rem) ->
	#mon{id = 2100408,name = "赛博暴民",color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 305,att = 21808,hp_lim = 14616182,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1092,is_hit_ac = 1,rem_flag = Rem};
get(2100504,Rem) ->
	#mon{id = 2100504,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 335,att = 30331,hp_lim = 20328273,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1213,is_hit_ac = 1,rem_flag = Rem};
get(2100510,Rem) ->
	#mon{id = 2100510,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 365,att = 38225,hp_lim = 25619020,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1328,is_hit_ac = 1,rem_flag = Rem};
get(2100606,Rem) ->
	#mon{id = 2100606,name = "原始巫妖",color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 395,att = 48537,hp_lim = 32530169,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1468,is_hit_ac = 1,rem_flag = Rem};
get(2100702,Rem) ->
	#mon{id = 2100702,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 425,att = 59812,hp_lim = 40087075,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1618,is_hit_ac = 1,rem_flag = Rem};
get(2100708,Rem) ->
	#mon{id = 2100708,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 455,att = 74273,hp_lim = 49779142,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1778,is_hit_ac = 1,rem_flag = Rem};
get(2100804,Rem) ->
	#mon{id = 2100804,name = "生化守卫",color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 485,att = 89885,hp_lim = 60242168,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100810,Rem) ->
	#mon{id = 2100810,name = "赛博先锋",color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 515,att = 111623,hp_lim = 74811254,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100906,Rem) ->
	#mon{id = 2100906,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 545,att = 155418,hp_lim = 104163514,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101002,Rem) ->
	#mon{id = 2101002,name = "音乐丧民",color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 575,att = 209079,hp_lim = 140127953,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101008,Rem) ->
	#mon{id = 2101008,name = "赛博暴民",color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 605,att = 287021,hp_lim = 192365656,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101104,Rem) ->
	#mon{id = 2101104,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 635,att = 386293,hp_lim = 258898843,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101110,Rem) ->
	#mon{id = 2101110,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 665,att = 519900,hp_lim = 348443753,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101206,Rem) ->
	#mon{id = 2101206,name = "原始巫妖",color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 695,att = 713711,hp_lim = 478338609,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101302,Rem) ->
	#mon{id = 2101302,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 725,att = 960561,hp_lim = 643780788,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101308,Rem) ->
	#mon{id = 2101308,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 755,att = 1292789,hp_lim = 866444180,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101404,Rem) ->
	#mon{id = 2101404,name = "生化守卫",color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 785,att = 1774723,hp_lim = 1189442191,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101410,Rem) ->
	#mon{id = 2101410,name = "赛博先锋",color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 815,att = 2637145,hp_lim = 1767448529,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101506,Rem) ->
	#mon{id = 2101506,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 845,att = 5069203,hp_lim = 3397445065,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2300004,Rem) ->
	#mon{id = 2300004,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 135,att = 15224,hp_lim = 382725,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300010,Rem) ->
	#mon{id = 2300010,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 170,att = 27944,hp_lim = 846720,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300016,Rem) ->
	#mon{id = 2300016,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 230,att = 57223,hp_lim = 1941975,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300022,Rem) ->
	#mon{id = 2300022,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 290,att = 122810,hp_lim = 4252805,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300028,Rem) ->
	#mon{id = 2300028,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 350,att = 222651,hp_lim = 7556008,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300034,Rem) ->
	#mon{id = 2300034,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 410,att = 374806,hp_lim = 12470199,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300040,Rem) ->
	#mon{id = 2300040,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 470,att = 560531,hp_lim = 18649471,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300046,Rem) ->
	#mon{id = 2300046,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 530,att = 1494214,hp_lim = 39006440,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(3000006,Rem) ->
	#mon{id = 3000006,name = "虚空触手",boss = 6,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10000020,Rem) ->
	#mon{id = 10000020,name = "弃用待查",kind = 2,color = 1,icon = 2040009,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10010106,Rem) ->
	#mon{id = 10010106,name = "管道多足虫",boss = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202032,lv = 14,att = 24,hp_lim = 1653,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 2,is_hit_ac = 1,rem_flag = Rem};
get(10010202,Rem) ->
	#mon{id = 10010202,name = "科技装备",kind = 2,color = 1,icon = 10010202,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 3,att = 13,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10020102,Rem) ->
	#mon{id = 10020102,name = "吊塔指挥",boss = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202036,lv = 26,att = 36,hp_lim = 2484,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 6,is_hit_ac = 1,rem_flag = Rem};
get(10020204,Rem) ->
	#mon{id = 10020204,name = "旋转木马",kind = 2,color = 1,icon = 10020203,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10040202,Rem) ->
	#mon{id = 10040202,name = "体感游戏机",kind = 2,color = 1,icon = 10080201,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10050102,Rem) ->
	#mon{id = 10050102,name = "荧光水母",boss = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 89,att = 99,hp_lim = 26720,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 14,is_hit_ac = 1,rem_flag = Rem};
get(10070106,Rem) ->
	#mon{id = 10070106,name = "机械守卫",boss = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 134,att = 100,hp_lim = 192000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 19,is_hit_ac = 1,rem_flag = Rem};
get(10070202,Rem) ->
	#mon{id = 10070202,name = "推荐信",kind = 2,color = 1,icon = 10070202,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10080102,Rem) ->
	#mon{id = 10080102,name = "蜥蜴劳工",boss = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 155,att = 100,hp_lim = 352000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 23,is_hit_ac = 1,rem_flag = Rem};
get(10080108,Rem) ->
	#mon{id = 10080108,name = "故障机械",boss = 1,color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 190,att = 100,hp_lim = 672000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 27,is_hit_ac = 1,rem_flag = Rem};
get(10090104,Rem) ->
	#mon{id = 10090104,name = "雪山伪装者",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 260,att = 100,hp_lim = 2001275,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 31,is_hit_ac = 1,rem_flag = Rem};
get(10100106,Rem) ->
	#mon{id = 10100106,name = "触手沙怪",boss = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 360,att = 100,hp_lim = 5605925,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 62,is_hit_ac = 1,rem_flag = Rem};
get(10100202,Rem) ->
	#mon{id = 10100202,name = "矿石残渣",kind = 2,color = 1,icon = 10020202,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10110102,Rem) ->
	#mon{id = 10110102,name = "书馆守卫",boss = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 390,att = 100,hp_lim = 7162275,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 70,is_hit_ac = 1,rem_flag = Rem};
get(10120104,Rem) ->
	#mon{id = 10120104,name = "执行者残影",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 445,att = 100,hp_lim = 10724825,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 104,is_hit_ac = 1,rem_flag = Rem};
get(10130106,Rem) ->
	#mon{id = 10130106,name = "基地蜥蜴",boss = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 495,att = 100,hp_lim = 14484075,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 152,is_hit_ac = 1,rem_flag = Rem};
get(10140102,Rem) ->
	#mon{id = 10140102,name = "尾随小贩",boss = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202010,lv = 505,att = 100,hp_lim = 15582800,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 162,rem_flag = Rem};
get(10150104,Rem) ->
	#mon{id = 10150104,name = "囚禁科学家",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202009,lv = 585,att = 100,hp_lim = 35362875,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 242,rem_flag = Rem};
get(11001006,Rem) ->
	#mon{id = 11001006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 5440,hp_lim = 1008000,hit = 144,dodge = 96,ten = 76,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001012,Rem) ->
	#mon{id = 11001012,name = "隐秘人马",boss = 6,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 142,att = 7480,hp_lim = 1386000,hit = 198,dodge = 132,ten = 105,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001018,Rem) ->
	#mon{id = 11001018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 154,att = 10596,hp_lim = 1963500,hit = 280,dodge = 187,ten = 149,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001024,Rem) ->
	#mon{id = 11001024,name = "神盾战士",boss = 6,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 166,att = 15413,hp_lim = 2856000,hit = 408,dodge = 272,ten = 217,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001030,Rem) ->
	#mon{id = 11001030,name = "变异恶犬",boss = 6,type = 1,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 178,att = 20230,hp_lim = 3748500,hit = 535,dodge = 357,ten = 285,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002002,Rem) ->
	#mon{id = 11002002,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 182,att = 14098,hp_lim = 1256850,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002008,Rem) ->
	#mon{id = 11002008,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 194,att = 18915,hp_lim = 1686300,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002014,Rem) ->
	#mon{id = 11002014,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 206,att = 24874,hp_lim = 2217600,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002020,Rem) ->
	#mon{id = 11002020,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 218,att = 29844,hp_lim = 2660700,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002026,Rem) ->
	#mon{id = 11002026,name = "无畏暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 34368,hp_lim = 3064005,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003004,Rem) ->
	#mon{id = 11003004,name = "阴影蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 246,att = 39631,hp_lim = 3533210,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003010,Rem) ->
	#mon{id = 11003010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 258,att = 46324,hp_lim = 4129884,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003016,Rem) ->
	#mon{id = 11003016,name = "沙漠守卫",type = 1,color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 270,att = 52233,hp_lim = 4656632,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003022,Rem) ->
	#mon{id = 11003022,name = "蒙面刺客",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 282,att = 57780,hp_lim = 5151185,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003028,Rem) ->
	#mon{id = 11003028,name = "神殿仆从",type = 1,color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 294,att = 66367,hp_lim = 5916683,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004006,Rem) ->
	#mon{id = 11004006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 131934,hp_lim = 24446669,hit = 3492,dodge = 2328,ten = 1862,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004012,Rem) ->
	#mon{id = 11004012,name = "隐秘人马",boss = 6,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 322,att = 147793,hp_lim = 27385173,hit = 3912,dodge = 2608,ten = 2086,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004018,Rem) ->
	#mon{id = 11004018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 334,att = 156334,hp_lim = 28967789,hit = 4138,dodge = 2758,ten = 2207,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004024,Rem) ->
	#mon{id = 11004024,name = "神盾战士",boss = 6,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 346,att = 181237,hp_lim = 33582265,hit = 4797,dodge = 3198,ten = 2558,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004030,Rem) ->
	#mon{id = 11004030,name = "变异恶犬",boss = 6,type = 1,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 358,att = 208470,hp_lim = 38628446,hit = 5518,dodge = 3678,ten = 2943,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005002,Rem) ->
	#mon{id = 11005002,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 362,att = 132987,hp_lim = 11855978,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005008,Rem) ->
	#mon{id = 11005008,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 374,att = 158198,hp_lim = 14103554,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005014,Rem) ->
	#mon{id = 11005014,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 386,att = 194492,hp_lim = 17339177,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005020,Rem) ->
	#mon{id = 11005020,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 398,att = 232310,hp_lim = 20710728,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005026,Rem) ->
	#mon{id = 11005026,name = "无畏暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 420,att = 297143,hp_lim = 26490616,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006004,Rem) ->
	#mon{id = 11006004,name = "阴影蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 452,att = 413325,hp_lim = 36848324,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006010,Rem) ->
	#mon{id = 11006010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 476,att = 509459,hp_lim = 45418810,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006016,Rem) ->
	#mon{id = 11006016,name = "沙漠守卫",type = 1,color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 500,att = 628753,hp_lim = 56053998,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006022,Rem) ->
	#mon{id = 11006022,name = "蒙面刺客",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 524,att = 852702,hp_lim = 76019215,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006028,Rem) ->
	#mon{id = 11006028,name = "神殿仆从",type = 1,color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 548,att = 1156080,hp_lim = 103065638,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007006,Rem) ->
	#mon{id = 11007006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 580,att = 2768743,hp_lim = 513031925,hit = 73290,dodge = 48860,ten = 39088,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007012,Rem) ->
	#mon{id = 11007012,name = "隐秘人马",boss = 6,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 604,att = 3694641,hp_lim = 684595406,hit = 97799,dodge = 65199,ten = 52159,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007018,Rem) ->
	#mon{id = 11007018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 628,att = 4918047,hp_lim = 911285363,hit = 130183,dodge = 86789,ten = 69431,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007024,Rem) ->
	#mon{id = 11007024,name = "神盾战士",boss = 6,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 652,att = 6662587,hp_lim = 1234538259,hit = 176362,dodge = 117575,ten = 94060,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007030,Rem) ->
	#mon{id = 11007030,name = "变异恶犬",boss = 6,type = 1,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 676,att = 8830964,hp_lim = 1636325780,hit = 233760,dodge = 155840,ten = 124672,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008002,Rem) ->
	#mon{id = 11008002,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 684,att = 6058721,hp_lim = 540140697,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008008,Rem) ->
	#mon{id = 11008008,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 708,att = 8010718,hp_lim = 714163144,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008014,Rem) ->
	#mon{id = 11008014,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 732,att = 10721322,hp_lim = 955816010,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008020,Rem) ->
	#mon{id = 11008020,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 756,att = 14214719,hp_lim = 1267255626,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008026,Rem) ->
	#mon{id = 11008026,name = "无畏暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 780,att = 18707659,hp_lim = 1667805526,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12010014,Rem) ->
	#mon{id = 12010014,name = "机械猿猴",boss = 6,color = 1,module = 610,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 5193,hp_lim = 906018,hit = 179,dodge = 119,ten = 95,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12030012,Rem) ->
	#mon{id = 12030012,name = "铁血战姬",boss = 6,color = 1,module = 610,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 48154,hp_lim = 8401034,hit = 1666,dodge = 1111,ten = 888,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12040014,Rem) ->
	#mon{id = 12040014,name = "炎甲美杜莎",boss = 6,color = 1,module = 610,icon = 100400042,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 340,att = 237878,hp_lim = 41500562,hit = 8234,dodge = 5489,ten = 4391,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12060012,Rem) ->
	#mon{id = 12060012,name = "嗜血霸尸",boss = 6,color = 1,module = 610,icon = 100400011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 525,att = 620189,hp_lim = 108199249,hit = 21468,dodge = 14312,ten = 11449,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13030002,Rem) ->
	#mon{id = 13030002,name = "能量光侍",boss = 3,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 44353,hp_lim = 48246738,hit = 2393,dodge = 1595,ten = 1276,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13060002,Rem) ->
	#mon{id = 13060002,name = "静谧三角",boss = 3,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 555,att = 462403,hp_lim = 502989054,hit = 24949,dodge = 16633,ten = 13306,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14020002,Rem) ->
	#mon{id = 14020002,name = "兵器少女",boss = 4,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 13875,hp_lim = 94500000,hit = 562,dodge = 375,ten = 300,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14050002,Rem) ->
	#mon{id = 14050002,name = "地狱猎犬",boss = 4,type = 1,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 597340,hp_lim = 3584042000,hit = 21333,dodge = 14222,ten = 11377,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14060004,Rem) ->
	#mon{id = 14060004,name = "疯狂博士",boss = 4,type = 1,color = 1,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 575,att = 1342662,hp_lim = 8055974050,hit = 47952,dodge = 31968,ten = 25574,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(15010002,Rem) ->
	#mon{id = 15010002,name = "物资宝箱",kind = 1,color = 1,icon = 10010404,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,hp_lim = 3732752,def = 109008,hit = 34855,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 1,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(18010002,Rem) ->
	#mon{id = 18010002,name = "光刃利爪",boss = 9,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 2166,hp_lim = 2552163,hit = 126,dodge = 84,ten = 67,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18020004,Rem) ->
	#mon{id = 18020004,name = "寄生触手",boss = 9,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 190,att = 20496,hp_lim = 15240960,hit = 756,dodge = 504,ten = 403,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18030006,Rem) ->
	#mon{id = 18030006,name = "将级异形",boss = 9,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 202025,hp_lim = 150227238,hit = 7451,dodge = 4967,ten = 3974,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18040002,Rem) ->
	#mon{id = 18040002,name = "不灭血魔",boss = 9,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 340,att = 124021,hp_lim = 92223471,hit = 4574,dodge = 3049,ten = 2439,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18050004,Rem) ->
	#mon{id = 18050004,name = "超级机甲",boss = 9,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 480,att = 409240,hp_lim = 304313562,hit = 15094,dodge = 10063,ten = 8050,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18060006,Rem) ->
	#mon{id = 18060006,name = "病毒人马",boss = 9,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 620,att = 2567433,hp_lim = 1909160667,hit = 94700,dodge = 63133,ten = 50506,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19010004,Rem) ->
	#mon{id = 19010004,name = "能量光侍",boss = 12,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 10522,hp_lim = 26082000,hit = 388,dodge = 258,ten = 207,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19020006,Rem) ->
	#mon{id = 19020006,name = "兵器少女",boss = 12,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 250,att = 104346,hp_lim = 258643620,hit = 3848,dodge = 2565,ten = 2052,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19030002,Rem) ->
	#mon{id = 19030002,name = "能量光侍",boss = 12,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 84732,hp_lim = 210025870,hit = 3125,dodge = 2083,ten = 1666,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19040004,Rem) ->
	#mon{id = 19040004,name = "寄生之爪",boss = 12,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 390,att = 409593,hp_lim = 1015254470,hit = 15107,dodge = 10071,ten = 8057,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19050006,Rem) ->
	#mon{id = 19050006,name = "收割死神",boss = 12,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 540,att = 1284898,hp_lim = 3184862580,hit = 47393,dodge = 31595,ten = 25276,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19060002,Rem) ->
	#mon{id = 19060002,name = "病毒行者",boss = 12,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 530,att = 1162096,hp_lim = 2880475660,hit = 42864,dodge = 28576,ten = 22860,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20010006,Rem) ->
	#mon{id = 20010006,name = "异形长枪",boss = 13,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 20130,hp_lim = 49896000,hit = 742,dodge = 495,ten = 396,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20020002,Rem) ->
	#mon{id = 20020002,name = "远古血魔",boss = 13,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 10980,hp_lim = 27216000,hit = 405,dodge = 270,ten = 216,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20030004,Rem) ->
	#mon{id = 20030004,name = "光刃利爪",boss = 13,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 290,att = 168073,hp_lim = 416601360,hit = 6199,dodge = 4132,ten = 3306,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20040006,Rem) ->
	#mon{id = 20040006,name = "超能兵器",boss = 13,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 594924,hp_lim = 1474631970,hit = 21943,dodge = 14629,ten = 11703,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20050002,Rem) ->
	#mon{id = 20050002,name = "疯狂博士",boss = 13,type = 1,color = 1,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 558931,hp_lim = 1385417930,hit = 20616,dodge = 13744,ten = 10995,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20060004,Rem) ->
	#mon{id = 20060004,name = "病毒机甲",boss = 13,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 590,att = 2146096,hp_lim = 5319504330,hit = 79159,dodge = 52772,ten = 42218,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(43001004,Rem) ->
	#mon{id = 43001004,name = "东城中枢",kind = 11,boss = 1,color = 1,icon = 10010306,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 1,att = 1000,hp_lim = 1131000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(60401100,Rem) ->
	#mon{id = 60401100,name = "空间古兽",boss = 6,type = 1,color = 1,module = 604,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 2400,hp_lim = 453600000,hit = 225,dodge = 150,ten = 120,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60401400,Rem) ->
	#mon{id = 60401400,name = "星门守望者",boss = 6,type = 1,color = 1,module = 604,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4000,hp_lim = 1512000000,hit = 375,dodge = 250,ten = 200,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60402006,Rem) ->
	#mon{id = 60402006,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403002,Rem) ->
	#mon{id = 60403002,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403008,Rem) ->
	#mon{id = 60403008,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(70010004,Rem) ->
	#mon{id = 70010004,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 86,att = 625,hp_lim = 162223,hit = 33,dodge = 22,ten = 17,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010010,Rem) ->
	#mon{id = 70010010,name = "赛博战士",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 2862,hp_lim = 374220,hit = 121,dodge = 81,ten = 64,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010016,Rem) ->
	#mon{id = 70010016,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 4080,hp_lim = 1058400,hit = 216,dodge = 144,ten = 115,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010022,Rem) ->
	#mon{id = 70010022,name = "海族娜迦",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 8586,hp_lim = 1122660,hit = 364,dodge = 243,ten = 194,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010028,Rem) ->
	#mon{id = 70010028,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 10200,hp_lim = 2646000,hit = 540,dodge = 360,ten = 288,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010034,Rem) ->
	#mon{id = 70010034,name = "地底石怪",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 18603,hp_lim = 2432430,hit = 789,dodge = 526,ten = 421,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010040,Rem) ->
	#mon{id = 70010040,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 19380,hp_lim = 5027400,hit = 1026,dodge = 684,ten = 547,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010046,Rem) ->
	#mon{id = 70010046,name = "生化守卫",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 31482,hp_lim = 4116420,hit = 1336,dodge = 891,ten = 712,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010052,Rem) ->
	#mon{id = 70010052,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 150,att = 30600,hp_lim = 7938000,hit = 1620,dodge = 1080,ten = 864,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010058,Rem) ->
	#mon{id = 70010058,name = "赛博战士",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 155,att = 48654,hp_lim = 6361740,hit = 2065,dodge = 1377,ten = 1101,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010064,Rem) ->
	#mon{id = 70010064,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 165,att = 42840,hp_lim = 11113200,hit = 2268,dodge = 1512,ten = 1209,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010070,Rem) ->
	#mon{id = 70010070,name = "海族娜迦",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 170,att = 68688,hp_lim = 8981280,hit = 2916,dodge = 1944,ten = 1555,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010076,Rem) ->
	#mon{id = 70010076,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 180,att = 61200,hp_lim = 15876000,hit = 3240,dodge = 2160,ten = 1728,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010082,Rem) ->
	#mon{id = 70010082,name = "地底石怪",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 185,att = 94446,hp_lim = 12349260,hit = 4009,dodge = 2673,ten = 2138,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010088,Rem) ->
	#mon{id = 70010088,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 195,att = 81600,hp_lim = 21168000,hit = 4320,dodge = 2880,ten = 2304,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010094,Rem) ->
	#mon{id = 70010094,name = "生化守卫",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 200,att = 125928,hp_lim = 16465680,hit = 5346,dodge = 3564,ten = 2851,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010100,Rem) ->
	#mon{id = 70010100,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 210,att = 106080,hp_lim = 27518400,hit = 5616,dodge = 3744,ten = 2995,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010106,Rem) ->
	#mon{id = 70010106,name = "赛博战士",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 215,att = 160272,hp_lim = 20956320,hit = 6804,dodge = 4536,ten = 3628,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010112,Rem) ->
	#mon{id = 70010112,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 225,att = 138720,hp_lim = 35985600,hit = 7344,dodge = 4896,ten = 3916,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010118,Rem) ->
	#mon{id = 70010118,name = "海族娜迦",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 230,att = 217512,hp_lim = 28440720,hit = 9234,dodge = 6156,ten = 4924,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010124,Rem) ->
	#mon{id = 70010124,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 240,att = 187680,hp_lim = 48686400,hit = 9936,dodge = 6624,ten = 5299,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010130,Rem) ->
	#mon{id = 70010130,name = "地底石怪",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 245,att = 286200,hp_lim = 37422000,hit = 12150,dodge = 8100,ten = 6480,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010136,Rem) ->
	#mon{id = 70010136,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 255,att = 236640,hp_lim = 61387200,hit = 12528,dodge = 8352,ten = 6681,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010142,Rem) ->
	#mon{id = 70010142,name = "生化守卫",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 260,att = 354888,hp_lim = 46403280,hit = 15066,dodge = 10044,ten = 8035,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010148,Rem) ->
	#mon{id = 70010148,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 270,att = 285600,hp_lim = 74088000,hit = 15120,dodge = 10080,ten = 8064,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010154,Rem) ->
	#mon{id = 70010154,name = "赛博战士",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 429300,hp_lim = 56133000,hit = 18225,dodge = 12150,ten = 9720,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010160,Rem) ->
	#mon{id = 70010160,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 285,att = 346800,hp_lim = 89964000,hit = 18360,dodge = 12240,ten = 9792,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010166,Rem) ->
	#mon{id = 70010166,name = "海族娜迦",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 290,att = 515160,hp_lim = 67359600,hit = 21870,dodge = 14580,ten = 11664,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010172,Rem) ->
	#mon{id = 70010172,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 300,att = 408000,hp_lim = 105840000,hit = 21600,dodge = 14400,ten = 11520,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010178,Rem) ->
	#mon{id = 70010178,name = "地底石怪",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 601020,hp_lim = 78586200,hit = 25515,dodge = 17010,ten = 13608,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010184,Rem) ->
	#mon{id = 70010184,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 315,att = 469200,hp_lim = 121716000,hit = 24840,dodge = 16560,ten = 13248,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010190,Rem) ->
	#mon{id = 70010190,name = "生化守卫",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 715500,hp_lim = 93555000,hit = 30375,dodge = 20250,ten = 16200,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010196,Rem) ->
	#mon{id = 70010196,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 330,att = 591600,hp_lim = 153468000,hit = 31320,dodge = 20880,ten = 16704,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010202,Rem) ->
	#mon{id = 70010202,name = "生化守卫",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 335,att = 887220,hp_lim = 116008200,hit = 37665,dodge = 25110,ten = 20088,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010208,Rem) ->
	#mon{id = 70010208,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 345,att = 714000,hp_lim = 185220000,hit = 37800,dodge = 25200,ten = 20160,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010214,Rem) ->
	#mon{id = 70010214,name = "赛博战士",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 350,att = 1058940,hp_lim = 138461400,hit = 44955,dodge = 29970,ten = 23976,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010220,Rem) ->
	#mon{id = 70010220,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 360,att = 836400,hp_lim = 216972000,hit = 44280,dodge = 29520,ten = 23616,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010226,Rem) ->
	#mon{id = 70010226,name = "海族娜迦",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 365,att = 1230660,hp_lim = 160914600,hit = 52245,dodge = 34830,ten = 27864,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010232,Rem) ->
	#mon{id = 70010232,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 375,att = 958800,hp_lim = 248724000,hit = 50760,dodge = 33840,ten = 27072,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010238,Rem) ->
	#mon{id = 70010238,name = "地底石怪",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 380,att = 1402380,hp_lim = 183367800,hit = 59535,dodge = 39690,ten = 31752,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010244,Rem) ->
	#mon{id = 70010244,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 390,att = 1081200,hp_lim = 280476000,hit = 57240,dodge = 38160,ten = 30528,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010250,Rem) ->
	#mon{id = 70010250,name = "生化守卫",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 395,att = 1574100,hp_lim = 205821000,hit = 66825,dodge = 44550,ten = 35640,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010256,Rem) ->
	#mon{id = 70010256,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 405,att = 1326000,hp_lim = 343980000,hit = 70200,dodge = 46800,ten = 37440,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010262,Rem) ->
	#mon{id = 70010262,name = "赛博战士",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 410,att = 2003400,hp_lim = 261954000,hit = 85050,dodge = 56700,ten = 45360,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010268,Rem) ->
	#mon{id = 70010268,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 1632000,hp_lim = 423360000,hit = 86400,dodge = 57600,ten = 46080,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010274,Rem) ->
	#mon{id = 70010274,name = "海族娜迦",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 425,att = 2432700,hp_lim = 318087000,hit = 103275,dodge = 68850,ten = 55080,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010280,Rem) ->
	#mon{id = 70010280,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 435,att = 1938000,hp_lim = 502740000,hit = 102600,dodge = 68400,ten = 54720,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010286,Rem) ->
	#mon{id = 70010286,name = "地底石怪",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 2862000,hp_lim = 374220000,hit = 121500,dodge = 81000,ten = 64800,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010292,Rem) ->
	#mon{id = 70010292,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 450,att = 2856000,hp_lim = 740880000,hit = 151200,dodge = 100800,ten = 80640,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010298,Rem) ->
	#mon{id = 70010298,name = "生化守卫",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 455,att = 4579200,hp_lim = 598752000,hit = 194400,dodge = 129600,ten = 103680,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010502,Rem) ->
	#mon{id = 70010502,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 100100031,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 116,att = 15300,hp_lim = 1984500,hit = 405,dodge = 270,ten = 216,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010508,Rem) ->
	#mon{id = 70010508,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 100100091,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 164,att = 81600,hp_lim = 10584000,hit = 2160,dodge = 1440,ten = 1152,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010514,Rem) ->
	#mon{id = 70010514,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 100400022,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 215,att = 193800,hp_lim = 25137000,hit = 5130,dodge = 3420,ten = 2736,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010520,Rem) ->
	#mon{id = 70010520,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100052,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 367200,hp_lim = 47628000,hit = 9720,dodge = 6480,ten = 5184,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010526,Rem) ->
	#mon{id = 70010526,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 100100031,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 335,att = 612000,hp_lim = 79380000,hit = 16200,dodge = 10800,ten = 8640,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010532,Rem) ->
	#mon{id = 70010532,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 100100091,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 425,att = 1101600,hp_lim = 142884000,hit = 29160,dodge = 19440,ten = 15552,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010538,Rem) ->
	#mon{id = 70010538,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 100400022,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 515,att = 1632000,hp_lim = 211680000,hit = 43200,dodge = 28800,ten = 23040,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010544,Rem) ->
	#mon{id = 70010544,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100052,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 605,att = 2244000,hp_lim = 291060000,hit = 59400,dodge = 39600,ten = 31680,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70011000,Rem) ->
	#mon{id = 70011000,name = "无尽近卫",type = 1,color = 1,module = 20,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 42,att = 305,hp_lim = 16477,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80020002,Rem) ->
	#mon{id = 80020002,name = "机械黄蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80020008,Rem) ->
	#mon{id = 80020008,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80030004,Rem) ->
	#mon{id = 80030004,name = "森林贤王",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80050002,Rem) ->
	#mon{id = 80050002,name = "核心守护者",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80050008,Rem) ->
	#mon{id = 80050008,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80060004,Rem) ->
	#mon{id = 80060004,name = "合金仓鼠",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80080002,Rem) ->
	#mon{id = 80080002,name = "返祖变异人",type = 1,color = 1,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80080008,Rem) ->
	#mon{id = 80080008,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80090004,Rem) ->
	#mon{id = 80090004,name = "兽血改造者",boss = 6,type = 1,color = 3,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80110002,Rem) ->
	#mon{id = 80110002,name = "穿山蜥",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80110008,Rem) ->
	#mon{id = 80110008,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80120004,Rem) ->
	#mon{id = 80120004,name = "球形海怪",boss = 6,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80140002,Rem) ->
	#mon{id = 80140002,name = "土行从者",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80140008,Rem) ->
	#mon{id = 80140008,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80150004,Rem) ->
	#mon{id = 80150004,name = "深渊巨网",boss = 6,type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80170002,Rem) ->
	#mon{id = 80170002,name = "变异合成人",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80170008,Rem) ->
	#mon{id = 80170008,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80180004,Rem) ->
	#mon{id = 80180004,name = "蛇行者",boss = 6,type = 1,color = 3,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80200002,Rem) ->
	#mon{id = 80200002,name = "辐射章鱼",type = 1,color = 1,module = 610,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80200008,Rem) ->
	#mon{id = 80200008,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80210004,Rem) ->
	#mon{id = 80210004,name = "核心机甲",boss = 6,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80230002,Rem) ->
	#mon{id = 80230002,name = "武装蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80230008,Rem) ->
	#mon{id = 80230008,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80240004,Rem) ->
	#mon{id = 80240004,name = "原始巫妖",boss = 6,type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80260002,Rem) ->
	#mon{id = 80260002,name = "机械黄蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80260008,Rem) ->
	#mon{id = 80260008,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80270004,Rem) ->
	#mon{id = 80270004,name = "森林贤王",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010002,Rem) ->
	#mon{id = 81010002,name = "中路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 200,att = 30333,hp_lim = 32760000,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81010302,Rem) ->
	#mon{id = 81010302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 206,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010602,Rem) ->
	#mon{id = 81010602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 215,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010902,Rem) ->
	#mon{id = 81010902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 224,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011202,Rem) ->
	#mon{id = 81011202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 233,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011502,Rem) ->
	#mon{id = 81011502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 242,att = 129020,hp_lim = 6502612,hit = 2322,dodge = 1548,ten = 1238,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020004,Rem) ->
	#mon{id = 81020004,name = "初级箱子",kind = 1,color = 3,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 109,hp_lim = 5911,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81020202,Rem) ->
	#mon{id = 81020202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 245,att = 60209,hp_lim = 3251306,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020502,Rem) ->
	#mon{id = 81020502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 260,att = 156351,hp_lim = 7880115,hit = 2814,dodge = 1876,ten = 1500,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020802,Rem) ->
	#mon{id = 81020802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 275,att = 93068,hp_lim = 5025701,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021102,Rem) ->
	#mon{id = 81021102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 290,att = 107150,hp_lim = 5786130,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021402,Rem) ->
	#mon{id = 81021402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 121801,hp_lim = 6577281,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021702,Rem) ->
	#mon{id = 81021702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 320,att = 144895,hp_lim = 7824335,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022002,Rem) ->
	#mon{id = 81022002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 335,att = 363004,hp_lim = 18295443,hit = 6534,dodge = 4356,ten = 3484,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022302,Rem) ->
	#mon{id = 81022302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 350,att = 186568,hp_lim = 10074678,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030102,Rem) ->
	#mon{id = 81030102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 360,att = 208470,hp_lim = 11257433,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030402,Rem) ->
	#mon{id = 81030402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 369,att = 247238,hp_lim = 13350853,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030702,Rem) ->
	#mon{id = 81030702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 378,att = 289974,hp_lim = 15658614,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031002,Rem) ->
	#mon{id = 81031002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 387,att = 538527,hp_lim = 27141773,hit = 9693,dodge = 6462,ten = 5169,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031302,Rem) ->
	#mon{id = 81031302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 396,att = 374096,hp_lim = 20201233,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031602,Rem) ->
	#mon{id = 81031602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 405,att = 428437,hp_lim = 23135644,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031902,Rem) ->
	#mon{id = 81031902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 414,att = 487405,hp_lim = 26319904,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032202,Rem) ->
	#mon{id = 81032202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 423,att = 551197,hp_lim = 29764651,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032502,Rem) ->
	#mon{id = 81032502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 432,att = 763568,hp_lim = 38483831,hit = 13744,dodge = 9162,ten = 7330,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032802,Rem) ->
	#mon{id = 81032802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 441,att = 694078,hp_lim = 37480229,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033102,Rem) ->
	#mon{id = 81033102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 450,att = 773488,hp_lim = 41768383,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033402,Rem) ->
	#mon{id = 81033402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 459,att = 858096,hp_lim = 46337184,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033702,Rem) ->
	#mon{id = 81033702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 468,att = 948048,hp_lim = 51194627,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034002,Rem) ->
	#mon{id = 81034002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 477,att = 1021035,hp_lim = 51460201,hit = 18378,dodge = 12252,ten = 9801,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034302,Rem) ->
	#mon{id = 81034302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 486,att = 1144601,hp_lim = 61808464,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034602,Rem) ->
	#mon{id = 81034602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 495,att = 1251516,hp_lim = 67581901,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034902,Rem) ->
	#mon{id = 81034902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 504,att = 1397583,hp_lim = 75469484,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040002,Rem) ->
	#mon{id = 81040002,name = "中路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 500,att = 1386594,hp_lim = 1509502140,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81040302,Rem) ->
	#mon{id = 81040302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 508,att = 1500898,hp_lim = 81048506,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040602,Rem) ->
	#mon{id = 81040602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 520,att = 1779218,hp_lim = 96077784,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040902,Rem) ->
	#mon{id = 81040902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 532,att = 2087141,hp_lim = 112705660,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041202,Rem) ->
	#mon{id = 81041202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 544,att = 2426987,hp_lim = 131057303,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041502,Rem) ->
	#mon{id = 81041502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 556,att = 2079154,hp_lim = 104789386,hit = 37424,dodge = 24949,ten = 19959,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041802,Rem) ->
	#mon{id = 81041802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 568,att = 3334153,hp_lim = 180044311,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042102,Rem) ->
	#mon{id = 81042102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 580,att = 3866327,hp_lim = 208781688,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042402,Rem) ->
	#mon{id = 81042402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 592,att = 4479712,hp_lim = 241904458,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042702,Rem) ->
	#mon{id = 81042702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 604,att = 5186328,hp_lim = 280061757,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043002,Rem) ->
	#mon{id = 81043002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 616,att = 3792629,hp_lim = 191148501,hit = 68267,dodge = 45511,ten = 36409,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043302,Rem) ->
	#mon{id = 81043302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 625,att = 6800287,hp_lim = 367215504,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043602,Rem) ->
	#mon{id = 81043602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 634,att = 7551216,hp_lim = 407765675,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043902,Rem) ->
	#mon{id = 81043902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 643,att = 8547333,hp_lim = 461555998,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044202,Rem) ->
	#mon{id = 81044202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 652,att = 9669002,hp_lim = 522126139,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044502,Rem) ->
	#mon{id = 81044502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 661,att = 5980593,hp_lim = 301421933,hit = 107650,dodge = 71767,ten = 57413,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044802,Rem) ->
	#mon{id = 81044802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 670,att = 12110010,hp_lim = 653940551,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045102,Rem) ->
	#mon{id = 81045102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 679,att = 13408453,hp_lim = 724056503,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045402,Rem) ->
	#mon{id = 81045402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 688,att = 15135449,hp_lim = 817314279,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045702,Rem) ->
	#mon{id = 81045702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 697,att = 17076688,hp_lim = 922141169,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81046002,Rem) ->
	#mon{id = 81046002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 706,att = 9430794,hp_lim = 475312030,hit = 169754,dodge = 113169,ten = 90535,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050004,Rem) ->
	#mon{id = 81050004,name = "初级箱子",kind = 1,color = 3,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 475,hp_lim = 25655,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81050202,Rem) ->
	#mon{id = 81050202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 703,att = 18984866,hp_lim = 1025182804,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050502,Rem) ->
	#mon{id = 81050502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 712,att = 10008034,hp_lim = 504404926,hit = 180144,dodge = 120096,ten = 96077,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050802,Rem) ->
	#mon{id = 81050802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 721,att = 23616846,hp_lim = 1275309693,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051102,Rem) ->
	#mon{id = 81051102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 730,att = 26065976,hp_lim = 1407562708,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051402,Rem) ->
	#mon{id = 81051402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 739,att = 29045986,hp_lim = 1568483245,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051702,Rem) ->
	#mon{id = 81051702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 748,att = 31104826,hp_lim = 1679660619,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052002,Rem) ->
	#mon{id = 81052002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 757,att = 14300945,hp_lim = 720767661,hit = 257417,dodge = 171611,ten = 137289,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052302,Rem) ->
	#mon{id = 81052302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 766,att = 35281447,hp_lim = 1905198146,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052602,Rem) ->
	#mon{id = 81052602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 775,att = 37370926,hp_lim = 2018030020,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052902,Rem) ->
	#mon{id = 81052902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 784,att = 39967638,hp_lim = 2158252502,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053202,Rem) ->
	#mon{id = 81053202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 793,att = 43159348,hp_lim = 2330604826,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053502,Rem) ->
	#mon{id = 81053502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 802,att = 18523390,hp_lim = 933578864,hit = 333421,dodge = 222280,ten = 177824,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053802,Rem) ->
	#mon{id = 81053802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 811,att = 50284722,hp_lim = 2715375007,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054102,Rem) ->
	#mon{id = 81054102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 820,att = 54254896,hp_lim = 2929764386,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054402,Rem) ->
	#mon{id = 81054402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 829,att = 60296560,hp_lim = 3256014243,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054702,Rem) ->
	#mon{id = 81054702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 838,att = 66994062,hp_lim = 3617679370,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055002,Rem) ->
	#mon{id = 81055002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 847,att = 29275456,hp_lim = 1475482982,hit = 526958,dodge = 351305,ten = 281044,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055302,Rem) ->
	#mon{id = 81055302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 856,att = 100840587,hp_lim = 5445391714,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055602,Rem) ->
	#mon{id = 81055602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 865,att = 147933998,hp_lim = 7988435894,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055902,Rem) ->
	#mon{id = 81055902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 874,att = 349807796,hp_lim = 18889621016,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000002,Rem) ->
	#mon{id = 82000002,name = "丧尸霸主",boss = 6,color = 1,module = 610,auto = 3,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000008,Rem) ->
	#mon{id = 82000008,name = "异星监管者",boss = 6,color = 1,module = 610,auto = 3,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000014,Rem) ->
	#mon{id = 82000014,name = "网路歌姬",boss = 6,color = 1,module = 610,auto = 3,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000020,Rem) ->
	#mon{id = 82000020,name = "魔化雪兽",boss = 6,color = 1,module = 610,auto = 3,icon = 10030002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(83000004,Rem) ->
	#mon{id = 83000004,name = "时空领主分身",color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 200,att = 5000,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,drop = 1,is_armor = 1,del_hp_each_time = [9000,11000],is_hit_ac = 1,rem_flag = Rem};
get(84000006,Rem) ->
	#mon{id = 84000006,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 382,att = 451531,hp_lim = 15658614,hit = 9320,dodge = 6213,ten = 4970,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000012,Rem) ->
	#mon{id = 84000012,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 387,att = 268057,hp_lim = 8305381,hit = 9887,dodge = 6591,ten = 5273,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000018,Rem) ->
	#mon{id = 84000018,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 392,att = 631176,hp_lim = 16920907,hit = 10071,dodge = 6714,ten = 5371,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000024,Rem) ->
	#mon{id = 84000024,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 398,att = 530684,hp_lim = 18403565,hit = 10954,dodge = 7303,ten = 5842,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000030,Rem) ->
	#mon{id = 84000030,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 404,att = 718576,hp_lim = 19263963,hit = 11466,dodge = 7644,ten = 6115,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000036,Rem) ->
	#mon{id = 84000036,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 410,att = 620469,hp_lim = 21517209,hit = 12807,dodge = 8538,ten = 6830,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000042,Rem) ->
	#mon{id = 84000042,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 417,att = 835825,hp_lim = 22407227,hit = 13337,dodge = 8891,ten = 7113,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000048,Rem) ->
	#mon{id = 84000048,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 428,att = 741597,hp_lim = 25717781,hit = 15308,dodge = 10205,ten = 8164,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000054,Rem) ->
	#mon{id = 84000054,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 434,att = 995489,hp_lim = 26687601,hit = 15885,dodge = 10590,ten = 8472,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000060,Rem) ->
	#mon{id = 84000060,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 440,att = 850449,hp_lim = 29492641,hit = 17555,dodge = 11703,ten = 9362,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000066,Rem) ->
	#mon{id = 84000066,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 447,att = 1105797,hp_lim = 29644778,hit = 17645,dodge = 11763,ten = 9411,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000072,Rem) ->
	#mon{id = 84000072,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 458,att = 997147,hp_lim = 34579986,hit = 20583,dodge = 13722,ten = 10977,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000078,Rem) ->
	#mon{id = 84000078,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 464,att = 1294931,hp_lim = 34715192,hit = 20663,dodge = 13775,ten = 11020,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000084,Rem) ->
	#mon{id = 84000084,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 470,att = 1096640,hp_lim = 38030295,hit = 22637,dodge = 15091,ten = 12073,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000090,Rem) ->
	#mon{id = 84000090,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 477,att = 1462694,hp_lim = 39212671,hit = 23340,dodge = 15560,ten = 12448,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000096,Rem) ->
	#mon{id = 84000096,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 488,att = 1266376,hp_lim = 43916538,hit = 26140,dodge = 17427,ten = 13941,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000102,Rem) ->
	#mon{id = 84000102,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 494,att = 1684862,hp_lim = 45168661,hit = 26886,dodge = 17924,ten = 14339,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000108,Rem) ->
	#mon{id = 84000108,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 500,att = 1450932,hp_lim = 50316736,hit = 29950,dodge = 19966,ten = 15973,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000114,Rem) ->
	#mon{id = 84000114,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 507,att = 1926435,hp_lim = 51644862,hit = 30740,dodge = 20493,ten = 16395,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000120,Rem) ->
	#mon{id = 84000120,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 518,att = 1727532,hp_lim = 59908940,hit = 35660,dodge = 23773,ten = 19018,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000126,Rem) ->
	#mon{id = 84000126,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 528,att = 2490738,hp_lim = 66773001,hit = 39745,dodge = 26497,ten = 21197,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000132,Rem) ->
	#mon{id = 84000132,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 538,att = 2251201,hp_lim = 78069191,hit = 46469,dodge = 30979,ten = 24783,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000138,Rem) ->
	#mon{id = 84000138,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 548,att = 3202976,hp_lim = 85867021,hit = 51111,dodge = 34074,ten = 27259,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000144,Rem) ->
	#mon{id = 84000144,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 559,att = 2912887,hp_lim = 101015732,hit = 60128,dodge = 40085,ten = 32068,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000150,Rem) ->
	#mon{id = 84000150,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 569,att = 4042862,hp_lim = 108383110,hit = 64513,dodge = 43009,ten = 34407,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000156,Rem) ->
	#mon{id = 84000156,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 579,att = 3632231,hp_lim = 125961804,hit = 74977,dodge = 49984,ten = 39987,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000162,Rem) ->
	#mon{id = 84000162,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 589,att = 5192145,hp_lim = 139193696,hit = 82853,dodge = 55235,ten = 44188,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000168,Rem) ->
	#mon{id = 84000168,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 600,att = 4657355,hp_lim = 161511973,hit = 96138,dodge = 64092,ten = 51273,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000174,Rem) ->
	#mon{id = 84000174,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 615,att = 6930498,hp_lim = 185796346,hit = 110593,dodge = 73728,ten = 58982,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000180,Rem) ->
	#mon{id = 84000180,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 632,att = 6587295,hp_lim = 228440157,hit = 135976,dodge = 90650,ten = 72520,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000186,Rem) ->
	#mon{id = 84000186,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 647,att = 9807734,hp_lim = 262930746,hit = 156506,dodge = 104337,ten = 83470,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000192,Rem) ->
	#mon{id = 84000192,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 664,att = 9495092,hp_lim = 329279350,hit = 195999,dodge = 130666,ten = 104533,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000198,Rem) ->
	#mon{id = 84000198,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 679,att = 13867028,hp_lim = 371754384,hit = 221282,dodge = 147521,ten = 118017,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000204,Rem) ->
	#mon{id = 84000204,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 696,att = 13407147,hp_lim = 464945130,hit = 276753,dodge = 184502,ten = 147601,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000210,Rem) ->
	#mon{id = 84000210,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 711,att = 19981641,hp_lim = 535678035,hit = 318855,dodge = 212570,ten = 170056,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000216,Rem) ->
	#mon{id = 84000216,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 728,att = 18916394,hp_lim = 655999752,hit = 390476,dodge = 260317,ten = 208253,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000222,Rem) ->
	#mon{id = 84000222,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 743,att = 27383920,hp_lim = 734122128,hit = 436977,dodge = 291318,ten = 233054,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000228,Rem) ->
	#mon{id = 84000228,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 760,att = 24170052,hp_lim = 838190802,hit = 498923,dodge = 332615,ten = 266092,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000234,Rem) ->
	#mon{id = 84000234,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 775,att = 32991937,hp_lim = 884464718,hit = 526467,dodge = 350978,ten = 280782,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000240,Rem) ->
	#mon{id = 84000240,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 792,att = 29377981,hp_lim = 1018796058,hit = 606426,dodge = 404284,ten = 323427,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000246,Rem) ->
	#mon{id = 84000246,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 807,att = 41332809,hp_lim = 1108071057,hit = 659566,dodge = 439710,ten = 351768,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000252,Rem) ->
	#mon{id = 84000252,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 824,att = 37879909,hp_lim = 1313633568,hit = 781924,dodge = 521283,ten = 417026,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000258,Rem) ->
	#mon{id = 84000258,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 839,att = 56034872,hp_lim = 1502211475,hit = 894173,dodge = 596115,ten = 476892,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000264,Rem) ->
	#mon{id = 84000264,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 856,att = 65139472,hp_lim = 2258965197,hit = 1344622,dodge = 896414,ten = 717131,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000270,Rem) ->
	#mon{id = 84000270,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 871,att = 207396178,hp_lim = 5559982653,hit = 3309513,dodge = 2206342,ten = 1765073,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000276,Rem) ->
	#mon{id = 84000276,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 888,att = 555600064,hp_lim = 19267598579,hit = 11468808,dodge = 7645872,ten = 6116697,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(85000002,Rem) ->
	#mon{id = 85000002,name = "魔龙·耐萨里奥",boss = 11,color = 1,module = 331,sub_module = 117,auto = 1,icon = 10030002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 100000,hp_lim = 2000000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [4000,8000],rem_flag = Rem};
get(_MonTypeId, _Rem) -> [].