%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc
%%% 怪物配置数据（1/6）
%%% @end
%%% -------------------------------------------------------
-module(data_mon_1).
-export([
		get/2
	]).
-include("scene.hrl").

%% 获取怪物配置
%% Rem是求余结果，
%%   主要目的是为了拆散编译期生成大的literal字面常量，
%%   减少热更新移除旧模块时literal拷贝引发内存暴涨问题，
%%   此值请勿用于它处，不保证未来取值
-spec get(MonTypeId, Rem) -> #mon{} | [] when
	MonTypeId :: non_neg_integer(), Rem :: any().
get(1,Rem) ->
	#mon{id = 1,name = "皮卡丘1",boss = 7,type = 1,color = 7,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 500,att = 5000,hp_lim = 5000,resum = [1],hate_range = 500,skill = [{1110000001,1}],retime = 500,exp = 100,is_fight_back = 0,del_hp_each_time = [1,1],rem_flag = Rem};
get(7,Rem) ->
	#mon{id = 7,name = "归属掉落0",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 325,att = 1000,hp_lim = 256000,def = 6400,hit = 3200,dodge = 3200,crit = 3200,ten = 3200,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(13,Rem) ->
	#mon{id = 13,name = "掉落蓝装",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 500,att = 1439,hp_lim = 166164061,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(19,Rem) ->
	#mon{id = 19,name = "掉落5个",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 2,exp = 100,rem_flag = Rem};
get(25,Rem) ->
	#mon{id = 25,name = "掉落测试大礼包",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(31,Rem) ->
	#mon{id = 31,name = "掉落概率归属",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 600,att = 101042,hp_lim = 1479932,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(121,Rem) ->
	#mon{id = 121,name = "随机分配第一击",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 121,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 121,rem_flag = Rem};
get(133,Rem) ->
	#mon{id = 133,name = "均等分配无归属",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 133,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 133,rem_flag = Rem};
get(1003,Rem) ->
	#mon{id = 1003,name = "稀有外送",kind = 3,boss = 7,color = 5,icon = 10060103,icon_effect = <<"0"/utf8>>,weapon_id = 10060103,lv = 100,att = 100,hp_lim = 150,striking_distance = 250,speed = 300,is_fight_back = 0,del_hp_each_time = [1,1],rem_flag = Rem};
get(9001,Rem) ->
	#mon{id = 9001,name = "失落刺蛇",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 16000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(9007,Rem) ->
	#mon{id = 9007,name = "羽鹰工兵",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 22000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(9013,Rem) ->
	#mon{id = 9013,name = "矿坑蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 28000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(9019,Rem) ->
	#mon{id = 9019,name = "深渊执行者",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 34000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10003,Rem) ->
	#mon{id = 10003,name = "改造死侍",boss = 6,type = 1,color = 1,auto = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 11000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10009,Rem) ->
	#mon{id = 10009,name = "奸商会长",boss = 6,type = 1,color = 1,auto = 1,icon = 10010010,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 14000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10015,Rem) ->
	#mon{id = 10015,name = "水下异形",boss = 6,type = 1,color = 1,auto = 1,icon = 10040003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 17000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10021,Rem) ->
	#mon{id = 10021,name = "萝莉战姬",boss = 6,type = 1,color = 1,auto = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 20000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(350101,Rem) ->
	#mon{id = 350101,name = "转职检察官",boss = 6,color = 1,icon = 10030005,weapon_id = 202002,lv = 230,att = 104166,hp_lim = 5250000,hit = 1875,dodge = 1250,ten = 1000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(350401,Rem) ->
	#mon{id = 350401,name = "转职检察官",boss = 6,color = 1,icon = 10030005,weapon_id = 202002,lv = 520,att = 2083333,hp_lim = 105000000,hit = 37500,dodge = 25000,ten = 20000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360001,Rem) ->
	#mon{id = 360001,name = "次元检察官",boss = 6,color = 1,icon = 10010003,weapon_id = 202002,lv = 100,att = 767,hp_lim = 23263,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360301,Rem) ->
	#mon{id = 360301,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 100,att = 767,hp_lim = 23263,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360601,Rem) ->
	#mon{id = 360601,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 115,att = 10833,hp_lim = 546000,hit = 195,dodge = 130,ten = 104,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360901,Rem) ->
	#mon{id = 360901,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 160,att = 50000,hp_lim = 2520000,hit = 900,dodge = 600,ten = 480,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(400099,Rem) ->
	#mon{id = 400099,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 40,att = 822,hp_lim = 44404,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400111,Rem) ->
	#mon{id = 400111,name = "独眼卫士",type = 1,color = 1,auto = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 50,att = 956,hp_lim = 51657,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400201,Rem) ->
	#mon{id = 400201,name = "雷电地鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 60,att = 1058,hp_lim = 57143,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400399,Rem) ->
	#mon{id = 400399,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 70,att = 1112,hp_lim = 60091,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400411,Rem) ->
	#mon{id = 400411,name = "独眼卫士",type = 1,color = 1,auto = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 80,att = 1170,hp_lim = 63189,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400501,Rem) ->
	#mon{id = 400501,name = "雷电地鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 90,att = 1433,hp_lim = 77406,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400699,Rem) ->
	#mon{id = 400699,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 100,att = 2747,hp_lim = 148339,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500005,Rem) ->
	#mon{id = 500005,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 68,att = 170,hp_lim = 11529,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500011,Rem) ->
	#mon{id = 500011,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 101,att = 861,hp_lim = 58333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500017,Rem) ->
	#mon{id = 500017,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 109,att = 1446,hp_lim = 98000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500023,Rem) ->
	#mon{id = 500023,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 121,att = 2480,hp_lim = 168000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500029,Rem) ->
	#mon{id = 500029,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 133,att = 4133,hp_lim = 280000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500035,Rem) ->
	#mon{id = 500035,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 145,att = 6200,hp_lim = 420000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500041,Rem) ->
	#mon{id = 500041,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 157,att = 8025,hp_lim = 543666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500047,Rem) ->
	#mon{id = 500047,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 169,att = 10040,hp_lim = 680166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500053,Rem) ->
	#mon{id = 500053,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 181,att = 12124,hp_lim = 821333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500059,Rem) ->
	#mon{id = 500059,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 193,att = 14053,hp_lim = 952000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500065,Rem) ->
	#mon{id = 500065,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 205,att = 16120,hp_lim = 1092000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500071,Rem) ->
	#mon{id = 500071,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 211,att = 17928,hp_lim = 1214500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500077,Rem) ->
	#mon{id = 500077,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 217,att = 19736,hp_lim = 1337000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500083,Rem) ->
	#mon{id = 500083,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 223,att = 21545,hp_lim = 1459500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500089,Rem) ->
	#mon{id = 500089,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 229,att = 23370,hp_lim = 1583166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500095,Rem) ->
	#mon{id = 500095,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 235,att = 25488,hp_lim = 1726666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500101,Rem) ->
	#mon{id = 500101,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 241,att = 27366,hp_lim = 1853833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500107,Rem) ->
	#mon{id = 500107,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 246,att = 29260,hp_lim = 1982166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500113,Rem) ->
	#mon{id = 500113,name = "蓝衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 251,att = 31172,hp_lim = 2111666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500119,Rem) ->
	#mon{id = 500119,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 256,att = 33101,hp_lim = 2242333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500125,Rem) ->
	#mon{id = 500125,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 260,att = 35340,hp_lim = 2394000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500131,Rem) ->
	#mon{id = 500131,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 265,att = 37337,hp_lim = 2529333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500137,Rem) ->
	#mon{id = 500137,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 270,att = 39352,hp_lim = 2665833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500143,Rem) ->
	#mon{id = 500143,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 275,att = 41385,hp_lim = 2803500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500149,Rem) ->
	#mon{id = 500149,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 280,att = 43451,hp_lim = 2943500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500155,Rem) ->
	#mon{id = 500155,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 284,att = 45828,hp_lim = 3104500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500161,Rem) ->
	#mon{id = 500161,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 289,att = 47946,hp_lim = 3248000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500167,Rem) ->
	#mon{id = 500167,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 294,att = 50065,hp_lim = 3391500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500173,Rem) ->
	#mon{id = 500173,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 299,att = 52235,hp_lim = 3538500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500179,Rem) ->
	#mon{id = 500179,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 304,att = 54422,hp_lim = 3686666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500185,Rem) ->
	#mon{id = 500185,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 308,att = 56953,hp_lim = 3858166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500191,Rem) ->
	#mon{id = 500191,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 313,att = 59192,hp_lim = 4009833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500197,Rem) ->
	#mon{id = 500197,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 318,att = 61448,hp_lim = 4162666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500203,Rem) ->
	#mon{id = 500203,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 323,att = 63739,hp_lim = 4317833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500209,Rem) ->
	#mon{id = 500209,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 328,att = 66064,hp_lim = 4475333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500215,Rem) ->
	#mon{id = 500215,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 332,att = 68751,hp_lim = 4657333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500221,Rem) ->
	#mon{id = 500221,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 337,att = 71127,hp_lim = 4818333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500227,Rem) ->
	#mon{id = 500227,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 342,att = 73521,hp_lim = 4980500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500233,Rem) ->
	#mon{id = 500233,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 347,att = 75967,hp_lim = 5146166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500239,Rem) ->
	#mon{id = 500239,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 352,att = 78412,hp_lim = 5311833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500245,Rem) ->
	#mon{id = 500245,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 356,att = 81254,hp_lim = 5504333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500251,Rem) ->
	#mon{id = 500251,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 361,att = 83786,hp_lim = 5675833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500257,Rem) ->
	#mon{id = 500257,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 366,att = 86335,hp_lim = 5848500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500263,Rem) ->
	#mon{id = 500263,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 371,att = 88918,hp_lim = 6023500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500269,Rem) ->
	#mon{id = 500269,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 376,att = 91536,hp_lim = 6200833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500275,Rem) ->
	#mon{id = 500275,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 380,att = 94532,hp_lim = 6403833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500281,Rem) ->
	#mon{id = 500281,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 385,att = 97236,hp_lim = 6587000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500287,Rem) ->
	#mon{id = 500287,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 390,att = 99940,hp_lim = 6770166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500293,Rem) ->
	#mon{id = 500293,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 395,att = 102678,hp_lim = 6955666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500299,Rem) ->
	#mon{id = 500299,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 400,att = 123535,hp_lim = 8368500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510001,Rem) ->
	#mon{id = 510001,name = "迷失小丑",boss = 6,type = 1,color = 1,auto = 1,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 68,att = 623,hp_lim = 57750,hit = 16,dodge = 11,ten = 8,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510007,Rem) ->
	#mon{id = 510007,name = "病毒异形",boss = 6,type = 1,color = 1,auto = 1,icon = 100400031,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 145,att = 20400,hp_lim = 3780000,hit = 540,dodge = 360,ten = 288,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510013,Rem) ->
	#mon{id = 510013,name = "病毒暴君",boss = 6,type = 1,color = 1,auto = 1,icon = 100400011,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 205,att = 53040,hp_lim = 9828000,hit = 1404,dodge = 936,ten = 748,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510019,Rem) ->
	#mon{id = 510019,name = "执行者铁角",boss = 6,type = 1,color = 1,auto = 1,icon = 100400022,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 235,att = 83866,hp_lim = 15540000,hit = 2220,dodge = 1480,ten = 1184,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510025,Rem) ->
	#mon{id = 510025,name = "三头吼兽",boss = 6,type = 1,color = 1,auto = 1,icon = 100300011,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 260,att = 116280,hp_lim = 21546000,hit = 3078,dodge = 2052,ten = 1641,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510031,Rem) ->
	#mon{id = 510031,name = "能源守卫",boss = 6,type = 1,color = 1,auto = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 284,att = 150790,hp_lim = 27940500,hit = 3991,dodge = 2661,ten = 2128,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510037,Rem) ->
	#mon{id = 510037,name = "灵魂收割者",boss = 6,type = 1,color = 1,auto = 1,icon = 100100031,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 308,att = 187396,hp_lim = 34723500,hit = 4960,dodge = 3307,ten = 2645,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510043,Rem) ->
	#mon{id = 510043,name = "武装女神",boss = 6,type = 1,color = 1,auto = 1,icon = 100200041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 332,att = 226213,hp_lim = 41916000,hit = 5988,dodge = 3992,ten = 3193,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510049,Rem) ->
	#mon{id = 510049,name = "海神祭祀",boss = 6,type = 1,color = 1,auto = 1,icon = 100100102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 356,att = 267353,hp_lim = 49539000,hit = 7077,dodge = 4718,ten = 3774,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510055,Rem) ->
	#mon{id = 510055,name = "铁甲战姬",boss = 6,type = 1,color = 1,auto = 1,icon = 100100052,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 380,att = 311043,hp_lim = 57634500,hit = 8233,dodge = 5489,ten = 4391,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(651001,Rem) ->
	#mon{id = 651001,name = "第五使徒",boss = 5,type = 1,color = 1,module = 406,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 144487,hp_lim = 4000000000,striking_distance = 200,tracing_distance = 1000,warning_range = 1000,hate_range = 1000,skill = [{1110000001,1}],att_time = 2000,is_hide_hp = 1,rem_flag = Rem};
get(651103,Rem) ->
	#mon{id = 651103,name = "社团晚间召唤坐标1",type = 1,color = 1,icon = 202036,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 100,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,del_hp_each_time = [0.02,0.02],rem_flag = Rem};
get(653101,Rem) ->
	#mon{id = 653101,name = "攻击宝箱",kind = 1,color = 1,icon = 10010198,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(1001005,Rem) ->
	#mon{id = 1001005,name = "海族战士",type = 1,color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 1811,hp_lim = 118906,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001011,Rem) ->
	#mon{id = 1001011,name = "改造水母",type = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 323,hp_lim = 21233,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001017,Rem) ->
	#mon{id = 1001017,name = "机械狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 1941,hp_lim = 127400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001023,Rem) ->
	#mon{id = 1001023,name = "机器枪手",type = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 5176,hp_lim = 339733,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1200103,Rem) ->
	#mon{id = 1200103,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 106,att = 2080,hp_lim = 102119,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200109,Rem) ->
	#mon{id = 1200109,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 118,att = 4427,hp_lim = 217350,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200115,Rem) ->
	#mon{id = 1200115,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 145,att = 14305,hp_lim = 748440,hit = 495,dodge = 330,ten = 264,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200205,Rem) ->
	#mon{id = 1200205,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 130,att = 9537,hp_lim = 498960,hit = 270,dodge = 180,ten = 144,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200211,Rem) ->
	#mon{id = 1200211,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 160,att = 13552,hp_lim = 665280,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200217,Rem) ->
	#mon{id = 1200217,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 190,att = 33379,hp_lim = 8731800,hit = 945,dodge = 630,ten = 504,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200301,Rem) ->
	#mon{id = 1200301,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 146,att = 7623,hp_lim = 374220,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200307,Rem) ->
	#mon{id = 1200307,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 170,att = 12936,hp_lim = 635040,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200313,Rem) ->
	#mon{id = 1200313,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 200,att = 20020,hp_lim = 982800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200403,Rem) ->
	#mon{id = 1200403,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 180,att = 16170,hp_lim = 793800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200409,Rem) ->
	#mon{id = 1200409,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 210,att = 23870,hp_lim = 1171800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200415,Rem) ->
	#mon{id = 1200415,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 240,att = 70251,hp_lim = 3675452,hit = 2083,dodge = 1389,ten = 1111,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200505,Rem) ->
	#mon{id = 1200505,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 215,att = 44795,hp_lim = 2343600,hit = 1395,dodge = 930,ten = 744,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200511,Rem) ->
	#mon{id = 1200511,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 245,att = 39738,hp_lim = 1950783,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200517,Rem) ->
	#mon{id = 1200517,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 275,att = 115272,hp_lim = 30154206,hit = 3589,dodge = 2393,ten = 1914,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200601,Rem) ->
	#mon{id = 1200601,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 226,att = 31647,hp_lim = 1553580,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200607,Rem) ->
	#mon{id = 1200607,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 250,att = 43905,hp_lim = 2155363,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200613,Rem) ->
	#mon{id = 1200613,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 280,att = 61425,hp_lim = 3015420,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200703,Rem) ->
	#mon{id = 1200703,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 250,att = 43905,hp_lim = 2155363,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200709,Rem) ->
	#mon{id = 1200709,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 280,att = 61425,hp_lim = 3015420,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200715,Rem) ->
	#mon{id = 1200715,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 310,att = 160206,hp_lim = 8381714,hit = 4989,dodge = 3326,ten = 2660,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200805,Rem) ->
	#mon{id = 1200805,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 280,att = 115272,hp_lim = 6030841,hit = 3589,dodge = 2393,ten = 1914,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200811,Rem) ->
	#mon{id = 1200811,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 310,att = 85369,hp_lim = 4190857,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200817,Rem) ->
	#mon{id = 1200817,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 340,att = 220342,hp_lim = 57639670,hit = 6861,dodge = 4574,ten = 3659,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200901,Rem) ->
	#mon{id = 1200901,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 286,att = 66026,hp_lim = 3241290,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200907,Rem) ->
	#mon{id = 1200907,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 310,att = 85369,hp_lim = 4190857,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200913,Rem) ->
	#mon{id = 1200913,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 340,att = 117414,hp_lim = 5763967,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201003,Rem) ->
	#mon{id = 1201003,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 310,att = 85369,hp_lim = 4190857,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201009,Rem) ->
	#mon{id = 1201009,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 340,att = 117414,hp_lim = 5763967,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201015,Rem) ->
	#mon{id = 1201015,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 370,att = 275875,hp_lim = 14433355,hit = 8591,dodge = 5727,ten = 4582,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201105,Rem) ->
	#mon{id = 1201105,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 340,att = 220342,hp_lim = 11527934,hit = 6861,dodge = 4574,ten = 3659,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201111,Rem) ->
	#mon{id = 1201111,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 370,att = 147006,hp_lim = 7216677,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201117,Rem) ->
	#mon{id = 1201117,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 400,att = 348278,hp_lim = 91106769,hit = 10846,dodge = 7230,ten = 5784,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201201,Rem) ->
	#mon{id = 1201201,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 346,att = 123134,hp_lim = 6044807,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201207,Rem) ->
	#mon{id = 1201207,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 370,att = 147006,hp_lim = 7216677,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201213,Rem) ->
	#mon{id = 1201213,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 400,att = 185587,hp_lim = 9110676,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201303,Rem) ->
	#mon{id = 1201303,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 370,att = 147006,hp_lim = 7216677,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201309,Rem) ->
	#mon{id = 1201309,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 400,att = 185587,hp_lim = 9110676,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201315,Rem) ->
	#mon{id = 1201315,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 430,att = 441342,hp_lim = 23090298,hit = 13744,dodge = 9162,ten = 7330,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201405,Rem) ->
	#mon{id = 1201405,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 400,att = 348278,hp_lim = 18221353,hit = 10846,dodge = 7230,ten = 5784,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201411,Rem) ->
	#mon{id = 1201411,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 430,att = 235178,hp_lim = 11545149,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201417,Rem) ->
	#mon{id = 1201417,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 460,att = 528762,hp_lim = 138319952,hit = 16466,dodge = 10977,ten = 8782,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201501,Rem) ->
	#mon{id = 1201501,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 406,att = 192359,hp_lim = 9443120,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201507,Rem) ->
	#mon{id = 1201507,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 430,att = 235178,hp_lim = 11545149,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201513,Rem) ->
	#mon{id = 1201513,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 460,att = 281762,hp_lim = 13831995,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201603,Rem) ->
	#mon{id = 1201603,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 430,att = 235178,hp_lim = 11545149,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201609,Rem) ->
	#mon{id = 1201609,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 460,att = 281762,hp_lim = 13831995,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201615,Rem) ->
	#mon{id = 1201615,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 490,att = 637836,hp_lim = 33370527,hit = 19863,dodge = 13242,ten = 10593,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201705,Rem) ->
	#mon{id = 1201705,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 460,att = 528762,hp_lim = 27663990,hit = 16466,dodge = 10977,ten = 8782,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201711,Rem) ->
	#mon{id = 1201711,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 490,att = 339885,hp_lim = 16685263,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201717,Rem) ->
	#mon{id = 1201717,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 520,att = 825351,hp_lim = 215905132,hit = 25702,dodge = 17135,ten = 13708,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201801,Rem) ->
	#mon{id = 1201801,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 466,att = 289820,hp_lim = 14227538,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201807,Rem) ->
	#mon{id = 1201807,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 490,att = 339885,hp_lim = 16685263,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201813,Rem) ->
	#mon{id = 1201813,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 520,att = 439806,hp_lim = 21590513,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201903,Rem) ->
	#mon{id = 1201903,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 490,att = 339885,hp_lim = 16685263,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201909,Rem) ->
	#mon{id = 1201909,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 520,att = 439806,hp_lim = 21590513,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201915,Rem) ->
	#mon{id = 1201915,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 550,att = 1137488,hp_lim = 59511526,hit = 35423,dodge = 23615,ten = 18892,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202005,Rem) ->
	#mon{id = 1202005,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 520,att = 825351,hp_lim = 43181026,hit = 25702,dodge = 17135,ten = 13708,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202011,Rem) ->
	#mon{id = 1202011,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 550,att = 606135,hp_lim = 29755763,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202017,Rem) ->
	#mon{id = 1202017,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 580,att = 1534847,hp_lim = 401503246,hit = 47798,dodge = 31865,ten = 25492,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202101,Rem) ->
	#mon{id = 1202101,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 526,att = 469010,hp_lim = 23024151,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202107,Rem) ->
	#mon{id = 1202107,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 550,att = 606135,hp_lim = 29755763,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202113,Rem) ->
	#mon{id = 1202113,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 580,att = 817876,hp_lim = 40150324,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202203,Rem) ->
	#mon{id = 1202203,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 550,att = 606135,hp_lim = 29755763,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202209,Rem) ->
	#mon{id = 1202209,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 580,att = 817876,hp_lim = 40150324,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202215,Rem) ->
	#mon{id = 1202215,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 610,att = 2065702,hp_lim = 108074100,hit = 64329,dodge = 42886,ten = 34309,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202305,Rem) ->
	#mon{id = 1202305,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 580,att = 1534847,hp_lim = 80300649,hit = 47798,dodge = 31865,ten = 25492,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202311,Rem) ->
	#mon{id = 1202311,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 610,att = 1100754,hp_lim = 54037050,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202317,Rem) ->
	#mon{id = 1202317,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 640,att = 2835766,hp_lim = 741812916,hit = 88311,dodge = 58874,ten = 47099,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202401,Rem) ->
	#mon{id = 1202401,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 586,att = 867937,hp_lim = 42607846,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202407,Rem) ->
	#mon{id = 1202407,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 610,att = 1100754,hp_lim = 54037050,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202413,Rem) ->
	#mon{id = 1202413,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 640,att = 1511100,hp_lim = 74181291,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(2001103,Rem) ->
	#mon{id = 2001103,name = "战争女神",boss = 6,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 85,att = 1031,hp_lim = 25480,hit = 27,dodge = 18,ten = 14,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2002201,Rem) ->
	#mon{id = 2002201,name = "合成丧尸",type = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 105,att = 1253,hp_lim = 33973,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2003101,Rem) ->
	#mon{id = 2003101,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 1567,hp_lim = 42466,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2003203,Rem) ->
	#mon{id = 2003203,name = "能源守卫",boss = 6,type = 1,color = 1,icon = 100100021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 9282,hp_lim = 229320,hit = 245,dodge = 163,ten = 131,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2004103,Rem) ->
	#mon{id = 2004103,name = "深海祭祀",boss = 6,type = 1,color = 1,icon = 10010010,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 10313,hp_lim = 254800,hit = 273,dodge = 182,ten = 145,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2005201,Rem) ->
	#mon{id = 2005201,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 125,att = 5955,hp_lim = 161373,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2006101,Rem) ->
	#mon{id = 2006101,name = "叛乱矿工",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 5955,hp_lim = 161373,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2006203,Rem) ->
	#mon{id = 2006203,name = "静谧三角",boss = 6,type = 1,color = 1,icon = 100400021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 145,att = 20626,hp_lim = 509600,hit = 546,dodge = 364,ten = 291,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2007103,Rem) ->
	#mon{id = 2007103,name = "战争女神",boss = 6,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 165,att = 21658,hp_lim = 535080,hit = 573,dodge = 382,ten = 305,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2008201,Rem) ->
	#mon{id = 2008201,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 165,att = 8619,hp_lim = 233566,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2009101,Rem) ->
	#mon{id = 2009101,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 175,att = 7836,hp_lim = 212333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2009203,Rem) ->
	#mon{id = 2009203,name = "兵武女刺",boss = 6,type = 1,color = 1,icon = 100100071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 28361,hp_lim = 700700,hit = 750,dodge = 500,ten = 400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2010103,Rem) ->
	#mon{id = 2010103,name = "改造暴猿",boss = 6,type = 1,color = 1,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 190,att = 29908,hp_lim = 738920,hit = 791,dodge = 527,ten = 422,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2011201,Rem) ->
	#mon{id = 2011201,name = "海族战士",type = 1,color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 195,att = 10186,hp_lim = 276033,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2012101,Rem) ->
	#mon{id = 2012101,name = "叛乱矿工",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 12537,hp_lim = 339733,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2012203,Rem) ->
	#mon{id = 2012203,name = "静谧三角",boss = 6,type = 1,color = 1,icon = 100400021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 225,att = 45378,hp_lim = 1121120,hit = 1201,dodge = 800,ten = 640,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2013103,Rem) ->
	#mon{id = 2013103,name = "战争女神",boss = 6,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 225,att = 41253,hp_lim = 1019200,hit = 1092,dodge = 728,ten = 582,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2014201,Rem) ->
	#mon{id = 2014201,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 260,att = 23508,hp_lim = 637000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2015101,Rem) ->
	#mon{id = 2015101,name = "叛乱矿工",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 380,att = 47016,hp_lim = 1274000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2015203,Rem) ->
	#mon{id = 2015203,name = "静谧三角",boss = 6,type = 1,color = 1,icon = 100400021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 385,att = 180483,hp_lim = 4459000,hit = 4777,dodge = 3185,ten = 2548,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2100103,Rem) ->
	#mon{id = 2100103,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 1504,hp_lim = 1008000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 778,is_hit_ac = 1,rem_flag = Rem};
get(2100109,Rem) ->
	#mon{id = 2100109,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 160,att = 3342,hp_lim = 2240000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 807,is_hit_ac = 1,rem_flag = Rem};
get(2100205,Rem) ->
	#mon{id = 2100205,name = "兽血改造者",color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 190,att = 5264,hp_lim = 3528000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 837,is_hit_ac = 1,rem_flag = Rem};
get(2100301,Rem) ->
	#mon{id = 2100301,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 220,att = 7896,hp_lim = 5292000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 869,is_hit_ac = 1,rem_flag = Rem};
get(2100307,Rem) ->
	#mon{id = 2100307,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 250,att = 11910,hp_lim = 7982828,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 934,is_hit_ac = 1,rem_flag = Rem};
get(2100403,Rem) ->
	#mon{id = 2100403,name = "感染护士",color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 280,att = 16663,hp_lim = 11168227,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1016,is_hit_ac = 1,rem_flag = Rem};
get(2100409,Rem) ->
	#mon{id = 2100409,name = "武装暴民",color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 310,att = 23159,hp_lim = 15521695,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1117,is_hit_ac = 1,rem_flag = Rem};
get(2100505,Rem) ->
	#mon{id = 2100505,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 340,att = 31852,hp_lim = 21348026,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1240,is_hit_ac = 1,rem_flag = Rem};
get(2100601,Rem) ->
	#mon{id = 2100601,name = "变异柴犬",color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 370,att = 39880,hp_lim = 26728436,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1345,is_hit_ac = 1,rem_flag = Rem};
get(2100607,Rem) ->
	#mon{id = 2100607,name = "武装暴民",color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 400,att = 50347,hp_lim = 33743248,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1487,is_hit_ac = 1,rem_flag = Rem};
get(2100703,Rem) ->
	#mon{id = 2100703,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 63800,hp_lim = 42759815,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1638,is_hit_ac = 1,rem_flag = Rem};
get(2100709,Rem) ->
	#mon{id = 2100709,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 460,att = 76437,hp_lim = 51229612,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1800,is_hit_ac = 1,rem_flag = Rem};
get(2100805,Rem) ->
	#mon{id = 2100805,name = "兽血改造者",color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 490,att = 92205,hp_lim = 61797274,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100901,Rem) ->
	#mon{id = 2100901,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 520,att = 119312,hp_lim = 79964864,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100907,Rem) ->
	#mon{id = 2100907,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 550,att = 164435,hp_lim = 110206530,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101003,Rem) ->
	#mon{id = 2101003,name = "感染护士",color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 580,att = 221877,hp_lim = 148704906,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101009,Rem) ->
	#mon{id = 2101009,name = "武装暴民",color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 610,att = 298617,hp_lim = 200137224,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101105,Rem) ->
	#mon{id = 2101105,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 640,att = 409937,hp_lim = 274745520,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101201,Rem) ->
	#mon{id = 2101201,name = "变异柴犬",color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 670,att = 551722,hp_lim = 369771304,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101207,Rem) ->
	#mon{id = 2101207,name = "武装暴民",color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 700,att = 742545,hp_lim = 497663488,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101303,Rem) ->
	#mon{id = 2101303,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 730,att = 999368,hp_lim = 669789533,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101309,Rem) ->
	#mon{id = 2101309,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 760,att = 1371918,hp_lim = 919477496,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101405,Rem) ->
	#mon{id = 2101405,name = "兽血改造者",color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 790,att = 1883350,hp_lim = 1262245565,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101501,Rem) ->
	#mon{id = 2101501,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 820,att = 2798559,hp_lim = 1875630512,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101507,Rem) ->
	#mon{id = 2101507,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 850,att = 6179331,hp_lim = 4141466574,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2300005,Rem) ->
	#mon{id = 2300005,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 140,att = 18796,hp_lim = 425250,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300011,Rem) ->
	#mon{id = 2300011,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 180,att = 28080,hp_lim = 972405,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300017,Rem) ->
	#mon{id = 2300017,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 240,att = 67071,hp_lim = 2231524,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300023,Rem) ->
	#mon{id = 2300023,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 300,att = 151231,hp_lim = 5031619,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300029,Rem) ->
	#mon{id = 2300029,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 360,att = 243912,hp_lim = 8277524,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300035,Rem) ->
	#mon{id = 2300035,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 420,att = 425203,hp_lim = 13742750,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300041,Rem) ->
	#mon{id = 2300041,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 480,att = 643638,hp_lim = 20802683,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300047,Rem) ->
	#mon{id = 2300047,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 540,att = 1781641,hp_lim = 44787129,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(3000001,Rem) ->
	#mon{id = 3000001,name = "虚空兵长",boss = 6,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10000021,Rem) ->
	#mon{id = 10000021,name = "弃用待查",kind = 2,color = 1,icon = 2040012,icon_effect = <<"0"/utf8>>,weapon_id = 2040012,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10010101,Rem) ->
	#mon{id = 10010101,name = "辐射异形",boss = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 5,att = 15,hp_lim = 1176,striking_distance = 110,tracing_distance = 80,hate_range = 80,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 2,del_hp_each_time = [700,1100],is_hit_ac = 1,rem_flag = Rem};
get(10010203,Rem) ->
	#mon{id = 10010203,name = "幻光激活",kind = 2,color = 1,icon = 10010203,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 3,att = 13,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10020001,Rem) ->
	#mon{id = 10020001,name = "湾区守卫",boss = 7,color = 3,icon = 20010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 30,att = 500,hp_lim = 9810,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 1,is_hit_ac = 1,rem_flag = Rem};
get(10020103,Rem) ->
	#mon{id = 10020103,name = "侦查刺蜂",boss = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202038,lv = 30,att = 40,hp_lim = 3270,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 7,is_hit_ac = 1,rem_flag = Rem};
get(10020205,Rem) ->
	#mon{id = 10020205,name = "考核装备",kind = 2,color = 1,icon = 10010202,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10030201,Rem) ->
	#mon{id = 10030201,name = "黑晶碎片",kind = 2,color = 1,icon = 10020202,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10040101,Rem) ->
	#mon{id = 10040101,name = "绞杀兵器",boss = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 52,att = 62,hp_lim = 3501,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 9,is_patrol = 1,is_hit_ac = 1,rem_flag = Rem};
get(10040203,Rem) ->
	#mon{id = 10040203,name = "秘密组件",kind = 2,color = 1,icon = 10040202,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10050001,Rem) ->
	#mon{id = 10050001,name = "海底怒鲨",boss = 7,color = 3,icon = 10010010,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 90,att = 1100,hp_lim = 65250,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 12,is_hit_ac = 1,rem_flag = Rem};
get(10050103,Rem) ->
	#mon{id = 10050103,name = "机械章鱼",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 90,att = 100,hp_lim = 27840,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10060201,Rem) ->
	#mon{id = 10060201,name = "中途补给站",kind = 2,color = 1,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 9700,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10070101,Rem) ->
	#mon{id = 10070101,name = "迷幻章鱼",boss = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 110,att = 100,hp_lim = 135025,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 17,is_hit_ac = 1,rem_flag = Rem};
get(10070107,Rem) ->
	#mon{id = 10070107,name = "巡逻警卫",boss = 1,type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 138,att = 100,hp_lim = 192000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 20,is_hit_ac = 1,rem_flag = Rem};
get(10080001,Rem) ->
	#mon{id = 10080001,name = "傀儡长枪",boss = 6,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 200,att = 100,hp_lim = 1664000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 22,is_hit_ac = 1,rem_flag = Rem};
get(10080103,Rem) ->
	#mon{id = 10080103,name = "逃窜疑犯",boss = 1,type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 160,att = 100,hp_lim = 512000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 23,is_hit_ac = 1,rem_flag = Rem};
get(10090105,Rem) ->
	#mon{id = 10090105,name = "瞭望台守卫",boss = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 270,att = 100,hp_lim = 2365250,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 33,is_hit_ac = 1,rem_flag = Rem};
get(10090201,Rem) ->
	#mon{id = 10090201,name = "捆绑锁链",kind = 2,color = 1,icon = 41000202,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10100101,Rem) ->
	#mon{id = 10100101,name = "沙暴蜥",boss = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 295,att = 100,hp_lim = 3137900,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 36,is_hit_ac = 1,rem_flag = Rem};
get(10100107,Rem) ->
	#mon{id = 10100107,name = "砂砾研究员",boss = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 370,att = 100,hp_lim = 6109350,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 65,is_hit_ac = 1,rem_flag = Rem};
get(10110103,Rem) ->
	#mon{id = 10110103,name = "书馆老鼠",boss = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 395,att = 100,hp_lim = 7435450,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 72,is_hit_ac = 1,rem_flag = Rem};
get(10120105,Rem) ->
	#mon{id = 10120105,name = "变异矿工",boss = 1,color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 450,att = 100,hp_lim = 11049825,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 109,is_hit_ac = 1,rem_flag = Rem};
get(10120201,Rem) ->
	#mon{id = 10120201,name = "仓库钥匙",kind = 2,color = 1,icon = 10040201,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10130101,Rem) ->
	#mon{id = 10130101,name = "基地护卫犬",boss = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 465,att = 100,hp_lim = 12044475,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 122,is_hit_ac = 1,rem_flag = Rem};
get(10140001,Rem) ->
	#mon{id = 10140001,name = "黑市会长",boss = 6,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 530,att = 100,hp_lim = 40641600,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 187,is_hit_ac = 1,rem_flag = Rem};
get(10140103,Rem) ->
	#mon{id = 10140103,name = "阴暗触手",boss = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 5010084,lv = 510,att = 100,hp_lim = 16333700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 167,rem_flag = Rem};
get(10150105,Rem) ->
	#mon{id = 10150105,name = "蜕化龙蜥",boss = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 1007006,lv = 600,att = 100,hp_lim = 41433225,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 257,rem_flag = Rem};
get(10150201,Rem) ->
	#mon{id = 10150201,name = "深渊之灵",kind = 2,color = 1,icon = 10010203,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(11001001,Rem) ->
	#mon{id = 11001001,name = "音波蜘蛛",type = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 2031,hp_lim = 181125,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001007,Rem) ->
	#mon{id = 11001007,name = "舞动柴犬",type = 1,color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 132,att = 3533,hp_lim = 315000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001013,Rem) ->
	#mon{id = 11001013,name = "影袭蜜蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 144,att = 4923,hp_lim = 438900,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001019,Rem) ->
	#mon{id = 11001019,name = "音乐护士",type = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 156,att = 7043,hp_lim = 627900,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001025,Rem) ->
	#mon{id = 11001025,name = "改造械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 168,att = 10176,hp_lim = 907200,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002003,Rem) ->
	#mon{id = 11002003,name = "深渊女王",boss = 6,type = 1,color = 1,icon = 10040004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 184,att = 23800,hp_lim = 4410000,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002009,Rem) ->
	#mon{id = 11002009,name = "地底魔蝎",boss = 6,type = 1,color = 1,icon = 10030006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 196,att = 32413,hp_lim = 6006000,hit = 858,dodge = 572,ten = 457,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002015,Rem) ->
	#mon{id = 11002015,name = "深渊女王",boss = 6,type = 1,color = 1,icon = 10040004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 208,att = 42160,hp_lim = 7812000,hit = 1116,dodge = 744,ten = 595,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002021,Rem) ->
	#mon{id = 11002021,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 100300082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 48960,hp_lim = 9072000,hit = 1296,dodge = 864,ten = 691,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002027,Rem) ->
	#mon{id = 11002027,name = "改造男孩",boss = 6,type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 232,att = 34852,hp_lim = 3107160,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003005,Rem) ->
	#mon{id = 11003005,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 248,att = 40970,hp_lim = 3652548,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003011,Rem) ->
	#mon{id = 11003011,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 48453,hp_lim = 4319711,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003017,Rem) ->
	#mon{id = 11003017,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 272,att = 52233,hp_lim = 4656632,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003023,Rem) ->
	#mon{id = 11003023,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 284,att = 59188,hp_lim = 5276668,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003029,Rem) ->
	#mon{id = 11003029,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 296,att = 67831,hp_lim = 6047236,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004001,Rem) ->
	#mon{id = 11004001,name = "音波蜘蛛",type = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 300,att = 72019,hp_lim = 6420574,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004007,Rem) ->
	#mon{id = 11004007,name = "舞动柴犬",type = 1,color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 312,att = 83896,hp_lim = 7479471,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004013,Rem) ->
	#mon{id = 11004013,name = "影袭蜜蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 324,att = 93850,hp_lim = 8366900,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004019,Rem) ->
	#mon{id = 11004019,name = "音乐护士",type = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 336,att = 100904,hp_lim = 8995761,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004025,Rem) ->
	#mon{id = 11004025,name = "改造械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 348,att = 114792,hp_lim = 10233822,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005003,Rem) ->
	#mon{id = 11005003,name = "深渊女王",boss = 6,type = 1,color = 1,icon = 10040004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 364,att = 215687,hp_lim = 39965671,hit = 5709,dodge = 3806,ten = 3045,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005009,Rem) ->
	#mon{id = 11005009,name = "地底魔蝎",boss = 6,type = 1,color = 1,icon = 10030006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 376,att = 261566,hp_lim = 48466814,hit = 6923,dodge = 4615,ten = 3692,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005015,Rem) ->
	#mon{id = 11005015,name = "深渊女王",boss = 6,type = 1,color = 1,icon = 10040004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 388,att = 324690,hp_lim = 60163232,hit = 8594,dodge = 5729,ten = 4583,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005021,Rem) ->
	#mon{id = 11005021,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 100300082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 400,att = 382423,hp_lim = 70860820,hit = 10122,dodge = 6748,ten = 5398,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005027,Rem) ->
	#mon{id = 11005027,name = "改造男孩",boss = 6,type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 424,att = 307563,hp_lim = 27419559,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006005,Rem) ->
	#mon{id = 11006005,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 456,att = 426461,hp_lim = 38019488,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006011,Rem) ->
	#mon{id = 11006011,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 480,att = 524369,hp_lim = 46748063,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006017,Rem) ->
	#mon{id = 11006017,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 504,att = 656176,hp_lim = 58498724,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006023,Rem) ->
	#mon{id = 11006023,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 528,att = 898140,hp_lim = 80070053,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006029,Rem) ->
	#mon{id = 11006029,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 552,att = 1218641,hp_lim = 108643035,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007001,Rem) ->
	#mon{id = 11007001,name = "音波蜘蛛",type = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 560,att = 1351800,hp_lim = 120514308,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007007,Rem) ->
	#mon{id = 11007007,name = "舞动柴犬",type = 1,color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 584,att = 1815901,hp_lim = 161889306,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007013,Rem) ->
	#mon{id = 11007013,name = "影袭蜜蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 608,att = 2422039,hp_lim = 215927128,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007019,Rem) ->
	#mon{id = 11007019,name = "音乐护士",type = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 632,att = 3246267,hp_lim = 289407825,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007025,Rem) ->
	#mon{id = 11007025,name = "改造械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 656,att = 4364201,hp_lim = 389072703,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008003,Rem) ->
	#mon{id = 11008003,name = "深渊女王",boss = 6,type = 1,color = 1,icon = 10040004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 688,att = 10159742,hp_lim = 1882540595,hit = 268934,dodge = 179289,ten = 143431,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008009,Rem) ->
	#mon{id = 11008009,name = "地底魔蝎",boss = 6,type = 1,color = 1,icon = 10030006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 712,att = 13429447,hp_lim = 2488397635,hit = 355485,dodge = 236990,ten = 189592,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008015,Rem) ->
	#mon{id = 11008015,name = "深渊女王",boss = 6,type = 1,color = 1,icon = 10040004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 736,att = 18076709,hp_lim = 3349508001,hit = 478501,dodge = 319000,ten = 255200,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008021,Rem) ->
	#mon{id = 11008021,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 100300082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 760,att = 23818845,hp_lim = 4413491980,hit = 630498,dodge = 420332,ten = 336266,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008027,Rem) ->
	#mon{id = 11008027,name = "改造男孩",boss = 6,type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 784,att = 19541946,hp_lim = 1742182972,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12010015,Rem) ->
	#mon{id = 12010015,name = "爆裂机甲",boss = 6,color = 1,module = 610,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 8671,hp_lim = 1512756,hit = 300,dodge = 200,ten = 160,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12020011,Rem) ->
	#mon{id = 12020011,name = "变异利爪",boss = 6,color = 1,module = 610,icon = 100100041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 5200,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12030013,Rem) ->
	#mon{id = 12030013,name = "末世环刃",boss = 6,color = 1,module = 610,icon = 100100072,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 64205,hp_lim = 11201379,hit = 2222,dodge = 1481,ten = 1185,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12040015,Rem) ->
	#mon{id = 12040015,name = "寄生触手",boss = 6,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 350,att = 277186,hp_lim = 48358462,hit = 9594,dodge = 6396,ten = 5117,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12050011,Rem) ->
	#mon{id = 12050011,name = "变异博士",boss = 6,color = 1,module = 610,icon = 100200061,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 240068,hp_lim = 41882672,hit = 8310,dodge = 5540,ten = 4432,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12060013,Rem) ->
	#mon{id = 12060013,name = "末世三角",boss = 6,color = 1,module = 610,icon = 100400022,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 530,att = 880568,hp_lim = 153625368,hit = 30481,dodge = 20320,ten = 16256,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13020001,Rem) ->
	#mon{id = 13020001,name = "异形长枪",boss = 3,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 3336,hp_lim = 3628800,hit = 180,dodge = 120,ten = 96,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13030003,Rem) ->
	#mon{id = 13030003,name = "爆裂机甲",boss = 3,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 92464,hp_lim = 100580568,hit = 4989,dodge = 3326,ten = 2660,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13050001,Rem) ->
	#mon{id = 13050001,name = "软泥逃犯",boss = 3,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 169817,hp_lim = 184722399,hit = 9162,dodge = 6108,ten = 4886,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13060003,Rem) ->
	#mon{id = 13060003,name = "人造异形",boss = 3,color = 1,icon = 10040003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 580,att = 885856,hp_lim = 963607788,hit = 47798,dodge = 31865,ten = 25492,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14010001,Rem) ->
	#mon{id = 14010001,name = "异形长枪",boss = 4,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2903,hp_lim = 17422250,hit = 103,dodge = 69,ten = 55,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14020003,Rem) ->
	#mon{id = 14020003,name = "软泥逃犯",boss = 4,type = 1,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 11531,hp_lim = 94500000,hit = 562,dodge = 375,ten = 300,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14040001,Rem) ->
	#mon{id = 14040001,name = "变异死神",boss = 4,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 232955,hp_lim = 1397733100,hit = 8319,dodge = 5546,ten = 4437,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14050003,Rem) ->
	#mon{id = 14050003,name = "生化暴君",boss = 4,type = 1,color = 1,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 475,att = 821309,hp_lim = 4927856200,hit = 29332,dodge = 19554,ten = 15643,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(15010003,Rem) ->
	#mon{id = 15010003,name = "物资宝箱",kind = 1,color = 1,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,hp_lim = 3732752,def = 109008,hit = 34855,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 1,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(17010001,Rem) ->
	#mon{id = 17010001,name = "小螃蟹",kind = 6,type = 1,color = 1,icon = 5010001,icon_effect = <<"0"/utf8>>,weapon_id = 5010001,lv = 5,att = 30,hp_lim = 5000,def = 15,striking_distance = 100,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 100,att_time = 1500,exp = 10000,rem_flag = Rem};
get(18010003,Rem) ->
	#mon{id = 18010003,name = "变异死神",boss = 9,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 4676,hp_lim = 3477600,hit = 172,dodge = 115,ten = 92,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18020005,Rem) ->
	#mon{id = 18020005,name = "雇佣兵长",boss = 9,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 210,att = 37820,hp_lim = 28123200,hit = 1395,dodge = 930,ten = 744,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18020101,Rem) ->
	#mon{id = 18020101,name = "星域精英",boss = 10,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 8946,hp_lim = 6652800,hit = 330,dodge = 220,ten = 176,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18030001,Rem) ->
	#mon{id = 18030001,name = "爆裂机甲",boss = 9,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 29280,hp_lim = 21772800,hit = 1080,dodge = 720,ten = 576,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18040003,Rem) ->
	#mon{id = 18040003,name = "人马王者",boss = 9,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 360,att = 142484,hp_lim = 105952311,hit = 5255,dodge = 3503,ten = 2802,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18050005,Rem) ->
	#mon{id = 18050005,name = "阴影侍从",boss = 9,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 500,att = 579992,hp_lim = 431286327,hit = 21393,dodge = 14262,ten = 11409,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18050101,Rem) ->
	#mon{id = 18050101,name = "星域精英",boss = 10,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 264410,hp_lim = 196617606,hit = 9752,dodge = 6501,ten = 5201,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18060001,Rem) ->
	#mon{id = 18060001,name = "病毒利爪",boss = 9,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 464557,hp_lim = 345448212,hit = 17135,dodge = 11423,ten = 9138,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19010005,Rem) ->
	#mon{id = 19010005,name = "爆裂机甲",boss = 12,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 14640,hp_lim = 36288000,hit = 540,dodge = 360,ten = 288,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19020001,Rem) ->
	#mon{id = 19020001,name = "机甲环刃",boss = 12,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 10980,hp_lim = 27216000,hit = 405,dodge = 270,ten = 216,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19030003,Rem) ->
	#mon{id = 19030003,name = "变异死神",boss = 12,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 114449,hp_lim = 283684160,hit = 4221,dodge = 2814,ten = 2251,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19040005,Rem) ->
	#mon{id = 19040005,name = "雇佣兵王",boss = 12,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 506913,hp_lim = 1256480160,hit = 18697,dodge = 12465,ten = 9972,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19050001,Rem) ->
	#mon{id = 19050001,name = "莱姆战士",boss = 12,type = 1,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 410,att = 473502,hp_lim = 1173665950,hit = 17465,dodge = 11643,ten = 9314,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19060003,Rem) ->
	#mon{id = 19060003,name = "病毒异形",boss = 12,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 560,att = 1605791,hp_lim = 3980256530,hit = 59230,dodge = 39486,ten = 31589,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20010001,Rem) ->
	#mon{id = 20010001,name = "执首领主",boss = 13,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2911,hp_lim = 7216170,hit = 107,dodge = 71,ten = 57,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20020003,Rem) ->
	#mon{id = 20020003,name = "霹雳人马",boss = 13,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 29280,hp_lim = 72576000,hit = 1080,dodge = 720,ten = 576,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20030005,Rem) ->
	#mon{id = 20030005,name = "王级行者",boss = 13,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 227278,hp_lim = 563352140,hit = 8383,dodge = 5588,ten = 4471,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20040001,Rem) ->
	#mon{id = 20040001,name = "改造机甲",boss = 13,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 202890,hp_lim = 502902840,hit = 7483,dodge = 4989,ten = 3991,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20050003,Rem) ->
	#mon{id = 20050003,name = "投弹猩猩",boss = 13,type = 1,color = 1,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 460,att = 669644,hp_lim = 1659839420,hit = 24699,dodge = 16466,ten = 13173,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20060005,Rem) ->
	#mon{id = 20060005,name = "病毒血魔",boss = 13,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 620,att = 2888363,hp_lim = 7159352500,hit = 106537,dodge = 71025,ten = 56820,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(43001005,Rem) ->
	#mon{id = 43001005,name = "北城中枢",kind = 11,boss = 1,color = 1,icon = 10010306,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 1,att = 1000,hp_lim = 1131000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(43001101,Rem) ->
	#mon{id = 43001101,name = "核心守卫者",kind = 11,boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 250,att = 1000,hp_lim = 942000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(60402001,Rem) ->
	#mon{id = 60402001,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60402007,Rem) ->
	#mon{id = 60402007,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403003,Rem) ->
	#mon{id = 60403003,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403009,Rem) ->
	#mon{id = 60403009,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(70010005,Rem) ->
	#mon{id = 70010005,name = "街头少女",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 88,att = 766,hp_lim = 113266,hit = 35,dodge = 23,ten = 18,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010011,Rem) ->
	#mon{id = 70010011,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 7650,hp_lim = 992250,hit = 202,dodge = 135,ten = 108,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010017,Rem) ->
	#mon{id = 70010017,name = "战争兵蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 4998,hp_lim = 738990,hit = 229,dodge = 153,ten = 122,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010023,Rem) ->
	#mon{id = 70010023,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 115,att = 20400,hp_lim = 2646000,hit = 540,dodge = 360,ten = 288,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010029,Rem) ->
	#mon{id = 70010029,name = "机械护卫",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 12495,hp_lim = 1847475,hit = 573,dodge = 382,ten = 306,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010035,Rem) ->
	#mon{id = 70010035,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 40800,hp_lim = 5292000,hit = 1080,dodge = 720,ten = 576,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010041,Rem) ->
	#mon{id = 70010041,name = "改造行者",type = 1,color = 1,module = 610,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 23740,hp_lim = 3510202,hit = 1090,dodge = 726,ten = 581,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010047,Rem) ->
	#mon{id = 70010047,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 145,att = 66300,hp_lim = 8599500,hit = 1755,dodge = 1170,ten = 936,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010053,Rem) ->
	#mon{id = 70010053,name = "街头少女",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 150,att = 37485,hp_lim = 5542425,hit = 1721,dodge = 1147,ten = 918,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010059,Rem) ->
	#mon{id = 70010059,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 160,att = 96900,hp_lim = 12568500,hit = 2565,dodge = 1710,ten = 1368,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010065,Rem) ->
	#mon{id = 70010065,name = "战争兵蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 165,att = 52479,hp_lim = 7759395,hit = 2409,dodge = 1606,ten = 1285,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010071,Rem) ->
	#mon{id = 70010071,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 175,att = 137700,hp_lim = 17860500,hit = 3645,dodge = 2430,ten = 1944,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010077,Rem) ->
	#mon{id = 70010077,name = "机械护卫",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 180,att = 74970,hp_lim = 11084850,hit = 3442,dodge = 2295,ten = 1836,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010083,Rem) ->
	#mon{id = 70010083,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 190,att = 183600,hp_lim = 23814000,hit = 4860,dodge = 3240,ten = 2592,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010089,Rem) ->
	#mon{id = 70010089,name = "改造行者",type = 1,color = 1,module = 610,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 195,att = 99960,hp_lim = 14779800,hit = 4590,dodge = 3060,ten = 2448,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010095,Rem) ->
	#mon{id = 70010095,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 205,att = 244800,hp_lim = 31752000,hit = 6480,dodge = 4320,ten = 3456,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010101,Rem) ->
	#mon{id = 70010101,name = "街头少女",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 210,att = 129948,hp_lim = 19213740,hit = 5967,dodge = 3978,ten = 3182,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010107,Rem) ->
	#mon{id = 70010107,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 306000,hp_lim = 39690000,hit = 8100,dodge = 5400,ten = 4320,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010113,Rem) ->
	#mon{id = 70010113,name = "战争兵蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 225,att = 169932,hp_lim = 25125660,hit = 7803,dodge = 5202,ten = 4161,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010119,Rem) ->
	#mon{id = 70010119,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 428400,hp_lim = 55566000,hit = 11340,dodge = 7560,ten = 6048,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010125,Rem) ->
	#mon{id = 70010125,name = "机械护卫",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 240,att = 229908,hp_lim = 33993540,hit = 10557,dodge = 7038,ten = 5630,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010131,Rem) ->
	#mon{id = 70010131,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 250,att = 550800,hp_lim = 71442000,hit = 14580,dodge = 9720,ten = 7776,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010137,Rem) ->
	#mon{id = 70010137,name = "改造行者",type = 1,color = 1,module = 610,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 255,att = 289884,hp_lim = 42861420,hit = 13311,dodge = 8874,ten = 7099,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010143,Rem) ->
	#mon{id = 70010143,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 265,att = 673200,hp_lim = 87318000,hit = 17820,dodge = 11880,ten = 9504,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010149,Rem) ->
	#mon{id = 70010149,name = "街头少女",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 270,att = 349860,hp_lim = 51729300,hit = 16065,dodge = 10710,ten = 8568,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010155,Rem) ->
	#mon{id = 70010155,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 816000,hp_lim = 105840000,hit = 21600,dodge = 14400,ten = 11520,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010161,Rem) ->
	#mon{id = 70010161,name = "战争兵蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 285,att = 424830,hp_lim = 62814150,hit = 19507,dodge = 13005,ten = 10404,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010167,Rem) ->
	#mon{id = 70010167,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 295,att = 969000,hp_lim = 125685000,hit = 25650,dodge = 17100,ten = 13680,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010173,Rem) ->
	#mon{id = 70010173,name = "机械护卫",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 300,att = 499800,hp_lim = 73899000,hit = 22950,dodge = 15300,ten = 12240,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010179,Rem) ->
	#mon{id = 70010179,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 1122000,hp_lim = 145530000,hit = 29700,dodge = 19800,ten = 15840,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010185,Rem) ->
	#mon{id = 70010185,name = "改造行者",type = 1,color = 1,module = 610,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 315,att = 574770,hp_lim = 84983850,hit = 26392,dodge = 17595,ten = 14076,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010191,Rem) ->
	#mon{id = 70010191,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 1377000,hp_lim = 178605000,hit = 36450,dodge = 24300,ten = 19440,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010197,Rem) ->
	#mon{id = 70010197,name = "改造行者",type = 1,color = 1,module = 610,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 330,att = 724710,hp_lim = 107153550,hit = 33277,dodge = 22185,ten = 17748,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010203,Rem) ->
	#mon{id = 70010203,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 340,att = 1683000,hp_lim = 218295000,hit = 44550,dodge = 29700,ten = 23760,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010209,Rem) ->
	#mon{id = 70010209,name = "街头少女",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 345,att = 874650,hp_lim = 129323250,hit = 40162,dodge = 26775,ten = 21420,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010215,Rem) ->
	#mon{id = 70010215,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 355,att = 1989000,hp_lim = 257985000,hit = 52650,dodge = 35100,ten = 28080,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010221,Rem) ->
	#mon{id = 70010221,name = "战争兵蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 360,att = 1024590,hp_lim = 151492950,hit = 47047,dodge = 31365,ten = 25092,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010227,Rem) ->
	#mon{id = 70010227,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 2295000,hp_lim = 297675000,hit = 60750,dodge = 40500,ten = 32400,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010233,Rem) ->
	#mon{id = 70010233,name = "机械护卫",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 375,att = 1174530,hp_lim = 173662650,hit = 53932,dodge = 35955,ten = 28764,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010239,Rem) ->
	#mon{id = 70010239,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 385,att = 2601000,hp_lim = 337365000,hit = 68850,dodge = 45900,ten = 36720,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010245,Rem) ->
	#mon{id = 70010245,name = "改造行者",type = 1,color = 1,module = 610,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 390,att = 1324470,hp_lim = 195832350,hit = 60817,dodge = 40545,ten = 32436,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010251,Rem) ->
	#mon{id = 70010251,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 400,att = 3060000,hp_lim = 396900000,hit = 81000,dodge = 54000,ten = 43200,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010257,Rem) ->
	#mon{id = 70010257,name = "街头少女",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 405,att = 1624350,hp_lim = 240171750,hit = 74587,dodge = 49725,ten = 39780,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010263,Rem) ->
	#mon{id = 70010263,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 415,att = 3825000,hp_lim = 496125000,hit = 101250,dodge = 67500,ten = 54000,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010269,Rem) ->
	#mon{id = 70010269,name = "战争兵蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 1999200,hp_lim = 295596000,hit = 91800,dodge = 61200,ten = 48960,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010275,Rem) ->
	#mon{id = 70010275,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 4590000,hp_lim = 595350000,hit = 121500,dodge = 81000,ten = 64800,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010281,Rem) ->
	#mon{id = 70010281,name = "机械护卫",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 435,att = 2374050,hp_lim = 351020250,hit = 109012,dodge = 72675,ten = 58140,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010287,Rem) ->
	#mon{id = 70010287,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 445,att = 6120000,hp_lim = 793800000,hit = 162000,dodge = 108000,ten = 86400,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010293,Rem) ->
	#mon{id = 70010293,name = "改造行者",type = 1,color = 1,module = 610,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 450,att = 3498600,hp_lim = 517293000,hit = 160650,dodge = 107100,ten = 85680,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010299,Rem) ->
	#mon{id = 70010299,name = "三角杀戮者",boss = 6,type = 1,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 460,att = 9180000,hp_lim = 1190700000,hit = 243000,dodge = 162000,ten = 129600,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010503,Rem) ->
	#mon{id = 70010503,name = "异星监管者",boss = 6,type = 1,color = 1,module = 610,icon = 100100041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 124,att = 20400,hp_lim = 2646000,hit = 540,dodge = 360,ten = 288,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010509,Rem) ->
	#mon{id = 70010509,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 100200011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 172,att = 96900,hp_lim = 12568500,hit = 2565,dodge = 1710,ten = 1368,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010515,Rem) ->
	#mon{id = 70010515,name = "异形II代",boss = 6,type = 1,color = 1,module = 610,icon = 100400032,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 225,att = 214200,hp_lim = 27783000,hit = 5670,dodge = 3780,ten = 3024,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010521,Rem) ->
	#mon{id = 70010521,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 100100062,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 285,att = 408000,hp_lim = 52920000,hit = 10800,dodge = 7200,ten = 5760,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010527,Rem) ->
	#mon{id = 70010527,name = "异星监管者",boss = 6,type = 1,color = 1,module = 610,icon = 100100041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 350,att = 693600,hp_lim = 89964000,hit = 18360,dodge = 12240,ten = 9792,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010533,Rem) ->
	#mon{id = 70010533,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 100200011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 1183200,hp_lim = 153468000,hit = 31320,dodge = 20880,ten = 16704,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010539,Rem) ->
	#mon{id = 70010539,name = "异形II代",boss = 6,type = 1,color = 1,module = 610,icon = 100400032,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 530,att = 1734000,hp_lim = 224910000,hit = 45900,dodge = 30600,ten = 24480,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010545,Rem) ->
	#mon{id = 70010545,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 100100062,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 620,att = 2346000,hp_lim = 304290000,hit = 62100,dodge = 41400,ten = 33120,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70011001,Rem) ->
	#mon{id = 70011001,name = "蜂刺射手",type = 1,color = 1,module = 20,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 42,att = 305,hp_lim = 16477,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80010001,Rem) ->
	#mon{id = 80010001,name = "叛逃者",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80010007,Rem) ->
	#mon{id = 80010007,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80020003,Rem) ->
	#mon{id = 80020003,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80020009,Rem) ->
	#mon{id = 80020009,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80040001,Rem) ->
	#mon{id = 80040001,name = "改造水母",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80040007,Rem) ->
	#mon{id = 80040007,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80050003,Rem) ->
	#mon{id = 80050003,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80050009,Rem) ->
	#mon{id = 80050009,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80070001,Rem) ->
	#mon{id = 80070001,name = "变异虫体",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80070007,Rem) ->
	#mon{id = 80070007,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80080003,Rem) ->
	#mon{id = 80080003,name = "原始巫妖",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80080009,Rem) ->
	#mon{id = 80080009,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80100001,Rem) ->
	#mon{id = 80100001,name = "怪异博士",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80100007,Rem) ->
	#mon{id = 80100007,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80110003,Rem) ->
	#mon{id = 80110003,name = "森林贤王",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80110009,Rem) ->
	#mon{id = 80110009,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80130001,Rem) ->
	#mon{id = 80130001,name = "邪心女仆",type = 1,color = 1,module = 610,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80130007,Rem) ->
	#mon{id = 80130007,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80140003,Rem) ->
	#mon{id = 80140003,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80140009,Rem) ->
	#mon{id = 80140009,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80160001,Rem) ->
	#mon{id = 80160001,name = "原始守护者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80160007,Rem) ->
	#mon{id = 80160007,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80170003,Rem) ->
	#mon{id = 80170003,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80170009,Rem) ->
	#mon{id = 80170009,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80190001,Rem) ->
	#mon{id = 80190001,name = "草地蜥",type = 1,color = 1,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80190007,Rem) ->
	#mon{id = 80190007,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80200003,Rem) ->
	#mon{id = 80200003,name = "球形海怪",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80200009,Rem) ->
	#mon{id = 80200009,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80220001,Rem) ->
	#mon{id = 80220001,name = "冰原从者",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80220007,Rem) ->
	#mon{id = 80220007,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80230003,Rem) ->
	#mon{id = 80230003,name = "深渊巨网",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80230009,Rem) ->
	#mon{id = 80230009,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80250001,Rem) ->
	#mon{id = 80250001,name = "叛逃者",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80250007,Rem) ->
	#mon{id = 80250007,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80260003,Rem) ->
	#mon{id = 80260003,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80260009,Rem) ->
	#mon{id = 80260009,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80280001,Rem) ->
	#mon{id = 80280001,name = "改造水母",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80280007,Rem) ->
	#mon{id = 80280007,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010003,Rem) ->
	#mon{id = 81010003,name = "上路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 200,att = 30333,hp_lim = 32760000,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81010201,Rem) ->
	#mon{id = 81010201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 203,att = 30333,hp_lim = 1638000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010303,Rem) ->
	#mon{id = 81010303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 206,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010501,Rem) ->
	#mon{id = 81010501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 212,att = 77500,hp_lim = 3906000,hit = 1395,dodge = 930,ten = 744,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010603,Rem) ->
	#mon{id = 81010603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 215,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010801,Rem) ->
	#mon{id = 81010801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 221,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010903,Rem) ->
	#mon{id = 81010903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 224,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011101,Rem) ->
	#mon{id = 81011101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 230,att = 47950,hp_lim = 2589300,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011203,Rem) ->
	#mon{id = 81011203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 233,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011401,Rem) ->
	#mon{id = 81011401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 239,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011503,Rem) ->
	#mon{id = 81011503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 242,att = 129020,hp_lim = 6502612,hit = 2322,dodge = 1548,ten = 1238,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020005,Rem) ->
	#mon{id = 81020005,name = "豪华箱子",kind = 1,color = 3,module = 610,icon = 10010402,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 109,hp_lim = 5911,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81020101,Rem) ->
	#mon{id = 81020101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 240,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020203,Rem) ->
	#mon{id = 81020203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 245,att = 60209,hp_lim = 3251306,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020401,Rem) ->
	#mon{id = 81020401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 255,att = 72964,hp_lim = 3940057,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020503,Rem) ->
	#mon{id = 81020503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 260,att = 156351,hp_lim = 7880115,hit = 2814,dodge = 1876,ten = 1500,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020701,Rem) ->
	#mon{id = 81020701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 270,att = 86233,hp_lim = 4656632,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020803,Rem) ->
	#mon{id = 81020803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 275,att = 93068,hp_lim = 5025701,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021001,Rem) ->
	#mon{id = 81021001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 285,att = 214371,hp_lim = 10804302,hit = 3858,dodge = 2572,ten = 2057,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021103,Rem) ->
	#mon{id = 81021103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 290,att = 107150,hp_lim = 5786130,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021301,Rem) ->
	#mon{id = 81021301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 300,att = 121801,hp_lim = 6577281,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021403,Rem) ->
	#mon{id = 81021403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 121801,hp_lim = 6577281,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021601,Rem) ->
	#mon{id = 81021601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 315,att = 137044,hp_lim = 7400391,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021703,Rem) ->
	#mon{id = 81021703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 320,att = 144895,hp_lim = 7824335,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021901,Rem) ->
	#mon{id = 81021901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 161070,hp_lim = 8697830,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022003,Rem) ->
	#mon{id = 81022003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 335,att = 363004,hp_lim = 18295443,hit = 6534,dodge = 4356,ten = 3484,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022201,Rem) ->
	#mon{id = 81022201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 345,att = 177900,hp_lim = 9606611,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022303,Rem) ->
	#mon{id = 81022303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 350,att = 186568,hp_lim = 10074678,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022501,Rem) ->
	#mon{id = 81022501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 360,att = 437964,hp_lim = 22073398,hit = 7883,dodge = 5255,ten = 4204,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030001,Rem) ->
	#mon{id = 81030001,name = "下路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 360,att = 204383,hp_lim = 222941320,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81030103,Rem) ->
	#mon{id = 81030103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 360,att = 210514,hp_lim = 11367800,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030301,Rem) ->
	#mon{id = 81030301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 366,att = 238328,hp_lim = 12869741,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030403,Rem) ->
	#mon{id = 81030403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 369,att = 249465,hp_lim = 13471131,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030601,Rem) ->
	#mon{id = 81030601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 375,att = 269260,hp_lim = 14540043,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030703,Rem) ->
	#mon{id = 81030703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 378,att = 292390,hp_lim = 15789103,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030901,Rem) ->
	#mon{id = 81030901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 384,att = 314140,hp_lim = 16963608,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031003,Rem) ->
	#mon{id = 81031003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 387,att = 538527,hp_lim = 27141773,hit = 9693,dodge = 6462,ten = 5169,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031201,Rem) ->
	#mon{id = 81031201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 393,att = 363253,hp_lim = 19615690,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031303,Rem) ->
	#mon{id = 81031303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 396,att = 376807,hp_lim = 20347619,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031501,Rem) ->
	#mon{id = 81031501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 402,att = 624545,hp_lim = 31477068,hit = 11241,dodge = 7494,ten = 5995,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031603,Rem) ->
	#mon{id = 81031603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 405,att = 431352,hp_lim = 23293030,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031801,Rem) ->
	#mon{id = 81031801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 411,att = 458840,hp_lim = 24777392,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031903,Rem) ->
	#mon{id = 81031903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 414,att = 490530,hp_lim = 26488622,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032101,Rem) ->
	#mon{id = 81032101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 420,att = 520301,hp_lim = 28096292,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032203,Rem) ->
	#mon{id = 81032203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 423,att = 554537,hp_lim = 29945043,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032401,Rem) ->
	#mon{id = 81032401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 429,att = 586691,hp_lim = 31681325,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032503,Rem) ->
	#mon{id = 81032503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 432,att = 763568,hp_lim = 38483831,hit = 13744,dodge = 9162,ten = 7330,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032701,Rem) ->
	#mon{id = 81032701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 438,att = 658217,hp_lim = 35543754,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032803,Rem) ->
	#mon{id = 81032803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 441,att = 697871,hp_lim = 37685039,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033001,Rem) ->
	#mon{id = 81033001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 447,att = 837877,hp_lim = 42229030,hit = 15081,dodge = 10054,ten = 8043,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033103,Rem) ->
	#mon{id = 81033103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 450,att = 777517,hp_lim = 41985926,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033301,Rem) ->
	#mon{id = 81033301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 456,att = 817207,hp_lim = 44129209,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033403,Rem) ->
	#mon{id = 81033403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 459,att = 862365,hp_lim = 46567717,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033601,Rem) ->
	#mon{id = 81033601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 465,att = 904590,hp_lim = 48847881,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033703,Rem) ->
	#mon{id = 81033703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 468,att = 952563,hp_lim = 51438411,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033901,Rem) ->
	#mon{id = 81033901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 474,att = 997396,hp_lim = 53859403,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034003,Rem) ->
	#mon{id = 81034003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 477,att = 1021035,hp_lim = 51460201,hit = 18378,dodge = 12252,ten = 9801,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034201,Rem) ->
	#mon{id = 81034201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 483,att = 1095779,hp_lim = 59172081,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034303,Rem) ->
	#mon{id = 81034303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 486,att = 1149621,hp_lim = 62079554,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034501,Rem) ->
	#mon{id = 81034501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 492,att = 1103522,hp_lim = 55617546,hit = 19863,dodge = 13242,ten = 10593,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034603,Rem) ->
	#mon{id = 81034603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 495,att = 1256797,hp_lim = 67867057,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034801,Rem) ->
	#mon{id = 81034801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 501,att = 1342223,hp_lim = 72480063,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034903,Rem) ->
	#mon{id = 81034903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 504,att = 1403264,hp_lim = 75776270,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040003,Rem) ->
	#mon{id = 81040003,name = "上路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 500,att = 1386594,hp_lim = 1515492220,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81040201,Rem) ->
	#mon{id = 81040201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 504,att = 1443032,hp_lim = 77923776,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040303,Rem) ->
	#mon{id = 81040303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 508,att = 1506715,hp_lim = 81362648,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040501,Rem) ->
	#mon{id = 81040501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 516,att = 1366286,hp_lim = 68860852,hit = 24593,dodge = 16395,ten = 13116,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040603,Rem) ->
	#mon{id = 81040603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 520,att = 1785881,hp_lim = 96437625,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040801,Rem) ->
	#mon{id = 81040801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 528,att = 1973815,hp_lim = 106586011,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040903,Rem) ->
	#mon{id = 81040903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 532,att = 2094703,hp_lim = 113114013,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041101,Rem) ->
	#mon{id = 81041101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 540,att = 2301816,hp_lim = 124298109,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041203,Rem) ->
	#mon{id = 81041203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 544,att = 2435502,hp_lim = 131517153,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041401,Rem) ->
	#mon{id = 81041401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 552,att = 2712981,hp_lim = 146500979,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041503,Rem) ->
	#mon{id = 81041503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 556,att = 2079154,hp_lim = 104789386,hit = 37424,dodge = 24949,ten = 19959,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041701,Rem) ->
	#mon{id = 81041701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 564,att = 3170186,hp_lim = 171190072,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041803,Rem) ->
	#mon{id = 81041803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 568,att = 3345157,hp_lim = 180638516,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042001,Rem) ->
	#mon{id = 81042001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 576,att = 2552330,hp_lim = 128637461,hit = 45941,dodge = 30627,ten = 24502,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042103,Rem) ->
	#mon{id = 81042103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 580,att = 3878719,hp_lim = 209450860,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042301,Rem) ->
	#mon{id = 81042301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 588,att = 4252105,hp_lim = 229613683,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042403,Rem) ->
	#mon{id = 81042403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 592,att = 4493667,hp_lim = 242658055,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042601,Rem) ->
	#mon{id = 81042601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 600,att = 4924513,hp_lim = 265923751,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042703,Rem) ->
	#mon{id = 81042703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 604,att = 5202044,hp_lim = 280910429,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042901,Rem) ->
	#mon{id = 81042901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 612,att = 5698907,hp_lim = 307741002,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043003,Rem) ->
	#mon{id = 81043003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 616,att = 3792629,hp_lim = 191148501,hit = 68267,dodge = 45511,ten = 36409,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043201,Rem) ->
	#mon{id = 81043201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 622,att = 6461094,hp_lim = 348899110,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043303,Rem) ->
	#mon{id = 81043303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 625,att = 6819828,hp_lim = 368270721,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043501,Rem) ->
	#mon{id = 81043501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 631,att = 4443669,hp_lim = 223960938,hit = 79986,dodge = 53324,ten = 42659,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043603,Rem) ->
	#mon{id = 81043603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 634,att = 7572368,hp_lim = 408907876,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043801,Rem) ->
	#mon{id = 81043801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 640,att = 8288156,hp_lim = 447560459,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043903,Rem) ->
	#mon{id = 81043903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 643,att = 8570686,hp_lim = 462817080,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044101,Rem) ->
	#mon{id = 81044101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 649,att = 9194412,hp_lim = 496498264,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044203,Rem) ->
	#mon{id = 81044203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 652,att = 9694786,hp_lim = 523518475,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044401,Rem) ->
	#mon{id = 81044401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 658,att = 10397633,hp_lim = 561472233,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044503,Rem) ->
	#mon{id = 81044503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 661,att = 5980593,hp_lim = 301421933,hit = 107650,dodge = 71767,ten = 57413,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044701,Rem) ->
	#mon{id = 81044701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 667,att = 11521292,hp_lim = 622149814,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044803,Rem) ->
	#mon{id = 81044803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 670,att = 12140824,hp_lim = 655604521,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045001,Rem) ->
	#mon{id = 81045001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 676,att = 7007219,hp_lim = 353163837,hit = 126129,dodge = 84086,ten = 67269,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045103,Rem) ->
	#mon{id = 81045103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 679,att = 13441808,hp_lim = 725857639,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045301,Rem) ->
	#mon{id = 81045301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 685,att = 14694260,hp_lim = 793490078,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045403,Rem) ->
	#mon{id = 81045403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 688,att = 15172275,hp_lim = 819302879,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045601,Rem) ->
	#mon{id = 81045601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 694,att = 16257260,hp_lim = 877892040,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045703,Rem) ->
	#mon{id = 81045703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 697,att = 17117347,hp_lim = 924336743,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045901,Rem) ->
	#mon{id = 81045901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 703,att = 18337655,hp_lim = 990233390,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81046003,Rem) ->
	#mon{id = 81046003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 706,att = 9430794,hp_lim = 475312030,hit = 169754,dodge = 113169,ten = 90535,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050005,Rem) ->
	#mon{id = 81050005,name = "豪华箱子",kind = 1,color = 3,module = 610,icon = 10010402,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 476,hp_lim = 25715,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81050101,Rem) ->
	#mon{id = 81050101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 700,att = 18081773,hp_lim = 976415763,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050203,Rem) ->
	#mon{id = 81050203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 703,att = 19028014,hp_lim = 1027512765,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050401,Rem) ->
	#mon{id = 81050401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 709,att = 20375834,hp_lim = 1100295065,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050503,Rem) ->
	#mon{id = 81050503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 712,att = 10008034,hp_lim = 504404926,hit = 180144,dodge = 120096,ten = 96077,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050701,Rem) ->
	#mon{id = 81050701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 718,att = 22501524,hp_lim = 1215082300,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050803,Rem) ->
	#mon{id = 81050803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 721,att = 23668411,hp_lim = 1278094212,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051001,Rem) ->
	#mon{id = 81051001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 727,att = 11726007,hp_lim = 590990765,hit = 211068,dodge = 140712,ten = 112569,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051103,Rem) ->
	#mon{id = 81051103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 730,att = 26121791,hp_lim = 1410576761,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051301,Rem) ->
	#mon{id = 81051301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 736,att = 28516734,hp_lim = 1539903678,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051403,Rem) ->
	#mon{id = 81051403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 739,att = 29107007,hp_lim = 1571778378,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051601,Rem) ->
	#mon{id = 81051601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 745,att = 30240458,hp_lim = 1632984750,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051703,Rem) ->
	#mon{id = 81051703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 748,att = 31168959,hp_lim = 1683123837,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051901,Rem) ->
	#mon{id = 81051901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 754,att = 32377718,hp_lim = 1748396795,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052003,Rem) ->
	#mon{id = 81052003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 757,att = 14300945,hp_lim = 720767661,hit = 257417,dodge = 171611,ten = 137289,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052201,Rem) ->
	#mon{id = 81052201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 763,att = 34311223,hp_lim = 1852806063,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052303,Rem) ->
	#mon{id = 81052303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 766,att = 35351589,hp_lim = 1908985816,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052501,Rem) ->
	#mon{id = 81052501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 772,att = 15485874,hp_lim = 780488095,hit = 278745,dodge = 185830,ten = 148664,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052603,Rem) ->
	#mon{id = 81052603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 775,att = 37443916,hp_lim = 2021971485,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052801,Rem) ->
	#mon{id = 81052801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 781,att = 38879311,hp_lim = 2099482819,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052903,Rem) ->
	#mon{id = 81052903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 784,att = 40044352,hp_lim = 2162395021,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053101,Rem) ->
	#mon{id = 81053101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 790,att = 41989626,hp_lim = 2267439814,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053203,Rem) ->
	#mon{id = 81053203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 793,att = 43240781,hp_lim = 2335002194,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053401,Rem) ->
	#mon{id = 81053401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 799,att = 45335487,hp_lim = 2448116319,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053503,Rem) ->
	#mon{id = 81053503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 802,att = 18523390,hp_lim = 933578864,hit = 333421,dodge = 222280,ten = 177824,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053701,Rem) ->
	#mon{id = 81053701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 808,att = 48934105,hp_lim = 2642441674,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053803,Rem) ->
	#mon{id = 81053803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 811,att = 50376482,hp_lim = 2720330071,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054001,Rem) ->
	#mon{id = 81054001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 817,att = 20461346,hp_lim = 1031251867,hit = 368304,dodge = 245536,ten = 196428,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054103,Rem) ->
	#mon{id = 81054103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 820,att = 54352301,hp_lim = 2935024287,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054301,Rem) ->
	#mon{id = 81054301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 826,att = 58109655,hp_lim = 3137921389,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054403,Rem) ->
	#mon{id = 81054403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 829,att = 60403091,hp_lim = 3261766918,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054601,Rem) ->
	#mon{id = 81054601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 835,att = 64571437,hp_lim = 3486857637,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054703,Rem) ->
	#mon{id = 81054703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 838,att = 67110573,hp_lim = 3623970986,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054901,Rem) ->
	#mon{id = 81054901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 844,att = 74646629,hp_lim = 4030917968,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055003,Rem) ->
	#mon{id = 81055003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 847,att = 29275456,hp_lim = 1475482982,hit = 526958,dodge = 351305,ten = 281044,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055201,Rem) ->
	#mon{id = 81055201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 853,att = 91580625,hp_lim = 4945353752,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055303,Rem) ->
	#mon{id = 81055303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 856,att = 101010638,hp_lim = 5454574499,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055501,Rem) ->
	#mon{id = 81055501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 862,att = 45356978,hp_lim = 2285991712,hit = 816425,dodge = 544283,ten = 435426,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055603,Rem) ->
	#mon{id = 81055603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 865,att = 148179735,hp_lim = 8001705721,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055801,Rem) ->
	#mon{id = 81055801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 871,att = 257831367,hp_lim = 13922893847,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055903,Rem) ->
	#mon{id = 81055903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 874,att = 350380313,hp_lim = 18920536926,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000003,Rem) ->
	#mon{id = 82000003,name = "机械大触",boss = 6,color = 1,module = 610,auto = 3,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000009,Rem) ->
	#mon{id = 82000009,name = "明日战姬",boss = 6,color = 1,module = 610,auto = 3,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000015,Rem) ->
	#mon{id = 82000015,name = "机械大触",boss = 6,color = 1,module = 610,auto = 3,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000021,Rem) ->
	#mon{id = 82000021,name = "傻士奇兄弟",boss = 6,color = 1,module = 610,auto = 3,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000001,Rem) ->
	#mon{id = 84000001,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 380,att = 126345,hp_lim = 3914653,hit = 4660,dodge = 3106,ten = 2485,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000007,Rem) ->
	#mon{id = 84000007,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 382,att = 451531,hp_lim = 15658614,hit = 9320,dodge = 6213,ten = 4970,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000013,Rem) ->
	#mon{id = 84000013,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 388,att = 487930,hp_lim = 16920907,hit = 10071,dodge = 6714,ten = 5371,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000019,Rem) ->
	#mon{id = 84000019,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 393,att = 283477,hp_lim = 8783145,hit = 10456,dodge = 6970,ten = 5576,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000025,Rem) ->
	#mon{id = 84000025,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 398,att = 535939,hp_lim = 18585778,hit = 11062,dodge = 7375,ten = 5900,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000031,Rem) ->
	#mon{id = 84000031,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 405,att = 313921,hp_lim = 9726413,hit = 11579,dodge = 7719,ten = 6175,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000037,Rem) ->
	#mon{id = 84000037,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 410,att = 631750,hp_lim = 21908428,hit = 13040,dodge = 8693,ten = 6955,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000043,Rem) ->
	#mon{id = 84000043,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 419,att = 364977,hp_lim = 11308321,hit = 13462,dodge = 8974,ten = 7179,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000049,Rem) ->
	#mon{id = 84000049,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 428,att = 754494,hp_lim = 26165046,hit = 15574,dodge = 10382,ten = 8306,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000055,Rem) ->
	#mon{id = 84000055,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 435,att = 434518,hp_lim = 13462941,hit = 16027,dodge = 10684,ten = 8547,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000061,Rem) ->
	#mon{id = 84000061,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 440,att = 864623,hp_lim = 29984184,hit = 17847,dodge = 11898,ten = 9518,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000067,Rem) ->
	#mon{id = 84000067,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 449,att = 497104,hp_lim = 15402090,hit = 18335,dodge = 12223,ten = 9779,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000073,Rem) ->
	#mon{id = 84000073,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 458,att = 1013102,hp_lim = 35133265,hit = 20912,dodge = 13941,ten = 11153,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000079,Rem) ->
	#mon{id = 84000079,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 465,att = 564810,hp_lim = 17499871,hit = 20833,dodge = 13888,ten = 11111,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000085,Rem) ->
	#mon{id = 84000085,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 470,att = 1113512,hp_lim = 38615376,hit = 22985,dodge = 15323,ten = 12258,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000091,Rem) ->
	#mon{id = 84000091,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 479,att = 637779,hp_lim = 19760717,hit = 23524,dodge = 15683,ten = 12546,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000097,Rem) ->
	#mon{id = 84000097,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 488,att = 1285137,hp_lim = 44567155,hit = 26528,dodge = 17685,ten = 14148,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000103,Rem) ->
	#mon{id = 84000103,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 495,att = 734434,hp_lim = 22755424,hit = 27089,dodge = 18059,ten = 14447,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000109,Rem) ->
	#mon{id = 84000109,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 500,att = 1471659,hp_lim = 51035546,hit = 30378,dodge = 20252,ten = 16201,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000115,Rem) ->
	#mon{id = 84000115,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 509,att = 859357,hp_lim = 26625997,hit = 31697,dodge = 21131,ten = 16905,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000121,Rem) ->
	#mon{id = 84000121,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 518,att = 1751360,hp_lim = 60735270,hit = 36151,dodge = 24101,ten = 19281,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000127,Rem) ->
	#mon{id = 84000127,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 530,att = 1107865,hp_lim = 34325667,hit = 40863,dodge = 27242,ten = 21794,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000133,Rem) ->
	#mon{id = 84000133,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 538,att = 2281217,hp_lim = 79110113,hit = 47089,dodge = 31392,ten = 25114,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000139,Rem) ->
	#mon{id = 84000139,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 550,att = 1421349,hp_lim = 44038528,hit = 52426,dodge = 34951,ten = 27960,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000145,Rem) ->
	#mon{id = 84000145,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 559,att = 2950473,hp_lim = 102319161,hit = 60904,dodge = 40602,ten = 32482,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000151,Rem) ->
	#mon{id = 84000151,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 571,att = 1795757,hp_lim = 55639040,hit = 66236,dodge = 44157,ten = 35326,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000157,Rem) ->
	#mon{id = 84000157,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 579,att = 3677634,hp_lim = 127536325,hit = 75914,dodge = 50609,ten = 40487,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000163,Rem) ->
	#mon{id = 84000163,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 591,att = 2305765,hp_lim = 71440944,hit = 85048,dodge = 56699,ten = 45359,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000169,Rem) ->
	#mon{id = 84000169,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 600,att = 4713808,hp_lim = 163469693,hit = 97303,dodge = 64868,ten = 51895,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000175,Rem) ->
	#mon{id = 84000175,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 618,att = 3077145,hp_lim = 95341051,hit = 113501,dodge = 75667,ten = 60534,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000181,Rem) ->
	#mon{id = 84000181,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 632,att = 6664793,hp_lim = 231127689,hit = 137576,dodge = 91717,ten = 73373,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000187,Rem) ->
	#mon{id = 84000187,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 650,att = 4440916,hp_lim = 137595596,hit = 163804,dodge = 109202,ten = 87362,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000193,Rem) ->
	#mon{id = 84000193,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 664,att = 9603607,hp_lim = 333042544,hit = 198239,dodge = 132159,ten = 105727,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000199,Rem) ->
	#mon{id = 84000199,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 682,att = 6277867,hp_lim = 194510971,hit = 231560,dodge = 154373,ten = 123499,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000205,Rem) ->
	#mon{id = 84000205,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 696,att = 13556116,hp_lim = 470111186,hit = 279828,dodge = 186552,ten = 149241,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000211,Rem) ->
	#mon{id = 84000211,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 714,att = 8867246,hp_lim = 274739276,hit = 327070,dodge = 218047,ten = 174437,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000217,Rem) ->
	#mon{id = 84000217,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 728,att = 19120896,hp_lim = 663091639,hit = 394697,dodge = 263131,ten = 210505,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000223,Rem) ->
	#mon{id = 84000223,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 746,att = 12151469,hp_lim = 376496348,hit = 448209,dodge = 298806,ten = 239045,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000229,Rem) ->
	#mon{id = 84000229,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 760,att = 24424473,hp_lim = 847013864,hit = 504174,dodge = 336116,ten = 268893,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000235,Rem) ->
	#mon{id = 84000235,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 778,att = 14637858,hp_lim = 453533643,hit = 539921,dodge = 359947,ten = 287957,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000241,Rem) ->
	#mon{id = 84000241,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 792,att = 29679294,hp_lim = 1029245250,hit = 612645,dodge = 408430,ten = 326744,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000247,Rem) ->
	#mon{id = 84000247,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 810,att = 18335994,hp_lim = 568115244,hit = 676327,dodge = 450885,ten = 360708,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000253,Rem) ->
	#mon{id = 84000253,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 824,att = 38258708,hp_lim = 1326769904,hit = 789743,dodge = 526495,ten = 421196,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000259,Rem) ->
	#mon{id = 84000259,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 842,att = 25607957,hp_lim = 793426885,hit = 944555,dodge = 629703,ten = 503763,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000265,Rem) ->
	#mon{id = 84000265,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 856,att = 65774979,hp_lim = 2281003882,hit = 1357740,dodge = 905160,ten = 724128,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000271,Rem) ->
	#mon{id = 84000271,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 874,att = 121533877,hp_lim = 3765557840,hit = 4482806,dodge = 2988537,ten = 2390830,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000277,Rem) ->
	#mon{id = 84000277,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 888,att = 560891494,hp_lim = 19451099518,hit = 11578035,dodge = 7718690,ten = 6174952,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(85000003,Rem) ->
	#mon{id = 85000003,name = "魔龙·玛里苟斯",boss = 11,color = 1,module = 331,sub_module = 117,auto = 1,icon = 10030002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 100000,hp_lim = 2000000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [4000,8000],rem_flag = Rem};
get(_MonTypeId, _Rem) -> [].