%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc
%%% 怪物配置数据（2/6）
%%% @end
%%% -------------------------------------------------------
-module(data_mon_2).
-export([
		get/2
	]).
-include("scene.hrl").

%% 获取怪物配置
%% Rem是求余结果，
%%   主要目的是为了拆散编译期生成大的literal字面常量，
%%   减少热更新移除旧模块时literal拷贝引发内存暴涨问题，
%%   此值请勿用于它处，不保证未来取值
-spec get(MonTypeId, Rem) -> #mon{} | [] when
	MonTypeId :: non_neg_integer(), Rem :: any().
get(2,Rem) ->
	#mon{id = 2,name = "测试小怪（带晕眩）",type = 1,color = 1,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 1,att = 1,hp_lim = 3000,striking_distance = 50,tracing_distance = 300,warning_range = 200,speed = 150,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(8,Rem) ->
	#mon{id = 8,name = "归属掉落1",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(14,Rem) ->
	#mon{id = 14,name = "掉落紫装",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 500,att = 959,hp_lim = 299095311,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(20,Rem) ->
	#mon{id = 20,name = "掉落20个",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 3,exp = 100,rem_flag = Rem};
get(26,Rem) ->
	#mon{id = 26,name = "固定归属",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(32,Rem) ->
	#mon{id = 32,name = "掉落概率无归属",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 600,att = 80833,hp_lim = 42690336,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(110,Rem) ->
	#mon{id = 110,name = "个人独占伤害最高",type = 1,color = 7,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 110,att = 1,hp_lim = 100000,resum = [1],striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 110,is_fight_back = 0,rem_flag = Rem};
get(122,Rem) ->
	#mon{id = 122,name = "随机分配最后一击",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 122,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 122,rem_flag = Rem};
get(140,Rem) ->
	#mon{id = 140,name = "先到先得伤害最高",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 140,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 140,rem_flag = Rem};
get(1004,Rem) ->
	#mon{id = 1004,name = "豪华外送",kind = 3,boss = 7,color = 6,icon = 10060104,icon_effect = <<"0"/utf8>>,weapon_id = 10060104,lv = 100,att = 100,hp_lim = 200,striking_distance = 250,speed = 300,is_fight_back = 0,del_hp_each_time = [1,1],rem_flag = Rem};
get(9002,Rem) ->
	#mon{id = 9002,name = "美杜莎",boss = 6,type = 1,color = 1,auto = 1,icon = 10040004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 108000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(9008,Rem) ->
	#mon{id = 9008,name = "水手服战神",boss = 6,type = 1,color = 1,auto = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 111000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(9014,Rem) ->
	#mon{id = 9014,name = "血芒蝎女",boss = 6,type = 1,color = 1,auto = 1,icon = 100300062,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 114000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(9020,Rem) ->
	#mon{id = 9020,name = "霹雳人马",boss = 6,type = 1,color = 1,auto = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 117000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10004,Rem) ->
	#mon{id = 10004,name = "多足脑虫",type = 1,color = 1,auto = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 101000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10010,Rem) ->
	#mon{id = 10010,name = "叛逆兽人",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 104000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10016,Rem) ->
	#mon{id = 10016,name = "粉蛾女伶",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 107000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10022,Rem) ->
	#mon{id = 10022,name = "巫咒石灵",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 110000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(400202,Rem) ->
	#mon{id = 400202,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 60,att = 1058,hp_lim = 57143,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400502,Rem) ->
	#mon{id = 400502,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 90,att = 1433,hp_lim = 77406,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500006,Rem) ->
	#mon{id = 500006,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 70,att = 275,hp_lim = 18666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500012,Rem) ->
	#mon{id = 500012,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 102,att = 930,hp_lim = 63000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500018,Rem) ->
	#mon{id = 500018,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 111,att = 1550,hp_lim = 105000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500024,Rem) ->
	#mon{id = 500024,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 123,att = 2686,hp_lim = 182000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500030,Rem) ->
	#mon{id = 500030,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 135,att = 4650,hp_lim = 315000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500036,Rem) ->
	#mon{id = 500036,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 147,att = 6458,hp_lim = 437500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500042,Rem) ->
	#mon{id = 500042,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 159,att = 8318,hp_lim = 563500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500048,Rem) ->
	#mon{id = 500048,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 171,att = 10350,hp_lim = 701166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500054,Rem) ->
	#mon{id = 500054,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 183,att = 12434,hp_lim = 842333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500060,Rem) ->
	#mon{id = 500060,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 195,att = 14570,hp_lim = 987000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500066,Rem) ->
	#mon{id = 500066,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 206,att = 16378,hp_lim = 1109500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500072,Rem) ->
	#mon{id = 500072,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 212,att = 18186,hp_lim = 1232000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500078,Rem) ->
	#mon{id = 500078,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 218,att = 19995,hp_lim = 1354500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500084,Rem) ->
	#mon{id = 500084,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 224,att = 21803,hp_lim = 1477000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500090,Rem) ->
	#mon{id = 500090,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 230,att = 23904,hp_lim = 1619333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500096,Rem) ->
	#mon{id = 500096,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 236,att = 25747,hp_lim = 1744166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500102,Rem) ->
	#mon{id = 500102,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 242,att = 27624,hp_lim = 1871333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500108,Rem) ->
	#mon{id = 500108,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 247,att = 29536,hp_lim = 2000833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500114,Rem) ->
	#mon{id = 500114,name = "蓝衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 252,att = 31447,hp_lim = 2130333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500120,Rem) ->
	#mon{id = 500120,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 256,att = 33669,hp_lim = 2280833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500126,Rem) ->
	#mon{id = 500126,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 261,att = 35632,hp_lim = 2413833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500132,Rem) ->
	#mon{id = 500132,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 266,att = 37630,hp_lim = 2549166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500138,Rem) ->
	#mon{id = 500138,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 271,att = 39645,hp_lim = 2685666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500144,Rem) ->
	#mon{id = 500144,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 276,att = 41677,hp_lim = 2823333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500150,Rem) ->
	#mon{id = 500150,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 280,att = 44054,hp_lim = 2984333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500156,Rem) ->
	#mon{id = 500156,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 285,att = 46138,hp_lim = 3125500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500162,Rem) ->
	#mon{id = 500162,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 290,att = 48239,hp_lim = 3267833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500168,Rem) ->
	#mon{id = 500168,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 295,att = 50375,hp_lim = 3412500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500174,Rem) ->
	#mon{id = 500174,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 300,att = 52545,hp_lim = 3559500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500180,Rem) ->
	#mon{id = 500180,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 304,att = 55059,hp_lim = 3729833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500186,Rem) ->
	#mon{id = 500186,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 309,att = 57263,hp_lim = 3879166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500192,Rem) ->
	#mon{id = 500192,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 314,att = 59502,hp_lim = 4030833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500198,Rem) ->
	#mon{id = 500198,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 319,att = 61776,hp_lim = 4184833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500204,Rem) ->
	#mon{id = 500204,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 324,att = 64066,hp_lim = 4340000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500210,Rem) ->
	#mon{id = 500210,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 328,att = 66736,hp_lim = 4520833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500216,Rem) ->
	#mon{id = 500216,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 333,att = 69078,hp_lim = 4679500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500222,Rem) ->
	#mon{id = 500222,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 338,att = 71472,hp_lim = 4841666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500228,Rem) ->
	#mon{id = 500228,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 343,att = 73883,hp_lim = 5005000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500234,Rem) ->
	#mon{id = 500234,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 348,att = 76311,hp_lim = 5169500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500240,Rem) ->
	#mon{id = 500240,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 352,att = 79136,hp_lim = 5360833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500246,Rem) ->
	#mon{id = 500246,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 357,att = 81616,hp_lim = 5528833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500252,Rem) ->
	#mon{id = 500252,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 362,att = 84147,hp_lim = 5700333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500258,Rem) ->
	#mon{id = 500258,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 367,att = 86696,hp_lim = 5873000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500264,Rem) ->
	#mon{id = 500264,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 372,att = 89280,hp_lim = 6048000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500270,Rem) ->
	#mon{id = 500270,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 376,att = 92276,hp_lim = 6251000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500276,Rem) ->
	#mon{id = 500276,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 381,att = 94911,hp_lim = 6429500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500282,Rem) ->
	#mon{id = 500282,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 386,att = 97615,hp_lim = 6612666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500288,Rem) ->
	#mon{id = 500288,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 391,att = 100319,hp_lim = 6795833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500294,Rem) ->
	#mon{id = 500294,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 396,att = 103075,hp_lim = 6982500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500300,Rem) ->
	#mon{id = 500300,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 400,att = 133386,hp_lim = 9035833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510002,Rem) ->
	#mon{id = 510002,name = "迷失小丑",boss = 6,type = 1,color = 1,auto = 1,icon = 100200011,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 2550,hp_lim = 472500,hit = 67,dodge = 45,ten = 36,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510008,Rem) ->
	#mon{id = 510008,name = "病毒异形",boss = 6,type = 1,color = 1,auto = 1,icon = 100400031,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 155,att = 25500,hp_lim = 4725000,hit = 675,dodge = 450,ten = 360,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510014,Rem) ->
	#mon{id = 510014,name = "病毒暴君",boss = 6,type = 1,color = 1,auto = 1,icon = 100400012,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 210,att = 58140,hp_lim = 10773000,hit = 1539,dodge = 1026,ten = 820,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510020,Rem) ->
	#mon{id = 510020,name = "执行者铁角",boss = 6,type = 1,color = 1,auto = 1,icon = 100400022,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 240,att = 89136,hp_lim = 16516500,hit = 2359,dodge = 1573,ten = 1258,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510026,Rem) ->
	#mon{id = 510026,name = "兵武女刺",boss = 6,type = 1,color = 1,auto = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 264,att = 121946,hp_lim = 22596000,hit = 3228,dodge = 2152,ten = 1721,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510032,Rem) ->
	#mon{id = 510032,name = "能源守卫",boss = 6,type = 1,color = 1,auto = 1,icon = 100100061,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 288,att = 156796,hp_lim = 29053500,hit = 4150,dodge = 2767,ten = 2213,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510038,Rem) ->
	#mon{id = 510038,name = "灵魂收割者",boss = 6,type = 1,color = 1,auto = 1,icon = 100100031,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 312,att = 193686,hp_lim = 35889000,hit = 5127,dodge = 3418,ten = 2734,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510044,Rem) ->
	#mon{id = 510044,name = "武装女神",boss = 6,type = 1,color = 1,auto = 1,icon = 100200042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 336,att = 232900,hp_lim = 43155000,hit = 6165,dodge = 4110,ten = 3288,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510050,Rem) ->
	#mon{id = 510050,name = "海神祭祀",boss = 6,type = 1,color = 1,auto = 1,icon = 100100102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 360,att = 274493,hp_lim = 50862000,hit = 7266,dodge = 4844,ten = 3875,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510056,Rem) ->
	#mon{id = 510056,name = "末世利爪",boss = 6,type = 1,color = 1,auto = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 384,att = 318636,hp_lim = 59041500,hit = 8434,dodge = 5623,ten = 4498,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(650000,Rem) ->
	#mon{id = 650000,name = "社团字段",kind = 6,type = 1,color = 1,icon = 203008,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,def = 113014,hit = 23745,dodge = 23745,crit = 15293,ten = 15444,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,rem_flag = Rem};
get(651104,Rem) ->
	#mon{id = 651104,name = "社团晚间召唤坐标2",type = 1,color = 1,icon = 202036,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 100,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,del_hp_each_time = [0.02,0.02],rem_flag = Rem};
get(653102,Rem) ->
	#mon{id = 653102,name = "暴击宝箱",kind = 1,color = 1,icon = 10010198,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(1001000,Rem) ->
	#mon{id = 1001000,name = "副本字段",color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 3,att = 1,hp_lim = 15,def = 16,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001006,Rem) ->
	#mon{id = 1001006,name = "海神祭祀",boss = 6,color = 1,icon = 10010010,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 115,att = 1811,hp_lim = 356720,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001012,Rem) ->
	#mon{id = 1001012,name = "生化暴君",boss = 6,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 323,hp_lim = 63700,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001018,Rem) ->
	#mon{id = 1001018,name = "异形地狱犬",boss = 6,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 160,att = 1941,hp_lim = 382200,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001024,Rem) ->
	#mon{id = 1001024,name = "末世天使",boss = 6,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 5176,hp_lim = 1019200,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1200104,Rem) ->
	#mon{id = 1200104,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 108,att = 2469,hp_lim = 121210,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200110,Rem) ->
	#mon{id = 1200110,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 120,att = 4648,hp_lim = 228217,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200116,Rem) ->
	#mon{id = 1200116,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 150,att = 8046,hp_lim = 395010,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,is_be_clicked = 0,rem_flag = Rem};
get(1200206,Rem) ->
	#mon{id = 1200206,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 135,att = 5544,hp_lim = 272160,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200212,Rem) ->
	#mon{id = 1200212,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 165,att = 26588,hp_lim = 1391040,hit = 720,dodge = 480,ten = 384,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200302,Rem) ->
	#mon{id = 1200302,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 148,att = 8470,hp_lim = 415800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200308,Rem) ->
	#mon{id = 1200308,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 175,att = 25432,hp_lim = 1330560,hit = 720,dodge = 480,ten = 384,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200314,Rem) ->
	#mon{id = 1200314,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 205,att = 25063,hp_lim = 1230390,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200404,Rem) ->
	#mon{id = 1200404,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 185,att = 16978,hp_lim = 833490,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200410,Rem) ->
	#mon{id = 1200410,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 215,att = 25063,hp_lim = 1230390,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200416,Rem) ->
	#mon{id = 1200416,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 245,att = 39738,hp_lim = 1950783,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200506,Rem) ->
	#mon{id = 1200506,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 220,att = 27720,hp_lim = 1360800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200512,Rem) ->
	#mon{id = 1200512,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 250,att = 82394,hp_lim = 4310727,hit = 2565,dodge = 1710,ten = 1368,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200602,Rem) ->
	#mon{id = 1200602,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 228,att = 31647,hp_lim = 1553580,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200608,Rem) ->
	#mon{id = 1200608,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 255,att = 90371,hp_lim = 4728069,hit = 2814,dodge = 1876,ten = 1500,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200614,Rem) ->
	#mon{id = 1200614,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 285,att = 66026,hp_lim = 3241290,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200704,Rem) ->
	#mon{id = 1200704,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 255,att = 48156,hp_lim = 2364034,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200710,Rem) ->
	#mon{id = 1200710,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 285,att = 66026,hp_lim = 3241290,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200716,Rem) ->
	#mon{id = 1200716,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 315,att = 90449,hp_lim = 4440234,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200806,Rem) ->
	#mon{id = 1200806,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 285,att = 66026,hp_lim = 3241290,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200812,Rem) ->
	#mon{id = 1200812,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 315,att = 169739,hp_lim = 8880469,hit = 5285,dodge = 3523,ten = 2819,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200902,Rem) ->
	#mon{id = 1200902,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 288,att = 70719,hp_lim = 3471678,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200908,Rem) ->
	#mon{id = 1200908,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 315,att = 169739,hp_lim = 8880469,hit = 5285,dodge = 3523,ten = 2819,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200914,Rem) ->
	#mon{id = 1200914,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 345,att = 117414,hp_lim = 5763967,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201004,Rem) ->
	#mon{id = 1201004,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 315,att = 90449,hp_lim = 4440234,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201010,Rem) ->
	#mon{id = 1201010,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 345,att = 117414,hp_lim = 5763967,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201016,Rem) ->
	#mon{id = 1201016,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 375,att = 153199,hp_lim = 7520711,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201106,Rem) ->
	#mon{id = 1201106,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 345,att = 117414,hp_lim = 5763967,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201112,Rem) ->
	#mon{id = 1201112,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 375,att = 287498,hp_lim = 15041423,hit = 8953,dodge = 5968,ten = 4775,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201202,Rem) ->
	#mon{id = 1201202,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 348,att = 123134,hp_lim = 6044807,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201208,Rem) ->
	#mon{id = 1201208,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 375,att = 287498,hp_lim = 15041423,hit = 8953,dodge = 5968,ten = 4775,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201214,Rem) ->
	#mon{id = 1201214,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 405,att = 192359,hp_lim = 9443120,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201304,Rem) ->
	#mon{id = 1201304,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 375,att = 153199,hp_lim = 7520711,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201310,Rem) ->
	#mon{id = 1201310,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 405,att = 192359,hp_lim = 9443120,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201316,Rem) ->
	#mon{id = 1201316,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 435,att = 242694,hp_lim = 11914107,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201406,Rem) ->
	#mon{id = 1201406,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 405,att = 192359,hp_lim = 9443120,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201412,Rem) ->
	#mon{id = 1201412,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 435,att = 455446,hp_lim = 23828215,hit = 14183,dodge = 9455,ten = 7564,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201502,Rem) ->
	#mon{id = 1201502,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 408,att = 199233,hp_lim = 9780549,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201508,Rem) ->
	#mon{id = 1201508,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 435,att = 455446,hp_lim = 23828215,hit = 14183,dodge = 9455,ten = 7564,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201514,Rem) ->
	#mon{id = 1201514,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 465,att = 289820,hp_lim = 14227538,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201604,Rem) ->
	#mon{id = 1201604,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 435,att = 242694,hp_lim = 11914107,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201610,Rem) ->
	#mon{id = 1201610,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 465,att = 289820,hp_lim = 14227538,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201616,Rem) ->
	#mon{id = 1201616,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 495,att = 348523,hp_lim = 17109342,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201706,Rem) ->
	#mon{id = 1201706,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 465,att = 289820,hp_lim = 14227538,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201712,Rem) ->
	#mon{id = 1201712,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 495,att = 654047,hp_lim = 34218684,hit = 20368,dodge = 13578,ten = 10863,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201802,Rem) ->
	#mon{id = 1201802,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 468,att = 297958,hp_lim = 14627036,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201808,Rem) ->
	#mon{id = 1201808,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 495,att = 654047,hp_lim = 34218684,hit = 20368,dodge = 13578,ten = 10863,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201814,Rem) ->
	#mon{id = 1201814,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 525,att = 459178,hp_lim = 22541509,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201904,Rem) ->
	#mon{id = 1201904,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 495,att = 348523,hp_lim = 17109342,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201910,Rem) ->
	#mon{id = 1201910,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 525,att = 459178,hp_lim = 22541509,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201916,Rem) ->
	#mon{id = 1201916,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 555,att = 640379,hp_lim = 31436816,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202006,Rem) ->
	#mon{id = 1202006,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 525,att = 459178,hp_lim = 22541509,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202012,Rem) ->
	#mon{id = 1202012,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 555,att = 1201751,hp_lim = 62873632,hit = 37424,dodge = 24949,ten = 19959,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202102,Rem) ->
	#mon{id = 1202102,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 528,att = 478940,hp_lim = 23511620,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202108,Rem) ->
	#mon{id = 1202108,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 555,att = 1201751,hp_lim = 62873632,hit = 37424,dodge = 24949,ten = 19959,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202114,Rem) ->
	#mon{id = 1202114,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 585,att = 850919,hp_lim = 41772398,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202204,Rem) ->
	#mon{id = 1202204,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 555,att = 640379,hp_lim = 31436816,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202210,Rem) ->
	#mon{id = 1202210,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 585,att = 850919,hp_lim = 41772398,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202216,Rem) ->
	#mon{id = 1202216,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 615,att = 1168129,hp_lim = 57344550,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202306,Rem) ->
	#mon{id = 1202306,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 585,att = 850919,hp_lim = 41772398,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202312,Rem) ->
	#mon{id = 1202312,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 615,att = 2192139,hp_lim = 114689100,hit = 68267,dodge = 45511,ten = 36409,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202402,Rem) ->
	#mon{id = 1202402,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 588,att = 885296,hp_lim = 43460003,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202408,Rem) ->
	#mon{id = 1202408,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 615,att = 2192139,hp_lim = 114689100,hit = 68267,dodge = 45511,ten = 36409,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202414,Rem) ->
	#mon{id = 1202414,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 645,att = 1572148,hp_lim = 77178215,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(2002202,Rem) ->
	#mon{id = 2002202,name = "病毒行者",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 105,att = 1253,hp_lim = 33973,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2003102,Rem) ->
	#mon{id = 2003102,name = "生化护卫",type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 1567,hp_lim = 42466,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2005202,Rem) ->
	#mon{id = 2005202,name = "机械触须",type = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 125,att = 5955,hp_lim = 161373,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2006102,Rem) ->
	#mon{id = 2006102,name = "地底狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 5955,hp_lim = 161373,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2008202,Rem) ->
	#mon{id = 2008202,name = "生化护卫",type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 165,att = 8619,hp_lim = 233566,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2009102,Rem) ->
	#mon{id = 2009102,name = "机械触须",type = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 175,att = 7836,hp_lim = 212333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2011202,Rem) ->
	#mon{id = 2011202,name = "海族迦娜",type = 1,color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 195,att = 10186,hp_lim = 276033,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2012102,Rem) ->
	#mon{id = 2012102,name = "地底狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 12537,hp_lim = 339733,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2014202,Rem) ->
	#mon{id = 2014202,name = "机械触须",type = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 260,att = 23508,hp_lim = 637000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2015102,Rem) ->
	#mon{id = 2015102,name = "地底狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 380,att = 47016,hp_lim = 1274000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2100104,Rem) ->
	#mon{id = 2100104,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 1629,hp_lim = 1092000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 778,is_hit_ac = 1,rem_flag = Rem};
get(2100110,Rem) ->
	#mon{id = 2100110,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 165,att = 3676,hp_lim = 2464000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 807,is_hit_ac = 1,rem_flag = Rem};
get(2100206,Rem) ->
	#mon{id = 2100206,name = "原始巫妖",color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 195,att = 5431,hp_lim = 3640000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 838,is_hit_ac = 1,rem_flag = Rem};
get(2100302,Rem) ->
	#mon{id = 2100302,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 225,att = 8272,hp_lim = 5544000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 878,is_hit_ac = 1,rem_flag = Rem};
get(2100308,Rem) ->
	#mon{id = 2100308,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 255,att = 13064,hp_lim = 8755684,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 945,is_hit_ac = 1,rem_flag = Rem};
get(2100404,Rem) ->
	#mon{id = 2100404,name = "生化守卫",color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 285,att = 17911,hp_lim = 12004783,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1040,is_hit_ac = 1,rem_flag = Rem};
get(2100410,Rem) ->
	#mon{id = 2100410,name = "赛博先锋",color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 315,att = 24537,hp_lim = 16445317,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1131,is_hit_ac = 1,rem_flag = Rem};
get(2100506,Rem) ->
	#mon{id = 2100506,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 345,att = 31852,hp_lim = 21348026,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1256,is_hit_ac = 1,rem_flag = Rem};
get(2100602,Rem) ->
	#mon{id = 2100602,name = "音乐丧民",color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 375,att = 41560,hp_lim = 27854491,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1391,is_hit_ac = 1,rem_flag = Rem};
get(2100608,Rem) ->
	#mon{id = 2100608,name = "赛博暴民",color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 405,att = 52184,hp_lim = 34974520,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1517,is_hit_ac = 1,rem_flag = Rem};
get(2100704,Rem) ->
	#mon{id = 2100704,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 435,att = 65839,hp_lim = 44126327,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1670,is_hit_ac = 1,rem_flag = Rem};
get(2100710,Rem) ->
	#mon{id = 2100710,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 465,att = 78623,hp_lim = 52694586,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1833,is_hit_ac = 1,rem_flag = Rem};
get(2100806,Rem) ->
	#mon{id = 2100806,name = "原始巫妖",color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 495,att = 94548,hp_lim = 63367934,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100902,Rem) ->
	#mon{id = 2100902,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 525,att = 124568,hp_lim = 83487075,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100908,Rem) ->
	#mon{id = 2100908,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 555,att = 173724,hp_lim = 116432652,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101004,Rem) ->
	#mon{id = 2101004,name = "生化守卫",color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 585,att = 230841,hp_lim = 154712586,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101010,Rem) ->
	#mon{id = 2101010,name = "赛博先锋",color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 615,att = 316895,hp_lim = 212387224,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101106,Rem) ->
	#mon{id = 2101106,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 645,att = 426499,hp_lim = 285845245,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101202,Rem) ->
	#mon{id = 2101202,name = "音乐丧民",color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 675,att = 574011,hp_lim = 384710060,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101208,Rem) ->
	#mon{id = 2101208,name = "赛博暴民",color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 705,att = 787995,hp_lim = 528124478,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101304,Rem) ->
	#mon{id = 2101304,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 735,att = 1060537,hp_lim = 710786013,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101310,Rem) ->
	#mon{id = 2101310,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 765,att = 1427344,hp_lim = 956624389,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101406,Rem) ->
	#mon{id = 2101406,name = "原始巫妖",color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 795,att = 1998626,hp_lim = 1339505097,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101502,Rem) ->
	#mon{id = 2101502,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 825,att = 3089836,hp_lim = 2070847646,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101508,Rem) ->
	#mon{id = 2101508,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 855,att = 7836885,hp_lim = 5252381001,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2300006,Rem) ->
	#mon{id = 2300006,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 145,att = 15315,hp_lim = 519750,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300012,Rem) ->
	#mon{id = 2300012,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 190,att = 35378,hp_lim = 1091475,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300018,Rem) ->
	#mon{id = 2300018,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 250,att = 79389,hp_lim = 2694204,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300024,Rem) ->
	#mon{id = 2300024,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 310,att = 180050,hp_lim = 5657656,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300030,Rem) ->
	#mon{id = 2300030,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 370,att = 265815,hp_lim = 9020847,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300036,Rem) ->
	#mon{id = 2300036,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 430,att = 425248,hp_lim = 14431436,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300042,Rem) ->
	#mon{id = 2300042,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 490,att = 743638,hp_lim = 22942237,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300048,Rem) ->
	#mon{id = 2300048,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 550,att = 2148179,hp_lim = 52072585,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(3000002,Rem) ->
	#mon{id = 3000002,name = "虚空守护",boss = 6,color = 1,module = 610,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10010102,Rem) ->
	#mon{id = 10010102,name = "叛变研究员",boss = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202032,lv = 12,att = 22,hp_lim = 1623,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 2,is_hit_ac = 1,rem_flag = Rem};
get(10010204,Rem) ->
	#mon{id = 10010204,name = "蛇骨之樱",kind = 2,color = 1,icon = 10010099,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 3,att = 13,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,collect_count = 9999,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10020002,Rem) ->
	#mon{id = 10020002,name = "兄弟会首领",boss = 7,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 40,att = 600,hp_lim = 9396,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 5,is_hit_ac = 1,rem_flag = Rem};
get(10020104,Rem) ->
	#mon{id = 10020104,name = "铁锈蘑菇",boss = 1,color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202035,lv = 35,att = 45,hp_lim = 3339,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 7,is_hit_ac = 1,rem_flag = Rem};
get(10040102,Rem) ->
	#mon{id = 10040102,name = "赛博爬虫",boss = 1,color = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 60,att = 70,hp_lim = 10935,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 9,is_hit_ac = 1,rem_flag = Rem};
get(10050002,Rem) ->
	#mon{id = 10050002,name = "失落之鲸",boss = 7,color = 1,icon = 10010010,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 92,att = 1200,hp_lim = 70800,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 13,is_hit_ac = 1,rem_flag = Rem};
get(10050104,Rem) ->
	#mon{id = 10050104,name = "罪恶之花",boss = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 91,att = 100,hp_lim = 29008,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10070102,Rem) ->
	#mon{id = 10070102,name = "后台保镖",boss = 1,type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 118,att = 100,hp_lim = 184000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 17,is_hit_ac = 1,rem_flag = Rem};
get(10070108,Rem) ->
	#mon{id = 10070108,name = "傀儡裁缝",boss = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 140,att = 100,hp_lim = 192000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 20,is_hit_ac = 1,rem_flag = Rem};
get(10080104,Rem) ->
	#mon{id = 10080104,name = "可疑黑影",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 165,att = 100,hp_lim = 512000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 24,is_hit_ac = 1,rem_flag = Rem};
get(10080110,Rem) ->
	#mon{id = 10080110,name = "自爆甲虫",boss = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 210,att = 100,hp_lim = 992000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 28,is_hit_ac = 1,rem_flag = Rem};
get(10090106,Rem) ->
	#mon{id = 10090106,name = "兄弟会前锋",boss = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 275,att = 100,hp_lim = 2552725,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 34,is_hit_ac = 1,rem_flag = Rem};
get(10090202,Rem) ->
	#mon{id = 10090202,name = "秘藏开关",kind = 2,color = 1,icon = 10040201,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10100102,Rem) ->
	#mon{id = 10100102,name = "沙海毒蚁",boss = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 305,att = 100,hp_lim = 3340825,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 43,is_hit_ac = 1,rem_flag = Rem};
get(10110104,Rem) ->
	#mon{id = 10110104,name = "智能警卫",boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 405,att = 100,hp_lim = 7994175,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 75,is_hit_ac = 1,rem_flag = Rem};
get(10120106,Rem) ->
	#mon{id = 10120106,name = "浑浊石柱",boss = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 455,att = 100,hp_lim = 11378075,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 113,is_hit_ac = 1,rem_flag = Rem};
get(10130102,Rem) ->
	#mon{id = 10130102,name = "基地疯医",boss = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 470,att = 100,hp_lim = 12382675,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 127,is_hit_ac = 1,rem_flag = Rem};
get(10140104,Rem) ->
	#mon{id = 10140104,name = "黑市暗卫",boss = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202009,lv = 520,att = 100,hp_lim = 18277675,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 177,rem_flag = Rem};
get(10150106,Rem) ->
	#mon{id = 10150106,name = "狂暴使徒",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202009,lv = 615,att = 100,hp_lim = 48545650,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 272,rem_flag = Rem};
get(10150202,Rem) ->
	#mon{id = 10150202,name = "沉睡胶囊",kind = 2,color = 1,icon = 10010203,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(11001002,Rem) ->
	#mon{id = 11001002,name = "声控械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 122,att = 2544,hp_lim = 226800,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001008,Rem) ->
	#mon{id = 11001008,name = "进击蛇女",type = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 134,att = 3674,hp_lim = 327600,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001014,Rem) ->
	#mon{id = 11001014,name = "绝地探索者",type = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 146,att = 5182,hp_lim = 462000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001020,Rem) ->
	#mon{id = 11001020,name = "人造章鱼",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 158,att = 7478,hp_lim = 666750,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001026,Rem) ->
	#mon{id = 11001026,name = "无畏暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 10741,hp_lim = 957600,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002004,Rem) ->
	#mon{id = 11002004,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 186,att = 15334,hp_lim = 1367100,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002010,Rem) ->
	#mon{id = 11002010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 198,att = 20823,hp_lim = 1856400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002016,Rem) ->
	#mon{id = 11002016,name = "音波蜘蛛",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 210,att = 27018,hp_lim = 2408700,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002022,Rem) ->
	#mon{id = 11002022,name = "地底怪物",type = 1,color = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 222,att = 31485,hp_lim = 2806965,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002028,Rem) ->
	#mon{id = 11002028,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 234,att = 35232,hp_lim = 3141016,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003006,Rem) ->
	#mon{id = 11003006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 250,att = 67854,hp_lim = 12572954,hit = 1796,dodge = 1197,ten = 957,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003012,Rem) ->
	#mon{id = 11003012,name = "隐秘人马",boss = 6,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 262,att = 81123,hp_lim = 15031793,hit = 2147,dodge = 1431,ten = 1145,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003018,Rem) ->
	#mon{id = 11003018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 274,att = 83770,hp_lim = 15522108,hit = 2217,dodge = 1478,ten = 1182,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003024,Rem) ->
	#mon{id = 11003024,name = "神盾战士",boss = 6,type = 1,color = 1,icon = 10030002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 286,att = 97181,hp_lim = 18007174,hit = 2572,dodge = 1714,ten = 1371,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003030,Rem) ->
	#mon{id = 11003030,name = "沙漠皇帝",boss = 6,type = 1,color = 1,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 298,att = 111134,hp_lim = 20592631,hit = 2941,dodge = 1961,ten = 1568,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004002,Rem) ->
	#mon{id = 11004002,name = "声控械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 302,att = 74742,hp_lim = 6663360,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004008,Rem) ->
	#mon{id = 11004008,name = "进击蛇女",type = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 314,att = 85528,hp_lim = 7624941,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004014,Rem) ->
	#mon{id = 11004014,name = "绝地探索者",type = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 326,att = 95548,hp_lim = 8518247,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004020,Rem) ->
	#mon{id = 11004020,name = "人造章鱼",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 338,att = 104330,hp_lim = 9301186,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004026,Rem) ->
	#mon{id = 11004026,name = "无畏暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 350,att = 116577,hp_lim = 10392966,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005004,Rem) ->
	#mon{id = 11005004,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 366,att = 139127,hp_lim = 12403326,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005010,Rem) ->
	#mon{id = 11005010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 378,att = 168252,hp_lim = 14999893,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005016,Rem) ->
	#mon{id = 11005016,name = "音波蜘蛛",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 390,att = 208311,hp_lim = 18571210,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005022,Rem) ->
	#mon{id = 11005022,name = "地底怪物",type = 1,color = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 404,att = 251069,hp_lim = 22383074,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005028,Rem) ->
	#mon{id = 11005028,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 428,att = 322348,hp_lim = 28737645,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006006,Rem) ->
	#mon{id = 11006006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 460,att = 705017,hp_lim = 130635510,hit = 18662,dodge = 12441,ten = 9953,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006012,Rem) ->
	#mon{id = 11006012,name = "隐秘人马",boss = 6,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 484,att = 864882,hp_lim = 160257721,hit = 22893,dodge = 15262,ten = 12210,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006018,Rem) ->
	#mon{id = 11006018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 508,att = 1096337,hp_lim = 203144836,hit = 29020,dodge = 19347,ten = 15477,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006024,Rem) ->
	#mon{id = 11006024,name = "神盾战士",boss = 6,type = 1,color = 1,icon = 10030002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 532,att = 1513285,hp_lim = 280402970,hit = 40057,dodge = 26705,ten = 21364,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006030,Rem) ->
	#mon{id = 11006030,name = "沙漠皇帝",boss = 6,type = 1,color = 1,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 556,att = 2054759,hp_lim = 380734772,hit = 54390,dodge = 36260,ten = 29008,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007002,Rem) ->
	#mon{id = 11007002,name = "声控械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 564,att = 1422398,hp_lim = 126808185,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007008,Rem) ->
	#mon{id = 11007008,name = "进击蛇女",type = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 588,att = 1905409,hp_lim = 169869034,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007014,Rem) ->
	#mon{id = 11007014,name = "绝地探索者",type = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 612,att = 2540361,hp_lim = 226475635,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007020,Rem) ->
	#mon{id = 11007020,name = "人造章鱼",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 636,att = 3425987,hp_lim = 305430041,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007026,Rem) ->
	#mon{id = 11007026,name = "无畏暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 660,att = 4574084,hp_lim = 407783928,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008004,Rem) ->
	#mon{id = 11008004,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 692,att = 6651547,hp_lim = 592991736,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008010,Rem) ->
	#mon{id = 11008010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 716,att = 8789519,hp_lim = 783593937,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008016,Rem) ->
	#mon{id = 11008016,name = "音波蜘蛛",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 740,att = 11827792,hp_lim = 1054458830,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008022,Rem) ->
	#mon{id = 11008022,name = "地底怪物",type = 1,color = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 764,att = 15580862,hp_lim = 1389048608,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008028,Rem) ->
	#mon{id = 11008028,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 788,att = 20798063,hp_lim = 1854166979,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12020012,Rem) ->
	#mon{id = 12020012,name = "起源之母",boss = 6,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 7800,hp_lim = 1360800,hit = 270,dodge = 180,ten = 144,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12030014,Rem) ->
	#mon{id = 12030014,name = "人马合成姬",boss = 6,color = 1,module = 610,icon = 100100092,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 250,att = 88951,hp_lim = 15518617,hit = 3079,dodge = 2052,ten = 1642,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12050012,Rem) ->
	#mon{id = 12050012,name = "蓝液猿神",boss = 6,color = 1,module = 610,icon = 100200071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 425,att = 297789,hp_lim = 51952849,hit = 10308,dodge = 6872,ten = 5497,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12060014,Rem) ->
	#mon{id = 12060014,name = "血腥狂蝎",boss = 6,color = 1,module = 610,icon = 100300062,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 540,att = 1095323,hp_lim = 191091755,hit = 37915,dodge = 25276,ten = 20221,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13010000,Rem) ->
	#mon{id = 13010000,name = "霹雳人马",boss = 3,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 513,hp_lim = 201600,hit = 30,dodge = 20,ten = 16,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13020002,Rem) ->
	#mon{id = 13020002,name = "行者首领",boss = 3,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 8896,hp_lim = 9676800,hit = 480,dodge = 320,ten = 256,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13050002,Rem) ->
	#mon{id = 13050002,name = "邪恶博士",boss = 3,color = 1,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 455,att = 197694,hp_lim = 215045892,hit = 10666,dodge = 7111,ten = 5689,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13060004,Rem) ->
	#mon{id = 13060004,name = "王之行者",boss = 3,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 605,att = 1145949,hp_lim = 1246529448,hit = 61831,dodge = 41221,ten = 32976,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14010002,Rem) ->
	#mon{id = 14010002,name = "机甲环刃",boss = 4,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2558,hp_lim = 17422250,hit = 103,dodge = 69,ten = 55,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14020004,Rem) ->
	#mon{id = 14020004,name = "邪恶博士",boss = 4,type = 1,color = 1,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 10125,hp_lim = 94500000,hit = 562,dodge = 375,ten = 300,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14040002,Rem) ->
	#mon{id = 14040002,name = "光刃利爪",boss = 4,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 232955,hp_lim = 1397733100,hit = 8319,dodge = 5546,ten = 4437,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14050004,Rem) ->
	#mon{id = 14050004,name = "寄生之爪",boss = 4,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 475,att = 821309,hp_lim = 4927856200,hit = 29332,dodge = 19554,ten = 15643,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18010004,Rem) ->
	#mon{id = 18010004,name = "能量光侍",boss = 9,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 7320,hp_lim = 5443200,hit = 270,dodge = 180,ten = 144,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18020006,Rem) ->
	#mon{id = 18020006,name = "兵器少女",boss = 9,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 66856,hp_lim = 49714560,hit = 2466,dodge = 1644,ten = 1315,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18030002,Rem) ->
	#mon{id = 18030002,name = "能量光侍",boss = 9,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 37658,hp_lim = 28003449,hit = 1389,dodge = 926,ten = 740,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18040004,Rem) ->
	#mon{id = 18040004,name = "寄生之爪",boss = 9,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 380,att = 202153,hp_lim = 150322713,hit = 7456,dodge = 4970,ten = 3976,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18050006,Rem) ->
	#mon{id = 18050006,name = "收割死神",boss = 9,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 929115,hp_lim = 690896424,hit = 34270,dodge = 22847,ten = 18277,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18060002,Rem) ->
	#mon{id = 18060002,name = "病毒行者",boss = 9,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 540,att = 571065,hp_lim = 424648344,hit = 21063,dodge = 14042,ten = 11234,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19010006,Rem) ->
	#mon{id = 19010006,name = "异形长枪",boss = 12,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 20130,hp_lim = 49896000,hit = 742,dodge = 495,ten = 396,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19020002,Rem) ->
	#mon{id = 19020002,name = "远古血魔",boss = 12,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 14640,hp_lim = 36288000,hit = 540,dodge = 360,ten = 288,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19030004,Rem) ->
	#mon{id = 19030004,name = "光刃利爪",boss = 12,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 290,att = 168073,hp_lim = 416601360,hit = 6199,dodge = 4132,ten = 3306,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19040006,Rem) ->
	#mon{id = 19040006,name = "超能兵器",boss = 12,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 594924,hp_lim = 1474631970,hit = 21943,dodge = 14629,ten = 11703,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19050002,Rem) ->
	#mon{id = 19050002,name = "疯狂博士",boss = 12,type = 1,color = 1,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 558931,hp_lim = 1385417930,hit = 20616,dodge = 13744,ten = 10995,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19060004,Rem) ->
	#mon{id = 19060004,name = "病毒机甲",boss = 12,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 590,att = 2146096,hp_lim = 5319504330,hit = 79159,dodge = 52772,ten = 42218,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20010002,Rem) ->
	#mon{id = 20010002,name = "光刃利爪",boss = 13,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 4533,hp_lim = 11237940,hit = 167,dodge = 111,ten = 89,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20020004,Rem) ->
	#mon{id = 20020004,name = "寄生触手",boss = 13,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 47580,hp_lim = 117936000,hit = 1755,dodge = 1170,ten = 936,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20030006,Rem) ->
	#mon{id = 20030006,name = "将级异形",boss = 13,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 340,att = 279049,hp_lim = 691676040,hit = 10292,dodge = 6861,ten = 5489,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20040002,Rem) ->
	#mon{id = 20040002,name = "不灭血魔",boss = 13,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 252651,hp_lim = 626243780,hit = 9319,dodge = 6212,ten = 4970,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20050004,Rem) ->
	#mon{id = 20050004,name = "超级机甲",boss = 13,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 490,att = 807778,hp_lim = 2002231670,hit = 29795,dodge = 19863,ten = 15890,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20060006,Rem) ->
	#mon{id = 20060006,name = "病毒人马",boss = 13,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 640,att = 3591316,hp_lim = 8901754990,hit = 132466,dodge = 88311,ten = 70648,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(43001102,Rem) ->
	#mon{id = 43001102,name = "西城守卫者",kind = 11,boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 250,att = 1000,hp_lim = 942000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(60401300,Rem) ->
	#mon{id = 60401300,name = "空间虚灵",boss = 6,type = 1,color = 1,module = 604,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 3200,hp_lim = 604800000,hit = 300,dodge = 200,ten = 160,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60402002,Rem) ->
	#mon{id = 60402002,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60402008,Rem) ->
	#mon{id = 60402008,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403004,Rem) ->
	#mon{id = 60403004,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403010,Rem) ->
	#mon{id = 60403010,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(70010006,Rem) ->
	#mon{id = 70010006,name = "赛博战姬",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 90,att = 877,hp_lim = 114715,hit = 37,dodge = 24,ten = 19,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010012,Rem) ->
	#mon{id = 70010012,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 3060,hp_lim = 793800,hit = 162,dodge = 108,ten = 86,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010018,Rem) ->
	#mon{id = 70010018,name = "战争蜂后",type = 1,color = 1,module = 610,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 5724,hp_lim = 748440,hit = 243,dodge = 162,ten = 129,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010024,Rem) ->
	#mon{id = 70010024,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 115,att = 8160,hp_lim = 2116800,hit = 432,dodge = 288,ten = 230,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010030,Rem) ->
	#mon{id = 70010030,name = "改造战士",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 14310,hp_lim = 1871100,hit = 607,dodge = 405,ten = 324,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010036,Rem) ->
	#mon{id = 70010036,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 16320,hp_lim = 4233600,hit = 864,dodge = 576,ten = 460,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010042,Rem) ->
	#mon{id = 70010042,name = "变异行者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 27189,hp_lim = 3555090,hit = 1154,dodge = 769,ten = 615,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010048,Rem) ->
	#mon{id = 70010048,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 145,att = 26520,hp_lim = 6879600,hit = 1404,dodge = 936,ten = 748,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010054,Rem) ->
	#mon{id = 70010054,name = "赛博战姬",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 150,att = 42930,hp_lim = 5613300,hit = 1822,dodge = 1215,ten = 972,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010060,Rem) ->
	#mon{id = 70010060,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 160,att = 38760,hp_lim = 10054800,hit = 2052,dodge = 1368,ten = 1094,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010066,Rem) ->
	#mon{id = 70010066,name = "战争蜂后",type = 1,color = 1,module = 610,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 165,att = 60102,hp_lim = 7858620,hit = 2551,dodge = 1701,ten = 1360,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010072,Rem) ->
	#mon{id = 70010072,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 175,att = 55080,hp_lim = 14288400,hit = 2916,dodge = 1944,ten = 1555,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010078,Rem) ->
	#mon{id = 70010078,name = "改造战士",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 180,att = 85860,hp_lim = 11226600,hit = 3645,dodge = 2430,ten = 1944,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010084,Rem) ->
	#mon{id = 70010084,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 190,att = 73440,hp_lim = 19051200,hit = 3888,dodge = 2592,ten = 2073,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010090,Rem) ->
	#mon{id = 70010090,name = "变异行者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 195,att = 114480,hp_lim = 14968800,hit = 4860,dodge = 3240,ten = 2592,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010096,Rem) ->
	#mon{id = 70010096,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 205,att = 97920,hp_lim = 25401600,hit = 5184,dodge = 3456,ten = 2764,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010102,Rem) ->
	#mon{id = 70010102,name = "赛博战姬",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 210,att = 148824,hp_lim = 19459440,hit = 6318,dodge = 4212,ten = 3369,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010108,Rem) ->
	#mon{id = 70010108,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 220,att = 122400,hp_lim = 31752000,hit = 6480,dodge = 4320,ten = 3456,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010114,Rem) ->
	#mon{id = 70010114,name = "战争蜂后",type = 1,color = 1,module = 610,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 225,att = 194616,hp_lim = 25446960,hit = 8262,dodge = 5508,ten = 4406,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010120,Rem) ->
	#mon{id = 70010120,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 235,att = 171360,hp_lim = 44452800,hit = 9072,dodge = 6048,ten = 4838,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010126,Rem) ->
	#mon{id = 70010126,name = "改造战士",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 240,att = 263304,hp_lim = 34428240,hit = 11178,dodge = 7452,ten = 5961,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010132,Rem) ->
	#mon{id = 70010132,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 250,att = 220320,hp_lim = 57153600,hit = 11664,dodge = 7776,ten = 6220,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010138,Rem) ->
	#mon{id = 70010138,name = "变异行者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 255,att = 331992,hp_lim = 43409520,hit = 14094,dodge = 9396,ten = 7516,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010144,Rem) ->
	#mon{id = 70010144,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 265,att = 269280,hp_lim = 69854400,hit = 14256,dodge = 9504,ten = 7603,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010150,Rem) ->
	#mon{id = 70010150,name = "赛博战姬",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 270,att = 400680,hp_lim = 52390800,hit = 17010,dodge = 11340,ten = 9072,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010156,Rem) ->
	#mon{id = 70010156,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 326400,hp_lim = 84672000,hit = 17280,dodge = 11520,ten = 9216,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010162,Rem) ->
	#mon{id = 70010162,name = "战争蜂后",type = 1,color = 1,module = 610,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 285,att = 486540,hp_lim = 63617400,hit = 20655,dodge = 13770,ten = 11016,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010168,Rem) ->
	#mon{id = 70010168,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 295,att = 387600,hp_lim = 100548000,hit = 20520,dodge = 13680,ten = 10944,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010174,Rem) ->
	#mon{id = 70010174,name = "改造战士",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 300,att = 572400,hp_lim = 74844000,hit = 24300,dodge = 16200,ten = 12960,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010180,Rem) ->
	#mon{id = 70010180,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 448800,hp_lim = 116424000,hit = 23760,dodge = 15840,ten = 12672,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010186,Rem) ->
	#mon{id = 70010186,name = "变异行者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 315,att = 658260,hp_lim = 86070600,hit = 27945,dodge = 18630,ten = 14904,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010192,Rem) ->
	#mon{id = 70010192,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 550800,hp_lim = 142884000,hit = 29160,dodge = 19440,ten = 15552,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010198,Rem) ->
	#mon{id = 70010198,name = "变异行者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 330,att = 829980,hp_lim = 108523800,hit = 35235,dodge = 23490,ten = 18792,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010204,Rem) ->
	#mon{id = 70010204,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 340,att = 673200,hp_lim = 174636000,hit = 35640,dodge = 23760,ten = 19008,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010210,Rem) ->
	#mon{id = 70010210,name = "赛博战姬",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 345,att = 1001700,hp_lim = 130977000,hit = 42525,dodge = 28350,ten = 22680,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010216,Rem) ->
	#mon{id = 70010216,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 355,att = 795600,hp_lim = 206388000,hit = 42120,dodge = 28080,ten = 22464,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010222,Rem) ->
	#mon{id = 70010222,name = "战争蜂后",type = 1,color = 1,module = 610,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 360,att = 1173420,hp_lim = 153430200,hit = 49815,dodge = 33210,ten = 26568,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010228,Rem) ->
	#mon{id = 70010228,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 370,att = 918000,hp_lim = 238140000,hit = 48600,dodge = 32400,ten = 25920,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010234,Rem) ->
	#mon{id = 70010234,name = "改造战士",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 375,att = 1345140,hp_lim = 175883400,hit = 57105,dodge = 38070,ten = 30456,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010240,Rem) ->
	#mon{id = 70010240,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 385,att = 1040400,hp_lim = 269892000,hit = 55080,dodge = 36720,ten = 29376,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010246,Rem) ->
	#mon{id = 70010246,name = "变异行者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 390,att = 1516860,hp_lim = 198336600,hit = 64395,dodge = 42930,ten = 34344,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010252,Rem) ->
	#mon{id = 70010252,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 400,att = 1224000,hp_lim = 317520000,hit = 64800,dodge = 43200,ten = 34560,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010258,Rem) ->
	#mon{id = 70010258,name = "赛博战姬",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 405,att = 1860300,hp_lim = 243243000,hit = 78975,dodge = 52650,ten = 42120,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010264,Rem) ->
	#mon{id = 70010264,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 415,att = 1530000,hp_lim = 396900000,hit = 81000,dodge = 54000,ten = 43200,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010270,Rem) ->
	#mon{id = 70010270,name = "战争蜂后",type = 1,color = 1,module = 610,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 2289600,hp_lim = 299376000,hit = 97200,dodge = 64800,ten = 51840,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010276,Rem) ->
	#mon{id = 70010276,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 1836000,hp_lim = 476280000,hit = 97200,dodge = 64800,ten = 51840,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010282,Rem) ->
	#mon{id = 70010282,name = "改造战士",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 435,att = 2718900,hp_lim = 355509000,hit = 115425,dodge = 76950,ten = 61560,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010288,Rem) ->
	#mon{id = 70010288,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 445,att = 2448000,hp_lim = 635040000,hit = 129600,dodge = 86400,ten = 69120,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010294,Rem) ->
	#mon{id = 70010294,name = "变异行者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 450,att = 4006800,hp_lim = 523908000,hit = 170100,dodge = 113400,ten = 90720,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010300,Rem) ->
	#mon{id = 70010300,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 460,att = 3672000,hp_lim = 952560000,hit = 194400,dodge = 129600,ten = 103680,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010504,Rem) ->
	#mon{id = 70010504,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100051,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 132,att = 30600,hp_lim = 3969000,hit = 810,dodge = 540,ten = 432,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010510,Rem) ->
	#mon{id = 70010510,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 100200021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 112200,hp_lim = 14553000,hit = 2970,dodge = 1980,ten = 1584,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010516,Rem) ->
	#mon{id = 70010516,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 100100012,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 244800,hp_lim = 31752000,hit = 6480,dodge = 4320,ten = 3456,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010522,Rem) ->
	#mon{id = 70010522,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 100100072,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 295,att = 448800,hp_lim = 58212000,hit = 11880,dodge = 7920,ten = 6336,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010528,Rem) ->
	#mon{id = 70010528,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100051,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 365,att = 775200,hp_lim = 100548000,hit = 20520,dodge = 13680,ten = 10944,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010534,Rem) ->
	#mon{id = 70010534,name = "机械大触",boss = 6,type = 1,color = 1,module = 610,icon = 100200021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 455,att = 1264800,hp_lim = 164052000,hit = 33480,dodge = 22320,ten = 17856,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010540,Rem) ->
	#mon{id = 70010540,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 100100012,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 545,att = 1836000,hp_lim = 238140000,hit = 48600,dodge = 32400,ten = 25920,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010546,Rem) ->
	#mon{id = 70010546,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 100100072,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 635,att = 2550000,hp_lim = 330750000,hit = 67500,dodge = 45000,ten = 36000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80010002,Rem) ->
	#mon{id = 80010002,name = "变异合成人",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80010008,Rem) ->
	#mon{id = 80010008,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80020004,Rem) ->
	#mon{id = 80020004,name = "蛇行者",boss = 6,type = 1,color = 3,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80040002,Rem) ->
	#mon{id = 80040002,name = "辐射章鱼",type = 1,color = 1,module = 610,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80040008,Rem) ->
	#mon{id = 80040008,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80050004,Rem) ->
	#mon{id = 80050004,name = "核心机甲",boss = 6,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80070002,Rem) ->
	#mon{id = 80070002,name = "武装蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80070008,Rem) ->
	#mon{id = 80070008,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80080004,Rem) ->
	#mon{id = 80080004,name = "原始巫妖",boss = 6,type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80100002,Rem) ->
	#mon{id = 80100002,name = "机械黄蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80100008,Rem) ->
	#mon{id = 80100008,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80110004,Rem) ->
	#mon{id = 80110004,name = "森林贤王",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80130002,Rem) ->
	#mon{id = 80130002,name = "核心守护者",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80130008,Rem) ->
	#mon{id = 80130008,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80140004,Rem) ->
	#mon{id = 80140004,name = "合金仓鼠",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80160002,Rem) ->
	#mon{id = 80160002,name = "返祖变异人",type = 1,color = 1,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80160008,Rem) ->
	#mon{id = 80160008,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80170004,Rem) ->
	#mon{id = 80170004,name = "兽血改造者",boss = 6,type = 1,color = 3,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80190002,Rem) ->
	#mon{id = 80190002,name = "穿山蜥",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80190008,Rem) ->
	#mon{id = 80190008,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80200004,Rem) ->
	#mon{id = 80200004,name = "球形海怪",boss = 6,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80220002,Rem) ->
	#mon{id = 80220002,name = "土行从者",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80220008,Rem) ->
	#mon{id = 80220008,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80230004,Rem) ->
	#mon{id = 80230004,name = "深渊巨网",boss = 6,type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80250002,Rem) ->
	#mon{id = 80250002,name = "变异合成人",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80250008,Rem) ->
	#mon{id = 80250008,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80260004,Rem) ->
	#mon{id = 80260004,name = "蛇行者",boss = 6,type = 1,color = 3,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80280002,Rem) ->
	#mon{id = 80280002,name = "辐射章鱼",type = 1,color = 1,module = 610,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80280008,Rem) ->
	#mon{id = 80280008,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010004,Rem) ->
	#mon{id = 81010004,name = "初级箱子",kind = 1,color = 3,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 109,hp_lim = 5911,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81010202,Rem) ->
	#mon{id = 81010202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 203,att = 30333,hp_lim = 1638000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010502,Rem) ->
	#mon{id = 81010502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 212,att = 77500,hp_lim = 3906000,hit = 1395,dodge = 930,ten = 744,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010802,Rem) ->
	#mon{id = 81010802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 221,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011102,Rem) ->
	#mon{id = 81011102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 230,att = 47950,hp_lim = 2589300,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011402,Rem) ->
	#mon{id = 81011402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 239,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020102,Rem) ->
	#mon{id = 81020102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 240,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020402,Rem) ->
	#mon{id = 81020402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 255,att = 72964,hp_lim = 3940057,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020702,Rem) ->
	#mon{id = 81020702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 270,att = 86233,hp_lim = 4656632,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021002,Rem) ->
	#mon{id = 81021002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 285,att = 214371,hp_lim = 10804302,hit = 3858,dodge = 2572,ten = 2057,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021302,Rem) ->
	#mon{id = 81021302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 300,att = 121801,hp_lim = 6577281,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021602,Rem) ->
	#mon{id = 81021602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 315,att = 137044,hp_lim = 7400391,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021902,Rem) ->
	#mon{id = 81021902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 161070,hp_lim = 8697830,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022202,Rem) ->
	#mon{id = 81022202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 345,att = 177900,hp_lim = 9606611,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022502,Rem) ->
	#mon{id = 81022502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 360,att = 437964,hp_lim = 22073398,hit = 7883,dodge = 5255,ten = 4204,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030002,Rem) ->
	#mon{id = 81030002,name = "中路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 360,att = 204383,hp_lim = 225148660,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81030302,Rem) ->
	#mon{id = 81030302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 366,att = 240555,hp_lim = 12990019,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030602,Rem) ->
	#mon{id = 81030602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 375,att = 271581,hp_lim = 14665388,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030902,Rem) ->
	#mon{id = 81030902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 384,att = 316654,hp_lim = 17099317,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031202,Rem) ->
	#mon{id = 81031202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 393,att = 365964,hp_lim = 19762076,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031502,Rem) ->
	#mon{id = 81031502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 402,att = 624545,hp_lim = 31477068,hit = 11241,dodge = 7494,ten = 5995,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031802,Rem) ->
	#mon{id = 81031802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 411,att = 461859,hp_lim = 24940401,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032102,Rem) ->
	#mon{id = 81032102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 420,att = 523533,hp_lim = 28270803,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032402,Rem) ->
	#mon{id = 81032402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 429,att = 590142,hp_lim = 31867686,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032702,Rem) ->
	#mon{id = 81032702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 438,att = 661894,hp_lim = 35742322,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033002,Rem) ->
	#mon{id = 81033002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 447,att = 837877,hp_lim = 42229030,hit = 15081,dodge = 10054,ten = 8043,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033302,Rem) ->
	#mon{id = 81033302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 456,att = 821355,hp_lim = 44353215,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033602,Rem) ->
	#mon{id = 81033602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 465,att = 908981,hp_lim = 49085006,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033902,Rem) ->
	#mon{id = 81033902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 474,att = 1002035,hp_lim = 54109912,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034202,Rem) ->
	#mon{id = 81034202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 483,att = 1100671,hp_lim = 59436242,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034502,Rem) ->
	#mon{id = 81034502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 492,att = 1103522,hp_lim = 55617546,hit = 19863,dodge = 13242,ten = 10593,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034802,Rem) ->
	#mon{id = 81034802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 501,att = 1347769,hp_lim = 72779567,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040004,Rem) ->
	#mon{id = 81040004,name = "初级箱子",kind = 1,color = 3,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 273,hp_lim = 14778,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81040202,Rem) ->
	#mon{id = 81040202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 504,att = 1448714,hp_lim = 78230563,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040502,Rem) ->
	#mon{id = 81040502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 516,att = 1366286,hp_lim = 68860852,hit = 24593,dodge = 16395,ten = 13116,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040802,Rem) ->
	#mon{id = 81040802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 528,att = 1981071,hp_lim = 106977871,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041102,Rem) ->
	#mon{id = 81041102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 540,att = 2310008,hp_lim = 124740451,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041402,Rem) ->
	#mon{id = 81041402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 552,att = 2722336,hp_lim = 147006154,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041702,Rem) ->
	#mon{id = 81041702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 564,att = 3180789,hp_lim = 171762614,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042002,Rem) ->
	#mon{id = 81042002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 576,att = 2552330,hp_lim = 128637461,hit = 45941,dodge = 30627,ten = 24502,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042302,Rem) ->
	#mon{id = 81042302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 588,att = 4265518,hp_lim = 230338016,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042602,Rem) ->
	#mon{id = 81042602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 600,att = 4939619,hp_lim = 266739468,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042902,Rem) ->
	#mon{id = 81042902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 612,att = 5715919,hp_lim = 308659632,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043202,Rem) ->
	#mon{id = 81043202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 622,att = 6479876,hp_lim = 349913351,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043502,Rem) ->
	#mon{id = 81043502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 631,att = 4443669,hp_lim = 223960938,hit = 79986,dodge = 53324,ten = 42659,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043802,Rem) ->
	#mon{id = 81043802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 640,att = 8311052,hp_lim = 448796814,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044102,Rem) ->
	#mon{id = 81044102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 649,att = 9219195,hp_lim = 497836534,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044402,Rem) ->
	#mon{id = 81044402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 658,att = 10424996,hp_lim = 562949791,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044702,Rem) ->
	#mon{id = 81044702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 667,att = 11550910,hp_lim = 623749171,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045002,Rem) ->
	#mon{id = 81045002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 676,att = 7007219,hp_lim = 353163837,hit = 126129,dodge = 84086,ten = 67269,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045302,Rem) ->
	#mon{id = 81045302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 685,att = 14730364,hp_lim = 795439685,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045602,Rem) ->
	#mon{id = 81045602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 694,att = 16296339,hp_lim = 880002357,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045902,Rem) ->
	#mon{id = 81045902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 703,att = 18380802,hp_lim = 992563351,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050102,Rem) ->
	#mon{id = 81050102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 700,att = 18123245,hp_lim = 978655249,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050402,Rem) ->
	#mon{id = 81050402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 709,att = 20421622,hp_lim = 1102767638,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050702,Rem) ->
	#mon{id = 81050702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 718,att = 22551086,hp_lim = 1217758693,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051002,Rem) ->
	#mon{id = 81051002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 727,att = 11726007,hp_lim = 590990765,hit = 211068,dodge = 140712,ten = 112569,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051302,Rem) ->
	#mon{id = 81051302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 736,att = 28577151,hp_lim = 1543166186,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051602,Rem) ->
	#mon{id = 81051602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 745,att = 30303328,hp_lim = 1636379729,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051902,Rem) ->
	#mon{id = 81051902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 754,att = 32443795,hp_lim = 1751964951,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052202,Rem) ->
	#mon{id = 81052202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 763,att = 34379983,hp_lim = 1856519101,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052502,Rem) ->
	#mon{id = 81052502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 772,att = 15485874,hp_lim = 780488095,hit = 278745,dodge = 185830,ten = 148664,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052802,Rem) ->
	#mon{id = 81052802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 781,att = 38954513,hp_lim = 2103543714,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053102,Rem) ->
	#mon{id = 81053102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 790,att = 42069454,hp_lim = 2271750536,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053402,Rem) ->
	#mon{id = 81053402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 799,att = 45420226,hp_lim = 2452692237,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053702,Rem) ->
	#mon{id = 81053702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 808,att = 49024057,hp_lim = 2647299104,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054002,Rem) ->
	#mon{id = 81054002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 817,att = 20461346,hp_lim = 1031251867,hit = 368304,dodge = 245536,ten = 196428,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054302,Rem) ->
	#mon{id = 81054302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 826,att = 58213053,hp_lim = 3143504879,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054602,Rem) ->
	#mon{id = 81054602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 835,att = 64684522,hp_lim = 3492964218,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054902,Rem) ->
	#mon{id = 81054902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 844,att = 74775330,hp_lim = 4037867826,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055202,Rem) ->
	#mon{id = 81055202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 853,att = 91736109,hp_lim = 4953749938,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055502,Rem) ->
	#mon{id = 81055502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 862,att = 45356978,hp_lim = 2285991712,hit = 816425,dodge = 544283,ten = 435426,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055802,Rem) ->
	#mon{id = 81055802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 871,att = 258256130,hp_lim = 13945831069,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000004,Rem) ->
	#mon{id = 82000004,name = "明日战姬",boss = 6,color = 1,module = 610,auto = 3,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000010,Rem) ->
	#mon{id = 82000010,name = "修女机械体",boss = 6,color = 1,module = 610,auto = 3,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000016,Rem) ->
	#mon{id = 82000016,name = "神盾卫士",boss = 6,color = 1,module = 610,auto = 3,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000002,Rem) ->
	#mon{id = 84000002,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 380,att = 350454,hp_lim = 9395167,hit = 5592,dodge = 3728,ten = 2982,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000008,Rem) ->
	#mon{id = 84000008,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 385,att = 241777,hp_lim = 7491128,hit = 8918,dodge = 5945,ten = 4756,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000014,Rem) ->
	#mon{id = 84000014,name = "辰星",boss = 6,type = 1,color = 1,module = 610,icon = 100300041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 388,att = 492810,hp_lim = 17090115,hit = 10172,dodge = 6781,ten = 5425,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000020,Rem) ->
	#mon{id = 84000020,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 394,att = 661803,hp_lim = 17741954,hit = 10560,dodge = 7040,ten = 5632,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000026,Rem) ->
	#mon{id = 84000026,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 400,att = 645701,hp_lim = 17310285,hit = 10303,dodge = 6869,ten = 5495,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000032,Rem) ->
	#mon{id = 84000032,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 406,att = 732666,hp_lim = 19641688,hit = 11691,dodge = 7794,ten = 6235,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000038,Rem) ->
	#mon{id = 84000038,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 410,att = 729660,hp_lim = 19561099,hit = 11643,dodge = 7762,ten = 6209,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000044,Rem) ->
	#mon{id = 84000044,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 421,att = 851448,hp_lim = 22826054,hit = 13586,dodge = 9057,ten = 7246,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000050,Rem) ->
	#mon{id = 84000050,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 430,att = 904370,hp_lim = 24244814,hit = 14431,dodge = 9620,ten = 7696,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000056,Rem) ->
	#mon{id = 84000056,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 436,att = 1013266,hp_lim = 27164166,hit = 16169,dodge = 10779,ten = 8623,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000062,Rem) ->
	#mon{id = 84000062,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 440,att = 1008445,hp_lim = 27034920,hit = 16092,dodge = 10728,ten = 8582,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000068,Rem) ->
	#mon{id = 84000068,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 451,att = 1158782,hp_lim = 31065234,hit = 18491,dodge = 12327,ten = 9861,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000074,Rem) ->
	#mon{id = 84000074,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 460,att = 1186697,hp_lim = 31813588,hit = 18936,dodge = 12624,ten = 10099,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000080,Rem) ->
	#mon{id = 84000080,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 466,att = 1316160,hp_lim = 35284294,hit = 21002,dodge = 14001,ten = 11201,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000086,Rem) ->
	#mon{id = 84000086,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 470,att = 1309468,hp_lim = 35104887,hit = 20895,dodge = 13930,ten = 11144,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000092,Rem) ->
	#mon{id = 84000092,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 481,att = 1525341,hp_lim = 40892133,hit = 24340,dodge = 16227,ten = 12981,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000098,Rem) ->
	#mon{id = 84000098,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 490,att = 1555967,hp_lim = 41713159,hit = 24829,dodge = 16552,ten = 13242,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000104,Rem) ->
	#mon{id = 84000104,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 496,att = 1710391,hp_lim = 45853035,hit = 27293,dodge = 18195,ten = 14556,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000110,Rem) ->
	#mon{id = 84000110,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 500,att = 1742830,hp_lim = 46722684,hit = 27811,dodge = 18540,ten = 14832,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000116,Rem) ->
	#mon{id = 84000116,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 511,att = 2000777,hp_lim = 53637877,hit = 31927,dodge = 21284,ten = 17027,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000122,Rem) ->
	#mon{id = 84000122,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 520,att = 2174473,hp_lim = 58294383,hit = 34699,dodge = 23132,ten = 18506,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000128,Rem) ->
	#mon{id = 84000128,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 532,att = 2632132,hp_lim = 70563543,hit = 42002,dodge = 28001,ten = 22401,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000134,Rem) ->
	#mon{id = 84000134,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 540,att = 2772009,hp_lim = 74313459,hit = 44234,dodge = 29489,ten = 23591,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000140,Rem) ->
	#mon{id = 84000140,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 552,att = 3369281,hp_lim = 90325431,hit = 53765,dodge = 35843,ten = 28674,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000146,Rem) ->
	#mon{id = 84000146,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 561,att = 3588022,hp_lim = 96189531,hit = 57255,dodge = 38170,ten = 30536,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000152,Rem) ->
	#mon{id = 84000152,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 573,att = 4261538,hp_lim = 114245497,hit = 68003,dodge = 45335,ten = 36268,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000158,Rem) ->
	#mon{id = 84000158,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 581,att = 4493012,hp_lim = 120450975,hit = 71697,dodge = 47798,ten = 38238,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000164,Rem) ->
	#mon{id = 84000164,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 593,att = 5470722,hp_lim = 146661928,hit = 87298,dodge = 58199,ten = 46559,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000170,Rem) ->
	#mon{id = 84000170,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 603,att = 5888167,hp_lim = 157852994,hit = 93960,dodge = 62640,ten = 50112,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000176,Rem) ->
	#mon{id = 84000176,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 621,att = 7445499,hp_lim = 199602748,hit = 118811,dodge = 79207,ten = 63365,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000182,Rem) ->
	#mon{id = 84000182,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 635,att = 8343939,hp_lim = 223688601,hit = 133147,dodge = 88765,ten = 71012,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000188,Rem) ->
	#mon{id = 84000188,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 653,att = 10532693,hp_lim = 282365818,hit = 168074,dodge = 112049,ten = 89639,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000194,Rem) ->
	#mon{id = 84000194,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 667,att = 11812392,hp_lim = 316672655,hit = 188495,dodge = 125663,ten = 100531,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000200,Rem) ->
	#mon{id = 84000200,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 685,att = 15184653,hp_lim = 407077957,hit = 242308,dodge = 161538,ten = 129231,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000206,Rem) ->
	#mon{id = 84000206,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 699,att = 17041419,hp_lim = 456855084,hit = 271937,dodge = 181291,ten = 145033,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000212,Rem) ->
	#mon{id = 84000212,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 717,att = 21444278,hp_lim = 574889157,hit = 342195,dodge = 228130,ten = 182504,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000218,Rem) ->
	#mon{id = 84000218,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 731,att = 24082282,hp_lim = 645610132,hit = 384291,dodge = 256194,ten = 204955,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000224,Rem) ->
	#mon{id = 84000224,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 749,att = 28523721,hp_lim = 764678484,hit = 455165,dodge = 303443,ten = 242755,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000230,Rem) ->
	#mon{id = 84000230,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 763,att = 29916479,hp_lim = 802016253,hit = 477390,dodge = 318260,ten = 254608,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000236,Rem) ->
	#mon{id = 84000236,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 781,att = 34355173,hp_lim = 921011033,hit = 548220,dodge = 365480,ten = 292384,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000242,Rem) ->
	#mon{id = 84000242,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 795,att = 36778535,hp_lim = 985977765,hit = 586891,dodge = 391261,ten = 313008,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000248,Rem) ->
	#mon{id = 84000248,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 813,att = 43459119,hp_lim = 1165074261,hit = 693496,dodge = 462331,ten = 369864,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000254,Rem) ->
	#mon{id = 84000254,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 827,att = 47961115,hp_lim = 1285766080,hit = 765336,dodge = 510224,ten = 408179,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000260,Rem) ->
	#mon{id = 84000260,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 845,att = 63151017,hp_lim = 1692984714,hit = 1007728,dodge = 671819,ten = 537455,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000266,Rem) ->
	#mon{id = 84000266,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 859,att = 88538333,hp_lim = 2373580843,hit = 1412845,dodge = 941897,ten = 753517,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000272,Rem) ->
	#mon{id = 84000272,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 877,att = 384311471,hp_lim = 10302818173,hit = 6132629,dodge = 4088419,ten = 3270735,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(85000004,Rem) ->
	#mon{id = 85000004,name = "宝藏看护者",color = 1,module = 424,auto = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 30000,hp_lim = 30000000,def = 30000,hit = 14222,dodge = 9481,ten = 7585,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,rem_flag = Rem};
get(_MonTypeId, _Rem) -> [].