%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc
%%% 怪物配置数据（3/6）
%%% @end
%%% -------------------------------------------------------
-module(data_mon_3).
-export([
		get/2
	]).
-include("scene.hrl").

%% 获取怪物配置
%% Rem是求余结果，
%%   主要目的是为了拆散编译期生成大的literal字面常量，
%%   减少热更新移除旧模块时literal拷贝引发内存暴涨问题，
%%   此值请勿用于它处，不保证未来取值
-spec get(MonTypeId, Rem) -> #mon{} | [] when
	MonTypeId :: non_neg_integer(), Rem :: any().
get(3,Rem) ->
	#mon{id = 3,name = "木桩怪",color = 1,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 1,hp_lim = 10000000,def = 1000,hit = 1000,dodge = 1000,ten = 1000,skill = [{1110000001,1}],exp = 100,is_fight_back = 0,rem_flag = Rem};
get(9,Rem) ->
	#mon{id = 9,name = "归属掉落2",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(15,Rem) ->
	#mon{id = 15,name = "掉落橙装",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(21,Rem) ->
	#mon{id = 21,name = "掉落50个",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 550,att = 73358,hp_lim = 1125770,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(27,Rem) ->
	#mon{id = 27,name = "固定队伍",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(33,Rem) ->
	#mon{id = 33,name = "冰人皮卡丘",boss = 3,type = 1,color = 3,icon = 1202004,icon_effect = <<"0"/utf8>>,weapon_id = 1202004,lv = 600,att = 3368,hp_lim = 341522692,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,hate_range = 2000,speed = 600,skill = [{1001,1},{16000014,1}],att_time = 1000,drop = 1,del_hp_each_time = [1,2],rem_flag = Rem};
get(111,Rem) ->
	#mon{id = 111,name = "个人独占第一击",type = 1,color = 1,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 111,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 111,rem_flag = Rem};
get(123,Rem) ->
	#mon{id = 123,name = "随机分配无归属",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 123,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 123,rem_flag = Rem};
get(141,Rem) ->
	#mon{id = 141,name = "先到先得第一击",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 141,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 141,rem_flag = Rem};
get(2001,Rem) ->
	#mon{id = 2001,name = "性格宝箱",kind = 1,color = 1,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(9003,Rem) ->
	#mon{id = 9003,name = "琼鲸多足虫",type = 1,color = 1,auto = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 18000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(9009,Rem) ->
	#mon{id = 9009,name = "雄狮沙菇",type = 1,color = 1,auto = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 100,att = 50,hp_lim = 24000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(9015,Rem) ->
	#mon{id = 9015,name = "基地护卫者",type = 1,color = 1,auto = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 30000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10005,Rem) ->
	#mon{id = 10005,name = "机甲老鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 12000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10011,Rem) ->
	#mon{id = 10011,name = "光刃女侍",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 15000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10017,Rem) ->
	#mon{id = 10017,name = "荧光多足虫",type = 1,color = 1,auto = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 18000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10023,Rem) ->
	#mon{id = 10023,name = "雪国入侵者",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 21000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(11001,Rem) ->
	#mon{id = 11001,name = "废土结晶",kind = 1,color = 1,auto = 1,icon = 10020202,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 50,att = 50,hp_lim = 15000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,rem_flag = Rem};
get(350001,Rem) ->
	#mon{id = 350001,name = "转职检察官",boss = 6,color = 1,icon = 10030005,weapon_id = 202002,lv = 130,att = 20833,hp_lim = 1050000,hit = 375,dodge = 250,ten = 200,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(350301,Rem) ->
	#mon{id = 350301,name = "转职检察官",boss = 6,color = 1,icon = 10030005,weapon_id = 202002,lv = 420,att = 1041666,hp_lim = 52500000,hit = 18750,dodge = 12500,ten = 10000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360201,Rem) ->
	#mon{id = 360201,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 100,att = 767,hp_lim = 23263,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360501,Rem) ->
	#mon{id = 360501,name = "次元检察官",boss = 6,color = 1,icon = 10010003,weapon_id = 202002,lv = 100,att = 767,hp_lim = 23263,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360801,Rem) ->
	#mon{id = 360801,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 145,att = 33333,hp_lim = 1680000,hit = 600,dodge = 400,ten = 320,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(400011,Rem) ->
	#mon{id = 400011,name = "独眼卫士",type = 1,color = 1,auto = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 40,att = 822,hp_lim = 44404,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400101,Rem) ->
	#mon{id = 400101,name = "雷电地鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 50,att = 956,hp_lim = 51657,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400299,Rem) ->
	#mon{id = 400299,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 60,att = 1058,hp_lim = 57143,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400311,Rem) ->
	#mon{id = 400311,name = "独眼卫士",type = 1,color = 1,auto = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 70,att = 1112,hp_lim = 60091,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400401,Rem) ->
	#mon{id = 400401,name = "雷电地鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 80,att = 1170,hp_lim = 63189,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400599,Rem) ->
	#mon{id = 400599,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 90,att = 1433,hp_lim = 77406,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400611,Rem) ->
	#mon{id = 400611,name = "独眼卫士",type = 1,color = 1,auto = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 2747,hp_lim = 148339,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(500001,Rem) ->
	#mon{id = 500001,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 60,att = 114,hp_lim = 3875,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500007,Rem) ->
	#mon{id = 500007,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 75,att = 378,hp_lim = 25666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500013,Rem) ->
	#mon{id = 500013,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 103,att = 1016,hp_lim = 68833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500019,Rem) ->
	#mon{id = 500019,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 113,att = 1653,hp_lim = 112000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500025,Rem) ->
	#mon{id = 500025,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 125,att = 3100,hp_lim = 210000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500031,Rem) ->
	#mon{id = 500031,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 137,att = 4908,hp_lim = 332500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500037,Rem) ->
	#mon{id = 500037,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 149,att = 6716,hp_lim = 455000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500043,Rem) ->
	#mon{id = 500043,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 161,att = 8611,hp_lim = 583333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500049,Rem) ->
	#mon{id = 500049,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 173,att = 10643,hp_lim = 721000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500055,Rem) ->
	#mon{id = 500055,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 185,att = 13020,hp_lim = 882000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500061,Rem) ->
	#mon{id = 500061,name = "绿衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 197,att = 14828,hp_lim = 1004500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500067,Rem) ->
	#mon{id = 500067,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 207,att = 16636,hp_lim = 1127000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500073,Rem) ->
	#mon{id = 500073,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 213,att = 18445,hp_lim = 1249500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500079,Rem) ->
	#mon{id = 500079,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 219,att = 20253,hp_lim = 1372000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500085,Rem) ->
	#mon{id = 500085,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 225,att = 22320,hp_lim = 1512000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500091,Rem) ->
	#mon{id = 500091,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 231,att = 24162,hp_lim = 1636833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500097,Rem) ->
	#mon{id = 500097,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 237,att = 26022,hp_lim = 1762833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500103,Rem) ->
	#mon{id = 500103,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 243,att = 27900,hp_lim = 1890000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500109,Rem) ->
	#mon{id = 500109,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 248,att = 29794,hp_lim = 2018333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500115,Rem) ->
	#mon{id = 500115,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 252,att = 31998,hp_lim = 2167666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500121,Rem) ->
	#mon{id = 500121,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 257,att = 33945,hp_lim = 2299500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500127,Rem) ->
	#mon{id = 500127,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 262,att = 35908,hp_lim = 2432500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500133,Rem) ->
	#mon{id = 500133,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 267,att = 37906,hp_lim = 2567833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500139,Rem) ->
	#mon{id = 500139,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 272,att = 39938,hp_lim = 2705500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500145,Rem) ->
	#mon{id = 500145,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 276,att = 42263,hp_lim = 2863000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500151,Rem) ->
	#mon{id = 500151,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 281,att = 44347,hp_lim = 3004166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500157,Rem) ->
	#mon{id = 500157,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 286,att = 46431,hp_lim = 3145333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500163,Rem) ->
	#mon{id = 500163,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 291,att = 48549,hp_lim = 3288833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500169,Rem) ->
	#mon{id = 500169,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 296,att = 50685,hp_lim = 3433500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500175,Rem) ->
	#mon{id = 500175,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 300,att = 53165,hp_lim = 3601500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500181,Rem) ->
	#mon{id = 500181,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 305,att = 55369,hp_lim = 3750833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500187,Rem) ->
	#mon{id = 500187,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 310,att = 57591,hp_lim = 3901333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500193,Rem) ->
	#mon{id = 500193,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 315,att = 59830,hp_lim = 4053000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500199,Rem) ->
	#mon{id = 500199,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 320,att = 62103,hp_lim = 4207000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500205,Rem) ->
	#mon{id = 500205,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 324,att = 64721,hp_lim = 4384333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500211,Rem) ->
	#mon{id = 500211,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 329,att = 67063,hp_lim = 4543000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500217,Rem) ->
	#mon{id = 500217,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 334,att = 69422,hp_lim = 4702833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500223,Rem) ->
	#mon{id = 500223,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 339,att = 71816,hp_lim = 4865000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500229,Rem) ->
	#mon{id = 500229,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 344,att = 74227,hp_lim = 5028333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500235,Rem) ->
	#mon{id = 500235,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 348,att = 77000,hp_lim = 5216166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500241,Rem) ->
	#mon{id = 500241,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 353,att = 79480,hp_lim = 5384166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500247,Rem) ->
	#mon{id = 500247,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 358,att = 81977,hp_lim = 5553333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500253,Rem) ->
	#mon{id = 500253,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 363,att = 84509,hp_lim = 5724833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500259,Rem) ->
	#mon{id = 500259,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 368,att = 87075,hp_lim = 5898666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500265,Rem) ->
	#mon{id = 500265,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 372,att = 90020,hp_lim = 6098166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500271,Rem) ->
	#mon{id = 500271,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 377,att = 92655,hp_lim = 6276666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500277,Rem) ->
	#mon{id = 500277,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 382,att = 95307,hp_lim = 6456333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500283,Rem) ->
	#mon{id = 500283,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 387,att = 97994,hp_lim = 6638333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500289,Rem) ->
	#mon{id = 500289,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 392,att = 100715,hp_lim = 6822666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500295,Rem) ->
	#mon{id = 500295,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 396,att = 103850,hp_lim = 7035000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510003,Rem) ->
	#mon{id = 510003,name = "生化魔人",boss = 6,type = 1,color = 1,auto = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 105,att = 4080,hp_lim = 756000,hit = 108,dodge = 72,ten = 57,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510009,Rem) ->
	#mon{id = 510009,name = "病毒异形",boss = 6,type = 1,color = 1,auto = 1,icon = 100400032,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 165,att = 31110,hp_lim = 5764500,hit = 823,dodge = 549,ten = 439,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510015,Rem) ->
	#mon{id = 510015,name = "病毒暴君",boss = 6,type = 1,color = 1,auto = 1,icon = 100400012,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 215,att = 63240,hp_lim = 11718000,hit = 1674,dodge = 1116,ten = 892,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510021,Rem) ->
	#mon{id = 510021,name = "三头吼兽",boss = 6,type = 1,color = 1,auto = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 244,att = 94463,hp_lim = 17503500,hit = 2500,dodge = 1667,ten = 1333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510027,Rem) ->
	#mon{id = 510027,name = "兵武女刺",boss = 6,type = 1,color = 1,auto = 1,icon = 100100071,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 268,att = 127556,hp_lim = 23635500,hit = 3376,dodge = 2251,ten = 1800,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510033,Rem) ->
	#mon{id = 510033,name = "能源守卫",boss = 6,type = 1,color = 1,auto = 1,icon = 100100061,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 292,att = 162690,hp_lim = 30145500,hit = 4306,dodge = 2871,ten = 2296,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510039,Rem) ->
	#mon{id = 510039,name = "灵魂收割者",boss = 6,type = 1,color = 1,auto = 1,icon = 100100032,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 316,att = 200033,hp_lim = 37065000,hit = 5295,dodge = 3530,ten = 2824,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510045,Rem) ->
	#mon{id = 510045,name = "武装女神",boss = 6,type = 1,color = 1,auto = 1,icon = 100200042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 340,att = 239643,hp_lim = 44404500,hit = 6343,dodge = 4229,ten = 3383,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510051,Rem) ->
	#mon{id = 510051,name = "铁甲战姬",boss = 6,type = 1,color = 1,auto = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 364,att = 281633,hp_lim = 52185000,hit = 7455,dodge = 4970,ten = 3976,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510057,Rem) ->
	#mon{id = 510057,name = "末世利爪",boss = 6,type = 1,color = 1,auto = 1,icon = 100100041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 388,att = 326230,hp_lim = 60448500,hit = 8635,dodge = 5757,ten = 4605,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(650001,Rem) ->
	#mon{id = 650001,name = "时空裂隙",kind = 1,color = 1,icon_effect = <<"effect_other_10010301"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,def = 113014,hit = 23745,dodge = 23745,crit = 15293,ten = 15444,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 1000,collect_time = 10,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,rem_flag = Rem};
get(651105,Rem) ->
	#mon{id = 651105,name = "boss采集怪",kind = 1,type = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 1000,collect_time = 10,collect_count = 1,is_fight_back = 0,rem_flag = Rem};
get(653001,Rem) ->
	#mon{id = 653001,name = "结晶守卫",boss = 6,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 1000,hp_lim = 1200000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(653103,Rem) ->
	#mon{id = 653103,name = "会心宝箱",kind = 1,color = 1,icon = 10010198,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(1001001,Rem) ->
	#mon{id = 1001001,name = "武装暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 42,att = 64,hp_lim = 4246,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001007,Rem) ->
	#mon{id = 1001007,name = "合成丧尸",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 116,att = 194,hp_lim = 12740,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001013,Rem) ->
	#mon{id = 1001013,name = "武装暴民",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 82,att = 1164,hp_lim = 76440,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001019,Rem) ->
	#mon{id = 1001019,name = "机械娜迦",type = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 3235,hp_lim = 212333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1200105,Rem) ->
	#mon{id = 1200105,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 110,att = 5487,hp_lim = 287116,hit = 170,dodge = 113,ten = 91,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200111,Rem) ->
	#mon{id = 1200111,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 125,att = 4851,hp_lim = 238140,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200117,Rem) ->
	#mon{id = 1200117,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 155,att = 15895,hp_lim = 4158000,hit = 495,dodge = 330,ten = 264,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,is_be_clicked = 0,rem_flag = Rem};
get(1200201,Rem) ->
	#mon{id = 1200201,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 116,att = 3984,hp_lim = 195615,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200207,Rem) ->
	#mon{id = 1200207,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 140,att = 5775,hp_lim = 283500,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200213,Rem) ->
	#mon{id = 1200213,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 170,att = 14784,hp_lim = 725760,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200303,Rem) ->
	#mon{id = 1200303,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 150,att = 9317,hp_lim = 457380,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200309,Rem) ->
	#mon{id = 1200309,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 180,att = 14553,hp_lim = 714420,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200315,Rem) ->
	#mon{id = 1200315,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 210,att = 49274,hp_lim = 2577960,hit = 1395,dodge = 930,ten = 744,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200405,Rem) ->
	#mon{id = 1200405,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 190,att = 33379,hp_lim = 1746360,hit = 945,dodge = 630,ten = 504,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200411,Rem) ->
	#mon{id = 1200411,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 220,att = 27720,hp_lim = 1360800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200417,Rem) ->
	#mon{id = 1200417,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 250,att = 82394,hp_lim = 21553635,hit = 2565,dodge = 1710,ten = 1368,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200501,Rem) ->
	#mon{id = 1200501,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 201,att = 20020,hp_lim = 982800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200507,Rem) ->
	#mon{id = 1200507,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 225,att = 27720,hp_lim = 1360800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200513,Rem) ->
	#mon{id = 1200513,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 255,att = 48156,hp_lim = 2364034,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200603,Rem) ->
	#mon{id = 1200603,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 230,att = 31647,hp_lim = 1553580,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200609,Rem) ->
	#mon{id = 1200609,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 260,att = 48156,hp_lim = 2364034,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200615,Rem) ->
	#mon{id = 1200615,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 290,att = 132713,hp_lim = 6943356,hit = 4132,dodge = 2755,ten = 2204,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200705,Rem) ->
	#mon{id = 1200705,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 260,att = 90371,hp_lim = 4728069,hit = 2814,dodge = 1876,ten = 1500,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200711,Rem) ->
	#mon{id = 1200711,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 290,att = 70719,hp_lim = 3471678,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200717,Rem) ->
	#mon{id = 1200717,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 320,att = 179462,hp_lim = 46946012,hit = 5588,dodge = 3725,ten = 2980,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200801,Rem) ->
	#mon{id = 1200801,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 266,att = 52491,hp_lim = 2576878,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200807,Rem) ->
	#mon{id = 1200807,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 290,att = 70719,hp_lim = 3471678,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200813,Rem) ->
	#mon{id = 1200813,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 320,att = 95630,hp_lim = 4694601,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200903,Rem) ->
	#mon{id = 1200903,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 290,att = 70719,hp_lim = 3471678,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200909,Rem) ->
	#mon{id = 1200909,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 320,att = 95630,hp_lim = 4694601,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200915,Rem) ->
	#mon{id = 1200915,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 350,att = 231077,hp_lim = 12089614,hit = 7196,dodge = 4797,ten = 3837,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201005,Rem) ->
	#mon{id = 1201005,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 320,att = 179462,hp_lim = 9389202,hit = 5588,dodge = 3725,ten = 2980,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201011,Rem) ->
	#mon{id = 1201011,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 350,att = 123134,hp_lim = 6044807,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201017,Rem) ->
	#mon{id = 1201017,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 380,att = 299294,hp_lim = 78293073,hit = 9320,dodge = 6213,ten = 4970,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201101,Rem) ->
	#mon{id = 1201101,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 326,att = 100915,hp_lim = 4954054,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201107,Rem) ->
	#mon{id = 1201107,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 350,att = 123134,hp_lim = 6044807,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201113,Rem) ->
	#mon{id = 1201113,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 380,att = 159485,hp_lim = 7829307,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201203,Rem) ->
	#mon{id = 1201203,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 350,att = 123134,hp_lim = 6044807,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201209,Rem) ->
	#mon{id = 1201209,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 380,att = 159485,hp_lim = 7829307,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201215,Rem) ->
	#mon{id = 1201215,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 410,att = 373886,hp_lim = 19561099,hit = 11643,dodge = 7762,ten = 6209,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201305,Rem) ->
	#mon{id = 1201305,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 380,att = 299294,hp_lim = 15658614,hit = 9320,dodge = 6213,ten = 4970,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201311,Rem) ->
	#mon{id = 1201311,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 410,att = 199233,hp_lim = 9780549,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201317,Rem) ->
	#mon{id = 1201317,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 440,att = 469762,hp_lim = 122885998,hit = 14629,dodge = 9752,ten = 7802,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201401,Rem) ->
	#mon{id = 1201401,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 386,att = 165866,hp_lim = 8142532,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201407,Rem) ->
	#mon{id = 1201407,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 410,att = 199233,hp_lim = 9780549,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201413,Rem) ->
	#mon{id = 1201413,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 440,att = 250323,hp_lim = 12288599,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201503,Rem) ->
	#mon{id = 1201503,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 410,att = 199233,hp_lim = 9780549,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201509,Rem) ->
	#mon{id = 1201509,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 440,att = 250323,hp_lim = 12288599,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201515,Rem) ->
	#mon{id = 1201515,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 470,att = 559155,hp_lim = 29254072,hit = 17413,dodge = 11608,ten = 9287,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201605,Rem) ->
	#mon{id = 1201605,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 440,att = 469762,hp_lim = 24577199,hit = 14629,dodge = 9752,ten = 7802,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201611,Rem) ->
	#mon{id = 1201611,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 470,att = 297958,hp_lim = 14627036,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201617,Rem) ->
	#mon{id = 1201617,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 500,att = 686958,hp_lim = 179702636,hit = 21393,dodge = 14262,ten = 11409,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201701,Rem) ->
	#mon{id = 1201701,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 446,att = 258066,hp_lim = 12668709,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201707,Rem) ->
	#mon{id = 1201707,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 470,att = 297958,hp_lim = 14627036,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201713,Rem) ->
	#mon{id = 1201713,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 500,att = 366060,hp_lim = 17970263,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201803,Rem) ->
	#mon{id = 1201803,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 470,att = 297958,hp_lim = 14627036,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201809,Rem) ->
	#mon{id = 1201809,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 500,att = 366060,hp_lim = 17970263,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201815,Rem) ->
	#mon{id = 1201815,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 530,att = 917611,hp_lim = 48007927,hit = 28576,dodge = 19050,ten = 15240,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201905,Rem) ->
	#mon{id = 1201905,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 500,att = 686958,hp_lim = 35940527,hit = 21393,dodge = 14262,ten = 11409,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201911,Rem) ->
	#mon{id = 1201911,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 530,att = 488969,hp_lim = 24003963,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201917,Rem) ->
	#mon{id = 1201917,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 560,att = 1267960,hp_lim = 331688044,hit = 39486,dodge = 26324,ten = 21059,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202001,Rem) ->
	#mon{id = 1202001,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 506,att = 374961,hp_lim = 18407191,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202007,Rem) ->
	#mon{id = 1202007,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 530,att = 488969,hp_lim = 24003963,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202013,Rem) ->
	#mon{id = 1202013,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 560,att = 675660,hp_lim = 33168804,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202103,Rem) ->
	#mon{id = 1202103,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 530,att = 488969,hp_lim = 24003963,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202109,Rem) ->
	#mon{id = 1202109,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 560,att = 675660,hp_lim = 33168804,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202115,Rem) ->
	#mon{id = 1202115,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 590,att = 1694595,hp_lim = 88658405,hit = 52772,dodge = 35181,ten = 28145,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202205,Rem) ->
	#mon{id = 1202205,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 560,att = 1267960,hp_lim = 66337608,hit = 39486,dodge = 26324,ten = 21059,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202211,Rem) ->
	#mon{id = 1202211,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 590,att = 903002,hp_lim = 44329202,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202217,Rem) ->
	#mon{id = 1202217,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 620,att = 2280702,hp_lim = 596612709,hit = 71025,dodge = 47350,ten = 37880,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202301,Rem) ->
	#mon{id = 1202301,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 566,att = 712011,hp_lim = 34953274,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202307,Rem) ->
	#mon{id = 1202307,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 590,att = 903002,hp_lim = 44329202,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202313,Rem) ->
	#mon{id = 1202313,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 620,att = 1215322,hp_lim = 59661270,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202403,Rem) ->
	#mon{id = 1202403,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 590,att = 903002,hp_lim = 44329202,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202409,Rem) ->
	#mon{id = 1202409,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 620,att = 1215322,hp_lim = 59661270,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202415,Rem) ->
	#mon{id = 1202415,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 650,att = 3130915,hp_lim = 163804278,hit = 97502,dodge = 65001,ten = 52001,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(2001201,Rem) ->
	#mon{id = 2001201,name = "武装暴民",type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 85,att = 470,hp_lim = 12740,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2002101,Rem) ->
	#mon{id = 2002101,name = "合成丧尸",type = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 626,hp_lim = 16986,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2002203,Rem) ->
	#mon{id = 2002203,name = "改造暴猿",boss = 6,type = 1,color = 1,icon = 100200071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 4125,hp_lim = 101920,hit = 109,dodge = 72,ten = 58,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2003103,Rem) ->
	#mon{id = 2003103,name = "能源守卫",boss = 6,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 5156,hp_lim = 127400,hit = 136,dodge = 91,ten = 72,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2004201,Rem) ->
	#mon{id = 2004201,name = "海族战士",type = 1,color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 125,att = 4388,hp_lim = 118906,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2005101,Rem) ->
	#mon{id = 2005101,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 4701,hp_lim = 127400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2005203,Rem) ->
	#mon{id = 2005203,name = "兵武女刺",boss = 6,type = 1,color = 1,icon = 100100071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 19595,hp_lim = 484120,hit = 518,dodge = 345,ten = 276,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2006103,Rem) ->
	#mon{id = 2006103,name = "静谧三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 145,att = 19595,hp_lim = 484120,hit = 518,dodge = 345,ten = 276,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2007201,Rem) ->
	#mon{id = 2007201,name = "武装暴民",type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 160,att = 7522,hp_lim = 203840,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2008101,Rem) ->
	#mon{id = 2008101,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 165,att = 7836,hp_lim = 212333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2008203,Rem) ->
	#mon{id = 2008203,name = "能源守卫",boss = 6,type = 1,color = 1,icon = 100100021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 28361,hp_lim = 700700,hit = 750,dodge = 500,ten = 400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2009103,Rem) ->
	#mon{id = 2009103,name = "兵武女刺",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 25783,hp_lim = 637000,hit = 682,dodge = 455,ten = 364,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2010201,Rem) ->
	#mon{id = 2010201,name = "合成丧尸",type = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 185,att = 10186,hp_lim = 276033,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2011101,Rem) ->
	#mon{id = 2011101,name = "海族战士",type = 1,color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 195,att = 9403,hp_lim = 254800,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2011203,Rem) ->
	#mon{id = 2011203,name = "深海祭祀",boss = 6,type = 1,color = 1,icon = 100100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 33518,hp_lim = 828100,hit = 887,dodge = 591,ten = 473,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2012103,Rem) ->
	#mon{id = 2012103,name = "静谧三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 225,att = 41253,hp_lim = 1019200,hit = 1092,dodge = 728,ten = 582,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2013201,Rem) ->
	#mon{id = 2013201,name = "武装暴民",type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 220,att = 13791,hp_lim = 373706,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2014101,Rem) ->
	#mon{id = 2014101,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 20373,hp_lim = 552066,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2014203,Rem) ->
	#mon{id = 2014203,name = "兵武女刺",boss = 6,type = 1,color = 1,icon = 100100071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 265,att = 77350,hp_lim = 1911000,hit = 2047,dodge = 1365,ten = 1092,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2015103,Rem) ->
	#mon{id = 2015103,name = "静谧三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 385,att = 154700,hp_lim = 3822000,hit = 4095,dodge = 2730,ten = 2184,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2100105,Rem) ->
	#mon{id = 2100105,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 1880,hp_lim = 1260000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 787,is_hit_ac = 1,rem_flag = Rem};
get(2100201,Rem) ->
	#mon{id = 2100201,name = "变异柴犬",color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 4010,hp_lim = 2688000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 807,is_hit_ac = 1,rem_flag = Rem};
get(2100207,Rem) ->
	#mon{id = 2100207,name = "武装暴民",color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 5974,hp_lim = 4004000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 839,is_hit_ac = 1,rem_flag = Rem};
get(2100303,Rem) ->
	#mon{id = 2100303,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 230,att = 8585,hp_lim = 5754000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 879,is_hit_ac = 1,rem_flag = Rem};
get(2100309,Rem) ->
	#mon{id = 2100309,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 260,att = 13064,hp_lim = 8755684,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 968,is_hit_ac = 1,rem_flag = Rem};
get(2100405,Rem) ->
	#mon{id = 2100405,name = "兽血改造者",color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 290,att = 19185,hp_lim = 12858069,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1053,is_hit_ac = 1,rem_flag = Rem};
get(2100501,Rem) ->
	#mon{id = 2100501,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 320,att = 25943,hp_lim = 17387412,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1157,is_hit_ac = 1,rem_flag = Rem};
get(2100507,Rem) ->
	#mon{id = 2100507,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 350,att = 33404,hp_lim = 22388177,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1283,is_hit_ac = 1,rem_flag = Rem};
get(2100603,Rem) ->
	#mon{id = 2100603,name = "感染护士",color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 380,att = 43266,hp_lim = 28997437,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1392,is_hit_ac = 1,rem_flag = Rem};
get(2100609,Rem) ->
	#mon{id = 2100609,name = "武装暴民",color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 410,att = 54048,hp_lim = 36224258,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1536,is_hit_ac = 1,rem_flag = Rem};
get(2100705,Rem) ->
	#mon{id = 2100705,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 67908,hp_lim = 45513335,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1691,is_hit_ac = 1,rem_flag = Rem};
get(2100801,Rem) ->
	#mon{id = 2100801,name = "变异柴犬",color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 470,att = 80831,hp_lim = 54174211,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1890,is_hit_ac = 1,rem_flag = Rem};
get(2100807,Rem) ->
	#mon{id = 2100807,name = "武装暴民",color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 500,att = 99306,hp_lim = 66556532,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100903,Rem) ->
	#mon{id = 2100903,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 530,att = 132649,hp_lim = 88903570,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100909,Rem) ->
	#mon{id = 2100909,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 560,att = 183296,hp_lim = 122847424,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101005,Rem) ->
	#mon{id = 2101005,name = "兽血改造者",color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 590,att = 244970,hp_lim = 164182235,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101101,Rem) ->
	#mon{id = 2101101,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 620,att = 329697,hp_lim = 220967670,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101107,Rem) ->
	#mon{id = 2101107,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 650,att = 452604,hp_lim = 303341255,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101203,Rem) ->
	#mon{id = 2101203,name = "感染护士",color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 680,att = 609145,hp_lim = 408257395,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101209,Rem) ->
	#mon{id = 2101209,name = "武装暴民",color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 710,att = 819830,hp_lim = 549460702,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101305,Rem) ->
	#mon{id = 2101305,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 740,att = 1125451,hp_lim = 754291804,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101401,Rem) ->
	#mon{id = 2101401,name = "变异柴犬",color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 770,att = 1514709,hp_lim = 1015177457,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101407,Rem) ->
	#mon{id = 2101407,name = "武装暴民",color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 800,att = 2120958,hp_lim = 1421493521,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101503,Rem) ->
	#mon{id = 2101503,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 830,att = 3411428,hp_lim = 2286383134,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101509,Rem) ->
	#mon{id = 2101509,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 860,att = 10973532,hp_lim = 7354601429,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2300001,Rem) ->
	#mon{id = 2300001,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 120,att = 8005,hp_lim = 271687,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300007,Rem) ->
	#mon{id = 2300007,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 150,att = 19211,hp_lim = 582120,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300013,Rem) ->
	#mon{id = 2300013,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 200,att = 45409,hp_lim = 1375920,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300019,Rem) ->
	#mon{id = 2300019,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 260,att = 105361,hp_lim = 3250546,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300025,Rem) ->
	#mon{id = 2300025,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 320,att = 172918,hp_lim = 5868251,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300031,Rem) ->
	#mon{id = 2300031,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 380,att = 300031,hp_lim = 9982367,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300037,Rem) ->
	#mon{id = 2300037,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 440,att = 452632,hp_lim = 15360749,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300043,Rem) ->
	#mon{id = 2300043,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 500,att = 875373,hp_lim = 25832253,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300049,Rem) ->
	#mon{id = 2300049,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 560,att = 2568675,hp_lim = 60118457,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(3000003,Rem) ->
	#mon{id = 3000003,name = "虚空光刃",boss = 6,color = 1,module = 610,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10010001,Rem) ->
	#mon{id = 10010001,name = "赤骨光刃",boss = 7,color = 3,icon = 20010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 12,att = 200,hp_lim = 3895,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 1,is_hit_ac = 1,rem_flag = Rem};
get(10010103,Rem) ->
	#mon{id = 10010103,name = "异化黑骸",boss = 1,type = 1,color = 1,icon = 10010107,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 6,att = 16,hp_lim = 1185,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 4,is_hit_ac = 1,rem_flag = Rem};
get(10020105,Rem) ->
	#mon{id = 10020105,name = "荧光毒蛛",boss = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 32,att = 42,hp_lim = 3270,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 6,is_hit_ac = 1,rem_flag = Rem};
get(10020201,Rem) ->
	#mon{id = 10020201,name = "水上浮标",kind = 2,color = 1,icon = 10020206,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10030101,Rem) ->
	#mon{id = 10030101,name = "宝具窃贼",boss = 1,type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 48,att = 58,hp_lim = 3429,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 6,is_hit_ac = 1,rem_flag = Rem};
get(10040001,Rem) ->
	#mon{id = 10040001,name = "美杜莎",boss = 7,color = 3,icon = 20040004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 80,att = 1000,hp_lim = 31162,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 8,is_hit_ac = 1,rem_flag = Rem};
get(10040103,Rem) ->
	#mon{id = 10040103,name = "地牢伪装者",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202003,lv = 65,att = 75,hp_lim = 3738,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 10,is_hit_ac = 1,rem_flag = Rem};
get(10050003,Rem) ->
	#mon{id = 10050003,name = "深渊领主",boss = 7,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 94,att = 1300,hp_lim = 76837,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 13,is_hit_ac = 1,rem_flag = Rem};
get(10050105,Rem) ->
	#mon{id = 10050105,name = "机甲鼠",boss = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 95,att = 100,hp_lim = 29876,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 16,is_hit_ac = 1,rem_flag = Rem};
get(10050201,Rem) ->
	#mon{id = 10050201,name = "女王雕像",kind = 2,color = 1,icon = 10050201,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 9700,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10070103,Rem) ->
	#mon{id = 10070103,name = "两栖水族",boss = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 120,att = 100,hp_lim = 184000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 18,is_hit_ac = 1,rem_flag = Rem};
get(10070109,Rem) ->
	#mon{id = 10070109,name = "执行耳目",boss = 1,type = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 142,att = 100,hp_lim = 352000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 21,is_hit_ac = 1,rem_flag = Rem};
get(10080105,Rem) ->
	#mon{id = 10080105,name = "狂暴柴犬",boss = 1,type = 1,color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 170,att = 100,hp_lim = 512000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 24,is_hit_ac = 1,rem_flag = Rem};
get(10080111,Rem) ->
	#mon{id = 10080111,name = "疯癫船员",boss = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 220,att = 100,hp_lim = 1152000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 29,is_hit_ac = 1,rem_flag = Rem};
get(10080201,Rem) ->
	#mon{id = 10080201,name = "烟雾发生器",kind = 2,color = 1,icon = 10080201,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10090101,Rem) ->
	#mon{id = 10090101,name = "羽鹰巡逻兵",boss = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 240,att = 100,hp_lim = 1481650,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 23,is_hit_ac = 1,rem_flag = Rem};
get(10090107,Rem) ->
	#mon{id = 10090107,name = "神殿守卫",boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 285,att = 100,hp_lim = 2743950,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 35,is_hit_ac = 1,rem_flag = Rem};
get(10100001,Rem) ->
	#mon{id = 10100001,name = "雄狮领主",boss = 6,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 345,att = 100,hp_lim = 9759050,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 55,is_hit_ac = 1,rem_flag = Rem};
get(10100103,Rem) ->
	#mon{id = 10100103,name = "遥控巡逻兵",boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 320,att = 100,hp_lim = 3974250,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 46,is_hit_ac = 1,rem_flag = Rem};
get(10110105,Rem) ->
	#mon{id = 10110105,name = "追击执行者",boss = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 410,att = 100,hp_lim = 8279825,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 76,is_hit_ac = 1,rem_flag = Rem};
get(10110201,Rem) ->
	#mon{id = 10110201,name = "遗物项链",kind = 2,color = 1,icon = 10110201,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10120101,Rem) ->
	#mon{id = 10120101,name = "生锈机械",boss = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 425,att = 100,hp_lim = 9162750,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 84,is_hit_ac = 1,rem_flag = Rem};
get(10130001,Rem) ->
	#mon{id = 10130001,name = "狂热科学家",boss = 7,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 480,att = 100,hp_lim = 26835400,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 137,is_hit_ac = 1,rem_flag = Rem};
get(10130103,Rem) ->
	#mon{id = 10130103,name = "陆地触手",boss = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 475,att = 100,hp_lim = 12724250,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 132,is_hit_ac = 1,rem_flag = Rem};
get(10140105,Rem) ->
	#mon{id = 10140105,name = "游荡兽人",boss = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 1007006,lv = 525,att = 100,hp_lim = 19082750,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 182,rem_flag = Rem};
get(10140201,Rem) ->
	#mon{id = 10140201,name = "破碎显示器",kind = 2,color = 1,icon = 10010203,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10150101,Rem) ->
	#mon{id = 10150101,name = "深渊护卫",boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 1007006,lv = 540,att = 100,hp_lim = 22468150,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 197,rem_flag = Rem};
get(10150107,Rem) ->
	#mon{id = 10150107,name = "幻影暗灵",boss = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 1007006,lv = 630,att = 100,hp_lim = 55763675,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 287,rem_flag = Rem};
get(11001003,Rem) ->
	#mon{id = 11001003,name = "协奏女爵",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 124,att = 4760,hp_lim = 882000,hit = 126,dodge = 84,ten = 67,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001009,Rem) ->
	#mon{id = 11001009,name = "弹奏指挥家",boss = 6,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 136,att = 6120,hp_lim = 1134000,hit = 162,dodge = 108,ten = 86,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001015,Rem) ->
	#mon{id = 11001015,name = "钢琴弹奏者",boss = 6,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 148,att = 8726,hp_lim = 1617000,hit = 231,dodge = 154,ten = 123,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001021,Rem) ->
	#mon{id = 11001021,name = "触手女孩",boss = 6,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 160,att = 12693,hp_lim = 2352000,hit = 336,dodge = 224,ten = 179,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001027,Rem) ->
	#mon{id = 11001027,name = "冷血三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 172,att = 11306,hp_lim = 1008000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002005,Rem) ->
	#mon{id = 11002005,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 188,att = 15829,hp_lim = 1411200,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002011,Rem) ->
	#mon{id = 11002011,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 21435,hp_lim = 1911000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002017,Rem) ->
	#mon{id = 11002017,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 212,att = 27748,hp_lim = 2473800,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002023,Rem) ->
	#mon{id = 11002023,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 224,att = 32443,hp_lim = 2892330,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002029,Rem) ->
	#mon{id = 11002029,name = "变异恶犬",type = 1,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 236,att = 35612,hp_lim = 3174872,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003001,Rem) ->
	#mon{id = 11003001,name = "刺棘蜥蜴",type = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 36646,hp_lim = 3267069,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003007,Rem) ->
	#mon{id = 11003007,name = "沙漠守卫",type = 1,color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 252,att = 42937,hp_lim = 3827943,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003013,Rem) ->
	#mon{id = 11003013,name = "刺棘蜥蜴",type = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 264,att = 51133,hp_lim = 4558569,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003019,Rem) ->
	#mon{id = 11003019,name = "刺棘蜥蜴",type = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 276,att = 53613,hp_lim = 4779655,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003025,Rem) ->
	#mon{id = 11003025,name = "改造械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 288,att = 62031,hp_lim = 5530145,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004003,Rem) ->
	#mon{id = 11004003,name = "协奏女爵",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 304,att = 124237,hp_lim = 23020486,hit = 3288,dodge = 2192,ten = 1753,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004009,Rem) ->
	#mon{id = 11004009,name = "弹奏指挥家",boss = 6,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 316,att = 139785,hp_lim = 25901374,hit = 3700,dodge = 2466,ten = 1973,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004015,Rem) ->
	#mon{id = 11004015,name = "钢琴弹奏者",boss = 6,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 328,att = 155960,hp_lim = 28898652,hit = 4128,dodge = 2752,ten = 2201,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004021,Rem) ->
	#mon{id = 11004021,name = "触手女孩",boss = 6,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 340,att = 172817,hp_lim = 32022039,hit = 4574,dodge = 3049,ten = 2439,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004027,Rem) ->
	#mon{id = 11004027,name = "冷血三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 352,att = 118362,hp_lim = 10552109,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005005,Rem) ->
	#mon{id = 11005005,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 368,att = 143766,hp_lim = 12816951,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005011,Rem) ->
	#mon{id = 11005011,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 380,att = 173410,hp_lim = 15459743,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005017,Rem) ->
	#mon{id = 11005017,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 392,att = 214169,hp_lim = 19093451,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005023,Rem) ->
	#mon{id = 11005023,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 408,att = 263686,hp_lim = 23507903,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005029,Rem) ->
	#mon{id = 11005029,name = "变异恶犬",type = 1,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 432,att = 337133,hp_lim = 30055732,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006001,Rem) ->
	#mon{id = 11006001,name = "刺棘蜥蜴",type = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 440,att = 368008,hp_lim = 32808265,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006007,Rem) ->
	#mon{id = 11006007,name = "沙漠守卫",type = 1,color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 464,att = 457915,hp_lim = 40823621,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006013,Rem) ->
	#mon{id = 11006013,name = "刺棘蜥蜴",type = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 488,att = 559963,hp_lim = 49921301,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006019,Rem) ->
	#mon{id = 11006019,name = "刺棘蜥蜴",type = 1,color = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 512,att = 724820,hp_lim = 64618426,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006025,Rem) ->
	#mon{id = 11006025,name = "改造械鼠",type = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 536,att = 993558,hp_lim = 88576674,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007003,Rem) ->
	#mon{id = 11007003,name = "协奏女爵",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 568,att = 2394428,hp_lim = 443673541,hit = 63381,dodge = 42254,ten = 33803,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007009,Rem) ->
	#mon{id = 11007009,name = "弹奏指挥家",boss = 6,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 592,att = 3199395,hp_lim = 592829211,hit = 84689,dodge = 56459,ten = 45167,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007015,Rem) ->
	#mon{id = 11007015,name = "钢琴弹奏者",boss = 6,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 616,att = 4263926,hp_lim = 790080473,hit = 112868,dodge = 75245,ten = 60196,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007021,Rem) ->
	#mon{id = 11007021,name = "触手女孩",boss = 6,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 640,att = 5782739,hp_lim = 1071507528,hit = 153072,dodge = 102048,ten = 81638,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007027,Rem) ->
	#mon{id = 11007027,name = "冷血三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 664,att = 4783966,hp_lim = 426495153,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008005,Rem) ->
	#mon{id = 11008005,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 696,att = 6968196,hp_lim = 621221294,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008011,Rem) ->
	#mon{id = 11008011,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 720,att = 9205383,hp_lim = 820668584,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008017,Rem) ->
	#mon{id = 11008017,name = "深渊触手",type = 1,color = 1,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 744,att = 12384224,hp_lim = 1104065260,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008023,Rem) ->
	#mon{id = 11008023,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 768,att = 16309974,hp_lim = 1454049621,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008029,Rem) ->
	#mon{id = 11008029,name = "变异恶犬",type = 1,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 792,att = 22054180,hp_lim = 1966150986,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12010011,Rem) ->
	#mon{id = 12010011,name = "变异机甲",boss = 6,color = 1,module = 610,icon = 100100011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 90,att = 625,hp_lim = 34265,hit = 40,dodge = 27,ten = 21,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12020013,Rem) ->
	#mon{id = 12020013,name = "末世利爪",boss = 6,color = 1,module = 610,icon = 100100042,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 10400,hp_lim = 1814400,hit = 360,dodge = 240,ten = 192,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12030015,Rem) ->
	#mon{id = 12030015,name = "机甲环刃",boss = 6,color = 1,module = 610,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 108403,hp_lim = 18912277,hit = 3752,dodge = 2501,ten = 2001,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12040011,Rem) ->
	#mon{id = 12040011,name = "变异触手",boss = 6,color = 1,module = 610,icon = 100200021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 107636,hp_lim = 18778404,hit = 3725,dodge = 2483,ten = 1987,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12050013,Rem) ->
	#mon{id = 12050013,name = "末世博士",boss = 6,color = 1,module = 610,icon = 100200062,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 423525,hp_lim = 73888960,hit = 14660,dodge = 9773,ten = 7818,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12060015,Rem) ->
	#mon{id = 12060015,name = "静谧三角",boss = 6,color = 1,module = 610,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 550,att = 1364461,hp_lim = 238046104,hit = 47231,dodge = 31487,ten = 25190,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13010001,Rem) ->
	#mon{id = 13010001,name = "霹雳人马",boss = 3,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 856,hp_lim = 1008684,hit = 50,dodge = 33,ten = 26,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13020003,Rem) ->
	#mon{id = 13020003,name = "光刃利爪",boss = 3,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 21684,hp_lim = 23587200,hit = 1170,dodge = 780,ten = 624,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13040001,Rem) ->
	#mon{id = 13040001,name = "寄生触手",boss = 3,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 76761,hp_lim = 83499171,hit = 4141,dodge = 2761,ten = 2208,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13050003,Rem) ->
	#mon{id = 13050003,name = "猩猩守卫",boss = 3,color = 1,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 480,att = 349698,hp_lim = 380391951,hit = 18868,dodge = 12579,ten = 10063,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14010003,Rem) ->
	#mon{id = 14010003,name = "远古血魔",boss = 4,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2311,hp_lim = 17422250,hit = 103,dodge = 69,ten = 55,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14030001,Rem) ->
	#mon{id = 14030001,name = "猩猩守卫",boss = 4,type = 1,color = 1,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 91042,hp_lim = 546255350,hit = 3251,dodge = 2167,ten = 1734,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14040003,Rem) ->
	#mon{id = 14040003,name = "王之行者",boss = 4,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 375,att = 424567,hp_lim = 2547404700,hit = 15163,dodge = 10108,ten = 8086,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14060001,Rem) ->
	#mon{id = 14060001,name = "雇佣兵王",boss = 4,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 1013768,hp_lim = 6082611400,hit = 36206,dodge = 24137,ten = 19309,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18010005,Rem) ->
	#mon{id = 18010005,name = "爆裂机甲",boss = 9,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 9760,hp_lim = 7257600,hit = 360,dodge = 240,ten = 192,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18010101,Rem) ->
	#mon{id = 18010101,name = "星域精英",boss = 10,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 3432,hp_lim = 2552163,hit = 126,dodge = 84,ten = 67,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18020001,Rem) ->
	#mon{id = 18020001,name = "机甲环刃",boss = 9,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 4880,hp_lim = 3628800,hit = 180,dodge = 120,ten = 96,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18030003,Rem) ->
	#mon{id = 18030003,name = "变异死神",boss = 9,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 50866,hp_lim = 37824552,hit = 1876,dodge = 1250,ten = 1000,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18040005,Rem) ->
	#mon{id = 18040005,name = "雇佣兵王",boss = 9,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 400,att = 294048,hp_lim = 218656245,hit = 10846,dodge = 7230,ten = 5784,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18040101,Rem) ->
	#mon{id = 18040101,name = "星域精英",boss = 10,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 340,att = 124021,hp_lim = 92223471,hit = 4574,dodge = 3049,ten = 2439,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18050001,Rem) ->
	#mon{id = 18050001,name = "莱姆战士",boss = 9,type = 1,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 225294,hp_lim = 167530686,hit = 8310,dodge = 5540,ten = 4432,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18060003,Rem) ->
	#mon{id = 18060003,name = "病毒异形",boss = 9,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 560,att = 713685,hp_lim = 530700870,hit = 26324,dodge = 17549,ten = 14039,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19010001,Rem) ->
	#mon{id = 19010001,name = "执首领主",boss = 12,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2911,hp_lim = 7216170,hit = 107,dodge = 71,ten = 57,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19020003,Rem) ->
	#mon{id = 19020003,name = "霹雳人马",boss = 12,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 29280,hp_lim = 72576000,hit = 1080,dodge = 720,ten = 576,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19030005,Rem) ->
	#mon{id = 19030005,name = "王级行者",boss = 12,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 227278,hp_lim = 563352140,hit = 8383,dodge = 5588,ten = 4471,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19040001,Rem) ->
	#mon{id = 19040001,name = "改造机甲",boss = 12,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 202890,hp_lim = 502902840,hit = 7483,dodge = 4989,ten = 3991,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19050003,Rem) ->
	#mon{id = 19050003,name = "投弹猩猩",boss = 12,type = 1,color = 1,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 460,att = 669644,hp_lim = 1659839420,hit = 24699,dodge = 16466,ten = 13173,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19060005,Rem) ->
	#mon{id = 19060005,name = "病毒血魔",boss = 12,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 620,att = 2888363,hp_lim = 7159352500,hit = 106537,dodge = 71025,ten = 56820,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20010003,Rem) ->
	#mon{id = 20010003,name = "变异死神",boss = 13,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 6950,hp_lim = 17226970,hit = 256,dodge = 170,ten = 136,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20020005,Rem) ->
	#mon{id = 20020005,name = "雇佣兵长",boss = 13,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 75213,hp_lim = 186429600,hit = 2774,dodge = 1849,ten = 1479,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20030001,Rem) ->
	#mon{id = 20030001,name = "爆裂机甲",boss = 13,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 65880,hp_lim = 163296000,hit = 2430,dodge = 1620,ten = 1296,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20040003,Rem) ->
	#mon{id = 20040003,name = "人马王者",boss = 13,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 360,att = 320589,hp_lim = 794642330,hit = 11825,dodge = 7883,ten = 6306,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20050005,Rem) ->
	#mon{id = 20050005,name = "阴影侍从",boss = 13,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 1045255,hp_lim = 2590861590,hit = 38554,dodge = 25702,ten = 20562,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20060001,Rem) ->
	#mon{id = 20060001,name = "病毒利爪",boss = 13,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 510,att = 934084,hp_lim = 2315304120,hit = 34453,dodge = 22969,ten = 18375,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(43001001,Rem) ->
	#mon{id = 43001001,name = "核心中枢",kind = 11,boss = 1,color = 1,icon = 10010306,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 1,att = 1000,hp_lim = 1131000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(43001103,Rem) ->
	#mon{id = 43001103,name = "南城守卫者",kind = 11,boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 250,att = 1000,hp_lim = 942000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(60402003,Rem) ->
	#mon{id = 60402003,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60402009,Rem) ->
	#mon{id = 60402009,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403005,Rem) ->
	#mon{id = 60403005,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10040003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(70010001,Rem) ->
	#mon{id = 70010001,name = "雷电地鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 80,att = 565,hp_lim = 83616,hit = 25,dodge = 17,ten = 13,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010007,Rem) ->
	#mon{id = 70010007,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 5100,hp_lim = 661500,hit = 135,dodge = 90,ten = 72,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010013,Rem) ->
	#mon{id = 70010013,name = "部落守卫",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 3748,hp_lim = 554242,hit = 172,dodge = 114,ten = 91,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010019,Rem) ->
	#mon{id = 70010019,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 15300,hp_lim = 1984500,hit = 405,dodge = 270,ten = 216,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010025,Rem) ->
	#mon{id = 70010025,name = "变异触手",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 115,att = 9996,hp_lim = 1477980,hit = 459,dodge = 306,ten = 244,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010031,Rem) ->
	#mon{id = 70010031,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 33150,hp_lim = 4299750,hit = 877,dodge = 585,ten = 468,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010037,Rem) ->
	#mon{id = 70010037,name = "异化魔藤",type = 1,color = 1,module = 610,icon = 10130102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 19992,hp_lim = 2955960,hit = 918,dodge = 612,ten = 489,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010043,Rem) ->
	#mon{id = 70010043,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 56100,hp_lim = 7276500,hit = 1485,dodge = 990,ten = 792,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010049,Rem) ->
	#mon{id = 70010049,name = "雷电地鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 145,att = 32487,hp_lim = 4803435,hit = 1491,dodge = 994,ten = 795,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010055,Rem) ->
	#mon{id = 70010055,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 155,att = 86700,hp_lim = 11245500,hit = 2295,dodge = 1530,ten = 1224,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010061,Rem) ->
	#mon{id = 70010061,name = "部落守卫",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 160,att = 47481,hp_lim = 7020405,hit = 2180,dodge = 1453,ten = 1162,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010067,Rem) ->
	#mon{id = 70010067,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 122400,hp_lim = 15876000,hit = 3240,dodge = 2160,ten = 1728,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010073,Rem) ->
	#mon{id = 70010073,name = "变异触手",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 175,att = 67473,hp_lim = 9976365,hit = 3098,dodge = 2065,ten = 1652,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010079,Rem) ->
	#mon{id = 70010079,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 168300,hp_lim = 21829500,hit = 4455,dodge = 2970,ten = 2376,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010085,Rem) ->
	#mon{id = 70010085,name = "异化魔藤",type = 1,color = 1,module = 610,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 190,att = 89964,hp_lim = 13301820,hit = 4131,dodge = 2754,ten = 2203,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010091,Rem) ->
	#mon{id = 70010091,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 224400,hp_lim = 29106000,hit = 5940,dodge = 3960,ten = 3168,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010097,Rem) ->
	#mon{id = 70010097,name = "雷电地鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 205,att = 119952,hp_lim = 17735760,hit = 5508,dodge = 3672,ten = 2937,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010103,Rem) ->
	#mon{id = 70010103,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 215,att = 285600,hp_lim = 37044000,hit = 7560,dodge = 5040,ten = 4032,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010109,Rem) ->
	#mon{id = 70010109,name = "部落守卫",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 220,att = 149940,hp_lim = 22169700,hit = 6885,dodge = 4590,ten = 3672,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010115,Rem) ->
	#mon{id = 70010115,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 387600,hp_lim = 50274000,hit = 10260,dodge = 6840,ten = 5472,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010121,Rem) ->
	#mon{id = 70010121,name = "变异触手",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 235,att = 209916,hp_lim = 31037580,hit = 9639,dodge = 6426,ten = 5140,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010127,Rem) ->
	#mon{id = 70010127,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 245,att = 510000,hp_lim = 66150000,hit = 13500,dodge = 9000,ten = 7200,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010133,Rem) ->
	#mon{id = 70010133,name = "异化魔藤",type = 1,color = 1,module = 610,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 250,att = 269892,hp_lim = 39905460,hit = 12393,dodge = 8262,ten = 6609,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010139,Rem) ->
	#mon{id = 70010139,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 632400,hp_lim = 82026000,hit = 16740,dodge = 11160,ten = 8928,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010145,Rem) ->
	#mon{id = 70010145,name = "雷电地鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 265,att = 329868,hp_lim = 48773340,hit = 15147,dodge = 10098,ten = 8078,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010151,Rem) ->
	#mon{id = 70010151,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 765000,hp_lim = 99225000,hit = 20250,dodge = 13500,ten = 10800,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010157,Rem) ->
	#mon{id = 70010157,name = "部落守卫",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 399840,hp_lim = 59119200,hit = 18360,dodge = 12240,ten = 9792,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010163,Rem) ->
	#mon{id = 70010163,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 290,att = 918000,hp_lim = 119070000,hit = 24300,dodge = 16200,ten = 12960,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010169,Rem) ->
	#mon{id = 70010169,name = "变异触手",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 295,att = 474810,hp_lim = 70204050,hit = 21802,dodge = 14535,ten = 11628,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010175,Rem) ->
	#mon{id = 70010175,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 1071000,hp_lim = 138915000,hit = 28350,dodge = 18900,ten = 15120,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010181,Rem) ->
	#mon{id = 70010181,name = "异化魔藤",type = 1,color = 1,module = 610,icon = 10130102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 549780,hp_lim = 81288900,hit = 25245,dodge = 16830,ten = 13464,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010187,Rem) ->
	#mon{id = 70010187,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 1275000,hp_lim = 165375000,hit = 33750,dodge = 22500,ten = 18000,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010193,Rem) ->
	#mon{id = 70010193,name = "异化魔藤",type = 1,color = 1,module = 610,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 325,att = 674730,hp_lim = 99763650,hit = 30982,dodge = 20655,ten = 16524,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010199,Rem) ->
	#mon{id = 70010199,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 335,att = 1581000,hp_lim = 205065000,hit = 41850,dodge = 27900,ten = 22320,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010205,Rem) ->
	#mon{id = 70010205,name = "雷电地鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 340,att = 824670,hp_lim = 121933350,hit = 37867,dodge = 25245,ten = 20196,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010211,Rem) ->
	#mon{id = 70010211,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 350,att = 1887000,hp_lim = 244755000,hit = 49950,dodge = 33300,ten = 26640,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010217,Rem) ->
	#mon{id = 70010217,name = "部落守卫",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 355,att = 974610,hp_lim = 144103050,hit = 44752,dodge = 29835,ten = 23868,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010223,Rem) ->
	#mon{id = 70010223,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 365,att = 2193000,hp_lim = 284445000,hit = 58050,dodge = 38700,ten = 30960,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010229,Rem) ->
	#mon{id = 70010229,name = "变异触手",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 370,att = 1124550,hp_lim = 166272750,hit = 51637,dodge = 34425,ten = 27540,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010235,Rem) ->
	#mon{id = 70010235,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 380,att = 2499000,hp_lim = 324135000,hit = 66150,dodge = 44100,ten = 35280,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010241,Rem) ->
	#mon{id = 70010241,name = "异化魔藤",type = 1,color = 1,module = 610,icon = 10130102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 385,att = 1274490,hp_lim = 188442450,hit = 58522,dodge = 39015,ten = 31212,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010247,Rem) ->
	#mon{id = 70010247,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 395,att = 2805000,hp_lim = 363825000,hit = 74250,dodge = 49500,ten = 39600,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010253,Rem) ->
	#mon{id = 70010253,name = "雷电地鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 400,att = 1499400,hp_lim = 221697000,hit = 68850,dodge = 45900,ten = 36720,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010259,Rem) ->
	#mon{id = 70010259,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 410,att = 3570000,hp_lim = 463050000,hit = 94500,dodge = 63000,ten = 50400,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010265,Rem) ->
	#mon{id = 70010265,name = "部落守卫",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 415,att = 1874250,hp_lim = 277121250,hit = 86062,dodge = 57375,ten = 45900,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010271,Rem) ->
	#mon{id = 70010271,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 425,att = 4335000,hp_lim = 562275000,hit = 114750,dodge = 76500,ten = 61200,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010277,Rem) ->
	#mon{id = 70010277,name = "变异触手",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 2249100,hp_lim = 332545500,hit = 103275,dodge = 68850,ten = 55080,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010283,Rem) ->
	#mon{id = 70010283,name = "网路歌姬",boss = 6,type = 1,color = 1,module = 610,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 5100000,hp_lim = 661500000,hit = 135000,dodge = 90000,ten = 72000,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010289,Rem) ->
	#mon{id = 70010289,name = "异化魔藤",type = 1,color = 1,module = 610,icon = 10130102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 445,att = 2998800,hp_lim = 443394000,hit = 137700,dodge = 91800,ten = 73440,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010295,Rem) ->
	#mon{id = 70010295,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 455,att = 8160000,hp_lim = 1058400000,hit = 216000,dodge = 144000,ten = 115200,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010505,Rem) ->
	#mon{id = 70010505,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 100100061,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 40800,hp_lim = 5292000,hit = 1080,dodge = 720,ten = 576,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010511,Rem) ->
	#mon{id = 70010511,name = "神盾卫士",boss = 6,type = 1,color = 1,module = 610,icon = 100200032,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 188,att = 132600,hp_lim = 17199000,hit = 3510,dodge = 2340,ten = 1872,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010517,Rem) ->
	#mon{id = 70010517,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100022,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 245,att = 275400,hp_lim = 35721000,hit = 7290,dodge = 4860,ten = 3888,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010523,Rem) ->
	#mon{id = 70010523,name = "悍地魔兽",boss = 6,type = 1,color = 1,module = 610,icon = 100100082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 489600,hp_lim = 63504000,hit = 12960,dodge = 8640,ten = 6912,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010529,Rem) ->
	#mon{id = 70010529,name = "修女机械体",boss = 6,type = 1,color = 1,module = 610,icon = 100100061,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 380,att = 856800,hp_lim = 111132000,hit = 22680,dodge = 15120,ten = 12096,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010535,Rem) ->
	#mon{id = 70010535,name = "神盾卫士",boss = 6,type = 1,color = 1,module = 610,icon = 100200032,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 470,att = 1346400,hp_lim = 174636000,hit = 35640,dodge = 23760,ten = 19008,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010541,Rem) ->
	#mon{id = 70010541,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100022,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 560,att = 1938000,hp_lim = 251370000,hit = 51300,dodge = 34200,ten = 27360,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010547,Rem) ->
	#mon{id = 70010547,name = "悍地魔兽",boss = 6,type = 1,color = 1,module = 610,icon = 100100082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 650,att = 2754000,hp_lim = 357210000,hit = 72900,dodge = 48600,ten = 38880,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80010003,Rem) ->
	#mon{id = 80010003,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80010009,Rem) ->
	#mon{id = 80010009,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80030001,Rem) ->
	#mon{id = 80030001,name = "草地蜥",type = 1,color = 1,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80030007,Rem) ->
	#mon{id = 80030007,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80040003,Rem) ->
	#mon{id = 80040003,name = "球形海怪",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80040009,Rem) ->
	#mon{id = 80040009,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80060001,Rem) ->
	#mon{id = 80060001,name = "冰原从者",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80060007,Rem) ->
	#mon{id = 80060007,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80070003,Rem) ->
	#mon{id = 80070003,name = "深渊巨网",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80070009,Rem) ->
	#mon{id = 80070009,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80090001,Rem) ->
	#mon{id = 80090001,name = "叛逃者",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80090007,Rem) ->
	#mon{id = 80090007,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80100003,Rem) ->
	#mon{id = 80100003,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80100009,Rem) ->
	#mon{id = 80100009,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80120001,Rem) ->
	#mon{id = 80120001,name = "改造水母",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80120007,Rem) ->
	#mon{id = 80120007,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80130003,Rem) ->
	#mon{id = 80130003,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80130009,Rem) ->
	#mon{id = 80130009,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80150001,Rem) ->
	#mon{id = 80150001,name = "变异虫体",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80150007,Rem) ->
	#mon{id = 80150007,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80160003,Rem) ->
	#mon{id = 80160003,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80160009,Rem) ->
	#mon{id = 80160009,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80180001,Rem) ->
	#mon{id = 80180001,name = "怪异博士",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80180007,Rem) ->
	#mon{id = 80180007,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80190003,Rem) ->
	#mon{id = 80190003,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80190009,Rem) ->
	#mon{id = 80190009,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80210001,Rem) ->
	#mon{id = 80210001,name = "邪心女仆",type = 1,color = 1,module = 610,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80210007,Rem) ->
	#mon{id = 80210007,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80220003,Rem) ->
	#mon{id = 80220003,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80220009,Rem) ->
	#mon{id = 80220009,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80240001,Rem) ->
	#mon{id = 80240001,name = "原始守护者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80240007,Rem) ->
	#mon{id = 80240007,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80250003,Rem) ->
	#mon{id = 80250003,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80250009,Rem) ->
	#mon{id = 80250009,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80270001,Rem) ->
	#mon{id = 80270001,name = "草地蜥",type = 1,color = 1,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80270007,Rem) ->
	#mon{id = 80270007,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80280003,Rem) ->
	#mon{id = 80280003,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80280009,Rem) ->
	#mon{id = 80280009,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010005,Rem) ->
	#mon{id = 81010005,name = "豪华箱子",kind = 1,color = 3,module = 610,icon = 10010402,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 109,hp_lim = 5911,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81010101,Rem) ->
	#mon{id = 81010101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 200,att = 30333,hp_lim = 1638000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010203,Rem) ->
	#mon{id = 81010203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 203,att = 30333,hp_lim = 1638000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010401,Rem) ->
	#mon{id = 81010401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 209,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010503,Rem) ->
	#mon{id = 81010503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 212,att = 77500,hp_lim = 3906000,hit = 1395,dodge = 930,ten = 744,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010701,Rem) ->
	#mon{id = 81010701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 218,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010803,Rem) ->
	#mon{id = 81010803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 221,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011001,Rem) ->
	#mon{id = 81011001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 227,att = 102750,hp_lim = 5178600,hit = 1849,dodge = 1233,ten = 986,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011103,Rem) ->
	#mon{id = 81011103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 230,att = 47950,hp_lim = 2589300,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011301,Rem) ->
	#mon{id = 81011301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 236,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011403,Rem) ->
	#mon{id = 81011403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 239,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020001,Rem) ->
	#mon{id = 81020001,name = "下路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 240,att = 54019,hp_lim = 58340520,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81020103,Rem) ->
	#mon{id = 81020103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 240,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020301,Rem) ->
	#mon{id = 81020301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 250,att = 66523,hp_lim = 3592272,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020403,Rem) ->
	#mon{id = 81020403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 255,att = 72964,hp_lim = 3940057,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020601,Rem) ->
	#mon{id = 81020601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 265,att = 79533,hp_lim = 4294798,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020703,Rem) ->
	#mon{id = 81020703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 270,att = 86233,hp_lim = 4656632,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020901,Rem) ->
	#mon{id = 81020901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 93068,hp_lim = 5025701,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021003,Rem) ->
	#mon{id = 81021003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 285,att = 214371,hp_lim = 10804302,hit = 3858,dodge = 2572,ten = 2057,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021201,Rem) ->
	#mon{id = 81021201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 295,att = 114403,hp_lim = 6177788,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021303,Rem) ->
	#mon{id = 81021303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 300,att = 121801,hp_lim = 6577281,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021501,Rem) ->
	#mon{id = 81021501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 310,att = 277173,hp_lim = 13969523,hit = 4989,dodge = 3326,ten = 2660,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021603,Rem) ->
	#mon{id = 81021603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 315,att = 137044,hp_lim = 7400391,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021801,Rem) ->
	#mon{id = 81021801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 325,att = 152902,hp_lim = 8256756,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021903,Rem) ->
	#mon{id = 81021903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 161070,hp_lim = 8697830,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022101,Rem) ->
	#mon{id = 81022101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 340,att = 177900,hp_lim = 9606611,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022203,Rem) ->
	#mon{id = 81022203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 345,att = 177900,hp_lim = 9606611,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022401,Rem) ->
	#mon{id = 81022401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 355,att = 195409,hp_lim = 10552109,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022503,Rem) ->
	#mon{id = 81022503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 360,att = 437964,hp_lim = 22073398,hit = 7883,dodge = 5255,ten = 4204,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030003,Rem) ->
	#mon{id = 81030003,name = "上路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 360,att = 204383,hp_lim = 227356000,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81030201,Rem) ->
	#mon{id = 81030201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 363,att = 222031,hp_lim = 11989701,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030303,Rem) ->
	#mon{id = 81030303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 366,att = 242783,hp_lim = 13110297,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030501,Rem) ->
	#mon{id = 81030501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 372,att = 497401,hp_lim = 25069039,hit = 8953,dodge = 5968,ten = 4775,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030603,Rem) ->
	#mon{id = 81030603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 375,att = 273902,hp_lim = 14790733,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030801,Rem) ->
	#mon{id = 81030801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 381,att = 294807,hp_lim = 15919591,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030903,Rem) ->
	#mon{id = 81030903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 384,att = 319167,hp_lim = 17235026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031101,Rem) ->
	#mon{id = 81031101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 390,att = 342073,hp_lim = 18471991,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031203,Rem) ->
	#mon{id = 81031203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 393,att = 368675,hp_lim = 19908462,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031401,Rem) ->
	#mon{id = 81031401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 399,att = 393671,hp_lim = 21258246,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031503,Rem) ->
	#mon{id = 81031503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 402,att = 624545,hp_lim = 31477068,hit = 11241,dodge = 7494,ten = 5995,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031701,Rem) ->
	#mon{id = 81031701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 408,att = 449784,hp_lim = 24288364,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031803,Rem) ->
	#mon{id = 81031803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 411,att = 464877,hp_lim = 25103410,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032001,Rem) ->
	#mon{id = 81032001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 417,att = 692504,hp_lim = 34902226,hit = 12465,dodge = 8310,ten = 6648,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032103,Rem) ->
	#mon{id = 81032103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 420,att = 526765,hp_lim = 28445314,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032301,Rem) ->
	#mon{id = 81032301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 426,att = 576337,hp_lim = 31122243,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032403,Rem) ->
	#mon{id = 81032403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 429,att = 593593,hp_lim = 32054047,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032601,Rem) ->
	#mon{id = 81032601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 435,att = 647186,hp_lim = 34948049,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032703,Rem) ->
	#mon{id = 81032703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 438,att = 665572,hp_lim = 35940891,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032901,Rem) ->
	#mon{id = 81032901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 444,att = 723367,hp_lim = 39061852,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033003,Rem) ->
	#mon{id = 81033003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 447,att = 837877,hp_lim = 42229030,hit = 15081,dodge = 10054,ten = 8043,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033201,Rem) ->
	#mon{id = 81033201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 453,att = 804762,hp_lim = 43457190,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033303,Rem) ->
	#mon{id = 81033303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 456,att = 825504,hp_lim = 44577221,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033501,Rem) ->
	#mon{id = 81033501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 462,att = 914814,hp_lim = 46106650,hit = 16466,dodge = 10977,ten = 8782,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033603,Rem) ->
	#mon{id = 81033603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 465,att = 913372,hp_lim = 49322132,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033801,Rem) ->
	#mon{id = 81033801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 471,att = 957077,hp_lim = 51682195,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033903,Rem) ->
	#mon{id = 81033903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 474,att = 1006674,hp_lim = 54360421,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034101,Rem) ->
	#mon{id = 81034101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 480,att = 1081103,hp_lim = 58379598,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034203,Rem) ->
	#mon{id = 81034203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 483,att = 1105563,hp_lim = 59700403,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034401,Rem) ->
	#mon{id = 81034401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 489,att = 1184447,hp_lim = 63960178,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034503,Rem) ->
	#mon{id = 81034503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 492,att = 1103522,hp_lim = 55617546,hit = 19863,dodge = 13242,ten = 10593,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034701,Rem) ->
	#mon{id = 81034701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 498,att = 1293673,hp_lim = 69858351,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034803,Rem) ->
	#mon{id = 81034803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 501,att = 1353316,hp_lim = 73079072,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81035001,Rem) ->
	#mon{id = 81035001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 507,att = 1246593,hp_lim = 62828299,hit = 22438,dodge = 14959,ten = 11967,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040005,Rem) ->
	#mon{id = 81040005,name = "豪华箱子",kind = 1,color = 3,module = 610,icon = 10010402,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 273,hp_lim = 14778,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81040101,Rem) ->
	#mon{id = 81040101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 500,att = 1392140,hp_lim = 75175602,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040203,Rem) ->
	#mon{id = 81040203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 504,att = 1454395,hp_lim = 78537349,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040401,Rem) ->
	#mon{id = 81040401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 512,att = 1584424,hp_lim = 85558931,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040503,Rem) ->
	#mon{id = 81040503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 516,att = 1366286,hp_lim = 68860852,hit = 24593,dodge = 16395,ten = 13116,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040701,Rem) ->
	#mon{id = 81040701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 524,att = 1871501,hp_lim = 101061101,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040803,Rem) ->
	#mon{id = 81040803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 528,att = 1988328,hp_lim = 107369732,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041001,Rem) ->
	#mon{id = 81041001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 536,att = 1687217,hp_lim = 85035766,hit = 30369,dodge = 20246,ten = 16197,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041103,Rem) ->
	#mon{id = 81041103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 540,att = 2318199,hp_lim = 125182793,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041301,Rem) ->
	#mon{id = 81041301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 548,att = 2587116,hp_lim = 139704280,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041403,Rem) ->
	#mon{id = 81041403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 552,att = 2731691,hp_lim = 147511330,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041601,Rem) ->
	#mon{id = 81041601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 560,att = 3030236,hp_lim = 163632768,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041703,Rem) ->
	#mon{id = 81041703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 564,att = 3191391,hp_lim = 172335156,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041901,Rem) ->
	#mon{id = 81041901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 572,att = 3491750,hp_lim = 188554527,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042003,Rem) ->
	#mon{id = 81042003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 576,att = 2552330,hp_lim = 128637461,hit = 45941,dodge = 30627,ten = 24502,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042201,Rem) ->
	#mon{id = 81042201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 584,att = 4048312,hp_lim = 218608884,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042303,Rem) ->
	#mon{id = 81042303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 588,att = 4278932,hp_lim = 231062350,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042501,Rem) ->
	#mon{id = 81042501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 596,att = 3111276,hp_lim = 156808348,hit = 56002,dodge = 37335,ten = 29868,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042603,Rem) ->
	#mon{id = 81042603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 600,att = 4954725,hp_lim = 267555185,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042801,Rem) ->
	#mon{id = 81042801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 608,att = 5428558,hp_lim = 293142174,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042903,Rem) ->
	#mon{id = 81042903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 612,att = 5732930,hp_lim = 309578262,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043101,Rem) ->
	#mon{id = 81043101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 619,att = 6279164,hp_lim = 339074889,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043203,Rem) ->
	#mon{id = 81043203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 622,att = 6498659,hp_lim = 350927593,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043401,Rem) ->
	#mon{id = 81043401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 628,att = 6976156,hp_lim = 376712453,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043503,Rem) ->
	#mon{id = 81043503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 631,att = 4443669,hp_lim = 223960938,hit = 79986,dodge = 53324,ten = 42659,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043701,Rem) ->
	#mon{id = 81043701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 637,att = 7900298,hp_lim = 426616102,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043803,Rem) ->
	#mon{id = 81043803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 640,att = 8333947,hp_lim = 450033169,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044001,Rem) ->
	#mon{id = 81044001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 646,att = 5206466,hp_lim = 262405932,hit = 93716,dodge = 62477,ten = 49982,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044103,Rem) ->
	#mon{id = 81044103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 649,att = 9243977,hp_lim = 499174805,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044301,Rem) ->
	#mon{id = 81044301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 655,att = 9914982,hp_lim = 535409031,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044403,Rem) ->
	#mon{id = 81044403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 658,att = 10452358,hp_lim = 564427350,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044601,Rem) ->
	#mon{id = 81044601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 664,att = 11208274,hp_lim = 605246803,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044703,Rem) ->
	#mon{id = 81044703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 667,att = 11580528,hp_lim = 625348528,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044901,Rem) ->
	#mon{id = 81044901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 673,att = 12415071,hp_lim = 670413861,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045003,Rem) ->
	#mon{id = 81045003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 676,att = 7007219,hp_lim = 353163837,hit = 126129,dodge = 84086,ten = 67269,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045201,Rem) ->
	#mon{id = 81045201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 682,att = 14019559,hp_lim = 757056191,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045303,Rem) ->
	#mon{id = 81045303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 685,att = 14766468,hp_lim = 797389292,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045501,Rem) ->
	#mon{id = 81045501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 691,att = 8210073,hp_lim = 413787725,hit = 147781,dodge = 98520,ten = 78816,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045603,Rem) ->
	#mon{id = 81045603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 694,att = 16335419,hp_lim = 882112675,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045801,Rem) ->
	#mon{id = 81045801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 700,att = 17501165,hp_lim = 945062963,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045903,Rem) ->
	#mon{id = 81045903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 703,att = 18423950,hp_lim = 994893312,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050001,Rem) ->
	#mon{id = 81050001,name = "下路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 700,att = 17874413,hp_lim = 19528315260,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81050103,Rem) ->
	#mon{id = 81050103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 700,att = 18164717,hp_lim = 980894734,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050301,Rem) ->
	#mon{id = 81050301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 706,att = 19452584,hp_lim = 1050439586,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050403,Rem) ->
	#mon{id = 81050403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 709,att = 20467411,hp_lim = 1105240211,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050601,Rem) ->
	#mon{id = 81050601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 715,att = 21914544,hp_lim = 1183385406,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050703,Rem) ->
	#mon{id = 81050703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 718,att = 22600649,hp_lim = 1220435086,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050901,Rem) ->
	#mon{id = 81050901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 724,att = 24194376,hp_lim = 1306496307,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051003,Rem) ->
	#mon{id = 81051003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 727,att = 11726007,hp_lim = 590990765,hit = 211068,dodge = 140712,ten = 112569,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051201,Rem) ->
	#mon{id = 81051201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 733,att = 27235183,hp_lim = 1470699886,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051303,Rem) ->
	#mon{id = 81051303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 736,att = 28637568,hp_lim = 1546428694,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051501,Rem) ->
	#mon{id = 81051501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 742,att = 13338750,hp_lim = 672273008,hit = 240097,dodge = 160065,ten = 128052,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051603,Rem) ->
	#mon{id = 81051603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 745,att = 30366198,hp_lim = 1639774708,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051801,Rem) ->
	#mon{id = 81051801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 751,att = 31545424,hp_lim = 1703452922,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051903,Rem) ->
	#mon{id = 81051903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 754,att = 32509872,hp_lim = 1755533108,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052101,Rem) ->
	#mon{id = 81052101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 760,att = 33767270,hp_lim = 1823432626,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052203,Rem) ->
	#mon{id = 81052203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 763,att = 34448743,hp_lim = 1860232139,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052401,Rem) ->
	#mon{id = 81052401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 769,att = 35775948,hp_lim = 1931901226,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052503,Rem) ->
	#mon{id = 81052503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 772,att = 15485874,hp_lim = 780488095,hit = 278745,dodge = 185830,ten = 148664,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052701,Rem) ->
	#mon{id = 81052701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 778,att = 38270996,hp_lim = 2066633790,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052803,Rem) ->
	#mon{id = 81052803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 781,att = 39029714,hp_lim = 2107604609,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053001,Rem) ->
	#mon{id = 81053001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 787,att = 16768983,hp_lim = 845156764,hit = 301841,dodge = 201227,ten = 160982,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053103,Rem) ->
	#mon{id = 81053103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 790,att = 42149282,hp_lim = 2276061258,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053301,Rem) ->
	#mon{id = 81053301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 796,att = 44192990,hp_lim = 2386421492,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053403,Rem) ->
	#mon{id = 81053403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 799,att = 45504965,hp_lim = 2457268156,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053601,Rem) ->
	#mon{id = 81053601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 805,att = 47705370,hp_lim = 2576089981,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053703,Rem) ->
	#mon{id = 81053703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 808,att = 49114009,hp_lim = 2652156533,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053901,Rem) ->
	#mon{id = 81053901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 814,att = 51482654,hp_lim = 2780063366,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054003,Rem) ->
	#mon{id = 81054003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 817,att = 20461346,hp_lim = 1031251867,hit = 368304,dodge = 245536,ten = 196428,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054201,Rem) ->
	#mon{id = 81054201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 823,att = 56099587,hp_lim = 3029377738,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054303,Rem) ->
	#mon{id = 81054303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 826,att = 58316451,hp_lim = 3149088369,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054501,Rem) ->
	#mon{id = 81054501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 832,att = 23519790,hp_lim = 1185397432,hit = 423356,dodge = 282237,ten = 225789,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054603,Rem) ->
	#mon{id = 81054603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 835,att = 64797607,hp_lim = 3499070799,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054801,Rem) ->
	#mon{id = 81054801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 841,att = 69956774,hp_lim = 3777665822,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054903,Rem) ->
	#mon{id = 81054903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 844,att = 74904031,hp_lim = 4044817685,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055101,Rem) ->
	#mon{id = 81055101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 850,att = 84983831,hp_lim = 4589126914,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055203,Rem) ->
	#mon{id = 81055203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 853,att = 91891594,hp_lim = 4962146125,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055401,Rem) ->
	#mon{id = 81055401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 859,att = 111766429,hp_lim = 6035387179,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055503,Rem) ->
	#mon{id = 81055503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 862,att = 45356978,hp_lim = 2285991712,hit = 816425,dodge = 544283,ten = 435426,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055701,Rem) ->
	#mon{id = 81055701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 868,att = 188460965,hp_lim = 10176892153,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055803,Rem) ->
	#mon{id = 81055803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 871,att = 258680894,hp_lim = 13968768291,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81056001,Rem) ->
	#mon{id = 81056001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 877,att = 167010617,hp_lim = 8417335109,hit = 3006191,dodge = 2004127,ten = 1603301,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000005,Rem) ->
	#mon{id = 82000005,name = "霸王兔甲",boss = 6,color = 1,module = 610,auto = 3,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000011,Rem) ->
	#mon{id = 82000011,name = "重装宅女",boss = 6,color = 1,module = 610,auto = 3,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000017,Rem) ->
	#mon{id = 82000017,name = "梦魇蝎女",boss = 6,color = 1,module = 610,auto = 3,icon = 10030006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(83000001,Rem) ->
	#mon{id = 83000001,name = "机械战士",boss = 5,color = 1,module = 610,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 200,att = 5000,hp_lim = 100000000000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,drop = 1,is_armor = 1,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(84000003,Rem) ->
	#mon{id = 84000003,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 381,att = 202153,hp_lim = 6263446,hit = 7456,dodge = 4970,ten = 3976,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000009,Rem) ->
	#mon{id = 84000009,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 385,att = 577085,hp_lim = 15470809,hit = 9208,dodge = 6139,ten = 4911,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000015,Rem) ->
	#mon{id = 84000015,name = "辰日",boss = 6,type = 1,color = 1,module = 610,icon = 100300042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 388,att = 497689,hp_lim = 17259326,hit = 10273,dodge = 6848,ten = 5479,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000021,Rem) ->
	#mon{id = 84000021,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 395,att = 289146,hp_lim = 8958807,hit = 10665,dodge = 7110,ten = 5688,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000027,Rem) ->
	#mon{id = 84000027,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 401,att = 288167,hp_lim = 8928463,hit = 10629,dodge = 7086,ten = 5668,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000033,Rem) ->
	#mon{id = 84000033,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 407,att = 331451,hp_lim = 10269577,hit = 12225,dodge = 8150,ten = 6520,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000039,Rem) ->
	#mon{id = 84000039,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 411,att = 325138,hp_lim = 10073965,hit = 11992,dodge = 7995,ten = 6396,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000045,Rem) ->
	#mon{id = 84000045,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 423,att = 384263,hp_lim = 11905860,hit = 14173,dodge = 9449,ten = 7559,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000051,Rem) ->
	#mon{id = 84000051,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 431,att = 402430,hp_lim = 12468760,hit = 14843,dodge = 9895,ten = 7916,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000057,Rem) ->
	#mon{id = 84000057,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 437,att = 442208,hp_lim = 13701223,hit = 16310,dodge = 10873,ten = 8699,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000063,Rem) ->
	#mon{id = 84000063,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 441,att = 448176,hp_lim = 13886117,hit = 16531,dodge = 11020,ten = 8816,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000069,Rem) ->
	#mon{id = 84000069,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 453,att = 520547,hp_lim = 16128441,hit = 19200,dodge = 12800,ten = 10240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000075,Rem) ->
	#mon{id = 84000075,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 461,att = 526786,hp_lim = 16321753,hit = 19430,dodge = 12953,ten = 10363,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000081,Rem) ->
	#mon{id = 84000081,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 467,att = 590111,hp_lim = 18283795,hit = 21766,dodge = 14510,ten = 11608,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000087,Rem) ->
	#mon{id = 84000087,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 471,att = 580670,hp_lim = 17991255,hit = 21418,dodge = 14278,ten = 11423,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000093,Rem) ->
	#mon{id = 84000093,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 483,att = 665015,hp_lim = 20604563,hit = 24529,dodge = 16352,ten = 13082,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000099,Rem) ->
	#mon{id = 84000099,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 491,att = 689304,hp_lim = 21357137,hit = 25425,dodge = 16950,ten = 13560,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000105,Rem) ->
	#mon{id = 84000105,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 497,att = 764140,hp_lim = 23675842,hit = 28185,dodge = 18790,ten = 15032,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000111,Rem) ->
	#mon{id = 84000111,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 501,att = 771390,hp_lim = 23900449,hit = 28452,dodge = 18968,ten = 15174,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000117,Rem) ->
	#mon{id = 84000117,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 513,att = 892152,hp_lim = 27642115,hit = 32907,dodge = 21938,ten = 17550,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000123,Rem) ->
	#mon{id = 84000123,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 522,att = 982707,hp_lim = 30447831,hit = 36247,dodge = 24164,ten = 19331,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000129,Rem) ->
	#mon{id = 84000129,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 534,att = 1170135,hp_lim = 36255030,hit = 43160,dodge = 28773,ten = 23019,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000135,Rem) ->
	#mon{id = 84000135,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 542,att = 1249057,hp_lim = 38700309,hit = 46071,dodge = 30714,ten = 24571,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000141,Rem) ->
	#mon{id = 84000141,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 554,att = 1494542,hp_lim = 46306319,hit = 55126,dodge = 36751,ten = 29400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000147,Rem) ->
	#mon{id = 84000147,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 563,att = 1640923,hp_lim = 50841733,hit = 60525,dodge = 40350,ten = 32280,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000153,Rem) ->
	#mon{id = 84000153,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 575,att = 1892728,hp_lim = 58643548,hit = 69813,dodge = 46542,ten = 37233,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000159,Rem) ->
	#mon{id = 84000159,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 583,att = 2022314,hp_lim = 62658596,hit = 74593,dodge = 49729,ten = 39783,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000165,Rem) ->
	#mon{id = 84000165,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 595,att = 2429284,hp_lim = 75268007,hit = 89604,dodge = 59736,ten = 47789,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000171,Rem) ->
	#mon{id = 84000171,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 606,att = 2648600,hp_lim = 82063187,hit = 97694,dodge = 65129,ten = 52103,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000177,Rem) ->
	#mon{id = 84000177,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 624,att = 3305558,hp_lim = 102418117,hit = 121926,dodge = 81284,ten = 65027,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000183,Rem) ->
	#mon{id = 84000183,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 638,att = 3826043,hp_lim = 118544612,hit = 141124,dodge = 94083,ten = 75266,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000189,Rem) ->
	#mon{id = 84000189,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 656,att = 4768839,hp_lim = 147755850,hit = 175899,dodge = 117266,ten = 93813,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000195,Rem) ->
	#mon{id = 84000195,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 670,att = 5413451,hp_lim = 167728262,hit = 199676,dodge = 133117,ten = 106494,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000201,Rem) ->
	#mon{id = 84000201,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 688,att = 6739141,hp_lim = 208802918,hit = 248574,dodge = 165716,ten = 132573,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000207,Rem) ->
	#mon{id = 84000207,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 702,att = 7652685,hp_lim = 237107789,hit = 282271,dodge = 188180,ten = 150544,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000213,Rem) ->
	#mon{id = 84000213,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 720,att = 9515723,hp_lim = 294831423,hit = 350989,dodge = 233993,ten = 187194,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000219,Rem) ->
	#mon{id = 84000219,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 734,att = 11025306,hp_lim = 341603758,hit = 406671,dodge = 271114,ten = 216891,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000225,Rem) ->
	#mon{id = 84000225,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 752,att = 12656498,hp_lim = 392143958,hit = 466838,dodge = 311225,ten = 248980,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000231,Rem) ->
	#mon{id = 84000231,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 766,att = 13422782,hp_lim = 415886196,hit = 495102,dodge = 330068,ten = 264054,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000237,Rem) ->
	#mon{id = 84000237,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 784,att = 15241840,hp_lim = 472247188,hit = 562199,dodge = 374799,ten = 299839,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000243,Rem) ->
	#mon{id = 84000243,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 798,att = 16494305,hp_lim = 511053060,hit = 608396,dodge = 405597,ten = 324478,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000249,Rem) ->
	#mon{id = 84000249,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 816,att = 19278235,hp_lim = 597309250,hit = 711082,dodge = 474054,ten = 379243,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000255,Rem) ->
	#mon{id = 84000255,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 830,att = 21715399,hp_lim = 672821402,hit = 800977,dodge = 533985,ten = 427188,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000261,Rem) ->
	#mon{id = 84000261,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 848,att = 29147159,hp_lim = 903084115,hit = 1075100,dodge = 716733,ten = 573386,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000267,Rem) ->
	#mon{id = 84000267,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 862,att = 43825726,hp_lim = 1357879078,hit = 1616522,dodge = 1077681,ten = 862145,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000273,Rem) ->
	#mon{id = 84000273,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 880,att = 225195121,hp_lim = 6977357038,hit = 8306377,dodge = 5537584,ten = 4430067,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(_MonTypeId, _Rem) -> [].