%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc
%%% 怪物配置数据（4/6）
%%% @end
%%% -------------------------------------------------------
-module(data_mon_4).
-export([
		get/2
	]).
-include("scene.hrl").

%% 获取怪物配置
%% Rem是求余结果，
%%   主要目的是为了拆散编译期生成大的literal字面常量，
%%   减少热更新移除旧模块时literal拷贝引发内存暴涨问题，
%%   此值请勿用于它处，不保证未来取值
-spec get(MonTypeId, Rem) -> #mon{} | [] when
	MonTypeId :: non_neg_integer(), Rem :: any().
get(4,Rem) ->
	#mon{id = 4,name = "测试boss",boss = 2,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 1,att = 1,hp_lim = 1000,striking_distance = 50,tracing_distance = 300,warning_range = 200,speed = 150,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(10,Rem) ->
	#mon{id = 10,name = "归属掉落3",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(16,Rem) ->
	#mon{id = 16,name = "掉落红装",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(22,Rem) ->
	#mon{id = 22,name = "掉落100个",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 550,att = 58686,hp_lim = 32474148,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(28,Rem) ->
	#mon{id = 28,name = "任务归属",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(34,Rem) ->
	#mon{id = 34,name = "冰神",boss = 3,type = 1,color = 3,icon = 1202008,icon_effect = <<"0"/utf8>>,weapon_id = 1202008,lv = 600,att = 2245,hp_lim = 614740845,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 800,tracing_distance = 2000,warning_range = 2000,hate_range = 2000,speed = 300,skill = [{20005600,1},{20005601,1},{20005603,1},{20005602,1},{20005605,1},{20005604,1}],att_time = 2000,att_type = 1,drop = 1,is_armor = 1,rem_flag = Rem};
get(100,Rem) ->
	#mon{id = 100,name = "重生怪",type = 1,color = 2,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 1,att = 1,hp_lim = 10000,striking_distance = 200,tracing_distance = 500,warning_range = 200,speed = 150,skill = [{1110000001,1}],retime = 2000,att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(112,Rem) ->
	#mon{id = 112,name = "个人独占最后一击",color = 1,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 112,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 112,is_fight_back = 0,rem_flag = Rem};
get(130,Rem) ->
	#mon{id = 130,name = "均等分配伤害最高",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 130,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 130,rem_flag = Rem};
get(142,Rem) ->
	#mon{id = 142,name = "先到先得最后一击",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 142,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 142,rem_flag = Rem};
get(9004,Rem) ->
	#mon{id = 9004,name = "灵魂收割者",boss = 6,type = 1,color = 1,auto = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 109000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(9010,Rem) ->
	#mon{id = 9010,name = "穿刺异形",boss = 6,type = 1,color = 1,auto = 1,icon = 100400031,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 112000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(9016,Rem) ->
	#mon{id = 9016,name = "赛博武士",boss = 6,type = 1,color = 1,auto = 1,icon = 100300072,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 115000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10006,Rem) ->
	#mon{id = 10006,name = "暴走机甲",boss = 6,type = 1,color = 1,auto = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 102000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10012,Rem) ->
	#mon{id = 10012,name = "地狱魔犬",boss = 6,type = 1,color = 1,auto = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 105000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10018,Rem) ->
	#mon{id = 10018,name = "灵魂暴君",boss = 6,type = 1,color = 1,auto = 1,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 108000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(10024,Rem) ->
	#mon{id = 10024,name = "寄生魔兽",boss = 6,type = 1,color = 1,auto = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 100,hp_lim = 111000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 100,is_fight_back = 0,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(400102,Rem) ->
	#mon{id = 400102,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 50,att = 956,hp_lim = 51657,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400402,Rem) ->
	#mon{id = 400402,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 80,att = 1170,hp_lim = 63189,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500002,Rem) ->
	#mon{id = 500002,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 65,att = 134,hp_lim = 4542,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500008,Rem) ->
	#mon{id = 500008,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 80,att = 482,hp_lim = 32666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500014,Rem) ->
	#mon{id = 500014,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 104,att = 1085,hp_lim = 73500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500020,Rem) ->
	#mon{id = 500020,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 115,att = 1860,hp_lim = 126000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500026,Rem) ->
	#mon{id = 500026,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 127,att = 3358,hp_lim = 227500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500032,Rem) ->
	#mon{id = 500032,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 139,att = 5166,hp_lim = 350000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500038,Rem) ->
	#mon{id = 500038,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 151,att = 6975,hp_lim = 472500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500044,Rem) ->
	#mon{id = 500044,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 163,att = 8886,hp_lim = 602000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500050,Rem) ->
	#mon{id = 500050,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 175,att = 11246,hp_lim = 761833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500056,Rem) ->
	#mon{id = 500056,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 187,att = 13278,hp_lim = 899500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500062,Rem) ->
	#mon{id = 500062,name = "绿衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 199,att = 15086,hp_lim = 1022000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500068,Rem) ->
	#mon{id = 500068,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 208,att = 16895,hp_lim = 1144500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500074,Rem) ->
	#mon{id = 500074,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 214,att = 18703,hp_lim = 1267000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500080,Rem) ->
	#mon{id = 500080,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 220,att = 20770,hp_lim = 1407000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500086,Rem) ->
	#mon{id = 500086,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 226,att = 22578,hp_lim = 1529500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500092,Rem) ->
	#mon{id = 500092,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 232,att = 24421,hp_lim = 1654333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500098,Rem) ->
	#mon{id = 500098,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 238,att = 26281,hp_lim = 1780333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500104,Rem) ->
	#mon{id = 500104,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 244,att = 28175,hp_lim = 1908666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500110,Rem) ->
	#mon{id = 500110,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 248,att = 30345,hp_lim = 2055666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500116,Rem) ->
	#mon{id = 500116,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 253,att = 32274,hp_lim = 2186333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500122,Rem) ->
	#mon{id = 500122,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 258,att = 34220,hp_lim = 2318166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500128,Rem) ->
	#mon{id = 500128,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 263,att = 36201,hp_lim = 2452333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500134,Rem) ->
	#mon{id = 500134,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 268,att = 38198,hp_lim = 2587666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500140,Rem) ->
	#mon{id = 500140,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 272,att = 40523,hp_lim = 2745166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500146,Rem) ->
	#mon{id = 500146,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 277,att = 42573,hp_lim = 2884000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500152,Rem) ->
	#mon{id = 500152,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 282,att = 44640,hp_lim = 3024000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500158,Rem) ->
	#mon{id = 500158,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 287,att = 46741,hp_lim = 3166333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500164,Rem) ->
	#mon{id = 500164,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 292,att = 48842,hp_lim = 3308666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500170,Rem) ->
	#mon{id = 500170,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 296,att = 51305,hp_lim = 3475500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500176,Rem) ->
	#mon{id = 500176,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 301,att = 53475,hp_lim = 3622500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500182,Rem) ->
	#mon{id = 500182,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 306,att = 55679,hp_lim = 3771833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500188,Rem) ->
	#mon{id = 500188,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 311,att = 57901,hp_lim = 3922333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500194,Rem) ->
	#mon{id = 500194,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 316,att = 60157,hp_lim = 4075166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500200,Rem) ->
	#mon{id = 500200,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 320,att = 62757,hp_lim = 4251333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500206,Rem) ->
	#mon{id = 500206,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 325,att = 65065,hp_lim = 4407666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500212,Rem) ->
	#mon{id = 500212,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 330,att = 67407,hp_lim = 4566333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500218,Rem) ->
	#mon{id = 500218,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 335,att = 69767,hp_lim = 4726166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500224,Rem) ->
	#mon{id = 500224,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 340,att = 72161,hp_lim = 4888333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500230,Rem) ->
	#mon{id = 500230,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 344,att = 74916,hp_lim = 5075000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500236,Rem) ->
	#mon{id = 500236,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 349,att = 77362,hp_lim = 5240666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500242,Rem) ->
	#mon{id = 500242,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 354,att = 79842,hp_lim = 5408666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500248,Rem) ->
	#mon{id = 500248,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 359,att = 82339,hp_lim = 5577833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500254,Rem) ->
	#mon{id = 500254,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 364,att = 84871,hp_lim = 5749333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500260,Rem) ->
	#mon{id = 500260,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 368,att = 87816,hp_lim = 5948833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500266,Rem) ->
	#mon{id = 500266,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 373,att = 90399,hp_lim = 6123833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500272,Rem) ->
	#mon{id = 500272,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 378,att = 93034,hp_lim = 6302333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500278,Rem) ->
	#mon{id = 500278,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 383,att = 95686,hp_lim = 6482000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500284,Rem) ->
	#mon{id = 500284,name = "雄鹰武士",type = 1,color = 1,auto = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 388,att = 98390,hp_lim = 6665166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500290,Rem) ->
	#mon{id = 500290,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 392,att = 101507,hp_lim = 6876333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500296,Rem) ->
	#mon{id = 500296,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 397,att = 108775,hp_lim = 7368666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510004,Rem) ->
	#mon{id = 510004,name = "生化魔人",boss = 6,type = 1,color = 1,auto = 1,icon = 100200021,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 115,att = 6120,hp_lim = 1134000,hit = 162,dodge = 108,ten = 86,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510010,Rem) ->
	#mon{id = 510010,name = "病毒异形",boss = 6,type = 1,color = 1,auto = 1,icon = 100400032,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 175,att = 37003,hp_lim = 6856500,hit = 979,dodge = 653,ten = 522,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510016,Rem) ->
	#mon{id = 510016,name = "执行者铁角",boss = 6,type = 1,color = 1,auto = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 220,att = 68340,hp_lim = 12663000,hit = 1809,dodge = 1206,ten = 964,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510022,Rem) ->
	#mon{id = 510022,name = "三头吼兽",boss = 6,type = 1,color = 1,auto = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 248,att = 99846,hp_lim = 18501000,hit = 2643,dodge = 1762,ten = 1409,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510028,Rem) ->
	#mon{id = 510028,name = "兵武女刺",boss = 6,type = 1,color = 1,auto = 1,icon = 100100071,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 272,att = 133336,hp_lim = 24706500,hit = 3529,dodge = 2353,ten = 1882,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510034,Rem) ->
	#mon{id = 510034,name = "能源守卫",boss = 6,type = 1,color = 1,auto = 1,icon = 100100062,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 296,att = 168810,hp_lim = 31279500,hit = 4468,dodge = 2979,ten = 2383,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510040,Rem) ->
	#mon{id = 510040,name = "灵魂收割者",boss = 6,type = 1,color = 1,auto = 1,icon = 100100032,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 320,att = 206493,hp_lim = 38262000,hit = 5466,dodge = 3644,ten = 2915,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510046,Rem) ->
	#mon{id = 510046,name = "海神祭祀",boss = 6,type = 1,color = 1,auto = 1,icon = 10010010,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 344,att = 246500,hp_lim = 45675000,hit = 6525,dodge = 4350,ten = 3480,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510052,Rem) ->
	#mon{id = 510052,name = "铁甲战姬",boss = 6,type = 1,color = 1,auto = 1,icon = 100100051,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 368,att = 288943,hp_lim = 53539500,hit = 7648,dodge = 5099,ten = 4079,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510058,Rem) ->
	#mon{id = 510058,name = "末世利爪",boss = 6,type = 1,color = 1,auto = 1,icon = 100100041,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 392,att = 333993,hp_lim = 61887000,hit = 8841,dodge = 5894,ten = 4715,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(650002,Rem) ->
	#mon{id = 650002,name = "时空宝箱",boss = 2,type = 1,color = 1,auto = 2,icon = 10010402,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 5000,hp_lim = 600000,striking_distance = 150,tracing_distance = 800,warning_range = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],att_time = 1000,del_hp_each_time = [1800,2200],rem_flag = Rem};
get(653002,Rem) ->
	#mon{id = 653002,name = "碎星结晶",kind = 1,color = 1,icon = 10020202,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 9999,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(653104,Rem) ->
	#mon{id = 653104,name = "技伤宝箱",kind = 1,color = 1,icon = 10010198,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(1001002,Rem) ->
	#mon{id = 1001002,name = "赛博暴民",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 42,att = 64,hp_lim = 4246,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001008,Rem) ->
	#mon{id = 1001008,name = "街头分子",type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 116,att = 194,hp_lim = 12740,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001014,Rem) ->
	#mon{id = 1001014,name = "矿坑蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 82,att = 1164,hp_lim = 76440,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001020,Rem) ->
	#mon{id = 1001020,name = "机械蜜蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 3235,hp_lim = 212333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1200106,Rem) ->
	#mon{id = 1200106,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 112,att = 3456,hp_lim = 169694,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200112,Rem) ->
	#mon{id = 1200112,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 130,att = 9537,hp_lim = 498960,hit = 270,dodge = 180,ten = 144,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200118,Rem) ->
	#mon{id = 1200118,name = "上阵宠物",kind = 7,type = 1,color = 2,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 160,att = 23120,hp_lim = 6048000,hit = 720,dodge = 480,ten = 384,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,is_be_clicked = 0,rem_flag = Rem};
get(1200202,Rem) ->
	#mon{id = 1200202,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 118,att = 4427,hp_lim = 217350,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200208,Rem) ->
	#mon{id = 1200208,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 145,att = 14305,hp_lim = 748440,hit = 495,dodge = 330,ten = 264,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200214,Rem) ->
	#mon{id = 1200214,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 175,att = 15400,hp_lim = 756000,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200304,Rem) ->
	#mon{id = 1200304,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 155,att = 10164,hp_lim = 498960,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200310,Rem) ->
	#mon{id = 1200310,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 185,att = 16170,hp_lim = 793800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200316,Rem) ->
	#mon{id = 1200316,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 215,att = 27450,hp_lim = 1347570,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200406,Rem) ->
	#mon{id = 1200406,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 195,att = 18018,hp_lim = 884520,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200412,Rem) ->
	#mon{id = 1200412,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 225,att = 54621,hp_lim = 2857680,hit = 1620,dodge = 1080,ten = 864,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200502,Rem) ->
	#mon{id = 1200502,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 203,att = 20020,hp_lim = 982800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200508,Rem) ->
	#mon{id = 1200508,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 230,att = 59389,hp_lim = 3107160,hit = 1849,dodge = 1233,ten = 986,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200514,Rem) ->
	#mon{id = 1200514,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 260,att = 48156,hp_lim = 2364034,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200604,Rem) ->
	#mon{id = 1200604,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 235,att = 35652,hp_lim = 1750215,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200610,Rem) ->
	#mon{id = 1200610,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 265,att = 52491,hp_lim = 2576878,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200616,Rem) ->
	#mon{id = 1200616,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 295,att = 75506,hp_lim = 3706673,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200706,Rem) ->
	#mon{id = 1200706,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 265,att = 52491,hp_lim = 2576878,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200712,Rem) ->
	#mon{id = 1200712,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 295,att = 141696,hp_lim = 7413346,hit = 4412,dodge = 2941,ten = 2353,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200802,Rem) ->
	#mon{id = 1200802,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 268,att = 56914,hp_lim = 2793979,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200808,Rem) ->
	#mon{id = 1200808,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 295,att = 141696,hp_lim = 7413346,hit = 4412,dodge = 2941,ten = 2353,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200814,Rem) ->
	#mon{id = 1200814,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 325,att = 100915,hp_lim = 4954054,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200904,Rem) ->
	#mon{id = 1200904,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 295,att = 75506,hp_lim = 3706673,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200910,Rem) ->
	#mon{id = 1200910,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 325,att = 100915,hp_lim = 4954054,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200916,Rem) ->
	#mon{id = 1200916,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 355,att = 128970,hp_lim = 6331265,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201006,Rem) ->
	#mon{id = 1201006,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 325,att = 100915,hp_lim = 4954054,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201012,Rem) ->
	#mon{id = 1201012,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 355,att = 242028,hp_lim = 12662531,hit = 7537,dodge = 5024,ten = 4019,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201102,Rem) ->
	#mon{id = 1201102,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 328,att = 100915,hp_lim = 4954054,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201108,Rem) ->
	#mon{id = 1201108,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 355,att = 242028,hp_lim = 12662531,hit = 7537,dodge = 5024,ten = 4019,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201114,Rem) ->
	#mon{id = 1201114,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 385,att = 165866,hp_lim = 8142532,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201204,Rem) ->
	#mon{id = 1201204,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 355,att = 128970,hp_lim = 6331265,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201210,Rem) ->
	#mon{id = 1201210,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 385,att = 165866,hp_lim = 8142532,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201216,Rem) ->
	#mon{id = 1201216,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 415,att = 206210,hp_lim = 10123040,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201306,Rem) ->
	#mon{id = 1201306,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 385,att = 165866,hp_lim = 8142532,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201312,Rem) ->
	#mon{id = 1201312,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 415,att = 386978,hp_lim = 20246080,hit = 12051,dodge = 8034,ten = 6427,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201402,Rem) ->
	#mon{id = 1201402,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 388,att = 172342,hp_lim = 8460453,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201408,Rem) ->
	#mon{id = 1201408,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 415,att = 386978,hp_lim = 20246080,hit = 12051,dodge = 8034,ten = 6427,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201414,Rem) ->
	#mon{id = 1201414,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 445,att = 258066,hp_lim = 12668709,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201504,Rem) ->
	#mon{id = 1201504,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 415,att = 206210,hp_lim = 10123040,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201510,Rem) ->
	#mon{id = 1201510,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 445,att = 258066,hp_lim = 12668709,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201516,Rem) ->
	#mon{id = 1201516,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 475,att = 306177,hp_lim = 15030531,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201606,Rem) ->
	#mon{id = 1201606,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 445,att = 258066,hp_lim = 12668709,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201612,Rem) ->
	#mon{id = 1201612,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 475,att = 574579,hp_lim = 30061062,hit = 17893,dodge = 11928,ten = 9543,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201702,Rem) ->
	#mon{id = 1201702,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 448,att = 265886,hp_lim = 13052619,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201708,Rem) ->
	#mon{id = 1201708,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 475,att = 574579,hp_lim = 30061062,hit = 17893,dodge = 11928,ten = 9543,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201714,Rem) ->
	#mon{id = 1201714,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 505,att = 374961,hp_lim = 18407191,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201804,Rem) ->
	#mon{id = 1201804,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 475,att = 306177,hp_lim = 15030531,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201810,Rem) ->
	#mon{id = 1201810,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 505,att = 374961,hp_lim = 18407191,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201816,Rem) ->
	#mon{id = 1201816,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 535,att = 509329,hp_lim = 25003468,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201906,Rem) ->
	#mon{id = 1201906,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 505,att = 374961,hp_lim = 18407191,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201912,Rem) ->
	#mon{id = 1201912,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 535,att = 955820,hp_lim = 50006937,hit = 29766,dodge = 19844,ten = 15875,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202002,Rem) ->
	#mon{id = 1202002,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 508,att = 383950,hp_lim = 18848489,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202008,Rem) ->
	#mon{id = 1202008,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 535,att = 955820,hp_lim = 50006937,hit = 29766,dodge = 19844,ten = 15875,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202014,Rem) ->
	#mon{id = 1202014,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 565,att = 712011,hp_lim = 34953274,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202104,Rem) ->
	#mon{id = 1202104,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 535,att = 509329,hp_lim = 25003468,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202110,Rem) ->
	#mon{id = 1202110,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 565,att = 712011,hp_lim = 34953274,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202116,Rem) ->
	#mon{id = 1202116,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 595,att = 958273,hp_lim = 47042504,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202206,Rem) ->
	#mon{id = 1202206,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 565,att = 712011,hp_lim = 34953274,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202212,Rem) ->
	#mon{id = 1202212,name = "突击青年",kind = 6,boss = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 595,att = 1798317,hp_lim = 94085008,hit = 56002,dodge = 37335,ten = 29868,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202302,Rem) ->
	#mon{id = 1202302,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 568,att = 726251,hp_lim = 35652338,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202308,Rem) ->
	#mon{id = 1202308,name = "进击丧尸",kind = 6,boss = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 595,att = 1798317,hp_lim = 94085008,hit = 56002,dodge = 37335,ten = 29868,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202314,Rem) ->
	#mon{id = 1202314,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 625,att = 1289709,hp_lim = 63313018,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202404,Rem) ->
	#mon{id = 1202404,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 595,att = 958273,hp_lim = 47042504,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202410,Rem) ->
	#mon{id = 1202410,name = "进击秋田",kind = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 625,att = 1289709,hp_lim = 63313018,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202416,Rem) ->
	#mon{id = 1202416,name = "保护者员工",kind = 7,type = 1,color = 2,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 655,att = 1735779,hp_lim = 85210986,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(2001202,Rem) ->
	#mon{id = 2001202,name = "赛博暴民",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 85,att = 470,hp_lim = 12740,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2002102,Rem) ->
	#mon{id = 2002102,name = "病毒行者",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 626,hp_lim = 16986,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2004202,Rem) ->
	#mon{id = 2004202,name = "海族迦娜",type = 1,color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 125,att = 4388,hp_lim = 118906,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2005102,Rem) ->
	#mon{id = 2005102,name = "机械触须",type = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 4701,hp_lim = 127400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2007202,Rem) ->
	#mon{id = 2007202,name = "赛博暴民",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 160,att = 7522,hp_lim = 203840,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2008102,Rem) ->
	#mon{id = 2008102,name = "生化护卫",type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 165,att = 7836,hp_lim = 212333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2010202,Rem) ->
	#mon{id = 2010202,name = "病毒行者",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 185,att = 10186,hp_lim = 276033,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2011102,Rem) ->
	#mon{id = 2011102,name = "海族迦娜",type = 1,color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 195,att = 9403,hp_lim = 254800,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2013202,Rem) ->
	#mon{id = 2013202,name = "赛博暴民",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 220,att = 13791,hp_lim = 373706,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2014102,Rem) ->
	#mon{id = 2014102,name = "机械触须",type = 1,color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 20373,hp_lim = 552066,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2100106,Rem) ->
	#mon{id = 2100106,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 145,att = 2297,hp_lim = 1540000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 787,is_hit_ac = 1,rem_flag = Rem};
get(2100202,Rem) ->
	#mon{id = 2100202,name = "音乐丧民",color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 175,att = 4344,hp_lim = 2912000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 816,is_hit_ac = 1,rem_flag = Rem};
get(2100208,Rem) ->
	#mon{id = 2100208,name = "赛博暴民",color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 205,att = 6475,hp_lim = 4340000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 847,is_hit_ac = 1,rem_flag = Rem};
get(2100304,Rem) ->
	#mon{id = 2100304,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 235,att = 9671,hp_lim = 6482280,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 900,is_hit_ac = 1,rem_flag = Rem};
get(2100310,Rem) ->
	#mon{id = 2100310,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 265,att = 14240,hp_lim = 9543996,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 980,is_hit_ac = 1,rem_flag = Rem};
get(2100406,Rem) ->
	#mon{id = 2100406,name = "原始巫妖",color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 295,att = 20483,hp_lim = 13728421,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1054,is_hit_ac = 1,rem_flag = Rem};
get(2100502,Rem) ->
	#mon{id = 2100502,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 325,att = 27376,hp_lim = 18348351,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1172,is_hit_ac = 1,rem_flag = Rem};
get(2100508,Rem) ->
	#mon{id = 2100508,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 355,att = 34987,hp_lim = 23449132,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1284,is_hit_ac = 1,rem_flag = Rem};
get(2100604,Rem) ->
	#mon{id = 2100604,name = "生化守卫",color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 385,att = 44996,hp_lim = 30157526,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1420,is_hit_ac = 1,rem_flag = Rem};
get(2100610,Rem) ->
	#mon{id = 2100610,name = "赛博先锋",color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 415,att = 55941,hp_lim = 37492742,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1567,is_hit_ac = 1,rem_flag = Rem};
get(2100706,Rem) ->
	#mon{id = 2100706,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 445,att = 70009,hp_lim = 46921147,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1723,is_hit_ac = 1,rem_flag = Rem};
get(2100802,Rem) ->
	#mon{id = 2100802,name = "音乐丧民",color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 475,att = 83061,hp_lim = 55668634,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100808,Rem) ->
	#mon{id = 2100808,name = "赛博暴民",color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 505,att = 101721,hp_lim = 68174785,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100904,Rem) ->
	#mon{id = 2100904,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 535,att = 138173,hp_lim = 92605443,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100910,Rem) ->
	#mon{id = 2100910,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 565,att = 193157,hp_lim = 129456572,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101006,Rem) ->
	#mon{id = 2101006,name = "原始巫妖",color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 595,att = 259964,hp_lim = 174231498,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101102,Rem) ->
	#mon{id = 2101102,name = "多足脑虫",color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 625,att = 349877,hp_lim = 234492657,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101108,Rem) ->
	#mon{id = 2101108,name = "海族迦娜",color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 655,att = 470889,hp_lim = 315596246,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101204,Rem) ->
	#mon{id = 2101204,name = "生化守卫",color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 685,att = 646430,hp_lim = 433246016,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101210,Rem) ->
	#mon{id = 2101210,name = "赛博先锋",color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 715,att = 870010,hp_lim = 583092097,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101306,Rem) ->
	#mon{id = 2101306,name = "改造水母",color = 1,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 745,att = 1170919,hp_lim = 784765191,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101402,Rem) ->
	#mon{id = 2101402,name = "音乐丧民",color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 775,att = 1575903,hp_lim = 1056190625,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101408,Rem) ->
	#mon{id = 2101408,name = "赛博暴民",color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 805,att = 2295793,hp_lim = 1538670301,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101504,Rem) ->
	#mon{id = 2101504,name = "机械章鱼",color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 835,att = 3766493,hp_lim = 2524351725,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101510,Rem) ->
	#mon{id = 2101510,name = "玛雅三角",color = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 865,att = 17650238,hp_lim = 11829414898,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2300002,Rem) ->
	#mon{id = 2300002,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 125,att = 10108,hp_lim = 311850,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300008,Rem) ->
	#mon{id = 2300008,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 155,att = 23930,hp_lim = 649687,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300014,Rem) ->
	#mon{id = 2300014,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 210,att = 52225,hp_lim = 1611225,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300020,Rem) ->
	#mon{id = 2300020,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 270,att = 102912,hp_lim = 3492474,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300026,Rem) ->
	#mon{id = 2300026,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 330,att = 192223,hp_lim = 6523372,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300032,Rem) ->
	#mon{id = 2300032,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 390,att = 281244,hp_lim = 10046789,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300038,Rem) ->
	#mon{id = 2300038,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 450,att = 480774,hp_lim = 16315774,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300044,Rem) ->
	#mon{id = 2300044,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 510,att = 1023370,hp_lim = 28941300,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300050,Rem) ->
	#mon{id = 2300050,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 570,att = 3013798,hp_lim = 68185100,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(3000004,Rem) ->
	#mon{id = 3000004,name = "虚空死神",boss = 6,color = 1,module = 610,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10010002,Rem) ->
	#mon{id = 10010002,name = "机械武士",boss = 7,color = 3,icon = 20030007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 20,att = 500,hp_lim = 10368,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 1,is_hit_ac = 1,rem_flag = Rem};
get(10010104,Rem) ->
	#mon{id = 10010104,name = "异化黑骸",boss = 1,type = 1,color = 1,icon = 10010107,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 6,att = 16,hp_lim = 1185,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 4,is_hit_ac = 1,rem_flag = Rem};
get(10020106,Rem) ->
	#mon{id = 10020106,name = "初级执行者",boss = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202038,lv = 40,att = 50,hp_lim = 3132,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 7,is_hit_ac = 1,rem_flag = Rem};
get(10020202,Rem) ->
	#mon{id = 10020202,name = "摩托核心",kind = 2,color = 1,icon = 10020205,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10040104,Rem) ->
	#mon{id = 10040104,name = "执行者",boss = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 67,att = 77,hp_lim = 3774,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 10,is_patrol = 1,is_hit_ac = 1,rem_flag = Rem};
get(10050106,Rem) ->
	#mon{id = 10050106,name = "球晶海怪",boss = 1,color = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 105,att = 100,hp_lim = 29730,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 16,is_hit_ac = 1,rem_flag = Rem};
get(10050202,Rem) ->
	#mon{id = 10050202,name = "科技装备",kind = 2,color = 1,icon = 10050202,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 9700,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10070104,Rem) ->
	#mon{id = 10070104,name = "过街老鼠",boss = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 126,att = 100,hp_lim = 192000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 18,is_hit_ac = 1,rem_flag = Rem};
get(10070110,Rem) ->
	#mon{id = 10070110,name = "监视黄蜂",boss = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 146,att = 100,hp_lim = 352000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 21,is_hit_ac = 1,rem_flag = Rem};
get(10080106,Rem) ->
	#mon{id = 10080106,name = "变异老鼠",boss = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 175,att = 100,hp_lim = 512000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 25,is_hit_ac = 1,rem_flag = Rem};
get(10080112,Rem) ->
	#mon{id = 10080112,name = "伪装执行者",boss = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 230,att = 100,hp_lim = 1315200,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 30,is_hit_ac = 1,rem_flag = Rem};
get(10080202,Rem) ->
	#mon{id = 10080202,name = "堆叠的纸箱",kind = 2,color = 1,icon = 10080201,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10090102,Rem) ->
	#mon{id = 10090102,name = "迷失医士",boss = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 250,att = 100,hp_lim = 1824625,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 30,is_hit_ac = 1,rem_flag = Rem};
get(10100104,Rem) ->
	#mon{id = 10100104,name = "改造沙鼠",boss = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 330,att = 100,hp_lim = 4417925,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 49,is_hit_ac = 1,rem_flag = Rem};
get(10110106,Rem) ->
	#mon{id = 10110106,name = "监视黄蜂",boss = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 415,att = 100,hp_lim = 8569750,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 78,is_hit_ac = 1,rem_flag = Rem};
get(10110202,Rem) ->
	#mon{id = 10110202,name = "登记表",kind = 2,color = 1,icon = 10070202,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10120102,Rem) ->
	#mon{id = 10120102,name = "矿坑蜥蜴",boss = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 435,att = 100,hp_lim = 10086000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 94,is_hit_ac = 1,rem_flag = Rem};
get(10130104,Rem) ->
	#mon{id = 10130104,name = "晶翅巡逻者",boss = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 485,att = 100,hp_lim = 13769625,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 142,is_hit_ac = 1,rem_flag = Rem};
get(10140106,Rem) ->
	#mon{id = 10140106,name = "黑市巫者",boss = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 1007006,lv = 535,att = 100,hp_lim = 21166950,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 192,rem_flag = Rem};
get(10140202,Rem) ->
	#mon{id = 10140202,name = "神秘包裹",kind = 2,color = 1,icon = 10010203,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10150102,Rem) ->
	#mon{id = 10150102,name = "阴影傀儡",boss = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202010,lv = 555,att = 100,hp_lim = 26613175,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 212,rem_flag = Rem};
get(11001004,Rem) ->
	#mon{id = 11001004,name = "印第舞者",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 126,att = 3109,hp_lim = 277200,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001010,Rem) ->
	#mon{id = 11001010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 138,att = 4098,hp_lim = 365400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001016,Rem) ->
	#mon{id = 11001016,name = "音乐丧民",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 5830,hp_lim = 519750,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001022,Rem) ->
	#mon{id = 11001022,name = "蒙面刺客",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 162,att = 8480,hp_lim = 756000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001028,Rem) ->
	#mon{id = 11001028,name = "甜心女仆",type = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 174,att = 11742,hp_lim = 1046850,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002006,Rem) ->
	#mon{id = 11002006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 100300082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 190,att = 26180,hp_lim = 4851000,hit = 693,dodge = 462,ten = 369,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002012,Rem) ->
	#mon{id = 11002012,name = "狂暴恶犬",boss = 6,type = 1,color = 1,icon = 100300011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 202,att = 35360,hp_lim = 6552000,hit = 936,dodge = 624,ten = 499,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002018,Rem) ->
	#mon{id = 11002018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 100100031,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 214,att = 45673,hp_lim = 8463000,hit = 1209,dodge = 806,ten = 644,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002024,Rem) ->
	#mon{id = 11002024,name = "地底魔蝎",boss = 6,type = 1,color = 1,icon = 10030006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 226,att = 53567,hp_lim = 9925650,hit = 1417,dodge = 945,ten = 756,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002030,Rem) ->
	#mon{id = 11002030,name = "冷血三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 238,att = 57723,hp_lim = 10695762,hit = 1527,dodge = 1018,ten = 814,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003002,Rem) ->
	#mon{id = 11003002,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 242,att = 38293,hp_lim = 3413872,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003008,Rem) ->
	#mon{id = 11003008,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 254,att = 43566,hp_lim = 3884000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003014,Rem) ->
	#mon{id = 11003014,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 266,att = 51683,hp_lim = 4607600,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003020,Rem) ->
	#mon{id = 11003020,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 278,att = 54993,hp_lim = 4902678,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003026,Rem) ->
	#mon{id = 11003026,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 290,att = 63466,hp_lim = 5658138,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004004,Rem) ->
	#mon{id = 11004004,name = "印第舞者",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 306,att = 79065,hp_lim = 7048764,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004010,Rem) ->
	#mon{id = 11004010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 318,att = 88824,hp_lim = 7918792,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004016,Rem) ->
	#mon{id = 11004016,name = "音乐丧民",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 330,att = 97323,hp_lim = 8676509,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004022,Rem) ->
	#mon{id = 11004022,name = "蒙面刺客",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 342,att = 109506,hp_lim = 9762634,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004028,Rem) ->
	#mon{id = 11004028,name = "甜心女仆",type = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 354,att = 122237,hp_lim = 10897584,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005006,Rem) ->
	#mon{id = 11005006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 100300082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 238010,hp_lim = 44101919,hit = 6300,dodge = 4200,ten = 3360,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005012,Rem) ->
	#mon{id = 11005012,name = "狂暴恶犬",boss = 6,type = 1,color = 1,icon = 100300011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 382,att = 286384,hp_lim = 53065309,hit = 7580,dodge = 5053,ten = 4043,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005018,Rem) ->
	#mon{id = 11005018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 100100031,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 394,att = 352874,hp_lim = 65385639,hit = 9340,dodge = 6227,ten = 4981,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005024,Rem) ->
	#mon{id = 11005024,name = "地底魔蝎",boss = 6,type = 1,color = 1,icon = 10030006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 412,att = 443128,hp_lim = 82109104,hit = 11729,dodge = 7819,ten = 6255,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005030,Rem) ->
	#mon{id = 11005030,name = "冷血三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 436,att = 564396,hp_lim = 104579394,hit = 14939,dodge = 9959,ten = 7967,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006002,Rem) ->
	#mon{id = 11006002,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 444,att = 384098,hp_lim = 34242713,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006008,Rem) ->
	#mon{id = 11006008,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 468,att = 476232,hp_lim = 42456589,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006014,Rem) ->
	#mon{id = 11006014,name = "神殿守卫",type = 1,color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 492,att = 580647,hp_lim = 51765286,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006020,Rem) ->
	#mon{id = 11006020,name = "影袭蜂后",type = 1,color = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 516,att = 766042,hp_lim = 68293402,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006026,Rem) ->
	#mon{id = 11006026,name = "影刺狂蜂",type = 1,color = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 540,att = 1043538,hp_lim = 93032458,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007004,Rem) ->
	#mon{id = 11007004,name = "印第舞者",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 572,att = 1570795,hp_lim = 140037900,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007010,Rem) ->
	#mon{id = 11007010,name = "躁动蜥蜴",type = 1,color = 1,icon = 10100101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 596,att = 2097850,hp_lim = 187025383,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007016,Rem) ->
	#mon{id = 11007016,name = "音乐丧民",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 620,att = 2794638,hp_lim = 249144630,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007022,Rem) ->
	#mon{id = 11007022,name = "蒙面刺客",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 644,att = 3788578,hp_lim = 337755331,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007028,Rem) ->
	#mon{id = 11007028,name = "甜心女仆",type = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 668,att = 5024766,hp_lim = 447962680,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008006,Rem) ->
	#mon{id = 11008006,name = "狂暴使者",boss = 6,type = 1,color = 1,icon = 100300082,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 700,att = 11683242,hp_lim = 2164836172,hit = 309262,dodge = 206174,ten = 164939,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008012,Rem) ->
	#mon{id = 11008012,name = "狂暴恶犬",boss = 6,type = 1,color = 1,icon = 100300011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 724,att = 15430301,hp_lim = 2859144104,hit = 408449,dodge = 272299,ten = 217839,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008018,Rem) ->
	#mon{id = 11008018,name = "亡灵死神",boss = 6,type = 1,color = 1,icon = 100100031,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 748,att = 20753882,hp_lim = 3845572301,hit = 549367,dodge = 366244,ten = 292995,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008024,Rem) ->
	#mon{id = 11008024,name = "地底魔蝎",boss = 6,type = 1,color = 1,icon = 10030006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 772,att = 27326836,hp_lim = 5063502119,hit = 723357,dodge = 482238,ten = 385790,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008030,Rem) ->
	#mon{id = 11008030,name = "冷血三角",boss = 6,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 796,att = 37384439,hp_lim = 6927116643,hit = 989588,dodge = 659725,ten = 527780,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12010000,Rem) ->
	#mon{id = 12010000,name = "boss字段预留",boss = 2,color = 4,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 24629,hp_lim = 3732752,def = 109008,hit = 34855,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12010012,Rem) ->
	#mon{id = 12010012,name = "嗜血异形",boss = 6,color = 1,module = 610,icon = 10040003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 1726,hp_lim = 88259,hit = 75,dodge = 50,ten = 40,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12020014,Rem) ->
	#mon{id = 12020014,name = "战舰枢女",boss = 6,color = 1,module = 610,icon = 100100061,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 145,att = 20973,hp_lim = 3659040,hit = 726,dodge = 484,ten = 387,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12040012,Rem) ->
	#mon{id = 12040012,name = "兔子战甲",boss = 6,color = 1,module = 610,icon = 100200041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 136302,hp_lim = 23779462,hit = 4718,dodge = 3145,ten = 2516,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12050014,Rem) ->
	#mon{id = 12050014,name = "异能伞兵",boss = 6,color = 1,module = 610,icon = 100200051,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 507148,hp_lim = 88477923,hit = 17555,dodge = 11703,ten = 9362,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13010002,Rem) ->
	#mon{id = 13010002,name = "远古血魔",boss = 3,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 1589,hp_lim = 1873005,hit = 92,dodge = 61,ten = 49,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13040002,Rem) ->
	#mon{id = 13040002,name = "雇佣兵长",boss = 3,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 360,att = 97403,hp_lim = 105952311,hit = 5255,dodge = 3503,ten = 2802,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13050004,Rem) ->
	#mon{id = 13050004,name = "地狱猎犬",boss = 3,color = 1,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 505,att = 406126,hp_lim = 441772590,hit = 21913,dodge = 14608,ten = 11687,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14010004,Rem) ->
	#mon{id = 14010004,name = "霹雳人马",boss = 4,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2125,hp_lim = 17422250,hit = 103,dodge = 69,ten = 55,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14030002,Rem) ->
	#mon{id = 14030002,name = "爆裂机甲",boss = 4,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 91042,hp_lim = 546255350,hit = 3251,dodge = 2167,ten = 1734,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14040004,Rem) ->
	#mon{id = 14040004,name = "静谧三角",boss = 4,type = 1,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 375,att = 424567,hp_lim = 2547404700,hit = 15163,dodge = 10108,ten = 8086,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14060002,Rem) ->
	#mon{id = 14060002,name = "超能兵器",boss = 4,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 1013768,hp_lim = 6082611400,hit = 36206,dodge = 24137,ten = 19309,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18010006,Rem) ->
	#mon{id = 18010006,name = "异形长枪",boss = 9,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 22366,hp_lim = 16632000,hit = 825,dodge = 550,ten = 440,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18020002,Rem) ->
	#mon{id = 18020002,name = "远古血魔",boss = 9,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 8946,hp_lim = 6652800,hit = 330,dodge = 220,ten = 176,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18030004,Rem) ->
	#mon{id = 18030004,name = "光刃利爪",boss = 9,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 77858,hp_lim = 57896088,hit = 2871,dodge = 1914,ten = 1531,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18040006,Rem) ->
	#mon{id = 18040006,name = "超能兵器",boss = 9,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 450589,hp_lim = 335061375,hit = 16620,dodge = 11080,ten = 8864,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18050002,Rem) ->
	#mon{id = 18050002,name = "疯狂博士",boss = 9,type = 1,color = 1,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 264410,hp_lim = 196617606,hit = 9752,dodge = 6501,ten = 5201,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18060004,Rem) ->
	#mon{id = 18060004,name = "病毒机甲",boss = 9,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 580,att = 1036685,hp_lim = 770886231,hit = 38238,dodge = 25492,ten = 20393,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19010002,Rem) ->
	#mon{id = 19010002,name = "光刃利爪",boss = 12,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 4533,hp_lim = 11237940,hit = 167,dodge = 111,ten = 89,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19020004,Rem) ->
	#mon{id = 19020004,name = "寄生触手",boss = 12,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 47580,hp_lim = 117936000,hit = 1755,dodge = 1170,ten = 936,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19030006,Rem) ->
	#mon{id = 19030006,name = "将级异形",boss = 12,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 340,att = 279049,hp_lim = 691676040,hit = 10292,dodge = 6861,ten = 5489,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19040002,Rem) ->
	#mon{id = 19040002,name = "不灭血魔",boss = 12,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 252651,hp_lim = 626243780,hit = 9319,dodge = 6212,ten = 4970,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19050004,Rem) ->
	#mon{id = 19050004,name = "超级机甲",boss = 12,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 490,att = 807778,hp_lim = 2002231670,hit = 29795,dodge = 19863,ten = 15890,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19060006,Rem) ->
	#mon{id = 19060006,name = "病毒人马",boss = 12,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 640,att = 3591316,hp_lim = 8901754990,hit = 132466,dodge = 88311,ten = 70648,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20010004,Rem) ->
	#mon{id = 20010004,name = "能量光侍",boss = 13,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 10522,hp_lim = 26082000,hit = 388,dodge = 258,ten = 207,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20020006,Rem) ->
	#mon{id = 20020006,name = "兵器少女",boss = 13,type = 1,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 250,att = 104346,hp_lim = 258643620,hit = 3848,dodge = 2565,ten = 2052,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20030002,Rem) ->
	#mon{id = 20030002,name = "能量光侍",boss = 13,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 84732,hp_lim = 210025870,hit = 3125,dodge = 2083,ten = 1666,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20040004,Rem) ->
	#mon{id = 20040004,name = "寄生之爪",boss = 13,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 390,att = 409593,hp_lim = 1015254470,hit = 15107,dodge = 10071,ten = 8057,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20050006,Rem) ->
	#mon{id = 20050006,name = "收割死神",boss = 13,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 540,att = 1284898,hp_lim = 3184862580,hit = 47393,dodge = 31595,ten = 25276,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20060002,Rem) ->
	#mon{id = 20060002,name = "病毒行者",boss = 13,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 530,att = 1162096,hp_lim = 2880475660,hit = 42864,dodge = 28576,ten = 22860,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(43001002,Rem) ->
	#mon{id = 43001002,name = "西城中枢",kind = 11,boss = 1,color = 1,icon = 10010306,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 1,att = 1000,hp_lim = 1131000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(43001104,Rem) ->
	#mon{id = 43001104,name = "东城守卫者",kind = 11,boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 250,att = 1000,hp_lim = 942000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(60401200,Rem) ->
	#mon{id = 60401200,name = "空间护卫",boss = 6,type = 1,color = 1,module = 604,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 2880,hp_lim = 544320000,hit = 270,dodge = 180,ten = 144,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60402004,Rem) ->
	#mon{id = 60402004,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60402010,Rem) ->
	#mon{id = 60402010,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403006,Rem) ->
	#mon{id = 60403006,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(70010002,Rem) ->
	#mon{id = 70010002,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 82,att = 866,hp_lim = 103051,hit = 36,dodge = 24,ten = 19,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010008,Rem) ->
	#mon{id = 70010008,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 2040,hp_lim = 529200,hit = 108,dodge = 72,ten = 57,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010014,Rem) ->
	#mon{id = 70010014,name = "部落猎人",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 4293,hp_lim = 561330,hit = 182,dodge = 121,ten = 97,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010020,Rem) ->
	#mon{id = 70010020,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 6120,hp_lim = 1587600,hit = 324,dodge = 216,ten = 172,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010026,Rem) ->
	#mon{id = 70010026,name = "机械触手",type = 1,color = 1,module = 610,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 115,att = 11448,hp_lim = 1496880,hit = 486,dodge = 324,ten = 259,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010032,Rem) ->
	#mon{id = 70010032,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 13260,hp_lim = 3439800,hit = 702,dodge = 468,ten = 374,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010038,Rem) ->
	#mon{id = 70010038,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 22896,hp_lim = 2993760,hit = 972,dodge = 648,ten = 518,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010044,Rem) ->
	#mon{id = 70010044,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 22440,hp_lim = 5821200,hit = 1188,dodge = 792,ten = 633,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010050,Rem) ->
	#mon{id = 70010050,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 145,att = 37206,hp_lim = 4864860,hit = 1579,dodge = 1053,ten = 842,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010056,Rem) ->
	#mon{id = 70010056,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 155,att = 34680,hp_lim = 8996400,hit = 1836,dodge = 1224,ten = 979,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010062,Rem) ->
	#mon{id = 70010062,name = "部落猎人",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 160,att = 54378,hp_lim = 7110180,hit = 2308,dodge = 1539,ten = 1231,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010068,Rem) ->
	#mon{id = 70010068,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 170,att = 48960,hp_lim = 12700800,hit = 2592,dodge = 1728,ten = 1382,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010074,Rem) ->
	#mon{id = 70010074,name = "机械触手",type = 1,color = 1,module = 610,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 175,att = 77274,hp_lim = 10103940,hit = 3280,dodge = 2187,ten = 1749,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010080,Rem) ->
	#mon{id = 70010080,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 185,att = 67320,hp_lim = 17463600,hit = 3564,dodge = 2376,ten = 1900,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010086,Rem) ->
	#mon{id = 70010086,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 190,att = 103032,hp_lim = 13471920,hit = 4374,dodge = 2916,ten = 2332,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010092,Rem) ->
	#mon{id = 70010092,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 200,att = 89760,hp_lim = 23284800,hit = 4752,dodge = 3168,ten = 2534,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010098,Rem) ->
	#mon{id = 70010098,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 205,att = 137376,hp_lim = 17962560,hit = 5832,dodge = 3888,ten = 3110,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010104,Rem) ->
	#mon{id = 70010104,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 215,att = 114240,hp_lim = 29635200,hit = 6048,dodge = 4032,ten = 3225,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010110,Rem) ->
	#mon{id = 70010110,name = "部落猎人",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 220,att = 171720,hp_lim = 22453200,hit = 7290,dodge = 4860,ten = 3888,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010116,Rem) ->
	#mon{id = 70010116,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 230,att = 155040,hp_lim = 40219200,hit = 8208,dodge = 5472,ten = 4377,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010122,Rem) ->
	#mon{id = 70010122,name = "机械触手",type = 1,color = 1,module = 610,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 235,att = 240408,hp_lim = 31434480,hit = 10206,dodge = 6804,ten = 5443,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010128,Rem) ->
	#mon{id = 70010128,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 245,att = 204000,hp_lim = 52920000,hit = 10800,dodge = 7200,ten = 5760,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010134,Rem) ->
	#mon{id = 70010134,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 250,att = 309096,hp_lim = 40415760,hit = 13122,dodge = 8748,ten = 6998,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010140,Rem) ->
	#mon{id = 70010140,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 260,att = 252960,hp_lim = 65620800,hit = 13392,dodge = 8928,ten = 7142,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010146,Rem) ->
	#mon{id = 70010146,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 265,att = 377784,hp_lim = 49397040,hit = 16038,dodge = 10692,ten = 8553,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010152,Rem) ->
	#mon{id = 70010152,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 306000,hp_lim = 79380000,hit = 16200,dodge = 10800,ten = 8640,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010158,Rem) ->
	#mon{id = 70010158,name = "部落猎人",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 457920,hp_lim = 59875200,hit = 19440,dodge = 12960,ten = 10368,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010164,Rem) ->
	#mon{id = 70010164,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 290,att = 367200,hp_lim = 95256000,hit = 19440,dodge = 12960,ten = 10368,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010170,Rem) ->
	#mon{id = 70010170,name = "机械触手",type = 1,color = 1,module = 610,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 295,att = 543780,hp_lim = 71101800,hit = 23085,dodge = 15390,ten = 12312,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010176,Rem) ->
	#mon{id = 70010176,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 428400,hp_lim = 111132000,hit = 22680,dodge = 15120,ten = 12096,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010182,Rem) ->
	#mon{id = 70010182,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 310,att = 629640,hp_lim = 82328400,hit = 26730,dodge = 17820,ten = 14256,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010188,Rem) ->
	#mon{id = 70010188,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 510000,hp_lim = 132300000,hit = 27000,dodge = 18000,ten = 14400,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010194,Rem) ->
	#mon{id = 70010194,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 325,att = 772740,hp_lim = 101039400,hit = 32805,dodge = 21870,ten = 17496,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010200,Rem) ->
	#mon{id = 70010200,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 335,att = 632400,hp_lim = 164052000,hit = 33480,dodge = 22320,ten = 17856,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010206,Rem) ->
	#mon{id = 70010206,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 340,att = 944460,hp_lim = 123492600,hit = 40095,dodge = 26730,ten = 21384,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010212,Rem) ->
	#mon{id = 70010212,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 350,att = 754800,hp_lim = 195804000,hit = 39960,dodge = 26640,ten = 21312,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010218,Rem) ->
	#mon{id = 70010218,name = "部落猎人",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 355,att = 1116180,hp_lim = 145945800,hit = 47385,dodge = 31590,ten = 25272,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010224,Rem) ->
	#mon{id = 70010224,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 365,att = 877200,hp_lim = 227556000,hit = 46440,dodge = 30960,ten = 24768,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010230,Rem) ->
	#mon{id = 70010230,name = "机械触手",type = 1,color = 1,module = 610,icon = 10050104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 370,att = 1287900,hp_lim = 168399000,hit = 54675,dodge = 36450,ten = 29160,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010236,Rem) ->
	#mon{id = 70010236,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 380,att = 999600,hp_lim = 259308000,hit = 52920,dodge = 35280,ten = 28224,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010242,Rem) ->
	#mon{id = 70010242,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 385,att = 1459620,hp_lim = 190852200,hit = 61965,dodge = 41310,ten = 33048,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010248,Rem) ->
	#mon{id = 70010248,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 395,att = 1122000,hp_lim = 291060000,hit = 59400,dodge = 39600,ten = 31680,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010254,Rem) ->
	#mon{id = 70010254,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 400,att = 1717200,hp_lim = 224532000,hit = 72900,dodge = 48600,ten = 38880,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010260,Rem) ->
	#mon{id = 70010260,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 410,att = 1428000,hp_lim = 370440000,hit = 75600,dodge = 50400,ten = 40320,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010266,Rem) ->
	#mon{id = 70010266,name = "部落猎人",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 415,att = 2146500,hp_lim = 280665000,hit = 91125,dodge = 60750,ten = 48600,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010272,Rem) ->
	#mon{id = 70010272,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 425,att = 1734000,hp_lim = 449820000,hit = 91800,dodge = 61200,ten = 48960,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010278,Rem) ->
	#mon{id = 70010278,name = "机械触手",type = 1,color = 1,module = 610,icon = 10050104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 430,att = 2575800,hp_lim = 336798000,hit = 109350,dodge = 72900,ten = 58320,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010284,Rem) ->
	#mon{id = 70010284,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 2040000,hp_lim = 529200000,hit = 108000,dodge = 72000,ten = 57600,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010290,Rem) ->
	#mon{id = 70010290,name = "独眼怪物",type = 1,color = 1,module = 610,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 445,att = 3434400,hp_lim = 449064000,hit = 145800,dodge = 97200,ten = 77760,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010296,Rem) ->
	#mon{id = 70010296,name = "回廊宝箱",kind = 1,color = 1,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 455,att = 3264000,hp_lim = 846720000,hit = 172800,dodge = 115200,ten = 92160,striking_distance = 110,tracing_distance = 800,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 3,collect_count = 1,is_fight_back = 0,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(70010500,Rem) ->
	#mon{id = 70010500,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 100100011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2815,hp_lim = 365148,hit = 74,dodge = 49,ten = 39,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010506,Rem) ->
	#mon{id = 70010506,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 100100071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 148,att = 51000,hp_lim = 6615000,hit = 1350,dodge = 900,ten = 720,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010512,Rem) ->
	#mon{id = 70010512,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 100300012,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 196,att = 153000,hp_lim = 19845000,hit = 4050,dodge = 2700,ten = 2160,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010518,Rem) ->
	#mon{id = 70010518,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 100100032,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 255,att = 306000,hp_lim = 39690000,hit = 8100,dodge = 5400,ten = 4320,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010524,Rem) ->
	#mon{id = 70010524,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 100100011,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 315,att = 530400,hp_lim = 68796000,hit = 14040,dodge = 9360,ten = 7488,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010530,Rem) ->
	#mon{id = 70010530,name = "重装宅女",boss = 6,type = 1,color = 1,module = 610,icon = 100100071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 395,att = 938400,hp_lim = 121716000,hit = 24840,dodge = 16560,ten = 13248,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010536,Rem) ->
	#mon{id = 70010536,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 100300012,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 485,att = 1428000,hp_lim = 185220000,hit = 37800,dodge = 25200,ten = 20160,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010542,Rem) ->
	#mon{id = 70010542,name = "网路死神",boss = 6,type = 1,color = 1,module = 610,icon = 100100032,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 575,att = 2040000,hp_lim = 264600000,hit = 54000,dodge = 36000,ten = 28800,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80010004,Rem) ->
	#mon{id = 80010004,name = "兽血改造者",boss = 6,type = 1,color = 3,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80030002,Rem) ->
	#mon{id = 80030002,name = "穿山蜥",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80030008,Rem) ->
	#mon{id = 80030008,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80040004,Rem) ->
	#mon{id = 80040004,name = "球形海怪",boss = 6,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80060002,Rem) ->
	#mon{id = 80060002,name = "土行从者",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80060008,Rem) ->
	#mon{id = 80060008,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80070004,Rem) ->
	#mon{id = 80070004,name = "深渊巨网",boss = 6,type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80090002,Rem) ->
	#mon{id = 80090002,name = "变异合成人",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80090008,Rem) ->
	#mon{id = 80090008,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80100004,Rem) ->
	#mon{id = 80100004,name = "蛇行者",boss = 6,type = 1,color = 3,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80120002,Rem) ->
	#mon{id = 80120002,name = "辐射章鱼",type = 1,color = 1,module = 610,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80120008,Rem) ->
	#mon{id = 80120008,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80130004,Rem) ->
	#mon{id = 80130004,name = "核心机甲",boss = 6,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80150002,Rem) ->
	#mon{id = 80150002,name = "武装蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80150008,Rem) ->
	#mon{id = 80150008,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80160004,Rem) ->
	#mon{id = 80160004,name = "原始巫妖",boss = 6,type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80180002,Rem) ->
	#mon{id = 80180002,name = "机械黄蜂",type = 1,color = 1,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80180008,Rem) ->
	#mon{id = 80180008,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80190004,Rem) ->
	#mon{id = 80190004,name = "森林贤王",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80210002,Rem) ->
	#mon{id = 80210002,name = "核心守护者",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80210008,Rem) ->
	#mon{id = 80210008,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80220004,Rem) ->
	#mon{id = 80220004,name = "合金仓鼠",boss = 6,type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80240002,Rem) ->
	#mon{id = 80240002,name = "返祖变异人",type = 1,color = 1,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80240008,Rem) ->
	#mon{id = 80240008,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80250004,Rem) ->
	#mon{id = 80250004,name = "兽血改造者",boss = 6,type = 1,color = 3,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80270002,Rem) ->
	#mon{id = 80270002,name = "穿山蜥",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80270008,Rem) ->
	#mon{id = 80270008,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80280004,Rem) ->
	#mon{id = 80280004,name = "球形海怪",boss = 6,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010102,Rem) ->
	#mon{id = 81010102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 200,att = 30333,hp_lim = 1638000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010402,Rem) ->
	#mon{id = 81010402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 209,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010702,Rem) ->
	#mon{id = 81010702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 218,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011002,Rem) ->
	#mon{id = 81011002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 227,att = 102750,hp_lim = 5178600,hit = 1849,dodge = 1233,ten = 986,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011302,Rem) ->
	#mon{id = 81011302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 236,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020002,Rem) ->
	#mon{id = 81020002,name = "中路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 240,att = 54019,hp_lim = 58340520,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81020302,Rem) ->
	#mon{id = 81020302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 250,att = 66523,hp_lim = 3592272,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020602,Rem) ->
	#mon{id = 81020602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 265,att = 79533,hp_lim = 4294798,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020902,Rem) ->
	#mon{id = 81020902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 93068,hp_lim = 5025701,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021202,Rem) ->
	#mon{id = 81021202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 295,att = 114403,hp_lim = 6177788,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021502,Rem) ->
	#mon{id = 81021502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 310,att = 277173,hp_lim = 13969523,hit = 4989,dodge = 3326,ten = 2660,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021802,Rem) ->
	#mon{id = 81021802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 325,att = 152902,hp_lim = 8256756,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022102,Rem) ->
	#mon{id = 81022102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 340,att = 177900,hp_lim = 9606611,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022402,Rem) ->
	#mon{id = 81022402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 355,att = 195409,hp_lim = 10552109,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030004,Rem) ->
	#mon{id = 81030004,name = "初级箱子",kind = 1,color = 3,module = 610,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 109,hp_lim = 5911,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81030202,Rem) ->
	#mon{id = 81030202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 363,att = 224166,hp_lim = 12104986,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030502,Rem) ->
	#mon{id = 81030502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 372,att = 497401,hp_lim = 25069039,hit = 8953,dodge = 5968,ten = 4775,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030802,Rem) ->
	#mon{id = 81030802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 381,att = 297223,hp_lim = 16050080,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031102,Rem) ->
	#mon{id = 81031102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 390,att = 344685,hp_lim = 18612998,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031402,Rem) ->
	#mon{id = 81031402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 399,att = 396483,hp_lim = 21410090,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031702,Rem) ->
	#mon{id = 81031702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 408,att = 452803,hp_lim = 24451374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032002,Rem) ->
	#mon{id = 81032002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 417,att = 692504,hp_lim = 34902226,hit = 12465,dodge = 8310,ten = 6648,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032302,Rem) ->
	#mon{id = 81032302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 426,att = 579788,hp_lim = 31308604,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032602,Rem) ->
	#mon{id = 81032602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 435,att = 650863,hp_lim = 35146617,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032902,Rem) ->
	#mon{id = 81032902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 444,att = 727277,hp_lim = 39272998,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033202,Rem) ->
	#mon{id = 81033202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 453,att = 808911,hp_lim = 43681197,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033502,Rem) ->
	#mon{id = 81033502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 462,att = 914814,hp_lim = 46106650,hit = 16466,dodge = 10977,ten = 8782,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033802,Rem) ->
	#mon{id = 81033802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 471,att = 961592,hp_lim = 51925979,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034102,Rem) ->
	#mon{id = 81034102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 480,att = 1085995,hp_lim = 58643759,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034402,Rem) ->
	#mon{id = 81034402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 489,att = 1189597,hp_lim = 64238266,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034702,Rem) ->
	#mon{id = 81034702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 498,att = 1299086,hp_lim = 70150646,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81035002,Rem) ->
	#mon{id = 81035002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 507,att = 1246593,hp_lim = 62828299,hit = 22438,dodge = 14959,ten = 11967,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040102,Rem) ->
	#mon{id = 81040102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 500,att = 1397687,hp_lim = 75475107,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040402,Rem) ->
	#mon{id = 81040402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 512,att = 1590518,hp_lim = 85888004,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040702,Rem) ->
	#mon{id = 81040702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 524,att = 1878459,hp_lim = 101436793,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041002,Rem) ->
	#mon{id = 81041002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 536,att = 1687217,hp_lim = 85035766,hit = 30369,dodge = 20246,ten = 16197,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041302,Rem) ->
	#mon{id = 81041302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 548,att = 2596130,hp_lim = 140191055,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041602,Rem) ->
	#mon{id = 81041602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 560,att = 3040473,hp_lim = 164185582,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041902,Rem) ->
	#mon{id = 81041902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 572,att = 3503198,hp_lim = 189172739,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042202,Rem) ->
	#mon{id = 81042202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 584,att = 4061205,hp_lim = 219305090,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042502,Rem) ->
	#mon{id = 81042502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 596,att = 3111276,hp_lim = 156808348,hit = 56002,dodge = 37335,ten = 29868,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042802,Rem) ->
	#mon{id = 81042802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 608,att = 5444909,hp_lim = 294025132,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043102,Rem) ->
	#mon{id = 81043102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 619,att = 6297578,hp_lim = 340069244,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043402,Rem) ->
	#mon{id = 81043402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 628,att = 6996088,hp_lim = 377788774,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043702,Rem) ->
	#mon{id = 81043702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 637,att = 7922304,hp_lim = 427804448,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044002,Rem) ->
	#mon{id = 81044002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 646,att = 5206466,hp_lim = 262405932,hit = 93716,dodge = 62477,ten = 49982,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044302,Rem) ->
	#mon{id = 81044302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 655,att = 9941281,hp_lim = 536829214,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044602,Rem) ->
	#mon{id = 81044602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 664,att = 11237311,hp_lim = 606814799,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044902,Rem) ->
	#mon{id = 81044902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 673,att = 12446502,hp_lim = 672111111,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045202,Rem) ->
	#mon{id = 81045202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 682,att = 14054260,hp_lim = 758930092,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045502,Rem) ->
	#mon{id = 81045502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 691,att = 8210073,hp_lim = 413787725,hit = 147781,dodge = 98520,ten = 78816,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045802,Rem) ->
	#mon{id = 81045802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 700,att = 17542637,hp_lim = 947302449,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050002,Rem) ->
	#mon{id = 81050002,name = "中路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 700,att = 17915885,hp_lim = 19573104980,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81050302,Rem) ->
	#mon{id = 81050302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 706,att = 19496595,hp_lim = 1052816146,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050602,Rem) ->
	#mon{id = 81050602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 715,att = 21963135,hp_lim = 1186009320,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050902,Rem) ->
	#mon{id = 81050902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 724,att = 24246972,hp_lim = 1309336517,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051202,Rem) ->
	#mon{id = 81051202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 733,att = 27293253,hp_lim = 1473835706,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051502,Rem) ->
	#mon{id = 81051502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 742,att = 13338750,hp_lim = 672273008,hit = 240097,dodge = 160065,ten = 128052,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051802,Rem) ->
	#mon{id = 81051802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 751,att = 31610199,hp_lim = 1706950772,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052102,Rem) ->
	#mon{id = 81052102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 760,att = 33835350,hp_lim = 1827108901,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052402,Rem) ->
	#mon{id = 81052402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 769,att = 35846792,hp_lim = 1935726773,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052702,Rem) ->
	#mon{id = 81052702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 778,att = 38345453,hp_lim = 2070654478,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053002,Rem) ->
	#mon{id = 81053002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 787,att = 16768983,hp_lim = 845156764,hit = 301841,dodge = 201227,ten = 160982,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053302,Rem) ->
	#mon{id = 81053302,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 796,att = 44276060,hp_lim = 2390907247,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053602,Rem) ->
	#mon{id = 81053602,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 805,att = 47793550,hp_lim = 2580851700,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053902,Rem) ->
	#mon{id = 81053902,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 814,att = 51576259,hp_lim = 2785118027,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054202,Rem) ->
	#mon{id = 81054202,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 823,att = 56199944,hp_lim = 3034797018,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054502,Rem) ->
	#mon{id = 81054502,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 832,att = 23519790,hp_lim = 1185397432,hit = 423356,dodge = 282237,ten = 225789,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054802,Rem) ->
	#mon{id = 81054802,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 841,att = 70078016,hp_lim = 3784212904,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055102,Rem) ->
	#mon{id = 81055102,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 850,att = 85128855,hp_lim = 4596958189,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055402,Rem) ->
	#mon{id = 81055402,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 859,att = 111954271,hp_lim = 6045530686,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055702,Rem) ->
	#mon{id = 81055702,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 868,att = 188772987,hp_lim = 10193741312,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81056002,Rem) ->
	#mon{id = 81056002,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 877,att = 167010617,hp_lim = 8417335109,hit = 3006191,dodge = 2004127,ten = 1603301,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000006,Rem) ->
	#mon{id = 82000006,name = "达尔机械姬",boss = 6,color = 1,module = 610,auto = 3,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000012,Rem) ->
	#mon{id = 82000012,name = "悍地魔兽",boss = 6,color = 1,module = 610,auto = 3,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000018,Rem) ->
	#mon{id = 82000018,name = "矿石巨人",boss = 6,color = 1,module = 610,auto = 3,icon = 10030008,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(83000002,Rem) ->
	#mon{id = 83000002,name = "机械战士同伴",color = 1,module = 610,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 200,att = 5000,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,drop = 1,is_armor = 1,del_hp_each_time = [9000,11000],is_hit_ac = 1,rem_flag = Rem};
get(84000004,Rem) ->
	#mon{id = 84000004,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 381,att = 525682,hp_lim = 14092752,hit = 8388,dodge = 5592,ten = 4473,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000010,Rem) ->
	#mon{id = 84000010,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 386,att = 262801,hp_lim = 8142532,hit = 9693,dodge = 6462,ten = 5169,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000016,Rem) ->
	#mon{id = 84000016,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 390,att = 580682,hp_lim = 15567234,hit = 9266,dodge = 6177,ten = 4941,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000022,Rem) ->
	#mon{id = 84000022,name = "星之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 396,att = 674908,hp_lim = 18093279,hit = 10769,dodge = 7179,ten = 5743,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000028,Rem) ->
	#mon{id = 84000028,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 402,att = 704486,hp_lim = 18886240,hit = 11241,dodge = 7494,ten = 5995,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000034,Rem) ->
	#mon{id = 84000034,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 408,att = 773439,hp_lim = 20734764,hit = 12342,dodge = 8228,ten = 6582,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000040,Rem) ->
	#mon{id = 84000040,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 413,att = 792971,hp_lim = 21258382,hit = 12653,dodge = 8435,ten = 6748,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000046,Rem) ->
	#mon{id = 84000046,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 425,att = 896289,hp_lim = 24028192,hit = 14302,dodge = 9534,ten = 7627,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000052,Rem) ->
	#mon{id = 84000052,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 432,att = 947435,hp_lim = 25399329,hit = 15118,dodge = 10079,ten = 8063,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000058,Rem) ->
	#mon{id = 84000058,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 438,att = 1031043,hp_lim = 27640730,hit = 16452,dodge = 10968,ten = 8774,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000064,Rem) ->
	#mon{id = 84000064,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 443,att = 1086894,hp_lim = 29138031,hit = 17344,dodge = 11562,ten = 9250,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000070,Rem) ->
	#mon{id = 84000070,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 455,att = 1213259,hp_lim = 32525690,hit = 19360,dodge = 12907,ten = 10325,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000076,Rem) ->
	#mon{id = 84000076,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 462,att = 1238292,hp_lim = 33196786,hit = 19759,dodge = 13173,ten = 10538,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000082,Rem) ->
	#mon{id = 84000082,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 468,att = 1374941,hp_lim = 36860130,hit = 21940,dodge = 14627,ten = 11701,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000088,Rem) ->
	#mon{id = 84000088,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 473,att = 1401656,hp_lim = 37576327,hit = 22366,dodge = 14911,ten = 11928,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000094,Rem) ->
	#mon{id = 84000094,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 485,att = 1589618,hp_lim = 42615309,hit = 25366,dodge = 16910,ten = 13528,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000100,Rem) ->
	#mon{id = 84000100,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 492,att = 1618205,hp_lim = 43381684,hit = 25822,dodge = 17214,ten = 13771,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000106,Rem) ->
	#mon{id = 84000106,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 498,att = 1779376,hp_lim = 47702438,hit = 28394,dodge = 18929,ten = 15143,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000112,Rem) ->
	#mon{id = 84000112,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 503,att = 1809862,hp_lim = 48519709,hit = 28880,dodge = 19253,ten = 15403,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000118,Rem) ->
	#mon{id = 84000118,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 515,att = 2124746,hp_lim = 56961288,hit = 33905,dodge = 22603,ten = 18082,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000124,Rem) ->
	#mon{id = 84000124,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 524,att = 2354335,hp_lim = 63116227,hit = 37569,dodge = 25046,ten = 20036,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000130,Rem) ->
	#mon{id = 84000130,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 536,att = 2778644,hp_lim = 74491331,hit = 44340,dodge = 29560,ten = 23648,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000136,Rem) ->
	#mon{id = 84000136,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 544,att = 2984646,hp_lim = 80013933,hit = 47627,dodge = 31751,ten = 25401,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000142,Rem) ->
	#mon{id = 84000142,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 556,att = 3541382,hp_lim = 94939183,hit = 56511,dodge = 37674,ten = 30139,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000148,Rem) ->
	#mon{id = 84000148,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 565,att = 3911437,hp_lim = 104859823,hit = 62416,dodge = 41611,ten = 33288,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000154,Rem) ->
	#mon{id = 84000154,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 577,att = 4491285,hp_lim = 120404665,hit = 71669,dodge = 47779,ten = 38223,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000160,Rem) ->
	#mon{id = 84000160,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 585,att = 4830347,hp_lim = 129494433,hit = 77080,dodge = 51386,ten = 41109,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000166,Rem) ->
	#mon{id = 84000166,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 597,att = 5763334,hp_lim = 154506403,hit = 91968,dodge = 61312,ten = 49049,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000172,Rem) ->
	#mon{id = 84000172,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 609,att = 6450136,hp_lim = 172918564,hit = 102927,dodge = 68618,ten = 54894,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000178,Rem) ->
	#mon{id = 84000178,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 627,att = 7997579,hp_lim = 214403205,hit = 127620,dodge = 85080,ten = 68064,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000184,Rem) ->
	#mon{id = 84000184,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 641,att = 9131363,hp_lim = 244798263,hit = 145713,dodge = 97142,ten = 77713,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000190,Rem) ->
	#mon{id = 84000190,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 659,att = 11309655,hp_lim = 303195007,hit = 180473,dodge = 120315,ten = 96252,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000196,Rem) ->
	#mon{id = 84000196,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 673,att = 12915266,hp_lim = 346239059,hit = 206094,dodge = 137396,ten = 109917,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000202,Rem) ->
	#mon{id = 84000202,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 691,att = 16299295,hp_lim = 436959837,hit = 260095,dodge = 173396,ten = 138717,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000208,Rem) ->
	#mon{id = 84000208,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 705,att = 18616387,hp_lim = 499077631,hit = 297070,dodge = 198046,ten = 158437,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000214,Rem) ->
	#mon{id = 84000214,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 723,att = 23011105,hp_lim = 616893474,hit = 367198,dodge = 244798,ten = 195839,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000220,Rem) ->
	#mon{id = 84000220,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 737,att = 26286491,hp_lim = 704701685,hit = 419465,dodge = 279643,ten = 223714,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000226,Rem) ->
	#mon{id = 84000226,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 755,att = 29707453,hp_lim = 796412584,hit = 474055,dodge = 316036,ten = 252829,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000232,Rem) ->
	#mon{id = 84000232,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 769,att = 31679172,hp_lim = 849271429,hit = 505518,dodge = 337012,ten = 269609,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000238,Rem) ->
	#mon{id = 84000238,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 787,att = 36128439,hp_lim = 968549654,hit = 576517,dodge = 384345,ten = 307476,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000244,Rem) ->
	#mon{id = 84000244,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 801,att = 39306267,hp_lim = 1053742480,hit = 627227,dodge = 418151,ten = 334521,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000250,Rem) ->
	#mon{id = 84000250,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 819,att = 45689957,hp_lim = 1224879720,hit = 729095,dodge = 486063,ten = 388850,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000256,Rem) ->
	#mon{id = 84000256,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 833,att = 52251472,hp_lim = 1400784144,hit = 833800,dodge = 555866,ten = 444693,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000262,Rem) ->
	#mon{id = 84000262,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 851,att = 71875324,hp_lim = 1926870392,hit = 1146946,dodge = 764631,ten = 611704,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000268,Rem) ->
	#mon{id = 84000268,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 865,att = 118796547,hp_lim = 3184758496,hit = 1895689,dodge = 1263793,ten = 1011034,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000274,Rem) ->
	#mon{id = 84000274,name = "月之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 883,att = 705022257,hp_lim = 18900596700,hit = 11250355,dodge = 7500236,ten = 6000189,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(_MonTypeId, _Rem) -> [].