%%% -------------------------------------------------------
%%% @author huangyongxing@yeah.net
%%% @doc
%%% 怪物配置数据（5/6）
%%% @end
%%% -------------------------------------------------------
-module(data_mon_5).
-export([
		get/2
	]).
-include("scene.hrl").

%% 获取怪物配置
%% Rem是求余结果，
%%   主要目的是为了拆散编译期生成大的literal字面常量，
%%   减少热更新移除旧模块时literal拷贝引发内存暴涨问题，
%%   此值请勿用于它处，不保证未来取值
-spec get(MonTypeId, Rem) -> #mon{} | [] when
	MonTypeId :: non_neg_integer(), Rem :: any().
get(5,Rem) ->
	#mon{id = 5,name = "测试采集怪",kind = 2,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 1,att = 1,hp_lim = 10000,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,is_fight_back = 0,is_be_atted = 0,rem_flag = Rem};
get(11,Rem) ->
	#mon{id = 11,name = "掉落白装",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 500,att = 43163,hp_lim = 720044,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(17,Rem) ->
	#mon{id = 17,name = "转生任务怪物",type = 1,color = 1,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 150,att = 5,hp_lim = 50,striking_distance = 300,tracing_distance = 300,warning_range = 300,hate_range = 300,speed = 150,skill = [{1110000001,1}],retime = 20000,att_time = 1000,exp = 10,rem_flag = Rem};
get(23,Rem) ->
	#mon{id = 23,name = "掉落一大堆",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 550,att = 2445,hp_lim = 259793182,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,rem_flag = Rem};
get(29,Rem) ->
	#mon{id = 29,name = "任务队伍",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 2,att = 5,hp_lim = 3000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 100,rem_flag = Rem};
get(35,Rem) ->
	#mon{id = 35,name = "AI测试",boss = 3,type = 1,color = 3,icon = 1202008,icon_effect = <<"0"/utf8>>,weapon_id = 1202008,lv = 600,att = 2245,hp_lim = 614740845,def = 51239,hit = 28149,dodge = 7700,crit = 5483,ten = 14098,striking_distance = 800,tracing_distance = 2000,warning_range = 2000,hate_range = 2000,speed = 300,skill = [{20005600,1},{20005601,1},{20005603,1},{20005602,1},{20005605,1},{20005604,1}],att_time = 2000,att_type = 1,drop = 1,is_armor = 1,rem_flag = Rem};
get(113,Rem) ->
	#mon{id = 113,name = "个人独占无归属",boss = 2,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 113,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 113,rem_flag = Rem};
get(131,Rem) ->
	#mon{id = 131,name = "均等分配第一击",boss = 1,type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 131,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 131,rem_flag = Rem};
get(143,Rem) ->
	#mon{id = 143,name = "先到先得无归属",type = 1,color = 3,icon = 5010011,icon_effect = <<"0"/utf8>>,weapon_id = 5010011,lv = 143,att = 1,hp_lim = 100000,striking_distance = 100,tracing_distance = 600,warning_range = 600,speed = 200,skill = [{1110000001,1}],retime = 3000,att_time = 2000,drop = 1,exp = 143,rem_flag = Rem};
get(1001,Rem) ->
	#mon{id = 1001,name = "普通外送",kind = 3,boss = 7,color = 3,icon = 10060101,icon_effect = <<"0"/utf8>>,weapon_id = 10060101,lv = 100,att = 100,hp_lim = 50,striking_distance = 250,speed = 300,is_fight_back = 0,del_hp_each_time = [1,1],rem_flag = Rem};
get(9005,Rem) ->
	#mon{id = 9005,name = "商队感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 20000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(9011,Rem) ->
	#mon{id = 9011,name = "雀灵飞蚁",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 100,att = 50,hp_lim = 26000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(9017,Rem) ->
	#mon{id = 9017,name = "黑市打手",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 32000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10001,Rem) ->
	#mon{id = 10001,name = "巡逻女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 10000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10007,Rem) ->
	#mon{id = 10007,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 13000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10013,Rem) ->
	#mon{id = 10013,name = "宝箱章鱼",type = 1,color = 1,auto = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 16000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(10019,Rem) ->
	#mon{id = 10019,name = "故障蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 50,hp_lim = 19000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,exp = 50,is_fight_back = 0,del_hp_each_time = [0.15,0.25],rem_flag = Rem};
get(300101,Rem) ->
	#mon{id = 300101,name = "派单首领",boss = 6,color = 1,icon = 10010001,weapon_id = 202002,lv = 100,att = 767,hp_lim = 23263,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,del_hp_each_time = [0.01,0.02],rem_flag = Rem};
get(350201,Rem) ->
	#mon{id = 350201,name = "转职检察官",boss = 6,color = 1,icon = 10030005,weapon_id = 202002,lv = 320,att = 375000,hp_lim = 18900000,hit = 6750,dodge = 4500,ten = 3600,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360101,Rem) ->
	#mon{id = 360101,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 100,att = 767,hp_lim = 23263,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360401,Rem) ->
	#mon{id = 360401,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 100,att = 767,hp_lim = 23263,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(360701,Rem) ->
	#mon{id = 360701,name = "次元检察官",boss = 6,color = 1,icon = 10020003,weapon_id = 202002,lv = 130,att = 20833,hp_lim = 1050000,hit = 375,dodge = 250,ten = 200,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_armor = 1,rem_flag = Rem};
get(400001,Rem) ->
	#mon{id = 400001,name = "雷电地鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 40,att = 822,hp_lim = 44404,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400199,Rem) ->
	#mon{id = 400199,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 50,att = 956,hp_lim = 51657,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400211,Rem) ->
	#mon{id = 400211,name = "独眼卫士",type = 1,color = 1,auto = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 60,att = 1058,hp_lim = 57143,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400301,Rem) ->
	#mon{id = 400301,name = "雷电地鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 70,att = 1112,hp_lim = 60091,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400499,Rem) ->
	#mon{id = 400499,name = "宝箱",type = 1,color = 1,auto = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 80,att = 1170,hp_lim = 63189,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(400511,Rem) ->
	#mon{id = 400511,name = "独眼卫士",type = 1,color = 1,auto = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 90,att = 1433,hp_lim = 77406,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(400601,Rem) ->
	#mon{id = 400601,name = "雷电地鼠",type = 1,color = 1,auto = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 100,att = 2747,hp_lim = 148339,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,del_hp_each_time = [0.20,0.3],rem_flag = Rem};
get(500003,Rem) ->
	#mon{id = 500003,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 64,att = 150,hp_lim = 5084,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500009,Rem) ->
	#mon{id = 500009,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 90,att = 585,hp_lim = 39666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500015,Rem) ->
	#mon{id = 500015,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 105,att = 1240,hp_lim = 84000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500021,Rem) ->
	#mon{id = 500021,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 117,att = 2066,hp_lim = 140000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500027,Rem) ->
	#mon{id = 500027,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 129,att = 3616,hp_lim = 245000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500033,Rem) ->
	#mon{id = 500033,name = "紫衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 141,att = 5425,hp_lim = 367500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500039,Rem) ->
	#mon{id = 500039,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 153,att = 7233,hp_lim = 490000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500045,Rem) ->
	#mon{id = 500045,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 165,att = 9455,hp_lim = 640500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500051,Rem) ->
	#mon{id = 500051,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 177,att = 11538,hp_lim = 781666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500057,Rem) ->
	#mon{id = 500057,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 189,att = 13536,hp_lim = 917000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500063,Rem) ->
	#mon{id = 500063,name = "绿衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 201,att = 15345,hp_lim = 1039500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500069,Rem) ->
	#mon{id = 500069,name = "生化研究员",type = 1,color = 1,auto = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 209,att = 17153,hp_lim = 1162000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500075,Rem) ->
	#mon{id = 500075,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 215,att = 19220,hp_lim = 1302000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500081,Rem) ->
	#mon{id = 500081,name = "感染护士",type = 1,color = 1,auto = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 221,att = 21028,hp_lim = 1424500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500087,Rem) ->
	#mon{id = 500087,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 227,att = 22853,hp_lim = 1548166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500093,Rem) ->
	#mon{id = 500093,name = "生化感染者",type = 1,color = 1,auto = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 233,att = 24696,hp_lim = 1673000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500099,Rem) ->
	#mon{id = 500099,name = "巡逻部队",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 239,att = 26556,hp_lim = 1799000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500105,Rem) ->
	#mon{id = 500105,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 244,att = 28709,hp_lim = 1944833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500111,Rem) ->
	#mon{id = 500111,name = "蓝衣战士",type = 1,color = 1,auto = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 249,att = 30621,hp_lim = 2074333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500117,Rem) ->
	#mon{id = 500117,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 254,att = 32550,hp_lim = 2205000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500123,Rem) ->
	#mon{id = 500123,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 259,att = 34496,hp_lim = 2336833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500129,Rem) ->
	#mon{id = 500129,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 264,att = 36493,hp_lim = 2472166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500135,Rem) ->
	#mon{id = 500135,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 268,att = 38767,hp_lim = 2626166,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500141,Rem) ->
	#mon{id = 500141,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 273,att = 40816,hp_lim = 2765000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500147,Rem) ->
	#mon{id = 500147,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 278,att = 42866,hp_lim = 2903833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500153,Rem) ->
	#mon{id = 500153,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 283,att = 44950,hp_lim = 3045000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500159,Rem) ->
	#mon{id = 500159,name = "刺蛇叉姬",type = 1,color = 1,auto = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 288,att = 47051,hp_lim = 3187333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500165,Rem) ->
	#mon{id = 500165,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 292,att = 49445,hp_lim = 3349500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500171,Rem) ->
	#mon{id = 500171,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 297,att = 51615,hp_lim = 3496500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500177,Rem) ->
	#mon{id = 500177,name = "钢针飞蛾",type = 1,color = 1,auto = 1,icon = 10040106,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 302,att = 53802,hp_lim = 3644666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500183,Rem) ->
	#mon{id = 500183,name = "钢铁蜥蜴",type = 1,color = 1,auto = 1,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 307,att = 56006,hp_lim = 3794000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500189,Rem) ->
	#mon{id = 500189,name = "钢针蜂",type = 1,color = 1,auto = 1,icon = 10020101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 312,att = 58228,hp_lim = 3944500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000003,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500195,Rem) ->
	#mon{id = 500195,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 316,att = 60794,hp_lim = 4118333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500201,Rem) ->
	#mon{id = 500201,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 321,att = 63085,hp_lim = 4273500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500207,Rem) ->
	#mon{id = 500207,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 326,att = 65392,hp_lim = 4429833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500213,Rem) ->
	#mon{id = 500213,name = "海族战士",type = 1,color = 1,auto = 1,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 331,att = 67735,hp_lim = 4588500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500219,Rem) ->
	#mon{id = 500219,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 336,att = 70111,hp_lim = 4749500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500225,Rem) ->
	#mon{id = 500225,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 340,att = 72832,hp_lim = 4933833,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500231,Rem) ->
	#mon{id = 500231,name = "海族护卫",type = 1,color = 1,auto = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 345,att = 75261,hp_lim = 5098333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500237,Rem) ->
	#mon{id = 500237,name = "玛雅三角",type = 1,color = 1,auto = 1,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 350,att = 77706,hp_lim = 5264000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500243,Rem) ->
	#mon{id = 500243,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 355,att = 80186,hp_lim = 5432000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500249,Rem) ->
	#mon{id = 500249,name = "街头少女",type = 1,color = 1,auto = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 360,att = 82701,hp_lim = 5602333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500255,Rem) ->
	#mon{id = 500255,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 364,att = 85594,hp_lim = 5798333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500261,Rem) ->
	#mon{id = 500261,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 369,att = 88177,hp_lim = 5973333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500267,Rem) ->
	#mon{id = 500267,name = "乐动女仆",type = 1,color = 1,auto = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 374,att = 90778,hp_lim = 6149500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500273,Rem) ->
	#mon{id = 500273,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 379,att = 93413,hp_lim = 6328000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500279,Rem) ->
	#mon{id = 500279,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 384,att = 96065,hp_lim = 6507666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500285,Rem) ->
	#mon{id = 500285,name = "波数间隔占用",type = 1,color = 1,auto = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 388,att = 99148,hp_lim = 6716500,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500291,Rem) ->
	#mon{id = 500291,name = "赛博先锋",type = 1,color = 1,auto = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 393,att = 101886,hp_lim = 6902000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(500297,Rem) ->
	#mon{id = 500297,name = "印第舞者",type = 1,color = 1,auto = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 398,att = 113701,hp_lim = 7702333,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510005,Rem) ->
	#mon{id = 510005,name = "生化魔人",boss = 6,type = 1,color = 1,auto = 1,icon = 100200022,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 125,att = 10200,hp_lim = 1890000,hit = 270,dodge = 180,ten = 144,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510011,Rem) ->
	#mon{id = 510011,name = "病毒暴君",boss = 6,type = 1,color = 1,auto = 1,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 185,att = 42840,hp_lim = 7938000,hit = 1134,dodge = 756,ten = 604,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510017,Rem) ->
	#mon{id = 510017,name = "执行者铁角",boss = 6,type = 1,color = 1,auto = 1,icon = 100400021,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 225,att = 73440,hp_lim = 13608000,hit = 1944,dodge = 1296,ten = 1036,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510023,Rem) ->
	#mon{id = 510023,name = "三头吼兽",boss = 6,type = 1,color = 1,auto = 1,icon = 100300011,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 252,att = 105286,hp_lim = 19509000,hit = 2787,dodge = 1858,ten = 1486,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510029,Rem) ->
	#mon{id = 510029,name = "兵武女刺",boss = 6,type = 1,color = 1,auto = 1,icon = 100100072,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 276,att = 139060,hp_lim = 25767000,hit = 3681,dodge = 2454,ten = 1963,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510035,Rem) ->
	#mon{id = 510035,name = "能源守卫",boss = 6,type = 1,color = 1,auto = 1,icon = 100100062,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 300,att = 174930,hp_lim = 32413500,hit = 4630,dodge = 3087,ten = 2469,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510041,Rem) ->
	#mon{id = 510041,name = "武装女神",boss = 6,type = 1,color = 1,auto = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 324,att = 212953,hp_lim = 39459000,hit = 5637,dodge = 3758,ten = 3006,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510047,Rem) ->
	#mon{id = 510047,name = "海神祭祀",boss = 6,type = 1,color = 1,auto = 1,icon = 100100101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 348,att = 253356,hp_lim = 46945500,hit = 6706,dodge = 4471,ten = 3576,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510053,Rem) ->
	#mon{id = 510053,name = "铁甲战姬",boss = 6,type = 1,color = 1,auto = 1,icon = 100100051,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 372,att = 296196,hp_lim = 54883500,hit = 7840,dodge = 5227,ten = 4181,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(510059,Rem) ->
	#mon{id = 510059,name = "末世利爪",boss = 6,type = 1,color = 1,auto = 1,icon = 100100042,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 396,att = 341700,hp_lim = 63315000,hit = 9045,dodge = 6030,ten = 4824,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_fight_back = 0,rem_flag = Rem};
get(651101,Rem) ->
	#mon{id = 651101,name = "boss水晶球",kind = 7,boss = 1,type = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 100,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,del_hp_each_time = [0.008,0.008],rem_flag = Rem};
get(652001,Rem) ->
	#mon{id = 652001,name = "社团午间boss",boss = 1,type = 1,color = 1,icon = 203008,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,rem_flag = Rem};
get(653003,Rem) ->
	#mon{id = 653003,name = "日曜结晶",kind = 1,color = 1,icon = 10020202,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,collect_time = 3,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hide_hp = 1,rem_flag = Rem};
get(653105,Rem) ->
	#mon{id = 653105,name = "幻影图腾",boss = 5,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 100000,hp_lim = 999987654321,hit = 166666,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 500,skill = [{1110000001,1}],att_time = 1000,rem_flag = Rem};
get(659999,Rem) ->
	#mon{id = 659999,name = "社团字段",kind = 6,type = 1,color = 1,auto = 1,icon = 203008,icon_effect = <<"0"/utf8>>,weapon_id = 203008,lv = 630,att = 144487,hp_lim = 20576130,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 1000,is_fight_back = 0,rem_flag = Rem};
get(1001003,Rem) ->
	#mon{id = 1001003,name = "武装战姬",boss = 6,color = 1,icon = 10020001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 45,att = 64,hp_lim = 12740,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001009,Rem) ->
	#mon{id = 1001009,name = "疯狂博士",boss = 6,color = 1,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 194,hp_lim = 38220,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001015,Rem) ->
	#mon{id = 1001015,name = "生化三角头",boss = 6,color = 1,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 85,att = 1164,hp_lim = 229320,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1001021,Rem) ->
	#mon{id = 1001021,name = "武器合成娘",boss = 6,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 190,att = 3235,hp_lim = 637000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(1200101,Rem) ->
	#mon{id = 1200101,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 102,att = 1465,hp_lim = 71947,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200107,Rem) ->
	#mon{id = 1200107,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 114,att = 4078,hp_lim = 200222,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200113,Rem) ->
	#mon{id = 1200113,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 135,att = 5544,hp_lim = 272160,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200203,Rem) ->
	#mon{id = 1200203,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 120,att = 4648,hp_lim = 228217,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200209,Rem) ->
	#mon{id = 1200209,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 150,att = 8470,hp_lim = 415800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200215,Rem) ->
	#mon{id = 1200215,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 180,att = 30345,hp_lim = 1587600,hit = 945,dodge = 630,ten = 504,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200305,Rem) ->
	#mon{id = 1200305,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 160,att = 20808,hp_lim = 1088640,hit = 720,dodge = 480,ten = 384,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200311,Rem) ->
	#mon{id = 1200311,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 190,att = 17787,hp_lim = 873180,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200317,Rem) ->
	#mon{id = 1200317,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 220,att = 52020,hp_lim = 13608000,hit = 1620,dodge = 1080,ten = 864,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200401,Rem) ->
	#mon{id = 1200401,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 176,att = 12320,hp_lim = 604800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200407,Rem) ->
	#mon{id = 1200407,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 200,att = 20020,hp_lim = 982800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200413,Rem) ->
	#mon{id = 1200413,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 230,att = 31647,hp_lim = 1553580,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200503,Rem) ->
	#mon{id = 1200503,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 205,att = 23870,hp_lim = 1171800,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200509,Rem) ->
	#mon{id = 1200509,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 235,att = 35652,hp_lim = 1750215,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200515,Rem) ->
	#mon{id = 1200515,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 265,att = 98507,hp_lim = 5153757,hit = 3067,dodge = 2045,ten = 1636,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200605,Rem) ->
	#mon{id = 1200605,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 240,att = 66906,hp_lim = 3500431,hit = 2083,dodge = 1389,ten = 1111,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200611,Rem) ->
	#mon{id = 1200611,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 270,att = 56914,hp_lim = 2793979,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200617,Rem) ->
	#mon{id = 1200617,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 300,att = 150859,hp_lim = 39463691,hit = 4698,dodge = 3132,ten = 2505,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200701,Rem) ->
	#mon{id = 1200701,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 246,att = 39738,hp_lim = 1950783,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200707,Rem) ->
	#mon{id = 1200707,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 270,att = 56914,hp_lim = 2793979,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200713,Rem) ->
	#mon{id = 1200713,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 300,att = 80389,hp_lim = 3946369,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200803,Rem) ->
	#mon{id = 1200803,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 270,att = 56914,hp_lim = 2793979,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200809,Rem) ->
	#mon{id = 1200809,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 300,att = 80389,hp_lim = 3946369,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200815,Rem) ->
	#mon{id = 1200815,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 330,att = 199497,hp_lim = 10437396,hit = 6212,dodge = 4141,ten = 3313,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200905,Rem) ->
	#mon{id = 1200905,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 300,att = 150859,hp_lim = 7892738,hit = 4698,dodge = 3132,ten = 2505,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200911,Rem) ->
	#mon{id = 1200911,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 330,att = 106306,hp_lim = 5218698,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1200917,Rem) ->
	#mon{id = 1200917,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 360,att = 253143,hp_lim = 66220194,hit = 7883,dodge = 5255,ten = 4204,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201001,Rem) ->
	#mon{id = 1201001,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 306,att = 89637,hp_lim = 4400399,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201007,Rem) ->
	#mon{id = 1201007,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 330,att = 106306,hp_lim = 5218698,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201013,Rem) ->
	#mon{id = 1201013,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 360,att = 134892,hp_lim = 6622019,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201103,Rem) ->
	#mon{id = 1201103,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 330,att = 106306,hp_lim = 5218698,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201109,Rem) ->
	#mon{id = 1201109,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 360,att = 134892,hp_lim = 6622019,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201115,Rem) ->
	#mon{id = 1201115,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 390,att = 323422,hp_lim = 16920907,hit = 10071,dodge = 6714,ten = 5371,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201205,Rem) ->
	#mon{id = 1201205,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 360,att = 253143,hp_lim = 13244038,hit = 7883,dodge = 5255,ten = 4204,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201211,Rem) ->
	#mon{id = 1201211,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 390,att = 172342,hp_lim = 8460453,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201217,Rem) ->
	#mon{id = 1201217,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 420,att = 400267,hp_lim = 104706680,hit = 12465,dodge = 8310,ten = 6648,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201301,Rem) ->
	#mon{id = 1201301,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 366,att = 147006,hp_lim = 7216677,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201307,Rem) ->
	#mon{id = 1201307,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 390,att = 172342,hp_lim = 8460453,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201313,Rem) ->
	#mon{id = 1201313,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 420,att = 213291,hp_lim = 10470668,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201403,Rem) ->
	#mon{id = 1201403,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 390,att = 172342,hp_lim = 8460453,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201409,Rem) ->
	#mon{id = 1201409,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 420,att = 213291,hp_lim = 10470668,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201415,Rem) ->
	#mon{id = 1201415,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 450,att = 498969,hp_lim = 26105239,hit = 15538,dodge = 10359,ten = 8287,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201505,Rem) ->
	#mon{id = 1201505,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 420,att = 400267,hp_lim = 20941336,hit = 12465,dodge = 8310,ten = 6648,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201511,Rem) ->
	#mon{id = 1201511,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202018,lv = 450,att = 265886,hp_lim = 13052619,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201517,Rem) ->
	#mon{id = 1201517,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 480,att = 605893,hp_lim = 158496647,hit = 18868,dodge = 12579,ten = 10063,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201601,Rem) ->
	#mon{id = 1201601,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 426,att = 227774,hp_lim = 11181644,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201607,Rem) ->
	#mon{id = 1201607,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 450,att = 265886,hp_lim = 13052619,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201613,Rem) ->
	#mon{id = 1201613,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 480,att = 322863,hp_lim = 15849664,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201703,Rem) ->
	#mon{id = 1201703,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 450,att = 265886,hp_lim = 13052619,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201709,Rem) ->
	#mon{id = 1201709,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 480,att = 322863,hp_lim = 15849664,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201715,Rem) ->
	#mon{id = 1201715,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 510,att = 737569,hp_lim = 38588402,hit = 22969,dodge = 15312,ten = 12250,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201805,Rem) ->
	#mon{id = 1201805,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 480,att = 605893,hp_lim = 31699329,hit = 18868,dodge = 12579,ten = 10063,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201811,Rem) ->
	#mon{id = 1201811,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 510,att = 393030,hp_lim = 19294201,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201817,Rem) ->
	#mon{id = 1201817,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 540,att = 1014578,hp_lim = 265405215,hit = 31595,dodge = 21063,ten = 16851,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201901,Rem) ->
	#mon{id = 1201901,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 486,att = 331331,hp_lim = 16265385,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201907,Rem) ->
	#mon{id = 1201907,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 510,att = 393030,hp_lim = 19294201,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1201913,Rem) ->
	#mon{id = 1201913,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 540,att = 540640,hp_lim = 26540521,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202003,Rem) ->
	#mon{id = 1202003,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 510,att = 393030,hp_lim = 19294201,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202009,Rem) ->
	#mon{id = 1202009,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 540,att = 540640,hp_lim = 26540521,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202015,Rem) ->
	#mon{id = 1202015,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 570,att = 1390158,hp_lim = 72730773,hit = 43292,dodge = 28861,ten = 23089,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202105,Rem) ->
	#mon{id = 1202105,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 540,att = 1014578,hp_lim = 53081043,hit = 31595,dodge = 21063,ten = 16851,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202111,Rem) ->
	#mon{id = 1202111,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 570,att = 740776,hp_lim = 36365386,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202117,Rem) ->
	#mon{id = 1202117,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 600,att = 1870970,hp_lim = 489430216,hit = 58265,dodge = 38843,ten = 31074,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202201,Rem) ->
	#mon{id = 1202201,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 546,att = 572899,hp_lim = 28124148,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202207,Rem) ->
	#mon{id = 1202207,name = "突击青年",kind = 6,type = 1,color = 2,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 570,att = 740776,hp_lim = 36365386,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202213,Rem) ->
	#mon{id = 1202213,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 600,att = 996987,hp_lim = 48943021,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202303,Rem) ->
	#mon{id = 1202303,name = "进击丧尸",kind = 6,type = 1,color = 2,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 570,att = 740776,hp_lim = 36365386,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202309,Rem) ->
	#mon{id = 1202309,name = "突击暴民",kind = 6,type = 1,color = 2,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 600,att = 996987,hp_lim = 48943021,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202315,Rem) ->
	#mon{id = 1202315,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 630,att = 2518079,hp_lim = 131741726,hit = 78417,dodge = 52278,ten = 41822,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202405,Rem) ->
	#mon{id = 1202405,name = "进击秋田",kind = 6,boss = 6,type = 1,color = 2,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 600,att = 1870970,hp_lim = 97886043,hit = 58265,dodge = 38843,ten = 31074,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202411,Rem) ->
	#mon{id = 1202411,name = "进击护士",kind = 6,type = 1,color = 2,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202018,lv = 630,att = 1341813,hp_lim = 65870863,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,speed = 200,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(1202417,Rem) ->
	#mon{id = 1202417,name = "中央核心",kind = 7,boss = 6,type = 1,color = 2,icon = 10010403,icon_effect = <<"0"/utf8>>,weapon_id = 202018,lv = 660,att = 3456783,hp_lim = 904265800,hit = 107650,dodge = 71767,ten = 57413,striking_distance = 110,tracing_distance = 4000,warning_range = 4000,hate_range = 4000,att_time = 2000,drop = 1,exp = 3,rem_flag = Rem};
get(2001101,Rem) ->
	#mon{id = 2001101,name = "武装暴民",type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 80,att = 313,hp_lim = 8493,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2001203,Rem) ->
	#mon{id = 2001203,name = "战争女神",boss = 6,type = 1,color = 1,icon = 100200041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 90,att = 1547,hp_lim = 38220,hit = 40,dodge = 27,ten = 21,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2002103,Rem) ->
	#mon{id = 2002103,name = "改造暴猿",boss = 6,type = 1,color = 1,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2062,hp_lim = 50960,hit = 54,dodge = 36,ten = 29,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2003201,Rem) ->
	#mon{id = 2003201,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 115,att = 2821,hp_lim = 76440,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2004101,Rem) ->
	#mon{id = 2004101,name = "海族战士",type = 1,color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 3134,hp_lim = 84933,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2004203,Rem) ->
	#mon{id = 2004203,name = "深海祭祀",boss = 6,type = 1,color = 1,icon = 100100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 14438,hp_lim = 356720,hit = 382,dodge = 254,ten = 203,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2005103,Rem) ->
	#mon{id = 2005103,name = "兵武女刺",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 15470,hp_lim = 382200,hit = 409,dodge = 273,ten = 218,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2006201,Rem) ->
	#mon{id = 2006201,name = "叛乱矿工",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 140,att = 6268,hp_lim = 169866,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2007101,Rem) ->
	#mon{id = 2007101,name = "武装暴民",type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 160,att = 6582,hp_lim = 178360,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2007203,Rem) ->
	#mon{id = 2007203,name = "战争女神",boss = 6,type = 1,color = 1,icon = 100200041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 165,att = 24752,hp_lim = 611520,hit = 655,dodge = 436,ten = 349,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2008103,Rem) ->
	#mon{id = 2008103,name = "能源守卫",boss = 6,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 25783,hp_lim = 637000,hit = 682,dodge = 455,ten = 364,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2009201,Rem) ->
	#mon{id = 2009201,name = "赛博先锋",type = 1,color = 1,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 175,att = 8619,hp_lim = 233566,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2010101,Rem) ->
	#mon{id = 2010101,name = "合成丧尸",type = 1,color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 9089,hp_lim = 246306,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2010203,Rem) ->
	#mon{id = 2010203,name = "改造暴猿",boss = 6,type = 1,color = 1,icon = 100200071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 190,att = 33518,hp_lim = 828100,hit = 887,dodge = 591,ten = 473,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2011103,Rem) ->
	#mon{id = 2011103,name = "深海祭祀",boss = 6,type = 1,color = 1,icon = 10010010,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,att = 30940,hp_lim = 764400,hit = 819,dodge = 546,ten = 436,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2012201,Rem) ->
	#mon{id = 2012201,name = "叛乱矿工",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 220,att = 13791,hp_lim = 373706,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2013101,Rem) ->
	#mon{id = 2013101,name = "武装暴民",type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 12537,hp_lim = 339733,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2013203,Rem) ->
	#mon{id = 2013203,name = "战争女神",boss = 6,type = 1,color = 1,icon = 100200041,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 225,att = 45378,hp_lim = 1121120,hit = 1201,dodge = 800,ten = 640,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2014103,Rem) ->
	#mon{id = 2014103,name = "兵武女刺",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 265,att = 67036,hp_lim = 1656200,hit = 1774,dodge = 1183,ten = 946,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.2,0.3],is_hit_ac = 1,rem_flag = Rem};
get(2015201,Rem) ->
	#mon{id = 2015201,name = "叛乱矿工",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 380,att = 54852,hp_lim = 1486333,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.25,0.5],is_hit_ac = 1,rem_flag = Rem};
get(2100101,Rem) ->
	#mon{id = 2100101,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 1201,hp_lim = 805000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 778,is_hit_ac = 1,rem_flag = Rem};
get(2100107,Rem) ->
	#mon{id = 2100107,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 2527,hp_lim = 1694000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 787,is_hit_ac = 1,rem_flag = Rem};
get(2100203,Rem) ->
	#mon{id = 2100203,name = "感染护士",color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 4386,hp_lim = 2940000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 816,is_hit_ac = 1,rem_flag = Rem};
get(2100209,Rem) ->
	#mon{id = 2100209,name = "武装暴民",color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 210,att = 6799,hp_lim = 4557000,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 848,is_hit_ac = 1,rem_flag = Rem};
get(2100305,Rem) ->
	#mon{id = 2100305,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 240,att = 9671,hp_lim = 6482280,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 911,is_hit_ac = 1,rem_flag = Rem};
get(2100401,Rem) ->
	#mon{id = 2100401,name = "变异柴犬",color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 270,att = 15439,hp_lim = 10348072,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 981,is_hit_ac = 1,rem_flag = Rem};
get(2100407,Rem) ->
	#mon{id = 2100407,name = "武装暴民",color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 300,att = 21808,hp_lim = 14616182,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1078,is_hit_ac = 1,rem_flag = Rem};
get(2100503,Rem) ->
	#mon{id = 2100503,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 330,att = 28839,hp_lim = 19328512,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1198,is_hit_ac = 1,rem_flag = Rem};
get(2100509,Rem) ->
	#mon{id = 2100509,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 360,att = 36594,hp_lim = 24525998,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1300,is_hit_ac = 1,rem_flag = Rem};
get(2100605,Rem) ->
	#mon{id = 2100605,name = "兽血改造者",color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 390,att = 46753,hp_lim = 31335017,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1438,is_hit_ac = 1,rem_flag = Rem};
get(2100701,Rem) ->
	#mon{id = 2100701,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 57862,hp_lim = 38780252,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1587,is_hit_ac = 1,rem_flag = Rem};
get(2100707,Rem) ->
	#mon{id = 2100707,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 450,att = 72130,hp_lim = 48343036,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1745,is_hit_ac = 1,rem_flag = Rem};
get(2100803,Rem) ->
	#mon{id = 2100803,name = "感染护士",color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 480,att = 87587,hp_lim = 58702462,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100809,Rem) ->
	#mon{id = 2100809,name = "武装暴民",color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 510,att = 106622,hp_lim = 71460004,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2100905,Rem) ->
	#mon{id = 2100905,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 540,att = 146667,hp_lim = 98298228,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101001,Rem) ->
	#mon{id = 2101001,name = "变异柴犬",color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 570,att = 200960,hp_lim = 134686615,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101007,Rem) ->
	#mon{id = 2101007,name = "武装暴民",color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 600,att = 270467,hp_lim = 181270453,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101103,Rem) ->
	#mon{id = 2101103,name = "蓝光水母",color = 1,icon = 10050102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 630,att = 364013,hp_lim = 243966163,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101109,Rem) ->
	#mon{id = 2101109,name = "流沙蛇尾",color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 660,att = 499711,hp_lim = 334913257,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101205,Rem) ->
	#mon{id = 2101205,name = "兽血改造者",color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 690,att = 672546,hp_lim = 450749152,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101301,Rem) ->
	#mon{id = 2101301,name = "掘地多足虫",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 720,att = 905158,hp_lim = 606649015,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101307,Rem) ->
	#mon{id = 2101307,name = "海族战士",color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 750,att = 1242589,hp_lim = 832799100,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101403,Rem) ->
	#mon{id = 2101403,name = "感染护士",color = 1,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 780,att = 1672361,hp_lim = 1120837942,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101409,Rem) ->
	#mon{id = 2101409,name = "武装暴民",color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 810,att = 2436314,hp_lim = 1632849239,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2101505,Rem) ->
	#mon{id = 2101505,name = "荧光多足虫",color = 1,icon = 10120101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 840,att = 4241682,hp_lim = 2842830046,striking_distance = 110,tracing_distance = 600,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 30000,att_time = 2000,drop = 1,exp = 1542,is_hit_ac = 1,rem_flag = Rem};
get(2300003,Rem) ->
	#mon{id = 2300003,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 130,att = 12029,hp_lim = 340200,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300009,Rem) ->
	#mon{id = 2300009,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 160,att = 22276,hp_lim = 756000,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300015,Rem) ->
	#mon{id = 2300015,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 220,att = 50123,hp_lim = 1701000,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300021,Rem) ->
	#mon{id = 2300021,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 280,att = 100239,hp_lim = 3580811,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300027,Rem) ->
	#mon{id = 2300027,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 340,att = 191607,hp_lim = 6844710,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300033,Rem) ->
	#mon{id = 2300033,name = "菠萝布丁窃贼",kind = 10,color = 1,module = 610,icon = 23000102,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 400,att = 322289,hp_lim = 11160579,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300039,Rem) ->
	#mon{id = 2300039,name = "草莓蛋糕窃贼",kind = 10,color = 1,module = 610,icon = 23000101,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 460,att = 509481,hp_lim = 17289994,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300045,Rem) ->
	#mon{id = 2300045,name = "粉色糖果窃贼",kind = 10,color = 1,module = 610,icon = 23000103,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 520,att = 1242585,hp_lim = 33735177,tracing_distance = 500,hate_range = 600,speed = 80,att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(2300051,Rem) ->
	#mon{id = 2300051,name = "隐藏宝藏怪",kind = 10,color = 1,module = 610,icon = 10010402,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 150,att = 15315,hp_lim = 519750,tracing_distance = 500,hate_range = 600,speed = 50,skill = [{1110000001,1}],att_time = 2000,drop = 1,is_hit_ac = 1,rem_flag = Rem};
get(3000005,Rem) ->
	#mon{id = 3000005,name = "虚空光侍",boss = 6,color = 1,module = 610,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 200,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(10010105,Rem) ->
	#mon{id = 10010105,name = "朋克打手",boss = 1,type = 1,color = 1,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202033,lv = 15,att = 25,hp_lim = 1653,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 3,is_hit_ac = 1,rem_flag = Rem};
get(10010201,Rem) ->
	#mon{id = 10010201,name = "新手武器",kind = 2,color = 1,icon = 10010198,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 3,att = 13,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10020101,Rem) ->
	#mon{id = 10020101,name = "藏匿异形",boss = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202022,lv = 24,att = 34,hp_lim = 2424,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 5,is_hit_ac = 1,rem_flag = Rem};
get(10020107,Rem) ->
	#mon{id = 10020107,name = "断桥触手怪",boss = 1,type = 1,color = 1,icon = 10040103,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 33,att = 43,hp_lim = 3270,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 6,is_hit_ac = 1,rem_flag = Rem};
get(10020203,Rem) ->
	#mon{id = 10020203,name = "神兵核心",kind = 2,color = 1,icon = 41000202,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10040105,Rem) ->
	#mon{id = 10040105,name = "变异人",boss = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 71,att = 81,hp_lim = 3852,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 11,is_patrol = 1,is_hit_ac = 1,rem_flag = Rem};
get(10040201,Rem) ->
	#mon{id = 10040201,name = "地牢黑晶",kind = 2,color = 1,icon = 10020202,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 1164,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10050101,Rem) ->
	#mon{id = 10050101,name = "鲛人战士",boss = 1,color = 1,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 86,att = 96,hp_lim = 24256,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 14,is_hit_ac = 1,rem_flag = Rem};
get(10050203,Rem) ->
	#mon{id = 10050203,name = "突袭警告",kind = 2,color = 1,icon = 41000201,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 9700,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10070105,Rem) ->
	#mon{id = 10070105,name = "招募船员",boss = 1,type = 1,color = 1,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 130,att = 100,hp_lim = 192000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 19,is_hit_ac = 1,rem_flag = Rem};
get(10070201,Rem) ->
	#mon{id = 10070201,name = "应援灯牌",kind = 2,color = 1,icon = 10070201,icon_effect = <<"0"/utf8>>,weapon_id = 2040009,lv = 2,att = 12,hp_lim = 9700,striking_distance = 100,tracing_distance = 800,hate_range = 800,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10080101,Rem) ->
	#mon{id = 10080101,name = "偷渡蛇姬",boss = 1,type = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 150,att = 100,hp_lim = 352000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 22,is_hit_ac = 1,rem_flag = Rem};
get(10080107,Rem) ->
	#mon{id = 10080107,name = "信号干扰蛛",boss = 1,type = 1,color = 1,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 180,att = 100,hp_lim = 672000,striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 26,is_hit_ac = 1,rem_flag = Rem};
get(10080203,Rem) ->
	#mon{id = 10080203,name = "安全插销",kind = 2,color = 1,icon = 10080201,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10090001,Rem) ->
	#mon{id = 10090001,name = "雪山魔兽",boss = 6,type = 1,color = 1,icon = 10030002,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 270,att = 100,hp_lim = 4730500,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 33,is_hit_ac = 1,rem_flag = Rem};
get(10090103,Rem) ->
	#mon{id = 10090103,name = "玛雅巫灵",boss = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 255,att = 100,hp_lim = 2001275,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 30,is_hit_ac = 1,rem_flag = Rem};
get(10100105,Rem) ->
	#mon{id = 10100105,name = "流沙蛇尾",boss = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 345,att = 100,hp_lim = 4879525,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 55,is_hit_ac = 1,rem_flag = Rem};
get(10100201,Rem) ->
	#mon{id = 10100201,name = "沙海套装",kind = 2,color = 1,icon = 10010401,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10110101,Rem) ->
	#mon{id = 10110101,name = "发狂柴犬",boss = 1,color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 380,att = 100,hp_lim = 6627975,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 67,is_hit_ac = 1,rem_flag = Rem};
get(10120001,Rem) ->
	#mon{id = 10120001,name = "远古血魔",boss = 7,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 450,att = 100,hp_lim = 22099650,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 109,is_hit_ac = 1,rem_flag = Rem};
get(10120103,Rem) ->
	#mon{id = 10120103,name = "坑洞蛇尾",boss = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 440,att = 100,hp_lim = 10403025,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 99,is_hit_ac = 1,rem_flag = Rem};
get(10130105,Rem) ->
	#mon{id = 10130105,name = "入侵机体",boss = 1,color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202001,lv = 490,att = 100,hp_lim = 14125075,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 147,is_hit_ac = 1,rem_flag = Rem};
get(10130201,Rem) ->
	#mon{id = 10130201,name = "血液样本",kind = 2,color = 1,icon = 10010203,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 2,att = 12,hp_lim = 9700,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 100,att_time = 2000,drop = 1,collect_time = 2,is_fight_back = 0,is_be_atted = 0,is_be_clicked = 0,rem_flag = Rem};
get(10140101,Rem) ->
	#mon{id = 10140101,name = "护甲角鼠",boss = 1,color = 1,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 1007006,lv = 500,att = 100,hp_lim = 15212900,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 157,rem_flag = Rem};
get(10150001,Rem) ->
	#mon{id = 10150001,name = "黯皇龙裔",boss = 7,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 575,att = 100,hp_lim = 64058450,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 232,is_hit_ac = 1,rem_flag = Rem};
get(10150103,Rem) ->
	#mon{id = 10150103,name = "龙影刺莽",boss = 1,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 5010084,lv = 570,att = 100,hp_lim = 30785500,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 1000,att_time = 2000,drop = 1,exp = 227,rem_flag = Rem};
get(11001005,Rem) ->
	#mon{id = 11001005,name = "面具影刺",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 128,att = 3250,hp_lim = 289800,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001011,Rem) ->
	#mon{id = 11001011,name = "野蛮武士",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 4381,hp_lim = 390600,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001017,Rem) ->
	#mon{id = 11001017,name = "乐动女仆",type = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 152,att = 6218,hp_lim = 554400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001023,Rem) ->
	#mon{id = 11001023,name = "暴动青年",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 164,att = 9045,hp_lim = 806400,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11001029,Rem) ->
	#mon{id = 11001029,name = "改造男孩",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 176,att = 12178,hp_lim = 1085700,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002001,Rem) ->
	#mon{id = 11002001,name = "音波蜘蛛",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 13356,hp_lim = 1190700,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002007,Rem) ->
	#mon{id = 11002007,name = "暗影武士",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 192,att = 17619,hp_lim = 1570800,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002013,Rem) ->
	#mon{id = 11002013,name = "地底怪物",type = 1,color = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 204,att = 23461,hp_lim = 2091600,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002019,Rem) ->
	#mon{id = 11002019,name = "暗影武士",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 216,att = 29161,hp_lim = 2599800,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11002025,Rem) ->
	#mon{id = 11002025,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 228,att = 33884,hp_lim = 3020850,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003003,Rem) ->
	#mon{id = 11003003,name = "协奏女爵",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 244,att = 61413,hp_lim = 11379575,hit = 1625,dodge = 1083,ten = 867,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003009,Rem) ->
	#mon{id = 11003009,name = "神殿祭祀",boss = 6,type = 1,color = 1,icon = 100100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 256,att = 70879,hp_lim = 13133526,hit = 1876,dodge = 1250,ten = 1000,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003015,Rem) ->
	#mon{id = 11003015,name = "钢琴弹奏者",boss = 6,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 268,att = 83770,hp_lim = 15522108,hit = 2217,dodge = 1478,ten = 1182,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003021,Rem) ->
	#mon{id = 11003021,name = "触手女孩",boss = 6,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 90409,hp_lim = 16752340,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11003027,Rem) ->
	#mon{id = 11003027,name = "沙漠血蝎",boss = 6,type = 1,color = 1,icon = 100300062,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 292,att = 64902,hp_lim = 5786131,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004005,Rem) ->
	#mon{id = 11004005,name = "面具影刺",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 308,att = 80665,hp_lim = 7191382,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004011,Rem) ->
	#mon{id = 11004011,name = "野蛮武士",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 320,att = 90488,hp_lim = 8067172,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004017,Rem) ->
	#mon{id = 11004017,name = "乐动女仆",type = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 332,att = 97401,hp_lim = 8683423,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004023,Rem) ->
	#mon{id = 11004023,name = "暴动青年",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 344,att = 111256,hp_lim = 9918657,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11004029,Rem) ->
	#mon{id = 11004029,name = "改造男孩",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 356,att = 126112,hp_lim = 11243059,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005001,Rem) ->
	#mon{id = 11005001,name = "音波蜘蛛",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 360,att = 131487,hp_lim = 11722256,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005007,Rem) ->
	#mon{id = 11005007,name = "暗影武士",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 372,att = 153302,hp_lim = 13667065,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005013,Rem) ->
	#mon{id = 11005013,name = "地底怪物",type = 1,color = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 384,att = 186530,hp_lim = 16629385,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005019,Rem) ->
	#mon{id = 11005019,name = "暗影武士",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 396,att = 226169,hp_lim = 20163210,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11005025,Rem) ->
	#mon{id = 11005025,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 416,att = 286723,hp_lim = 25561674,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006003,Rem) ->
	#mon{id = 11006003,name = "协奏女爵",boss = 6,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 448,att = 641811,hp_lim = 118923868,hit = 16989,dodge = 11326,ten = 9060,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006009,Rem) ->
	#mon{id = 11006009,name = "神殿祭祀",boss = 6,type = 1,color = 1,icon = 100100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 472,att = 793145,hp_lim = 146965193,hit = 20995,dodge = 13996,ten = 11197,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006015,Rem) ->
	#mon{id = 11006015,name = "钢琴弹奏者",boss = 6,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 496,att = 964399,hp_lim = 178697573,hit = 25528,dodge = 17018,ten = 13615,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006021,Rem) ->
	#mon{id = 11006021,name = "触手女孩",boss = 6,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 1294669,hp_lim = 239894592,hit = 34270,dodge = 22847,ten = 18277,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11006027,Rem) ->
	#mon{id = 11006027,name = "沙漠血蝎",boss = 6,type = 1,color = 1,icon = 100300062,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 544,att = 1093518,hp_lim = 97488242,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007005,Rem) ->
	#mon{id = 11007005,name = "面具影刺",type = 1,color = 1,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 576,att = 1648594,hp_lim = 146973739,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007011,Rem) ->
	#mon{id = 11007011,name = "野蛮武士",type = 1,color = 1,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 600,att = 2200784,hp_lim = 196202002,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007017,Rem) ->
	#mon{id = 11007017,name = "乐动女仆",type = 1,color = 1,icon = 10010101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 624,att = 2930592,hp_lim = 261265119,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007023,Rem) ->
	#mon{id = 11007023,name = "暴动青年",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 648,att = 3971448,hp_lim = 354058404,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11007029,Rem) ->
	#mon{id = 11007029,name = "改造男孩",type = 1,color = 1,icon = 10010105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 672,att = 5265566,hp_lim = 469430207,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008001,Rem) ->
	#mon{id = 11008001,name = "音波蜘蛛",color = 1,icon = 10020103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 680,att = 5782543,hp_lim = 515519215,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008007,Rem) ->
	#mon{id = 11008007,name = "暗影武士",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 704,att = 7647782,hp_lim = 681806998,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008013,Rem) ->
	#mon{id = 11008013,name = "地底怪物",type = 1,color = 1,icon = 10120102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 728,att = 10171284,hp_lim = 906779621,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008019,Rem) ->
	#mon{id = 11008019,name = "暗影武士",type = 1,color = 1,icon = 10020102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 752,att = 13577687,hp_lim = 1210463658,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(11008025,Rem) ->
	#mon{id = 11008025,name = "深渊护卫",type = 1,color = 1,icon = 10080101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 776,att = 17873373,hp_lim = 1593428081,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12010013,Rem) ->
	#mon{id = 12010013,name = "末世机甲",boss = 6,color = 1,module = 610,icon = 100100012,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 2856,hp_lim = 498266,hit = 98,dodge = 65,ten = 52,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12020015,Rem) ->
	#mon{id = 12020015,name = "光刃利爪",boss = 6,color = 1,module = 610,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 23833,hp_lim = 4158000,hit = 825,dodge = 550,ten = 440,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12030011,Rem) ->
	#mon{id = 12030011,name = "变异环刃",boss = 6,color = 1,module = 610,icon = 100100071,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 35620,hp_lim = 6214320,hit = 1233,dodge = 822,ten = 657,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12040013,Rem) ->
	#mon{id = 12040013,name = "末世触手",boss = 6,color = 1,module = 610,icon = 100200022,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 191444,hp_lim = 33399668,hit = 6626,dodge = 4417,ten = 3534,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12050015,Rem) ->
	#mon{id = 12050015,name = "邪恶博士",boss = 6,color = 1,module = 610,icon = 10020006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 450,att = 598532,hp_lim = 104420957,hit = 20718,dodge = 13812,ten = 11049,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(12060011,Rem) ->
	#mon{id = 12060011,name = "变异三角",boss = 6,color = 1,module = 610,icon = 100400021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 495020,hp_lim = 86362053,hit = 17135,dodge = 11423,ten = 9138,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13010003,Rem) ->
	#mon{id = 13010003,name = "机甲环刃",boss = 3,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 4795,hp_lim = 5216400,hit = 258,dodge = 172,ten = 138,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13030001,Rem) ->
	#mon{id = 13030001,name = "变异死神",boss = 3,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 25743,hp_lim = 28003449,hit = 1389,dodge = 926,ten = 740,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13040003,Rem) ->
	#mon{id = 13040003,name = "兵器少女",boss = 3,color = 1,icon = 10020004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 390,att = 186667,hp_lim = 203050893,hit = 10071,dodge = 6714,ten = 5371,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(13060001,Rem) ->
	#mon{id = 13060001,name = "生化暴君",boss = 3,color = 1,icon = 10040001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 530,att = 353074,hp_lim = 384063420,hit = 19050,dodge = 12700,ten = 10160,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14010005,Rem) ->
	#mon{id = 14010005,name = "寄生触手",boss = 4,type = 1,color = 1,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 1866,hp_lim = 17422250,hit = 103,dodge = 69,ten = 55,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14020001,Rem) ->
	#mon{id = 14020001,name = "雇佣兵长",boss = 4,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 15750,hp_lim = 94500000,hit = 562,dodge = 375,ten = 300,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14030003,Rem) ->
	#mon{id = 14030003,name = "能量光侍",boss = 4,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 91042,hp_lim = 546255350,hit = 3251,dodge = 2167,ten = 1734,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14050001,Rem) ->
	#mon{id = 14050001,name = "人造异形",boss = 4,type = 1,color = 1,icon = 10040003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 597340,hp_lim = 3584042000,hit = 21333,dodge = 14222,ten = 11377,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(14060003,Rem) ->
	#mon{id = 14060003,name = "软泥战士",boss = 4,type = 1,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 575,att = 1342662,hp_lim = 8055974050,hit = 47952,dodge = 31968,ten = 25574,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(15010001,Rem) ->
	#mon{id = 15010001,name = "物资宝箱",kind = 1,color = 1,icon = 41000201,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,hp_lim = 3732752,def = 109008,hit = 34855,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 1,collect_count = 1,is_fight_back = 0,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(18010001,Rem) ->
	#mon{id = 18010001,name = "执首领主",boss = 9,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 1166,hp_lim = 1374528,hit = 68,dodge = 45,ten = 36,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18020003,Rem) ->
	#mon{id = 18020003,name = "霹雳人马",boss = 9,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 170,att = 13013,hp_lim = 9676800,hit = 480,dodge = 320,ten = 256,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18030005,Rem) ->
	#mon{id = 18030005,name = "王级行者",boss = 9,type = 1,color = 1,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 300,att = 127369,hp_lim = 94712859,hit = 4698,dodge = 3132,ten = 2505,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18030101,Rem) ->
	#mon{id = 18030101,name = "星域精英",boss = 10,color = 1,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 37658,hp_lim = 28003449,hit = 1389,dodge = 926,ten = 740,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18040001,Rem) ->
	#mon{id = 18040001,name = "改造机甲",boss = 9,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 101012,hp_lim = 75113619,hit = 3725,dodge = 2483,ten = 1987,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18050003,Rem) ->
	#mon{id = 18050003,name = "投弹猩猩",boss = 9,type = 1,color = 1,icon = 10020007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 460,att = 297619,hp_lim = 221311923,hit = 10977,dodge = 7318,ten = 5854,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18060005,Rem) ->
	#mon{id = 18060005,name = "病毒血魔",boss = 9,type = 1,color = 1,icon = 10010008,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 600,att = 1579642,hp_lim = 1174632534,hit = 58265,dodge = 38843,ten = 31074,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(18060101,Rem) ->
	#mon{id = 18060101,name = "星域精英",boss = 10,color = 1,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 540,att = 571065,hp_lim = 424648344,hit = 21063,dodge = 14042,ten = 11234,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19010003,Rem) ->
	#mon{id = 19010003,name = "变异死神",boss = 12,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 6950,hp_lim = 17226970,hit = 256,dodge = 170,ten = 136,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19020005,Rem) ->
	#mon{id = 19020005,name = "雇佣兵长",boss = 12,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 75213,hp_lim = 186429600,hit = 2774,dodge = 1849,ten = 1479,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19030001,Rem) ->
	#mon{id = 19030001,name = "爆裂机甲",boss = 12,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 220,att = 65880,hp_lim = 163296000,hit = 2430,dodge = 1620,ten = 1296,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19040003,Rem) ->
	#mon{id = 19040003,name = "人马王者",boss = 12,type = 1,color = 1,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 360,att = 320589,hp_lim = 794642330,hit = 11825,dodge = 7883,ten = 6306,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19050005,Rem) ->
	#mon{id = 19050005,name = "阴影侍从",boss = 12,type = 1,color = 1,icon = 10010002,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 520,att = 1045255,hp_lim = 2590861590,hit = 38554,dodge = 25702,ten = 20562,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(19060001,Rem) ->
	#mon{id = 19060001,name = "病毒利爪",boss = 12,type = 1,color = 1,icon = 10010004,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 510,att = 934084,hp_lim = 2315304120,hit = 34453,dodge = 22969,ten = 18375,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20010005,Rem) ->
	#mon{id = 20010005,name = "爆裂机甲",boss = 13,type = 1,color = 1,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 10980,hp_lim = 27216000,hit = 405,dodge = 270,ten = 216,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20020001,Rem) ->
	#mon{id = 20020001,name = "机甲环刃",boss = 13,type = 1,color = 1,icon = 10010007,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 10980,hp_lim = 27216000,hit = 405,dodge = 270,ten = 216,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20030003,Rem) ->
	#mon{id = 20030003,name = "变异死神",boss = 13,type = 1,color = 1,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 260,att = 114449,hp_lim = 283684160,hit = 4221,dodge = 2814,ten = 2251,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20040005,Rem) ->
	#mon{id = 20040005,name = "雇佣兵王",boss = 13,type = 1,color = 1,icon = 10020003,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 506913,hp_lim = 1256480160,hit = 18697,dodge = 12465,ten = 9972,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20050001,Rem) ->
	#mon{id = 20050001,name = "莱姆战士",boss = 13,type = 1,color = 1,icon = 10020005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 410,att = 473502,hp_lim = 1173665950,hit = 17465,dodge = 11643,ten = 9314,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(20060003,Rem) ->
	#mon{id = 20060003,name = "病毒异形",boss = 13,type = 1,color = 1,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 560,att = 1605791,hp_lim = 3980256530,hit = 59230,dodge = 39486,ten = 31589,resum = [1,4000000000,500],striking_distance = 110,tracing_distance = 800,warning_range = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(43001003,Rem) ->
	#mon{id = 43001003,name = "南城中枢",kind = 11,boss = 1,color = 1,icon = 10010306,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 1,att = 1000,hp_lim = 1131000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(43001105,Rem) ->
	#mon{id = 43001105,name = "北城守卫者",kind = 11,boss = 1,color = 1,icon = 10010104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 250,att = 1000,hp_lim = 942000,striking_distance = 100,tracing_distance = 800,warning_range = 800,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [800,1200],rem_flag = Rem};
get(60402005,Rem) ->
	#mon{id = 60402005,name = "星空领主",boss = 6,type = 1,color = 1,module = 604,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 4070,hp_lim = 539000,hit = 330,dodge = 220,ten = 176,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403001,Rem) ->
	#mon{id = 60403001,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(60403007,Rem) ->
	#mon{id = 60403007,name = "失落科技守卫",boss = 6,type = 1,color = 1,module = 604,icon = 10020002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 200,att = 5550,hp_lim = 735000,hit = 450,dodge = 300,ten = 240,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,is_hit_ac = 1,rem_flag = Rem};
get(70010003,Rem) ->
	#mon{id = 70010003,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 84,att = 1563,hp_lim = 202779,hit = 41,dodge = 27,ten = 22,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010009,Rem) ->
	#mon{id = 70010009,name = "改造守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 95,att = 2499,hp_lim = 369495,hit = 114,dodge = 76,ten = 61,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010015,Rem) ->
	#mon{id = 70010015,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 10200,hp_lim = 1323000,hit = 270,dodge = 180,ten = 144,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010021,Rem) ->
	#mon{id = 70010021,name = "海族护卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 110,att = 7497,hp_lim = 1108485,hit = 344,dodge = 229,ten = 183,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010027,Rem) ->
	#mon{id = 70010027,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 120,att = 25500,hp_lim = 3307500,hit = 675,dodge = 450,ten = 360,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010033,Rem) ->
	#mon{id = 70010033,name = "变色异虫",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 125,att = 16243,hp_lim = 2401717,hit = 745,dodge = 497,ten = 397,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010039,Rem) ->
	#mon{id = 70010039,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 48450,hp_lim = 6284250,hit = 1282,dodge = 855,ten = 684,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010045,Rem) ->
	#mon{id = 70010045,name = "感染护士",type = 1,color = 1,module = 610,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 140,att = 27489,hp_lim = 4064445,hit = 1262,dodge = 841,ten = 673,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010051,Rem) ->
	#mon{id = 70010051,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 150,att = 76500,hp_lim = 9922500,hit = 2025,dodge = 1350,ten = 1080,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010057,Rem) ->
	#mon{id = 70010057,name = "改造守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 155,att = 42483,hp_lim = 6281415,hit = 1950,dodge = 1300,ten = 1040,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010063,Rem) ->
	#mon{id = 70010063,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 165,att = 107100,hp_lim = 13891500,hit = 2835,dodge = 1890,ten = 1512,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010069,Rem) ->
	#mon{id = 70010069,name = "海族护卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 170,att = 59976,hp_lim = 8867880,hit = 2754,dodge = 1836,ten = 1468,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010075,Rem) ->
	#mon{id = 70010075,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 153000,hp_lim = 19845000,hit = 4050,dodge = 2700,ten = 2160,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010081,Rem) ->
	#mon{id = 70010081,name = "变色异虫",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 185,att = 82467,hp_lim = 12193335,hit = 3786,dodge = 2524,ten = 2019,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010087,Rem) ->
	#mon{id = 70010087,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 195,att = 204000,hp_lim = 26460000,hit = 5400,dodge = 3600,ten = 2880,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010093,Rem) ->
	#mon{id = 70010093,name = "感染护士",type = 1,color = 1,module = 610,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 200,att = 109956,hp_lim = 16257780,hit = 5049,dodge = 3366,ten = 2692,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010099,Rem) ->
	#mon{id = 70010099,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 210,att = 265200,hp_lim = 34398000,hit = 7020,dodge = 4680,ten = 3744,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010105,Rem) ->
	#mon{id = 70010105,name = "改造守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 215,att = 139944,hp_lim = 20691720,hit = 6426,dodge = 4284,ten = 3427,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010111,Rem) ->
	#mon{id = 70010111,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 225,att = 346800,hp_lim = 44982000,hit = 9180,dodge = 6120,ten = 4896,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010117,Rem) ->
	#mon{id = 70010117,name = "海族护卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 230,att = 189924,hp_lim = 28081620,hit = 8721,dodge = 5814,ten = 4651,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010123,Rem) ->
	#mon{id = 70010123,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 240,att = 469200,hp_lim = 60858000,hit = 12420,dodge = 8280,ten = 6624,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010129,Rem) ->
	#mon{id = 70010129,name = "变色异虫",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 245,att = 249900,hp_lim = 36949500,hit = 11475,dodge = 7650,ten = 6120,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010135,Rem) ->
	#mon{id = 70010135,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 255,att = 591600,hp_lim = 76734000,hit = 15660,dodge = 10440,ten = 8352,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010141,Rem) ->
	#mon{id = 70010141,name = "感染护士",type = 1,color = 1,module = 610,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 260,att = 309876,hp_lim = 45817380,hit = 14229,dodge = 9486,ten = 7588,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010147,Rem) ->
	#mon{id = 70010147,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 270,att = 714000,hp_lim = 92610000,hit = 18900,dodge = 12600,ten = 10080,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010153,Rem) ->
	#mon{id = 70010153,name = "改造守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 374850,hp_lim = 55424250,hit = 17212,dodge = 11475,ten = 9180,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010159,Rem) ->
	#mon{id = 70010159,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 285,att = 867000,hp_lim = 112455000,hit = 22950,dodge = 15300,ten = 12240,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010165,Rem) ->
	#mon{id = 70010165,name = "海族护卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 290,att = 449820,hp_lim = 66509100,hit = 20655,dodge = 13770,ten = 11016,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010171,Rem) ->
	#mon{id = 70010171,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 300,att = 1020000,hp_lim = 132300000,hit = 27000,dodge = 18000,ten = 14400,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010177,Rem) ->
	#mon{id = 70010177,name = "变色异虫",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 524790,hp_lim = 77593950,hit = 24097,dodge = 16065,ten = 12852,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010183,Rem) ->
	#mon{id = 70010183,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 315,att = 1173000,hp_lim = 152145000,hit = 31050,dodge = 20700,ten = 16560,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010189,Rem) ->
	#mon{id = 70010189,name = "感染护士",type = 1,color = 1,module = 610,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 624750,hp_lim = 92373750,hit = 28687,dodge = 19125,ten = 15300,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010195,Rem) ->
	#mon{id = 70010195,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 330,att = 1479000,hp_lim = 191835000,hit = 39150,dodge = 26100,ten = 20880,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010201,Rem) ->
	#mon{id = 70010201,name = "感染护士",type = 1,color = 1,module = 610,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202031,lv = 335,att = 774690,hp_lim = 114543450,hit = 35572,dodge = 23715,ten = 18972,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010207,Rem) ->
	#mon{id = 70010207,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 345,att = 1785000,hp_lim = 231525000,hit = 47250,dodge = 31500,ten = 25200,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010213,Rem) ->
	#mon{id = 70010213,name = "改造守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 350,att = 924630,hp_lim = 136713150,hit = 42457,dodge = 28305,ten = 22644,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010219,Rem) ->
	#mon{id = 70010219,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 360,att = 2091000,hp_lim = 271215000,hit = 55350,dodge = 36900,ten = 29520,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010225,Rem) ->
	#mon{id = 70010225,name = "海族护卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 365,att = 1074570,hp_lim = 158882850,hit = 49342,dodge = 32895,ten = 26316,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010231,Rem) ->
	#mon{id = 70010231,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 375,att = 2397000,hp_lim = 310905000,hit = 63450,dodge = 42300,ten = 33840,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010237,Rem) ->
	#mon{id = 70010237,name = "变色异虫",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 380,att = 1224510,hp_lim = 181052550,hit = 56227,dodge = 37485,ten = 29988,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010243,Rem) ->
	#mon{id = 70010243,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 390,att = 2703000,hp_lim = 350595000,hit = 71550,dodge = 47700,ten = 38160,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010249,Rem) ->
	#mon{id = 70010249,name = "感染护士",type = 1,color = 1,module = 610,icon = 10040105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202031,lv = 395,att = 1374450,hp_lim = 203222250,hit = 63112,dodge = 42075,ten = 33660,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010255,Rem) ->
	#mon{id = 70010255,name = "霸王兔甲",boss = 6,type = 1,color = 1,module = 610,icon = 10010001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 405,att = 3315000,hp_lim = 429975000,hit = 87750,dodge = 58500,ten = 46800,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010261,Rem) ->
	#mon{id = 70010261,name = "改造守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 410,att = 1749300,hp_lim = 258646500,hit = 80325,dodge = 53550,ten = 42840,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010267,Rem) ->
	#mon{id = 70010267,name = "明日战姬",boss = 6,type = 1,color = 1,module = 610,icon = 10010005,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 420,att = 4080000,hp_lim = 529200000,hit = 108000,dodge = 72000,ten = 57600,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010273,Rem) ->
	#mon{id = 70010273,name = "海族护卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 425,att = 2124150,hp_lim = 314070750,hit = 97537,dodge = 65025,ten = 52020,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010279,Rem) ->
	#mon{id = 70010279,name = "异星人马",boss = 6,type = 1,color = 1,module = 610,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 435,att = 4845000,hp_lim = 628425000,hit = 128250,dodge = 85500,ten = 68400,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010285,Rem) ->
	#mon{id = 70010285,name = "变色异虫",type = 1,color = 1,module = 610,icon = 10050103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 440,att = 2499000,hp_lim = 369495000,hit = 114750,dodge = 76500,ten = 61200,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010291,Rem) ->
	#mon{id = 70010291,name = "魔兽地狱犬",boss = 6,type = 1,color = 1,module = 610,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 450,att = 7140000,hp_lim = 926100000,hit = 189000,dodge = 126000,ten = 100800,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010297,Rem) ->
	#mon{id = 70010297,name = "感染护士",type = 1,color = 1,module = 610,icon = 10040105,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 455,att = 3998400,hp_lim = 591192000,hit = 183600,dodge = 122400,ten = 97920,striking_distance = 110,tracing_distance = 800,warning_range = 1000,hate_range = 1000,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010501,Rem) ->
	#mon{id = 70010501,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 108,att = 10200,hp_lim = 1323000,hit = 270,dodge = 180,ten = 144,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010507,Rem) ->
	#mon{id = 70010507,name = "悍地魔兽",boss = 6,type = 1,color = 1,module = 610,icon = 100100081,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 156,att = 66300,hp_lim = 8599500,hit = 1755,dodge = 1170,ten = 936,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010513,Rem) ->
	#mon{id = 70010513,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 100400012,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 205,att = 173400,hp_lim = 22491000,hit = 4590,dodge = 3060,ten = 2448,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010519,Rem) ->
	#mon{id = 70010519,name = "异星监管者",boss = 6,type = 1,color = 1,module = 610,icon = 100100042,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 265,att = 336600,hp_lim = 43659000,hit = 8910,dodge = 5940,ten = 4752,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010525,Rem) ->
	#mon{id = 70010525,name = "达尔机械姬",boss = 6,type = 1,color = 1,module = 610,icon = 100100021,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 571200,hp_lim = 74088000,hit = 15120,dodge = 10080,ten = 8064,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010531,Rem) ->
	#mon{id = 70010531,name = "悍地魔兽",boss = 6,type = 1,color = 1,module = 610,icon = 100100081,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 410,att = 1020000,hp_lim = 132300000,hit = 27000,dodge = 18000,ten = 14400,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010537,Rem) ->
	#mon{id = 70010537,name = "丧尸霸主",boss = 6,type = 1,color = 1,module = 610,icon = 100400012,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 500,att = 1530000,hp_lim = 198450000,hit = 40500,dodge = 27000,ten = 21600,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(70010543,Rem) ->
	#mon{id = 70010543,name = "异星监管者",boss = 6,type = 1,color = 1,module = 610,icon = 100100042,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 590,att = 2142000,hp_lim = 277830000,hit = 56700,dodge = 37800,ten = 30240,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(75000101,Rem) ->
	#mon{id = 75000101,name = "领域电生兽",color = 1,icon = 10010107,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 3,att = 1,hp_lim = 15000,def = 16,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],retime = 2000,att_time = 2000,drop = 1,exp = 15,del_hp_each_time = [0.05,0.1],is_hit_ac = 1,rem_flag = Rem};
get(80020001,Rem) ->
	#mon{id = 80020001,name = "怪异博士",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80020007,Rem) ->
	#mon{id = 80020007,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80030003,Rem) ->
	#mon{id = 80030003,name = "森林贤王",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 100,att = 782,hp_lim = 127271,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80030009,Rem) ->
	#mon{id = 80030009,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 105,att = 2271,hp_lim = 468249,hit = 92,dodge = 61,ten = 49,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80050001,Rem) ->
	#mon{id = 80050001,name = "邪心女仆",type = 1,color = 1,module = 610,icon = 10010101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80050007,Rem) ->
	#mon{id = 80050007,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80060003,Rem) ->
	#mon{id = 80060003,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80060009,Rem) ->
	#mon{id = 80060009,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80080001,Rem) ->
	#mon{id = 80080001,name = "原始守护者",type = 1,color = 1,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 130,att = 2066,hp_lim = 336000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80080007,Rem) ->
	#mon{id = 80080007,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 135,att = 4400,hp_lim = 907200,hit = 180,dodge = 120,ten = 96,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80090003,Rem) ->
	#mon{id = 80090003,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80090009,Rem) ->
	#mon{id = 80090009,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80110001,Rem) ->
	#mon{id = 80110001,name = "草地蜥",type = 1,color = 1,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80110007,Rem) ->
	#mon{id = 80110007,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80120003,Rem) ->
	#mon{id = 80120003,name = "球形海怪",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 180,att = 7233,hp_lim = 1176000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80120009,Rem) ->
	#mon{id = 80120009,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 185,att = 15400,hp_lim = 3175200,hit = 630,dodge = 420,ten = 336,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80140001,Rem) ->
	#mon{id = 80140001,name = "冰原从者",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80140007,Rem) ->
	#mon{id = 80140007,name = "合金仓鼠",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80150003,Rem) ->
	#mon{id = 80150003,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 230,att = 14156,hp_lim = 2301600,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80150009,Rem) ->
	#mon{id = 80150009,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 235,att = 33954,hp_lim = 7000860,hit = 1389,dodge = 926,ten = 740,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80170001,Rem) ->
	#mon{id = 80170001,name = "叛逃者",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80170007,Rem) ->
	#mon{id = 80170007,name = "兽血改造者",type = 1,color = 1,module = 610,icon = 10020102,icon_effect = <<"0"/utf8>>,weapon_id = 202037,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80180003,Rem) ->
	#mon{id = 80180003,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80180009,Rem) ->
	#mon{id = 80180009,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80200001,Rem) ->
	#mon{id = 80200001,name = "改造水母",type = 1,color = 1,module = 610,icon = 10050102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 275,att = 27477,hp_lim = 4467290,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80200007,Rem) ->
	#mon{id = 80200007,name = "球形海怪",type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 280,att = 58500,hp_lim = 12061683,hit = 2393,dodge = 1595,ten = 1276,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80210003,Rem) ->
	#mon{id = 80210003,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80210009,Rem) ->
	#mon{id = 80210009,name = "核心机甲",type = 1,color = 1,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80230001,Rem) ->
	#mon{id = 80230001,name = "变异虫体",type = 1,color = 1,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80230007,Rem) ->
	#mon{id = 80230007,name = "深渊巨网",type = 1,color = 3,module = 610,icon = 10010106,icon_effect = <<"0"/utf8>>,weapon_id = 202008,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80240003,Rem) ->
	#mon{id = 80240003,name = "原始巫妖",type = 1,color = 1,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 320,att = 42778,hp_lim = 6954964,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80240009,Rem) ->
	#mon{id = 80240009,name = "原始巫妖",type = 1,color = 3,module = 610,icon = 10080101,icon_effect = <<"0"/utf8>>,weapon_id = 202007,lv = 325,att = 96110,hp_lim = 19816218,hit = 3931,dodge = 2621,ten = 2096,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80260001,Rem) ->
	#mon{id = 80260001,name = "怪异博士",type = 1,color = 1,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80260007,Rem) ->
	#mon{id = 80260007,name = "蛇行者",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80270003,Rem) ->
	#mon{id = 80270003,name = "森林贤王",type = 1,color = 1,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 370,att = 65760,hp_lim = 10691374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(80270009,Rem) ->
	#mon{id = 80270009,name = "森林贤王",type = 1,color = 3,module = 610,icon = 10040104,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 375,att = 145904,hp_lim = 30082848,hit = 5968,dodge = 3979,ten = 3183,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010001,Rem) ->
	#mon{id = 81010001,name = "下路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 200,att = 30333,hp_lim = 32760000,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81010103,Rem) ->
	#mon{id = 81010103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 200,att = 30333,hp_lim = 1638000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010301,Rem) ->
	#mon{id = 81010301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 206,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010403,Rem) ->
	#mon{id = 81010403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 209,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010601,Rem) ->
	#mon{id = 81010601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 215,att = 36166,hp_lim = 1953000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010703,Rem) ->
	#mon{id = 81010703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 218,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81010901,Rem) ->
	#mon{id = 81010901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 224,att = 42000,hp_lim = 2268000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011003,Rem) ->
	#mon{id = 81011003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 227,att = 102750,hp_lim = 5178600,hit = 1849,dodge = 1233,ten = 986,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011201,Rem) ->
	#mon{id = 81011201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 233,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011303,Rem) ->
	#mon{id = 81011303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 236,att = 54019,hp_lim = 2917026,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81011501,Rem) ->
	#mon{id = 81011501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 242,att = 129020,hp_lim = 6502612,hit = 2322,dodge = 1548,ten = 1238,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020003,Rem) ->
	#mon{id = 81020003,name = "上路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 240,att = 54019,hp_lim = 58340520,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81020201,Rem) ->
	#mon{id = 81020201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 245,att = 60209,hp_lim = 3251306,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020303,Rem) ->
	#mon{id = 81020303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 250,att = 66523,hp_lim = 3592272,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020501,Rem) ->
	#mon{id = 81020501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 260,att = 156351,hp_lim = 7880115,hit = 2814,dodge = 1876,ten = 1500,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020603,Rem) ->
	#mon{id = 81020603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 265,att = 79533,hp_lim = 4294798,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020801,Rem) ->
	#mon{id = 81020801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 275,att = 93068,hp_lim = 5025701,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81020903,Rem) ->
	#mon{id = 81020903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 280,att = 93068,hp_lim = 5025701,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021101,Rem) ->
	#mon{id = 81021101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 290,att = 107150,hp_lim = 5786130,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021203,Rem) ->
	#mon{id = 81021203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 295,att = 114403,hp_lim = 6177788,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021401,Rem) ->
	#mon{id = 81021401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 305,att = 121801,hp_lim = 6577281,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021503,Rem) ->
	#mon{id = 81021503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 310,att = 277173,hp_lim = 13969523,hit = 4989,dodge = 3326,ten = 2660,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021701,Rem) ->
	#mon{id = 81021701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 320,att = 144895,hp_lim = 7824335,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81021803,Rem) ->
	#mon{id = 81021803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 325,att = 152902,hp_lim = 8256756,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022001,Rem) ->
	#mon{id = 81022001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 335,att = 363004,hp_lim = 18295443,hit = 6534,dodge = 4356,ten = 3484,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022103,Rem) ->
	#mon{id = 81022103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 340,att = 177900,hp_lim = 9606611,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022301,Rem) ->
	#mon{id = 81022301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 350,att = 186568,hp_lim = 10074678,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81022403,Rem) ->
	#mon{id = 81022403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 355,att = 195409,hp_lim = 10552109,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030005,Rem) ->
	#mon{id = 81030005,name = "豪华箱子",kind = 1,color = 3,module = 610,icon = 10010402,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 1,att = 109,hp_lim = 5911,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_count = 1,is_be_atted = 0,is_hit_ac = 1,rem_flag = Rem};
get(81030101,Rem) ->
	#mon{id = 81030101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 360,att = 206427,hp_lim = 11147066,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030203,Rem) ->
	#mon{id = 81030203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 363,att = 226301,hp_lim = 12220272,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030401,Rem) ->
	#mon{id = 81030401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 369,att = 245010,hp_lim = 13230575,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030503,Rem) ->
	#mon{id = 81030503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 372,att = 497401,hp_lim = 25069039,hit = 8953,dodge = 5968,ten = 4775,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030701,Rem) ->
	#mon{id = 81030701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 378,att = 287557,hp_lim = 15528126,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81030803,Rem) ->
	#mon{id = 81030803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 381,att = 299640,hp_lim = 16180568,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031001,Rem) ->
	#mon{id = 81031001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 387,att = 538527,hp_lim = 27141773,hit = 9693,dodge = 6462,ten = 5169,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031103,Rem) ->
	#mon{id = 81031103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 390,att = 347296,hp_lim = 18754006,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031301,Rem) ->
	#mon{id = 81031301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 396,att = 371386,hp_lim = 20054847,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031403,Rem) ->
	#mon{id = 81031403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 399,att = 399295,hp_lim = 21561935,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031601,Rem) ->
	#mon{id = 81031601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 405,att = 425523,hp_lim = 22978259,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031703,Rem) ->
	#mon{id = 81031703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 408,att = 455821,hp_lim = 24614383,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81031901,Rem) ->
	#mon{id = 81031901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 414,att = 484281,hp_lim = 26151187,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032003,Rem) ->
	#mon{id = 81032003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 417,att = 692504,hp_lim = 34902226,hit = 12465,dodge = 8310,ten = 6648,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032201,Rem) ->
	#mon{id = 81032201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 423,att = 547856,hp_lim = 29584259,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032303,Rem) ->
	#mon{id = 81032303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 426,att = 583240,hp_lim = 31494965,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032501,Rem) ->
	#mon{id = 81032501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 432,att = 763568,hp_lim = 38483831,hit = 13744,dodge = 9162,ten = 7330,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032603,Rem) ->
	#mon{id = 81032603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 435,att = 654540,hp_lim = 35345186,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032801,Rem) ->
	#mon{id = 81032801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 441,att = 690285,hp_lim = 37275419,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81032903,Rem) ->
	#mon{id = 81032903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 444,att = 731187,hp_lim = 39484143,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033101,Rem) ->
	#mon{id = 81033101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 450,att = 769459,hp_lim = 41550839,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033203,Rem) ->
	#mon{id = 81033203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 453,att = 813059,hp_lim = 43905203,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033401,Rem) ->
	#mon{id = 81033401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 459,att = 853826,hp_lim = 46106650,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033503,Rem) ->
	#mon{id = 81033503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 462,att = 914814,hp_lim = 46106650,hit = 16466,dodge = 10977,ten = 8782,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033701,Rem) ->
	#mon{id = 81033701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 468,att = 943534,hp_lim = 50950843,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81033803,Rem) ->
	#mon{id = 81033803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 471,att = 966106,hp_lim = 52169762,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034001,Rem) ->
	#mon{id = 81034001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 477,att = 1021035,hp_lim = 51460201,hit = 18378,dodge = 12252,ten = 9801,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034103,Rem) ->
	#mon{id = 81034103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 480,att = 1090887,hp_lim = 58907920,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034301,Rem) ->
	#mon{id = 81034301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 486,att = 1139581,hp_lim = 61537374,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034403,Rem) ->
	#mon{id = 81034403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 489,att = 1194747,hp_lim = 64516354,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034601,Rem) ->
	#mon{id = 81034601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 495,att = 1246236,hp_lim = 67296745,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034703,Rem) ->
	#mon{id = 81034703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 498,att = 1304498,hp_lim = 70442940,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81034901,Rem) ->
	#mon{id = 81034901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 504,att = 1391901,hp_lim = 75162697,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81035003,Rem) ->
	#mon{id = 81035003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 507,att = 1246593,hp_lim = 62828299,hit = 22438,dodge = 14959,ten = 11967,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040001,Rem) ->
	#mon{id = 81040001,name = "下路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 500,att = 1386594,hp_lim = 1503512040,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81040103,Rem) ->
	#mon{id = 81040103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 500,att = 1403233,hp_lim = 75774611,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040301,Rem) ->
	#mon{id = 81040301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 508,att = 1495080,hp_lim = 80734365,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040403,Rem) ->
	#mon{id = 81040403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 512,att = 1596612,hp_lim = 86217077,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040601,Rem) ->
	#mon{id = 81040601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 520,att = 1772554,hp_lim = 95717942,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040703,Rem) ->
	#mon{id = 81040703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 524,att = 1885416,hp_lim = 101812485,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81040901,Rem) ->
	#mon{id = 81040901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 532,att = 2079579,hp_lim = 112297306,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041003,Rem) ->
	#mon{id = 81041003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 536,att = 1687217,hp_lim = 85035766,hit = 30369,dodge = 20246,ten = 16197,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041201,Rem) ->
	#mon{id = 81041201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 544,att = 2418471,hp_lim = 130597453,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041303,Rem) ->
	#mon{id = 81041303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 548,att = 2605144,hp_lim = 140677829,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041501,Rem) ->
	#mon{id = 81041501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 556,att = 2079154,hp_lim = 104789386,hit = 37424,dodge = 24949,ten = 19959,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041603,Rem) ->
	#mon{id = 81041603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 560,att = 3050711,hp_lim = 164738395,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041801,Rem) ->
	#mon{id = 81041801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 568,att = 3323150,hp_lim = 179450105,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81041903,Rem) ->
	#mon{id = 81041903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 572,att = 3514647,hp_lim = 189790950,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042101,Rem) ->
	#mon{id = 81042101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 580,att = 3853935,hp_lim = 208112515,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042203,Rem) ->
	#mon{id = 81042203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 584,att = 4074098,hp_lim = 220001297,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042401,Rem) ->
	#mon{id = 81042401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 592,att = 4465756,hp_lim = 241150862,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042503,Rem) ->
	#mon{id = 81042503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 596,att = 3111276,hp_lim = 156808348,hit = 56002,dodge = 37335,ten = 29868,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042701,Rem) ->
	#mon{id = 81042701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 604,att = 5170612,hp_lim = 279213085,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81042803,Rem) ->
	#mon{id = 81042803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 608,att = 5461260,hp_lim = 294908090,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043001,Rem) ->
	#mon{id = 81043001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 616,att = 3792629,hp_lim = 191148501,hit = 68267,dodge = 45511,ten = 36409,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043103,Rem) ->
	#mon{id = 81043103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 619,att = 6315992,hp_lim = 341063598,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043301,Rem) ->
	#mon{id = 81043301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 625,att = 6780746,hp_lim = 366160287,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043403,Rem) ->
	#mon{id = 81043403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 628,att = 7016020,hp_lim = 378865095,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043601,Rem) ->
	#mon{id = 81043601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 634,att = 7530064,hp_lim = 406623475,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043703,Rem) ->
	#mon{id = 81043703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 637,att = 7944311,hp_lim = 428992794,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81043901,Rem) ->
	#mon{id = 81043901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 643,att = 8523979,hp_lim = 460294916,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044003,Rem) ->
	#mon{id = 81044003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 646,att = 5206466,hp_lim = 262405932,hit = 93716,dodge = 62477,ten = 49982,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044201,Rem) ->
	#mon{id = 81044201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 652,att = 9643218,hp_lim = 520733803,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044303,Rem) ->
	#mon{id = 81044303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 655,att = 9967581,hp_lim = 538249397,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044501,Rem) ->
	#mon{id = 81044501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 661,att = 5980593,hp_lim = 301421933,hit = 107650,dodge = 71767,ten = 57413,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044603,Rem) ->
	#mon{id = 81044603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 664,att = 11266348,hp_lim = 608382796,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044801,Rem) ->
	#mon{id = 81044801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 670,att = 12079195,hp_lim = 652276580,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81044903,Rem) ->
	#mon{id = 81044903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 673,att = 12477932,hp_lim = 673808361,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045101,Rem) ->
	#mon{id = 81045101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 679,att = 13375099,hp_lim = 722255367,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045203,Rem) ->
	#mon{id = 81045203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 682,att = 14088962,hp_lim = 760803993,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045401,Rem) ->
	#mon{id = 81045401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 688,att = 15098623,hp_lim = 815325680,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045503,Rem) ->
	#mon{id = 81045503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 691,att = 8210073,hp_lim = 413787725,hit = 147781,dodge = 98520,ten = 78816,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045701,Rem) ->
	#mon{id = 81045701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 697,att = 17036029,hp_lim = 919945595,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81045803,Rem) ->
	#mon{id = 81045803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 700,att = 17584109,hp_lim = 949541935,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81046001,Rem) ->
	#mon{id = 81046001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 706,att = 9430794,hp_lim = 475312030,hit = 169754,dodge = 113169,ten = 90535,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050003,Rem) ->
	#mon{id = 81050003,name = "上路物资",kind = 7,color = 3,module = 610,icon = 10010305,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 700,att = 17957357,hp_lim = 19617894680,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,collect_time = 5,is_fight_back = 0,is_be_clicked = 0,is_hit_ac = 1,rem_flag = Rem};
get(81050201,Rem) ->
	#mon{id = 81050201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 703,att = 18941719,hp_lim = 1022852843,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050303,Rem) ->
	#mon{id = 81050303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 706,att = 19540605,hp_lim = 1055192707,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050501,Rem) ->
	#mon{id = 81050501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 712,att = 10008034,hp_lim = 504404926,hit = 180144,dodge = 120096,ten = 96077,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050603,Rem) ->
	#mon{id = 81050603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 715,att = 22011726,hp_lim = 1188633234,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050801,Rem) ->
	#mon{id = 81050801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 721,att = 23565281,hp_lim = 1272525174,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81050903,Rem) ->
	#mon{id = 81050903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 724,att = 24299569,hp_lim = 1312176726,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051101,Rem) ->
	#mon{id = 81051101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 730,att = 26010160,hp_lim = 1404548655,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051203,Rem) ->
	#mon{id = 81051203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 733,att = 27351324,hp_lim = 1476971527,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051401,Rem) ->
	#mon{id = 81051401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 739,att = 28984965,hp_lim = 1565188112,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051503,Rem) ->
	#mon{id = 81051503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 742,att = 13338750,hp_lim = 672273008,hit = 240097,dodge = 160065,ten = 128052,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051701,Rem) ->
	#mon{id = 81051701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 748,att = 31040692,hp_lim = 1676197401,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81051803,Rem) ->
	#mon{id = 81051803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 751,att = 31674974,hp_lim = 1710448622,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052001,Rem) ->
	#mon{id = 81052001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 757,att = 14300945,hp_lim = 720767661,hit = 257417,dodge = 171611,ten = 137289,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052103,Rem) ->
	#mon{id = 81052103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 760,att = 33903429,hp_lim = 1830785177,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052301,Rem) ->
	#mon{id = 81052301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 766,att = 35211305,hp_lim = 1901410476,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052403,Rem) ->
	#mon{id = 81052403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 769,att = 35917635,hp_lim = 1939552320,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052601,Rem) ->
	#mon{id = 81052601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 775,att = 37297936,hp_lim = 2014088555,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052703,Rem) ->
	#mon{id = 81052703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 778,att = 38419910,hp_lim = 2074675166,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81052901,Rem) ->
	#mon{id = 81052901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 784,att = 39890925,hp_lim = 2154109983,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053003,Rem) ->
	#mon{id = 81053003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 787,att = 16768983,hp_lim = 845156764,hit = 301841,dodge = 201227,ten = 160982,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053201,Rem) ->
	#mon{id = 81053201,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 793,att = 43077915,hp_lim = 2326207458,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053303,Rem) ->
	#mon{id = 81053303,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 796,att = 44359129,hp_lim = 2395393002,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053501,Rem) ->
	#mon{id = 81053501,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 802,att = 18523390,hp_lim = 933578864,hit = 333421,dodge = 222280,ten = 177824,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053603,Rem) ->
	#mon{id = 81053603,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 805,att = 47881729,hp_lim = 2585613419,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053801,Rem) ->
	#mon{id = 81053801,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 811,att = 50192961,hp_lim = 2710419944,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81053903,Rem) ->
	#mon{id = 81053903,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 814,att = 51669864,hp_lim = 2790172688,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054101,Rem) ->
	#mon{id = 81054101,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 820,att = 54157490,hp_lim = 2924504486,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054203,Rem) ->
	#mon{id = 81054203,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 823,att = 56300301,hp_lim = 3040216299,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054401,Rem) ->
	#mon{id = 81054401,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 829,att = 60190029,hp_lim = 3250261567,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054503,Rem) ->
	#mon{id = 81054503,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 832,att = 23519790,hp_lim = 1185397432,hit = 423356,dodge = 282237,ten = 225789,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054701,Rem) ->
	#mon{id = 81054701,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 838,att = 66877550,hp_lim = 3611387753,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81054803,Rem) ->
	#mon{id = 81054803,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 841,att = 70199258,hp_lim = 3790759985,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055001,Rem) ->
	#mon{id = 81055001,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 847,att = 29275456,hp_lim = 1475482982,hit = 526958,dodge = 351305,ten = 281044,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055103,Rem) ->
	#mon{id = 81055103,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 850,att = 85273878,hp_lim = 4604789463,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055301,Rem) ->
	#mon{id = 81055301,name = "武力者",kind = 9,type = 1,color = 3,module = 610,icon = 10020101,icon_effect = <<"0"/utf8>>,weapon_id = 202005,lv = 856,att = 100670535,hp_lim = 5436208928,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055403,Rem) ->
	#mon{id = 81055403,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 859,att = 112142114,hp_lim = 6055674194,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055601,Rem) ->
	#mon{id = 81055601,name = "呼唤者",kind = 9,type = 1,color = 3,module = 610,icon = 10010103,icon_effect = <<"0"/utf8>>,weapon_id = 202004,lv = 865,att = 147688260,hp_lim = 7975166067,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055703,Rem) ->
	#mon{id = 81055703,name = "狂热者",kind = 9,type = 1,color = 3,module = 610,icon = 10010104,icon_effect = <<"0"/utf8>>,weapon_id = 202011,lv = 868,att = 189085008,hp_lim = 10210590471,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81055901,Rem) ->
	#mon{id = 81055901,name = "争夺者",kind = 9,type = 1,color = 3,module = 610,icon = 10100101,icon_effect = <<"0"/utf8>>,weapon_id = 202031,lv = 874,att = 349235279,hp_lim = 18858705106,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(81056003,Rem) ->
	#mon{id = 81056003,name = "持械者",kind = 9,boss = 6,type = 1,color = 3,module = 610,icon = 10010102,icon_effect = <<"0"/utf8>>,weapon_id = 202034,lv = 877,att = 167010617,hp_lim = 8417335109,hit = 3006191,dodge = 2004127,ten = 1603301,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000001,Rem) ->
	#mon{id = 82000001,name = "网路死神",boss = 6,color = 1,module = 610,auto = 3,icon = 10010003,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000007,Rem) ->
	#mon{id = 82000007,name = "魔兽地狱犬",boss = 6,color = 1,module = 610,auto = 3,icon = 10030001,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000013,Rem) ->
	#mon{id = 82000013,name = "异星人马",boss = 6,color = 1,module = 610,auto = 3,icon = 10010009,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(82000019,Rem) ->
	#mon{id = 82000019,name = "三角杀戮者",boss = 6,color = 1,module = 610,auto = 3,icon = 10040002,icon_effect = <<"0"/utf8>>,weapon_id = 202002,hp_lim = 1000000,striking_distance = 110,tracing_distance = 800,hate_range = 600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(83000003,Rem) ->
	#mon{id = 83000003,name = "时空领主",boss = 5,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 203024,lv = 200,att = 5000,hp_lim = 100000000000,striking_distance = 110,tracing_distance = 800,warning_range = 600,hate_range = 600,skill = [{1110000001,1}],att_time = 2000,drop = 1,is_armor = 1,is_hide_hp = 1,is_hit_ac = 1,rem_flag = Rem};
get(84000005,Rem) ->
	#mon{id = 84000005,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 382,att = 451531,hp_lim = 15658614,hit = 9320,dodge = 6213,ten = 4970,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000011,Rem) ->
	#mon{id = 84000011,name = "日之使者",boss = 6,type = 1,color = 1,module = 610,icon = 10010006,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 386,att = 613533,hp_lim = 16447914,hit = 9790,dodge = 6526,ten = 5221,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000017,Rem) ->
	#mon{id = 84000017,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 391,att = 259409,hp_lim = 8037431,hit = 9568,dodge = 6378,ten = 5103,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000023,Rem) ->
	#mon{id = 84000023,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 398,att = 525430,hp_lim = 18221353,hit = 10846,dodge = 7230,ten = 5784,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000029,Rem) ->
	#mon{id = 84000029,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 403,att = 307825,hp_lim = 9537551,hit = 11354,dodge = 7569,ten = 6055,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000035,Rem) ->
	#mon{id = 84000035,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 410,att = 609188,hp_lim = 21125986,hit = 12574,dodge = 8383,ten = 6706,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000041,Rem) ->
	#mon{id = 84000041,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 415,att = 346325,hp_lim = 10730422,hit = 12774,dodge = 8516,ten = 6812,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000047,Rem) ->
	#mon{id = 84000047,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 428,att = 728700,hp_lim = 25270514,hit = 15041,dodge = 10027,ten = 8022,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000053,Rem) ->
	#mon{id = 84000053,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 433,att = 413609,hp_lim = 12815116,hit = 15256,dodge = 10170,ten = 8136,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000059,Rem) ->
	#mon{id = 84000059,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 440,att = 836274,hp_lim = 29001094,hit = 17262,dodge = 11508,ten = 9206,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000065,Rem) ->
	#mon{id = 84000065,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 445,att = 474305,hp_lim = 14695702,hit = 17494,dodge = 11663,ten = 9330,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000071,Rem) ->
	#mon{id = 84000071,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 458,att = 981193,hp_lim = 34026708,hit = 20253,dodge = 13502,ten = 10802,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000077,Rem) ->
	#mon{id = 84000077,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 463,att = 555626,hp_lim = 17215320,hit = 20494,dodge = 13662,ten = 10930,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000083,Rem) ->
	#mon{id = 84000083,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 470,att = 1079769,hp_lim = 37445214,hit = 22288,dodge = 14859,ten = 11887,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000089,Rem) ->
	#mon{id = 84000089,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 475,att = 611241,hp_lim = 18938469,hit = 22545,dodge = 15030,ten = 12024,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000095,Rem) ->
	#mon{id = 84000095,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 488,att = 1247615,hp_lim = 43265922,hit = 25753,dodge = 17169,ten = 13735,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000101,Rem) ->
	#mon{id = 84000101,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 493,att = 723390,hp_lim = 22413237,hit = 26682,dodge = 17788,ten = 14230,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000107,Rem) ->
	#mon{id = 84000107,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 500,att = 1430204,hp_lim = 49597926,hit = 29522,dodge = 19681,ten = 15745,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000113,Rem) ->
	#mon{id = 84000113,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 505,att = 807968,hp_lim = 25033780,hit = 29802,dodge = 19868,ten = 15894,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000119,Rem) ->
	#mon{id = 84000119,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 518,att = 1703704,hp_lim = 59082609,hit = 35168,dodge = 23445,ten = 18756,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000125,Rem) ->
	#mon{id = 84000125,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 526,att = 1047781,hp_lim = 32464053,hit = 38647,dodge = 25765,ten = 20612,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000131,Rem) ->
	#mon{id = 84000131,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 538,att = 2221185,hp_lim = 77028267,hit = 45850,dodge = 30566,ten = 24453,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000137,Rem) ->
	#mon{id = 84000137,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 546,att = 1325257,hp_lim = 41061256,hit = 48882,dodge = 32588,ten = 26070,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000143,Rem) ->
	#mon{id = 84000143,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 559,att = 2875301,hp_lim = 99712302,hit = 59352,dodge = 39568,ten = 31654,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000149,Rem) ->
	#mon{id = 84000149,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 567,att = 1703463,hp_lim = 52779443,hit = 62832,dodge = 41888,ten = 33510,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000155,Rem) ->
	#mon{id = 84000155,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 579,att = 3586828,hp_lim = 124387280,hit = 74040,dodge = 49360,ten = 39488,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000161,Rem) ->
	#mon{id = 84000161,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 587,att = 2188176,hp_lim = 67797604,hit = 80711,dodge = 53807,ten = 43046,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000167,Rem) ->
	#mon{id = 84000167,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 600,att = 4600903,hp_lim = 159554253,hit = 94972,dodge = 63315,ten = 50652,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000173,Rem) ->
	#mon{id = 84000173,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 1,weapon_id = 202002,lv = 612,att = 2864083,hp_lim = 88739645,hit = 105642,dodge = 70428,ten = 56342,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000179,Rem) ->
	#mon{id = 84000179,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 632,att = 6509797,hp_lim = 225752625,hit = 134376,dodge = 89584,ten = 71667,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000185,Rem) ->
	#mon{id = 84000185,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10020104,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 644,att = 4134955,hp_lim = 128115838,hit = 152518,dodge = 101679,ten = 81343,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000191,Rem) ->
	#mon{id = 84000191,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 664,att = 9386577,hp_lim = 325516159,hit = 193759,dodge = 129173,ten = 103338,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000197,Rem) ->
	#mon{id = 84000197,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 676,att = 5847384,hp_lim = 181173050,hit = 215682,dodge = 143788,ten = 115030,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000203,Rem) ->
	#mon{id = 84000203,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 696,att = 13258179,hp_lim = 459779072,hit = 273678,dodge = 182452,ten = 145961,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000209,Rem) ->
	#mon{id = 84000209,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10090101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 708,att = 8261918,hp_lim = 255984046,hit = 304742,dodge = 203161,ten = 162529,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000215,Rem) ->
	#mon{id = 84000215,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 728,att = 18711893,hp_lim = 648907862,hit = 386254,dodge = 257503,ten = 206002,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000221,Rem) ->
	#mon{id = 84000221,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10130101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 740,att = 11665199,hp_lim = 361429945,hit = 430273,dodge = 286849,ten = 229479,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000227,Rem) ->
	#mon{id = 84000227,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 760,att = 23915630,hp_lim = 829367743,hit = 493671,dodge = 329114,ten = 263291,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000233,Rem) ->
	#mon{id = 84000233,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 772,att = 14056218,hp_lim = 435512357,hit = 518467,dodge = 345644,ten = 276515,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000239,Rem) ->
	#mon{id = 84000239,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 792,att = 29076668,hp_lim = 1008346867,hit = 600206,dodge = 400137,ten = 320110,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000245,Rem) ->
	#mon{id = 84000245,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10050105,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 804,att = 17437934,hp_lim = 540290096,hit = 643202,dodge = 428801,ten = 343041,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000251,Rem) ->
	#mon{id = 84000251,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 824,att = 37501110,hp_lim = 1300497231,hit = 774105,dodge = 516070,ten = 412856,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000257,Rem) ->
	#mon{id = 84000257,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10040101,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 836,att = 23409645,hp_lim = 725315241,hit = 863470,dodge = 575647,ten = 460517,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000263,Rem) ->
	#mon{id = 84000263,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 856,att = 64503965,hp_lim = 2236926512,hit = 1331503,dodge = 887669,ten = 710135,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(84000269,Rem) ->
	#mon{id = 84000269,name = "星辰守卫",type = 1,color = 1,module = 610,icon = 10080102,icon_effect = <<"0"/utf8>>,icon_texture = 2,weapon_id = 202002,lv = 868,att = 65583346,hp_lim = 2032008599,hit = 2419057,dodge = 1612705,ten = 1290164,striking_distance = 110,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000001,1}],att_time = 2000,drop = 1,exp = 15,is_hit_ac = 1,rem_flag = Rem};
get(84000275,Rem) ->
	#mon{id = 84000275,name = "辰月",boss = 6,type = 1,color = 1,module = 610,icon = 10030004,icon_effect = <<"0"/utf8>>,weapon_id = 202002,lv = 888,att = 550308635,hp_lim = 19084097639,hit = 11359581,dodge = 7573054,ten = 6058443,striking_distance = 300,tracing_distance = 1600,warning_range = 1600,hate_range = 1600,speed = 200,skill = [{1110000003,1}],att_time = 2000,att_type = 1,drop = 1,exp = 15,del_hp_each_time = [0.01,0.08],is_hit_ac = 1,rem_flag = Rem};
get(85000001,Rem) ->
	#mon{id = 85000001,name = "魔龙·诺兹多姆",boss = 11,color = 1,module = 331,sub_module = 117,auto = 1,icon = 10030002,icon_effect = <<"0"/utf8>>,weapon_id = 202006,lv = 200,att = 100000,hp_lim = 2000000,striking_distance = 150,tracing_distance = 2250,warning_range = 1500,hate_range = 2250,speed = 200,skill = [{1110000001,1}],att_time = 2000,del_hp_each_time = [4000,8000],rem_flag = Rem};
get(_MonTypeId, _Rem) -> [].