%%%---------------------------------------
%%% module      : data_race_rank
%%% description : 跨服竞榜活动配置
%%%
%%%---------------------------------------
-module(data_race_rank).
-compile(export_all).
-include("race_rank.hrl").



get_race_rank_act(101) ->
    #race_rank_act{act_id = 101,type = 1,open_day = [1,400],name = <<"座驾冲榜"/utf8>>,start_time = 1594656000,end_time = 1594821600,show_time = 7200,condition = [{icon,3},{show,2,1001,1012},{fight,[146,1,3]}],lv = 50};

get_race_rank_act(102) ->
    #race_rank_act{act_id = 102,type = 1,open_day = [1,400],name = <<"宠物冲榜"/utf8>>,start_time = 1594656000,end_time = 1594821600,show_time = 7200,condition = [{icon,1},{show,2,1201,1083},{fight,[163,1,201]}],lv = 70};

get_race_rank_act(_Actid) ->
    false.

get_race_rank_act_list() ->
    [101,102].

%%单抽消耗
get_race_rank_config(rock_cost_1) ->
    [{0,102350,25}];

%%十连抽消耗
get_race_rank_config(rock_cost_10) ->
    [{0,102350,200}];

%%单抽所得积分
get_race_rank_config(rock_score_1) ->
    1;

%%10连抽所得积分
get_race_rank_config(rock_score_10) ->
    10;

%%最大上榜人数
get_race_rank_config(max_rank) ->
    50;

%%跨服服务器数
get_race_rank_config(cross_service_number) ->
    10;

%%单抽为全服进度贡献积分区间
get_race_rank_config(random_score_area) ->
    [1,10];

get_race_rank_config(_Key) ->
    [].

get_world_lev_stage(WorldLev) when WorldLev >= 0, WorldLev =< 208 ->
		1;
get_world_lev_stage(WorldLev) when WorldLev >= 209, WorldLev =< 550 ->
		2;
get_world_lev_stage(WorldLev) when WorldLev >= 551, WorldLev =< 999 ->
		3;
get_world_lev_stage(_WorldLev) ->
    0.

get_race_rank_draw_pool(101,1,1) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 1,award = [{100,230001,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,2) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 2,award = [{100,230001,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,3) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 3,award = [{100,230001,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,4) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 4,award = [{100,230001,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,5) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 5,award = [{100,230001,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,6) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 6,award = [{100,230001,6}],loading_times = 1,weight = 10000000,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,7) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 7,award = [{100,230001,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,8) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 8,award = [{100,230001,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,9) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 9,award = [{100,230001,9}],loading_times = 100,weight = 12000000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,10) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 10,award = [{100,230001,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,11) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 11,award = [{100,230001,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,12) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 12,award = [{100,230001,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,13) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 13,award = [{100,230001,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,14) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 14,award = [{100,230001,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,15) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 15,award = [{100,230001,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,16) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 16,award = [{100,230001,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,17) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 17,award = [{100,230001,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,18) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 18,award = [{100,230001,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,19) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 19,award = [{100,230001,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,20) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 20,award = [{100,230001,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,21) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 21,award = [{100,230001,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,22) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 22,award = [{100,230001,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,23) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 23,award = [{100,230001,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,24) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 24,award = [{100,230001,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,25) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 25,award = [{100,230001,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,26) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 26,award = [{100,230001,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,27) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 27,award = [{100,230001,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,28) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 28,award = [{100,230001,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,29) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 29,award = [{100,230001,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,30) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 30,award = [{100,230001,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,31) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 31,award = [{100,230001,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,1,32) ->
    #race_rank_draw_pool{act_id = 101,stage = 1,award_id = 32,award = [{100,230001,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,1) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 1,award = [{100,230001,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,2) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 2,award = [{100,230001,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,3) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 3,award = [{100,230001,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,4) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 4,award = [{100,230001,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,5) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 5,award = [{100,230001,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,6) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 6,award = [{100,230001,38}],loading_times = 1,weight = 1000000000,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,7) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 7,award = [{100,230001,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,8) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 8,award = [{100,230001,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,9) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 9,award = [{100,230001,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,10) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 10,award = [{100,230001,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,11) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 11,award = [{100,230001,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,12) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 12,award = [{100,230001,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,13) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 13,award = [{100,230001,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,14) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 14,award = [{100,230001,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,15) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 15,award = [{100,230001,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,16) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 16,award = [{100,230001,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,17) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 17,award = [{100,230001,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,18) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 18,award = [{100,230001,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,19) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 19,award = [{100,230001,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,20) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 20,award = [{100,230001,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,21) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 21,award = [{100,230001,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,22) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 22,award = [{100,230001,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,23) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 23,award = [{100,230001,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,24) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 24,award = [{100,230001,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,25) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 25,award = [{100,230001,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,26) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 26,award = [{100,230001,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,27) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 27,award = [{100,230001,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,28) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 28,award = [{100,230001,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,29) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 29,award = [{100,230001,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,30) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 30,award = [{100,230001,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,31) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 31,award = [{100,230001,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,2,32) ->
    #race_rank_draw_pool{act_id = 101,stage = 2,award_id = 32,award = [{100,230001,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,1) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 1,award = [{100,230001,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,2) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 2,award = [{100,230001,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,3) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 3,award = [{100,230001,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,4) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 4,award = [{100,230001,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,5) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 5,award = [{100,230001,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,6) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 6,award = [{100,230001,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,7) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 7,award = [{100,230001,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,8) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 8,award = [{100,230001,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,9) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 9,award = [{100,230001,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,10) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 10,award = [{100,230001,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,11) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 11,award = [{100,230001,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,12) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 12,award = [{100,230001,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,13) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 13,award = [{100,230001,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,14) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 14,award = [{100,230001,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,15) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 15,award = [{100,230001,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,16) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 16,award = [{100,230001,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,17) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 17,award = [{100,230001,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,18) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 18,award = [{100,230001,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,19) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 19,award = [{100,230001,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,20) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 20,award = [{100,230001,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,21) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 21,award = [{100,230001,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,22) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 22,award = [{100,230001,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,23) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 23,award = [{100,230001,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,24) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 24,award = [{100,230001,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,25) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 25,award = [{100,230001,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,26) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 26,award = [{100,230001,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,27) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 27,award = [{100,230001,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,28) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 28,award = [{100,230001,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,29) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 29,award = [{100,230001,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,30) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 30,award = [{100,230001,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,31) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 31,award = [{100,230001,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(101,3,32) ->
    #race_rank_draw_pool{act_id = 101,stage = 3,award_id = 32,award = [{100,230001,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,1) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 1,award = [{100,230002,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,2) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 2,award = [{100,230002,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,3) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 3,award = [{100,230002,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,4) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 4,award = [{100,230002,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,5) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 5,award = [{100,230002,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,6) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 6,award = [{100,230002,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,7) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 7,award = [{100,230002,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,8) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 8,award = [{100,230002,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,9) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 9,award = [{100,230002,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,10) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 10,award = [{100,230002,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,11) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 11,award = [{100,230002,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,12) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 12,award = [{100,230002,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,13) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 13,award = [{100,230002,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,14) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 14,award = [{100,230002,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,15) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 15,award = [{100,230002,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,16) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 16,award = [{100,230002,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,17) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 17,award = [{100,230002,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,18) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 18,award = [{100,230002,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,19) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 19,award = [{100,230002,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,20) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 20,award = [{100,230002,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,21) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 21,award = [{100,230002,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,22) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 22,award = [{100,230002,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,23) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 23,award = [{100,230002,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,24) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 24,award = [{100,230002,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,25) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 25,award = [{100,230002,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,26) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 26,award = [{100,230002,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,27) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 27,award = [{100,230002,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,28) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 28,award = [{100,230002,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,29) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 29,award = [{100,230002,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,30) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 30,award = [{100,230002,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,31) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 31,award = [{100,230002,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,1,32) ->
    #race_rank_draw_pool{act_id = 102,stage = 1,award_id = 32,award = [{100,230002,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,1) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 1,award = [{100,230002,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,2) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 2,award = [{100,230002,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,3) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 3,award = [{100,230002,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,4) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 4,award = [{100,230002,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,5) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 5,award = [{100,230002,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,6) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 6,award = [{100,230002,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,7) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 7,award = [{100,230002,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,8) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 8,award = [{100,230002,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,9) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 9,award = [{100,230002,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,10) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 10,award = [{100,230002,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,11) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 11,award = [{100,230002,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,12) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 12,award = [{100,230002,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,13) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 13,award = [{100,230002,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,14) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 14,award = [{100,230002,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,15) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 15,award = [{100,230002,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,16) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 16,award = [{100,230002,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,17) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 17,award = [{100,230002,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,18) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 18,award = [{100,230002,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,19) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 19,award = [{100,230002,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,20) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 20,award = [{100,230002,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,21) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 21,award = [{100,230002,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,22) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 22,award = [{100,230002,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,23) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 23,award = [{100,230002,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,24) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 24,award = [{100,230002,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,25) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 25,award = [{100,230002,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,26) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 26,award = [{100,230002,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,27) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 27,award = [{100,230002,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,28) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 28,award = [{100,230002,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,29) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 29,award = [{100,230002,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,30) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 30,award = [{100,230002,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,31) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 31,award = [{100,230002,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,2,32) ->
    #race_rank_draw_pool{act_id = 102,stage = 2,award_id = 32,award = [{100,230002,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,1) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 1,award = [{100,230002,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,2) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 2,award = [{100,230002,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,3) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 3,award = [{100,230002,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,4) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 4,award = [{100,230002,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,5) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 5,award = [{100,230002,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,6) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 6,award = [{100,230002,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,7) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 7,award = [{100,230002,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,8) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 8,award = [{100,230002,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,9) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 9,award = [{100,230002,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,10) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 10,award = [{100,230002,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,11) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 11,award = [{100,230002,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,12) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 12,award = [{100,230002,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,13) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 13,award = [{100,230002,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,14) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 14,award = [{100,230002,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,15) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 15,award = [{100,230002,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,16) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 16,award = [{100,230002,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,17) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 17,award = [{100,230002,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,18) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 18,award = [{100,230002,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,19) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 19,award = [{100,230002,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,20) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 20,award = [{100,230002,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,21) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 21,award = [{100,230002,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,22) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 22,award = [{100,230002,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,23) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 23,award = [{100,230002,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,24) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 24,award = [{100,230002,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,25) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 25,award = [{100,230002,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,26) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 26,award = [{100,230002,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,27) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 27,award = [{100,230002,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,28) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 28,award = [{100,230002,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,29) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 29,award = [{100,230002,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,30) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 30,award = [{100,230002,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,31) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 31,award = [{100,230002,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(102,3,32) ->
    #race_rank_draw_pool{act_id = 102,stage = 3,award_id = 32,award = [{100,230002,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,1) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 1,award = [{100,230003,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,2) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 2,award = [{100,230003,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,3) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 3,award = [{100,230003,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,4) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 4,award = [{100,230003,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,5) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 5,award = [{100,230003,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,6) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 6,award = [{100,230003,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,7) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 7,award = [{100,230003,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,8) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 8,award = [{100,230003,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,9) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 9,award = [{100,230003,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,10) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 10,award = [{100,230003,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,11) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 11,award = [{100,230003,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,12) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 12,award = [{100,230003,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,13) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 13,award = [{100,230003,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,14) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 14,award = [{100,230003,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,15) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 15,award = [{100,230003,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,16) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 16,award = [{100,230003,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,17) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 17,award = [{100,230003,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,18) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 18,award = [{100,230003,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,19) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 19,award = [{100,230003,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,20) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 20,award = [{100,230003,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,21) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 21,award = [{100,230003,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,22) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 22,award = [{100,230003,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,23) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 23,award = [{100,230003,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,24) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 24,award = [{100,230003,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,25) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 25,award = [{100,230003,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,26) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 26,award = [{100,230003,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,27) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 27,award = [{100,230003,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,28) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 28,award = [{100,230003,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,29) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 29,award = [{100,230003,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,30) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 30,award = [{100,230003,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,31) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 31,award = [{100,230003,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,1,32) ->
    #race_rank_draw_pool{act_id = 103,stage = 1,award_id = 32,award = [{100,230003,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,1) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 1,award = [{100,230003,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,2) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 2,award = [{100,230003,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,3) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 3,award = [{100,230003,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,4) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 4,award = [{100,230003,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,5) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 5,award = [{100,230003,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,6) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 6,award = [{100,230003,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,7) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 7,award = [{100,230003,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,8) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 8,award = [{100,230003,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,9) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 9,award = [{100,230003,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,10) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 10,award = [{100,230003,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,11) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 11,award = [{100,230003,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,12) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 12,award = [{100,230003,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,13) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 13,award = [{100,230003,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,14) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 14,award = [{100,230003,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,15) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 15,award = [{100,230003,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,16) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 16,award = [{100,230003,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,17) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 17,award = [{100,230003,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,18) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 18,award = [{100,230003,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,19) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 19,award = [{100,230003,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,20) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 20,award = [{100,230003,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,21) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 21,award = [{100,230003,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,22) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 22,award = [{100,230003,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,23) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 23,award = [{100,230003,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,24) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 24,award = [{100,230003,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,25) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 25,award = [{100,230003,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,26) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 26,award = [{100,230003,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,27) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 27,award = [{100,230003,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,28) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 28,award = [{100,230003,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,29) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 29,award = [{100,230003,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,30) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 30,award = [{100,230003,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,31) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 31,award = [{100,230003,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,2,32) ->
    #race_rank_draw_pool{act_id = 103,stage = 2,award_id = 32,award = [{100,230003,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,1) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 1,award = [{100,230003,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,2) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 2,award = [{100,230003,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,3) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 3,award = [{100,230003,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,4) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 4,award = [{100,230003,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,5) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 5,award = [{100,230003,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,6) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 6,award = [{100,230003,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,7) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 7,award = [{100,230003,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,8) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 8,award = [{100,230003,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,9) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 9,award = [{100,230003,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,10) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 10,award = [{100,230003,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,11) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 11,award = [{100,230003,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,12) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 12,award = [{100,230003,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,13) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 13,award = [{100,230003,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,14) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 14,award = [{100,230003,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,15) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 15,award = [{100,230003,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,16) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 16,award = [{100,230003,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,17) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 17,award = [{100,230003,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,18) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 18,award = [{100,230003,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,19) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 19,award = [{100,230003,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,20) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 20,award = [{100,230003,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,21) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 21,award = [{100,230003,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,22) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 22,award = [{100,230003,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,23) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 23,award = [{100,230003,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,24) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 24,award = [{100,230003,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,25) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 25,award = [{100,230003,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,26) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 26,award = [{100,230003,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,27) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 27,award = [{100,230003,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,28) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 28,award = [{100,230003,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,29) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 29,award = [{100,230003,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,30) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 30,award = [{100,230003,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,31) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 31,award = [{100,230003,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(103,3,32) ->
    #race_rank_draw_pool{act_id = 103,stage = 3,award_id = 32,award = [{100,230003,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,1) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 1,award = [{100,230004,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,2) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 2,award = [{100,230004,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,3) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 3,award = [{100,230004,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,4) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 4,award = [{100,230004,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,5) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 5,award = [{100,230004,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,6) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 6,award = [{100,230004,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,7) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 7,award = [{100,230004,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,8) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 8,award = [{100,230004,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,9) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 9,award = [{100,230004,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,10) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 10,award = [{100,230004,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,11) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 11,award = [{100,230004,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,12) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 12,award = [{100,230004,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,13) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 13,award = [{100,230004,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,14) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 14,award = [{100,230004,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,15) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 15,award = [{100,230004,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,16) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 16,award = [{100,230004,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,17) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 17,award = [{100,230004,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,18) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 18,award = [{100,230004,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,19) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 19,award = [{100,230004,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,20) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 20,award = [{100,230004,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,21) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 21,award = [{100,230004,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,22) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 22,award = [{100,230004,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,23) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 23,award = [{100,230004,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,24) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 24,award = [{100,230004,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,25) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 25,award = [{100,230004,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,26) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 26,award = [{100,230004,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,27) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 27,award = [{100,230004,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,28) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 28,award = [{100,230004,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,29) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 29,award = [{100,230004,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,30) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 30,award = [{100,230004,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,31) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 31,award = [{100,230004,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,1,32) ->
    #race_rank_draw_pool{act_id = 104,stage = 1,award_id = 32,award = [{100,230004,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,1) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 1,award = [{100,230004,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,2) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 2,award = [{100,230004,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,3) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 3,award = [{100,230004,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,4) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 4,award = [{100,230004,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,5) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 5,award = [{100,230004,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,6) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 6,award = [{100,230004,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,7) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 7,award = [{100,230004,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,8) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 8,award = [{100,230004,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,9) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 9,award = [{100,230004,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,10) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 10,award = [{100,230004,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,11) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 11,award = [{100,230004,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,12) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 12,award = [{100,230004,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,13) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 13,award = [{100,230004,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,14) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 14,award = [{100,230004,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,15) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 15,award = [{100,230004,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,16) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 16,award = [{100,230004,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,17) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 17,award = [{100,230004,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,18) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 18,award = [{100,230004,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,19) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 19,award = [{100,230004,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,20) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 20,award = [{100,230004,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,21) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 21,award = [{100,230004,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,22) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 22,award = [{100,230004,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,23) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 23,award = [{100,230004,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,24) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 24,award = [{100,230004,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,25) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 25,award = [{100,230004,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,26) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 26,award = [{100,230004,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,27) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 27,award = [{100,230004,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,28) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 28,award = [{100,230004,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,29) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 29,award = [{100,230004,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,30) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 30,award = [{100,230004,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,31) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 31,award = [{100,230004,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,2,32) ->
    #race_rank_draw_pool{act_id = 104,stage = 2,award_id = 32,award = [{100,230004,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,1) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 1,award = [{100,230004,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,2) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 2,award = [{100,230004,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,3) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 3,award = [{100,230004,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,4) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 4,award = [{100,230004,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,5) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 5,award = [{100,230004,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,6) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 6,award = [{100,230004,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,7) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 7,award = [{100,230004,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,8) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 8,award = [{100,230004,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,9) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 9,award = [{100,230004,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,10) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 10,award = [{100,230004,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,11) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 11,award = [{100,230004,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,12) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 12,award = [{100,230004,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,13) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 13,award = [{100,230004,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,14) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 14,award = [{100,230004,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,15) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 15,award = [{100,230004,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,16) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 16,award = [{100,230004,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,17) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 17,award = [{100,230004,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,18) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 18,award = [{100,230004,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,19) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 19,award = [{100,230004,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,20) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 20,award = [{100,230004,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,21) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 21,award = [{100,230004,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,22) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 22,award = [{100,230004,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,23) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 23,award = [{100,230004,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,24) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 24,award = [{100,230004,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,25) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 25,award = [{100,230004,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,26) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 26,award = [{100,230004,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,27) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 27,award = [{100,230004,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,28) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 28,award = [{100,230004,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,29) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 29,award = [{100,230004,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,30) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 30,award = [{100,230004,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,31) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 31,award = [{100,230004,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(104,3,32) ->
    #race_rank_draw_pool{act_id = 104,stage = 3,award_id = 32,award = [{100,230004,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,1) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 1,award = [{100,230005,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,2) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 2,award = [{100,230005,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,3) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 3,award = [{100,230005,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,4) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 4,award = [{100,230005,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,5) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 5,award = [{100,230005,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,6) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 6,award = [{100,230005,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,7) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 7,award = [{100,230005,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,8) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 8,award = [{100,230005,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,9) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 9,award = [{100,230005,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,10) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 10,award = [{100,230005,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,11) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 11,award = [{100,230005,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,12) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 12,award = [{100,230005,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,13) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 13,award = [{100,230005,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,14) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 14,award = [{100,230005,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,15) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 15,award = [{100,230005,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,16) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 16,award = [{100,230005,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,17) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 17,award = [{100,230005,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,18) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 18,award = [{100,230005,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,19) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 19,award = [{100,230005,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,20) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 20,award = [{100,230005,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,21) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 21,award = [{100,230005,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,22) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 22,award = [{100,230005,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,23) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 23,award = [{100,230005,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,24) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 24,award = [{100,230005,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,25) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 25,award = [{100,230005,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,26) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 26,award = [{100,230005,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,27) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 27,award = [{100,230005,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,28) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 28,award = [{100,230005,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,29) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 29,award = [{100,230005,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,30) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 30,award = [{100,230005,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,31) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 31,award = [{100,230005,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,1,32) ->
    #race_rank_draw_pool{act_id = 105,stage = 1,award_id = 32,award = [{100,230005,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,1) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 1,award = [{100,230005,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,2) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 2,award = [{100,230005,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,3) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 3,award = [{100,230005,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,4) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 4,award = [{100,230005,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,5) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 5,award = [{100,230005,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,6) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 6,award = [{100,230005,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,7) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 7,award = [{100,230005,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,8) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 8,award = [{100,230005,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,9) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 9,award = [{100,230005,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,10) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 10,award = [{100,230005,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,11) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 11,award = [{100,230005,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,12) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 12,award = [{100,230005,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,13) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 13,award = [{100,230005,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,14) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 14,award = [{100,230005,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,15) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 15,award = [{100,230005,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,16) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 16,award = [{100,230005,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,17) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 17,award = [{100,230005,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,18) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 18,award = [{100,230005,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,19) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 19,award = [{100,230005,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,20) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 20,award = [{100,230005,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,21) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 21,award = [{100,230005,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,22) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 22,award = [{100,230005,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,23) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 23,award = [{100,230005,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,24) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 24,award = [{100,230005,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,25) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 25,award = [{100,230005,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,26) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 26,award = [{100,230005,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,27) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 27,award = [{100,230005,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,28) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 28,award = [{100,230005,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,29) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 29,award = [{100,230005,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,30) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 30,award = [{100,230005,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,31) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 31,award = [{100,230005,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,2,32) ->
    #race_rank_draw_pool{act_id = 105,stage = 2,award_id = 32,award = [{100,230005,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,1) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 1,award = [{100,230005,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,2) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 2,award = [{100,230005,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,3) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 3,award = [{100,230005,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,4) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 4,award = [{100,230005,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,5) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 5,award = [{100,230005,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,6) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 6,award = [{100,230005,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,7) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 7,award = [{100,230005,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,8) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 8,award = [{100,230005,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,9) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 9,award = [{100,230005,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,10) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 10,award = [{100,230005,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,11) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 11,award = [{100,230005,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,12) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 12,award = [{100,230005,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,13) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 13,award = [{100,230005,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,14) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 14,award = [{100,230005,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,15) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 15,award = [{100,230005,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,16) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 16,award = [{100,230005,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,17) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 17,award = [{100,230005,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,18) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 18,award = [{100,230005,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,19) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 19,award = [{100,230005,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,20) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 20,award = [{100,230005,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,21) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 21,award = [{100,230005,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,22) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 22,award = [{100,230005,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,23) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 23,award = [{100,230005,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,24) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 24,award = [{100,230005,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,25) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 25,award = [{100,230005,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,26) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 26,award = [{100,230005,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,27) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 27,award = [{100,230005,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,28) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 28,award = [{100,230005,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,29) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 29,award = [{100,230005,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,30) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 30,award = [{100,230005,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,31) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 31,award = [{100,230005,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(105,3,32) ->
    #race_rank_draw_pool{act_id = 105,stage = 3,award_id = 32,award = [{100,230005,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,1) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 1,award = [{100,230006,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,2) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 2,award = [{100,230006,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,3) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 3,award = [{100,230006,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,4) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 4,award = [{100,230006,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,5) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 5,award = [{100,230006,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,6) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 6,award = [{100,230006,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,7) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 7,award = [{100,230006,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,8) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 8,award = [{100,230006,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,9) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 9,award = [{100,230006,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,10) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 10,award = [{100,230006,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,11) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 11,award = [{100,230006,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,12) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 12,award = [{100,230006,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,13) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 13,award = [{100,230006,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,14) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 14,award = [{100,230006,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,15) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 15,award = [{100,230006,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,16) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 16,award = [{100,230006,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,17) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 17,award = [{100,230006,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,18) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 18,award = [{100,230006,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,19) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 19,award = [{100,230006,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,20) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 20,award = [{100,230006,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,21) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 21,award = [{100,230006,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,22) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 22,award = [{100,230006,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,23) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 23,award = [{100,230006,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,24) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 24,award = [{100,230006,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,25) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 25,award = [{100,230006,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,26) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 26,award = [{100,230006,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,27) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 27,award = [{100,230006,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,28) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 28,award = [{100,230006,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,29) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 29,award = [{100,230006,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,30) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 30,award = [{100,230006,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,31) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 31,award = [{100,230006,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,1,32) ->
    #race_rank_draw_pool{act_id = 106,stage = 1,award_id = 32,award = [{100,230006,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,1) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 1,award = [{100,230006,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,2) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 2,award = [{100,230006,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,3) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 3,award = [{100,230006,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,4) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 4,award = [{100,230006,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,5) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 5,award = [{100,230006,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,6) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 6,award = [{100,230006,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,7) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 7,award = [{100,230006,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,8) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 8,award = [{100,230006,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,9) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 9,award = [{100,230006,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,10) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 10,award = [{100,230006,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,11) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 11,award = [{100,230006,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,12) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 12,award = [{100,230006,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,13) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 13,award = [{100,230006,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,14) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 14,award = [{100,230006,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,15) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 15,award = [{100,230006,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,16) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 16,award = [{100,230006,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,17) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 17,award = [{100,230006,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,18) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 18,award = [{100,230006,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,19) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 19,award = [{100,230006,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,20) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 20,award = [{100,230006,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,21) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 21,award = [{100,230006,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,22) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 22,award = [{100,230006,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,23) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 23,award = [{100,230006,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,24) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 24,award = [{100,230006,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,25) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 25,award = [{100,230006,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,26) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 26,award = [{100,230006,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,27) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 27,award = [{100,230006,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,28) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 28,award = [{100,230006,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,29) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 29,award = [{100,230006,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,30) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 30,award = [{100,230006,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,31) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 31,award = [{100,230006,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,2,32) ->
    #race_rank_draw_pool{act_id = 106,stage = 2,award_id = 32,award = [{100,230006,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,1) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 1,award = [{100,230006,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,2) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 2,award = [{100,230006,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,3) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 3,award = [{100,230006,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,4) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 4,award = [{100,230006,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,5) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 5,award = [{100,230006,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,6) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 6,award = [{100,230006,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,7) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 7,award = [{100,230006,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,8) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 8,award = [{100,230006,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,9) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 9,award = [{100,230006,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,10) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 10,award = [{100,230006,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,11) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 11,award = [{100,230006,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,12) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 12,award = [{100,230006,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,13) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 13,award = [{100,230006,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,14) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 14,award = [{100,230006,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,15) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 15,award = [{100,230006,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,16) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 16,award = [{100,230006,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,17) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 17,award = [{100,230006,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,18) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 18,award = [{100,230006,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,19) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 19,award = [{100,230006,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,20) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 20,award = [{100,230006,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,21) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 21,award = [{100,230006,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,22) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 22,award = [{100,230006,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,23) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 23,award = [{100,230006,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,24) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 24,award = [{100,230006,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,25) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 25,award = [{100,230006,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,26) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 26,award = [{100,230006,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,27) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 27,award = [{100,230006,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,28) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 28,award = [{100,230006,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,29) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 29,award = [{100,230006,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,30) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 30,award = [{100,230006,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,31) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 31,award = [{100,230006,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(106,3,32) ->
    #race_rank_draw_pool{act_id = 106,stage = 3,award_id = 32,award = [{100,230006,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,1) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 1,award = [{100,230007,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,2) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 2,award = [{100,230007,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,3) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 3,award = [{100,230007,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,4) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 4,award = [{100,230007,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,5) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 5,award = [{100,230007,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,6) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 6,award = [{100,230007,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,7) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 7,award = [{100,230007,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,8) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 8,award = [{100,230007,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,9) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 9,award = [{100,230007,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,10) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 10,award = [{100,230007,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,11) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 11,award = [{100,230007,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,12) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 12,award = [{100,230007,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,13) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 13,award = [{100,230007,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,14) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 14,award = [{100,230007,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,15) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 15,award = [{100,230007,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,16) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 16,award = [{100,230007,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,17) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 17,award = [{100,230007,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,18) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 18,award = [{100,230007,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,19) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 19,award = [{100,230007,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,20) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 20,award = [{100,230007,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,21) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 21,award = [{100,230007,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,22) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 22,award = [{100,230007,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,23) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 23,award = [{100,230007,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,24) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 24,award = [{100,230007,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,25) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 25,award = [{100,230007,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,26) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 26,award = [{100,230007,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,27) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 27,award = [{100,230007,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,28) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 28,award = [{100,230007,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,29) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 29,award = [{100,230007,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,30) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 30,award = [{100,230007,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,31) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 31,award = [{100,230007,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,1,32) ->
    #race_rank_draw_pool{act_id = 107,stage = 1,award_id = 32,award = [{100,230007,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,1) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 1,award = [{100,230007,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,2) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 2,award = [{100,230007,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,3) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 3,award = [{100,230007,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,4) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 4,award = [{100,230007,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,5) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 5,award = [{100,230007,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,6) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 6,award = [{100,230007,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,7) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 7,award = [{100,230007,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,8) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 8,award = [{100,230007,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,9) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 9,award = [{100,230007,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,10) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 10,award = [{100,230007,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,11) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 11,award = [{100,230007,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,12) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 12,award = [{100,230007,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,13) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 13,award = [{100,230007,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,14) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 14,award = [{100,230007,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,15) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 15,award = [{100,230007,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,16) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 16,award = [{100,230007,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,17) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 17,award = [{100,230007,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,18) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 18,award = [{100,230007,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,19) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 19,award = [{100,230007,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,20) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 20,award = [{100,230007,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,21) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 21,award = [{100,230007,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,22) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 22,award = [{100,230007,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,23) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 23,award = [{100,230007,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,24) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 24,award = [{100,230007,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,25) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 25,award = [{100,230007,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,26) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 26,award = [{100,230007,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,27) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 27,award = [{100,230007,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,28) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 28,award = [{100,230007,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,29) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 29,award = [{100,230007,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,30) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 30,award = [{100,230007,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,31) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 31,award = [{100,230007,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,2,32) ->
    #race_rank_draw_pool{act_id = 107,stage = 2,award_id = 32,award = [{100,230007,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,1) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 1,award = [{100,230007,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,2) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 2,award = [{100,230007,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,3) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 3,award = [{100,230007,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,4) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 4,award = [{100,230007,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,5) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 5,award = [{100,230007,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,6) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 6,award = [{100,230007,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,7) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 7,award = [{100,230007,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,8) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 8,award = [{100,230007,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,9) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 9,award = [{100,230007,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,10) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 10,award = [{100,230007,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,11) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 11,award = [{100,230007,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,12) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 12,award = [{100,230007,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,13) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 13,award = [{100,230007,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,14) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 14,award = [{100,230007,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,15) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 15,award = [{100,230007,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,16) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 16,award = [{100,230007,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,17) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 17,award = [{100,230007,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,18) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 18,award = [{100,230007,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,19) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 19,award = [{100,230007,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,20) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 20,award = [{100,230007,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,21) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 21,award = [{100,230007,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,22) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 22,award = [{100,230007,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,23) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 23,award = [{100,230007,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,24) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 24,award = [{100,230007,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,25) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 25,award = [{100,230007,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,26) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 26,award = [{100,230007,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,27) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 27,award = [{100,230007,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,28) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 28,award = [{100,230007,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,29) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 29,award = [{100,230007,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,30) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 30,award = [{100,230007,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,31) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 31,award = [{100,230007,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(107,3,32) ->
    #race_rank_draw_pool{act_id = 107,stage = 3,award_id = 32,award = [{100,230007,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,1) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 1,award = [{100,230008,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,2) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 2,award = [{100,230008,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,3) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 3,award = [{100,230008,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,4) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 4,award = [{100,230008,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,5) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 5,award = [{100,230008,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,6) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 6,award = [{100,230008,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,7) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 7,award = [{100,230008,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,8) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 8,award = [{100,230008,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,9) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 9,award = [{100,230008,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,10) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 10,award = [{100,230008,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,11) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 11,award = [{100,230008,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,12) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 12,award = [{100,230008,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,13) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 13,award = [{100,230008,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,14) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 14,award = [{100,230008,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,15) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 15,award = [{100,230008,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,16) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 16,award = [{100,230008,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,17) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 17,award = [{100,230008,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,18) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 18,award = [{100,230008,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,19) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 19,award = [{100,230008,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,20) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 20,award = [{100,230008,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,21) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 21,award = [{100,230008,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,22) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 22,award = [{100,230008,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,23) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 23,award = [{100,230008,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,24) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 24,award = [{100,230008,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,25) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 25,award = [{100,230008,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,26) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 26,award = [{100,230008,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,27) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 27,award = [{100,230008,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,28) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 28,award = [{100,230008,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,29) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 29,award = [{100,230008,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,30) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 30,award = [{100,230008,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,31) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 31,award = [{100,230008,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,1,32) ->
    #race_rank_draw_pool{act_id = 108,stage = 1,award_id = 32,award = [{100,230008,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,1) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 1,award = [{100,230008,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,2) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 2,award = [{100,230008,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,3) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 3,award = [{100,230008,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,4) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 4,award = [{100,230008,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,5) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 5,award = [{100,230008,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,6) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 6,award = [{100,230008,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,7) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 7,award = [{100,230008,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,8) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 8,award = [{100,230008,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,9) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 9,award = [{100,230008,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,10) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 10,award = [{100,230008,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,11) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 11,award = [{100,230008,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,12) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 12,award = [{100,230008,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,13) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 13,award = [{100,230008,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,14) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 14,award = [{100,230008,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,15) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 15,award = [{100,230008,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,16) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 16,award = [{100,230008,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,17) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 17,award = [{100,230008,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,18) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 18,award = [{100,230008,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,19) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 19,award = [{100,230008,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,20) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 20,award = [{100,230008,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,21) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 21,award = [{100,230008,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,22) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 22,award = [{100,230008,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,23) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 23,award = [{100,230008,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,24) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 24,award = [{100,230008,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,25) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 25,award = [{100,230008,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,26) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 26,award = [{100,230008,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,27) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 27,award = [{100,230008,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,28) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 28,award = [{100,230008,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,29) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 29,award = [{100,230008,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,30) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 30,award = [{100,230008,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,31) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 31,award = [{100,230008,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,2,32) ->
    #race_rank_draw_pool{act_id = 108,stage = 2,award_id = 32,award = [{100,230008,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,1) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 1,award = [{100,230008,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,2) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 2,award = [{100,230008,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,3) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 3,award = [{100,230008,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,4) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 4,award = [{100,230008,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,5) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 5,award = [{100,230008,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,6) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 6,award = [{100,230008,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,7) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 7,award = [{100,230008,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,8) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 8,award = [{100,230008,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,9) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 9,award = [{100,230008,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,10) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 10,award = [{100,230008,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,11) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 11,award = [{100,230008,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,12) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 12,award = [{100,230008,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,13) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 13,award = [{100,230008,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,14) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 14,award = [{100,230008,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,15) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 15,award = [{100,230008,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,16) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 16,award = [{100,230008,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,17) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 17,award = [{100,230008,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,18) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 18,award = [{100,230008,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,19) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 19,award = [{100,230008,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,20) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 20,award = [{100,230008,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,21) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 21,award = [{100,230008,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,22) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 22,award = [{100,230008,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,23) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 23,award = [{100,230008,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,24) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 24,award = [{100,230008,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,25) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 25,award = [{100,230008,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,26) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 26,award = [{100,230008,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,27) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 27,award = [{100,230008,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,28) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 28,award = [{100,230008,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,29) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 29,award = [{100,230008,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,30) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 30,award = [{100,230008,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,31) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 31,award = [{100,230008,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(108,3,32) ->
    #race_rank_draw_pool{act_id = 108,stage = 3,award_id = 32,award = [{100,230008,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,1) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 1,award = [{100,230001,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,2) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 2,award = [{100,230001,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,3) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 3,award = [{100,230001,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,4) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 4,award = [{100,230001,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,5) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 5,award = [{100,230001,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,6) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 6,award = [{100,230001,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,7) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 7,award = [{100,230001,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,8) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 8,award = [{100,230001,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,9) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 9,award = [{100,230001,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,10) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 10,award = [{100,230001,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,11) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 11,award = [{100,230001,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,12) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 12,award = [{100,230001,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,13) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 13,award = [{100,230001,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,14) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 14,award = [{100,230001,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,15) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 15,award = [{100,230001,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,16) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 16,award = [{100,230001,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,17) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 17,award = [{100,230001,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,18) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 18,award = [{100,230001,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,19) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 19,award = [{100,230001,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,20) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 20,award = [{100,230001,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,21) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 21,award = [{100,230001,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,22) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 22,award = [{100,230001,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,23) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 23,award = [{100,230001,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,24) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 24,award = [{100,230001,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,25) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 25,award = [{100,230001,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,26) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 26,award = [{100,230001,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,27) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 27,award = [{100,230001,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,28) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 28,award = [{100,230001,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,29) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 29,award = [{100,230001,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,30) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 30,award = [{100,230001,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,31) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 31,award = [{100,230001,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,1,32) ->
    #race_rank_draw_pool{act_id = 109,stage = 1,award_id = 32,award = [{100,230001,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,1) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 1,award = [{100,230001,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,2) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 2,award = [{100,230001,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,3) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 3,award = [{100,230001,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,4) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 4,award = [{100,230001,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,5) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 5,award = [{100,230001,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,6) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 6,award = [{100,230001,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,7) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 7,award = [{100,230001,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,8) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 8,award = [{100,230001,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,9) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 9,award = [{100,230001,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,10) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 10,award = [{100,230001,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,11) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 11,award = [{100,230001,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,12) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 12,award = [{100,230001,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,13) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 13,award = [{100,230001,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,14) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 14,award = [{100,230001,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,15) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 15,award = [{100,230001,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,16) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 16,award = [{100,230001,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,17) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 17,award = [{100,230001,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,18) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 18,award = [{100,230001,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,19) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 19,award = [{100,230001,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,20) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 20,award = [{100,230001,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,21) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 21,award = [{100,230001,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,22) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 22,award = [{100,230001,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,23) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 23,award = [{100,230001,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,24) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 24,award = [{100,230001,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,25) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 25,award = [{100,230001,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,26) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 26,award = [{100,230001,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,27) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 27,award = [{100,230001,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,28) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 28,award = [{100,230001,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,29) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 29,award = [{100,230001,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,30) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 30,award = [{100,230001,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,31) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 31,award = [{100,230001,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,2,32) ->
    #race_rank_draw_pool{act_id = 109,stage = 2,award_id = 32,award = [{100,230001,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,1) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 1,award = [{100,230001,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,2) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 2,award = [{100,230001,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,3) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 3,award = [{100,230001,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,4) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 4,award = [{100,230001,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,5) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 5,award = [{100,230001,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,6) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 6,award = [{100,230001,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,7) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 7,award = [{100,230001,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,8) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 8,award = [{100,230001,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,9) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 9,award = [{100,230001,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,10) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 10,award = [{100,230001,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,11) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 11,award = [{100,230001,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,12) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 12,award = [{100,230001,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,13) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 13,award = [{100,230001,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,14) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 14,award = [{100,230001,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,15) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 15,award = [{100,230001,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,16) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 16,award = [{100,230001,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,17) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 17,award = [{100,230001,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,18) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 18,award = [{100,230001,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,19) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 19,award = [{100,230001,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,20) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 20,award = [{100,230001,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,21) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 21,award = [{100,230001,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,22) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 22,award = [{100,230001,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,23) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 23,award = [{100,230001,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,24) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 24,award = [{100,230001,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,25) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 25,award = [{100,230001,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,26) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 26,award = [{100,230001,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,27) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 27,award = [{100,230001,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,28) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 28,award = [{100,230001,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,29) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 29,award = [{100,230001,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,30) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 30,award = [{100,230001,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,31) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 31,award = [{100,230001,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(109,3,32) ->
    #race_rank_draw_pool{act_id = 109,stage = 3,award_id = 32,award = [{100,230001,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,1) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 1,award = [{100,230002,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,2) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 2,award = [{100,230002,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,3) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 3,award = [{100,230002,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,4) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 4,award = [{100,230002,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,5) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 5,award = [{100,230002,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,6) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 6,award = [{100,230002,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,7) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 7,award = [{100,230002,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,8) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 8,award = [{100,230002,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,9) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 9,award = [{100,230002,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,10) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 10,award = [{100,230002,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,11) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 11,award = [{100,230002,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,12) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 12,award = [{100,230002,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,13) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 13,award = [{100,230002,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,14) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 14,award = [{100,230002,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,15) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 15,award = [{100,230002,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,16) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 16,award = [{100,230002,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,17) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 17,award = [{100,230002,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,18) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 18,award = [{100,230002,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,19) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 19,award = [{100,230002,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,20) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 20,award = [{100,230002,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,21) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 21,award = [{100,230002,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,22) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 22,award = [{100,230002,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,23) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 23,award = [{100,230002,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,24) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 24,award = [{100,230002,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,25) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 25,award = [{100,230002,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,26) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 26,award = [{100,230002,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,27) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 27,award = [{100,230002,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,28) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 28,award = [{100,230002,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,29) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 29,award = [{100,230002,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,30) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 30,award = [{100,230002,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,31) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 31,award = [{100,230002,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,1,32) ->
    #race_rank_draw_pool{act_id = 133,stage = 1,award_id = 32,award = [{100,230002,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,1) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 1,award = [{100,230002,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,2) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 2,award = [{100,230002,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,3) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 3,award = [{100,230002,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,4) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 4,award = [{100,230002,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,5) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 5,award = [{100,230002,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,6) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 6,award = [{100,230002,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,7) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 7,award = [{100,230002,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,8) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 8,award = [{100,230002,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,9) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 9,award = [{100,230002,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,10) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 10,award = [{100,230002,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,11) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 11,award = [{100,230002,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,12) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 12,award = [{100,230002,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,13) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 13,award = [{100,230002,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,14) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 14,award = [{100,230002,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,15) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 15,award = [{100,230002,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,16) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 16,award = [{100,230002,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,17) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 17,award = [{100,230002,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,18) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 18,award = [{100,230002,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,19) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 19,award = [{100,230002,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,20) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 20,award = [{100,230002,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,21) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 21,award = [{100,230002,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,22) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 22,award = [{100,230002,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,23) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 23,award = [{100,230002,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,24) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 24,award = [{100,230002,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,25) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 25,award = [{100,230002,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,26) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 26,award = [{100,230002,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,27) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 27,award = [{100,230002,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,28) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 28,award = [{100,230002,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,29) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 29,award = [{100,230002,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,30) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 30,award = [{100,230002,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,31) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 31,award = [{100,230002,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,2,32) ->
    #race_rank_draw_pool{act_id = 133,stage = 2,award_id = 32,award = [{100,230002,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,1) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 1,award = [{100,230002,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,2) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 2,award = [{100,230002,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,3) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 3,award = [{100,230002,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,4) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 4,award = [{100,230002,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,5) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 5,award = [{100,230002,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,6) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 6,award = [{100,230002,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,7) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 7,award = [{100,230002,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,8) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 8,award = [{100,230002,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,9) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 9,award = [{100,230002,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,10) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 10,award = [{100,230002,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,11) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 11,award = [{100,230002,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,12) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 12,award = [{100,230002,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,13) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 13,award = [{100,230002,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,14) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 14,award = [{100,230002,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,15) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 15,award = [{100,230002,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,16) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 16,award = [{100,230002,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,17) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 17,award = [{100,230002,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,18) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 18,award = [{100,230002,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,19) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 19,award = [{100,230002,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,20) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 20,award = [{100,230002,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,21) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 21,award = [{100,230002,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,22) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 22,award = [{100,230002,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,23) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 23,award = [{100,230002,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,24) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 24,award = [{100,230002,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,25) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 25,award = [{100,230002,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,26) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 26,award = [{100,230002,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,27) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 27,award = [{100,230002,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,28) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 28,award = [{100,230002,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,29) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 29,award = [{100,230002,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,30) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 30,award = [{100,230002,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,31) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 31,award = [{100,230002,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(133,3,32) ->
    #race_rank_draw_pool{act_id = 133,stage = 3,award_id = 32,award = [{100,230002,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,1) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 1,award = [{100,230003,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,2) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 2,award = [{100,230003,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,3) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 3,award = [{100,230003,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,4) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 4,award = [{100,230003,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,5) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 5,award = [{100,230003,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,6) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 6,award = [{100,230003,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,7) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 7,award = [{100,230003,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,8) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 8,award = [{100,230003,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,9) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 9,award = [{100,230003,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,10) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 10,award = [{100,230003,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,11) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 11,award = [{100,230003,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,12) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 12,award = [{100,230003,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,13) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 13,award = [{100,230003,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,14) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 14,award = [{100,230003,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,15) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 15,award = [{100,230003,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,16) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 16,award = [{100,230003,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,17) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 17,award = [{100,230003,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,18) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 18,award = [{100,230003,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,19) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 19,award = [{100,230003,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,20) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 20,award = [{100,230003,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,21) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 21,award = [{100,230003,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,22) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 22,award = [{100,230003,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,23) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 23,award = [{100,230003,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,24) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 24,award = [{100,230003,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,25) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 25,award = [{100,230003,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,26) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 26,award = [{100,230003,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,27) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 27,award = [{100,230003,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,28) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 28,award = [{100,230003,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,29) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 29,award = [{100,230003,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,30) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 30,award = [{100,230003,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,31) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 31,award = [{100,230003,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,1,32) ->
    #race_rank_draw_pool{act_id = 134,stage = 1,award_id = 32,award = [{100,230003,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,1) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 1,award = [{100,230003,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,2) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 2,award = [{100,230003,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,3) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 3,award = [{100,230003,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,4) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 4,award = [{100,230003,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,5) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 5,award = [{100,230003,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,6) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 6,award = [{100,230003,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,7) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 7,award = [{100,230003,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,8) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 8,award = [{100,230003,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,9) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 9,award = [{100,230003,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,10) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 10,award = [{100,230003,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,11) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 11,award = [{100,230003,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,12) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 12,award = [{100,230003,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,13) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 13,award = [{100,230003,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,14) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 14,award = [{100,230003,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,15) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 15,award = [{100,230003,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,16) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 16,award = [{100,230003,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,17) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 17,award = [{100,230003,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,18) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 18,award = [{100,230003,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,19) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 19,award = [{100,230003,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,20) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 20,award = [{100,230003,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,21) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 21,award = [{100,230003,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,22) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 22,award = [{100,230003,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,23) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 23,award = [{100,230003,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,24) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 24,award = [{100,230003,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,25) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 25,award = [{100,230003,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,26) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 26,award = [{100,230003,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,27) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 27,award = [{100,230003,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,28) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 28,award = [{100,230003,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,29) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 29,award = [{100,230003,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,30) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 30,award = [{100,230003,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,31) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 31,award = [{100,230003,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,2,32) ->
    #race_rank_draw_pool{act_id = 134,stage = 2,award_id = 32,award = [{100,230003,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,1) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 1,award = [{100,230003,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,2) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 2,award = [{100,230003,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,3) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 3,award = [{100,230003,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,4) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 4,award = [{100,230003,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,5) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 5,award = [{100,230003,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,6) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 6,award = [{100,230003,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,7) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 7,award = [{100,230003,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,8) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 8,award = [{100,230003,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,9) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 9,award = [{100,230003,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,10) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 10,award = [{100,230003,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,11) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 11,award = [{100,230003,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,12) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 12,award = [{100,230003,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,13) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 13,award = [{100,230003,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,14) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 14,award = [{100,230003,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,15) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 15,award = [{100,230003,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,16) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 16,award = [{100,230003,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,17) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 17,award = [{100,230003,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,18) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 18,award = [{100,230003,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,19) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 19,award = [{100,230003,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,20) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 20,award = [{100,230003,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,21) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 21,award = [{100,230003,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,22) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 22,award = [{100,230003,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,23) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 23,award = [{100,230003,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,24) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 24,award = [{100,230003,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,25) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 25,award = [{100,230003,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,26) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 26,award = [{100,230003,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,27) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 27,award = [{100,230003,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,28) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 28,award = [{100,230003,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,29) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 29,award = [{100,230003,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,30) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 30,award = [{100,230003,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,31) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 31,award = [{100,230003,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(134,3,32) ->
    #race_rank_draw_pool{act_id = 134,stage = 3,award_id = 32,award = [{100,230003,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,1) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 1,award = [{100,230004,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,2) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 2,award = [{100,230004,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,3) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 3,award = [{100,230004,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,4) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 4,award = [{100,230004,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,5) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 5,award = [{100,230004,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,6) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 6,award = [{100,230004,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,7) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 7,award = [{100,230004,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,8) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 8,award = [{100,230004,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,9) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 9,award = [{100,230004,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,10) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 10,award = [{100,230004,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,11) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 11,award = [{100,230004,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,12) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 12,award = [{100,230004,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,13) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 13,award = [{100,230004,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,14) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 14,award = [{100,230004,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,15) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 15,award = [{100,230004,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,16) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 16,award = [{100,230004,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,17) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 17,award = [{100,230004,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,18) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 18,award = [{100,230004,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,19) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 19,award = [{100,230004,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,20) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 20,award = [{100,230004,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,21) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 21,award = [{100,230004,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,22) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 22,award = [{100,230004,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,23) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 23,award = [{100,230004,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,24) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 24,award = [{100,230004,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,25) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 25,award = [{100,230004,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,26) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 26,award = [{100,230004,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,27) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 27,award = [{100,230004,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,28) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 28,award = [{100,230004,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,29) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 29,award = [{100,230004,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,30) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 30,award = [{100,230004,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,31) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 31,award = [{100,230004,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,1,32) ->
    #race_rank_draw_pool{act_id = 135,stage = 1,award_id = 32,award = [{100,230004,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,1) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 1,award = [{100,230004,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,2) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 2,award = [{100,230004,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,3) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 3,award = [{100,230004,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,4) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 4,award = [{100,230004,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,5) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 5,award = [{100,230004,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,6) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 6,award = [{100,230004,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,7) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 7,award = [{100,230004,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,8) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 8,award = [{100,230004,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,9) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 9,award = [{100,230004,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,10) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 10,award = [{100,230004,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,11) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 11,award = [{100,230004,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,12) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 12,award = [{100,230004,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,13) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 13,award = [{100,230004,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,14) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 14,award = [{100,230004,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,15) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 15,award = [{100,230004,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,16) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 16,award = [{100,230004,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,17) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 17,award = [{100,230004,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,18) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 18,award = [{100,230004,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,19) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 19,award = [{100,230004,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,20) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 20,award = [{100,230004,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,21) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 21,award = [{100,230004,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,22) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 22,award = [{100,230004,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,23) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 23,award = [{100,230004,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,24) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 24,award = [{100,230004,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,25) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 25,award = [{100,230004,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,26) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 26,award = [{100,230004,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,27) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 27,award = [{100,230004,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,28) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 28,award = [{100,230004,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,29) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 29,award = [{100,230004,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,30) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 30,award = [{100,230004,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,31) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 31,award = [{100,230004,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,2,32) ->
    #race_rank_draw_pool{act_id = 135,stage = 2,award_id = 32,award = [{100,230004,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,1) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 1,award = [{100,230004,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,2) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 2,award = [{100,230004,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,3) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 3,award = [{100,230004,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,4) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 4,award = [{100,230004,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,5) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 5,award = [{100,230004,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,6) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 6,award = [{100,230004,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,7) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 7,award = [{100,230004,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,8) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 8,award = [{100,230004,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,9) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 9,award = [{100,230004,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,10) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 10,award = [{100,230004,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,11) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 11,award = [{100,230004,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,12) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 12,award = [{100,230004,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,13) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 13,award = [{100,230004,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,14) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 14,award = [{100,230004,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,15) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 15,award = [{100,230004,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,16) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 16,award = [{100,230004,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,17) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 17,award = [{100,230004,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,18) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 18,award = [{100,230004,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,19) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 19,award = [{100,230004,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,20) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 20,award = [{100,230004,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,21) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 21,award = [{100,230004,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,22) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 22,award = [{100,230004,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,23) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 23,award = [{100,230004,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,24) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 24,award = [{100,230004,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,25) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 25,award = [{100,230004,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,26) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 26,award = [{100,230004,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,27) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 27,award = [{100,230004,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,28) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 28,award = [{100,230004,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,29) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 29,award = [{100,230004,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,30) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 30,award = [{100,230004,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,31) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 31,award = [{100,230004,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(135,3,32) ->
    #race_rank_draw_pool{act_id = 135,stage = 3,award_id = 32,award = [{100,230004,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,1) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 1,award = [{100,230005,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,2) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 2,award = [{100,230005,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,3) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 3,award = [{100,230005,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,4) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 4,award = [{100,230005,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,5) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 5,award = [{100,230005,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,6) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 6,award = [{100,230005,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,7) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 7,award = [{100,230005,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,8) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 8,award = [{100,230005,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,9) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 9,award = [{100,230005,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,10) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 10,award = [{100,230005,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,11) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 11,award = [{100,230005,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,12) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 12,award = [{100,230005,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,13) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 13,award = [{100,230005,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,14) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 14,award = [{100,230005,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,15) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 15,award = [{100,230005,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,16) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 16,award = [{100,230005,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,17) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 17,award = [{100,230005,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,18) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 18,award = [{100,230005,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,19) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 19,award = [{100,230005,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,20) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 20,award = [{100,230005,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,21) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 21,award = [{100,230005,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,22) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 22,award = [{100,230005,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,23) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 23,award = [{100,230005,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,24) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 24,award = [{100,230005,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,25) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 25,award = [{100,230005,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,26) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 26,award = [{100,230005,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,27) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 27,award = [{100,230005,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,28) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 28,award = [{100,230005,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,29) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 29,award = [{100,230005,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,30) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 30,award = [{100,230005,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,31) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 31,award = [{100,230005,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,1,32) ->
    #race_rank_draw_pool{act_id = 137,stage = 1,award_id = 32,award = [{100,230005,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,1) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 1,award = [{100,230005,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,2) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 2,award = [{100,230005,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,3) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 3,award = [{100,230005,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,4) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 4,award = [{100,230005,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,5) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 5,award = [{100,230005,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,6) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 6,award = [{100,230005,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,7) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 7,award = [{100,230005,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,8) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 8,award = [{100,230005,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,9) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 9,award = [{100,230005,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,10) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 10,award = [{100,230005,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,11) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 11,award = [{100,230005,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,12) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 12,award = [{100,230005,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,13) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 13,award = [{100,230005,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,14) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 14,award = [{100,230005,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,15) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 15,award = [{100,230005,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,16) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 16,award = [{100,230005,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,17) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 17,award = [{100,230005,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,18) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 18,award = [{100,230005,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,19) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 19,award = [{100,230005,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,20) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 20,award = [{100,230005,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,21) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 21,award = [{100,230005,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,22) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 22,award = [{100,230005,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,23) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 23,award = [{100,230005,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,24) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 24,award = [{100,230005,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,25) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 25,award = [{100,230005,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,26) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 26,award = [{100,230005,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,27) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 27,award = [{100,230005,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,28) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 28,award = [{100,230005,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,29) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 29,award = [{100,230005,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,30) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 30,award = [{100,230005,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,31) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 31,award = [{100,230005,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,2,32) ->
    #race_rank_draw_pool{act_id = 137,stage = 2,award_id = 32,award = [{100,230005,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,1) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 1,award = [{100,230005,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,2) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 2,award = [{100,230005,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,3) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 3,award = [{100,230005,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,4) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 4,award = [{100,230005,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,5) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 5,award = [{100,230005,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,6) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 6,award = [{100,230005,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,7) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 7,award = [{100,230005,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,8) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 8,award = [{100,230005,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,9) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 9,award = [{100,230005,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,10) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 10,award = [{100,230005,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,11) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 11,award = [{100,230005,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,12) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 12,award = [{100,230005,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,13) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 13,award = [{100,230005,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,14) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 14,award = [{100,230005,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,15) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 15,award = [{100,230005,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,16) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 16,award = [{100,230005,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,17) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 17,award = [{100,230005,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,18) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 18,award = [{100,230005,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,19) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 19,award = [{100,230005,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,20) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 20,award = [{100,230005,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,21) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 21,award = [{100,230005,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,22) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 22,award = [{100,230005,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,23) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 23,award = [{100,230005,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,24) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 24,award = [{100,230005,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,25) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 25,award = [{100,230005,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,26) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 26,award = [{100,230005,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,27) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 27,award = [{100,230005,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,28) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 28,award = [{100,230005,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,29) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 29,award = [{100,230005,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,30) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 30,award = [{100,230005,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,31) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 31,award = [{100,230005,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(137,3,32) ->
    #race_rank_draw_pool{act_id = 137,stage = 3,award_id = 32,award = [{100,230005,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,1) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 1,award = [{100,230006,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,2) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 2,award = [{100,230006,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,3) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 3,award = [{100,230006,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,4) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 4,award = [{100,230006,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,5) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 5,award = [{100,230006,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,6) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 6,award = [{100,230006,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,7) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 7,award = [{100,230006,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,8) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 8,award = [{100,230006,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,9) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 9,award = [{100,230006,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,10) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 10,award = [{100,230006,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,11) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 11,award = [{100,230006,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,12) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 12,award = [{100,230006,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,13) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 13,award = [{100,230006,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,14) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 14,award = [{100,230006,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,15) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 15,award = [{100,230006,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,16) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 16,award = [{100,230006,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,17) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 17,award = [{100,230006,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,18) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 18,award = [{100,230006,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,19) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 19,award = [{100,230006,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,20) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 20,award = [{100,230006,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,21) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 21,award = [{100,230006,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,22) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 22,award = [{100,230006,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,23) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 23,award = [{100,230006,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,24) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 24,award = [{100,230006,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,25) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 25,award = [{100,230006,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,26) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 26,award = [{100,230006,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,27) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 27,award = [{100,230006,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,28) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 28,award = [{100,230006,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,29) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 29,award = [{100,230006,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,30) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 30,award = [{100,230006,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,31) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 31,award = [{100,230006,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,1,32) ->
    #race_rank_draw_pool{act_id = 138,stage = 1,award_id = 32,award = [{100,230006,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,1) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 1,award = [{100,230006,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,2) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 2,award = [{100,230006,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,3) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 3,award = [{100,230006,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,4) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 4,award = [{100,230006,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,5) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 5,award = [{100,230006,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,6) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 6,award = [{100,230006,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,7) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 7,award = [{100,230006,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,8) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 8,award = [{100,230006,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,9) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 9,award = [{100,230006,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,10) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 10,award = [{100,230006,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,11) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 11,award = [{100,230006,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,12) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 12,award = [{100,230006,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,13) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 13,award = [{100,230006,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,14) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 14,award = [{100,230006,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,15) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 15,award = [{100,230006,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,16) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 16,award = [{100,230006,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,17) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 17,award = [{100,230006,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,18) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 18,award = [{100,230006,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,19) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 19,award = [{100,230006,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,20) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 20,award = [{100,230006,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,21) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 21,award = [{100,230006,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,22) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 22,award = [{100,230006,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,23) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 23,award = [{100,230006,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,24) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 24,award = [{100,230006,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,25) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 25,award = [{100,230006,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,26) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 26,award = [{100,230006,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,27) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 27,award = [{100,230006,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,28) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 28,award = [{100,230006,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,29) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 29,award = [{100,230006,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,30) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 30,award = [{100,230006,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,31) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 31,award = [{100,230006,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,2,32) ->
    #race_rank_draw_pool{act_id = 138,stage = 2,award_id = 32,award = [{100,230006,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,1) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 1,award = [{100,230006,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,2) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 2,award = [{100,230006,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,3) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 3,award = [{100,230006,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,4) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 4,award = [{100,230006,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,5) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 5,award = [{100,230006,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,6) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 6,award = [{100,230006,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,7) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 7,award = [{100,230006,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,8) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 8,award = [{100,230006,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,9) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 9,award = [{100,230006,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,10) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 10,award = [{100,230006,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,11) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 11,award = [{100,230006,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,12) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 12,award = [{100,230006,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,13) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 13,award = [{100,230006,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,14) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 14,award = [{100,230006,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,15) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 15,award = [{100,230006,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,16) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 16,award = [{100,230006,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,17) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 17,award = [{100,230006,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,18) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 18,award = [{100,230006,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,19) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 19,award = [{100,230006,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,20) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 20,award = [{100,230006,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,21) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 21,award = [{100,230006,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,22) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 22,award = [{100,230006,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,23) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 23,award = [{100,230006,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,24) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 24,award = [{100,230006,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,25) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 25,award = [{100,230006,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,26) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 26,award = [{100,230006,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,27) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 27,award = [{100,230006,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,28) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 28,award = [{100,230006,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,29) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 29,award = [{100,230006,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,30) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 30,award = [{100,230006,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,31) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 31,award = [{100,230006,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(138,3,32) ->
    #race_rank_draw_pool{act_id = 138,stage = 3,award_id = 32,award = [{100,230006,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,1) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 1,award = [{100,230007,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,2) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 2,award = [{100,230007,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,3) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 3,award = [{100,230007,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,4) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 4,award = [{100,230007,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,5) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 5,award = [{100,230007,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,6) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 6,award = [{100,230007,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,7) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 7,award = [{100,230007,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,8) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 8,award = [{100,230007,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,9) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 9,award = [{100,230007,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,10) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 10,award = [{100,230007,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,11) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 11,award = [{100,230007,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,12) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 12,award = [{100,230007,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,13) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 13,award = [{100,230007,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,14) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 14,award = [{100,230007,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,15) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 15,award = [{100,230007,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,16) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 16,award = [{100,230007,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,17) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 17,award = [{100,230007,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,18) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 18,award = [{100,230007,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,19) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 19,award = [{100,230007,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,20) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 20,award = [{100,230007,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,21) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 21,award = [{100,230007,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,22) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 22,award = [{100,230007,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,23) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 23,award = [{100,230007,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,24) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 24,award = [{100,230007,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,25) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 25,award = [{100,230007,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,26) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 26,award = [{100,230007,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,27) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 27,award = [{100,230007,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,28) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 28,award = [{100,230007,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,29) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 29,award = [{100,230007,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,30) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 30,award = [{100,230007,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,31) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 31,award = [{100,230007,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,1,32) ->
    #race_rank_draw_pool{act_id = 139,stage = 1,award_id = 32,award = [{100,230007,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,1) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 1,award = [{100,230007,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,2) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 2,award = [{100,230007,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,3) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 3,award = [{100,230007,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,4) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 4,award = [{100,230007,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,5) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 5,award = [{100,230007,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,6) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 6,award = [{100,230007,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,7) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 7,award = [{100,230007,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,8) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 8,award = [{100,230007,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,9) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 9,award = [{100,230007,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,10) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 10,award = [{100,230007,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,11) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 11,award = [{100,230007,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,12) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 12,award = [{100,230007,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,13) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 13,award = [{100,230007,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,14) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 14,award = [{100,230007,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,15) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 15,award = [{100,230007,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,16) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 16,award = [{100,230007,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,17) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 17,award = [{100,230007,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,18) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 18,award = [{100,230007,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,19) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 19,award = [{100,230007,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,20) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 20,award = [{100,230007,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,21) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 21,award = [{100,230007,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,22) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 22,award = [{100,230007,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,23) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 23,award = [{100,230007,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,24) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 24,award = [{100,230007,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,25) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 25,award = [{100,230007,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,26) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 26,award = [{100,230007,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,27) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 27,award = [{100,230007,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,28) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 28,award = [{100,230007,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,29) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 29,award = [{100,230007,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,30) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 30,award = [{100,230007,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,31) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 31,award = [{100,230007,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,2,32) ->
    #race_rank_draw_pool{act_id = 139,stage = 2,award_id = 32,award = [{100,230007,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,1) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 1,award = [{100,230007,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,2) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 2,award = [{100,230007,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,3) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 3,award = [{100,230007,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,4) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 4,award = [{100,230007,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,5) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 5,award = [{100,230007,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,6) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 6,award = [{100,230007,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,7) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 7,award = [{100,230007,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,8) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 8,award = [{100,230007,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,9) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 9,award = [{100,230007,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,10) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 10,award = [{100,230007,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,11) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 11,award = [{100,230007,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,12) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 12,award = [{100,230007,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,13) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 13,award = [{100,230007,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,14) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 14,award = [{100,230007,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,15) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 15,award = [{100,230007,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,16) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 16,award = [{100,230007,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,17) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 17,award = [{100,230007,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,18) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 18,award = [{100,230007,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,19) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 19,award = [{100,230007,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,20) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 20,award = [{100,230007,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,21) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 21,award = [{100,230007,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,22) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 22,award = [{100,230007,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,23) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 23,award = [{100,230007,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,24) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 24,award = [{100,230007,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,25) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 25,award = [{100,230007,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,26) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 26,award = [{100,230007,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,27) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 27,award = [{100,230007,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,28) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 28,award = [{100,230007,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,29) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 29,award = [{100,230007,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,30) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 30,award = [{100,230007,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,31) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 31,award = [{100,230007,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(139,3,32) ->
    #race_rank_draw_pool{act_id = 139,stage = 3,award_id = 32,award = [{100,230007,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,1) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 1,award = [{100,230008,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,2) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 2,award = [{100,230008,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,3) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 3,award = [{100,230008,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,4) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 4,award = [{100,230008,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,5) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 5,award = [{100,230008,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,6) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 6,award = [{100,230008,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,7) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 7,award = [{100,230008,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,8) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 8,award = [{100,230008,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,9) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 9,award = [{100,230008,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,10) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 10,award = [{100,230008,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,11) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 11,award = [{100,230008,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,12) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 12,award = [{100,230008,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,13) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 13,award = [{100,230008,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,14) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 14,award = [{100,230008,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,15) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 15,award = [{100,230008,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,16) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 16,award = [{100,230008,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,17) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 17,award = [{100,230008,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,18) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 18,award = [{100,230008,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,19) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 19,award = [{100,230008,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,20) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 20,award = [{100,230008,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,21) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 21,award = [{100,230008,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,22) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 22,award = [{100,230008,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,23) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 23,award = [{100,230008,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,24) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 24,award = [{100,230008,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,25) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 25,award = [{100,230008,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,26) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 26,award = [{100,230008,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,27) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 27,award = [{100,230008,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,28) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 28,award = [{100,230008,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,29) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 29,award = [{100,230008,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,30) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 30,award = [{100,230008,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,31) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 31,award = [{100,230008,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,1,32) ->
    #race_rank_draw_pool{act_id = 140,stage = 1,award_id = 32,award = [{100,230008,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,1) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 1,award = [{100,230008,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,2) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 2,award = [{100,230008,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,3) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 3,award = [{100,230008,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,4) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 4,award = [{100,230008,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,5) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 5,award = [{100,230008,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,6) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 6,award = [{100,230008,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,7) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 7,award = [{100,230008,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,8) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 8,award = [{100,230008,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,9) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 9,award = [{100,230008,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,10) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 10,award = [{100,230008,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,11) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 11,award = [{100,230008,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,12) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 12,award = [{100,230008,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,13) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 13,award = [{100,230008,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,14) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 14,award = [{100,230008,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,15) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 15,award = [{100,230008,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,16) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 16,award = [{100,230008,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,17) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 17,award = [{100,230008,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,18) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 18,award = [{100,230008,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,19) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 19,award = [{100,230008,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,20) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 20,award = [{100,230008,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,21) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 21,award = [{100,230008,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,22) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 22,award = [{100,230008,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,23) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 23,award = [{100,230008,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,24) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 24,award = [{100,230008,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,25) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 25,award = [{100,230008,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,26) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 26,award = [{100,230008,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,27) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 27,award = [{100,230008,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,28) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 28,award = [{100,230008,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,29) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 29,award = [{100,230008,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,30) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 30,award = [{100,230008,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,31) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 31,award = [{100,230008,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,2,32) ->
    #race_rank_draw_pool{act_id = 140,stage = 2,award_id = 32,award = [{100,230008,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,1) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 1,award = [{100,230008,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,2) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 2,award = [{100,230008,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,3) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 3,award = [{100,230008,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,4) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 4,award = [{100,230008,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,5) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 5,award = [{100,230008,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,6) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 6,award = [{100,230008,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,7) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 7,award = [{100,230008,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,8) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 8,award = [{100,230008,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,9) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 9,award = [{100,230008,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,10) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 10,award = [{100,230008,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,11) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 11,award = [{100,230008,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,12) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 12,award = [{100,230008,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,13) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 13,award = [{100,230008,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,14) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 14,award = [{100,230008,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,15) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 15,award = [{100,230008,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,16) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 16,award = [{100,230008,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,17) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 17,award = [{100,230008,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,18) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 18,award = [{100,230008,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,19) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 19,award = [{100,230008,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,20) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 20,award = [{100,230008,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,21) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 21,award = [{100,230008,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,22) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 22,award = [{100,230008,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,23) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 23,award = [{100,230008,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,24) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 24,award = [{100,230008,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,25) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 25,award = [{100,230008,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,26) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 26,award = [{100,230008,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,27) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 27,award = [{100,230008,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,28) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 28,award = [{100,230008,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,29) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 29,award = [{100,230008,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,30) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 30,award = [{100,230008,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,31) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 31,award = [{100,230008,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(140,3,32) ->
    #race_rank_draw_pool{act_id = 140,stage = 3,award_id = 32,award = [{100,230008,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,1) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 1,award = [{100,230001,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,2) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 2,award = [{100,230001,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,3) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 3,award = [{100,230001,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,4) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 4,award = [{100,230001,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,5) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 5,award = [{100,230001,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,6) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 6,award = [{100,230001,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,7) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 7,award = [{100,230001,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,8) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 8,award = [{100,230001,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,9) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 9,award = [{100,230001,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,10) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 10,award = [{100,230001,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,11) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 11,award = [{100,230001,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,12) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 12,award = [{100,230001,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,13) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 13,award = [{100,230001,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,14) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 14,award = [{100,230001,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,15) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 15,award = [{100,230001,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,16) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 16,award = [{100,230001,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,17) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 17,award = [{100,230001,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,18) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 18,award = [{100,230001,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,19) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 19,award = [{100,230001,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,20) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 20,award = [{100,230001,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,21) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 21,award = [{100,230001,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,22) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 22,award = [{100,230001,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,23) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 23,award = [{100,230001,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,24) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 24,award = [{100,230001,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,25) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 25,award = [{100,230001,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,26) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 26,award = [{100,230001,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,27) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 27,award = [{100,230001,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,28) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 28,award = [{100,230001,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,29) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 29,award = [{100,230001,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,30) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 30,award = [{100,230001,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,31) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 31,award = [{100,230001,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,1,32) ->
    #race_rank_draw_pool{act_id = 141,stage = 1,award_id = 32,award = [{100,230001,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,1) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 1,award = [{100,230001,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,2) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 2,award = [{100,230001,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,3) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 3,award = [{100,230001,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,4) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 4,award = [{100,230001,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,5) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 5,award = [{100,230001,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,6) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 6,award = [{100,230001,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,7) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 7,award = [{100,230001,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,8) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 8,award = [{100,230001,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,9) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 9,award = [{100,230001,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,10) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 10,award = [{100,230001,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,11) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 11,award = [{100,230001,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,12) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 12,award = [{100,230001,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,13) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 13,award = [{100,230001,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,14) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 14,award = [{100,230001,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,15) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 15,award = [{100,230001,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,16) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 16,award = [{100,230001,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,17) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 17,award = [{100,230001,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,18) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 18,award = [{100,230001,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,19) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 19,award = [{100,230001,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,20) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 20,award = [{100,230001,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,21) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 21,award = [{100,230001,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,22) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 22,award = [{100,230001,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,23) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 23,award = [{100,230001,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,24) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 24,award = [{100,230001,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,25) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 25,award = [{100,230001,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,26) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 26,award = [{100,230001,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,27) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 27,award = [{100,230001,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,28) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 28,award = [{100,230001,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,29) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 29,award = [{100,230001,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,30) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 30,award = [{100,230001,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,31) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 31,award = [{100,230001,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,2,32) ->
    #race_rank_draw_pool{act_id = 141,stage = 2,award_id = 32,award = [{100,230001,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,1) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 1,award = [{100,230001,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,2) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 2,award = [{100,230001,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,3) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 3,award = [{100,230001,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,4) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 4,award = [{100,230001,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,5) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 5,award = [{100,230001,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,6) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 6,award = [{100,230001,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,7) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 7,award = [{100,230001,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,8) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 8,award = [{100,230001,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,9) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 9,award = [{100,230001,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,10) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 10,award = [{100,230001,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,11) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 11,award = [{100,230001,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,12) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 12,award = [{100,230001,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,13) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 13,award = [{100,230001,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,14) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 14,award = [{100,230001,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,15) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 15,award = [{100,230001,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,16) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 16,award = [{100,230001,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,17) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 17,award = [{100,230001,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,18) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 18,award = [{100,230001,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,19) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 19,award = [{100,230001,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,20) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 20,award = [{100,230001,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,21) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 21,award = [{100,230001,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,22) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 22,award = [{100,230001,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,23) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 23,award = [{100,230001,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,24) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 24,award = [{100,230001,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,25) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 25,award = [{100,230001,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,26) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 26,award = [{100,230001,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,27) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 27,award = [{100,230001,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,28) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 28,award = [{100,230001,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,29) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 29,award = [{100,230001,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,30) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 30,award = [{100,230001,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,31) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 31,award = [{100,230001,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(141,3,32) ->
    #race_rank_draw_pool{act_id = 141,stage = 3,award_id = 32,award = [{100,230001,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,1) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 1,award = [{100,230002,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,2) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 2,award = [{100,230002,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,3) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 3,award = [{100,230002,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,4) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 4,award = [{100,230002,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,5) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 5,award = [{100,230002,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,6) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 6,award = [{100,230002,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,7) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 7,award = [{100,230002,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,8) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 8,award = [{100,230002,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,9) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 9,award = [{100,230002,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,10) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 10,award = [{100,230002,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,11) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 11,award = [{100,230002,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,12) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 12,award = [{100,230002,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,13) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 13,award = [{100,230002,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,14) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 14,award = [{100,230002,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,15) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 15,award = [{100,230002,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,16) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 16,award = [{100,230002,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,17) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 17,award = [{100,230002,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,18) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 18,award = [{100,230002,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,19) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 19,award = [{100,230002,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,20) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 20,award = [{100,230002,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,21) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 21,award = [{100,230002,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,22) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 22,award = [{100,230002,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,23) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 23,award = [{100,230002,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,24) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 24,award = [{100,230002,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,25) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 25,award = [{100,230002,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,26) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 26,award = [{100,230002,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,27) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 27,award = [{100,230002,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,28) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 28,award = [{100,230002,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,29) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 29,award = [{100,230002,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,30) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 30,award = [{100,230002,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,31) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 31,award = [{100,230002,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,1,32) ->
    #race_rank_draw_pool{act_id = 142,stage = 1,award_id = 32,award = [{100,230002,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,1) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 1,award = [{100,230002,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,2) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 2,award = [{100,230002,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,3) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 3,award = [{100,230002,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,4) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 4,award = [{100,230002,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,5) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 5,award = [{100,230002,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,6) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 6,award = [{100,230002,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,7) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 7,award = [{100,230002,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,8) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 8,award = [{100,230002,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,9) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 9,award = [{100,230002,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,10) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 10,award = [{100,230002,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,11) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 11,award = [{100,230002,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,12) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 12,award = [{100,230002,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,13) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 13,award = [{100,230002,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,14) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 14,award = [{100,230002,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,15) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 15,award = [{100,230002,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,16) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 16,award = [{100,230002,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,17) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 17,award = [{100,230002,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,18) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 18,award = [{100,230002,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,19) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 19,award = [{100,230002,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,20) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 20,award = [{100,230002,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,21) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 21,award = [{100,230002,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,22) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 22,award = [{100,230002,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,23) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 23,award = [{100,230002,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,24) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 24,award = [{100,230002,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,25) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 25,award = [{100,230002,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,26) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 26,award = [{100,230002,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,27) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 27,award = [{100,230002,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,28) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 28,award = [{100,230002,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,29) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 29,award = [{100,230002,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,30) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 30,award = [{100,230002,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,31) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 31,award = [{100,230002,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,2,32) ->
    #race_rank_draw_pool{act_id = 142,stage = 2,award_id = 32,award = [{100,230002,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,1) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 1,award = [{100,230002,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,2) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 2,award = [{100,230002,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,3) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 3,award = [{100,230002,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,4) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 4,award = [{100,230002,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,5) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 5,award = [{100,230002,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,6) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 6,award = [{100,230002,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,7) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 7,award = [{100,230002,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,8) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 8,award = [{100,230002,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,9) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 9,award = [{100,230002,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,10) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 10,award = [{100,230002,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,11) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 11,award = [{100,230002,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,12) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 12,award = [{100,230002,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,13) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 13,award = [{100,230002,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,14) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 14,award = [{100,230002,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,15) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 15,award = [{100,230002,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,16) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 16,award = [{100,230002,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,17) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 17,award = [{100,230002,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,18) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 18,award = [{100,230002,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,19) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 19,award = [{100,230002,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,20) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 20,award = [{100,230002,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,21) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 21,award = [{100,230002,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,22) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 22,award = [{100,230002,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,23) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 23,award = [{100,230002,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,24) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 24,award = [{100,230002,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,25) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 25,award = [{100,230002,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,26) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 26,award = [{100,230002,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,27) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 27,award = [{100,230002,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,28) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 28,award = [{100,230002,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,29) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 29,award = [{100,230002,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,30) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 30,award = [{100,230002,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,31) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 31,award = [{100,230002,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(142,3,32) ->
    #race_rank_draw_pool{act_id = 142,stage = 3,award_id = 32,award = [{100,230002,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,1) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 1,award = [{100,230003,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,2) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 2,award = [{100,230003,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,3) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 3,award = [{100,230003,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,4) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 4,award = [{100,230003,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,5) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 5,award = [{100,230003,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,6) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 6,award = [{100,230003,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,7) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 7,award = [{100,230003,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,8) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 8,award = [{100,230003,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,9) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 9,award = [{100,230003,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,10) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 10,award = [{100,230003,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,11) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 11,award = [{100,230003,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,12) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 12,award = [{100,230003,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,13) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 13,award = [{100,230003,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,14) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 14,award = [{100,230003,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,15) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 15,award = [{100,230003,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,16) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 16,award = [{100,230003,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,17) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 17,award = [{100,230003,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,18) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 18,award = [{100,230003,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,19) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 19,award = [{100,230003,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,20) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 20,award = [{100,230003,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,21) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 21,award = [{100,230003,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,22) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 22,award = [{100,230003,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,23) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 23,award = [{100,230003,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,24) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 24,award = [{100,230003,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,25) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 25,award = [{100,230003,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,26) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 26,award = [{100,230003,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,27) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 27,award = [{100,230003,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,28) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 28,award = [{100,230003,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,29) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 29,award = [{100,230003,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,30) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 30,award = [{100,230003,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,31) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 31,award = [{100,230003,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,1,32) ->
    #race_rank_draw_pool{act_id = 143,stage = 1,award_id = 32,award = [{100,230003,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,1) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 1,award = [{100,230003,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,2) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 2,award = [{100,230003,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,3) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 3,award = [{100,230003,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,4) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 4,award = [{100,230003,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,5) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 5,award = [{100,230003,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,6) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 6,award = [{100,230003,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,7) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 7,award = [{100,230003,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,8) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 8,award = [{100,230003,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,9) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 9,award = [{100,230003,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,10) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 10,award = [{100,230003,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,11) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 11,award = [{100,230003,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,12) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 12,award = [{100,230003,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,13) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 13,award = [{100,230003,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,14) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 14,award = [{100,230003,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,15) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 15,award = [{100,230003,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,16) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 16,award = [{100,230003,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,17) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 17,award = [{100,230003,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,18) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 18,award = [{100,230003,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,19) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 19,award = [{100,230003,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,20) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 20,award = [{100,230003,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,21) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 21,award = [{100,230003,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,22) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 22,award = [{100,230003,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,23) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 23,award = [{100,230003,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,24) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 24,award = [{100,230003,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,25) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 25,award = [{100,230003,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,26) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 26,award = [{100,230003,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,27) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 27,award = [{100,230003,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,28) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 28,award = [{100,230003,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,29) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 29,award = [{100,230003,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,30) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 30,award = [{100,230003,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,31) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 31,award = [{100,230003,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,2,32) ->
    #race_rank_draw_pool{act_id = 143,stage = 2,award_id = 32,award = [{100,230003,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,1) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 1,award = [{100,230003,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,2) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 2,award = [{100,230003,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,3) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 3,award = [{100,230003,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,4) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 4,award = [{100,230003,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,5) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 5,award = [{100,230003,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,6) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 6,award = [{100,230003,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,7) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 7,award = [{100,230003,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,8) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 8,award = [{100,230003,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,9) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 9,award = [{100,230003,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,10) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 10,award = [{100,230003,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,11) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 11,award = [{100,230003,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,12) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 12,award = [{100,230003,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,13) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 13,award = [{100,230003,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,14) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 14,award = [{100,230003,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,15) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 15,award = [{100,230003,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,16) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 16,award = [{100,230003,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,17) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 17,award = [{100,230003,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,18) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 18,award = [{100,230003,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,19) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 19,award = [{100,230003,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,20) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 20,award = [{100,230003,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,21) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 21,award = [{100,230003,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,22) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 22,award = [{100,230003,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,23) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 23,award = [{100,230003,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,24) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 24,award = [{100,230003,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,25) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 25,award = [{100,230003,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,26) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 26,award = [{100,230003,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,27) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 27,award = [{100,230003,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,28) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 28,award = [{100,230003,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,29) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 29,award = [{100,230003,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,30) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 30,award = [{100,230003,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,31) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 31,award = [{100,230003,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(143,3,32) ->
    #race_rank_draw_pool{act_id = 143,stage = 3,award_id = 32,award = [{100,230003,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,1) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 1,award = [{100,230004,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,2) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 2,award = [{100,230004,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,3) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 3,award = [{100,230004,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,4) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 4,award = [{100,230004,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,5) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 5,award = [{100,230004,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,6) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 6,award = [{100,230004,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,7) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 7,award = [{100,230004,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,8) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 8,award = [{100,230004,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,9) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 9,award = [{100,230004,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,10) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 10,award = [{100,230004,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,11) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 11,award = [{100,230004,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,12) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 12,award = [{100,230004,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,13) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 13,award = [{100,230004,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,14) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 14,award = [{100,230004,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,15) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 15,award = [{100,230004,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,16) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 16,award = [{100,230004,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,17) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 17,award = [{100,230004,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,18) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 18,award = [{100,230004,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,19) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 19,award = [{100,230004,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,20) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 20,award = [{100,230004,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,21) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 21,award = [{100,230004,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,22) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 22,award = [{100,230004,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,23) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 23,award = [{100,230004,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,24) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 24,award = [{100,230004,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,25) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 25,award = [{100,230004,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,26) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 26,award = [{100,230004,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,27) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 27,award = [{100,230004,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,28) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 28,award = [{100,230004,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,29) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 29,award = [{100,230004,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,30) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 30,award = [{100,230004,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,31) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 31,award = [{100,230004,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,1,32) ->
    #race_rank_draw_pool{act_id = 161,stage = 1,award_id = 32,award = [{100,230004,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,1) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 1,award = [{100,230004,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,2) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 2,award = [{100,230004,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,3) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 3,award = [{100,230004,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,4) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 4,award = [{100,230004,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,5) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 5,award = [{100,230004,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,6) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 6,award = [{100,230004,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,7) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 7,award = [{100,230004,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,8) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 8,award = [{100,230004,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,9) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 9,award = [{100,230004,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,10) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 10,award = [{100,230004,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,11) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 11,award = [{100,230004,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,12) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 12,award = [{100,230004,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,13) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 13,award = [{100,230004,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,14) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 14,award = [{100,230004,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,15) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 15,award = [{100,230004,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,16) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 16,award = [{100,230004,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,17) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 17,award = [{100,230004,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,18) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 18,award = [{100,230004,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,19) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 19,award = [{100,230004,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,20) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 20,award = [{100,230004,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,21) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 21,award = [{100,230004,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,22) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 22,award = [{100,230004,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,23) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 23,award = [{100,230004,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,24) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 24,award = [{100,230004,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,25) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 25,award = [{100,230004,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,26) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 26,award = [{100,230004,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,27) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 27,award = [{100,230004,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,28) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 28,award = [{100,230004,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,29) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 29,award = [{100,230004,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,30) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 30,award = [{100,230004,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,31) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 31,award = [{100,230004,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,2,32) ->
    #race_rank_draw_pool{act_id = 161,stage = 2,award_id = 32,award = [{100,230004,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,1) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 1,award = [{100,230004,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,2) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 2,award = [{100,230004,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,3) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 3,award = [{100,230004,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,4) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 4,award = [{100,230004,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,5) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 5,award = [{100,230004,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,6) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 6,award = [{100,230004,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,7) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 7,award = [{100,230004,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,8) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 8,award = [{100,230004,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,9) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 9,award = [{100,230004,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,10) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 10,award = [{100,230004,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,11) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 11,award = [{100,230004,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,12) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 12,award = [{100,230004,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,13) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 13,award = [{100,230004,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,14) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 14,award = [{100,230004,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,15) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 15,award = [{100,230004,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,16) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 16,award = [{100,230004,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,17) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 17,award = [{100,230004,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,18) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 18,award = [{100,230004,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,19) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 19,award = [{100,230004,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,20) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 20,award = [{100,230004,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,21) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 21,award = [{100,230004,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,22) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 22,award = [{100,230004,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,23) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 23,award = [{100,230004,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,24) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 24,award = [{100,230004,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,25) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 25,award = [{100,230004,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,26) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 26,award = [{100,230004,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,27) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 27,award = [{100,230004,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,28) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 28,award = [{100,230004,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,29) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 29,award = [{100,230004,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,30) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 30,award = [{100,230004,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,31) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 31,award = [{100,230004,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(161,3,32) ->
    #race_rank_draw_pool{act_id = 161,stage = 3,award_id = 32,award = [{100,230004,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,1) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 1,award = [{100,230005,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,2) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 2,award = [{100,230005,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,3) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 3,award = [{100,230005,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,4) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 4,award = [{100,230005,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,5) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 5,award = [{100,230005,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,6) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 6,award = [{100,230005,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,7) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 7,award = [{100,230005,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,8) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 8,award = [{100,230005,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,9) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 9,award = [{100,230005,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,10) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 10,award = [{100,230005,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,11) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 11,award = [{100,230005,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,12) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 12,award = [{100,230005,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,13) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 13,award = [{100,230005,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,14) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 14,award = [{100,230005,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,15) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 15,award = [{100,230005,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,16) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 16,award = [{100,230005,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,17) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 17,award = [{100,230005,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,18) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 18,award = [{100,230005,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,19) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 19,award = [{100,230005,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,20) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 20,award = [{100,230005,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,21) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 21,award = [{100,230005,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,22) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 22,award = [{100,230005,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,23) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 23,award = [{100,230005,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,24) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 24,award = [{100,230005,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,25) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 25,award = [{100,230005,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,26) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 26,award = [{100,230005,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,27) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 27,award = [{100,230005,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,28) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 28,award = [{100,230005,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,29) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 29,award = [{100,230005,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,30) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 30,award = [{100,230005,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,31) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 31,award = [{100,230005,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,1,32) ->
    #race_rank_draw_pool{act_id = 162,stage = 1,award_id = 32,award = [{100,230005,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,1) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 1,award = [{100,230005,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,2) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 2,award = [{100,230005,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,3) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 3,award = [{100,230005,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,4) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 4,award = [{100,230005,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,5) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 5,award = [{100,230005,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,6) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 6,award = [{100,230005,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,7) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 7,award = [{100,230005,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,8) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 8,award = [{100,230005,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,9) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 9,award = [{100,230005,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,10) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 10,award = [{100,230005,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,11) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 11,award = [{100,230005,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,12) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 12,award = [{100,230005,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,13) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 13,award = [{100,230005,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,14) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 14,award = [{100,230005,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,15) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 15,award = [{100,230005,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,16) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 16,award = [{100,230005,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,17) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 17,award = [{100,230005,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,18) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 18,award = [{100,230005,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,19) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 19,award = [{100,230005,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,20) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 20,award = [{100,230005,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,21) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 21,award = [{100,230005,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,22) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 22,award = [{100,230005,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,23) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 23,award = [{100,230005,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,24) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 24,award = [{100,230005,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,25) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 25,award = [{100,230005,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,26) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 26,award = [{100,230005,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,27) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 27,award = [{100,230005,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,28) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 28,award = [{100,230005,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,29) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 29,award = [{100,230005,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,30) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 30,award = [{100,230005,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,31) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 31,award = [{100,230005,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,2,32) ->
    #race_rank_draw_pool{act_id = 162,stage = 2,award_id = 32,award = [{100,230005,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,1) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 1,award = [{100,230005,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,2) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 2,award = [{100,230005,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,3) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 3,award = [{100,230005,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,4) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 4,award = [{100,230005,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,5) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 5,award = [{100,230005,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,6) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 6,award = [{100,230005,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,7) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 7,award = [{100,230005,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,8) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 8,award = [{100,230005,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,9) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 9,award = [{100,230005,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,10) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 10,award = [{100,230005,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,11) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 11,award = [{100,230005,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,12) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 12,award = [{100,230005,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,13) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 13,award = [{100,230005,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,14) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 14,award = [{100,230005,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,15) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 15,award = [{100,230005,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,16) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 16,award = [{100,230005,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,17) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 17,award = [{100,230005,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,18) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 18,award = [{100,230005,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,19) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 19,award = [{100,230005,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,20) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 20,award = [{100,230005,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,21) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 21,award = [{100,230005,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,22) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 22,award = [{100,230005,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,23) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 23,award = [{100,230005,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,24) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 24,award = [{100,230005,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,25) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 25,award = [{100,230005,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,26) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 26,award = [{100,230005,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,27) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 27,award = [{100,230005,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,28) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 28,award = [{100,230005,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,29) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 29,award = [{100,230005,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,30) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 30,award = [{100,230005,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,31) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 31,award = [{100,230005,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(162,3,32) ->
    #race_rank_draw_pool{act_id = 162,stage = 3,award_id = 32,award = [{100,230005,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,1) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 1,award = [{100,230006,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,2) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 2,award = [{100,230006,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,3) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 3,award = [{100,230006,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,4) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 4,award = [{100,230006,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,5) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 5,award = [{100,230006,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,6) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 6,award = [{100,230006,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,7) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 7,award = [{100,230006,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,8) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 8,award = [{100,230006,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,9) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 9,award = [{100,230006,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,10) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 10,award = [{100,230006,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,11) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 11,award = [{100,230006,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,12) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 12,award = [{100,230006,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,13) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 13,award = [{100,230006,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,14) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 14,award = [{100,230006,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,15) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 15,award = [{100,230006,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,16) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 16,award = [{100,230006,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,17) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 17,award = [{100,230006,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,18) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 18,award = [{100,230006,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,19) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 19,award = [{100,230006,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,20) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 20,award = [{100,230006,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,21) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 21,award = [{100,230006,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,22) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 22,award = [{100,230006,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,23) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 23,award = [{100,230006,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,24) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 24,award = [{100,230006,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,25) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 25,award = [{100,230006,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,26) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 26,award = [{100,230006,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,27) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 27,award = [{100,230006,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,28) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 28,award = [{100,230006,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,29) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 29,award = [{100,230006,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,30) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 30,award = [{100,230006,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,31) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 31,award = [{100,230006,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,1,32) ->
    #race_rank_draw_pool{act_id = 163,stage = 1,award_id = 32,award = [{100,230006,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,1) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 1,award = [{100,230006,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,2) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 2,award = [{100,230006,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,3) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 3,award = [{100,230006,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,4) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 4,award = [{100,230006,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,5) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 5,award = [{100,230006,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,6) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 6,award = [{100,230006,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,7) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 7,award = [{100,230006,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,8) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 8,award = [{100,230006,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,9) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 9,award = [{100,230006,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,10) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 10,award = [{100,230006,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,11) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 11,award = [{100,230006,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,12) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 12,award = [{100,230006,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,13) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 13,award = [{100,230006,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,14) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 14,award = [{100,230006,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,15) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 15,award = [{100,230006,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,16) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 16,award = [{100,230006,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,17) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 17,award = [{100,230006,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,18) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 18,award = [{100,230006,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,19) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 19,award = [{100,230006,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,20) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 20,award = [{100,230006,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,21) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 21,award = [{100,230006,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,22) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 22,award = [{100,230006,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,23) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 23,award = [{100,230006,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,24) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 24,award = [{100,230006,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,25) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 25,award = [{100,230006,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,26) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 26,award = [{100,230006,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,27) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 27,award = [{100,230006,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,28) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 28,award = [{100,230006,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,29) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 29,award = [{100,230006,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,30) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 30,award = [{100,230006,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,31) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 31,award = [{100,230006,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,2,32) ->
    #race_rank_draw_pool{act_id = 163,stage = 2,award_id = 32,award = [{100,230006,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,1) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 1,award = [{100,230006,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,2) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 2,award = [{100,230006,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,3) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 3,award = [{100,230006,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,4) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 4,award = [{100,230006,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,5) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 5,award = [{100,230006,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,6) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 6,award = [{100,230006,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,7) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 7,award = [{100,230006,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,8) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 8,award = [{100,230006,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,9) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 9,award = [{100,230006,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,10) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 10,award = [{100,230006,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,11) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 11,award = [{100,230006,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,12) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 12,award = [{100,230006,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,13) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 13,award = [{100,230006,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,14) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 14,award = [{100,230006,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,15) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 15,award = [{100,230006,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,16) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 16,award = [{100,230006,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,17) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 17,award = [{100,230006,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,18) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 18,award = [{100,230006,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,19) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 19,award = [{100,230006,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,20) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 20,award = [{100,230006,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,21) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 21,award = [{100,230006,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,22) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 22,award = [{100,230006,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,23) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 23,award = [{100,230006,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,24) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 24,award = [{100,230006,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,25) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 25,award = [{100,230006,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,26) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 26,award = [{100,230006,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,27) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 27,award = [{100,230006,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,28) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 28,award = [{100,230006,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,29) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 29,award = [{100,230006,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,30) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 30,award = [{100,230006,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,31) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 31,award = [{100,230006,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(163,3,32) ->
    #race_rank_draw_pool{act_id = 163,stage = 3,award_id = 32,award = [{100,230006,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,1) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 1,award = [{100,230007,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,2) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 2,award = [{100,230007,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,3) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 3,award = [{100,230007,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,4) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 4,award = [{100,230007,4}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,5) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 5,award = [{100,230007,5}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,6) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 6,award = [{100,230007,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,7) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 7,award = [{100,230007,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,8) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 8,award = [{100,230007,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,9) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 9,award = [{100,230007,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,10) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 10,award = [{100,230007,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,11) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 11,award = [{100,230007,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,12) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 12,award = [{100,230007,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,13) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 13,award = [{100,230007,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,14) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 14,award = [{100,230007,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,15) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 15,award = [{100,230007,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,16) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 16,award = [{100,230007,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,17) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 17,award = [{100,230007,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,18) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 18,award = [{100,230007,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,19) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 19,award = [{100,230007,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,20) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 20,award = [{100,230007,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,21) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 21,award = [{100,230007,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,22) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 22,award = [{100,230007,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,23) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 23,award = [{100,230007,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,24) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 24,award = [{100,230007,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,25) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 25,award = [{100,230007,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,26) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 26,award = [{100,230007,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,27) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 27,award = [{100,230007,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,28) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 28,award = [{100,230007,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,29) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 29,award = [{100,230007,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,30) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 30,award = [{100,230007,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,31) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 31,award = [{100,230007,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,1,32) ->
    #race_rank_draw_pool{act_id = 165,stage = 1,award_id = 32,award = [{100,230007,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,1) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 1,award = [{100,230007,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,2) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 2,award = [{100,230007,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,3) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 3,award = [{100,230007,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,4) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 4,award = [{100,230007,36}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,5) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 5,award = [{100,230007,37}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,6) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 6,award = [{100,230007,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,7) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 7,award = [{100,230007,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,8) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 8,award = [{100,230007,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,9) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 9,award = [{100,230007,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,10) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 10,award = [{100,230007,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,11) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 11,award = [{100,230007,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,12) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 12,award = [{100,230007,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,13) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 13,award = [{100,230007,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,14) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 14,award = [{100,230007,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,15) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 15,award = [{100,230007,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,16) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 16,award = [{100,230007,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,17) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 17,award = [{100,230007,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,18) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 18,award = [{100,230007,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,19) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 19,award = [{100,230007,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,20) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 20,award = [{100,230007,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,21) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 21,award = [{100,230007,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,22) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 22,award = [{100,230007,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,23) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 23,award = [{100,230007,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,24) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 24,award = [{100,230007,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,25) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 25,award = [{100,230007,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,26) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 26,award = [{100,230007,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,27) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 27,award = [{100,230007,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,28) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 28,award = [{100,230007,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,29) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 29,award = [{100,230007,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,30) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 30,award = [{100,230007,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,31) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 31,award = [{100,230007,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,2,32) ->
    #race_rank_draw_pool{act_id = 165,stage = 2,award_id = 32,award = [{100,230007,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,1) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 1,award = [{100,230007,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,2) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 2,award = [{100,230007,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,3) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 3,award = [{100,230007,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,4) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 4,award = [{100,230007,68}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,5) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 5,award = [{100,230007,69}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,6) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 6,award = [{100,230007,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,7) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 7,award = [{100,230007,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,8) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 8,award = [{100,230007,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,9) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 9,award = [{100,230007,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,10) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 10,award = [{100,230007,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,11) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 11,award = [{100,230007,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,12) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 12,award = [{100,230007,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,13) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 13,award = [{100,230007,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,14) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 14,award = [{100,230007,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,15) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 15,award = [{100,230007,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,16) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 16,award = [{100,230007,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,17) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 17,award = [{100,230007,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,18) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 18,award = [{100,230007,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,19) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 19,award = [{100,230007,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,20) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 20,award = [{100,230007,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,21) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 21,award = [{100,230007,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,22) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 22,award = [{100,230007,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,23) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 23,award = [{100,230007,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,24) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 24,award = [{100,230007,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,25) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 25,award = [{100,230007,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,26) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 26,award = [{100,230007,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,27) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 27,award = [{100,230007,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,28) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 28,award = [{100,230007,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,29) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 29,award = [{100,230007,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,30) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 30,award = [{100,230007,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,31) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 31,award = [{100,230007,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(165,3,32) ->
    #race_rank_draw_pool{act_id = 165,stage = 3,award_id = 32,award = [{100,230007,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,1) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 1,award = [{100,230008,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,2) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 2,award = [{100,230008,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,3) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 3,award = [{100,230008,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,4) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 4,award = [{100,230008,4}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,5) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 5,award = [{100,230008,5}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,6) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 6,award = [{100,230008,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,7) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 7,award = [{100,230008,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,8) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 8,award = [{100,230008,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,9) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 9,award = [{100,230008,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,10) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 10,award = [{100,230008,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,11) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 11,award = [{100,230008,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,12) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 12,award = [{100,230008,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,13) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 13,award = [{100,230008,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,14) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 14,award = [{100,230008,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,15) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 15,award = [{100,230008,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,16) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 16,award = [{100,230008,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,17) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 17,award = [{100,230008,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,18) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 18,award = [{100,230008,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,19) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 19,award = [{100,230008,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,20) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 20,award = [{100,230008,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,21) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 21,award = [{100,230008,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,22) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 22,award = [{100,230008,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,23) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 23,award = [{100,230008,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,24) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 24,award = [{100,230008,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,25) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 25,award = [{100,230008,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,26) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 26,award = [{100,230008,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,27) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 27,award = [{100,230008,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,28) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 28,award = [{100,230008,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,29) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 29,award = [{100,230008,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,30) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 30,award = [{100,230008,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,31) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 31,award = [{100,230008,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,1,32) ->
    #race_rank_draw_pool{act_id = 166,stage = 1,award_id = 32,award = [{100,230008,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,1) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 1,award = [{100,230008,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,2) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 2,award = [{100,230008,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,3) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 3,award = [{100,230008,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,4) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 4,award = [{100,230008,36}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,5) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 5,award = [{100,230008,37}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,6) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 6,award = [{100,230008,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,7) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 7,award = [{100,230008,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,8) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 8,award = [{100,230008,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,9) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 9,award = [{100,230008,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,10) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 10,award = [{100,230008,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,11) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 11,award = [{100,230008,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,12) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 12,award = [{100,230008,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,13) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 13,award = [{100,230008,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,14) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 14,award = [{100,230008,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,15) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 15,award = [{100,230008,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,16) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 16,award = [{100,230008,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,17) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 17,award = [{100,230008,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,18) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 18,award = [{100,230008,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,19) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 19,award = [{100,230008,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,20) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 20,award = [{100,230008,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,21) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 21,award = [{100,230008,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,22) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 22,award = [{100,230008,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,23) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 23,award = [{100,230008,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,24) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 24,award = [{100,230008,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,25) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 25,award = [{100,230008,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,26) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 26,award = [{100,230008,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,27) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 27,award = [{100,230008,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,28) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 28,award = [{100,230008,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,29) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 29,award = [{100,230008,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,30) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 30,award = [{100,230008,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,31) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 31,award = [{100,230008,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,2,32) ->
    #race_rank_draw_pool{act_id = 166,stage = 2,award_id = 32,award = [{100,230008,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,1) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 1,award = [{100,230008,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,2) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 2,award = [{100,230008,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,3) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 3,award = [{100,230008,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,4) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 4,award = [{100,230008,68}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,5) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 5,award = [{100,230008,69}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,6) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 6,award = [{100,230008,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,7) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 7,award = [{100,230008,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,8) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 8,award = [{100,230008,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,9) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 9,award = [{100,230008,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,10) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 10,award = [{100,230008,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,11) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 11,award = [{100,230008,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,12) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 12,award = [{100,230008,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,13) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 13,award = [{100,230008,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,14) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 14,award = [{100,230008,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,15) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 15,award = [{100,230008,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,16) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 16,award = [{100,230008,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,17) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 17,award = [{100,230008,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,18) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 18,award = [{100,230008,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,19) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 19,award = [{100,230008,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,20) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 20,award = [{100,230008,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,21) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 21,award = [{100,230008,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,22) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 22,award = [{100,230008,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,23) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 23,award = [{100,230008,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,24) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 24,award = [{100,230008,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,25) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 25,award = [{100,230008,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,26) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 26,award = [{100,230008,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,27) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 27,award = [{100,230008,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,28) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 28,award = [{100,230008,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,29) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 29,award = [{100,230008,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,30) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 30,award = [{100,230008,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,31) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 31,award = [{100,230008,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(166,3,32) ->
    #race_rank_draw_pool{act_id = 166,stage = 3,award_id = 32,award = [{100,230008,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,1) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 1,award = [{100,230001,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,2) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 2,award = [{100,230001,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,3) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 3,award = [{100,230001,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,4) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 4,award = [{100,230001,4}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,5) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 5,award = [{100,230001,5}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,6) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 6,award = [{100,230001,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,7) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 7,award = [{100,230001,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,8) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 8,award = [{100,230001,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,9) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 9,award = [{100,230001,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,10) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 10,award = [{100,230001,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,11) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 11,award = [{100,230001,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,12) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 12,award = [{100,230001,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,13) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 13,award = [{100,230001,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,14) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 14,award = [{100,230001,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,15) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 15,award = [{100,230001,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,16) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 16,award = [{100,230001,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,17) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 17,award = [{100,230001,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,18) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 18,award = [{100,230001,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,19) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 19,award = [{100,230001,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,20) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 20,award = [{100,230001,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,21) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 21,award = [{100,230001,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,22) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 22,award = [{100,230001,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,23) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 23,award = [{100,230001,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,24) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 24,award = [{100,230001,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,25) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 25,award = [{100,230001,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,26) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 26,award = [{100,230001,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,27) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 27,award = [{100,230001,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,28) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 28,award = [{100,230001,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,29) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 29,award = [{100,230001,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,30) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 30,award = [{100,230001,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,31) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 31,award = [{100,230001,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,1,32) ->
    #race_rank_draw_pool{act_id = 167,stage = 1,award_id = 32,award = [{100,230001,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,1) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 1,award = [{100,230001,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,2) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 2,award = [{100,230001,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,3) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 3,award = [{100,230001,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,4) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 4,award = [{100,230001,36}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,5) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 5,award = [{100,230001,37}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,6) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 6,award = [{100,230001,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,7) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 7,award = [{100,230001,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,8) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 8,award = [{100,230001,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,9) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 9,award = [{100,230001,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,10) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 10,award = [{100,230001,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,11) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 11,award = [{100,230001,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,12) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 12,award = [{100,230001,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,13) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 13,award = [{100,230001,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,14) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 14,award = [{100,230001,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,15) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 15,award = [{100,230001,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,16) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 16,award = [{100,230001,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,17) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 17,award = [{100,230001,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,18) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 18,award = [{100,230001,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,19) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 19,award = [{100,230001,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,20) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 20,award = [{100,230001,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,21) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 21,award = [{100,230001,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,22) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 22,award = [{100,230001,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,23) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 23,award = [{100,230001,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,24) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 24,award = [{100,230001,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,25) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 25,award = [{100,230001,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,26) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 26,award = [{100,230001,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,27) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 27,award = [{100,230001,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,28) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 28,award = [{100,230001,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,29) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 29,award = [{100,230001,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,30) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 30,award = [{100,230001,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,31) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 31,award = [{100,230001,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,2,32) ->
    #race_rank_draw_pool{act_id = 167,stage = 2,award_id = 32,award = [{100,230001,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,1) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 1,award = [{100,230001,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,2) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 2,award = [{100,230001,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,3) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 3,award = [{100,230001,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,4) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 4,award = [{100,230001,68}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,5) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 5,award = [{100,230001,69}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,6) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 6,award = [{100,230001,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,7) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 7,award = [{100,230001,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,8) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 8,award = [{100,230001,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,9) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 9,award = [{100,230001,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,10) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 10,award = [{100,230001,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,11) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 11,award = [{100,230001,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,12) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 12,award = [{100,230001,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,13) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 13,award = [{100,230001,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,14) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 14,award = [{100,230001,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,15) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 15,award = [{100,230001,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,16) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 16,award = [{100,230001,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,17) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 17,award = [{100,230001,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,18) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 18,award = [{100,230001,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,19) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 19,award = [{100,230001,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,20) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 20,award = [{100,230001,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,21) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 21,award = [{100,230001,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,22) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 22,award = [{100,230001,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,23) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 23,award = [{100,230001,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,24) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 24,award = [{100,230001,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,25) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 25,award = [{100,230001,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,26) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 26,award = [{100,230001,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,27) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 27,award = [{100,230001,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,28) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 28,award = [{100,230001,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,29) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 29,award = [{100,230001,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,30) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 30,award = [{100,230001,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,31) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 31,award = [{100,230001,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(167,3,32) ->
    #race_rank_draw_pool{act_id = 167,stage = 3,award_id = 32,award = [{100,230001,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,1) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 1,award = [{100,230002,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,2) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 2,award = [{100,230002,2}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,3) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 3,award = [{100,230002,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,4) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 4,award = [{100,230002,4}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,5) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 5,award = [{100,230002,5}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,6) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 6,award = [{100,230002,6}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,7) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 7,award = [{100,230002,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,8) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 8,award = [{100,230002,8}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,9) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 9,award = [{100,230002,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,10) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 10,award = [{100,230002,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,11) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 11,award = [{100,230002,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,12) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 12,award = [{100,230002,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,13) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 13,award = [{100,230002,13}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,14) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 14,award = [{100,230002,14}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,15) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 15,award = [{100,230002,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,16) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 16,award = [{100,230002,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,17) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 17,award = [{100,230002,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,18) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 18,award = [{100,230002,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,19) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 19,award = [{100,230002,19}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,20) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 20,award = [{100,230002,20}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,21) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 21,award = [{100,230002,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,22) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 22,award = [{100,230002,22}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,23) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 23,award = [{100,230002,23}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,24) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 24,award = [{100,230002,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,25) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 25,award = [{100,230002,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,26) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 26,award = [{100,230002,26}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,27) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 27,award = [{100,230002,27}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,28) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 28,award = [{100,230002,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,29) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 29,award = [{100,230002,29}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,30) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 30,award = [{100,230002,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,31) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 31,award = [{100,230002,31}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,1,32) ->
    #race_rank_draw_pool{act_id = 170,stage = 1,award_id = 32,award = [{100,230002,32}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,1) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 1,award = [{100,230002,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,2) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 2,award = [{100,230002,34}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,3) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 3,award = [{100,230002,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,4) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 4,award = [{100,230002,36}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,5) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 5,award = [{100,230002,37}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,6) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 6,award = [{100,230002,38}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,7) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 7,award = [{100,230002,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,8) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 8,award = [{100,230002,40}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,9) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 9,award = [{100,230002,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,10) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 10,award = [{100,230002,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,11) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 11,award = [{100,230002,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,12) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 12,award = [{100,230002,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,13) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 13,award = [{100,230002,45}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,14) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 14,award = [{100,230002,46}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,15) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 15,award = [{100,230002,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,16) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 16,award = [{100,230002,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,17) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 17,award = [{100,230002,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,18) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 18,award = [{100,230002,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,19) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 19,award = [{100,230002,51}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,20) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 20,award = [{100,230002,52}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,21) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 21,award = [{100,230002,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,22) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 22,award = [{100,230002,54}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,23) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 23,award = [{100,230002,55}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,24) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 24,award = [{100,230002,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,25) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 25,award = [{100,230002,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,26) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 26,award = [{100,230002,58}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,27) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 27,award = [{100,230002,59}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,28) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 28,award = [{100,230002,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,29) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 29,award = [{100,230002,61}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,30) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 30,award = [{100,230002,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,31) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 31,award = [{100,230002,63}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,2,32) ->
    #race_rank_draw_pool{act_id = 170,stage = 2,award_id = 32,award = [{100,230002,64}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,1) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 1,award = [{100,230002,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,2) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 2,award = [{100,230002,66}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,3) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 3,award = [{100,230002,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,4) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 4,award = [{100,230002,68}],loading_times = 1,weight = 20,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,5) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 5,award = [{100,230002,69}],loading_times = 1,weight = 50,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,6) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 6,award = [{100,230002,70}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,7) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 7,award = [{100,230002,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,8) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 8,award = [{100,230002,72}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,9) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 9,award = [{100,230002,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,10) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 10,award = [{100,230002,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,11) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 11,award = [{100,230002,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,12) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 12,award = [{100,230002,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,13) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 13,award = [{100,230002,77}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,14) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 14,award = [{100,230002,78}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,15) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 15,award = [{100,230002,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,16) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 16,award = [{100,230002,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,17) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 17,award = [{100,230002,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,18) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 18,award = [{100,230002,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,19) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 19,award = [{100,230002,83}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,20) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 20,award = [{100,230002,84}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,21) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 21,award = [{100,230002,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,22) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 22,award = [{100,230002,86}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,23) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 23,award = [{100,230002,87}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,24) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 24,award = [{100,230002,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,25) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 25,award = [{100,230002,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,26) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 26,award = [{100,230002,90}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,27) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 27,award = [{100,230002,91}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,28) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 28,award = [{100,230002,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,29) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 29,award = [{100,230002,93}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,30) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 30,award = [{100,230002,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,31) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 31,award = [{100,230002,95}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(170,3,32) ->
    #race_rank_draw_pool{act_id = 170,stage = 3,award_id = 32,award = [{100,230002,96}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,2) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 2,award = [{100,230003,1}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,3) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 3,award = [{100,230003,2}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,4) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 4,award = [{100,230003,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,5) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 5,award = [{100,230003,4}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,6) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 6,award = [{100,230003,5}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,7) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 7,award = [{100,230003,6}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,8) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 8,award = [{100,230003,7}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,9) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 9,award = [{100,230003,8}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,10) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 10,award = [{100,230003,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,11) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 11,award = [{100,230003,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,12) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 12,award = [{100,230003,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,13) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 13,award = [{100,230003,12}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,14) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 14,award = [{100,230003,13}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,15) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 15,award = [{100,230003,14}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,16) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 16,award = [{100,230003,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,17) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 17,award = [{100,230003,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,18) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 18,award = [{100,230003,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,19) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 19,award = [{100,230003,18}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,20) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 20,award = [{100,230003,19}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,21) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 21,award = [{100,230003,20}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,22) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 22,award = [{100,230003,21}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,23) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 23,award = [{100,230003,22}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,24) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 24,award = [{100,230003,23}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,25) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 25,award = [{100,230003,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,26) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 26,award = [{100,230003,25}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,27) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 27,award = [{100,230003,26}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,28) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 28,award = [{100,230003,27}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,29) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 29,award = [{100,230003,28}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,30) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 30,award = [{100,230003,29}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,31) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 31,award = [{100,230003,30}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,1,32) ->
    #race_rank_draw_pool{act_id = 171,stage = 1,award_id = 32,award = [{100,230003,31}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,1) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 1,award = [{100,230003,32}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,2) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 2,award = [{100,230003,33}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,3) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 3,award = [{100,230003,34}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,4) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 4,award = [{100,230003,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,5) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 5,award = [{100,230003,36}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,6) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 6,award = [{100,230003,37}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,7) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 7,award = [{100,230003,38}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,8) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 8,award = [{100,230003,39}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,9) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 9,award = [{100,230003,40}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,10) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 10,award = [{100,230003,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,11) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 11,award = [{100,230003,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,12) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 12,award = [{100,230003,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,13) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 13,award = [{100,230003,44}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,14) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 14,award = [{100,230003,45}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,15) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 15,award = [{100,230003,46}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,16) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 16,award = [{100,230003,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,17) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 17,award = [{100,230003,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,18) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 18,award = [{100,230003,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,19) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 19,award = [{100,230003,50}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,20) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 20,award = [{100,230003,51}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,21) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 21,award = [{100,230003,52}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,22) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 22,award = [{100,230003,53}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,23) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 23,award = [{100,230003,54}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,24) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 24,award = [{100,230003,55}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,25) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 25,award = [{100,230003,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,26) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 26,award = [{100,230003,57}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,27) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 27,award = [{100,230003,58}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,28) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 28,award = [{100,230003,59}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,29) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 29,award = [{100,230003,60}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,30) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 30,award = [{100,230003,61}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,31) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 31,award = [{100,230003,62}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,2,32) ->
    #race_rank_draw_pool{act_id = 171,stage = 2,award_id = 32,award = [{100,230003,63}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,1) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 1,award = [{100,230003,64}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,2) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 2,award = [{100,230003,65}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,3) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 3,award = [{100,230003,66}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,4) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 4,award = [{100,230003,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,5) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 5,award = [{100,230003,68}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,6) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 6,award = [{100,230003,69}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,7) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 7,award = [{100,230003,70}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,8) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 8,award = [{100,230003,71}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,9) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 9,award = [{100,230003,72}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,10) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 10,award = [{100,230003,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,11) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 11,award = [{100,230003,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,12) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 12,award = [{100,230003,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,13) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 13,award = [{100,230003,76}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,14) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 14,award = [{100,230003,77}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,15) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 15,award = [{100,230003,78}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,16) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 16,award = [{100,230003,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,17) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 17,award = [{100,230003,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,18) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 18,award = [{100,230003,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,19) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 19,award = [{100,230003,82}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,20) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 20,award = [{100,230003,83}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,21) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 21,award = [{100,230003,84}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,22) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 22,award = [{100,230003,85}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,23) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 23,award = [{100,230003,86}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,24) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 24,award = [{100,230003,87}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,25) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 25,award = [{100,230003,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,26) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 26,award = [{100,230003,89}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,27) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 27,award = [{100,230003,90}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,28) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 28,award = [{100,230003,91}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,29) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 29,award = [{100,230003,92}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,30) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 30,award = [{100,230003,93}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,31) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 31,award = [{100,230003,94}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(171,3,32) ->
    #race_rank_draw_pool{act_id = 171,stage = 3,award_id = 32,award = [{100,230003,95}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,2) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 2,award = [{100,230003,96}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,3) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 3,award = [{100,230004,1}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,4) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 4,award = [{100,230004,2}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,5) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 5,award = [{100,230004,3}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,6) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 6,award = [{100,230004,4}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,7) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 7,award = [{100,230004,5}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,8) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 8,award = [{100,230004,6}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,9) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 9,award = [{100,230004,7}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,10) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 10,award = [{100,230004,8}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,11) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 11,award = [{100,230004,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,12) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 12,award = [{100,230004,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,13) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 13,award = [{100,230004,11}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,14) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 14,award = [{100,230004,12}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,15) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 15,award = [{100,230004,13}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,16) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 16,award = [{100,230004,14}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,17) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 17,award = [{100,230004,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,18) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 18,award = [{100,230004,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,19) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 19,award = [{100,230004,17}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,20) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 20,award = [{100,230004,18}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,21) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 21,award = [{100,230004,19}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,22) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 22,award = [{100,230004,20}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,23) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 23,award = [{100,230004,21}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,24) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 24,award = [{100,230004,22}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,25) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 25,award = [{100,230004,23}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,26) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 26,award = [{100,230004,24}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,27) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 27,award = [{100,230004,25}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,28) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 28,award = [{100,230004,26}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,29) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 29,award = [{100,230004,27}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,30) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 30,award = [{100,230004,28}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,31) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 31,award = [{100,230004,29}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,1,32) ->
    #race_rank_draw_pool{act_id = 172,stage = 1,award_id = 32,award = [{100,230004,30}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,1) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 1,award = [{100,230004,31}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,2) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 2,award = [{100,230004,32}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,3) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 3,award = [{100,230004,33}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,4) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 4,award = [{100,230004,34}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,5) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 5,award = [{100,230004,35}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,6) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 6,award = [{100,230004,36}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,7) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 7,award = [{100,230004,37}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,8) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 8,award = [{100,230004,38}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,9) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 9,award = [{100,230004,39}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,10) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 10,award = [{100,230004,40}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,11) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 11,award = [{100,230004,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,12) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 12,award = [{100,230004,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,13) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 13,award = [{100,230004,43}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,14) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 14,award = [{100,230004,44}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,15) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 15,award = [{100,230004,45}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,16) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 16,award = [{100,230004,46}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,17) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 17,award = [{100,230004,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,18) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 18,award = [{100,230004,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,19) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 19,award = [{100,230004,49}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,20) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 20,award = [{100,230004,50}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,21) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 21,award = [{100,230004,51}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,22) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 22,award = [{100,230004,52}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,23) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 23,award = [{100,230004,53}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,24) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 24,award = [{100,230004,54}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,25) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 25,award = [{100,230004,55}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,26) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 26,award = [{100,230004,56}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,27) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 27,award = [{100,230004,57}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,28) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 28,award = [{100,230004,58}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,29) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 29,award = [{100,230004,59}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,30) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 30,award = [{100,230004,60}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,31) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 31,award = [{100,230004,61}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,2,32) ->
    #race_rank_draw_pool{act_id = 172,stage = 2,award_id = 32,award = [{100,230004,62}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,1) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 1,award = [{100,230004,63}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,2) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 2,award = [{100,230004,64}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,3) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 3,award = [{100,230004,65}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,4) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 4,award = [{100,230004,66}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,5) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 5,award = [{100,230004,67}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,6) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 6,award = [{100,230004,68}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,7) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 7,award = [{100,230004,69}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,8) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 8,award = [{100,230004,70}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,9) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 9,award = [{100,230004,71}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,10) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 10,award = [{100,230004,72}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,11) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 11,award = [{100,230004,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,12) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 12,award = [{100,230004,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,13) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 13,award = [{100,230004,75}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,14) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 14,award = [{100,230004,76}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,15) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 15,award = [{100,230004,77}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,16) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 16,award = [{100,230004,78}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,17) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 17,award = [{100,230004,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,18) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 18,award = [{100,230004,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,19) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 19,award = [{100,230004,81}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,20) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 20,award = [{100,230004,82}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,21) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 21,award = [{100,230004,83}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,22) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 22,award = [{100,230004,84}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,23) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 23,award = [{100,230004,85}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,24) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 24,award = [{100,230004,86}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,25) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 25,award = [{100,230004,87}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,26) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 26,award = [{100,230004,88}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,27) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 27,award = [{100,230004,89}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,28) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 28,award = [{100,230004,90}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,29) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 29,award = [{100,230004,91}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,30) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 30,award = [{100,230004,92}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,31) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 31,award = [{100,230004,93}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(172,3,32) ->
    #race_rank_draw_pool{act_id = 172,stage = 3,award_id = 32,award = [{100,230004,94}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,2) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 2,award = [{100,230004,95}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,3) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 3,award = [{100,230004,96}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,4) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 4,award = [{100,230005,1}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,5) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 5,award = [{100,230005,2}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,6) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 6,award = [{100,230005,3}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,7) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 7,award = [{100,230005,4}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,8) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 8,award = [{100,230005,5}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,9) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 9,award = [{100,230005,6}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,10) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 10,award = [{100,230005,7}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,11) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 11,award = [{100,230005,8}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,12) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 12,award = [{100,230005,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,13) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 13,award = [{100,230005,10}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,14) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 14,award = [{100,230005,11}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,15) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 15,award = [{100,230005,12}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,16) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 16,award = [{100,230005,13}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,17) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 17,award = [{100,230005,14}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,18) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 18,award = [{100,230005,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,19) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 19,award = [{100,230005,16}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,20) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 20,award = [{100,230005,17}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,21) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 21,award = [{100,230005,18}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,22) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 22,award = [{100,230005,19}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,23) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 23,award = [{100,230005,20}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,24) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 24,award = [{100,230005,21}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,25) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 25,award = [{100,230005,22}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,26) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 26,award = [{100,230005,23}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,27) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 27,award = [{100,230005,24}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,28) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 28,award = [{100,230005,25}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,29) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 29,award = [{100,230005,26}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,30) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 30,award = [{100,230005,27}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,31) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 31,award = [{100,230005,28}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,1,32) ->
    #race_rank_draw_pool{act_id = 173,stage = 1,award_id = 32,award = [{100,230005,29}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,1) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 1,award = [{100,230005,30}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,2) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 2,award = [{100,230005,31}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,3) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 3,award = [{100,230005,32}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,4) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 4,award = [{100,230005,33}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,5) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 5,award = [{100,230005,34}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,6) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 6,award = [{100,230005,35}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,7) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 7,award = [{100,230005,36}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,8) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 8,award = [{100,230005,37}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,9) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 9,award = [{100,230005,38}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,10) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 10,award = [{100,230005,39}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,11) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 11,award = [{100,230005,40}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,12) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 12,award = [{100,230005,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,13) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 13,award = [{100,230005,42}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,14) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 14,award = [{100,230005,43}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,15) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 15,award = [{100,230005,44}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,16) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 16,award = [{100,230005,45}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,17) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 17,award = [{100,230005,46}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,18) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 18,award = [{100,230005,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,19) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 19,award = [{100,230005,48}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,20) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 20,award = [{100,230005,49}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,21) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 21,award = [{100,230005,50}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,22) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 22,award = [{100,230005,51}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,23) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 23,award = [{100,230005,52}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,24) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 24,award = [{100,230005,53}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,25) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 25,award = [{100,230005,54}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,26) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 26,award = [{100,230005,55}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,27) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 27,award = [{100,230005,56}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,28) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 28,award = [{100,230005,57}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,29) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 29,award = [{100,230005,58}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,30) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 30,award = [{100,230005,59}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,31) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 31,award = [{100,230005,60}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,2,32) ->
    #race_rank_draw_pool{act_id = 173,stage = 2,award_id = 32,award = [{100,230005,61}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,1) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 1,award = [{100,230005,62}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,2) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 2,award = [{100,230005,63}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,3) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 3,award = [{100,230005,64}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,4) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 4,award = [{100,230005,65}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,5) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 5,award = [{100,230005,66}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,6) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 6,award = [{100,230005,67}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,7) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 7,award = [{100,230005,68}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,8) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 8,award = [{100,230005,69}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,9) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 9,award = [{100,230005,70}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,10) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 10,award = [{100,230005,71}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,11) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 11,award = [{100,230005,72}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,12) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 12,award = [{100,230005,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,13) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 13,award = [{100,230005,74}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,14) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 14,award = [{100,230005,75}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,15) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 15,award = [{100,230005,76}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,16) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 16,award = [{100,230005,77}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,17) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 17,award = [{100,230005,78}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,18) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 18,award = [{100,230005,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,19) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 19,award = [{100,230005,80}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,20) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 20,award = [{100,230005,81}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,21) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 21,award = [{100,230005,82}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,22) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 22,award = [{100,230005,83}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,23) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 23,award = [{100,230005,84}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,24) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 24,award = [{100,230005,85}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,25) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 25,award = [{100,230005,86}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,26) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 26,award = [{100,230005,87}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,27) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 27,award = [{100,230005,88}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,28) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 28,award = [{100,230005,89}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,29) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 29,award = [{100,230005,90}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,30) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 30,award = [{100,230005,91}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,31) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 31,award = [{100,230005,92}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(173,3,32) ->
    #race_rank_draw_pool{act_id = 173,stage = 3,award_id = 32,award = [{100,230005,93}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,2) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 2,award = [{100,230005,94}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,3) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 3,award = [{100,230005,95}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,4) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 4,award = [{100,230005,96}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,5) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 5,award = [{100,230006,1}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,6) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 6,award = [{100,230006,2}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,7) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 7,award = [{100,230006,3}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,8) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 8,award = [{100,230006,4}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,9) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 9,award = [{100,230006,5}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,10) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 10,award = [{100,230006,6}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,11) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 11,award = [{100,230006,7}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,12) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 12,award = [{100,230006,8}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,13) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 13,award = [{100,230006,9}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,14) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 14,award = [{100,230006,10}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,15) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 15,award = [{100,230006,11}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,16) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 16,award = [{100,230006,12}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,17) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 17,award = [{100,230006,13}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,18) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 18,award = [{100,230006,14}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,19) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 19,award = [{100,230006,15}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,20) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 20,award = [{100,230006,16}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,21) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 21,award = [{100,230006,17}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,22) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 22,award = [{100,230006,18}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,23) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 23,award = [{100,230006,19}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,24) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 24,award = [{100,230006,20}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,25) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 25,award = [{100,230006,21}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,26) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 26,award = [{100,230006,22}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,27) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 27,award = [{100,230006,23}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,28) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 28,award = [{100,230006,24}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,29) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 29,award = [{100,230006,25}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,30) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 30,award = [{100,230006,26}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,31) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 31,award = [{100,230006,27}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,1,32) ->
    #race_rank_draw_pool{act_id = 174,stage = 1,award_id = 32,award = [{100,230006,28}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,1) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 1,award = [{100,230006,29}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,2) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 2,award = [{100,230006,30}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,3) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 3,award = [{100,230006,31}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,4) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 4,award = [{100,230006,32}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,5) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 5,award = [{100,230006,33}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,6) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 6,award = [{100,230006,34}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,7) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 7,award = [{100,230006,35}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,8) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 8,award = [{100,230006,36}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,9) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 9,award = [{100,230006,37}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,10) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 10,award = [{100,230006,38}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,11) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 11,award = [{100,230006,39}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,12) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 12,award = [{100,230006,40}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,13) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 13,award = [{100,230006,41}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,14) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 14,award = [{100,230006,42}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,15) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 15,award = [{100,230006,43}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,16) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 16,award = [{100,230006,44}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,17) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 17,award = [{100,230006,45}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,18) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 18,award = [{100,230006,46}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,19) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 19,award = [{100,230006,47}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,20) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 20,award = [{100,230006,48}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,21) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 21,award = [{100,230006,49}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,22) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 22,award = [{100,230006,50}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,23) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 23,award = [{100,230006,51}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,24) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 24,award = [{100,230006,52}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,25) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 25,award = [{100,230006,53}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,26) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 26,award = [{100,230006,54}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,27) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 27,award = [{100,230006,55}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,28) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 28,award = [{100,230006,56}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,29) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 29,award = [{100,230006,57}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,30) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 30,award = [{100,230006,58}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,31) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 31,award = [{100,230006,59}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,2,32) ->
    #race_rank_draw_pool{act_id = 174,stage = 2,award_id = 32,award = [{100,230006,60}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,1) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 1,award = [{100,230006,61}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,2) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 2,award = [{100,230006,62}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,3) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 3,award = [{100,230006,63}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,4) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 4,award = [{100,230006,64}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,5) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 5,award = [{100,230006,65}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,6) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 6,award = [{100,230006,66}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,7) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 7,award = [{100,230006,67}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,8) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 8,award = [{100,230006,68}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,9) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 9,award = [{100,230006,69}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,10) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 10,award = [{100,230006,70}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,11) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 11,award = [{100,230006,71}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,12) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 12,award = [{100,230006,72}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,13) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 13,award = [{100,230006,73}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,14) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 14,award = [{100,230006,74}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,15) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 15,award = [{100,230006,75}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,16) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 16,award = [{100,230006,76}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,17) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 17,award = [{100,230006,77}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,18) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 18,award = [{100,230006,78}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,19) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 19,award = [{100,230006,79}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,20) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 20,award = [{100,230006,80}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,21) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 21,award = [{100,230006,81}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,22) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 22,award = [{100,230006,82}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,23) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 23,award = [{100,230006,83}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,24) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 24,award = [{100,230006,84}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,25) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 25,award = [{100,230006,85}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,26) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 26,award = [{100,230006,86}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,27) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 27,award = [{100,230006,87}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,28) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 28,award = [{100,230006,88}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,29) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 29,award = [{100,230006,89}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,30) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 30,award = [{100,230006,90}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,31) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 31,award = [{100,230006,91}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(174,3,32) ->
    #race_rank_draw_pool{act_id = 174,stage = 3,award_id = 32,award = [{100,230006,92}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,2) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 2,award = [{100,230006,93}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,3) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 3,award = [{100,230006,94}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,4) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 4,award = [{100,230006,95}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,5) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 5,award = [{100,230006,96}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,6) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 6,award = [{100,230007,1}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,7) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 7,award = [{100,230007,2}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,8) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 8,award = [{100,230007,3}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,9) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 9,award = [{100,230007,4}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,10) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 10,award = [{100,230007,5}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,11) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 11,award = [{100,230007,6}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,12) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 12,award = [{100,230007,7}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,13) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 13,award = [{100,230007,8}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,14) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 14,award = [{100,230007,9}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,15) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 15,award = [{100,230007,10}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,16) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 16,award = [{100,230007,11}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,17) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 17,award = [{100,230007,12}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,18) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 18,award = [{100,230007,13}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,19) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 19,award = [{100,230007,14}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,20) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 20,award = [{100,230007,15}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,21) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 21,award = [{100,230007,16}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,22) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 22,award = [{100,230007,17}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,23) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 23,award = [{100,230007,18}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,24) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 24,award = [{100,230007,19}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,25) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 25,award = [{100,230007,20}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,26) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 26,award = [{100,230007,21}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,27) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 27,award = [{100,230007,22}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,28) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 28,award = [{100,230007,23}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,29) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 29,award = [{100,230007,24}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,30) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 30,award = [{100,230007,25}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,31) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 31,award = [{100,230007,26}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,1,32) ->
    #race_rank_draw_pool{act_id = 175,stage = 1,award_id = 32,award = [{100,230007,27}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,1) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 1,award = [{100,230007,28}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,2) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 2,award = [{100,230007,29}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,3) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 3,award = [{100,230007,30}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,4) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 4,award = [{100,230007,31}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,5) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 5,award = [{100,230007,32}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,6) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 6,award = [{100,230007,33}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,7) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 7,award = [{100,230007,34}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,8) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 8,award = [{100,230007,35}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,9) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 9,award = [{100,230007,36}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,10) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 10,award = [{100,230007,37}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,11) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 11,award = [{100,230007,38}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,12) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 12,award = [{100,230007,39}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,13) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 13,award = [{100,230007,40}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,14) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 14,award = [{100,230007,41}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,15) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 15,award = [{100,230007,42}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,16) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 16,award = [{100,230007,43}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,17) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 17,award = [{100,230007,44}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,18) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 18,award = [{100,230007,45}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,19) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 19,award = [{100,230007,46}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,20) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 20,award = [{100,230007,47}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,21) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 21,award = [{100,230007,48}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,22) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 22,award = [{100,230007,49}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,23) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 23,award = [{100,230007,50}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,24) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 24,award = [{100,230007,51}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,25) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 25,award = [{100,230007,52}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,26) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 26,award = [{100,230007,53}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,27) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 27,award = [{100,230007,54}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,28) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 28,award = [{100,230007,55}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,29) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 29,award = [{100,230007,56}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,30) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 30,award = [{100,230007,57}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,31) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 31,award = [{100,230007,58}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,2,32) ->
    #race_rank_draw_pool{act_id = 175,stage = 2,award_id = 32,award = [{100,230007,59}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,1) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 1,award = [{100,230007,60}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,2) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 2,award = [{100,230007,61}],loading_times = 1,weight = 1,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,3) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 3,award = [{100,230007,62}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,4) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 4,award = [{100,230007,63}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,5) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 5,award = [{100,230007,64}],loading_times = 1,weight = 10,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,6) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 6,award = [{100,230007,65}],loading_times = 1,weight = 100,is_broadcast = 1,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,7) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 7,award = [{100,230007,66}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,8) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 8,award = [{100,230007,67}],loading_times = 1,weight = 4,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,9) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 9,award = [{100,230007,68}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,10) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 10,award = [{100,230007,69}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,11) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 11,award = [{100,230007,70}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,12) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 12,award = [{100,230007,71}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,13) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 13,award = [{100,230007,72}],loading_times = 1,weight = 120,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,14) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 14,award = [{100,230007,73}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,15) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 15,award = [{100,230007,74}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,16) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 16,award = [{100,230007,75}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,17) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 17,award = [{100,230007,76}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,18) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 18,award = [{100,230007,77}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,19) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 19,award = [{100,230007,78}],loading_times = 1,weight = 250,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,20) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 20,award = [{100,230007,79}],loading_times = 1,weight = 100,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,21) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 21,award = [{100,230007,80}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,22) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 22,award = [{100,230007,81}],loading_times = 1,weight = 400,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,23) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 23,award = [{100,230007,82}],loading_times = 1,weight = 600,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,24) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 24,award = [{100,230007,83}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,25) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 25,award = [{100,230007,84}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,26) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 26,award = [{100,230007,85}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,27) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 27,award = [{100,230007,86}],loading_times = 1,weight = 1860,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,28) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 28,award = [{100,230007,87}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,29) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 29,award = [{100,230007,88}],loading_times = 1,weight = 1000,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,30) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 30,award = [{100,230007,89}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,31) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 31,award = [{100,230007,90}],loading_times = 1,weight = 200,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(175,3,32) ->
    #race_rank_draw_pool{act_id = 175,stage = 3,award_id = 32,award = [{100,230007,91}],loading_times = 1,weight = 500,is_broadcast = 0,is_tv = 0,type = 0};

get_race_rank_draw_pool(_Actid,_Stage,_Awardid) ->
    false.

get_draw_pool_award_ids(101,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(101,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(101,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(102,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(102,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(102,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(103,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(103,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(103,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(104,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(104,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(104,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(105,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(105,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(105,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(106,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(106,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(106,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(107,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(107,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(107,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(108,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(108,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(108,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(109,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(109,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(109,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(133,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(133,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(133,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(134,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(134,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(134,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(135,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(135,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(135,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(137,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(137,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(137,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(138,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(138,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(138,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(139,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(139,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(139,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(140,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(140,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(140,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(141,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(141,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(141,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(142,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(142,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(142,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(143,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(143,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(143,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(161,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(161,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(161,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(162,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(162,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(162,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(163,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(163,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(163,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(165,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(165,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(165,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(166,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(166,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(166,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(167,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(167,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(167,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(170,1) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(170,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(170,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(171,1) ->
    [2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(171,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(171,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(172,1) ->
    [2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(172,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(172,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(173,1) ->
    [2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(173,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(173,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(174,1) ->
    [2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(174,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(174,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(175,1) ->
    [2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(175,2) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(175,3) ->
    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32];

get_draw_pool_award_ids(_Actid,_Stage) ->
    [].

get_race_rank_award(101,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=101,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=101,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=101,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=101,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=101,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=101,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=101,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=101,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=101,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=101,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=101,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=101,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=101,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(101,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=101,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=101,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=101,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=101,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=101,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=101,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=101,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=101,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=101,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=101,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=101,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=101,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=101,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=101,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(101,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=101,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=101,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=101,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=101,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=101,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=101,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=101,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=101,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=101,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=101,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=101,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=101,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=101,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=101,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(101,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=101,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=102,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=102,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=102,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=102,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=102,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=102,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=102,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=102,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=102,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=102,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=102,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=102,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=102,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(102,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=102,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=102,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=102,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=102,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=102,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=102,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=102,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=102,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=102,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=102,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=102,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=102,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=102,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=102,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(102,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=102,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=102,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=102,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=102,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=102,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=102,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=102,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=102,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=102,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=102,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=102,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=102,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=102,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=102,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(102,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=102,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=103,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=103,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=103,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=103,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=103,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=103,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=103,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=103,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=103,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=103,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=103,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=103,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=103,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(103,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=103,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=103,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=103,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=103,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=103,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=103,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=103,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=103,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=103,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=103,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=103,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=103,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=103,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=103,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(103,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=103,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=103,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=103,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=103,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=103,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=103,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=103,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=103,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=103,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=103,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=103,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=103,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=103,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=103,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(103,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=103,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=104,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=104,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=104,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=104,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=104,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=104,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=104,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=104,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=104,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=104,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=104,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=104,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=104,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(104,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=104,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=104,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=104,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=104,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=104,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=104,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=104,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=104,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=104,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=104,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=104,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=104,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=104,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=104,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(104,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=104,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=104,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=104,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=104,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=104,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=104,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=104,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=104,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=104,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=104,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=104,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=104,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=104,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=104,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(104,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=104,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=105,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=105,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=105,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=105,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=105,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=105,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=105,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=105,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=105,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=105,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=105,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=105,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=105,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(105,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=105,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=105,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=105,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=105,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=105,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=105,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=105,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=105,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=105,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=105,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=105,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=105,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=105,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=105,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(105,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=105,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=105,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=105,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=105,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=105,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=105,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=105,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=105,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=105,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=105,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=105,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=105,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=105,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=105,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(105,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=105,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=106,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=106,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=106,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=106,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=106,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=106,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=106,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=106,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=106,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=106,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=106,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=106,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=106,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(106,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=106,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=106,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=106,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=106,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=106,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=106,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=106,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=106,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=106,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=106,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=106,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=106,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=106,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=106,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(106,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=106,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=106,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=106,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=106,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=106,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=106,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=106,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=106,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=106,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=106,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=106,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=106,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=106,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=106,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(106,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=106,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=107,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=107,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=107,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=107,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=107,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=107,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=107,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=107,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=107,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=107,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=107,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=107,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=107,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(107,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=107,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=107,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=107,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=107,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=107,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=107,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=107,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=107,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=107,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=107,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=107,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=107,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=107,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=107,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(107,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=107,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=107,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=107,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=107,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=107,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=107,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=107,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=107,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=107,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=107,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=107,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=107,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=107,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=107,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(107,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=107,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=108,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=108,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=108,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=108,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=108,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=108,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=108,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=108,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=108,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=108,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=108,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=108,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=108,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(108,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=108,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=108,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=108,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=108,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=108,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=108,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=108,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=108,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=108,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=108,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=108,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=108,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=108,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=108,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(108,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=108,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=108,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=108,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=108,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=108,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=108,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=108,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=108,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=108,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=108,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=108,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=108,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=108,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=108,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(108,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=108,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=109,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=109,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=109,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=109,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=109,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=109,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=109,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=109,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=109,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=109,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=109,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=109,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=109,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(109,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=109,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=109,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=109,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=109,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=109,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=109,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=109,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=109,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=109,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=109,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=109,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=109,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=109,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=109,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(109,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=109,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=109,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=109,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=109,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=109,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=109,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=109,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=109,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=109,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=109,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=109,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=109,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=109,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=109,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(109,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=109,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=133,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=133,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=133,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=133,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=133,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=133,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=133,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=133,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=133,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=133,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=133,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=133,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=133,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(133,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=133,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=133,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=133,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=133,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=133,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=133,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=133,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=133,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=133,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=133,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=133,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=133,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=133,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=133,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(133,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=133,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=133,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=133,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=133,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=133,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=133,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=133,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=133,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=133,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=133,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=133,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=133,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=133,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=133,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(133,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=133,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=134,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=134,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=134,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=134,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=134,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=134,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=134,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=134,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=134,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=134,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=134,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=134,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=134,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(134,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=134,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=134,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=134,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=134,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=134,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=134,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=134,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=134,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=134,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=134,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=134,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=134,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=134,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=134,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(134,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=134,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=134,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=134,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=134,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=134,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=134,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=134,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=134,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=134,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=134,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=134,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=134,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=134,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=134,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(134,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=134,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=135,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=135,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=135,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=135,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=135,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=135,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=135,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=135,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=135,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=135,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=135,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=135,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=135,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(135,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=135,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=135,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=135,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=135,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=135,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=135,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=135,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=135,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=135,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=135,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=135,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=135,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=135,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=135,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(135,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=135,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=135,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=135,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=135,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=135,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=135,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=135,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=135,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=135,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=135,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=135,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=135,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=135,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=135,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(135,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=135,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=137,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=137,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=137,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=137,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=137,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=137,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=137,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=137,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=137,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=137,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=137,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=137,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=137,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(137,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=137,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=137,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=137,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=137,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=137,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=137,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=137,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=137,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=137,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=137,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=137,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=137,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=137,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=137,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(137,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=137,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=137,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=137,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=137,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=137,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=137,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=137,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=137,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=137,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=137,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=137,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=137,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=137,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=137,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(137,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=137,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=138,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=138,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=138,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=138,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=138,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=138,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=138,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=138,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=138,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=138,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=138,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=138,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=138,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(138,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=138,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=138,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=138,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=138,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=138,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=138,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=138,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=138,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=138,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=138,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=138,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=138,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=138,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=138,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(138,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=138,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=138,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=138,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=138,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=138,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=138,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=138,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=138,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=138,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=138,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=138,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=138,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=138,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=138,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(138,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=138,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=139,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=139,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=139,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=139,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=139,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=139,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=139,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=139,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=139,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=139,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=139,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=139,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=139,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(139,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=139,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=139,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=139,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=139,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=139,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=139,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=139,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=139,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=139,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=139,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=139,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=139,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=139,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=139,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(139,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=139,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=139,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=139,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=139,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=139,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=139,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=139,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=139,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=139,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=139,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=139,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=139,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=139,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=139,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(139,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=139,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=140,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=140,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=140,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=140,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=140,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=140,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=140,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=140,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=140,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=140,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=140,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=140,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=140,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(140,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=140,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=140,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=140,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=140,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=140,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=140,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=140,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=140,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=140,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=140,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=140,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=140,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=140,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=140,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(140,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=140,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=140,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=140,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=140,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=140,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=140,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=140,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=140,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=140,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=140,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=140,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=140,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=140,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=140,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(140,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=140,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=141,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=141,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=141,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=141,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=141,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=141,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=141,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=141,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=141,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=141,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=141,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=141,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=141,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(141,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=141,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=141,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=141,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=141,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=141,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=141,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=141,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=141,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=141,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=141,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=141,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=141,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=141,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=141,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(141,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=141,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=141,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=141,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=141,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=141,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=141,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=141,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=141,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=141,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=141,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=141,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=141,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=141,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=141,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(141,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=141,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=142,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=142,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=142,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=142,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=142,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=142,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=142,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=142,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=142,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=142,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=142,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=142,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=142,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(142,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=142,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=142,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=142,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=142,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=142,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=142,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=142,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=142,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=142,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=142,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=142,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=142,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=142,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=142,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(142,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=142,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=142,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=142,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=142,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=142,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=142,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=142,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=142,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=142,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=142,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=142,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=142,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=142,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=142,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(142,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=142,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=143,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=143,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=143,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=143,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=143,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=143,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=143,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=143,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=143,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=143,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=143,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=143,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=143,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(143,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=143,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=143,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=143,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=143,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=143,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=143,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=143,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=143,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=143,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=143,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=143,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=143,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=143,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=143,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(143,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=143,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=143,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=143,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=143,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=143,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=143,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=143,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=143,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=143,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=143,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=143,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=143,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=143,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=143,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(143,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=143,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=161,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=161,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=161,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=161,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=161,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=161,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=161,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=161,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=161,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=161,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=161,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=161,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=161,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(161,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=161,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=161,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=161,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=161,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=161,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=161,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=161,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=161,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=161,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=161,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=161,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=161,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=161,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=161,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(161,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=161,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=161,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=161,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=161,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=161,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=161,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=161,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=161,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=161,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=161,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=161,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=161,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=161,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=161,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(161,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=161,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=162,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=162,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=162,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=162,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=162,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=162,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=162,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=162,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=162,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=162,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=162,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=162,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=162,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(162,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=162,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=162,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=162,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=162,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=162,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=162,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=162,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=162,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=162,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=162,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=162,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=162,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=162,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=162,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(162,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=162,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=162,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=162,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=162,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=162,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=162,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=162,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=162,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=162,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=162,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=162,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=162,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=162,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=162,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(162,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=162,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=163,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=163,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=163,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=163,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=163,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=163,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=163,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=163,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=163,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=163,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=163,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=163,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=163,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(163,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=163,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=163,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=163,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=163,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=163,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=163,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=163,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=163,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=163,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=163,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=163,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=163,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=163,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=163,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(163,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=163,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=163,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=163,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=163,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=163,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=163,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=163,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=163,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=163,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=163,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=163,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=163,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=163,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=163,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(163,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=163,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=165,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=165,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=165,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=165,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=165,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=165,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=165,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=165,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=165,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=165,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=165,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=165,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=165,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(165,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=165,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=165,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=165,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=165,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=165,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=165,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=165,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=165,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=165,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=165,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=165,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=165,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=165,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=165,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(165,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=165,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=165,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=165,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=165,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=165,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=165,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=165,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=165,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=165,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=165,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=165,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=165,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=165,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=165,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(165,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=165,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=166,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=166,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=166,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=166,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=166,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=166,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=166,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=166,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=166,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=166,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=166,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=166,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=166,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(166,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=166,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=166,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=166,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=166,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=166,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=166,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=166,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=166,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=166,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=166,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=166,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=166,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=166,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=166,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(166,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=166,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=166,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=166,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=166,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=166,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=166,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=166,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=166,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=166,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=166,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=166,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=166,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=166,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=166,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(166,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=166,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=167,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=167,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=167,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=167,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=167,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=167,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=167,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=167,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=167,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=167,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=167,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=167,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=167,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(167,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=167,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=167,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=167,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=167,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=167,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=167,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=167,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=167,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=167,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=167,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=167,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=167,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=167,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=167,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(167,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=167,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=167,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=167,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=167,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=167,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=167,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=167,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=167,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=167,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=167,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=167,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=167,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=167,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=167,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(167,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=167,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=170,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=170,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=170,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=170,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=170,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=170,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=170,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=170,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=170,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=170,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=170,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=170,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=170,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(170,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=170,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=170,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=170,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=170,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=170,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=170,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=170,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=170,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=170,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=170,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=170,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=170,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=170,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=170,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(170,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=170,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=170,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=170,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=170,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=170,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=170,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=170,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=170,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=170,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=170,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=170,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=170,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=170,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=170,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(170,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=170,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=171,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=171,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=171,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=171,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=171,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=171,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=171,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=171,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=171,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=171,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=171,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=171,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=171,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(171,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=171,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=171,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=171,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=171,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=171,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=171,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=171,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=171,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=171,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=171,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=171,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=171,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=171,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=171,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(171,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=171,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=171,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=171,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=171,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=171,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=171,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=171,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=171,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=171,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=171,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=171,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=171,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=171,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=171,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(171,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=171,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=172,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=172,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=172,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=172,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=172,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=172,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=172,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=172,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=172,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=172,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=172,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=172,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=172,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(172,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=172,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=172,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=172,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=172,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=172,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=172,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=172,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=172,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=172,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=172,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=172,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=172,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=172,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=172,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(172,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=172,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=172,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=172,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=172,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=172,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=172,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=172,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=172,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=172,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=172,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=172,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=172,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=172,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=172,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(172,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=172,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=173,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=173,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=173,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=173,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=173,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=173,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=173,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=173,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=173,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=173,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=173,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=173,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=173,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(173,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=173,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=173,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=173,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=173,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=173,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=173,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=173,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=173,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=173,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=173,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=173,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=173,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=173,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=173,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(173,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=173,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=173,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=173,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=173,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=173,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=173,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=173,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=173,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=173,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=173,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=173,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=173,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=173,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=173,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(173,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=173,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=174,stage=1,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=174,stage=1,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=174,stage=1,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=174,stage=1,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=174,stage=1,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=174,stage=1,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=174,stage=1,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=174,stage=1,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=174,stage=1,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=174,stage=1,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=174,stage=1,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=174,stage=1,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=174,stage=1,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(174,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=174,stage=1,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=174,stage=2,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=174,stage=2,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=174,stage=2,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=174,stage=2,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=174,stage=2,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=174,stage=2,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=174,stage=2,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=174,stage=2,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=174,stage=2,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=174,stage=2,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=174,stage=2,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=174,stage=2,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=174,stage=2,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(174,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=174,stage=2,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=174,stage=3,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=174,stage=3,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=174,stage=3,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=174,stage=3,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=174,stage=3,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=174,stage=3,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=174,stage=3,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=174,stage=3,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=174,stage=3,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=174,stage=3,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=174,stage=3,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=174,stage=3,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=174,stage=3,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(174,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=174,stage=3,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=175,stage=1,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=175,stage=1,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=175,stage=1,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=175,stage=1,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=175,stage=1,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=175,stage=1,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=175,stage=1,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=175,stage=1,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=175,stage=1,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=175,stage=1,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=175,stage=1,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=175,stage=1,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=175,stage=1,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(175,1,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=175,stage=1,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=175,stage=2,min_rank=1,max_rank=1,award=[{100,230202,70},{100,230202,1},{100,230202,120},{100,230202,120}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=175,stage=2,min_rank=2,max_rank=2,award=[{100,230202,60},{100,230102,90},{100,230102,105}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=175,stage=2,min_rank=3,max_rank=3,award=[{100,230202,50},{100,230102,70},{100,230102,90}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=175,stage=2,min_rank=4,max_rank=4,award=[{100,230202,45},{100,230102,55},{100,230102,83}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=175,stage=2,min_rank=5,max_rank=5,award=[{100,230202,40},{100,230102,50},{100,230102,75}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=175,stage=2,min_rank=6,max_rank=6,award=[{100,230202,36},{100,230102,45},{100,230102,68}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=175,stage=2,min_rank=7,max_rank=7,award=[{100,230202,32},{100,230102,40},{100,230102,60}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=175,stage=2,min_rank=8,max_rank=8,award=[{100,230202,28},{100,230102,35},{100,230102,53}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=175,stage=2,min_rank=9,max_rank=9,award=[{100,230202,24},{100,230102,30},{100,230102,45}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=175,stage=2,min_rank=10,max_rank=10,award=[{100,230202,20},{100,230102,25},{100,230102,38}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=175,stage=2,min_rank=11,max_rank=20,award=[{100,230202,15},{100,230102,20},{100,230102,30}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=175,stage=2,min_rank=21,max_rank=30,award=[{100,230202,10},{100,230102,15},{100,230102,22}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=175,stage=2,min_rank=31,max_rank=40,award=[{100,230202,6},{100,230102,10},{100,230102,15}]};
get_race_rank_award(175,2,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=175,stage=2,min_rank=41,max_rank=50,award=[{100,230202,3},{100,230102,5},{100,230102,8}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 1, _Rank =< 1 ->
	#race_rank_award{act_id=175,stage=3,min_rank=1,max_rank=1,award=[{100,230201,1},{100,230201,2},{100,230201,5},{100,230201,100}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 2, _Rank =< 2 ->
	#race_rank_award{act_id=175,stage=3,min_rank=2,max_rank=2,award=[{100,230201,45},{100,230201,70},{100,230201,70}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 3, _Rank =< 3 ->
	#race_rank_award{act_id=175,stage=3,min_rank=3,max_rank=3,award=[{100,230201,40},{100,230101,60},{100,230001,60}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 4, _Rank =< 4 ->
	#race_rank_award{act_id=175,stage=3,min_rank=4,max_rank=4,award=[{100,230201,35},{100,230101,55},{100,230001,55}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 5, _Rank =< 5 ->
	#race_rank_award{act_id=175,stage=3,min_rank=5,max_rank=5,award=[{100,230201,30},{100,230101,50},{100,230001,50}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 6, _Rank =< 6 ->
	#race_rank_award{act_id=175,stage=3,min_rank=6,max_rank=6,award=[{100,230201,27},{100,230101,45},{100,230001,45}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 7, _Rank =< 7 ->
	#race_rank_award{act_id=175,stage=3,min_rank=7,max_rank=7,award=[{100,230201,24},{100,230101,40},{100,230001,40}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 8, _Rank =< 8 ->
	#race_rank_award{act_id=175,stage=3,min_rank=8,max_rank=8,award=[{100,230201,21},{100,230101,35},{100,230001,35}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 9, _Rank =< 9 ->
	#race_rank_award{act_id=175,stage=3,min_rank=9,max_rank=9,award=[{100,230201,18},{100,230101,30},{100,230001,30}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 10, _Rank =< 10 ->
	#race_rank_award{act_id=175,stage=3,min_rank=10,max_rank=10,award=[{100,230201,15},{100,230101,25},{100,230001,25}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 11, _Rank =< 20 ->
	#race_rank_award{act_id=175,stage=3,min_rank=11,max_rank=20,award=[{100,230201,10},{100,230101,20},{100,230001,20}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 21, _Rank =< 30 ->
	#race_rank_award{act_id=175,stage=3,min_rank=21,max_rank=30,award=[{100,230201,7},{100,230101,15},{100,230001,15}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 31, _Rank =< 40 ->
	#race_rank_award{act_id=175,stage=3,min_rank=31,max_rank=40,award=[{100,230201,4},{100,230101,10},{100,230001,10}]};
get_race_rank_award(175,3,_Rank) when _Rank >= 41, _Rank =< 50 ->
	#race_rank_award{act_id=175,stage=3,min_rank=41,max_rank=50,award=[{100,230201,2},{100,230101,5},{100,230001,5}]};
get_race_rank_award(_Act_id,_Stage,_Rank) ->
    false.

get_race_rank_times_award(101,1,1) ->
    #race_rank_times_award{act_id = 101,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(101,1,2) ->
    #race_rank_times_award{act_id = 101,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(101,1,3) ->
    #race_rank_times_award{act_id = 101,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(101,1,4) ->
    #race_rank_times_award{act_id = 101,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(101,1,5) ->
    #race_rank_times_award{act_id = 101,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(101,1,6) ->
    #race_rank_times_award{act_id = 101,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(101,2,1) ->
    #race_rank_times_award{act_id = 101,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(101,2,2) ->
    #race_rank_times_award{act_id = 101,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(101,2,3) ->
    #race_rank_times_award{act_id = 101,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(101,2,4) ->
    #race_rank_times_award{act_id = 101,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(101,2,5) ->
    #race_rank_times_award{act_id = 101,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(101,2,6) ->
    #race_rank_times_award{act_id = 101,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(101,3,1) ->
    #race_rank_times_award{act_id = 101,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(101,3,2) ->
    #race_rank_times_award{act_id = 101,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(101,3,3) ->
    #race_rank_times_award{act_id = 101,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(101,3,4) ->
    #race_rank_times_award{act_id = 101,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(101,3,5) ->
    #race_rank_times_award{act_id = 101,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(101,3,6) ->
    #race_rank_times_award{act_id = 101,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(102,1,1) ->
    #race_rank_times_award{act_id = 102,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(102,1,2) ->
    #race_rank_times_award{act_id = 102,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(102,1,3) ->
    #race_rank_times_award{act_id = 102,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(102,1,4) ->
    #race_rank_times_award{act_id = 102,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(102,1,5) ->
    #race_rank_times_award{act_id = 102,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(102,1,6) ->
    #race_rank_times_award{act_id = 102,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(102,2,1) ->
    #race_rank_times_award{act_id = 102,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(102,2,2) ->
    #race_rank_times_award{act_id = 102,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(102,2,3) ->
    #race_rank_times_award{act_id = 102,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(102,2,4) ->
    #race_rank_times_award{act_id = 102,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(102,2,5) ->
    #race_rank_times_award{act_id = 102,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(102,2,6) ->
    #race_rank_times_award{act_id = 102,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(102,3,1) ->
    #race_rank_times_award{act_id = 102,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(102,3,2) ->
    #race_rank_times_award{act_id = 102,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(102,3,3) ->
    #race_rank_times_award{act_id = 102,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(102,3,4) ->
    #race_rank_times_award{act_id = 102,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(102,3,5) ->
    #race_rank_times_award{act_id = 102,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(102,3,6) ->
    #race_rank_times_award{act_id = 102,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(103,1,1) ->
    #race_rank_times_award{act_id = 103,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(103,1,2) ->
    #race_rank_times_award{act_id = 103,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(103,1,3) ->
    #race_rank_times_award{act_id = 103,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(103,1,4) ->
    #race_rank_times_award{act_id = 103,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(103,1,5) ->
    #race_rank_times_award{act_id = 103,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(103,1,6) ->
    #race_rank_times_award{act_id = 103,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(103,2,1) ->
    #race_rank_times_award{act_id = 103,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(103,2,2) ->
    #race_rank_times_award{act_id = 103,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(103,2,3) ->
    #race_rank_times_award{act_id = 103,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(103,2,4) ->
    #race_rank_times_award{act_id = 103,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(103,2,5) ->
    #race_rank_times_award{act_id = 103,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(103,2,6) ->
    #race_rank_times_award{act_id = 103,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(103,3,1) ->
    #race_rank_times_award{act_id = 103,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(103,3,2) ->
    #race_rank_times_award{act_id = 103,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(103,3,3) ->
    #race_rank_times_award{act_id = 103,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(103,3,4) ->
    #race_rank_times_award{act_id = 103,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(103,3,5) ->
    #race_rank_times_award{act_id = 103,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(103,3,6) ->
    #race_rank_times_award{act_id = 103,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(104,1,1) ->
    #race_rank_times_award{act_id = 104,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(104,1,2) ->
    #race_rank_times_award{act_id = 104,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(104,1,3) ->
    #race_rank_times_award{act_id = 104,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(104,1,4) ->
    #race_rank_times_award{act_id = 104,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(104,1,5) ->
    #race_rank_times_award{act_id = 104,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(104,1,6) ->
    #race_rank_times_award{act_id = 104,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(104,2,1) ->
    #race_rank_times_award{act_id = 104,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(104,2,2) ->
    #race_rank_times_award{act_id = 104,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(104,2,3) ->
    #race_rank_times_award{act_id = 104,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(104,2,4) ->
    #race_rank_times_award{act_id = 104,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(104,2,5) ->
    #race_rank_times_award{act_id = 104,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(104,2,6) ->
    #race_rank_times_award{act_id = 104,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(104,3,1) ->
    #race_rank_times_award{act_id = 104,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(104,3,2) ->
    #race_rank_times_award{act_id = 104,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(104,3,3) ->
    #race_rank_times_award{act_id = 104,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(104,3,4) ->
    #race_rank_times_award{act_id = 104,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(104,3,5) ->
    #race_rank_times_award{act_id = 104,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(104,3,6) ->
    #race_rank_times_award{act_id = 104,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(105,1,1) ->
    #race_rank_times_award{act_id = 105,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(105,1,2) ->
    #race_rank_times_award{act_id = 105,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(105,1,3) ->
    #race_rank_times_award{act_id = 105,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(105,1,4) ->
    #race_rank_times_award{act_id = 105,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(105,1,5) ->
    #race_rank_times_award{act_id = 105,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(105,1,6) ->
    #race_rank_times_award{act_id = 105,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(105,2,1) ->
    #race_rank_times_award{act_id = 105,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(105,2,2) ->
    #race_rank_times_award{act_id = 105,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(105,2,3) ->
    #race_rank_times_award{act_id = 105,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(105,2,4) ->
    #race_rank_times_award{act_id = 105,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(105,2,5) ->
    #race_rank_times_award{act_id = 105,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(105,2,6) ->
    #race_rank_times_award{act_id = 105,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(105,3,1) ->
    #race_rank_times_award{act_id = 105,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(105,3,2) ->
    #race_rank_times_award{act_id = 105,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(105,3,3) ->
    #race_rank_times_award{act_id = 105,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(105,3,4) ->
    #race_rank_times_award{act_id = 105,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(105,3,5) ->
    #race_rank_times_award{act_id = 105,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(105,3,6) ->
    #race_rank_times_award{act_id = 105,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(106,1,1) ->
    #race_rank_times_award{act_id = 106,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(106,1,2) ->
    #race_rank_times_award{act_id = 106,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(106,1,3) ->
    #race_rank_times_award{act_id = 106,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(106,1,4) ->
    #race_rank_times_award{act_id = 106,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(106,1,5) ->
    #race_rank_times_award{act_id = 106,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(106,1,6) ->
    #race_rank_times_award{act_id = 106,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(106,2,1) ->
    #race_rank_times_award{act_id = 106,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(106,2,2) ->
    #race_rank_times_award{act_id = 106,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(106,2,3) ->
    #race_rank_times_award{act_id = 106,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(106,2,4) ->
    #race_rank_times_award{act_id = 106,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(106,2,5) ->
    #race_rank_times_award{act_id = 106,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(106,2,6) ->
    #race_rank_times_award{act_id = 106,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(106,3,1) ->
    #race_rank_times_award{act_id = 106,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(106,3,2) ->
    #race_rank_times_award{act_id = 106,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(106,3,3) ->
    #race_rank_times_award{act_id = 106,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(106,3,4) ->
    #race_rank_times_award{act_id = 106,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(106,3,5) ->
    #race_rank_times_award{act_id = 106,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(106,3,6) ->
    #race_rank_times_award{act_id = 106,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(107,1,1) ->
    #race_rank_times_award{act_id = 107,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(107,1,2) ->
    #race_rank_times_award{act_id = 107,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(107,1,3) ->
    #race_rank_times_award{act_id = 107,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(107,1,4) ->
    #race_rank_times_award{act_id = 107,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(107,1,5) ->
    #race_rank_times_award{act_id = 107,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(107,1,6) ->
    #race_rank_times_award{act_id = 107,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(107,2,1) ->
    #race_rank_times_award{act_id = 107,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(107,2,2) ->
    #race_rank_times_award{act_id = 107,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(107,2,3) ->
    #race_rank_times_award{act_id = 107,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(107,2,4) ->
    #race_rank_times_award{act_id = 107,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(107,2,5) ->
    #race_rank_times_award{act_id = 107,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(107,2,6) ->
    #race_rank_times_award{act_id = 107,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(107,3,1) ->
    #race_rank_times_award{act_id = 107,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(107,3,2) ->
    #race_rank_times_award{act_id = 107,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(107,3,3) ->
    #race_rank_times_award{act_id = 107,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(107,3,4) ->
    #race_rank_times_award{act_id = 107,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(107,3,5) ->
    #race_rank_times_award{act_id = 107,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(107,3,6) ->
    #race_rank_times_award{act_id = 107,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(108,1,1) ->
    #race_rank_times_award{act_id = 108,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(108,1,2) ->
    #race_rank_times_award{act_id = 108,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(108,1,3) ->
    #race_rank_times_award{act_id = 108,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(108,1,4) ->
    #race_rank_times_award{act_id = 108,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(108,1,5) ->
    #race_rank_times_award{act_id = 108,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(108,1,6) ->
    #race_rank_times_award{act_id = 108,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(108,2,1) ->
    #race_rank_times_award{act_id = 108,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(108,2,2) ->
    #race_rank_times_award{act_id = 108,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(108,2,3) ->
    #race_rank_times_award{act_id = 108,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(108,2,4) ->
    #race_rank_times_award{act_id = 108,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(108,2,5) ->
    #race_rank_times_award{act_id = 108,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(108,2,6) ->
    #race_rank_times_award{act_id = 108,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(108,3,1) ->
    #race_rank_times_award{act_id = 108,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(108,3,2) ->
    #race_rank_times_award{act_id = 108,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(108,3,3) ->
    #race_rank_times_award{act_id = 108,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(108,3,4) ->
    #race_rank_times_award{act_id = 108,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(108,3,5) ->
    #race_rank_times_award{act_id = 108,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(108,3,6) ->
    #race_rank_times_award{act_id = 108,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(109,1,1) ->
    #race_rank_times_award{act_id = 109,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(109,1,2) ->
    #race_rank_times_award{act_id = 109,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(109,1,3) ->
    #race_rank_times_award{act_id = 109,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(109,1,4) ->
    #race_rank_times_award{act_id = 109,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(109,1,5) ->
    #race_rank_times_award{act_id = 109,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(109,1,6) ->
    #race_rank_times_award{act_id = 109,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(109,2,1) ->
    #race_rank_times_award{act_id = 109,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(109,2,2) ->
    #race_rank_times_award{act_id = 109,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(109,2,3) ->
    #race_rank_times_award{act_id = 109,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(109,2,4) ->
    #race_rank_times_award{act_id = 109,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(109,2,5) ->
    #race_rank_times_award{act_id = 109,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(109,2,6) ->
    #race_rank_times_award{act_id = 109,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(109,3,1) ->
    #race_rank_times_award{act_id = 109,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(109,3,2) ->
    #race_rank_times_award{act_id = 109,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(109,3,3) ->
    #race_rank_times_award{act_id = 109,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(109,3,4) ->
    #race_rank_times_award{act_id = 109,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(109,3,5) ->
    #race_rank_times_award{act_id = 109,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(109,3,6) ->
    #race_rank_times_award{act_id = 109,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(133,1,1) ->
    #race_rank_times_award{act_id = 133,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(133,1,2) ->
    #race_rank_times_award{act_id = 133,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(133,1,3) ->
    #race_rank_times_award{act_id = 133,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(133,1,4) ->
    #race_rank_times_award{act_id = 133,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(133,1,5) ->
    #race_rank_times_award{act_id = 133,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(133,1,6) ->
    #race_rank_times_award{act_id = 133,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(133,2,1) ->
    #race_rank_times_award{act_id = 133,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(133,2,2) ->
    #race_rank_times_award{act_id = 133,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(133,2,3) ->
    #race_rank_times_award{act_id = 133,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(133,2,4) ->
    #race_rank_times_award{act_id = 133,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(133,2,5) ->
    #race_rank_times_award{act_id = 133,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(133,2,6) ->
    #race_rank_times_award{act_id = 133,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(133,3,1) ->
    #race_rank_times_award{act_id = 133,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(133,3,2) ->
    #race_rank_times_award{act_id = 133,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(133,3,3) ->
    #race_rank_times_award{act_id = 133,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(133,3,4) ->
    #race_rank_times_award{act_id = 133,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(133,3,5) ->
    #race_rank_times_award{act_id = 133,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(133,3,6) ->
    #race_rank_times_award{act_id = 133,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(134,1,1) ->
    #race_rank_times_award{act_id = 134,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(134,1,2) ->
    #race_rank_times_award{act_id = 134,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(134,1,3) ->
    #race_rank_times_award{act_id = 134,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(134,1,4) ->
    #race_rank_times_award{act_id = 134,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(134,1,5) ->
    #race_rank_times_award{act_id = 134,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(134,1,6) ->
    #race_rank_times_award{act_id = 134,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(134,2,1) ->
    #race_rank_times_award{act_id = 134,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(134,2,2) ->
    #race_rank_times_award{act_id = 134,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(134,2,3) ->
    #race_rank_times_award{act_id = 134,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(134,2,4) ->
    #race_rank_times_award{act_id = 134,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(134,2,5) ->
    #race_rank_times_award{act_id = 134,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(134,2,6) ->
    #race_rank_times_award{act_id = 134,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(134,3,1) ->
    #race_rank_times_award{act_id = 134,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(134,3,2) ->
    #race_rank_times_award{act_id = 134,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(134,3,3) ->
    #race_rank_times_award{act_id = 134,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(134,3,4) ->
    #race_rank_times_award{act_id = 134,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(134,3,5) ->
    #race_rank_times_award{act_id = 134,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(134,3,6) ->
    #race_rank_times_award{act_id = 134,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(135,1,1) ->
    #race_rank_times_award{act_id = 135,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(135,1,2) ->
    #race_rank_times_award{act_id = 135,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(135,1,3) ->
    #race_rank_times_award{act_id = 135,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(135,1,4) ->
    #race_rank_times_award{act_id = 135,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(135,1,5) ->
    #race_rank_times_award{act_id = 135,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(135,1,6) ->
    #race_rank_times_award{act_id = 135,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(135,2,1) ->
    #race_rank_times_award{act_id = 135,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(135,2,2) ->
    #race_rank_times_award{act_id = 135,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(135,2,3) ->
    #race_rank_times_award{act_id = 135,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(135,2,4) ->
    #race_rank_times_award{act_id = 135,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(135,2,5) ->
    #race_rank_times_award{act_id = 135,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(135,2,6) ->
    #race_rank_times_award{act_id = 135,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(135,3,1) ->
    #race_rank_times_award{act_id = 135,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(135,3,2) ->
    #race_rank_times_award{act_id = 135,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(135,3,3) ->
    #race_rank_times_award{act_id = 135,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(135,3,4) ->
    #race_rank_times_award{act_id = 135,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(135,3,5) ->
    #race_rank_times_award{act_id = 135,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(135,3,6) ->
    #race_rank_times_award{act_id = 135,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(137,1,1) ->
    #race_rank_times_award{act_id = 137,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(137,1,2) ->
    #race_rank_times_award{act_id = 137,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(137,1,3) ->
    #race_rank_times_award{act_id = 137,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(137,1,4) ->
    #race_rank_times_award{act_id = 137,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(137,1,5) ->
    #race_rank_times_award{act_id = 137,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(137,1,6) ->
    #race_rank_times_award{act_id = 137,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(137,2,1) ->
    #race_rank_times_award{act_id = 137,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(137,2,2) ->
    #race_rank_times_award{act_id = 137,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(137,2,3) ->
    #race_rank_times_award{act_id = 137,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(137,2,4) ->
    #race_rank_times_award{act_id = 137,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(137,2,5) ->
    #race_rank_times_award{act_id = 137,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(137,2,6) ->
    #race_rank_times_award{act_id = 137,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(137,3,1) ->
    #race_rank_times_award{act_id = 137,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(137,3,2) ->
    #race_rank_times_award{act_id = 137,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(137,3,3) ->
    #race_rank_times_award{act_id = 137,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(137,3,4) ->
    #race_rank_times_award{act_id = 137,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(137,3,5) ->
    #race_rank_times_award{act_id = 137,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(137,3,6) ->
    #race_rank_times_award{act_id = 137,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(138,1,1) ->
    #race_rank_times_award{act_id = 138,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(138,1,2) ->
    #race_rank_times_award{act_id = 138,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(138,1,3) ->
    #race_rank_times_award{act_id = 138,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(138,1,4) ->
    #race_rank_times_award{act_id = 138,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(138,1,5) ->
    #race_rank_times_award{act_id = 138,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(138,1,6) ->
    #race_rank_times_award{act_id = 138,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(138,2,1) ->
    #race_rank_times_award{act_id = 138,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(138,2,2) ->
    #race_rank_times_award{act_id = 138,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(138,2,3) ->
    #race_rank_times_award{act_id = 138,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(138,2,4) ->
    #race_rank_times_award{act_id = 138,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(138,2,5) ->
    #race_rank_times_award{act_id = 138,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(138,2,6) ->
    #race_rank_times_award{act_id = 138,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(138,3,1) ->
    #race_rank_times_award{act_id = 138,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(138,3,2) ->
    #race_rank_times_award{act_id = 138,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(138,3,3) ->
    #race_rank_times_award{act_id = 138,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(138,3,4) ->
    #race_rank_times_award{act_id = 138,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(138,3,5) ->
    #race_rank_times_award{act_id = 138,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(138,3,6) ->
    #race_rank_times_award{act_id = 138,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(139,1,1) ->
    #race_rank_times_award{act_id = 139,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(139,1,2) ->
    #race_rank_times_award{act_id = 139,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(139,1,3) ->
    #race_rank_times_award{act_id = 139,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(139,1,4) ->
    #race_rank_times_award{act_id = 139,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(139,1,5) ->
    #race_rank_times_award{act_id = 139,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(139,1,6) ->
    #race_rank_times_award{act_id = 139,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(139,2,1) ->
    #race_rank_times_award{act_id = 139,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(139,2,2) ->
    #race_rank_times_award{act_id = 139,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(139,2,3) ->
    #race_rank_times_award{act_id = 139,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(139,2,4) ->
    #race_rank_times_award{act_id = 139,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(139,2,5) ->
    #race_rank_times_award{act_id = 139,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(139,2,6) ->
    #race_rank_times_award{act_id = 139,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(139,3,1) ->
    #race_rank_times_award{act_id = 139,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(139,3,2) ->
    #race_rank_times_award{act_id = 139,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(139,3,3) ->
    #race_rank_times_award{act_id = 139,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(139,3,4) ->
    #race_rank_times_award{act_id = 139,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(139,3,5) ->
    #race_rank_times_award{act_id = 139,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(139,3,6) ->
    #race_rank_times_award{act_id = 139,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(140,1,1) ->
    #race_rank_times_award{act_id = 140,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(140,1,2) ->
    #race_rank_times_award{act_id = 140,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(140,1,3) ->
    #race_rank_times_award{act_id = 140,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(140,1,4) ->
    #race_rank_times_award{act_id = 140,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(140,1,5) ->
    #race_rank_times_award{act_id = 140,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(140,1,6) ->
    #race_rank_times_award{act_id = 140,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(140,2,1) ->
    #race_rank_times_award{act_id = 140,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(140,2,2) ->
    #race_rank_times_award{act_id = 140,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(140,2,3) ->
    #race_rank_times_award{act_id = 140,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(140,2,4) ->
    #race_rank_times_award{act_id = 140,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(140,2,5) ->
    #race_rank_times_award{act_id = 140,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(140,2,6) ->
    #race_rank_times_award{act_id = 140,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(140,3,1) ->
    #race_rank_times_award{act_id = 140,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(140,3,2) ->
    #race_rank_times_award{act_id = 140,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(140,3,3) ->
    #race_rank_times_award{act_id = 140,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(140,3,4) ->
    #race_rank_times_award{act_id = 140,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(140,3,5) ->
    #race_rank_times_award{act_id = 140,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(140,3,6) ->
    #race_rank_times_award{act_id = 140,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(141,1,1) ->
    #race_rank_times_award{act_id = 141,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(141,1,2) ->
    #race_rank_times_award{act_id = 141,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(141,1,3) ->
    #race_rank_times_award{act_id = 141,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(141,1,4) ->
    #race_rank_times_award{act_id = 141,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(141,1,5) ->
    #race_rank_times_award{act_id = 141,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(141,1,6) ->
    #race_rank_times_award{act_id = 141,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(141,2,1) ->
    #race_rank_times_award{act_id = 141,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(141,2,2) ->
    #race_rank_times_award{act_id = 141,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(141,2,3) ->
    #race_rank_times_award{act_id = 141,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(141,2,4) ->
    #race_rank_times_award{act_id = 141,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(141,2,5) ->
    #race_rank_times_award{act_id = 141,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(141,2,6) ->
    #race_rank_times_award{act_id = 141,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(141,3,1) ->
    #race_rank_times_award{act_id = 141,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(141,3,2) ->
    #race_rank_times_award{act_id = 141,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(141,3,3) ->
    #race_rank_times_award{act_id = 141,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(141,3,4) ->
    #race_rank_times_award{act_id = 141,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(141,3,5) ->
    #race_rank_times_award{act_id = 141,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(141,3,6) ->
    #race_rank_times_award{act_id = 141,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(142,1,1) ->
    #race_rank_times_award{act_id = 142,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(142,1,2) ->
    #race_rank_times_award{act_id = 142,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(142,1,3) ->
    #race_rank_times_award{act_id = 142,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(142,1,4) ->
    #race_rank_times_award{act_id = 142,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(142,1,5) ->
    #race_rank_times_award{act_id = 142,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(142,1,6) ->
    #race_rank_times_award{act_id = 142,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(142,2,1) ->
    #race_rank_times_award{act_id = 142,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(142,2,2) ->
    #race_rank_times_award{act_id = 142,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(142,2,3) ->
    #race_rank_times_award{act_id = 142,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(142,2,4) ->
    #race_rank_times_award{act_id = 142,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(142,2,5) ->
    #race_rank_times_award{act_id = 142,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(142,2,6) ->
    #race_rank_times_award{act_id = 142,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(142,3,1) ->
    #race_rank_times_award{act_id = 142,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(142,3,2) ->
    #race_rank_times_award{act_id = 142,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(142,3,3) ->
    #race_rank_times_award{act_id = 142,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(142,3,4) ->
    #race_rank_times_award{act_id = 142,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(142,3,5) ->
    #race_rank_times_award{act_id = 142,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(142,3,6) ->
    #race_rank_times_award{act_id = 142,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(143,1,1) ->
    #race_rank_times_award{act_id = 143,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(143,1,2) ->
    #race_rank_times_award{act_id = 143,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(143,1,3) ->
    #race_rank_times_award{act_id = 143,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(143,1,4) ->
    #race_rank_times_award{act_id = 143,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(143,1,5) ->
    #race_rank_times_award{act_id = 143,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(143,1,6) ->
    #race_rank_times_award{act_id = 143,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(143,2,1) ->
    #race_rank_times_award{act_id = 143,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(143,2,2) ->
    #race_rank_times_award{act_id = 143,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(143,2,3) ->
    #race_rank_times_award{act_id = 143,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(143,2,4) ->
    #race_rank_times_award{act_id = 143,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(143,2,5) ->
    #race_rank_times_award{act_id = 143,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(143,2,6) ->
    #race_rank_times_award{act_id = 143,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(143,3,1) ->
    #race_rank_times_award{act_id = 143,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(143,3,2) ->
    #race_rank_times_award{act_id = 143,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(143,3,3) ->
    #race_rank_times_award{act_id = 143,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(143,3,4) ->
    #race_rank_times_award{act_id = 143,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(143,3,5) ->
    #race_rank_times_award{act_id = 143,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(143,3,6) ->
    #race_rank_times_award{act_id = 143,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(161,1,1) ->
    #race_rank_times_award{act_id = 161,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(161,1,2) ->
    #race_rank_times_award{act_id = 161,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(161,1,3) ->
    #race_rank_times_award{act_id = 161,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(161,1,4) ->
    #race_rank_times_award{act_id = 161,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(161,1,5) ->
    #race_rank_times_award{act_id = 161,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(161,1,6) ->
    #race_rank_times_award{act_id = 161,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(161,2,1) ->
    #race_rank_times_award{act_id = 161,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(161,2,2) ->
    #race_rank_times_award{act_id = 161,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(161,2,3) ->
    #race_rank_times_award{act_id = 161,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(161,2,4) ->
    #race_rank_times_award{act_id = 161,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(161,2,5) ->
    #race_rank_times_award{act_id = 161,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(161,2,6) ->
    #race_rank_times_award{act_id = 161,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(161,3,1) ->
    #race_rank_times_award{act_id = 161,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(161,3,2) ->
    #race_rank_times_award{act_id = 161,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(161,3,3) ->
    #race_rank_times_award{act_id = 161,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(161,3,4) ->
    #race_rank_times_award{act_id = 161,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(161,3,5) ->
    #race_rank_times_award{act_id = 161,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(161,3,6) ->
    #race_rank_times_award{act_id = 161,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(162,1,1) ->
    #race_rank_times_award{act_id = 162,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(162,1,2) ->
    #race_rank_times_award{act_id = 162,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(162,1,3) ->
    #race_rank_times_award{act_id = 162,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(162,1,4) ->
    #race_rank_times_award{act_id = 162,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(162,1,5) ->
    #race_rank_times_award{act_id = 162,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(162,1,6) ->
    #race_rank_times_award{act_id = 162,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(162,2,1) ->
    #race_rank_times_award{act_id = 162,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(162,2,2) ->
    #race_rank_times_award{act_id = 162,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(162,2,3) ->
    #race_rank_times_award{act_id = 162,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(162,2,4) ->
    #race_rank_times_award{act_id = 162,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(162,2,5) ->
    #race_rank_times_award{act_id = 162,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(162,2,6) ->
    #race_rank_times_award{act_id = 162,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(162,3,1) ->
    #race_rank_times_award{act_id = 162,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(162,3,2) ->
    #race_rank_times_award{act_id = 162,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(162,3,3) ->
    #race_rank_times_award{act_id = 162,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(162,3,4) ->
    #race_rank_times_award{act_id = 162,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(162,3,5) ->
    #race_rank_times_award{act_id = 162,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(162,3,6) ->
    #race_rank_times_award{act_id = 162,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(163,1,1) ->
    #race_rank_times_award{act_id = 163,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(163,1,2) ->
    #race_rank_times_award{act_id = 163,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(163,1,3) ->
    #race_rank_times_award{act_id = 163,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(163,1,4) ->
    #race_rank_times_award{act_id = 163,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(163,1,5) ->
    #race_rank_times_award{act_id = 163,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(163,1,6) ->
    #race_rank_times_award{act_id = 163,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(163,2,1) ->
    #race_rank_times_award{act_id = 163,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(163,2,2) ->
    #race_rank_times_award{act_id = 163,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(163,2,3) ->
    #race_rank_times_award{act_id = 163,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(163,2,4) ->
    #race_rank_times_award{act_id = 163,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(163,2,5) ->
    #race_rank_times_award{act_id = 163,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(163,2,6) ->
    #race_rank_times_award{act_id = 163,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(163,3,1) ->
    #race_rank_times_award{act_id = 163,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(163,3,2) ->
    #race_rank_times_award{act_id = 163,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(163,3,3) ->
    #race_rank_times_award{act_id = 163,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(163,3,4) ->
    #race_rank_times_award{act_id = 163,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(163,3,5) ->
    #race_rank_times_award{act_id = 163,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(163,3,6) ->
    #race_rank_times_award{act_id = 163,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(165,1,1) ->
    #race_rank_times_award{act_id = 165,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(165,1,2) ->
    #race_rank_times_award{act_id = 165,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(165,1,3) ->
    #race_rank_times_award{act_id = 165,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(165,1,4) ->
    #race_rank_times_award{act_id = 165,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(165,1,5) ->
    #race_rank_times_award{act_id = 165,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(165,1,6) ->
    #race_rank_times_award{act_id = 165,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(165,2,1) ->
    #race_rank_times_award{act_id = 165,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(165,2,2) ->
    #race_rank_times_award{act_id = 165,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(165,2,3) ->
    #race_rank_times_award{act_id = 165,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(165,2,4) ->
    #race_rank_times_award{act_id = 165,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(165,2,5) ->
    #race_rank_times_award{act_id = 165,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(165,2,6) ->
    #race_rank_times_award{act_id = 165,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(165,3,1) ->
    #race_rank_times_award{act_id = 165,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(165,3,2) ->
    #race_rank_times_award{act_id = 165,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(165,3,3) ->
    #race_rank_times_award{act_id = 165,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(165,3,4) ->
    #race_rank_times_award{act_id = 165,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(165,3,5) ->
    #race_rank_times_award{act_id = 165,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(165,3,6) ->
    #race_rank_times_award{act_id = 165,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(166,1,1) ->
    #race_rank_times_award{act_id = 166,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(166,1,2) ->
    #race_rank_times_award{act_id = 166,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(166,1,3) ->
    #race_rank_times_award{act_id = 166,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(166,1,4) ->
    #race_rank_times_award{act_id = 166,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(166,1,5) ->
    #race_rank_times_award{act_id = 166,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(166,1,6) ->
    #race_rank_times_award{act_id = 166,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(166,2,1) ->
    #race_rank_times_award{act_id = 166,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(166,2,2) ->
    #race_rank_times_award{act_id = 166,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(166,2,3) ->
    #race_rank_times_award{act_id = 166,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(166,2,4) ->
    #race_rank_times_award{act_id = 166,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(166,2,5) ->
    #race_rank_times_award{act_id = 166,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(166,2,6) ->
    #race_rank_times_award{act_id = 166,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(166,3,1) ->
    #race_rank_times_award{act_id = 166,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(166,3,2) ->
    #race_rank_times_award{act_id = 166,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(166,3,3) ->
    #race_rank_times_award{act_id = 166,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(166,3,4) ->
    #race_rank_times_award{act_id = 166,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(166,3,5) ->
    #race_rank_times_award{act_id = 166,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(166,3,6) ->
    #race_rank_times_award{act_id = 166,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(167,1,1) ->
    #race_rank_times_award{act_id = 167,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(167,1,2) ->
    #race_rank_times_award{act_id = 167,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(167,1,3) ->
    #race_rank_times_award{act_id = 167,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(167,1,4) ->
    #race_rank_times_award{act_id = 167,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(167,1,5) ->
    #race_rank_times_award{act_id = 167,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(167,1,6) ->
    #race_rank_times_award{act_id = 167,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(167,2,1) ->
    #race_rank_times_award{act_id = 167,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(167,2,2) ->
    #race_rank_times_award{act_id = 167,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(167,2,3) ->
    #race_rank_times_award{act_id = 167,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(167,2,4) ->
    #race_rank_times_award{act_id = 167,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(167,2,5) ->
    #race_rank_times_award{act_id = 167,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(167,2,6) ->
    #race_rank_times_award{act_id = 167,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(167,3,1) ->
    #race_rank_times_award{act_id = 167,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(167,3,2) ->
    #race_rank_times_award{act_id = 167,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(167,3,3) ->
    #race_rank_times_award{act_id = 167,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(167,3,4) ->
    #race_rank_times_award{act_id = 167,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(167,3,5) ->
    #race_rank_times_award{act_id = 167,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(167,3,6) ->
    #race_rank_times_award{act_id = 167,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(170,1,1) ->
    #race_rank_times_award{act_id = 170,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(170,1,2) ->
    #race_rank_times_award{act_id = 170,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(170,1,3) ->
    #race_rank_times_award{act_id = 170,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(170,1,4) ->
    #race_rank_times_award{act_id = 170,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(170,1,5) ->
    #race_rank_times_award{act_id = 170,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(170,1,6) ->
    #race_rank_times_award{act_id = 170,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(170,2,1) ->
    #race_rank_times_award{act_id = 170,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(170,2,2) ->
    #race_rank_times_award{act_id = 170,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(170,2,3) ->
    #race_rank_times_award{act_id = 170,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(170,2,4) ->
    #race_rank_times_award{act_id = 170,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(170,2,5) ->
    #race_rank_times_award{act_id = 170,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(170,2,6) ->
    #race_rank_times_award{act_id = 170,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(170,3,1) ->
    #race_rank_times_award{act_id = 170,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(170,3,2) ->
    #race_rank_times_award{act_id = 170,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(170,3,3) ->
    #race_rank_times_award{act_id = 170,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(170,3,4) ->
    #race_rank_times_award{act_id = 170,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(170,3,5) ->
    #race_rank_times_award{act_id = 170,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(170,3,6) ->
    #race_rank_times_award{act_id = 170,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(171,1,1) ->
    #race_rank_times_award{act_id = 171,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(171,1,2) ->
    #race_rank_times_award{act_id = 171,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(171,1,3) ->
    #race_rank_times_award{act_id = 171,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(171,1,4) ->
    #race_rank_times_award{act_id = 171,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(171,1,5) ->
    #race_rank_times_award{act_id = 171,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(171,1,6) ->
    #race_rank_times_award{act_id = 171,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(171,2,1) ->
    #race_rank_times_award{act_id = 171,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(171,2,2) ->
    #race_rank_times_award{act_id = 171,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(171,2,3) ->
    #race_rank_times_award{act_id = 171,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(171,2,4) ->
    #race_rank_times_award{act_id = 171,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(171,2,5) ->
    #race_rank_times_award{act_id = 171,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(171,2,6) ->
    #race_rank_times_award{act_id = 171,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(171,3,1) ->
    #race_rank_times_award{act_id = 171,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(171,3,2) ->
    #race_rank_times_award{act_id = 171,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(171,3,3) ->
    #race_rank_times_award{act_id = 171,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(171,3,4) ->
    #race_rank_times_award{act_id = 171,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(171,3,5) ->
    #race_rank_times_award{act_id = 171,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(171,3,6) ->
    #race_rank_times_award{act_id = 171,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(172,1,1) ->
    #race_rank_times_award{act_id = 172,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(172,1,2) ->
    #race_rank_times_award{act_id = 172,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(172,1,3) ->
    #race_rank_times_award{act_id = 172,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(172,1,4) ->
    #race_rank_times_award{act_id = 172,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(172,1,5) ->
    #race_rank_times_award{act_id = 172,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(172,1,6) ->
    #race_rank_times_award{act_id = 172,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(172,2,1) ->
    #race_rank_times_award{act_id = 172,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(172,2,2) ->
    #race_rank_times_award{act_id = 172,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(172,2,3) ->
    #race_rank_times_award{act_id = 172,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(172,2,4) ->
    #race_rank_times_award{act_id = 172,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(172,2,5) ->
    #race_rank_times_award{act_id = 172,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(172,2,6) ->
    #race_rank_times_award{act_id = 172,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(172,3,1) ->
    #race_rank_times_award{act_id = 172,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(172,3,2) ->
    #race_rank_times_award{act_id = 172,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(172,3,3) ->
    #race_rank_times_award{act_id = 172,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(172,3,4) ->
    #race_rank_times_award{act_id = 172,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(172,3,5) ->
    #race_rank_times_award{act_id = 172,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(172,3,6) ->
    #race_rank_times_award{act_id = 172,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(173,1,1) ->
    #race_rank_times_award{act_id = 173,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(173,1,2) ->
    #race_rank_times_award{act_id = 173,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(173,1,3) ->
    #race_rank_times_award{act_id = 173,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(173,1,4) ->
    #race_rank_times_award{act_id = 173,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(173,1,5) ->
    #race_rank_times_award{act_id = 173,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(173,1,6) ->
    #race_rank_times_award{act_id = 173,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(173,2,1) ->
    #race_rank_times_award{act_id = 173,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(173,2,2) ->
    #race_rank_times_award{act_id = 173,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(173,2,3) ->
    #race_rank_times_award{act_id = 173,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(173,2,4) ->
    #race_rank_times_award{act_id = 173,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(173,2,5) ->
    #race_rank_times_award{act_id = 173,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(173,2,6) ->
    #race_rank_times_award{act_id = 173,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(173,3,1) ->
    #race_rank_times_award{act_id = 173,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(173,3,2) ->
    #race_rank_times_award{act_id = 173,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(173,3,3) ->
    #race_rank_times_award{act_id = 173,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(173,3,4) ->
    #race_rank_times_award{act_id = 173,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(173,3,5) ->
    #race_rank_times_award{act_id = 173,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(173,3,6) ->
    #race_rank_times_award{act_id = 173,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(174,1,1) ->
    #race_rank_times_award{act_id = 174,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(174,1,2) ->
    #race_rank_times_award{act_id = 174,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(174,1,3) ->
    #race_rank_times_award{act_id = 174,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(174,1,4) ->
    #race_rank_times_award{act_id = 174,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(174,1,5) ->
    #race_rank_times_award{act_id = 174,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(174,1,6) ->
    #race_rank_times_award{act_id = 174,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(174,2,1) ->
    #race_rank_times_award{act_id = 174,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(174,2,2) ->
    #race_rank_times_award{act_id = 174,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(174,2,3) ->
    #race_rank_times_award{act_id = 174,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(174,2,4) ->
    #race_rank_times_award{act_id = 174,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(174,2,5) ->
    #race_rank_times_award{act_id = 174,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(174,2,6) ->
    #race_rank_times_award{act_id = 174,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(174,3,1) ->
    #race_rank_times_award{act_id = 174,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(174,3,2) ->
    #race_rank_times_award{act_id = 174,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(174,3,3) ->
    #race_rank_times_award{act_id = 174,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(174,3,4) ->
    #race_rank_times_award{act_id = 174,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(174,3,5) ->
    #race_rank_times_award{act_id = 174,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(174,3,6) ->
    #race_rank_times_award{act_id = 174,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(175,1,1) ->
    #race_rank_times_award{act_id = 175,stage = 1,award_id = 1,need_score = 10,server_score = 0,award = [{100,211001,3},{100,211006,3}]};

get_race_rank_times_award(175,1,2) ->
    #race_rank_times_award{act_id = 175,stage = 1,award_id = 2,need_score = 30,server_score = 0,award = [{100,211001,3},{100,211006,4}]};

get_race_rank_times_award(175,1,3) ->
    #race_rank_times_award{act_id = 175,stage = 1,award_id = 3,need_score = 50,server_score = 0,award = [{100,211001,3},{100,211006,5}]};

get_race_rank_times_award(175,1,4) ->
    #race_rank_times_award{act_id = 175,stage = 1,award_id = 4,need_score = 80,server_score = 0,award = [{100,211001,3},{100,211006,6}]};

get_race_rank_times_award(175,1,5) ->
    #race_rank_times_award{act_id = 175,stage = 1,award_id = 5,need_score = 200,server_score = 0,award = [{100,211001,3},{100,211006,7}]};

get_race_rank_times_award(175,1,6) ->
    #race_rank_times_award{act_id = 175,stage = 1,award_id = 6,need_score = 500,server_score = 0,award = [{100,211001,3},{100,211006,8}]};

get_race_rank_times_award(175,2,1) ->
    #race_rank_times_award{act_id = 175,stage = 2,award_id = 1,need_score = 10,server_score = 0,award = [{100,109022,3},{100,109012,1}]};

get_race_rank_times_award(175,2,2) ->
    #race_rank_times_award{act_id = 175,stage = 2,award_id = 2,need_score = 30,server_score = 0,award = [{100,109022,3},{100,109012,2}]};

get_race_rank_times_award(175,2,3) ->
    #race_rank_times_award{act_id = 175,stage = 2,award_id = 3,need_score = 50,server_score = 0,award = [{100,109022,3},{100,109012,3}]};

get_race_rank_times_award(175,2,4) ->
    #race_rank_times_award{act_id = 175,stage = 2,award_id = 4,need_score = 80,server_score = 0,award = [{100,109022,3},{100,109012,4}]};

get_race_rank_times_award(175,2,5) ->
    #race_rank_times_award{act_id = 175,stage = 2,award_id = 5,need_score = 200,server_score = 0,award = [{100,109022,3},{100,109012,5}]};

get_race_rank_times_award(175,2,6) ->
    #race_rank_times_award{act_id = 175,stage = 2,award_id = 6,need_score = 500,server_score = 0,award = [{100,109022,3},{100,109012,6}]};

get_race_rank_times_award(175,3,1) ->
    #race_rank_times_award{act_id = 175,stage = 3,award_id = 1,need_score = 10,server_score = 0,award = [{100,109003,3},{100,109004,5}]};

get_race_rank_times_award(175,3,2) ->
    #race_rank_times_award{act_id = 175,stage = 3,award_id = 2,need_score = 30,server_score = 0,award = [{100,109003,3},{100,109004,6}]};

get_race_rank_times_award(175,3,3) ->
    #race_rank_times_award{act_id = 175,stage = 3,award_id = 3,need_score = 50,server_score = 0,award = [{100,109003,3},{100,109004,7}]};

get_race_rank_times_award(175,3,4) ->
    #race_rank_times_award{act_id = 175,stage = 3,award_id = 4,need_score = 80,server_score = 0,award = [{100,109003,3},{100,109004,8}]};

get_race_rank_times_award(175,3,5) ->
    #race_rank_times_award{act_id = 175,stage = 3,award_id = 5,need_score = 200,server_score = 0,award = [{100,109003,3},{100,109004,9}]};

get_race_rank_times_award(175,3,6) ->
    #race_rank_times_award{act_id = 175,stage = 3,award_id = 6,need_score = 500,server_score = 0,award = [{100,109003,3},{100,109004,10}]};

get_race_rank_times_award(_Actid,_Stage,_Awardid) ->
    false.

get_times_award_list(101,1) ->
    [1,2,3,4,5,6];

get_times_award_list(101,2) ->
    [1,2,3,4,5,6];

get_times_award_list(101,3) ->
    [1,2,3,4,5,6];

get_times_award_list(102,1) ->
    [1,2,3,4,5,6];

get_times_award_list(102,2) ->
    [1,2,3,4,5,6];

get_times_award_list(102,3) ->
    [1,2,3,4,5,6];

get_times_award_list(103,1) ->
    [1,2,3,4,5,6];

get_times_award_list(103,2) ->
    [1,2,3,4,5,6];

get_times_award_list(103,3) ->
    [1,2,3,4,5,6];

get_times_award_list(104,1) ->
    [1,2,3,4,5,6];

get_times_award_list(104,2) ->
    [1,2,3,4,5,6];

get_times_award_list(104,3) ->
    [1,2,3,4,5,6];

get_times_award_list(105,1) ->
    [1,2,3,4,5,6];

get_times_award_list(105,2) ->
    [1,2,3,4,5,6];

get_times_award_list(105,3) ->
    [1,2,3,4,5,6];

get_times_award_list(106,1) ->
    [1,2,3,4,5,6];

get_times_award_list(106,2) ->
    [1,2,3,4,5,6];

get_times_award_list(106,3) ->
    [1,2,3,4,5,6];

get_times_award_list(107,1) ->
    [1,2,3,4,5,6];

get_times_award_list(107,2) ->
    [1,2,3,4,5,6];

get_times_award_list(107,3) ->
    [1,2,3,4,5,6];

get_times_award_list(108,1) ->
    [1,2,3,4,5,6];

get_times_award_list(108,2) ->
    [1,2,3,4,5,6];

get_times_award_list(108,3) ->
    [1,2,3,4,5,6];

get_times_award_list(109,1) ->
    [1,2,3,4,5,6];

get_times_award_list(109,2) ->
    [1,2,3,4,5,6];

get_times_award_list(109,3) ->
    [1,2,3,4,5,6];

get_times_award_list(133,1) ->
    [1,2,3,4,5,6];

get_times_award_list(133,2) ->
    [1,2,3,4,5,6];

get_times_award_list(133,3) ->
    [1,2,3,4,5,6];

get_times_award_list(134,1) ->
    [1,2,3,4,5,6];

get_times_award_list(134,2) ->
    [1,2,3,4,5,6];

get_times_award_list(134,3) ->
    [1,2,3,4,5,6];

get_times_award_list(135,1) ->
    [1,2,3,4,5,6];

get_times_award_list(135,2) ->
    [1,2,3,4,5,6];

get_times_award_list(135,3) ->
    [1,2,3,4,5,6];

get_times_award_list(137,1) ->
    [1,2,3,4,5,6];

get_times_award_list(137,2) ->
    [1,2,3,4,5,6];

get_times_award_list(137,3) ->
    [1,2,3,4,5,6];

get_times_award_list(138,1) ->
    [1,2,3,4,5,6];

get_times_award_list(138,2) ->
    [1,2,3,4,5,6];

get_times_award_list(138,3) ->
    [1,2,3,4,5,6];

get_times_award_list(139,1) ->
    [1,2,3,4,5,6];

get_times_award_list(139,2) ->
    [1,2,3,4,5,6];

get_times_award_list(139,3) ->
    [1,2,3,4,5,6];

get_times_award_list(140,1) ->
    [1,2,3,4,5,6];

get_times_award_list(140,2) ->
    [1,2,3,4,5,6];

get_times_award_list(140,3) ->
    [1,2,3,4,5,6];

get_times_award_list(141,1) ->
    [1,2,3,4,5,6];

get_times_award_list(141,2) ->
    [1,2,3,4,5,6];

get_times_award_list(141,3) ->
    [1,2,3,4,5,6];

get_times_award_list(142,1) ->
    [1,2,3,4,5,6];

get_times_award_list(142,2) ->
    [1,2,3,4,5,6];

get_times_award_list(142,3) ->
    [1,2,3,4,5,6];

get_times_award_list(143,1) ->
    [1,2,3,4,5,6];

get_times_award_list(143,2) ->
    [1,2,3,4,5,6];

get_times_award_list(143,3) ->
    [1,2,3,4,5,6];

get_times_award_list(161,1) ->
    [1,2,3,4,5,6];

get_times_award_list(161,2) ->
    [1,2,3,4,5,6];

get_times_award_list(161,3) ->
    [1,2,3,4,5,6];

get_times_award_list(162,1) ->
    [1,2,3,4,5,6];

get_times_award_list(162,2) ->
    [1,2,3,4,5,6];

get_times_award_list(162,3) ->
    [1,2,3,4,5,6];

get_times_award_list(163,1) ->
    [1,2,3,4,5,6];

get_times_award_list(163,2) ->
    [1,2,3,4,5,6];

get_times_award_list(163,3) ->
    [1,2,3,4,5,6];

get_times_award_list(165,1) ->
    [1,2,3,4,5,6];

get_times_award_list(165,2) ->
    [1,2,3,4,5,6];

get_times_award_list(165,3) ->
    [1,2,3,4,5,6];

get_times_award_list(166,1) ->
    [1,2,3,4,5,6];

get_times_award_list(166,2) ->
    [1,2,3,4,5,6];

get_times_award_list(166,3) ->
    [1,2,3,4,5,6];

get_times_award_list(167,1) ->
    [1,2,3,4,5,6];

get_times_award_list(167,2) ->
    [1,2,3,4,5,6];

get_times_award_list(167,3) ->
    [1,2,3,4,5,6];

get_times_award_list(170,1) ->
    [1,2,3,4,5,6];

get_times_award_list(170,2) ->
    [1,2,3,4,5,6];

get_times_award_list(170,3) ->
    [1,2,3,4,5,6];

get_times_award_list(171,1) ->
    [1,2,3,4,5,6];

get_times_award_list(171,2) ->
    [1,2,3,4,5,6];

get_times_award_list(171,3) ->
    [1,2,3,4,5,6];

get_times_award_list(172,1) ->
    [1,2,3,4,5,6];

get_times_award_list(172,2) ->
    [1,2,3,4,5,6];

get_times_award_list(172,3) ->
    [1,2,3,4,5,6];

get_times_award_list(173,1) ->
    [1,2,3,4,5,6];

get_times_award_list(173,2) ->
    [1,2,3,4,5,6];

get_times_award_list(173,3) ->
    [1,2,3,4,5,6];

get_times_award_list(174,1) ->
    [1,2,3,4,5,6];

get_times_award_list(174,2) ->
    [1,2,3,4,5,6];

get_times_award_list(174,3) ->
    [1,2,3,4,5,6];

get_times_award_list(175,1) ->
    [1,2,3,4,5,6];

get_times_award_list(175,2) ->
    [1,2,3,4,5,6];

get_times_award_list(175,3) ->
    [1,2,3,4,5,6];

get_times_award_list(_Actid,_Stage) ->
    [].

get_ranking_requirement(101,Ranking) when Ranking >= 49, Ranking =< 50 ->
		10;
get_ranking_requirement(101,Ranking) when Ranking >= 31, Ranking =< 48 ->
		30;
get_ranking_requirement(101,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(101,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(101,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(101,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(101,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(101,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(101,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(101,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(101,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(101,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(101,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(101,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(102,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(102,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(102,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(102,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(102,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(102,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(102,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(102,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(102,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(102,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(102,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(102,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(102,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(102,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(103,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(103,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(103,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(103,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(103,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(103,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(103,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(103,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(103,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(103,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(103,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(103,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(103,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(103,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(104,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(104,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(104,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(104,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(104,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(104,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(104,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(104,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(104,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(104,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(104,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(104,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(104,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(104,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(105,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(105,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(105,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(105,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(105,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(105,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(105,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(105,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(105,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(105,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(105,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(105,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(105,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(105,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(106,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(106,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(106,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(106,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(106,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(106,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(106,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(106,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(106,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(106,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(106,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(106,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(106,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(106,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(107,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(107,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(107,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(107,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(107,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(107,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(107,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(107,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(107,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(107,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(107,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(107,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(107,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(107,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(108,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(108,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(108,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(108,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(108,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(108,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(108,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(108,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(108,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(108,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(108,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(108,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(108,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(108,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(109,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(109,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(109,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(109,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(109,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(109,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(109,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(109,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(109,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(109,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(109,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(109,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(109,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(109,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(133,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(133,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(133,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(133,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(133,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(133,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(133,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(133,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(133,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(133,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(133,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(133,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(133,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(133,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(134,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(134,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(134,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(134,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(134,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(134,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(134,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(134,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(134,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(134,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(134,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(134,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(134,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(134,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(135,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(135,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(135,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(135,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(135,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(135,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(135,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(135,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(135,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(135,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(135,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(135,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(135,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(135,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(137,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(137,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(137,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(137,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(137,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(137,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(137,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(137,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(137,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(137,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(137,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(137,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(137,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(137,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(138,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(138,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(138,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(138,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(138,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(138,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(138,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(138,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(138,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(138,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(138,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(138,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(138,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(138,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(139,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(139,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(139,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(139,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(139,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(139,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(139,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(139,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(139,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(139,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(139,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(139,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(139,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(139,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(140,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(140,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(140,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(140,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(140,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(140,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(140,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(140,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(140,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(140,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(140,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(140,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(140,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(140,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(141,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(141,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(141,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(141,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(141,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(141,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(141,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(141,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(141,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(141,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(141,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(141,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(141,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(141,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(142,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(142,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(142,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(142,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(142,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(142,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(142,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(142,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(142,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(142,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(142,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(142,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(142,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(142,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(143,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(143,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(143,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(143,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(143,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(143,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(143,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(143,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(143,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(143,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(143,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(143,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(143,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(143,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(161,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(161,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(161,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(161,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(161,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(161,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(161,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(161,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(161,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(161,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(161,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(161,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(161,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(161,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(162,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(162,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(162,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(162,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(162,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(162,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(162,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(162,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(162,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(162,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(162,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(162,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(162,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(162,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(163,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(163,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(163,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(163,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(163,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(163,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(163,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(163,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(163,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(163,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(163,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(163,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(163,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(163,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(165,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(165,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(165,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(165,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(165,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(165,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(165,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(165,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(165,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(165,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(165,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(165,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(165,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(165,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(166,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(166,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(166,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(166,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(166,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(166,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(166,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(166,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(166,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(166,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(166,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(166,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(166,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(166,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(167,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(167,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(167,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(167,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(167,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(167,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(167,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(167,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(167,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(167,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(167,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(167,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(167,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(167,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(170,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(170,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(170,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(170,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(170,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(170,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(170,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(170,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(170,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(170,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(170,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(170,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(170,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(170,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(171,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(171,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(171,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(171,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(171,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(171,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(171,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(171,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(171,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(171,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(171,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(171,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(171,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(171,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(172,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(172,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(172,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(172,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(172,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(172,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(172,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(172,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(172,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(172,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(172,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(172,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(172,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(172,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(173,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(173,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(173,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(173,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(173,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(173,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(173,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(173,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(173,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(173,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(173,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(173,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(173,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(173,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(174,Ranking) when Ranking >= 41, Ranking =< 50 ->
		10;
get_ranking_requirement(174,Ranking) when Ranking >= 31, Ranking =< 40 ->
		30;
get_ranking_requirement(174,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(174,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(174,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(174,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(174,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(174,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(174,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(174,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(174,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(174,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(174,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(174,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(175,Ranking) when Ranking >= 49, Ranking =< 50 ->
		10;
get_ranking_requirement(175,Ranking) when Ranking >= 31, Ranking =< 48 ->
		30;
get_ranking_requirement(175,Ranking) when Ranking >= 21, Ranking =< 30 ->
		50;
get_ranking_requirement(175,Ranking) when Ranking >= 11, Ranking =< 20 ->
		80;
get_ranking_requirement(175,Ranking) when Ranking >= 10, Ranking =< 10 ->
		100;
get_ranking_requirement(175,Ranking) when Ranking >= 9, Ranking =< 9 ->
		120;
get_ranking_requirement(175,Ranking) when Ranking >= 8, Ranking =< 8 ->
		140;
get_ranking_requirement(175,Ranking) when Ranking >= 7, Ranking =< 7 ->
		160;
get_ranking_requirement(175,Ranking) when Ranking >= 6, Ranking =< 6 ->
		180;
get_ranking_requirement(175,Ranking) when Ranking >= 5, Ranking =< 5 ->
		200;
get_ranking_requirement(175,Ranking) when Ranking >= 4, Ranking =< 4 ->
		250;
get_ranking_requirement(175,Ranking) when Ranking >= 3, Ranking =< 3 ->
		300;
get_ranking_requirement(175,Ranking) when Ranking >= 2, Ranking =< 2 ->
		350;
get_ranking_requirement(175,Ranking) when Ranking >= 1, Ranking =< 1 ->
		400;
get_ranking_requirement(_Act_id,_Ranking) ->
    false.

get_score_top_ranking(101,Score) when Score >= 400 ->
		1;
get_score_top_ranking(101,Score) when Score >= 350 ->
		2;
get_score_top_ranking(101,Score) when Score >= 300 ->
		3;
get_score_top_ranking(101,Score) when Score >= 250 ->
		4;
get_score_top_ranking(101,Score) when Score >= 200 ->
		5;
get_score_top_ranking(101,Score) when Score >= 180 ->
		6;
get_score_top_ranking(101,Score) when Score >= 160 ->
		7;
get_score_top_ranking(101,Score) when Score >= 140 ->
		8;
get_score_top_ranking(101,Score) when Score >= 120 ->
		9;
get_score_top_ranking(101,Score) when Score >= 100 ->
		10;
get_score_top_ranking(101,Score) when Score >= 80 ->
		11;
get_score_top_ranking(101,Score) when Score >= 50 ->
		21;
get_score_top_ranking(101,Score) when Score >= 30 ->
		31;
get_score_top_ranking(101,Score) when Score >= 10 ->
		49;
get_score_top_ranking(102,Score) when Score >= 400 ->
		1;
get_score_top_ranking(102,Score) when Score >= 350 ->
		2;
get_score_top_ranking(102,Score) when Score >= 300 ->
		3;
get_score_top_ranking(102,Score) when Score >= 250 ->
		4;
get_score_top_ranking(102,Score) when Score >= 200 ->
		5;
get_score_top_ranking(102,Score) when Score >= 180 ->
		6;
get_score_top_ranking(102,Score) when Score >= 160 ->
		7;
get_score_top_ranking(102,Score) when Score >= 140 ->
		8;
get_score_top_ranking(102,Score) when Score >= 120 ->
		9;
get_score_top_ranking(102,Score) when Score >= 100 ->
		10;
get_score_top_ranking(102,Score) when Score >= 80 ->
		11;
get_score_top_ranking(102,Score) when Score >= 50 ->
		21;
get_score_top_ranking(102,Score) when Score >= 30 ->
		31;
get_score_top_ranking(102,Score) when Score >= 10 ->
		41;
get_score_top_ranking(103,Score) when Score >= 400 ->
		1;
get_score_top_ranking(103,Score) when Score >= 350 ->
		2;
get_score_top_ranking(103,Score) when Score >= 300 ->
		3;
get_score_top_ranking(103,Score) when Score >= 250 ->
		4;
get_score_top_ranking(103,Score) when Score >= 200 ->
		5;
get_score_top_ranking(103,Score) when Score >= 180 ->
		6;
get_score_top_ranking(103,Score) when Score >= 160 ->
		7;
get_score_top_ranking(103,Score) when Score >= 140 ->
		8;
get_score_top_ranking(103,Score) when Score >= 120 ->
		9;
get_score_top_ranking(103,Score) when Score >= 100 ->
		10;
get_score_top_ranking(103,Score) when Score >= 80 ->
		11;
get_score_top_ranking(103,Score) when Score >= 50 ->
		21;
get_score_top_ranking(103,Score) when Score >= 30 ->
		31;
get_score_top_ranking(103,Score) when Score >= 10 ->
		41;
get_score_top_ranking(104,Score) when Score >= 400 ->
		1;
get_score_top_ranking(104,Score) when Score >= 350 ->
		2;
get_score_top_ranking(104,Score) when Score >= 300 ->
		3;
get_score_top_ranking(104,Score) when Score >= 250 ->
		4;
get_score_top_ranking(104,Score) when Score >= 200 ->
		5;
get_score_top_ranking(104,Score) when Score >= 180 ->
		6;
get_score_top_ranking(104,Score) when Score >= 160 ->
		7;
get_score_top_ranking(104,Score) when Score >= 140 ->
		8;
get_score_top_ranking(104,Score) when Score >= 120 ->
		9;
get_score_top_ranking(104,Score) when Score >= 100 ->
		10;
get_score_top_ranking(104,Score) when Score >= 80 ->
		11;
get_score_top_ranking(104,Score) when Score >= 50 ->
		21;
get_score_top_ranking(104,Score) when Score >= 30 ->
		31;
get_score_top_ranking(104,Score) when Score >= 10 ->
		41;
get_score_top_ranking(105,Score) when Score >= 400 ->
		1;
get_score_top_ranking(105,Score) when Score >= 350 ->
		2;
get_score_top_ranking(105,Score) when Score >= 300 ->
		3;
get_score_top_ranking(105,Score) when Score >= 250 ->
		4;
get_score_top_ranking(105,Score) when Score >= 200 ->
		5;
get_score_top_ranking(105,Score) when Score >= 180 ->
		6;
get_score_top_ranking(105,Score) when Score >= 160 ->
		7;
get_score_top_ranking(105,Score) when Score >= 140 ->
		8;
get_score_top_ranking(105,Score) when Score >= 120 ->
		9;
get_score_top_ranking(105,Score) when Score >= 100 ->
		10;
get_score_top_ranking(105,Score) when Score >= 80 ->
		11;
get_score_top_ranking(105,Score) when Score >= 50 ->
		21;
get_score_top_ranking(105,Score) when Score >= 30 ->
		31;
get_score_top_ranking(105,Score) when Score >= 10 ->
		41;
get_score_top_ranking(106,Score) when Score >= 400 ->
		1;
get_score_top_ranking(106,Score) when Score >= 350 ->
		2;
get_score_top_ranking(106,Score) when Score >= 300 ->
		3;
get_score_top_ranking(106,Score) when Score >= 250 ->
		4;
get_score_top_ranking(106,Score) when Score >= 200 ->
		5;
get_score_top_ranking(106,Score) when Score >= 180 ->
		6;
get_score_top_ranking(106,Score) when Score >= 160 ->
		7;
get_score_top_ranking(106,Score) when Score >= 140 ->
		8;
get_score_top_ranking(106,Score) when Score >= 120 ->
		9;
get_score_top_ranking(106,Score) when Score >= 100 ->
		10;
get_score_top_ranking(106,Score) when Score >= 80 ->
		11;
get_score_top_ranking(106,Score) when Score >= 50 ->
		21;
get_score_top_ranking(106,Score) when Score >= 30 ->
		31;
get_score_top_ranking(106,Score) when Score >= 10 ->
		41;
get_score_top_ranking(107,Score) when Score >= 400 ->
		1;
get_score_top_ranking(107,Score) when Score >= 350 ->
		2;
get_score_top_ranking(107,Score) when Score >= 300 ->
		3;
get_score_top_ranking(107,Score) when Score >= 250 ->
		4;
get_score_top_ranking(107,Score) when Score >= 200 ->
		5;
get_score_top_ranking(107,Score) when Score >= 180 ->
		6;
get_score_top_ranking(107,Score) when Score >= 160 ->
		7;
get_score_top_ranking(107,Score) when Score >= 140 ->
		8;
get_score_top_ranking(107,Score) when Score >= 120 ->
		9;
get_score_top_ranking(107,Score) when Score >= 100 ->
		10;
get_score_top_ranking(107,Score) when Score >= 80 ->
		11;
get_score_top_ranking(107,Score) when Score >= 50 ->
		21;
get_score_top_ranking(107,Score) when Score >= 30 ->
		31;
get_score_top_ranking(107,Score) when Score >= 10 ->
		41;
get_score_top_ranking(108,Score) when Score >= 400 ->
		1;
get_score_top_ranking(108,Score) when Score >= 350 ->
		2;
get_score_top_ranking(108,Score) when Score >= 300 ->
		3;
get_score_top_ranking(108,Score) when Score >= 250 ->
		4;
get_score_top_ranking(108,Score) when Score >= 200 ->
		5;
get_score_top_ranking(108,Score) when Score >= 180 ->
		6;
get_score_top_ranking(108,Score) when Score >= 160 ->
		7;
get_score_top_ranking(108,Score) when Score >= 140 ->
		8;
get_score_top_ranking(108,Score) when Score >= 120 ->
		9;
get_score_top_ranking(108,Score) when Score >= 100 ->
		10;
get_score_top_ranking(108,Score) when Score >= 80 ->
		11;
get_score_top_ranking(108,Score) when Score >= 50 ->
		21;
get_score_top_ranking(108,Score) when Score >= 30 ->
		31;
get_score_top_ranking(108,Score) when Score >= 10 ->
		41;
get_score_top_ranking(109,Score) when Score >= 400 ->
		1;
get_score_top_ranking(109,Score) when Score >= 350 ->
		2;
get_score_top_ranking(109,Score) when Score >= 300 ->
		3;
get_score_top_ranking(109,Score) when Score >= 250 ->
		4;
get_score_top_ranking(109,Score) when Score >= 200 ->
		5;
get_score_top_ranking(109,Score) when Score >= 180 ->
		6;
get_score_top_ranking(109,Score) when Score >= 160 ->
		7;
get_score_top_ranking(109,Score) when Score >= 140 ->
		8;
get_score_top_ranking(109,Score) when Score >= 120 ->
		9;
get_score_top_ranking(109,Score) when Score >= 100 ->
		10;
get_score_top_ranking(109,Score) when Score >= 80 ->
		11;
get_score_top_ranking(109,Score) when Score >= 50 ->
		21;
get_score_top_ranking(109,Score) when Score >= 30 ->
		31;
get_score_top_ranking(109,Score) when Score >= 10 ->
		41;
get_score_top_ranking(133,Score) when Score >= 400 ->
		1;
get_score_top_ranking(133,Score) when Score >= 350 ->
		2;
get_score_top_ranking(133,Score) when Score >= 300 ->
		3;
get_score_top_ranking(133,Score) when Score >= 250 ->
		4;
get_score_top_ranking(133,Score) when Score >= 200 ->
		5;
get_score_top_ranking(133,Score) when Score >= 180 ->
		6;
get_score_top_ranking(133,Score) when Score >= 160 ->
		7;
get_score_top_ranking(133,Score) when Score >= 140 ->
		8;
get_score_top_ranking(133,Score) when Score >= 120 ->
		9;
get_score_top_ranking(133,Score) when Score >= 100 ->
		10;
get_score_top_ranking(133,Score) when Score >= 80 ->
		11;
get_score_top_ranking(133,Score) when Score >= 50 ->
		21;
get_score_top_ranking(133,Score) when Score >= 30 ->
		31;
get_score_top_ranking(133,Score) when Score >= 10 ->
		41;
get_score_top_ranking(134,Score) when Score >= 400 ->
		1;
get_score_top_ranking(134,Score) when Score >= 350 ->
		2;
get_score_top_ranking(134,Score) when Score >= 300 ->
		3;
get_score_top_ranking(134,Score) when Score >= 250 ->
		4;
get_score_top_ranking(134,Score) when Score >= 200 ->
		5;
get_score_top_ranking(134,Score) when Score >= 180 ->
		6;
get_score_top_ranking(134,Score) when Score >= 160 ->
		7;
get_score_top_ranking(134,Score) when Score >= 140 ->
		8;
get_score_top_ranking(134,Score) when Score >= 120 ->
		9;
get_score_top_ranking(134,Score) when Score >= 100 ->
		10;
get_score_top_ranking(134,Score) when Score >= 80 ->
		11;
get_score_top_ranking(134,Score) when Score >= 50 ->
		21;
get_score_top_ranking(134,Score) when Score >= 30 ->
		31;
get_score_top_ranking(134,Score) when Score >= 10 ->
		41;
get_score_top_ranking(135,Score) when Score >= 400 ->
		1;
get_score_top_ranking(135,Score) when Score >= 350 ->
		2;
get_score_top_ranking(135,Score) when Score >= 300 ->
		3;
get_score_top_ranking(135,Score) when Score >= 250 ->
		4;
get_score_top_ranking(135,Score) when Score >= 200 ->
		5;
get_score_top_ranking(135,Score) when Score >= 180 ->
		6;
get_score_top_ranking(135,Score) when Score >= 160 ->
		7;
get_score_top_ranking(135,Score) when Score >= 140 ->
		8;
get_score_top_ranking(135,Score) when Score >= 120 ->
		9;
get_score_top_ranking(135,Score) when Score >= 100 ->
		10;
get_score_top_ranking(135,Score) when Score >= 80 ->
		11;
get_score_top_ranking(135,Score) when Score >= 50 ->
		21;
get_score_top_ranking(135,Score) when Score >= 30 ->
		31;
get_score_top_ranking(135,Score) when Score >= 10 ->
		41;
get_score_top_ranking(137,Score) when Score >= 400 ->
		1;
get_score_top_ranking(137,Score) when Score >= 350 ->
		2;
get_score_top_ranking(137,Score) when Score >= 300 ->
		3;
get_score_top_ranking(137,Score) when Score >= 250 ->
		4;
get_score_top_ranking(137,Score) when Score >= 200 ->
		5;
get_score_top_ranking(137,Score) when Score >= 180 ->
		6;
get_score_top_ranking(137,Score) when Score >= 160 ->
		7;
get_score_top_ranking(137,Score) when Score >= 140 ->
		8;
get_score_top_ranking(137,Score) when Score >= 120 ->
		9;
get_score_top_ranking(137,Score) when Score >= 100 ->
		10;
get_score_top_ranking(137,Score) when Score >= 80 ->
		11;
get_score_top_ranking(137,Score) when Score >= 50 ->
		21;
get_score_top_ranking(137,Score) when Score >= 30 ->
		31;
get_score_top_ranking(137,Score) when Score >= 10 ->
		41;
get_score_top_ranking(138,Score) when Score >= 400 ->
		1;
get_score_top_ranking(138,Score) when Score >= 350 ->
		2;
get_score_top_ranking(138,Score) when Score >= 300 ->
		3;
get_score_top_ranking(138,Score) when Score >= 250 ->
		4;
get_score_top_ranking(138,Score) when Score >= 200 ->
		5;
get_score_top_ranking(138,Score) when Score >= 180 ->
		6;
get_score_top_ranking(138,Score) when Score >= 160 ->
		7;
get_score_top_ranking(138,Score) when Score >= 140 ->
		8;
get_score_top_ranking(138,Score) when Score >= 120 ->
		9;
get_score_top_ranking(138,Score) when Score >= 100 ->
		10;
get_score_top_ranking(138,Score) when Score >= 80 ->
		11;
get_score_top_ranking(138,Score) when Score >= 50 ->
		21;
get_score_top_ranking(138,Score) when Score >= 30 ->
		31;
get_score_top_ranking(138,Score) when Score >= 10 ->
		41;
get_score_top_ranking(139,Score) when Score >= 400 ->
		1;
get_score_top_ranking(139,Score) when Score >= 350 ->
		2;
get_score_top_ranking(139,Score) when Score >= 300 ->
		3;
get_score_top_ranking(139,Score) when Score >= 250 ->
		4;
get_score_top_ranking(139,Score) when Score >= 200 ->
		5;
get_score_top_ranking(139,Score) when Score >= 180 ->
		6;
get_score_top_ranking(139,Score) when Score >= 160 ->
		7;
get_score_top_ranking(139,Score) when Score >= 140 ->
		8;
get_score_top_ranking(139,Score) when Score >= 120 ->
		9;
get_score_top_ranking(139,Score) when Score >= 100 ->
		10;
get_score_top_ranking(139,Score) when Score >= 80 ->
		11;
get_score_top_ranking(139,Score) when Score >= 50 ->
		21;
get_score_top_ranking(139,Score) when Score >= 30 ->
		31;
get_score_top_ranking(139,Score) when Score >= 10 ->
		41;
get_score_top_ranking(140,Score) when Score >= 400 ->
		1;
get_score_top_ranking(140,Score) when Score >= 350 ->
		2;
get_score_top_ranking(140,Score) when Score >= 300 ->
		3;
get_score_top_ranking(140,Score) when Score >= 250 ->
		4;
get_score_top_ranking(140,Score) when Score >= 200 ->
		5;
get_score_top_ranking(140,Score) when Score >= 180 ->
		6;
get_score_top_ranking(140,Score) when Score >= 160 ->
		7;
get_score_top_ranking(140,Score) when Score >= 140 ->
		8;
get_score_top_ranking(140,Score) when Score >= 120 ->
		9;
get_score_top_ranking(140,Score) when Score >= 100 ->
		10;
get_score_top_ranking(140,Score) when Score >= 80 ->
		11;
get_score_top_ranking(140,Score) when Score >= 50 ->
		21;
get_score_top_ranking(140,Score) when Score >= 30 ->
		31;
get_score_top_ranking(140,Score) when Score >= 10 ->
		41;
get_score_top_ranking(141,Score) when Score >= 400 ->
		1;
get_score_top_ranking(141,Score) when Score >= 350 ->
		2;
get_score_top_ranking(141,Score) when Score >= 300 ->
		3;
get_score_top_ranking(141,Score) when Score >= 250 ->
		4;
get_score_top_ranking(141,Score) when Score >= 200 ->
		5;
get_score_top_ranking(141,Score) when Score >= 180 ->
		6;
get_score_top_ranking(141,Score) when Score >= 160 ->
		7;
get_score_top_ranking(141,Score) when Score >= 140 ->
		8;
get_score_top_ranking(141,Score) when Score >= 120 ->
		9;
get_score_top_ranking(141,Score) when Score >= 100 ->
		10;
get_score_top_ranking(141,Score) when Score >= 80 ->
		11;
get_score_top_ranking(141,Score) when Score >= 50 ->
		21;
get_score_top_ranking(141,Score) when Score >= 30 ->
		31;
get_score_top_ranking(141,Score) when Score >= 10 ->
		41;
get_score_top_ranking(142,Score) when Score >= 400 ->
		1;
get_score_top_ranking(142,Score) when Score >= 350 ->
		2;
get_score_top_ranking(142,Score) when Score >= 300 ->
		3;
get_score_top_ranking(142,Score) when Score >= 250 ->
		4;
get_score_top_ranking(142,Score) when Score >= 200 ->
		5;
get_score_top_ranking(142,Score) when Score >= 180 ->
		6;
get_score_top_ranking(142,Score) when Score >= 160 ->
		7;
get_score_top_ranking(142,Score) when Score >= 140 ->
		8;
get_score_top_ranking(142,Score) when Score >= 120 ->
		9;
get_score_top_ranking(142,Score) when Score >= 100 ->
		10;
get_score_top_ranking(142,Score) when Score >= 80 ->
		11;
get_score_top_ranking(142,Score) when Score >= 50 ->
		21;
get_score_top_ranking(142,Score) when Score >= 30 ->
		31;
get_score_top_ranking(142,Score) when Score >= 10 ->
		41;
get_score_top_ranking(143,Score) when Score >= 400 ->
		1;
get_score_top_ranking(143,Score) when Score >= 350 ->
		2;
get_score_top_ranking(143,Score) when Score >= 300 ->
		3;
get_score_top_ranking(143,Score) when Score >= 250 ->
		4;
get_score_top_ranking(143,Score) when Score >= 200 ->
		5;
get_score_top_ranking(143,Score) when Score >= 180 ->
		6;
get_score_top_ranking(143,Score) when Score >= 160 ->
		7;
get_score_top_ranking(143,Score) when Score >= 140 ->
		8;
get_score_top_ranking(143,Score) when Score >= 120 ->
		9;
get_score_top_ranking(143,Score) when Score >= 100 ->
		10;
get_score_top_ranking(143,Score) when Score >= 80 ->
		11;
get_score_top_ranking(143,Score) when Score >= 50 ->
		21;
get_score_top_ranking(143,Score) when Score >= 30 ->
		31;
get_score_top_ranking(143,Score) when Score >= 10 ->
		41;
get_score_top_ranking(161,Score) when Score >= 400 ->
		1;
get_score_top_ranking(161,Score) when Score >= 350 ->
		2;
get_score_top_ranking(161,Score) when Score >= 300 ->
		3;
get_score_top_ranking(161,Score) when Score >= 250 ->
		4;
get_score_top_ranking(161,Score) when Score >= 200 ->
		5;
get_score_top_ranking(161,Score) when Score >= 180 ->
		6;
get_score_top_ranking(161,Score) when Score >= 160 ->
		7;
get_score_top_ranking(161,Score) when Score >= 140 ->
		8;
get_score_top_ranking(161,Score) when Score >= 120 ->
		9;
get_score_top_ranking(161,Score) when Score >= 100 ->
		10;
get_score_top_ranking(161,Score) when Score >= 80 ->
		11;
get_score_top_ranking(161,Score) when Score >= 50 ->
		21;
get_score_top_ranking(161,Score) when Score >= 30 ->
		31;
get_score_top_ranking(161,Score) when Score >= 10 ->
		41;
get_score_top_ranking(162,Score) when Score >= 400 ->
		1;
get_score_top_ranking(162,Score) when Score >= 350 ->
		2;
get_score_top_ranking(162,Score) when Score >= 300 ->
		3;
get_score_top_ranking(162,Score) when Score >= 250 ->
		4;
get_score_top_ranking(162,Score) when Score >= 200 ->
		5;
get_score_top_ranking(162,Score) when Score >= 180 ->
		6;
get_score_top_ranking(162,Score) when Score >= 160 ->
		7;
get_score_top_ranking(162,Score) when Score >= 140 ->
		8;
get_score_top_ranking(162,Score) when Score >= 120 ->
		9;
get_score_top_ranking(162,Score) when Score >= 100 ->
		10;
get_score_top_ranking(162,Score) when Score >= 80 ->
		11;
get_score_top_ranking(162,Score) when Score >= 50 ->
		21;
get_score_top_ranking(162,Score) when Score >= 30 ->
		31;
get_score_top_ranking(162,Score) when Score >= 10 ->
		41;
get_score_top_ranking(163,Score) when Score >= 400 ->
		1;
get_score_top_ranking(163,Score) when Score >= 350 ->
		2;
get_score_top_ranking(163,Score) when Score >= 300 ->
		3;
get_score_top_ranking(163,Score) when Score >= 250 ->
		4;
get_score_top_ranking(163,Score) when Score >= 200 ->
		5;
get_score_top_ranking(163,Score) when Score >= 180 ->
		6;
get_score_top_ranking(163,Score) when Score >= 160 ->
		7;
get_score_top_ranking(163,Score) when Score >= 140 ->
		8;
get_score_top_ranking(163,Score) when Score >= 120 ->
		9;
get_score_top_ranking(163,Score) when Score >= 100 ->
		10;
get_score_top_ranking(163,Score) when Score >= 80 ->
		11;
get_score_top_ranking(163,Score) when Score >= 50 ->
		21;
get_score_top_ranking(163,Score) when Score >= 30 ->
		31;
get_score_top_ranking(163,Score) when Score >= 10 ->
		41;
get_score_top_ranking(165,Score) when Score >= 400 ->
		1;
get_score_top_ranking(165,Score) when Score >= 350 ->
		2;
get_score_top_ranking(165,Score) when Score >= 300 ->
		3;
get_score_top_ranking(165,Score) when Score >= 250 ->
		4;
get_score_top_ranking(165,Score) when Score >= 200 ->
		5;
get_score_top_ranking(165,Score) when Score >= 180 ->
		6;
get_score_top_ranking(165,Score) when Score >= 160 ->
		7;
get_score_top_ranking(165,Score) when Score >= 140 ->
		8;
get_score_top_ranking(165,Score) when Score >= 120 ->
		9;
get_score_top_ranking(165,Score) when Score >= 100 ->
		10;
get_score_top_ranking(165,Score) when Score >= 80 ->
		11;
get_score_top_ranking(165,Score) when Score >= 50 ->
		21;
get_score_top_ranking(165,Score) when Score >= 30 ->
		31;
get_score_top_ranking(165,Score) when Score >= 10 ->
		41;
get_score_top_ranking(166,Score) when Score >= 400 ->
		1;
get_score_top_ranking(166,Score) when Score >= 350 ->
		2;
get_score_top_ranking(166,Score) when Score >= 300 ->
		3;
get_score_top_ranking(166,Score) when Score >= 250 ->
		4;
get_score_top_ranking(166,Score) when Score >= 200 ->
		5;
get_score_top_ranking(166,Score) when Score >= 180 ->
		6;
get_score_top_ranking(166,Score) when Score >= 160 ->
		7;
get_score_top_ranking(166,Score) when Score >= 140 ->
		8;
get_score_top_ranking(166,Score) when Score >= 120 ->
		9;
get_score_top_ranking(166,Score) when Score >= 100 ->
		10;
get_score_top_ranking(166,Score) when Score >= 80 ->
		11;
get_score_top_ranking(166,Score) when Score >= 50 ->
		21;
get_score_top_ranking(166,Score) when Score >= 30 ->
		31;
get_score_top_ranking(166,Score) when Score >= 10 ->
		41;
get_score_top_ranking(167,Score) when Score >= 400 ->
		1;
get_score_top_ranking(167,Score) when Score >= 350 ->
		2;
get_score_top_ranking(167,Score) when Score >= 300 ->
		3;
get_score_top_ranking(167,Score) when Score >= 250 ->
		4;
get_score_top_ranking(167,Score) when Score >= 200 ->
		5;
get_score_top_ranking(167,Score) when Score >= 180 ->
		6;
get_score_top_ranking(167,Score) when Score >= 160 ->
		7;
get_score_top_ranking(167,Score) when Score >= 140 ->
		8;
get_score_top_ranking(167,Score) when Score >= 120 ->
		9;
get_score_top_ranking(167,Score) when Score >= 100 ->
		10;
get_score_top_ranking(167,Score) when Score >= 80 ->
		11;
get_score_top_ranking(167,Score) when Score >= 50 ->
		21;
get_score_top_ranking(167,Score) when Score >= 30 ->
		31;
get_score_top_ranking(167,Score) when Score >= 10 ->
		41;
get_score_top_ranking(170,Score) when Score >= 400 ->
		1;
get_score_top_ranking(170,Score) when Score >= 350 ->
		2;
get_score_top_ranking(170,Score) when Score >= 300 ->
		3;
get_score_top_ranking(170,Score) when Score >= 250 ->
		4;
get_score_top_ranking(170,Score) when Score >= 200 ->
		5;
get_score_top_ranking(170,Score) when Score >= 180 ->
		6;
get_score_top_ranking(170,Score) when Score >= 160 ->
		7;
get_score_top_ranking(170,Score) when Score >= 140 ->
		8;
get_score_top_ranking(170,Score) when Score >= 120 ->
		9;
get_score_top_ranking(170,Score) when Score >= 100 ->
		10;
get_score_top_ranking(170,Score) when Score >= 80 ->
		11;
get_score_top_ranking(170,Score) when Score >= 50 ->
		21;
get_score_top_ranking(170,Score) when Score >= 30 ->
		31;
get_score_top_ranking(170,Score) when Score >= 10 ->
		41;
get_score_top_ranking(171,Score) when Score >= 400 ->
		1;
get_score_top_ranking(171,Score) when Score >= 350 ->
		2;
get_score_top_ranking(171,Score) when Score >= 300 ->
		3;
get_score_top_ranking(171,Score) when Score >= 250 ->
		4;
get_score_top_ranking(171,Score) when Score >= 200 ->
		5;
get_score_top_ranking(171,Score) when Score >= 180 ->
		6;
get_score_top_ranking(171,Score) when Score >= 160 ->
		7;
get_score_top_ranking(171,Score) when Score >= 140 ->
		8;
get_score_top_ranking(171,Score) when Score >= 120 ->
		9;
get_score_top_ranking(171,Score) when Score >= 100 ->
		10;
get_score_top_ranking(171,Score) when Score >= 80 ->
		11;
get_score_top_ranking(171,Score) when Score >= 50 ->
		21;
get_score_top_ranking(171,Score) when Score >= 30 ->
		31;
get_score_top_ranking(171,Score) when Score >= 10 ->
		41;
get_score_top_ranking(172,Score) when Score >= 400 ->
		1;
get_score_top_ranking(172,Score) when Score >= 350 ->
		2;
get_score_top_ranking(172,Score) when Score >= 300 ->
		3;
get_score_top_ranking(172,Score) when Score >= 250 ->
		4;
get_score_top_ranking(172,Score) when Score >= 200 ->
		5;
get_score_top_ranking(172,Score) when Score >= 180 ->
		6;
get_score_top_ranking(172,Score) when Score >= 160 ->
		7;
get_score_top_ranking(172,Score) when Score >= 140 ->
		8;
get_score_top_ranking(172,Score) when Score >= 120 ->
		9;
get_score_top_ranking(172,Score) when Score >= 100 ->
		10;
get_score_top_ranking(172,Score) when Score >= 80 ->
		11;
get_score_top_ranking(172,Score) when Score >= 50 ->
		21;
get_score_top_ranking(172,Score) when Score >= 30 ->
		31;
get_score_top_ranking(172,Score) when Score >= 10 ->
		41;
get_score_top_ranking(173,Score) when Score >= 400 ->
		1;
get_score_top_ranking(173,Score) when Score >= 350 ->
		2;
get_score_top_ranking(173,Score) when Score >= 300 ->
		3;
get_score_top_ranking(173,Score) when Score >= 250 ->
		4;
get_score_top_ranking(173,Score) when Score >= 200 ->
		5;
get_score_top_ranking(173,Score) when Score >= 180 ->
		6;
get_score_top_ranking(173,Score) when Score >= 160 ->
		7;
get_score_top_ranking(173,Score) when Score >= 140 ->
		8;
get_score_top_ranking(173,Score) when Score >= 120 ->
		9;
get_score_top_ranking(173,Score) when Score >= 100 ->
		10;
get_score_top_ranking(173,Score) when Score >= 80 ->
		11;
get_score_top_ranking(173,Score) when Score >= 50 ->
		21;
get_score_top_ranking(173,Score) when Score >= 30 ->
		31;
get_score_top_ranking(173,Score) when Score >= 10 ->
		41;
get_score_top_ranking(174,Score) when Score >= 400 ->
		1;
get_score_top_ranking(174,Score) when Score >= 350 ->
		2;
get_score_top_ranking(174,Score) when Score >= 300 ->
		3;
get_score_top_ranking(174,Score) when Score >= 250 ->
		4;
get_score_top_ranking(174,Score) when Score >= 200 ->
		5;
get_score_top_ranking(174,Score) when Score >= 180 ->
		6;
get_score_top_ranking(174,Score) when Score >= 160 ->
		7;
get_score_top_ranking(174,Score) when Score >= 140 ->
		8;
get_score_top_ranking(174,Score) when Score >= 120 ->
		9;
get_score_top_ranking(174,Score) when Score >= 100 ->
		10;
get_score_top_ranking(174,Score) when Score >= 80 ->
		11;
get_score_top_ranking(174,Score) when Score >= 50 ->
		21;
get_score_top_ranking(174,Score) when Score >= 30 ->
		31;
get_score_top_ranking(174,Score) when Score >= 10 ->
		41;
get_score_top_ranking(175,Score) when Score >= 400 ->
		1;
get_score_top_ranking(175,Score) when Score >= 350 ->
		2;
get_score_top_ranking(175,Score) when Score >= 300 ->
		3;
get_score_top_ranking(175,Score) when Score >= 250 ->
		4;
get_score_top_ranking(175,Score) when Score >= 200 ->
		5;
get_score_top_ranking(175,Score) when Score >= 180 ->
		6;
get_score_top_ranking(175,Score) when Score >= 160 ->
		7;
get_score_top_ranking(175,Score) when Score >= 140 ->
		8;
get_score_top_ranking(175,Score) when Score >= 120 ->
		9;
get_score_top_ranking(175,Score) when Score >= 100 ->
		10;
get_score_top_ranking(175,Score) when Score >= 80 ->
		11;
get_score_top_ranking(175,Score) when Score >= 50 ->
		21;
get_score_top_ranking(175,Score) when Score >= 30 ->
		31;
get_score_top_ranking(175,Score) when Score >= 10 ->
		49;
get_score_top_ranking(_Act_id,_Score) ->
    999.

get_stage(Total) when 0 =< Total, Total =< 59 ->
		0;
get_stage(Total) when 60 =< Total, Total =< 119 ->
		1;
get_stage(Total) when 120 =< Total, Total =< 299 ->
		2;
get_stage(Total) when 300 =< Total, Total =< 359 ->
		3;
get_stage(Total) when 360 =< Total, Total =< 499 ->
		4;
get_stage(Total) when 500 =< Total, Total =< 559 ->
		5;
get_stage(Total) when 560 =< Total, Total =< 799 ->
		6;
get_stage(Total) when 800 =< Total, Total =< 979 ->
		7;
get_stage(Total) when 980 =< Total, Total =< 1039 ->
		8;
get_stage(Total) when 1040 =< Total, Total =< 1279 ->
		9;
get_stage(Total) when 1280 =< Total, Total =< 1579 ->
		10;
get_stage(Total) when 1580 =< Total, Total =< 1879 ->
		11;
get_stage(Total) when 1880 =< Total, Total =< 2179 ->
		12;
get_stage(Total) when 2180 =< Total, Total =< 2479 ->
		13;
get_stage(Total) when 2480 =< Total, Total =< 2779 ->
		14;
get_stage(Total) when 2780 =< Total, Total =< 3079 ->
		15;
get_stage(Total) when 3080 =< Total, Total =< 3379 ->
		16;
get_stage(Total) when 3380 =< Total, Total =< 3679 ->
		17;
get_stage(Total) when 3680 =< Total, Total =< 3979 ->
		18;
get_stage(Total) when 3980 =< Total, Total =< 4279 ->
		19;
get_stage(Total) when 4280 =< Total, Total =< 4579 ->
		20;
get_stage(Total) when 4580 =< Total, Total =< 4879 ->
		21;
get_stage(Total) when 4880 =< Total, Total =< 5179 ->
		22;
get_stage(Total) when 5180 =< Total, Total =< 5479 ->
		23;
get_stage(Total) when 5480 =< Total, Total =< 5779 ->
		24;
get_stage(Total) when 5780 =< Total, Total =< 6079 ->
		25;
get_stage(Total) when 6080 =< Total, Total =< 6379 ->
		26;
get_stage(Total) when 6380 =< Total, Total =< 6679 ->
		27;
get_stage(Total) when 6680 =< Total, Total =< 6979 ->
		28;
get_stage(Total) when 6980 =< Total, Total =< 7279 ->
		29;
get_stage(Total) when 7280 =< Total, Total =< 7579 ->
		30;
get_stage(Total) when 7580 =< Total, Total =< 7879 ->
		31;
get_stage(Total) when 7880 =< Total, Total =< 8179 ->
		32;
get_stage(Total) when 8180 =< Total, Total =< 8479 ->
		33;
get_stage(Total) when 8480 =< Total, Total =< 8779 ->
		34;
get_stage(Total) when 8780 =< Total, Total =< 9079 ->
		35;
get_stage(Total) when 9080 =< Total, Total =< 9379 ->
		36;
get_stage(Total) when 9380 =< Total, Total =< 9679 ->
		37;
get_stage(Total) when 9680 =< Total, Total =< 9979 ->
		38;
get_stage(Total) when 9980 =< Total, Total =< 10279 ->
		39;
get_stage(Total) when 10280 =< Total, Total =< 10579 ->
		40;
get_stage(Total) when 10580 =< Total, Total =< 10879 ->
		41;
get_stage(Total) when 10880 =< Total, Total =< 11179 ->
		42;
get_stage(Total) when 11180 =< Total, Total =< 11479 ->
		43;
get_stage(Total) when 11480 =< Total, Total =< 11779 ->
		44;
get_stage(Total) when 11780 =< Total, Total =< 12079 ->
		45;
get_stage(Total) when 12080 =< Total, Total =< 12379 ->
		46;
get_stage(Total) when 12380 =< Total, Total =< 12679 ->
		47;
get_stage(Total) when 12680 =< Total, Total =< 12979 ->
		48;
get_stage(Total) when 12980 =< Total, Total =< 13279 ->
		49;
get_stage(Total) when 13280 =< Total, Total =< 13579 ->
		50;
get_stage(Total) when 13580 =< Total, Total =< 13879 ->
		51;
get_stage(Total) when 13880 =< Total, Total =< 14179 ->
		52;
get_stage(Total) when 14180 =< Total, Total =< 14479 ->
		53;
get_stage(Total) when 14480 =< Total, Total =< 14779 ->
		54;
get_stage(Total) when 14780 =< Total, Total =< 15079 ->
		55;
get_stage(Total) when 15080 =< Total, Total =< 15379 ->
		56;
get_stage(Total) when 15380 =< Total, Total =< 15679 ->
		57;
get_stage(Total) when 15680 =< Total, Total =< 15979 ->
		58;
get_stage(Total) when 15980 =< Total, Total =< 16279 ->
		59;
get_stage(Total) when 16280 =< Total, Total =< 16579 ->
		60;
get_stage(Total) when 16580 =< Total, Total =< 16879 ->
		61;
get_stage(Total) when 16880 =< Total, Total =< 17179 ->
		62;
get_stage(Total) when 17180 =< Total, Total =< 17479 ->
		63;
get_stage(Total) when 17480 =< Total, Total =< 17779 ->
		64;
get_stage(Total) when 17780 =< Total, Total =< 18079 ->
		65;
get_stage(Total) when 18080 =< Total, Total =< 18379 ->
		66;
get_stage(Total) when 18380 =< Total, Total =< 18679 ->
		67;
get_stage(Total) when 18680 =< Total, Total =< 18979 ->
		68;
get_stage(Total) when 18980 =< Total, Total =< 19279 ->
		69;
get_stage(Total) when 19280 =< Total, Total =< 19579 ->
		70;
get_stage(Total) when 19580 =< Total, Total =< 19879 ->
		71;
get_stage(Total) when 19880 =< Total, Total =< 20179 ->
		72;
get_stage(Total) when 20180 =< Total, Total =< 20479 ->
		73;
get_stage(Total) when 20480 =< Total, Total =< 20779 ->
		74;
get_stage(Total) when 20780 =< Total, Total =< 21079 ->
		75;
get_stage(Total) when 21080 =< Total, Total =< 21379 ->
		76;
get_stage(Total) when 21380 =< Total, Total =< 21679 ->
		77;
get_stage(Total) when 21680 =< Total, Total =< 21979 ->
		78;
get_stage(Total) when 21980 =< Total, Total =< 22279 ->
		79;
get_stage(Total) when 22280 =< Total, Total =< 22579 ->
		80;
get_stage(Total) when 22580 =< Total, Total =< 22879 ->
		81;
get_stage(Total) when 22880 =< Total, Total =< 23179 ->
		82;
get_stage(Total) when 23180 =< Total, Total =< 23479 ->
		83;
get_stage(Total) when 23480 =< Total, Total =< 23779 ->
		84;
get_stage(Total) when 23780 =< Total, Total =< 24079 ->
		85;
get_stage(Total) when 24080 =< Total, Total =< 24379 ->
		86;
get_stage(Total) when 24380 =< Total, Total =< 24679 ->
		87;
get_stage(Total) when 24680 =< Total, Total =< 24979 ->
		88;
get_stage(Total) when 24980 =< Total, Total =< 25279 ->
		89;
get_stage(Total) when 25280 =< Total, Total =< 25579 ->
		90;
get_stage(Total) when 25580 =< Total, Total =< 25879 ->
		91;
get_stage(Total) when 25880 =< Total, Total =< 26179 ->
		92;
get_stage(Total) when 26180 =< Total, Total =< 26479 ->
		93;
get_stage(Total) when 26480 =< Total, Total =< 26779 ->
		94;
get_stage(Total) when 26780 =< Total, Total =< 27079 ->
		95;
get_stage(Total) when 27080 =< Total, Total =< 27379 ->
		96;
get_stage(Total) when 27380 =< Total, Total =< 27679 ->
		97;
get_stage(Total) when 27680 =< Total, Total =< 27979 ->
		98;
get_stage(Total) when 27980 =< Total, Total =< 28480 ->
		99;
get_stage(Total) when 28481 =< Total, Total =< 29181 ->
		100;
get_stage(Total) when 29182 =< Total, Total =< 30082 ->
		101;
get_stage(Total) when 30083 =< Total, Total =< 31283 ->
		102;
get_stage(Total) when 31284 =< Total, Total =< 32884 ->
		103;
get_stage(Total) when 32885 =< Total, Total =< 34985 ->
		104;
get_stage(Total) when 34986 =< Total, Total =< 37686 ->
		105;
get_stage(Total) when 37687 =< Total, Total =< 41087 ->
		106;
get_stage(Total) when 41088 =< Total, Total =< 45288 ->
		107;
get_stage(Total) when 45289 =< Total, Total =< 50289 ->
		108;
get_stage(Total) when 50290 =< Total, Total =< 56090 ->
		109;
get_stage(Total) when 56091 =< Total, Total =< 62691 ->
		110;
get_stage(Total) when 62692 =< Total, Total =< 70092 ->
		111;
get_stage(Total) when 70093 =< Total, Total =< 78293 ->
		112;
get_stage(Total) when 78294 =< Total, Total =< 87294 ->
		113;
get_stage(Total) when 87295 =< Total, Total =< 97095 ->
		114;
get_stage(Total) when 97096 =< Total, Total =< 107696 ->
		115;
get_stage(Total) when 107697 =< Total, Total =< 119097 ->
		116;
get_stage(Total) when 119098 =< Total, Total =< 131498 ->
		117;
get_stage(Total) when 131499 =< Total, Total =< 145099 ->
		118;
get_stage(Total) when 145100 =< Total, Total =< 160100 ->
		119;
get_stage(Total) when 160101 =< Total, Total =< 176701 ->
		120;
get_stage(Total) when 176702 =< Total, Total =< 195102 ->
		121;
get_stage(Total) when 195103 =< Total, Total =< 215503 ->
		122;
get_stage(Total) when 215504 =< Total, Total =< 238104 ->
		123;
get_stage(Total) when 238105 =< Total, Total =< 263105 ->
		124;
get_stage(Total) when 263106 =< Total, Total =< 290706 ->
		125;
get_stage(Total) when 290707 =< Total, Total =< 321107 ->
		126;
get_stage(Total) when 321108 =< Total, Total =< 354508 ->
		127;
get_stage(Total) when 354509 =< Total, Total =< 391109 ->
		128;
get_stage(Total) when 391110 =< Total, Total =< 431310 ->
		129;
get_stage(Total) when 431311 =< Total, Total =< 475311 ->
		130;
get_stage(Total) when 475312 =< Total, Total =< 523312 ->
		131;
get_stage(Total) when 523313 =< Total, Total =< 575513 ->
		132;
get_stage(Total) when 575514 =< Total, Total =< 9999999 ->
		133;
get_stage(_Total) ->
    0.

get_rune_cost(N) when N =< 1 ->
		50;
get_rune_cost(N) when N =< 2 ->
		50;
get_rune_cost(N) when N =< 3 ->
		60;
get_rune_cost(N) when N =< 4 ->
		60;
get_rune_cost(N) when N =< 5 ->
		80;
get_rune_cost(N) when N =< 6 ->
		80;
get_rune_cost(N) when N =< 7 ->
		80;
get_rune_cost(N) when N =< 8 ->
		80;
get_rune_cost(N) when N =< 9 ->
		80;
get_rune_cost(N) when N =< 10 ->
		100;
get_rune_cost(N) when N =< 11 ->
		100;
get_rune_cost(N) when N =< 12 ->
		100;
get_rune_cost(N) when N =< 13 ->
		100;
get_rune_cost(N) when N =< 14 ->
		100;
get_rune_cost(N) when N =< 15 ->
		120;
get_rune_cost(N) when N =< 16 ->
		120;
get_rune_cost(N) when N =< 17 ->
		120;
get_rune_cost(N) when N =< 18 ->
		120;
get_rune_cost(N) when N =< 19 ->
		120;
get_rune_cost(N) when N =< 20 ->
		150;
get_rune_cost(N) when N =< 30 ->
		200;
get_rune_cost(N) when N =< 50 ->
		250;
get_rune_cost(N) when N =< 60 ->
		250;
get_rune_cost(N) when N =< 100 ->
		300;
get_rune_cost(N) when N =< 150 ->
		350;
get_rune_cost(N) when N =< 200 ->
		400;
get_rune_cost(N) when N =< 250 ->
		450;
get_rune_cost(N) when N =< 300 ->
		500;
get_rune_cost(N) when N =< 350 ->
		550;
get_rune_cost(N) when N =< 400 ->
		600;
get_rune_cost(N) when N =< 9999 ->
		600;
get_rune_cost(_N) ->
    0.

get_ten_times_cost(Times) when 1 =< Times, Times =< 1 ->
		[{0,110139,100}];
get_ten_times_cost(Times) when 2 =< Times, Times =< 3 ->
		[{0,110139,160}];
get_ten_times_cost(Times) when 4 =< Times, Times =< 99999 ->
		[{0,110139,200}];
get_ten_times_cost(_Times) ->
    [].

